update L_ODS
set VERSION_RELEASE = 0,
    VERSION_BUILD = 17
^

--------------------------------------------------------------------
--                           10.0.0.1
--------------------------------------------------------------------


--[15039, 15046]
create or alter procedure M__BASEUPGRADE_RABMAT
as
begin
  if (not exists(
      select * from RDB$RELATION_FIELDS F
        where (upper(F.RDB$RELATION_NAME) = 'B_RABMAT') and
              (upper(F.RDB$FIELD_NAME) = 'BB_PR'))) then
  begin
    execute statement 'ALTER TABLE B_RABMAT ADD BB_PR S_DOUBLE';
  end

  if (not exists(
      select * from RDB$RELATION_FIELDS F
        where (upper(F.RDB$RELATION_NAME) = 'B_RABMAT') and
              (upper(F.RDB$FIELD_NAME) = 'TRANSP_SH'))) then
  begin
    execute statement 'ALTER TABLE B_RABMAT ADD TRANSP_SH S_VARCHAR255';
  end
end
^
execute procedure M__BASEUPGRADE_RABMAT
^
drop procedure M__BASEUPGRADE_RABMAT
^^


-- MK 03.10.2016      B_RABMAT
alter table B_RABMAT
alter ID position 1,
alter IDREESTR position 2,
alter ORDERVIEW position 3,
alter IDNAME position 4,
alter IDPAPKA position 5,
alter ID_UNIQUE position 6,
alter IDTCH position 7,
alter TAB position 8,
alter TABU position 9,
alter RABMAT position 10,
alter IDOGL position 11,
alter FRTCH position 12,
alter IDSOSTAV position 13,
alter ALTTAB position 14,
alter IDEDIZM position 15,
alter IDALTEDIZM position 16,
alter EDIZMKOEF position 17,
alter IDABCOKP position 18,
alter COMMENT position 19,
alter IDTCARD position 20,
alter IDESN position 21,
alter FRESN position 22,
alter RAZRAD position 23,
alter BA position 24,
alter BB position 25,
alter BC position 26,
alter BD position 27,
alter BE position 28,
alter BF position 29,
alter BG position 30,
alter BH position 31,
alter BI position 32,
alter BJ position 33,
alter PA position 34,
alter PB position 35,
alter PC position 36,
alter PD position 37,
alter PE position 38,
alter MA position 39,
alter MB position 40,
alter MC position 41,
alter MD position 42,
alter ME position 43,
alter MF position 44,
alter MG position 45,
alter MH position 46,
alter VRPZ position 47,
alter NTR position 48,
alter BRUTTO position 49,
alter NETTO position 50,
alter VB position 51,
alter VN position 52,
alter PREISK position 53,
alter POSPREISK position 54,
alter TKALK position 55,
alter IDPOSTAV position 56,
alter MBETON position 57,
alter MRKBETON position 58,
alter VBETON position 59,
alter MMASHINE position 60,
alter PUNKTIND position 61,
alter ISESN position 62,
alter IDWITHESN position 63,
alter CREATEDATE position 64,
alter AUTHOR position 65,
alter IDPICTURE position 66,
alter MI position 67,
alter MJ position 68,
alter MK position 69,
alter ML position 70,
alter MM position 71,
alter MN position 72,
alter MO position 73,
alter MP position 74,
alter MQ position 75,
alter MR position 76,
alter MS position 77,
alter MT position 78,
alter IDQUALIFIER position 79,
alter NEW_PAGE position 80,
alter IDENT_KOD_MAT_SAP position 81,
alter BASE_EDIZM_SAP position 82,
alter STOIM_MAT_SAP position 83,
alter ZAG_SKL_1 position 84,
alter ZAG_SKL_P position 85,
alter TRANSP_P position 86,
alter KLASS_G position 87,
alter TAB_TRANSP position 88,
alter BB_OTP position 89,
alter BB_PR position 90,
alter TRANSP_SH position 91
^





--[15047]
create or alter procedure M__BASEUPGRADE_IND
as
begin
  if (not exists(
      select * from RDB$RELATION_FIELDS F
        where (upper(F.RDB$RELATION_NAME) = 'B_IND') and
              (upper(F.RDB$FIELD_NAME) = 'BB_PR'))) then
  begin
    execute statement 'ALTER TABLE B_IND ADD BB_PR B_D_DOUBLE';
  end
end
^
execute procedure M__BASEUPGRADE_IND
^
drop procedure M__BASEUPGRADE_IND
^^


--[15047]
create or alter procedure M__BASEUPGRADE_IND_FILL
as
begin
  if (not exists (
      select * from M_GLOBAL_PARAMS
      where upper(PARAM_NAME)='M__BASEUPGRADE_IND_FILL_15047'
        and INT_VALUE <> 0)) then
  begin
    update b_ind
    set bb_pr = 1;

    update M_GLOBAL_PARAMS
      set INT_VALUE = 1
      where upper(PARAM_NAME)='M__BASEUPGRADE_IND_FILL_15047';
    if (row_count = 0) then
      insert into M_GLOBAL_PARAMS(ID_SELF, PARAM_NAME, INT_VALUE)
      values(gen_id(A_G_SMETA, 1), 'M__BASEUPGRADE_IND_FILL_15047', 1);
  end
end
^
execute procedure M__BASEUPGRADE_IND_FILL
^
drop procedure M__BASEUPGRADE_IND_FILL
^^





-- CQ[15039, 15046]
CREATE OR ALTER TRIGGER B_BUFER_BI0 FOR B_BUFER
ACTIVE BEFORE INSERT POSITION 0
AS
DECLARE VARIABLE STATUS INTEGER;
BEGIN
/* !!!    S_BUFER_INSERT_FROM... */
  if (new.ID = 0) then
  begin

  NEW.ID = GEN_ID (A_G_SMETA, 1);
  IF (NEW.IDNORMY IS NOT NULL) THEN

  IF (NEW.PODGROUP = 1) THEN IF (NEW.RABMAT = 1) THEN
  /*TRUD*/
    INSERT INTO B_TRUD (ID,
        /*ORDERVIEW,*/ IDNAME, ID_UNIQUE, TAB, TABU, IDEDIZM,
        RAZRAD, CENA, /*IDABCOKP,*/ COMMENT, IDQUALIFIER, TYPE_TRUD)
      SELECT NEW.ID,
          /*ORDERVIEW,*/ IDNAME, ID_UNIQUE, TAB, TABU, IDEDIZM,
          RAZRAD, CENA, /*IDABCOKP,*/ COMMENT, IDQUALIFIER, TYPE_TRUD
        FROM B_TRUD
        WHERE ID = NEW.IDNORMY;

  ELSE
  /*RABMAT*/
    INSERT INTO B_RABMAT (ID,
        /*IDREESTR, ORDERVIEW,*/ IDNAME, /*IDPAPKA,*/ ID_UNIQUE, IDTCH,
        TAB, TABU, RABMAT, /*IDOGL,*/ FRTCH, IDSOSTAV, ALTTAB,
        IDEDIZM, IDALTEDIZM, EDIZMKOEF, /*IDABCOKP,*/ COMMENT,
        IDTCARD, IDESN, FRESN, RAZRAD,
        BA, BB,
        BB_OTP, --<<[14355]
        BB_PR, -- CQ[15046]
        BC, BD, BE, BF, BG, BH, BI,
        TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
        BJ, PA, PB, PC, PD, PE,
        MA, MB, MC, MD, ME, MF, MG, MH,
        MI, MJ, MK, ML, MM, MN, MO, MP, MQ, MR, MS, MT,
        VRPZ, NTR, BRUTTO, NETTO, VB, VN,
        PREISK, POSPREISK, TKALK, IDPOSTAV,
        MBETON, MRKBETON, VBETON, MMASHINE, PUNKTIND,
        ISESN, IDWITHESN, CREATEDATE, AUTHOR, IDPICTURE, IDQUALIFIER,
        TRANSP_SH) -- CQ[15039]
      SELECT NEW.ID,
          /*IDREESTR, ORDERVIEW,*/ IDNAME, /*IDPAPKA,*/ ID_UNIQUE, IDTCH,
          TAB, TABU, RABMAT, /*IDOGL,*/ FRTCH, IDSOSTAV, ALTTAB,
          IDEDIZM, IDALTEDIZM, EDIZMKOEF, /*IDABCOKP,*/ COMMENT,
          IDTCARD, IDESN, FRESN, RAZRAD,
          BA, BB,
          BB_OTP, --<<[14355]
          BB_PR, -- CQ[15046]
          BC, BD, BE, BF, BG, BH, BI,
          TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
          BJ, PA, PB, PC, PD, PE,
          MA, MB, MC, MD, ME, MF, MG, MH,
          MI, MJ, MK, ML, MM, MN, MO, MP, MQ, MR, MS, MT,
          VRPZ, NTR, BRUTTO, NETTO, VB, VN,
          PREISK, POSPREISK, TKALK, IDPOSTAV,
          MBETON, MRKBETON, VBETON, MMASHINE, PUNKTIND,
          ISESN, IDWITHESN, CREATEDATE, AUTHOR, IDPICTURE, IDQUALIFIER,
          TRANSP_SH -- CQ[15039]
        FROM B_RABMAT
        WHERE ID = NEW.IDNORMY;

        --CQ[TIMUR 7932]
        SELECT STATUS
        FROM B_RABMAT_EX
        WHERE ID = NEW.IDNORMY
        INTO STATUS;
      
        if (STATUS <> 0) then
          INSERT INTO B_RABMAT_EX (ID, STATUS) VALUES (NEW.ID, :STATUS);
        --CQ[TIMUR 7932]

  ELSE
  /*ABC_OKP*/
    INSERT INTO B_ABC_OKP (ID,
        RABMAT, /*ORDERVIEW,*/ IDNAME, ID_UNIQUE, TAB, TABU,
        /*IDPODGROUP,*/ ISGROUPOKP, IDEDIZM, CENA, RAZRAD,
        IDPOSTAV, /*IDNORMA,*/ COMMENT, PUNKTIND, VRPZ, NTR/*, IDQUALIFIER*/)
      SELECT NEW.ID,
          RABMAT, /*ORDERVIEW,*/ IDNAME, ID_UNIQUE, TAB, TABU,
          /*IDPODGROUP,*/ ISGROUPOKP, IDEDIZM, CENA, RAZRAD,
          IDPOSTAV, /*IDNORMA,*/ COMMENT, PUNKTIND, VRPZ, NTR/*, IDQUALIFIER*/
        FROM B_ABC_OKP
        WHERE ID = NEW.IDNORMY;

  end
END
^

-- MK CQ[15047]
CREATE OR ALTER TRIGGER B_IND_BIU0 FOR B_IND
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
begin
  --<<[11189]
  new.TABU_MASK = case when new.TABU containing '%' or new.TABU containing '_' then '' else null end;

  -- MK CQ[15047]
  if (coalesce(new.bb_pr, 0) = 0) then
    new.bb_pr = 1;
end
^


-- CQ[15039, 15046]
-- 
create or alter procedure B_PASTE_EXCEL_IN_RABMAT (
    IDUSER integer,
    IDREESTR integer,
    ORDERVIEW integer,
    IDOGL integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NAME blob sub_type 1 segment size 80,
    EDIZM varchar(100),
    IN_IDEDIZM integer,
    BB double precision,
    BB_OTP double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BRUTTO double precision,
    NETTO double precision,
    IDENT_KOD_MAT_SAP varchar(30),
    BASE_EDIZM_SAP varchar(42),
    STOIM_MAT_SAP double precision)
returns (
    ID integer)
AS
begin
  suspend;
end
^

-- CQ[15039, 15046]
-- 
create or alter procedure B_PASTE_NORMY_IN_RABMAT (
    IDUSER integer,
    IDREESTR integer,
    ORDERVIEW integer,
    IDOGL integer,
    INTAB varchar(42),
    PASTEBLOB blob sub_type 0 segment size 80,
    PODGROUPBLOB blob sub_type 0 segment size 80,
    PASTECOUNT integer,
    ISPASTEFROMBUFER integer)
returns (
    ID integer,
    PASTEDID integer,
    REJECTCOUNT integer)
AS
begin
  suspend;
end
^


-- CQ[15039, 15046]
-- 
create or alter procedure B_PASTE_SMETA_IN_RABMAT (
    IDUSER integer,
    IDREESTR integer,
    ORDERVIEW integer,
    IDOGL integer,
    PASTEBLOB blob sub_type 0 segment size 80,
    PASTECOUNT integer,
    IDPUT_MASH integer,
    IDPUT_MAT integer,
    ID_NEW_MASH integer,
    ID_NEW_MAT integer)
returns (
    ID integer,
    PASTEDID integer)
AS
begin
  suspend;
end
^


-- CQ[15039, 15046]
-- 
create or alter procedure DM_COPY_NORMATIV (
    IDUSER integer,
    ID integer,
    IDPODGROUP integer,
    INTAB varchar(42))
returns (
    NEWID integer)
AS
begin
  suspend;
end
^


-- CQ[15039, 15046]
-- 
create or alter procedure L_IMP_NORMY_ADD_RABMAT_RECORD (
    IDREESTR integer,
    IDZONE integer,
    RABMAT integer,
    NAME_START blob sub_type 0 segment size 80,
    NAME blob sub_type 0 segment size 80,
    TAB varchar(42),
    IDOGL integer,
    ALTTAB varchar(250),
    EDIZM varchar(100),
    ALTEDIZM varchar(250),
    RAZRAD double precision,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    MN double precision,
    MO double precision,
    MP double precision,
    MQ double precision,
    MR double precision,
    MS double precision,
    MT double precision,
    VRPZ integer,
    NTR integer,
    BRUTTO double precision,
    NETTO double precision,
    VB double precision,
    VN double precision,
    PREISK varchar(42),
    POSPREISK varchar(42),
    TKALK varchar(50),
    MBETON double precision,
    MRKBETON varchar(15),
    VBETON double precision,
    MMASHINE varchar(25),
    PUNKTIND varchar(42),
    IDPOSTAV integer,
    IDABCOKP integer,
    comment varchar(42),
    ISESN smallint,
    IDWITHESN integer,
    IDSOST integer,
    SOSTAVRABOT blob sub_type 0 segment size 80,
    IDTCH integer,
    FRTCH varchar(250),
    IDESN integer,
    FRESN varchar(21),
    IDTCARD integer,
    IDPICTURE integer,
    ZONE_BA double precision,
    ZONE_BB double precision,
    ZONE_BC double precision,
    ZONE_BD double precision,
    ZONE_BE double precision,
    ORDERVIEW integer,
    NEEDTESTINPAPKA integer,
    ID_USER integer,
    ID_BLOB_GEN integer)
returns (
    ID integer)
AS
begin
  exit;
end
^


-- CQ[15039, 15046]
create or alter procedure L_IMP_VC_WRITE_ZONA_CENA_EX1 (
    ID_ZONE integer,
    TAB varchar(42),
    EDIZM varchar(250),
    ZONE_BA double precision,
    ZONE_BB double precision,
    ZONE_BC double precision,
    ZONE_BD double precision,
    ZONE_BE double precision,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer,
    ADD_IF_NOT_FOUND integer,
    NAME_TITLE blob sub_type 0 segment size 80,
    NAME_PART blob sub_type 0 segment size 80,
    RAZRAD double precision,
    IDREESTR integer,
    ID_USER integer,
    ID_PUT_TRUD integer,
    FILL_MASK integer,
    USE_EDIZM_IN_FILTER integer,
    UPDNAMEANDEDIZM integer,
    FIND_EDIZM_MODE integer)
returns (
    RES integer,
    IDNORMATIV integer,
    IDRABMAT integer,
    IDPODGROUP integer,
    INSERTED integer,
    LAST_EDIZM_NAME varchar(255),
    FOUNDED integer)
AS
begin
  exit;
end
^


-- CQ[15039, 15046]
create or alter procedure B_WRITE_RECORD_RABMAT (
    IDUSER integer,
    IDREESTR integer,
    ID integer,
    IDZONE integer,
    RABMAT integer,
    NAME_PART blob sub_type 1 segment size 80,
    NAME_TITLE blob sub_type 1 segment size 80,
    TAB varchar(42),
    IDOGL integer,
    ALTTAB varchar(250),
    IDEDIZM integer,
    RAZRAD double precision,
    BA double precision,
    BB double precision,
    BB_OTP double precision,
    BB_PR double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    TRANSP_P double precision,
    ZAG_SKL_1 double precision,
    ZAG_SKL_P double precision,
    KLASS_G integer,
    TAB_TRANSP varchar(42),
    BJ double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    MN double precision,
    MO double precision,
    MP double precision,
    MQ double precision,
    MR double precision,
    MS double precision,
    MT double precision,
    VRPZ integer,
    NTR integer,
    BRUTTO double precision,
    NETTO double precision,
    VB double precision,
    VN double precision,
    PREISK varchar(42),
    POSPREISK varchar(42),
    TKALK varchar(50),
    MBETON double precision,
    MRKBETON varchar(15),
    VBETON double precision,
    MMASHINE varchar(25),
    PUNKTIND varchar(42),
    IDPOSTAV integer,
    IDABCOKP integer,
    comment varchar(42),
    ISESN smallint,
    IDWITHESN integer,
    IDSOST integer,
    SOSTAVRABOT blob sub_type 0 segment size 80,
    IDTCH integer,
    FRTCH varchar(250),
    IDESN integer,
    FRESN varchar(21),
    IDTCARD integer,
    IDPICTURE integer,
    IDQUALIFIER integer,
    RECALCULATEKOEFF double precision,
    ZONE_BA double precision,
    ZONE_BB double precision,
    ZONE_BC double precision,
    ZONE_BD double precision,
    ZONE_BE double precision,
    NEEDUPDATE_NAME_PART integer,
    NEEDUPDATE_NAME_TITLE integer,
    NEEDUPDATESOST integer,
    TABTESTMODE integer,
    EMPTYPARAM integer,
    ID_GEN integer,
    TRANSP_SH varchar(255))
AS
DECLARE VARIABLE TABU VARCHAR(42);
DECLARE VARIABLE RESACTION INTEGER;
DECLARE VARIABLE RECORDEXISTS INTEGER;
DECLARE VARIABLE ID_NAME INTEGER;
BEGIN
 IF ((ID_GEN <> -1) AND ((NAME_PART IS NOT NULL) OR (NAME_TITLE IS NOT NULL))) THEN BEGIN
    IF (ID_GEN > 0) THEN BEGIN
       UPDATE B_TEMP_BLOB SET BLOB1 = :NAME_PART, BLOB2 = :NAME_TITLE WHERE ID = :ID_GEN;
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_GEN INTO :NAME_PART, :NAME_TITLE;
    END
    ELSE BEGIN
       ID_NAME = GEN_ID(B_GEN_TEMP, 1) ;
       INSERT INTO B_TEMP_BLOB(ID, BLOB1, BLOB2) VALUES (:ID_NAME, :NAME_PART, :NAME_TITLE);
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_NAME INTO :NAME_PART, :NAME_TITLE;
       DELETE FROM B_TEMP_BLOB WHERE ID = :ID_NAME ;
    END
 END

 IF (NOT EXISTS (SELECT * FROM B_RABMAT WHERE ID = :ID))
 THEN EXCEPTION B_E_RABMAT_NOT_FOUND ;

 TABU = TAB ;

 IF (TAB <> '') THEN BEGIN
    TAB = LCKTRIMVARCHAR(TAB) ;
    TABU = S_TRANSLITERATE/*[14280]_TAB*/(TAB); --[12447]

    IF (TABTESTMODE = 0)
    THEN
    BEGIN
       SELECT RECORDEXISTS
       FROM B_TEST_RABMAT_RECORD_EXISTS (:IDUSER, :IDREESTR, :ID, :TABU)
       INTO :RECORDEXISTS ;

       IF (RECORDEXISTS = 1)
       THEN EXCEPTION B_E_TAB_EXISTS ;
    END
 END

 IF (ALTTAB <> '')
 THEN ALTTAB = LCKTRIMVARCHAR(ALTTAB) ;

 IF ((NEEDUPDATE_NAME_PART = 1) OR (NEEDUPDATE_NAME_TITLE = 1))
 THEN
    SELECT IDNAME
    FROM B_WRITE_NAME_EX (:IDUSER, 0, :ID,
       :NAME_PART, :NEEDUPDATE_NAME_PART, :NAME_TITLE, :NEEDUPDATE_NAME_TITLE)
    INTO :ID_NAME;

 IF (NEEDUPDATESOST = 1)
 THEN EXECUTE PROCEDURE B_FIND_AND_WRITE_SOSTAVRABOT (:IDUSER, :ID, :IDSOST, :SOSTAVRABOT)
 RETURNING_VALUES :IDSOST ;

 IF (IDTCH <= 0)
 THEN IDTCH = NULL ;

 IF (IDTCH IS NOT NULL)
 THEN
    IF (NOT EXISTS(SELECT * FROM B_REESTR_DOC WHERE ID = :IDTCH))
    THEN EXCEPTION B_E_T_CH_NOT_FOUND ;

 IF (IDESN <= 0)
 THEN IDESN = NULL ;
 IF (IDESN IS NOT NULL)
 THEN
    IF (NOT EXISTS(SELECT * FROM B_REESTR_DOC WHERE ID = :IDESN))
    THEN EXCEPTION B_E_ESN_NOT_FOUND ;


 IF (IDTCARD <= 0)
 THEN IDTCARD = NULL ;
 IF (IDTCARD IS NOT NULL)
 THEN
    IF (NOT EXISTS(SELECT * FROM B_REESTR_DOC WHERE ID = :IDTCARD))
    THEN EXCEPTION B_E_T_CARD_NOT_FOUND ;


 IF (IDPICTURE <= 0)
 THEN IDPICTURE = NULL ;
 IF (IDPICTURE IS NOT NULL)
 THEN
    IF (NOT EXISTS(SELECT * FROM B_MATER_PICTURES WHERE ID = :IDPICTURE))
    THEN EXCEPTION B_E_MATER_PICTURE_NOT_FOUND ;

 IF (IDOGL <= 0)
 THEN IDOGL = NULL ;
 IF (IDOGL IS NOT NULL)
 THEN
    IF (NOT EXISTS (SELECT * FROM B_OGL WHERE ID = :IDOGL))
    THEN IDOGL = NULL ;


 IF (IDQUALIFIER <= 0)
 THEN IDQUALIFIER = NULL ;
 IF (IDQUALIFIER is not null)
 THEN
    IF (NOT EXISTS (SELECT * FROM B_QUALIFIER WHERE ID = :IDQUALIFIER))
    THEN IDQUALIFIER = NULL ;

 EXECUTE PROCEDURE B_WRITE_ED_IZM_IN_TABLE(:IDUSER, 0, :ID, :IDEDIZM) ;

 EXECUTE PROCEDURE B_WRITE_ZONE_CENA(:IDUSER, :IDZONE, :ID, :RABMAT, 1,
      :ZONE_BA, :ZONE_BB, :ZONE_BC, :ZONE_BD, :ZONE_BE, 0)
 RETURNING_VALUES RESACTION ;

 BEGIN
    IF ((RECALCULATEKOEFF <> 1) AND (RECALCULATEKOEFF <> 0))
    THEN EXECUTE PROCEDURE B_RECALC_RABMAT_KOEFF (:IDUSER, :ID, RECALCULATEKOEFF) ;

    UPDATE B_RABMAT
    SET IDTCH = :IDTCH, FRTCH = :FRTCH,
        IDESN = :IDESN, FRESN = :FRESN,
        TAB = :TAB, --[14280]TABU = :TABU,
        IDOGL = :IDOGL,
        ALTTAB = :ALTTAB,
        IDTCARD = :IDTCARD, RAZRAD = :RAZRAD,
        BA = :BA, BB = :BB,
        BB_OTP = :BB_OTP, --<<[14355]
        BC = :BC, BD = :BD, BE = :BE,
        BF = :BF, BG = :BG, BH = :BH, BI = :BI,
        /*<[14420]>*/ TRANSP_P = :TRANSP_P,
        ZAG_SKL_1 = :ZAG_SKL_1, ZAG_SKL_P = :ZAG_SKL_P,
        KLASS_G = :KLASS_G, TAB_TRANSP = :TAB_TRANSP, --</>
        BJ = :BJ,
        PA = :PA, PB = :PB, PC = :PC, PD = :PD, PE = :PE,
        MA = :MA, MB = :MB, MC = :MC, MD = :MD, ME = :ME,
        MF = :MF, MG = :MG, MH = :MH, MI = :MI, MJ = :MJ,
        MK = :MK, ML = :ML, MM = :MM, MN = :MN, MO = :MO,
        MP = :MP, MQ = :MQ, MR = :MR, MS = :MS, MT = :MT,
        VRPZ = :VRPZ, NTR = :NTR,
        BRUTTO = :BRUTTO, NETTO = :NETTO,
        VB = :VB, VN = :VN,
        PREISK = :PREISK, POSPREISK = :POSPREISK,
        TKALK = :TKALK,
        MBETON = :MBETON, MRKBETON = :MRKBETON, VBETON = :VBETON,
        MMASHINE = :MMASHINE,
        PUNKTIND = :PUNKTIND,
        IDPICTURE = :IDPICTURE,
        IDPOSTAV = :IDPOSTAV,
        IDABCOKP = :IDABCOKP,
        COMMENT = :COMMENT,
        ISESN = :ISESN,
        IDWITHESN = :IDWITHESN,
        IDQUALIFIER = :IDQUALIFIER,
        BB_PR = :BB_PR,        -- MK CQ[15046]
        TRANSP_SH = :TRANSP_SH -- MK CQ[15039]
    WHERE (ID = :ID);

    WHEN GDSCODE FOREIGN_KEY, GDSCODE BAD_SEGSTR_ID DO EXCEPTION B_E_RECORD_IS_LOCKED ;
 END
END
^


-- CQ[15039, 15046]
create or alter procedure B_PASTE_EXCEL_IN_RABMAT (
    IDUSER integer,
    IDREESTR integer,
    ORDERVIEW integer,
    IDOGL integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NAME blob sub_type 1 segment size 80,
    EDIZM varchar(100),
    IN_IDEDIZM integer,
    BB double precision,
    BB_OTP double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BRUTTO double precision,
    NETTO double precision,
    IDENT_KOD_MAT_SAP varchar(30),
    BASE_EDIZM_SAP varchar(42),
    STOIM_MAT_SAP double precision)
returns (
    ID integer)
AS
declare variable RABMAT integer;
declare variable TABU varchar(42);
declare variable IDEDIZM integer;
declare variable IDTCH integer;
declare variable FRTCH varchar(250);
declare variable IDESN integer;
declare variable FRESN varchar(21);
declare variable comment varchar(42);
declare variable RAZRAD double precision;
declare variable BA double precision;
--[14355]
--declare variable BB_OTP double precision;
--<[14420]>
declare TRANSP_P double precision;
declare ZAG_SKL_1 double precision;
declare ZAG_SKL_P double precision;
declare KLASS_G integer;
declare TAB_TRANSP varchar(42);
--</>
declare variable BJ double precision;
declare variable PA double precision;
declare variable PB double precision;
declare variable PC double precision;
declare variable PD double precision;
declare variable PE double precision;
declare variable MA double precision;
declare variable MB double precision;
declare variable MC double precision;
declare variable MD double precision;
declare variable ME double precision;
declare variable MF double precision;
declare variable MG double precision;
declare variable MH double precision;
declare variable MI double precision;
declare variable MJ double precision;
declare variable MK double precision;
declare variable ML double precision;
declare variable MM double precision;
declare variable MN double precision;
declare variable MO double precision;
declare variable MP double precision;
declare variable MQ double precision;
declare variable MR double precision;
declare variable MS double precision;
declare variable MT double precision;
declare variable VRPZ integer;
declare variable NTR integer;
declare variable VB double precision;
declare variable VN double precision;
declare variable PREISK varchar(42);
declare variable POSPREISK varchar(42);
declare variable MBETON double precision;
declare variable MRKBETON varchar(15);
declare variable MMASHINE varchar(25);
declare variable VBETON double precision;
declare variable TKALK varchar(50);
declare variable PUNKTIND varchar(42);
declare variable IDSOSTAV integer;
declare variable IDTCARD integer;
declare variable IDPICTURE integer;
declare variable IDPOSTAV integer;
declare variable ISESN smallint;
declare variable IDWITHESN integer;
declare variable RECORDEXISTS integer;
declare variable IDQUALIFIER integer;
declare variable IDEDIZMGROUP integer;
begin
  --    CQ[12361]    CopyPaste  B_PASTE_SMETA_IN_RABMAT

  --  Rabmat ,   
  select RABMAT
  from B_REESTR
  where ID = :IDREESTR
  into RABMAT;

  IDTCH = null;
  FRTCH = null;
  IDSOSTAV = null;
  comment = null;
  IDTCARD = null;
  IDESN = null;
  FRESN = null;
  RAZRAD = null;
  VRPZ = null;
  NTR = null;
  VB = null;
  VN = null;
  PREISK = null;
  POSPREISK = null;
  MBETON = null;
  MRKBETON = null;
  VBETON = null;
  MMASHINE = null;
  IDPICTURE = null;
  TKALK = null;
  PUNKTIND = null;
  IDPOSTAV = null;
  ISESN = null;
  IDWITHESN = null;
  IDQUALIFIER = null;

  BA = null;
  BJ = null;
  PA = null;
  PB = null;
  PC = null;
  PD = null;
  PE = null;
  MA = null;
  MB = null;
  MC = null;
  MD = null;
  ME = null;
  MF = null;
  MG = null;
  MH = null;
  MI = null;
  MJ = null;
  MK = null;
  ML = null;
  MM = null;
  MN = null;
  MO = null;
  MP = null;
  MQ = null;
  MR = null;
  MS = null;
  MT = null;

  TABU = TAB;
  if (TAB <> '') then
    TABU = S_TRANSLITERATE/*[14280]_TAB*/(LCKTRIMVARCHAR(TAB)); --[12447]

  /* ,        */
  select RECORDEXISTS
  from B_TEST_RABMAT_RECORD_EXISTS(:IDUSER, :IDREESTR, null, :TABU)
  into :RECORDEXISTS;

  if (RECORDEXISTS = 0) then
  begin
    IDEDIZM = coalesce(:IN_IDEDIZM, 0);
    if (:IDEDIZM = 0) then
    begin
      --  B_EDIZM
      execute procedure B_FIND_EDIZM(:IDUSER, :EDIZM, '')
      returning_values :IDEDIZM;
      if (IDEDIZM is null) then --   - 
      begin
        if (EDIZM <> '') then  --CQ[TIMUR 12919]
        begin
          --  "   "    - 
          execute procedure DM_ADD_EDIZMGROUP('   ')
          returning_values :IDEDIZMGROUP;

          execute procedure B_ADD_EDIZM(:IDUSER, :IDEDIZMGROUP, :EDIZM, :EDIZM, 1)
          returning_values :IDEDIZM;
        end
      end
    end

    /*    B_Rabmat */
    select ID
    from B_ADD_RABMAT_RECORD(:IDUSER, :IDREESTR, :IDOGL, :IDQUALIFIER, :ORDERVIEW, :NAME, null, -1)
    into :ID;

    execute procedure B_WRITE_RECORD_RABMAT(:IDUSER, :IDREESTR, :ID, null, :RABMAT, null, null,
      :TAB, :IDOGL, :ALTTAB, :IDEDIZM, :RAZRAD, :BA, :BB,
      :BB_OTP, --[14355]
      null, -- BB_PR CQ[15046]
      :BC, :BD, :BE, :BF, :BG, :BH, :BI,
      :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
      :BJ,
      :PA, :PB, :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML, :MM, :MN,
      :MO, :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
      :TKALK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND, :IDPOSTAV, null, :comment, :ISESN,
      :IDWITHESN, :IDSOSTAV, null, :IDTCH, :FRTCH, :IDESN, :FRESN, :IDTCARD, :IDPICTURE,
      :IDQUALIFIER, 1, null, null, null, null, null, 0, 0, 1, 0, 0, -1,
      null); -- TRANSP_SH CQ[15039]

    update B_RABMAT set
      IDENT_KOD_MAT_SAP = :IDENT_KOD_MAT_SAP,
      BASE_EDIZM_SAP = :BASE_EDIZM_SAP,
      STOIM_MAT_SAP = :STOIM_MAT_SAP
    where ID = :ID;
    suspend;
  end
end
^


-- CQ[15039, 15046]
create or alter procedure B_PASTE_NORMY_IN_RABMAT (
    IDUSER integer,
    IDREESTR integer,
    ORDERVIEW integer,
    IDOGL integer,
    INTAB varchar(42),
    PASTEBLOB blob sub_type 0 segment size 80,
    PODGROUPBLOB blob sub_type 0 segment size 80,
    PASTECOUNT integer,
    ISPASTEFROMBUFER integer)
returns (
    ID integer,
    PASTEDID integer,
    REJECTCOUNT integer)
AS
DECLARE VARIABLE IDNORMY INTEGER;
DECLARE VARIABLE IDPODGROUP INTEGER;
DECLARE VARIABLE BUFERIDNORMY INTEGER;
DECLARE VARIABLE RABMAT INTEGER;
DECLARE VARIABLE TAB VARCHAR(42);
DECLARE VARIABLE TABU VARCHAR(42);
DECLARE VARIABLE ALTTAB VARCHAR(250);
DECLARE VARIABLE IDNAME INTEGER;
DECLARE VARIABLE IDEDIZM INTEGER;
DECLARE VARIABLE IDTCH INTEGER;
DECLARE VARIABLE FRTCH VARCHAR(250);
DECLARE VARIABLE IDESN INTEGER;
DECLARE VARIABLE FRESN VARCHAR(21);
DECLARE VARIABLE IDABCOKP INTEGER;
DECLARE VARIABLE COMMENT VARCHAR(42);
DECLARE VARIABLE RAZRAD DOUBLE PRECISION;
DECLARE VARIABLE BA DOUBLE PRECISION;
DECLARE VARIABLE BB DOUBLE PRECISION;
--<[14355]>
declare BB_OTP double precision; --</>
DECLARE VARIABLE BC DOUBLE PRECISION;
DECLARE VARIABLE BD DOUBLE PRECISION;
DECLARE VARIABLE BE DOUBLE PRECISION;
DECLARE VARIABLE BF DOUBLE PRECISION;
DECLARE VARIABLE BG DOUBLE PRECISION;
DECLARE VARIABLE BH DOUBLE PRECISION;
DECLARE VARIABLE BI DOUBLE PRECISION;
--<[14420]>
declare TRANSP_P double precision;
declare ZAG_SKL_1 double precision;
declare ZAG_SKL_P double precision;
declare KLASS_G integer;
declare TAB_TRANSP varchar(42);
--</>
DECLARE VARIABLE BJ DOUBLE PRECISION;
DECLARE VARIABLE PA DOUBLE PRECISION;
DECLARE VARIABLE PB DOUBLE PRECISION;
DECLARE VARIABLE PC DOUBLE PRECISION;
DECLARE VARIABLE PD DOUBLE PRECISION;
DECLARE VARIABLE PE DOUBLE PRECISION;
DECLARE VARIABLE MA DOUBLE PRECISION;
DECLARE VARIABLE MB DOUBLE PRECISION;
DECLARE VARIABLE MC DOUBLE PRECISION;
DECLARE VARIABLE MD DOUBLE PRECISION;
DECLARE VARIABLE ME DOUBLE PRECISION;
DECLARE VARIABLE MF DOUBLE PRECISION;
DECLARE VARIABLE MG DOUBLE PRECISION;
DECLARE VARIABLE MH DOUBLE PRECISION;
DECLARE VARIABLE MI DOUBLE PRECISION;
DECLARE VARIABLE MJ DOUBLE PRECISION;
DECLARE VARIABLE MK DOUBLE PRECISION;
DECLARE VARIABLE ML DOUBLE PRECISION;
DECLARE VARIABLE MM DOUBLE PRECISION;
DECLARE VARIABLE MN DOUBLE PRECISION;
DECLARE VARIABLE MO DOUBLE PRECISION;
DECLARE VARIABLE MP DOUBLE PRECISION;
DECLARE VARIABLE MQ DOUBLE PRECISION;
DECLARE VARIABLE MR DOUBLE PRECISION;
DECLARE VARIABLE MS DOUBLE PRECISION;
DECLARE VARIABLE MT DOUBLE PRECISION;
DECLARE VARIABLE VRPZ INTEGER;
DECLARE VARIABLE NTR INTEGER;
DECLARE VARIABLE BRUTTO DOUBLE PRECISION;
DECLARE VARIABLE NETTO DOUBLE PRECISION;
DECLARE VARIABLE VB DOUBLE PRECISION;
DECLARE VARIABLE VN DOUBLE PRECISION;
DECLARE VARIABLE PREISK VARCHAR(42);
DECLARE VARIABLE POSPREISK VARCHAR(42);
DECLARE VARIABLE MBETON DOUBLE PRECISION;
DECLARE VARIABLE MRKBETON VARCHAR(15);
DECLARE VARIABLE MMASHINE VARCHAR(25);
DECLARE VARIABLE VBETON DOUBLE PRECISION;
DECLARE VARIABLE TKALK VARCHAR(50);
DECLARE VARIABLE PUNKTIND VARCHAR(42);
DECLARE VARIABLE NAME_TITLE BLOB SUB_TYPE 1 SEGMENT SIZE 80;
DECLARE VARIABLE NAME_PART BLOB SUB_TYPE 1 SEGMENT SIZE 80;
DECLARE VARIABLE IDSOSTAV INTEGER;
DECLARE VARIABLE IDTCARD INTEGER;
DECLARE VARIABLE IDPICTURE INTEGER;
DECLARE VARIABLE IDPOSTAV INTEGER;
DECLARE VARIABLE ISESN SMALLINT;
DECLARE VARIABLE IDWITHESN INTEGER;
DECLARE VARIABLE ID_UNIQUE INTEGER;
DECLARE VARIABLE ISZONEFIND INTEGER;
DECLARE VARIABLE RECORDEXISTS INTEGER;
DECLARE VARIABLE CENA DOUBLE PRECISION;
DECLARE VARIABLE TAB_OKP VARCHAR(42);
DECLARE VARIABLE COUNTER INTEGER;
DECLARE VARIABLE ZONEID INTEGER;
DECLARE VARIABLE RESACTION INTEGER;
DECLARE VARIABLE IDQUALIFIER INTEGER;
DECLARE VARIABLE ID_TMP INTEGER;
DECLARE VARIABLE STATUS INTEGER;
-- MK CQ[15046]
declare variable BB_PR double precision;
-- MK CQ[15039]
declare variable TRANSP_SH varchar(255);
BEGIN

 ID_TMP = GEN_ID(B_GEN_TEMP, 1) ;
 INSERT INTO B_TEMP_BLOB (ID, BLOB1, BLOB2) VALUES (:ID_TMP, :PASTEBLOB, :PODGROUPBLOB);
 SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_TMP INTO :PASTEBLOB, :PODGROUPBLOB;
 DELETE FROM B_TEMP_BLOB WHERE ID = :ID_TMP ;

 REJECTCOUNT = 0 ;

 FOR SELECT FVALUE FROM S_INTFROMBLOB_SELECT (:PASTEBLOB, :PASTECOUNT)
 INTO :IDNORMY
 DO BEGIN
    IDPODGROUP = READINTFROMBLOB (:PODGROUPBLOB, :COUNTER);

    PASTEDID  = NULL ;
    RABMAT    = NULL;  IDNAME   = NULL;  TAB       = NULL;  ID_UNIQUE = NULL;
    IDTCH     = NULL;  FRTCH    = NULL;  IDSOSTAV  = NULL;  ALTTAB    = NULL;
    IDEDIZM   = NULL;  IDABCOKP = NULL;  COMMENT   = NULL;  IDTCARD   = NULL;
    IDESN     = NULL;  FRESN    = NULL;  RAZRAD    = NULL;  VRPZ      = NULL;
    NTR       = NULL;  BRUTTO   = NULL;  NETTO     = NULL;  VB        = NULL;
    VN        = NULL;  PREISK   = NULL;  POSPREISK = NULL;  MBETON    = NULL;
    MRKBETON  = NULL;  VBETON   = NULL;  MMASHINE  = NULL;  IDPICTURE = NULL;
    TKALK     = NULL;  PUNKTIND = NULL;  IDPOSTAV  = NULL;  ISESN     = NULL;
    IDWITHESN = NULL;  CENA     = NULL;  TAB_OKP   = NULL;  IDQUALIFIER = NULL;
    TABU      = NULL;

    BA = NULL; BB = NULL;
    BB_OTP = null; --[14355]
    BB_PR = null;     -- CQ[15046]
    TRANSP_SH = null; -- CQ[15039]
    BC = NULL;  BD = NULL; BE = NULL; BF = NULL;
    BG = NULL; BH = NULL; BI = NULL;
    TRANSP_P = null; ZAG_SKL_1 = null; ZAG_SKL_P = null; KLASS_G = null; TAB_TRANSP = null; --<<[14420]
    BJ = NULL; PA = NULL; PB = NULL;
    PC = NULL; PD = NULL; PE = NULL;  MA = NULL; MB = NULL; MC = NULL;
    MD = NULL; ME = NULL; MF = NULL;  MG = NULL; MH = NULL; MI = NULL;
    MJ = NULL; MK = NULL; ML = NULL;  MM = NULL; MN = NULL; MO = NULL;
    MP = NULL; MQ = NULL; MR = NULL;  MS = NULL; MT = NULL;

    IF (ISPASTEFROMBUFER = 0) THEN BEGIN        /* Not From Bufer */

       IF (IDPODGROUP = 1) THEN BEGIN           /*  From Rabmat */
          FOR SELECT RABMAT, IDNAME, TAB, ID_UNIQUE,
                     IDTCH, FRTCH, IDSOSTAV, ALTTAB, IDEDIZM, IDABCOKP, COMMENT,
                     IDTCARD, IDESN, FRESN, RAZRAD,
                     BA, BB,
                     BB_OTP, --[14355]
                     BB_PR,  -- CQ[15046]
                     BC, BD, BE, BF, BG, BH, BI,
                     TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
                     BJ, PA, PB, PC,
                     PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK,
                     ML, MM, MN, MO, MP, MQ, MR, MS, MT, VRPZ, NTR,
                     BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
                     MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK,
                     PUNKTIND, IDPOSTAV, ISESN, IDWITHESN, IDQUALIFIER,
                     TRANSP_SH -- CQ[15039]
          FROM B_RABMAT
          WHERE (ID = :IDNORMY)
          INTO       :RABMAT, :IDNAME, :TAB, ID_UNIQUE,
                     :IDTCH, :FRTCH, :IDSOSTAV, :ALTTAB, :IDEDIZM,  :IDABCOKP, :COMMENT,
                     :IDTCARD, :IDESN, :FRESN, :RAZRAD,
                     :BA, :BB,
                     :BB_OTP, --[14355]
                     :BB_PR,  -- CQ[15046]
                     :BC, :BD, :BE, :BF, :BG, :BH, :BI,
                     :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
                     :BJ, :PA, :PB, :PC,
                     :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK,
                     :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR,
                     :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
                     :MBETON, :MRKBETON, :VBETON, :MMASHINE,:IDPICTURE, :TKALK,
                     :PUNKTIND, :IDPOSTAV, :ISESN, :IDWITHESN, :IDQUALIFIER,
                     :TRANSP_SH -- CQ[15039]
          DO BEGIN
             IF (INTAB IS NOT NULL) THEN BEGIN
                TAB = INTAB ;
                INTAB = NULL ;
             END

             IF (TAB <> '')
             THEN TABU = S_TRANSLITERATE/*[14280]_TAB*/(LCKTRIMVARCHAR(TAB)) ; --[12447]

             SELECT RECORDEXISTS
             FROM B_TEST_RABMAT_RECORD_EXISTS (:IDUSER, :IDREESTR, NULL, :TABU)
             INTO :RECORDEXISTS ;

             IF (RECORDEXISTS = 1) THEN REJECTCOUNT = REJECTCOUNT + 1;
             ELSE BEGIN
                SELECT NAME_TITLE, NAME_PART
                FROM B_GETNAME_2 (:IDUSER, :IDNAME)
                INTO :NAME_TITLE, :NAME_PART ;

                SELECT ID
                FROM B_ADD_RABMAT_RECORD (:IDUSER, :IDREESTR, :IDOGL, :IDQUALIFIER,
                                          :ORDERVIEW, :NAME_PART, :NAME_TITLE, -1)
                INTO :ID ;

                EXECUTE PROCEDURE B_WRITE_RECORD_RABMAT(:IDUSER, :IDREESTR, :ID, NULL,
                        :RABMAT, NULL, NULL, :TAB, :IDOGL, :ALTTAB, :IDEDIZM, :RAZRAD,
                        :BA, :BB,
                        :BB_OTP, --[14355]
                        :BB_PR,  --[15046]
                        :BC, :BD, :BE, :BF, :BG, :BH, :BI,
                        :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
                        :BJ, :PA, :PB,
                        :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH,
                        :MI, :MJ, :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, 
                        :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
                        :TKALK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND,
                        :IDPOSTAV, NULL, :COMMENT, :ISESN, :IDWITHESN, :IDSOSTAV,
                        NULL, :IDTCH, :FRTCH, :IDESN, :FRESN, :IDTCARD,
                        :IDPICTURE, :IDQUALIFIER, 1, NULL, NULL, NULL, NULL, NULL, 0, 0, 1, 0, 0, -1,
                        :TRANSP_SH) ; -- CQ[15039]

                EXECUTE PROCEDURE B_COPY_RABMAT_RECORD_RESURSES (:IDUSER, :IDNORMY, :ID) ;

                FOR SELECT IDZONE
                FROM B_READ_RABMAT_ZONES(:IDUSER, :IDREESTR)
                INTO :ZONEID
                DO
                   EXECUTE PROCEDURE B_COPY_RABMAT_RECORD_ZONECEN (:IDUSER, :ZONEID, :IDNORMY, :ID) ;

                PASTEDID  = IDNORMY;
                ORDERVIEW = ORDERVIEW + 1 ;

                SUSPEND ;

                WHEN ANY DO REJECTCOUNT = REJECTCOUNT + 1;
             END
          END
       END

       ELSE BEGIN                                              /*  From ABC_OKP */

          FOR SELECT TAB, RABMAT, IDNAME, IDNORMA, COMMENT, ID_UNIQUE, IDEDIZM,
                     CENA, RAZRAD, IDPOSTAV, PUNKTIND, VRPZ, NTR, IDQUALIFIER
          FROM B_ABC_OKP
          WHERE (ID = :IDNORMY)
          INTO       :COMMENT, :RABMAT, :IDNAME, :IDABCOKP, :TAB, :ID_UNIQUE, :IDEDIZM,
                     :CENA, :RAZRAD, :IDPOSTAV, :PUNKTIND, :VRPZ, :NTR, :IDQUALIFIER
          DO BEGIN
             /*    - */
             IDQUALIFIER = NULL ;

             IF (INTAB IS NOT NULL) THEN BEGIN
                TAB = INTAB ;
                INTAB = NULL ;
             END ELSE BEGIN
                IF (:IDABCOKP IS NOT NULL) THEN BEGIN
                   SELECT TAB FROM B_RABMAT WHERE ID = :IDABCOKP
                   INTO :TAB_OKP ;

                   IF (TAB IS NULL) THEN TAB = TAB_OKP ;
                END
             END

             IF (TAB <> '')
             THEN TABU = S_TRANSLITERATE/*[14280]_TAB*/(LCKTRIMVARCHAR(TAB)) ; --[12447]

             SELECT RECORDEXISTS FROM B_TEST_RABMAT_RECORD_EXISTS (:IDUSER, :IDREESTR, NULL, :TABU)
             INTO :RECORDEXISTS ;

             IF (RECORDEXISTS = 1) THEN REJECTCOUNT = REJECTCOUNT + 1;
             ELSE BEGIN

                IF (:IDABCOKP IS NOT NULL) THEN
                   SELECT IDTCH, FRTCH, IDSOSTAV, ALTTAB, IDTCARD, IDESN, FRESN,
                          BB_OTP, --[14355]
                          BB_PR,  -- CQ[15046]
                          BD, BF, BG, BH, BI,
                          TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
                          BJ, PA, PB, PC, PD, PE, MA, MB,
                          MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO, MP,
                          MQ, MR, MS, MT, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
                          MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, ISESN, IDWITHESN,
                          TRANSP_SH -- CQ[15039]
                   FROM B_RABMAT WHERE ID = :IDABCOKP
                   INTO   :IDTCH, :FRTCH, :IDSOSTAV, :ALTTAB, :IDTCARD, :IDESN, :FRESN,
                          :BB_OTP, --[14355]
                          :BB_PR,  -- CQ[15046]
                          :BD, :BF, :BG, :BH, :BI,
                          :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
                          :BJ, :PA, :PB, :PC, :PD, :PE, :MA, :MB,
                          :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML, :MM, :MN, :MO, :MP,
                          :MQ, :MR, :MS, :MT, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
                          :MBETON, :MRKBETON, :VBETON, :MMASHINE, :IDPICTURE, :TKALK, :ISESN, :IDWITHESN,
                          :TRANSP_SH ; -- CQ[15039]

                SELECT NAME_TITLE, NAME_PART
                FROM B_GETNAME_2 (:IDUSER, :IDNAME)
                INTO :NAME_TITLE, :NAME_PART ;

                SELECT ID FROM B_ADD_RABMAT_RECORD (:IDUSER, :IDREESTR, :IDOGL,
                   :IDQUALIFIER, :ORDERVIEW, :NAME_PART, :NAME_TITLE, -1)
                INTO :ID ;

                SELECT BA, BB, BC, BD, BE FROM B_REALLOCATION_CENA (:IDUSER, :RABMAT, :CENA, :BD)
                INTO :BA, :BB, :BC, :BD, :BE ;

                EXECUTE PROCEDURE B_WRITE_RECORD_RABMAT(:IDUSER, :IDREESTR, :ID, NULL,
                        :RABMAT, NULL, NULL, TAB, :IDOGL, :ALTTAB, :IDEDIZM, :RAZRAD,
                        :BA, :BB,
                        :BB_OTP, --[14355]
                        :BB_PR,  --[15046]
                        :BC, :BD, :BE, :BF, :BG, :BH, :BI,
                        :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
                        :BJ, :PA, :PB,
                        :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH,
                        :MI, :MJ, :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, 
                        :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
                        :TKALK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND,
                        :IDPOSTAV, NULL, :COMMENT, :ISESN, :IDWITHESN, :IDSOSTAV,
                        NULL, :IDTCH, :FRTCH, :IDESN, :FRESN, :IDTCARD,
                        :IDPICTURE, :IDQUALIFIER, 1, NULL, NULL, NULL, NULL, NULL, 0, 0, 1, 0, 0, -1,
                        :TRANSP_SH) ; -- CQ[15039]

                FOR SELECT IDZONE FROM B_READ_RABMAT_ZONES(:IDUSER, :IDREESTR)
                INTO :ZONEID DO BEGIN
                   EXECUTE PROCEDURE B_READ_ZONE_ABC_TSENY (:IDUSER, :IDNORMY, :ZONEID)
                   RETURNING_VALUES :CENA, :ISZONEFIND;

                   IF (CENA IS NOT NULL)
                   THEN EXECUTE PROCEDURE B_WRITE_ZONE_CENA (:IDUSER, :ZONEID, :ID,
                        :RABMAT, 1, :CENA, NULL, NULL, NULL, NULL, 1)
                   RETURNING_VALUES :RESACTION;
                END

                PASTEDID  = IDNORMY;
                ORDERVIEW = ORDERVIEW + 1 ;

                SUSPEND ;

                WHEN ANY DO REJECTCOUNT = REJECTCOUNT + 1;
             END
          END
       END
    END ELSE BEGIN                                  /* From Bufer */
       IF (IDPODGROUP = 1) THEN BEGIN               /*  From Rabmat */

          FOR SELECT IDNORMY, RABMAT, NAME_PART, NAME_TITLE, TAB, IDUNIQUE,
                     IDTCH, FRTCH, IDSOSTAV, ALTTAB, IDEDIZM, IDABCOKP, COMMENT,
                     IDTCARD, IDESN, FRESN, RAZRAD,
                     BA, BB,
                     R.BB_OTP, --[14355]
                     R.BB_PR,  --[15046]
                     BC, BD, BE, BF, BG, BH, BI,
                     R.TRANSP_P, R.ZAG_SKL_1, R.ZAG_SKL_P, R.KLASS_G, R.TAB_TRANSP, --<<[14420]
                     BJ, PA, PB, PC,
                     PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK,
                     ML, MM, MN, MO, MP, MQ, MR, MS, MT, VRPZ, NTR,
                     BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
                     MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK,
                     PUNKTIND, IDPOSTAV, ISESN, IDWITHESN, IDQUALIFIER,
                     R.TRANSP_SH -- CQ[15039]
          FROM S_BUFER_RABMAT_SELECT_ONE (:IDUSER, :IDNORMY, NULL)
          left join B_RABMAT R on R.ID = :IDNORMY --<<[14420]
          INTO       :BUFERIDNORMY, :RABMAT, :NAME_PART, :NAME_TITLE, :TAB, ID_UNIQUE,
                     :IDTCH, :FRTCH, :IDSOSTAV, :ALTTAB, :IDEDIZM,  :IDABCOKP, :COMMENT,
                     :IDTCARD, :IDESN, :FRESN, :RAZRAD,
                     :BA, :BB,
                     :BB_OTP, --[14355]
                     :BB_PR,  --[15046]
                     :BC, :BD, :BE, :BF, :BG, :BH, :BI,
                     :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
                     :BJ, :PA, :PB, :PC,
                     :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK,
                     :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR,
                     :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
                     :MBETON, :MRKBETON, :VBETON, :MMASHINE,:IDPICTURE, :TKALK,
                     :PUNKTIND, :IDPOSTAV, :ISESN, :IDWITHESN, :IDQUALIFIER,
                     :TRANSP_SH -- CQ[15039]
          DO BEGIN
             IF (INTAB IS NOT NULL) THEN BEGIN
                 TAB = INTAB ;
                 INTAB = NULL ;
             END

             IF (TAB <> '')
             THEN TABU = S_TRANSLITERATE/*[14280]_TAB*/(LCKTRIMVARCHAR(TAB)) ; --[12447]

             SELECT RECORDEXISTS
             FROM B_TEST_RABMAT_RECORD_EXISTS (:IDUSER, :IDREESTR, NULL, :TABU)
             INTO :RECORDEXISTS ;

             IF (RECORDEXISTS = 1)
             THEN REJECTCOUNT = REJECTCOUNT + 1;
             ELSE BEGIN

                SELECT ID
                FROM B_ADD_RABMAT_RECORD (:IDUSER, :IDREESTR, :IDOGL, :IDQUALIFIER,
                                          :ORDERVIEW, :NAME_PART, :NAME_TITLE, -1)
                INTO :ID ;

                EXECUTE PROCEDURE B_WRITE_RECORD_RABMAT(:IDUSER, :IDREESTR, :ID, NULL,
                        :RABMAT, NULL, NULL, :TAB, :IDOGL, :ALTTAB, :IDEDIZM, :RAZRAD,
                        :BA, :BB,
                        :BB_OTP, --[14355]
                        :BB_PR,  --[15046]
                        :BC, :BD, :BE, :BF, :BG, :BH, :BI,
                        :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
                        :BJ, :PA, :PB,
                        :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH,
                        :MI, :MJ, :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, 
                        :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
                        :TKALK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND,
                        :IDPOSTAV, NULL, :COMMENT, :ISESN, :IDWITHESN, :IDSOSTAV,
                        NULL, :IDTCH, :FRTCH, :IDESN, :FRESN, :IDTCARD,
                        :IDPICTURE, :IDQUALIFIER, 1, NULL, NULL, NULL, NULL, NULL, 0, 0, 1, 0, 0, -1,
                        :TRANSP_SH) ; -- CQ[15039]

                EXECUTE PROCEDURE B_COPY_RABMAT_RECORD_RESURSES (:IDUSER, :BUFERIDNORMY, :ID) ;

                --CQ[TIMUR 7932]
                STATUS = null;

                SELECT STATUS
                FROM B_RABMAT_EX
                WHERE ID = :IDNORMY
                INTO STATUS;

                if (STATUS <> 0) then
                  INSERT INTO B_RABMAT_EX (ID, STATUS) VALUES (:ID, :STATUS);
                --CQ[TIMUR 7932]

                FOR SELECT IDZONE
                FROM B_READ_RABMAT_ZONES(:IDUSER, :IDREESTR)
                INTO :ZONEID DO
                   EXECUTE PROCEDURE B_COPY_RABMAT_RECORD_ZONECEN (:IDUSER, :ZONEID, :BUFERIDNORMY, :ID) ;

                PASTEDID  = IDNORMY;
                ORDERVIEW = ORDERVIEW + 1 ;

                SUSPEND ;

                WHEN ANY DO REJECTCOUNT = REJECTCOUNT + 1;
             END
          END
       END
       ELSE BEGIN                        /*  From ABC_OKP */
          FOR SELECT IDNORMY, TAB, TABNORMA, IDNORMA, RABMAT, NAME_PART, NAME_TITLE,
                     ID_UNIQUE, IDEDIZM, CENA, RAZRAD, IDPOSTAV, PUNKTIND, VRPZ,
                     NTR, IDQUALIFIER
          FROM S_BUFER_RESURS_SELECT_ONE(:IDUSER, :IDNORMY, NULL)
          INTO       :BUFERIDNORMY, :COMMENT, :TAB, :IDABCOKP, :RABMAT, :NAME_PART, :NAME_TITLE,
                     :ID_UNIQUE, :IDEDIZM, :CENA, :RAZRAD, :IDPOSTAV, :PUNKTIND, :VRPZ,
                     :NTR, :IDQUALIFIER
          DO BEGIN
             IF (INTAB IS NOT NULL) THEN BEGIN
                TAB = INTAB ;
                INTAB = NULL ;
             END

             IF (TAB <> '')
             THEN TABU = S_TRANSLITERATE/*[14280]_TAB*/(LCKTRIMVARCHAR(TAB)) ; --[12447]

             SELECT RECORDEXISTS FROM B_TEST_RABMAT_RECORD_EXISTS (:IDUSER, :IDREESTR, NULL, :TABU)
             INTO :RECORDEXISTS ;

             IF (RECORDEXISTS = 1) THEN REJECTCOUNT = REJECTCOUNT + 1;
             ELSE BEGIN
                IF (:IDABCOKP IS NOT NULL) THEN
                   SELECT IDTCH, FRTCH, IDSOSTAV, ALTTAB, IDTCARD, IDESN, FRESN,
                          BB_OTP, --[14355]
                          BB_PR,  --[15046]
                          BD, BF, BG, BH, BI,
                          TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
                          BJ, PA, PB, PC, PD, PE, MA, MB,
                          MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO, MP,
                          MQ, MR, MS, MT, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
                          MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, ISESN, IDWITHESN,
                          TRANSP_SH -- CQ[15039]
                   FROM B_RABMAT WHERE ID = :IDABCOKP
                   INTO   :IDTCH, :FRTCH, :IDSOSTAV, :ALTTAB, :IDTCARD, :IDESN, :FRESN,
                          :BB_OTP, --[14355]
                          :BB_PR,  --[15046]
                          :BD, :BF, :BG, :BH, :BI,
                          :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
                          :BJ, :PA, :PB, :PC, :PD, :PE, :MA, :MB,
                          :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML, :MM, :MN, :MO, :MP,
                          :MQ, :MR, :MS, :MT, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
                          :MBETON, :MRKBETON, :VBETON, :MMASHINE, :IDPICTURE, :TKALK, :ISESN, :IDWITHESN,
                          :TRANSP_SH ; -- CQ[15039]

                SELECT ID FROM B_ADD_RABMAT_RECORD (:IDUSER, :IDREESTR, :IDOGL,
                   :IDQUALIFIER, :ORDERVIEW, :NAME_PART, :NAME_TITLE, -1)
                INTO :ID ;

                SELECT BA, BB, BC, BD, BE FROM B_REALLOCATION_CENA (:IDUSER, :RABMAT, :CENA, :BD)
                INTO :BA, :BB, :BC, :BD, :BE ;

                EXECUTE PROCEDURE B_WRITE_RECORD_RABMAT(:IDUSER, :IDREESTR, :ID, NULL,
                        :RABMAT, NULL, NULL, :TAB, :IDOGL, :ALTTAB, :IDEDIZM, :RAZRAD,
                        :BA, :BB,
                        :BB_OTP, --[14355]
                        :BB_PR,  --[15046]
                        :BC, :BD, :BE, :BF, :BG, :BH, :BI,
                        :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
                        :BJ, :PA, :PB,
                        :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH,
                        :MI, :MJ, :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, 
                        :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
                        :TKALK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND,
                        :IDPOSTAV, NULL, :COMMENT, :ISESN, :IDWITHESN, :IDSOSTAV,
                        NULL, :IDTCH, :FRTCH, :IDESN, :FRESN, :IDTCARD,
                        :IDPICTURE, :IDQUALIFIER, 1, NULL, NULL, NULL, NULL, NULL, 0, 0, 1, 0, 0, -1,
                        :TRANSP_SH) ; -- CQ[15039]

                FOR SELECT IDZONE FROM B_READ_RABMAT_ZONES(:IDUSER, :IDREESTR)
                INTO :ZONEID DO BEGIN
                   EXECUTE PROCEDURE B_READ_ZONE_ABC_TSENY (:IDUSER, :BUFERIDNORMY, :ZONEID)
                   RETURNING_VALUES :CENA, :ISZONEFIND;

                   IF (CENA IS NOT NULL)
                   THEN EXECUTE PROCEDURE B_WRITE_ZONE_CENA (:IDUSER, :ZONEID, :ID,
                        :RABMAT, 1, :CENA, NULL, NULL, NULL, NULL, 1)
                   RETURNING_VALUES :RESACTION;
                END

                PASTEDID  = IDNORMY;
                ORDERVIEW = ORDERVIEW + 1 ;

                SUSPEND ;

                WHEN ANY DO REJECTCOUNT = REJECTCOUNT + 1;
             END
          END
       END
    END
 END

 ID = NULL ;
 PASTEDID = NULL ;
 SUSPEND ;
END
^


-- CQ[15039, 15046]
create or alter procedure B_PASTE_SMETA_IN_RABMAT (
    IDUSER integer,
    IDREESTR integer,
    ORDERVIEW integer,
    IDOGL integer,
    PASTEBLOB blob sub_type 0 segment size 80,
    PASTECOUNT integer,
    IDPUT_MASH integer,
    IDPUT_MAT integer,
    ID_NEW_MASH integer,
    ID_NEW_MAT integer)
returns (
    ID integer,
    PASTEDID integer)
AS
DECLARE VARIABLE RABMAT INTEGER;
DECLARE VARIABLE TAB VARCHAR(42);
DECLARE VARIABLE TABU VARCHAR(42);
DECLARE VARIABLE TABU_8 VARCHAR(42); --[14280,12447]
DECLARE VARIABLE ALTTAB VARCHAR(250);
DECLARE VARIABLE IDNAME INTEGER;
DECLARE VARIABLE IDEDIZM INTEGER;
DECLARE VARIABLE IDTCH INTEGER;
DECLARE VARIABLE FRTCH VARCHAR(250);
DECLARE VARIABLE IDESN INTEGER;
DECLARE VARIABLE FRESN VARCHAR(21);
DECLARE VARIABLE COMMENT VARCHAR(42);
DECLARE VARIABLE RAZRAD DOUBLE PRECISION;
DECLARE VARIABLE BA DOUBLE PRECISION;
DECLARE VARIABLE BB DOUBLE PRECISION;
--<[14355]>
declare BB_OTP double precision; --</>
DECLARE VARIABLE BC DOUBLE PRECISION;
DECLARE VARIABLE BD DOUBLE PRECISION;
DECLARE VARIABLE BE DOUBLE PRECISION;
DECLARE VARIABLE BF DOUBLE PRECISION;
DECLARE VARIABLE BG DOUBLE PRECISION;
DECLARE VARIABLE BH DOUBLE PRECISION;
DECLARE VARIABLE BI DOUBLE PRECISION;
--<[14420]>
declare TRANSP_P double precision;
declare ZAG_SKL_1 double precision;
declare ZAG_SKL_P double precision;
declare KLASS_G integer;
declare TAB_TRANSP varchar(42);
--</>
DECLARE VARIABLE BJ DOUBLE PRECISION;
DECLARE VARIABLE PA DOUBLE PRECISION;
DECLARE VARIABLE PB DOUBLE PRECISION;
DECLARE VARIABLE PC DOUBLE PRECISION;
DECLARE VARIABLE PD DOUBLE PRECISION;
DECLARE VARIABLE PE DOUBLE PRECISION;
DECLARE VARIABLE MA DOUBLE PRECISION;
DECLARE VARIABLE MB DOUBLE PRECISION;
DECLARE VARIABLE MC DOUBLE PRECISION;
DECLARE VARIABLE MD DOUBLE PRECISION;
DECLARE VARIABLE ME DOUBLE PRECISION;
DECLARE VARIABLE MF DOUBLE PRECISION;
DECLARE VARIABLE MG DOUBLE PRECISION;
DECLARE VARIABLE MH DOUBLE PRECISION;
DECLARE VARIABLE MI DOUBLE PRECISION;
DECLARE VARIABLE MJ DOUBLE PRECISION;
DECLARE VARIABLE MK DOUBLE PRECISION;
DECLARE VARIABLE ML DOUBLE PRECISION;
DECLARE VARIABLE MM DOUBLE PRECISION;
DECLARE VARIABLE MN DOUBLE PRECISION;
DECLARE VARIABLE MO DOUBLE PRECISION;
DECLARE VARIABLE MP DOUBLE PRECISION;
DECLARE VARIABLE MQ DOUBLE PRECISION;
DECLARE VARIABLE MR DOUBLE PRECISION;
DECLARE VARIABLE MS DOUBLE PRECISION;
DECLARE VARIABLE MT DOUBLE PRECISION;
DECLARE VARIABLE VRPZ INTEGER;
DECLARE VARIABLE NTR INTEGER;
DECLARE VARIABLE BRUTTO DOUBLE PRECISION;
DECLARE VARIABLE NETTO DOUBLE PRECISION;
DECLARE VARIABLE VB DOUBLE PRECISION;
DECLARE VARIABLE VN DOUBLE PRECISION;
DECLARE VARIABLE PREISK VARCHAR(42);
DECLARE VARIABLE POSPREISK VARCHAR(42);
DECLARE VARIABLE MBETON DOUBLE PRECISION;
DECLARE VARIABLE MRKBETON VARCHAR(15);
DECLARE VARIABLE MMASHINE VARCHAR(25);
DECLARE VARIABLE VBETON DOUBLE PRECISION;
DECLARE VARIABLE TKALK VARCHAR(50);
DECLARE VARIABLE PUNKTIND VARCHAR(42);
DECLARE VARIABLE NAME_TITLE BLOB SUB_TYPE 1 SEGMENT SIZE 80;
DECLARE VARIABLE NAME_PART BLOB SUB_TYPE 1 SEGMENT SIZE 80;
DECLARE VARIABLE IDSOSTAV INTEGER;
DECLARE VARIABLE IDTCARD INTEGER;
DECLARE VARIABLE IDPICTURE INTEGER;
DECLARE VARIABLE IDPOSTAV INTEGER;
DECLARE VARIABLE ISESN SMALLINT;
DECLARE VARIABLE IDWITHESN INTEGER;
DECLARE VARIABLE ID_UNIQUE INTEGER;
DECLARE VARIABLE RECORDEXISTS INTEGER;
DECLARE VARIABLE IDQUALIFIER INTEGER;
DECLARE VARIABLE ID_TMP INTEGER;
DECLARE VARIABLE IDSMETA INTEGER;
DECLARE VARIABLE IDNORMY INTEGER;
DECLARE VARIABLE IDNORMYPODGROUP INTEGER;
DECLARE VARIABLE IDNORMYRABMAT INTEGER;
DECLARE VARIABLE SMETA_IDHIER INTEGER;
DECLARE VARIABLE SMETA_GROUP INTEGER;
DECLARE VARIABLE SMETA_PODGROUP INTEGER;
DECLARE VARIABLE RES_ID_SELF INTEGER;
DECLARE VARIABLE RES_IDABC_OKP INTEGER;
DECLARE VARIABLE RES_RABMAT INTEGER;
DECLARE VARIABLE RES_PODGROUP INTEGER;
DECLARE VARIABLE RASHOD DOUBLE PRECISION;
DECLARE VARIABLE VIDNR INTEGER;
DECLARE VARIABLE UCH INTEGER;
DECLARE VARIABLE SMETA_SMETATYPE INTEGER;
DECLARE VARIABLE ID_RES INTEGER;
BEGIN
 ID_TMP = GEN_ID(B_GEN_TEMP, 1) ;
 INSERT INTO B_TEMP_BLOB (ID, BLOB1) VALUES (:ID_TMP, :PASTEBLOB);
 SELECT BLOB1 FROM B_TEMP_BLOB WHERE ID = :ID_TMP INTO :PASTEBLOB;
 DELETE FROM B_TEMP_BLOB WHERE ID = :ID_TMP ;

 /*         */
 IF (ID_NEW_MASH = 0)
 THEN ID_NEW_MASH = NULL;

 IF (ID_NEW_MASH IS NOT NULL)
 THEN
    IF (NOT EXISTS(  SELECT ID FROM B_REESTR WHERE ID = :ID_NEW_MASH ))
    THEN ID_NEW_MASH = NULL ;

 IF (ID_NEW_MAT = 0)
 THEN ID_NEW_MAT = NULL;

 IF (ID_NEW_MAT IS NOT NULL)
 THEN
    IF (NOT EXISTS(  SELECT ID FROM B_REESTR WHERE ID = :ID_NEW_MAT ))
    THEN ID_NEW_MAT = NULL ;

 IF (NOT EXISTS(  SELECT ID FROM B_REESTR WHERE ID = :IDREESTR ))
 THEN EXCEPTION B_E_SBORNIK_NOT_FOUND ;

 /*  Rabmat ,    */
 SELECT RABMAT
 FROM B_REESTR
 WHERE ID = :IDREESTR
 INTO RABMAT ;

/* IDSMETA = 30227500; */

 FOR SELECT FVALUE
 FROM S_INTFROMBLOB_SELECT (:PASTEBLOB, :PASTECOUNT)
 INTO IDSMETA
 DO BEGIN

    IDTCH     = NULL;  FRTCH    = NULL;  IDSOSTAV  = NULL;  ALTTAB    = NULL;
    COMMENT   = NULL;  IDTCARD   = NULL;  ID_UNIQUE = NULL;
    IDESN     = NULL;  FRESN    = NULL;  RAZRAD    = NULL;  VRPZ      = NULL;
    NTR       = NULL;  BRUTTO   = NULL;  NETTO     = NULL;  VB        = NULL;
    VN        = NULL;  PREISK   = NULL;  POSPREISK = NULL;  MBETON    = NULL;
    MRKBETON  = NULL;  VBETON   = NULL;  MMASHINE  = NULL;  IDPICTURE = NULL;
    TKALK     = NULL;  PUNKTIND = NULL;  IDPOSTAV  = NULL;  ISESN     = NULL;
    IDWITHESN = NULL;  IDQUALIFIER = NULL;

    BA = NULL; BB = NULL;
    BB_OTP = null; --[14355]
    BC = NULL;  BD = NULL; BE = NULL; BF = NULL;
    BG = NULL; BH = NULL; BI = NULL;
    TRANSP_P = null; ZAG_SKL_1 = null; ZAG_SKL_P = null; KLASS_G = null; TAB_TRANSP = null; --<<[14420]
    BJ = NULL; PA = NULL; PB = NULL;
    PC = NULL; PD = NULL; PE = NULL;  MA = NULL; MB = NULL; MC = NULL;
    MD = NULL; ME = NULL; MF = NULL;  MG = NULL; MH = NULL; MI = NULL;
    MJ = NULL; MK = NULL; ML = NULL;  MM = NULL; MN = NULL; MO = NULL;
    MP = NULL; MQ = NULL; MR = NULL;  MS = NULL; MT = NULL;

    /*    */
    FOR SELECT
        IDNORMATIV, KODIR_PODGROUP, RABMAT, IDHIER,
        TAB, NAME_ID, ID_EDIZM, BA, BB, BC, BD, BE, BF, BG, BH, BI,
        --[13168]PA, PB,
        PC, PD, SMETATYPE --, VRPZ
    FROM A_SMETA
    WHERE ID = :IDSMETA
    INTO
        IDNORMY, IDNORMYPODGROUP,  IDNORMYRABMAT, SMETA_IDHIER,
        TAB, IDNAME, IDEDIZM, BA, BB, BC, BD, BE, BF, BG, BH, BI,
        --[13168]PA, PB,
        PC, PD, :SMETA_SMETATYPE --, VRPZ
    DO BEGIN
       /*   */
       IF ((SMETA_GROUP IS NULL) OR (SMETA_PODGROUP IS NULL)) THEN BEGIN
          SELECT KODIR_GROUP, KODIR_PODGROUP
--          FROM A_S_GET_PARAMS_OBJ( :IDUSER, :SMETA_IDHIER, :SMETA_SMETATYPE ) P
          from a_get_params_obj_akt( :iduser, :SMETA_IDHIER, :SMETA_SMETATYPE ) p
          INTO SMETA_GROUP, SMETA_PODGROUP ;
       END

       TABU_8/*[14280]TABU*/ = TAB;
       IF ((TAB <> '')/* AND (TAB IS NOT NULL)*/)
       THEN TABU_8/*[14280]TABU*/ = S_TRANSLITERATE/*[14280]_TAB*/(LCKTRIMVARCHAR(TAB)) ; --[12447]

       /* ,        */
       SELECT RECORDEXISTS
       FROM B_TEST_RABMAT_RECORD_EXISTS (:IDUSER, :IDREESTR, NULL, :TABU_8/*[14280]TABU*/)
       INTO :RECORDEXISTS ;

       IF (RECORDEXISTS = 0)
       THEN BEGIN
          IF ((IDNORMYPODGROUP = 1) AND (IDNORMYRABMAT <> 1))
          THEN SELECT
             ID_UNIQUE, IDTCH, FRTCH, IDSOSTAV, ALTTAB, COMMENT, IDTCARD, IDESN, FRESN, RAZRAD,
             PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO, MP,
             MQ, MR, MS, MT, VRPZ, NTR, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK, MBETON,
             MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, PUNKTIND, IDPOSTAV, ISESN,
             IDWITHESN, IDQUALIFIER
          FROM B_RABMAT
          WHERE ID = :IDNORMY
          INTO
             ID_UNIQUE, IDTCH, FRTCH, IDSOSTAV, ALTTAB, COMMENT, IDTCARD, IDESN, FRESN, RAZRAD,
             PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO, MP,
             MQ, MR, MS, MT, VRPZ, NTR, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK, MBETON,
             MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, PUNKTIND, IDPOSTAV, ISESN,
             IDWITHESN, IDQUALIFIER;



          SELECT NAME_TITLE, NAME_PART
          FROM B_GETNAME_2 (:IDUSER, :IDNAME)
          INTO :NAME_TITLE, :NAME_PART ;

          /*    B_Rabmat */
          SELECT ID
          FROM B_ADD_RABMAT_RECORD (:IDUSER, :IDREESTR, :IDOGL, :IDQUALIFIER,
                                    :ORDERVIEW, :NAME_PART, :NAME_TITLE, -1)
          INTO :ID;

          EXECUTE PROCEDURE B_WRITE_RECORD_RABMAT(:IDUSER, :IDREESTR, :ID, NULL,
             :RABMAT, NULL, NULL, :TAB, :IDOGL, :ALTTAB, :IDEDIZM, :RAZRAD,
             :BA, :BB,
             :BB_OTP, --[14355]
             null, -- BB_PR CQ[15046]
             :BC, :BD, :BE, :BF, :BG, :BH, :BI,
             :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
             :BJ, :PA, :PB,
             :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH,
             :MI, :MJ, :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT,
             :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
             :TKALK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND,
             :IDPOSTAV, NULL, :COMMENT, :ISESN, :IDWITHESN, :IDSOSTAV,
             NULL, :IDTCH, :FRTCH, :IDESN, :FRESN, :IDTCARD,
             :IDPICTURE, :IDQUALIFIER, 1, NULL, NULL, NULL, NULL, NULL, 0, 0, 1, 0, 0, -1,
             null) ; -- TRANSP_SH CQ[15039]

          PASTEDID  = IDSMETA;
          ORDERVIEW = ORDERVIEW + 1 ;

          /*    */
          IDNORMY = NULL ;
          FOR SELECT
              NORM_ID, NORM_PODGROUP, RABMAT,
              TAB, NAME_ID, IDEDIZM, RASHOD, BB, BC, BD, BE,
              VIDNR, UCH, ID    --
          FROM A_S_RES_SELECT (:IDUSER, :IDSMETA, :SMETA_GROUP, :SMETA_PODGROUP, 0, 0)
          INTO
             IDNORMY, IDNORMYPODGROUP, IDNORMYRABMAT,
             TAB, IDNAME, IDEDIZM, RASHOD, BB, BC, BD, BE, VIDNR, UCH, :ID_res --
          DO BEGIN
             vrpz=0;

             select vrpz from a_smeta   --
             where id_s_res=:ID_res     --
             into vrpz;                 --

             IF (IDNORMY = 0)
             THEN IDNORMY = NULL;

             RES_ID_SELF = NULL ;
             RES_RABMAT = NULL;

             /* ,      */
             IF (IDNORMY IS NOT NULL) THEN BEGIN
                IF ((IDNORMYPODGROUP = 1) AND (IDNORMYRABMAT = 1))
                THEN
                   SELECT ID, 1
                   FROM B_TRUD
                   WHERE ID = :IDNORMY
                   INTO RES_ID_SELF, RES_RABMAT;
                ELSE
                IF (IDNORMYPODGROUP > 1)
                THEN
                   SELECT ID, RABMAT
                   FROM B_ABC_OKP
                   WHERE ID = :IDNORMY
                   INTO RES_ID_SELF, RES_RABMAT;
                ELSE
                   SELECT ID, RABMAT
                   FROM B_RABMAT
                   WHERE ID = :IDNORMY
                   INTO RES_ID_SELF, RES_RABMAT;

                IDNORMY = RES_ID_SELF;
                IF (IDNORMY IS NOT NULL)
                THEN IDNORMYRABMAT = RES_RABMAT;
             END

             /*     ,    */
             IF (IDNORMY IS NULL) THEN BEGIN
                IF (TAB = '')
                THEN TAB = NULL ;

                TABU = TAB;
                IF (TAB IS NOT NULL)
                THEN TABU = S_TRANSLITERATE_TAB(LCKTRIMVARCHAR(TAB)) ; --[12447]

                /*      */
                IF (TABU IS NOT NULL) THEN BEGIN
                   /*          */

                   IF (IDNORMYRABMAT = 1)
                   THEN
                      SELECT first 1 ID
                      FROM B_TRUD
                      WHERE TABU = :TABU
                        and ORDERVIEW > 0
                      --[14280]plan (B_TRUD index (B_TRUD_IDX_LF_TABU))
                      order by case when S_TRANSLITERATE(TAB)=:TABU_8 then 0 else ORDERVIEW end --[14280,12447]
                      INTO IDNORMY ;
                   ELSE
                   IF ((ID_NEW_MASH IS NOT NULL) AND (IDNORMYRABMAT = 2))
                   THEN
                      SELECT first 1 ID
                      FROM B_RABMAT
                      WHERE TABU = :TABU AND
                            IDREESTR = :ID_NEW_MASH
                      --[14280]PLAN (B_RABMAT INDEX (B_RABMAT_IDX_TABU))
                      order by case when S_TRANSLITERATE(TAB)=:TABU_8 then 0 else ORDERVIEW end --[14280,12447]
                      INTO IDNORMY ;
                   ELSE
                   IF ((ID_NEW_MAT IS NOT NULL) AND (IDNORMYRABMAT = 3))
                   THEN
                      SELECT first 1 ID
                      FROM B_RABMAT
                      WHERE TABU = :TABU AND
                            IDREESTR = :ID_NEW_MAT
                      --[14280]PLAN (B_RABMAT INDEX (B_RABMAT_IDX_TABU))
                      order by case when S_TRANSLITERATE(TAB)=:TABU_8 then 0 else ORDERVIEW end --[14280,12447]
                      INTO IDNORMY ;

                   IF (IDNORMY IS NOT NULL)
                   THEN IDNORMYPODGROUP = 1;
                   /*   ,     */
                   ELSE BEGIN
                      FOR SELECT ID_SELF, RABMAT, ID_ABC_OKP, PODGROUP
                      FROM L_FB_SEARCH_ID (:TAB/*[14280,12447]TABU*/, :IDNORMYPODGROUP, -1, :IDUSER, 0, :IDPUT_MASH, :IDPUT_MAT, 0, 1)
                      INTO RES_ID_SELF, RES_RABMAT, RES_IDABC_OKP, RES_PODGROUP
                      DO BEGIN
                         IF (RES_ID_SELF = 0)
                         THEN RES_ID_SELF = NULL;

                         IF (RES_IDABC_OKP = 0)
                         THEN RES_IDABC_OKP = NULL;

                         IF (RES_RABMAT > 0)
                         THEN
                            /*        */
                            IF ((IDNORMYPODGROUP = 1) AND (RES_PODGROUP = 1) AND (RES_ID_SELF IS NOT NULL))
                            THEN IDNORMY = RES_ID_SELF;
                            ELSE
                               IF ((IDNORMYPODGROUP > 1) AND (RES_IDABC_OKP IS NOT NULL))
                               THEN BEGIN
                                  SELECT IDPODGROUP
                                  FROM B_ABC_OKP
                                  WHERE ID = :RES_IDABC_OKP
                                  INTO RES_PODGROUP ;
                                
                                  IF (IDNORMYPODGROUP = RES_PODGROUP)
                                  THEN IDNORMY = RES_IDABC_OKP;
                               END
                      END

                      IF (IDNORMY IS NOT NULL)
                      THEN IDNORMYRABMAT = RES_RABMAT ;
                   END

                   /*      ,     */
                   IF ((IDNORMY IS NULL) AND (IDNORMYRABMAT > 0))
                   THEN BEGIN
                      IDNORMYPODGROUP = 1;

                      SELECT NAME_TITLE, NAME_PART
                      FROM B_GETNAME_2 (:IDUSER, :IDNAME)
                      INTO :NAME_TITLE, :NAME_PART ;

                      SELECT BA
                      FROM B_CALCULATE_BA(:IDUSER, :IDNORMYRABMAT, :BB, :BC, :BD, :BE)
                      INTO BA ;

                      IF (IDNORMYRABMAT = 1) THEN BEGIN
                         SELECT ID
                         FROM B_ADD_TRUD_RECORD (:IDUSER, NULL, NULL, :NAME_PART, :NAME_TITLE, -1)
                         INTO :IDNORMY;

                         UPDATE B_TRUD
                         SET TAB = :TAB, TABU = :TABU, CENA = :BA
                         WHERE ID = :IDNORMY ;

                         EXECUTE PROCEDURE B_WRITE_ED_IZM_IN_TABLE(:IDUSER, 2, :IDNORMY, :IDEDIZM) ;
                      END
                      ELSE BEGIN
                         IF ((ID_NEW_MASH IS NOT NULL) AND (IDNORMYRABMAT = 2))
                         THEN
                            SELECT ID
                            FROM B_ADD_RABMAT_RECORD (:IDUSER, :ID_NEW_MASH, NULL, NULL,
                                       NULL, :NAME_PART, :NAME_TITLE, -1)
                            INTO :IDNORMY;
                         ELSE
                         IF ((ID_NEW_MAT IS NOT NULL) AND (IDNORMYRABMAT = 3))
                         THEN
                            SELECT ID
                            FROM B_ADD_RABMAT_RECORD (:IDUSER, :ID_NEW_MAT, NULL, NULL,
                                       NULL, :NAME_PART, :NAME_TITLE, -1)
                            INTO :IDNORMY;



                         UPDATE B_RABMAT
                         SET TAB = :TAB, TABU = :TABU,
                             BA = :BA, BB = :BB, BC = :BC, BD = :BD, BE = :BE,
                             VRPZ = :VRPZ
                         WHERE ID = :IDNORMY ;

                         EXECUTE PROCEDURE B_WRITE_ED_IZM_IN_TABLE(:IDUSER, 0, :IDNORMY, :IDEDIZM) ;
                      END
                   END
                END
             END


             /*   */
             IF (IDNORMY IS NOT NULL) THEN BEGIN
                SELECT ID
                FROM B_ADD_RESURS_RECORD(:IDUSER, :ID, :SMETA_GROUP,
                                         :SMETA_PODGROUP, :IDNORMYPODGROUP,
                                         :IDNORMY, :RASHOD, :VIDNR, :UCH,
                                         :IDNORMYRABMAT)
                INTO RES_ID_SELF ;

                WHEN ANY DO RES_ID_SELF = RES_ID_SELF;
             END
          END

          SUSPEND ;

          /*WHEN ANY DO ID = ID;*/
       END
    END
 END
END
^


-- CQ[15039, 15046]
create or alter procedure DM_COPY_NORMATIV (
    IDUSER integer,
    ID integer,
    IDPODGROUP integer,
    INTAB varchar(42))
returns (
    NEWID integer)
AS
declare variable RABMAT integer;
declare variable TAB varchar(42);
declare variable TABU varchar(42);
declare variable ALTTAB varchar(250);
declare variable IDNAME integer;
declare variable IDEDIZM integer;
declare variable IDTCH integer;
declare variable FRTCH varchar(250);
declare variable IDESN integer;
declare variable FRESN varchar(21);
declare variable IDABCOKP integer;
declare variable comment varchar(42);
declare variable RAZRAD double precision;
declare variable BA double precision;
declare variable BB double precision;
--<[14355]>
declare BB_OTP double precision; --</>
declare variable BC double precision;
declare variable BD double precision;
declare variable BE double precision;
declare variable BF double precision;
declare variable BG double precision;
declare variable BH double precision;
declare variable BI double precision;
--<[14420]>
declare TRANSP_P double precision;
declare ZAG_SKL_1 double precision;
declare ZAG_SKL_P double precision;
declare KLASS_G integer;
declare TAB_TRANSP varchar(42);
--</>
declare variable BJ double precision;
declare variable PA double precision;
declare variable PB double precision;
declare variable PC double precision;
declare variable PD double precision;
declare variable PE double precision;
declare variable MA double precision;
declare variable MB double precision;
declare variable MC double precision;
declare variable MD double precision;
declare variable ME double precision;
declare variable MF double precision;
declare variable MG double precision;
declare variable MH double precision;
declare variable MI double precision;
declare variable MJ double precision;
declare variable MK double precision;
declare variable ML double precision;
declare variable MM double precision;
declare variable MN double precision;
declare variable MO double precision;
declare variable MP double precision;
declare variable MQ double precision;
declare variable MR double precision;
declare variable MS double precision;
declare variable MT double precision;
declare variable VRPZ integer;
declare variable NTR integer;
declare variable BRUTTO double precision;
declare variable NETTO double precision;
declare variable VB double precision;
declare variable VN double precision;
declare variable PREISK varchar(42);
declare variable POSPREISK varchar(42);
declare variable MBETON double precision;
declare variable MRKBETON varchar(15);
declare variable MMASHINE varchar(25);
declare variable VBETON double precision;
declare variable TKALK varchar(50);
declare variable PUNKTIND varchar(42);
declare variable NAME_TITLE blob sub_type 1 segment size 80;
declare variable NAME_PART blob sub_type 1 segment size 80;
declare variable IDSOSTAV integer;
declare variable IDTCARD integer;
declare variable IDPICTURE integer;
declare variable IDPOSTAV integer;
declare variable ISESN smallint;
declare variable IDWITHESN integer;
declare variable RECORDEXISTS integer;
declare variable CENA double precision;
declare variable TAB_OKP varchar(42);
declare variable ZONEID integer;
declare variable RESACTION integer;
declare variable IDQUALIFIER integer;
declare variable IDREESTR integer;
declare variable IDOGL integer;
declare variable ISZONEFIND integer;
-- MK CQ[15046]
declare variable BB_PR double precision;
-- MK CQ[15039]
declare variable TRANSP_SH varchar(255);
begin
  --CQ[10049]-->  CopyPaste  B_PASTE_NORMY_IN_RABMAT
  /*  From Rabmat */
  if (IDPODGROUP = 1) then
  begin
    for select RABMAT, IDNAME, coalesce(TAB, ''), IDTCH, FRTCH, IDSOSTAV, ALTTAB, IDEDIZM, IDABCOKP,
               comment, IDTCARD, IDESN, FRESN, RAZRAD, BA, BB,
               BB_OTP, --[14355]
               BB_PR,  -- CQ[15046]
               BC, BD, BE, BF, BG, BH, BI,
               TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
               BJ, PA,
               PB, PC, PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO, MP, MQ,
               MR, MS, MT, VRPZ, NTR, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK, MBETON, MRKBETON,
               VBETON, MMASHINE, IDPICTURE, TKALK, PUNKTIND, IDPOSTAV, ISESN, IDWITHESN,
               IDQUALIFIER, IDREESTR, IDOGL,
               TRANSP_SH -- CQ[15039]
        from B_RABMAT
        where (ID = :ID)
        into :RABMAT, :IDNAME, :TAB, :IDTCH, :FRTCH, :IDSOSTAV, :ALTTAB, :IDEDIZM, :IDABCOKP, :comment,
               :IDTCARD, :IDESN, :FRESN, :RAZRAD, :BA, :BB,
               :BB_OTP, --[14355]
               :BB_PR,  -- CQ[15046]
               :BC, :BD, :BE, :BF, :BG, :BH, :BI,
               :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
               :BJ,
               :PA, :PB, :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
               :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN,
               :PREISK, :POSPREISK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :IDPICTURE, :TKALK,
               :PUNKTIND, :IDPOSTAV, :ISESN, :IDWITHESN, :IDQUALIFIER, :IDREESTR, :IDOGL,
               :TRANSP_SH -- CQ[15039]
    do
    begin
      if (INTAB is not null) then
        TAB = INTAB;

      if (TAB <> '') then
        TABU = S_TRANSLITERATE/*[14280]_TAB*/(LCKTRIMVARCHAR(TAB)); --[12447]
      else
        TABU = TAB; --[14280,12447]

      execute procedure B_TEST_RABMAT_RECORD_EXISTS(:IDUSER, :IDREESTR, null, :TABU)
      returning_values :RECORDEXISTS;

      if (RECORDEXISTS = 0) then
      begin
        select NAME_TITLE, NAME_PART
        from B_GETNAME_2(:IDUSER, :IDNAME)
        into :NAME_TITLE, :NAME_PART;

        select ID
        from B_ADD_RABMAT_RECORD(:IDUSER, :IDREESTR, :IDOGL, :IDQUALIFIER, 0, :NAME_PART, :NAME_TITLE, -1)
        into :NEWID;

        execute procedure B_WRITE_RECORD_RABMAT(:IDUSER, :IDREESTR, :NEWID, null, :RABMAT, null,
            null, :TAB, :IDOGL, :ALTTAB, :IDEDIZM, :RAZRAD, :BA, :BB,
            :BB_OTP, --[14355]
            :BB_PR, -- CQ[15046]
            :BC, :BD, :BE, :BF, :BG, :BH,
            :BI,
            :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
            :BJ, :PA, :PB, :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ,
            :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR, :BRUTTO, :NETTO, :VB,
            :VN, :PREISK, :POSPREISK, :TKALK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND,
            :IDPOSTAV, null, :comment, :ISESN, :IDWITHESN, :IDSOSTAV, null, :IDTCH, :FRTCH, :IDESN,
            :FRESN, :IDTCARD, :IDPICTURE, :IDQUALIFIER, 1, null, null, null, null, null, 0, 0, 1, 0,
            0, -1,
            :TRANSP_SH); -- CQ[15039]

        execute procedure B_COPY_RABMAT_RECORD_RESURSES(:IDUSER, :ID, :NEWID);

        for select IDZONE
            from B_READ_RABMAT_ZONES(:IDUSER, :IDREESTR)
            into :ZONEID
        do
          execute procedure B_COPY_RABMAT_RECORD_ZONECEN(:IDUSER, :ZONEID, :ID, :NEWID);
        suspend;
      end
    end
  end

  /*  From ABC_OKP */
  else
  begin
    for select coalesce(TAB, ''), RABMAT, IDNAME, IDNORMA, comment, IDEDIZM, CENA, RAZRAD, IDPOSTAV,
               PUNKTIND, VRPZ, NTR, IDQUALIFIER
        from B_ABC_OKP
        where (ID = :ID)
        into :comment, :RABMAT, :IDNAME, :IDABCOKP, :TAB, :IDEDIZM, :CENA, :RAZRAD, :IDPOSTAV,
               :PUNKTIND, :VRPZ, :NTR, :IDQUALIFIER
    do
    begin
      /*    - */
      IDQUALIFIER = null;
      if (INTAB is not null) then
      begin
        TAB = INTAB;
      end
      else
      begin
        if (:IDABCOKP is not null) then
        begin
          select coalesce(TAB, '')
          from B_RABMAT
          where ID = :IDABCOKP
          into :TAB_OKP;
          if (TAB = '') then
            TAB = TAB_OKP;
        end
      end

      if (TAB <> '') then
        TABU = S_TRANSLITERATE/*[14280]_TAB*/(LCKTRIMVARCHAR(TAB)); --[12447]
      else
        TABU = TAB; --[14280,12447]

      execute procedure B_TEST_RABMAT_RECORD_EXISTS(:IDUSER, :IDREESTR, null, :TABU)
      returning_values :RECORDEXISTS;

      if (RECORDEXISTS = 0) then
      begin
        if (:IDABCOKP is not null) then
        begin
          select IDTCH, FRTCH, IDSOSTAV, ALTTAB, IDTCARD, IDESN, FRESN,
                 BB_OTP, --[14355]
                 BB_PR, -- CQ[15046]
                 BD, BF, BG, BH, BI,
                 TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
                 BJ, PA,
                 PB, PC, PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO, MP, MQ,
                 MR, MS, MT, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK, MBETON, MRKBETON, VBETON,
                 MMASHINE, IDPICTURE, TKALK, ISESN, IDWITHESN, IDREESTR, IDOGL,
                 TRANSP_SH -- CQ[15039]
          from B_RABMAT
          where ID = :IDABCOKP
          into :IDTCH, :FRTCH, :IDSOSTAV, :ALTTAB, :IDTCARD, :IDESN, :FRESN,
               :BB_OTP, --[14355]
               :BB_PR, -- CQ[15046]
               :BD, :BF, :BG, :BH,
               :BI,
               :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
               :BJ, :PA, :PB, :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ,
               :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, :BRUTTO, :NETTO, :VB, :VN, :PREISK,
               :POSPREISK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :IDPICTURE, :TKALK, :ISESN,
               :IDWITHESN, :IDREESTR, :IDOGL,
               :TRANSP_SH; -- CQ[15039]
        end
        select NAME_TITLE, NAME_PART
        from B_GETNAME_2(:IDUSER, :IDNAME)
        into :NAME_TITLE, :NAME_PART;

        select ID
        from B_ADD_RABMAT_RECORD(:IDUSER, :IDREESTR, :IDOGL, :IDQUALIFIER, 0, :NAME_PART, :NAME_TITLE, -1)
        into :NEWID;

        select BA, BB, BC, BD, BE
        from B_REALLOCATION_CENA(:IDUSER, :RABMAT, :CENA, :BD)
        into :BA, :BB, :BC, :BD, :BE;

        execute procedure B_WRITE_RECORD_RABMAT(:IDUSER, :IDREESTR, :NEWID, null, :RABMAT, null,
            null, TAB, :IDOGL, :ALTTAB, :IDEDIZM, :RAZRAD, :BA, :BB,
            :BB_OTP, --[14355]
            :BB_PR,  -- CQ[15046]
            :BC, :BD, :BE, :BF, :BG, :BH,
            :BI,
            :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
            :BJ, :PA, :PB, :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ,
            :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR, :BRUTTO, :NETTO, :VB,
            :VN, :PREISK, :POSPREISK, :TKALK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND,
            :IDPOSTAV, null, :comment, :ISESN, :IDWITHESN, :IDSOSTAV, null, :IDTCH, :FRTCH, :IDESN,
            :FRESN, :IDTCARD, :IDPICTURE, :IDQUALIFIER, 1, null, null, null, null, null, 0, 0, 1, 0,
            0, -1,
            :TRANSP_SH); -- CQ[15039]

        for select IDZONE
            from B_READ_RABMAT_ZONES(:IDUSER, :IDREESTR)
            into :ZONEID
        do
        begin
          execute procedure B_READ_ZONE_ABC_TSENY(:IDUSER, :IDABCOKP, :ZONEID)
          returning_values :CENA, :ISZONEFIND;

          if (CENA is not null) then
            execute procedure B_WRITE_ZONE_CENA(:IDUSER, :ZONEID, :NEWID, :RABMAT, 1, :CENA, null,
                null, null, null, 1)
            returning_values :RESACTION;
        end
        suspend;
      end
    end
  end
  --CQ[10049]<--
end
^


-- CQ[15039, 15046]
create or alter procedure L_IMP_NORMY_ADD_RABMAT_RECORD (
    IDREESTR integer,
    IDZONE integer,
    RABMAT integer,
    NAME_START blob sub_type 0 segment size 80,
    NAME blob sub_type 0 segment size 80,
    TAB varchar(42),
    IDOGL integer,
    ALTTAB varchar(250),
    EDIZM varchar(100),
    ALTEDIZM varchar(250),
    RAZRAD double precision,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    MN double precision,
    MO double precision,
    MP double precision,
    MQ double precision,
    MR double precision,
    MS double precision,
    MT double precision,
    VRPZ integer,
    NTR integer,
    BRUTTO double precision,
    NETTO double precision,
    VB double precision,
    VN double precision,
    PREISK varchar(42),
    POSPREISK varchar(42),
    TKALK varchar(50),
    MBETON double precision,
    MRKBETON varchar(15),
    VBETON double precision,
    MMASHINE varchar(25),
    PUNKTIND varchar(42),
    IDPOSTAV integer,
    IDABCOKP integer,
    comment varchar(42),
    ISESN smallint,
    IDWITHESN integer,
    IDSOST integer,
    SOSTAVRABOT blob sub_type 0 segment size 80,
    IDTCH integer,
    FRTCH varchar(250),
    IDESN integer,
    FRESN varchar(21),
    IDTCARD integer,
    IDPICTURE integer,
    ZONE_BA double precision,
    ZONE_BB double precision,
    ZONE_BC double precision,
    ZONE_BD double precision,
    ZONE_BE double precision,
    ORDERVIEW integer,
    NEEDTESTINPAPKA integer,
    ID_USER integer,
    ID_BLOB_GEN integer)
returns (
    ID integer)
AS
DECLARE VARIABLE IDEDIZM INTEGER;
DECLARE VARIABLE TABU VARCHAR(42);
DECLARE VARIABLE TABU_8 VARCHAR(42); --[14280,12447]
DECLARE VARIABLE RECORDEXISTS INTEGER;
--<[14355]>
declare BB_OTP double precision; --</>
--<[14420]>
declare TRANSP_P double precision;
declare ZAG_SKL_1 double precision;
declare ZAG_SKL_P double precision;
declare KLASS_G integer;
declare TAB_TRANSP varchar(42);
--</>
begin

 IF (TAB <> '') THEN
 BEGIN
    TAB = LCKTRIMVARCHAR(TAB) ;
    TABU = S_TRANSLITERATE_TAB(TAB); --[12447]
    TABU_8 = S_TRANSLITERATE(TAB); --[14280,12447]

    IF ( NEEDTESTINPAPKA <> 0 ) THEN
    BEGIN
       FOR SELECT IDREESTR
       FROM B_RABMAT
       WHERE IDPAPKA = :NEEDTESTINPAPKA AND TABU = :TABU
         and S_TRANSLITERATE(TAB)=:TABU_8 --[14280,12447]
       INTO :RECORDEXISTS
       DO
          IF (RECORDEXISTS = IDREESTR)
          THEN EXCEPTION B_E_TAB_EXISTS;
          ELSE
             EXCEPTION B_E_TAB_FOLDER_EXISTS;
    END
    ELSE
    BEGIN
       SELECT RECORDEXISTS
       FROM B_TEST_RABMAT_RECORD_EXISTS (:ID_USER, :IDREESTR, :ID, :TABU_8/*[14280]TABU*/)
       INTO :RECORDEXISTS ;

       IF (RECORDEXISTS = 1)
       THEN EXCEPTION B_E_TAB_EXISTS ;
    END
 END

   IF ((NAME IS NOT NULL) OR (NAME_START IS NOT NULL)) THEN
   BEGIN
      IF (ID_BLOB_GEN > 0) THEN
      BEGIN
         UPDATE B_TEMP_BLOB SET BLOB1 = :NAME, BLOB2 = :NAME_START WHERE ID = :ID_BLOB_GEN;
         SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_BLOB_GEN INTO :NAME, :NAME_START;
      END
      ELSE
      BEGIN
         ID_BLOB_GEN = GEN_ID(B_GEN_TEMP, 1) ;
         INSERT INTO B_TEMP_BLOB(ID, BLOB1, BLOB2) VALUES (:ID_BLOB_GEN, :NAME, :NAME_START);
         SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_BLOB_GEN INTO :NAME, :NAME_START;
         DELETE FROM B_TEMP_BLOB WHERE ID = :ID_BLOB_GEN;
      END
   END

   if ( ORDERVIEW = -1 ) then
   begin
      ORDERVIEW = 0;
      select max ( ORDERVIEW ) from b_rabmat where IDREESTR = :IDREESTR into ORDERVIEW;
      if ( ORDERVIEW is null ) then
         ORDERVIEW = 0;
      ORDERVIEW = ORDERVIEW + 1;
   end


   execute PROCEDURE B_ADD_RABMAT_RECORD ( :ID_USER , :IDREESTR , :IDOGL , null , :ORDERVIEW , :name, :name_start, -1) returning_values ( :ID );


   execute procedure b_add_edizm_in_silence ( :ID_USER, :EDIZM, :ALTEDIZM ) returning_values ( :IDEDIZM );


   execute PROCEDURE B_WRITE_RECORD_RABMAT (
    ID_USER,
    IDREESTR,
    ID,
    IDZONE,
    RABMAT,
    null,
    null,
    TAB,
    IDOGL,
    ALTTAB,
    IDEDIZM,
    RAZRAD,
    BA, BB,
    :BB_OTP, --[14355]
    null, -- BB_PR CQ[15046]
    BC, BD, BE, BF, BG, BH, BI,
    :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
    null/*BJ*/, null/*PA*/, null/*PB*/, --[13168]
    PC, PD, PE,
    MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO, MP, MQ,  MR, MS, MT,
    VRPZ,
    NTR,
    BRUTTO,
    NETTO,
    VB,
    VN,
    PREISK,
    POSPREISK,
    TKALK,
    MBETON,
    MRKBETON,
    VBETON,
    MMASHINE,
    PUNKTIND,
    IDPOSTAV,
    IDABCOKP,
    COMMENT,
    ISESN,
    IDWITHESN,
    IDSOST,
    SOSTAVRABOT,
    IDTCH,
    FRTCH,
    IDESN,
    FRESN,
    IDTCARD,
    IDPICTURE,
    null, 
    0,
    ZONE_BA, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE,
    0,
    0,
    1,
    1/*0*/,
    0,
    -1,
    null); -- TRANSP_SH CQ[15039]
END
^


-- CQ[15039, 15046]
/*create or alter procedure L_IMP_VC_WRITE_ZONA_CENA_EX1 (
   
*/
-- CQ[15039, 15046]
create or alter procedure B_COPY_RABMAT_SBORNIK (
    IDUSER integer,
    OLD_SBORNIK_ID integer,
    NEW_SBORNIK_ID integer,
    NEW_PAPKA_ID integer)
AS
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE OLD_ID INTEGER;
DECLARE VARIABLE IDNAME INTEGER;
DECLARE VARIABLE ID_UNIQUE INTEGER;
DECLARE VARIABLE IDTCH INTEGER;
DECLARE VARIABLE TAB VARCHAR(42);
DECLARE VARIABLE TABU VARCHAR(42);
DECLARE VARIABLE RABMAT INTEGER;
DECLARE VARIABLE IDOGL INTEGER;
DECLARE VARIABLE FRTCH VARCHAR(250);
DECLARE VARIABLE IDSOSTAV INTEGER;
DECLARE VARIABLE ALTTAB VARCHAR(250);
DECLARE VARIABLE IDEDIZM INTEGER;
DECLARE VARIABLE IDALTEDIZM INTEGER;
DECLARE VARIABLE EDIZMKOEF DOUBLE PRECISION;
DECLARE VARIABLE IDABCOKP INTEGER;
DECLARE VARIABLE COMMENT VARCHAR(42);
DECLARE VARIABLE IDTCARD INTEGER;
DECLARE VARIABLE IDESN INTEGER;
DECLARE VARIABLE FRESN VARCHAR(21);
DECLARE VARIABLE RAZRAD DOUBLE PRECISION;
DECLARE VARIABLE BA DOUBLE PRECISION;
DECLARE VARIABLE BB DOUBLE PRECISION;
DECLARE VARIABLE BC DOUBLE PRECISION;
DECLARE VARIABLE BD DOUBLE PRECISION;
DECLARE VARIABLE BE DOUBLE PRECISION;
DECLARE VARIABLE BF DOUBLE PRECISION;
DECLARE VARIABLE BG DOUBLE PRECISION;
DECLARE VARIABLE BH DOUBLE PRECISION;
DECLARE VARIABLE BI DOUBLE PRECISION;
DECLARE VARIABLE BJ DOUBLE PRECISION;
DECLARE VARIABLE PA DOUBLE PRECISION;
DECLARE VARIABLE PB DOUBLE PRECISION;
DECLARE VARIABLE PC DOUBLE PRECISION;
DECLARE VARIABLE PD DOUBLE PRECISION;
DECLARE VARIABLE PE DOUBLE PRECISION;
DECLARE VARIABLE MA DOUBLE PRECISION;
DECLARE VARIABLE MB DOUBLE PRECISION;
DECLARE VARIABLE MC DOUBLE PRECISION;
DECLARE VARIABLE MD DOUBLE PRECISION;
DECLARE VARIABLE ME DOUBLE PRECISION;
DECLARE VARIABLE MF DOUBLE PRECISION;
DECLARE VARIABLE MG DOUBLE PRECISION;
DECLARE VARIABLE MH DOUBLE PRECISION;
DECLARE VARIABLE MI DOUBLE PRECISION;
DECLARE VARIABLE MJ DOUBLE PRECISION;
DECLARE VARIABLE MK DOUBLE PRECISION;
DECLARE VARIABLE ML DOUBLE PRECISION;
DECLARE VARIABLE MM DOUBLE PRECISION;
DECLARE VARIABLE MN DOUBLE PRECISION;
DECLARE VARIABLE MO DOUBLE PRECISION;
DECLARE VARIABLE MP DOUBLE PRECISION;
DECLARE VARIABLE MQ DOUBLE PRECISION;
DECLARE VARIABLE MR DOUBLE PRECISION;
DECLARE VARIABLE MS DOUBLE PRECISION;
DECLARE VARIABLE MT DOUBLE PRECISION;
DECLARE VARIABLE VRPZ INTEGER;
DECLARE VARIABLE NTR INTEGER;
DECLARE VARIABLE BRUTTO DOUBLE PRECISION;
DECLARE VARIABLE NETTO DOUBLE PRECISION;
DECLARE VARIABLE VB DOUBLE PRECISION;
DECLARE VARIABLE VN DOUBLE PRECISION;
DECLARE VARIABLE PREISK VARCHAR(42);
DECLARE VARIABLE POSPREISK VARCHAR(42);
DECLARE VARIABLE TKALK VARCHAR(50);
DECLARE VARIABLE IDPOSTAV INTEGER;
DECLARE VARIABLE MBETON DOUBLE PRECISION;
DECLARE VARIABLE MRKBETON VARCHAR(15);
DECLARE VARIABLE VBETON DOUBLE PRECISION;
DECLARE VARIABLE MMASHINE VARCHAR(25);
DECLARE VARIABLE PUNKTIND VARCHAR(42);
DECLARE VARIABLE ISESN SMALLINT;
DECLARE VARIABLE IDWITHESN INTEGER;
DECLARE VARIABLE CREATEDATE DATE;
DECLARE VARIABLE AUTHOR VARCHAR(250);
DECLARE VARIABLE IDPICTURE INTEGER;
DECLARE VARIABLE ORDERVIEW INTEGER;
DECLARE VARIABLE IDZONE INTEGER;
DECLARE VARIABLE IDQUALIFIER INTEGER;
DECLARE VARIABLE NEW_PAGE SMALLINT;
DECLARE VARIABLE IDENT_KOD_MAT_SAP varchar(30);  -- CQ[TIMUR 6776]
DECLARE VARIABLE BASE_EDIZM_SAP varchar(42);     -- CQ[TIMUR 6776]
DECLARE VARIABLE STOIM_MAT_SAP DOUBLE PRECISION; -- CQ[TIMUR 6776]
--<[14420]>
declare TRANSP_P double precision;
declare ZAG_SKL_1 double precision;
declare ZAG_SKL_P double precision;
declare KLASS_G integer;
declare TAB_TRANSP varchar(42); --</>
--<[14355]>
declare BB_OTP double precision; --</>
-- MK CQ[15046]
declare variable BB_PR double precision;
-- MK CQ[15039]
declare variable TRANSP_SH varchar(255);
BEGIN
 FOR SELECT ID, IDNAME, ID_UNIQUE, IDTCH, TAB, TABU,
            RABMAT, IDOGL, FRTCH, IDSOSTAV, ALTTAB,
            IDEDIZM, IDALTEDIZM, EDIZMKOEF, IDABCOKP, COMMENT, IDTCARD, IDESN,
            FRESN, RAZRAD, BA, BB,
            BB_OTP, --<<[14355]
            BB_PR, -- MK CQ[15046]
            BC, BD, BE, BF, BG, BH, BI,
            TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
            BJ, PA, PB, PC,
            PD, PE, MA, MB, MT, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO,
            MP, MQ, MR, MS, VRPZ, NTR, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
            TKALK, IDPOSTAV, MBETON, MRKBETON, VBETON, MMASHINE, PUNKTIND, ISESN,
            IDWITHESN, CREATEDATE, AUTHOR, IDPICTURE,ORDERVIEW, IDQUALIFIER, NEW_PAGE,
            IDENT_KOD_MAT_SAP, BASE_EDIZM_SAP, STOIM_MAT_SAP, -- CQ[TIMUR 6776]
            TRANSP_SH -- MK CQ[15039]
 FROM B_RABMAT
 WHERE IDREESTR = :OLD_SBORNIK_ID
 INTO       :OLD_ID, :IDNAME, :ID_UNIQUE, :IDTCH, :TAB, :TABU,
            :RABMAT, :IDOGL, :FRTCH, :IDSOSTAV, :ALTTAB,
            :IDEDIZM, :IDALTEDIZM, :EDIZMKOEF, :IDABCOKP, :COMMENT, :IDTCARD, :IDESN,
            :FRESN, :RAZRAD, :BA, :BB,
            :BB_OTP, --<<[14355]
            :BB_PR, -- MK CQ[15046]
            :BC, :BD, :BE, :BF, :BG, :BH, :BI,
            :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
            :BJ, :PA, :PB, :PC,
            :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML, :MM, :MN, :MO,
            :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
            :TKALK, :IDPOSTAV, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND, :ISESN,
            :IDWITHESN, :CREATEDATE, :AUTHOR, :IDPICTURE, :ORDERVIEW, :IDQUALIFIER, :NEW_PAGE,
            :IDENT_KOD_MAT_SAP, :BASE_EDIZM_SAP, :STOIM_MAT_SAP, -- CQ[TIMUR 6776]
            :TRANSP_SH -- MK CQ[15039]
 DO BEGIN
    ID = GEN_ID(A_G_SMETA,1) ;

    INSERT INTO B_RABMAT (ID, IDREESTR, IDNAME, IDPAPKA, ID_UNIQUE, IDTCH, TAB, TABU,
            RABMAT, IDOGL, FRTCH, IDSOSTAV, ALTTAB,
            IDEDIZM, IDALTEDIZM, EDIZMKOEF, /*IDABCOKP,*/ COMMENT, IDTCARD, IDESN,
            FRESN, RAZRAD, BA, BB,
            BB_OTP, --<<[14355]
            BB_PR, -- MK CQ[15046]
            BC, BD, BE, BF, BG, BH, BI,
            TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
            BJ, PA, PB, PC,
            PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO,
            MP, MQ, MR, MS, MT, VRPZ, NTR, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
            TKALK, IDPOSTAV, MBETON, MRKBETON, VBETON, MMASHINE, PUNKTIND, ISESN,
            IDWITHESN, CREATEDATE, AUTHOR, IDPICTURE, ORDERVIEW, IDQUALIFIER, NEW_PAGE,
            IDENT_KOD_MAT_SAP, BASE_EDIZM_SAP, STOIM_MAT_SAP,  -- CQ[TIMUR 6776]
            TRANSP_SH) -- MK CQ[15039]
    VALUES  (:ID, :NEW_SBORNIK_ID, :IDNAME, :NEW_PAPKA_ID, :ID_UNIQUE, :IDTCH, :TAB, :TABU,
             :RABMAT, :IDOGL, :FRTCH, :IDSOSTAV, :ALTTAB,
             :IDEDIZM, :IDALTEDIZM, :EDIZMKOEF, /*:IDABCOKP,*/ :COMMENT, :IDTCARD, :IDESN,
             :FRESN, :RAZRAD, :BA, :BB,
             :BB_OTP, --<<[14355]
             :BB_PR, -- MK CQ[15046]
             :BC, :BD, :BE, :BF, :BG, :BH, :BI,
             :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
             :BJ, :PA, :PB, :PC,
             :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML, :MM, :MN, :MO,
             :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
             :TKALK, :IDPOSTAV, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND, :ISESN,
             :IDWITHESN, :CREATEDATE, :AUTHOR, :IDPICTURE, :ORDERVIEW, :IDQUALIFIER, :NEW_PAGE,
             :IDENT_KOD_MAT_SAP, :BASE_EDIZM_SAP, :STOIM_MAT_SAP,  -- CQ[TIMUR 6776]
             :TRANSP_SH); -- MK CQ[15039]

    EXECUTE PROCEDURE B_COPY_RABMAT_RECORD_RESURSES (:IDUSER, :OLD_ID, :ID) ;

    FOR SELECT IDZONE
    FROM B_READ_RABMAT_ZONES(:IDUSER, :OLD_SBORNIK_ID)
    INTO :IDZONE DO
        EXECUTE PROCEDURE B_COPY_RABMAT_RECORD_ZONECEN (:IDUSER, :IDZONE, :OLD_ID, :ID) ;

    WHEN GDSCODE FOREIGN_KEY, GDSCODE BAD_SEGSTR_ID
    DO EXCEPTION B_E_RECORD_IS_LOCKED ;
 END

 /*    */
 EXECUTE PROCEDURE B_COPY_RABMAT_OGLAVLENIE (:IDUSER, :OLD_SBORNIK_ID, :NEW_SBORNIK_ID, 0, 0, 0) ;
 EXECUTE PROCEDURE B_REORDER_OGLAVLENIE (:IDUSER, :NEW_SBORNIK_ID, 0) ;
END
^


-- MK CQ[15047]
create or alter procedure B_REFRESH_IND_RECORD (
    IDUSER integer,
    ID integer)
returns (
    IDOGL integer,
    TAB varchar(42),
    PA double precision,
    PB double precision,
    BA double precision,
    BANDS double precision,
    ZBA double precision,
    BE double precision,
    BENDS double precision,
    ZBE double precision,
    BC double precision,
    BCNDS double precision,
    ZBC double precision,
    BB double precision,
    BBNDS double precision,
    ZBB double precision,
    BD double precision,
    BDNDS double precision,
    ZBD double precision,
    PROCENTPRED double precision,
    NEW_PAGE smallint,
    NAME_TITLE blob sub_type 1 segment size 80,
    NAME_PART blob sub_type 1 segment size 80,
    ORDERVIEW integer,
    BB_PR double precision)
AS
DECLARE VARIABLE IDNAME INTEGER;
BEGIN
 FOR SELECT IDOGL, TAB, PA, PB, BA, BANDS, ZBA,
            BE, BENDS, ZBE, BC, BCNDS, ZBC, BB, BBNDS, ZBB,
            BD, BDNDS, ZBD, PROCENTPRED, IDNAME, NEW_PAGE, ORDERVIEW,
            BB_PR -- MK CQ[15047]
 FROM B_IND
 WHERE (ID = :ID)
 INTO       :IDOGL, :TAB, :PA, :PB, :BA, :BANDS, :ZBA,
            :BE, :BENDS, :ZBE, :BC, :BCNDS, :ZBC, :BB, :BBNDS,
            :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :IDNAME, :NEW_PAGE, :ORDERVIEW,
            :BB_PR -- MK CQ[15047]
 DO BEGIN
    SELECT NAME_TITLE, NAME_PART
    FROM B_GETNAME_2 (:IDUSER, :IDNAME)
    INTO :NAME_TITLE, :NAME_PART ;

    SUSPEND;
 END
END
^


-- MK CQ[15047]
-- 
CREATE OR ALTER PROCEDURE S_CALC_INDEX_ON_RRDATA (
    IDUSER INTEGER,
    IDREESTR INTEGER,
    SHIFR VARCHAR(42),
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ORDERVIEW INTEGER)
RETURNS (
    ID INTEGER,
    REORDERED INTEGER)
AS
BEGIN
  SUSPEND;
END
^


-- MK CQ[15047]
-- 
CREATE OR ALTER PROCEDURE B_WRITE_RECORD_INDEX (
    IDUSER INTEGER,
    ID INTEGER,
    IDREESTR INTEGER,
    IDOGL INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    NAME_PART BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NEEDUPDATE_NAME_PART INTEGER,
    NEEDUPDATE_NAME_TITLE INTEGER,
    ID_GEN INTEGER,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
  EXIT;
END
^


-- MK CQ[15047]
/*create or alter procedure S_CALC_INDEX_ON_RRDATA (
 
*/
-- MK CQ[15052]
create or alter procedure GET_INDEX_BB_PR (
    IDCLASS integer,
    IDLEVEL integer,
    PUNKTIND varchar(42))
returns (
    INDEX_BB_PR double precision)
AS
declare variable VN_ID_COMPOSE integer;
declare variable VN_ID_MONTH integer;
declare variable VN_INDEX_BB_PR double precision;
begin
  -- MK   CQ[15052] ------------------------------------------------
  --   
  INDEX_BB_PR = 1;

  PUNKTIND = coalesce(PUNKTIND, '');
  if (PUNKTIND <> '') then
  begin
    --      " "
    VN_ID_COMPOSE = null;
    select first 1 c.id
    from level_compose c
    where (c.idclass = :IDCLASS) and (c.id_level = :IDLEVEL) and (c.atype = 1)
    into :VN_ID_COMPOSE;
  
    if (VN_ID_COMPOSE is not null) then
    begin
      --    
      VN_ID_MONTH = null;
      select first 1 i.id_month
      from level_index i
      where (i.id_compose = :VN_ID_COMPOSE)
      into :VN_ID_MONTH;
  
      if (coalesce(VN_ID_MONTH, 0) > 0) then
      begin
        VN_INDEX_BB_PR = null;

        --     IND_RECORD_EXISTS
        select first 1 bb_pr
        from B_IND
        where (IDREESTR = :VN_ID_MONTH) and (TABU = S_TRANSLITERATE(:PUNKTIND))
        plan sort((B_IND index(B_IND_IDX_TABU)))
        order by ORDERVIEW
        into :VN_INDEX_BB_PR;
  
        if (VN_INDEX_BB_PR is not null) then
          INDEX_BB_PR = VN_INDEX_BB_PR;
      end
    end
  end
end
^


-- MK CQ[15052]
create or alter procedure GET_TSN16_VALUES (
    ID_SM_REC integer,
    IDNORMATIV integer,
    PUNKTIND varchar(42),
    IDCLASS integer,
    BASE_LEVEL integer,
    CURR_LEVEL integer)
returns (
    SB_BB_PR double precision,
    INDEX_BB_PR_1 double precision,
    INDEX_BB_PR_2 double precision,
    VOLUME double precision,
    WEIGHT double precision)
AS
declare variable VN_VOLUME_RES double precision;
declare variable VN_WEIGHT_RES double precision;
declare variable VN_RASHOD_RES double precision;
declare variable VN_NORM_ID_RES double precision;
declare variable VN_TAB_RES varchar(42);
declare variable VN_NORM_PODGROUP integer;
begin
  -- MK   CQ[15052] ------------------------------------------------
  --   
  SB_BB_PR = 0;
  INDEX_BB_PR_1 = 1;
  INDEX_BB_PR_2 = 1;
  VOLUME = 0;
  WEIGHT = 0;

  --     
  select first 1 r.bb_pr, r.bi, r.mb
  from b_rabmat r
  where (r.id = :IDNORMATIV)
  into :SB_BB_PR, :VOLUME, :WEIGHT;

  --  ,   ------------------------------------------------
  --      
  VN_VOLUME_RES = null;
  VN_WEIGHT_RES = null;

  for select r.rashod_base, coalesce(r.norm_id, 0), r.norm_podgroup
  from a_s_res r
  where (r.id_source = :ID_SM_REC) and (r.rabmat = 3)
  order by r.tab
  into :VN_RASHOD_RES, :VN_NORM_ID_RES, :VN_NORM_PODGROUP
  do
  begin
    if ((VN_NORM_ID_RES > 0) and ((VN_VOLUME_RES is null) or (VN_WEIGHT_RES is null))) then
    begin
      VN_TAB_RES = null;

      if (VN_NORM_PODGROUP = 1) then
      begin
        select first 1 r.tab
        from b_rabmat r
        where (r.id = :VN_NORM_ID_RES)
        into :VN_TAB_RES;
      end
      else
      begin
        select first 1 a.tab
        from B_ABC_OKP a
        where (a.id = :VN_NORM_ID_RES)
        into :VN_TAB_RES;
      end

      if (VN_TAB_RES is not null) then
      begin
        --  
        if ((VN_VOLUME_RES is null) and VN_TAB_RES = '9999990004') then
          VN_VOLUME_RES = VN_RASHOD_RES;
        --  
        else if ((VN_WEIGHT_RES is null) and VN_TAB_RES = '9999990001') then
          VN_WEIGHT_RES = VN_RASHOD_RES;
      end
    end
  end

  if (VN_VOLUME_RES is not null) then
    VOLUME = VN_VOLUME_RES;
  if (VN_WEIGHT_RES is not null) then
    WEIGHT = VN_WEIGHT_RES;


  --     (  ) ---------------------------------
  if (BASE_LEVEL > 0) then
    execute procedure GET_INDEX_BB_PR(:IDCLASS, :BASE_LEVEL, :PUNKTIND)
    returning_values :INDEX_BB_PR_1;

  if (CURR_LEVEL > 0) then
    execute procedure GET_INDEX_BB_PR(:IDCLASS, :CURR_LEVEL, :PUNKTIND)
    returning_values :INDEX_BB_PR_2;


  suspend;
end
^


-- MK CQ[15048]
create or alter procedure B_EXP_RECORD_RABMAT_INNER (
    IDUSER integer,
    ID integer,
    IDTCH_REESTR integer)
returns (
    IDREESTR integer,
    RABMAT integer,
    ORDERVIEW integer,
    TAB varchar(42),
    TABU varchar(42),
    ALTTAB varchar(250),
    IDNAME integer,
    IDEDIZM integer,
    IDALTEDIZM integer,
    EDIZMKOEF double precision,
    ID_UNIQUE integer,
    comment varchar(42),
    RAZRAD double precision,
    BA double precision,
    BB double precision,
    BB_OTP double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    TRANSP_P double precision,
    ZAG_SKL_1 double precision,
    ZAG_SKL_P double precision,
    KLASS_G integer,
    TAB_TRANSP varchar(42),
    BJ double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    MN double precision,
    MO double precision,
    MP double precision,
    MQ double precision,
    MR double precision,
    MS double precision,
    MT double precision,
    VRPZ integer,
    NTR integer,
    BRUTTO double precision,
    NETTO double precision,
    VB double precision,
    VN double precision,
    PREISK varchar(42),
    POSPREISK varchar(42),
    MBETON double precision,
    MRKBETON varchar(15),
    MMASHINE varchar(25),
    VBETON double precision,
    TKALK varchar(50),
    PUNKTIND varchar(42),
    FRTCH varchar(250),
    FRESN varchar(21),
    IDPOSTAV integer,
    ISESN smallint,
    IDWITHESN integer,
    IDTCH integer,
    IDOGL integer,
    IDQUALIFIER integer,
    IDSOSTAV integer,
    IDPICTURE integer,
    NEW_PAGE smallint,
    ESN_NORM_GUID varchar(100),
    TCARD_NORM_GUID varchar(100),
    CREATEDATE date,
    AUTHOR varchar(250),
    IDABCOKP integer,
    ABCOKP_IDPODGROUP integer,
    STATUS integer,
    IDENT_KOD_MAT_SAP varchar(30),
    BASE_EDIZM_SAP varchar(42),
    STOIM_MAT_SAP double precision,
    IDOBJECT_FROM integer,
    BB_PR double precision,
    TRANSP_SH varchar(255))
AS
DECLARE VARIABLE IDESN INTEGER;
DECLARE VARIABLE IDTCARD INTEGER;
BEGIN
-- IDOBJECT_FROM <> 0:      ( )
-- B_RABMAT.ID = A_O_OBJECTPARAMS.NUMBER
 FOR SELECT
     IDREESTR, RABMAT, ORDERVIEW, IDNAME, TAB, TABU, ALTTAB, IDOGL, IDQUALIFIER,
     IDTCH, FRTCH, IDSOSTAV, ID_UNIQUE, IDEDIZM, IDALTEDIZM, EDIZMKOEF, IDABCOKP,
     COMMENT, IDTCARD, IDESN, FRESN, RAZRAD,
     BA, BB,
     BB_OTP, --[14355]
     BC, BD, BE, BF, BG, BH, BI,
     TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
     BJ, PA, PB, PC,
     PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK,
     ML, MM, MN, MO, MP, MQ, MR, MS, MT, VRPZ, NTR,
     BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
     MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, PUNKTIND,
     IDPOSTAV, ISESN, IDWITHESN, NEW_PAGE, CREATEDATE, AUTHOR,
     IDENT_KOD_MAT_SAP, BASE_EDIZM_SAP, STOIM_MAT_SAP, -- CQ[TIMUR 6776]
     BB_PR, TRANSP_SH -- MK CQ[15048]
 FROM B_RABMAT
 WHERE (ID = :ID)
 INTO :IDREESTR, :RABMAT, :ORDERVIEW, :IDNAME, :TAB, :TABU, :ALTTAB, :IDOGL, :IDQUALIFIER,
      :IDTCH, :FRTCH, :IDSOSTAV, :ID_UNIQUE, :IDEDIZM, :IDALTEDIZM, :EDIZMKOEF, :IDABCOKP,
      :COMMENT, :IDTCARD, :IDESN, :FRESN, :RAZRAD,
      :BA, :BB,
      :BB_OTP, --[14355]
      :BC, :BD, :BE, :BF, :BG, :BH, :BI,
      :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
      :BJ, :PA, :PB, :PC,
      :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK,
      :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR,
      :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
      :MBETON, :MRKBETON, :VBETON, :MMASHINE,:IDPICTURE, :TKALK, :PUNKTIND,
      :IDPOSTAV, :ISESN, :IDWITHESN, :NEW_PAGE, :CREATEDATE, :AUTHOR,
      :IDENT_KOD_MAT_SAP, :BASE_EDIZM_SAP, :STOIM_MAT_SAP, -- CQ[TIMUR 6776]
      :BB_PR, :TRANSP_SH -- MK CQ[15048]
 DO BEGIN
    --[12447.9]       
    if (:TAB <> '') then
      TABU = S_TRANSLITERATE(:TAB);

    SELECT STATUS
    FROM B_RABMAT_EX
    WHERE ID = :ID
    INTO STATUS;

    IF (IDABCOKP IS NOT NULL)
    THEN
        SELECT IDPODGROUP
        FROM B_ABC_OKP
        WHERE ID =:IDABCOKP
        INTO :ABCOKP_IDPODGROUP ;

    IF (IDESN IS NOT NULL)
    THEN
       SELECT NORM_GUID
       FROM B_REESTR_DOC
       WHERE ID =:IDESN
       INTO :ESN_NORM_GUID ;

    IF (IDTCARD IS NOT NULL)
    THEN
       SELECT NORM_GUID
       FROM B_REESTR_DOC
       WHERE ID =:IDTCARD
       INTO :TCARD_NORM_GUID ;

    IF (IDTCH_REESTR = IDTCH)
    THEN IDTCH = NULL;

    --CQ[9061] -->
    IDOBJECT_FROM =
    case when :RABMAT = 0
          and exists(select * from A_O_HIER H where H.NUMBER=:ID and H.ATYPE=1)
          and exists(select * from A_O_OBJECTPARAMS O where O.NUMBER=:ID)
      then :ID
      else null
    end;
    --CQ[9061] <--

    SUSPEND;
  END
END
^


-- MK CQ[15048]
create or alter procedure B_EXP_RABMAT (
    IDUSER integer,
    IN_ID integer)
returns (
    ID integer,
    IDREESTR integer,
    RABMAT integer,
    ORDERVIEW integer,
    TAB varchar(42),
    TABU varchar(42),
    ALTTAB varchar(250),
    IDNAME integer,
    IDEDIZM integer,
    IDALTEDIZM integer,
    EDIZMKOEF double precision,
    ID_UNIQUE integer,
    comment varchar(42),
    RAZRAD double precision,
    BA double precision,
    BB double precision,
    BB_OTP double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    TRANSP_P double precision,
    ZAG_SKL_1 double precision,
    ZAG_SKL_P double precision,
    KLASS_G integer,
    TAB_TRANSP varchar(42),
    BJ double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    MN double precision,
    MO double precision,
    MP double precision,
    MQ double precision,
    MR double precision,
    MS double precision,
    MT double precision,
    VRPZ integer,
    NTR integer,
    BRUTTO double precision,
    NETTO double precision,
    VB double precision,
    VN double precision,
    PREISK varchar(42),
    POSPREISK varchar(42),
    MBETON double precision,
    MRKBETON varchar(15),
    MMASHINE varchar(25),
    VBETON double precision,
    TKALK varchar(50),
    PUNKTIND varchar(42),
    FRTCH varchar(250),
    FRESN varchar(21),
    IDPOSTAV integer,
    ISESN integer,
    IDWITHESN integer,
    IDTCH integer,
    IDOGL integer,
    IDQUALIFIER integer,
    IDSOSTAV integer,
    IDPICTURE integer,
    NEW_PAGE integer,
    ESN_NORM_GUID varchar(100),
    TCARD_NORM_GUID varchar(100),
    CREATEDATE date,
    AUTHOR varchar(250),
    IDABCOKP integer,
    ABCOKP_IDPODGROUP integer,
    STATUS integer,
    IDENT_KOD_MAT_SAP varchar(30),
    BASE_EDIZM_SAP varchar(42),
    STOIM_MAT_SAP double precision,
    IDOBJECT_FROM integer,
    BB_PR double precision,
    TRANSP_SH varchar(255))
AS
DECLARE VARIABLE IDTCH_REESTR INTEGER;
BEGIN
 SELECT IDTCH
 FROM B_REESTR
 WHERE ID =:IN_ID
 INTO :IDTCH_REESTR;

 FOR SELECT ID
 FROM B_RABMAT
 WHERE IDREESTR = :IN_ID
 INTO :ID
 DO
    FOR SELECT
       IDREESTR, RABMAT, ORDERVIEW, IDNAME, TAB, TABU, ALTTAB, IDOGL, IDQUALIFIER,
       IDTCH, FRTCH, IDSOSTAV, ID_UNIQUE, IDEDIZM, IDALTEDIZM, EDIZMKOEF, COMMENT, FRESN, RAZRAD,
       BA, BB,
       BB_OTP, --[14355]
       BC, BD, BE, BF, BG, BH, BI,
       TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
       BJ, PA, PB, PC,
       PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK,
       ML, MM, MN, MO, MP, MQ, MR, MS, MT, VRPZ, NTR,
       BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
       MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, PUNKTIND,
       IDPOSTAV, ISESN, IDWITHESN, NEW_PAGE, CREATEDATE, AUTHOR,
       ESN_NORM_GUID, TCARD_NORM_GUID, IDABCOKP, ABCOKP_IDPODGROUP, STATUS,
       IDENT_KOD_MAT_SAP, BASE_EDIZM_SAP, STOIM_MAT_SAP, -- CQ[TIMUR 6776]
       IDOBJECT_FROM, --<<[9061]
       BB_PR, TRANSP_SH -- MK CQ[15048]
    FROM B_EXP_RECORD_RABMAT_INNER(:IDUSER, :ID, :IDTCH_REESTR)
    INTO :IDREESTR, :RABMAT, :ORDERVIEW, :IDNAME, :TAB, :TABU, :ALTTAB, :IDOGL, :IDQUALIFIER,
         :IDTCH, :FRTCH, :IDSOSTAV, :ID_UNIQUE, :IDEDIZM, :IDALTEDIZM, :EDIZMKOEF, :COMMENT, :FRESN, :RAZRAD,
         :BA, :BB,
         :BB_OTP, --[14355]
         :BC, :BD, :BE, :BF, :BG, :BH, :BI,
         :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
         :BJ, :PA, :PB, :PC,
         :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK,
         :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR,
         :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
         :MBETON, :MRKBETON, :VBETON, :MMASHINE,:IDPICTURE, :TKALK, :PUNKTIND,
         :IDPOSTAV, :ISESN, :IDWITHESN, :NEW_PAGE, :CREATEDATE, :AUTHOR,
         :ESN_NORM_GUID, :TCARD_NORM_GUID, :IDABCOKP, :ABCOKP_IDPODGROUP, :STATUS,
         :IDENT_KOD_MAT_SAP, :BASE_EDIZM_SAP, :STOIM_MAT_SAP, -- CQ[TIMUR 6776]
         :IDOBJECT_FROM, --<<[9061]
         :BB_PR, :TRANSP_SH -- MK CQ[15048]
    DO
       SUSPEND;
END
^


-- MK CQ[15048]
create or alter procedure B_EXP_RECORD_RABMAT (
    IDUSER integer,
    IN_ID integer)
returns (
    ID integer,
    IDREESTR integer,
    RABMAT integer,
    ORDERVIEW integer,
    TAB varchar(42),
    TABU varchar(42),
    ALTTAB varchar(250),
    IDNAME integer,
    IDEDIZM integer,
    IDALTEDIZM integer,
    EDIZMKOEF double precision,
    ID_UNIQUE integer,
    comment varchar(42),
    RAZRAD double precision,
    BA double precision,
    BB double precision,
    BB_OTP double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    TRANSP_P double precision,
    ZAG_SKL_1 double precision,
    ZAG_SKL_P double precision,
    KLASS_G integer,
    TAB_TRANSP varchar(42),
    BJ double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    MN double precision,
    MO double precision,
    MP double precision,
    MQ double precision,
    MR double precision,
    MS double precision,
    MT double precision,
    VRPZ integer,
    NTR integer,
    BRUTTO double precision,
    NETTO double precision,
    VB double precision,
    VN double precision,
    PREISK varchar(42),
    POSPREISK varchar(42),
    MBETON double precision,
    MRKBETON varchar(15),
    MMASHINE varchar(25),
    VBETON double precision,
    TKALK varchar(50),
    PUNKTIND varchar(42),
    FRTCH varchar(250),
    FRESN varchar(21),
    IDPOSTAV integer,
    ISESN integer,
    IDWITHESN integer,
    IDTCH integer,
    IDOGL integer,
    IDQUALIFIER integer,
    IDSOSTAV integer,
    IDPICTURE integer,
    NEW_PAGE integer,
    ESN_NORM_GUID varchar(100),
    TCARD_NORM_GUID varchar(100),
    CREATEDATE date,
    AUTHOR varchar(250),
    IDABCOKP integer,
    ABCOKP_IDPODGROUP integer,
    STATUS integer,
    IDENT_KOD_MAT_SAP varchar(30),
    BASE_EDIZM_SAP varchar(42),
    STOIM_MAT_SAP double precision,
    IDOBJECT_FROM integer,
    BB_PR double precision,
    TRANSP_SH varchar(255))
AS
DECLARE VARIABLE IDTCH_REESTR INTEGER;
BEGIN
 SELECT ID, IDREESTR
 FROM B_RABMAT
 WHERE (ID = :IN_ID)
 INTO :ID, :IDREESTR;

 SELECT IDTCH
 FROM B_REESTR
 WHERE ID =:IDREESTR
 INTO :IDTCH_REESTR;

 FOR SELECT
    RABMAT, ORDERVIEW, IDNAME, TAB, TABU, ALTTAB, IDOGL, IDQUALIFIER,
    IDTCH, FRTCH, IDSOSTAV, ID_UNIQUE, IDEDIZM, IDALTEDIZM, EDIZMKOEF,
    COMMENT, FRESN, RAZRAD, BA, BB,
    BB_OTP, --[14355]
    BC, BD, BE, BF, BG, BH, BI,
    TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
    BJ, PA, PB, PC,
    PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK,
    ML, MM, MN, MO, MP, MQ, MR, MS, MT, VRPZ, NTR,
    BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
    MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, PUNKTIND,
    IDPOSTAV, ISESN, IDWITHESN, NEW_PAGE, CREATEDATE, AUTHOR,
    ESN_NORM_GUID, TCARD_NORM_GUID, IDABCOKP, ABCOKP_IDPODGROUP, STATUS,
    IDENT_KOD_MAT_SAP, BASE_EDIZM_SAP, STOIM_MAT_SAP, -- CQ[TIMUR 6776]
    IDOBJECT_FROM, --<<[9061]
    BB_PR, TRANSP_SH -- MK CQ[15048]
 FROM B_EXP_RECORD_RABMAT_INNER(:IDUSER, :ID, :IDTCH_REESTR)
 INTO :RABMAT, :ORDERVIEW, :IDNAME, :TAB, :TABU, :ALTTAB, :IDOGL, :IDQUALIFIER,
      :IDTCH, :FRTCH, :IDSOSTAV, :ID_UNIQUE, :IDEDIZM, :IDALTEDIZM, :EDIZMKOEF,
      :COMMENT, :FRESN, :RAZRAD, :BA, :BB,
      :BB_OTP, --[14355]
      :BC, :BD, :BE, :BF, :BG, :BH, :BI,
      :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
      :BJ, :PA, :PB, :PC,
      :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK,
      :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT, :VRPZ, :NTR,
      :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
      :MBETON, :MRKBETON, :VBETON, :MMASHINE,:IDPICTURE, :TKALK, :PUNKTIND,
      :IDPOSTAV, :ISESN, :IDWITHESN, :NEW_PAGE, :CREATEDATE, :AUTHOR,
      :ESN_NORM_GUID, :TCARD_NORM_GUID, :IDABCOKP, :ABCOKP_IDPODGROUP, :STATUS,
      :IDENT_KOD_MAT_SAP, :BASE_EDIZM_SAP, :STOIM_MAT_SAP, -- CQ[TIMUR 6776]
      :IDOBJECT_FROM, --<<[9061]
      :BB_PR, :TRANSP_SH -- MK CQ[15048]
 DO
    SUSPEND;
END
^


-- MK CQ[15048]
create or alter procedure B_IMP_I_RABMAT (
    IDUSER integer,
    IMPMODE integer,
    IDREESTR integer,
    RABMAT integer,
    ORDERVIEW integer,
    TAB varchar(42),
    TABU varchar(42),
    ALTTAB varchar(250),
    IDNAME integer,
    IDEDIZM integer,
    IDALTEDIZM integer,
    EDIZMKOEF double precision,
    ID_UNIQUE integer,
    comment varchar(42),
    RAZRAD double precision,
    BA double precision,
    BB double precision,
    BB_OTP double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    TRANSP_P double precision,
    ZAG_SKL_1 double precision,
    ZAG_SKL_P double precision,
    KLASS_G integer,
    TAB_TRANSP varchar(42),
    BJ double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    MN double precision,
    MO double precision,
    MP double precision,
    MQ double precision,
    MR double precision,
    MS double precision,
    MT double precision,
    VRPZ integer,
    NTR integer,
    BRUTTO double precision,
    NETTO double precision,
    VB double precision,
    VN double precision,
    PREISK varchar(42),
    POSPREISK varchar(42),
    MBETON double precision,
    MRKBETON varchar(15),
    MMASHINE varchar(25),
    VBETON double precision,
    TKALK varchar(50),
    PUNKTIND varchar(42),
    FRTCH varchar(250),
    FRESN varchar(21),
    IDPOSTAV integer,
    ISESN integer,
    IDWITHESN integer,
    IDTCH integer,
    IDOGL integer,
    IDQUALIFIER integer,
    IDSOSTAV integer,
    IDPICTURE integer,
    NEW_PAGE integer,
    ESN_NORM_GUID varchar(100),
    IDESN integer,
    TCARD_NORM_GUID varchar(100),
    CREATEDATE date,
    AUTHOR varchar(250),
    IDABCOKP integer,
    STATUS integer,
    IDENT_KOD_MAT_SAP varchar(30),
    BASE_EDIZM_SAP varchar(42),
    STOIM_MAT_SAP double precision,
    BB_PR double precision,
    TRANSP_SH varchar(255))
returns (
    ID integer)
AS
DECLARE VARIABLE REORDERING INTEGER;
DECLARE VARIABLE AINSERTING INTEGER;
DECLARE VARIABLE IDNAME_OLD INTEGER;
DECLARE VARIABLE IDSOSTAV_OLD INTEGER;
DECLARE VARIABLE IDPICTURE_OLD INTEGER;
DECLARE VARIABLE IDTCARD INTEGER;
DECLARE VARIABLE IDPAPKA INTEGER;
BEGIN
  IF (STATUS IS NULL) THEN STATUS = 0;
  IF (:IDESN = 0) THEN IDESN = NULL;
  IF (:IDEDIZM = 0) THEN IDEDIZM = NULL;
  IF (:IDALTEDIZM = 0) THEN IDALTEDIZM = NULL;
  IF (:IDNAME = 0) THEN IDNAME = NULL;
  IF (:IDQUALIFIER = 0) THEN IDQUALIFIER = NULL;
  IF (:IDABCOKP = 0) THEN IDABCOKP = NULL;
  IF (:IDTCH = 0) THEN IDTCH = NULL;
  IF (:IDSOSTAV = 0) THEN IDSOSTAV = NULL;
  IF (:IDPICTURE = 0) THEN IDPICTURE = NULL;
  IF (:IDOGL = 0) THEN IDOGL = NULL;

  IF (:TAB IS NULL) THEN TAB = '';
  IF (:TABU IS NULL) THEN TABU = '';

  if (:IMPMODE = 3) then ORDERVIEW = null; /*   */

  IF (/*:TABU <> '' AND*/ :IDREESTR > 0) THEN
  BEGIN
    IF (:IDESN IS NULL AND :ESN_NORM_GUID <> '') THEN
      SELECT FIRST 1 ID
        FROM B_REESTR_DOC
        WHERE NORM_GUID = :ESN_NORM_GUID
        INTO :IDESN;

    IF (:TCARD_NORM_GUID <> '') THEN
      SELECT FIRST 1 ID
        FROM B_REESTR_DOC
        WHERE NORM_GUID = :TCARD_NORM_GUID
        INTO :IDTCARD;

    SELECT IDPARENT
      FROM B_REESTR
      WHERE ID = :IDREESTR
      INTO :IDPAPKA;

    IF (:ORDERVIEW = -1) THEN
    /*    -    */
      REORDERING = 0;
    ELSE
    BEGIN

      IF (:ORDERVIEW IS NULL OR :ORDERVIEW <= 0)
      THEN
      begin
        SELECT MAX(ORDERVIEW) + 1
          FROM B_RABMAT
          WHERE IDREESTR = :IDREESTR
          INTO :ORDERVIEW;
        IF (ORDERVIEW IS NULL) THEN
          ORDERVIEW = 1;
          /*    -    
        ELSE
          REORDERING = 1; */
      end /*   2008/07/03 [AE711D958997]
      ELSE
        REORDERING = 1; */
    END

    SELECT ID, NAMEID, IDSOSTAV, IDPICTURE
    FROM B_IMP_F_RABMAT(:IDUSER, :IDREESTR, :TABU, :IDNAME)
    INTO ID, IDNAME_OLD, IDSOSTAV_OLD, IDPICTURE_OLD;

    IF (:ID IS NULL) THEN
    BEGIN
      ID = GEN_ID (A_G_SMETA, 1);
      AINSERTING = 1;
    END

    IF (:REORDERING = 1) THEN
      EXECUTE PROCEDURE B_WRITE_NEWORDER_RABMAT (
          :IDUSER, :ID, :IDREESTR, :ORDERVIEW )
        RETURNING_VALUES (:REORDERING);

    if ( coalesce(BJ,0)=0 and not (PA is null and PB is null)
      or BJ is not null and (PA is null and PB is null) ) then
    begin --<<[13168]
      PA = null;
      PB = null;
      BJ = null;
    end

    IF (:AINSERTING = 1) THEN
    BEGIN
      INSERT INTO B_RABMAT (
          ID, IDREESTR, ORDERVIEW, IDNAME, IDPAPKA, ID_UNIQUE, IDTCH,
          TAB, TABU, RABMAT, IDOGL, FRTCH, IDSOSTAV, ALTTAB,
          IDEDIZM, IDALTEDIZM, EDIZMKOEF, IDABCOKP, COMMENT, IDTCARD,
          IDESN, FRESN, RAZRAD, BA, BB,
          BB_OTP, --<<[14355]
          BC, BD, BE, BF, BG, BH, BI,
          TRANSP_P, ZAG_SKL_1, ZAG_SKL_P, KLASS_G, TAB_TRANSP, --<<[14420]
          BJ,
          PA, PB, PC, PD, PE, MA, MB, MC, MD, ME, MF, MG, MH,
          VRPZ, NTR, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK, TKALK,
          IDPOSTAV, MBETON, MRKBETON, VBETON, MMASHINE, PUNKTIND,
          ISESN, IDWITHESN, CREATEDATE, AUTHOR, IDPICTURE,
          MI, MJ, MK, ML, MM, MN, MO, MP, MQ, MR, MS, MT,
          IDQUALIFIER, NEW_PAGE,
          IDENT_KOD_MAT_SAP, BASE_EDIZM_SAP, STOIM_MAT_SAP, -- CQ[TIMUR 6776]
          BB_PR, TRANSP_SH) -- MK CQ[15048]
        VALUES (
          :ID, :IDREESTR, :ORDERVIEW, :IDNAME, :IDPAPKA, :ID_UNIQUE, :IDTCH,
          :TAB, :TABU, :RABMAT, :IDOGL, :FRTCH, :IDSOSTAV, :ALTTAB,
          :IDEDIZM, :IDALTEDIZM, :EDIZMKOEF, :IDABCOKP, :COMMENT, :IDTCARD,
          :IDESN, :FRESN, :RAZRAD, :BA, :BB,
          :BB_OTP, --<<[14355]
          :BC, :BD, :BE, :BF, :BG, :BH, :BI,
          :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
          :BJ,
          :PA, :PB, :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH,
          :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK, :TKALK,
          :IDPOSTAV, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND,
          :ISESN, :IDWITHESN, :CREATEDATE, :AUTHOR, :IDPICTURE,
          :MI, :MJ, :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT,
          :IDQUALIFIER, :NEW_PAGE, :IDENT_KOD_MAT_SAP, :BASE_EDIZM_SAP, :STOIM_MAT_SAP, -- CQ[TIMUR 6776]
          :BB_PR, :TRANSP_SH); -- MK CQ[15048]

      if (:status <> 0) then
        INSERT INTO B_RABMAT_EX (ID, STATUS) VALUES (:ID, :STATUS);
    END
    ELSE
    if (:IMPMODE <> 3) then /*  3 -    */
    BEGIN
      UPDATE B_RABMAT
        SET /*IDREESTR    = :IDREESTR,*/
            ORDERVIEW   = :ORDERVIEW,
            IDNAME      = :IDNAME,
            IDPAPKA     = :IDPAPKA,
            ID_UNIQUE   = :ID_UNIQUE,
            IDTCH       = :IDTCH,
            TAB         = :TAB,
            /*TABU        = :TABU,*/
            RABMAT      = :RABMAT,
            IDOGL       = :IDOGL,
            FRTCH       = :FRTCH,
            IDSOSTAV    = :IDSOSTAV,
            ALTTAB      = :ALTTAB,
            IDEDIZM     = :IDEDIZM,
            IDALTEDIZM  = :IDALTEDIZM,
            EDIZMKOEF   = :EDIZMKOEF,
            IDABCOKP    = :IDABCOKP,
            COMMENT     = :COMMENT,
            IDTCARD     = :IDTCARD,
            IDESN       = :IDESN,
            FRESN       = :FRESN,
            RAZRAD      = :RAZRAD,
            BA          = :BA,
            BB          = :BB,
            BB_OTP      = :BB_OTP, --<<[14355]
            BC          = :BC,
            BD          = :BD,
            BE          = :BE,
            BF          = :BF,
            BG          = :BG,
            BH          = :BH,
            BI          = :BI,
            --<[14420]>
            TRANSP_P    = :TRANSP_P,
            ZAG_SKL_1   = :ZAG_SKL_1,
            ZAG_SKL_P   = :ZAG_SKL_P,
            KLASS_G     = :KLASS_G,
            TAB_TRANSP  = :TAB_TRANSP,
            --</>
            BJ          = :BJ,
            PA          = :PA,
            PB          = :PB,
            PC          = :PC,
            PD          = :PD,
            PE          = :PE,
            MA          = :MA,
            MB          = :MB,
            MC          = :MC,
            MD          = :MD,
            ME          = :ME,
            MF          = :MF,
            MG          = :MG,
            MH          = :MH,
            VRPZ        = :VRPZ,
            NTR         = :NTR,
            BRUTTO      = :BRUTTO,
            NETTO       = :NETTO,
            VB          = :VB,
            VN          = :VN,
            PREISK      = :PREISK,
            POSPREISK   = :POSPREISK,
            TKALK       = :TKALK,
            IDPOSTAV    = :IDPOSTAV,
            MBETON      = :MBETON,
            MRKBETON    = :MRKBETON,
            VBETON      = :VBETON,
            MMASHINE    = :MMASHINE,
            PUNKTIND    = :PUNKTIND,
            ISESN       = :ISESN,
            IDWITHESN   = :IDWITHESN,
            CREATEDATE  = :CREATEDATE,
            AUTHOR      = :AUTHOR,
            IDPICTURE   = :IDPICTURE,
            MI          = :MI,
            MJ          = :MJ,
            MK          = :MK,
            ML          = :ML,
            MM          = :MM,
            MN          = :MN,
            MO          = :MO,
            MP          = :MP,
            MQ          = :MQ,
            MR          = :MR,
            MS          = :MS,
            MT          = :MT,
            IDQUALIFIER = :IDQUALIFIER,
            NEW_PAGE    = :NEW_PAGE,
            --<<[6776]
            IDENT_KOD_MAT_SAP = :IDENT_KOD_MAT_SAP,
            BASE_EDIZM_SAP    = :BASE_EDIZM_SAP,
            STOIM_MAT_SAP     = :STOIM_MAT_SAP,

            -- MK CQ[15048]
            BB_PR = :BB_PR,
            TRANSP_SH = :TRANSP_SH

        WHERE ID = :ID;

      IF (:STATUS = 0) THEN
        DELETE FROM B_RABMAT_EX WHERE ID = :ID;
      ELSE
      IF (NOT EXISTS (SELECT * FROM B_RABMAT_EX WHERE ID = :ID)) THEN
        INSERT INTO B_RABMAT_EX (ID, STATUS) VALUES (:ID, :STATUS);
      ELSE
      /*      UPDATE- */
        UPDATE B_RABMAT_EX SET STATUS = :STATUS WHERE ID = :ID;

      IF (:IDNAME_OLD IS NOT NULL AND
         (:IDNAME IS NULL OR :IDNAME_OLD <> :IDNAME))
      THEN
        EXECUTE PROCEDURE B_DELETE_NAIMENOVANIE (:IDUSER, :IDNAME_OLD);

      IF (:IDSOSTAV_OLD IS NOT NULL AND
         (:IDSOSTAV IS NULL OR :IDSOSTAV_OLD <> :IDSOSTAV))
      THEN
        EXECUTE PROCEDURE B_DELETE_SOSTAV_RABOT(:IDUSER, :IDSOSTAV_OLD) ;

      IF (:IDPICTURE_OLD IS NOT NULL AND
         (:IDPICTURE IS NULL OR :IDPICTURE_OLD <> :IDPICTURE))
      THEN
        EXECUTE PROCEDURE B_DELETE_MATER_PICTURES(:IDUSER, IDPICTURE_OLD) ;
    END
  END

  SUSPEND;
END
^


-- MK CQ[15047, 15049]
-- 
CREATE OR ALTER PROCEDURE B_READ_RECORD_INDEX (
    IDUSER INTEGER,
    ID INTEGER,
    NEEDREADNAME INTEGER)
RETURNS (
    IDOGL INTEGER,
    ORDERVIEW INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    NEW_PAGE SMALLINT,
    IDNAME INTEGER,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^


-- MK CQ[15047, 15049]
create or alter procedure B_READ_SBORNIK_INDEX (
    IDUSER integer,
    REESTR_ID integer,
    OGL_ID integer,
    LIKETABU varchar(88),
    NNAMES blob sub_type 0 segment size 80,
    LIMIT integer,
    PRICES blob sub_type 0 segment size 80,
    INVERTPRICES integer)
returns (
    ID integer,
    IDOGL integer,
    TAB varchar(42),
    PA double precision,
    PB double precision,
    BA double precision,
    BANDS double precision,
    ZBA double precision,
    BE double precision,
    BENDS double precision,
    ZBE double precision,
    BC double precision,
    BCNDS double precision,
    ZBC double precision,
    BB double precision,
    BBNDS double precision,
    ZBB double precision,
    BD double precision,
    BDNDS double precision,
    ZBD double precision,
    PROCENTPRED double precision,
    NEW_PAGE smallint,
    NULLBLOB blob sub_type 1 segment size 80,
    NAME_TITLE blob sub_type 0 segment size 80,
    NAME_PART blob sub_type 0 segment size 80,
    ORDERVIEW integer,
    BB_PR double precision)
AS
DECLARE VARIABLE ID_TMP INTEGER;
declare variable dostup integer;
BEGIN
 if (:INVERTPRICES is null) then
   INVERTPRICES = 0;

 execute procedure L_CAN_USE_IND ( :iduser , :REESTR_ID , 1 ) returning_values ( :dostup );
 if ( dostup = 0 ) then
    exit;

 IF (NNAMES IS NOT NULL) THEN BEGIN
    ID_TMP = GEN_ID(B_GEN_TEMP, 1) ;
    INSERT INTO B_TEMP_BLOB (ID, BLOB1) VALUES (:ID_TMP, :NNAMES);
    SELECT BLOB1 FROM B_TEMP_BLOB WHERE ID = :ID_TMP INTO :NNAMES;
    DELETE FROM B_TEMP_BLOB WHERE ID = :ID_TMP ;
 END

 IF (NOT EXISTS(SELECT * FROM B_REESTR WHERE ID = :REESTR_ID))
 THEN EXCEPTION B_E_SBORNIK_NOT_FOUND;

 FOR SELECT ID, NAME_TITLE, NAME_PART
 FROM B_TEST_IND_CANSUSPEND(:IDUSER, :REESTR_ID, :OGL_ID, :LIKETABU, :NNAMES, :LIMIT)
 INTO :ID, :NAME_TITLE, :NAME_PART
 DO
    FOR SELECT IDOGL, ORDERVIEW, TAB, PA, PB, BA, BANDS,
               ZBA, BE, BENDS, ZBE, BC, BCNDS, ZBC, BB, BBNDS,
               ZBB, BD, BDNDS, ZBD, PROCENTPRED, NEW_PAGE,
               BB_PR -- MK CQ[15047, 15049]
    FROM B_READ_RECORD_INDEX(:IDUSER, :ID, 0)
    INTO :IDOGL, :ORDERVIEW, :TAB, :PA, :PB, :BA, :BANDS,
         :ZBA, :BE, :BENDS, :ZBE, :BC, :BCNDS, :ZBC, :BB, :BBNDS,
         :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :NEW_PAGE,
         :BB_PR -- MK CQ[15047, 15049]
    DO

    if (:PRICES is null or
        S_SEARCHBLOBPRICES(:PRICES, :BA, :BB, :BC, :BD, :BE, 0.0, 0.0) <> INVERTPRICES) then

       SUSPEND ;
END
^


-- MK CQ[15049]
-- 
CREATE OR ALTER PROCEDURE B_IMP_I_INDEX (
    IDUSER INTEGER,
    IDREESTR INTEGER,
    IDOGL INTEGER,
    ORDERVIEW INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    NAME_PART BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NEEDUPDATE_NAME_PART INTEGER,
    NEEDUPDATE_NAME_TITLE INTEGER,
    ID_GEN INTEGER,
    BB_PR DOUBLE PRECISION)
RETURNS (
    ID INTEGER)
AS
BEGIN
  SUSPEND;
END
^

/*15099*/
create or alter procedure T_GET_DATA_REPORT_FOR_NB (
    IDNORMOSECTOR integer,
    BUILDTYPE integer,
    IDZONE integer,
    IDZONE2 integer,
    IDUSER integer)
returns (
    TYPESTRUCT integer,
    IDSTRUCT integer,
    IDSTRUCT_PARENT integer,
    STRUCT_NAME varchar(250),
    TYPE_TRUD integer,
    RABMAT integer,
    RASHOD double precision,
    UCH integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    EDIZMNAME varchar(100),
    EDIZMFULLNAME varchar(250),
    NAME_TITLE blob sub_type 0 segment size 80,
    NAME_PART blob sub_type 0 segment size 80,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    ZONE_BA double precision,
    ZONE_BB double precision,
    ZONE_BC double precision,
    ZONE_BD double precision,
    ZONE_BE double precision,
    ZONE_BA2 double precision,
    ZONE_BB2 double precision,
    ZONE_BC2 double precision,
    ZONE_BD2 double precision,
    ZONE_BE2 double precision,
    BRUTTO double precision)
AS
declare variable in_rabmat integer;
declare variable idgroup integer;
declare variable idpodgroup integer;
declare variable def_idzone integer;
declare variable IDNORMO integer;
declare variable IDRES integer;
declare variable ID_MAIN_QUALIFIER integer;
begin

  /* BUILDTYPE
         (ReadQualifier) 1 -    
         (ReadOgl)       2 -      

     TYPESTRUCT
         (tsReestrSbornik) 0  -    - 
         (tsReestrFolder)  1  -    - 
         (tsOgl)           2  -   
         (tsOtherOgl)      3  -      
         (tsQualifier)     4  -   
         (tsRec)           17 -  
         (tsRes)           18 -     
         (tsMainRec)       20 -     */


  --     
  for select R.IDSTRUCT, R.PARENTSTRUCT, R.TYPESTRUCT, R.NAMESTRUCT
  from T_READ_REESTR_QUALIFIER_CHILDS(:IDNORMOSECTOR, :BUILDTYPE) R
  into :IDSTRUCT, :IDSTRUCT_PARENT, :TYPESTRUCT, :STRUCT_NAME
  do
  begin

    --  
    IDNORMO = null; RABMAT = null; TAB = null;
    RASHOD = null; UCH = null; ALTTAB = null; EDIZMNAME = null;
    EDIZMFULLNAME = null; NAME_TITLE = null; NAME_PART = null;
    BA = null; BB = null; BC = null; BD = null; BE = null;
    BF = null; BG = null; BH = null; BI = null;
    ZONE_BA = null; ZONE_BB = null; ZONE_BC = null; ZONE_BD = null; ZONE_BE = null;
    ID_MAIN_QUALIFIER = null;

    -- CQ[14597]  -->  
    BRUTTO = null;
    ZONE_BA2 = null; ZONE_BB2 = null; ZONE_BC2 = null; ZONE_BD2 = null; ZONE_BE2 = null;
    -- CQ[14597]  <--

    --   
    if ((TYPESTRUCT = 0 /*tsReestrSbornik*/) or
        (TYPESTRUCT = 1 /*tsReestrFolder*/))
    then
    begin
      select IDGROUP, IDPODGROUP, NOMER, GOD, RABMAT
        from B_REESTR r where ID = :IDSTRUCT
      into :IDGROUP, :IDPODGROUP, :TAB, :TYPE_TRUD, :RABMAT;

      if (IDZONE <= 0) then -- CQ[14597]   if (IDZONE < 0) then
        select IDZONE
        from B_READ_RABMAT_DEFZONE(:IDUSER, :IDSTRUCT)
        into :DEF_IDZONE;

    end
    else
    --    
    if (TYPESTRUCT = 3 /*tsOtherOgl*/) then
      STRUCT_NAME = "   ";

    suspend;

    --   
    TYPE_TRUD = null; RABMAT = null; TAB = null; STRUCT_NAME = null; IDSTRUCT_PARENT = null;

    --       
    for select R.IDNORMO from SELECT_FROM_RABMAT(:IDSTRUCT, :TYPESTRUCT) R
    into :IDNORMO do
    begin

       for select RABMAT, TAB, ALTTAB, EDIZMNAME, EDIZMFULLNAME, NAME_TITLE, NAME_PART,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, ZONE_BA, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE,
                  BRUTTO -- CQ[14597] 
       from B_READ_RECORD_RABMAT(:IDUSER,
                                 :IDNORMO,
                                 case when :IDZONE <= 0 then :DEF_IDZONE else :IDZONE end, -- CQ[14597]  (. ) :IDZONE < 0 <=>  :IDZONE <= 0
                                 1/*NEEDREADNAME*/)
       into :RABMAT, :TAB, :ALTTAB, :EDIZMNAME, :EDIZMFULLNAME, :NAME_TITLE, :NAME_PART,
            :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :ZONE_BA, :ZONE_BB, :ZONE_BC, :ZONE_BD, :ZONE_BE,
            :BRUTTO -- CQ[14597] 
       do
       begin

         --    ...
         if ( ((BUILDTYPE = 1) and (RABMAT = 3)) or (BUILDTYPE <> 1) )  then
         begin

            /*15099
            execute procedure B_CALCULATE_ZONE_BA(:IDUSER, :ZONE_BB, :ZONE_BC, :ZONE_BE)
            returning_values :ZONE_BA; */
   
            -- CQ[14597]  -->
            ZONE_BA2 = null; ZONE_BB2 = null; ZONE_BC2 = null; ZONE_BD2 = null; ZONE_BE2 = null;
            if (:IDZONE2 > 0) then
            begin
              select ZONE_BA, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE
              FROM B_READ_ZONE_RAB_TSENY (:IDUSER, :IDNORMO, :IDZONE2)
              INTO :ZONE_BA2, :ZONE_BB2, :ZONE_BC2, :ZONE_BD2, :ZONE_BE2;

              /*15099
              --     ,      (. )
              execute procedure B_CALCULATE_ZONE_BA(:IDUSER, :ZONE_BB2, :ZONE_BC2, :ZONE_BE2)
              returning_values :ZONE_BA2; */

            end
            -- CQ[14597]  <--
   
            --   ...     
            if ((BUILDTYPE = 1) and (ID_MAIN_QUALIFIER is null)) then
            begin
              ID_MAIN_QUALIFIER = 0;
              select IDNORMY
                from B_QUALIFIER_MAINS
              where (IDQUALIFIER = :IDSTRUCT) and (RABMAT = :RABMAT)
              into :ID_MAIN_QUALIFIER;
            end
   
            if (ID_MAIN_QUALIFIER = IDNORMO) then
              TYPESTRUCT = 20; /*tsMainRec*/
            else
              TYPESTRUCT = 17; /*tsRec*/
            IN_RABMAT  = RABMAT;
            suspend;
   
            ALTTAB = null; BF = null; BG = null; BH = null; BI = null;
   
            for select TYPE_TRUD, RABMAT, KOLL, UCH, TAB, EDIZM_NAME, EDIZM_FULLNAME, NAME_TITLE, NAME_PART,
                       BA, BB, BC, BD, BE, ZONE_CENA, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE,
                       IDRES -- CQ[14597] 
            from B_READ_RESURS_LIST(:IDUSER,
                                    :IDNORMO,
                                    1 /*IN_PODGROUP*/,
                                    :IN_RABMAT,
                                    :IDGROUP,
                                    :IDPODGROUP,
                                    case when :IDZONE <= 0 then :DEF_IDZONE else :IDZONE end, -- CQ[14597]  (. ) :IDZONE < 0 <=>  :IDZONE <= 0
                                    0/*READ_FOR_ESN*/)
            order by RABMAT, TAB, ID
            into :TYPE_TRUD, :RABMAT, :RASHOD, :UCH, :TAB, :EDIZMNAME, :EDIZMFULLNAME, :NAME_TITLE, :NAME_PART,
                 :BA, :BB, :BC, :BD, :BE, :ZONE_BA, :ZONE_BB, :ZONE_BC, :ZONE_BD, :ZONE_BE,
                 :IDRES -- CQ[14597] 
            do
            begin
   
              /*15099
              execute procedure B_CALCULATE_ZONE_BA(:IDUSER, :ZONE_BB, :ZONE_BC, :ZONE_BE)
              returning_values :ZONE_BA; */
   
              -- CQ[14597]  -->
              ZONE_BA2 = null; ZONE_BB2 = null; ZONE_BC2 = null; ZONE_BD2 = null; ZONE_BE2 = null;
              if (:IDZONE2 > 0) then
              begin
                select ZONE_BA, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE
                FROM B_READ_ZONE_RAB_TSENY (:IDUSER, :IDRES, :IDZONE2)
                INTO :ZONE_BA2, :ZONE_BB2, :ZONE_BC2, :ZONE_BD2, :ZONE_BE2;

                /*15099
                --     ,      (. )
                execute procedure B_CALCULATE_ZONE_BA(:IDUSER, :ZONE_BB2, :ZONE_BC2, :ZONE_BE2)
                returning_values :ZONE_BA2; */

              end
              -- CQ[14597]  <--
   
   
              TYPESTRUCT = 18; /*tsRes*/
              suspend;
            end
   
          end
       end

     end

  end
end^

--[12925,14976]
create or alter procedure PM_GET_LINKED_POSITIONS (
    IDPRICE integer,
    RETURN_POSITIONS integer)
returns (
    ID integer,
    ID_PARENT integer,
    ROW integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NORM_NAME blob sub_type 1 segment size 80,
    NORM_TITLE blob sub_type 1 segment size 80,
    EDIZM_ID integer,
    EDIZM_NAME varchar(100),
    KOEF double precision,
    NORMOCOST double precision,
    POS_COUNT integer,
    LINKED_COUNT integer,
    KOEFF_TRANSP_TYPE integer,
    KOEFF_TRANSP_VALUE double precision,
    KOEFF_ZAGOT_TYPE integer,
    KOEFF_ZAGOT_VALUE double precision,
    KOEFF_OBORUD_TYPE integer,
    KOEFF_OBORUD_VALUE double precision,
    KOEFF_OTHER_TYPE integer,
    KOEFF_OTHER_VALUE double precision,
    POSITIONNAME varchar(510),
    IDPOS integer,
    BB double precision,
    IDNORMO integer)
AS
declare MIN_ROW integer;
declare IDGEN integer;
declare NORMOCOST_LINK double precision;
begin
--    ID / ID_PARENT   [12925,14976]:
--  (:RETURN_POSITIONS <> 0)    ,  ...
--   IDNORMO, ..        

  IDGEN = 0;
  if (RETURN_POSITIONS is null) then RETURN_POSITIONS = 0;

  for select P.IDNORMO, LROUNDN(P.NORMOCOST, 2), N.NAME, T.NAME, E.ID, E.NAME, R.TAB, r.ALTTAB, r.BB -- CQ[7466]
    from PM_PRICEPOSLINKS P
    left join B_RABMAT R on P.IDNORMO = R.ID
    left join B_NNAME N on R.IDNAME = N.ID
    left join B_NNAME_TITLE T on N.IDTITLE = T.ID
    left join B_EDIZM E on R.IDEDIZM = E.ID
    where IDPRICE = :IDPRICE
    into :IDNORMO/*[12925,14976]ID*/, :NORMOCOST_LINK, :NORM_NAME, :NORM_TITLE, :EDIZM_ID, :EDIZM_NAME, :TAB, :ALTTAB, :BB
  do
  --<[12925,14976]>
  for select min(P.ROW) --[12925,14976]  / [ P.ROW / min(P.ROW) )  
    from PM_PRICEPOS P
    right join PM_PRICEPOSNORMS PPN on PPN.ID = P.ID --[12925]
    where PPN.IDPRICE = :IDPRICE
      and PPN.IDNORMO = :IDNORMO
    into :ROW
  do
  --</>
  begin

    select min(P.ROW), count(*)
    from PM_PRICEPOS P
    right join PM_PRICEPOSNORMS PPN on PPN.ID = P.ID --[12925]
    where PPN.IDPRICE = :IDPRICE
      and PPN.IDNORMO = :IDNORMO
    into :MIN_ROW, :POS_COUNT;

    if ((:ROW = :MIN_ROW) or (:RETURN_POSITIONS <> 0)) then --[12925,14976]
    begin

      NORMOCOST = :NORMOCOST_LINK;
      IDGEN = :IDGEN + 1;
      ID = case when :RETURN_POSITIONS <> 0 then :IDGEN else :IDNORMO end; --[12925,14976]
      --ID = :IDNORMO;
      IDPOS = null;

      ID_PARENT = 0;
      KOEF = null;
      POSITIONNAME = '';
      if ((RETURN_POSITIONS = 0) or (POS_COUNT = 1))  then
      begin
        select first 1 P.ID, PPN.KOEF, P.KOEFF_TRANSP_TYPE, P.KOEFF_TRANSP_VALUE,
                   P.KOEFF_ZAGOT_TYPE, P.KOEFF_ZAGOT_VALUE, P.KOEFF_OBORUD_TYPE,
                   P.KOEFF_OBORUD_VALUE, P.KOEFF_OTHER_TYPE, P.KOEFF_OTHER_VALUE
          from PM_PRICEPOS P
          right join PM_PRICEPOSNORMS PPN on PPN.ID = P.ID --[12925]
          where (PPN.IDPRICE = :IDPRICE) and (PPN.IDNORMO = :IDNORMO) --MK  :(IDNORMO = :ID_PARENT)
          into :IDPOS, :KOEF, :KOEFF_TRANSP_TYPE, :KOEFF_TRANSP_VALUE,
               :KOEFF_ZAGOT_TYPE, :KOEFF_ZAGOT_VALUE, :KOEFF_OBORUD_TYPE,
               :KOEFF_OBORUD_VALUE, :KOEFF_OTHER_TYPE, :KOEFF_OTHER_VALUE;
          if (POS_COUNT = 1) then execute procedure dm_getpriceposname(:IDPOS) returning_values :POSITIONNAME;  --CQ[7425]
      end
  
      LINKED_COUNT = POS_COUNT;
  
  --    if (POS_COUNT > 0) then
        suspend;
  
      if ((RETURN_POSITIONS <> 0) and (POS_COUNT > 1)) then
      begin
  --      TAB = null;
  --      ALTTAB = null;
  --      NORM_NAME = null;
  --      NORM_TITLE = null;
  --      EDIZM_ID = null;
  --      EDIZM_NAME = null;
        POS_COUNT = null;
        LINKED_COUNT = null;
  
        ID_PARENT = :ID;
        for select P.ID, P.ROW, LROUNDN(PPN.NORMOCOST, 2), PPN.KOEF, P.KOEFF_TRANSP_TYPE, P.KOEFF_TRANSP_VALUE,-- CQ[7466]
                   P.KOEFF_ZAGOT_TYPE, P.KOEFF_ZAGOT_VALUE, P.KOEFF_OBORUD_TYPE,
                   P.KOEFF_OBORUD_VALUE, P.KOEFF_OTHER_TYPE, P.KOEFF_OTHER_VALUE
          from PM_PRICEPOS P
          right join PM_PRICEPOSNORMS PPN on PPN.ID = P.ID --[12925]
          where (PPN.IDPRICE = :IDPRICE) and (PPN.IDNORMO = :IDNORMO)
          order by P.row
          into :IDPOS, :ROW, :NORMOCOST, :KOEF, :KOEFF_TRANSP_TYPE, :KOEFF_TRANSP_VALUE,
               :KOEFF_ZAGOT_TYPE, :KOEFF_ZAGOT_VALUE, :KOEFF_OBORUD_TYPE,
               :KOEFF_OBORUD_VALUE, :KOEFF_OTHER_TYPE, :KOEFF_OTHER_VALUE
        do
        begin
          IDGEN = :IDGEN + 1;
          ID = case when :RETURN_POSITIONS <> 0 then :IDGEN else :IDPOS end; --[12925,14976]
          --ID = :IDPOS;
          execute procedure dm_getpriceposname(:IDPOS) returning_values :POSITIONNAME;  --CQ[7425]
          suspend;
        end
      end

    end

  end
end
^

--------------------------------------------------------------------
--                           10.0.0.2
--------------------------------------------------------------------

--[15004]
create or alter procedure S__UPGRADE_LSTMP_15004
AS
begin

  if (not exists(select * from RDB$INDICES
      where RDB$INDEX_NAME = 'L_S_TMP_TBL_IDX_ID')) then
execute statement
'CREATE INDEX L_S_TMP_TBL_IDX_ID ON L_S_TMP_TBL (KEY2, ID)';

  if (not exists(select * from RDB$INDICES
      where RDB$INDEX_NAME = 'L_S_TMP_TBL_IDX_NUMBERS')) then
execute statement
'CREATE INDEX L_S_TMP_TBL_IDX_NUMBERS ON L_S_TMP_TBL (KEY2, NUMBER1, NUMBER2, NUMBER3)';

end
^
execute procedure S__UPGRADE_LSTMP_15004
^
drop procedure S__UPGRADE_LSTMP_15004
^^

--[15004]
create or alter procedure A_S_RENUM_BEFORE_INSERT_KS6 (
    IDHIER integer,
    ATYPE integer,
    NEWNUMBER1 integer,
    NEWNUMBER2 integer,
    NEWNUMBER3 integer,
    OFFSET integer)
AS
DECLARE VARIABLE ID_CUR INTEGER;
begin
--[15004] -   A_S_RENUM_BEFORE_INSERT -    -6 
  /*execute procedure A_S_REPARENT_COMMENT(:idhier,
                                         :smetatype,
                                         :atype,
                                         :newnumber1,
                                         :newnumber2,
                                         :insert_to_atype,
                                         :newid,
                                         :insert_to_id);*/

  /* ,     */
  for select s.id
      from L_S_TMP_TBL s
      where (s.KEY2 = :idhier) and
            (s.number1 = :newnumber1) and
            (s.number2 = :newnumber2) and
            (s.number3 = :newnumber3)
      into :id_cur do
  begin
   /*  ,        */

   /*     */
   if (atype = 17)
   then update L_S_TMP_TBL s
        set s.number1 = s.number1 + :offset
        where (s.KEY2 = :IDHIER) and
              (s.number1 >= :newnumber1);
        /*   - */
   else if (atype = 18)
        then update L_S_TMP_TBL s
             set s.number2 = s.number2 + :offset
             where (s.KEY2 = :idhier) and
                   (s.number1 = :newnumber1) and
                   (s.number2 >= :newnumber2);
             /*   - */
        else if (atype = 19)
             then update L_S_TMP_TBL s
             set s.number3 = s.number3 + :offset
             where (s.KEY2 = :idhier) and
                   (s.number1 = :newnumber1) and
                   (s.number2 = :newnumber2) and
                   (s.number3 >= :newnumber3);
             else exception A_TYPEUNKNOWN;
/*
   execute procedure A_S_REPARENT_COMMENT(:idhier,
                                          :smetatype,
                                          :atype,
                                          :newnumber1,
                                          :newnumber2,
                                          :insert_to_atype,
                                          :newid,
                                          :insert_to_id);
*/
   exit;
  end
/*
  execute procedure A_S_REPARENT_COMMENT(:idhier,
                                         :smetatype,
                                         :atype,
                                         :newnumber1,
                                         :newnumber2,
                                         :insert_to_atype,
                                         :newid,
                                         :insert_to_id);
*/
end
^

--[15004]
create or alter procedure L_PR_GET_NOMERROD_PREV (
    ID_ADDED integer)
returns (
    NOMERROD1_ADDED_PREV integer)
AS
declare IDHIER integer;
declare SMETATYPE_ADDED integer;
declare NUMBER1_ADDED integer;
declare NUMBER1_ADDED_PREV integer;
begin
--[15004]    ,     

  --   
  select NUMBER1, IDHIER, SMETATYPE
    from A_SMETA
    where ID = :ID_ADDED
    into :NUMBER1_ADDED, :IDHIER, :SMETATYPE_ADDED;

  if (:NUMBER1_ADDED is not null) then
  --   
  select max(NUMBER1)
    from A_SMETA
    where IDHIER = :IDHIER
      and SMETATYPE = :SMETATYPE_ADDED
      and NUMBER1 < :NUMBER1_ADDED
    into :NUMBER1_ADDED_PREV;

  if (:NUMBER1_ADDED_PREV is not null) then
  -- NOMERROD  
  select NOMERROD1
    from A_SMETA
    where IDHIER = :IDHIER
      and SMETATYPE = :SMETATYPE_ADDED
      and NUMBER1 = :NUMBER1_ADDED_PREV
      and ATYPE = 17/*SmRec*/
    into :NOMERROD1_ADDED_PREV;


end
^

--[15004]
-- 
CREATE OR ALTER PROCEDURE A_P_SMETA (
    IDOBJECT INTEGER,
    IDLEVEL INTEGER,
    IDUSER INTEGER,
    SMETATYPE INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    IDLS INTEGER,
    IDR INTEGER,
    ALLREC INTEGER,
    SENDER INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    CLCMODE_RES INTEGER,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    ID_LS INTEGER,
    ADDED_SMETATYPE INTEGER,
    PR_VIPOLNENO_TOTAL DOUBLE PRECISION,
    K_ITOGO VARCHAR(50),
    ISKS_NS_ID INTEGER,
    COD_RTM VARCHAR(60),
    COD_RTM_BLOB BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    K_PR VARCHAR(50),
    B_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15004]
create or alter procedure L_PR_COPY_SMETA_TO_PR_ONE_HIER (
    IN_IDHIER integer,
    IN_SMETATYPE integer,
    ID_PR integer,
    LYEAR integer,
    LMONTH integer,
    ID_USER integer,
    IN_HATYPE integer,
    IN_IDOBJ integer,
    IDLEVEL integer)
AS
DECLARE VARIABLE IDHIER INTEGER;
DECLARE VARIABLE HATYPE INTEGER;
DECLARE VARIABLE ID INTEGER;
--DECLARE VARIABLE SMETATYPE1 INTEGER;
--DECLARE VARIABLE SMETATYPE2 INTEGER;
DECLARE VARIABLE NUMBER1 INTEGER;
DECLARE VARIABLE NUMBER2 INTEGER;
DECLARE VARIABLE NUMBER3 INTEGER;
DECLARE VARIABLE ATYPE INTEGER;
DECLARE VARIABLE SLAVEPARENT INTEGER;
DECLARE VARIABLE SLAVEPARENT_18 INTEGER;
DECLARE VARIABLE SLAVEPARENT_19 INTEGER;
DECLARE VARIABLE NEW_ID INTEGER;
DECLARE VARIABLE S_SLAVEPARENT INTEGER;
DECLARE VARIABLE S_PR_ADDED_REC INTEGER;
DECLARE VARIABLE S_NOMERROD INTEGER;
DECLARE VARIABLE S_NUMBER1 INTEGER;
DECLARE VARIABLE S_NUMBER2 INTEGER;
DECLARE VARIABLE S_NUMBER3 INTEGER;
DECLARE VARIABLE id_obj INTEGER;
-- MK CQ[12020]
declare variable VIEW_NUMBER1 integer;
declare variable VIEW_NUMBER2 integer;
declare variable VIEW_NUMBER3 integer;
declare variable vn_clcmode integer;
declare variable vn_id integer;
-- MK CQ[14357]
declare variable VN_RENUM_SLAVE_AS_MAIN integer;

--<[15004]>
declare NUMBER1_LAST integer;
declare NUMBER1_NEW integer;
declare NOMERROD1_ADDED_PREV integer;--</>
begin
   -- MK CQ[11792] --->
   execute procedure STORE_REVISION_LS_CRC(:IN_IDHIER, :ID_PR);
   -- MK CQ[11792] <---

   -- MK CQ[14357] --->
   VN_RENUM_SLAVE_AS_MAIN = 0;

   select getbit(coalesce(f.auto_renum_mode, 0), 3)
   from a_o_factparams f
   where (f.number = :ID_PR)
   into :VN_RENUM_SLAVE_AS_MAIN;
   -- MK CQ[14357] <---

   --SMETATYPE1 = IN_SMETATYPE;
   --SMETATYPE2 = IN_SMETATYPE;
   --if ( IN_SMETATYPE = 16 ) then
   --   SMETATYPE1 = 15;

   IDHIER = IN_IDHIER;
   if (IN_HATYPE is null) then--CQ[8612]
   begin
     hatype = null;
     select first 1 atype from a_o_hier where number = :in_idhier into hatype;
   end
   else
     hatype = :IN_HATYPE;--CQ[8612]

   if ( ( hatype is null) or ( not hatype in ( 3 , 4 , 5 ) ) ) then
      exit;
   if (IN_IDOBJ is null) then --CQ[8612]
   begin
     execute procedure a_h_get_id_parentatype( :IN_IDHIER, 1 ) returning_values ( :id_obj );
   end
   else
     id_obj = :IN_IDOBJ; --CQ[8612]

         number1 = 0;
         number2 = 0;
         number3 = 0;
         atype   = 0;
         slaveparent = 0;
         slaveparent_18 = 0;
         slaveparent_19 = 0;
         for select id, number1, number2, number3, atype, slaveparent from a_smeta s
--             where s.idhier = :idhier and ( s.smetatype = :smetatype1 or s.smetatype = :smetatype2 )
             where s.idhier = :idhier and ( s.smetatype = :in_smetatype )
             order by idhier, smetatype, NUMBER1, NUMBER2, NUMBER3
             into id, number1, number2, number3, atype, slaveparent
         do
         begin
             execute procedure l_pr_copy_smeta_to_pr_one_rec ( :id , :id_pr , :id_user , -1 , 0 , 0 , 0 ,
                                                               :id_obj ,
                                                               :LYEAR ,
                                                               :LMONTH,
                                                               :IDLEVEL, --CQ[9439]
                                                               0, 0, 0 -- MK CQ[12020]
                                                               )
                                                               RETURNING_VALUES ( :new_id );
             if ( atype = 17 ) then
             begin
                slaveparent_18 = slaveparent;
                slaveparent_19 = slaveparent;
             end
             else if ( atype = 18 ) then
                slaveparent_19 = slaveparent;

             -- MK CQ[12020] --->
             --      
             select first 1 v.number1, v.number2, v.number3
             from A_SMETA_VIEW_NUM v
             where (v.id = :id) and
                   (v.number1 is not null) --   
             into :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3;
             -- MK CQ[12020] <---
         end

         -- MK CQ[12020] --->
         VIEW_NUMBER1 = coalesce(VIEW_NUMBER1, 0);
         VIEW_NUMBER2 = coalesce(VIEW_NUMBER2, 0);
         VIEW_NUMBER3 = coalesce(VIEW_NUMBER3, 0);
         -- MK CQ[12020] <---

         vn_clcmode = 0; -- MK   CQ[14357]

         --<[15004]>
         NUMBER1_LAST = :NUMBER1;
         --</>

         for select id
         from L_PR_SEL_IS_ONE_HIER_ID (:idhier, :lyear, :lmonth, :id_user, 1)
         -- MK 5.11.2014    
         -- (      )
         --where (id <> :ID_PR) /* MK 19.09.2006 CQ[3745] */
         into id
         do
         begin
             for select atype , slaveparent,
                        clcmode -- MK CQ[12020]
                 from a_smeta s where s.id = :id
                 into   atype , s_slaveparent,
                        :vn_clcmode -- MK CQ[12020]
             do
                 id = id;

             if (atype = 17) then -- MK   CQ[14357]
               vn_clcmode = getbit(:vn_clcmode, 10); -- MK CQ[12020]

             if ( atype = 17 ) then
             begin
               --<[15004]>
               NUMBER1_LAST = NUMBER1_LAST + 1;
               NUMBER1_NEW = null;
               execute procedure L_PR_GET_NOMERROD_PREV(:ID)
                   returning_values :NOMERROD1_ADDED_PREV;
               if (:NOMERROD1_ADDED_PREV is not null) then
                 select NUMBER1 + 1
                   from A_SMETA
                   where NOMERROD1=:NOMERROD1_ADDED_PREV
                     and SMETATYPE=:ID_PR
                   into NUMBER1_NEW;
               if (:NUMBER1_NEW is not null) then
               begin
                 execute procedure A_S_RENUM_BEFORE_INSERT(
                   :IDHIER, :ID_PR, 17/*SmRec*/, :NUMBER1_NEW, 0, 0, 1,
                   null/*INSERT_TO_ATYPE*/, null/*NEWID*/, null/*INSERT_TO_ID*/);
                 number1 = NUMBER1_NEW;
               end
               else
               begin
                 number1 = NUMBER1_LAST;
               end
               --</>

                slaveparent = 0;
                --[15004]number1 = number1 + 1;
                number2 = 0;
                number3 = 0;
                -- MK CQ[12020] --->
                if (vn_clcmode = 0) then
                begin
                  view_number1 = view_number1 + 1;
                  view_number2 = 0;
                  view_number3 = 0;
                end
                -- MK CQ[12020] <---
             end
             else if ( atype = 18 ) then
             begin
                slaveparent = slaveparent_18;
                number2 = number2 + 1;
                number3 = 0;
                -- MK CQ[12020] --->
                if (vn_clcmode = 0) then
                begin
                  -- MK CQ[14357] --->
                  if (VN_RENUM_SLAVE_AS_MAIN <> 0) then
                  begin
                    view_number1 = view_number1 + 1;
                    view_number2 = 0;
                    view_number3 = 0;
                  end
                  else
                  begin
                  -- MK CQ[14357] <---
                    view_number2 = view_number2 + 1;
                    view_number3 = 0;
                  end -- MK CQ[14357]
                end
                -- MK CQ[12020] <---
             end
             else if ( atype = 19 ) then
             begin
                slaveparent = slaveparent_19;
                number3 = number3 + 1;
                -- MK CQ[12020] --->
                if (vn_clcmode = 0) then
                  view_number3 = view_number3 + 1;
                -- MK CQ[12020] <---
             end

             S_NUMBER1 = NUMBER1;
             S_NUMBER2 = NUMBER2;
             S_NUMBER3 = NUMBER3;

             if ( ( atype in ( 18 , 19 ) ) and ( s_slaveparent <> 0 ) ) then
             begin
                for select PR_ADDED_REC, NOMERROD
                    from a_smeta where id = :s_slaveparent
                    into s_PR_ADDED_REC, S_NOMERROD
                do
                   /* hard case: we add resource or comment to string from ps. or procentov. ( not to is. ) */
                   if ( ( s_PR_ADDED_REC = 0 ) and ( not S_NOMERROD is null ) and ( S_NOMERROD <> 0 ) ) then
                   begin
                      /*slaveparent = S_NOMERROD;*/
                      slaveparent = 0;
                      for select id from a_smeta where nomerrod = :S_NOMERROD and smetatype = :id_pr
                          into slaveparent
                      do
                         slaveparent = slaveparent;
                     if ( slaveparent <> 0 ) then
                      for select number1, number2, number3,
                                 clcmode -- MK CQ[12020]
                          from a_smeta
                          where id = :slaveparent
                          into S_NUMBER1, S_NUMBER2, S_NUMBER3,
                               :vn_clcmode -- MK CQ[12020]
                      do
                      begin
                         -- MK CQ[12020] --->
                         vn_clcmode = getbit(:vn_clcmode, 10);
                         if (vn_clcmode = 0) then
                         begin
                           --   
                           select first 1 v.number1, v.number2, v.number3
                           from A_SMETA_VIEW_NUM v
                           where (v.id = :id)
                           into :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3;
                         end
                         -- MK CQ[12020] <---

                         if ( atype = 18 ) then
                         begin
                            -- MK CQ[12020] --->
                            vn_id = null;
                            S_number2 = null;
                            select first 1 s.id, s.number2
                            from a_smeta s
                            where (s.slaveparent = :slaveparent)
                            order by s.number2 desc
                            into :vn_id, :S_number2;

                            S_number2 = coalesce(S_number2, 0) + 1;
                            S_number3 = 0;
                            if (vn_clcmode = 0) then
                            begin
                              -- MK CQ[14357] --->
                              if (VN_RENUM_SLAVE_AS_MAIN <> 0) then
                              begin
                                if (vn_id is not null) then
                                begin
                                  select first 1 v.number1
                                  from A_SMETA_VIEW_NUM v
                                  where (v.id = :vn_id)
                                  into :VIEW_NUMBER1;
                                end
                                else
                                begin
                                  select first 1 v.number1
                                  from A_SMETA_VIEW_NUM v
                                  where (v.id = :slaveparent)
                                  into :VIEW_NUMBER1;
                                end
  
                                VIEW_NUMBER1 = VIEW_NUMBER1 + 1;
                                VIEW_NUMBER2 = 0;
                                VIEW_NUMBER3 = 0;
                              end
                              else
                              begin
                              -- MK CQ[14357] <---
                                if (vn_id is not null) then
                                begin
                                  select first 1 v.number2
                                  from A_SMETA_VIEW_NUM v
                                  where (v.id = :vn_id)
                                  into :VIEW_NUMBER2;
                                end
                                else
                                  VIEW_NUMBER2 = 0;
  
                                VIEW_NUMBER2 = VIEW_NUMBER2 + 1;
                                VIEW_NUMBER3 = 0;
                              end -- MK CQ[14357]
                            end

                            --select max(number2) from a_smeta where slaveparent = :slaveparent into S_number2;
                            --if ( S_number2 is null ) then
                            --   S_number2 = 0;
                            --S_number2 = S_number2 + 1;
                            --S_number3 = 0;
                            -- MK CQ[12020] <---
                         end
                         -- MK CQ[12020] --->
                         --  
                         else if (atype = 19) then
                         --else if ( atype = 18 ) then
                         -- MK CQ[12020] <---
                         begin
                            -- MK CQ[12020] --->
                            vn_id = null;
                            S_number3 = null;
                            --   number3      
                            select first 1 s.id, s.number3
                            from a_smeta s
                            where (s.slaveparent = :slaveparent) and (s.atype = 19)
                            order by s.number3 desc
                            into :vn_id, :S_number3;

                            S_number3 = coalesce(S_number3, 0) + 1;
                            if (vn_clcmode = 0) then
                            begin
                              if (vn_id is not null) then
                              begin
                                select first 1 v.number3
                                from A_SMETA_VIEW_NUM v
                                where (v.id = :vn_id)
                                into :VIEW_NUMBER3;
                              end
                              else
                                VIEW_NUMBER3 = 0;

                              VIEW_NUMBER3 = VIEW_NUMBER3 + 1;
                            end

                            --select max(number3) from a_smeta where slaveparent = :slaveparent into S_number3;
                            --if ( S_number3 is null ) then
                            --   S_number3 = 0;
                            --S_number3 = S_number3 + 1;
                            -- MK CQ[12020] <---
                         end
                      end
                   end
             end

             execute procedure l_pr_copy_smeta_to_pr_one_rec ( :id , :id_pr , :id_user , :slaveparent , :S_number1 , :S_number2 , :S_number3 ,
                                                               :id_obj ,
                                                               :LYEAR ,
                                                               :LMONTH,
                                                               :IDLEVEL, --CQ[9439]
                                                               -- MK CQ[12020] --->
                                                               case when vn_clcmode = 0 then :VIEW_NUMBER1 else null end,
                                                               case when vn_clcmode = 0 then :VIEW_NUMBER2 else null end,
                                                               case when vn_clcmode = 0 then :VIEW_NUMBER3 else null end
                                                               -- MK CQ[12020] <---
                                                               ) RETURNING_VALUES ( :new_id );

             if ( atype = 17 ) then
             begin
                slaveparent_18 = new_id;
                slaveparent_19 = new_id;

                if (:NUMBER1 <> :NUMBER1_LAST) then
                  --[15004]
                  execute procedure M_SET_VIEW_NUMS_AFTER_INS(
                      :NEW_ID, :IDHIER, :ID_PR, :ATYPE, :SLAVEPARENT,
                      :NUMBER1, :NUMBER2, :NUMBER3);
             end
             else
             if ( atype = 18 ) then
                slaveparent_19 = new_id;
         end
end
^

--[15004]
-- 
create or alter procedure L_PR_CREATE_KC6_1 (
    ID_OBJ integer,
    IN_SMETATYPE integer,
    ID_USER integer,
    LYEAR integer,
    USE_ONLY_UTV_PROCENT integer,
    SENDER integer,
    STOIMMODE integer,
    HIERCHECKING_SMETATYPE integer,
    HIERCHECKING_ATYPE integer,
    HIERCHECKING_MUST_EXISTS integer,
    NEED_NAME_EDIZM integer,
    ID_CENLVL integer,
    ID_PS_CENLVL integer)
returns (
    ID_SELF integer,
    ID integer,
    IDHIER integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE integer,
    BMP integer,
    NPP varchar(21),
    TAB varchar(42),
    NAME blob sub_type 0 segment size 80,
    EDIZM varchar(250),
    KOLL double precision,
    RA double precision,
    RA_NET double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    PA double precision,
    PB double precision,
    KOLL_PRIOR double precision,
    RA_PRIOR double precision,
    KOLL_YEAR double precision,
    RA_YEAR double precision,
    KOLL_OST double precision,
    RA_OST double precision,
    IDSRES integer,
    IDNORMO integer,
    SMETAPARENT integer,
    RABMAT integer,
    TYPE_TRUD integer,
    ID_EDIZM integer,
    TIPRAB integer,
    TAB_LONG blob sub_type 1 segment size 80,
    CLCMODE integer)
AS
BEGIN
             SUSPEND;
END
^

--[15004]
create or alter procedure L_PR_CREATE_KC6_BASE (
    IN_IDHIER integer,
    KEY2 integer,
    IN_SMETATYPE integer,
    LYEAR integer,
    LMONTH integer,
    ID_USER integer,
    SENDER integer,
    ONLY_ONE_HIER integer)
returns (
    ID_SELF integer,
    ID integer,
    IDHIER integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer)
AS
DECLARE VARIABLE HATYPE INTEGER;
DECLARE VARIABLE HCOUNTCHILDREN INTEGER;
DECLARE VARIABLE IN_SMETATYPE_ORIG INTEGER;
DECLARE VARIABLE SMETATYPE1 INTEGER;
DECLARE VARIABLE SMETATYPE2 INTEGER;
DECLARE VARIABLE ATYPE INTEGER;
DECLARE VARIABLE SLAVEPARENT_18 INTEGER;
DECLARE VARIABLE SLAVEPARENT_19 INTEGER;
DECLARE VARIABLE NEW_ID INTEGER;
DECLARE VARIABLE S_SLAVEPARENT INTEGER;
DECLARE VARIABLE S_PR_ADDED_REC INTEGER;
DECLARE VARIABLE S_NOMERROD INTEGER;
DECLARE VARIABLE S_NUMBER1 INTEGER;
DECLARE VARIABLE S_NUMBER2 INTEGER;
DECLARE VARIABLE S_NUMBER3 INTEGER;
DECLARE VARIABLE NOMERROD INTEGER;
DECLARE VARIABLE PROJECTTYPE INTEGER;
DECLARE VARIABLE STATUS_KEY INTEGER;
DECLARE VARIABLE curr_IDHIER INTEGER;
DECLARE VARIABLE skip_select_acts INTEGER;
DECLARE VARIABLE TMP_NUMBER1 INTEGER;
DECLARE VARIABLE TMP_NUMBER2 INTEGER;
DECLARE VARIABLE TMP_NUMBER3 INTEGER;
DECLARE VARIABLE smetatype INTEGER;
DECLARE VARIABLE nomerrod1 INTEGER;
--<[15004]>
declare NUMBER1_LAST integer;
declare NUMBER1_NEW integer;
declare NOMERROD1_ADDED_PREV integer;--</>
begin
--[12767]     [12020]  :
-- L_PR_CREATE_KC6_BASE     .
--        ,
--       [12767]

   /*
      IN_SMETATYPE:
         0 - skip PS
         < 0 - only for one PS or procentov.
   */

   skip_select_acts = 0;

   if ( IN_SMETATYPE is null ) then
      IN_SMETATYPE = 0;

   IN_SMETATYPE_ORIG = IN_SMETATYPE;

   if ( IN_SMETATYPE < 0 ) then
   begin
      IN_SMETATYPE = - IN_SMETATYPE;
      skip_select_acts = 1;
   end

   SMETATYPE1 = IN_SMETATYPE;
   SMETATYPE2 = IN_SMETATYPE;
   if ( IN_SMETATYPE = 16 ) then
      SMETATYPE1 = 15;

   if ( ONLY_ONE_HIER is null ) then
      ONLY_ONE_HIER = 0;

   execute procedure l_getprojecttype ( :id_user ) returning_values ( :PROJECTTYPE , :STATUS_KEY );

   for select h.number, h.atype, h.countchildren
      from a_o_hier h
      where (
             ( :ONLY_ONE_HIER = 0 ) and
             (   (h.parent = :in_idhier) and (h.atype IN (0,3,4,5)) and
                 ( (h.subtype is null) or (h.subtype in (0,1,2,3,4,5)) )
             )
            )
            or
            (
             ( :ONLY_ONE_HIER <> 0 ) and ( h.number = :in_idhier )
            )
      order by h.sorting
      into :IDHIER, :hatype, :hcountchildren
   do
   begin
     curr_IDHIER = IDHIER;
     if ( hatype <> 0 ) then
      if ( ( PROJECTTYPE <> 1 ) or ( hatype = 3 ) ) then
      begin
/* 0.  */
         ID_SELF = null;
         ID      = IDHIER;
         NUMBER1 = 0;
         NUMBER2 = 0;
         NUMBER3 = 0;
         SLAVEPARENT = hatype;
         if ( PROJECTTYPE <> 1 ) then
            suspend;

/* 1.  */
         delete from l_s_tmp_tbl where key2 = :key2;


/* 2.  */
         number1 = 0;
         number2 = 0;
         number3 = 0;
         atype   = 0;
         slaveparent = 0;
         slaveparent_18 = 0;
         slaveparent_19 = 0;

/* 2.a  */
        if ( IN_SMETATYPE <> 0 ) then
         for select id, /*number1, number2, number3,*/ atype/*, slaveparent*/ from a_smeta s
--             where s.idhier = :idhier and ( s.smetatype = :smetatype1 or s.smetatype = :smetatype2 )
             where s.idhier = :idhier and ( s.smetatype = :IN_SMETATYPE )
             order by idhier, smetatype, NUMBER1, NUMBER2, NUMBER3
             into id, /*s_number1, s_number2, s_number3,*/ atype/*, s_slaveparent*/
         do
         begin

             slaveparent = 0;
             if ( atype = 17 ) then
             begin
                slaveparent = 0;
                number1 = number1 + 1;
                number2 = 0;
                number3 = 0;
             end
             else if ( atype = 18 ) then
             begin
                slaveparent = slaveparent_18;
                number2 = number2 + 1;
                number3 = 0;
             end
             else if ( atype = 19 ) then
             begin
                slaveparent = slaveparent_19;
                number3 = number3 + 1;
             end

             execute procedure l_pr_copy_smeta_to_kc6_one_rec ( :id , :key2 , :id_user , :slaveparent , :number1 , :number2 , :number3 , null ) RETURNING_VALUES ( :new_id );
             if ( atype = 17 ) then
             begin
                slaveparent_18 = new_id;
                slaveparent_19 = new_id;
             end
             else if ( atype = 18 ) then
                slaveparent_19 = new_id;
         end

         --[15004]+ 2016/10/03
         NUMBER1_LAST = :NUMBER1;

/* 2.b  */
        if ( skip_select_acts = 0 ) then
         for select id from L_PR_SEL_IS_ONE_HIER_ID (:idhier, :LYEAR, :LMONTH, :id_user, 0)
             into id
         do
         begin
             select atype , slaveparent , nomerrod
                 from a_smeta s where s.id = :id
                 into   atype , s_slaveparent , NOMERROD;

             slaveparent = 0;
             if ( atype = 17 ) then
             begin
               --<[15004]>
               NUMBER1_LAST = NUMBER1_LAST + 1;
               NUMBER1_NEW = null;
               execute procedure L_PR_GET_NOMERROD_PREV(:ID)
                   returning_values :NOMERROD1_ADDED_PREV;

               if (:NOMERROD1_ADDED_PREV is not null) then
                 select NUMBER1 + 1
                   from L_S_TMP_TBL
                   where ID=:NOMERROD1_ADDED_PREV
                     and KEY2=:KEY2
                   into NUMBER1_NEW;

               if (:NUMBER1_NEW is not null) then
               begin
                 execute procedure A_S_RENUM_BEFORE_INSERT_KS6(
                   :KEY2, 17/*SmRec*/, :NUMBER1_NEW, 0, 0, 1);
                 number1 = NUMBER1_NEW;
               end
               else
               begin
                 number1 = NUMBER1_LAST;
               end
               --</>

                slaveparent = 0;
                --[15004]number1 = number1 + 1;
                number2 = 0;
                number3 = 0;
             end
             else if ( atype = 18 ) then
             begin
                slaveparent = slaveparent_18;
                number2 = number2 + 1;
                number3 = 0;
             end
             else if ( atype = 19 ) then
             begin
                slaveparent = slaveparent_19;
                number3 = number3 + 1;
             end

             S_NUMBER1 = NUMBER1;
             S_NUMBER2 = NUMBER2;
             S_NUMBER3 = NUMBER3;

             if ( ( atype in ( 18 , 19 ) ) and ( s_slaveparent <> 0 ) ) then
             begin
                for select PR_ADDED_REC, NOMERROD
                    from a_smeta where id = :s_slaveparent
                    into s_PR_ADDED_REC, S_NOMERROD
                do
                   /* hard case: we add resource or comment to string from ps. or procentov. ( not to is. ) */
                   if ( ( s_PR_ADDED_REC = 0 ) and ( not S_NOMERROD is null ) and ( S_NOMERROD <> 0 ) ) then
                   begin
                      slaveparent = 0;
                      for select id_self from l_s_tmp_tbl where key2 = :key2 and /*nomerrod*/ id = :S_NOMERROD
                          into slaveparent
                      do
                         slaveparent = slaveparent;
                     if ( slaveparent <> 0 ) then
                      for select number1, number2, number3
                          from l_s_tmp_tbl
                          where id_self = :slaveparent and key2 = :key2
                          into S_NUMBER1, S_NUMBER2, S_NUMBER3
                      do
                      begin
                         if ( atype = 18 ) then
                         begin
                            select max(number2) from l_s_tmp_tbl
                                   where key2 = :key2 and slaveparent = :slaveparent
                                   into S_number2;
                            if ( S_number2 is null ) then
                               S_number2 = 0;
                            S_number2 = S_number2 + 1;
                            S_number3 = 0;
                         end
                         -- MK   CQ[12020] --->
                         else if ( atype = 19 ) then
                         --else if ( atype = 18 ) then --[12767] -   ,
                         --         . !!!
                         -- MK   CQ[12020] <---
                         begin
                            select max(number3) from l_s_tmp_tbl
                                   where key2 = :key2 and slaveparent = :slaveparent
                                   into S_number3;
                            if ( S_number3 is null ) then
                               S_number3 = 0;
                            S_number3 = S_number3 + 1;
                         end
                      end
                   end
             end

             execute procedure l_pr_copy_smeta_to_kc6_one_rec ( :id , :key2 , :id_user , :slaveparent , :S_number1 , :S_number2 , :S_number3 , :NOMERROD ) RETURNING_VALUES ( :new_id );
             if ( atype = 17 ) then
             begin
                slaveparent_18 = new_id;
                slaveparent_19 = new_id;
             end
             else if ( atype = 18 ) then
                slaveparent_19 = new_id;
         end

/* 3.  */
         for select id_self , id , number1, number2, number3 , slaveparent
             from l_s_tmp_tbl where key2 = :key2
             order by number1, number2, number3
             into   id_self , id , number1, number2, number3 , slaveparent
         do
         begin
            /* convert our virtual numbers to numbers by smeta */

-- MK CQ[12020]  --->
--            /* save virtual numbers */
--            TMP_NUMBER1 = NUMBER1;
--            TMP_NUMBER2 = NUMBER2;
--            TMP_NUMBER3 = NUMBER3;
--
--            number1 = null;
--            number2 = null;
--            number3 = null;
--
--            nomerrod1 = null;
--            select /*[12767]first 1*/ nomerrod1 from a_smeta where id = :id into nomerrod1;
--
--            if ( nomerrod1 is not null ) then
--            begin
--               smetatype = null;
--
--               select /*[12767]first 1*/ number1, number2, number3, smetatype
--               from a_smeta where id = :nomerrod1
--               into number1, number2, number3, smetatype;
--
--               if ( smetatype is not null ) then
--                  if ( not smetatype in ( 15 , 16 ) ) then
--                     select /*[12767]first 1*/ pr_number1, pr_number2, pr_number3
--                     --    ,     :
--                     -- .. ,   ,    primary key      -  !
--                     from l_s_pr_addinfo where id = :NOMERROD1 --[12767]id = :id
--                     into number1, number2, number3;
--            end
--
--            suspend;
--
--            /* restore virtual numbers */
--            NUMBER1 = TMP_NUMBER1;
--            NUMBER2 = TMP_NUMBER2;
--            NUMBER3 = TMP_NUMBER3;
-- MK CQ[12020]  <---
            suspend; -- <<MK CQ[12020]

         end

/* 4.  */
         execute procedure l_pr_create_kc6_base_finalize ( :key2 );

      end

      if ( ONLY_ONE_HIER = 0 ) then
         if ( hcountchildren > 0 ) then
            if ( PROJECTTYPE <> 1 ) then
               for select * from L_PR_CREATE_KC6_BASE ( :IDHIER, :KEY2, :IN_SMETATYPE_ORIG, :LYEAR, :LMONTH, :ID_USER, :SENDER, :ONLY_ONE_HIER )
                   into ID_SELF, ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT
               do
                  suspend;

      if ( sender = 1 )
      then
      begin
         ID_SELF = null;
         ID      = CURR_IDHIER;
         NUMBER1 = 0;
         NUMBER2 = 0;
         NUMBER3 = 0;

         SLAVEPARENT = hatype + 23;
         suspend;

      end

   end
end
^

--[15004]
-- 
CREATE OR ALTER PROCEDURE L_S_CREATE_IS (
    IDOBJECT INTEGER,
    IDLEVEL INTEGER,
    IDUSER INTEGER,
    SMETATYPE INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    IDLS INTEGER,
    IDR INTEGER,
    ALLREC INTEGER,
    SENDER INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    VIDRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    ASUBTYPE INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    ID_LS INTEGER,
    ADDED_SMETATYPE INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    B_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15004]
create or alter procedure M_GET_INSERTED_VIEW_NUMDERS (
    IDHIER integer,
    SMETATYPE integer,
    ATYPE integer,
    INSERT_TO_ID integer,
    NEWNUMBER1 integer,
    NEWNUMBER2 integer,
    NEWNUMBER3 integer,
    RENUM_SLAVE_AS_MAIN integer)
returns (
    VIEW_NUMBER1 integer,
    VIEW_NUMBER2 integer,
    VIEW_NUMBER3 integer)
AS
declare variable VN_ID integer;
begin
  ------------------------------------------------------------------------------
  --       
  -- :
  -- INSERT_TO_ID -      (. = null)
  -- NEWNUMBER1, NEWNUMBER2, NEWNUMBER3 -   
  -- VIEW_NUMBER1, VIEW_NUMBER2, VIEW_NUMBER3 -   
  -- RENUM_SLAVE_AS_MAIN -      CQ[14357]
  --
  --     
  ------------------------------------------------------------------------------

  --        -------------------
/*
-- MK:  - INSERT_TO_ID    
-- ( Ctrl+Enter   ).    
--       .     
  if (INSERT_TO_ID is not null) then
  begin
    VN_ID = null;
    select first 1 ID, NUMBER1, NUMBER2, NUMBER3
    from A_SMETA_VIEW_NUM
    where (ID = :INSERT_TO_ID)
    into :VN_ID, :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3;

    if (VN_ID is null) then
    begin
      --     (INSERT_TO_ID =  - )
      VIEW_NUMBER1 = 0;
      VIEW_NUMBER2 = 0;
      VIEW_NUMBER3 = 0;
    end
    else
    begin
      --       (   
      --   ) -      (. )
      if (VIEW_NUMBER1 is null) then
        INSERT_TO_ID = null;
    end
  end

  if (INSERT_TO_ID is null) then
*/
  begin
    --   
    -- MK CQ[14282] --->
    if (ATYPE = 17) then --   
    begin
      select first 1 s.id
      from a_smeta s
      where (s.idhier = :IDHIER) and (s.smetatype = :SMETATYPE) and
            (s.atype = 17) and (s.number1 < :NEWNUMBER1) and
            (getbit(s.clcmode, 10) = 0) --    
      order by s.number1 desc
      into :VN_ID;
    end
    else --     
    begin
      select first 1 s.id
      from a_smeta s
      where (s.idhier = :IDHIER) and (s.smetatype = :SMETATYPE) and
            (
            ((s.number1 = :NEWNUMBER1) and (s.number2 < :NEWNUMBER2)) or
            ((s.number1 = :NEWNUMBER1) and (s.number2 = :NEWNUMBER2) and (s.number3 < :NEWNUMBER3))
            )
      order by s.number1 desc, s.number2 desc, s.number3 desc
      into :VN_ID;
    end

    -- MK CQ[14357] --->
    --      , :
    --       
    --    
    --     
    if ((:RENUM_SLAVE_AS_MAIN <> 0) and (ATYPE = 17) and (VN_ID is not null)) then
    begin
      select first 1 s.id
      from a_smeta s
      where --[15004](s.idhier = :IDHIER) and (s.smetatype = :SMETATYPE) and
            (s.slaveparent = :VN_ID) and (s.atype = 18)
      order by s.number1 desc, s.number2 desc
      into :VN_ID;
    end
    -- MK CQ[14357] <---

    --select first 1 s.id
    --from a_smeta s
    --where (s.idhier = :IDHIER) and (s.smetatype = :SMETATYPE) and
    --      (
    --      (s.number1 < :NEWNUMBER1) or
    --      ((s.number1 = :NEWNUMBER1) and (s.number2 < :NEWNUMBER2)) or
    --      ((s.number1 = :NEWNUMBER1) and (s.number2 = :NEWNUMBER2) and (s.number3 < :NEWNUMBER3))
    --      ) and
    --      (getbit(s.clcmode, 10) = 0) --    
    --order by s.number1 desc, s.number2 desc, s.number3 desc
    --into :VN_ID;
    -- MK CQ[14282] <---

    --    -    
    if (VN_ID is not null) then
    begin
      select first 1 NUMBER1, NUMBER2, NUMBER3
      from A_SMETA_VIEW_NUM
      where (ID = :VN_ID)
      into :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3;
    end
    --     -      
    else
    begin
      VIEW_NUMBER1 = 0;
      VIEW_NUMBER2 = 0;
      VIEW_NUMBER3 = 0;
    end
  end

  --       ---------------------
  -- MK CQ[14357] --->
  --      
  if (:RENUM_SLAVE_AS_MAIN <> 0) then
  begin
    if ((ATYPE = 17) or (ATYPE = 18))  then
    begin
      VIEW_NUMBER1 = VIEW_NUMBER1 + 1;
      VIEW_NUMBER2 = 0;
      VIEW_NUMBER3 = 0;
    end
    else if (ATYPE = 19) then
    begin
      VIEW_NUMBER3 = VIEW_NUMBER3 + 1;
    end
  end

  --      
  else
  begin
  -- MK CQ[14357] <---

    if (ATYPE = 17) then
    begin
      VIEW_NUMBER1 = VIEW_NUMBER1 + 1;
      VIEW_NUMBER2 = 0;
      VIEW_NUMBER3 = 0;
    end
    else if (ATYPE = 18) then
    begin
      VIEW_NUMBER2 = VIEW_NUMBER2 + 1;
      VIEW_NUMBER3 = 0;
    end
    else if (ATYPE = 19) then
    begin
      VIEW_NUMBER3 = VIEW_NUMBER3 + 1;
    end

  end -- MK CQ[14357]


  suspend;
end
^

--[15004]
create or alter procedure M_RENUM_BEFORE_INSERT (
    IDHIER integer,
    SMETATYPE integer,
    ATYPE integer,
    NEWNUMBER1 integer,
    NEWNUMBER2 integer,
    NEWNUMBER3 integer,
    RENUM_SLAVE_AS_MAIN integer)
AS
declare variable VN_VIEW_NUM1 integer;
declare variable VN_VIEW_NUM2 integer;
declare variable VN_VIEW_NUM3 integer;

declare variable VN_CURR_ID integer;
declare variable VN_NEED_RENUM integer;
-- MK CQ[14357] --->
declare variable VN_OFFSET integer;
declare variable VN_RANGE integer;
-- MK CQ[14357] <---
begin
  ------------------------------------------------------------------------------
  --      .
  --  A_S_RENUM_BEFORE_INSERT   A_SMETA_VIEW_NUM
  -- RENUM_SLAVE_AS_MAIN -      CQ[14357]
  -- : 0  -  
  --           >0 -  ,   ,   
  --                 (. M_INCLUDE_EXCLUDE_RENUM)
  --
  --     
  ------------------------------------------------------------------------------

  -- MK CQ[14357] --->
  VN_RANGE = 0;
  if (:RENUM_SLAVE_AS_MAIN <> 0) then
    VN_RANGE = RENUM_SLAVE_AS_MAIN - 1;

  VN_OFFSET = VN_RANGE + 1;
  -- MK CQ[14357] <---

  VN_NEED_RENUM = 0;

  for select v.id, v.number1, v.number2, coalesce(v.number3, 0)
  from a_smeta s
  left join a_smeta_view_num v on s.id = v.id
  where (s.idhier = :IDHIER) and (s.smetatype = :SMETATYPE)
  order by s.idhier, s.smetatype, s.number1, s.number2, s.number3 --[15004]
  --[15004]order by s.number1, s.number2, s.number3
  into :VN_CURR_ID, :VN_VIEW_NUM1, :VN_VIEW_NUM2, :VN_VIEW_NUM3 do
  begin
    --         -  
    -- MK CQ[14357] --->
    --        
    --    (. M_INCLUDE_EXCLUDE_RENUM)
    if ((VN_VIEW_NUM1 >= NEWNUMBER1) and (VN_VIEW_NUM1 <= NEWNUMBER1 + VN_RANGE) and
        (VN_VIEW_NUM2 = NEWNUMBER2) and (VN_VIEW_NUM3 = NEWNUMBER3)) then
    --if ((VN_VIEW_NUM1 = NEWNUMBER1) and (VN_VIEW_NUM2 = NEWNUMBER2) and (VN_VIEW_NUM3 = NEWNUMBER3)) then
    -- MK CQ[14357] <---
      VN_NEED_RENUM = 1;

    --    
    if (VN_NEED_RENUM = 1) then
    begin
      --   
      -- MK CQ[14357] --->
      --  (    .    )
      if ((ATYPE = 17) or
         ((:RENUM_SLAVE_AS_MAIN <> 0) and (ATYPE = 18))) then
      --if (ATYPE = 17) then
      -- MK CQ[14357] <---
      begin
        --  NUMBER1    
        if (VN_VIEW_NUM1 is not null) then
        begin
          update a_smeta_view_num
          -- MK CQ[14357] --->
          set NUMBER1 = :VN_VIEW_NUM1 + :VN_OFFSET
          --set NUMBER1 = :VN_VIEW_NUM1 + 1
          -- MK CQ[14357] <---
          where ID = :VN_CURR_ID;
        end
      end
      --   
      else if (ATYPE = 18) then
      begin
        --  NUMBER2
        if (VN_VIEW_NUM2 is not null) then
        begin
          update a_smeta_view_num
          set NUMBER2 = :VN_VIEW_NUM2 + 1

          -- MK CQ[14287] --->
          where (ID = :VN_CURR_ID) and (number1 = :NEWNUMBER1);
          --where ID = :VN_CURR_ID;
          -- MK CQ[14287] <---
        end

        --          
        if (VN_VIEW_NUM1 <> NEWNUMBER1) then
          VN_NEED_RENUM = 0;
      end
      --  
      else if (ATYPE = 19) then
      begin
        --  NUMBER3
        if (VN_VIEW_NUM3 is not null) then
        begin
          update a_smeta_view_num
          set NUMBER3 = :VN_VIEW_NUM3 + 1

          -- MK CQ[14287] --->
          where (ID = :VN_CURR_ID) and (number1 = :NEWNUMBER1) and (number2 = :NEWNUMBER2);
          --where ID = :VN_CURR_ID;
          -- MK CQ[14287] <---
        end

        --  ()        
        if ((VN_VIEW_NUM1 <> NEWNUMBER1) or (VN_VIEW_NUM2 <> NEWNUMBER2)) then
          VN_NEED_RENUM = 0;
      end
    end
  end
end
^

-- CQ[15050]
-- 
create or alter procedure L_KC6_SELECT_KOLL_RA (
    ID integer,
    ID_AKT integer,
    STOIMMODE integer,
    NRSP double precision,
    ID_USER integer,
    ID_CENLVL integer)
returns (
    RA double precision,
    KOLL double precision,
    CLCMODE integer)
AS
begin
  suspend;
end^

-- CQ[15050]
create or alter procedure L_KC6_SELECT_ITOGI_BY_ACTS (
    ID_OBJ integer,
    IN_SMETATYPE integer,
    ID_USER integer,
    LYEAR integer,
    USE_ONLY_UTV_PROCENT integer,
    SENDER integer,
    STOIMMODE integer,
    ID_AKT1 integer,
    ID_AKT2 integer,
    ID_AKT3 integer,
    ID_AKT4 integer,
    ID_AKT5 integer,
    ID_AKT6 integer,
    ID_AKT7 integer,
    ID_AKT8 integer,
    ID_AKT9 integer,
    ID_AKT10 integer,
    ID_AKT11 integer,
    ID_AKT12 integer,
    ID_AKT13 integer,
    ID_AKT14 integer,
    ID_AKT15 integer,
    ID_AKT16 integer,
    ID_AKT17 integer,
    ID_AKT18 integer,
    ID_AKT19 integer,
    ID_AKT20 integer,
    ID_CENLVL integer,
    ID_PS_CENLVL integer)
returns (
    SUM_RA_1 double precision,
    SUM_RA_2 double precision,
    SUM_RA_3 double precision,
    SUM_RA_4 double precision,
    SUM_RA_5 double precision,
    SUM_RA_6 double precision,
    SUM_RA_7 double precision,
    SUM_RA_8 double precision,
    SUM_RA_9 double precision,
    SUM_RA_10 double precision,
    SUM_RA_11 double precision,
    SUM_RA_12 double precision,
    SUM_RA_13 double precision,
    SUM_RA_14 double precision,
    SUM_RA_15 double precision,
    SUM_RA_16 double precision,
    SUM_RA_17 double precision,
    SUM_RA_18 double precision,
    SUM_RA_19 double precision,
    SUM_RA_20 double precision)
AS
declare variable id integer;
declare variable atype integer;
declare variable ra double precision;
declare variable KOLL double precision; --[15050]
declare variable CLCMODE integer;       --[15050]
declare variable nrsp_1 double precision;
declare variable nrsp_2 double precision;
declare variable nrsp_3 double precision;
declare variable nrsp_4 double precision;
declare variable nrsp_5 double precision;
declare variable nrsp_6 double precision;
declare variable nrsp_7 double precision;
declare variable nrsp_8 double precision;
declare variable nrsp_9 double precision;
declare variable nrsp_10 double precision;
declare variable nrsp_11 double precision;
declare variable nrsp_12 double precision;
declare variable nrsp_13 double precision;
declare variable nrsp_14 double precision;
declare variable nrsp_15 double precision;
declare variable nrsp_16 double precision;
declare variable nrsp_17 double precision;
declare variable nrsp_18 double precision;
declare variable nrsp_19 double precision;
declare variable nrsp_20 double precision;
begin
   SUM_RA_1   = 0;
   SUM_RA_2   = 0;
   SUM_RA_3   = 0;
   SUM_RA_4   = 0;
   SUM_RA_5   = 0;
   SUM_RA_6   = 0;
   SUM_RA_7   = 0;
   SUM_RA_8   = 0;
   SUM_RA_9   = 0;
   SUM_RA_10   = 0;
   SUM_RA_11   = 0;
   SUM_RA_12   = 0;
   SUM_RA_13   = 0;
   SUM_RA_14   = 0;
   SUM_RA_15   = 0;
   SUM_RA_16   = 0;
   SUM_RA_17   = 0;
   SUM_RA_18   = 0;
   SUM_RA_19   = 0;
   SUM_RA_20   = 0;


   if ( stoimmode = 1 ) then
   begin
      if ( ( not id_akt1 is null ) and ( id_akt1 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt1) into nrsp_1;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt1 into nrsp_1;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt2 is null ) and ( id_akt2 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt2) into nrsp_2;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt2 into nrsp_2;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt3 is null ) and ( id_akt3 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt3) into nrsp_3;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt3 into nrsp_3;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt4 is null ) and ( id_akt4 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt4) into nrsp_4;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt4 into nrsp_4;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt5 is null ) and ( id_akt5 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt5) into nrsp_5;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt5 into nrsp_5;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt6 is null ) and ( id_akt6 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt6) into nrsp_6;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt6 into nrsp_6;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt7 is null ) and ( id_akt7 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt7) into nrsp_7;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt7 into nrsp_7;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt8 is null ) and ( id_akt8 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt8) into nrsp_8;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt8 into nrsp_8;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt9 is null ) and ( id_akt9 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt9) into nrsp_9;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt9 into nrsp_9;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt10 is null ) and ( id_akt10 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt10) into nrsp_10;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt10 into nrsp_10;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt11 is null ) and ( id_akt11 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt11) into nrsp_11;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt11 into nrsp_11;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt12 is null ) and ( id_akt12 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt12) into nrsp_12;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt12 into nrsp_12;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt13 is null ) and ( id_akt13 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt13) into nrsp_13;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt13 into nrsp_13;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt14 is null ) and ( id_akt14 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt14) into nrsp_14;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt14 into nrsp_14;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt15 is null ) and ( id_akt15 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt15) into nrsp_15;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt15 into nrsp_15;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt16 is null ) and ( id_akt16 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt16) into nrsp_16;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt16 into nrsp_16;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt17 is null ) and ( id_akt17 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt17) into nrsp_17;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt17 into nrsp_17;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt18 is null ) and ( id_akt18 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt18) into nrsp_18;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt18 into nrsp_18;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt19 is null ) and ( id_akt19 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt19) into nrsp_19;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt19 into nrsp_19;
         -- MK 15.05.2012 CQ[9744] <---
      if ( ( not id_akt20 is null ) and ( id_akt20 <> 0 ) ) then
         -- MK 15.05.2012 CQ[9744] --->
         select nr_ot_zpm + sp_ot_zpm from level_cost where (id = :ID_CENLVL) and (idobject = :id_akt20) into nrsp_20;
         --select nr_ot_zpm + sp_ot_zpm from a_o_factparams where number = :id_akt20 into nrsp_20;
         -- MK 15.05.2012 CQ[9744] <---
   end

   for select id , atype
       from l_pr_create_kc6_1(:id_obj, :in_smetatype, :id_user, :lyear, :use_only_utv_procent,
                              :sender, :stoimmode, 17, 31, 0, 0,
                              :ID_CENLVL,  -- MK 15.05.2012 CQ[9744]
                              :ID_PS_CENLVL) --CQ[10944]
       into id , atype
   do
   begin
      if ( ( not id is null ) and ( atype in ( 17 , 18 ) ) ) then
      begin
         if ( ( not id_akt1 is null ) and ( id_akt1 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt1, :stoimmode, :nrsp_1, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_1   = SUM_RA_1 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt2 is null ) and ( id_akt2 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt2, :stoimmode, :nrsp_2, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_2   = SUM_RA_2 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt3 is null ) and ( id_akt3 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt3, :stoimmode, :nrsp_3, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_3   = SUM_RA_3 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt4 is null ) and ( id_akt4 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt4, :stoimmode, :nrsp_4, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_4   = SUM_RA_4 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt5 is null ) and ( id_akt5 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt5, :stoimmode, :nrsp_5, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_5   = SUM_RA_5 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt6 is null ) and ( id_akt6 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt6, :stoimmode, :nrsp_6, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_6   = SUM_RA_6 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt7 is null ) and ( id_akt7 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt7, :stoimmode, :nrsp_7, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_7   = SUM_RA_7 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt8 is null ) and ( id_akt8 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt8, :stoimmode, :nrsp_8, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_8   = SUM_RA_8 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt9 is null ) and ( id_akt9 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt9, :stoimmode, :nrsp_9, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_9   = SUM_RA_9 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt10 is null ) and ( id_akt10 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt10, :stoimmode, :nrsp_10, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_10   = SUM_RA_10 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt11 is null ) and ( id_akt11 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt11, :stoimmode, :nrsp_11, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_11   = SUM_RA_11 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt12 is null ) and ( id_akt12 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt12, :stoimmode, :nrsp_12, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_12   = SUM_RA_12 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt13 is null ) and ( id_akt13 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt13, :stoimmode, :nrsp_13, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_13   = SUM_RA_13 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt14 is null ) and ( id_akt14 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt14, :stoimmode, :nrsp_14 , :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_14   = SUM_RA_14 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt15 is null ) and ( id_akt15 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt15, :stoimmode, :nrsp_15, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_15   = SUM_RA_15 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt16 is null ) and ( id_akt16 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt16, :stoimmode, :nrsp_16, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_16   = SUM_RA_16 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt17 is null ) and ( id_akt17 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt17, :stoimmode, :nrsp_17, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_17   = SUM_RA_17 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt18 is null ) and ( id_akt18 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt18, :stoimmode, :nrsp_18, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_18   = SUM_RA_18 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt19 is null ) and ( id_akt19 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt19, :stoimmode, :nrsp_19, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_19   = SUM_RA_19 + LROUNDN(ra, 2);
         end
         if ( ( not id_akt20 is null ) and ( id_akt20 <> 0 ) ) then
         begin
            execute procedure l_kc6_select_koll_ra (:id, :id_akt20, :stoimmode, :nrsp_20, :id_user, :ID_CENLVL)
            returning_values ( :ra, :koll, :clcmode ); --[15050] -   koll  clcmode
            SUM_RA_20   = SUM_RA_20 + LROUNDN(ra, 2);
         end
      end
   end

   suspend;
end^

-- CQ[15050]
/*create or alter procedure L_PR_CREATE_KC6_1 (
   
*/

--[15050]
create or alter procedure L_PR_CREATE_KC6 (
    ID_OBJ integer,
    IN_SMETATYPE integer,
    ID_USER integer,
    LYEAR integer,
    USE_ONLY_UTV_PROCENT integer,
    SENDER integer,
    STOIMMODE integer,
    ID_CENLVL integer,
    ID_PS_CENLVL integer)
returns (
    ID_SELF integer,
    ID integer,
    IDHIER integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE integer,
    BMP integer,
    NPP varchar(21),
    TAB varchar(42),
    NAME blob sub_type 0 segment size 80,
    EDIZM varchar(250),
    KOLL double precision,
    RA double precision,
    RA_NET double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    PA double precision,
    PB double precision,
    KOLL_PRIOR double precision,
    RA_PRIOR double precision,
    KOLL_YEAR double precision,
    RA_YEAR double precision,
    KOLL_OST double precision,
    RA_OST double precision,
    IDSRES integer,
    IDNORMO integer,
    SMETAPARENT integer,
    RABMAT integer,
    TYPE_TRUD integer,
    ID_EDIZM integer,
    TIPRAB integer,
    TAB_LONG blob sub_type 1 segment size 80,
    CLCMODE integer)
AS
--declare variable key2 integer;
--declare variable id_name integer;
--declare variable id_edizm integer;   --CQ[TIMUR 7475]
--declare variable edizm_type integer;
--declare variable smetatype integer;
--declare variable cur_shifr varchar(60);
--declare variable fullname varchar(255);
--declare variable number integer;
--declare variable nomerrod integer;
--declare variable koll_loc double precision;
--declare variable ra_loc double precision;
--declare variable id1 integer;
--declare variable pr_number1 integer;
--declare variable pr_number2 integer;
--declare variable pr_number3 integer;
--declare variable pr_vsego double precision;
--declare variable pr_exists_childs integer;
--declare variable lyear1 integer;
--declare variable lmonth integer;
--declare variable lyear2 integer;
--declare variable lmonth2 integer;
--declare variable checknode integer;
--declare variable koll_ra double precision;
--declare variable rd double precision;
--declare variable rj double precision;
--declare variable rk double precision;
--declare variable pa double precision;
--declare variable pb double precision;
--declare variable rd_loc double precision;
--declare variable rj_loc double precision;
--declare variable rk_loc double precision;
--declare variable pa_loc double precision;
--declare variable pb_loc double precision;
begin

  for select ID_SELF, ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT,
             ATYPE, BMP, NPP, TAB, NAME, EDIZM, KOLL,
             RA, RA_NET, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, PA, PB,
             KOLL_PRIOR, RA_PRIOR, KOLL_YEAR, RA_YEAR,
             KOLL_OST, RA_OST, IDSRES, IDNORMO, SMETAPARENT,
             RABMAT, TYPE_TRUD, ID_EDIZM, TIPRAB,
             TAB_LONG, /*Voyager CQ[13929,14786]*/ CLCMODE /*[15050]*/
     from L_PR_CREATE_KC6_1(:ID_OBJ, :IN_SMETATYPE, :ID_USER, :LYEAR, :USE_ONLY_UTV_PROCENT,
                            :SENDER, :STOIMMODE, 17, 15, 1, 1,
                            :ID_CENLVL,  -- MK 15.05.2012 CQ[9744]
                            :ID_PS_CENLVL) --CQ[10944]
  into ID_SELF, ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT,
       ATYPE, BMP, NPP, TAB, NAME, EDIZM, KOLL,
       RA, RA_NET, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, PA, PB,
       KOLL_PRIOR, RA_PRIOR, KOLL_YEAR, RA_YEAR,
       KOLL_OST, RA_OST, IDSRES, IDNORMO, SMETAPARENT,
       RABMAT, TYPE_TRUD, ID_EDIZM, :TIPRAB,
       TAB_LONG, /* Voyager CQ[13929,14786]*/ CLCMODE /*[15050]*/
  do
    suspend;

 exit;


---------------------------- OLD CODE ------------------------->
--------------------------------------------------------------->

--   KEY2 = GEN_ID ( LG_S_TMP_TBL_KEY2 , 1 );
--
--/*
--   LYEAR1 = LYEAR - 1;
--   LMONTH = 12;
--   if ( LYEAR = 0 ) then
--   begin
--      LYEAR1 = 0;
--      LMONTH = 0;
--   end
--*/
--
--   LYEAR1 = 0;
--   LMONTH = 0;
--   if ( LYEAR = 0 ) then
--   begin
--      LYEAR2 = 0;
--      LMONTH2 = 0;
--   end
--   else
--   begin
--      LYEAR2 = LYEAR - 1;
--      LMONTH2 = 13;
--   end
--
--   if ( ( StoimMode is null ) or ( not StoimMode in ( 0,1,2 ) ) ) then
--      StoimMode = 0;
--
--   checknode = 0;
--
--   PA = 0;
--   PB = 0;
--   select first 1 a.nr_ot_zpm, a.sp_ot_zpm from a_o_objectparams a where number = :ID_OBJ into :pa, :pb;
--
--   for select ID_SELF, ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT
--       from L_PR_CREATE_KC6_BASE ( :ID_OBJ, :KEY2, :IN_SMETATYPE, :LYEAR1 , :LMONTH, :ID_USER, :SENDER, 0 )
--       into   ID_SELF, ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT
--   do
--      if ( ID_SELF is null ) then /* struct. str.  */
--      begin
--         ATYPE = SLAVEPARENT;
--         SLAVEPARENT = 0;
--
--         EXECUTE PROCEDURE a_h_GetName :IDHIER, :ATYPE RETURNING_VALUES :cur_shifr, :fullname;
--         if ( fullname is null ) then
--            fullname = '';
--         name = copyvarchartoblob(fullname);
--         NPP = null; TAB = null; EDIZM = null; KOLL = null; KOLL_RA = null; RA = null; KOLL_PRIOR = null; RA_PRIOR = null;
--
--       if ( not ATYPE in ( 26,27,28 ) ) then
--       begin
--
--         checknode = null;
--         select hch.id
--         from A_O_HIERCHECKING hch
--         where (hch.iduser = :id_user) and
--               (hch.idobject = :id_obj) and
--               (hch.smetatype = 17) and
--               (hch.atype = 15) and
--               (hch.idelem = :IDHIER)
--         INTO :checknode;
--
--         if ( checknode is null ) then
--            ATYPE = -ATYPE;
--
--       end
--
--         BMP = ATYPE;
--         suspend;
--
--      end
--      else if ( not checknode is null ) then /* smetn. str. in visible structure */
--      begin
--         for select ATYPE, TAB, NAME_ID, id_edizm, edizm_type, KOLL, RA, RD, RJ, RK, SMETATYPE, NOMERROD, RABMAT
--             from a_smeta where id = :id
--             into   ATYPE, TAB, ID_NAME, id_edizm, edizm_type, KOLL, RA, RD, RJ, RK, SMETATYPE, NOMERROD, BMP
--         do
--         begin
--             if ( ATYPE = 18 ) then
--                BMP = BMP + 100;
--             else if ( ATYPE = 19 ) then
--                BMP = 19;
--             else
--                BMP = 0;
--             execute procedure b_getname ( :ID_USER, :ID_NAME ) RETURNING_VALUES ( :NAME );
--             execute procedure a_get_edizm( :id_user, :id_edizm, :edizm_type ) returning_values ( :edizm );
--
--             execute procedure l_pr_kc6_calc_ra ( :StoimMode , :ra , :rd , :rj , :rk , :pa , :pb ) returning_values ( :ra );
--
--             if ( koll is null ) then
--                koll = 0;
--             KOLL_RA = koll;
--             if ( not SMETATYPE in ( 15 , 16 ) ) then
--             begin
--                KOLL = 0;
--                for select first 1 pr_vsego from l_s_pr_addinfo where id = :id into koll
--                do
--                begin
--                   if ( koll is null ) then
--                      koll = 0.0;
--                   if ( not RA is null ) then
--                      if ( ( not KOLL_RA is null ) and ( KOLL_RA <> 0.0 ) ) then
--                         RA = RA * KOLL / KOLL_RA;
--                end
--             end
--
--             NPP = '';
--             if ( atype = 17 ) then
--                NPP = cast (NUMBER1 as varchar(10) );
--             else if ( atype = 18 ) then
--                NPP = cast (NUMBER1 as varchar(10) ) || '.' || cast (NUMBER2 as varchar(10) );
--
--             KOLL_PRIOR = 0.0;
--             RA_PRIOR   = 0.0;
--             if ( ATYPE in ( 17, 18 ) ) then
--             begin
--                for select NUMBER from A_O_HIER_SELECT_PR1 ( :ID_USER, :ID_OBJ, :LYEAR2 , :LMONTH2, :USE_ONLY_UTV_PROCENT , 0 )
--                    into   NUMBER
--                do
--                begin
--                   PA_LOC = 0;
--                   PB_LOC = 0;
----                   select first 1 a.nr_ot_zpm, a.sp_ot_zpm from a_o_factparams a where number = :ID_OBJ into :pa_LOC, :pb_LOC;
--                   if ( NUMBER = ID_OBJ ) then
--                      select first 1 a.nr_ot_zpm, a.sp_ot_zpm from a_o_objectparams a where number = :NUMBER into :pa_LOC, :pb_LOC;
--                   else
--                      select first 1 a.nr_ot_zpm, a.sp_ot_zpm from a_o_factparams a where number = :NUMBER into :pa_LOC, :pb_LOC;
--                   for select KOLL , RA , ID , RD , RJ , RK
--                       from A_SMETA
--                       where  ( NOMERROD1 = :ID ) and ( SMETATYPE = :NUMBER )
--                       into   KOLL_LOC , RA_LOC , ID1 , RD_LOC , RJ_LOC , RK_LOC
--                   do
--                   begin
--/*
--                      KOLL_LOC = null;
--                      execute procedure l_pr_select_rec ( :id1, :id_user, :ID_OBJ, :lyear1, :Lmonth, :USE_ONLY_UTV_PROCENT )
--                          RETURNING_VALUES ( :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, :PR_VSEGO, :KOLL_LOC, :PR_EXISTS_CHILDS );
--*/
--                      if ( not KOLL_LOC is null ) then
--                         KOLL_PRIOR = KOLL_PRIOR + KOLL_LOC;
--                      execute procedure l_pr_kc6_calc_ra ( :StoimMode , :ra_LOC , :rd_LOC , :rj_LOC , :rk_LOC , :pa_LOC , :pb_LOC ) returning_values ( :ra_LOC );
--                      if ( not RA_LOC is null ) then
--                         RA_PRIOR = RA_PRIOR + RA_LOC;
--                   end
--                end
--             end
--             KOLL_YEAR = 0.0;
--             RA_YEAR   = 0.0;
--             KOLL_OST  = 0.0;
--             RA_OST    = 0.0;
--
--/*
--             if ( ATYPE in ( 18, 19 ) ) then
--             begin
--             end
--*/
--             suspend;
--         end
--      end
--   execute procedure l_pr_create_kc6_base_finalize ( :key2 );
end^

-- Voyager CQ[14547] ( )
-- 
create or alter procedure IMP_SM_RESOURCE_FROM_XML (
    ID_USER             integer,
    ID_SOURCE           integer,
    IDHIER              integer,
    SMETATYPE           integer,
    RABMAT              integer,
    TAB                 varchar(42),
    ALTTAB              varchar(250),
    EDIZM_NAME          varchar(100),
    EDIZM_FULLNAME      varchar(250),
    EDIZM_RELATION      double precision,
    NAME                blob sub_type 0 segment size 80,
    NORM_GUID           varchar(100),
    NORM_PODGROUP       integer,
    KODIR_GROUP_NAME    varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ISGROUPOKP          integer,
    RASHOD              double precision,
    RASHOD_BASE         double precision,
    CORRECT             varchar(50),
    VIDNR               integer,
    UCH                 integer,
    STATUS_EDIT         integer,
    STATUS_DOB_V_ZENU   integer,
    STATUS_REC_CEN      integer,
    TYPE_TRUD           integer,
    NOTE                varchar(255),
    REC_ADD_MODE        integer,
    CLCMODE             integer,
    IDNORMATIV          integer,
    BB                  double precision,
    BC                  double precision,
    BD                  double precision,
    BE                  double precision)
returns (
    ID        integer,
    NEW_ID_PS integer)
AS
begin
  suspend;
end
^

create or alter procedure IMP_ET_RESOURCE_FROM_XML (
    ID_USER             integer,
    ID_SOURCE           integer,
    IDHIER              integer,
    SMETATYPE           integer,
    RABMAT              integer,
    TAB                 varchar(42),
    ALTTAB              varchar(250),
    EDIZM_NAME          varchar(100),
    EDIZM_FULLNAME      varchar(250),
    EDIZM_RELATION      double precision,
    NAME                blob sub_type 0 segment size 80,
    NORM_GUID           varchar(100),
    NORM_PODGROUP       integer,
    KODIR_GROUP_NAME    varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ISGROUPOKP          integer,
    RASHOD              double precision,
    VIDNR               integer,
    UCH                 integer,
    TYPE_TRUD           integer,
    REC_ADD_MODE        integer,
    IDNORMATIV          integer,
    BB                  double precision,
    BC                  double precision,
    BD                  double precision,
    BE                  double precision)
returns (
    NEW_ID integer)
AS
declare variable I integer;
declare variable ID_NAME integer;
declare variable KODIR_GROUP integer;
declare variable KODIR_PODGROUP integer;
declare variable ID_EDIZM integer;
--declare variable ID_GROUP_EDIZM integer;
-- declare variable IDNORMATIV integer;
declare variable s_orderview integer;
declare variable s_nomerrod integer;
declare variable vn_smetatype integer;
declare variable vn_id_source integer;
declare variable NEW_ID_PS integer;
declare variable ID_OBJ integer;
begin
  -- ===========================================================================
  --         / 
  -- ===========================================================================


  NEW_ID = gen_id( a_g_smeta, 1); --   
  --  
  execute procedure a_h_get_id_parentatype (:idhier, 1) returning_values (:id_obj);


  --    ----------------------------------------------
  if (:EDIZM_RELATION is null) then EDIZM_RELATION = 1;
  if (:ISGROUPOKP is null) then ISGROUPOKP = 0;


   --    blob -----------------------------------------------------
   I = gen_id( B_GEN_TEMP, 1 );
   insert into B_TEMP_BLOB(ID, BLOB1) values (:I, :NAME);
   select BLOB1 from B_TEMP_BLOB where ID = :I into :NAME;
   delete from B_TEMP_BLOB where ID = :I;

  --     -------------------------------
  select first 1 n.IDNAME
  from B_WRITE_NAIMENOVANIE (:ID_USER, -1, 0, :NAME) n
  into :ID_NAME;

  --  KODIR_GROUP, KODIR_PODGROUP -----------------------------------------
  -- MK   CQ[12802] --->
  execute procedure M_FIND_KODIRS_ID_FOR_IMP_EXT (:id_obj, :SMETATYPE, :KODIR_GROUP_NAME,
                                                  :KODIR_PODGROUP_NAME)
  returning_values (:KODIR_GROUP, :KODIR_PODGROUP);

  --execute procedure M_FIND_KODIRS_ID_FOR_IMP (:SMETATYPE, :KODIR_GROUP_NAME,
  --                                            :KODIR_PODGROUP_NAME)
  --returning_values (:KODIR_GROUP, :KODIR_PODGROUP);
  -- MK   CQ[12802] <---

  --  ID_EDIZM ------------------------------------------------------------
  /*ID_EDIZM = Null;
  if (COALESCE(EDIZM_NAME,'') <> '') then
  begin
      if (coalesce(EDIZM_FULLNAME, '') = '') then
          EDIZM_FULLNAME = EDIZM_NAME;

      execute procedure B_FIND_EDIZM(:ID_USER, :EDIZM_NAME, :EDIZM_FULLNAME)
      returning_values (:ID_EDIZM);
      --    -   
      if (:ID_EDIZM is null) then
      begin
        execute procedure B_GEN_DEF_EDGROUP_ID(:ID_USER)
        returning_values (:ID_GROUP_EDIZM);
        execute procedure B_ADD_EDIZM (:ID_USER, :ID_GROUP_EDIZM, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION)
        returning_values (:ID_EDIZM);
      end
  end
  */
  --:     ,    Copy Paste   
  execute procedure IMP_EDIZM (:ID_USER, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION)
  returning_values (:ID_EDIZM);


  -- <-- Voyager CQ[12939]
  IDNORMATIV = coalesce(IDNORMATIV,0);
  execute procedure L_GET_NORMATIV_FROM_GUID ( :NORM_GUID, :TAB, :IDNORMATIV,
    :KODIR_PODGROUP, :RABMAT, :ID_USER )
  returning_values ( :IDNORMATIV, :KODIR_PODGROUP, :RABMAT );

  --   IDNORMATIV ------------------------------------------------
  --      /    
  /*
  execute procedure m_find_normativ(:IDHIER, :SMETATYPE, :KODIR_PODGROUP,
                                    :RABMAT, :ID_USER, :TAB)
  returning_values (:IDNORMATIV);
  */
  -- <-- Voyager CQ[12939]


  --      : .   
  if (SMETATYPE <> 15) then
  begin
    --        .   
    if (REC_ADD_MODE = 1) then
    begin
      select s.nomerrod, s.smetatype
      from a_smeta s
      where (s.id = :id_source)
      into :vn_id_source, :vn_smetatype;

      --    
      NEW_ID_PS = gen_id( a_g_smeta, 1);
      insert into M_ETALON_S_RES (ID, ID_SOURCE, NORM_ID, NORM_PODGROUP, KODIR_GROUP,
                                  KODIR_PODGROUP, ISGROUPOKP, RABMAT, TAB, ALTTAB,
                                  NAME_ID, IDEDIZM, RASHOD,
                                  VIDNR, UCH, NORM_GUID, TYPE_TRUD,
                                  BB, BC, BD, BE -- Voyager CQ[13244]
                                  )
    
      values (:NEW_ID_PS, :vn_id_source, :IDNORMATIV, :NORM_PODGROUP, :KODIR_GROUP,
              :KODIR_PODGROUP, :ISGROUPOKP, :RABMAT, :TAB, :ALTTAB,
              :ID_NAME, :ID_EDIZM, :RASHOD,
              :VIDNR, :UCH, :NORM_GUID, :TYPE_TRUD,
              :BB, :BC, :BD, :BE -- Voyager CQ[13244]
              );

      --       
      --        
      execute procedure M_SET_RES_REC_ENTITYS(:ID_USER, :NEW_ID_PS, :IDHIER,
                                              :vn_smetatype, 1);
    end
  end


  --   ----------------------------------------------------------
  insert into M_ETALON_S_RES (ID, ID_SOURCE, NORM_ID, NORM_PODGROUP, KODIR_GROUP,
                              KODIR_PODGROUP, ISGROUPOKP, RABMAT, TAB, ALTTAB,
                              NAME_ID, IDEDIZM, RASHOD,
                              VIDNR, UCH, NORM_GUID, TYPE_TRUD,
                              BB, BC, BD, BE -- Voyager CQ[13244]
                              )

  values (:NEW_ID, :ID_SOURCE, :IDNORMATIV, :NORM_PODGROUP, :KODIR_GROUP,
          :KODIR_PODGROUP, :ISGROUPOKP, :RABMAT, :TAB, :ALTTAB,
          :ID_NAME, :ID_EDIZM, :RASHOD,
          :VIDNR, :UCH, :NORM_GUID, :TYPE_TRUD,
          :BB, :BC, :BD, :BE -- Voyager CQ[13244]
          );



  ------------------------------------------------------------------------------
  --     

  --   
  select first 1 s.NOMERROD
  from a_smeta s
  where (s.id = :id_source)
  into :S_NOMERROD;

  if ((:S_NOMERROD is null) or (:S_NOMERROD = 0)) then
    S_NOMERROD = :ID_SOURCE;

  if (not exists( select *
        from A_SMETA
        where NOMERROD1 = :S_NOMERROD
          and SMETATYPE <> :SMETATYPE )) then
    exit;


  --     
  select ORDERVIEW
    from SD_IMPACT_SELECTSTRUCT_GETFIRST(:ID_USER, :ID_SOURCE, :SMETATYPE)
    into :S_ORDERVIEW;

  if (:S_ORDERVIEW > 0) then
  begin
    for select i.SMETATYPE
    from SD_IMPACT_SELECTSTRUCT(:ID_USER, :ID_SOURCE) i
    where (i.ORDERVIEW >= :S_ORDERVIEW)
    into :vn_smetatype do
    begin
      --  , 
      if (not exists(
            select * from M_UTV_STRUCT_ELEM_IN_AKT
              where ID_STRUCT = :IDHIER and ID_AKT = :vn_smetatype)) then
      begin
        for select ID
        from A_SMETA
        where (NOMERROD1 = :S_NOMERROD) and (SMETATYPE = :vn_smetatype)
        into :vn_id_source do
        begin
          I = gen_id(a_g_smeta, 1);

          insert into M_ETALON_S_RES (ID, ID_SOURCE, NORM_ID, NORM_PODGROUP, KODIR_GROUP,
                                      KODIR_PODGROUP, ISGROUPOKP, RABMAT, TAB, ALTTAB,
                                      NAME_ID, IDEDIZM, RASHOD,
                                      VIDNR, UCH, NORM_GUID, TYPE_TRUD,
                                      BB, BC, BD, BE -- Voyager CQ[13244]
                                      )

          values (:I, :vn_id_source, :IDNORMATIV, :NORM_PODGROUP, :KODIR_GROUP,
                  :KODIR_PODGROUP, :ISGROUPOKP, :RABMAT, :TAB, :ALTTAB,
                  :ID_NAME, :ID_EDIZM, :RASHOD,
                  :VIDNR, :UCH, :NORM_GUID, :TYPE_TRUD,
                  :BB, :BC, :BD, :BE -- Voyager CQ[13244]
                  );

          --       
          --        
          execute procedure M_SET_RES_REC_ENTITYS(:ID_USER, :I, :IDHIER,
                                                  :vn_smetatype, 1);
        end
      end
    end
  end



  suspend;
end
^

create or alter procedure PASTE_RESOURCE_RECORD (
    ID_USER             integer,
    ID_SOURCE           integer,
    IDHIER              integer,
    SMETATYPE           integer,
    RABMAT              integer,
    TAB                 varchar(42),
    ALTTAB              varchar(250),
    EDIZM_NAME          varchar(100),
    EDIZM_FULLNAME      varchar(250),
    EDIZM_RELATION      double precision,
    NAME                blob sub_type 0 segment size 80,
    NORM_GUID           varchar(100),
    NORM_PODGROUP       integer,
    KODIR_GROUP_NAME    varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ISGROUPOKP          integer,
    RASHOD              double precision,
    RASHOD_BASE         double precision,
    CORRECT             varchar(50),
    VIDNR               integer,
    UCH                 integer,
    STATUS_EDIT         integer,
    STATUS_DOB_V_ZENU   integer,
    STATUS_REC_CEN      integer,
    TYPE_TRUD           integer,
    NOTE                varchar(255),
    REC_ADD_MODE        integer,
    BB                  double precision,
    BC                  double precision,
    BD                  double precision,
    BE                  double precision,
    PRICE_GUID          varchar(100),
    PRICE_NORMOTAB      varchar(42),
    PRICE_NORMOGUID     varchar(100),
    ROW                 integer,
    COST                double precision,
    KOEF                double precision,
    CLCMODE             integer,
    IDNORMATIV          integer)
returns (
    ID integer)
AS
declare variable PRICE_NORMOID integer;
declare variable KODIR_PODGROUP integer;
declare variable ID_PRICE integer;
declare variable NEW_ID_PS integer;

begin
  --exception A_ELEMENTNOTFOUND;

  execute procedure IMP_SM_RESOURCE_FROM_XML(:ID_USER, :ID_SOURCE, :IDHIER, :SMETATYPE, :RABMAT,
    :TAB, :ALTTAB, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION, :NAME, :NORM_GUID, :NORM_PODGROUP,
    '', '', -- MK   CQ[12802] :KODIR_GROUP_NAME, :KODIR_PODGROUP_NAME,
    :ISGROUPOKP, :RASHOD, :RASHOD_BASE, :CORRECT, :VIDNR,
    :UCH, :STATUS_EDIT, :STATUS_DOB_V_ZENU, :STATUS_REC_CEN, :TYPE_TRUD, :NOTE, :REC_ADD_MODE,
    :CLCMODE,  -- MK CQ[12378]
    :IDNORMATIV, -- CQ[13026]
    :BB, :BC, :BD,  :BE -- Voyager CQ[13244]
    )
  returning_values (:ID, :NEW_ID_PS); -- CQ[14218]  NEW_ID  ID + NEW_ID_PS

  -- <-- Voyager CQ[13244]
  --     
  /*
  update A_S_RES set
    BB = :BB,
    BC = :BC,
    BD = :BD,
    BE = :BE
    -- MK CQ[12378]   IMP_SM_RESOURCE_FROM_XML
    --CLCMODE = :CLCMODE -- CQ[12370]      / xml  update ..   IMP_SM_RESOURCE_FROM_XML
  where ID = :NEW_ID;
  */
  -- <-- Voyager CQ[13244]

  -- CQ[12590] -->
  if (PRICE_NORMOGUID is not null) then
    PRICE_NORMOGUID = '';
  -- CQ[12590] <--

  --   
  if (PRICE_NORMOGUID <> '') then -- CQ[12590]
  begin
    if (PRICE_NORMOGUID = '-1') then
    begin
      PRICE_NORMOID = -1;
    end
    else
    begin
      execute procedure L_GET_NORMATIV_FROM_GUID(:PRICE_NORMOGUID, :PRICE_NORMOTAB, 0, 0, 0, 0)
      returning_values (:PRICE_NORMOID, :KODIR_PODGROUP, :RABMAT);
    end
    ID_PRICE = null;
    if (PRICE_NORMOID = 0) then
      PRICE_NORMOID = null;
    select first 1 PRICE_ID
    from PM_PRICE_GUID
    where PRICE_GUID = :PRICE_GUID
    into :ID_PRICE;
    if ((:ID_PRICE is not null) or (:PRICE_NORMOID is not null) or (:ROW is not null)) then
      execute procedure set_smeta_priceposinfo_nl(:ID, 0, :ID_PRICE, :PRICE_NORMOID, :ROW, :COST,
        :KOEF); -- CQ[14218]  NEW_ID  ID
  end

  suspend;
end
^

create or alter procedure PASTE_ET_RESOURCE_RECORD (
    ID_USER             integer,
    ID_SOURCE           integer,
    IDHIER              integer,
    SMETATYPE           integer,
    RABMAT              integer,
    TAB                 varchar(42),
    ALTTAB              varchar(250),
    EDIZM_NAME          varchar(100),
    EDIZM_FULLNAME      varchar(250),
    EDIZM_RELATION      double precision,
    NAME                blob sub_type 0 segment size 80,
    NORM_GUID           varchar(100),
    NORM_PODGROUP       integer,
    KODIR_GROUP_NAME    varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ISGROUPOKP          integer,
    RASHOD              double precision,
    VIDNR               integer,
    UCH                 integer,
    TYPE_TRUD           integer,
    REC_ADD_MODE        integer,
    BB                  double precision,
    BC                  double precision,
    BD                  double precision,
    BE                  double precision,
    IDNORMATIV          integer)
returns (
    NEW_ID integer)
AS
begin
  execute procedure IMP_ET_RESOURCE_FROM_XML(:ID_USER, :ID_SOURCE, :IDHIER, :SMETATYPE, :RABMAT, :TAB,
    :ALTTAB, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION, :NAME, :NORM_GUID, :NORM_PODGROUP,
    '', '', -- MK   CQ[12802] :KODIR_GROUP_NAME, :KODIR_PODGROUP_NAME,
    :ISGROUPOKP, :RASHOD, :VIDNR, :UCH, :TYPE_TRUD, :REC_ADD_MODE,
    :IDNORMATIV, -- CQ[13026]
    :BB, :BC, :BD,  :BE -- Voyager CQ[13244]
    )
  returning_values (:NEW_ID);

  -- Voyager CQ[13244]
  --     
  /*
  update M_ETALON_S_RES set
    BB = :BB,
    BC = :BC,
    BD = :BD,
    BE = :BE
  where ID = :NEW_ID;
  */
  -- Voyager CQ[13244]

  suspend;
end
^

--[15135]
create or alter procedure DM_GET_POSITIONINFO (
    IDPOSITION integer,
    IDPRICE integer,
    IDNORMO integer)
returns (
    ID integer,
    ID_PARENT integer,
    ROW integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NORM_NAME blob sub_type 1 segment size 80,
    NORM_TITLE blob sub_type 1 segment size 80,
    EDIZM_ID integer,
    EDIZM_NAME varchar(100),
    KOEF double precision,
    NORMOCOST double precision,
    POS_COUNT integer,
    LINKED_COUNT integer,
    KOEFF_TRANSP_TYPE integer,
    KOEFF_TRANSP_VALUE double precision,
    KOEFF_ZAGOT_TYPE integer,
    KOEFF_ZAGOT_VALUE double precision,
    KOEFF_OBORUD_TYPE integer,
    KOEFF_OBORUD_VALUE double precision,
    KOEFF_OTHER_TYPE integer,
    KOEFF_OTHER_VALUE double precision,
    POSITIONCOST varchar(510),
    IDPOS integer,
    POSITIONNAME varchar(510))
AS
begin
  if (/*(IDNORMO is not null) and*/ (IDNORMO <> 0 ))  then
  begin
    select N.NAME, T.NAME, E.ID, E.NAME, R.TAB, r.ALTTAB
    from B_RABMAT R
    left join B_NNAME N on R.IDNAME = N.ID
    left join B_NNAME_TITLE T on N.IDTITLE = T.ID
    left join B_EDIZM E on R.IDEDIZM = E.ID
    where  R.ID = :IDNORMO
    into :NORM_NAME, :NORM_TITLE, :EDIZM_ID, :EDIZM_NAME, :TAB, :ALTTAB;

    ID = :IDNORMO;
    NORMOCOST = 0;
    select  LROUNDN(coalesce(P.NORMOCOST,0), 2)
    from PM_PRICEPOSLINKS P where  P.IDNORMO = :IDNORMO and P.IDPRICE = :IDPRICE
    into :NORMOCOST;


    select min(PP.ROW), count(*)
    from PM_PRICEPOS PP
    right join PM_PRICEPOSNORMS PPN on PPN.ID = PP.ID --[12925]
    where PPN.IDPRICE = :IDPRICE and PPN.IDNORMO = :ID
    into :ROW, :POS_COUNT;
    ID_PARENT = 0;
    KOEF = null;
    POSITIONNAME = '';
    if (POS_COUNT = 1)  then
    begin
      select first 1 P.ID, PPN.KOEF, P.KOEFF_TRANSP_TYPE, P.KOEFF_TRANSP_VALUE,
                 P.KOEFF_ZAGOT_TYPE, P.KOEFF_ZAGOT_VALUE, P.KOEFF_OBORUD_TYPE,
                 P.KOEFF_OBORUD_VALUE, P.KOEFF_OTHER_TYPE, P.KOEFF_OTHER_VALUE,
                 A.dataident
        from PM_PRICEPOS P
        right join PM_PRICEPOSNORMS PPN on PPN.ID = P.ID --[12925]
        join PM_PRICEPOSAREAS A on A.IDPOS = P.ID
        join PM_AREAS F on F.ID = A.IDAREA
        where (PPN.IDPRICE = :IDPRICE) and (PPN.IDNORMO = :ID) and ((F.areatype = 3) or (F.areatype is null) )
        into :IDPOS, :KOEF, :KOEFF_TRANSP_TYPE, :KOEFF_TRANSP_VALUE,
             :KOEFF_ZAGOT_TYPE, :KOEFF_ZAGOT_VALUE, :KOEFF_OBORUD_TYPE,
             :KOEFF_OBORUD_VALUE, :KOEFF_OTHER_TYPE, :KOEFF_OTHER_VALUE, :POSITIONCOST;
      if (POS_COUNT = 1) then execute procedure dm_getpriceposname(:IDPOS) returning_values :POSITIONNAME;  --CQ[7425]
    end
    LINKED_COUNT = POS_COUNT;
    suspend;
    if (POS_COUNT > 1) then
    begin
      POS_COUNT = null;
      LINKED_COUNT = null;
      ID_PARENT = :ID;
      for select P.ID, P.ROW, LROUNDN(PPN.NORMOCOST, 2), PPN.KOEF, P.KOEFF_TRANSP_TYPE, P.KOEFF_TRANSP_VALUE,-- CQ[7466]
                 P.KOEFF_ZAGOT_TYPE, P.KOEFF_ZAGOT_VALUE, P.KOEFF_OBORUD_TYPE,
                 P.KOEFF_OBORUD_VALUE, P.KOEFF_OTHER_TYPE, P.KOEFF_OTHER_VALUE, A.dataident
        from PM_PRICEPOS P
        right join PM_PRICEPOSNORMS PPN on PPN.ID = P.ID --[12925]
        join PM_PRICEPOSAREAS A on A.IDPOS = P.ID
        join PM_AREAS F on F.ID = A.IDAREA
        where (PPN.IDPRICE = :IDPRICE) and (PPN.IDNORMO = :ID_PARENT) and ((F.areatype = 3) or (F.areatype is null) )
        order by row
        into :IDPOS, :ROW, :NORMOCOST, :KOEF, :KOEFF_TRANSP_TYPE, :KOEFF_TRANSP_VALUE,
             :KOEFF_ZAGOT_TYPE, :KOEFF_ZAGOT_VALUE, :KOEFF_OBORUD_TYPE,
             :KOEFF_OBORUD_VALUE, :KOEFF_OTHER_TYPE, :KOEFF_OTHER_VALUE ,:POSITIONCOST
      do
      begin
        execute procedure dm_getpriceposname(:IDPOS) returning_values :POSITIONNAME;  --CQ[7425]
        suspend;
      end
    end
  end
  else
  begin
    ID_PARENT = 0;
    ID = -1;

    -- MK CQ[15135] --->
    for select first 1 P.ID, P.ROW, null, null, P.KOEFF_TRANSP_TYPE, P.KOEFF_TRANSP_VALUE,-- CQ[7466]
                   P.KOEFF_ZAGOT_TYPE, P.KOEFF_ZAGOT_VALUE, P.KOEFF_OBORUD_TYPE,
                   P.KOEFF_OBORUD_VALUE, P.KOEFF_OTHER_TYPE, P.KOEFF_OTHER_VALUE, A.dataident
    from PM_PRICEPOS P
    left outer join PM_PRICEPOSAREAS A on A.IDPOS = P.ID
    left outer join PM_AREAS F on F.ID = A.IDAREA
    where P.id =:IDPOSITION and ((F.areatype = 3) or (F.areatype is null) )

    --for select first 1 P.ID, P.ROW, LROUNDN(PPN.NORMOCOST, 2), PPN.KOEF, P.KOEFF_TRANSP_TYPE, P.KOEFF_TRANSP_VALUE,-- CQ[7466]
    --               P.KOEFF_ZAGOT_TYPE, P.KOEFF_ZAGOT_VALUE, P.KOEFF_OBORUD_TYPE,
    --               P.KOEFF_OBORUD_VALUE, P.KOEFF_OTHER_TYPE, P.KOEFF_OTHER_VALUE,A.dataident
    --from PM_PRICEPOS P
    --right join PM_PRICEPOSNORMS PPN on PPN.ID = P.ID --[12925]
    --left outer join PM_PRICEPOSAREAS A on A.IDPOS = P.ID
    --left outer join PM_AREAS F on F.ID = A.IDAREA
    --where PPN.id =:IDPOSITION and ((F.areatype = 3) or (F.areatype is null) )
    -- MK CQ[15135] <---

    into :IDPOS, :ROW, :NORMOCOST,  :KOEF, :KOEFF_TRANSP_TYPE, :KOEFF_TRANSP_VALUE,
         :KOEFF_ZAGOT_TYPE, :KOEFF_ZAGOT_VALUE, :KOEFF_OBORUD_TYPE,
         :KOEFF_OBORUD_VALUE, :KOEFF_OTHER_TYPE, :KOEFF_OTHER_VALUE, :POSITIONCOST
    do
    begin
      if (NORMOCOST is null) then  NORMOCOST = 0;
      execute procedure dm_getpriceposname(:IDPOS) returning_values :POSITIONNAME;  --CQ[7425]
      suspend;
    end
  end
end
^
/* CQ[15067] >> */
create or alter procedure LEVEL_RULES_STRUCT_EXP_XML (
    iID integer)
returns (
    ID integer,
    ID_RULES integer,
    ID_STRUCT integer,
    GUID varchar(100))
as
declare variable ATYPE integer;
begin
  /* CQ[15067] >> */
  for select ID, ID_RULES, ID_STRUCT
    from level_rules_struct
    where ID = :iID
    into :ID, :ID_RULES, :ID_STRUCT
  do
  begin
    for select ATYPE
      from A_O_HIER
      where NUMBER = :ID_STRUCT
      into :ATYPE
    do
    begin
      GUID = null;
      if (:ATYPE = 0) -- FolderType
      then
        select GUID
        from a_o_FolderParams
        where number = :ID_STRUCT
        into :GUID;
      else
      if (atype = 3) -- LSType
      then
        select GUID
        from A_O_PARAMS_LS
        where id = :ID_STRUCT
        into :GUID;
      else
      if (atype in (4, 5)) -- RType PRType
      then
        select GUID
        from A_O_PARAMS_R_PR
        where id = :ID_STRUCT
        into :GUID;

      if (coalesce(:GUID, '') = '') then
      begin
        GUID = COCREATEGUID();
        if (:ATYPE = 0) -- FolderType
        then
          update a_o_FolderParams set
            GUID = :GUID
          where number = :ID_STRUCT;
        else
        if (atype = 3) -- LSType
        then
          update A_O_PARAMS_LS set
            GUID = :GUID
          where id = :ID_STRUCT;
        else
        if (atype in (4, 5)) -- RType PRType
        then
          update A_O_PARAMS_R_PR set
            GUID = :GUID
          where id = :ID_STRUCT;
      end
    end
    suspend;
  end
end
^

--[15140]
create or alter procedure A_CLC_PREPARE_B_E_M__NL (
    ID integer,
    ID_CENLVL integer,
    ATYPE integer,
    ID_S_RES integer,
    IDGROUP integer,
    IDPODGROUP integer,
    ISCLC integer,
    MODE_KOMPNS_ST integer,
    IN_BA double precision,
    IN_BB double precision,
    IN_BC double precision,
    IN_BD double precision,
    IN_BE double precision,
    IN_BG double precision,
    IN_BH double precision,
    IN_BM double precision)
returns (
    CLCMODE integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BG double precision,
    BH double precision,
    BM double precision,
    CALK_BA integer,
    CALK_BB integer,
    CALK_BC integer,
    CALK_BD integer,
    CALK_BE integer,
    CALK_BG integer,
    CALK_BG_READONLY integer,
    CALK_BH integer,
    CALK_BH_READONLY integer,
    CALK_BM integer,
    S_BA double precision,
    S_BB double precision,
    S_BC double precision,
    S_BD double precision,
    S_BE double precision,
    S_BG double precision,
    S_BH double precision,
    S_BM double precision,
    NORM_BA double precision,
    NORM_BB double precision,
    NORM_BC double precision,
    NORM_BD double precision,
    NORM_BE double precision,
    NORM_BG double precision,
    NORM_BH double precision,
    NORM_BM double precision,
    NORM_EA double precision,
    NORM_EB double precision,
    NORM_EC double precision,
    NORM_ED double precision,
    NORM_EE double precision,
    NORM_EG double precision,
    NORM_EH double precision,
    NORM_EM double precision,
    UCH_EA double precision,
    UCH_EB double precision,
    UCH_EC double precision,
    UCH_ED double precision,
    UCH_EE double precision,
    UCH_EG double precision,
    UCH_EH double precision,
    UCH_EM double precision,
    RES_EA double precision,
    RES_EB double precision,
    RES_EC double precision,
    RES_ED double precision,
    RES_EE double precision,
    RES_EG double precision,
    RES_EH double precision,
    RES_EM double precision,
    NORM_BB_COUNT integer,
    NORM_BC_COUNT integer,
    NORM_BE_COUNT integer)
AS
-- written by S_
declare IDUSER integer;
declare DELTA_8168 double precision;

-- Bx      - ,     ""  
-- CALK_Bx -  ""  (     )
-- CALK_Bx_READONLY -   "" ()   
-- S_Bx    - ""   
-- NORM_Bx - ""    () 
-- NORM_Ex - ""    ()  (   )
-- UCH_Ex  - ""     (     )
-- RES_Ex  - ""     (     )

--  
-- BM      - :   ()
-- CALK_BM - 1 ()
-- S_BM    - (:UCH_BM & :KB)  (:UCH_EM) - (!!!)   ,
                  --   ""    [BEEF9D1CC98A]
-- NORM_BM - null (    ,   ) [36025D343167]
-- NORM_EM - null (    ,   ) [36025D343167]
-- UCH_EM  - A_CLC_PREPARE_RES: sum(BM_UCH * RASHOD_E)
-- RES_EM  - A_CLC_PREPARE_RES: sum(BM_DOB * RASHOD_E)

--   -  :
-- UCH_BM  - A_CLC_PREPARE_RES: sum(BM_UCH * RASHOD_B)
-- RES_BM  - A_CLC_PREPARE_RES: sum(BM_DOB * RASHOD_B)


declare OZP_USE_TRUD_MASH integer;
declare ZPM_AS_TRUD_MASH integer;

declare IDSOURCE integer;

--  ,     ()
declare RES_BA double precision;
declare RES_BB double precision;
declare RES_BC double precision;
declare RES_BD double precision;
declare RES_BE double precision;
declare RES_BG double precision;
declare RES_BH double precision;

--  
declare RES_BM double precision; --<<rvs:[6929]
declare UCH_BM double precision; --<<rvs:[6929]
declare KB varchar(50);
declare IFLAG integer;

--  

declare SM_CLCMODE integer;
declare DEF_DOB_V_ZENU integer;
declare ISZERO integer;

declare RABMAT integer;
declare TYPE_TRUD integer;
declare TAB varchar(42);

declare ISSMETAWORKREC integer;

--declare SUM_BA double precision;
begin
  DELTA_8168 = 0.05;

  --OZP_USE_TRUD_MASH = 1;
  -- <> '0' -      (  )
  -- 'null' or '0' -    

  --     (  )
  -- :S_BM  
  -- :IN_BM ,     
  select /*[10163]
         coalesce(:IN_BA, BA, 0.0),
         coalesce(:IN_BB, BB, 0.0),
         coalesce(:IN_BC, BC, 0.0),
         coalesce(:IN_BD, BD, 0.0),
         coalesce(:IN_BE, BE, 0.0),
         coalesce(:IN_BG, BG, 0.0),
         coalesce(:IN_BH, BH, 0.0),*/
         ID,
         coalesce(:ATYPE, ATYPE),
         coalesce(:ID_S_RES, ID_S_RES),
         coalesce(CLCMODE, 0),
         RABMAT, TYPE_TRUD, TAB,
         coalesce(KB, '')
    from A_SMETA s
    where ID = :ID
    into /*:S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH,*/
         :IDSOURCE, :ATYPE, :ID_S_RES, :SM_CLCMODE,
         :RABMAT, :TYPE_TRUD, :TAB,
         :KB;

  if (:IDSOURCE is null) then -- ,   ID ...
    exit;

  --[10163] - ,   
  select coalesce(:IN_BA, BA, 0.0),
         coalesce(:IN_BB, BB, 0.0),
         coalesce(:IN_BC, BC, 0.0),
         coalesce(:IN_BD, BD, 0.0),
         coalesce(:IN_BE, BE, 0.0),
         coalesce(:IN_BG, BG, 0.0),
         coalesce(:IN_BH, BH, 0.0)
    from A_SMETA_CENLVL
    where ID = :ID
      and IDCENLVL = :ID_CENLVL
    into :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH;

  --   
  -- .  CLCMODEMASK
  if (GETBIT(:SM_CLCMODE, 1) <> 0) then
    CLCMODE = 2;
  else
    execute procedure A_CLC_GET_MODE(:ISCLC)
      returning_values :CLCMODE;

  ZPM_AS_TRUD_MASH = case when CLCMODE = 2 then GETBIT(coalesce(:MODE_KOMPNS_ST, 0), 4) else 0 end;
  -- <> '0' -      
  -- 'null' or '0' -     

  if (:CLCMODE = 3) then
  begin
    --<rvs:00004080> -    , SM_CLCMODE    
    --execute procedure A_CLC_RES_COSTS_IS_ZERO(:S_BA, :S_BB, :S_BC, :S_BD, :S_BE)
    --  returning_values :ISZERO;
    --</rvs:00004080>
    --   
    CLCMODE = case
      when :ISZERO <> 0 then
        2 -- . 
      else
        0 --  1,  ...
      end;
  end

  if (:CLCMODE = 2) then
    DEF_DOB_V_ZENU = 1;

  ISSMETAWORKREC = case when :ATYPE = 18 or :RABMAT <> 0 then 0 else 1 end;

  --      (  ,  "" )
  if (:ISSMETAWORKREC = 0) then
  begin
    /* [15140] -  ,        .
    -          ,        ...
    if (:ATYPE = 18 and :CLCMODE <> 0) then
    begin
      select coalesce(c.BB, 0.0),
             coalesce(c.BC, 0.0),
             coalesce(c.BD, 0.0),
             coalesce(c.BE, 0.0)
        from A_S_RES_CENLVL c

        where (c.ID = :ID_S_RES)  and (c.idcenlvl = :ID_CENLVL)
        into :BB, :BC, :BD, :BE;


      BA = :BB + :BC + :BE;

      CALK_BA = 1;
      CALK_BB = 1;
      CALK_BC = 1;
      CALK_BD = 1;
      CALK_BE = 1;
    end
    else
    */
    begin
      BA = :S_BA;
      BB = :S_BB;
      BC = :S_BC;
      BD = :S_BD;
      BE = :S_BE;

      CALK_BA = 0;
      CALK_BB = 0;
      CALK_BC = 0;
      CALK_BD = 0;
      CALK_BE = 0;
    end

    BG = :S_BG;
    BH = :S_BH;

    CALK_BG = 0;
    CALK_BG_READONLY = 0;
    CALK_BH = 0;
    CALK_BH_READONLY = 0;
  end


  begin
    --    
    if (:ZPM_AS_TRUD_MASH <> 0) then
    begin
      --        
      if (:RABMAT = 2) then
      begin
        --    
        S_BD = 0;

        BD = 0;
        CALK_BD = 1;
      end
      else
      if (:RABMAT = 1) then
        if (:TAB starting 2) then
        begin
          --      
          S_BD = :S_BE;

          BD = :BE;
          CALK_BD = 1;
        end
    end

    if (:RABMAT = 1) then
      if (coalesce(:OZP_USE_TRUD_MASH, 0) = 0) then
        if (:TAB starting 2) then
        begin
          --     
          S_BE = 0;

          BE = 0;
          CALK_BE = 1;
        end
  end

  if (ISSMETAWORKREC = 0) then
  begin
    -- [1F408CE7E558] -    
    BA = :BB + :BC + :BE;
    CALK_BA = 1;

    --rvs:[6929] -  
    --[BEEF9D1CC98A] -        -  
    CALK_BM = 1;
    if (RABMAT = 3 and TYPE_TRUD <> 0) then
    begin
      BM = :BB;

      if (ATYPE = 18) then
      begin
        --        
        S_BM = null;
        select coalesce(c.BB, 0) --      
            --coalesce(R.RASHOD, 0) * coalesce(R.BB, 0)
          from A_S_RES_CENLVL c
          where (c.ID = :ID_S_RES) and (c.idcenlvl = :ID_CENLVL)
          into :S_BM;
      end
      else
        S_BM = :BM;

      --    
      execute procedure K_CALCULATENORMRASH (:KB, coalesce(:S_BM, 0.0), :IDUSER)
        returning_values :IFLAG, :S_BM;
    end
    else
    begin
      BM = 0;
      S_BM = :BM;
    end

    suspend;
    exit;
  end

  --   ( not null)
  select coalesce(sum(BM_UCH * RASHOD_B), 0.0),
         --(1)
         coalesce(sum(BB_DOB * RASHOD_B), 0.0),
         coalesce(sum(BM_DOB * RASHOD_B), 0.0),
         coalesce(sum(BC_DOB * RASHOD_B), 0.0),
         coalesce(sum(case when :ZPM_AS_TRUD_MASH <> 0 then
                      BE_DOB * RASHOD_B * BH_DOB else
                      BD_DOB * RASHOD_B end), 0.0),
         coalesce(sum(case when coalesce(:OZP_USE_TRUD_MASH, 0) <> 0 or BG_DOB <> 0 then
                      BE_DOB * RASHOD_B else null end ), 0.0),
         coalesce(sum(         RASHOD_B * BG_DOB), 0.0),
         coalesce(sum(         RASHOD_B * BH_DOB), 0.0),
         --(2)
         coalesce(sum(BB_DOB * RASHOD_E), 0.0),
         coalesce(sum(BM_DOB * RASHOD_E), 0.0),
         coalesce(sum(BC_DOB * RASHOD_E), 0.0),
         coalesce(sum(case when :ZPM_AS_TRUD_MASH <> 0 then
                      BE_DOB * RASHOD_E * BH_DOB else
                      BD_DOB * RASHOD_E end), 0.0),
         coalesce(sum(case when coalesce(:OZP_USE_TRUD_MASH, 0) <> 0 or BG_DOB <> 0 then
                      BE_DOB * RASHOD_E else null end), 0.0),
         coalesce(sum(         RASHOD_E * BG_DOB), 0.0),
         coalesce(sum(         RASHOD_E * BH_DOB), 0.0),
         --(3)
         coalesce(sum(BB_UCH * RASHOD_E), 0.0),
         coalesce(sum(BM_UCH * RASHOD_E), 0.0),
         coalesce(sum(BC_UCH * RASHOD_E), 0.0),
         coalesce(sum(case when :ZPM_AS_TRUD_MASH <> 0 then
                      BE_UCH * RASHOD_E * BH_UCH else
                      BD_UCH * RASHOD_E end), 0.0),
         coalesce(sum(case when coalesce(:OZP_USE_TRUD_MASH, 0) <> 0 or BG_UCH <> 0 then
                      BE_UCH * RASHOD_E else null end), 0.0),
         coalesce(sum(         RASHOD_E * BG_UCH), 0.0),
         coalesce(sum(         RASHOD_E * BH_UCH), 0.0),
         --(4)
         coalesce(avg(case when BB_DOB is null then null else 1 end), 0),
         coalesce(avg(case when BC_DOB is null then null else 1 end), 0),
         coalesce(avg(case when :ZPM_AS_TRUD_MASH <> 0 then   case when BH_DOB <> 0 then 1 else null end
                           when BD_DOB is null then null else 1 end), 0),
         coalesce(avg(case when BE_DOB is null then null
                           when coalesce(:OZP_USE_TRUD_MASH, 0) <> 0 or BG_DOB <> 0 then 1
                                                      else null end), 0),
         --(5)
                   coalesce(avg(BG_DOB), 0),
         case when coalesce(sum(BG_DOB), 0) > 1 then 0 else 1 end,
                   coalesce(avg(BH_DOB), 0),
         case when coalesce(sum(BH_DOB), 0) > 1 then 0 else 1 end

    from A_CLC_PREPARE_RES_NL (:IDSOURCE, :ID_CENLVL, :IDGROUP, :IDPODGROUP, :DEF_DOB_V_ZENU)
    into          :UCH_BM,
         --(1)
         :RES_BB, :RES_BM, :RES_BC, :RES_BD, :RES_BE,
         :RES_BG, :RES_BH,
         --(2)
         :RES_EB, :RES_EM, :RES_EC, :RES_ED, :RES_EE,
         :RES_EG, :RES_EH,
         --(3)
         :UCH_EB, :UCH_EM, :UCH_EC, :UCH_ED, :UCH_EE,
         :UCH_EG, :UCH_EH,
         --(4)
         :CALK_BB, :CALK_BC, :CALK_BD, :CALK_BE,
         --(5)
         :CALK_BG, :CALK_BG_READONLY,
         :CALK_BH, :CALK_BH_READONLY;

  --  ()  ( not null)
  select coalesce(sum(BB_UCH * RASHOD_B), 0.0),
         coalesce(sum(BC_UCH * RASHOD_B), 0.0),
         coalesce(sum(BD_UCH * RASHOD_B), 0.0),
         coalesce(sum(BE_UCH * RASHOD_B
                             * coalesce(:OZP_USE_TRUD_MASH, BG_UCH)
                                       ), 0.0),
         coalesce(sum(         RASHOD_B * BG_UCH), 0.0),
         coalesce(sum(         RASHOD_B * BH_UCH), 0.0),

         coalesce(sum(BB_UCH * RASHOD_E), 0.0),
         coalesce(sum(BC_UCH * RASHOD_E), 0.0),
         coalesce(sum(BD_UCH * RASHOD_E), 0.0),
         coalesce(sum(BE_UCH * RASHOD_E
                             * coalesce(:OZP_USE_TRUD_MASH, BG_UCH)
                                       ), 0.0),
         coalesce(sum(         RASHOD_E * BG_UCH), 0.0),
         coalesce(sum(         RASHOD_E * BH_UCH), 0.0),
                count(BB_UCH),
                count(BC_UCH),
                count(BE_UCH * coalesce(:OZP_USE_TRUD_MASH, BG_UCH))

    from A_CLC_PREPARE_RES_NORM_NL (:IDSOURCE, :ID_CENLVL, :IDGROUP, :IDPODGROUP)
    into :NORM_BB, :NORM_BC, :NORM_BD, :NORM_BE,
         :NORM_BG, :NORM_BH,
         :NORM_EB, :NORM_EC, :NORM_ED, :NORM_EE,
         :NORM_EG, :NORM_EH,
         :NORM_BB_COUNT,
         :NORM_BC_COUNT,
         :NORM_BE_COUNT;

  --         ()
  -- 
  --UCH_EE = 0;
  --NORM_EE = 0;

  --   (   )
  RES_BA = :RES_BB + :RES_BC + :RES_BE;
  RES_EA = :RES_EB + :RES_EC + :RES_EE;
  UCH_EA = :UCH_EB + :UCH_EC + :UCH_EE;
  CALK_BA = case when :CALK_BB <> 0 or :CALK_BC <> 0 or :CALK_BE <> 0 then 1 else 0 end;
  -- rvs:00003700 -             
  CALK_BG_READONLY = :CALK_BG;
  CALK_BH_READONLY = :CALK_BH;

  NORM_BA = :NORM_BB + :NORM_BC + :NORM_BE;
  NORM_EA = :NORM_EB + :NORM_EC + :NORM_EE;

  --SUM_BA = :S_BB + :S_BC + :S_BE;

  --    :    ,
  --        
  --   (!)       
  --   ""    "   "
  if (:CLCMODE <> 2 and GETBIT(coalesce(:MODE_KOMPNS_ST, 0), 0) = 0) then
    select :UCH_BM - coalesce(sum(c.BB * R.RASHOD_BASE), 0.0),
           :UCH_EM - coalesce(sum(c.BB * R.RASHOD     ), 0.0)
      from A_S_RES R
      left join A_S_RES_CENLVL c on (r.id = c.id) and (c.idcenlvl = :ID_CENLVL)
/* <--------> */
--      --    
--      join A_SMETA S on R.ID = S.ID_S_RES
/* </--------> */
      --     
      where R.ID_SOURCE      = :IDSOURCE
        and R.KODIR_GROUP    = :IDGROUP
        and R.KODIR_PODGROUP = :IDPODGROUP

        and R.UCH <> 0 -- 
        and R.RABMAT = 3 and R.TYPE_TRUD <> 0 --  
        and R.RASHOD_BASE < 0.0 --    
/* <++++++++> */
        --    
        and exists(select * from A_SMETA s where s.ID_S_RES = R.ID)
/* </++++++++> */
      into :UCH_BM,
           :UCH_EM;


  --  ,  Bx  CALK_Bx
  if (:CLCMODE = 0) then -- 
  begin
    BA = :S_BA;
    BB = :S_BB;
    BC = :S_BC;
    BD = :S_BD;
    BE = :S_BE;
    BG = :S_BG;
    BH = :S_BH;
    BM = :UCH_BM;
    CALK_BA = 0;
    CALK_BB = 0;
    CALK_BC = 0;
    CALK_BD = 0;
    CALK_BE = 0;
    CALK_BG = 0;
    CALK_BG_READONLY = 0;
    CALK_BH = 0;
    CALK_BH_READONLY = 0;
  end
  else
  if (:CLCMODE = 2) then -- 
  begin
    BA = :RES_BA;
    BB = :RES_BB;
    BC = :RES_BC;
    BD = :RES_BD;
    BE = :RES_BE;
    BG = :RES_BG;
    BH = :RES_BH;
    BM = :RES_BM;
    CALK_BA = 1;
    CALK_BB = 1;
    CALK_BC = 1;
    CALK_BD = 1;
    CALK_BE = 1;

    CALK_BG = 1;
    CALK_BG_READONLY = 1;
    CALK_BH = 1;
    CALK_BH_READONLY = 1;
  end
  else
  --if (:CLCMODE in (1, 3, ...)) then -- 
  begin
    BA = :S_BA + :RES_BA;
    BB = :S_BB + :RES_BB;
    BC = :S_BC + :RES_BC;
    BD = :S_BD + :RES_BD;
    BE = :S_BE + :RES_BE;
    BG = :S_BG + :RES_BG;
    BH = :S_BH + :RES_BH;
    BM = :UCH_BM + :RES_BM;
  end

  begin

    /* --CQ[TIMUR 10647] (.  M_TMP_A_CLC_PREPARE_B_E_M) -          ,   ,    ...
    -- [1F408CE7E558] -    
    BA = :BB + :BC + :BE;
    CALK_BA = 1;
    */

    CALK_BM = 1;
    -- [BEEF9D1CC98A] S_BM    
    if (:CLCMODE = 2) then
      S_BM = 0; --       
    else
    --  :
    if ( GETBIT(coalesce(:MODE_KOMPNS_ST, 0), 0) <> 0 )  then
      S_BM = :UCH_EM; --      
    else
    --  :
    begin
      execute procedure S_CHECK_MULTIPLICITY (:KB)
        returning_values :IFLAG;
      --       
      if (:IFLAG <> 0) then
        execute procedure K_CALCULATENORMRASH (:KB, :UCH_BM, :IDUSER)
          returning_values :IFLAG, :S_BM;
      else
        S_BM = :UCH_EM; --      
    end

    --<[8168]> .  [AE2874690A54]
    -- DELTA_8168     (  )
    --if (:NORM_RES_COUNT > 0) then --<<   -   :)
    begin
      if ( (:NORM_BB_COUNT > 0) and (ABS(:S_BB-:NORM_BB) > :DELTA_8168) or
           (:NORM_BC_COUNT > 0) and (ABS(:S_BC-:NORM_BC) > :DELTA_8168) or
           (:NORM_BE_COUNT > 0) and (ABS(:S_BE-:NORM_BE) > :DELTA_8168) ) then
        CLCMODE = SETBIT(:CLCMODE, 6, 1); --<<""
      if ( (:NORM_BB_COUNT > 0) and (ABS(:S_BB-:NORM_BB) > :DELTA_8168) and (ABS(:NORM_EB-:UCH_EB) > :DELTA_8168) or
           (:NORM_BC_COUNT > 0) and (ABS(:S_BC-:NORM_BC) > :DELTA_8168) and (ABS(:NORM_EC-:UCH_EC) > :DELTA_8168) or
           (:NORM_BE_COUNT > 0) and (ABS(:S_BE-:NORM_BE) > :DELTA_8168) and (ABS(:NORM_EE-:UCH_EE) > :DELTA_8168) ) then
        CLCMODE = SETBIT(:CLCMODE, 7, 1); --<<""
    end
    --</[8168]>

    suspend;
    exit;
  end

end
^
/* CQ[15096] >> */
create or alter procedure D_GET_CLOUD_OBJECTS_AND_FOLDERS (
    IN_USER_ID integer)
returns (
    NUMBER integer,
    PARENT integer,
    ATYPE integer,
    FULLNAME varchar(1024),
    SHIFR varchar(1024),
    CHILDCOUNT integer,
    SORTING integer)
as
declare variable IN_PARENT integer;
begin
  IN_PARENT = 0;
  select ID_SECTION
  from A_O_HIER_CLOUD_AREA
  where ID_USER = :IN_USER_ID and
        ATYPE = 0
  into :IN_PARENT;

  for select NUMBER, PARENT, ATYPE, FULLNAME, SHIFR, CHILDCOUNT, SORTING
    from D_GET_OBJECTS_AND_FOLDERS(:IN_USER_ID, :IN_PARENT)
    into :NUMBER, :PARENT, :ATYPE, :FULLNAME, :SHIFR, :CHILDCOUNT, :SORTING
  do
    suspend;
end
^

--[15160]
-- 
create or alter procedure L_FB_SEARCH_ID_IN_ONE_PUT (
    ID_PUT integer,
    IN_RABMAT integer,
    STAB varchar(42),
    FETCHMODE integer)
returns (
    ID_SELF integer,
    ID_ABC_OKP integer,
    BEDA integer)
AS
begin
   suspend;
end
^


-- MK CQ[15151]
create or alter procedure IMP_SM_RESOURCE_FROM_XML (
    ID_USER integer,
    ID_SOURCE integer,
    IDHIER integer,
    SMETATYPE integer,
    RABMAT integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    EDIZM_NAME varchar(100),
    EDIZM_FULLNAME varchar(250),
    EDIZM_RELATION double precision,
    NAME blob sub_type 0 segment size 80,
    NORM_GUID varchar(100),
    NORM_PODGROUP integer,
    KODIR_GROUP_NAME varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ISGROUPOKP integer,
    RASHOD double precision,
    RASHOD_BASE double precision,
    CORRECT varchar(50),
    VIDNR integer,
    UCH integer,
    STATUS_EDIT integer,
    STATUS_DOB_V_ZENU integer,
    STATUS_REC_CEN integer,
    TYPE_TRUD integer,
    NOTE varchar(255),
    REC_ADD_MODE integer,
    CLCMODE integer,
    IDNORMATIV integer,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision)
returns (
    ID integer,
    NEW_ID_PS integer)
AS
declare variable I integer;
declare variable ID_NAME integer;
declare variable KODIR_GROUP integer;
declare variable KODIR_PODGROUP integer;
declare variable ID_EDIZM integer;
--declare variable ID_GROUP_EDIZM integer;
-- declare variable IDNORMATIV integer;
declare variable s_orderview integer;
declare variable s_nomerrod integer;
declare variable vn_smetatype integer;
declare variable vn_id_source integer;
-- CQ[14238, 13929] declare variable NEW_ID_PS integer;
declare variable vn_nomerrod integer;
declare variable ID_OBJ integer;
declare variable VN_CRC integer;
declare variable VN_CRC_1 integer;
declare variable VN_ID_NAME integer;
declare variable VN_TMP integer;
declare variable VN_NAME blob sub_type 0 segment size 80;
declare variable vn_id_sm_rec integer;
declare variable vn_res_nomerrod integer;
begin
  -- ===========================================================================
  --         / 
  -- ===========================================================================

  ------------------------------------------------------------------------------
  -- REC_ADD_MODE - .   IMP_SMREC_FROM_XML


  ID = gen_id( a_g_smeta, 1); --    -- CQ[14238, 13929]  NEW_ID  ID
  NEW_ID_PS = 0; -- CQ[14238, 13929]
  --  
  execute procedure a_h_get_id_parentatype (:idhier, 1) returning_values (:id_obj);

  --    ----------------------------------------------
  if (:EDIZM_RELATION is null) then EDIZM_RELATION = 1;
  if (:ISGROUPOKP is null) then ISGROUPOKP = 0;


   --    blob -----------------------------------------------------
   I = gen_id( B_GEN_TEMP, 1 );
   insert into B_TEMP_BLOB(ID, BLOB1) values (:I, :NAME);
   select BLOB1 from B_TEMP_BLOB where ID = :I into :NAME;
   delete from B_TEMP_BLOB where ID = :I;

  --     -------------------------------
  select first 1 n.IDNAME
  from B_WRITE_NAIMENOVANIE (:ID_USER, -1, 0, :NAME) n
  into :ID_NAME;

  VN_CRC = K_GETCRC32(:NAME); -- MK 27.06.2013 CQ[11337]

  --  KODIR_GROUP, KODIR_PODGROUP -----------------------------------------
  -- MK   CQ[12802] --->
  execute procedure M_FIND_KODIRS_ID_FOR_IMP_EXT (:id_obj, :SMETATYPE, :KODIR_GROUP_NAME,
                                                  :KODIR_PODGROUP_NAME)
  returning_values (:KODIR_GROUP, :KODIR_PODGROUP);

  --execute procedure M_FIND_KODIRS_ID_FOR_IMP (:SMETATYPE, :KODIR_GROUP_NAME,
  --                                            :KODIR_PODGROUP_NAME)
  --returning_values (:KODIR_GROUP, :KODIR_PODGROUP);
  -- MK   CQ[12802] <---

  --  ID_EDIZM ------------------------------------------------------------
  /*ID_EDIZM = null;
  if (coalesce(EDIZM_NAME,'') <> '') then
  begin
      if (coalesce(EDIZM_FULLNAME, '') = '') then
          EDIZM_FULLNAME = EDIZM_NAME;

      execute procedure B_FIND_EDIZM(:ID_USER, :EDIZM_NAME, :EDIZM_FULLNAME)
      returning_values (:ID_EDIZM);
      --    -   
      if (:ID_EDIZM is null) then
      begin
        execute procedure B_GEN_DEF_EDGROUP_ID(:ID_USER)
        returning_values (:ID_GROUP_EDIZM);
        execute procedure B_ADD_EDIZM (:ID_USER, :ID_GROUP_EDIZM, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION)
        returning_values (:ID_EDIZM);
      end
  end*/

  --:     ,    Copy Paste   
  execute procedure IMP_EDIZM (:ID_USER, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION)
  returning_values (:ID_EDIZM);

  -- <-- Voyager CQ[12939]
  IDNORMATIV = coalesce(IDNORMATIV,0);
  execute procedure L_GET_NORMATIV_FROM_GUID ( :NORM_GUID, :TAB, :IDNORMATIV,
    :KODIR_PODGROUP, :RABMAT, :ID_USER )
  returning_values ( :IDNORMATIV, :KODIR_PODGROUP, :RABMAT );

  --   IDNORMATIV ------------------------------------------------
  --      /    
  /*
  execute procedure m_find_normativ(:IDHIER, :SMETATYPE, :KODIR_PODGROUP,
                                    :RABMAT, :ID_USER, :TAB)
  returning_values (:IDNORMATIV);
  */
  -- <-- Voyager CQ[12939]


  --      : .   
  if (SMETATYPE <> 15) then
  begin
    --        .   
    if (REC_ADD_MODE = 1) then
    begin
      select s.nomerrod -- MK CQ[15151], s.smetatype
      from a_smeta s
      where (s.id = :id_source)
      into :vn_id_source; -- MK CQ[15151], :vn_smetatype;

      -- MK CQ[15151] --->
      vn_smetatype = 15;

      select s.smetatype
      from a_smeta s
      where (s.id = :vn_id_source)
      into :vn_smetatype;
      -- MK CQ[15151] <---

      --    
      NEW_ID_PS = gen_id( a_g_smeta, 1);
      insert into a_s_res (ID, ID_SOURCE, NORM_ID, NORM_PODGROUP, KODIR_GROUP,
                           KODIR_PODGROUP, ISGROUPOKP, RABMAT, TAB, ALTTAB,
                           NAME_ID, IDEDIZM, RASHOD, RASHOD_BASE, CORRECT,
                           VIDNR, UCH, STATUS_EDIT,
                           STATUS_DOB_V_ZENU, STATUS_REC_CEN, NOTE,
                           SMETATYPE,
                           NORM_GUID, TYPE_TRUD, IDHIER,
                           CLCMODE, -- MK CQ[12378]
                           BB, BC, BD, BE -- Voyager CQ[13244]
                           )
      values (:NEW_ID_PS, :vn_id_source, :IDNORMATIV, :NORM_PODGROUP, :KODIR_GROUP,
              :KODIR_PODGROUP, :ISGROUPOKP, :RABMAT, :TAB, :ALTTAB,
              :ID_NAME, :ID_EDIZM, :RASHOD, :RASHOD_BASE, :CORRECT,
              :VIDNR, :UCH, :STATUS_EDIT,
              :STATUS_DOB_V_ZENU, :STATUS_REC_CEN, :NOTE,
              --    SMETATYPE ..  
              case when :vn_smetatype = 15 then :id_obj else :vn_smetatype end,
              :NORM_GUID, :TYPE_TRUD, :IDHIER,
              :CLCMODE, -- MK CQ[12378]
              :BB, :BC, :BD, :BE -- Voyager CQ[13244]
              );

      vn_nomerrod = NEW_ID_PS;

      --       
      --        
      execute procedure M_SET_RES_REC_ENTITYS(:ID_USER, :NEW_ID_PS, :IDHIER,
                                              :vn_smetatype, 0);

    end
    --  .    ( )
    else if (REC_ADD_MODE = 2) then
    begin
      NEW_ID_PS = -1;
      vn_id_source = null;

      --      
      select s.nomerrod
      from a_smeta s
      where (s.id = :id_source)
      into :vn_id_source;

      if (vn_id_source is not null) then
      begin
        --       
        for select r.id, r.name_id
        from a_s_res r
        left join b_edizm e on (r.idedizm = e.id)
        where (r.id_source = :vn_id_source) and
              (r.rabmat = :RABMAT) and
              (coalesce(r.type_trud, 0) = coalesce(:TYPE_TRUD, 0)) and
              (r.tab = :TAB) and
              ((r.idedizm = :ID_EDIZM) or (e.name = :EDIZM_NAME))
        into :VN_TMP, :VN_ID_NAME do
        begin
          execute procedure b_getname(:ID_USER, :VN_ID_NAME)
          returning_values (:VN_NAME);

          VN_CRC_1 = 0;
          if (VN_NAME is not null) then
            VN_CRC_1 = K_GETCRC32(VN_NAME);

          if (VN_CRC = VN_CRC_1) then
          begin
            NEW_ID_PS = VN_TMP;
            leave;
          end
        end

        NEW_ID_PS = coalesce(:NEW_ID_PS, -1);

        --           - 
        --         
        if (NEW_ID_PS = -1) then
        begin
          for select s.id
          from a_smeta s
          where (s.nomerrod = :vn_id_source) and (s.id <> :id_source)
          and s.idhier = :idhier -- CQ[13116]
          into :vn_id_sm_rec do
          begin
            for select r.id, r.name_id, r.nomerrod
            from a_s_res r
            left join b_edizm e on (r.idedizm = e.id)
            where (r.id_source = :vn_id_sm_rec) and
                  (r.rabmat = :RABMAT) and
                  (coalesce(r.type_trud, 0) = coalesce(:TYPE_TRUD, 0)) and
                  (r.tab = :TAB) and
                  ((r.idedizm = :ID_EDIZM) or (e.name = :EDIZM_NAME))
            into :VN_TMP, :VN_ID_NAME, :vn_res_nomerrod do
            begin
              execute procedure b_getname(:ID_USER, :VN_ID_NAME)
              returning_values (:VN_NAME);
    
              VN_CRC_1 = 0;
              if (VN_NAME is not null) then
                VN_CRC_1 = K_GETCRC32(VN_NAME);
    
              if (VN_CRC = VN_CRC_1) then
              begin
                if ((vn_res_nomerrod is null) or (vn_res_nomerrod = 0))  then
                  NEW_ID_PS = VN_TMP;
                else
                  NEW_ID_PS = :vn_res_nomerrod;

                leave;
              end
            end

            if (NEW_ID_PS <> -1) then
              leave;
          end
        end
      end


      --  -  
      if (NEW_ID_PS <> -1) then
      begin
        vn_nomerrod = NEW_ID_PS;
      end

      --   -  . 
      else
      begin
        vn_nomerrod = null;
      end
    end
    --  . 
    else if (REC_ADD_MODE = 3) then
    begin
      vn_nomerrod = null;
    end
  end



  --   ----------------------------------------------------------
  insert into a_s_res (ID, ID_SOURCE, NORM_ID, NORM_PODGROUP, KODIR_GROUP,
                       KODIR_PODGROUP, ISGROUPOKP, RABMAT, TAB, ALTTAB,
                       NAME_ID, IDEDIZM, RASHOD, RASHOD_BASE, CORRECT,
                       VIDNR, UCH, STATUS_EDIT,
                       STATUS_DOB_V_ZENU, STATUS_REC_CEN, NOTE,
                       SMETATYPE,
                       NORM_GUID, TYPE_TRUD, IDHIER, NOMERROD,
                       CLCMODE, -- MK CQ[12378]
                       BB, BC, BD, BE -- Voyager CQ[13244]
                       )
  values (:ID, :ID_SOURCE, :IDNORMATIV, :NORM_PODGROUP, :KODIR_GROUP, -- CQ[14238, 13929]  NEW_ID  ID
          :KODIR_PODGROUP, :ISGROUPOKP, :RABMAT, :TAB, :ALTTAB,
          :ID_NAME, :ID_EDIZM, :RASHOD, :RASHOD_BASE, :CORRECT,
          :VIDNR, :UCH, :STATUS_EDIT,
          :STATUS_DOB_V_ZENU, :STATUS_REC_CEN, :NOTE,
          case when :SMETATYPE = 15 then :id_obj else :SMETATYPE end,
          :NORM_GUID, :TYPE_TRUD, :IDHIER, :vn_nomerrod,
          :CLCMODE, -- MK CQ[12378]
          :BB, :BC, :BD, :BE -- Voyager CQ[13244]
          );



  ------------------------------------------------------------------------------
  --     

  --   ,     
  if (vn_nomerrod is not null) then
    exit;

  --   
  select first 1 s.NOMERROD
  from a_smeta s
  where (s.id = :id_source)
  into :S_NOMERROD;

  if ((:S_NOMERROD is null) or (:S_NOMERROD = 0)) then
    S_NOMERROD = :ID_SOURCE;

  if (not exists( select *
        from A_SMETA
        where NOMERROD1 = :S_NOMERROD
          and SMETATYPE <> :SMETATYPE )) then
    exit;


  --     
  select ORDERVIEW
    from SD_IMPACT_SELECTSTRUCT_GETFIRST(:ID_USER, :ID_SOURCE, :SMETATYPE)
    into :S_ORDERVIEW;

  if (:S_ORDERVIEW > 0) then
  begin
    for select i.SMETATYPE
    from SD_IMPACT_SELECTSTRUCT(:ID_USER, :ID_SOURCE) i
    where (i.ORDERVIEW >= :S_ORDERVIEW)
    into :vn_smetatype do
    begin
      --  , 
      if (not exists(
            select * from M_UTV_STRUCT_ELEM_IN_AKT
              where ID_STRUCT = :IDHIER and ID_AKT = :vn_smetatype)) then
      begin
        for select ID
        from A_SMETA
        where (NOMERROD1 = :S_NOMERROD) and (SMETATYPE = :vn_smetatype)
        into :vn_id_source do
        begin
          I = gen_id(a_g_smeta, 1);

          insert into a_s_res (ID, ID_SOURCE, NORM_ID, NORM_PODGROUP, KODIR_GROUP,
                               KODIR_PODGROUP, ISGROUPOKP, RABMAT, TAB, ALTTAB,
                               NAME_ID, IDEDIZM, RASHOD, RASHOD_BASE, CORRECT,
                               VIDNR, UCH, STATUS_EDIT,
                               STATUS_DOB_V_ZENU, STATUS_REC_CEN, NOTE, SMETATYPE,
                               NORM_GUID, TYPE_TRUD, IDHIER, NOMERROD,
                               CLCMODE, -- MK CQ[12378]
                               BB, BC, BD, BE -- Voyager CQ[13244]
                               )
          values (:I, :vn_id_source, :IDNORMATIV, :NORM_PODGROUP, :KODIR_GROUP,
                  :KODIR_PODGROUP, :ISGROUPOKP, :RABMAT, :TAB, :ALTTAB,
                  :ID_NAME, :ID_EDIZM, :RASHOD, :RASHOD_BASE, :CORRECT,
                  :VIDNR, :UCH, :STATUS_EDIT,
                  :STATUS_DOB_V_ZENU, :STATUS_REC_CEN, :NOTE, :vn_smetatype,
                  :NORM_GUID, :TYPE_TRUD, :IDHIER, :ID, -- CQ[14238, 13929]  NEW_ID  ID
                  :CLCMODE, -- MK CQ[12378]
                  :BB, :BC, :BD, :BE -- Voyager CQ[13244]
                  );
          --       
          --        
          execute procedure M_SET_RES_REC_ENTITYS(:ID_USER, :I, :IDHIER,
                                                  :vn_smetatype, 0);

        end
      end
    end
  end


  suspend;
end
^

/*15156*/
create or alter procedure V_PR_SELECT_REC_VERSIONS_ITOGI (
    IN_ID integer,
    ID_USER integer,
    ID_OBJ integer,
    LYEAR integer,
    LMONTH integer,
    USE_ONLY_UTV_PROCENT integer,
    SKIP_PS integer,
    INCLUDEACTSMODE integer)
returns (
    KOLL double precision,
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
    CLCMODE integer)
AS
declare variable ID integer;
declare variable ATYPE integer;
declare variable SMETAPARENT integer;
declare variable VN_KOLL double precision;
declare variable VN_RA double precision;
declare variable VN_RB double precision;
declare variable VN_RC double precision;
declare variable VN_RD double precision;
declare variable VN_RE double precision;
declare variable VN_RF double precision;
declare variable VN_RG double precision;
declare variable VN_RH double precision;
declare variable VN_RI double precision;
declare variable VN_RJ double precision;
declare variable VN_RK double precision;
declare variable VN_RL double precision;
declare variable VN_RM double precision;
begin 
    /*
        CQ[8457]      L_PR_SELECT_REC_VERSIONS_ITOGI 
        IncludeActsMode.  .   A_O_HIER_SELECT_PR1_WITH_FILTER
    */

   if ( SKIP_PS is null ) then
      SKIP_PS = 0;

  /* CQ[15156] -   ...     
    select coalesce(sum(S.KOLL), 0),
          coalesce(sum(S.RA), 0),
          coalesce(sum(S.RB), 0),
          coalesce(sum(S.RC), 0),
          coalesce(sum(S.RD), 0),
          coalesce(sum(S.RE), 0),
          coalesce(sum(S.RF), 0),
          coalesce(sum(S.RG), 0),
          coalesce(sum(S.RH), 0),
          coalesce(sum(S.RI), 0),
          coalesce(sum(S.RJ), 0),
          coalesce(sum(S.RK), 0),
          coalesce(sum(S.RL), 0),
          coalesce(sum(S.RM), 0)
     from V_PR_SELECT_REC_VERSIONS ( :IN_ID, :ID_USER,
         :ID_OBJ, :LYEAR, :LMONTH, :USE_ONLY_UTV_PROCENT, :INCLUDEACTSMODE ) V
     left join A_SMETA S on S.ID = V.ID
     where :SKIP_PS = 0 or S.SMETATYPE <> 15
     into :KOLL,
          :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH,
          :RI, :RJ, :RK, :RL, :RM; */

   KOLL = 0.0;
   RA = 0.0; RB = 0.0; RC = 0.0; RD = 0.0; RE = 0.0;
   RF = 0.0; RG = 0.0; RH = 0.0; RI = 0.0; RJ = 0.0;
   RK = 0.0; RL = 0.0; RM = 0.0;

   for select s.ID, s.ATYPE,  s.CLCMODE, s.SLAVEPARENT, s.KOLL,
     s.RA, s.RB, s.RC, s.RD, s.RE, s.RF, s.RG, s.RH, s.RI, s.RJ, s.RK, s.RL, s.RM
   from V_PR_SELECT_REC_VERSIONS ( :IN_ID, :ID_USER,
         :ID_OBJ, :LYEAR, :LMONTH, :USE_ONLY_UTV_PROCENT, :INCLUDEACTSMODE ) V
   left join A_SMETA s on s.ID = V.ID
   where :SKIP_PS = 0 or s.SMETATYPE <> 15
   into :ID, :ATYPE, :CLCMODE, :SMETAPARENT, :VN_KOLL,
        :VN_RA, :VN_RB, :VN_RC, :VN_RD, :VN_RE, :VN_RF, :VN_RG, :VN_RH,
        :VN_RI, :VN_RJ, :VN_RK, :VN_RL, :VN_RM
   do
   begin
     if (ATYPE = 18) then
       select first 1 s.CLCMODE
         from A_SMETA s
       where (s.ID = :SMETAPARENT)
       into :CLCMODE;

     if (GETBIT(CLCMODE, 10) = 0) then
     begin
       KOLL = KOLL + coalesce(VN_KOLL,  0);

       RA = RA + coalesce(VN_RA, 0);
       RB = RB + coalesce(VN_RB, 0);
       RC = RC + coalesce(VN_RC, 0);
       RD = RD + coalesce(VN_RD, 0);
       RE = RE + coalesce(VN_RE, 0);
       RF = RF + coalesce(VN_RF, 0);
       RG = RG + coalesce(VN_RG, 0);
       RH = RH + coalesce(VN_RH, 0);
       RI = RI + coalesce(VN_RI, 0);
       RJ = RJ + coalesce(VN_RJ, 0);
       RK = RK + coalesce(VN_RK, 0);
       RL = RL + coalesce(VN_RL, 0);
       RM = RM + coalesce(VN_RM, 0);
     end
   end

   suspend;
end^

/*15156*/
-- 
CREATE OR ALTER PROCEDURE V_PR_SELECT_REC_VERSIONS_IT_NL (
    IN_ID INTEGER,
    ID_USER INTEGER,
    ID_OBJ INTEGER,
    LYEAR INTEGER,
    LMONTH INTEGER,
    USE_ONLY_UTV_PROCENT INTEGER,
    SKIP_PS INTEGER,
    INCLUDEACTSMODE INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    KOLL DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--------------------------------------------------------------------
--                           10.0.0.3, 9.2.1.3
--------------------------------------------------------------------

-- Voyager CQ[14886,15191]
-- 
CREATE OR ALTER PROCEDURE A_S_HIER_SELECT (
    IDUSER INTEGER,
    HATYPE INTEGER,
    AID INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IN_NLS INTEGER,
    IN_NR INTEGER,
    IN_NPR INTEGER,
    IN_IDLS INTEGER,
    IN_IDR INTEGER,
    CUR_PROJECTTYPE INTEGER,
    ALLREC INTEGER,
    SENDER INTEGER,
    CUR_ID_ZONE INTEGER,
    CUR_SAVECENZONETONORMBASE INTEGER,
    CUR_ID_TR INTEGER,
    PARAM_KODIR_GROUP INTEGER,
    PARAM_KODIR_PODGROUP INTEGER,
    SHOW_ZERO_STRINGS INTEGER,
    ISCLC INTEGER,
    MODE_KOMPNS_ST INTEGER,
    NO_SUSPEND_STRUCT_REC INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    IDLS INTEGER,
    IDR INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    UCH INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    CLCMODE_RES INTEGER,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    ADDED_SMETATYPE INTEGER,
    PR_VIPOLNENO_TOTAL DOUBLE PRECISION,
    K_ITOGO VARCHAR(50),
    ISKS_NS_ID INTEGER,
    COD_RTM VARCHAR(60),
    COD_RTM_BLOB BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    K_PR VARCHAR(50),
    B_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

/*create or alter procedure A_P_SMETA (
   
*/

-- Voyager CQ[14886,15209]
CREATE OR ALTER trigger A_SMETA_BD1 for A_SMETA
active before delete position 1
AS
   declare variable ID integer;
   declare variable RABMAT integer;
   declare variable ATYPE integer;
begin
    -- <-- Voyager CQ[14886,15209]
    --  IDSMREC   SPEC_TROW   -
    --     ISKS_NS_ID  CODE_RTM  
    if ( (Old.SMETATYPE = 15) and --    
        ( exists(select * from SPEC_TROW ST where ST.IDSMREC = OLD.ID)) ) then
    begin
        select first 1 S.ID, S.RABMAT,S.ATYPE from A_SMETA S
        where S.IDHIER = Old.IDHIER and S.SMETATYPE = 15 and S.NUMBER1 > Old.Number1
        order by S.NUMBER1
        into :ID, :RABMAT, :ATYPE;

        --     
        --      ,  
        --       
        --      [31A30561]  A_S_HIER_SELECT!
        if ( ((:RABMAT = 3) /*or (:ATYPE = 19)*/) and
           (not exists(select * from SPEC_TROW ST where ST.IDSMREC = :ID)) ) then
                update SPEC_TROW ST set ST.IDSMREC = :ID where ST.IDSMREC = OLD.ID;
    end
    -- <-- Voyager CQ[14886,15209]
end
^

--[15213]
create or alter procedure T_UPGRADE_A_O_OBJECTPARAMS
as
begin
  if (not exists(
      select * from RDB$RELATION_FIELDS F
        where (upper(F.RDB$RELATION_NAME) = 'A_O_OBJECTPARAMS') and
              (upper(F.RDB$FIELD_NAME) = 'SPEC_INFO'))) then
  begin
    execute statement 'ALTER TABLE A_O_OBJECTPARAMS ' ||
                      'ADD SPEC_INFO A_INTEGERNOTNULL ' ||
                      'NOT NULL';
  end

end
^

execute procedure T_UPGRADE_A_O_OBJECTPARAMS
^

drop procedure T_UPGRADE_A_O_OBJECTPARAMS
^^

/*15213*/
create or alter procedure A_H_GETOBJECTPARAM (
    IDUSER integer,
    ID integer)
returns (
    IDTN integer,
    ISCLC integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ID_TR integer,
    ID_ZONE integer,
    SAVECENZONETONORMBASE integer,
    INDEX_ID_ORG integer,
    INDEX_ID_GOD integer,
    INDEX_ID_MES integer,
    INDEX_NASNACHAUTO integer,
    INDEX_ZAMENNASNACH integer,
    INDEX_UCHITNDS integer,
    INDEX_SPOSOBRASCH integer,
    INDEX_RASCHNRISP integer,
    INDEX_BRAT_ZU_IS integer,
    INDEX_FOT integer,
    RES_ZANOSIT_S_RES integer,
    RES_TOLKO_NEUCHT_RES integer,
    RES_COPY_INDEX integer,
    RES_COPY_POPR integer,
    RES_COPY_FORMULS integer,
    RES_APPLY_TAB integer,
    NE_OBNUL_KOLL integer,
    NE_OBNUL_NR integer,
    NE_OBNUL_RES integer,
    NE_OBNUL_IND integer,
    NE_OBNUL_POPR integer,
    NE_OBNUL_FORMULS integer,
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision,
    PRECED integer,
    PRECIT integer,
    PUT_ID_GROUP integer,
    PUT_ID_RAB integer,
    PUT_ID_MASH integer,
    PUT_ID_MAT integer,
    NAME_STROYKI varchar(255),
    OCHERED_STROIT varchar(255),
    PUSK_KOMPLEX varchar(255),
    NUMGLSSR integer,
    DOGOVOR varchar(255),
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VELICHSTROBJ double precision,
    EDIZM varchar(40),
    STAD_PROEKT integer,
    NACH_STROY date,
    OKONCH_STROIT date,
    V_KAKIH_CENAH_MES integer,
    V_KAKIH_CENAH_GOD integer,
    SPISOKSHERT blob sub_type 0 segment size 80,
    OPISANIE blob sub_type 0 segment size 80,
    ADRESS_OBJECTA blob sub_type 0 segment size 80,
    ISPOLNIL_FIO varchar(250),
    ISPOLNIL_DOLGN varchar(100),
    PROVERIL_FIO varchar(250),
    PROVERIL_DOLGN varchar(100),
    UTVERDIL_FIO varchar(250),
    UTVERDIL_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    SUBPODR_ID_ORG integer,
    SUBPODR_NAME_ORG varchar(255),
    SUBPODR_ID integer,
    SUBPODR_FIO varchar(250),
    SUBPODR_DOLGN varchar(100),
    GLAVN_ING_FIO varchar(250),
    BOSS_FIO varchar(250),
    BOSS_DOLGN varchar(100),
    BOSS_OTDEL varchar(100),
    UTV integer,
    DORECALK integer,
    POPR_CURRENTGROUP integer,
    TRUD_SYNH_STR integer,
    TRUD_SYNH_MASH integer,
    MODE_KOMPNS_ST integer,
    CODE varchar(512),
    REPLACECORRECTION integer,
    CORRECTIONRULE integer,
    REVISION varchar(255),
    KODSTROYKI integer,
    APPLY_TO_ALL_IDLEVEL integer,
    APPLY_TO_ALL_IDLEVEL_SNB integer,
    AUTO_RENUM_MODE integer,
    AUTO_RENUM_START integer,
    AUTO_RENUM_STEP integer,
    SPEC_INFO integer)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
--DECLARE VARIABLE CUR_KODSTROYKI INTEGER;
DECLARE VARIABLE CUR_KODDOG INTEGER;
DECLARE VARIABLE CUR_KODSTROYKI_TYPE INTEGER;
DECLARE VARIABLE CUR_KODSTROYKI_NAME VARCHAR(255);
DECLARE VARIABLE tmpCount INTEGER;
begin

/* if ( not exists ( select h.number
                   from a_o_hier h
                   where h.number = :id and h.atype = 1 ) )
 then
 begin

  exception A_ELSTRUCTNOTFOUND;
  exit;

 end*/

 if ( not exists ( select p.number
                   from A_O_OBJECTPARAMS p
                   where p.number = :id ) )
 then
 begin

  exception AE_PARAM_NOT_FOUND;
  exit;

 end

 cur_koddog = null;
 kodstroyki = null;

 for select p.idtn, p.ISCLC, p.KODIR_GROUP, p.KODIR_PODGROUP, p.ID_TR, p.ID_ZONE,
            p.SAVECENZONETONORMBASE, p.INDEX_ID_ORG, p.INDEX_ID_GOD, p.INDEX_ID_MES,
            p.INDEX_NASNACHAUTO, p.INDEX_ZAMENNASNACH, p.INDEX_UCHITNDS, p.INDEX_SPOSOBRASCH,
            p.INDEX_RASCHNRISP, p.INDEX_BRAT_ZU_IS, p.INDEX_FOT, p.RES_ZANOSIT_S_RES,
            p.RES_TOLKO_NEUCHT_RES, p.RES_COPY_INDEX, p.RES_COPY_POPR, p.RES_COPY_FORMULS,
            p.RES_APPLY_TAB, p.NE_OBNUL_KOLL, p.NE_OBNUL_NR, p.NE_OBNUL_RES, p.NE_OBNUL_IND,
            p.NE_OBNUL_POPR, p.NE_OBNUL_FORMULS, p.NR_OT_ZPM, p.SP_OT_ZPM, p.PRECED, p.PRECIT,
            p.PUT_ID_GROUP, p.PUT_ID_RAB, p.PUT_ID_MASH, p.PUT_ID_MAT,
            p.KODSTROYKI, p.KODDOG, p.NUMGLSSR,
            p.SHIFR, p.FULLNAME,
            p.VELICHSTROBJ, p.EDIZM, p.STAD_PROEKT, p.NACH_STROY, p.OKONCH_STROIT,
            p.V_KAKIH_CENAH_MES, p.V_KAKIH_CENAH_GOD, p.SPISOKSHERT, p.OPISANIE,
            p.ADRESS_OBJECTA, p.ISPOLNIL_FIO, p.ISPOLNIL_DOLGN, p.PROVERIL_FIO,
            p.PROVERIL_DOLGN, p.UTVERDIL_FIO, p.UTVERDIL_DOLGN, p.ZAKAZCHIK_ID_ORG,
            p.ZAKAZCHIK_NAME_ORG, p.ZAKAZCHIK_ID, p.ZAKAZCHIK_FIO, p.ZAKAZCHIK_DOLGN,
            p.GENPODR_ID_ORG, p.GENPODR_NAME_ORG, p.GENPODR_ID, p.GENPODR_FIO, p.GENPODR_DOLGN,
            p.SUBPODR_ID_ORG, p.SUBPODR_NAME_ORG, p.SUBPODR_ID, p.SUBPODR_FIO, p.SUBPODR_DOLGN,
            p.GLAVN_ING_FIO, p.BOSS_FIO, p.BOSS_DOLGN, p.BOSS_OTDEL, p.utv, p.dorecalk,
            p.POPR_CURRENTGROUP, p.MODE_KOMPNS_ST, p.CODE,
            --CQ[9077]
            p.REPLACECORRECTION,
            p.CORRECTIONRULE,
            --CQ[9077]
            --CQ[9544]>>
            p.REVISION,
            p.APPLY_TO_ALL_IDLEVEL, --<<[12113]
            p.APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
            p.AUTO_RENUM_MODE, p.AUTO_RENUM_START, p.AUTO_RENUM_STEP, -- MK CQ[12020]
            p.SPEC_INFO /*15213*/
     from A_O_OBJECTPARAMS p
     where p.number = :id
     into :idtn, :ISCLC, :KODIR_GROUP, :KODIR_PODGROUP, :ID_TR, :ID_ZONE,
          :SAVECENZONETONORMBASE, :INDEX_ID_ORG, :INDEX_ID_GOD, :INDEX_ID_MES,
          :INDEX_NASNACHAUTO, :INDEX_ZAMENNASNACH, :INDEX_UCHITNDS, :INDEX_SPOSOBRASCH,
          :INDEX_RASCHNRISP, :INDEX_BRAT_ZU_IS, :INDEX_FOT, :RES_ZANOSIT_S_RES,
          :RES_TOLKO_NEUCHT_RES, :RES_COPY_INDEX, :RES_COPY_POPR, :RES_COPY_FORMULS,
          :RES_APPLY_TAB, :NE_OBNUL_KOLL, :NE_OBNUL_NR, :NE_OBNUL_RES, :NE_OBNUL_IND,
          :NE_OBNUL_POPR, :NE_OBNUL_FORMULS, :NR_OT_ZPM, :SP_OT_ZPM, :PRECED, :PRECIT,
          :PUT_ID_GROUP, :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT,
          :KODSTROYKI, :CUR_KODDOG, :NUMGLSSR,
          :SHIFR, :FULLNAME,
          :VELICHSTROBJ, :EDIZM, :STAD_PROEKT, :NACH_STROY, :OKONCH_STROIT,
          :V_KAKIH_CENAH_MES, :V_KAKIH_CENAH_GOD, :SPISOKSHERT, :OPISANIE,
          :ADRESS_OBJECTA, :ISPOLNIL_FIO, :ISPOLNIL_DOLGN, :PROVERIL_FIO,
          :PROVERIL_DOLGN, :UTVERDIL_FIO, :UTVERDIL_DOLGN, :ZAKAZCHIK_ID_ORG,
          :ZAKAZCHIK_NAME_ORG, :ZAKAZCHIK_ID, :ZAKAZCHIK_FIO, :ZAKAZCHIK_DOLGN,
          :GENPODR_ID_ORG, :GENPODR_NAME_ORG, :GENPODR_ID, :GENPODR_FIO, :GENPODR_DOLGN,
          :SUBPODR_ID_ORG, :SUBPODR_NAME_ORG, :SUBPODR_ID, :SUBPODR_FIO, :SUBPODR_DOLGN,
          :GLAVN_ING_FIO, :BOSS_FIO, :BOSS_DOLGN, :BOSS_OTDEL, :utv, :dorecalk,
          :POPR_CURRENTGROUP, :MODE_KOMPNS_ST, :CODE,
          --CQ[9077]
          :REPLACECORRECTION,
          :CORRECTIONRULE,
          --CQ[9077]
          --CQ[9544]>>
          :REVISION,
          :APPLY_TO_ALL_IDLEVEL, --<<[12113]
          :APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
          :AUTO_RENUM_MODE, :AUTO_RENUM_START, :AUTO_RENUM_STEP, -- MK CQ[12020]
          :SPEC_INFO /*15213*/
 do
 begin

  if ( not kodstroyki is null )
  then for select s.id_type, s.name
           from l_str_getnodehierarchy( :kodstroyki ) s
           into :CUR_kodstroyki_type, :CUR_kodstroyki_name
       do if ( CUR_kodstroyki_type = 1 )
          then name_stroyki = cur_kodstroyki_name;
          else if ( CUR_kodstroyki_type = 2 )
               then ochered_stroit = cur_kodstroyki_name;
               else if ( CUR_kodstroyki_type = 3 )
                    then pusk_komplex = cur_kodstroyki_name;

  if ( not cur_koddog is null )
  then for select s.id_type, s.name
           from l_str_getnodehierarchy( :cur_koddog ) s
           into :CUR_kodstroyki_type, :CUR_kodstroyki_name
       do if ( CUR_kodstroyki_type = 4 )
          then dogovor = cur_kodstroyki_name;

  trud_synh_str  = 1;
  trud_synh_mash = 1;


  /* MK 15.11.2004 */
  if ((:ID_TR is not null) and (:ID_TR <> 0)) then
  begin
     select count(*)
     from A_SRF_TR
     where (ID = :ID_TR)
     into :tmpCount;

     if (tmpCount = 0) then
        ID_TR = 0;
  end



  suspend;
  exit;

 end
end^

/*15213*/
create or alter procedure L_H_GETOBJECT_PROCENT_PARAM (
    IDUSER integer,
    ID integer)
returns (
    IDTN integer,
    ISCLC integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ID_TR integer,
    ID_ZONE integer,
    SAVECENZONETONORMBASE integer,
    INDEX_ID_ORG integer,
    INDEX_ID_GOD integer,
    INDEX_ID_MES integer,
    INDEX_NASNACHAUTO integer,
    INDEX_ZAMENNASNACH integer,
    INDEX_UCHITNDS integer,
    INDEX_SPOSOBRASCH integer,
    INDEX_RASCHNRISP integer,
    INDEX_BRAT_ZU_IS integer,
    INDEX_FOT integer,
    RES_ZANOSIT_S_RES integer,
    RES_TOLKO_NEUCHT_RES integer,
    RES_COPY_INDEX integer,
    RES_COPY_POPR integer,
    RES_COPY_FORMULS integer,
    RES_APPLY_TAB integer,
    NE_OBNUL_KOLL integer,
    NE_OBNUL_NR integer,
    NE_OBNUL_RES integer,
    NE_OBNUL_IND integer,
    NE_OBNUL_POPR integer,
    NE_OBNUL_FORMULS integer,
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision,
    PRECED integer,
    PRECIT integer,
    PUT_ID_GROUP integer,
    PUT_ID_RAB integer,
    PUT_ID_MASH integer,
    PUT_ID_MAT integer,
    NAME_STROYKI varchar(255),
    OCHERED_STROIT varchar(255),
    PUSK_KOMPLEX varchar(255),
    NUMGLSSR integer,
    DOGOVOR varchar(255),
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VELICHSTROBJ double precision,
    EDIZM varchar(40),
    STAD_PROEKT integer,
    NACH_STROY date,
    OKONCH_STROIT date,
    V_KAKIH_CENAH_MES integer,
    V_KAKIH_CENAH_GOD integer,
    SPISOKSHERT blob sub_type 0 segment size 80,
    OPISANIE blob sub_type 0 segment size 80,
    ADRESS_OBJECTA blob sub_type 0 segment size 80,
    ISPOLNIL_FIO varchar(250),
    ISPOLNIL_DOLGN varchar(100),
    PROVERIL_FIO varchar(250),
    PROVERIL_DOLGN varchar(100),
    UTVERDIL_FIO varchar(250),
    UTVERDIL_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    SUBPODR_ID_ORG integer,
    SUBPODR_NAME_ORG varchar(255),
    SUBPODR_ID integer,
    SUBPODR_FIO varchar(250),
    SUBPODR_DOLGN varchar(100),
    GLAVN_ING_FIO varchar(250),
    BOSS_FIO varchar(250),
    BOSS_DOLGN varchar(100),
    BOSS_OTDEL varchar(100),
    UTV_DATE date,
    OPLACHEN integer,
    OPL_SUM double precision,
    OPL_DATE date,
    NOMERDOC varchar(40),
    INVESTOR_KODOKPO varchar(40),
    INVESTOR_NAME varchar(255),
    INVESTOR_ID_ORG integer,
    INVESTOR_ID integer,
    INVESTOR_FIO varchar(250),
    INVESTOR_DOLGN varchar(100),
    ZAK_KODOKPO varchar(40),
    SUBPODR_KODOKPO varchar(40),
    STROYKA_KODOKPO varchar(40),
    OBJECT_KODOKPO varchar(40),
    VIDDEYATOKPD varchar(40),
    DOGPODR_NOMER varchar(40),
    DOGPODR_DATE date,
    VIDOPER varchar(40),
    OBJECT_NAME varchar(1024),
    LYEAR integer,
    LMONTH integer,
    USE_ONLY_UTV_PROCENT integer,
    UTV integer,
    DORECALK integer,
    POPR_CURRENTGROUP integer,
    TRUD_SYNH_STR integer,
    TRUD_SYNH_MASH integer,
    MODE_KOMPNS_ST integer,
    CODE varchar(512),
    GENPODR_KODOKPO varchar(40),
    REPLACECORRECTION integer,
    CORRECTIONRULE integer,
    NRSPOTZPM_USED integer,
    REVISION varchar(255),
    APPLY_TO_ALL_IDLEVEL integer,
    APPLY_TO_ALL_IDLEVEL_SNB integer,
    AUTO_RENUM_MODE integer,
    AUTO_RENUM_START integer,
    AUTO_RENUM_STEP integer,
    SPEC_INFO integer)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME, OBJECT_NAME
DECLARE VARIABLE ID_OBJ INTEGER;
DECLARE VARIABLE ATYPE INTEGER;
DECLARE VARIABLE Y_MONTH INTEGER;
DECLARE VARIABLE Y_YEAR INTEGER;
DECLARE VARIABLE INBASKET INTEGER;
DECLARE VARIABLE CUR_KODSTROYKI INTEGER;
declare variable tmp_parent integer;
declare variable tmp_atype integer;
--[10111]    GOD_VID_NB integer,
begin
   ATYPE = null;
   for select h.atype from a_o_hier h where h.number = :id into :ATYPE
   do
     ATYPE = ATYPE;
     --cq[11569]
    -- isinexchange = 0;
     if ( ATYPE is null ) then
     begin
       ATYPE = 1;
       ID_OBJ = ID;
     end
     else if ( ATYPE = 1 ) then -- exception A_ELSTRUCTNOTFOUND;
     begin
--      ID_OBJ = ID;
       execute procedure a_h_get_id_parentatype( :id, 1 ) returning_values ( :id_obj );
     end
   else if ( ATYPE = 8 ) then
   begin
      id_obj = null;
      execute procedure a_h_get_id_parentatype( :id, 1 ) returning_values ( :id_obj );
      if ( ( id_obj is null ) or ( id_obj <= 0 ) ) then
      begin
         id_obj = null;
         execute procedure a_h_inbasket ( :id ) returning_values ( :inbasket );
         if ( inbasket = 0 ) then
            exception A_ELSTRUCTNOTFOUND;
      end
   end

  /* chinger: please do not delete
  for select p.parent
       from a_h_parentslist(:iduser, :id) p
   into :tmp_parent
   do begin
     isinexchange = iif((:tmp_parent = 517) or (isinexchange = 1) , 1, 0);
   end    */

   if ( not id_obj is null ) then
      if ( not exists ( select p.number
                        from A_O_OBJECTPARAMS p
                        where p.number = :id_obj ) ) then
         exception AE_PARAM_NOT_FOUND;

   if ( ATYPE = 8 ) then
      if ( not exists ( select p.number
                        from a_o_factparams p
                        where p.number = :id ) ) then
         exception AE_PARAM_NOT_FOUND;


   -- MK 4.07.2011 CQ[9295]
   --[10111]execute procedure T_GETGODVIDNB(:IDUSER, :id_obj) returning_values(:GOD_VID_NB);
   execute procedure T_GET_USENRSPOTZPM(:id_obj) returning_values :NRSPOTZPM_USED;

 /* read params for object */
   if ( not id_obj is null ) then
     for select
         IDTN, ISCLC, KODIR_GROUP, KODIR_PODGROUP, ID_TR, ID_ZONE,
         SAVECENZONETONORMBASE, INDEX_ID_ORG, INDEX_ID_GOD, INDEX_ID_MES,
         INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS, INDEX_SPOSOBRASCH,
         INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS, INDEX_FOT, RES_ZANOSIT_S_RES,
         RES_TOLKO_NEUCHT_RES, RES_COPY_INDEX, RES_COPY_POPR, RES_COPY_FORMULS,
         RES_APPLY_TAB, NE_OBNUL_KOLL, NE_OBNUL_NR, NE_OBNUL_RES, NE_OBNUL_IND,
         NE_OBNUL_POPR, NE_OBNUL_FORMULS, NR_OT_ZPM, SP_OT_ZPM, PRECED, PRECIT,
         PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT, NAME_STROYKI,
         OCHERED_STROIT, PUSK_KOMPLEX, NUMGLSSR, DOGOVOR, SHIFR, FULLNAME,
         VELICHSTROBJ, EDIZM, STAD_PROEKT, NACH_STROY, OKONCH_STROIT,
         V_KAKIH_CENAH_MES, V_KAKIH_CENAH_GOD, SPISOKSHERT, OPISANIE,
         ADRESS_OBJECTA, ISPOLNIL_FIO, ISPOLNIL_DOLGN, PROVERIL_FIO,
         PROVERIL_DOLGN, UTVERDIL_FIO, UTVERDIL_DOLGN, ZAKAZCHIK_ID_ORG,
         ZAKAZCHIK_NAME_ORG, ZAKAZCHIK_ID, ZAKAZCHIK_FIO, ZAKAZCHIK_DOLGN,
         GENPODR_ID_ORG, GENPODR_NAME_ORG, GENPODR_ID, GENPODR_FIO, GENPODR_DOLGN,
         SUBPODR_ID_ORG, SUBPODR_NAME_ORG, SUBPODR_ID, SUBPODR_FIO, SUBPODR_DOLGN,
         GLAVN_ING_FIO, BOSS_FIO, BOSS_DOLGN, BOSS_OTDEL, UTV, DORECALK,
         POPR_CURRENTGROUP, TRUD_SYNH_STR, TRUD_SYNH_MASH, MODE_KOMPNS_ST, CODE,
         REPLACECORRECTION, CORRECTIONRULE,
         REVISION,
         KODSTROYKI,
         APPLY_TO_ALL_IDLEVEL, --<<[12113]
         APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
         AUTO_RENUM_MODE, AUTO_RENUM_START, AUTO_RENUM_STEP, -- MK CQ[12020]
         SPEC_INFO
     from A_H_GETOBJECTPARAM ( :IDUSER , :ID_OBJ )
       into
         IDTN, ISCLC, KODIR_GROUP, KODIR_PODGROUP, ID_TR, ID_ZONE,
         SAVECENZONETONORMBASE, INDEX_ID_ORG, INDEX_ID_GOD, INDEX_ID_MES,
         INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS, INDEX_SPOSOBRASCH,
         INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS, INDEX_FOT, RES_ZANOSIT_S_RES,
         RES_TOLKO_NEUCHT_RES, RES_COPY_INDEX, RES_COPY_POPR, RES_COPY_FORMULS,
         RES_APPLY_TAB, NE_OBNUL_KOLL, NE_OBNUL_NR, NE_OBNUL_RES, NE_OBNUL_IND,
         NE_OBNUL_POPR, NE_OBNUL_FORMULS, NR_OT_ZPM, SP_OT_ZPM, PRECED, PRECIT,
         PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT, NAME_STROYKI,
         OCHERED_STROIT, PUSK_KOMPLEX, NUMGLSSR, DOGOVOR, SHIFR, FULLNAME,
         VELICHSTROBJ, EDIZM, STAD_PROEKT, NACH_STROY, OKONCH_STROIT,
         V_KAKIH_CENAH_MES, V_KAKIH_CENAH_GOD, SPISOKSHERT, OPISANIE,
         ADRESS_OBJECTA, ISPOLNIL_FIO, ISPOLNIL_DOLGN, PROVERIL_FIO,
         PROVERIL_DOLGN, UTVERDIL_FIO, UTVERDIL_DOLGN, ZAKAZCHIK_ID_ORG,
         ZAKAZCHIK_NAME_ORG, ZAKAZCHIK_ID, ZAKAZCHIK_FIO, ZAKAZCHIK_DOLGN,
         GENPODR_ID_ORG, GENPODR_NAME_ORG, GENPODR_ID, GENPODR_FIO, GENPODR_DOLGN,
         SUBPODR_ID_ORG, SUBPODR_NAME_ORG, SUBPODR_ID, SUBPODR_FIO, SUBPODR_DOLGN,
         GLAVN_ING_FIO, BOSS_FIO, BOSS_DOLGN, BOSS_OTDEL, utv, dorecalk,
         POPR_CURRENTGROUP, TRUD_SYNH_STR, TRUD_SYNH_MASH, MODE_KOMPNS_ST, CODE,
         --CQ[9077]
         :REPLACECORRECTION, :CORRECTIONRULE,
         --CQ[9077]
         --CQ[9544]>>
         :REVISION,
         :CUR_KODSTROYKI,
         :APPLY_TO_ALL_IDLEVEL, --<<[12113]
         :APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
         :AUTO_RENUM_MODE, :AUTO_RENUM_START, :AUTO_RENUM_STEP, -- MK CQ[12020],
         :SPEC_INFO /*15213*/
   do
   begin
      OBJECT_NAME = FULLNAME;
   end

      /* read params for procentov. */
      if ( ATYPE = 8 ) then
       for select
         IDTN, ISCLC, KODIR_GROUP, KODIR_PODGROUP, ID_TR, ID_ZONE,
         SAVECENZONETONORMBASE, INDEX_ID_ORG, INDEX_ID_GOD, INDEX_ID_MES,
         INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS, INDEX_SPOSOBRASCH,
         INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS, INDEX_FOT, RES_ZANOSIT_S_RES,
         RES_TOLKO_NEUCHT_RES, RES_COPY_INDEX, RES_COPY_POPR, RES_COPY_FORMULS,
         RES_APPLY_TAB, NE_OBNUL_KOLL, NE_OBNUL_NR, NE_OBNUL_RES, NE_OBNUL_IND,
         NE_OBNUL_POPR, NE_OBNUL_FORMULS, NR_OT_ZPM, SP_OT_ZPM, PRECED, PRECIT,
         PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT,
         SHIFR, FULLNAME,
         OPISANIE,
         ISPOLNIL_FIO, ISPOLNIL_DOLGN, PROVERIL_FIO,
         PROVERIL_DOLGN, UTVERDIL_FIO, UTVERDIL_DOLGN, ZAKAZCHIK_ID_ORG,
         ZAKAZCHIK_NAME_ORG, ZAKAZCHIK_ID, ZAKAZCHIK_FIO, ZAKAZCHIK_DOLGN,
         GENPODR_ID_ORG, GENPODR_NAME_ORG, GENPODR_ID, GENPODR_FIO, GENPODR_DOLGN,
         SUBPODR_ID_ORG, SUBPODR_NAME_ORG, SUBPODR_ID, SUBPODR_FIO, SUBPODR_DOLGN,
         UTV_DATE, OPLACHEN, OPL_SUM, OPL_DATE, NOMERDOC, INVESTOR_KODOKPO,
         INVESTOR_NAME, INVESTOR_ID_ORG, INVESTOR_ID, INVESTOR_FIO, INVESTOR_DOLGN,
         ZAK_KODOKPO, SUBPODR_KODOKPO, STROYKA_KODOKPO, OBJECT_KODOKPO,
         VIDDEYATOKPD, DOGPODR_NOMER, DOGPODR_DATE, VIDOPER, USE_ONLY_UTV_PROCENT,
         utv, dorecalk,
         POPR_CURRENTGROUP,
         MODE_KOMPNS_ST, CODE,
         GENPODR_KODOKPO, -- CQ[TIMUR 6902]
         --CQ[9077]
         0, --REPLACECORRECTION,
         0, --CORRECTIONRULE
         --CQ[9077]
         --CQ[9544]>>
         '',
         APPLY_TO_ALL_IDLEVEL, --<<[12113]
         APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
         AUTO_RENUM_MODE, AUTO_RENUM_START, AUTO_RENUM_STEP -- MK CQ[12020]
       from a_o_factparams
       where number = :id
       into
         IDTN, ISCLC, KODIR_GROUP, KODIR_PODGROUP, ID_TR, ID_ZONE,
         SAVECENZONETONORMBASE, INDEX_ID_ORG, INDEX_ID_GOD, INDEX_ID_MES,
         INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS, INDEX_SPOSOBRASCH,
         INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS, INDEX_FOT, RES_ZANOSIT_S_RES,
         RES_TOLKO_NEUCHT_RES, RES_COPY_INDEX, RES_COPY_POPR, RES_COPY_FORMULS,
         RES_APPLY_TAB, NE_OBNUL_KOLL, NE_OBNUL_NR, NE_OBNUL_RES, NE_OBNUL_IND,
         NE_OBNUL_POPR, NE_OBNUL_FORMULS, NR_OT_ZPM, SP_OT_ZPM, PRECED, PRECIT,
         PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT,
         SHIFR, FULLNAME,
         OPISANIE,
         ISPOLNIL_FIO, ISPOLNIL_DOLGN, PROVERIL_FIO,
         PROVERIL_DOLGN, UTVERDIL_FIO, UTVERDIL_DOLGN, ZAKAZCHIK_ID_ORG,
         ZAKAZCHIK_NAME_ORG, ZAKAZCHIK_ID, ZAKAZCHIK_FIO, ZAKAZCHIK_DOLGN,
         GENPODR_ID_ORG, GENPODR_NAME_ORG, GENPODR_ID, GENPODR_FIO, GENPODR_DOLGN,
         SUBPODR_ID_ORG, SUBPODR_NAME_ORG, SUBPODR_ID, SUBPODR_FIO, SUBPODR_DOLGN,
         UTV_DATE, OPLACHEN, OPL_SUM, OPL_DATE, NOMERDOC, INVESTOR_KODOKPO,
         INVESTOR_NAME, INVESTOR_ID_ORG, INVESTOR_ID, INVESTOR_FIO, INVESTOR_DOLGN,
         ZAK_KODOKPO, SUBPODR_KODOKPO, STROYKA_KODOKPO, OBJECT_KODOKPO,
         VIDDEYATOKPD, DOGPODR_NOMER, DOGPODR_DATE, VIDOPER, USE_ONLY_UTV_PROCENT,
         utv, dorecalk,
         POPR_CURRENTGROUP,
         MODE_KOMPNS_ST, CODE,
         GENPODR_KODOKPO, -- CQ[TIMUR 6902]
         --CQ[9077]
         :REPLACECORRECTION,
         :CORRECTIONRULE,
         --CQ[9077]
         --CQ[9544]>>
         :REVISION,
         :APPLY_TO_ALL_IDLEVEL, --<<[12113]
         :APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
         :AUTO_RENUM_MODE, :AUTO_RENUM_START, :AUTO_RENUM_STEP -- MK CQ[12020]
         do                       
         begin
            /* MK CQ[3493] 14.06.2006 */
            --FULLNAME = SHIFR;

            for select parent from a_o_hier where number = :id
                into y_month
            do
                y_month = y_month;

            for select sorting , parent from a_o_hier where number = :y_month
                into  lmonth , y_year
            do
               for select sorting from a_o_hier where number = :y_year
                   into  lyear
               do
                  lyear = lyear;


            /* MK 15.11.2004, semenov - 2004/12/06 */
            if (:ID_TR <> 0) then
            if (not exists (select * from A_SRF_TR where ID = :ID_TR)) then
             ID_TR = 0;

            suspend;
            exit;
         end

      suspend;
      exit;
end^

--[15213]
-- 
create or alter procedure IS_SPEC_REC (
    FIND_CHILD integer,
    ID_REC integer,
    SMETATYPE integer)
returns (
    SPEC_ISKS_NS_ID integer,
    SPEC_ID_REC integer,
    SPEC_IDHIER integer)
AS
begin
          exit;
end
^

--[15213]
-- 
create or alter procedure ALLOW_EDIT_SPEC_REC (
    ID_REC integer,
    IDUSER integer)
returns (
    RESULT integer)
AS
begin
  --suspend;
  exit;
end
^

--[15213]
create or alter procedure M_UTV_SMETA_RECS (
    NUMBER integer,
    UTV integer,
    SMETATYPE integer,
    ID_USER integer)
returns (
    ID_UTV_RABOTY integer,
    ID_READ_ONLY_SPEC_REC integer)
AS
declare variable VN_ID integer;
declare variable VN_HAVE_VIP integer;
declare variable VN_ALLOW_EDIT_SPEC_REC integer;
begin
   /*    */
   if (UTV = 1) then
   begin
      update A_SMETA s
      set s.utv = 1
      where (s.idhier = :NUMBER) and (s.atype = 17) and (s.smetatype = :SMETATYPE);
   end
   else
   /*    */
   if (UTV = 0) then
   begin

      for select s.id
      from a_smeta s
      where (s.idhier = :NUMBER) and (s.atype = 17) and (s.smetatype = :SMETATYPE)
      into :VN_ID do
      begin

         execute procedure M_IS_SMETA_REC_HAVE_VIP(:VN_ID)
         returning_values :VN_HAVE_VIP;

         /*     ,       */
         if (VN_HAVE_VIP = 0) then
            -- ...
            ID_UTV_RABOTY = null;
         else
            ID_UTV_RABOTY = :VN_ID;

         /*     ,       [15213]*/
         execute procedure ALLOW_EDIT_SPEC_REC(:VN_ID, :ID_USER)
         returning_values :VN_ALLOW_EDIT_SPEC_REC;

         if (VN_ALLOW_EDIT_SPEC_REC = 1) then
            -- ...
            ID_READ_ONLY_SPEC_REC = null;
         else
            ID_READ_ONLY_SPEC_REC = :VN_ID;

         if ( (ID_UTV_RABOTY is not null) or (ID_READ_ONLY_SPEC_REC is not null) ) then
           suspend;
         else
            update A_SMETA s1
            set s1.utv = 0
            where (s1.id = :VN_ID);
      end
   end
end^

--[15213]
-- 
CREATE OR ALTER PROCEDURE A_S_DELETERECS (
    IDUSER INTEGER,
    COUNTREC INTEGER,
    IDRECS BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SMETATYPE INTEGER,
    APPLY_POPR_MODE INTEGER)
RETURNS (
    IDHIER DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    UTV_FAILCOUNT INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15213]
create or alter procedure M_UTV_ELEM_STRUCT_ONE_REC (
    NUMBER integer,
    ATYPE integer,
    UTV integer,
    SMETATYPE integer,
    ID_USER integer)
returns (
    ID_UTV_RABOTY integer,
    ID_READ_ONLY_SPEC_REC integer)
AS
begin
   /* 1.   */
   /*   */
   if (SMETATYPE = 15) then
   begin
      /*  */
     if (ATYPE = 1) then
      update a_o_objectparams p
      set p.utv = :UTV
      where (p.NUMBER = :NUMBER);

      /*  */
      if (ATYPE = 3) then
      update a_o_params_ls p
      set p.utv = :UTV
      where (p.id = :NUMBER);

      /* ,  */
      if (ATYPE in (4, 5)) then
      update a_o_params_r_pr p
      set p.utv = :UTV
      where (p.id = :NUMBER);
   end
   /*  */
   else
   begin
      /*  */
     if (ATYPE = 1) then
      update a_o_factparams p
      set p.utv = :UTV
      where (p.NUMBER = :NUMBER);

      /* , ,  */
      if (ATYPE in (3, 4, 5)) then
      begin
         if (:UTV = 1) then
         begin
            if (not exists (select * from M_UTV_STRUCT_ELEM_IN_AKT m
                       where (m.id_struct = :NUMBER) and (m.id_akt = :SMETATYPE))) then

               insert into M_UTV_STRUCT_ELEM_IN_AKT (id_struct, id_akt)
                      values (:NUMBER, :SMETATYPE);
         end
         else
            delete from M_UTV_STRUCT_ELEM_IN_AKT m
            where (m.id_struct = :NUMBER) and (m.id_akt = :SMETATYPE);

      end
   end

   /* 2.      */
   for select ID_UTV_RABOTY, ID_READ_ONLY_SPEC_REC
   from M_UTV_SMETA_RECS(:NUMBER, :UTV, :SMETATYPE, :ID_USER)
   into :ID_UTV_RABOTY, ID_READ_ONLY_SPEC_REC do
      suspend;
end^

--[15213]
create or alter procedure M_UTV_ELEM_STRUCT (
    NUMBER integer,
    UTV integer,
    SMETATYPE integer,
    ID_USER integer)
returns (
    ID_UTV_RABOTY integer,
    ID_READ_ONLY_SPEC_REC integer)
AS
declare variable vn_number integer;
declare variable vn_atype integer;
declare variable vn_id_obj integer;
begin
   select first 1 a.atype
   from a_o_hier a
   where (a.number = :NUMBER)
   into :vn_atype;

   /*   */
   for select ID_UTV_RABOTY, ID_READ_ONLY_SPEC_REC
   from M_UTV_ELEM_STRUCT_ONE_REC(:NUMBER, :vn_atype, :UTV, :SMETATYPE, :ID_USER)
   into :ID_UTV_RABOTY, :ID_READ_ONLY_SPEC_REC do
      suspend;

   /*   */
   if ((SMETATYPE <> 15) and (vn_atype = 8)) then
      execute procedure A_H_GET_ID_PARENTATYPE :NUMBER, 1
      returning_values :vn_id_obj;
   else
      vn_id_obj = NUMBER;


   for select a.NUMSTRUCT, a.atype
   from A_H_SELTREE(:ID_USER, :vn_id_obj, 0, 1) a
   where (a.atype in (3, 4, 5))
   into :vn_number, :vn_atype do
   begin
      for select ID_UTV_RABOTY, ID_READ_ONLY_SPEC_REC
      from M_UTV_ELEM_STRUCT_ONE_REC(:vn_number, :vn_atype, :UTV, :SMETATYPE, :ID_USER)
      into :ID_UTV_RABOTY, :ID_READ_ONLY_SPEC_REC do
         suspend;
   end
end^

--[15213]
-- 
create or alter procedure MARK_SPEC_EDIT_MODE (
    IDUSER integer,
    NUMBER integer,
    EDIT_MODE_VALUE integer)
AS
begin
  exit;
end
^




-- CQ[15102, 15103]
-- 
CREATE OR ALTER PROCEDURE L_SC_READ_ONE_HIER_NL (
    IN_SMETATYPE INTEGER,
    IN_IDHIER INTEGER,
    ID_USER INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    ATYPE INTEGER,
    VRPZ INTEGER,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    RLM DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    RN DOUBLE PRECISION,
    RO DOUBLE PRECISION,
    RP DOUBLE PRECISION,
    R25 DOUBLE PRECISION,
    R26 DOUBLE PRECISION,
    R27 DOUBLE PRECISION,
    R28 DOUBLE PRECISION,
    R29 DOUBLE PRECISION,
    TIPRAB INTEGER,
    VIDRAB INTEGER,
    UTV INTEGER,
    CLCMODE INTEGER,
    RABMAT INTEGER,
    CB DOUBLE PRECISION,
    CURR_CENA DOUBLE PRECISION,
    TRANSP DOUBLE PRECISION,
    ZAG_SKL DOUBLE PRECISION,
    ZAPCHAST DOUBLE PRECISION,
    TARA DOUBLE PRECISION,
    NACEN DOUBLE PRECISION,
    COMPLECT DOUBLE PRECISION,
    KOEFF_TYPE INTEGER,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^


-- CQ[15102, 15103]
-- 
CREATE OR ALTER PROCEDURE M_READ_SMETA_TO_CACHE (
    IN_ID_OBJ INTEGER,
    IN_SMETATYPE INTEGER,
    IN_ID_USER INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    ATYPE INTEGER,
    VRPZ INTEGER,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    RLM DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    RN DOUBLE PRECISION,
    RO DOUBLE PRECISION,
    RP DOUBLE PRECISION,
    R25 DOUBLE PRECISION,
    R26 DOUBLE PRECISION,
    R27 DOUBLE PRECISION,
    R28 DOUBLE PRECISION,
    R29 DOUBLE PRECISION,
    TIPRAB INTEGER,
    VIDRAB INTEGER,
    UTV INTEGER,
    CLCMODE INTEGER,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION,
    RABMAT INTEGER,
    CB DOUBLE PRECISION,
    CURR_CENA DOUBLE PRECISION,
    TRANSP DOUBLE PRECISION,
    ZAG_SKL DOUBLE PRECISION,
    ZAPCHAST DOUBLE PRECISION,
    TARA DOUBLE PRECISION,
    NACEN DOUBLE PRECISION,
    COMPLECT DOUBLE PRECISION,
    KOEFF_TYPE INTEGER)
AS
BEGIN
  SUSPEND;
END
^


-- CQ[15102, 15103]
-- 
CREATE OR ALTER PROCEDURE M_READ_LZ_CACHE (
    IN_ID_OBJ INTEGER,
    IN_SMETATYPE INTEGER,
    IN_ID_USER INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    ATYPE INTEGER,
    NUMBER INTEGER,
    ITOG DOUBLE PRECISION,
    PRECIS INTEGER,
    FORMULA_S VARCHAR(100),
    VID INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--------------------------------------------------------------------
--                           10.0.0.4, 9.2.1.4
--------------------------------------------------------------------

--[15220]
create or alter procedure S_UPGRADE_KKS_SHIFR_LSR_MOVING (
    IDLS integer)
returns (
    IRESULT integer)
AS
declare MOVE_SHIFR_TO_LSR integer;
begin
  select INT_VALUE
    from M_GET_GLOBAL_PARAM('MOVE_SHIFR_TO_LSR_15220')
    into :MOVE_SHIFR_TO_LSR;

  if (:MOVE_SHIFR_TO_LSR <> 0) then
  begin
    update A_O_PARAMS_LS
    set NUMLSR_LS = SHIFR,
        SHIFR = null
    where ID = :IDLS
      and coalesce(NUMLSR_LS, '') = ''
      and SHIFR <> ''
      and SHIFR not like '____._.___._.______._____.___.__.____';

    IRESULT = row_count;
  end

  suspend;
end
^

--------------------------------------------------------------------
--                           10.0.0.5, 9.2.1.5
--------------------------------------------------------------------

-- MK  
create or alter procedure M_H_CHECKALL_FOR_CLASS (
    IDUSER integer,
    IDOBJ integer,
    SMETATYPE integer)
AS
DECLARE VARIABLE CUR_NUMBER INTEGER;
begin
  -- MK ( 2016 .)    
  --        
  --     A_H_CHECKALL_FOR_CLASS,  
  --     (IDHIER =  )

  --    
  execute procedure a_h_inserthiercheck(:iduser,
                                        :IDOBJ,
                                        :SMETATYPE,
                                        :IDOBJ,
                                        25);

  --      
  for select p.number
  from A_O_HIER_SELECT_STRUCT(:iduser, :IDOBJ) p
  into :CUR_NUMBER do
  begin
    --      
    execute procedure a_h_inserthiercheck(:iduser,
                                          :IDOBJ,
                                          :SMETATYPE,
                                          :CUR_NUMBER,
                                          15);

    --     
    execute procedure a_h_inserthiercheck(:iduser,
                                          :IDOBJ,
                                          :SMETATYPE,
                                          :CUR_NUMBER,
                                          25);
  end
end
^

/* Denis CQ[15075] >> */
-- 
create or alter procedure ATOM_XML_GET_SSR_DOMAIN (
    ID_SSR integer,
    IDUSER integer)
returns (
    ID integer,
    ATYPE integer,
    ID_OBJ integer,
    SORTING integer)
AS
begin
        suspend;
end
^


-- MK:  
create or alter procedure M_SRF_VARS_IMP_XML (
    ID_MASTER integer,
    NUMBER integer,
    AVAR varchar(30),
    NAME varchar(250),
    ITOG double precision,
    ID_PARENT integer,
    DO_PRINT integer,
    PRINT_COMMENT blob sub_type 1 segment size 80,
    TYPE_ITOG integer,
    DOC_BLOB_NAME blob sub_type 1 segment size 80)
returns (
    ID_SELF integer)
AS
begin
  --     
  ID_SELF = null;
  select first 1 v.ID
  from A_SRF_VARS v
  where (v.id_master = :id_master) and
        (UPPER(v.avar collate pxw_cyrl) = UPPER(:avar collate pxw_cyrl))
  into :ID_SELF;

  --   - 
  if (ID_SELF is null) then
  begin
    ID_SELF = GEN_ID(a_g_smeta, 1);

    insert into A_SRF_VARS (ID,  ID_MASTER,  AVAR,  NUMBER,  NAME, ITOG, ID_PARENT,
                            do_print, print_comment, TYPE_ITOG,  DOC_BLOB_NAME)
    values (:ID_SELF, :ID_MASTER, :AVAR, :NUMBER, :NAME, :ITOG, :ID_PARENT,
            :do_print, :print_comment, :TYPE_ITOG,  :DOC_BLOB_NAME);
  end

  --  - 
  else
  begin
    update A_SRF_VARS a
    set a.NUMBER = :NUMBER,
        a.AVAR = :AVAR,
        a.NAME = :NAME,
        a.ITOG = :ITOG,
        a.ID_PARENT = :ID_PARENT,
        a.DO_PRINT = :DO_PRINT,
        a.PRINT_COMMENT = :PRINT_COMMENT,
        a.TYPE_ITOG = :TYPE_ITOG,
        a.DOC_BLOB_NAME = :DOC_BLOB_NAME

    where (a.id = :ID_SELF) and (a.ID_MASTER = :ID_MASTER);
  end
end
^


-- MK:  
create or alter procedure L_IMP_LEVEL_PARAMS (
    ID_LEVEL integer,
    ID_MASTER integer,
    ID_SRFVAR integer,
    ITOG double precision)
returns (
    OUT_ID integer)
AS
begin
  -- MK      
  OUT_ID = null;
  select first 1 ID
  from LEVEL_PARAMS
  where (ID_LEVEL = :ID_LEVEL) and (ID_MASTER = :ID_MASTER) and (ID_SRFVAR = :ID_SRFVAR)
  into :OUT_ID;

  if (OUT_ID is null) then
  begin
    OUT_ID = GEN_ID(A_G_SMETA, 1);

    insert into LEVEL_PARAMS (ID, ID_LEVEL, ID_MASTER, ID_SRFVAR, ITOG)
    values (:OUT_ID, :ID_LEVEL, :ID_MASTER, :ID_SRFVAR, :ITOG);
  end

  else
  begin
    update LEVEL_PARAMS
    set ITOG = :ITOG
    where (ID = :OUT_ID);
  end

  suspend;


--  
--    OUT_ID = GEN_ID(A_G_SMETA,1);
--
--  --<[14113]>
--  if (not exists(
--      select * from LEVEL_PARAMS
--        where ID_LEVEL=:ID_LEVEL
--          and ID_MASTER=:ID_MASTER
--          and ID_SRFVAR=:ID_SRFVAR)) then
--  --</[14113]>
--    insert into LEVEL_PARAMS (ID, ID_LEVEL, ID_MASTER, ID_SRFVAR, ITOG)
--    values (:OUT_ID, :ID_LEVEL, :ID_MASTER, :ID_SRFVAR, :ITOG);
--
--    suspend;
end
^


-- MK:  
create or alter procedure LEVEL_COST_LIST_EXP (
    ID_CLASS integer)
returns (
    ID integer)
AS
declare variable ATYPE integer;
begin
  ATYPE = null;
  select ATYPE
  from A_O_HIER
  where NUMBER = :ID_CLASS
  into :ATYPE;
  if (ATYPE = 1) then
  begin
    execute procedure M_GET_AKT_CENLVL(:ID_CLASS)
    returning_values :ID;
    suspend;
  end
  else
  if (ATYPE = 8) then
  begin
    for select ID
      from LEVEL_COST
      where IDOBJECT = :ID_CLASS
      order by LORDER --      
      into :ID
    do
      suspend;
  end
end
^


-- MK:   
create or alter procedure LEVEL_COST_LIST_EXP1 (
    ID_CLASS integer)
returns (
    ID integer)
AS
begin
    -- <-- Voyager CQ[9758]
    --  LEVEL_COST_LIST_EXP,      XML
    for select ID
      from LEVEL_COST
      where IDOBJECT = :ID_CLASS
      order by LORDER --      
      into :ID
    do
      suspend;
end
^


-- MK:  
create or alter procedure ATOM_XML_GET_DOMAIN_COUNT (
    ID integer,
    ATYPE integer)
returns (
    DOMAIN_COUNT integer)
AS
declare variable IDHIER integer;
declare variable SMETATYPE integer;
declare variable CNT integer;
declare variable ID_OBJECT integer;
begin
  --      -------------------------------------
  DOMAIN_COUNT = 0;
  if ((ATYPE = 1) or (ATYPE = 3)) then -- ObgectType, LSType
  begin
    SMETATYPE = 15;-- PSType
    -- 
    for select IDHIER
      --     ,     
      from M_O_HIER_SELECT(:ID)
      --from S_O_HIER_SELECT2(:ID)
      into :IDHIER
    do
    begin
      CNT = 0;
      select count(*)
      from A_SMETA
      where IDHIER = :IDHIER and
            smetatype = :SMETATYPE
      into :CNT;
      DOMAIN_COUNT = :DOMAIN_COUNT + :CNT;
      DOMAIN_COUNT = :DOMAIN_COUNT + 1;-- +    - 
    end
  end
  --else
  --if (ATYPE = 3) then -- LSType
  --begin
  --  -- TODO ..           
  --end
  else
  if (ATYPE = 8) then -- ExecType
  begin
    --  ID 
    select RES_ID from A_H_GET_ID_PARENTATYPE(:ID, 1) into :ID_OBJECT;

    -- 
    for select IDHIER
      from S_O_HIER_SELECT2(:ID_OBJECT)
      into :IDHIER
    do
    begin
      CNT = 0;
      select count(*)
      from A_SMETA
      where IDHIER = :IDHIER and
            smetatype = :ID
      into :CNT;
      DOMAIN_COUNT = :DOMAIN_COUNT + :CNT;
      DOMAIN_COUNT = :DOMAIN_COUNT + 1;-- +    - 
    end
  end
  else
  if (ATYPE = 20) then -- SSRType ???
  begin
    select STEP_COUNT
      from T_SSR_EXP_XML_STEP_COUNT(:ID)
    into :DOMAIN_COUNT;
  end
end
^





--    XML    
-- 
CREATE OR ALTER PROCEDURE M_AFTER_IMP_DOP_RAB_FROM_XML (
    ID_USER INTEGER,
    ID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    ATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    IDNORMATIV INTEGER,
    ID_EDIZM INTEGER,
    ID_NAME INTEGER,
    VRPZ INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    NORM_GUID VARCHAR(100),
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    VIDRAB INTEGER,
    UTV INTEGER,
    CLCMODE INTEGER,
    TYPE_TRUD INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    K_ITOGO VARCHAR(50),
    B_PR DOUBLE PRECISION,
    K_PR VARCHAR(50))
AS
BEGIN
  EXIT;
END
^

-- 
CREATE OR ALTER PROCEDURE IMP_SMREC_FROM_XML (
    ID_USER INTEGER,
    IDHIER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    ATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(250),
    EDIZM_RELATION DOUBLE PRECISION,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    VRPZ INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    NORM_GUID VARCHAR(100),
    KODIR_GROUP_NAME VARCHAR(250),
    KODIR_PODGROUP_NAME VARCHAR(250),
    ISGROUPOKP INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    VIDRAB INTEGER,
    UTV INTEGER,
    CLCMODE INTEGER,
    TYPE_TRUD INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    REC_ADD_MODE INTEGER,
    IDNORMATIV INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    K_ITOGO VARCHAR(50),
    B_PR DOUBLE PRECISION,
    K_PR VARCHAR(50))
RETURNS (
    ID INTEGER,
    NEW_ID_PS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

-- 
create or alter procedure M_FIND_PROEKT_REC (
    ID_USER integer,
    IDHIER integer,
    SMETATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer)
returns (
    ID_PROEKT_REC integer)
AS
begin
  suspend;
end
^

create or alter procedure M_GET_IDREC_TO_STRUCT (
    AIDHIER integer,
    ASMETATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer)
returns (
    IDREC integer)
AS
begin
  --    A_S_GET_IDREC_TO_STRUCT
  --       
  ------------------------------------------------------------------------------

  idrec = -1;

  --  
  if (ASMETATYPE = 15) then
  begin
    select s.id
    from a_smeta s
    where s.idhier = :aidhier and
         s.smetatype = :asmetatype and
         s.number1 = :number1 and
         s.number2 = :number2 and
         s.number3 = :number3 and
         s.atype in (17, 18, 19)
    into :idrec;
  end
  
  -- 
  else
  begin
    select s.id
    from a_smeta s
    left join l_s_pr_addinfo a on (s.id = a.id)
    where s.idhier = :aidhier and
         s.smetatype = :asmetatype and
         a.pr_number1 = :number1 and
         a.pr_number2 = :number2 and
         a.pr_number3 = :number3 and
         s.atype in (17, 18, 19)
    into :idrec;
  end

  suspend;
end
^

/*create or alter procedure M_AFTER_IMP_DOP_RAB_FROM_XML (
   
*/
create or alter procedure M_FIND_PROEKT_REC (
    ID_USER integer,
    IDHIER integer,
    SMETATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer)
returns (
    ID_PROEKT_REC integer)
AS
DECLARE VARIABLE ID_OBJ INTEGER;
DECLARE VARIABLE LYEAR INTEGER;
DECLARE VARIABLE LMONTH INTEGER;
declare variable IN_SMETATYPE integer;
begin
  ID_PROEKT_REC = -1;

  execute procedure a_h_get_id_parentatype (:idhier, 1) returning_values (:id_obj);
  execute procedure L_PR_GET_YEAR_MONTH (:SMETATYPE, :id_user) returning_values (:lyear, :lmonth);

  --   
  IN_SMETATYPE = 15;
  execute procedure M_GET_IDREC_TO_STRUCT(:IDHIER, :IN_SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3)
  returning_values (:ID_PROEKT_REC);

  --    -    
  if (ID_PROEKT_REC = -1) then
  begin
    for select NUMBER
    from a_o_hier_select_pr1 (:id_user, :id_obj, :lyear, :lmonth, 0, 0)
    into :IN_SMETATYPE do
    begin
      if (ID_PROEKT_REC = -1) then
        execute procedure M_GET_IDREC_TO_STRUCT(:IDHIER, :IN_SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3)
        returning_values (:ID_PROEKT_REC);
    end
  end

  suspend;
end
^

--   10.0.0.6, 9.2.1.6
--create or alter procedure IMP_SMREC_FROM_XML (

--------------------------------------------------------------------
--                           10.0.0.6, 9.2.1.6
--------------------------------------------------------------------

--[15160]
create or alter procedure T_READ_ZONERABMAT (
    IDUSER integer,
    IDZONE integer,
    INDRABMAT integer)
returns (
    ID integer,
    IDREESTR integer,
    RABMAT integer,
    ORDERVIEW integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    EDIZMNAME varchar(100),
    EDIZMFULLNAME varchar(250),
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    NAME_TITLE blob sub_type 1 segment size 80,
    NAME_PART blob sub_type 1 segment size 80,
    NULLBLOB blob sub_type 1 segment size 80)
AS
begin

  -- INDRABMAT = -1      (IDZONE)
  if (INDRABMAT = -1) then
  begin

    for Select IDNORMY, ZONE_BA/*[10658]*/, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE from b_zonecen_rab
    where (idzone = :idzone)
    Into :ID, :BA/*10658*/, :BB, :BC, :BD, :BE
    do
    begin
      --[10658]BA = :BB + :BC + :BE;

      select /*ID,*/ IDReestr, RABMAT, tab from b_rabmat
      where ID = :id --[15160]order by Tab -    
      into /*:ID,*/ :IDReestr, :RABMAT, :tab;

      --<<[10658] . B_READ_ZONE_RAB_TSENY_INNER
      if (RABMAT <> 0) then --[10652]:   - -
      /* 2004/04/06 -   BA  !!! */
        execute procedure B_CALCULATE_ZONE_BA(:IDUSER, :BB, :BC, :BE)
            returning_values :BA;

      suspend;
    end

  end
  else
  begin
    if (INDRABMAT <> 1) then
    begin
      -- INDRABMAT = 0, 2, 3      (IDZONE)   RABMAT
      for Select z.IDNORMY from b_zonecen_rab z
      left join B_RABMAT r on (z.IDNORMY = r.ID)
      where (z.idzone = :idzone) and (r.RABMAT = :INDRABMAT)
      Into :ID
      do
      begin

        for select rabmat, orderview, tab, alttab, edizmname, edizmfullname, NAME_TITLE, NAME_PART,
                   ZONE_BA/*[10658]*/, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE
        from b_read_record_rabmat(:iduser, :ID, :idzone, 1)
        into :rabmat, :orderview, :tab, :alttab, :edizmname, :edizmfullname, :NAME_TITLE, :NAME_PART,
                   :BA, :BB, :BC, :BD, :BE
        do
        begin
          --[10658]BA = :BB + :BC + :BE;
          suspend;
        end
      end
    end
    else
    begin
      -- INDRABMAT = 1   RABMAT ()     //CQ[TIMUR 6588]
      if (INDRABMAT = 1) then
      begin
        for Select z.IDNORMY from b_zonecen_trud z
        left join b_trud t on (z.IDNORMY = t.id)
        where (z.idzone = :idzone)
        Into :ID
        do
        begin
          rabmat = 1;
          for select
            orderview, tab, edizmname, edizmfullname, name_title, name_part, zone_cena
          from b_read_record_trud(:iduser, :id, :idzone, 1)
          into
           :orderview, :tab, :edizmname, :edizmfullname, :NAME_TITLE, :NAME_PART, :BE
          do
          begin
            suspend;
          end
        end
      end
    --//CQ[TIMUR 6588]
    end

  end
end
^

--[15192]
-- 
CREATE OR ALTER PROCEDURE KD_COPY_PARAMS_LS (
    SOURCE_ID INTEGER,
    TARGET_ID INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15286]
create or alter procedure D_GET_F3_VID_RAB_VALUES_NL (
    ACT_LIST blob sub_type 0 segment size 80,
    ACT_LIST_COUNT integer,
    FORM_COST_TYPE integer,
    ID_USER integer,
    ID_CEN_LVL_BASIS integer,
    ID_CEN_LVL_CURRENT integer)
returns (
    ID_ACT integer,
    NAME_VID_RAB_F3 varchar(250),
    NUMBER_F3 integer,
    SUM_ALL double precision,
    SUM_YEAR double precision,
    SUM_PERIOD double precision,
    SUM_ALL_CURRENT double precision,
    SUM_YEAR_CURRENT double precision,
    SUM_PERIOD_CURRENT double precision)
AS
declare variable i integer;
  declare variable ACT_INFO integer;
  declare variable IN_ALL integer;
  declare variable IN_YEAR integer;
  declare variable IN_PERIOD integer;

  --[15286] declare variable NR_OT_ZPM double precision;
  --[15286] declare variable SP_OT_ZPM double precision;
  --[15286] declare variable NR_OT_ZPM_CURRENT double precision;
  --[15286] declare variable SP_OT_ZPM_CURRENT double precision;
  declare variable RA double precision;
  --[15286] declare variable RD double precision;
  --[15286] declare variable RJ double precision;
  --[15286] declare variable RK double precision;
  declare variable VRPZ integer;
  declare variable REC_NUMBER_F3 integer;
  declare variable SUM_TMP double precision;
  declare variable ID_TR integer;
begin
  -- Voyager CQ[9746]
  -- - D_GET_F3_VID_RAB_VALUES,     
  i = 0;
  ACT_LIST_COUNT = ACT_LIST_COUNT - 1;
  while (i < :ACT_LIST_COUNT) do
  begin
    ID_ACT = readintfromblob(:ACT_LIST, :i);
    i = i + 1;
    ACT_INFO = readintfromblob(:ACT_LIST, :i);
    i = i + 1;

    IN_ALL    = GETBIT(ACT_INFO, 0);
    IN_YEAR   = GETBIT(ACT_INFO, 1);
    IN_PERIOD = GETBIT(ACT_INFO, 2);

    select ID_TR --, NR_OT_ZPM, SP_OT_ZPM
    from a_o_factparams f
    where f.number = :ID_ACT
    into :ID_TR; --, :NR_OT_ZPM, :SP_OT_ZPM;

    /* --[15286]

    --Voyager.           LEVEL_COSTS
    select lc.nr_ot_zpm, lc.sp_ot_zpm
    from LEVEL_COST lc
    where lc.ID = :ID_CEN_LVL_BASIS --CQ[10807] lc.ID = :ID_CEN_LVL
          and lc.IDOBJECT = :ID_ACT
    into :NR_OT_ZPM, :SP_OT_ZPM;

    --CQ[10807] -->
    select lc.nr_ot_zpm, lc.sp_ot_zpm
    from LEVEL_COST lc
    where lc.ID = :ID_CEN_LVL_CURRENT
          and lc.IDOBJECT = :ID_ACT
    into :NR_OT_ZPM_CURRENT, :SP_OT_ZPM_CURRENT;
    --CQ[10807] <--

    --[15286] */

    for select NUMBER, NAME from a_f3_vr
    where ID_TR = :ID_TR
    order by NUMBER
    into :NUMBER_F3, NAME_VID_RAB_F3
    do
    begin
      SUM_ALL = 0;
      SUM_YEAR = 0;
      SUM_PERIOD = 0;

      --CQ[10807] -->
      SUM_ALL_CURRENT = 0;
      SUM_YEAR_CURRENT = 0;
      SUM_PERIOD_CURRENT = 0;
      --CQ[10807] <--

      --for select RA, RD, RJ, RK, vrpz from a_smeta
      --where (SMETATYPE = :ID_ACT)
      for select
        case when :FORM_COST_TYPE=0 then CL.ITOGO else CL.RA end,
        S.VRPZ /* [15286] ,CL.RD, CL.RJ, CL.RK */
      from A_SMETA S join A_SMETA_CENLVL CL on s.ID = CL.ID and S.SMETATYPE = :ID_ACT
      and CL.IDCENLVL = :ID_CEN_LVL_BASIS --CQ[10807] :ID_CEN_LVL
      into :RA, :VRPZ /* [15286] :RD, :RJ, :RK*/ do
      begin
        select first 1 NUMBER_F3_VR from a_srf_f
        where (ID_TR = :ID_TR) and (NUMBER = :VRPZ)
        into :REC_NUMBER_F3;
        if (:NUMBER_F3 = :REC_NUMBER_F3) then
        begin
          --[15286] execute procedure l_pr_kc6_calc_ra(:FORM_COST_TYPE, :RA, :RD, :RJ, :RK, :NR_OT_ZPM, :SP_OT_ZPM)
          --[15286] returning_values(:SUM_TMP);
          --[15286] if (SUM_TMP is null) then SUM_TMP = 0;
          SUM_TMP = coalesce(RA, 0);

          if (IN_ALL = 1)    then SUM_ALL = :SUM_ALL + :SUM_TMP;
          if (IN_YEAR = 1)   then SUM_YEAR = :SUM_YEAR + :SUM_TMP;
          if (IN_PERIOD = 1) then SUM_PERIOD = :SUM_PERIOD + :SUM_TMP;
        end
      end

      --CQ[10807] -->
      for select
        case when :FORM_COST_TYPE=0 then CL.ITOGO else CL.RA end,
        S.VRPZ /* [15286] CL.RD, CL.RJ, CL.RK*/
      from A_SMETA S join A_SMETA_CENLVL CL on s.ID = CL.ID and S.SMETATYPE = :ID_ACT
      and CL.IDCENLVL = :ID_CEN_LVL_CURRENT --CQ[10807] :ID_CEN_LVL
      into :RA, :VRPZ /* [15286] :RD, :RJ, :RK*/  do
      begin
        select first 1 NUMBER_F3_VR from a_srf_f
        where (ID_TR = :ID_TR) and (NUMBER = :VRPZ)
        into :REC_NUMBER_F3;
        if (:NUMBER_F3 = :REC_NUMBER_F3) then
        begin
          --[15286] execute procedure l_pr_kc6_calc_ra(:FORM_COST_TYPE, :RA, :RD, :RJ, :RK, :NR_OT_ZPM_CURRENT, :SP_OT_ZPM_CURRENT)
          --[15286] returning_values(:SUM_TMP);
          --[15286] if (SUM_TMP is null) then SUM_TMP = 0;
          SUM_TMP = coalesce(RA, 0);

          if (IN_ALL = 1)    then SUM_ALL_CURRENT = :SUM_ALL_CURRENT + :SUM_TMP;
          if (IN_YEAR = 1)   then SUM_YEAR_CURRENT = :SUM_YEAR_CURRENT + :SUM_TMP;
          if (IN_PERIOD = 1) then SUM_PERIOD_CURRENT = :SUM_PERIOD_CURRENT + :SUM_TMP;
        end
      end
      --CQ[10807] <--

      if ((SUM_ALL <> 0) or (SUM_YEAR <> 0) or (SUM_PERIOD <> 0) or
          (SUM_ALL_CURRENT <> 0) or (SUM_YEAR_CURRENT <> 0) or (SUM_PERIOD_CURRENT <> 0) --CQ[10807]
         ) then
        suspend;
    end
  end
end^

--[15286]
create or alter procedure K_F3_CALC_STOIM_AKT_NL (
    IDAKT integer,
    TYPEALGCALCSTOIM integer,
    ID_CEN_LVL integer)
returns (
    STOIMMONTHWORK double precision)
AS
--[15286] declare variable NrOtZpm double precision;
--[15286] declare variable SpOtZpm double precision;
--[15286] declare variable ra double precision;
--[15286] declare variable rd double precision;
--[15286] declare variable rj double precision;
--[15286] declare variable rk double precision;
begin
   -- Voyager CQ[9746]
   -- - K_F3_CALC_STOIM_AKT,   ID  ,    


   --[15286] -    ""
   StoimMonthWork = 0.0;
   select sum(case when :TypeAlgCalcStoim=0 then A.ITOGO else A.RA end)
     from A_SMETA_CENLVL a join A_SMETA s on s.ID = a.ID and
                                             S.SMETATYPE = :IDAkt and
                                             a.IDCENLVL = :ID_CEN_LVL
   into :StoimMonthWork;

/*$$IBEC$$ [15286]
   NrOtZpm = 0.0;
   SpOtZpm = 0.0;
   ra = 0.0;
   rd = 0.0;
   rj = 0.0;
   rk = 0.0;

    $$IBEC$$*//*  +  +  (, , 1984) *//*$$IBEC$$ 
   if ( TypeAlgCalcStoim = 0 ) then
   begin
       $$IBEC$$*//*                .     . .              *//*$$IBEC$$ 
      --select sum( a.ra ), sum( a.rj ), sum( a.rk ) from a_smeta a
      --where a.smetatype = :IDAkt
      --into :ra, :rj, :rk;
      select sum( a.ra ), sum( a.rj ), sum( a.rk )
      from A_SMETA_CENLVL a join A_SMETA s on s.ID = a.ID and S.SMETATYPE = :IDAkt
      and a.IDCENLVL = :ID_CEN_LVL
      into :ra, :rj, :rk;

      StoimMonthWork = ra + rj + rk;
   end
    $$IBEC$$*//*  +  +  +      ( 81-98) *//*$$IBEC$$ 
   else if ( TypeAlgCalcStoim = 1 ) then
   begin
      -- Voyager.           -    
      --select first 1 f.nr_ot_zpm, f.sp_ot_zpm
      --from a_o_factparams f
      --where f.number = :IDAKT
      --into :NrOtZpm, :SpOtZpm;
      select lc.nr_ot_zpm, lc.sp_ot_zpm
      from LEVEL_COST lc
      where lc.ID = :ID_CEN_LVL and lc.IDOBJECT = :IDAkt
      into :NrOtZpm, :SpOtZpm;

       $$IBEC$$*//*                          .     . .              *//*$$IBEC$$ 
      --select sum( a.ra ), sum( a.rd ), sum( a.rj ), sum( a.rk ) from a_smeta a
      --where a.smetatype = :IDAkt
      --into :ra, :rd, :rj, :rk;
      select sum( a.ra ), sum( a.rd ), sum( a.rj ), sum( a.rk )
      from A_SMETA_CENLVL a join A_SMETA s on s.ID = a.ID and S.SMETATYPE = :IDAkt
      and a.IDCENLVL = :ID_CEN_LVL
      into :ra, :rd, :rj, :rk;

      StoimMonthWork = ra + rj + rk + rd * ( NrOtZpm + SpOtZpm ) / 100;
   end
    $$IBEC$$*//*  *//*$$IBEC$$ 
   else if ( TypeAlgCalcStoim = 2 ) then
   begin
      --select sum( a.ra ) from a_smeta a
      --where a.smetatype = :IDAkt
      --into :StoimMonthWork;
      select sum( a.ra )
      from A_SMETA_CENLVL a join A_SMETA s on s.ID = a.ID and S.SMETATYPE = :IDAkt
      and a.IDCENLVL = :ID_CEN_LVL
      into :StoimMonthWork;
   end
   $$IBEC$$*/


   suspend;
end^

--[15286]
create or alter procedure L_KC6_SELECT_KOLL_RA (
    ID integer,
    ID_AKT integer,
    STOIMMODE integer,
    NRSP double precision,
    ID_USER integer,
    ID_CENLVL integer)
returns (
    RA double precision,
    KOLL double precision,
    CLCMODE integer)
AS
--[15286] declare variable rd double precision;
--[15286] declare variable rj double precision;
--[15286] declare variable rk double precision;

declare variable ATYPE integer;
declare variable SLAVEPARENT integer;

begin
  -- CQ[15050] -  KOLL  CLCMODE

  -- MK 15.05.2012 CQ[9744] --->
  select first 1
      ID, KOLL, case when :STOIMMODE=0 then c.ITOGO else c.RA end,
      /*--[15286] c.RD, c.RJ, c.RK, */
      s.SLAVEPARENT, s.CLCMODE, s.ATYPE
  from A_SMETA s
  join A_SMETA_CENLVL c on (s.ID = c.ID) and (c.IDCENLVL = :ID_CENLVL)
  where (s.NOMERROD1 = :ID) and (s.SMETATYPE = :ID_AKT)
  into :ID, :KOLL, :RA, /*--[15286] :RD, :RJ, :RK, */
       :SLAVEPARENT, :CLCMODE, :ATYPE;

  if (( not ID is null) and (ATYPE in (17, 18))) then
  begin
    if (ATYPE = 18) then
      select first 1 s.CLCMODE
        from A_SMETA s
      where (s.ID = :SLAVEPARENT)
      into :CLCMODE;
 
    -- CQ[15050]     
    if ( (GETBIT(:CLCMODE, 10) = 0) ) then
    begin
 
      --select first 1 ra , rd , rj , rk
      --from a_smeta
      --where nomerrod1 = :id and smetatype = :id_akt
      --into ra , rd , rj , rk;
      -- MK 15.05.2012 CQ[9744] <---
   
      if ( RA is null ) then
         RA = 0;

      /*--[15286]
      if ( RD is null ) then
         RD = 0;
      if ( RJ is null ) then
         RJ = 0;
      if ( RK is null ) then
         RK = 0;
   
      if ( STOIMMODE = 0 ) then
         RA = RA + RJ + RK;
      else if ( STOIMMODE = 1 ) then
         RA = RA + RJ + RK + RD * NRSP / 100; [15286] */
    end
    else
    begin
      RA = 0;
      KOLL = 0;
    end
  end
  else
  begin -- 
    RA = null;
    KOLL = null;
  end

  suspend; -- CQ[15050] -     
end^

--[15286]
/* 
create or alter procedure L_PR_CREATE_KC6_1 (
*/
-- MK:    
create or alter procedure MS_O_HIER_SELECT3 (
    IDPARENT integer)
returns (
    IDHIER integer,
    ATYPE integer)
AS
BEGIN
  --     (  ),   
  --    MS_O_HIER_SELECT2   CQ[10784,11147]
  --   -  ,   

  FOR SELECT NUMBER, ATYPE
    FROM A_O_HIER /*    */
    WHERE PARENT = :IDPARENT
      AND ATYPE IN (
            0, /* FolderType */
            3, /* LSType */
            4, /* RType */
            5) /* PRType */
    ORDER BY ATYPE,SORTING
    INTO :IDHIER, :ATYPE
  DO
    suspend;
END
^

-- MK:    
create or alter procedure MS_O_HIER_SELECT4 (
    IDPARENT integer)
returns (
    IDHIER integer,
    ATYPE integer)
AS
BEGIN
  --     (  ),   
  --    MS_O_HIER_SELECT3    
  --   -   SORTING

  FOR SELECT NUMBER, ATYPE
    FROM A_O_HIER /*    */
    WHERE PARENT = :IDPARENT
      AND ATYPE IN (
            0, /* FolderType */
            3, /* LSType */
            4, /* RType */
            5) /* PRType */
    ORDER BY SORTING
    INTO :IDHIER, :ATYPE
  DO
    suspend;
END
^


-- MK:    
create or alter procedure M_GET_OBJ_STRUCT_HIER_1 (
    IN_PARENT integer)
returns (
    NUMBER integer,
    PARENT integer,
    ATYPE integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    GUID varchar(100))
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
-- MK:         
begin
  for select idhier, atype
  from MS_O_HIER_SELECT4(:IN_PARENT)
  --from S_O_HIER_SELECT_LEVEL_NF(:IN_PARENT)
  into :NUMBER, :ATYPE do
  begin
    PARENT = :IN_PARENT;

    --select first 1 h.atype
    --from a_o_hier h
    --where (h.number = :NUMBER)
    --into :ATYPE;

    select first 1 SHIFR, FULLNAME, GUID
    from A_H_GETNAMEGUID(:NUMBER, :ATYPE)
    into :SHIFR, :FULLNAME, :GUID;

    suspend;

    --     
    for select m.number, m.parent, m.atype, m.shifr, m.fullname, m.guid
    from M_GET_OBJ_STRUCT_HIER_1(:NUMBER) m
    into :number, :parent, :atype, :shifr, :fullname, :guid do
      suspend;
  end
end
^


-- MK:    
/*create or alter procedure IMP_SMREC_FROM_XML (
   
*/
-- MK:    
create or alter procedure MB_IMP_I_SRF_F (
    IDUSER integer,
    IMPMODE integer,
    ID_TR integer,
    NUMBER_VR integer,
    NUMBER_F3_VR integer,
    ATYPE integer,
    NUMBER integer,
    NAME varchar(250),
    SHIFR varchar(255),
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    NOTE varchar(255))
returns (
    ID integer)
AS
begin
  --    .   B_IMP_I_SRF_F  
  --     (  )
  ------------------------------------------------------------------------------

  if (:ID_TR <> 0 and :NUMBER is not null) then
  begin
    if (not exists(select * from A_SRF_F where (ID_TR = :ID_TR) and (NUMBER = :NUMBER))) then
    begin
      execute procedure B_IMP_I_SRF_F(:IDUSER, :IMPMODE, :ID_TR, :NUMBER_VR,
                                      :NUMBER_F3_VR, :ATYPE, :NUMBER, :NAME,
                                      :SHIFR, :PA, :PB, :PC, :PD, :PE, :NOTE)
      returning_values :ID;

    end
    else
      ID = -1;
  end

  suspend;
end
^


-- MK:    
create or alter procedure MB_IMP_I_SRF_VR (
    IDUSER integer,
    IMPMODE integer,
    ID_TR integer,
    NUMBER integer,
    NAME varchar(250),
    NOTE varchar(255))
returns (
    ID integer)
AS
begin
  --     .   B_IMP_I_SRF_VR  
  --     (  )
  ------------------------------------------------------------------------------

  if (:ID_TR <> 0 and :NUMBER is not null) then
  begin
    if (not exists(select * from A_SRF_VR where (ID_TR = :ID_TR) and (NUMBER = :NUMBER))) then
    begin
      execute procedure B_IMP_I_SRF_VR(:IDUSER, :IMPMODE, :ID_TR, :NUMBER, :NAME, :NOTE)
      returning_values :ID;
    end
    else
      ID = -1;
  end

  suspend;
end
^


-- MK:    
create or alter procedure MB_IMP_I_F3_VR (
    IDUSER integer,
    IMPMODE integer,
    ID_TR integer,
    NUMBER integer,
    NAME varchar(250))
returns (
    ID integer)
AS
begin
  --     3  .   B_IMP_I_F3_VR  
  --     (  )
  ------------------------------------------------------------------------------


  if (:ID_TR <> 0 and :NUMBER is not null) then
  begin
    if (not exists(select * from A_F3_VR where (ID_TR = :ID_TR) and (NUMBER = :NUMBER))) then
    begin
      execute procedure B_IMP_I_F3_VR(:IDUSER, :IMPMODE, :ID_TR, :NUMBER, :NAME)
      returning_values :ID;
    end
    else
      ID = -1;
  end

  suspend;
end
^

-- MK:    
create or alter procedure M_SET_SM_REC_ENTITYS (
    ID_USER integer,
    ID_SM_REC integer)
AS
declare variable VN_IDHIER integer;
declare variable VN_SMETATYPE integer;
declare variable VN_IDNORMATIV integer;
declare variable VN_ATYPE integer;
declare variable VN_RABMAT integer;
declare variable VN_SLAVEPARENT integer;
declare variable VN_VRPZ integer;
declare variable VN_ID_OBJ integer;
declare variable VN_IDFORMULS integer;
declare variable VN_TIPRAB integer;
declare variable VN_VIDRAB integer;
declare variable VN_PUNKTIND varchar(42);
declare variable VN_ID_TR integer;
declare variable VN_RES_COPY_FORMULS integer;
declare variable VN_ID_PODGROUP integer;
declare variable VN_ID_PODGROUP_PARAM integer;
declare variable VN_BA double precision;
declare variable VN_BB double precision;
declare variable VN_BC double precision;
declare variable VN_BD double precision;
declare variable VN_BE double precision;
declare variable VN_BF double precision;
declare variable VN_BG double precision;
declare variable VN_BH double precision;
declare variable VN_BI double precision;
-- <-- Voyager CQ[13218]
--declare variable VN_BJ double precision;
declare variable VN_BN double precision;
declare variable VN_BO double precision;
declare variable VN_B_ITOGO double precision;
-- <-- Voyager CQ[13218]
declare variable VN_DORECALK integer;
declare variable VN_TMP integer;
begin
  ------------------------------------------------------------------------------
  --      : , , 
  -- :
  -- -   XML (      )
  ------------------------------------------------------------------------------

  --     
  select first 1 s.idhier, s.smetatype, s.idnormativ, s.atype, s.slaveparent,
                 s.rabmat, s.kodir_podgroup, coalesce(s.tiprab, 0)
  from a_smeta s
  where (s.id = :ID_SM_REC)
  into :VN_IDHIER, :VN_SMETATYPE, :VN_IDNORMATIV, :VN_ATYPE, :VN_SLAVEPARENT,
       :VN_RABMAT, :VN_ID_PODGROUP, :VN_TIPRAB;

  --   ?  -       
  if (VN_IDHIER is null) then
    exit;

  --    ?  
  if (not ((VN_SMETATYPE = 15) or (VN_SMETATYPE > 999)))  then
    exit;

  --     / 
  execute procedure a_h_get_id_parentatype (:VN_IDHIER, 1) returning_values (:VN_ID_OBJ);

  if (VN_SMETATYPE = 15) then
  begin
    select p.id_tr, p.res_copy_formuls, p.kodir_podgroup, p.dorecalk
    from a_o_objectparams p
    where (p.number = :VN_ID_OBJ)
    into :VN_ID_TR, :VN_RES_COPY_FORMULS, :VN_ID_PODGROUP_PARAM, :VN_DORECALK;
  end
  else
  begin
    select f.id_tr, f.res_copy_formuls, f.kodir_podgroup, f.dorecalk
    from a_o_factparams f
    where (f.number = :VN_SMETATYPE)
    into :VN_ID_TR, :VN_RES_COPY_FORMULS, :VN_ID_PODGROUP_PARAM, :VN_DORECALK;
  end

  --   
  VN_ID_PODGROUP = coalesce(VN_ID_PODGROUP, 0);
  if (VN_ID_PODGROUP = 0) then
    VN_ID_PODGROUP = VN_ID_PODGROUP_PARAM;

  --   ,     
  VN_IDNORMATIV = coalesce(VN_IDNORMATIV, 0);
  execute procedure M_FB_READ_SBORNIK(:VN_IDNORMATIV, :VN_ID_PODGROUP, :VN_RABMAT)
  returning_values (:VN_TMP, :VN_BA, :VN_BB, :VN_BC, :VN_BD, :VN_BE, :VN_BF,
                    :VN_BG, :VN_BH, :VN_BI,
                    /*:VN_BJ,*/ :VN_BN, :VN_BO, :VN_B_ITOGO, -- <-- Voyager CQ[13218]
                    :VN_PUNKTIND, :VN_VRPZ);

  ------------------------------------------------------------------------------
  -- 
  if (VN_TIPRAB = 0) then
    VN_TIPRAB = 1; --     ""

  select first 1 RES_IDFORMULS, RES_TIPRAB, RES_VIDRAB
  from A_S_GET_FORMULS_DM(:ID_USER, :VN_ATYPE, :VN_SLAVEPARENT,
                          :VN_ID_TR, :VN_VRPZ, :VN_RES_COPY_FORMULS, :VN_TIPRAB)
  into :VN_IDFORMULS, :VN_TIPRAB, :VN_VIDRAB;

  update a_smeta s
  set s.idformuls = :VN_IDFORMULS,
      s.vrpz = coalesce(:VN_VRPZ,0), -- < Voyager.  coalesce, ,  EInterbaseError
      s.tiprab = :VN_TIPRAB,
      s.vidrab = :VN_VIDRAB,

      -- <-- Voyager CQ[13244]
      --    XML   ,     
      /*
      --    
      s.BA = :VN_BA,
      s.BB = :VN_BB,
      s.BC = :VN_BC,
      s.BD = :VN_BD,
      s.BE = :VN_BE,
      s.BF = :VN_BF,
      s.BG = :VN_BG,
      s.BH = :VN_BH,
      s.BI = :VN_BI,
      -- <-- Voyager CQ[13218]
      --s.BJ = :VN_BJ,
      s.BN = :VN_BN,
      s.BO = :VN_BO,
      s.B_ITOGO = :VN_B_ITOGO,
      -- <-- Voyager CQ[13218]
      */
      -- <-- Voyager CQ[13244]


      --  
      s.punktind = :VN_PUNKTIND

  where (s.id = :ID_SM_REC);


  ------------------------------------------------------------------------------
  --     
  for select ID_LEVEL
  from NL_CTRL_ENTER_SMREC (:VN_ID_OBJ, :VN_SMETATYPE, :ID_USER, 1, 1,
                            :VN_PUNKTIND, :ID_SM_REC, :VN_ID_TR, :VN_VRPZ,
                            :VN_RES_COPY_FORMULS, 0)
  into :VN_TMP do
  begin
    -- nothing
    VN_TMP = VN_TMP;
  end


  ------------------------------------------------------------------------------
  --       / 
  VN_DORECALK = SETBIT(:VN_DORECALK, 0, 1);
  execute procedure A_H_SAVE_DORECALK(:ID_USER, :VN_ID_OBJ, :VN_SMETATYPE, :VN_DORECALK);
end
^

-- Voyager.    
/*create or alter procedure IMP_SMREC_FROM_XML (
   
*/

--------------------------------------------------------------------
--                           10.0.0.7, 9.2.1.7
--------------------------------------------------------------------

-- MK:    
create or alter procedure ATOM_XML_GET_DOMAIN_COUNT_1 (
    IDUSER integer,
    IDLS integer)
returns (
    DOMAIN_COUNT integer,
    ID_OBJECT integer,
    ACT_COUNT integer)
AS
declare variable IDHIER integer;
declare variable SMETATYPE integer;
declare variable CNT integer;
begin
  --          
  -- (       )
  ------------------------------------------------------------------------------

  DOMAIN_COUNT = 0;
  ACT_COUNT = 0;
  --  ID 
  select RES_ID from A_H_GET_ID_PARENTATYPE(:IDLS, 1) into :ID_OBJECT;

  --    
  for select NUMBER
  from A_O_HIER_SELECT_PR1(:IDUSER, :ID_OBJECT, 0, 0, 0, 0)
  into :SMETATYPE do
  begin
     ACT_COUNT = ACT_COUNT + 1;

    --      
    for select IDHIER
    from M_O_HIER_SELECT(:IDLS)
    into :IDHIER do
    begin
      CNT = 0;
      select count(*)
      from A_SMETA
      where (IDHIER = :IDHIER) and (smetatype = :SMETATYPE)
      into :CNT;

      DOMAIN_COUNT = :DOMAIN_COUNT + :CNT;
      DOMAIN_COUNT = :DOMAIN_COUNT + 1;-- +    - 
    end
  end
end
^

--[15371]
create or alter procedure T_GET_IDGROP (
    IDUSER integer,
    IDPUT integer)
returns (
    IDPODGROUP integer)
AS
declare variable IDREESTR integer;
begin
  /* 15371 -       
   IDPODGROUP   .  IDPODGROUP  
     ,      ,    
      */
  IDPODGROUP = null;
  for select IDREESTR
    from B_PUTVIEW
    where (IDPUTNAME = :IDPUT)
  into :IDREESTR do
  begin
    select first 1 IDREESTR
      from B_READ_REESTR_NODE_CHILDS(:IDUSER, :IDREESTR, 0/*:NEEDSUSPENDSELF*/, 0/*:NEEDTESTDOSTUP*/)
    where (SBORNIK = 1)
    into :IDREESTR;

    IDPODGROUP = null;
    select IDPODGROUP
       from B_REESTR
      where (ID = :IDREESTR)
    into :IDPODGROUP;

    if (IDPODGROUP is not null) then
      exit;
  end
end
^

--[15371]
-- 
create or alter procedure M_FB_SEARCH_NORMATIV_EX (
    IN_PODGROUP integer,
    IN_RABMAT integer,
    ID_USER integer,
    STAB varchar(42),
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer,
    ID_ZONE integer,
    SNAME_CRC integer,
    SNAME_ID integer,
    SEDIZM varchar(100))
returns (
    ID_SELF                integer,
    PODGROUP               integer,
    RABMAT                 integer,
    ID_ABC_OKP             integer,
    BEDA1                  integer,
    BEDA2                  integer,
    BEDARAB                integer,
    BEDAMASH               integer,
    BEDAMAT                integer,
    NAME_PART              blob sub_type 1 segment size 80,
    NAME_TITLE             blob sub_type 1 segment size 80,
    IDNAME                 integer,
    ID_UNIQUE              integer,
    TAB                    varchar(42),
    TABU                   varchar(42),
    ALTTAB                 varchar(250),
    IDEDIZM                integer,
    EDIZM_NAME             varchar(100),
    EDIZM_FULLNAME         varchar(255),
    comment varchar(42),
    RAZRAD                 double precision,
    BA                     double precision,
    BB                     double precision,
    BC                     double precision,
    BD                     double precision,
    BE                     double precision,
    BF                     double precision,
    BG                     double precision,
    BH                     double precision,
    BI                     double precision,
    BJ                     double precision,
    PA                     double precision,
    PB                     double precision,
    PC                     double precision,
    PD                     double precision,
    PE                     double precision,
    VRPZ                   integer,
    NTR                    integer,
    PUNKTIND               varchar(42),
    ISESN                  integer,
    IDWITHESN              integer,
    CCURRENT_BA            double precision,
    CCURRENT_BB            double precision,
    CCURRENT_BC            double precision,
    CCURRENT_BD            double precision,
    CCURRENT_BE            double precision,
    CCURRENT_ZONE          integer,
    IDQUALIFIER            integer,
    IDNORMTYPE             integer,
    NORM_GUID              varchar(100),
    IDREESTR               integer,
    ABC_OKP_NAME_PART      blob sub_type 1 segment size 80,
    ABC_OKP_NAME_TITLE     blob sub_type 1 segment size 80,
    ABC_OKP_RABMAT         integer,
    ABC_OKP_IDNAME         integer,
    ABC_OKP_ID_UNIQUE      integer,
    ABC_OKP_TAB            varchar(42),
    ABC_OKP_TABU           varchar(42),
    ABC_OKP_IDGROUP        integer,
    ABC_OKP_IDPODGROUP     integer,
    ABC_OKP_ISGROUPOKP     integer,
    ABC_OKP_IDEDIZM        integer,
    ABC_OKP_EDIZM_NAME     varchar(100),
    ABC_OKP_EDIZM_FULLNAME varchar(255),
    ABC_OKP_CENA           double precision,
    ABC_OKP_RAZRAD         double precision,
    ABC_OKP_VIDNR          integer,
    ABC_OKP_COMMENT        varchar(42),
    ABC_OKP_PUNKTIND       varchar(42),
    ABC_OKP_VRPZ           integer,
    ABC_OKP_NTR            integer,
    ABC_OKP_CCURRENT       double precision,
    ABC_OKP_CCURRENT_ZONE  integer,
    ABC_OKP_IDQUALIFIER    integer,
    TYPE_TRUD              integer,
    ABC_OKP_TYPE_TRUD      integer,
    BB_PR                  double precision)
AS
begin
  suspend;
end
^

--[15371]
-- 
create or alter procedure M_CONVERT_OBJ_VNB (
    IDOBJECT integer,
    IDUSER integer,
    IN_PODGROUP integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer,
    ID_TR integer,
    INDEX_ID_ORG integer,
    INDEX_ID_GOD integer,
    INDEX_ID_MES integer,
    RETURN_ALL integer,
    MIN_STEP_SUSPEND integer,
    CLEARPRICE_IFNOTFOUND integer,
    REPLACE_CHANGE_NAME integer,
    REPLACE_ALL_RES integer,
    LEAVE_MATER_PRICE integer)
returns (
    ID integer,
    REC_NO integer,
    CONVERT_RESULT integer,
    RABMAT integer,
    TAB varchar(42),
    ATYPE integer,
    HIER_CAPTION varchar(255),
    REC_NUMBER varchar(10),
    VRPZ integer,
    OUT_IDFORMULS integer)
AS
begin
      suspend;
end
^


-- MK   
create or alter procedure M_GET_SORTING_WITHOUT_FOLDERS (
    IDHIER integer)
returns (
    SORTING integer)
AS
declare variable VN_NUMBER integer;
declare variable VN_PARENT integer;
declare variable VN_ATYPE integer;
declare variable VN_SORTING integer;
begin
  --  SORTING     ,  
  --    ( SORTING  SORTING   )
  ------------------------------------------------------------------------------

  VN_ATYPE = -1; --    IDHIER

  --      
  select h.parent, h.atype, h.sorting
  from a_o_hier h
  where (h.number = :IDHIER)
  into :VN_PARENT, :VN_ATYPE, :SORTING;

  --   , , 
  --  SORTING    - 
  if (VN_ATYPE in (3, 4, 5)) then
  begin
    while (:VN_PARENT is not null) do
    begin
      select h.number, h.parent, h.atype, h.sorting
      from a_o_hier h
      where (h.number = :VN_PARENT)
      into :VN_NUMBER, :VN_PARENT, :VN_ATYPE, :VN_SORTING;

      --     -   SORTING
      if (VN_ATYPE = 0) then
        SORTING = :VN_SORTING;
      --  -  
      else
        VN_PARENT = null;

      --    
      if ((VN_PARENT is not null) and (VN_NUMBER = VN_PARENT)) then
        VN_PARENT = null;
    end
  end

  suspend;
end
^


-- MK   
create or alter procedure M_GET_HIER_SORT_WITHOUT_FOLDERS (
    IDHIER integer)
returns (
    NUMBER integer,
    PARENT integer,
    ATYPE integer,
    SORTING integer,
    COUNTCHILDREN integer)
as
begin
  ATYPE = -1; --    IDHIER

  --      
  select h.number, h.parent, h.atype, h.sorting, h.countchildren
  from a_o_hier h
  where (h.number = :IDHIER)
  into :NUMBER, :PARENT, :ATYPE, :SORTING, :COUNTCHILDREN;

  --   , , 
  --  SORTING    - 
  if (ATYPE in (3, 4, 5)) then
  begin
    execute procedure M_GET_SORTING_WITHOUT_FOLDERS(:NUMBER)
    returning_values :SORTING;
  end

  suspend;
end
^


-- MK   
create or alter procedure ATOM_XML_GET_SSR_DOMAIN (
    ID_SSR integer,
    IDUSER integer)
returns (
    ID integer,
    ATYPE integer,
    ID_OBJ integer,
    SORTING integer)
AS
declare variable ID_OBJ_STRUC integer;
begin
  --       
  for select distinct ID_OBJ_STRUC
    from L_SSR
    where (ID_SSR = :ID_SSR) and (ID_OBJ_STRUC > 0)
    into :ID_OBJ_STRUC
  do
  begin
    for select ATYPE
      from A_O_HIER
      where NUMBER = :ID_OBJ_STRUC
      into :ATYPE
    do
    begin
      if (ATYPE in (1, 3, 4, 5)) then -- ObgectType, LSType, RType, PRType
      begin
        SORTING = 0;

        if ((ATYPE = 1) or (ATYPE = 3)) then -- ObgectType, LSType
        begin
          ID = :ID_OBJ_STRUC;
        end
        else
        if ((ATYPE = 4) or (ATYPE = 5)) then -- RType, PRType
        begin
          ATYPE = 3;-- LSType
          execute procedure s_o_hier_parent_oftype(:ID_OBJ_STRUC, :ATYPE)
          returning_values (:ID);
        end

        if (ATYPE = 3) then
        begin
          --        
          execute procedure M_GET_SORTING_WITHOUT_FOLDERS(:ID)
          returning_values :SORTING;
        end
  
        --   
        execute procedure s_o_hier_parent_oftype(:ID, 1)
        returning_values (:ID_OBJ);
  
        suspend;

        --     
        if (ATYPE = 1) then
        begin
          ATYPE = 2;   --  2  8   
          SORTING = 0;

          --  
          for select NUMBER
          from A_O_HIER_SELECT_PR1(:IDUSER, :ID_OBJ, 0, 0, 0, 0)
          into :ID do
          begin
            SORTING = SORTING + 1;
            suspend;
          end
        end

      end
    end
  end
end
^


-- MK   
create or alter procedure M_GET_LS_NPP (
    IDHIER integer)
returns (
    NPP integer)
AS
declare variable VN_ID_LS integer;
declare variable VN_ID_OBJ integer;
begin
  --           
  --   IDHIER.
  ------------------------------------------------------------------------------

  --   
  execute procedure s_o_hier_parent_oftype(:IDHIER, 3)
  returning_values (:VN_ID_LS);

  --   
  execute procedure s_o_hier_parent_oftype(:VN_ID_LS, 1)
  returning_values (:VN_ID_OBJ);

  --    
  execute procedure A_H_GETNUMHIER(:VN_ID_LS, :VN_ID_OBJ)
  returning_values (:NPP);

  suspend;
end
^

-- Voyager,   
create or alter procedure V_GET_SSR_DEST_COMMON_FOLDER_ID (
    ID_USER            integer,
    COMMON_FOLDER_NAME varchar(1024))
returns (
    FOLDER_ID integer,
    COMMON_FOLDER_ID integer)
AS
begin
-- COMMON_FOLDER_NAME -     ,
--         
--    :
-- afSSRFull_CommonFolderName = '    ';

    --   .        
    COMMON_FOLDER_ID = null;
    select first 1 P.NUMBER from A_O_FOLDERPARAMS P join A_O_HIER H
    on P.NUMBER = H.NUMBER and H.PARENT = 0
    where p.FULLNAME = :COMMON_FOLDER_NAME and p.SHIFR = :COMMON_FOLDER_NAME
    into :COMMON_FOLDER_ID;

    --    -  ID  
    if (COMMON_FOLDER_ID is null) then
    begin
        execute procedure A_SET_G_NUMBER_OBG(1)
            returning_values :COMMON_FOLDER_ID;

        --  ,   -  ,   
        --     " "
        execute procedure A_H_INSERT(
            :COMMON_FOLDER_ID,
            0/*:PARENT*/,
            0/*:ATYPE*/,
            0/*:SUBTYPE*/,
            :COMMON_FOLDER_NAME,
            0/*:NAMEATYPE*/,
            0/*:SORTING*/,
            0/*:SUPPOSED_PARENT_ATYPE*/,
            0/*:NUMBER_OBG*/,
            :ID_USER
        );

        update A_O_FOLDERPARAMS P
        set
            P.FULLNAME = :COMMON_FOLDER_NAME,
            P.SHIFR = :COMMON_FOLDER_NAME
        where
            P.NUMBER = :COMMON_FOLDER_ID;
    end


    --           
    execute procedure A_SET_G_NUMBER_OBG(1)
        returning_values :FOLDER_ID;

    --  ,   -  ,   
    --     " "
    execute procedure A_H_INSERT(
        :FOLDER_ID,
        :COMMON_FOLDER_ID/*:PARENT*/,
        0/*:ATYPE*/,
        0/*:SUBTYPE*/,
        ' ',
        0/*:NAMEATYPE*/,
        0/*:SORTING*/,
        0/*:SUPPOSED_PARENT_ATYPE*/,
        0/*:NUMBER_OBG*/,
        :ID_USER
    );

    --      ,    
    -- . TafSSRFullImportTask.OnReadedStroyka

    suspend;
end
^
/* CQ[15073]>> */
create or alter procedure T_SSR_IMP_XML_ONE_REC_ATOM (
    ID_SSR integer,
    ID_REC integer,
    NM_GL integer,
    NM_NACH integer,
    NM_OBJ_STRUC integer,
    OBJ_STRUC_TYPE integer,
    ID_OBJ_STRUC integer,
    CALC_POLN integer,
    NPP_GL integer,
    NSR varchar(1024),
    NAME varchar(1024),
    RUS_NAME varchar(30),
    UNIONS integer,
    PRINT smallint,
    I1_FRM blob sub_type 0 segment size 80,
    I2_FRM blob sub_type 0 segment size 80,
    I3_FRM blob sub_type 0 segment size 80,
    I4_FRM blob sub_type 0 segment size 80,
    I5_FRM blob sub_type 0 segment size 80,
    I6_FRM blob sub_type 0 segment size 80,
    I1_VAL double precision,
    I2_VAL double precision,
    I3_VAL double precision,
    I4_VAL double precision,
    I5_VAL double precision,
    I6_VAL double precision,
    TIP_ZATRAT integer,
    STRUCT_GUID varchar(100),
    IDVRZUCL integer,
    VRIDDOC integer,
    VRNPPTEXT varchar(20),
    VRPRVALUE double precision,
    ZUIDDOC integer,
    ZUNPPTEXT varchar(20),
    ZUPRVALUE double precision,
    CLIDDOC integer,
    CLNPPTEXT varchar(20),
    CLZONE integer,
    CLKOEF double precision)
AS
--CQ[TIMUR 13931] -    NSR, NAME
declare variable FIND_ID_OBJ_STRUC integer;
declare variable NEW_IDVRZUCL integer;
begin
  /* :     T_SSR_IMP_XML_ONE_REC.    . */

  if (coalesce(:ID_OBJ_STRUC, 0) = 0) then
  begin
    execute procedure T_FIND_STRUCT_BY_GUID (:STRUCT_GUID, :OBJ_STRUC_TYPE, :NAME, :NSR)
    returning_values :FIND_ID_OBJ_STRUC;
    if (:FIND_ID_OBJ_STRUC is not null) then
      ID_OBJ_STRUC = :FIND_ID_OBJ_STRUC;
  end

  if ((IDVRZUCL = 0) or (IDVRZUCL is null)) then
    NEW_IDVRZUCL = null;
  else
    execute procedure A_SET_G_NUMBER_OBG 1 returning_values :NEW_IDVRZUCL;

  if (NEW_IDVRZUCL is not null) then
    insert into M_STRUCT_PARAMS_VRZUCL(ID, VRIDDOC, VRNPPTEXT, VRPRVALUE,
                                       ZUIDDOC, ZUNPPTEXT, ZUPRVALUE,
                                       CLIDDOC, CLNPPTEXT, CLKOEF, CLZONE)
    values(:NEW_IDVRZUCL, :VRIDDOC, :VRNPPTEXT, :VRPRVALUE,
           :ZUIDDOC, :ZUNPPTEXT, :ZUPRVALUE,
           :CLIDDOC, :CLNPPTEXT, :CLKOEF, :CLZONE);

  insert into L_SSR(
     ID_SSR, ID_REC, NM_GL, NM_NACH, NM_OBJ_STRUC, OBJ_STRUC_TYPE, ID_OBJ_STRUC, CALC_POLN,
     NPP_GL, NSR, NAME, RUS_NAME, UNIONS, PRINT,
     I1_FRM, I2_FRM, I3_FRM, I4_FRM, I5_FRM, I6_FRM,
     I1_VAL, I2_VAL, I3_VAL, I4_VAL, I5_VAL, I6_VAL,
     TIP_ZATRAT, IDVRZUCL)
  values(
     :ID_SSR, :ID_REC, :NM_GL, :NM_NACH, :NM_OBJ_STRUC, :OBJ_STRUC_TYPE, :ID_OBJ_STRUC, :CALC_POLN,
     :NPP_GL, :NSR, :NAME, :RUS_NAME, :UNIONS, :PRINT,
     :I1_FRM, :I2_FRM, :I3_FRM, :I4_FRM, :I5_FRM, :I6_FRM,
     :I1_VAL, :I2_VAL, :I3_VAL, :I4_VAL, :I5_VAL, :I6_VAL,
     :TIP_ZATRAT, :NEW_IDVRZUCL);

end
^





--------------------------------------------------------------------
--                           10.0.0.8, 9.2.1.8
--------------------------------------------------------------------

--[15392]
create or alter procedure B_ADD_RABMAT_RECORD (
    IDUSER integer,
    IDREESTR integer,
    IDOGL integer,
    IDQUALIFIER integer,
    ORDERVIEW integer,
    NAME_PART blob sub_type 1 segment size 80,
    NAME_TITLE blob sub_type 1 segment size 80,
    ID_GEN integer)
returns (
    ID integer)
AS
DECLARE VARIABLE AUTHOR VARCHAR(250);
DECLARE VARIABLE ISREORDERED INTEGER;
DECLARE VARIABLE IDPAPKA INTEGER;
DECLARE VARIABLE IDTCH INTEGER;
DECLARE VARIABLE RABMAT INTEGER;
DECLARE VARIABLE ID_NAME INTEGER;
DECLARE VARIABLE NEEDUPDATE_NAME_PART SMALLINT;
DECLARE VARIABLE NEEDUPDATE_NAME_TITLE SMALLINT;
BEGIN
 IF ((ID_GEN <> -1) AND ((NAME_PART IS NOT NULL) OR (NAME_TITLE IS NOT NULL))) THEN BEGIN
    IF (ID_GEN > 0) THEN BEGIN
       UPDATE B_TEMP_BLOB SET BLOB1 = :NAME_PART, BLOB2 = :NAME_TITLE WHERE ID = :ID_GEN;
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_GEN INTO :NAME_PART, :NAME_TITLE;
    END
    ELSE BEGIN
       ID_NAME = GEN_ID(B_GEN_TEMP, 1) ;
       INSERT INTO B_TEMP_BLOB(ID, BLOB1, BLOB2) VALUES (:ID_NAME, :NAME_PART, :NAME_TITLE);
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_NAME INTO :NAME_PART, :NAME_TITLE;
       DELETE FROM B_TEMP_BLOB WHERE ID = :ID_NAME ;
    END
 END

 SELECT IDPARENT, RABMAT, IDTCH
 FROM B_REESTR
 WHERE ID = :IDREESTR
 INTO :IDPAPKA, :RABMAT, :IDTCH ;

 IF (IDPAPKA IS NULL)
 THEN EXCEPTION B_E_SBORNIK_NOT_FOUND ;

 ID = GEN_ID(A_G_SMETA,1) ;

 IF (IDOGL <= 0)
 THEN IDOGL = NULL ;
 IF (IDOGL IS NOT NULL)
 THEN
    IF (NOT EXISTS (SELECT * FROM B_OGL WHERE ID = :IDOGL))
    THEN IDOGL = NULL ;

 IF (IDQUALIFIER <= 0)
 THEN IDQUALIFIER = NULL ;
 IF (IDQUALIFIER IS NOT NULL)
 THEN
    IF (NOT EXISTS (SELECT * FROM B_QUALIFIER WHERE ID = :IDQUALIFIER))
    THEN IDQUALIFIER = NULL ;

 IF (ORDERVIEW IS NULL)
 THEN
     ORDERVIEW = :ID - 1; --[15392] -   
     if (exists(select * from B_RABMAT where IDREESTR=:IDREESTR and ORDERVIEW>:ORDERVIEW)) then --[15392] -   
       SELECT MAX(ORDERVIEW)
       FROM B_RABMAT
       WHERE IDREESTR = :IDREESTR
       INTO :ORDERVIEW ;
 IF (ORDERVIEW IS NULL)
 THEN ORDERVIEW = 0;
 ORDERVIEW = ORDERVIEW + 1;
  
 EXECUTE PROCEDURE B_WRITE_NEWORDER_RABMAT(:IDUSER, :ID, :IDREESTR, :ORDERVIEW)
 RETURNING_VALUES (:ISREORDERED);

 EXECUTE PROCEDURE B_READ_USERNAME(:IDUSER)
 RETURNING_VALUES :AUTHOR ;

 IF (IDTCH IS NOT NULL) THEN
    IF (NOT EXISTS(SELECT * FROM B_REESTR_DOC WHERE ID = :IDTCH))
    THEN EXCEPTION B_E_T_CH_NOT_FOUND ;


 IF ((NAME_PART IS NOT NULL) OR (NAME_TITLE IS NOT NULL))
 THEN BEGIN
    IF (NAME_PART IS NULL)
    THEN NEEDUPDATE_NAME_PART = 0;
    ELSE NEEDUPDATE_NAME_PART = 1;

    IF (NAME_TITLE IS NULL)
    THEN NEEDUPDATE_NAME_TITLE = 0;
    ELSE NEEDUPDATE_NAME_TITLE = 1;

    SELECT IDNAME
    FROM B_WRITE_NAME_EX ( :IDUSER, -1, 0, :NAME_PART, :NEEDUPDATE_NAME_PART,
                           :NAME_TITLE, :NEEDUPDATE_NAME_TITLE)
    INTO :ID_NAME;
 END

 BEGIN
    INSERT INTO B_RABMAT
       (ID, IDREESTR, IDPAPKA, ORDERVIEW,RABMAT,IDOGL, IDQUALIFIER, IDTCH, IDNAME, AUTHOR)
    VALUES
       (:ID, :IDREESTR, :IDPAPKA, :ORDERVIEW, :RABMAT, :IDOGL, :IDQUALIFIER, :IDTCH, :ID_NAME, :AUTHOR) ;

    WHEN GDSCODE FOREIGN_KEY, GDSCODE BAD_SEGSTR_ID DO BEGIN
       INSERT INTO B_RABMAT
          (ID, IDREESTR, IDPAPKA, ORDERVIEW,RABMAT,IDOGL, IDQUALIFIER, IDTCH, AUTHOR)
       VALUES
          (:ID, :IDREESTR, :IDPAPKA, :ORDERVIEW, :RABMAT, :IDOGL, :IDQUALIFIER, :IDTCH, :AUTHOR) ;

       IF ((NAME_PART IS NOT NULL) OR (NAME_TITLE IS NOT NULL))
       THEN
          SELECT IDNAME
          FROM B_WRITE_NAME_EX (:IDUSER, 0, :ID,
             :NAME_PART, :NEEDUPDATE_NAME_PART, :NAME_TITLE, :NEEDUPDATE_NAME_TITLE)
          INTO :ID_NAME;

       WHEN GDSCODE FOREIGN_KEY, GDSCODE BAD_SEGSTR_ID DO EXCEPTION B_E_RECORD_IS_LOCKED ;
    END
 END

 SUSPEND ;

END^


--[15371]
create or alter procedure M_CONVERT_RES_TAB (
    ID_USER integer,
    TAB varchar(42),
    NAME_ID integer)
returns (
    NEW_TAB varchar(42))
AS
declare S_NAME blob sub_type 1 segment size 80;
begin
  NEW_TAB = TAB;

  if ((TAB = '0.0-0-0') or (TAB = '2.0-0-0') or (TAB = '22.0-0-0')) then
  begin

    select upper(NAME)
      from B_GETNAME_EX(:ID_USER, :NAME_ID)
    into :S_NAME;

    if (S_NAME = ' ') then NEW_TAB = '9999990001';
    else if (S_NAME = ' ') then NEW_TAB = '9999990002';
    else if (S_NAME = ' ') then NEW_TAB = '9999990003';
    else if (S_NAME = ' ') then NEW_TAB = '9999990004';
    else if (S_NAME = ' ') then NEW_TAB = '9999990005';
    else if (S_NAME = '   ()') then NEW_TAB = '9999990006';
    else if (S_NAME = '   ()') then NEW_TAB = '9999990007';

    else if (S_NAME = '  ()') then NEW_TAB = '9999990008';
    else if (S_NAME = ' ') then NEW_TAB = '9999990008';
  end

end^

--[15371]
create or alter procedure NORMATIV_IS_TSN (
    IDNORMATIV integer)
returns (
    NORMATIV_TYPE integer)
AS
declare variable VN_IDREESTR integer;
declare variable VN_IDTYPE integer;
declare variable VN_NORM_GUID varchar(100);
begin
  /* NORMATIV_TYPE
    -1 -   
     0 -     
     1(tsn_mccs) -    
     2(tsn_mge)  -     */

  VN_IDREESTR = null; VN_IDTYPE = null; VN_NORM_GUID = null;

  select IDREESTR
    from B_RABMAT
    where ID = :IDNORMATIV
  into :VN_IDREESTR;

  if (VN_IDREESTR is not null) then
  begin
    select IDTYPE
      from B_REESTR
    where ID = :VN_IDREESTR
    into :VN_IDTYPE;

    select NORM_GUID
      from B_NORMTYPE
    where ID = :VN_IDTYPE
    into :VN_NORM_GUID;

    NORMATIV_TYPE =
      case VN_NORM_GUID
        when '000!B {8C497DB8-A6FA-44A7-BF73-651413AE0B3F} {h}' then 1 --  
        when '000!B {E3483982-2966-4D63-BB97-E9D4463052D5} {}}' then 2 --  
        else 0 --    
      end;
  end
  else
    NORMATIV_TYPE = -1; --  

end
^

--[15371]
-- 
create or alter procedure M_CONVERT_OBJ_VNB_RES (
    ID_SOURCE integer,
    IDUSER integer,
    IN_PODGROUP integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer,
    RETURN_ALL integer,
    CLEARPRICE_IFNOTFOUND integer,
    REPLACE_CHANGE_NAME integer)
returns (
    ID integer,
    CONVERT_RESULT integer,
    RABMAT integer,
    TAB varchar(42))
AS
begin
  suspend;
end^

--[15371]
/* 
create or alter procedure M_FB_SEARCH_NORMATIV_EX (
*/
--[15371]
/* 
create or alter procedure M_CONVERT_OBJ_VNB (
*/
--[15371]
/* 
create or alter procedure M_CONVERT_OBJ_VNB_RES (
*/
--[15371]
-- 
CREATE OR ALTER PROCEDURE A_S_PASTE_SMETA_RECORD (
    IDUSER INTEGER,
    IDRECORD INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    SLAVEPARENT_INSERT INTEGER,
    VSEGO DOUBLE PRECISION,
    TOBUFFER INTEGER,
    COPY_RES_UCH_STATUS INTEGER)
RETURNS (
    ID INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^
/* .  2 >> */
create or alter procedure DM_OKPD2_CREATE
AS
begin
  if (not exists(select * from RDB$RELATIONS
      where upper(RDB$RELATION_NAME) = 'OKPD2') ) then
  begin

    execute statement
    'CREATE TABLE OKPD2 ('||
    '    ID              A_INTEGERNOTNULL,'||
    '    VERSION_NUMBER  A_VARCHAR10,'||
    '    VERSION_DATE    S_DATE,'||
    '    DATA            S_BLOB /* S_DOUBLE = DOUBLE PRECISION */'||
    ')';

    execute statement 'ALTER TABLE B_RABMAT ADD OKPD2 S_VARCHAR42';
  end
end
^
execute procedure DM_OKPD2_CREATE
^
drop procedure DM_OKPD2_CREATE
^^
create or alter trigger OKPD2_BI_0 for OKPD2
active before insert position 0
as
begin
  if ((new.ID is null) or
      (new.ID = 0)) then
    new.ID = gen_id(A_G_SMETA, 1);
end
^

--[15432]
create or alter procedure L_FB_SEARCH_ID_WITH_EDIZM (
    STAB varchar(42),
    EDIZM varchar(250),
    IN_PODGROUP integer,
    IN_RABMAT integer,
    ID_USER integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer,
    FETCHMODE integer,
    ID_PUT_TRUD integer)
returns (
    ID_SELF integer,
    PODGROUP integer,
    RABMAT integer,
    ID_ABC_OKP integer,
    BEDA1 integer,
    BEDA2 integer,
    BEDARAB integer,
    BEDAMASH integer,
    BEDAMAT integer,
    LAST_EDIZM integer,
    TAB_FOUND varchar(42))
AS
declare variable FETCHMODE1 INTEGER;
declare variable edizm_name varchar(100);
declare variable edizm_fullname varchar(250);
declare variable idedizm INTEGER;
declare variable fetch_cnt INTEGER;
declare variable found_cnt INTEGER;
begin
--[15432]+ TAB_FOUND

   fetch_cnt = 0;
   found_cnt = 0;

   FETCHMODE1 = 0;
   LAST_EDIZM = null;

   if ( not EDIZM is null ) then
   begin
      EDIZM = s_transliterate ( :EDIZM );
      if ( EDIZM = '' ) then
         EDIZM = null;
   end

   if ( not EDIZM is null ) then
      FETCHMODE1 = 1;


   for select ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP,
              BEDA1, BEDA2, BEDARAB, BEDAMASH, BEDAMAT
       from  L_FB_SEARCH_ID ( :STAB, :IN_PODGROUP, :IN_RABMAT, :ID_USER,
                 :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, :FETCHMODE1, :ID_PUT_TRUD )
       into   ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP,
              BEDA1, BEDA2, BEDARAB, BEDAMASH, BEDAMAT
   do
      if ( EDIZM is null ) then
      begin
         if ( ID_SELF > 0 ) then
         begin
            found_cnt = found_cnt + 1;
            if ( PODGROUP > 1 ) then
               select first 1 TAB from b_abc_okp where id = :ID_SELF into :TAB_FOUND; --[15432,12447]
            else if ( RABMAT = 1 ) then
               select first 1 TAB from b_trud where id = :ID_SELF into :TAB_FOUND; --[15432,12447]
            else
               select first 1 TAB from b_rabmat where id = :ID_SELF into :TAB_FOUND; --[15432,12447]
         end
         fetch_cnt = fetch_cnt + 1;
         suspend;
         if ( FETCHMODE = 0 ) then
            exit;
      end
      else
      begin
         idedizm = null;
         if ( ID_SELF > 0 ) then
         begin
            found_cnt = found_cnt + 1;
            if ( PODGROUP > 1 ) then
               select first 1 idedizm, TAB from b_abc_okp where id = :ID_SELF into idedizm, :TAB_FOUND; --[15432,12447]
            else if ( RABMAT = 1 ) then
               select first 1 idedizm, TAB from b_trud where id = :ID_SELF into idedizm, :TAB_FOUND; --[15432,12447]
            else
               select first 1 idedizm, TAB from b_rabmat where id = :ID_SELF into idedizm, :TAB_FOUND; --[15432,12447]

            if ( not idedizm is null ) then
            begin
               last_edizm = idedizm;
               execute procedure b_get_edizm ( idedizm ) returning_values ( :edizm_name , :edizm_fullname );
               if ( ( s_transliterate ( edizm_name ) <> edizm ) and ( s_transliterate ( edizm_fullname ) <> edizm ) ) then
                  idedizm = null;
            end
         end

         if ( idedizm is null ) then
         begin
            ID_SELF = 0;
            PODGROUP = 0;
            RABMAT = 0;
            ID_ABC_OKP = 0;
            BEDA1 = 0;
            BEDA2 = 0;
            BEDARAB = 0;
            BEDAMASH = 0;
            BEDAMAT = 0;
         end

         if ( not idedizm is null ) then
         begin
            last_edizm = idedizm;
            fetch_cnt = fetch_cnt + 1;
            suspend;
            if ( FETCHMODE = 0 ) then
               exit;
         end
      end

   if ( fetch_cnt = 0 ) then
   begin
      ID_SELF = 0;
      BEDA1 = 0;
      if ( found_cnt > 0 ) then
         BEDA1 = 100;
      suspend;
   end
end
^

--[15432]
create or alter procedure L_IMP_VC_WRITE_ZONA_CENA_EX1 (
    ID_ZONE integer,
    TAB varchar(42),
    EDIZM varchar(250),
    ZONE_BA double precision,
    ZONE_BB double precision,
    ZONE_BC double precision,
    ZONE_BD double precision,
    ZONE_BE double precision,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer,
    ADD_IF_NOT_FOUND integer,
    NAME_TITLE blob sub_type 0 segment size 80,
    NAME_PART blob sub_type 0 segment size 80,
    RAZRAD double precision,
    IDREESTR integer,
    ID_USER integer,
    ID_PUT_TRUD integer,
    FILL_MASK integer,
    USE_EDIZM_IN_FILTER integer,
    UPDNAMEANDEDIZM integer,
    FIND_EDIZM_MODE integer)
returns (
    RES integer,
    IDNORMATIV integer,
    IDRABMAT integer,
    IDPODGROUP integer,
    INSERTED integer,
    LAST_EDIZM_NAME varchar(255),
    FOUNDED integer)
AS
declare variable RESACTION SMALLINT;
declare variable RESULT integer;
declare variable BEDA1 integer;
declare variable TABU VARCHAR(42);
DECLARE VARIABLE RABMAT INTEGER;
DECLARE VARIABLE ALTTAB VARCHAR(250);
DECLARE VARIABLE IDEDIZM INTEGER;
DECLARE VARIABLE IDTCH INTEGER;
DECLARE VARIABLE FRTCH VARCHAR(250);
DECLARE VARIABLE IDESN INTEGER;
DECLARE VARIABLE FRESN VARCHAR(21);
DECLARE VARIABLE COMMENT VARCHAR(42);
DECLARE VARIABLE BA DOUBLE PRECISION;
DECLARE VARIABLE BB DOUBLE PRECISION;
--<[14355]>
declare BB_OTP double precision; --</>
DECLARE VARIABLE BC DOUBLE PRECISION;
DECLARE VARIABLE BD DOUBLE PRECISION;
DECLARE VARIABLE BE DOUBLE PRECISION;
DECLARE VARIABLE BF DOUBLE PRECISION;
DECLARE VARIABLE BG DOUBLE PRECISION;
DECLARE VARIABLE BH DOUBLE PRECISION;
DECLARE VARIABLE BI DOUBLE PRECISION;
--<[14420]>
declare TRANSP_P double precision;
declare ZAG_SKL_1 double precision;
declare ZAG_SKL_P double precision;
declare KLASS_G integer;
declare TAB_TRANSP varchar(42);
--</>
DECLARE VARIABLE BJ DOUBLE PRECISION;
DECLARE VARIABLE PA DOUBLE PRECISION;
DECLARE VARIABLE PB DOUBLE PRECISION;
DECLARE VARIABLE PC DOUBLE PRECISION;
DECLARE VARIABLE PD DOUBLE PRECISION;
DECLARE VARIABLE PE DOUBLE PRECISION;
DECLARE VARIABLE MA DOUBLE PRECISION;
DECLARE VARIABLE MB DOUBLE PRECISION;
DECLARE VARIABLE MC DOUBLE PRECISION;
DECLARE VARIABLE MD DOUBLE PRECISION;
DECLARE VARIABLE ME DOUBLE PRECISION;
DECLARE VARIABLE MF DOUBLE PRECISION;
DECLARE VARIABLE MG DOUBLE PRECISION;
DECLARE VARIABLE MH DOUBLE PRECISION;
DECLARE VARIABLE MI DOUBLE PRECISION;
DECLARE VARIABLE MJ DOUBLE PRECISION;
DECLARE VARIABLE MK DOUBLE PRECISION;
DECLARE VARIABLE ML DOUBLE PRECISION;
DECLARE VARIABLE MM DOUBLE PRECISION;
DECLARE VARIABLE MN DOUBLE PRECISION;
DECLARE VARIABLE MO DOUBLE PRECISION;
DECLARE VARIABLE MP DOUBLE PRECISION;
DECLARE VARIABLE MQ DOUBLE PRECISION;
DECLARE VARIABLE MR DOUBLE PRECISION;
DECLARE VARIABLE MS DOUBLE PRECISION;
DECLARE VARIABLE MT DOUBLE PRECISION;
DECLARE VARIABLE VRPZ INTEGER;
DECLARE VARIABLE NTR INTEGER;
DECLARE VARIABLE BRUTTO DOUBLE PRECISION;
DECLARE VARIABLE NETTO DOUBLE PRECISION;
DECLARE VARIABLE VB DOUBLE PRECISION;
DECLARE VARIABLE VN DOUBLE PRECISION;
DECLARE VARIABLE PREISK VARCHAR(42);
DECLARE VARIABLE POSPREISK VARCHAR(42);
DECLARE VARIABLE MBETON DOUBLE PRECISION;
DECLARE VARIABLE MRKBETON VARCHAR(15);
DECLARE VARIABLE MMASHINE VARCHAR(25);
DECLARE VARIABLE VBETON DOUBLE PRECISION;
DECLARE VARIABLE TKALK VARCHAR(50);
DECLARE VARIABLE PUNKTIND VARCHAR(42);
DECLARE VARIABLE IDSOSTAV INTEGER;
DECLARE VARIABLE IDTCARD INTEGER;
DECLARE VARIABLE IDPICTURE INTEGER;
DECLARE VARIABLE IDPOSTAV INTEGER;
DECLARE VARIABLE ISESN SMALLINT;
DECLARE VARIABLE IDWITHESN INTEGER;
DECLARE VARIABLE ID_UNIQUE INTEGER;
DECLARE VARIABLE IDQUALIFIER INTEGER;
DECLARE VARIABLE ISH_ZONE_BA DOUBLE PRECISION;
DECLARE VARIABLE ISH_ZONE_BB DOUBLE PRECISION;
DECLARE VARIABLE ISH_ZONE_BC DOUBLE PRECISION;
DECLARE VARIABLE ISH_ZONE_BD DOUBLE PRECISION;
DECLARE VARIABLE ISH_ZONE_BE DOUBLE PRECISION;
DECLARE VARIABLE ISZONEFIND INTEGER;
DECLARE VARIABLE ID_BLOB_GEN INTEGER;
DECLARE VARIABLE DO_UPDATE INTEGER;
DECLARE VARIABLE EDIZM_FOR_SEARCH VARCHAR(250);
DECLARE VARIABLE dummy INTEGER;
DECLARE VARIABLE LAST_EDIZM INTEGER;
declare TABU_8 varchar(42); --[14280,12447]
declare TAB_FOUND varchar(42); --[15432]
begin

-- RES = -1; /*    */
-- RES = 0;  /*    ?? */
-- RES = 1;  /*   (VC)*/
-- RES = 2;  /*   (VC)*/
-- RES = 4;  /*   , ..   (VC)*/
-- RES = 5;  /* Deadlock */
-- RES = 6;  /* ,    .  */

   RES = -1;
   FOUNDED = 0;

   IDNORMATIV = 0;
   BEDA1 = 0;
   INSERTED = 0;

   ID_BLOB_GEN = 0;
   DO_UPDATE = 1;

   if ( FILL_MASK is null ) then
      FILL_MASK = -1;

   if ( IDREESTR is null ) then
      IDREESTR = 0;

   if ( USE_EDIZM_IN_FILTER is null ) then
      USE_EDIZM_IN_FILTER = 0;

   EDIZM_FOR_SEARCH = EDIZM;
   if ( USE_EDIZM_IN_FILTER = 0 ) then
      EDIZM_FOR_SEARCH = null;

   if ( UpdNameAndEdIzm is null ) then
      UpdNameAndEdIzm = 0;

   -- MK 10.03.2011 CQ[9163] --->
   if (FIND_EDIZM_MODE is null) then
      FIND_EDIZM_MODE = 0;
   -- MK 10.03.2011 CQ[9163] <---


   if ( ( not NAME_TITLE is null ) or ( not NAME_PART is null ) ) then
   begin
       ID_BLOB_GEN = GEN_ID(B_GEN_TEMP, 1);
       INSERT INTO B_TEMP_BLOB(ID, BLOB1, BLOB2) VALUES (:ID_BLOB_GEN, :NAME_TITLE, :NAME_PART);
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_BLOB_GEN INTO :NAME_TITLE, :NAME_PART;
   end


   if ( ( ADD_IF_NOT_FOUND is null ) or ( ADD_IF_NOT_FOUND = 0 ) ) then
   begin

      select first 1 ID_SELF, RABMAT , PODGROUP , BEDA1 , LAST_EDIZM,
          TAB_FOUND --[15432,12447]
      from l_fb_search_id_with_edizm ( :tab , :edizm_for_search , 1 , -1 , :id_user , :ID_PUT_RAB , :ID_PUT_MASH , :ID_PUT_MAT , 0 , :ID_PUT_TRUD )
      into :IDNORMATIV, :IDRABMAT, :IDPODGROUP, :BEDA1, :LAST_EDIZM,
          :TAB_FOUND; --[15432,12447]

      --[15432,12447]:
      if (IDNORMATIV <> 0) then
        if (S_TRANSLITERATE(:TAB) <> S_TRANSLITERATE(:TAB_FOUND))  then
          IDNORMATIV = null;

      if ( ( IDNORMATIV is null ) or ( IDNORMATIV = 0 ) ) then
      begin
         if ( BEDA1 = 100 ) then
         begin
            RES = 6;
            if ( not last_edizm is null ) then
               select first 1 name from b_edizm where id = :last_edizm into last_edizm_name;
         end
         DO_UPDATE = 0;
      end
      else
         FOUNDED = 1;

   end
   else
   begin

      select first 1 ID_SELF, RABMAT , PODGROUP , BEDA1,
          TAB_FOUND --[15432,12447]
      from l_fb_search_id_with_edizm ( :tab , :edizm_for_search /*null*/ , 1 , -1 , :id_user , :ID_PUT_RAB , :ID_PUT_MASH , :ID_PUT_MAT , 0 , :ID_PUT_TRUD )
      into :IDNORMATIV, :IDRABMAT, :IDPODGROUP, :BEDA1,
          :TAB_FOUND; --[15432,12447];

      --[15432,12447]:
      if (IDNORMATIV <> 0) then
        if (S_TRANSLITERATE(:TAB) <> S_TRANSLITERATE(:TAB_FOUND)) then
          IDNORMATIV = null;

      if ( IDNORMATIV <> 0 ) then
         FOUNDED = 1;

      if ( ( ( IDNORMATIV is null ) or ( IDNORMATIV = 0 ) ) and
           ( IDREESTR <> 0 ) ) then
      begin

         --[14280]TABU = TAB;
         IF ( (TAB IS NOT NULL) and (TAB <> '') ) THEN
         begin
            TABU = S_TRANSLITERATE_TAB(LCKTRIMVARCHAR(TAB)); --[12447]
            TABU_8 = S_TRANSLITERATE(LCKTRIMVARCHAR(TAB)); --[14280]

             /* ,        */
             SELECT first 1 ID, RABMAT FROM B_RABMAT
             WHERE ( TABU  = :TABU ) and ( IDREESTR = :IDREESTR )
               and S_TRANSLITERATE(TAB) = :TABU_8 --[14280,12447]
             INTO IDNORMATIV, IDRABMAT;
         end

         IDPODGROUP = 1;

         if ( ( IDNORMATIV is null ) or ( IDNORMATIV = 0 ) ) then
         begin

            IDTCH     = NULL;  FRTCH    = NULL;  IDSOSTAV  = NULL;  ALTTAB    = NULL;
            COMMENT   = NULL;  IDTCARD  = NULL;  ID_UNIQUE = NULL;
            IDESN     = NULL;  FRESN    = NULL;  RAZRAD    = NULL;  VRPZ      = NULL;
            NTR       = NULL;  BRUTTO   = NULL;  NETTO     = NULL;  VB        = NULL;
            VN        = NULL;  PREISK   = NULL;  POSPREISK = NULL;  MBETON    = NULL;
            MRKBETON  = NULL;  VBETON   = NULL;  MMASHINE  = NULL;  IDPICTURE = NULL;
            TKALK     = NULL;  PUNKTIND = NULL;  IDPOSTAV  = NULL;  ISESN     = NULL;
            IDWITHESN = NULL;  IDQUALIFIER = NULL;

            BA = NULL; BB = NULL;
            BB_OTP = null; --[14355]
            BC = NULL;  BD = NULL; BE = NULL; BF = NULL;
            BG = NULL; BH = NULL; BI = NULL;
            TRANSP_P = null; ZAG_SKL_1 = null; ZAG_SKL_P = null; KLASS_G = null; TAB_TRANSP = null; --<<[14420]
            BJ = NULL; PA = NULL; PB = NULL;
            PC = NULL; PD = NULL; PE = NULL;  MA = NULL; MB = NULL; MC = NULL;
            MD = NULL; ME = NULL; MF = NULL;  MG = NULL; MH = NULL; MI = NULL;
            MJ = NULL; MK = NULL; ML = NULL;  MM = NULL; MN = NULL; MO = NULL;
            MP = NULL; MQ = NULL; MR = NULL;  MS = NULL; MT = NULL;

            /*    B_Rabmat */
            SELECT ID
            FROM B_ADD_RABMAT_RECORD (:ID_USER, :IDREESTR, null/*:IDOGL*/, null/*:IDQUALIFIER*/,
                                      NULL, :NAME_PART, :NAME_TITLE, -1)
            INTO :IDNORMATIV;

            RABMAT = 3;
            select first 1 RABMAT from B_REESTR
            where ID = :IDREESTR
            into RABMAT;

            -- MK 10.03.2011 CQ[9163] --->
            execute procedure mb_add_edizm_in_silence(:ID_USER, substring(:EDIZM from 1 for 100), :EDIZM, :FIND_EDIZM_MODE)
               returning_values(:IDEDIZM);

            --execute procedure b_add_edizm_in_silence ( :ID_USER, substring ( :EDIZM from 1 for 100 ) , null )
            --   returning_values ( :IDEDIZM );
            -- MK 10.03.2011 CQ[9163] <---

            ALTTAB = TAB;
            VRPZ = 0;
            if ( ID_ZONE = -3 ) then
            begin
               BA = ZONE_BA;
               BB = ZONE_BB;
               BC = ZONE_BC;
               BD = ZONE_BD;
               BE = ZONE_BE;
               BF = NULL;
               BG = NULL;
               BH = NULL;
               BI = NULL;
            end

            IDRABMAT = RABMAT;
            IDPODGROUP = 1;

            EXECUTE PROCEDURE B_WRITE_RECORD_RABMAT(:ID_USER, :IDREESTR, :IDNORMATIV, NULL,
                :RABMAT, NULL, NULL, :TAB, null/*:IDOGL*/, :ALTTAB, :IDEDIZM, :RAZRAD,
                :BA, :BB,
                :BB_OTP, --[14355]
                null, -- BB_PR CQ[15046]
                :BC, :BD, :BE, :BF, :BG, :BH, :BI,
                :TRANSP_P, :ZAG_SKL_1, :ZAG_SKL_P, :KLASS_G, :TAB_TRANSP, --<<[14420]
                :BJ, :PA, :PB,
                :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH,
                :MI, :MJ, :MK, :ML, :MM, :MN, :MO, :MP, :MQ, :MR, :MS, :MT,
                :VRPZ, :NTR, :BRUTTO, :NETTO, :VB, :VN, :PREISK, :POSPREISK,
                :TKALK, :MBETON, :MRKBETON, :VBETON, :MMASHINE, :PUNKTIND,
                :IDPOSTAV, NULL, :COMMENT, :ISESN, :IDWITHESN, :IDSOSTAV,
                NULL, :IDTCH, :FRTCH, :IDESN, :FRESN, :IDTCARD,
                :IDPICTURE, :IDQUALIFIER, 1, NULL, NULL, NULL, NULL, NULL, 0, 0, 1, 0, 0, -1,
                null) ; -- TRANSP_SH CQ[15039]

            if ( ID_ZONE = -3 ) then
               DO_UPDATE = 0;

            INSERTED = 1;
            if ( DO_UPDATE = 0 ) then  -- 3.2
               RES = 2;                -- 3.2

         end

      end

   end

   RABMAT = IDRABMAT;

   if ( DO_UPDATE <> 0 ) then
   begin
      if ( FILL_MASK <> -1 ) then
      begin
         execute procedure L_FILL_CCURRENT1 ( :IDNORMATIV, :RABMAT, :IDPODGROUP, :ID_ZONE, :ID_USER )
            returning_values ( :ISH_ZONE_BA, :ISH_ZONE_BB, :ISH_ZONE_BC, :ISH_ZONE_BD, :ISH_ZONE_BE, :ISZONEFIND );
         if ( ISZONEFIND <> 0 ) then
         begin
            if ( getbit ( FILL_MASK , 0 ) = 0 ) then
               ZONE_BA = ISH_ZONE_BA;
            if ( getbit ( FILL_MASK , 1 ) = 0 ) then
               ZONE_BB = ISH_ZONE_BB;
            if ( getbit ( FILL_MASK , 2 ) = 0 ) then
               ZONE_BC = ISH_ZONE_BC;
            if ( getbit ( FILL_MASK , 3 ) = 0 ) then
               ZONE_BD = ISH_ZONE_BD;
            if ( getbit ( FILL_MASK , 4 ) = 0 ) then
               ZONE_BE = ISH_ZONE_BE;
         end
      end

      if ( ( INSERTED = 0 ) and ( UpdNameAndEdIzm <> 0 ) ) then
      begin

         if ((UpdNameAndEdIzm = 1) or (getbit(UpdNameAndEdIzm,  1) = 1))  then  -- MK 10.03.2011 CQ[9163]
           if ( getbit ( FILL_MASK ,  9 ) = 1 ) then
              select first 1 IDNAME
              from B_WRITE_NAME_EX ( :id_user , 0 , :idnormativ , :name_part , 1 , :name_title , 1 )
              into dummy;

         if ((UpdNameAndEdIzm = 1) or (getbit(UpdNameAndEdIzm,  2) = 1))  then  -- MK 10.03.2011 CQ[9163]
           if ( getbit ( FILL_MASK , 10 ) = 1 ) then
           begin

              -- MK 10.03.2011 CQ[9163] --->
              execute procedure mb_add_edizm_in_silence(:id_user, substring(:EDIZM from 1 for 100), :EDIZM, :FIND_EDIZM_MODE)
                 returning_values(:IDEDIZM);
  
              --execute procedure b_add_edizm_in_silence ( :id_user, substring ( :edizm from 1 for 100 ) , null )
              --   returning_values ( :idedizm );
              -- MK 10.03.2011 CQ[9163] <---

              execute procedure b_write_ed_izm_in_table ( :id_user, 0, :idnormativ, :idedizm );
           end
      end

      execute procedure L_SAVE_CCURRENT_TO_NORMY ( :ID_USER, :ID_ZONE,
          :IDNORMATIV, :IDRABMAT, :IDPODGROUP,
          :ZONE_BA, :ZONE_BB, :ZONE_BC, :ZONE_BD, :ZONE_BE, 0, 0/*1*/ )
      returning_values ( :RESULT, :RESACTION );

      RES = RESACTION;

      if ( RESULT = -1 ) then
         RES = 5;
      else if ( RESULT = -2 ) then
         RES = -1;

   when sqlcode -913 , gdscode lock_conflict , gdscode lock_timeout , gdscode deadlock do
      RES = 5;

   end

   if ( ID_BLOB_GEN <> 0 ) then
       delete from B_TEMP_BLOB where ID = :ID_BLOB_GEN;
end
^

--[15196]
/* Trigger: B_REESTR_BD0 */
CREATE or alter TRIGGER B_REESTR_BD0 FOR B_REESTR
ACTIVE BEFORE DELETE POSITION 0
AS
declare IDUSER integer;
declare IDNAME integer;
begin
--[15196]
--       ,
--       ...
--     ,
--      
  for select IDNAME
    from B_IND
    where IDREESTR=old.ID
      and IDNAME is not null
    group by IDREESTR,IDNAME --<<   
  into :IDNAME
  do
  if (not exists(
      select * from B_IND
        where IDNAME = :IDNAME
          and IDREESTR <> old.ID)) then
  begin
    update B_IND
      set IDNAME = null
      where IDNAME = :IDNAME
        and coalesce(IDREESTR, 0) = old.ID; --<<   
    execute procedure B_DELETE_NAIMENOVANIE(:IDUSER, :IDNAME);
  end

  update B_IND
    set IDNAME = null
    where IDREESTR = old.ID
      and IDNAME is not null;
end
^

--[15352]
create or alter procedure S__UPGRADE_SMETA_B_PR_15352
AS
begin
  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='A_O_PARAMS_LS'
        and upper(f.RDB$FIELD_NAME)='K_PR')) then
    execute statement
'alter table A_O_PARAMS_LS' ||
' add K_PR A_VARCHAR50';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='A_O_PARAMS_R_PR'
        and upper(f.RDB$FIELD_NAME)='K_PR')) then
    execute statement
'alter table A_O_PARAMS_R_PR' ||
' add K_PR A_VARCHAR50';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='A_SMETA'
        and upper(f.RDB$FIELD_NAME)='K_PR')) then
    execute statement
'alter table A_SMETA' ||
' add MMAT    S_DOUBLE,' ||
' add MOBORUD S_DOUBLE,' ||
' add MGARB   S_DOUBLE,' ||
' add MGRUNT  S_DOUBLE,' ||
' add VGRUNT  S_DOUBLE,' ||
' add B_PR    S_DOUBLE,' ||
' add K_PR    A_VARCHAR50';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='A_SMETA_CENLVL'
        and upper(f.RDB$FIELD_NAME)='B_PR')) then
    execute statement
'alter table A_SMETA_CENLVL' ||
' add B_PR S_DOUBLE,' ||
' add C_PR S_DOUBLE,' ||
' add E_PR S_DOUBLE,' ||
' add R_PR S_DOUBLE';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='A_SMETA_CENLVL'
        and upper(f.RDB$FIELD_NAME)='RC_16')) then
    execute statement
'alter table A_SMETA_CENLVL' ||
' add RC_16 S_DOUBLE,' ||
' add RE_16 S_DOUBLE,' ||
' alter ID position 1,' ||
' alter IDCENLVL position 2,' ||
' alter IDZONE position 3,' ||
' alter ID_LEVEL_VC position 4,' ||
' alter BA position 5,' ||
' alter BB position 6,' ||
' alter BC position 7,' ||
' alter BD position 8,' ||
' alter BE position 9,' ||
' alter BF position 10,' ||
' alter BG position 11,' ||
' alter BH position 12,' ||
' alter BI position 13,' ||
' alter BJ position 14,' ||
' alter BN position 15,' ||
' alter BO position 16,' ||
' alter B_ITOGO position 17,' ||
' alter B_PR position 18,' ||
' alter CA position 19,' ||
' alter CB position 20,' ||
' alter CC position 21,' ||
' alter CD position 22,' ||
' alter CE position 23,' ||
' alter CF position 24,' ||
' alter CG position 25,' ||
' alter CH position 26,' ||
' alter CI position 27,' ||
' alter CJ position 28,' ||
' alter C_ITOGO position 29,' ||
' alter C_PR position 30,' ||
' alter EA position 31,' ||
' alter EB position 32,' ||
' alter EC position 33,' ||
' alter ED position 34,' ||
' alter EE position 35,' ||
' alter EF position 36,' ||
' alter EG position 37,' ||
' alter EH position 38,' ||
' alter EI position 39,' ||
' alter EJ position 40,' ||
' alter EK position 41,' ||
' alter EN position 42,' ||
' alter EO position 43,' ||
' alter E_ITOGO position 44,' ||
' alter E_PR position 45,' ||
' alter RA position 46,' ||
' alter RB position 47,' ||
' alter RC position 48,' ||
' alter RD position 49,' ||
' alter RE position 50,' ||
' alter RF position 51,' ||
' alter RG position 52,' ||
' alter RH position 53,' ||
' alter RI position 54,' ||
' alter RJ position 55,' ||
' alter RK position 56,' ||
' alter RL position 57,' ||
' alter RM position 58,' ||
' alter PA position 59,' ||
' alter PB position 60,' ||
' alter PC position 61,' ||
' alter PD position 62,' ||
' alter ITOGO position 63,' ||
' alter R_PR position 64,' ||
' alter RC_16 position 65,' ||
' alter RE_16 position 66,' ||
' alter CALCBMASK position 67,' ||
' alter BASE_INFO position 68,' ||
' alter CURR_CENA position 69,' ||
' alter BASE_CALC_INFO position 70,' ||
' alter SOURCE_LEVEL_ID position 71,' ||
' alter CURR_CENA_INFO position 72,' ||
' alter ID_VALUTE position 73,' ||
' alter VALUTE_CURS position 74,' ||
' alter VALUTE_DATE position 75,' ||
' alter TRANSP position 76,' ||
' alter ZAG_SKL position 77,' ||
' alter ZAPCHAST position 78,' ||
' alter TARA position 79,' ||
' alter NACEN position 80,' ||
' alter COMPLECT position 81,' ||
' alter KOEFF_TYPE position 82';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='A_SMETA_CENLVL_BASE_FORMUL'
        and upper(f.RDB$FIELD_NAME)='SBQ')) then
    execute statement
'alter table A_SMETA_CENLVL_BASE_FORMUL' ||
' add SBQ S_VARCHAR255';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='A_SMETA_INDLVL'
        and upper(f.RDB$FIELD_NAME)='M_PR')) then
    execute statement
'alter table A_SMETA_INDLVL' ||
' add M_PR S_DOUBLE,' ||
' alter ID position 1,' ||
' alter IDCENLVL position 2,' ||
' alter IDINDEX position 3,' ||
' alter ID_LEVEL_INDEX position 4,' ||
' alter PUNKTIND position 5,' ||
' alter MA position 6,' ||
' alter MB position 7,' ||
' alter MC position 8,' ||
' alter MD position 9,' ||
' alter ME position 10,' ||
' alter MF position 11,' ||
' alter MG position 12,' ||
' alter MH position 13,' ||
' alter MI position 14,' ||
' alter MJ position 15,' ||
' alter MK position 16,' ||
' alter ML position 17,' ||
' alter MM position 18,' ||
' alter M_PR position 19,' ||
' alter DA position 20,' ||
' alter DB position 21,' ||
' alter DC position 22,' ||
' alter DD position 23,' ||
' alter DE position 24,' ||
' alter DJ position 25,' ||
' alter DK position 26,' ||
' alter DL position 27,' ||
' alter DM position 28,' ||
' alter INDEX_SPOSOBRASCH position 29,' ||
' alter INDEX_INFO position 30';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='A_SMETA_INDLVL_DESCR'
        and upper(f.RDB$FIELD_NAME)='NM_PR')) then
    execute statement
'alter table A_SMETA_INDLVL_DESCR' ||
' add NM_PR A_VARCHAR255,' ||
' alter ID position 1,' ||
' alter IDCENLVL position 2,' ||
' alter NMA position 3,' ||
' alter NMB position 4,' ||
' alter NMC position 5,' ||
' alter NMD position 6,' ||
' alter NME position 7,' ||
' alter NMF position 8,' ||
' alter NMG position 9,' ||
' alter NMH position 10,' ||
' alter NMI position 11,' ||
' alter NMJ position 12,' ||
' alter NMK position 13,' ||
' alter NML position 14,' ||
' alter NMM position 15,' ||
' alter NM_PR position 16,' ||
' alter NDA position 17,' ||
' alter NDB position 18,' ||
' alter NDC position 19,' ||
' alter NDD position 20,' ||
' alter NDE position 21,' ||
' alter NDJ position 22,' ||
' alter NDK position 23,' ||
' alter NDL position 24,' ||
' alter NDM position 25';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='CORRECTIONS'
        and upper(f.RDB$FIELD_NAME)='K_PR')) then
    execute statement
'alter table CORRECTIONS' ||
' add K_PR A_VARCHAR50';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='K_CORRECTION_TABLE'
        and upper(f.RDB$FIELD_NAME)='M_PR')) then
    execute statement
'alter table K_CORRECTION_TABLE' ||
' add M_PR A_VARCHAR50';

  if (not exists(select * from RDB$RELATION_FIELDS f
      where upper(f.RDB$RELATION_NAME)='LEVEL_INDEX_ITOG'
        and upper(f.RDB$FIELD_NAME)='MN')) then
    execute statement
'alter table LEVEL_INDEX_ITOG' ||
' add MN L_D_DOUBLEDEF1,' ||
' add NMN S_VARCHAR255,' ||
' alter ID_COMPOSE position 1,' ||
' alter MA position 2,' ||
' alter MB position 3,' ||
' alter MC position 4,' ||
' alter MD position 5,' ||
' alter ME position 6,' ||
' alter MJ position 7,' ||
' alter MK position 8,' ||
' alter ML position 9,' ||
' alter MM position 10,' ||
' alter MN position 11,' ||
' alter DA position 12,' ||
' alter DB position 13,' ||
' alter DJ position 14,' ||
' alter DK position 15,' ||
' alter DL position 16,' ||
' alter DM position 17,' ||
' alter NMA position 18,' ||
' alter NMB position 19,' ||
' alter NMC position 20,' ||
' alter NMD position 21,' ||
' alter NME position 22,' ||
' alter NMJ position 23,' ||
' alter NMK position 24,' ||
' alter NML position 25,' ||
' alter NMM position 26,' ||
' alter NMN position 27,' ||
' alter NDA position 28,' ||
' alter NDB position 29,' ||
' alter NDJ position 30,' ||
' alter NDK position 31,' ||
' alter NDL position 32,' ||
' alter NDM position 33,' ||
' alter NOTE position 34,' ||
' alter DIRTY_MASK position 35,' ||
' alter SPOSOBRASCH position 36';

end
^
execute procedure S__UPGRADE_SMETA_B_PR_15352
^
drop procedure S__UPGRADE_SMETA_B_PR_15352
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_P_SMETA_EX (
    IDOBJECT INTEGER,
    IDLEVEL INTEGER,
    IDUSER INTEGER,
    SMETATYPE INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    IDLS INTEGER,
    IDR INTEGER,
    ALLREC INTEGER,
    SENDER INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    NBA DOUBLE PRECISION,
    NBB DOUBLE PRECISION,
    NBC DOUBLE PRECISION,
    NBD DOUBLE PRECISION,
    NBE DOUBLE PRECISION,
    NBF DOUBLE PRECISION,
    NBG DOUBLE PRECISION,
    NBH DOUBLE PRECISION,
    NBI DOUBLE PRECISION,
    NBJ DOUBLE PRECISION,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    IDFORMULS INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_APPENDREC_NL (
    IDUSER INTEGER,
    ID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME_ID INTEGER,
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    ID_S_RES INTEGER,
    VRPZ INTEGER,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    TIPRAB INTEGER,
    PUNKTIND VARCHAR(42),
    NORM_GUID VARCHAR(100),
    VIDRAB INTEGER,
    APPLAY_INDEX_AS_IS INTEGER,
    APPLAY_FORMULS_AS_IS INTEGER,
    APPLAY_POPR_AS_IS INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    COPY_RES_ID INTEGER,
    NOMERROD INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    RES_DOB_V_CENU INTEGER,
    REPLACE INTEGER,
    IDFORMULS INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    K_ITOGO VARCHAR(50),
    B_PR DOUBLE PRECISION,
    K_PR VARCHAR(50))
RETURNS (
    OUT_IDFORMULS INTEGER,
    OUT_ID INTEGER,
    OUT_SMETATYPE INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_GET_INDEX_NL (
    ID_LEVEL INTEGER,
    ID_USER INTEGER,
    ATYPE INTEGER,
    IN_PUNKTIND VARCHAR(42),
    ID_LEVEL_INDEX INTEGER,
    ID_SM_REC INTEGER)
RETURNS (
    IDINDEX INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    PUNKTIND VARCHAR(42),
    SPOSOB_RASCH INTEGER,
    RES_INDEX INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_GET_INDEX_NL_NEW (
    ID_LEVEL INTEGER,
    ID_USER INTEGER,
    ATYPE INTEGER,
    IN_PUNKTIND VARCHAR(42),
    ID_LEVEL_INDEX INTEGER,
    ID_SM_REC INTEGER,
    NEED_APPLY_INDEX INTEGER)
RETURNS (
    IDINDEX INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    M_PR DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    PUNKTIND VARCHAR(42),
    SPOSOB_RASCH INTEGER,
    RES_INDEX INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_GET_NRSPZU_INDEX_NL_1 (
    ID_USER INTEGER,
    ID_SM_REC INTEGER,
    IN_PUNKTIND VARCHAR(42),
    IN_SLAVEPARENT INTEGER,
    IDCENLVL INTEGER,
    MODE INTEGER)
RETURNS (
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_GET_POPR (
    ATYPE INTEGER,
    SLAVEPARENT INTEGER,
    RES_COPY_POPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    KN VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
RETURNS (
    RES_KA VARCHAR(50),
    RES_KB VARCHAR(50),
    RES_KC VARCHAR(50),
    RES_KD VARCHAR(50),
    RES_KE VARCHAR(50),
    RES_KF VARCHAR(50),
    RES_KG VARCHAR(50),
    RES_KH VARCHAR(50),
    RES_KI VARCHAR(50),
    RES_KJ VARCHAR(50),
    RES_KK VARCHAR(50),
    RES_KL VARCHAR(50),
    RES_KM VARCHAR(50),
    RES_KN VARCHAR(50),
    RES_K_ITOGO VARCHAR(50),
    RES_K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_PARAMS_TO_SMETA_NL_ONE (
    IDUSER INTEGER,
    IDSMETASTR INTEGER,
    IDLEVEL INTEGER,
    SLAVECOMPOSEFROMMAINNEEDED INTEGER)
RETURNS (
    RECORDS_MODIFIED INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_PASTE_EXCEL_RECORD_NL (
    IDUSER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDZONE INTEGER,
    AGROUP INTEGER,
    APODGROUP INTEGER,
    ZAMEN INTEGER,
    INSERT_ALL INTEGER,
    INSERT_SLAVE INTEGER,
    RES_APPLY_TAB INTEGER,
    APPLY_POPR_MODE INTEGER,
    TAB VARCHAR(42),
    TAB_BLOB BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    EDIZM VARCHAR(100),
    IN_IDEDIZM INTEGER,
    BB DOUBLE PRECISION,
    CURR_BB DOUBLE PRECISION,
    KOLL DOUBLE PRECISION,
    NORMRASH DOUBLE PRECISION,
    VRPZ INTEGER,
    VALUTE_ID INTEGER,
    VALUTE_RATE DOUBLE PRECISION,
    VALUTE_DATE DATE)
RETURNS (
    ID INTEGER,
    ID_RES INTEGER,
    REJECTCOUNT INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_PASTE_MONITORING_REC_NL_M (
    IDUSER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDZONE INTEGER,
    AGROUP INTEGER,
    APODGROUP INTEGER,
    ZAMEN INTEGER,
    INSERT_ALL INTEGER,
    INSERT_SLAVE INTEGER,
    PASTEBLOB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    PASTECOUNT INTEGER,
    RES_APPLY_TAB INTEGER,
    APPLY_POPR_MODE INTEGER,
    VRPZ INTEGER,
    FROMPRICE INTEGER,
    ONLY_RES INTEGER,
    REPLACE1 INTEGER)
RETURNS (
    ID INTEGER,
    ID_RES INTEGER,
    REJECTCOUNT INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_PASTE_MONITORING_RECORDS_NL (
    IDUSER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDZONE INTEGER,
    AGROUP INTEGER,
    APODGROUP INTEGER,
    ZAMEN INTEGER,
    INSERT_ALL INTEGER,
    INSERT_SLAVE INTEGER,
    PASTEBLOB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    PASTECOUNT INTEGER,
    RES_APPLY_TAB INTEGER,
    APPLY_POPR_MODE INTEGER,
    VRPZ INTEGER,
    FROMPRICE INTEGER,
    ONLY_RES INTEGER,
    REPLACE1 INTEGER)
RETURNS (
    ID INTEGER,
    ID_RES INTEGER,
    REJECTCOUNT INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_PASTE_RABMAT_RECORD (
    IDUSER INTEGER,
    NEWID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    SLAVEPARENT INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDNORMY INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    IDNAME INTEGER,
    IDEDIZM INTEGER,
    IDTCH INTEGER,
    IDESN INTEGER,
    IDTCARD INTEGER,
    ID_UNIQUE INTEGER,
    VRPZ INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    PUNKTIND VARCHAR(42),
    NORM_GUID VARCHAR(100),
    APPLY_POPR_MODE INTEGER,
    REPLACE INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    B_PR DOUBLE PRECISION)
RETURNS (
    OUT_ID INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_PASTE_RABMAT_RECORDS_NL (
    IDUSER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDZONE INTEGER,
    AGROUP INTEGER,
    APODGROUP INTEGER,
    ZAMEN INTEGER,
    INSERT_ALL INTEGER,
    INSERT_SLAVE INTEGER,
    PASTEBLOB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    PASTECOUNT INTEGER,
    ISPASTEFROMBUFER SMALLINT,
    RES_APPLY_TAB INTEGER,
    APPLY_POPR_MODE INTEGER,
    PASTE_AS_IS INTEGER)
RETURNS (
    ID INTEGER,
    REJECTCOUNT INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_RES_TO_SLAVEREC_NL (
    IDUSER INTEGER,
    ID_RES INTEGER,
    ID_SMREC INTEGER,
    PUNKTIND VARCHAR(42),
    VRPZ INTEGER,
    INSERT_MODE INTEGER,
    IDZONE INTEGER,
    APPLY_POPR_MODE INTEGER,
    ISMANUAL INTEGER,
    IDNORMATIVUNIQ INTEGER,
    PASTE_AS_IS INTEGER)
RETURNS (
    ADDED_SLAVE INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_RES_TO_SLAVEREC_NL_2 (
    IDUSER INTEGER,
    ID_RES INTEGER,
    ID_SMREC INTEGER,
    PUNKTIND VARCHAR(42),
    VRPZ INTEGER,
    INSERT_MODE INTEGER,
    IDZONE INTEGER,
    APPLY_POPR_MODE INTEGER,
    ISMANUAL INTEGER,
    IDNORMATIVUNIQ INTEGER,
    PASTE_AS_IS INTEGER)
RETURNS (
    ADDED_SLAVE INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_S_UPDATEREC_NL (
    IDUSER INTEGER,
    ID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME_ID INTEGER,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    B_PR DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    DORECALC INTEGER,
    ID_S_RES INTEGER,
    NEEDUPDATENAME INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    VIDRAB INTEGER,
    CALK_BG INTEGER,
    CALK_BH INTEGER,
    UTV INTEGER,
    UPDATE_ALL_ACTS INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    IDFORMULS INTEGER,
    CLCMODE_RES INTEGER,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
RETURNS (
    RENUM INTEGER,
    REFR_TRUD_STR_MASH INTEGER,
    OUT_ID INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    OUT_CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    OUT_CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_SMETA_CENLVL_UPDATE (
    ID_USER INTEGER,
    ID INTEGER,
    IDCENLVL INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    CA DOUBLE PRECISION,
    CB DOUBLE PRECISION,
    CC DOUBLE PRECISION,
    CD DOUBLE PRECISION,
    CE DOUBLE PRECISION,
    CF DOUBLE PRECISION,
    CG DOUBLE PRECISION,
    CH DOUBLE PRECISION,
    CI DOUBLE PRECISION,
    CJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    CALCBMASK INTEGER,
    BASE_INFO INTEGER,
    CURR_CENA DOUBLE PRECISION,
    BASE_CALC_INFO INTEGER,
    SOURCE_LEVEL_ID INTEGER,
    BASECOSTCHANGED INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    EN DOUBLE PRECISION,
    EO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    C_ITOGO DOUBLE PRECISION,
    E_ITOGO DOUBLE PRECISION,
    B_PR DOUBLE PRECISION,
    C_PR DOUBLE PRECISION,
    E_PR DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION,
    CURR_CENA_INFO INTEGER,
    ID_VALUTE INTEGER,
    VALUTE_CURS DOUBLE PRECISION,
    VALUTE_DATE DATE,
    TRANSP DOUBLE PRECISION,
    ZAG_SKL DOUBLE PRECISION,
    ZAPCHAST DOUBLE PRECISION,
    TARA DOUBLE PRECISION,
    NACEN DOUBLE PRECISION,
    COMPLECT DOUBLE PRECISION,
    KOEFF_TYPE INTEGER)
RETURNS (
    R_COUNT INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_SMETA_COPY_CENLVL_AS_IS (
    ID INTEGER,
    IDUSER INTEGER,
    IDLEVEL INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_SMETA_INS_OR_UPD_CENLVL (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDZONE INTEGER,
    ID_LEVEL_VC INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    B_PR DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    BASE_INFO INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_SMETA_INS_OR_UPD_INDLVL (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDINDEX INTEGER,
    ID_LEVEL_INDEX INTEGER,
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    M_PR DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    INDEX_SPOSOBRASCH INTEGER,
    INDEX_INFO INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_SMETA_NL_IMP (
    ID integer,
    IDCENLVL integer,
    IDZONE integer,
    ID_LEVEL_VC integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    BN double precision,
    BO double precision,
    B_ITOGO double precision,
    B_PR double precision,
    CA double precision,
    CB double precision,
    CC double precision,
    CD double precision,
    CE double precision,
    CF double precision,
    CG double precision,
    CH double precision,
    CI double precision,
    CJ double precision,
    C_ITOGO double precision,
    C_PR double precision,
    EA double precision,
    EB double precision,
    EC double precision,
    ED double precision,
    EE double precision,
    EF double precision,
    EG double precision,
    EH double precision,
    EI double precision,
    EJ double precision,
    EK double precision,
    EN double precision,
    EO double precision,
    E_ITOGO double precision,
    E_PR double precision,
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    ITOGO double precision,
    R_PR double precision,
    RC_16 double precision,
    RE_16 double precision,
    CALCBMASK integer,
    BASE_INFO integer,
    CURR_CENA double precision,
    BASE_CALC_INFO integer,
    SOURCE_LEVEL_ID integer,
    IDINDEX integer,
    ID_LEVEL_INDEX integer,
    PUNKTIND varchar(42),
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    M_PR double precision,
    DA double precision,
    DB double precision,
    DC double precision,
    DD double precision,
    DE double precision,
    DJ double precision,
    DK double precision,
    DL double precision,
    DM double precision,
    INDEX_SPOSOBRASCH integer,
    INDEX_INFO integer,
    NMA varchar(255),
    NMB varchar(255),
    NMC varchar(255),
    NMD varchar(255),
    NME varchar(255),
    NMF varchar(255),
    NMG varchar(255),
    NMH varchar(255),
    NMI varchar(255),
    NMJ varchar(255),
    NMK varchar(255),
    NML varchar(255),
    NMM varchar(255),
    NM_PR varchar(255),
    NDA varchar(255),
    NDB varchar(255),
    NDC varchar(255),
    NDD varchar(255),
    NDE varchar(255),
    NDJ varchar(255),
    NDK varchar(255),
    NDL varchar(255),
    NDM varchar(255),
    CURR_CENA_INFO integer,
    ID_VALUTE integer,
    VALUTE_CURS double precision,
    VALUTE_DATE date,
    TRANSP double precision,
    ZAG_SKL double precision,
    ZAPCHAST double precision,
    TARA double precision,
    NACEN double precision,
    COMPLECT double precision,
    KOEFF_TYPE integer)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE A_SMETA_SELECT_CLIPBOARD (
    ID_SM_REC INTEGER,
    ID_USER INTEGER)
RETURNS (
    ID INTEGER,
    SMETATYPE INTEGER,
    ATYPE SMALLINT,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    TAB VARCHAR(42),
    KOLL DOUBLE PRECISION,
    NORMARASH DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(250),
    EDIZM_RELATION DOUBLE PRECISION,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    RABMAT INTEGER,
    VRPZ INTEGER,
    ALTTAB VARCHAR(250),
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    KODIR_GROUP_NAME VARCHAR(250),
    KODIR_PODGROUP_NAME VARCHAR(250),
    ISGROUPOKP INTEGER,
    NOMERROD INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    VIDRAB INTEGER,
    UTV INTEGER,
    CLCMODE INTEGER,
    TYPE_TRUD INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    NORM_GUID VARCHAR(100),
    IDFORMULS INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    IDHIER INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    SLAVEPARENT INTEGER,
    IDNORMATIVUNIQ INTEGER,
    PUNKTIND VARCHAR(42),
    PRICE_GUID VARCHAR(100),
    PRICE_NORMOTAB VARCHAR(42),
    PRICE_NORMOGUID VARCHAR(100),
    ROW INTEGER,
    COST DOUBLE PRECISION,
    KOEF DOUBLE PRECISION,
    SM_CLCMODE INTEGER,
    RES_CLCMODE INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    K_ITOGO VARCHAR(50),
    B_PR DOUBLE PRECISION,
    K_PR VARCHAR(50),
    COD_RTM blob sub_type 1 segment size 80)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE B_IMP_I_CORRECTION (
    IDUSER INTEGER,
    IMPMODE INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    MM VARCHAR(50),
    MN VARCHAR(50),
    MO VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    ML VARCHAR(50),
    MM_NEW VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER)
RETURNS (
    ID INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE B_IMP_I_CORRECTION_V2 (
    IDUSER INTEGER,
    IMPMODE INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    MM VARCHAR(50),
    MN VARCHAR(50),
    MO VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    ML VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
RETURNS (
    ID INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE BASE_FORMUL_IU (
    ID INTEGER,
    IDCENLVL INTEGER,
    SBA VARCHAR(255),
    SBB VARCHAR(255),
    SBC VARCHAR(255),
    SBD VARCHAR(255),
    SBE VARCHAR(255),
    SBF VARCHAR(255),
    SBG VARCHAR(255),
    SBH VARCHAR(255),
    SBI VARCHAR(255),
    SBJ VARCHAR(255),
    SBQ VARCHAR(255))
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE CORRECTIONS_EXP_XML (
    AID INTEGER,
    ATYPE INTEGER)
RETURNS (
    ID INTEGER,
    REPLACECORRECTION INTEGER,
    CORRECTIONRULE INTEGER,
    SPREADONEXISTSREC INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE D_GET_CORRECTIONS (
    IDGROUP INTEGER,
    IDLIST BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDLISTCOUNT INTEGER,
    USE_IDLIST INTEGER,
    IDUSER INTEGER,
    ORDER_BY_USAGE INTEGER)
RETURNS (
    ID INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    ML VARCHAR(50),
    MM VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER,
    CORE_TYPE_NAME VARCHAR(100),
    USAGE INTEGER,
    USAGE_DATE DATE,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE D_GET_HIER_POPRS (
    ID_USER INTEGER,
    ID_HIER INTEGER)
RETURNS (
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE D_GET_POPR_VALUE (
    IN_KA VARCHAR(50),
    IN_KB VARCHAR(50),
    IN_KC VARCHAR(50),
    IN_KD VARCHAR(50),
    IN_KE VARCHAR(50),
    IN_KF VARCHAR(50),
    IN_KG VARCHAR(50),
    IN_KH VARCHAR(50),
    IN_KI VARCHAR(50),
    IN_KJ VARCHAR(50),
    IN_KK VARCHAR(50),
    IN_KL VARCHAR(50),
    IN_KM VARCHAR(50),
    IN_K_ITOGO VARCHAR(50),
    IN_K_PR VARCHAR(50),
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    FROM_PRICE_POPRS INTEGER)
RETURNS (
    CORRECT VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE D_GET_SMETA_REC (
    IDUSER INTEGER,
    IN_IDOBJECT INTEGER,
    IN_ID INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    STATUS_REC_CEN INTEGER,
    VIDRAB INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    RES_PRICE_COUNT INTEGER,
    SMETATYPE INTEGER,
    TYPE_TRUD INTEGER,
    IDFORMULS INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE D_GET_SMETA_RECS (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLIST BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDLISTCOUNT INTEGER,
    WITHSTRUCT INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    CLCMODE_RES INTEGER,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    ID_LS INTEGER,
    ADDED_SMETATYPE INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE D_GET_SMETA_RECS_NL (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLIST BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDLISTCOUNT INTEGER,
    WITHSTRUCT INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE D_GR_RES_SHOW_IN_SMETA_RECS_NL (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    ID_CEN INTEGER,
    ISGROUPMODE INTEGER,
    SMETATYPE INTEGER,
    WITHSTRUCT INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    CLCMODE_RES INTEGER,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    ID_LS INTEGER,
    ADDED_SMETATYPE INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE D_REPLACE_ONE_RES (
    ID_RES INTEGER,
    ID_USER INTEGER,
    REPLACE_CORRECTION INTEGER,
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    IDNORMATIV INTEGER,
    TAB VARCHAR(42),
    TAB_BLOB BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    ID_EDIZM INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    ID_PRICE INTEGER,
    STATUS INTEGER,
    ALTTAB VARCHAR(255),
    NORM_GUID VARCHAR(100),
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    CORRECT VARCHAR(50),
    VIDNR INTEGER,
    NAME BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    SOURCE_UTV INTEGER,
    NOMER_ROD INTEGER,
    SOURCE INTEGER,
    EDIZM_KOEF DOUBLE PRECISION,
    RES_IDOBJECT INTEGER,
    TIPRAB INTEGER,
    ISGROUPMODE INTEGER)
RETURNS (
    RESULT INTEGER,
    NEW_TIPRAB INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE D_SET_POPR_VALUE (
    IN_KA VARCHAR(50),
    IN_KB VARCHAR(50),
    IN_KC VARCHAR(50),
    IN_KD VARCHAR(50),
    IN_KE VARCHAR(50),
    IN_KF VARCHAR(50),
    IN_KG VARCHAR(50),
    IN_KH VARCHAR(50),
    IN_KI VARCHAR(50),
    IN_KJ VARCHAR(50),
    IN_KK VARCHAR(50),
    IN_KL VARCHAR(50),
    IN_KM VARCHAR(50),
    IN_K_ITOGO VARCHAR(50),
    IN_K_PR VARCHAR(50),
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    CORRECT VARCHAR(50),
    TO_PRICE_POPRS INTEGER)
RETURNS (
    OUT_KA VARCHAR(50),
    OUT_KB VARCHAR(50),
    OUT_KC VARCHAR(50),
    OUT_KD VARCHAR(50),
    OUT_KE VARCHAR(50),
    OUT_KF VARCHAR(50),
    OUT_KG VARCHAR(50),
    OUT_KH VARCHAR(50),
    OUT_KI VARCHAR(50),
    OUT_KJ VARCHAR(50),
    OUT_KK VARCHAR(50),
    OUT_KL VARCHAR(50),
    OUT_KM VARCHAR(50),
    OUT_K_ITOGO VARCHAR(50),
    OUT_K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_ADD_LEVEL_IN_SMETA_ONE (
    IDUSER INTEGER,
    IDSMETAREC INTEGER,
    IDLEVEL INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_ADD_LEVEL_IN_SMETA_ONE_EXT (
    IDUSER INTEGER,
    IDSMETAREC INTEGER,
    IDLEVEL INTEGER,
    APPLY_ALL_IDLEVEL INTEGER,
    APPLY_SNB_IDLEVEL INTEGER,
    MIN_DATE_IDLEVEL INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_COPY_CORRECTION (
    AIDSOURCE INTEGER,
    AIDTARGET INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_EXP_A_O_PARAMS_R_PR (
    PARAMID INTEGER)
RETURNS (
    ID INTEGER,
    NUMGLSSR INTEGER,
    TIPRAB INTEGER,
    SHIFR VARCHAR(1024),
    FULLNAME VARCHAR(1024),
    OPISANIE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ISPOLNIL_FIO VARCHAR(250),
    ISPOLNIL_DOLGN VARCHAR(100),
    PROVERIL_FIO VARCHAR(250),
    PROVERIL_DOLGN VARCHAR(100),
    UTVERDIL_FIO VARCHAR(250),
    UTVERDIL_DOLGN VARCHAR(100),
    SUBPODR_ID_ORG INTEGER,
    SUBPODR_NAME_ORG VARCHAR(255),
    SUBPODR_ID INTEGER,
    SUBPODR_FIO VARCHAR(250),
    SUBPODR_DOLGN VARCHAR(100),
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    GUID VARCHAR(100),
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    VELICHSTROBJ DOUBLE PRECISION,
    EDIZM VARCHAR(40),
    REPLACECORRECTION INTEGER,
    SPREADONEXISTSREC INTEGER,
    CORRECTIONRULE INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_EXP_CORRECTIONS (
    AID INTEGER)
RETURNS (
    ID INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_GET_CORRECTION_BY_TYPE (
    AID INTEGER,
    ATYPE INTEGER)
RETURNS (
    ID INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_IMP_CORRECTIONS (
    ID INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_PARAMS_SET_DEF_CORRECTION (
    AID INTEGER,
    ATYPE INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_REPLACE_CORRECTION (
    USERID INTEGER,
    AIDSTRUCT INTEGER,
    ATYPE INTEGER,
    SPREADONEXISTSREC INTEGER,
    KA_NEW VARCHAR(50),
    KA_OLD VARCHAR(50),
    KB_NEW VARCHAR(50),
    KB_OLD VARCHAR(50),
    KC_NEW VARCHAR(50),
    KC_OLD VARCHAR(50),
    KD_NEW VARCHAR(50),
    KD_OLD VARCHAR(50),
    KE_NEW VARCHAR(50),
    KE_OLD VARCHAR(50),
    KF_NEW VARCHAR(50),
    KF_OLD VARCHAR(50),
    KG_NEW VARCHAR(50),
    KG_OLD VARCHAR(50),
    KH_NEW VARCHAR(50),
    KH_OLD VARCHAR(50),
    KI_NEW VARCHAR(50),
    KI_OLD VARCHAR(50),
    KJ_NEW VARCHAR(50),
    KJ_OLD VARCHAR(50),
    KK_NEW VARCHAR(50),
    KK_OLD VARCHAR(50),
    KL_NEW VARCHAR(50),
    KL_OLD VARCHAR(50),
    KM_NEW VARCHAR(50),
    KM_OLD VARCHAR(50),
    K_ITOGO_NEW VARCHAR(50),
    K_ITOGO_OLD VARCHAR(50),
    K_PR_NEW VARCHAR(50),
    K_PR_OLD VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_SET_CORRECTION (
    AID INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_SPREADDOWN_CORRECTION (
    AIDSTRUCT INTEGER,
    ATYPE INTEGER,
    IDUSER INTEGER,
    KA_NEW VARCHAR(50),
    KA_OLD VARCHAR(50),
    KB_NEW VARCHAR(50),
    KB_OLD VARCHAR(50),
    KC_NEW VARCHAR(50),
    KC_OLD VARCHAR(50),
    KD_NEW VARCHAR(50),
    KD_OLD VARCHAR(50),
    KE_NEW VARCHAR(50),
    KE_OLD VARCHAR(50),
    KF_NEW VARCHAR(50),
    KF_OLD VARCHAR(50),
    KG_NEW VARCHAR(50),
    KG_OLD VARCHAR(50),
    KH_NEW VARCHAR(50),
    KH_OLD VARCHAR(50),
    KI_NEW VARCHAR(50),
    KI_OLD VARCHAR(50),
    KJ_NEW VARCHAR(50),
    KJ_OLD VARCHAR(50),
    KK_NEW VARCHAR(50),
    KK_OLD VARCHAR(50),
    KL_NEW VARCHAR(50),
    KL_OLD VARCHAR(50),
    KM_NEW VARCHAR(50),
    KM_OLD VARCHAR(50),
    K_ITOGO_NEW VARCHAR(50),
    K_ITOGO_OLD VARCHAR(50),
    K_PR_NEW VARCHAR(50),
    K_PR_OLD VARCHAR(50))
RETURNS (
    HAVEWRONG INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE DM_UPDATE_OLD_IMP_R_PR_PARAMS (
    ID INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE GET_NORM_BASE_COSTS (
    NORM_ID INTEGER,
    NORM_RABMAT INTEGER,
    NORM_PODGROUP INTEGER)
RETURNS (
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    B_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE GET_ONE_INDEX_APPLY_INFO (
    IDUSER INTEGER,
    IDSMETASTR INTEGER,
    IDLEVEL INTEGER,
    NEW_LEVEL INTEGER)
RETURNS (
    OUT_INDEX_INFO INTEGER,
    OUT_IDINDEX INTEGER,
    OUT_IND_TYPE VARCHAR(50),
    OUT_IND_YEAR INTEGER,
    OUT_IND_MONTH INTEGER,
    OUT_PUNKTIND VARCHAR(42))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE K_CORRECTION_TABLE_INSERT (
    ID INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    ML VARCHAR(50),
    MM VARCHAR(50),
    NOTE VARCHAR(2000),
    IDUSER INTEGER,
    ID_CORE_TYPE INTEGER,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE K_CORRECTION_TABLE_SELECT (
    ID_GC INTEGER,
    IDUSER INTEGER,
    ORDER_BY_USAGE INTEGER)
RETURNS (
    ID INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    ML VARCHAR(50),
    MM VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER,
    USAGE INTEGER,
    USAGE_DATE DATE,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE K_CORRECTION_TABLE_UPDATE (
    ID INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    ML VARCHAR(50),
    MM VARCHAR(50),
    NOTE VARCHAR(2000),
    IDUSER INTEGER,
    ID_CORE_TYPE INTEGER,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE K_GET_CORRECTIONS (
    IDGRCORR INTEGER,
    BASIS VARCHAR(42),
    IDUSER INTEGER)
RETURNS (
    ID INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE KD_COPY_PARAMS_R_PR (
    SOURCE_ID INTEGER,
    TARGET_ID INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_BUFER_SELECT_ONE (
    IDUSER INTEGER,
    IDBUFER INTEGER,
    IDZONE INTEGER,
    FROM_RABMAT INTEGER)
RETURNS (
    IDNORMY INTEGER,
    RABMAT INTEGER,
    IDNAME INTEGER,
    IDUNIQUE INTEGER,
    TAB VARCHAR(42),
    FRTCH VARCHAR(250),
    ALTTAB VARCHAR(250),
    IDEDIZM INTEGER,
    EDIZMNAME VARCHAR(100),
    EDIZMFULLNAME VARCHAR(250),
    EDIZMKOEF DOUBLE PRECISION,
    IDABCOKP INTEGER,
    COMMENT VARCHAR(15),
    OKP VARCHAR(15),
    FRESN VARCHAR(21),
    RAZRAD DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    MO DOUBLE PRECISION,
    MP DOUBLE PRECISION,
    MQ DOUBLE PRECISION,
    MR DOUBLE PRECISION,
    MS DOUBLE PRECISION,
    MT DOUBLE PRECISION,
    VRPZ INTEGER,
    NTR INTEGER,
    BRUTTO DOUBLE PRECISION,
    NETTO DOUBLE PRECISION,
    VB DOUBLE PRECISION,
    VN DOUBLE PRECISION,
    PREISK VARCHAR(42),
    POSPREISK VARCHAR(42),
    MBETON DOUBLE PRECISION,
    MRKBETON VARCHAR(15),
    MMASHINE VARCHAR(25),
    VBETON DOUBLE PRECISION,
    TKALK VARCHAR(50),
    PUNKTIND VARCHAR(42),
    ZONE_BB DOUBLE PRECISION,
    ZONE_BC DOUBLE PRECISION,
    ZONE_BD DOUBLE PRECISION,
    ZONE_BE DOUBLE PRECISION,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDTCH INTEGER,
    IDSOSTAV INTEGER,
    IDTCARD INTEGER,
    IDESN INTEGER,
    IDPICTURE INTEGER,
    IDPOSTAV INTEGER,
    ISESN SMALLINT,
    IDWITHESN INTEGER,
    IDQUALIFIER INTEGER,
    ID_UNIQUE INTEGER,
    IDPODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    IDNORMA INTEGER,
    TYPE_TRUD INTEGER,
    ZONE_BA DOUBLE PRECISION,
    OUT_FROM_RABMAT INTEGER,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_EXP_A_SMETA_N (
    ID_OBJ INTEGER,
    IN_SMETATYPE INTEGER,
    ID_USER INTEGER)
RETURNS (
    ID integer,
    IDHIER integer,
    SMETATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE smallint,
    RABMAT integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NAME_ID integer,
    ID_EDIZM integer,
    EDIZM_TYPE integer,
    KOLL double precision,
    SKOLL varchar(255),
    NORMARASH double precision,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    BN double precision,
    BO double precision,
    B_ITOGO double precision,
    B_PR double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    VRPZ integer,
    IDTIPR integer,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    K_ITOGO varchar(50),
    K_PR varchar(50),
    PUNKTIND varchar(42),
    SSTCH integer,
    KODZAK integer,
    KODGP integer,
    KODSP integer,
    KODISP integer,
    NACH date,
    OKONCH date,
    TIPRAB integer,
    IDNORMATIV integer,
    IDNORMATIVUNIQ integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ISGROUPOKP integer,
    ARPS_OTHER blob sub_type 0 segment size 80,
    DORECALC smallint,
    ID_S_RES integer,
    NOMERROD integer,
    PR_ADDED_REC integer,
    NOMERROD1 integer,
    PR_NUMBER1 integer,
    PR_NUMBER2 integer,
    PR_NUMBER3 integer,
    PR_VSEGO double precision,
    TCH_GUID varchar(100),
    NORM_GUID varchar(100),
    STATUS_REC_CEN integer,
    VIDRAB integer,
    UTV integer,
    CORRECTNODE blob sub_type 0 segment size 80,
    CORRECTNODE_1 blob sub_type 0 segment size 80,
    ASUBTYPE integer,
    CLCMODE integer,
    PRICE_GUID varchar(50),
    PRICE_NORMOTAB varchar(42),
    PRICE_NORMOGUID varchar(100),
    ROW integer,
    TYPE_TRUD integer,
    KOEF double precision,
    IDFORMULS integer,
    CREATENAME_UW varchar(100),
    CREATEDATE_UW date,
    CONFIRMNAME_UW varchar(100),
    CONFIRMDATE_UW date,
    CHANGE_NAME_UW varchar(100),
    CHANGE_DATE_UW date)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_FB_READ_SBORNIK (
    IN_ID_SELF INTEGER,
    IN_ID_ABC_OKP INTEGER,
    IN_PODGROUP INTEGER,
    IN_RABMAT INTEGER,
    ID_USER INTEGER,
    ID_ZONE INTEGER)
RETURNS (
    ID_SELF INTEGER,
    PODGROUP INTEGER,
    RABMAT INTEGER,
    ID_ABC_OKP INTEGER,
    BEDA INTEGER,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDNAME INTEGER,
    ID_UNIQUE INTEGER,
    TAB VARCHAR(42),
    TABU VARCHAR(42),
    ALTTAB VARCHAR(250),
    IDEDIZM INTEGER,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(255),
    COMMENT VARCHAR(42),
    RAZRAD DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    NTR INTEGER,
    PUNKTIND VARCHAR(42),
    ISESN INTEGER,
    IDWITHESN INTEGER,
    CCURRENT_BA DOUBLE PRECISION,
    CCURRENT_BB DOUBLE PRECISION,
    CCURRENT_BC DOUBLE PRECISION,
    CCURRENT_BD DOUBLE PRECISION,
    CCURRENT_BE DOUBLE PRECISION,
    CCURRENT_ZONE INTEGER,
    IDQUALIFIER INTEGER,
    IDNORMTYPE INTEGER,
    NORM_GUID VARCHAR(100),
    IDREESTR INTEGER,
    ABC_OKP_NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_RABMAT INTEGER,
    ABC_OKP_IDNAME INTEGER,
    ABC_OKP_ID_UNIQUE INTEGER,
    ABC_OKP_TAB VARCHAR(42),
    ABC_OKP_TABU VARCHAR(42),
    ABC_OKP_IDGROUP INTEGER,
    ABC_OKP_IDPODGROUP INTEGER,
    ABC_OKP_ISGROUPOKP INTEGER,
    ABC_OKP_IDEDIZM INTEGER,
    ABC_OKP_EDIZM_NAME VARCHAR(100),
    ABC_OKP_EDIZM_FULLNAME VARCHAR(255),
    ABC_OKP_CENA DOUBLE PRECISION,
    ABC_OKP_RAZRAD DOUBLE PRECISION,
    ABC_OKP_VIDNR INTEGER,
    ABC_OKP_COMMENT VARCHAR(42),
    ABC_OKP_PUNKTIND VARCHAR(42),
    ABC_OKP_VRPZ INTEGER,
    ABC_OKP_NTR INTEGER,
    ABC_OKP_CCURRENT DOUBLE PRECISION,
    ABC_OKP_CCURRENT_ZONE INTEGER,
    ABC_OKP_IDQUALIFIER INTEGER,
    TYPE_TRUD INTEGER,
    ABC_OKP_TYPE_TRUD INTEGER,
    MA DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_FB_SEARCH_NORMATIV (
    HINT_IDNORMATIV INTEGER,
    HINT_PODGROUP INTEGER,
    HINT_RABMAT INTEGER,
    IN_PODGROUP INTEGER,
    IN_RABMAT INTEGER,
    ID_USER INTEGER,
    STAB VARCHAR(42),
    ID_PUT_RAB INTEGER,
    ID_PUT_MASH INTEGER,
    ID_PUT_MAT INTEGER,
    ID_ZONE INTEGER)
RETURNS (
    ID_SELF INTEGER,
    PODGROUP INTEGER,
    RABMAT INTEGER,
    ID_ABC_OKP INTEGER,
    BEDA1 INTEGER,
    BEDA2 INTEGER,
    BEDARAB INTEGER,
    BEDAMASH INTEGER,
    BEDAMAT INTEGER,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDNAME INTEGER,
    ID_UNIQUE INTEGER,
    TAB VARCHAR(42),
    TABU VARCHAR(42),
    ALTTAB VARCHAR(250),
    IDEDIZM INTEGER,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(255),
    COMMENT VARCHAR(42),
    RAZRAD DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    NTR INTEGER,
    PUNKTIND VARCHAR(42),
    ISESN INTEGER,
    IDWITHESN INTEGER,
    CCURRENT_BA DOUBLE PRECISION,
    CCURRENT_BB DOUBLE PRECISION,
    CCURRENT_BC DOUBLE PRECISION,
    CCURRENT_BD DOUBLE PRECISION,
    CCURRENT_BE DOUBLE PRECISION,
    CCURRENT_ZONE INTEGER,
    IDQUALIFIER INTEGER,
    IDNORMTYPE INTEGER,
    NORM_GUID VARCHAR(100),
    IDREESTR INTEGER,
    ABC_OKP_NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_RABMAT INTEGER,
    ABC_OKP_IDNAME INTEGER,
    ABC_OKP_ID_UNIQUE INTEGER,
    ABC_OKP_TAB VARCHAR(42),
    ABC_OKP_TABU VARCHAR(42),
    ABC_OKP_IDGROUP INTEGER,
    ABC_OKP_IDPODGROUP INTEGER,
    ABC_OKP_ISGROUPOKP INTEGER,
    ABC_OKP_IDEDIZM INTEGER,
    ABC_OKP_EDIZM_NAME VARCHAR(100),
    ABC_OKP_EDIZM_FULLNAME VARCHAR(255),
    ABC_OKP_CENA DOUBLE PRECISION,
    ABC_OKP_RAZRAD DOUBLE PRECISION,
    ABC_OKP_VIDNR INTEGER,
    ABC_OKP_COMMENT VARCHAR(42),
    ABC_OKP_PUNKTIND VARCHAR(42),
    ABC_OKP_VRPZ INTEGER,
    ABC_OKP_NTR INTEGER,
    ABC_OKP_CCURRENT DOUBLE PRECISION,
    ABC_OKP_CCURRENT_ZONE INTEGER,
    ABC_OKP_IDQUALIFIER INTEGER,
    TYPE_TRUD INTEGER,
    ABC_OKP_TYPE_TRUD INTEGER,
    MA DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_IMP_INS_SMSTR (
    ID_USER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME_ID INTEGER,
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    DORECALC SMALLINT,
    ID_S_RES INTEGER,
    NOMERROD INTEGER,
    PR_ADDED_REC INTEGER,
    NOMERROD1 INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    TCH_GUID VARCHAR(100),
    NORM_GUID VARCHAR(100),
    OLD_ID INTEGER,
    OLD_NOMERROD INTEGER,
    OLD_NOMERROD1 INTEGER,
    STATUS_REC_CEN INTEGER,
    VIDRAB INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    PRICE_GUID VARCHAR(100),
    PRICE_NORMOTAB VARCHAR(42),
    PRICE_NORMOGUID VARCHAR(100),
    ROW INTEGER,
    TYPE_TRUD INTEGER,
    KOEF DOUBLE PRECISION,
    CREATENAME_UW VARCHAR(100),
    CREATEDATE_UW DATE,
    CONFIRMNAME_UW VARCHAR(100),
    CONFIRMDATE_UW DATE,
    CHANGE_NAME_UW VARCHAR(100),
    CHANGE_DATE_UW DATE)
RETURNS (
    ID INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_IMP_INS_SMSTR_N (
    ID_USER integer,
    IDHIER integer,
    SMETATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE smallint,
    RABMAT integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NAME_ID integer,
    ID_EDIZM integer,
    EDIZM_TYPE integer,
    KOLL double precision,
    SKOLL varchar(255),
    NORMARASH double precision,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    BN double precision,
    BO double precision,
    B_PR double precision,
    B_ITOGO double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    VRPZ integer,
    IDTIPR integer,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    K_ITOGO varchar(50),
    K_PR varchar(50),
    PUNKTIND varchar(42),
    SSTCH integer,
    KODZAK integer,
    KODGP integer,
    KODSP integer,
    KODISP integer,
    NACH date,
    OKONCH date,
    TIPRAB integer,
    IDNORMATIV integer,
    IDNORMATIVUNIQ integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ISGROUPOKP integer,
    ARPS_OTHER blob sub_type 0 segment size 80,
    DORECALC smallint,
    ID_S_RES integer,
    NOMERROD integer,
    PR_ADDED_REC integer,
    NOMERROD1 integer,
    PR_NUMBER1 integer,
    PR_NUMBER2 integer,
    PR_NUMBER3 integer,
    PR_VSEGO double precision,
    TCH_GUID varchar(100),
    NORM_GUID varchar(100),
    OLD_ID integer,
    OLD_NOMERROD integer,
    OLD_NOMERROD1 integer,
    STATUS_REC_CEN integer,
    VIDRAB integer,
    UTV integer,
    CORRECTNODE blob sub_type 0 segment size 80,
    CORRECTNODE_1 blob sub_type 0 segment size 80,
    ASUBTYPE integer,
    CLCMODE integer,
    PRICE_GUID varchar(100),
    PRICE_NORMOTAB varchar(42),
    PRICE_NORMOGUID varchar(100),
    ROW integer,
    TYPE_TRUD integer,
    KOEF double precision,
    CREATENAME_UW varchar(100),
    CREATEDATE_UW date,
    CONFIRMNAME_UW varchar(100),
    CONFIRMDATE_UW date,
    CHANGE_NAME_UW varchar(100),
    CHANGE_DATE_UW date)
RETURNS (
    ID INTEGER,
    IDPAPKA INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_IMP_S_APPENDREC (
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EDIZM VARCHAR(100),
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    DORECALC INTEGER,
    ID_USER INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    DORECALL INTEGER,
    USE_ARGS_F INTEGER,
    USE_ARGS_P INTEGER,
    USE_ARGS_M INTEGER,
    USE_ARGS_K INTEGER,
    USE_OBJ_NASTR_F INTEGER,
    USE_OBJ_NASTR_M INTEGER,
    USE_OBJ_NASTR_K INTEGER,
    RECALL_FILL_FRM INTEGER,
    RECALL_FILL_PA INTEGER,
    RECALL_FILL_PB INTEGER,
    RECALL_FILL_PC INTEGER,
    RECALL_FILL_PD INTEGER,
    RECALL_FILL_NAME INTEGER,
    RECALL_FILL_EDIZM INTEGER,
    RECALL_FILL_BA INTEGER,
    RECALL_FILL_BB INTEGER,
    RECALL_FILL_BC INTEGER,
    RECALL_FILL_BD INTEGER,
    RECALL_FILL_BE INTEGER,
    RECALL_FILL_BF INTEGER,
    RECALL_FILL_BG INTEGER,
    RECALL_FILL_BH INTEGER,
    RECALL_FILL_BI INTEGER,
    ID_BLOB_GEN INTEGER,
    UTV INTEGER,
    ASUBTYPE INTEGER,
    IN_IDFORMULS INTEGER)
RETURNS (
    ID INTEGER,
    OUT_ID_OBJ INTEGER,
    OUT_ID_TR INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_IMP_S_APPENDREC_NL (
    MODE INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EDIZM VARCHAR(100),
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_USER INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    DORECALL INTEGER,
    USE_ARGS_F INTEGER,
    USE_ARGS_P INTEGER,
    USE_ARGS_M INTEGER,
    USE_ARGS_K INTEGER,
    USE_OBJ_NASTR_F INTEGER,
    USE_OBJ_NASTR_M INTEGER,
    USE_OBJ_NASTR_K INTEGER,
    RECALL_FILL_FRM INTEGER,
    RECALL_FILL_PA INTEGER,
    RECALL_FILL_PB INTEGER,
    RECALL_FILL_PC INTEGER,
    RECALL_FILL_PD INTEGER,
    RECALL_FILL_NAME INTEGER,
    RECALL_FILL_EDIZM INTEGER,
    RECALL_FILL_BA INTEGER,
    RECALL_FILL_BB INTEGER,
    RECALL_FILL_BC INTEGER,
    RECALL_FILL_BD INTEGER,
    RECALL_FILL_BE INTEGER,
    RECALL_FILL_BF INTEGER,
    RECALL_FILL_BG INTEGER,
    RECALL_FILL_BH INTEGER,
    RECALL_FILL_BI INTEGER,
    UTV INTEGER,
    ASUBTYPE INTEGER,
    IN_IDFORMULS INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    TAB_BLOB BLOB SUB_TYPE 1 SEGMENT SIZE 80)
RETURNS (
    ID INTEGER,
    OUT_ID_OBJ INTEGER,
    OUT_ID_TR INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_PR_COPY_SMETA_TO_PR_ONE_REC (
    IN_ID INTEGER,
    ID_PR INTEGER,
    ID_USER INTEGER,
    NEW_SLAVEPARENT INTEGER,
    NEW_NUMBER1 INTEGER,
    NEW_NUMBER2 INTEGER,
    NEW_NUMBER3 INTEGER,
    PR_ID_OBJ INTEGER,
    PR_LYEAR INTEGER,
    PR_LMONTH INTEGER,
    PR_IDLEVEL INTEGER,
    NEW_VIEW_NUMBER1 INTEGER,
    NEW_VIEW_NUMBER2 INTEGER,
    NEW_VIEW_NUMBER3 INTEGER)
RETURNS (
    ID INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_S_APPENDREC (
    USE_ARGS_F INTEGER,
    USE_ARGS_P INTEGER,
    USE_ARGS_M INTEGER,
    USE_ARGS_K INTEGER,
    USE_OBJ_NASTR_F INTEGER,
    USE_OBJ_NASTR_M INTEGER,
    USE_OBJ_NASTR_K INTEGER,
    SKIP_INS_SM_RES INTEGER,
    IDUSER INTEGER,
    ID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    ID_S_RES INTEGER,
    VRPZ INTEGER,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    TIPRAB INTEGER,
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    NORM_GUID VARCHAR(100),
    UTV INTEGER,
    ASUBTYPE INTEGER,
    IN_IDFORMULS INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_S_APPENDREC_NL_2 (
    USE_ARGS_F INTEGER,
    USE_ARGS_P INTEGER,
    USE_ARGS_M INTEGER,
    USE_ARGS_K INTEGER,
    USE_OBJ_NASTR_F INTEGER,
    USE_OBJ_NASTR_M INTEGER,
    USE_OBJ_NASTR_K INTEGER,
    SKIP_INS_SM_RES INTEGER,
    IDUSER INTEGER,
    ID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    ID_S_RES INTEGER,
    VRPZ INTEGER,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    TIPRAB INTEGER,
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    NORM_GUID VARCHAR(100),
    UTV INTEGER,
    ASUBTYPE INTEGER,
    IN_IDFORMULS INTEGER,
    B_DORECALL INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_S_APPENDREC_VALIDATE_PARAMS (
    IN_BA DOUBLE PRECISION,
    IN_BB DOUBLE PRECISION,
    IN_BC DOUBLE PRECISION,
    IN_BD DOUBLE PRECISION,
    IN_BE DOUBLE PRECISION,
    IN_BF DOUBLE PRECISION,
    IN_BG DOUBLE PRECISION,
    IN_BH DOUBLE PRECISION,
    IN_BI DOUBLE PRECISION,
    IN_BJ DOUBLE PRECISION,
    IN_EA DOUBLE PRECISION,
    IN_EB DOUBLE PRECISION,
    IN_EC DOUBLE PRECISION,
    IN_ED DOUBLE PRECISION,
    IN_EE DOUBLE PRECISION,
    IN_EF DOUBLE PRECISION,
    IN_EG DOUBLE PRECISION,
    IN_EH DOUBLE PRECISION,
    IN_EI DOUBLE PRECISION,
    IN_EJ DOUBLE PRECISION,
    IN_EK DOUBLE PRECISION,
    IN_RA DOUBLE PRECISION,
    IN_RB DOUBLE PRECISION,
    IN_RC DOUBLE PRECISION,
    IN_RD DOUBLE PRECISION,
    IN_RE DOUBLE PRECISION,
    IN_RF DOUBLE PRECISION,
    IN_RG DOUBLE PRECISION,
    IN_RH DOUBLE PRECISION,
    IN_RI DOUBLE PRECISION,
    IN_RJ DOUBLE PRECISION,
    IN_RK DOUBLE PRECISION,
    IN_RL DOUBLE PRECISION,
    IN_RM DOUBLE PRECISION,
    IN_PA DOUBLE PRECISION,
    IN_PB DOUBLE PRECISION,
    IN_PC DOUBLE PRECISION,
    IN_PD DOUBLE PRECISION,
    IN_PE DOUBLE PRECISION,
    IN_MA DOUBLE PRECISION,
    IN_MB DOUBLE PRECISION,
    IN_MC DOUBLE PRECISION,
    IN_MD DOUBLE PRECISION,
    IN_ME DOUBLE PRECISION,
    IN_MF DOUBLE PRECISION,
    IN_MG DOUBLE PRECISION,
    IN_MH DOUBLE PRECISION,
    IN_MI DOUBLE PRECISION,
    IN_MJ DOUBLE PRECISION,
    IN_MK DOUBLE PRECISION,
    IN_ML DOUBLE PRECISION)
RETURNS (
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE L_SELECT_HIER_CORRECTIONS (
    IDHIER INTEGER,
    ID_USER INTEGER)
RETURNS (
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE M_ADD_REC_TO_MERGED_AKT_NL (
    SOURCE_REC_ID INTEGER,
    RES_KOLL DOUBLE PRECISION,
    MERGE_AKT_ID INTEGER,
    ID_OBJ INTEGER,
    IS_DOP INTEGER,
    NEW_SLAVEPARENT INTEGER,
    ID_USER INTEGER,
    ID_BASE_CENLVL INTEGER,
    S_NUMBER1 INTEGER,
    S_NUMBER2 INTEGER,
    S_NUMBER3 INTEGER)
RETURNS (
    NEW_ID INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE M_CORRECTION_STRUCT_IMP_XML (
    ID INTEGER,
    ATYPE INTEGER,
    REPLACECORRECTION INTEGER,
    CORRECTIONRULE INTEGER,
    SPREADONEXISTSREC INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE M_ET_RES_APPEND_NL (
    IDUSER INTEGER,
    ID INTEGER,
    ID_SOURCE INTEGER,
    NORM_ID INTEGER,
    NORM_PODGROUP INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME_ID INTEGER,
    IDEDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    RASHOD DOUBLE PRECISION,
    RASHOD_BASE DOUBLE PRECISION,
    CORRECT VARCHAR(50),
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    VIDNR INTEGER,
    UCH INTEGER,
    STATUS_EDIT INTEGER,
    STATUS_DOB_V_ZENU INTEGER,
    STATUS_REC_CEN INTEGER,
    NOTE VARCHAR(255),
    NOMERROD INTEGER,
    NORM_GUID VARCHAR(100),
    TYPE_TRUD INTEGER,
    ET_NORM_ID INTEGER,
    ET_NORM_PODGROUP INTEGER,
    ET_KODIR_GROUP INTEGER,
    ET_KODIR_PODGROUP INTEGER,
    ET_ISGROUPOKP INTEGER,
    ET_RABMAT INTEGER,
    ET_TAB VARCHAR(42),
    ET_ALTTAB VARCHAR(250),
    ET_NAME_ID INTEGER,
    ET_IDEDIZM INTEGER,
    ET_EDIZM_TYPE INTEGER,
    ET_RASHOD DOUBLE PRECISION,
    ET_BB DOUBLE PRECISION,
    ET_BC DOUBLE PRECISION,
    ET_BD DOUBLE PRECISION,
    ET_BE DOUBLE PRECISION,
    ET_VIDNR INTEGER,
    ET_UCH INTEGER,
    ET_NORM_GUID VARCHAR(100),
    ET_TYPE_TRUD INTEGER,
    SENDER INTEGER,
    MODE INTEGER,
    VRPZ INTEGER,
    NEEDUPDCOST INTEGER,
    PASTE_AS_IS INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE M_EXP_SM_REC (
    ID_SM_REC INTEGER,
    ID_USER INTEGER)
RETURNS (
    ID INTEGER,
    SMETATYPE INTEGER,
    ATYPE SMALLINT,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    TAB VARCHAR(42),
    KOLL DOUBLE PRECISION,
    NORMARASH DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(250),
    EDIZM_RELATION DOUBLE PRECISION,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    RABMAT INTEGER,
    VRPZ INTEGER,
    ALTTAB VARCHAR(250),
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    KODIR_GROUP_NAME VARCHAR(250),
    KODIR_PODGROUP_NAME VARCHAR(250),
    ISGROUPOKP INTEGER,
    NOMERROD INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    VIDRAB INTEGER,
    UTV INTEGER,
    CLCMODE INTEGER,
    TYPE_TRUD INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SOSTAV_RABOT BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    NORM_GUID VARCHAR(100),
    IDFORMULS INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    IDHIER INTEGER,
    SLAVEPARENT INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    B_PR DOUBLE PRECISION,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    KOD_KKS blob sub_type 1 segment size 80)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE M_FB_SEARCH_NORMATIV (
    IN_PODGROUP INTEGER,
    IN_RABMAT INTEGER,
    ID_USER INTEGER,
    STAB VARCHAR(42),
    ID_PUT_RAB INTEGER,
    ID_PUT_MASH INTEGER,
    ID_PUT_MAT INTEGER,
    ID_ZONE INTEGER,
    FETCH_ALL_SEARCH INTEGER)
RETURNS (
    ID_SELF INTEGER,
    PODGROUP INTEGER,
    RABMAT INTEGER,
    ID_ABC_OKP INTEGER,
    BEDA1 INTEGER,
    BEDA2 INTEGER,
    BEDARAB INTEGER,
    BEDAMASH INTEGER,
    BEDAMAT INTEGER,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDNAME INTEGER,
    ID_UNIQUE INTEGER,
    TAB VARCHAR(42),
    TABU VARCHAR(42),
    ALTTAB VARCHAR(250),
    IDEDIZM INTEGER,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(255),
    COMMENT VARCHAR(42),
    RAZRAD DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    NTR INTEGER,
    PUNKTIND VARCHAR(42),
    ISESN INTEGER,
    IDWITHESN INTEGER,
    CCURRENT_BA DOUBLE PRECISION,
    CCURRENT_BB DOUBLE PRECISION,
    CCURRENT_BC DOUBLE PRECISION,
    CCURRENT_BD DOUBLE PRECISION,
    CCURRENT_BE DOUBLE PRECISION,
    CCURRENT_ZONE INTEGER,
    IDQUALIFIER INTEGER,
    IDNORMTYPE INTEGER,
    NORM_GUID VARCHAR(100),
    IDREESTR INTEGER,
    ABC_OKP_NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_RABMAT INTEGER,
    ABC_OKP_IDNAME INTEGER,
    ABC_OKP_ID_UNIQUE INTEGER,
    ABC_OKP_TAB VARCHAR(42),
    ABC_OKP_TABU VARCHAR(42),
    ABC_OKP_IDGROUP INTEGER,
    ABC_OKP_IDPODGROUP INTEGER,
    ABC_OKP_ISGROUPOKP INTEGER,
    ABC_OKP_IDEDIZM INTEGER,
    ABC_OKP_EDIZM_NAME VARCHAR(100),
    ABC_OKP_EDIZM_FULLNAME VARCHAR(255),
    ABC_OKP_CENA DOUBLE PRECISION,
    ABC_OKP_RAZRAD DOUBLE PRECISION,
    ABC_OKP_VIDNR INTEGER,
    ABC_OKP_COMMENT VARCHAR(42),
    ABC_OKP_PUNKTIND VARCHAR(42),
    ABC_OKP_VRPZ INTEGER,
    ABC_OKP_NTR INTEGER,
    ABC_OKP_CCURRENT DOUBLE PRECISION,
    ABC_OKP_CCURRENT_ZONE INTEGER,
    ABC_OKP_IDQUALIFIER INTEGER,
    TYPE_TRUD INTEGER,
    ABC_OKP_TYPE_TRUD INTEGER,
    MA DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    BB_PR DOUBLE PRECISION,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAMECRC INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE M_GET_ONE_RES_INDEX (
    ID_SOURCE INTEGER,
    ID_LEVEL INTEGER,
    IDCLASS INTEGER,
    INSMETA INTEGER,
    RABMAT INTEGER,
    IDHIER INTEGER,
    IDNORMATIV INTEGER,
    PODGROUP INTEGER,
    TYPE_RAB INTEGER,
    VID_RAB INTEGER,
    PUNKTIND VARCHAR(42),
    TYPE_TRUD INTEGER,
    ID_USER INTEGER)
RETURNS (
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE NL_CTRL_ENTER_SMREC (
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    ID_USER INTEGER,
    NEED_APPLY_INDEX INTEGER,
    NEED_APPLY_FORMUL INTEGER,
    SEARCH_PUNKTIND VARCHAR(42),
    ID_SM_REC INTEGER,
    IN_IDTR INTEGER,
    IN_VRPZ INTEGER,
    IN_RES_COPY_FORMULS INTEGER,
    UPDATE_ALL_ACT INTEGER)
RETURNS (
    ID_LEVEL INTEGER,
    RES_VC INTEGER,
    RES_INDEX INTEGER,
    ID_S_RES INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE NL_GET_CENLVL_NEW (
    ID_LEVEL INTEGER,
    IDCLASS INTEGER,
    ID_USER INTEGER,
    TYPE_RAB INTEGER,
    VID_RAB INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    IDHIER INTEGER,
    IDNORMATIV INTEGER,
    PODGROUP INTEGER,
    IN_PUNKTIND VARCHAR(42),
    IN_IDZONE INTEGER,
    IN_BA DOUBLE PRECISION,
    IN_BB DOUBLE PRECISION,
    IN_BC DOUBLE PRECISION,
    IN_BD DOUBLE PRECISION,
    IN_BE DOUBLE PRECISION,
    IN_B_PR DOUBLE PRECISION,
    ID_SM_REC INTEGER,
    NEED_APPLY_INDEX INTEGER)
RETURNS (
    ID_LEVEL_VC INTEGER,
    IDZONE INTEGER,
    ID_LEVEL_INDEX INTEGER,
    IDINDEX INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    B_PR DOUBLE PRECISION,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    M_PR DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    PUNKTIND VARCHAR(42),
    SPOSOB_RASCH INTEGER,
    RES_VC INTEGER,
    RES_INDEX INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE NL_GET_RES_CENLVL (
    ID_LEVEL INTEGER,
    IDCLASS INTEGER,
    ID_USER INTEGER,
    TYPE_RAB INTEGER,
    VID_RAB INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    IDHIER INTEGER,
    IDNORMATIV INTEGER,
    PODGROUP INTEGER,
    IN_IDZONE INTEGER,
    IN_BB DOUBLE PRECISION,
    IN_BC DOUBLE PRECISION,
    IN_BD DOUBLE PRECISION,
    IN_BE DOUBLE PRECISION)
RETURNS (
    ID_LEVEL_VC INTEGER,
    IDZONE INTEGER,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    RES_VC INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE NL_RECALL_EMPTYNORMO_INDEX (
    IDUSER INTEGER,
    IDSMETASTR INTEGER,
    IDLEVEL INTEGER)
RETURNS (
    RECORDS_MODIFIED INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
CREATE OR ALTER PROCEDURE PASTE_SMETA_RECORD (
    IDUSER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    INSERT_TO_ATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    ATYPE INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    RABMAT INTEGER,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(250),
    EDIZM_RELATION DOUBLE PRECISION,
    TYPE_TRUD INTEGER,
    TIPRAB INTEGER,
    VIDRAB INTEGER,
    IDNORMATIVUNIQ INTEGER,
    NORM_GUID VARCHAR(100),
    KODIR_GROUP_NAME VARCHAR(250),
    KODIR_PODGROUP_NAME VARCHAR(250),
    ISGROUPOKP INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    PUNKTIND VARCHAR(42),
    SLAVEPARENT INTEGER,
    ID_S_RES INTEGER,
    IDFORMULS INTEGER,
    VRPZ INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CLCMODE INTEGER,
    SM_CLCMODE INTEGER,
    PRICE_GUID VARCHAR(100),
    PRICE_NORMOTAB VARCHAR(42),
    PRICE_NORMOGUID VARCHAR(100),
    ROW INTEGER,
    COST DOUBLE PRECISION,
    KOEF DOUBLE PRECISION,
    SOURCE_IDHIER INTEGER,
    VSEGO DOUBLE PRECISION,
    COPY_RES_UCH_STATUS INTEGER,
    APPLAY_FORMULS_AS_IS INTEGER,
    IDNORMATIV INTEGER,
    K_ITOGO VARCHAR(50),
    B_PR DOUBLE PRECISION,
    K_PR VARCHAR(50),
    COD_RTM blob sub_type 1 segment size 80)
RETURNS (
    ID INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15352]
CREATE OR ALTER PROCEDURE V_GET_PARAMS_LS (
    IDUSER INTEGER,
    IDHIER INTEGER)
RETURNS (
    ID INTEGER,
    NUMGLSSR INTEGER,
    TIPRAB INTEGER,
    SHIFR VARCHAR(1024),
    FULLNAME VARCHAR(1024),
    NACH_STROY DATE,
    OKONCH_STROIT DATE,
    SPISOKSHERT BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    OPISANIE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ISPOLNIL_FIO VARCHAR(250),
    ISPOLNIL_DOLGN VARCHAR(100),
    PROVERIL_FIO VARCHAR(250),
    PROVERIL_DOLGN VARCHAR(100),
    UTVERDIL_FIO VARCHAR(250),
    UTVERDIL_DOLGN VARCHAR(100),
    SUBPODR_ID_ORG INTEGER,
    SUBPODR_NAME_ORG VARCHAR(255),
    SUBPODR_ID INTEGER,
    SUBPODR_FIO VARCHAR(250),
    SUBPODR_DOLGN VARCHAR(100),
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    VELICHSTROBJ DOUBLE PRECISION,
    EDIZM VARCHAR(40),
    CODE VARCHAR(512),
    REPLACECORRECTION INTEGER,
    SPREADONEXISTSREC INTEGER,
    CORRECTIONRULE INTEGER,
    NUMGLSSR_CALCULATED INTEGER,
    REVISION VARCHAR(255),
    GUID VARCHAR(100),
    VRIDDOC INTEGER,
    VRDOCCAPTION VARCHAR(20),
    VRNPPTEXT VARCHAR(20),
    VRPRVALUE DOUBLE PRECISION,
    ZUIDDOC INTEGER,
    ZUDOCCAPTION VARCHAR(20),
    ZUNPPTEXT VARCHAR(20),
    ZUPRVALUE DOUBLE PRECISION,
    CLIDDOC INTEGER,
    CLDOCCAPTION VARCHAR(20),
    CLNPPTEXT VARCHAR(20),
    CLZONE INTEGER,
    CLKOEF DOUBLE PRECISION,
    NUMLSR_LS VARCHAR(1024))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE V_GET_PARAMS_R_PR (
    IDUSER INTEGER,
    IDHIER INTEGER)
RETURNS (
    ID INTEGER,
    NUMGLSSR INTEGER,
    TIPRAB INTEGER,
    SHIFR VARCHAR(1024),
    FULLNAME VARCHAR(1024),
    OPISANIE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ISPOLNIL_FIO VARCHAR(250),
    ISPOLNIL_DOLGN VARCHAR(100),
    PROVERIL_FIO VARCHAR(250),
    PROVERIL_DOLGN VARCHAR(100),
    UTVERDIL_FIO VARCHAR(250),
    UTVERDIL_DOLGN VARCHAR(100),
    SUBPODR_ID_ORG INTEGER,
    SUBPODR_NAME_ORG VARCHAR(255),
    SUBPODR_ID INTEGER,
    SUBPODR_FIO VARCHAR(250),
    SUBPODR_DOLGN VARCHAR(100),
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    VELICHSTROBJ DOUBLE PRECISION,
    EDIZM VARCHAR(40),
    REPLACECORRECTION INTEGER,
    SPREADONEXISTSREC INTEGER,
    CORRECTIONRULE INTEGER,
    NUMGLSSR_CALCULATED INTEGER,
    GUID VARCHAR(100))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
-- 
CREATE OR ALTER PROCEDURE V_SELECT_ASMETA_FOR_EXP_ACT_XML (
    ID_USER INTEGER,
    ID_OBJ INTEGER,
    IN_SMETATYPE INTEGER,
    IDHIER INTEGER)
RETURNS (
    ID INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    NAME BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(250),
    EDIZM_RELATION DOUBLE PRECISION,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    VRPZ INTEGER,
    ALTTAB VARCHAR(250),
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    KODIR_GROUP_NAME VARCHAR(250),
    KODIR_PODGROUP_NAME VARCHAR(250),
    ISGROUPOKP INTEGER,
    NOMERROD INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    VIDRAB INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CLCMODE INTEGER,
    TYPE_TRUD INTEGER,
    IDFORMULS INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
BEGIN
  SUSPEND;
END
^

--[15352]
CREATE OR ALTER PROCEDURE A_P_SMETA (
    IDOBJECT INTEGER,
    IDLEVEL INTEGER,
    IDUSER INTEGER,
    SMETATYPE INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    IDLS INTEGER,
    IDR INTEGER,
    ALLREC INTEGER,
    SENDER INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    CLCMODE_RES INTEGER,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    ID_LS INTEGER,
    ADDED_SMETATYPE INTEGER,
    PR_VIPOLNENO_TOTAL DOUBLE PRECISION,
    K_ITOGO VARCHAR(50),
    ISKS_NS_ID INTEGER,
    COD_RTM VARCHAR(60),
    COD_RTM_BLOB BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    K_PR VARCHAR(50),
    B_PR DOUBLE PRECISION)
AS
--CQ[TIMUR 13931] -    FULL_STRUCT_NAME, STRUCT_SHIFR, NUMLSR_LS
declare variable hatype integer;
declare variable hcountchildren integer;
declare variable aid integer;
declare variable cur_projecttype integer;
declare variable cur_id_tr integer;
declare variable cur_id_zone integer;
declare variable cur_savecenzonetonormbase integer;
declare variable param_kodir_group integer;
declare variable param_kodir_podgroup integer;
declare variable show_zero_strings integer;
declare variable futv integer;
declare variable isclc integer;
declare variable mode_kompns_st integer;
declare variable vn_sm_rec_itog double precision;
--[10111]declare variable god_vid_nb integer;
--[14507]declare NRSPOTZPM_USED integer;
declare variable obj_nr_ot_zpm double precision;
declare variable obj_sp_ot_zpm double precision;
declare variable obj_precit integer;

declare variable abs_atype integer;
declare variable ls_number1 integer;
declare variable ls_number2 integer;
declare variable ls_number3 integer;

declare variable P_CLCMODE integer;  --CQ[TIMUR 9266]
begin
--[15352]+

  -- MK 22.05.2012 CQ[9460]  !!! ---------------------------------------
  --   STRUCT_SHIFR   ()   
  --   SAP (B_RABMAT.IDENT_KOD_MAT_SAP)



 IsHaveCorrectionNR = null;

 if (idobject = 0)
 then exit;


 if ( ( SMETATYPE = 16 ) or ( SMETATYPE = -16 ) ) then
 begin
    -- MK 30.08.2011 CQ[9465]
    execute procedure M_PREPARE_IS_LZ_VALUES(:idobject);


    for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE,
               RABMAT, TYPE_TRUD, TAB, ALTTAB, 
               NAME, NAME_ID, EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH, 
               BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
               --CQ[9359]SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
               EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
               --CQ[9359]SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
               RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
               PA, PB, PC, PD, PE, VRPZ, IDTIPR,
               KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
               PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
               SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH,
               OKONCH, TIPRAB, VIDRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, ARPS_OTHER,
               ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_ADDED_REC, PR_VSEGO, PR_VIPOLNENO, PR_EXISTS_CHILDS,
               NORM_GUID, CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, STATUS_REC_CEN, IDREESTR,
               CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
               UTV, ASUBTYPE,
               STRUCT_NAME, FULL_STRUCT_NAME,
               IDFORMULS/*CQ[9359]*/, STRUCT_SHIFR/*CQ[9609]*/, NUMLSR_LS/*CQ[12881]*/,
               VIEW_NUMBER1, VIEW_NUMBER2, VIEW_NUMBER3, ID_LS/*MK CQ[12020]*/,
               ADDED_SMETATYPE, --[15004]
               K_ITOGO/*14460*/, K_PR, /*15421*/
               B_PR --[15352]
           from L_S_CREATE_IS (:idobject, :aid, :iduser, :smetatype, :nls, :nr, :npr, :idls, :idr, :allrec, :sender)
           into :id, :idhier, :number1, :number2, :number3, :slaveparent, :atype,
                :rabmat, :TYPE_TRUD, :tab, :alttab,
                :name, :name_id, :edizm, :id_edizm, :edizm_type, :koll, :skoll, :normarash,
                :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi, :bj,
                --CQ[9359]:sea,:seb,:sec,:sed,:see,:sef,:seg,:seh,:sei, :sej,  :sek,
                :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
                --CQ[9359]:sra,:srb,:src,:srd,:sre,:srf,:srg,:srh,:sri,:srj,:srk,:srl,:srm,
                :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
                :pa, :pb, :pc, :pd, :pe, :vrpz, :idtipr,
                :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM, 
                :punktind, :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :mj, :mk, :ml,
                :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
                :okonch, :tiprab, :vidrab, :idnormativ, :idnormativuniq, :kodir_group, :kodir_podgroup, :isgroupokp, :arps_other,
                :id_s_res, :pr_number1, :pr_number2, :pr_number3, :pr_added_rec, :pr_vsego, :pr_vipolneno, :pr_exists_childs,
                :norm_guid, :calk_ba, :calk_bb, :calk_bc, :calk_bd, :calk_be, :status_rec_cen, :idreestr,
                :calk_bg, :calk_bg_readonly, :calk_bh, :calk_bh_readonly,
                :UTV, :asubtype,
                :STRUCT_NAME, :FULL_STRUCT_NAME,
                :IDFORMULS/*CQ[9359]*/, :STRUCT_SHIFR/*CQ[9609]*/, :NUMLSR_LS/*CQ[12881]*/,
                :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3, :ID_LS/*MK CQ[12020]*/,
                :ADDED_SMETATYPE, --[15004]
                :K_ITOGO/*14460*/, :K_PR, /*15421*/
                :B_PR --[15352]
       do
       begin
         PR_VIPOLNENO_TOTAL = null; -- CQ[12834]
         -- MK 14.09.2010 CQ[8691] --->
         abs_atype = abs(atype);
         --  
         if (abs_atype in (3, 4, 5)) then
         begin
           --   -  
           if (abs_atype = 3) then
           begin
             execute procedure M_GET_BLOCKED_STRUCT(:IDOBJECT, :idhier)
             returning_values(:NUMBER1, :NUMBER2, :NUMBER3);
             --     
             ls_number1 = NUMBER1;
             ls_number2 = NUMBER2;
             ls_number3 = NUMBER3;
           end

           --   ,  -     
           else
           begin
             NUMBER1 = ls_number1;
             NUMBER2 = ls_number2;
             NUMBER3 = ls_number3;
           end
         end
         -- MK 14.09.2010 CQ[8691] <---

         PCELLMEM = null;

         --CQ[TIMUR 13246]
         CLCMODE = null;
         select CLCMODE
           from A_SMETA
         where (ID = :ID)
         into :CLCMODE;
         --CQ[TIMUR 13246]

         suspend;
       end

    exit;
 end




/*
 if SENDER = 1
 then run Cristal Report
 
 if sender = 2
 then run cristal report (smeta na montag objrudovanij)
*/

 cur_id_zone = -1;
 cur_savecenzonetonormbase = 0;

 select p.id_zone, p.savecenzonetonormbase, p.id_tr, p.kodir_group, p.kodir_podgroup,
        p.ISCLC, p.MODE_KOMPNS_ST, p.NR_OT_ZPM, p.SP_OT_ZPM, p.PRECIT
 --from A_S_GET_PARAMS_OBJ( :iduser, :idobject ) p
 from A_GET_PARAMS_OBJ_AKT( :iduser, :idobject, :SMETATYPE ) p
 into :cur_id_zone, :cur_savecenzonetonormbase, :cur_id_tr, :param_kodir_group, :param_kodir_podgroup,
      :ISCLC, :MODE_KOMPNS_ST, :OBJ_NR_OT_ZPM, :OBJ_SP_OT_ZPM, :OBJ_PRECIT;

 /* MK 3.11.2006 CQ[4026] */
 --[10111]execute procedure T_GETGODVIDNB(:IDUSER, :IDOBJECT) returning_values(:GOD_VID_NB);
 --[14507]execute procedure T_GET_USENRSPOTZPM(:IDOBJECT) returning_values :NRSPOTZPM_USED;


 select projecttype
 from l_getprojecttype( :iduser )
 into :cur_projecttype;

 show_zero_strings = 1;
 if ( smetatype > 999 ) then
 begin
    select first 1 utv from a_o_factparams where number = :smetatype into :futv;
    if ( :futv <> 0 ) then
       show_zero_strings = 0;
 end

 id = idlevel;

 /**********************************************************************/

 if ( idobject = idlevel )
 then for select h.number, h.atype, h.countchildren
          from a_o_hier h
          where ( h.number = :idobject ) and
                ( h.atype in ( 0, 3, 4, 5 ) ) and
                ( ( h.subtype is null ) or ( h.subtype in ( 0, 1, 2, 3, 4, 5 ) ) )
          into :id, :hatype, :hcountchildren
 do
 begin

  atype = hatype;
  aid =  id;

  for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE, RABMAT, TAB, ALTTAB,
             NAME, NAME_ID, EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
             BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
             --CQ[9359] SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
             EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
             --CQ[9359] SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
             RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
             PA, PB, PC, PD, PE, VRPZ, IDTIPR,
             KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
             PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
             SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH,
             OKONCH, TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, ARPS_OTHER,
             ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_ADDED_REC, PR_VSEGO, PR_VIPOLNENO, PR_EXISTS_CHILDS,
             NORM_GUID, CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB,
             NLS, NR, NPR, IDLS, IDR, ISHAVECORRECTIONNR,
             CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
             UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
             S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH, ISRESPOPR, TYPE_TRUD, UCH,
             STRUCT_NAME, FULL_STRUCT_NAME,
             IDFORMULS/*CQ[9359]*/, STRUCT_SHIFR/*CQ[9609]*/, NUMLSR_LS/*CQ[12881]*/,
             CLCMODE_RES/*CQ[12244]*/, VIEW_NUMBER1, VIEW_NUMBER2, VIEW_NUMBER3, ADDED_SMETATYPE/*MK CQ[12020]*/,
             PR_VIPOLNENO_TOTAL/*CQ[12834]*/, K_ITOGO/*14460*/,
             ISKS_NS_ID, COD_RTM, COD_RTM_BLOB, -- <-- Voyager CQ[14886,15191]
             K_PR, /*15421*/
             B_PR --[15352]
      from a_s_hier_select ( :iduser,
                             :hatype,
                             :aid,
                             :idobject,
                             :smetatype,
                             :nls,
                             :nr,
                             :npr,
                             :idls,
                             :idr,
                             :cur_projecttype,
                             :allrec,
                             :sender,
                             :cur_id_zone,
                             :cur_savecenzonetonormbase,
                             :cur_id_tr,
                             :param_kodir_group,
                             :param_kodir_podgroup,
                             :show_zero_strings,
                             :ISCLC,
                             :MODE_KOMPNS_ST,
                             0 -- MK 20.10.2008 CQ[6704]
                           )
      into :id, :idhier, :number1, :number2, :number3, :slaveparent, :atype, :rabmat, :tab, :alttab,
           :name, :name_id, :edizm, :id_edizm, :edizm_type, :koll, :skoll, :normarash,
           :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi, :bj,
           --CQ[9359] :sea,:seb,:sec,:sed,:see,:sef,:seg,:seh,:sei, :sej, :sek,
           :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek, 
           --CQ[9359] :sra,:srb,:src,:srd,:sre,:srf,:srg,:srh,:sri,:srj,:srk,:srl,:srm,
           :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
           :pa, :pb, :pc, :pd, :pe, :vrpz, :idtipr,
           :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM, 
           :punktind, :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :mj, :mk, :ml,
           :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
           :okonch, :tiprab, :idnormativ, :idnormativuniq, :kodir_group, :kodir_podgroup, :isgroupokp, :arps_other,
           :id_s_res, :pr_number1, :pr_number2, :pr_number3, :pr_added_rec, :pr_vsego, :pr_vipolneno, :pr_exists_childs,
           :norm_guid, :calk_ba, :calk_bb, :calk_bc, :calk_bd, :calk_be, :status_rec_cen, :idreestr, :pcellmem, :vidrab,
           :nls, :nr, :npr, :idls, :idr, :IsHaveCorrectionNR,
           :calk_bg, :calk_bg_readonly, :calk_bh, :calk_bh_readonly,
           :UTV, :CorrectNode, :CorrectNode_1, :asubtype, :CLCMODE,
           :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH, :ISRESPOPR, :TYPE_TRUD, :UCH,  --              , :RES_PRICE_COUNT
           :STRUCT_NAME, :FULL_STRUCT_NAME,
           :IDFORMULS/*CQ[9359]*/, :STRUCT_SHIFR/*CQ[9609]*/, :NUMLSR_LS/*CQ[12881]*/, :CLCMODE_RES/*CQ[12244]*/,
           :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3, :ADDED_SMETATYPE/*MK CQ[12020]*/,
           :PR_VIPOLNENO_TOTAL/*CQ[12834]*/, :K_ITOGO/*14460*/,
           :ISKS_NS_ID, :COD_RTM, :COD_RTM_BLOB, -- <-- Voyager CQ[14886,15191]
           :K_PR, /*15421*/
           :B_PR --[15352]

  do
  begin
    -- MK 14.09.2010 CQ[8691] --->
    abs_atype = abs(atype);
    --  
    if (abs_atype in (3, 4, 5)) then
    begin
      execute procedure M_GET_BLOCKED_STRUCT(:IDOBJECT, :idhier)
      returning_values(:NUMBER1, :NUMBER2, :NUMBER3);

      --   -  
      if (SMETATYPE > 16) then
      begin
        execute procedure M_GET_BLOCKED_STRUCT(:SMETATYPE, :idhier)
        returning_values(:PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3);
      end
    end
    -- MK 14.09.2010 CQ[8691] <---

     /* MK 3.11.2006 CQ[4026] ---> */
     if (atype = 17) then
     begin
        --<[14507]>execute procedure M_CALC_ITOG_SM_REC(:IDUSER, :id, :NRSPOTZPM_USED/*[10111]GOD_VID_NB*/, :OBJ_NR_OT_ZPM,
        --                                     :OBJ_SP_OT_ZPM, :RA, :RD, :RJ, :RK, :OBJ_PRECIT)
        --returning_values (:VN_SM_REC_ITOG);
        --</>SM_REC_ITOG = VN_SM_REC_ITOG;

        P_CLCMODE = CLCMODE; --CQ[TIMUR 9266]
     end
     else if (atype = 18) then
     begin
        --[14507]SM_REC_ITOG = VN_SM_REC_ITOG;

        --CQ[TIMUR 9266]
        if (GETBIT(:P_CLCMODE, 10) <> 0) then
          CLCMODE = SETBIT(:CLCMODE, 10, 1);
        --CQ[TIMUR 9266]
     end
     else
        SM_REC_ITOG = null;
     /* MK 3.11.2006 <--- */

     -- MK CQ[12020] --->
     if (abs_atype = 3) then
       ID_LS = aid;
     -- MK CQ[12020] <---
    suspend;
  end

  exit;

 end

 /**********************************************************************/


 --<rvs:00004533>
 for select IDHIER
   from S_O_HIER_SELECT_LEVEL_NF(:IDLEVEL)
   into :ID
 do
 --</rvs:00004533>
 for select h.number, h.atype, h.countchildren
     from a_o_hier h
     where h.NUMBER = :ID and --(h.parent = :idlevel) and <<rvs:00004533
           --(h.atype in (0,3,4,5)) and <<rvs:00004533
           ( (h.subtype is null) or (h.subtype in (0,1,2,3,4,5)) )
     order by h.sorting
     into :id, :hatype, :hcountchildren
 do
 begin
  atype = hatype;
  aid =  id;

  for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE, RABMAT, TAB, ALTTAB,
             NAME, NAME_ID, EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
             BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
             --CQ[9359] SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
             EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
             --CQ[9359] SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
             RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
             PA, PB, PC, PD, PE, VRPZ, IDTIPR,
             KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
             PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
             SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH,
             OKONCH, TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, ARPS_OTHER,
             ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_ADDED_REC, PR_VSEGO, PR_VIPOLNENO, PR_EXISTS_CHILDS,
             NORM_GUID, CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB,
             NLS, NR, NPR, IDLS, IDR, ISHAVECORRECTIONNR,
             CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
             UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
             S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH, ISRESPOPR, TYPE_TRUD, UCH,
             STRUCT_NAME, FULL_STRUCT_NAME,
             IDFORMULS/*CQ[9359]*/, STRUCT_SHIFR/*CQ[9609]*/, NUMLSR_LS/*CQ[12881]*/, CLCMODE_RES/*CQ[12244]*/, --
             VIEW_NUMBER1, VIEW_NUMBER2, VIEW_NUMBER3, ADDED_SMETATYPE/*MK CQ[12020]*/,
             PR_VIPOLNENO_TOTAL/*CQ[12834]*/, K_ITOGO/*14460*/,
             ISKS_NS_ID, COD_RTM, COD_RTM_BLOB, -- <-- Voyager CQ[14886,15191]
             K_PR, /*15421*/
             B_PR --[15352]
      from a_s_hier_select ( :iduser,
                             :hatype,
                             :aid,
                             :idobject,
                             :smetatype,
                             :nls,
                             :nr,
                             :npr,
                             :idls,
                             :idr,
                             :cur_projecttype,
                             :allrec,
                             :sender,
                             :cur_id_zone,
                             :cur_savecenzonetonormbase,
                             :cur_id_tr,
                             :param_kodir_group,
                             :param_kodir_podgroup,
                             :show_zero_strings,
                             :ISCLC,
                             :MODE_KOMPNS_ST,
                             0 -- MK 20.10.2008 CQ[6704]
                           )
      into :id, :idhier, :number1, :number2, :number3, :slaveparent, :atype, :rabmat, :tab, :alttab,
           :name, :name_id, :edizm, :id_edizm, :edizm_type, :koll, :skoll, :normarash,
           :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi, :bj,
           --CQ[9359] :sea,:seb,:sec,:sed,:see,:sef,:seg,:seh,:sei, :sej, :sek,
           :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
           --CQ[9359] :sra,:srb,:src,:srd,:sre,:srf,:srg,:srh,:sri,:srj,:srk,:srl,:srm,
           :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
           :pa, :pb, :pc, :pd, :pe, :vrpz, :idtipr,
           :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM, 
           :punktind, :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :mj, :mk, :ml,
           :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
           :okonch, :tiprab, :idnormativ, :idnormativuniq, :kodir_group, :kodir_podgroup, :isgroupokp, :arps_other,
           :id_s_res, :pr_number1, :pr_number2, :pr_number3, :pr_added_rec, :pr_vsego, :pr_vipolneno, :pr_exists_childs,
           :norm_guid, :calk_ba, :calk_bb, :calk_bc, :calk_bd, :calk_be, :status_rec_cen, :idreestr, :pcellmem, :vidrab,
           :nls, :nr, :npr, :idls, :idr, :IsHaveCorrectionNR,
           :calk_bg, :calk_bg_readonly, :calk_bh, :calk_bh_readonly,
           :UTV, :CorrectNode, :CorrectNode_1, :asubtype, :CLCMODE,
           :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH, :ISRESPOPR, :TYPE_TRUD, :UCH, --             , :RES_PRICE_COUNT
           :STRUCT_NAME, :FULL_STRUCT_NAME, :IDFORMULS/*CQ[9359]*/,
           :STRUCT_SHIFR/*CQ[9609]*/, :NUMLSR_LS/*CQ[12881]*/, :CLCMODE_RES/*CQ[12244]*/,
           :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3, :ADDED_SMETATYPE/*MK CQ[12020]*/,
           :PR_VIPOLNENO_TOTAL/*CQ[12834]*/, :K_ITOGO/*14460*/,
           :ISKS_NS_ID, :COD_RTM, :COD_RTM_BLOB, -- <-- Voyager CQ[14886,15191]
           :K_PR, /*15421*/
           :B_PR --[15352]
  do
  begin
    -- MK 14.09.2010 CQ[8691] --->
    abs_atype = abs(atype);
    --  
    if (abs_atype in (3, 4, 5)) then
    begin
      execute procedure M_GET_BLOCKED_STRUCT(:IDOBJECT, :idhier)
      returning_values(:NUMBER1, :NUMBER2, :NUMBER3);

      --   -  
      if (SMETATYPE > 16) then
      begin
        execute procedure M_GET_BLOCKED_STRUCT(:SMETATYPE, :idhier)
        returning_values(:PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3);
      end
    end
    -- MK 14.09.2010 CQ[8691] <---


     /* MK 3.11.2006 CQ[4026] ---> */
     if (atype = 17) then
     begin
        --<[14507]>execute procedure M_CALC_ITOG_SM_REC(:IDUSER, :id, :NRSPOTZPM_USED/*[10111]GOD_VID_NB*/, :OBJ_NR_OT_ZPM,
        --                                     :OBJ_SP_OT_ZPM, :RA, :RD, :RJ, :RK, :OBJ_PRECIT)
        --returning_values (:VN_SM_REC_ITOG);
        --</>SM_REC_ITOG = VN_SM_REC_ITOG;

        P_CLCMODE = CLCMODE; --CQ[TIMUR 9266]
     end
     else if (atype = 18) then
     begin
        --[14507]SM_REC_ITOG = VN_SM_REC_ITOG;

        --CQ[TIMUR 9266]
        if (GETBIT(:P_CLCMODE, 10) <> 0) then
          CLCMODE = SETBIT(:CLCMODE, 10, 1);
        else
          CLCMODE = SETBIT(:CLCMODE, 10, 0);
        --CQ[TIMUR 9266]

     end
     else
        SM_REC_ITOG = null;
     /* MK 3.11.2006 <--- */

     -- MK CQ[12020] --->
     if (abs_atype = 3) then
       ID_LS = aid;
     -- MK CQ[12020] <---

     suspend;
  end



  if (
      (hcountchildren > 0) and
      ( cur_projecttype <> 1 )
     )
  then for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE, RABMAT, TAB, ALTTAB,
                  NAME, NAME_ID, EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
                  --CQ[9359]SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
                  EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                  --CQ[9359]SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
                  RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                  PA, PB, PC, PD, PE, VRPZ, IDTIPR,
                  KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                  PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
                  SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH,
                  OKONCH, TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, ARPS_OTHER,
                  ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_ADDED_REC, PR_VSEGO, PR_VIPOLNENO, PR_EXISTS_CHILDS,
                  NORM_GUID, CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB,
                  ISHAVECORRECTIONNR,
                  CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
                  UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
                  S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH, ISRESPOPR, TYPE_TRUD, SM_REC_ITOG, UCH,
                  STRUCT_NAME, FULL_STRUCT_NAME,
                  IDFORMULS/*CQ[9359]*/, STRUCT_SHIFR/*CQ[9609]*/, NUMLSR_LS/*CQ[12881]*/, CLCMODE_RES/*CQ[12244]*/,
                  VIEW_NUMBER1, VIEW_NUMBER2, VIEW_NUMBER3, ID_LS, ADDED_SMETATYPE/*MK CQ[12020]*/,
                  PR_VIPOLNENO_TOTAL/*CQ[12834]*/, K_ITOGO/*14460*/,
                  ISKS_NS_ID, COD_RTM, COD_RTM_BLOB, -- Voyager CQ[14886,15191]
                  K_PR, /*15421*/
                  B_PR --[15352]
           from a_p_smeta (:idobject, :aid, :iduser, :smetatype, :nls, :nr, :npr, :idls, :idr, :allrec, :sender)
           into :id, :idhier, :number1, :number2, :number3, :slaveparent, :atype, :rabmat, :tab, :alttab,
                :name, :name_id, :edizm, :id_edizm, :edizm_type, :koll, :skoll, :normarash,
                :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi, :bj,
                --CQ[9359]:sea,:seb,:sec,:sed,:see,:sef,:seg,:seh,:sei, :sej, :sek,
                :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
                --CQ[9359]:sra,:srb,:src,:srd,:sre,:srf,:srg,:srh,:sri,:srj,:srk,:srl,:srm,
                :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
                :pa, :pb, :pc, :pd, :pe, :vrpz, :idtipr,
                :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM,
                :punktind, :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :mj, :mk, :ml,
                :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
                :okonch, :tiprab, :idnormativ, :idnormativuniq, :kodir_group, :kodir_podgroup, :isgroupokp, :arps_other,
                :id_s_res, :pr_number1, :pr_number2, :pr_number3, :pr_added_rec, :pr_vsego, :pr_vipolneno, :pr_exists_childs,
                :norm_guid, :calk_ba, :calk_bb, :calk_bc, :calk_bd, :calk_be, :status_rec_cen, :idreestr, :PCELLMEM, :vidrab,
                :IsHaveCorrectionNR,
                :calk_bg, :calk_bg_readonly, :calk_bh, :calk_bh_readonly,
                :UTV, :CorrectNode, :CorrectNode_1, :asubtype, :CLCMODE,
                :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH, :IsResPopr, :TYPE_TRUD, :SM_REC_ITOG, :UCH, --    A_P_SMETA, :RES_PRICE_COUNT
                :STRUCT_NAME, :FULL_STRUCT_NAME, :IDFORMULS/*CQ[9359]*/, :STRUCT_SHIFR/*CQ[9609]*/,
                :NUMLSR_LS/*CQ[12881]*/, :CLCMODE_RES/*CQ[12244]*/,
                :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3, :ID_LS, :ADDED_SMETATYPE/*MK CQ[12020]*/,
                :PR_VIPOLNENO_TOTAL/*CQ[12834]*/, :K_ITOGO/*14460*/,
                :ISKS_NS_ID, :COD_RTM, :COD_RTM_BLOB, -- Voyager CQ[14886,15191]
                :K_PR, /*15421*/
                :B_PR --[15352]
       do
       begin
         suspend;

       end

  if ( ( sender >= 1 ) and ( hatype <> 0 ) )
  then
  begin

   atype = hatype + 23;
   idhier = aid;

   suspend;

  end

  if ( cur_projecttype = 1 )
  then exit;

 end
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_P_SMETA_EX (
    IDOBJECT INTEGER,
    IDLEVEL INTEGER,
    IDUSER INTEGER,
    SMETATYPE INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    IDLS INTEGER,
    IDR INTEGER,
    ALLREC INTEGER,
    SENDER INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    NBA DOUBLE PRECISION,
    NBB DOUBLE PRECISION,
    NBC DOUBLE PRECISION,
    NBD DOUBLE PRECISION,
    NBE DOUBLE PRECISION,
    NBF DOUBLE PRECISION,
    NBG DOUBLE PRECISION,
    NBH DOUBLE PRECISION,
    NBI DOUBLE PRECISION,
    NBJ DOUBLE PRECISION,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    IDFORMULS INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
--CQ[TIMUR 13931] -    full_struct_name
declare variable full_struct_name VARCHAR(1050);
begin
--[15352]+
--[8443]

       for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE, RABMAT, TAB, ALTTAB,
                  NAME, NAME_ID, EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
                  SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
                  EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                  SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
                  RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                  PA, PB, PC, PD, PE, VRPZ, IDTIPR,
                  KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                  PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
                  SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH,
                  OKONCH, TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, ARPS_OTHER,
                  ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_ADDED_REC, PR_VSEGO, PR_VIPOLNENO, PR_EXISTS_CHILDS,
                  NORM_GUID, CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB,
                  ISHAVECORRECTIONNR,
                  CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY, UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE,
                  CLCMODE, S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH, ISRESPOPR, TYPE_TRUD, SM_REC_ITOG, UCH,
                  FULL_STRUCT_NAME, IDFORMULS/*CQ[9359]*/, K_ITOGO/*14460*/, K_PR /*15421*/
           from a_p_smeta (:idobject, :idlevel, :iduser, :smetatype, :nls, :nr, :npr, :idls, :idr, :allrec, :sender)
           into :id, :idhier, :number1, :number2, :number3, :slaveparent, :atype, :rabmat, :tab, :alttab,
                :name, :name_id, :edizm, :id_edizm, :edizm_type, :koll, :skoll, :normarash,
                :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi, :bj,
                :sea,:seb,:sec,:sed,:see,:sef,:seg,:seh,:sei, :sej, :sek,
                :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
                :sra,:srb,:src,:srd,:sre,:srf,:srg,:srh,:sri,:srj,:srk,:srl,:srm,
                :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
                :pa, :pb, :pc, :pd, :pe, :vrpz, :idtipr,
                :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM,
                :punktind, :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :mj, :mk, :ml,
                :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
                :okonch, :tiprab, :idnormativ, :idnormativuniq, :kodir_group, :kodir_podgroup, :isgroupokp, :arps_other,
                :id_s_res, :pr_number1, :pr_number2, :pr_number3, :pr_added_rec, :pr_vsego, :pr_vipolneno, :pr_exists_childs,
                :norm_guid, :calk_ba, :calk_bb, :calk_bc, :calk_bd, :calk_be, :status_rec_cen, :idreestr, :PCELLMEM, :vidrab,
                :IsHaveCorrectionNR,
                :calk_bg, :calk_bg_readonly, :calk_bh, :calk_bh_readonly, :UTV, :CorrectNode, :CorrectNode_1, :asubtype,
                :CLCMODE, :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH, :IsResPopr, :TYPE_TRUD, :SM_REC_ITOG, :UCH, --    A_P_SMETA, :RES_PRICE_COUNT
                :full_struct_name, :IDFORMULS/*CQ[9359]*/, K_ITOGO/*14460*/, :K_PR /*15421*/
       do
       begin

          -- MK 9.09.2010 CQ[8691] --->
          --       Crystall
          --      
          if (abs(atype) in (3, 4, 5)) then
          begin
            if (full_struct_name is null) then
              full_struct_name = '';
            if (atype = 4) then
               full_struct_name = '    ' || full_struct_name;
            if (atype = 5) then
               full_struct_name = '    ' || '    ' || full_struct_name;
            name = copyvarchartoblob_1024(substring(full_struct_name from 1 for 1024)); --CQ[TIMUR 13931] name = copyvarchartoblob(full_struct_name);
            NAME_ID = gen_id(B_GEN_TEMP, 1) ;
            insert into B_TEMP_BLOB(ID, BLOB1) values (:NAME_ID, :NAME);
            select BLOB1 from B_TEMP_BLOB where ID = :NAME_ID into :NAME;
            delete from B_TEMP_BLOB where ID = :NAME_ID;
          end
          -- MK 9.09.2010 CQ[8691] <---


          NBA = 0;
          NBB = 0;
          NBC = 0;
          NBD = 0;
          NBE = 0;
          NBF = 0;
          NBG = 0;
          NBH = 0;
          NBI = 0;
          NBJ = 0;

          if ( ( not IDNORMATIV is null ) and ( IDNORMATIV <> 0 ) ) then
          begin
             if ( kodir_podgroup > 1 ) then
             begin
                select first 1 a.cena from b_abc_okp a where id = :idnormativ into :nba;
                if ( rabmat = 1 ) then
                   nbe = nba;
                else if ( rabmat = 2 ) then
                   nbe = nbc;
                else if ( rabmat = 3 ) then
                   nbe = nbb;
             end
             else if ( rabmat = 1 ) then
                select first 1 t.cena, t.cena from b_trud t where id = :idnormativ into :nba, :nbe;
             else
             begin
                if ( rabmat = 3 ) then
                   select first 1 bb, bb
                   from b_rabmat r where id = :idnormativ
                   into nbb, nba;
                else
                   select first 1 ba, bb, bc, bd, be,  bf, bg, bh, bi
                   from b_rabmat r where id = :idnormativ
                   into nba, nbb, nbc, nbd, nbe,  nbf, nbg, nbh, nbi;

             end

             if (nba is null) then nba = 0;
             if (nbb is null) then nbb = 0;
             if (nbc is null) then nbc = 0;
             if (nbd is null) then nbd = 0;
             if (nbe is null) then nbe = 0;
             if (nbf is null) then nbf = 0;
             if (nbg is null) then nbg = 0;
             if (nbh is null) then nbh = 0;
             if (nbi is null) then nbi = 0;

          end

          suspend;
       end
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_S_APPENDREC_NL (
    IDUSER INTEGER,
    ID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME_ID INTEGER,
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    ID_S_RES INTEGER,
    VRPZ INTEGER,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    TIPRAB INTEGER,
    PUNKTIND VARCHAR(42),
    NORM_GUID VARCHAR(100),
    VIDRAB INTEGER,
    APPLAY_INDEX_AS_IS INTEGER,
    APPLAY_FORMULS_AS_IS INTEGER,
    APPLAY_POPR_AS_IS INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    COPY_RES_ID INTEGER,
    NOMERROD INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    RES_DOB_V_CENU INTEGER,
    REPLACE INTEGER,
    IDFORMULS INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    K_ITOGO VARCHAR(50),
    B_PR DOUBLE PRECISION,
    K_PR VARCHAR(50))
RETURNS (
    OUT_IDFORMULS INTEGER,
    OUT_ID INTEGER,
    OUT_SMETATYPE INTEGER)
AS
declare variable id_cur integer;
declare variable atype_cur integer;
declare variable cur_id_tr integer;
declare variable cur_koll_parent double precision;
declare variable pr_added_rec integer;
declare variable pr_number1 integer;
declare variable pr_number2 integer;
declare variable added_res integer;
declare variable index_id_org integer;
declare variable index_id_god integer;
declare variable index_id_mes integer;
declare variable index_nasnachauto integer;
declare variable index_zamennasnach integer;
--[10217]declare variable index_raschnrisp integer;
--[10217]declare variable index_brat_zu_is integer;
declare variable index_uchitnds integer;
declare variable res_copy_index integer;
declare variable res_copy_formuls integer;
declare variable res_copy_popr integer;
declare variable res_norm_id integer;
declare variable res_norm_podgroup integer;
declare variable res_kodir_group integer;
declare variable res_kodir_podgroup integer;
declare variable res_isgroupokp integer;
declare variable res_rabmat integer;
declare variable res_tab varchar(42);
declare variable res_alttab varchar(250);
declare variable res_name_id integer;
declare variable res_idedizm integer;
declare variable res_edizm_type integer;
declare variable res_rashod double precision;
declare variable res_bb double precision;
declare variable res_bc double precision;
declare variable res_bd double precision;
declare variable res_be double precision;
declare variable res_vidnr integer;
declare variable res_uch integer;
declare variable res_status_edit integer;
declare variable res_status_dob_v_zenu integer;
declare variable res_status_rec_cen integer;
declare variable res_note varchar(255);
declare variable res_nomerrod integer;
declare variable res_id_res integer;
declare variable res_norm_guid varchar(100);
declare variable res_rashod_base double precision;
declare variable res_correct varchar(50);
declare variable res_type_trud integer;
declare variable source_param_kodir_group integer;
declare variable source_param_kodir_podgroup integer;
declare variable s_orderview integer;
declare variable s_skip_append_vip integer;
declare variable wildcard_used integer;
declare variable dob_uch integer;
declare variable dob_neuch integer;
declare variable isclc integer;
declare variable res_recall integer;
declare variable tmp_pa double precision;
declare variable tmp_pb double precision;
declare variable tmp_pc double precision;
declare variable tmp_pd double precision;
declare variable tmp_mf double precision;
declare variable tmp_mg double precision;
declare variable tmp_mh double precision;
declare variable tmp_mi double precision;
declare variable src_id integer;
declare variable dst_id integer;
declare variable id_price integer;
declare variable row integer;
declare variable price_normoid integer;
declare variable cost double precision;
declare variable koef double precision; --CQ[7790]
declare variable MODE_KOMPNS_ST integer;
--[12113]declare variable APPLY_TO_ALL_LEVELS integer;
declare variable UCHIT_NDS integer;
declare variable IDLEVEL integer;
declare variable BASE_CALC_INFO integer;
declare APPLY_TO_ALL_IDLEVEL integer; --<<[12113]

declare variable CLCMODE_RES integer; -- CQ[13312]
-- MK CQ[14357] --->
declare variable VN_RENUM_SLAVE_AS_MAIN integer;
declare variable VN_ID integer;
-- MK CQ[14357] <---
begin
-- ,   

--[15352]+

  /*  --CQ[TIMUR 9296]
       A_SMETA      ,
     Bx (  ).
          ,    
       ,      .
    !!!          ,
        .          

    A_S_GET_NRSPZU_INDEX_NL
    A_S_GET_FORMUL_NRSPZU_NL
    A_S_GET_FORMUL_NRSPZU_NL_1
  */


  -- MK 26.12.2014
  IDNORMATIV = coalesce(IDNORMATIV, 0);
  IDNORMATIVUNIQ = coalesce(IDNORMATIVUNIQ, 0);


  WILDCARD_USED = 1;
  OUT_IDFORMULS = :IDFORMULS;--CQ[9359]

  /*      */
  if (:NOMERROD is null) then
    NOMERROD = 0;
  else
  if (:NOMERROD = -1) then
  begin
    S_SKIP_APPEND_VIP = -1;
    NOMERROD = 0;
  end

  if ( idhier <> iduser ) then
  begin
    id_cur = 0;
 
    select h.number
      from a_o_hier h
    where h.number = :idhier
    into :id_cur;
 
    if (id_cur <= 0) then
      exception A_H_MODIFY_DATA;
  end

  if ( atype = 17 ) then
  begin
    slaveparent = 0;
    --NORMARASH = null;
  end

  if (slaveparent <> 0) then
  begin
   id_cur = 0;
 
   select s.id, s.atype, s.NUMBER1
     from a_smeta s
   where (s.id = :slaveparent) and
         (s.idhier = :idhier) and
         (s.smetatype = :smetatype)
   into :id_cur, :atype_cur, :NUMBER1;

   if ( (id_cur = 0) or ((atype = 18) and (not atype_cur in (17, 18))) ) then
     exception A_H_MODIFY_DATA;
  end

  /*   , :
        (  ),
         
         - .  */
  select NUMBER1, NUMBER2
    from S_GET_NEW_NUMBERS(
      :IDUSER, :SLAVEPARENT, :IDHIER, :SMETATYPE, :ATYPE, :NUMBER1, :NUMBER2,
      :NOMERROD)
    into :NUMBER1, :NUMBER2;

  if (coalesce(REPLACE, 0) <> 1 ) then --CQ[8078] -  coalesce
    execute procedure A_S_RENUM_BEFORE_INSERT(:idhier,
                                              :smetatype,
                                              :atype,
                                              :number1,
                                              :number2,
                                              :number3,
                                              1,
                                              :insert_to_atype,
                                              :id,
                                              :insert_to_id);

  /*
   insert into s_temp(IDGEN, ID, n1, n2)
          values( :idhier, :smetatype, :atype, :number1);
   insert into s_temp(IDGEN, ID, n1, n2)
          values( :number2, :number3, :insert_to_atype, :id);
   insert into s_temp(IDGEN)
          values( :insert_to_id );
  */

  if ( vrpz is null ) then
    vrpz = 0;

  -- MK CQ[13982]  --->
  /* --CQ[TIMUR 9296]    */
  if ( applay_index_as_is <> 1 ) then
  begin
    ma = 1;
    mb = 1;
    mc = 1;
    md = 1;
    me = 1;
    mf = 0;
    mg = 0;
    mh = 1;
    mi = 1;
  end
  else
  begin
    if ((ma is null) or (ma = 0)) then ma = 1;
    if ((mb is null) or (mb = 0)) then mb = 1;
    if ((mc is null) or (mc = 0)) then mc = 1;
    if ((md is null) or (md = 0)) then md = 1;
    if ((me is null) or (me = 0)) then me = 1;
    if (mf is null) then mf = 0;
    if (mg is null) then mg = 0;
    if ((mh is null) or (mh = 0)) then mh = 1;
    if ((mi is null) or (mi = 0)) then mi = 1;
  end
  -- MK CQ[13982]  <---
/*
  if (pa is null) then pa = 0;
  if ( pb is null) then pb = 0;
  if (( pc is null) or (pc = 0)) then pc = 1;
  if (( pd is null) or (pd = 0)) then pd = 1;
  */ --CQ[TIMUR 9296]

  -- MK 19.07.2012   CQ[10642] --->
  --   ,  
  if (pa is null) then pa = 0;
  if ( pb is null) then pb = 0;
  if (( pc is null) or (pc = 0)) then pc = 1;
  if (( pd is null) or (pd = 0)) then pd = 1;
  -- MK 19.07.2012   CQ[10642] <---

  if (ATYPE in (17, 18)) then
  begin
    select ID_TR, RES_COPY_FORMULS, RES_COPY_POPR, INDEX_ID_ORG, INDEX_ID_GOD,
           INDEX_ID_MES, INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH,
           --[10217]INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS,
           INDEX_UCHITNDS, RES_COPY_INDEX, KODIR_GROUP, KODIR_PODGROUP,
           coalesce (MODE_KOMPNS_ST, 0), --CQ[10892]
           null --[12578] APPLY_TO_ALL_IDLEVEL --<<[12133]
   --from A_S_GET_PARAMS_OBJ(:iduser, :idhier)
    from A_GET_PARAMS_OBJ_AKT(:IDUSER, :IDHIER, :SMETATYPE)
    into :CUR_ID_TR, :RES_COPY_FORMULS, :RES_COPY_POPR, :INDEX_ID_ORG, :INDEX_ID_GOD,
         :INDEX_ID_MES, :INDEX_NASNACHAUTO, :INDEX_ZAMENNASNACH,
         --[10217]:INDEX_RASCHNRISP, :INDEX_BRAT_ZU_IS,
         :INDEX_UCHITNDS, :RES_COPY_INDEX, :RES_KODIR_GROUP, :RES_KODIR_PODGROUP,
         :MODE_KOMPNS_ST, --CQ[10892]
         :APPLY_TO_ALL_IDLEVEL; --<<[12133]
 
    /*CQ[9291]
    if (APPLAY_INDEX_AS_IS <> 1) then
    begin
       select i.res_ma, i.res_mb, i.res_mc, i.res_md, i.res_me, i.res_mf, i.res_mg, i.res_mh, i.res_mi, i.res_pa,
               i.res_pb, i.res_pc, i.res_pd, i.res_punktind
        from a_s_get_index ( :iduser,
                             :id,
                             :slaveparent,
                             :atype,
                             :index_id_org,
                             :index_id_god,
                             :index_id_mes,
                             :index_nasnachauto,
                             :index_zamennasnach,
                             :index_raschnrisp,
                             :index_brat_zu_is,
                             :index_uchitnds,
                             :res_copy_index,
                             :ma,
                             :mb,
                             :mc,
                             :md,
                             :me,
                             :mf,
                             :mg,
                             :mh,
                             :mi,
                             :pa,
                             :pb,
                             :pc,
                             :pd,
                             :punktind,
                             0,
                             :WILDCARD_USED ) i
        into :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :pa, :pb, :pc, :pd, :punktind;
   end
   */
 
    if (APPLAY_FORMULS_AS_IS <> 1) then
    begin
     /*CQ[9359]
     select f.res_vrpz,
            f.res_sea, f.res_seb, f.res_sec, f.res_sed, f.res_see, f.res_sef, f.res_seg, f.res_seh,
            f.res_sei, f.res_sej, f.res_sek,
            f.res_sra, f.res_srb, f.res_src, f.res_srd, f.res_sre, f.res_srf, f.res_srg, f.res_srh,
            f.res_sri, f.res_srj, f.res_srk, f.res_srl, f.res_srm,
            f.res_pa, f.res_pb, f.res_pc, f.res_pd,
            f.res_mf, f.res_mg, f.res_mh, f.res_mi, f.res_tiprab, f.res_vidrab
        from a_s_get_formuls ( :IDUSER,
                               :ATYPE,
                               :SLAVEPARENT,
                               :cur_id_tr,
                               :VRPZ,
                               :INDEX_RASCHNRISP,
                               :INDEX_BRAT_ZU_IS,
                               :RES_COPY_FORMULS,
                               :PA,
                               :PB,
                               :PC,
                               :PD,
                               :MF,
                               :MG,
                               :MH,
                               :MI ) f
        into :vrpz,
             :sea, :seb, :sec, :sed, :see, :sef, :seg, :seh,
             :sei, :sej, :sek,
             :sra, :srb, :src, :srd, :sre, :srf, :srg, :srh,
             :sri, :srj, :srk, :srl, :srm,
             :pa, :pb, :pc, :pd, :mf, :mg, :mh, :mi, :tiprab, :vidrab;  */
      --CQ[9359]>>

      -- MK 19.07.2012   CQ[10642] --->
      --     ,    
      select RES_VRPZ, RES_IDFORMULS, RES_TIPRAB, RES_VIDRAB
        from A_S_GET_FORMULS_DM(:IDUSER, :ATYPE, :SLAVEPARENT, :CUR_ID_TR, :VRPZ, :RES_COPY_FORMULS, :TIPRAB)
        into :VRPZ, :OUT_IDFORMULS, :TIPRAB, :VIDRAB;

      --select RES_VRPZ, RES_IDFORMULS, RES_TIPRAB, RES_VIDRAB
      --  from A_DM_GET_FORMULS(:IDUSER, :ATYPE, :SLAVEPARENT, :CUR_ID_TR, :VRPZ, :RES_COPY_FORMULS)
      --  into :VRPZ, :OUT_IDFORMULS, :TIPRAB, :VIDRAB;
      -- MK 19.07.2012   CQ[10642] <---
    end
  end

  if ( (ATYPE = 18) and (NORMARASH > 0) ) then
  begin
    CUR_KOLL_PARENT = 0;
  
    select KOLL
    from a_smeta
    where ID = :SLAVEPARENT
    into :CUR_KOLL_PARENT;

    --<<>>[12901] KOLL = :CUR_KOLL_PARENT * :NORMARASH;
    if ( (coalesce(:CUR_KOLL_PARENT,0) = 0 )
      or ( LROUNDN(coalesce(:KOLL,0)/:CUR_KOLL_PARENT,6/*ciRangeNormRash*/) <>
           LROUNDN(coalesce(:NORMARASH,0),6/*ciRangeNormRash*/) )
       ) then
      --<<>>[13292]KOLL = :CUR_KOLL_PARENT * :NORMARASH;
      KOLL = LROUNDN(:CUR_KOLL_PARENT * :NORMARASH, 6/*ciRangeNormRash*/);
  end

  PR_ADDED_REC = 0;
  if (not SMETATYPE in (15, 16) and /*semenov*/:NOMERROD = 0) then
    PR_ADDED_REC = 1;

  /*  --CQ[TIMUR 9296]
  if (PD is null) then PD = 0;
  if (PC is null) then PC = 0;
  if (PB is null) then PB = 0;
  if (PA is null) then PA = 0;

  select BA, BB, BC, BD, BE, BF, BG, BH, BI,
         EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
         RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
         PA, PB, PC, PD, ,
         MA, MB, MC, MD, ME, MF, MG, MH, MI
  from L_S_APPENDREC_VALIDATE_PARAMS (
        :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, 0,
        :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
        :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
        :PA, :PB, :PC, :PD, 0,
        :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, 0, 0, 0)
  into BA, BB, BC, BD, BE, BF, BG, BH, BI,
       EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
       RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
       PA, PB, PC, PD,
       MA, MB, MC, MD, ME, MF, MG, MH, MI;
  */

  BA = coalesce(BA, 0.0);
  BB = coalesce(BB, 0.0);
  BC = coalesce(BC, 0.0);
  BD = coalesce(BD, 0.0);
  BE = coalesce(BE, 0.0);
  BF = coalesce(BF, 0.0);
  BG = coalesce(BG, 0.0);
  BH = coalesce(BH, 0.0);
  BI = coalesce(BI, 0.0);
  --CQ[TIMUR 9296]

  insert into A_SMETA (
          ID, IDHIER, SMETATYPE, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT,
          ATYPE, RABMAT, /*[6921]*/TYPE_TRUD, TAB, ALTTAB,
          NAME_ID, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
          BA, BB, BC, BD, BE, BF, BG, BH, BI,
          /*  --CQ[TIMUR 9296]
          EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
          RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
          PA, PB, PC, PD,
          */
          IDTIPR, KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM, PUNKTIND,

          -- MK CQ[13982] 
          MA, MB, MC, MD, ME, MF, MG, MH, MI, --CQ[TIMUR 9296] 

          SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH,
          OKONCH, TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP,
          KODIR_PODGROUP, ISGROUPOKP, ID_S_RES, VRPZ, PR_ADDED_REC,
          NORM_GUID, VIDRAB , NOMERROD, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
          IDFORMULS, --CQ[9359]
          BN, BO, B_ITOGO/*CQ[13179]*/, K_ITOGO/*14460*/,
          B_PR /*[15352]*/, K_PR /*15421*/
          )
  values (:ID, :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT,
          :ATYPE, :RABMAT, /*[6921]*/:TYPE_TRUD, :TAB, :ALTTAB,
          :NAME_ID, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
          :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
          /* --CQ[TIMUR 9296]
          :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
          :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
          :PA, :PB, :PC, :PD,
          */
          :IDTIPR, :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK,  :KL, :KM, :PUNKTIND, 

          -- MK CQ[13982] 
          :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, --CQ[TIMUR 9296] 

          :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH,
          :OKONCH, :TIPRAB, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP,
          :KODIR_PODGROUP, :ISGROUPOKP, :ID_S_RES, :VRPZ, :PR_ADDED_REC,
          :NORM_GUID, :VIDRAB, :NOMERROD, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE,
          :OUT_IDFORMULS, --CQ[9359]
          :BN, :BO, :B_ITOGO/*CQ[13179]*/, :K_ITOGO/*14460*/,
          :B_PR /*[15352]*/, :K_PR /*15421*/
          );


  -- MK CQ[12020] --->
  --     "    "
  -- (CQ[14357])       
  --    
  execute procedure m_set_view_nums_after_ins(:ID, :IDHIER, :SMETATYPE,
                                              :ATYPE, :SLAVEPARENT,
                                              :NUMBER1, :NUMBER2, :NUMBER3);
  -- MK CQ[12020] <---



  --CQ[10892]-->
  --[12113]APPLY_TO_ALL_LEVELS = GETBIT(:MODE_KOMPNS_ST, 12/*mksApplyToAllLevels*/);
  UCHIT_NDS = GETBIT(:MODE_KOMPNS_ST, 13/*mksWidhNDS*/);
  for select IDCENLVL, coalesce(BASE_CALC_INFO, 0) from A_SMETA_CENLVL where ID = :ID
  into :IDLEVEL, :BASE_CALC_INFO  do
  begin
    if (:UCHIT_NDS = 0) then
      BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 3/*bciUseNDS*/, 1);
    else
      BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 3/*bciUseNDS*/, 0);

    --<<>>[12113]if (:APPLY_TO_ALL_LEVELS = 0) then
    if (:IDLEVEL = :APPLY_TO_ALL_IDLEVEL) then
      BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 4/*bciApplyToAllLevels*/, 1);
    else
      BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 4/*bciApplyToAllLevels*/, 0);

    update A_SMETA_CENLVL set BASE_CALC_INFO = :BASE_CALC_INFO
    where ID = :ID and IDCENLVL = :IDLEVEL;
  end
  --CQ[10892]<--


  /*      */
  select IDFORMULS, CORRECTNODE, CORRECTNODE_1   /* MK 9.01.2007 CQ[4367] */
  from A_SMETA
  where id = :id
  into :OUT_IDFORMULS, :CORRECTNODE, :CORRECTNODE_1; /* MK 9.01.2007 CQ[4367] */


  if ( (not SLAVEPARENT is null) and (SLAVEPARENT > 0) and (ATYPE = 18) and (ID_S_RES is null) ) then
  begin
 
   /* select p.kodir_group, p.kodir_podgroup
        from a_s_get_params_obj( :iduser, :idhier )  p
      into :res_kodir_group, :res_kodir_podgroup; */
 
   if ( (COPY_RES_ID is null) or
        (not exists(select * from A_S_RES where ID = :COPY_RES_ID)) )
   then
   begin
     -- exception le_bad_zone  cast(bb as varchar(255));
 
     execute procedure A_S_RES_SLAVETORES(:IDUSER,
                                          :ID,
                                          :RES_KODIR_GROUP,
                                          :RES_KODIR_PODGROUP,
                                          :IDNORMATIV,
                                          :KODIR_PODGROUP,
                                          :RABMAT,
                                          :IDNORMATIV,
                                          1)
     returning_values (:ADDED_RES);
 
   end
   else
   begin
 
     SOURCE_PARAM_KODIR_GROUP = 1;
     SOURCE_PARAM_KODIR_PODGROUP = 1;
  
     select KODIR_GROUP, KODIR_PODGROUP, ISCLC
       --from A_S_GET_PARAMS_OBJ(:IDUSER, :IDHIER)
       from A_GET_PARAMS_OBJ_AKT(:IDUSER, :IDHIER, :SMETATYPE)
     into :SOURCE_PARAM_KODIR_GROUP, :SOURCE_PARAM_KODIR_PODGROUP, :ISCLC;
  
     --cq[4276]-->
     if (RES_DOB_V_CENU is null) then
     begin
       execute procedure A_S_RES_GET_DEF_ST_DOB_V_CENU3 (:ISCLC, :CLCMODE, :BA, :BB, :BC, :BD, :BE)
       returning_values :DOB_UCH, :DOB_NEUCH, :RES_RECALL;
     end
     else
     begin
       DOB_UCH = :RES_DOB_V_CENU;
       DOB_NEUCH = :RES_DOB_V_CENU;
     end
     --<
  
     select R.NORM_ID, R.NORM_PODGROUP, R.KODIR_GROUP, R.KODIR_PODGROUP,
            R.ISGROUPOKP, R.RABMAT, R.TYPE_TRUD,
            R.TAB, R.ALTTAB, R.NAME_ID, R.IDEDIZM, R.EDIZM_TYPE,
            R.RASHOD, R.RASHOD_BASE, R.CORRECT, R.BB, R.BC, R.BD, R.BE,
            R.VIDNR, R.UCH, R.STATUS_EDIT, /*R.STATUS_DOB_V_ZENU*/case when R.UCH <> 0 then :DOB_UCH else :DOB_NEUCH end,
            R.STATUS_REC_CEN, R.NOTE, R.NORM_GUID, -- , R.ID_PRICE   CQ[6884] 
            R.CLCMODE -- CQ[13312]
     from A_S_RES R
     where R.ID = :COPY_RES_ID
     into :RES_NORM_ID, :RES_NORM_PODGROUP, :RES_KODIR_GROUP, :RES_KODIR_PODGROUP,
          :RES_ISGROUPOKP, :RES_RABMAT, :RES_TYPE_TRUD,
          :RES_TAB, :RES_ALTTAB, :RES_NAME_ID, :RES_IDEDIZM, :RES_EDIZM_TYPE,
          :RES_RASHOD, :RES_RASHOD_BASE, :RES_CORRECT, :RES_BB, :RES_BC, :RES_BD, :RES_BE,
          :RES_VIDNR, :RES_UCH, :RES_STATUS_EDIT, :RES_STATUS_DOB_V_ZENU,
          :RES_STATUS_REC_CEN, :RES_NOTE, :RES_NORM_GUID, --, :ID_PRICE; CQ[6884] 
          :CLCMODE_RES; -- CQ[13312]
  
     RES_ID_RES = gen_id(A_G_SMETA, 1);
  
     /* RES_NOMERROD      */
     if (:NOMERROD <> 0) then
       select ID_S_RES
         from A_SMETA
         where ID = :NOMERROD
         into :RES_NOMERROD;
     /*  - RES_NOMERROD = null */
 
     insert into A_S_RES(
            ID, ID_SOURCE, NORM_ID, NORM_PODGROUP,
            KODIR_GROUP, KODIR_PODGROUP,
            ISGROUPOKP, RABMAT,
            TAB, ALTTAB, NAME_ID, IDEDIZM, EDIZM_TYPE,
            RASHOD, RASHOD_BASE, CORRECT, BB, BC, BD, BE, VIDNR, UCH,
            STATUS_EDIT, STATUS_DOB_V_ZENU, STATUS_REC_CEN, NOTE,
            NOMERROD, SMETATYPE, NORM_GUID, IDHIER
            /*<rvs:00000086> - added*/, TYPE_TRUD, /*</rvs:00000086>*//*CQ[6884], ID_PRICE*/
            CLCMODE -- CQ[13312]
            )
     values(:RES_ID_RES, :SLAVEPARENT, :RES_NORM_ID, :RES_NORM_PODGROUP,
            :SOURCE_PARAM_KODIR_GROUP, :SOURCE_PARAM_KODIR_PODGROUP,
            /*:RES_KODIR_GROUP :RES_KODIR_PODGROUP*/
            :RES_ISGROUPOKP, :RES_RABMAT, :RES_TAB, :RES_ALTTAB, :RES_NAME_ID, :RES_IDEDIZM, :RES_EDIZM_TYPE,
            :RES_RASHOD, :RES_RASHOD_BASE, :RES_CORRECT, :RES_BB, :RES_BC, :RES_BD, :RES_BE, :RES_VIDNR, :RES_UCH,
            :RES_STATUS_EDIT, :RES_STATUS_DOB_V_ZENU, :RES_STATUS_REC_CEN, :RES_NOTE,
            :RES_NOMERROD, :SMETATYPE, :RES_NORM_GUID, :IDHIER
            /*<rvs:00000086> - added*/, :RES_TYPE_TRUD, /*</rvs:00000086>*//*CQ[6884], :ID_PRICE*/
            :CLCMODE_RES -- CQ[13312]
            );
  
     --CQ[6884]          
  
     for select IDPRICE, IDNORMO, ROW, COST, KOEF
       from SMETA_PRICEPOS_INFO
       where ID = :COPY_RES_ID
     into :ID_PRICE, :PRICE_NORMOID, :ROW, :COST, :KOEF
     do
     begin
       execute procedure SET_SMETA_PRICEPOSINFO(:RES_ID_RES , :ID_PRICE, :PRICE_NORMOID, :ROW, :COST, :KOEF);
     end
 
     update A_SMETA S
     set S.ID_S_RES = :RES_ID_RES
     where S.ID = :ID;
 
   end
  end

  if ( not SMETATYPE in (15, 16) and /*semenov*/:NOMERROD = 0) then /* lck */
  begin
    if ( atype = 17 ) then
    begin
      execute procedure L_PR_GET_MAX_NUMBER1(:IDHIER, :IDUSER)
      returning_values(:PR_NUMBER1);

      insert into L_S_PR_ADDINFO(ID, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3)
      values(:ID, :PR_NUMBER1, :NUMBER2, :NUMBER3);
    end
    else
    begin
      execute procedure L_PR_GET_NUMBER_1_2(:SLAVEPARENT/*:ID*/, :IDHIER, :IDUSER)
      returning_values(:PR_NUMBER1, :PR_NUMBER2);
   
      -- MK 9.03.2011 CQ[9136] --->
      if (:PR_NUMBER1 is null) then
      begin
        select NUMBER1 from A_SMETA
        where (ID = :SLAVEPARENT)
        into :PR_NUMBER1;
      end
      -- MK 9.03.2011 CQ[9136] <---
   
      insert into L_S_PR_ADDINFO(ID, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3)
      values(:ID, :PR_NUMBER1, :PR_NUMBER2, :NUMBER3);
    end
  end                                                 /* lck */

  OUT_ID = :ID;
  OUT_SMETATYPE = :SMETATYPE;

  suspend;




  /*      */
  if (:NOMERROD = 0 and :S_SKIP_APPEND_VIP is null and
      :SMETATYPE <> 16 and :ATYPE in (17, 18)) then
  begin
    select NUMBER from A_GET_ID_OBJ_AKT(:IDHIER, :SMETATYPE) into :SRC_ID;

    NOMERROD = :ID; /*    */
    /*  ID     (  ) */

    /*  ,   */
    select ORDERVIEW
      from SD_IMPACT_SELECTSTRUCT_GETFIRST(:IDUSER, :ID, :SMETATYPE)
      into :S_ORDERVIEW;

    if (:S_ORDERVIEW > 0) then
    begin
      /*  NOMERROD */
      if (:ATYPE = 18) then
      begin
        /*      
              NOMERROD  
                   */
        ID = null;
        select /*ID*/NOMERROD1
          from A_SMETA
          where ID = :SLAVEPARENT
          into :ID;
        /*       */
        if (ID_S_RES is not null) then
        begin
          COPY_RES_ID = :ID_S_RES;
          RES_DOB_V_CENU = null; --    cq[4276]
          ID_S_RES = null;
        end
      end
      else
        SLAVEPARENT = 0; /*    */


      for select i.SMETATYPE
        from SD_IMPACT_SELECTSTRUCT(:IDUSER, :ID) i
        where (i.ORDERVIEW >= :S_ORDERVIEW)
        into :OUT_SMETATYPE
      do
      if (not exists( /* , */
            select * from M_UTV_STRUCT_ELEM_IN_AKT
              where ID_STRUCT = :IDHIER and ID_AKT = :OUT_SMETATYPE)) then
      begin

        OUT_ID = gen_id(A_G_SMETA, 1);

        if (:ATYPE = 18) then
        begin
          /*     */
          SLAVEPARENT = null;
          select ID
            from A_SMETA
            where NOMERROD = :ID
              and SMETATYPE = :OUT_SMETATYPE
             into :SLAVEPARENT;
          /* (!):    :SLAVEPARENT   */
        end

        /* (!):       -   A_S_APPENDREC */


        -- MK 1.04.2009 CQ[8336] --->
        if ((:SLAVEPARENT is not null) and (:src_id <> :OUT_SMETATYPE)) then
        --if (:SLAVEPARENT is not null) then
        -- MK 1.04.2009 CQ[8336] <---
        begin

--          select number from A_GET_ID_OBJ_AKT(:IDHIER, :OUT_SMETATYPE) into :DST_ID;
          DST_ID = :OUT_SMETATYPE;

--          exception d_wrong_params :src_id || '  '  || :dst_id;

          /* --CQ[TIMUR 9296] -    ,   ...
          select pa, pb, pc, pd, mf, mg, mh, mi
          from swap_nrsp_and_zu(:src_id, :DST_ID, :pa, :pb, :pc, :pd, :mf, :mg, :mh, :mi)
          into :tmp_pa, :tmp_pb, :tmp_pc, :tmp_pd, :tmp_mf, :tmp_mg, :tmp_mh, :tmp_mi;
          */

          for select
            OUT_ID, OUT_SMETATYPE,
            OUT_IDFORMULS
            from A_S_APPENDREC_NL(
            :IDUSER, :OUT_ID, :IDHIER, :OUT_SMETATYPE,
            :NUMBER1, :NUMBER2, :NUMBER3,
            :SLAVEPARENT, :ATYPE,
            :RABMAT, /*[6921]*/:TYPE_TRUD, :TAB, :ALTTAB, :NAME_ID, :ID_EDIZM, :EDIZM_TYPE,
            0.0/*:KOLL*/, null/*:SKOLL*/, :NORMARASH,
            :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
            :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
            :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
            :IDTIPR,
            :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK,  :KL, :KM,
            :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH,
            :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP,
            null/*:INSERT_TO_ATYPE*/, null/*:INSERT_TO_ID*/, null/*:ID_S_RES*/, :VRPZ,
            :TMP_PA, :TMP_PB, :TMP_PC, :TMP_PD,
            :TIPRAB, :PUNKTIND, :NORM_GUID, :VIDRAB,
            :APPLAY_INDEX_AS_IS, :APPLAY_FORMULS_AS_IS, :APPLAY_POPR_AS_IS,
            :MA, :MB, :MC, :MD, :ME, :TMP_MF, :TMP_MG, :TMP_MH, :TMP_MI,
            :COPY_RES_ID, :NOMERROD, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE,
            :CLCMODE, /*:res_status_dob_v_zenu*/:RES_DOB_V_CENU, :REPLACE, :OUT_IDFORMULS,
            :BN, :BO, :B_ITOGO/*CQ[13179]*/, :K_ITOGO/*14460*/,
            :B_PR /*[15352]*/, :K_PR /*15421*/
            )
            into
            :OUT_ID, :OUT_SMETATYPE,
            :OUT_IDFORMULS
          do
          suspend;
        end
      end
    end
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_S_DELETERECS (
    IDUSER INTEGER,
    COUNTREC INTEGER,
    IDRECS BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SMETATYPE INTEGER,
    APPLY_POPR_MODE INTEGER)
RETURNS (
    IDHIER DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    UTV_FAILCOUNT INTEGER)
AS
declare variable I integer;
declare variable IDREC integer;
declare variable CUR_RA double precision;
declare variable CUR_RB double precision;
declare variable CUR_RC double precision;
declare variable CUR_RD double precision;
declare variable CUR_RE double precision;
declare variable CUR_RF double precision;
declare variable CUR_RG double precision;
declare variable CUR_RH double precision;
declare variable CUR_RI double precision;
declare variable CUR_RJ double precision;
declare variable CUR_RK double precision;
declare variable CUR_RL double precision;
declare variable CUR_RM double precision;
declare variable CUR_IDHIER double precision;
declare variable CUR_ATYPE double precision;
declare variable CUR_TAB varchar(42);
declare variable CUR_TYPE_TRUD integer;
declare variable ID_NAME integer;
declare variable CUR_UCH integer;

--declare variable res_pz double precision;
--declare variable res_zp_mash double precision;
--declare variable res_bb double precision;
--declare variable res_bc double precision;
--declare variable res_bd double precision;
--declare variable res_be double precision;
--declare variable res_rashod double precision;
--declare variable res_rabmat integer;
--declare variable res_uch integer;

declare variable cur_id_s_res integer;
declare variable cur_slaveparent integer;

--declare variable mode_kompns_st integer;
-->DEN--25/11/04
declare variable utv integer;

declare variable NOZONEMODE integer;
declare variable cur_smetatype integer;
declare variable cur_rabmat integer;
declare variable ZONE_BA double precision;
declare variable ZONE_BB double precision;
declare variable ZONE_BC double precision;
declare variable ZONE_BD double precision;
declare variable ZONE_BE double precision;
declare variable ISZONEFIND integer;
declare variable IDNORMATIV integer;
declare variable NORMPODGROUP integer;
--<--DEN
--declare variable res_type_trud integer;

  declare variable KA varchar(50);
  declare variable KB varchar(50);
  declare variable KC varchar(50);
  declare variable KD varchar(50);
  declare variable KE varchar(50);
  declare variable KF varchar(50);
  declare variable KG varchar(50);
  declare variable KH varchar(50);
  declare variable KI varchar(50);
  declare variable KJ varchar(50);
  declare variable KK varchar(50);
  declare variable KL varchar(50);
  declare variable KM varchar(50);
  declare variable K_ITOGO varchar(50);
  declare variable K_PR varchar(50);
  declare variable CORRECT varchar(50);

  declare variable ID_SM_REC_CH_TRUD integer;
  declare variable ID_SL_REC_CH_NR_AND_KOLL integer;

  declare variable NEED_CONVERT_POPR integer;
  declare variable COPY_RES_POPR integer;
  declare variable CALC_MODE integer;
  declare variable CUR_CLCMODE integer;
  declare variable OLD_APPLY_POPR_MODE integer;
  declare variable CUR_RASHOD_BASE double precision;
  declare variable RES_CORRECT varchar(50);

-- MK CQ[12020]
declare variable VN_AUTORENUM_ENABLED integer;
declare variable VN_AUTORENUM_MODE integer;
declare variable VN_AUTORENUM_START integer;
declare variable VN_AUTORENUM_STEP integer;
declare variable VN_NEED_SKIP_EMPTY integer;
declare variable VN_IDOBJECT integer;
declare variable VN_IDGEN integer;
-- MK CQ[14357]
declare variable VN_RENUM_SLAVE_AS_MAIN integer;
declare variable VN_ALLOW_EDIT_SPEC_REC integer;
begin
--[15352]

 UTV_FAILCOUNT=0;

 id_name = gen_id(b_gen_temp, 1) ;
 insert into b_temp_blob(id, blob1) values (:id_name, :idrecs);
 select blob1 from b_temp_blob where id = :id_name into :idrecs;
 delete from b_temp_blob where id = :id_name ;

 i = 0;

 idhier = -1;


 for select first 1 FVALUE
     from S_INTFROMBLOB_SELECT(:IDRECS, :COUNTREC)
     into :idrec
 do
 begin

  if ( idrec > 0 )
  then select first 1 s.idhier--, s.smetatype  -- MK   CQ[12020] 
       from a_smeta s
       where s.id = :idrec
       into :cur_idhier;--, :cur_smetatype;  -- MK   CQ[12020] 
  else cur_idhier = - idrec;


-- MK   CQ[12020]  --->
--  2  MODE_KOMPNS_ST   LEVEL_VC -> APPLY_ON_RES
--  --DEN-->21/3/5
--  execute procedure d_get_nozonemode(:cur_idhier, :cur_smetatype)
--  returning_values :NOZONEMODE;
--  --<
-- MK   CQ[12020]  <---

  /* -    
  select mode_kompns_st
  from a_get_params_obj_akt( :iduser, :cur_idhier, :smetatype )
  into :mode_kompns_st;

  mode_kompns_st = getbit( mode_kompns_st, 0 );
  */

 end

 -- MK CQ[12020] --->
 execute procedure s_o_hier_parent_oftype(:cur_idhier, 1)
 returning_values :VN_IDOBJECT;

 --     
 execute procedure M_GET_AUTORENUM_PARAM(:VN_IDOBJECT, :SMETATYPE)
 returning_values :VN_AUTORENUM_ENABLED, :VN_AUTORENUM_MODE, :VN_AUTORENUM_START,
                  :VN_AUTORENUM_STEP, :VN_NEED_SKIP_EMPTY,
                  :VN_RENUM_SLAVE_AS_MAIN; -- MK CQ[14357]

 --   
 if (VN_AUTORENUM_ENABLED = 1) then
 begin
   --   
   VN_IDGEN = gen_id(S_TEMP_GEN_ID, 1);
 end
 -- MK CQ[12020] <---


/* while (i < :countrec) do */
 for select FVALUE
 from S_INTFROMBLOB_SELECT(:IDRECS, :COUNTREC)
 into :idrec do
 begin

/*  idrec = readintfromblob(:idrecs, :i); */

-- CQ: 2675
  CUR_RA = 0;
  CUR_RB = 0;
  CUR_RC = 0;
  CUR_RD = 0;
  CUR_RE = 0;
  CUR_RF = 0;
  CUR_RG = 0;
  CUR_RH = 0;
  CUR_RI = 0;
  CUR_RJ = 0;
  CUR_RK = 0;
  CUR_RL = 0;
  CUR_RM = 0;
-- CQ: 2675

  if ( idrec >= 0 )
  then
  begin

   select s.atype, s.idhier,
     s.RA,
     s.RB,
     s.RC,
     s.RD,
     s.RE,
     s.RF,
     s.RG,
     s.RH,
     s.RI,
     s.RJ,
     s.RK,
     s.RL,
     s.RM,
     s.id_s_res, s.slaveparent, s.utv, s.rabmat, /*[6921]*/s.TYPE_TRUD
   from a_smeta s
   where s.id = :idrec
   into :cur_atype, :cur_idhier,
     :CUR_RA,
     :CUR_RB,
     :CUR_RC,
     :CUR_RD,
     :CUR_RE,
     :CUR_RF,
     :CUR_RG,
     :CUR_RH,
     :CUR_RI,
     :CUR_RJ,
     :CUR_RK,
     :CUR_RL,
     :CUR_RM,
     :cur_id_s_res, :cur_slaveparent,
     :utv, :cur_rabmat, /*[6921]*/:CUR_TYPE_TRUD;

   execute procedure ALLOW_EDIT_SPEC_REC(:IDREC, :IDUSER)
   returning_values :VN_ALLOW_EDIT_SPEC_REC;

   if (
       ( cur_atype = 17 )
       --and exists( select * from a_smeta s where s.slaveparent = :idrec and s.atype = 18 ) <<   2 ?
      )
   then
   begin
    select :CUR_RA + coalesce(sum(s.RA), 0),
           :CUR_RB + coalesce(sum(s.RB), 0),
           :CUR_RC + coalesce(sum(s.RC), 0),
           :CUR_RD + coalesce(sum(s.RD), 0),
           :CUR_RE + coalesce(sum(s.RE), 0),
           :CUR_RF + coalesce(sum(s.RF), 0),
           :CUR_RG + coalesce(sum(s.RG), 0),
           :CUR_RH + coalesce(sum(s.RH), 0),
           :CUR_RI + coalesce(sum(s.RI), 0),
           :CUR_RJ + coalesce(sum(s.RJ), 0),
           :CUR_RK + coalesce(sum(s.RK), 0),
           :CUR_RL + coalesce(sum(s.RL), 0),
           :CUR_RM + coalesce(sum(s.RM), 0)
    from a_smeta s
    where ( s.slaveparent = :idrec and s.atype = 18 )
    into :CUR_RA,
         :CUR_RB,
         :CUR_RC,
         :CUR_RD,
         :CUR_RE,
         :CUR_RF,
         :CUR_RG,
         :CUR_RH,
         :CUR_RI,
         :CUR_RJ,
         :CUR_RK,
         :CUR_RL,
         :CUR_RM;
   end


-- MK   CQ[12020]  --->
--  NOZONEMODE   ,       . 
--   --DEN-->22/3/5
--   if ((NOZONEMODE=1) and (cur_rabmat<>0) and (cur_atype = 18)) then
--   begin
--
--     idnormativ = null;
--     select first 1 r.norm_id, r.norm_podgroup, r.rabmat
--     from a_s_res r
--     where r.id = :cur_id_s_res
--     into :idnormativ, :normpodgroup, :cur_rabmat;
--     if ((not idnormativ is null) and (cur_rabmat<>0)) then
--     begin
--
--       execute procedure L_FILL_CCURRENT1(:IDNORMATIV, :cur_rabmat, :normpodgroup, -3, :iduser)
--       returning_values :ZONE_BA, :ZONE_BB, :ZONE_BC, :ZONE_BD, :ZONE_BE, :ISZONEFIND;
--       if (ISZONEFIND=1) then
--       begin
--         update a_s_res r set
--           r.bb = :ZONE_BB,
--           r.bc = :ZONE_BC,
--           r.bd = :ZONE_BD,
--           r.be = :ZONE_BE
--         where r.id = :cur_id_s_res;
--       end
--     end
--   end
--   --<
-- MK   CQ[12020]  <---

   if ((utv=0) and (VN_ALLOW_EDIT_SPEC_REC = 1)) then
   begin
     delete from a_smeta s where s.id = :idrec;
-->DEN cq[4009]
     if (cur_atype = 18) then
     begin

       select s.CLCMODE from A_SMETA s where s.ID = :cur_slaveparent into :CUR_CLCMODE;
       if (CUR_CLCMODE is null) then
         CUR_CLCMODE = 0;

       OLD_APPLY_POPR_MODE = :APPLY_POPR_MODE;

       if ((not APPLY_POPR_MODE is null) and (getbit(:CUR_CLCMODE, 1) <> 0)) then
         APPLY_POPR_MODE = setbit(:APPLY_POPR_MODE, 3, 1);

       execute procedure D_DECODE_APPLY_POPR_MODE(:APPLY_POPR_MODE)
         returning_values :COPY_RES_POPR, :CALC_MODE;

       select first 1 r.UCH, r.RASHOD_BASE, r.CORRECT
       from a_s_res r
       where r.id = :cur_id_s_res
       into :CUR_UCH, :CUR_RASHOD_BASE, :RES_CORRECT;

       if ((CUR_UCH <> 0) and (CALC_MODE = 1)) then
       begin
         update A_S_RES r set
           r.RASHOD = -r.RASHOD_BASE,
           r.RASHOD_BASE = -r.RASHOD_BASE,
           r.CORRECT = ''
         where r.ID = :cur_id_s_res
           and r.RASHOD_BASE < 0;
         NEED_CONVERT_POPR = 1;
       end
       else
       begin
         execute procedure D_NEED_CONVERT_POPR(:APPLY_POPR_MODE, :CUR_UCH)
           returning_values :NEED_CONVERT_POPR;
       end

       if (NEED_CONVERT_POPR <> 0) then
       begin
         select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM, K_ITOGO/*14460*/, K_PR/*15421*/
         from A_SMETA where ID = :cur_slaveparent
         into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :K_ITOGO/*14460*/, :K_PR/*15421*/;

         select /*[6921] r.TYPE_TRUD,*/ r.TAB, r.UCH
         from A_S_RES r
         where ID = :CUR_ID_S_RES
         into /*[6921] :CUR_TYPE_TRUD,*/ :CUR_TAB, :CUR_UCH;

         if (CUR_RABMAT = 1) then
           CUR_TYPE_TRUD = coalesce(nullif(:CUR_TYPE_TRUD, 0), case when :CUR_TAB starting '2' then 2 else 1 end);

         if (RES_CORRECT is null) then
           RES_CORRECT = '';

         if (((CUR_UCH <> 0) and (CALC_MODE = 1)) or (RES_CORRECT = ''))  then
         begin
           select CORRECT
           from D_GET_POPR_VALUE(:KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :K_ITOGO/*14460*/, :K_PR/*15421*/, :CUR_RABMAT, :CUR_TYPE_TRUD, 0)
           into :CORRECT;
           execute procedure A_S_RES_APPLAY_CORRECTION (:IDUSER, 0, null, :CUR_ID_S_RES, :CUR_RABMAT, :CUR_TYPE_TRUD, '', :CORRECT, 1, :APPLY_POPR_MODE)
           returning_values :ID_SM_REC_CH_TRUD, :ID_SL_REC_CH_NR_AND_KOLL;
         end
       end
       APPLY_POPR_MODE = :OLD_APPLY_POPR_MODE;
     end
-- update a_s_res r set r.CORRECT = '' where r.ID = :id_res;
--<

   end
   else
     UTV_FAILCOUNT=UTV_FAILCOUNT+1;

   /* mode_kompns_st -    
   if (
       ( cur_atype = 18 ) and
       ( mode_kompns_st = 1 )
      )
   then
   begin

    for select first 1 r.bb, r.bc, r.bd, r.be, r.rashod, r.rabmat, r.uch, r.type_trud
        from a_s_res r
        where r.id = :cur_id_s_res
        into :res_bb, :res_bc, :res_bd, :res_be, :res_rashod, :res_rabmat, :res_uch, :res_type_trud
    do
    begin

     if ( res_uch = 1 )
     then
     begin

      res_pz = ( res_bb + res_bc + res_be ) * res_rashod;
      res_zp_mash = res_bd * res_rashod;


      if ( res_type_trud <> 2)
      then execute procedure a_s_kompens_rec( :iduser,
                                              :cur_slaveparent,
                                              :res_rabmat,
                                              0,
                                              res_pz,
                                              0,
                                              res_zp_mash );

     end

    end

   end
   */

  end
  else
  begin
   select coalesce(sum(s.RA), 0),
          coalesce(sum(s.RB), 0),
          coalesce(sum(s.RC), 0),
          coalesce(sum(s.RD), 0),
          coalesce(sum(s.RE), 0),
          coalesce(sum(s.RF), 0),
          coalesce(sum(s.RG), 0),
          coalesce(sum(s.RH), 0),
          coalesce(sum(s.RI), 0),
          coalesce(sum(s.RJ), 0),
          coalesce(sum(s.RK), 0),
          coalesce(sum(s.RL), 0),
          coalesce(sum(s.RM), 0)
   from a_smeta s
   where s.smetatype = :smetatype and s.idhier = -:idrec and s.utv=0
   into :CUR_RA,
        :CUR_RB,
        :CUR_RC,
        :CUR_RD,
        :CUR_RE,
        :CUR_RF,
        :CUR_RG,
        :CUR_RH,
        :CUR_RI,
        :CUR_RJ,
        :CUR_RK,
        :CUR_RL,
        :CUR_RM;

   -->--DEN--25/11/04-- -  
   for select s.UTV from a_smeta s
   where s.smetatype = :smetatype and s.idhier = -:idrec and s.utv<>0
   into :utv
   do
   begin
     UTV_FAILCOUNT=UTV_FAILCOUNT+1;
   end
   --<--DEN

   delete from a_smeta s where s.smetatype = :smetatype and s.idhier = -:idrec
     -->--DEN--25/11/04
     and s.utv=0;
     --<--DEN

   cur_idhier = -idrec;

  end

  if ( cur_idhier <> idhier) then
  begin
    if ( idhier <> -1 ) then
    begin
      suspend;

      -- MK CQ[12020] --->
      --  
      if ((VN_AUTORENUM_ENABLED = 1) and (:VN_AUTORENUM_MODE <> 2)) then
      begin
        execute procedure M_FILL_HIER_RENUM(:VN_AUTORENUM_MODE, :idhier, :VN_IDGEN);
      end
      -- MK CQ[12020] <---
    end

    RA = 0;
    RB = 0;
    RC = 0;
    RD = 0;
    RE = 0;
    RF = 0;
    RG = 0;
    RH = 0;
    RI = 0;
    RJ = 0;
    RK = 0;
    RL = 0;
    RM = 0;

    idhier = cur_idhier;
  end

  RA = :RA + coalesce(:CUR_RA, 0);
  RB = :RB + coalesce(:CUR_RB, 0);
  RC = :RC + coalesce(:CUR_RC, 0);
  RD = :RD + coalesce(:CUR_RD, 0);
  RE = :RE + coalesce(:CUR_RE, 0);
  RF = :RF + coalesce(:CUR_RF, 0);
  RG = :RG + coalesce(:CUR_RG, 0);
  RH = :RH + coalesce(:CUR_RH, 0);
  RI = :RI + coalesce(:CUR_RI, 0);
  RJ = :RJ + coalesce(:CUR_RJ, 0);
  RK = :RK + coalesce(:CUR_RK, 0);
  RL = :RL + coalesce(:CUR_RL, 0);
  RM = :RM + coalesce(:CUR_RM, 0);

/*  i = i + 1; */
 
 end

 suspend;

 -- MK CQ[12020] --->
 --  
 if (VN_AUTORENUM_ENABLED = 1) then
 begin
   if (:VN_AUTORENUM_MODE <> 2) then
     execute procedure M_FILL_HIER_RENUM(:VN_AUTORENUM_MODE, :idhier, :VN_IDGEN);

   --  
   if (VN_AUTORENUM_MODE = 2) then
   begin
     execute procedure MS_SMETA_RENUMBER(:VN_IDOBJECT, :SMETATYPE, :VN_AUTORENUM_MODE,
                                         0, null, :VN_NEED_SKIP_EMPTY,
                                         :VN_AUTORENUM_START, :VN_AUTORENUM_STEP,
                                         :VN_RENUM_SLAVE_AS_MAIN); -- MK CQ[14357]
   end
   else
   begin
     for select t.id
     from s_temp t
     where (t.idgen = :VN_IDGEN)
     into :cur_idhier do
     begin
       execute procedure MS_SMETA_RENUMBER(:cur_idhier, :SMETATYPE, :VN_AUTORENUM_MODE,
                                           1, null, :VN_NEED_SKIP_EMPTY,
                                           :VN_AUTORENUM_START, :VN_AUTORENUM_STEP,
                                           :VN_RENUM_SLAVE_AS_MAIN); -- MK CQ[14357]
     end

     --   
     delete from S_TEMP where IDGEN = :VN_IDGEN;
   end
 end
 -- MK CQ[12020] <---
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_S_GET_INDEX_NL (
    ID_LEVEL INTEGER,
    ID_USER INTEGER,
    ATYPE INTEGER,
    IN_PUNKTIND VARCHAR(42),
    ID_LEVEL_INDEX INTEGER,
    ID_SM_REC INTEGER)
RETURNS (
    IDINDEX INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    PUNKTIND VARCHAR(42),
    SPOSOB_RASCH INTEGER,
    RES_INDEX INTEGER)
AS
 /*$$IBE$$ declare variable VN_RES integer;
declare variable VN_MAIN_SM_REC integer;
declare variable VN_IS_USED_INDEX integer;

declare TAB varchar(42);
declare RABMAT integer;
declare TYPE_TRUD integer;
declare TIPRAB integer;

declare I_MA double precision;
declare I_MB double precision;
declare I_MC double precision;
declare I_MD double precision;
declare I_ME double precision;
declare I_MF double precision;
declare I_MG double precision;
declare I_SPOSOBRASCH integer;
declare OLD_LEVEL_INDEX integer; $$IBE$$*/ 
begin
--[15352] - 

--CQ[10929] :   A_S_GET_INDEX_NL_NEW



/*$$IBE$$ 
-- [10502]    7.10 - A_S_GET_INDEX_NL_OLD
--    
-- RES_INDEX . A_SMETA_INDLVL.INDEX_INFO

  RES_INDEX = -2 $$IBE$$*/ /*ciNotFound*/ /*$$IBE$$ ;
  --      (  )
  if (:ATYPE in (17, 18)) then
  begin
    select first 1 TAB, RABMAT, TYPE_TRUD, TIPRAB
      from A_SMETA
      where ID=:ID_SM_REC
      into TAB, RABMAT, TYPE_TRUD, TIPRAB;

    --      (LEVEL_COMPOSE)
    if (:ID_LEVEL_INDEX is not null) then
    begin
      --         
      select first 1 S.PUNKTIND, S.ID_LEVEL_INDEX
        from A_SMETA_INDLVL S
        where (S.ID = :ID_SM_REC)
          and (S.IDCENLVL = :ID_LEVEL)
        into :PUNKTIND, :OLD_LEVEL_INDEX;

      --           (  PUNKTIND)
      if ((:PUNKTIND is null) or (:PUNKTIND = '')) then
        VN_IS_USED_INDEX = 0;
      else
        VN_IS_USED_INDEX = 1;

      --     
      execute procedure NL_CHECK_INDEX(:ID_USER,
          :ID_LEVEL_INDEX, :ATYPE, :IN_PUNKTIND,
          :VN_IS_USED_INDEX, :OLD_LEVEL_INDEX)
          returning_values (:VN_RES);
    end
    else
      VN_RES = -2 $$IBE$$*/ /*ciNotFound*/ /*$$IBE$$ ; --<<[10703]

    --         
    select first 1 S.MA, S.MB, S.MC, S.MD, S.ME, S.MF, S.MG, S.MH, S.MI,
                   S.MJ, S.MK, S.ML, S.MM, --CQ[10529]
                   S.DA, S.DB, S.DC, S.DD, S.DE, S.DJ, S.DK, S.DL, S.DM, --CQ[10529]
                   S.INDEX_SPOSOBRASCH, S.IDINDEX, S.PUNKTIND, S.ID_LEVEL_INDEX
      --CQ[10529]from A_SMETA_CENLVL S1
      from A_SMETA_INDLVL S --CQ[10529]
      where (S.ID = :ID_SM_REC)
        and (S.IDCENLVL = :ID_LEVEL)
        and ((:VN_RES = 0) or (S.INDEX_INFO in (3 $$IBE$$*/ /*ciDirect*/ /*$$IBE$$ ))) --<<[10703]
      into :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
           :MJ, :MK, :ML, :MM, --CQ[10529]
           :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM, --CQ[10529]
           :SPOSOB_RASCH, :IDINDEX, :PUNKTIND, :OLD_LEVEL_INDEX;

    begin
      if (:VN_RES = 1 $$IBE$$*/ /*ciFromMain*/ /*$$IBE$$ ) then
      --     
      begin
        --      
        select first 1 S.SLAVEPARENT
          from A_SMETA S
          where (S.ID = :ID_SM_REC)
          into :VN_MAIN_SM_REC;

        --     
        select first 1 S.MA, S.MB, S.MC, S.MD,
                       S.ME, S.MF, S.MG, S.MH,
                       S.MI, S.INDEX_SPOSOBRASCH,
                       S.IDINDEX, S.PUNKTIND,
                       S.MJ, S.MK, S.ML, S.MM, --CQ[10529]
                       S.DA, S.DB, S.DC, S.DD, S.DE, S.DJ, S.DK, S.DL, S.DM --CQ[10529]
          --CQ[10529]from A_SMETA_CENLVL S_
          from A_SMETA_INDLVL S --CQ[10529]
          where (S.ID = :VN_MAIN_SM_REC) and
                (S.IDCENLVL = :ID_LEVEL)
          into :MA, :MB, :MC, :MD, :ME, :MF, :MG,
               :MH, :MI, :SPOSOB_RASCH, :IDINDEX,
               :PUNKTIND,
               :MJ, :MK, :ML, :MM, --CQ[10529]
               :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM; --CQ[10529]
      end

      else
      if (:VN_RES = 4 $$IBE$$*/ /*ciFromItog*/ /*$$IBE$$ ) then
      --     
      begin
         $$IBE$$*/ /*CQ[10529]
        for select first 1 MA, MB, MC, MD, ME, MF, MG, SPOSOBRASCH
          from LEVEL_INDEX_ITOG
          where ID_COMPOSE = :ID_LEVEL_INDEX
          into :I_MA, :I_MB, :I_MC, :I_MD, :I_ME, :I_MF, :I_MG, :I_SPOSOBRASCH
        do
        begin
          execute procedure A_S_APPLY_INDEX_FROM_ITOG(
              :I_MA, :I_MB, :I_MC, :I_MD, :I_ME, :I_MF, :I_MG, :I_SPOSOBRASCH,
              :TAB, :RABMAT, :TYPE_TRUD, :TIPRAB)
            returning_values
              :MA, :MB, :MC, :MD, :ME, :SPOSOB_RASCH;
          IDINDEX = null;
          MF = null; --    - . ...
          MG = null;
          MH = null;
          MI = null;
        end
        */ /*$$IBE$$ 
        select first 1 MA, MB, MC, MD, ME, MJ, SPOSOBRASCH,
               MK, ML, MM, DA, DB, DJ, DK, DL, DM
          from LEVEL_INDEX_ITOG
          where ID_COMPOSE = :ID_LEVEL_INDEX
          into :MA, :MB, :MC, :MD, :ME, :MJ, :SPOSOB_RASCH,
               :MK, :ML, :MM, :DA, :DB, :DJ, :DK, :DL, :DM;

        MF = null; --    - . ...
        MG = null;
        MH = null;
        MI = null;
      end

      else
      if (:VN_RES = 5 $$IBE$$*/ /*ciFromSbTCH*/ /*$$IBE$$ ) then --CQ[10519]    LEVEL_INDEX
      begin
        select first 1 I.MA, I.MB, I.MJ, I.MK, I.DA, I.DB, I.DJ, I.DK, i.sposob_rasch
          from LEVEL_INDEX I
          where (I.ID_COMPOSE = :ID_LEVEL_INDEX)
          into :MA, :MB,:MJ, :MK, :DA, :DB, :DJ, :DK, :SPOSOB_RASCH;
      end

      else
      if (:VN_RES > 5 $$IBE$$*/ /*ciLastBeforeSbID*/ /*$$IBE$$ ) then
      --     (VN_RES    b_ind)
      begin
        PUNKTIND = IN_PUNKTIND;

        --    
        select first 1 I.ID_MONTH,
                       I.SPOSOB_RASCH,
                       I.MJ, I.MK, I.DA, I.DB, I.DJ, I.DK
          from LEVEL_INDEX I
          where (I.ID_COMPOSE = :ID_LEVEL_INDEX)
          into :IDINDEX, :SPOSOB_RASCH,
               :MJ, :MK, :DA, :DB, :DJ, :DK; --CQ[10529]

        --    
        select I.BA, I.BB, I.BC, I.BD, I.BE,
               I.PA, I.PB,
               I.ZBA, I.ZBB,
               I.BE, I.BC --CQ[10529]
          from B_IND I
          where (I.ID = :VN_RES)
          into :MA, :MB, :MC, :MD, :ME,
               :MF, :MG,
               :MH, :MI,
               :ML, :MM; --CQ[10529]

        --      MI ( .)
        -- (. A_S_GET_INDEX   12.01.2005)
        if (:ATYPE = 18) then
        begin
          --      
          select first 1 S.SLAVEPARENT
            from A_SMETA S
            where (S.ID = :ID_SM_REC)
            into :VN_MAIN_SM_REC;

          MI = null;

          select first 1 MI from A_SMETA_INDLVL --CQ[10529]A_SMETA_CENLVL
            where (ID = :VN_MAIN_SM_REC)
              and (IDCENLVL = :ID_LEVEL)
            into :MI;
        end
      end

      RES_INDEX = VN_RES;
      if (RES_INDEX > 5 $$IBE$$*/ /*ciLastBeforeSbID*/ /*$$IBE$$ ) then
        RES_INDEX = 2 $$IBE$$*/ /*ciFromSbInd*/ /*$$IBE$$ ;
    end

    if ((SPOSOB_RASCH is null) or (SPOSOB_RASCH = 0)) then
      SPOSOB_RASCH = 2 $$IBE$$*/ /* */ /*$$IBE$$ ; --<<[10703]
    --    -   
    if ((MA is null) or (MA = 0)) then
      MA = 1;
    if ((MB is null) or (MB = 0)) then
      MB = 1;
    if ((MC is null) or (MC = 0)) then
      MC = 1;
    if ((MD is null) or (MD = 0)) then
      MD = 1;
    if ((ME is null) or (ME = 0)) then
      ME = 1;
    if (MF is null) then
      MF = 0;
    if (MG is null) then
      MG = 0;
    if ((MH is null) or (MH = 0)) then
      MH = 1;
    if ((MI is null) or (MI = 0)) then
      MI = 1;
    --CQ[10529]-->
    if ((MJ is null) or (MJ = 0)) then
      MJ = 1;
    if ((MK is null) or (MK = 0)) then
      MK = 1;
    if ((ML is null) or (ML = 0)) then
      ML = 1;
    if ((MM is null) or (MM = 0)) then
      MM = 1;
    if ((DA is null) or (DA = 0)) then
      DA = 1;
    if ((DB is null) or (DB = 0)) then
      DB = 1;
    if ((DC is null) or (DC = 0)) then
      DC = 1;
    if ((DD is null) or (DD = 0)) then
      DD = 1;
    if ((DE is null) or (DE = 0)) then
      DE = 1;
    if ((DJ is null) or (DJ = 0)) then
      DJ = 1;
    if ((DK is null) or (DK = 0)) then
      DK = 1;
    if ((DL is null) or (DL = 0)) then
      DL = 1;
    if ((DM is null) or (DM = 0)) then
      DM = 1;
    --CQ[10529]<--
  end
  --suspend;
 $$IBE$$*/ SUSPEND;
end
^


--[15352]
/* 
CREATE OR ALTER PROCEDURE A_S_GET_INDEX_NL_NEW (
*/
--[15352]
CREATE OR ALTER PROCEDURE A_S_GET_NRSPZU_INDEX_NL_1 (
    ID_USER INTEGER,
    ID_SM_REC INTEGER,
    IN_PUNKTIND VARCHAR(42),
    IN_SLAVEPARENT INTEGER,
    IDCENLVL INTEGER,
    MODE INTEGER)
RETURNS (
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION)
AS
declare variable VN_TYPE_RAB integer;
declare variable VN_VID_RAB integer;
declare variable VN_ATYPE integer;
declare variable VN_RABMAT integer;
declare variable VN_IDHIER integer;
declare variable VN_IDNORMATIV integer;
declare variable VN_PODGROUP integer;
declare variable VN_IDREESTR integer;

declare variable ID_LEVEL_VC integer;
declare variable ID_LEVEL_INDEX integer;

declare variable VN_SMETATYPE integer;
declare variable VN_IDOBJECT integer;
declare variable VN_RES_COPY_INDEX integer;

declare variable IdLevelIndex_MainStr integer;
declare variable vn_res_copy_formuls integer;

declare variable VN_MF double precision;
declare variable VN_MG double precision;
declare variable VN_MH double precision;
declare variable VN_MI double precision;

declare DUMMY_INT integer;
declare DUMMY_DBL double precision;
declare DUMMY_V42 varchar(42);

--<[14593]>
declare INDEX_DX_ONLY integer;
declare IDCLASS integer; --</>
begin
--[15352]

  ------------------------------------------------------------------------------
  -- MODE -    / :
  -- 0 - A_S_RES_TO_SLAVEREC_NL
  --     (   Ctrl+Enter )
  -- 1 - A_S_RES_TO_SLAVEREC_NL
  --     (    )
  -- 2 - NL_CTRL_ENTER_SMREC
  --     (Ctrl+Enter   )
  -- 3 - DM_ADD_LEVEL_IN_SMETA_ONE_COPY
  --     (    ,  )
  --
  -- IN_SLAVEPARENT -    -    
  --                -    -    
  --                         
  --                  (.   A_S_RES_TO_SLAVEREC_NL)
  ------------------------------------------------------------------------------


  --  , ,   
  MF = 0; MG = 0; MH = 1; MI = 1;
  VN_RES_COPY_INDEX = 0;
  ID_LEVEL_INDEX = null;
  IN_SLAVEPARENT = coalesce(IN_SLAVEPARENT, 0);


  --     
  select first 1 s.tiprab, s.vidrab, s.atype, s.rabmat, s.idhier, s.idnormativ,
                 s.kodir_podgroup, s.smetatype
  from a_smeta s
  where (s.id = :ID_SM_REC)
  into :VN_TYPE_RAB, :VN_VID_RAB, :VN_ATYPE, :VN_RABMAT, :VN_IDHIER, :VN_IDNORMATIV,
       :VN_PODGROUP, :VN_SMETATYPE;

  if (not (:VN_ATYPE in (17, 18))) then
    exit;

  --  
  execute procedure A_H_GET_ID_PARENTATYPE(:VN_IDHIER, 1)
  returning_values (:VN_IDOBJECT);

  IDCLASS = case when :VN_SMETATYPE > 999 then :VN_SMETATYPE else :VN_IDOBJECT end; --[14593]

  --    
  execute procedure L_S_SELECT_ID_REEST (:ID_USER, :VN_IDNORMATIV, :VN_RABMAT, :VN_PODGROUP)
  returning_values (:VN_IDREESTR);

  --   NL_GET_CENLVL_NEW
  --   ,      
  if ((VN_ATYPE = 18) or (IN_SLAVEPARENT > 0))  then
  begin
    IdLevelIndex_MainStr = null;

    --       Compose 
    select first 1 i.id_level_index
    from A_SMETA_INDLVL i
    where (i.id = :IN_SLAVEPARENT) and (i.idcenlvl = :IDCENLVL)
    into :IdLevelIndex_MainStr;

    if (IdLevelIndex_MainStr is not null) then
    begin
      select li.res_copy_index
      from LEVEL_INDEX li
      where (li.id_compose = :IdLevelIndex_MainStr)
      into :VN_RES_COPY_INDEX;

      if (:VN_RES_COPY_INDEX <> 0) then
        ID_LEVEL_INDEX = IdLevelIndex_MainStr;
    end
  end

  --       ""   :
  --    
  --       "...    "
  --             ""
  if (coalesce(ID_LEVEL_INDEX, 0) = 0) then
  begin
    --      
    execute procedure NL_FIND_COMPOSE_EX (
        :IDCENLVL,
        :IDCLASS, --[14593]
        :ID_USER, :VN_IDREESTR, :VN_TYPE_RAB, :VN_VID_RAB, :VN_ATYPE, :VN_RABMAT,
        :VN_IDHIER, :IN_PUNKTIND, :VN_IDNORMATIV, :VN_PODGROUP)
    returning_values (:ID_LEVEL_VC, :ID_LEVEL_INDEX, :INDEX_DX_ONLY); --[14593]

    --[14593] -   ,    
    if (:INDEX_DX_ONLY <> 0) then
      ID_LEVEL_INDEX = null;
  
    --      
    -- "       "
    if ((:ID_LEVEL_INDEX is not null) and ((VN_ATYPE = 18) or (IN_SLAVEPARENT > 0))) then
    begin
      select first 1 i.res_copy_index
      from level_index i
      where (i.id_compose = :ID_LEVEL_INDEX)
      into :VN_RES_COPY_INDEX;
    end
  end

  --    , , 
  ------------------------------------------------------------------------------
  --        :
  --  , ,       
  if ((VN_ATYPE = 18) or (IN_SLAVEPARENT > 0)) then
  begin
    select first 1 i.mf, i.mg, i.mh, i.mi
    from a_smeta_indlvl i
    where (i.id = :IN_SLAVEPARENT) and (i.idcenlvl = :IDCENLVL)
    into :VN_MF, :VN_MG, :VN_MH, :VN_MI;
  end

  --         
  --  "...    " = 
  --  , ,    
  if (((VN_ATYPE = 18) or (IN_SLAVEPARENT > 0)) and (VN_RES_COPY_INDEX <> 0)) then
  begin
    MF = VN_MF;
    MG = VN_MG;
    MH = VN_MH;
    MI = VN_MI;
  end

  --    
  --     "...    " = 
  else
  begin
    if (coalesce(ID_LEVEL_INDEX, 0) > 0) then --    
    begin
      --  , ,      ""   
      execute procedure A_S_GET_INDEX_NL_NEW(
            :IDCENLVL, :ID_USER, :VN_ATYPE,
            :IN_PUNKTIND, :ID_LEVEL_INDEX, :ID_SM_REC, 1)
      returning_values
            :DUMMY_INT, :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL,
            :MF, :MG, :MH, :MI,
            :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL,
            :DUMMY_DBL, --[15352]
            :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL,
            :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL, :DUMMY_DBL,
            :DUMMY_V42, :DUMMY_INT, :DUMMY_INT;
    end

    --      :
    --        
    --      7 -------------------------------
    if ((VN_ATYPE = 18) or (IN_SLAVEPARENT > 0)) then
    begin
      -- .     
      MI = VN_MI;

      --     / 
      -- "       "
      if (VN_SMETATYPE = 15) then
      begin
        select first 1 o.res_copy_formuls
        from a_o_objectparams o
        where (o.number = :VN_IDOBJECT)
        into :vn_res_copy_formuls;
      end
      else
      begin
        select first 1 f.res_copy_formuls
        from a_o_factparams f
        where (f.number = :VN_IDOBJECT)
        into :vn_res_copy_formuls;
      end

      --     (  ),  
      --   
      -- "       "
      --     
      if ((MODE in (0, 1, 3)) and (vn_res_copy_formuls <> 0)) then
        MH = VN_MH;
    end
  end

  suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_S_GET_POPR (
    ATYPE INTEGER,
    SLAVEPARENT INTEGER,
    RES_COPY_POPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    KN VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
RETURNS (
    RES_KA VARCHAR(50),
    RES_KB VARCHAR(50),
    RES_KC VARCHAR(50),
    RES_KD VARCHAR(50),
    RES_KE VARCHAR(50),
    RES_KF VARCHAR(50),
    RES_KG VARCHAR(50),
    RES_KH VARCHAR(50),
    RES_KI VARCHAR(50),
    RES_KJ VARCHAR(50),
    RES_KK VARCHAR(50),
    RES_KL VARCHAR(50),
    RES_KM VARCHAR(50),
    RES_KN VARCHAR(50),
    RES_K_ITOGO VARCHAR(50),
    RES_K_PR VARCHAR(50))
AS
begin
--[15352]+
  RES_KA = KA;
  RES_KB = KB;
  RES_KC = KC;
  RES_KD = KD;
  RES_KE = KE;
  RES_KF = KF;
  RES_KG = KG;
  RES_KH = KH;
  RES_KI = KI;
  RES_KJ = KJ;
  RES_KK = KK;
  RES_KL = KL;
  RES_KM = KM;
  RES_K_ITOGO = K_ITOGO; /*14460*/
  RES_K_PR = K_PR; /*15421*/

  if ( RES_COPY_POPR > 0 and
       ATYPE = 18 and
       SLAVEPARENT > 0 )
  then
    select KA, KB, KC, KD, KE, KF, KG, KH,
           KI, KJ, KK, KL, KM, K_ITOGO/*14460*/, K_PR/*15421*/
    from A_SMETA
    where ID = :SLAVEPARENT
    into :RES_KA, :RES_KB, :RES_KC, :RES_KD, :RES_KE, :RES_KF, :RES_KG, :RES_KH,
         :RES_KI, :RES_KJ, :RES_KK, :RES_KL, :RES_KM, :RES_K_ITOGO /*14460*/, :RES_K_PR /*15421*/;

  suspend;
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE A_S_HIER_SELECT (
*/
--[15352]
/* 
CREATE OR ALTER PROCEDURE A_S_PARAMS_TO_SMETA_NL_ONE (
*/
--[15352]
CREATE OR ALTER PROCEDURE A_S_PASTE_EXCEL_RECORD_NL (
    IDUSER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDZONE INTEGER,
    AGROUP INTEGER,
    APODGROUP INTEGER,
    ZAMEN INTEGER,
    INSERT_ALL INTEGER,
    INSERT_SLAVE INTEGER,
    RES_APPLY_TAB INTEGER,
    APPLY_POPR_MODE INTEGER,
    TAB VARCHAR(42),
    TAB_BLOB BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    EDIZM VARCHAR(100),
    IN_IDEDIZM INTEGER,
    BB DOUBLE PRECISION,
    CURR_BB DOUBLE PRECISION,
    KOLL DOUBLE PRECISION,
    NORMRASH DOUBLE PRECISION,
    VRPZ INTEGER,
    VALUTE_ID INTEGER,
    VALUTE_RATE DOUBLE PRECISION,
    VALUTE_DATE DATE)
RETURNS (
    ID INTEGER,
    ID_RES INTEGER,
    REJECTCOUNT INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
declare variable NEW_ID integer;
declare variable RABMAT integer;
declare variable IDNAME integer;
declare variable IDEDIZM integer;
declare variable IDTCH integer;
declare variable IDESN integer;
declare variable IDTCARD integer;
declare variable ID_UNIQUE integer;
declare variable PUNKTIND varchar(42);
declare variable SLAVEPARENT integer;
declare variable RES_ID integer;

declare variable IDOBJECT integer;
declare variable ID_LEVEL integer;

declare variable VN_IDSTRUCT integer;
declare variable BA double precision;
declare variable BC double precision;
declare variable BD double precision;
declare variable BE double precision;
declare variable BF double precision;
declare variable BG double precision;
declare variable BH double precision;
declare variable BI double precision;

declare variable IDEDIZMGROUP integer;
declare variable ID_BLOB_GEN integer;
declare variable IDNORMY integer;

declare variable MAIN_KOLL double precision;

declare variable VN_CALC_INFO integer;
declare variable VN_CURR_CENA_INFO integer;

declare variable BN double precision;
declare variable BO double precision;
declare variable B_ITOGO double precision;

declare B_PR double precision; --[15352]

-- MK CQ[14381]
declare variable VN_MAXDATE_IDLEVEL integer;
declare variable VN_APPLY_TO_ALL_IDLEVEL integer;
declare variable VN_BASE_CALC_INFO integer;
begin
--[15352]

  --    CQ[12362]   A_S_PASTE_MONITORING_RECORDS_NL

  BN = null;
  BO = null;
  B_ITOGO = null;

  BA = 0.0;
  BC = 0.0;
  BD = 0.0;
  BE = 0.0;
  BF = 0.0;
  BG = 0.0;
  BH = 0.0;
  BI = 0.0;
  RABMAT = 3;
  ID_UNIQUE = 0;
  IDNORMY = 0;
  IDTCH = 0;
  IDESN = 0;
  IDTCARD = 0;
  PUNKTIND = '';

  -- MK 9.04.2015
  if (coalesce(CURR_BB, 0) = 0) then
  begin
    VN_CALC_INFO = 4; -- cbDirect
    VN_CURR_CENA_INFO = 0; -- cciEmpty
  end
  else
  begin
    VN_CALC_INFO = 1; -- cbCalc
    VN_CURR_CENA_INFO = 2; -- cciMonitiring
  end

  execute procedure A_H_GET_ID_PARENTATYPE(:IDHIER, 1)
  returning_values (:IDOBJECT);

  if (SMETATYPE = 15) then
    VN_IDSTRUCT = IDOBJECT;
  else
    VN_IDSTRUCT = SMETATYPE;

  -- MK CQ[14381] --->
  --      
  execute procedure M_GET_MAX_DATE_LEVEL(:VN_IDSTRUCT)
  returning_values :VN_MAXDATE_IDLEVEL;

  --         "   ..."
  VN_APPLY_TO_ALL_IDLEVEL = 0;
  if (coalesce(CURR_BB, 0) <> 0) then --       
  begin
    if (:SMETATYPE > 15) then
      select coalesce(APPLY_TO_ALL_IDLEVEL, 0)
      from A_O_FACTPARAMS
      where NUMBER = :SMETATYPE
      into :VN_APPLY_TO_ALL_IDLEVEL;
    else
      select coalesce(APPLY_TO_ALL_IDLEVEL, 0)
      from A_O_OBJECTPARAMS
      where NUMBER = :IDOBJECT
      into :VN_APPLY_TO_ALL_IDLEVEL;
  end
  -- MK CQ[14381] <---

  REJECTCOUNT = 0;
  if (:NUMBER2 is null) then
    SLAVEPARENT = 0;
  else
  if (:INSERT_TO_ATYPE = 17) then
  begin
    SLAVEPARENT = :INSERT_TO_ID;

    select S.KOLL from A_SMETA S where ID = :INSERT_TO_ID into :MAIN_KOLL; -- Voyager CQ[12946]
  end
  else
  if (:INSERT_TO_ATYPE in (18, 19)) then
  begin
    select SLAVEPARENT
    from A_SMETA
    where ID = :INSERT_TO_ID
    into SLAVEPARENT;

    select S.KOLL from A_SMETA S where ID = :SLAVEPARENT into :MAIN_KOLL;  -- Voyager CQ[12946]
  end
  if (:SLAVEPARENT is null) then
  begin
    SLAVEPARENT = 0;
    NUMBER2 = null;
  end

  select max(NUMBER2) + 1
  from A_SMETA
  where IDHIER = :IDHIER and
        SMETATYPE = :SMETATYPE and
        NUMBER1 = :NUMBER1
  into :NUMBER2;

  ID_BLOB_GEN = gen_id(B_GEN_TEMP, 1);
  insert into B_TEMP_BLOB (ID, BLOB1)
  values (:ID_BLOB_GEN, :NAME);
  select BLOB1
  from B_TEMP_BLOB
  where ID = :ID_BLOB_GEN
  into :NAME;
  delete from B_TEMP_BLOB
  where ID = :ID_BLOB_GEN;
  execute procedure B_WRITE_NAIMENOVANIE(IDUSER, -1, null, NAME)
  returning_values :IDNAME, :NAME;

  IDEDIZM = coalesce(:IN_IDEDIZM, 0);
  if (:IDEDIZM = 0) then
  begin
    --  B_EDIZM
    execute procedure B_FIND_EDIZM(:IDUSER, :EDIZM, '')
    returning_values :IDEDIZM;
    if (IDEDIZM is null) then --   - 
    begin
      if (EDIZM <> '') then  --CQ[TIMUR 12919]
      begin
        --  "   "    - 
        execute procedure DM_ADD_EDIZMGROUP('   ')
        returning_values :IDEDIZMGROUP;

        execute procedure B_ADD_EDIZM(:IDUSER, :IDEDIZMGROUP, :EDIZM, :EDIZM, 1)
        returning_values :IDEDIZM;
      end
    end
  end

  NEW_ID = gen_id(A_G_SMETA, 1);
  for select OUT_ID, OUT_SMETATYPE, OUT_IDFORMULS
    from A_S_PASTE_RABMAT_RECORD(:IDUSER, :NEW_ID, :IDHIER, :SMETATYPE,  :NUMBER1, :NUMBER2,
      :SLAVEPARENT, :INSERT_TO_ATYPE, :INSERT_TO_ID, :IDNORMY, :RABMAT, :TAB, :ALTTAB,
      :IDNAME, :IDEDIZM, :IDTCH, :IDESN, :IDTCARD, :ID_UNIQUE, :VRPZ,
      :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :PUNKTIND, null, :APPLY_POPR_MODE, 0,
      :BN, :BO, :B_ITOGO,
      :B_PR) --[15352]
    into :ID, :OUT_SMETATYPE, :OUT_IDFORMULS
  do
  begin

    update A_SMETA set
      KOLL = case :OUT_SMETATYPE
               when :SMETATYPE then :KOLL
               else 0.0
             end,
      -- <-- Voyager CQ[12946]
      --NORMARASH = NORMRASH
      NORMARASH = case :SLAVEPARENT
               when 0 then 0.0
               else case :MAIN_KOLL when 0 then 0 else LROUNDN(:KOLL/:MAIN_KOLL,6) end
             end
      -- <-- Voyager CQ[12946]
    where ID = :ID;


    -- MK   CQ[14381]     
    for select L.ID
      from LEVEL_COST L
      where (L.IDOBJECT = :VN_IDSTRUCT)
      into :ID_LEVEL
    do
      execute procedure A_SMETA_COPY_CENLVL_AS_IS(:ID, :IDUSER, :ID_LEVEL);

    -- MK CQ[14381] --->
    --      
    if (coalesce(CURR_BB, 0) <> 0) then
    begin
      --         
      update A_SMETA_CENLVL
      set BASE_INFO = 2, -- csDirect
          BB = :BB,
          CURR_CENA = :CURR_BB,
          BASE_CALC_INFO = bin_or(bin_and(BASE_CALC_INFO, bin_xor(7, -1)), 1), -- 7 = 111 (cbCalcMask) 1 - cbCalc
          SOURCE_LEVEL_ID = case when (:VN_APPLY_TO_ALL_IDLEVEL = :VN_MAXDATE_IDLEVEL) then -1 else 0 end,
          CURR_CENA_INFO = 2, -- cciMonitiring
          ID_VALUTE = :VALUTE_ID,
          VALUTE_CURS = :VALUTE_RATE,
          VALUTE_DATE = :VALUTE_DATE

      where (ID = :ID) and (IDCENLVL = :VN_MAXDATE_IDLEVEL);

      --  
      VN_BASE_CALC_INFO = case when (:VN_APPLY_TO_ALL_IDLEVEL = :VN_MAXDATE_IDLEVEL) then 2 else 4 end; -- 2{cbFilled} 4{cbDirect}

      update A_SMETA_CENLVL
      set BASE_INFO = 2, -- csDirect
          BB = :BB,
          CURR_CENA = 0,
          BASE_CALC_INFO = bin_or(bin_and(BASE_CALC_INFO, bin_xor(7, -1)), :VN_BASE_CALC_INFO), -- 7 = 111 (cbCalcMask)
          SOURCE_LEVEL_ID = case when (:VN_APPLY_TO_ALL_IDLEVEL = :VN_MAXDATE_IDLEVEL) then :VN_MAXDATE_IDLEVEL else 0 end,
          CURR_CENA_INFO = 2, -- cciMonitiring
          ID_VALUTE = :VALUTE_ID,
          VALUTE_CURS = :VALUTE_RATE,
          VALUTE_DATE = :VALUTE_DATE

      where (ID = :ID) and (IDCENLVL <> :VN_MAXDATE_IDLEVEL);
    end
    else
    begin
    -- MK CQ[14381] <---

      update A_SMETA_CENLVL set
        BASE_INFO = 2, -- csDirect
        BB = :BB,
        CURR_CENA = :CURR_BB,

        -- MK 9.04.2015 --->
        BASE_CALC_INFO = bin_or(bin_and(BASE_CALC_INFO, bin_xor(7, -1)), :VN_CALC_INFO), -- 7 = 111 (cbCalcMask)
        --BASE_CALC_INFO = bin_or(bin_and(BASE_CALC_INFO, 24), 1),
        -- MK 9.04.2015 <---

        SOURCE_LEVEL_ID = 0,
        CURR_CENA_INFO = :VN_CURR_CENA_INFO,
        -- MK CQ[13036] --->
        ID_VALUTE = :VALUTE_ID,
        VALUTE_CURS = :VALUTE_RATE,
        VALUTE_DATE = :VALUTE_DATE
        -- MK CQ[13036] <---
      where (ID = :ID);
    end -- MK CQ[14381]


    ID_RES = null;
    if (:SLAVEPARENT <> 0) then
    begin
      RES_ID = null;
      select ID_S_RES
      from A_SMETA
      where ID = :ID
      into :RES_ID;
      ID_RES = :RES_ID;

      update A_S_RES_CENLVL set
        BASE_INFO = 2,
        -- MK CQ[14381] --->
        BB = :BB
        --BB = :CURR_BB
        -- MK CQ[14381] <---
      where (ID = :ID_RES);
    end

    -- MK CQ[13030]
    execute procedure M_FILL_REC_KOEFFS(:ID);

    --CQ[TIMUR 13929, 14262]
    if (TAB_BLOB = '') then TAB_BLOB = null;
    if (TAB_BLOB is not null) then
      insert into A_SMETA_BLOB (ID, FIELD_NAME, FIELD_VALUE)
      values (:ID, 'TAB', :TAB_BLOB);

    suspend;
  end
  INSERT_TO_ID = :NEW_ID;
  if (:SLAVEPARENT = 0) then
  begin
    NUMBER1 = :NUMBER1 + 1;
    for select ADDEDID, OUT_SMETATYPE, OUT_IDFORMULS
      from A_S_ADD_RES_NL(:IDUSER, :NEW_ID, :AGROUP, :APODGROUP, :IDZONE,
          :ZAMEN, :INSERT_ALL, :INSERT_SLAVE, :RES_APPLY_TAB,
          null, null, null, null, null, null, null, 0, :APPLY_POPR_MODE, 1)
      into :ID, :OUT_SMETATYPE, :OUT_IDFORMULS
    do
    begin
      if (:ID <> 0) then
        suspend;
    end
  end
  else
  begin
    NUMBER2 = :NUMBER2 + 1;
  end

  -- .. ID = null;
  -- .. suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_S_PASTE_MONITORING_REC_NL_M (
    IDUSER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDZONE INTEGER,
    AGROUP INTEGER,
    APODGROUP INTEGER,
    ZAMEN INTEGER,
    INSERT_ALL INTEGER,
    INSERT_SLAVE INTEGER,
    PASTEBLOB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    PASTECOUNT INTEGER,
    RES_APPLY_TAB INTEGER,
    APPLY_POPR_MODE INTEGER,
    VRPZ INTEGER,
    FROMPRICE INTEGER,
    ONLY_RES INTEGER,
    REPLACE1 INTEGER)
RETURNS (
    ID INTEGER,
    ID_RES INTEGER,
    REJECTCOUNT INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
declare variable NEW_ID integer;
declare variable IDPOS integer;
declare variable IDNORMY integer;
declare variable IDPRICE integer;
declare variable RABMAT integer;
declare variable TAB varchar(42);
declare variable ALTTAB varchar(250);
declare variable IDNAME integer;
declare variable IDEDIZM integer;
declare variable IDTCH integer;
declare variable IDESN integer;
declare variable IDTCARD integer;
declare variable ID_UNIQUE integer;
declare variable BA double precision;
declare variable BB double precision;
declare variable BC double precision;
declare variable BD double precision;
declare variable BE double precision;
declare variable BF double precision;
declare variable BG double precision;
declare variable BH double precision;
declare variable BI double precision;
declare variable PUNKTIND varchar(42);
declare variable ID_NAME integer;
declare variable CUR_IDREESTR integer;
declare variable CUR_NORM_GUID varchar(100);
declare variable SLAVEPARENT integer;
declare variable ROW integer;
declare variable RES_ID integer;
declare variable NORMOID integer;
declare variable PRICEINFOROW integer;
declare variable ISSOSTAV integer;

--CQ[9298] -->
declare variable IDOBJECT integer;
declare variable ID_LEVEL integer;
--CQ[9298] <--

declare variable VN_IDSTRUCT integer;
-- MK CQ[11629] --->
declare variable BA_NORM double precision;
declare variable BB_NORM double precision;
declare variable VN_WITH_NDS integer;
declare variable VN_MAXDATE_IDLEVEL integer;
declare variable D_TMP double precision;
-- MK CQ[11629] <---

-- <-- Voyager CQ[13228]
--      A_S_PASTE_RABMAT_RECORD
--  ,     
declare variable BN double precision;
declare variable BO double precision;
declare variable B_ITOGO double precision;
-- <-- Voyager CQ[13228]

declare B_PR double precision; --[15352]

-- Voyager CQ[14973]
declare IDNORMATIV integer; --[14973]
begin
--[15352] 

-- Voyager CQ[12925,14973]
--   A_S_PASTE_MONITORING_RECORDS_NL
--    (   )
--    ,  IDNORMY  ,   ,   :PASTEBLOB

  ID_NAME = gen_id(B_GEN_TEMP, 1);
  insert into B_TEMP_BLOB (ID, BLOB1)
  values (:ID_NAME, :PASTEBLOB);
  select BLOB1
  from B_TEMP_BLOB
  where ID = :ID_NAME
  into :PASTEBLOB;
  delete from B_TEMP_BLOB
  where ID = :ID_NAME;

  --CQ[9299] -->
  execute procedure A_H_GET_ID_PARENTATYPE(:IDHIER,
      1)
      returning_values (:IDOBJECT);
  --CQ[9299] <--

  -- MK 25.08.2011 CQ[9435] --->
  if (SMETATYPE = 15) then
    VN_IDSTRUCT = IDOBJECT;
  else
    VN_IDSTRUCT = SMETATYPE;
  -- MK 25.08.2011 CQ[9435] <---

  REJECTCOUNT = 0;
  if (:NUMBER2 is null) then
    SLAVEPARENT = 0;
  else
  if (:INSERT_TO_ATYPE = 17) then
    SLAVEPARENT = :INSERT_TO_ID;
  else
  if (:INSERT_TO_ATYPE in (18, 19)) then
  begin
    select SLAVEPARENT
    from A_SMETA
    where ID = :INSERT_TO_ID
    into SLAVEPARENT;
  end
  if (:SLAVEPARENT is null) then
  begin
    SLAVEPARENT = 0;
    NUMBER2 = null;
  end

  if (REPLACE1 <> 1) then
    select max(NUMBER2) + 1
    from A_SMETA
    where IDHIER = :IDHIER and
          SMETATYPE = :SMETATYPE and
          NUMBER1 = :NUMBER1
    into :NUMBER2;

  -- MK CQ[11629] --->
  --      
  execute procedure M_GET_MAX_DATE_LEVEL(:VN_IDSTRUCT)
  returning_values :VN_MAXDATE_IDLEVEL;
  -- MK CQ[11629] <---

  for select FVALUE1, FVALUE2
      from S_INTFROMBLOB_SELECT_2(:PASTEBLOB, :PASTECOUNT, :PASTECOUNT)
      into :IDNORMATIV, :IDPOS
  do
  begin
    IDNORMY = null;
    ID_UNIQUE = 0;

    select PPN.IDNORMO, P.IDPRICE,
           LROUNDN(PPN.NORMOCOST, 2), P.ROW + 1
      from PM_PRICEPOS P
      left join PM_PRICEPOSNORMS PPN on PPN.ID = P.ID --[12925]
        and PPN.IDNORMO = :IDNORMATIV -- Sem:   where,       
      where P.ID = abs(:IDPOS)
        --and PPN.IDNORMO = :IDNORMY -- Voyager CQ[14973]
      into :IDNORMY, :IDPRICE, :BB, :ROW;

    if (IDPOS < 0) then
      select LROUNDN(NORMOCOST, 2)
      from PM_PRICEPOSLINKS
      where IDNORMO = :IDNORMY and
            IDPRICE = :IDPRICE
      into :BB;
    if ((FROMPRICE = 0) and
        (IDNORMY is not null)) then --CQ[7580]    
    begin
      VN_WITH_NDS = 0; -- MK CQ[11629]

      select RABMAT, TAB, ALTTAB, IDNAME, IDEDIZM,
             IDTCH, IDESN, IDTCARD, ID_UNIQUE, BA,
             BC, BD, BE, BF, BG, BH, BI, PUNKTIND,
             IDREESTR,
             BB -- MK CQ[11629]
      from B_RABMAT
      where ID = :IDNORMY
      into :RABMAT, :TAB, :ALTTAB, :IDNAME,
           :IDEDIZM, :IDTCH, :IDESN, :IDTCARD,
           :ID_UNIQUE, :BA_NORM/*:BA CQ[11629]*/, :BC, :BD, :BE, :BF,
           :BG, :BH, :BI, :PUNKTIND,
           :CUR_IDREESTR,
           :BB_NORM; -- MK CQ[11629]
    end
    else --     
    begin
      -- MK CQ[11629] --->
      BA_NORM = 0;
      BB_NORM = 0;

      select first 1 p.bwithnds
      from pm_prices p
      where (p.id = :IDPRICE)
      into :VN_WITH_NDS;
      -- MK CQ[11629] <---

      RABMAT = 3;
      IDNORMY = 0;
      ID_UNIQUE = 0;
      execute procedure DM_GET_COPYPARAMPOSITION(:IDUSER,
          :IDPOS, :IDPRICE, :ROW)
          returning_values (:TAB, :ALTTAB,
          :IDNAME, :IDEDIZM, :D_TMP, :BB);  -- MK CQ[11629]  :D_TMP
    end
    CUR_NORM_GUID = null;
    select NORM_GUID
    from B_REESTR
    where ID = :CUR_IDREESTR
    into :CUR_NORM_GUID;
    NEW_ID = gen_id(A_G_SMETA, 1);
    for select OUT_ID, OUT_SMETATYPE,
               OUT_IDFORMULS --CQ[9359]
        from A_S_PASTE_RABMAT_RECORD(:IDUSER, :NEW_ID, :IDHIER, :SMETATYPE, :NUMBER1,
             :NUMBER2, :SLAVEPARENT, :INSERT_TO_ATYPE, :INSERT_TO_ID, :IDNORMY,
             :RABMAT, :TAB, :ALTTAB, :IDNAME, :IDEDIZM, :IDTCH, :IDESN, :IDTCARD,
             :ID_UNIQUE, :VRPZ, :BA_NORM/*:BA CQ[11629]*/, :BB_NORM/*:BB CQ[11629]*/,
             :BC, :BD, :BE, :BF, :BG, :BH, :BI,
             :PUNKTIND, :CUR_NORM_GUID, :APPLY_POPR_MODE, :REPLACE1,
             :BN, :BO, :B_ITOGO,
             :B_PR) --[15352]
        into :ID, :OUT_SMETATYPE,
             :OUT_IDFORMULS --CQ[9359]
    do
    begin
      -- 
      if (IDNORMY = 0) then
        NORMOID = -1;
      else
        NORMOID = IDNORMY;
      PRICEINFOROW = abs(ROW) - 1;
      ID_RES = null;
      --       
      if (FROMPRICE = 0) then --   
      begin
        if (IDPOS > 0) then --     
        begin
          execute procedure DM_GET_ISSOSTAV(:IDPRICE,
              :NORMOID)
              returning_values :ISSOSTAV;
          if (ISSOSTAV = 0) then
            PRICEINFOROW = -:PRICEINFOROW;
        end
      end
      else
        PRICEINFOROW = abs(ROW) - 1;
      if (:SLAVEPARENT = 0) then
      begin
        -- MK CQ[11629] --->
        execute procedure M_SET_SMETA_PRICEPOSINFO_NL(:ID, VN_MAXDATE_IDLEVEL,
            :IDPRICE, coalesce(:NORMOID, -1),
            PRICEINFOROW, :BB, 1,
            :IDOBJECT, :SMETATYPE -- CQ[11622]
            );

        --execute procedure SET_SMETA_PRICEPOSINFO(:ID,
        --    :IDPRICE, coalesce(:NORMOID, -1),
        --    PRICEINFOROW, :BB, 1);

        ----CQ[9288] -->
        --for select L.ID
        --    from LEVEL_COST L
        --    where (L.IDOBJECT = :VN_IDSTRUCT)
        --    --[AA5DC71D18EC]order by L.LORDER
        --    into :ID_LEVEL
        --do
        --begin
        --  execute procedure A_SMETA_COPY_CENLVL_AS_IS(:ID,
        --      :IDUSER, :ID_LEVEL);
        --end
        --CQ[9288] <--
        -- MK CQ[11629] <---
      end
      else
      begin
        RES_ID = null;
        select ID_S_RES
        from A_SMETA
        where ID = :ID
        into :RES_ID;
        if (ONLY_RES = 1) then
        begin
          delete from A_SMETA
          where ID = :ID;
        end
        ID_RES = :RES_ID;

        -- MK CQ[11629] --->
        -- (ONLY_RES = 1) -    :    
        execute procedure M_SET_SMETA_PRICEPOSINFO_NL(:RES_ID, :VN_MAXDATE_IDLEVEL,
            :IDPRICE, coalesce(:NORMOID, -1),
            PRICEINFOROW, :BB, 1,
            :IDOBJECT, :SMETATYPE -- CQ[11622]
            );

        --execute procedure SET_SMETA_PRICEPOSINFO(:RES_ID,
        --    :IDPRICE, coalesce(:NORMOID, -1),
        --    PRICEINFOROW, :BB, 1);
        --CQ[9288] -->
        --for select L.ID
        --    from LEVEL_COST L
        --    where (L.IDOBJECT = :VN_IDSTRUCT)
        --    --[AA5DC71D18EC]order by L.LORDER
        --    into :ID_LEVEL
        --do
        --begin
        --  if (ONLY_RES = 1) then
        --  begin
        --    execute procedure A_S_RES_COPY_CENLVL_AS_IS(:RES_ID,
        --        :IDUSER, :ID_LEVEL);
        --  end
        --  else
        --  begin
        --    execute procedure A_SMETA_COPY_CENLVL_AS_IS(:ID,
        --      :IDUSER, :ID_LEVEL);
        --  end
        --end
        --CQ[9288] <--
        -- MK CQ[11629] <---
      end

      -- MK CQ[11629] --->
      -- 

      -- MK CQ[13174] --->
      -- ,      5 (bciNeedRecalcItogoB)
      update A_SMETA_CENLVL set
        BASE_CALC_INFO = case
                           when (:VN_WITH_NDS = 0) then
                             SETBIT(BASE_CALC_INFO, 3, 0)
                           else
                             SETBIT(BASE_CALC_INFO, 3, 1)
                         end,

        CURR_CENA_INFO = 2 /*cciMonitiring*/  --CQ[TIMUR 13757]

      where (ID = :ID) and (IDCENLVL = :VN_MAXDATE_IDLEVEL);

      --if (VN_WITH_NDS = 0) then
      --begin
      --  update A_SMETA_CENLVL set
      --    BASE_CALC_INFO = bin_and(BASE_CALC_INFO, 23) -- 23 = 10111
      --  where (ID = :ID) and (IDCENLVL = :VN_MAXDATE_IDLEVEL);
      --end
      --else
      --begin
      --  update A_SMETA_CENLVL set
      --    BASE_CALC_INFO = bin_or(BASE_CALC_INFO, 8)   -- 8 = 01000
      --  where (ID = :ID) and (IDCENLVL = :VN_MAXDATE_IDLEVEL);
      --end
      -- MK CQ[13174] <---
      -- MK CQ[11629] <---

      suspend;
    end
    INSERT_TO_ID = :NEW_ID;
    if (:SLAVEPARENT = 0) then
    begin
      NUMBER1 = :NUMBER1 + 1;
      for select ADDEDID, OUT_SMETATYPE,
                 OUT_IDFORMULS --CQ[9359]
          from A_S_ADD_RES_NL(:IDUSER, :NEW_ID, :AGROUP, :APODGROUP, :IDZONE, :ZAMEN,
                              :INSERT_ALL, :INSERT_SLAVE, :RES_APPLY_TAB, null, null,
                              null, null, null, null, null, 0, :APPLY_POPR_MODE, 1)
          into :ID, :OUT_SMETATYPE,
               :OUT_IDFORMULS --CQ[9359]
      do
      begin
        if (:ID <> 0) then
          suspend;
      end
    end
    else
    begin
      NUMBER2 = :NUMBER2 + 1;
    end
  end
  ID = null;
  suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_S_PASTE_MONITORING_RECORDS_NL (
    IDUSER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDZONE INTEGER,
    AGROUP INTEGER,
    APODGROUP INTEGER,
    ZAMEN INTEGER,
    INSERT_ALL INTEGER,
    INSERT_SLAVE INTEGER,
    PASTEBLOB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    PASTECOUNT INTEGER,
    RES_APPLY_TAB INTEGER,
    APPLY_POPR_MODE INTEGER,
    VRPZ INTEGER,
    FROMPRICE INTEGER,
    ONLY_RES INTEGER,
    REPLACE1 INTEGER)
RETURNS (
    ID INTEGER,
    ID_RES INTEGER,
    REJECTCOUNT INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
 /*$$IBE$$ declare variable NEW_ID integer;
declare variable IDPOS integer;
declare variable IDNORMY integer;
declare variable IDPRICE integer;
declare variable RABMAT integer;
declare variable TAB varchar(42);
declare variable ALTTAB varchar(250);
declare variable IDNAME integer;
declare variable IDEDIZM integer;
declare variable IDTCH integer;
declare variable IDESN integer;
declare variable IDTCARD integer;
declare variable ID_UNIQUE integer;
declare variable BA double precision;
declare variable BB double precision;
declare variable BC double precision;
declare variable BD double precision;
declare variable BE double precision;
declare variable BF double precision;
declare variable BG double precision;
declare variable BH double precision;
declare variable BI double precision;
declare variable PUNKTIND varchar(42);
declare variable ID_NAME integer;
declare variable CUR_IDREESTR integer;
declare variable CUR_NORM_GUID varchar(100);
declare variable SLAVEPARENT integer;
declare variable ROW integer;
declare variable RES_ID integer;
declare variable NORMOID integer;
declare variable PRICEINFOROW integer;
declare variable ISSOSTAV integer;

--CQ[9298] -->
declare variable IDOBJECT integer;
declare variable ID_LEVEL integer;
--CQ[9298] <--

declare variable VN_IDSTRUCT integer;
-- MK CQ[11629] --->
declare variable BA_NORM double precision;
declare variable BB_NORM double precision;
declare variable VN_WITH_NDS integer;
declare variable VN_MAXDATE_IDLEVEL integer;
declare variable D_TMP double precision;
-- MK CQ[11629] <---

-- <-- Voyager CQ[13228]
--      A_S_PASTE_RABMAT_RECORD
--  ,     
declare variable BN double precision;
declare variable BO double precision;
declare variable B_ITOGO double precision;
-- <-- Voyager CQ[13228]

declare B_PR double precision; --[15352] $$IBE$$*/ 
begin /*$$IBE$$ 
--[15352]   A_S_PASTE_MONITORING_REC_NL_M

  ID_NAME = gen_id(B_GEN_TEMP, 1);
  insert into B_TEMP_BLOB (ID, BLOB1)
  values (:ID_NAME, :PASTEBLOB);
  select BLOB1
  from B_TEMP_BLOB
  where ID = :ID_NAME
  into :PASTEBLOB;
  delete from B_TEMP_BLOB
  where ID = :ID_NAME;

  --CQ[9299] -->
  execute procedure A_H_GET_ID_PARENTATYPE(:IDHIER,
      1)
      returning_values (:IDOBJECT);
  --CQ[9299] <--

  -- MK 25.08.2011 CQ[9435] --->
  if (SMETATYPE = 15) then
    VN_IDSTRUCT = IDOBJECT;
  else
    VN_IDSTRUCT = SMETATYPE;
  -- MK 25.08.2011 CQ[9435] <---

  REJECTCOUNT = 0;
  if (:NUMBER2 is null) then
    SLAVEPARENT = 0;
  else
  if (:INSERT_TO_ATYPE = 17) then
    SLAVEPARENT = :INSERT_TO_ID;
  else
  if (:INSERT_TO_ATYPE in (18, 19)) then
  begin
    select SLAVEPARENT
    from A_SMETA
    where ID = :INSERT_TO_ID
    into SLAVEPARENT;
  end
  if (:SLAVEPARENT is null) then
  begin
    SLAVEPARENT = 0;
    NUMBER2 = null;
  end

  if (REPLACE1 <> 1) then
    select max(NUMBER2) + 1
    from A_SMETA
    where IDHIER = :IDHIER and
          SMETATYPE = :SMETATYPE and
          NUMBER1 = :NUMBER1
    into :NUMBER2;

  -- MK CQ[11629] --->
  --      
  execute procedure M_GET_MAX_DATE_LEVEL(:VN_IDSTRUCT)
  returning_values :VN_MAXDATE_IDLEVEL;
  -- MK CQ[11629] <---


  for select FVALUE
      from S_INTFROMBLOB_SELECT(:PASTEBLOB, :PASTECOUNT)
      into :IDPOS
  do
  begin
    IDNORMY = null;
    ID_UNIQUE = 0;
     $$IBE$$*/ /* [12925]
    select IDNORMO, IDPRICE,
           LROUNDN(NORMOCOST, 2), ROW + 1
      from PM_PRICEPOS
      where ID = abs(:IDPOS)
    */ /*$$IBE$$  --[12925] :     
    select first 1 PPN.IDNORMO, P.IDPRICE,
           LROUNDN(PPN.NORMOCOST, 2), P.ROW + 1
      from PM_PRICEPOS P
      left join PM_PRICEPOSNORMS PPN on PPN.ID = P.ID --[12925]
      where P.ID = abs(:IDPOS)
      into :IDNORMY, :IDPRICE, :BB, :ROW;
    if (IDPOS < 0) then
      select LROUNDN(NORMOCOST, 2)
      from PM_PRICEPOSLINKS
      where IDNORMO = :IDNORMY and
            IDPRICE = :IDPRICE
      into :BB;
    if ((FROMPRICE = 0) and
        (IDNORMY is not null)) then --CQ[7580]    
    begin
      VN_WITH_NDS = 0; -- MK CQ[11629]

      select RABMAT, TAB, ALTTAB, IDNAME, IDEDIZM,
             IDTCH, IDESN, IDTCARD, ID_UNIQUE, BA,
             BC, BD, BE, BF, BG, BH, BI, PUNKTIND,
             IDREESTR,
             BB -- MK CQ[11629]
      from B_RABMAT
      where ID = :IDNORMY
      into :RABMAT, :TAB, :ALTTAB, :IDNAME,
           :IDEDIZM, :IDTCH, :IDESN, :IDTCARD,
           :ID_UNIQUE, :BA_NORM $$IBE$$*/ /*:BA CQ[11629]*/ /*$$IBE$$ , :BC, :BD, :BE, :BF,
           :BG, :BH, :BI, :PUNKTIND,
           :CUR_IDREESTR,
           :BB_NORM; -- MK CQ[11629]
    end
    else --     
    begin
      -- MK CQ[11629] --->
      BA_NORM = 0;
      BB_NORM = 0;

      select first 1 p.bwithnds
      from pm_prices p
      where (p.id = :IDPRICE)
      into :VN_WITH_NDS;
      -- MK CQ[11629] <---

      RABMAT = 3;
      IDNORMY = 0;
      ID_UNIQUE = 0;
      execute procedure DM_GET_COPYPARAMPOSITION(:IDUSER,
          :IDPOS, :IDPRICE, :ROW)
          returning_values (:TAB, :ALTTAB,
          :IDNAME, :IDEDIZM, :D_TMP, :BB);  -- MK CQ[11629]  :D_TMP
    end
    CUR_NORM_GUID = null;
    select NORM_GUID
    from B_REESTR
    where ID = :CUR_IDREESTR
    into :CUR_NORM_GUID;
    NEW_ID = gen_id(A_G_SMETA, 1);
    for select OUT_ID, OUT_SMETATYPE,
               OUT_IDFORMULS --CQ[9359]
        from A_S_PASTE_RABMAT_RECORD(:IDUSER, :NEW_ID, :IDHIER, :SMETATYPE, :NUMBER1,
             :NUMBER2, :SLAVEPARENT, :INSERT_TO_ATYPE, :INSERT_TO_ID, :IDNORMY,
             :RABMAT, :TAB, :ALTTAB, :IDNAME, :IDEDIZM, :IDTCH, :IDESN, :IDTCARD,
             :ID_UNIQUE, :VRPZ, :BA_NORM $$IBE$$*/ /*:BA CQ[11629]*/ /*$$IBE$$ , :BB_NORM $$IBE$$*/ /*:BB CQ[11629]*/ /*$$IBE$$ ,
             :BC, :BD, :BE, :BF, :BG, :BH, :BI,
             :PUNKTIND, :CUR_NORM_GUID, :APPLY_POPR_MODE, :REPLACE1,
             :BN, :BO, :B_ITOGO,
             :B_PR) --[15352]
        into :ID, :OUT_SMETATYPE,
             :OUT_IDFORMULS --CQ[9359]
    do
    begin
      -- 
      if (IDNORMY = 0) then
        NORMOID = -1;
      else
        NORMOID = IDNORMY;
      PRICEINFOROW = abs(ROW) - 1;
      ID_RES = null;
      --       
      if (FROMPRICE = 0) then --   
      begin
        if (IDPOS > 0) then --     
        begin
          execute procedure DM_GET_ISSOSTAV(:IDPRICE,
              :NORMOID)
              returning_values :ISSOSTAV;
          if (ISSOSTAV = 0) then
            PRICEINFOROW = -:PRICEINFOROW;
        end
      end
      else
        PRICEINFOROW = abs(ROW) - 1;
      if (:SLAVEPARENT = 0) then
      begin
        -- MK CQ[11629] --->
        execute procedure M_SET_SMETA_PRICEPOSINFO_NL(:ID, VN_MAXDATE_IDLEVEL,
            :IDPRICE, coalesce(:NORMOID, -1),
            PRICEINFOROW, :BB, 1,
            :IDOBJECT, :SMETATYPE -- CQ[11622]
            );

        --execute procedure SET_SMETA_PRICEPOSINFO(:ID,
        --    :IDPRICE, coalesce(:NORMOID, -1),
        --    PRICEINFOROW, :BB, 1);

        ----CQ[9288] -->
        --for select L.ID
        --    from LEVEL_COST L
        --    where (L.IDOBJECT = :VN_IDSTRUCT)
        --    --[AA5DC71D18EC]order by L.LORDER
        --    into :ID_LEVEL
        --do
        --begin
        --  execute procedure A_SMETA_COPY_CENLVL_AS_IS(:ID,
        --      :IDUSER, :ID_LEVEL);
        --end
        --CQ[9288] <--
        -- MK CQ[11629] <---
      end
      else
      begin
        RES_ID = null;
        select ID_S_RES
        from A_SMETA
        where ID = :ID
        into :RES_ID;
        if (ONLY_RES = 1) then
        begin
          delete from A_SMETA
          where ID = :ID;
        end
        ID_RES = :RES_ID;

        -- MK CQ[11629] --->
        -- (ONLY_RES = 1) -    :    
        execute procedure M_SET_SMETA_PRICEPOSINFO_NL(:RES_ID, :VN_MAXDATE_IDLEVEL,
            :IDPRICE, coalesce(:NORMOID, -1),
            PRICEINFOROW, :BB, 1,
            :IDOBJECT, :SMETATYPE -- CQ[11622]
            );

        --execute procedure SET_SMETA_PRICEPOSINFO(:RES_ID,
        --    :IDPRICE, coalesce(:NORMOID, -1),
        --    PRICEINFOROW, :BB, 1);
        --CQ[9288] -->
        --for select L.ID
        --    from LEVEL_COST L
        --    where (L.IDOBJECT = :VN_IDSTRUCT)
        --    --[AA5DC71D18EC]order by L.LORDER
        --    into :ID_LEVEL
        --do
        --begin
        --  if (ONLY_RES = 1) then
        --  begin
        --    execute procedure A_S_RES_COPY_CENLVL_AS_IS(:RES_ID,
        --        :IDUSER, :ID_LEVEL);
        --  end
        --  else
        --  begin
        --    execute procedure A_SMETA_COPY_CENLVL_AS_IS(:ID,
        --      :IDUSER, :ID_LEVEL);
        --  end
        --end
        --CQ[9288] <--
        -- MK CQ[11629] <---
      end

      -- MK CQ[11629] --->
      -- 

      -- MK CQ[13174] --->
      -- ,      5 (bciNeedRecalcItogoB)
      update A_SMETA_CENLVL set
        BASE_CALC_INFO = case
                           when (:VN_WITH_NDS = 0) then
                             SETBIT(BASE_CALC_INFO, 3, 0)
                           else
                             SETBIT(BASE_CALC_INFO, 3, 1)
                         end,

        CURR_CENA_INFO = 2  $$IBE$$*/ /*cciMonitiring*/ /*$$IBE$$   --CQ[TIMUR 13757]

      where (ID = :ID) and (IDCENLVL = :VN_MAXDATE_IDLEVEL);

      --if (VN_WITH_NDS = 0) then
      --begin
      --  update A_SMETA_CENLVL set
      --    BASE_CALC_INFO = bin_and(BASE_CALC_INFO, 23) -- 23 = 10111
      --  where (ID = :ID) and (IDCENLVL = :VN_MAXDATE_IDLEVEL);
      --end
      --else
      --begin
      --  update A_SMETA_CENLVL set
      --    BASE_CALC_INFO = bin_or(BASE_CALC_INFO, 8)   -- 8 = 01000
      --  where (ID = :ID) and (IDCENLVL = :VN_MAXDATE_IDLEVEL);
      --end
      -- MK CQ[13174] <---
      -- MK CQ[11629] <---

      suspend;
    end
    INSERT_TO_ID = :NEW_ID;
    if (:SLAVEPARENT = 0) then
    begin
      NUMBER1 = :NUMBER1 + 1;
      for select ADDEDID, OUT_SMETATYPE,
                 OUT_IDFORMULS --CQ[9359]
          from A_S_ADD_RES_NL(:IDUSER, :NEW_ID, :AGROUP, :APODGROUP, :IDZONE, :ZAMEN,
                              :INSERT_ALL, :INSERT_SLAVE, :RES_APPLY_TAB, null, null,
                              null, null, null, null, null, 0, :APPLY_POPR_MODE, 1)
          into :ID, :OUT_SMETATYPE,
               :OUT_IDFORMULS --CQ[9359]
      do
      begin
        if (:ID <> 0) then
          suspend;
      end
    end
    else
    begin
      NUMBER2 = :NUMBER2 + 1;
    end
  end
  ID = null;
  suspend;
 $$IBE$$*/ SUSPEND;
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_S_PASTE_RABMAT_RECORD (
    IDUSER INTEGER,
    NEWID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    SLAVEPARENT INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDNORMY INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    IDNAME INTEGER,
    IDEDIZM INTEGER,
    IDTCH INTEGER,
    IDESN INTEGER,
    IDTCARD INTEGER,
    ID_UNIQUE INTEGER,
    VRPZ INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    PUNKTIND VARCHAR(42),
    NORM_GUID VARCHAR(100),
    APPLY_POPR_MODE INTEGER,
    REPLACE INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    B_PR DOUBLE PRECISION)
RETURNS (
    OUT_ID INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
declare variable atype integer;
declare variable ka varchar(50);
declare variable kb varchar(50);
declare variable kc varchar(50);
declare variable kd varchar(50);
declare variable ke varchar(50);
declare variable kf varchar(50);
declare variable kg varchar(50);
declare variable kh varchar(50);
declare variable ki varchar(50);
declare variable kj varchar(50);
declare variable kk varchar(50);
declare variable kl varchar(50);
declare variable km varchar(50);
declare variable K_ITOGO varchar(50);
declare variable K_PR varchar(50);
declare variable id_sm_rec_ch_trud integer;
declare variable id_sl_rec_ch_nr_and_koll integer;
declare variable cur_uch integer;
declare variable apply_on_price integer;
declare variable copy_res_popr integer;
declare variable calc_mode integer;
declare variable cur_clcmode integer;
declare variable cur_rabmat integer;
declare variable cur_type_trud integer;
declare variable id_res integer;
declare variable cur_correct varchar(50);
declare variable new_normarash double precision;

begin
--[15352]+

 if (BA is null) then BA = 0 ;
 if (BB is null) then BB = 0 ;
 if (BC is null) then BC = 0 ;
 if (BD is null) then BD = 0 ;
 if (BE is null) then BE = 0 ;
 if (BF is null) then BF = 0 ;
 if (BG is null) then BG = 0 ;
 if (BH is null) then BH = 0 ;
 if (BI is null) then BI = 0 ;

 if (:NUMBER2 is not null and SLAVEPARENT <> 0) then
 begin
   /*  */
   ATYPE = 18;
 end
 else
 begin
   /*  -   */
   SLAVEPARENT = 0;
   NUMBER2 = 0;
   ATYPE = 17;
 end

-->DEN cq[4009]
  if (ATYPE = 18) then
  begin

    CALC_MODE = 0;
    CUR_UCH = 0;
    CUR_RABMAT = :RABMAT;
    CUR_TYPE_TRUD = null;
    if (CUR_RABMAT = 1) then
       CUR_TYPE_TRUD = coalesce(nullif(:CUR_TYPE_TRUD, 0), case when :TAB starting '2' then 2 else 1 end);
    else
      CUR_TYPE_TRUD = null;

    /* CQ[11307]        
    select s.CLCMODE
    from A_SMETA s where s.ID = :SLAVEPARENT
    into :CUR_CLCMODE;

    if ((not APPLY_POPR_MODE is null) and (getbit(:CUR_CLCMODE, 1) <> 0)) then
      APPLY_POPR_MODE = setbit(:APPLY_POPR_MODE, 3, 1);
    select COPY_RES_POPR, CALC_MODE
    from D_DECODE_APPLY_POPR_MODE(:APPLY_POPR_MODE)
    into :COPY_RES_POPR, :CALC_MODE;
    select RESULT
    from D_NEED_CONVERT_POPR(:APPLY_POPR_MODE, :CUR_UCH)
    into :APPLY_ON_PRICE;   */
    APPLY_ON_PRICE = 0; --CQ[11307]

    select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM, K_ITOGO/*14460*/, K_PR /*15421*/
    from A_SMETA where ID = :SLAVEPARENT
    into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :K_ITOGO/*14460*/, :K_PR /*15421*/;
    if (APPLY_ON_PRICE = 0) then
    begin
      select CORRECT
        from D_GET_POPR_VALUE(:KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH,
          :KI, :KJ, :KK, :KL, :KM, :K_ITOGO/*14460*/, :K_PR/*15421*/, :CUR_RABMAT, :CUR_TYPE_TRUD, 0)
      into :CUR_CORRECT;
      KA = ''; KB = ''; KC = ''; KD = ''; KE = ''; KF = ''; KG = ''; KH = '';
      KI = ''; KJ = ''; KK = ''; KL = ''; KM = '';
      K_ITOGO = ''/*14460*/; K_PR = ''; /*15421*/
    end
    NEW_NORMARASH = 0.0;  --//cq TIMUR [6432]

  end
  else
  begin
    APPLY_ON_PRICE = 1;
    NEW_NORMARASH = null;  --//cq TIMUR [6432]
  end
--<
 for select
     OUT_ID, OUT_SMETATYPE,
     OUT_IDFORMULS --CQ[9359]
   --CQ[9359]from A_S_APPENDREC (
   from A_S_APPENDREC_NL (
    :IDUSER,
    :NEWID,
    :IDHIER,
    :SMETATYPE,
    :NUMBER1,
    :NUMBER2,
    0,
    :SLAVEPARENT/*0*/,
    :ATYPE/*17*/,
    :RABMAT,
    /*[6921]*/:CUR_TYPE_TRUD,
    :TAB,
    :ALTTAB,
    :IDNAME,
    :IDEDIZM,
    0,
    0,
    '',

    /* MK 22.11.2006 CQ[4081] .1 ---> */
    :NEW_NORMARASH, /* 0 /* NORMARASH   DEN cq[4178]  */ --null
    /* MK 22.11.2006 <--- */

    :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -- null [9359]
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -- null  [9359]
    0,
    :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
    :IDTCH,
    0,
    0,
    0,
    0,
    null,
    null,
    :IDNORMY,
    :id_unique,
    1,
    1,
    0,
    :INSERT_TO_ATYPE,
    :INSERT_TO_ID,
    null,
    :VRPZ,
    0,
    0,
    0,
    0,
    null,
    :PUNKTIND,
    :norm_guid,
    0,
    0/*APPAY_INDEX_AS_IS*/,
    0/*APPLAY_FORMULS_AS_IS*/ /*  */,
    0/*APPLAY_POPR_AS_IS*/,
    1,
    1,
    1,
    1,
    1,
    0,
    0,
    1,
    1,
    null,
    0,
    null,
    null,

    null,
    null,
    null,
    :REPLACE,
    null, --CQ[9359]
    :BN, :BO, :B_ITOGO, -- CQ[13179]
    :K_ITOGO,/*14460*/
    :B_PR, --[15352]
    :K_PR /*15421*/)
  into
    :OUT_ID, :OUT_SMETATYPE,
    :OUT_IDFORMULS --CQ[9359]
  do
  begin

-->DEN cq[4009]
    if (APPLY_ON_PRICE = 0) then
    begin
      select s.ID_S_RES from A_SMETA s where s.ID = :OUT_ID into :ID_RES;
      execute procedure A_S_RES_APPLAY_CORRECTION (:IDUSER, 0, null, :ID_RES, :CUR_RABMAT, :CUR_TYPE_TRUD, '', :CUR_CORRECT, 1, :APPLY_POPR_MODE)
      returning_values :ID_SM_REC_CH_TRUD, :ID_SL_REC_CH_NR_AND_KOLL;
    end
--<
    if ((ATYPE = 17) and (RABMAT = 0)) then
      execute procedure UPDATE_SMETA_UNION_INFO(:IDNORMY, null, :OUT_ID);  --CQ[TIMUR 9063]

    suspend ;
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_S_PASTE_RABMAT_RECORDS_NL (
    IDUSER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    IDZONE INTEGER,
    AGROUP INTEGER,
    APODGROUP INTEGER,
    ZAMEN INTEGER,
    INSERT_ALL INTEGER,
    INSERT_SLAVE INTEGER,
    PASTEBLOB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    PASTECOUNT INTEGER,
    ISPASTEFROMBUFER SMALLINT,
    RES_APPLY_TAB INTEGER,
    APPLY_POPR_MODE INTEGER,
    PASTE_AS_IS INTEGER)
RETURNS (
    ID INTEGER,
    REJECTCOUNT INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
declare variable NEW_ID integer;

declare variable IDNORMY integer;
declare variable RABMAT integer;
declare variable TAB varchar(42);
declare variable ALTTAB varchar(250);
declare variable IDNAME integer;
declare variable IDEDIZM integer;
declare variable IDTCH integer;
declare variable IDESN integer;
declare variable IDTCARD integer;
declare variable ID_UNIQUE integer;
declare variable VRPZ integer;
declare variable BA double precision;
declare variable BB double precision;
declare variable BC double precision;
declare variable BD double precision;
declare variable BE double precision;
declare variable BF double precision;
declare variable BG double precision;
declare variable BH double precision;
declare variable BI double precision;
declare variable ZONE_BA double precision;
declare variable ZONE_BB double precision;
declare variable ZONE_BC double precision;
declare variable ZONE_BD double precision;
declare variable ZONE_BE double precision;
declare variable PUNKTIND varchar(42);
declare variable ID_NAME integer;
declare variable CUR_IDREESTR integer;
declare variable CUR_NORM_GUID varchar(100);
declare variable NOZONEMODE integer;
declare variable SLAVEPARENT integer;

declare variable ISZONEFIND integer;
declare variable FROM_RABMAT integer;

--CQ[9299] -->
declare variable IDOBJECT integer;
declare variable ID_LEVEL integer;
declare variable IN_IDTR integer;
declare variable IN_VRPZ integer;
declare variable IN_PUNKTIND varchar(42);
declare variable IN_RES_COPY_FORMULS integer;
--CQ[9299] <--

declare variable VN_IDSTRUCT integer;

declare variable PASTE_FROM_BUFER integer;
declare variable ID_PODGROUP integer;

-- <-- Voyager CQ[13228]
declare variable BN double precision;
declare variable BO double precision;
declare variable B_ITOGO double precision;
-- <-- Voyager CQ[13228]

declare B_PR double precision; --[15352]
begin
--[15352]

  ID_NAME = gen_id(B_GEN_TEMP, 1);
  insert into B_TEMP_BLOB (ID, BLOB1)
  values (:ID_NAME, :PASTEBLOB);
  select BLOB1
  from B_TEMP_BLOB
  where ID = :ID_NAME
  into :PASTEBLOB;
  delete from B_TEMP_BLOB
  where ID = :ID_NAME;

  REJECTCOUNT = 0;
  -->Den--7/2/5

  /* CQ[9299] -->     
  execute procedure D_GET_NOZONEMODE(:IDHIER,
      :SMETATYPE)
      returning_values :NOZONEMODE;
  CQ[9299] <-- */
  NOZONEMODE = 0;--CQ[9299] -->
  IDZONE = 0;--CQ[9299] -->
  --<Den

  --CQ[9299] -->
  execute procedure A_H_GET_ID_PARENTATYPE(:IDHIER,
      1)
      returning_values (:IDOBJECT);

  -- MK 25.08.2011 CQ[9435] --->
  if (SMETATYPE = 15) then
  begin
    VN_IDSTRUCT = IDOBJECT;

    -- MK 20.07.2012 CQ[10642] --->
    IN_RES_COPY_FORMULS = 0;
    IN_IDTR = 0;
    select o.res_copy_formuls, o.id_tr
    from a_o_objectparams o
    where (o.number = :IDOBJECT)
    into :IN_RES_COPY_FORMULS, :IN_IDTR;
    -- MK 20.07.2012 CQ[10642] <---
  end
  else
  begin
    VN_IDSTRUCT = SMETATYPE;

    -- MK 20.07.2012 CQ[10642] --->
    IN_RES_COPY_FORMULS = 0;
    IN_IDTR = 0;
    select f.res_copy_formuls, f.id_tr
    from a_o_factparams f
    where (f.number = :SMETATYPE)
    into :IN_RES_COPY_FORMULS, :IN_IDTR;
    -- MK 20.07.2012 CQ[10642] <---
  end
  -- MK 25.08.2011 CQ[9435] <---

  -- MK 20.07.2012 CQ[10642]  --->
  --IN_RES_COPY_FORMULS = 0;
  --select RES_COPY_FORMULS
  --from A_O_OBJECTPARAMS
  --where NUMBER = :IDOBJECT
  --into :IN_RES_COPY_FORMULS;
  -- MK 20.07.2012 CQ[10642]  <---
  --CQ[9299] <--

  /* <rvs> 2005/03/16
  NUMBER2 is null    SLAVEPARENT (is null  0 )
        -      (  )
   -   */
  /*  SLAVEPARENT */
  if (:NUMBER2 is null) then
    SLAVEPARENT = 0;
  else
  if (:INSERT_TO_ATYPE = 17) then
    SLAVEPARENT = :INSERT_TO_ID;
  else
  if (:INSERT_TO_ATYPE in (18, 19)) then
    select SLAVEPARENT
    from A_SMETA
    where ID = :INSERT_TO_ID
    into SLAVEPARENT;

  if (:SLAVEPARENT is null) then
  begin
    SLAVEPARENT = 0;
    NUMBER2 = null;
  end
  /* </rvs> */

  for select FVALUE
      from S_INTFROMBLOB_SELECT(:PASTEBLOB, :PASTECOUNT)
      into :IDNORMY
  do
  begin
    --CQ[11265]-->
    --      -   ABC_OKP        
    PASTE_FROM_BUFER = ISPASTEFROMBUFER;
    if (PASTE_FROM_BUFER = 0) then
    begin
      for select IDPODGROUP, RABMAT from b_abc_okp where ID = :IDNORMY
      into :ID_PODGROUP, :RABMAT do
      begin
        execute procedure B_WRITE_RECORD_IN_BUFFER (:IDUSER, :RABMAT, :ID_PODGROUP, :IDNORMY);
        select ID from B_BUFER where (IDNORMY = :IDNORMY) and (IDUSER = :IDUSER) and (ISBUFER = 1)
        into :IDNORMY;
        PASTE_FROM_BUFER = 1;
      end
    end
    --CQ[11265]<--

    if (PASTE_FROM_BUFER = 0) then
    begin
      for select RABMAT, TAB, ALTTAB, IDNAME,
                 IDEDIZM, IDTCH, IDESN, IDTCARD,
                 ID_UNIQUE, VRPZ, BA, BB, BC, BD,
                 BE, BF, BG, BH, BI, PUNKTIND,
                 IDREESTR,
                 PA, PB, BJ, -- <-- Voyager CQ[13228]
                 BB_PR --[15352]
          from B_RABMAT
          where ID = :IDNORMY
          into :RABMAT, :TAB, :ALTTAB, :IDNAME,
               :IDEDIZM, :IDTCH, :IDESN, :IDTCARD,
               :ID_UNIQUE, :VRPZ, :BA, :BB, :BC,
               :BD, :BE, :BF, :BG, :BH, :BI,
               :PUNKTIND, :CUR_IDREESTR,
               :BN, :BO, :B_ITOGO, -- <-- Voyager CQ[13228]
               :B_PR --[15352]
      do
      begin
        --<rvs:00003021>
        if (:IDZONE = -1) then
        begin
          BA = 0.0;
          BB = 0.0;
          BC = 0.0;
          BD = 0.0;
          BE = 0.0;
        end
        else


        --</rvs:00003021>
        --DEN cq[1800] 7/6/5
        if (IDZONE > 0) then
        begin
          if (((RABMAT <> 0) and
              (NOZONEMODE = 1)) or (NOZONEMODE = 0)) then
          begin
            execute procedure B_READ_ZONE_RAB_TSENY(:IDUSER,
                :IDNORMY, :IDZONE)
                returning_values :BA, :BB, :BC,
                :BD, :BE, :ISZONEFIND;
          end
        end
        CUR_NORM_GUID = null;

        select NORM_GUID
        from B_REESTR
        where ID = :CUR_IDREESTR
        into :CUR_NORM_GUID;

        NEW_ID = gen_id(A_G_SMETA, 1);

        for select OUT_ID, OUT_SMETATYPE,
                   OUT_IDFORMULS --CQ[9359]
            from A_S_PASTE_RABMAT_RECORD(:IDUSER, :NEW_ID, :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2,
                :SLAVEPARENT, :INSERT_TO_ATYPE, :INSERT_TO_ID, :IDNORMY, :RABMAT, :TAB, :ALTTAB,
                :IDNAME, :IDEDIZM, :IDTCH, :IDESN, :IDTCARD, :ID_UNIQUE, :VRPZ, :BA, :BB,
                :BC, :BD, :BE, :BF, :BG, :BH, :BI, :PUNKTIND, :CUR_NORM_GUID, :APPLY_POPR_MODE, 0,
                :BN, :BO, :B_ITOGO, -- <-- Voyager CQ[13228]
                :B_PR --[15352]
                )
            into :ID, :OUT_SMETATYPE,
                 :OUT_IDFORMULS --CQ[9359]
        do
        begin
          --CQ[9299] -->
          --            
          --     ,    
          if (PASTE_AS_IS = 1) then
          begin
            for select L.ID
                from LEVEL_COST L
                where (L.IDOBJECT = :VN_IDSTRUCT)
                --[AA5DC71D18EC]order by L.LORDER
                into :ID_LEVEL
            do
            begin
              execute procedure A_SMETA_COPY_CENLVL_AS_IS(:NEW_ID,
                  :IDUSER, :ID_LEVEL);
            end
          end
          else
          begin
            -- MK 20.07.2012 CQ[10642] IN_IDTR = 0;
            IN_VRPZ = 0;
            IN_PUNKTIND = null;

            select /*IDTIPR,*/ VRPZ, PUNKTIND
            from A_SMETA
            where ID = :NEW_ID
            into /*:IN_IDTR,*/ :IN_VRPZ, :IN_PUNKTIND;
            --      (  Ctrl+Enter  )
            for select ID_LEVEL
                from NL_CTRL_ENTER_SMREC(:IDOBJECT, :SMETATYPE, :IDUSER, 1/*:NEED_APPLY_INDEX*/, 1/*:NEED_APPLY_FORMUL*/,
                :IN_PUNKTIND, :NEW_ID, :IN_IDTR, :IN_VRPZ, :IN_RES_COPY_FORMULS, 1/*:UPDATE_ALL_ACT*/)
                into :ID_LEVEL
            do
            begin
              --nothing
              ID_LEVEL = :ID_LEVEL;
            end
          end
          --CQ[9299] <--

          suspend;
        end

        INSERT_TO_ID = :NEW_ID;

        if (:SLAVEPARENT = 0) then
        begin
          NUMBER1 = :NUMBER1 + 1;

          for select ADDEDID, OUT_SMETATYPE,
                     OUT_IDFORMULS --CQ[9359]
              from A_S_ADD_RES_NL_2( :IDUSER, :NEW_ID /*ID*/ , :AGROUP, :APODGROUP,
                  :IDZONE, :ZAMEN, :INSERT_ALL, :INSERT_SLAVE, :RES_APPLY_TAB,
                  null, null, null, null, null, null, null, 0, :APPLY_POPR_MODE, :PASTE_AS_IS)
              into :ID, :OUT_SMETATYPE,
                   :OUT_IDFORMULS --CQ[9359]
          do
            if (:ID <> 0) then
              suspend;
        end
        else
        begin
          NUMBER2 = :NUMBER2 + 1;

        end

        when any do
          REJECTCOUNT = REJECTCOUNT + 1;
      end
    end
    else
    begin
      for select IDNORMY, RABMAT, TAB, ALTTAB,
                 IDNAME, IDEDIZM, IDTCH, IDESN,
                 IDTCARD, IDUNIQUE, VRPZ,
                 BA, BB, BC, BD, BE, BF, BG, BH, BI,
                 PA, PB, BJ, -- CQ[TIMUR 13239]
                 BB_PR, --[15352]
                 PUNKTIND, ZONE_BA, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE, OUT_FROM_RABMAT
                 -- MK 15.07.2006 CQ[6308] --->
          from L_BUFER_SELECT_ONE(:IDUSER, :IDNORMY, :IDZONE, -1)
          --FROM S_BUFER_RABMAT_SELECT_ONE (:IDUSER, :IDNORMY, :IDZONE)
          -- MK 15.07.2006 <---
          into :IDNORMY, :RABMAT, :TAB, :ALTTAB,
               :IDNAME, :IDEDIZM, :IDTCH, :IDESN,
               :IDTCARD, :ID_UNIQUE, :VRPZ,
               :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
               :BN, :BO, :B_ITOGO, -- CQ[TIMUR 13239]
               B_PR, --[15352]
               :PUNKTIND, :ZONE_BA, :ZONE_BB, :ZONE_BC, :ZONE_BD, :ZONE_BE,
               :FROM_RABMAT
      do
      begin
        -- MK 15.07.2006 CQ[6308] --->
        --    BA (ZONE_BA)   
        if (FROM_RABMAT = 0) then
        begin
          execute procedure B_REALLOCATION_ZONE_CENA(:IDUSER,
              :RABMAT, :BA)
              returning_values (:BA, :BB, :BC,
              :BD, :BE);

          execute procedure B_REALLOCATION_ZONE_CENA(:IDUSER,
              :RABMAT, :ZONE_BA)
              returning_values (:ZONE_BA,
              :ZONE_BB, :ZONE_BC, :ZONE_BD,
              :ZONE_BE);
        end
        -- MK 15.07.2006 <---

        --<rvs:00003021>
        if (:IDZONE = -1) then
        begin
          BA = 0.0;
          BB = 0.0;
          BC = 0.0;
          BD = 0.0;
          BE = 0.0;
        end
        else


        --</rvs:00003021>
        if (IDZONE > 0) then
        begin
          if (((RABMAT <> 0) and
              (NOZONEMODE = 1)) or (NOZONEMODE = 0)) then -- MK 20.10.2006 CQ[3935]
          begin
            BA = ZONE_BA;
            BB = ZONE_BB;
            BC = ZONE_BC;
            BD = ZONE_BD;
            BE = ZONE_BE;
          end
        end

        NEW_ID = gen_id(A_G_SMETA, 1);

        for select OUT_ID, OUT_SMETATYPE,
                   OUT_IDFORMULS --CQ[9359]
            from A_S_PASTE_RABMAT_RECORD(:IDUSER, :NEW_ID /*:ID*/ , :IDHIER, :SMETATYPE, :NUMBER1,
            :NUMBER2, :SLAVEPARENT, :INSERT_TO_ATYPE, :INSERT_TO_ID, :IDNORMY, :RABMAT, :TAB,
            :ALTTAB, :IDNAME, :IDEDIZM, :IDTCH, :IDESN, :IDTCARD, :ID_UNIQUE, :VRPZ,
            :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
            :PUNKTIND, :CUR_NORM_GUID, :APPLY_POPR_MODE, 0,
            :BN, :BO, :B_ITOGO, -- <-- Voyager CQ[13228]
            :B_PR --[15352]
            )
            into :ID, :OUT_SMETATYPE,
                 :OUT_IDFORMULS --CQ[9359]
        do
        begin
          --CQ[9299] -->
          --            
          --     ,    
          if (PASTE_AS_IS = 1) then
          begin
            for select L.ID
                from LEVEL_COST L
                where (L.IDOBJECT = :VN_IDSTRUCT)
                --[AA5DC71D18EC]order by L.LORDER
                into :ID_LEVEL
            do
            begin
              execute procedure A_SMETA_COPY_CENLVL_AS_IS(:NEW_ID,
                  :IDUSER, :ID_LEVEL);
            end
          end
          else
          begin
            -- MK 20.07.2012 CQ[10642] IN_IDTR = 0;
            IN_VRPZ = 0;
            IN_PUNKTIND = null;

            select /*IDTIPR,*/ VRPZ, PUNKTIND
            from A_SMETA
            where ID = :NEW_ID
            into /*:IN_IDTR,*/ :IN_VRPZ, :IN_PUNKTIND;
            --      (  Ctrl+Enter  )
            for select ID_LEVEL
                from NL_CTRL_ENTER_SMREC(:IDOBJECT, :SMETATYPE, :IDUSER, 1/*:NEED_APPLY_INDEX*/, 1/*:NEED_APPLY_FORMUL*/,
                :IN_PUNKTIND, :NEW_ID, :IN_IDTR, :IN_VRPZ, :IN_RES_COPY_FORMULS, 1/*:UPDATE_ALL_ACT*/)
                into :ID_LEVEL
            do
            begin
              --nothing
              ID_LEVEL = :ID_LEVEL;
            end
          end
          --CQ[9299] <--
          suspend;
        end

        INSERT_TO_ID = :NEW_ID;

        if (:SLAVEPARENT = 0) then
        begin
          NUMBER1 = :NUMBER1 + 1;

          for select ADDEDID, OUT_SMETATYPE,
                     OUT_IDFORMULS --CQ[9359]
              from A_S_ADD_RES_NL_2(:IDUSER, :NEW_ID /*:ID*/ , :AGROUP, :APODGROUP,
                  :IDZONE, :ZAMEN, :INSERT_ALL, :INSERT_SLAVE, :RES_APPLY_TAB,
                  null, null, null, null, null, null, null, 0, :APPLY_POPR_MODE, :PASTE_AS_IS)
              into :ID, :OUT_SMETATYPE,
                   :OUT_IDFORMULS --CQ[9359]
          do
            if (:ID <> 0) then
              suspend;
        end
        else
          NUMBER2 = :NUMBER2 + 1;

        --          WHEN ANY DO REJECTCOUNT = REJECTCOUNT + 1;
      end
    end
  end

  ID = null;
  suspend;
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE A_S_PASTE_SMETA_RECORD (
*/
--[15352]
CREATE OR ALTER PROCEDURE A_S_RES_TO_SLAVEREC_NL (
    IDUSER INTEGER,
    ID_RES INTEGER,
    ID_SMREC INTEGER,
    PUNKTIND VARCHAR(42),
    VRPZ INTEGER,
    INSERT_MODE INTEGER,
    IDZONE INTEGER,
    APPLY_POPR_MODE INTEGER,
    ISMANUAL INTEGER,
    IDNORMATIVUNIQ INTEGER,
    PASTE_AS_IS INTEGER)
RETURNS (
    ADDED_SLAVE INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_IDFORMULS INTEGER)
AS
--   
-- ISMANUAL - 1 -    ( ), 0 -    Ctrl_Enter
 /*$$IBE$$ declare variable CUR_ID_SM integer;
declare variable CUR_IDHIER integer;
declare variable CUR_SMETATYPE integer;
declare variable CUR_NUMBER1 integer;
declare variable CUR_NUMBER2 integer;
declare variable NEW_NUMBER2 integer;
declare variable CUR_RABMAT integer;
declare variable CUR_TYPE_TRUD integer;
declare variable CUR_TAB varchar(42);
declare variable CUR_ALTTAB varchar(250);
declare variable CUR_NAME_ID integer;
declare variable CUR_IDEDIZM integer;
declare variable CUR_EDIZM_TYPE integer;
declare variable CUR_KOLL_SMREC double precision;
declare variable CUR_RASHOD_RES double precision;
declare variable CUR_RASHOD_BASE double precision;
declare variable NEW_KOLL double precision;
declare variable CUR_BA double precision;
declare variable CUR_BB double precision;
declare variable CUR_BC double precision;
declare variable CUR_BD double precision;
declare variable CUR_BE double precision;
declare variable CUR_NORM_ID integer;
declare variable CUR_IDNORMATIVUNIQ integer;
declare variable CUR_NORM_PODGROUP integer;
declare variable CUR_KODIR_GROUP integer;
declare variable CUR_KODIR_PODGROUP integer;
declare variable CUR_ISGROUPOKP integer;
declare variable CUR_INSERT_TO_ATYPE integer;
declare variable CUR_INSERT_TO_ID integer;
declare variable CUR_NORM_GUID varchar(100);
declare variable CUR_CORRECT varchar(50);
declare variable NEW_ATYPE integer;
declare variable NEW_SLAVEPARENT integer;
declare variable NEW_ID_RES integer;
declare variable NEW_RASHOD_RES double precision;
declare variable TMP_ID integer;

--declare variable res_pz double precision;
--declare variable res_zp_mash double precision;
--declare variable mode_kompns_st integer;

declare RES_TYPE_TRUD integer;

declare variable RES_NOMERROD integer;
declare variable S_ORDERVIEW integer;
declare variable ID_S_RES integer;
declare variable IDSOURCE integer;

declare variable NOZONEMODE integer;

declare variable ZONE_BA double precision;
declare variable ZONE_BB double precision;
declare variable ZONE_BC double precision;
declare variable ZONE_BD double precision;
declare variable ZONE_BE double precision;
declare variable ISZONEFIND integer;

declare variable KA varchar(50);
declare variable KB varchar(50);
declare variable KC varchar(50);
declare variable KD varchar(50);
declare variable KE varchar(50);
declare variable KF varchar(50);
declare variable KG varchar(50);
declare variable KH varchar(50);
declare variable KI varchar(50);
declare variable KJ varchar(50);
declare variable KK varchar(50);
declare variable KL varchar(50);
declare variable KM varchar(50);
declare variable K_ITOGO varchar(50);

declare variable ID_SM_REC_CH_TRUD integer;
declare variable ID_SL_REC_CH_NR_AND_KOLL integer;

declare variable CUR_UCH integer;
declare variable NEED_CONVERT_POPR integer;
declare variable COPY_RES_POPR integer;
declare variable CALC_MODE integer;
declare variable CUR_CLCMODE integer;
declare variable NEW_CLCMODE integer;

declare variable CORRECTNODE blob sub_type TEXT;
declare variable CORRECTNODE_1 blob sub_type TEXT;

declare variable TMP_CORRECT varchar(50);

--CQ[9273]>>
declare variable TYPE_RAB integer;
declare variable VID_RAB integer;
declare variable IDOBJECT integer;
declare variable ID_LEVEL integer;

declare variable NL_ID_LEVEL_VC integer;
declare variable NL_IDZONE integer; 
declare variable NL_ID_LEVEL_INDEX integer;
declare variable NL_IDINDEX integer; 
declare variable NL_BA double precision;
declare variable NL_BB double precision;
declare variable NL_BC double precision;
declare variable NL_BD double precision;
declare variable NL_BE double precision;
declare variable NL_MA double precision;
declare variable NL_MB double precision;
declare variable NL_MC double precision;
declare variable NL_MD double precision;
declare variable NL_ME double precision;
declare variable NL_MF double precision;
declare variable NL_MG double precision;
declare variable NL_MH double precision;
declare variable NL_MI double precision;
declare variable NL_PUNKTIND varchar(42);
declare variable NL_SPOSOB_RASCH integer;
declare variable NL_RES_VC integer; 
declare variable NL_RES_INDEX integer;
declare variable VN_PA double precision;
declare variable VN_PB double precision;
declare variable VN_PC double precision;
declare variable VN_PD double precision;

declare variable IN_RES_COPY_FORMULS integer;
declare variable APPLYONRES integer;
declare variable IDTR integer;

declare variable VN_IDSTRUCT integer;

-- MK 2.05.2012 CQ[10381]
declare variable VN_IS_UNION integer;
declare variable VN_SKOLL varchar(255);
declare variable VN_UKR_KOLL double precision;


declare variable NL_MJ double precision;
declare variable NL_MK  double precision;
declare variable NL_ML double precision;
declare variable NL_MM double precision;
declare variable NL_DA double precision;
declare variable NL_DB double precision;
declare variable NL_DC double precision;
declare variable NL_DD double precision;
declare variable NL_DE double precision;
declare variable NL_DJ double precision;
declare variable NL_DK  double precision;
declare variable NL_DL double precision;
declare variable NL_DM double precision;

declare variable NEED_APPLY_INDEX integer; $$IBE$$*/ 
begin /*$$IBE$$ 
--[15352]
--- >>> ,   <<< ---

   $$IBE$$*/ /*
  APPLY_POPR_MODE = 0  - RES_COPY_POPR
  APPLY_POPR_MODE = 1  - 
  APPLY_POPR_MODE = 2  -  ()
  APPLY_POPR_MODE = 3  - 
*/ /*$$IBE$$ 
  ADDED_SLAVE = 0;

  NEED_APPLY_INDEX = 1;--CQ[10929] :  = 1,    

  if (INSERT_MODE is null) then
    INSERT_MODE = 0;

   $$IBE$$*/ /* semenov -  NULL  
 OUT_SEA = null; OUT_SEB = null; OUT_SEC = null; OUT_SED = null; OUT_SEE = null;
                 OUT_SEF = null; OUT_SEG = null; OUT_SEH = null; OUT_SEI = null;
 OUT_SRA = null; OUT_SRB = null; OUT_SRC = null; OUT_SRD = null; OUT_SRE = null;
                 OUT_SRF = null; OUT_SRG = null; OUT_SRH = null; OUT_SRI = null;
                 OUT_SRJ = null; OUT_SRK = null; OUT_SRL = null; OUT_SRM = null;
*/ /*$$IBE$$ 

  if (not exists(select *
                 from A_SMETA S
                 where S.ID = :ID_SMREC)) then
    exit;

  if (not exists(select *
                 from A_S_RES R
                 where R.ID = :ID_RES)) then
    exit;

  CUR_ID_SM = gen_id(A_G_SMETA, 1);

  select S.IDHIER, S.SMETATYPE, S.NUMBER1, S.KOLL,
         S.ATYPE, S.CLCMODE, S.CORRECTNODE,
         S.CORRECTNODE_1
  from A_SMETA S
  where S.ID = :ID_SMREC
  into :CUR_IDHIER, :CUR_SMETATYPE, :CUR_NUMBER1,
       :CUR_KOLL_SMREC, :CUR_INSERT_TO_ATYPE,
       :CUR_CLCMODE, :CORRECTNODE, :CORRECTNODE_1;

  NEW_CLCMODE = 0;
  if (GETBIT(:CUR_CLCMODE, 8) <> 0) then
    NEW_CLCMODE = SETBIT(NEW_CLCMODE, 8, 1);
  if (GETBIT(:CUR_CLCMODE, 9) <> 0) then
    NEW_CLCMODE = SETBIT(NEW_CLCMODE, 9, 1);

  --DEN-->21/3/5
  execute procedure D_GET_NOZONEMODE(:CUR_IDHIER,
      :CUR_SMETATYPE)
      returning_values :NOZONEMODE;
  --<

  -- MK 2.05.2012 CQ[10381]
  execute procedure M_IS_HIER_IN_UNION(:CUR_IDHIER) returning_values :VN_IS_UNION;


  if (INSERT_MODE <> 0) then
  begin
    TMP_ID = null;
    select first 1 ID_SOURCE
    from A_S_RES
    where ID = :ID_RES
    into TMP_ID;
    if (not TMP_ID is null) then
      select first 1 KOLL
      from A_SMETA
      where ID = :TMP_ID
      into CUR_KOLL_SMREC;
  end

  if (INSERT_MODE = 0) then
  begin
    NEW_ATYPE = 18;
    NEW_SLAVEPARENT = ID_SMREC;
    NEW_ID_RES = ID_RES;

    NEW_NUMBER2 = 1;
    for select S.NUMBER2
        from A_SMETA S
        where S.SLAVEPARENT = :ID_SMREC
        into :CUR_NUMBER2
    do
      if (NEW_NUMBER2 <= :CUR_NUMBER2) then
        NEW_NUMBER2 = :CUR_NUMBER2 + 1;
  end
  else
  begin
    NEW_ATYPE = 17;
    NEW_SLAVEPARENT = 0;
    NEW_ID_RES = null;

    CUR_NUMBER1 = CUR_NUMBER1 + 1;
    NEW_NUMBER2 = 0;
  end

  CUR_NORM_GUID = null;

  select R.RABMAT, R.TAB, R.ALTTAB, R.NAME_ID,
         R.IDEDIZM, R.EDIZM_TYPE, R.RASHOD,
         R.RASHOD_BASE, R.BB, R.BC, R.BD, R.BE,
         R.NORM_ID, R.KODIR_GROUP,
         R.KODIR_PODGROUP, R.ISGROUPOKP,
         R.NORM_PODGROUP, R.NORM_GUID, R.NOMERROD,
         R.CORRECT, R.UCH, R.TYPE_TRUD
  from A_S_RES R
  where R.ID = :ID_RES
  into :CUR_RABMAT, :CUR_TAB, :CUR_ALTTAB,
       :CUR_NAME_ID, :CUR_IDEDIZM,
       :CUR_EDIZM_TYPE, :CUR_RASHOD_RES,
       :CUR_RASHOD_BASE, :CUR_BB, :CUR_BC,
       :CUR_BD, :CUR_BE, :CUR_NORM_ID,
       :CUR_KODIR_GROUP, :CUR_KODIR_PODGROUP,
       :CUR_ISGROUPOKP, :CUR_NORM_PODGROUP,
       :CUR_NORM_GUID, :RES_NOMERROD,
       :CUR_CORRECT, :CUR_UCH, :RES_TYPE_TRUD;
  -->DEN cq[4009]
  if (CUR_RABMAT = 1) then
    CUR_TYPE_TRUD = coalesce(nullif(:RES_TYPE_TRUD, 0), case
                                                          when :CUR_TAB starting '2' then 2
                                                          else 1
                                                        end);
--<

CUR_BA = CUR_BB + CUR_BC + CUR_BE;

--DEN-->21/3/5
if ((NOZONEMODE = 1) and
    (CUR_RABMAT <> 0)) then
begin
  execute procedure L_FILL_CCURRENT1(:CUR_NORM_ID,
      :CUR_RABMAT, :CUR_NORM_PODGROUP, :IDZONE,
      :IDUSER)
      returning_values :ZONE_BA, :ZONE_BB,
      :ZONE_BC, :ZONE_BD, :ZONE_BE, :ISZONEFIND;
  if ((ISZONEFIND = 1) or (IDZONE = -1)) then
  begin
    CUR_BB = :ZONE_BB;
    CUR_BC = :ZONE_BC;
    CUR_BD = :ZONE_BD;
    CUR_BE = :ZONE_BE;
    CUR_BA = :ZONE_BA;
  end
end
--<

CUR_INSERT_TO_ID = ID_SMREC;

if (INSERT_MODE = 0) then
begin
  CUR_INSERT_TO_ATYPE = 17;

   $$IBE$$*/ /*if ( exists ( select * - semenov -   ,   ...
                from a_smeta s
                where ( s.slaveparent = :id_smrec ) and
                      ( s.atype = 19 ) ) )
  then*/ /*$$IBE$$  for select S.ID
      from A_SMETA S
      where (S.SLAVEPARENT = :ID_SMREC) and
            (S.ATYPE = 19) and
            (S.NUMBER2 = 0)
      order by S.NUMBER1
      into :CUR_INSERT_TO_ID
  do
    CUR_INSERT_TO_ATYPE = 19;
end

CUR_IDNORMATIVUNIQ = IDNORMATIVUNIQ;--CQ[9223]
if ((PUNKTIND is null) and
    (VRPZ is null)) then
  select S.PUNKTIND, S.VRPZ, S.ID_UNIQUE
  from L_FB_SEARCH_NORMATIV(:CUR_NORM_ID, :CUR_NORM_PODGROUP, :CUR_RABMAT, null, null, :IDUSER, null, null, null, null, null) S
  into :PUNKTIND, :VRPZ, :CUR_IDNORMATIVUNIQ;--CQ[9223] CUR_IDNORMATIVUNIQ

 $$IBE$$*/ /*    . ,
   NOMERROD  ,    */ /*$$IBE$$ 

NEW_KOLL = :CUR_RASHOD_RES * :CUR_KOLL_SMREC;

NEW_RASHOD_RES = CUR_RASHOD_RES;
if (INSERT_MODE <> 0) then
  NEW_RASHOD_RES = null;

-->DEN cq[4009]
CALC_MODE = 0;
--  if (insert_mode = 0) then
begin
  if ((not APPLY_POPR_MODE is null) and
      (GETBIT(:CUR_CLCMODE, 1) <> 0)) then
    APPLY_POPR_MODE = SETBIT(:APPLY_POPR_MODE, 3, 1);
  select COPY_RES_POPR, CALC_MODE
  from D_DECODE_APPLY_POPR_MODE(:APPLY_POPR_MODE)
  into :COPY_RES_POPR, :CALC_MODE;

  select RESULT
  from D_NEED_CONVERT_POPR(:APPLY_POPR_MODE, :CUR_UCH)
  into :NEED_CONVERT_POPR;
end
--  else
--    NEED_CONVERT_POPR = 0;

if ( $$IBE$$*/ /*(insert_mode = 0) and */ /*$$IBE$$  (CUR_UCH <> 0) and
    (CALC_MODE = 1)) then
-- cq [4477]  insert_mode  ..            
begin
  if (CUR_RASHOD_BASE > 0) then
    NEW_RASHOD_RES = :CUR_RASHOD_BASE * -1;
  else
    NEW_RASHOD_RES = :CUR_RASHOD_BASE;
  NEW_KOLL = :NEW_RASHOD_RES * :CUR_KOLL_SMREC;

  update A_S_RES R
  set R.RASHOD = :NEW_RASHOD_RES,
      R.RASHOD_BASE = :NEW_RASHOD_RES,
      R.CORRECT = ''
  where R.ID = :ID_RES;
end

if ((NEED_CONVERT_POPR <> 0)) then
begin
  select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ,
         KK, KL, KM, K_ITOGO $$IBE$$*/ /*14460*/ /*$$IBE$$ 
  from A_SMETA
  where ID = :ID_SMREC
  into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH,
       :KI, :KJ, :KK, :KL, :KM, :K_ITOGO $$IBE$$*/ /*14460*/ /*$$IBE$$ ;
end
else
begin
  KA = '';
  KB = '';
  KC = '';
  KD = '';
  KE = '';
  KF = '';
  KG = '';
  KH = '';
  KI = '';
  KJ = '';
  KK = '';
  KL = '';
  KM = '';
  K_ITOGO = '';  $$IBE$$*/ /*14460*/ /*$$IBE$$ 
end

-- MK 1.09.2009 CQ[7406]
select GP.CORRECT
from D_GET_POPR_VALUE(:KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :K_ITOGO $$IBE$$*/ /*14460*/ /*$$IBE$$ , :CUR_RABMAT, :CUR_TYPE_TRUD, :NEED_CONVERT_POPR) GP
into :TMP_CORRECT;

if (INSERT_MODE = 1) then
begin
  -- MK 1.09.2009 CQ[7406] --->
  CUR_CORRECT = TMP_CORRECT;
  --select gp.CORRECT from D_GET_POPR_VALUE(:KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :CUR_RABMAT, :CUR_TYPE_TRUD, :NEED_CONVERT_POPR) gp
  --into :CUR_CORRECT;
  -- MK 1.09.2009 CQ[7406] <---

  KA = '';
  KB = '';
  KC = '';
  KD = '';
  KE = '';
  KF = '';
  KG = '';
  KH = '';
  KI = '';
  KJ = '';
  KK = '';
  KL = '';
  KM = '';
  K_ITOGO = '';  $$IBE$$*/ /*14460*/ /*$$IBE$$ 
end

-- MK 1.09.2009 CQ[7406] --->
else
begin
  if (TMP_CORRECT = '') then
  begin
    CORRECTNODE = null;
    CORRECTNODE_1 = null;
  end
end
-- MK 1.09.2009 CQ[7406] <---

if (NEED_CONVERT_POPR <> 0) then
  select OUT_KA, OUT_KB, OUT_KC, OUT_KD, OUT_KE,
         OUT_KF, OUT_KG, OUT_KH, OUT_KI, OUT_KJ,
         OUT_KK, OUT_KL, OUT_KM, OUT_K_ITOGO
  from D_SET_POPR_VALUE(:KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :K_ITOGO $$IBE$$*/ /*14460*/ /*$$IBE$$ , :CUR_RABMAT, :CUR_TYPE_TRUD, :CUR_CORRECT, :INSERT_MODE)
  into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH,
       :KI, :KJ, :KK, :KL, :KM, :K_ITOGO $$IBE$$*/ /*14460*/ /*$$IBE$$ ;

-- exception D_WRONG_PARAMS ' KC = '||:KC;
--<

--CQ[9359]execute procedure A_S_APPENDREC
    execute procedure A_S_APPENDREC_NL --CQ[9359]
    (:IDUSER,
    :CUR_ID_SM, :CUR_IDHIER, :CUR_SMETATYPE,
    :CUR_NUMBER1, :NEW_NUMBER2, 0,
    :NEW_SLAVEPARENT, :NEW_ATYPE, :CUR_RABMAT,
     $$IBE$$*/ /*[6921]*/ /*$$IBE$$  :RES_TYPE_TRUD, :CUR_TAB,
    :CUR_ALTTAB, :CUR_NAME_ID, :CUR_IDEDIZM,
    :CUR_EDIZM_TYPE, :NEW_KOLL, '',
    :NEW_RASHOD_RES, CUR_BA, CUR_BB, CUR_BC,
    CUR_BD, CUR_BE, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, :KA, :KB, :KC, :KD, :KE, :KF, :KG,
    :KH, :KI, :KJ, :KK, :KL, :KM, null, null,
    null, null, null, null, null, :CUR_NORM_ID,
    coalesce(:CUR_IDNORMATIVUNIQ, 0), --CQ[9223]0,
    :CUR_KODIR_GROUP,
    :CUR_NORM_PODGROUP  $$IBE$$*/ /*:cur_kodir_podgroup*/ /*$$IBE$$  ,
    :CUR_ISGROUPOKP, :CUR_INSERT_TO_ATYPE,
    :CUR_INSERT_TO_ID, :NEW_ID_RES, :VRPZ,
     $$IBE$$*/ /*--CQ[9359]null, null, null, null, null, null, null, null,
    null, null, null, null, null, null, null,
    null, null, null, null, null, null, null,
    null, null,*/ /*$$IBE$$  null, null, null, null, null,
    PUNKTIND, CUR_NORM_GUID, 0 $$IBE$$*/ /*VIDRAB*/ /*$$IBE$$ ,
    1 $$IBE$$*/ /*APPLAY_INDEX_AS_IS*/ /*Q[9273] 0       */ /*$$IBE$$ ,
    0 $$IBE$$*/ /*APPLAY_FORMULS_AS_IS*/ /*$$IBE$$ ,
    0 $$IBE$$*/ /*APPLAY_POPR_AS_IS*/ /*$$IBE$$ ,
    1, 1, 1, 1, 1, 0, 0, 1, 1, null, -1, :CORRECTNODE,
    :CORRECTNODE_1, null, :NEW_CLCMODE, null, 0,
    null, --CQ[9359] -      
    null, null, null $$IBE$$*/ /*CQ[13179]*/ /*$$IBE$$ , :K_ITOGO $$IBE$$*/ /*14460*/ /*$$IBE$$ 
    )
    returning_values (
     $$IBE$$*/ /*CQ[9359]:OUT_SEA, :OUT_SEB,
    :OUT_SEC, :OUT_SED, :OUT_SEE, :OUT_SEF,
    :OUT_SEG, :OUT_SEH, :OUT_SEI, :OUT_SEJ,
    :OUT_SEK, :OUT_SRA, :OUT_SRB, :OUT_SRC,
    :OUT_SRD, :OUT_SRE, :OUT_SRF, :OUT_SRG,
    :OUT_SRH, :OUT_SRI, :OUT_SRJ, :OUT_SRK,
    :OUT_SRL, :OUT_SRM, */ /*$$IBE$$ 
    :OUT_IDFORMULS, --CQ[9359]
    :ADDED_SLAVE,:OUT_SMETATYPE
    );

 --CQ[9273] -->    
  -- 
  select TIPRAB, VIDRAB $$IBE$$*/ /*, IDTIPR*/ /*$$IBE$$  from  a_smeta
  where ID = :CUR_ID_SM
  into :TYPE_RAB, :VID_RAB $$IBE$$*/ /*, :IDTR*/ /*$$IBE$$ ;
   $$IBE$$*/ /*execute procedure nl_get_res_type_vid_rab(:CUR_IDHIER, :ID_SMREC,  :SMETATYPE, :VRPZ)
    returning_values (:TYPE_RAB, :VID_RAB);*/ /*$$IBE$$ 
  execute procedure A_H_GET_ID_PARENTATYPE(:CUR_IDHIER, 1)
    returning_values (:IDOBJECT);

  -- MK 5.04.2013   CQ[11129] --->
  if (CUR_SMETATYPE = 15) then
  begin
    select o.RES_COPY_FORMULS, o.id_tr
    from a_o_objectparams o
    where NUMBER = :IDOBJECT
    into :IN_RES_COPY_FORMULS, :IDTR;
  end
  else
  begin
    select f.RES_COPY_FORMULS, f.id_tr
    from a_o_factparams f
    where NUMBER = :CUR_SMETATYPE
    into :IN_RES_COPY_FORMULS, :IDTR;
  end

  --select RES_COPY_FORMULS,
  --       coalesce(VELICHSTROBJ, 1)  -- CQ[10381]
  --from a_o_objectparams
  --where NUMBER = :IDOBJECT
  --into :IN_RES_COPY_FORMULS,
  --     :VN_UKR_KOLL;                -- CQ[10381]
  -- MK 5.04.2013   CQ[11129] <---

  -- MK 3.05.2012 CQ[10381] --->
  if (:VN_IS_UNION = 1) then
  begin
    -- MK 5.04.2013   CQ[11129] (  )
    select coalesce(VELICHSTROBJ, 1)
    from a_o_objectparams
    where NUMBER = :IDOBJECT
    into :VN_UKR_KOLL;

    VN_SKOLL = cast(NEW_KOLL as varchar(255));
    if (VN_UKR_KOLL > 0) then
      NEW_KOLL = NEW_KOLL / VN_UKR_KOLL;

    update a_smeta s
    set s.skoll = :VN_SKOLL,
        s.koll = :NEW_KOLL
    where s.id = :ADDED_SLAVE;
  end
  -- MK 3.05.2012 CQ[10381] <---


  -- MK 25.08.2011 CQ[9435] --->
  if (CUR_SMETATYPE = 15) then
    VN_IDSTRUCT = IDOBJECT;
  else
    VN_IDSTRUCT = CUR_SMETATYPE;
  -- MK 25.08.2011 CQ[9435] <---

  --        
  for select l.id
  from level_cost l
  where (l.idobject = :VN_IDSTRUCT)
  --[AA5DC71D18EC]order by l.lorder
  into :ID_LEVEL do
  begin
    if (PASTE_AS_IS = 1) then --    
    begin
    --CQ[9298] -->
      execute procedure A_SMETA_COPY_CENLVL_AS_IS(:CUR_ID_SM,
                  :IDUSER, :ID_LEVEL);
    --CQ[9298] <--
    end
    else
    begin
      --  , ,       
      execute procedure A_S_GET_FORMUL_NRSPZU_NL_1 (:IDUSER, :NEW_ATYPE, :ID_SMREC,
            :IDTR, :VRPZ, :IN_RES_COPY_FORMULS, :ID_LEVEL)
      returning_values (:VN_PA, :VN_PB, :VN_PC, :VN_PD);

      --CQ[10929]execute procedure NL_GET_CENLVL
      execute procedure NL_GET_CENLVL_NEW --CQ[10929]
                       (:ID_LEVEL,
                        case when :CUR_SMETATYPE > 999 then :CUR_SMETATYPE else :IDOBJECT end,
                        :IDUSER, :TYPE_RAB,
                        :VID_RAB, :NEW_ATYPE, :CUR_RABMAT, :CUR_IDHIER,
                        :CUR_NORM_ID, :CUR_NORM_PODGROUP $$IBE$$*/ /*[11537.4]CUR_KODIR_PODGROUP*/ /*$$IBE$$ , :PUNKTIND,
                        0 $$IBE$$*/ /*IDZONE*/ /*$$IBE$$ , :CUR_BA, :CUR_BB, :CUR_BC, :CUR_BD, :CUR_BE,
                        :CUR_ID_SM,
                        :NEED_APPLY_INDEX) --CQ[10929]
      returning_values (:NL_ID_LEVEL_VC, :NL_IDZONE, :NL_ID_LEVEL_INDEX, :NL_IDINDEX,
                        :NL_BA, :NL_BB, :NL_BC, :NL_BD, :NL_BE,
                        :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF,
                        :NL_MG, :NL_MH, :NL_MI,
                        :NL_MJ, :NL_MK, :NL_ML, :NL_MM, --CQ[10529]
                        :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE, :NL_DJ, :NL_DK, :NL_DL, :NL_DM,--CQ[10529]
                        :NL_PUNKTIND,
                        :NL_SPOSOB_RASCH, :NL_RES_VC, :NL_RES_INDEX );


      -- MK 8.04.2013 CQ[11129] --->
      execute procedure A_S_GET_NRSPZU_INDEX_NL_1(:IDUSER, :CUR_ID_SM, :PUNKTIND,
                                                  :ID_SMREC, :ID_LEVEL, :ISMANUAL)
      returning_values(:NL_MF, :NL_MG, :NL_MH, :NL_MI);
      -- MK 8.04.2013 CQ[11129] <---

      --    
      APPLYONRES = 0;
      if (NL_ID_LEVEL_VC is not null) then
      begin
        select coalesce(APPLY_ON_RES, 0) from LEVEL_VC
        where ID_COMPOSE = :NL_ID_LEVEL_VC
        into :APPLYONRES;
      end
      if ((APPLYONRES = 0) and (ISMANUAL <> 0)) then
      --  ( Ctrl+Enter)          . ,
      --     
      begin --!!! 2012/07/09 [B20A7A3DA1A5]        NL_BA??????
        select IDZONE, ID_LEVEL_VC, BB, BC, BD, BE, BASE_INFO from a_s_res_cenlvl
        -- MK 30.08.2013 CQ[11515] --->
        where (id = :ID_RES) and (idcenlvl = :ID_LEVEL)
        --where (id = :NEW_ID_RES) and (idcenlvl = :ID_LEVEL)

          --<<[10929] -   (  ),  IDZONE  :
          and (coalesce(nullif(IDZONE, 0), -3) = coalesce(nullif(:NL_IDZONE, 0), -3))
          --and (coalesce(nullif(IDZONE, 0), -3) = :NL_IDZONE)
        -- MK 30.08.2013 CQ[11515] <---
        into :NL_IDZONE, :NL_ID_LEVEL_VC, :NL_BB, :NL_BC, :NL_BD, :NL_BE, :NL_RES_VC;
      end
      --        
      update a_smeta_cenlvl c
      set c.idzone = :NL_IDZONE,
          --CQ[10529]c.idindex = :NL_IDINDEX,
          --CQ[10529]c.id_level_index = :NL_ID_LEVEL_INDEX,
          c.id_level_vc = :NL_ID_LEVEL_VC,
          c.ba = :NL_BA,
          c.bb = :NL_BB,
          c.bc = :NL_BC,
          c.bd = :NL_BD,
          c.be = :NL_BE,
          c.bf = 0,
          c.bg = 0,
          c.bh = 0,
          c.bi = 0,
          c.bj = 0,
          c.pa = :VN_PA,
          c.pb = :VN_PB,
          c.pc = :VN_PC,
          c.pd = :VN_PD,
          c.base_info = :NL_RES_VC
          --[10584] CURR_CENA, BASE_CALC_INFO, SOURCE_LEVEL_ID  , ..    
           $$IBE$$*/ /*--CQ[10529]c.punktind = :NL_PUNKTIND,
          c.ma = :NL_MA,
          c.mb = :NL_MB,
          c.mc = :NL_MC,
          c.md = :NL_MD,
          c.me = :NL_ME,
          c.mf = :NL_MF,
          c.mg = :NL_MG,
          c.mh = :NL_MH,
          c.mi = :NL_MI,
          c.index_sposobrasch = :NL_SPOSOB_RASCH,
          c.index_info = :NL_RES_INDEX*/ /*$$IBE$$ 
      where (c.id = :CUR_ID_SM) and (c.idcenlvl = :ID_LEVEL);

      update a_smeta_indlvl
      set
          idindex = :NL_IDINDEX,
          id_level_index = :NL_ID_LEVEL_INDEX,
          punktind = :NL_PUNKTIND,
          ma = :NL_MA,
          mb = :NL_MB,
          mc = :NL_MC,
          md = :NL_MD,
          me = :NL_ME,
          mf = :NL_MF,
          mg = :NL_MG,
          mh = :NL_MH,
          mi = :NL_MI,
          --CQ[10529]-->
          MJ = :NL_MJ,
          MK = :NL_MK,
          ML = :NL_ML,
          MM = :NL_MM,
          DA = :NL_DA,
          DB = :NL_DB,
          DC = :NL_DC,
          DD = :NL_DD,
          DE = :NL_DE,
          DJ = :NL_DJ,
          DK = :NL_DK,
          DL = :NL_DL,
          DM = :NL_DM,
          --CQ[10529]<--

          index_sposobrasch = :NL_SPOSOB_RASCH,
          index_info = :NL_RES_INDEX
      where (id = :CUR_ID_SM) and (idcenlvl = :ID_LEVEL);

      execute procedure FILL_INDLVL_DESCR(:CUR_ID_SM, :ID_LEVEL, :NL_ID_LEVEL_INDEX, :NL_RES_INDEX); --CQ[10529]

      --    .   update 
       $$IBE$$*/ /*  :   ->        
      if (not ((APPLYONRES <> 1) and (ISMANUAL = 1))) then --(NL_RES_VC = 1) then
      begin
        execute procedure A_S_RES_UPDATE_CEN_NL (:IDUSER, :NEW_ID_RES, :NL_BB, :NL_BC, :NL_BD, :NL_BE,
                                                 0, :ID_LEVEL, :NL_IDZONE, :NL_ID_LEVEL_VC, :NL_RES_VC);
      end*/ /*$$IBE$$ 
    end
  end


  --CQ[9273] <--

-->DEN cq[4009]

if (NEED_CONVERT_POPR <> 0) then
begin
  execute procedure A_S_RES_APPLAY_CORRECTION(:IDUSER,
      0, null, :ID_RES, :CUR_RABMAT,
      :CUR_TYPE_TRUD, '', '', 1, :APPLY_POPR_MODE)
      returning_values :ID_SM_REC_CH_TRUD,
      :ID_SL_REC_CH_NR_AND_KOLL;
end

-- update a_s_res r set r.CORRECT = '' where r.ID = :id_res;
--<

 $$IBE$$*/ /*added_slave = cur_id_sm; - semenov -   */ /*$$IBE$$ 

suspend;

 $$IBE$$*/ /*    */ /*$$IBE$$ 
if (:RES_NOMERROD <> 0) then
  exit;

 $$IBE$$*/ /*   ,   */ /*$$IBE$$ 
select ORDERVIEW
from SD_IMPACT_SELECTSTRUCT_GETFIRST(:IDUSER, :ID_SMREC, :CUR_SMETATYPE)
into :S_ORDERVIEW;

if (:S_ORDERVIEW > 0) then
begin

  for select I.SMETATYPE
      from SD_IMPACT_SELECTSTRUCT(:IDUSER, :ID_SMREC) I
      where (I.ORDERVIEW >= :S_ORDERVIEW)
      into :OUT_SMETATYPE
  do
    if (not exists( $$IBE$$*/ /* , */ /*$$IBE$$ 
    select *
    from M_UTV_STRUCT_ELEM_IN_AKT
    where ID_STRUCT = :CUR_IDHIER and
          ID_AKT = :OUT_SMETATYPE)) then
    begin
       $$IBE$$*/ /*    ,    */ /*$$IBE$$ 
      for select ID, ID_SOURCE
          from A_S_RES
          where NOMERROD = :ID_RES and
                SMETATYPE = :OUT_SMETATYPE
          into :ID_S_RES, :IDSOURCE
      do
         $$IBE$$*/ /* (!):     :IDSOURCE   */
        /*     */ /*$$IBE$$ 
        for select ADDED_SLAVE, OUT_SMETATYPE,
                    $$IBE$$*/ /*--CQ[9359]OUT_SEA, OUT_SEB, OUT_SEC,
                   OUT_SED, OUT_SEE, OUT_SEF,
                   OUT_SEG, OUT_SEH, OUT_SEI,
                   OUT_SEJ, OUT_SEK, OUT_SRA,
                   OUT_SRB, OUT_SRC, OUT_SRD,
                   OUT_SRE, OUT_SRF, OUT_SRG,
                   OUT_SRH, OUT_SRI, OUT_SRJ,
                   OUT_SRK, OUT_SRL, OUT_SRM,*/ /*$$IBE$$ 
                   OUT_IDFORMULS
            --CQ{9273] from A_S_RES_TO_SLAVEREC(:IDUSER, :ID_S_RES, :IDSOURCE, :PUNKTIND, :VRPZ, :INSERT_MODE, :IDZONE, :APPLY_POPR_MODE)
            from A_S_RES_TO_SLAVEREC_NL(:IDUSER, :ID_S_RES, :IDSOURCE, :PUNKTIND, :VRPZ, :INSERT_MODE, :IDZONE, :APPLY_POPR_MODE, :ISMANUAL, :IDNORMATIVUNIQ, :PASTE_AS_IS)
            into :ADDED_SLAVE, :OUT_SMETATYPE,
                  $$IBE$$*/ /*--CQ[9359]:OUT_SEA, :OUT_SEB, :OUT_SEC,
                 :OUT_SED, :OUT_SEE, :OUT_SEF,
                 :OUT_SEG, :OUT_SEH, :OUT_SEI,
                 :OUT_SEJ, :OUT_SEK, :OUT_SRA,
                 :OUT_SRB, :OUT_SRC, :OUT_SRD,
                 :OUT_SRE, :OUT_SRF, :OUT_SRG,
                 :OUT_SRH, :OUT_SRI, :OUT_SRJ,
                 :OUT_SRK, :OUT_SRL, :OUT_SRM,*/ /*$$IBE$$ 
                 :OUT_IDFORMULS
        do
        begin
           $$IBE$$*/ /*      */ /*$$IBE$$ 
          update A_SMETA
          set NOMERROD = :CUR_ID_SM,
               $$IBE$$*/ /*     */ /*$$IBE$$ 
              NOMERROD1 = :CUR_ID_SM,
              PR_ADDED_REC = 0
          where ID = :ADDED_SLAVE;
           $$IBE$$*/ /*   */ /*$$IBE$$ 
          delete from L_S_PR_ADDINFO
          where ID = :ADDED_SLAVE;
          suspend;
        end

    end
end
 $$IBE$$*/ SUSPEND;
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE A_S_RES_TO_SLAVEREC_NL_2 (
*/
--[15352]
CREATE OR ALTER PROCEDURE A_S_UPDATEREC_NL (
    IDUSER INTEGER,
    ID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME_ID INTEGER,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    B_PR DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    DORECALC INTEGER,
    ID_S_RES INTEGER,
    NEEDUPDATENAME INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    VIDRAB INTEGER,
    CALK_BG INTEGER,
    CALK_BH INTEGER,
    UTV INTEGER,
    UPDATE_ALL_ACTS INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    IDFORMULS INTEGER,
    CLCMODE_RES INTEGER,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
RETURNS (
    RENUM INTEGER,
    REFR_TRUD_STR_MASH INTEGER,
    OUT_ID INTEGER,
    OUT_SMETATYPE INTEGER,
    OUT_ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    OUT_CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    OUT_CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    OUT_IDFORMULS INTEGER)
AS
declare variable id_name integer;
declare variable res_synhron integer;
declare variable old_rashod double precision;
declare variable old_rabmat integer;
declare variable res_type_trud integer;
declare variable nomerrod1 integer;
declare variable normarash_compare double precision;
declare variable old_rashod_compare double precision;
declare variable lidnormo integer;
declare variable lidprice integer;
declare variable lrow integer;
declare variable lCost double precision;
declare variable KOEF double precision; --CQ[7790]

-- MK CQ[12020]
declare variable VN_AUTORENUM_ENABLED integer;
declare variable VN_AUTORENUM_MODE integer;
declare variable VN_AUTORENUM_START integer;
declare variable VN_AUTORENUM_STEP integer;
declare variable VN_NEED_SKIP_EMPTY integer;

declare variable VN_OLD_VIEW_NUM1 integer;
declare variable VN_OLD_VIEW_NUM2 integer;
declare variable VN_NEW_NUM1 integer;
declare variable VN_NEW_NUM2 integer;
declare variable VN_NEW_NUM3 integer;
declare variable VN_IDOBJECT integer;
declare variable VN_START_ID integer;
declare variable VN_NEED_RENUM integer;

declare variable VN_OLD_CLCMODE integer;
declare variable VN_NEW_CLCMODE integer;
declare variable VN_ID integer;
-- MK CQ[14357]
declare variable VN_RENUM_SLAVE_AS_MAIN integer;
begin
--[15352]+
  /*:BN, :BO, :B_ITOGO -   CQ[13178] */

  if ( utv is null ) then utv = 0;
  
  refr_trud_str_mash = 0;
  old_rashod = null;
  
  res_type_trud = null;

  CLCMODE_RES = coalesce(:CLCMODE_RES, 0); -- CQ[12244]
  CLCMODE = coalesce(:CLCMODE, 0); -- CQ[12244]
  
  if (NEEDUPDATENAME = 1)
  then
  begin
  
  id_name = gen_id(b_gen_temp, 1) ;
  insert into b_temp_blob(id, blob1) values (:id_name, :name);
  select blob1 from b_temp_blob where id = :id_name into :name;
  delete from b_temp_blob where id = :id_name ;
  
  select n.IDNAME
  from B_WRITE_NAIMENOVANIE (:iduser, 22, :ID, :NAME) n
  into :name_id; /*      */
  
  end
  
  -- MK CQ[12020] --->
  --   CLCMODE
  select first 1 s.clcmode
  from a_smeta s
  where (s.id = :ID)
  into :VN_OLD_CLCMODE;
  --   10  (   )
  VN_OLD_CLCMODE = getbit(:VN_OLD_CLCMODE, 10);
  VN_NEW_CLCMODE = getbit(:CLCMODE, 10);

  --    
  select first 1 v.number1, v.number2
  from a_smeta_view_num v
  where (v.id = :ID)
  into :VN_OLD_VIEW_NUM1, :VN_OLD_VIEW_NUM2;

  --      (   )
  VN_NEW_NUM3 = NUMBER3;
  --   
  VN_NEED_RENUM = 0;
  VIEW_NUMBER3 = coalesce(VIEW_NUMBER3, 0);

  --  -   , :
  --     (   )
  if ((VIEW_NUMBER1 <> VN_OLD_VIEW_NUM1) or (VIEW_NUMBER2 <> VN_OLD_VIEW_NUM2)) then
  begin
    VN_NEED_RENUM = 1;

    execute procedure s_o_hier_parent_oftype(:idhier, 1)
    returning_values :VN_IDOBJECT;
  
    --     
    execute procedure M_GET_AUTORENUM_PARAM(:VN_IDOBJECT, :SMETATYPE)
    returning_values :VN_AUTORENUM_ENABLED, :VN_AUTORENUM_MODE, :VN_AUTORENUM_START,
                     :VN_AUTORENUM_STEP, :VN_NEED_SKIP_EMPTY,
                     :VN_RENUM_SLAVE_AS_MAIN; -- MK CQ[14357]

    --    
    execute procedure M_GET_NEW_ORDER_NUM_BY_VIEW(:idhier, :SMETATYPE, :ATYPE,
                                                  :VIEW_NUMBER1, :VIEW_NUMBER2,
                                                  :NUMBER1, :NUMBER2) -- MK CQ[12915]
    returning_values :VN_NEW_NUM1, :VN_NEW_NUM2;


    -- MK CQ[12915] -   
    if ((NUMBER1 <> VN_NEW_NUM1) or (NUMBER2 <> VN_NEW_NUM2)) then
      --     
      execute procedure a_s_renum (:iduser, :id, :idhier, :smetatype, :VN_NEW_NUM1, :VN_NEW_NUM2)
      returning_values (:renum);


    renum = 1; -- MK CQ[12915]

    --    
    if (VN_AUTORENUM_ENABLED = 0) then
    begin
      -- MK CQ[14357] --->
      --          . 
      if ((ATYPE = 17) and (VN_RENUM_SLAVE_AS_MAIN <> 0)) then
      begin
        --   ,       
        -- (  +    ())
        select count(*) + 1
        from a_smeta s
        where (s.slaveparent = :ID) and (s.atype = 18)
        into :VN_RENUM_SLAVE_AS_MAIN;
      end

      --       . 
      if (VN_RENUM_SLAVE_AS_MAIN = 0) then
      begin
      -- MK CQ[14357] <---

        --   
        execute procedure M_RENUM_BEFORE_INSERT(:idhier, :SMETATYPE, :ATYPE,
                                                :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3,
                                                :VN_RENUM_SLAVE_AS_MAIN); -- MK CQ[14357]

      -- MK CQ[14357] --->
      end
      --       . 
      --else
      --   .  B384206F
      -- MK CQ[14357] <---
    end
    --    
    else
    begin
      --     
      execute procedure M_GET_START_NUM(:idhier, :SMETATYPE, :VN_AUTORENUM_MODE,
                                        :VN_AUTORENUM_START, :VN_AUTORENUM_STEP,
                                        --    
                                        case when :VN_NEW_NUM1 < :number1 then :VN_NEW_NUM1 else :number1 end,
                                        :VN_RENUM_SLAVE_AS_MAIN) -- MK CQ[14357]
      returning_values :VIEW_NUMBER1;

      --       
      -- MK CQ[14357] --->
      --       
      --   
      if ((:VN_RENUM_SLAVE_AS_MAIN <> 0) and (:ATYPE = 18)) then
        VN_START_ID = SLAVEPARENT; --     
      else
      begin
      -- MK CQ[14357] <---

        ----   
        if (:VN_NEW_NUM1 > :number1) then
        begin
          --      
          VN_START_ID = null;
          select first 1 s.id
          from a_smeta s
          where (s.idhier = :idhier) and (s.smetatype = :SMETATYPE) and
                (s.atype = 17) and (s.number1 > :number1)
          order by s.number1
          into :VN_START_ID;
  
          --      
          if (VN_START_ID is null) then
             VN_START_ID = ID;
        end
        --   
        else
          --     
          VN_START_ID = ID;
      end -- MK CQ[14357]

    end
  end
  --  -    
  else
  begin
    VN_NEW_NUM1 = NUMBER1;
    VN_NEW_NUM2 = NUMBER2;
  end


--  execute procedure a_s_renum ( :iduser, :id, :idhier, :smetatype, :number1, :number2 )
--         returning_values ( :renum );
  -- MK CQ[12020] <---

  
  if ( ( ma is null ) or ( ma = 0 ) ) then ma = 1;
  if ( ( mb is null ) or ( mb = 0 ) ) then mb = 1;
  if ( ( mc is null ) or ( mc = 0 ) ) then mc = 1;
  if ( ( md is null ) or ( md = 0 ) ) then md = 1;
  if ( ( me is null ) or ( me = 0 ) ) then me = 1;
  if ( mf is null ) then mf = 0;
  if ( mg is null ) then mg = 0;
  if ( ( mh is null ) or ( mh = 0 ) ) then mh = 1;
  if ( ( mi is null ) or ( mi = 0 ) ) then mi = 1;
  if ( ( mj is null ) or ( mj = 0 ) ) then mj = 1;
  if ( ( mk is null ) or ( mk = 0 ) ) then mk = 1;
  if ( ( ml is null ) or ( ml = 0 ) ) then ml = 1;
  
  if ( pa is null ) then pa = 0;
  if ( pb is null ) then pb = 0;
  if ( ( pc is null ) or ( pc = 0 ) ) then pc = 1;
  if ( ( pd is null ) or ( pd = 0 ) ) then pd = 1;
  if ( pe is null ) then pe = 0;
  
  if ( atype = 18 )
  then
  begin
  
  select s.normarash, s.rabmat
  from a_smeta s
  where s.id = :id
  into :old_rashod, :old_rabmat;
  
  old_rashod_compare = old_rashod;
  if ( old_rashod is null ) then
     old_rashod_compare = 0;
  
  normarash_compare = normarash;
  if ( normarash is null ) then
     normarash_compare = 0;
  
  if (
      ( lroundn ( normarash_compare , 6 ) <> lroundn ( old_rashod_compare , 6 ) ) or
      ( rabmat <> old_rabmat )
     )
  then
  begin
  
   select r.type_trud
   from a_s_res r
   where r.id = :id_s_res
   into :res_type_trud;
  
   if (res_type_trud in (1, 2) )
   then
   begin
  
    refr_trud_str_mash = 1;
  
   end
  
  end
  
  end
  
  if ( ek is null ) then
    ek = 0;
  
  --CQ[TIMUR 13178] -
  -- [8E8B6724937D] -   ... .
  /*   Ctrl+Enter         ,
               */
  if ((:bn = 0) and (:bo = 0)) then
    CLCMODE = SETBIT(:CLCMODE, 16, 0);
  else
  /*   Ctrl+Enter        ,
               */
  if ((:bn is not null) or (:bo is not null)) then
  begin
    CLCMODE = SETBIT(:CLCMODE, 16, 1);
  end
  else
    CLCMODE = CLCMODE; /*  bn  bo  ,      */
  --CQ[TIMUR 13178]

  update a_smeta s
  set s.idhier        = :idhier,
     s.smetatype      = :smetatype,

     -- MK CQ[12020] --->
     s.number1        = :VN_NEW_NUM1,
     s.number2        = :VN_NEW_NUM2,
     s.number3        = :VN_NEW_NUM3,
     --s.number1        = :number1,
     --s.number2        = :number2,
     --s.number3        = :number3,
     -- MK CQ[12020] <---

     s.slaveparent    = :slaveparent,
     s.atype          = :atype,
     s.rabmat         = :rabmat,
     s.TYPE_TRUD      = :TYPE_TRUD,
     s.tab            = :tab,
     s.alttab         = :alttab,
     s.id_edizm       = :id_edizm,
     s.edizm_type     = :edizm_type,
     s.koll           = :koll,
     s.skoll          = :skoll,
     s.normarash      = :normarash,
     s.ba             = case when :CALK_BA <> 0 then S.BA else coalesce(:BA, 0) end,
     s.bb             = case when :CALK_BB <> 0 then S.BB else coalesce(:BB, 0) end,
     s.bc             = case when :CALK_BC <> 0 then S.BC else coalesce(:BC, 0) end,
     s.bd             = case when :CALK_BD <> 0 then S.BD else coalesce(:BD, 0) end,
     s.be             = case when :CALK_BE <> 0 then S.BE else coalesce(:BE, 0) end,
     s.bf             = coalesce(:bf, 0),
     s.bg             = case when :CALK_BG <> 0 then S.BG else coalesce(:BG, 0) end,
     s.bh             = case when :CALK_BH <> 0 then S.BH else coalesce(:BH, 0) end,
     s.bi             = coalesce(:bi, 0),
     s.bj             = coalesce(:bj, 0),
     --CQ[TIMUR 13178] -- [8E8B6724937D] -   ... .
     s.bn             = case when ((:bn = 0) and (:bo = 0)) then null else coalesce(:bn, s.bn) end,
     s.bo             = case when ((:bn = 0) and (:bo = 0)) then null else coalesce(:bo, s.bo) end,
     s.b_itogo        = coalesce(:b_itogo, s.b_itogo), -- CQ[14457] = case when ((:bn = 0) and (:bo = 0)) then null else coalesce(:b_itogo, s.b_itogo) end,
     --CQ[TIMUR 13178]
     s.B_PR           = :B_PR, --[15352]
     s.ea             = :ea,
     s.eb             = :eb,
     s.ec             = :ec,
     s.ed             = :ed,
     s.ee             = :ee,
     s.ef             = :ef,
     s.eg             = :eg,
     s.eh             = :eh,
     s.ei             = :ei,
     s.ej             = :ej,
     s.ek             = :ek,
     s.ra             = :ra,
     s.rb             = :rb,
     s.rc             = :rc,
     s.rd             = :rd,
     s.re             = :re,
     s.rf             = :rf,
     s.rg             = :rg,
     s.rh             = :rh,
     s.ri             = :ri,
     s.rj             = :rj,
     s.rk             = :rk,
     s.rl             = :rl,
     s.rm             = :rm,
     s.pa             = :pa,
     s.pb             = :pb,
     s.pc             = :pc,
     s.pd             = :pd,
     s.pe             = :pe,
     s.vrpz           = :vrpz,
     s.idtipr         = :idtipr,
     s.ka             = :ka,
     s.kb             = :kb,
     s.kc             = :kc,
     s.kd             = :kd,
     s.ke             = :ke,
     s.kf             = :kf,
     s.kg             = :kg,
     s.kh             = :kh,
     s.ki             = :ki,
     s.kj             = :kj,
     s.kk             = :kk,
     s.kl             = :kl,
     s.km             = :km,
     s.K_ITOGO        = :K_ITOGO /*14460*/,
     s.K_PR           = :K_PR    /*15421*/,
     s.punktind       = :punktind,
     s.ma             = :ma,
     s.mb             = :mb,
     s.mc             = :mc,
     s.md             = :md,
     s.me             = :me,
     s.mf             = :mf,
     s.mg             = :mg,
     s.mh             = :mh,
     s.mi             = :mi,
     s.mj             = :mj,
     s.mk             = :mk,
     s.ml             = :ml,
     s.sstch          = :sstch,
     s.kodzak         = :kodzak,
     s.kodgp          = :kodgp,
     s.kodsp          = :kodsp,
     s.kodisp         = :kodisp,
     s.nach           = :nach,
     s.okonch         = :okonch,
     s.tiprab         = :tiprab,
     s.id_s_res       = :id_s_res,
     s.idnormativ     = :idnormativ,
     s.idnormativuniq = coalesce(:idnormativuniq, 0),
     s.kodir_group    = :kodir_group,
     s.kodir_podgroup = :kodir_podgroup,
     s.isgroupokp     = :isgroupokp,
     s.ARPS_OTHER     = :ARPS_OTHER,
     s.dorecalc       = :DORECALC,
     s.norm_guid      = :norm_guid,
     s.STATUS_REC_CEN = :STATUS_REC_CEN,
     s.vidrab         = :vidrab,
     s.utv            = :utv,
     s.correctnode    = :CorrectNode,
     s.correctnode_1  = :CorrectNode_1,
     s.asubtype       = :asubtype,
     s.CLCMODE        = bin_or( --<< [AE2874690A54] .    A_SMETA   - 
                          bin_and(coalesce(S.CLCMODE, 0), 255), --   
                          bin_and(coalesce(:CLCMODE, 0), bin_xor(255, -1)) ),
     s.IDFORMULS = :IDFORMULS --CQ[9359]
  where s.id = :id;


  -- MK CQ[12020] --->
  if (VN_NEED_RENUM = 1) then
  begin
    --    
    if (VN_AUTORENUM_ENABLED = 0) then
    begin
      -- MK CQ[14357] B384206F --->
      --       . 
      if (VN_RENUM_SLAVE_AS_MAIN <> 0) then
      begin
        --     ( )
        execute procedure MS_SMETA_RENUMBER(:IDHIER, :SMETATYPE, 1,       -- 1 -   
                                            1, :ID, :VN_NEED_SKIP_EMPTY,
                                            :VIEW_NUMBER1, 1,
                                            :VN_RENUM_SLAVE_AS_MAIN);
      end
      -- MK CQ[14357] <---

      --     
      update a_smeta_view_num v
      set v.number1 = :VIEW_NUMBER1,
          v.number2 = :VIEW_NUMBER2,
          v.number3 = :VIEW_NUMBER3
      where (v.id = :ID);

      --         
      -- MK CQ[14357] --->
      --        
      if ((:VN_RENUM_SLAVE_AS_MAIN = 0) and (:ATYPE = 17)) then
      --if (:ATYPE = 17) then
      -- MK CQ[14357] <---
      begin
        for select s.id
        from a_smeta s
        where (s.slaveparent = :ID)
        into :VN_START_ID do
        begin
          update a_smeta_view_num v
          set v.number1 = :VIEW_NUMBER1
          where (v.id = :VN_START_ID);
        end
      end
    end
    --    
    else
    begin
      --   
      -- MK CQ[14357] --->
      --  (    .    )
      if ((:ATYPE = 17) or
         ((:VN_RENUM_SLAVE_AS_MAIN <> 0) and (:ATYPE = 18))) then
      --if (:ATYPE = 17) then
      -- MK CQ[14357] <---
      begin
        --   
        execute procedure MS_SMETA_RENUMBER(:IDHIER, :SMETATYPE, :VN_AUTORENUM_MODE,
                                            1, :VN_START_ID, :VN_NEED_SKIP_EMPTY,
                                            :VIEW_NUMBER1, :VN_AUTORENUM_STEP,
                                            :VN_RENUM_SLAVE_AS_MAIN); -- MK CQ[14357]
      end
      --   
      else if (:ATYPE = 18) then
      begin
        --     
        execute procedure M_AUTORENUM_ONE_REC(:IDHIER, :SMETATYPE, :NUMBER1, :VIEW_NUMBER1);
      end
    end
  end

  --    
  if ((VN_NEW_CLCMODE = 1) and (VN_OLD_CLCMODE = 0)) then
  begin
    --        
    update a_smeta_view_num v
    set v.number1 = null,
        v.number2 = null
    where (v.id = :ID);

    --  
    if (:ATYPE = 17) then
    begin
      for select s.id
      from a_smeta s
      where (s.slaveparent = :ID)
      into :VN_ID do
      begin
        update a_smeta_view_num v
        set v.number1 = null,
            v.number2 = null
        where (v.id = :VN_ID);
      end
    end
  end
  -- MK CQ[12020] <---



  if ( atype = 18 )
  then
  begin
    execute procedure a_s_synhron_slave_res ( :iduser,
                                                1,
                                                0,
                                                :id,
                                                :id_s_res )
              returning_values ( :res_synhron );

    -- CQ[12244] -->   ,     a_s_synhron_slave_res
    update A_S_RES set CLCMODE = :CLCMODE_RES
    where ID = :id_s_res;
    -- CQ[12244] <--

  end

  if ( smetatype <> 15 ) then
    update l_s_pr_addinfo s set
     s.PR_NUMBER1 = :PR_NUMBER1,
     s.PR_NUMBER2 = :PR_NUMBER2,
     s.PR_NUMBER3 = :PR_NUMBER3,
     s.PR_VSEGO   = :PR_VSEGO
    where s.id = :id;

  suspend;
  --    
  if (:UPDATE_ALL_ACTS is null or :UPDATE_ALL_ACTS = 0) then
    exit;
  select NOMERROD1,
      ARPS_OTHER, CORRECTNODE, CORRECTNODE_1,
      IDFORMULS --CQ[9359]
    from A_SMETA
    where ID = :ID
    into :NOMERROD1,
      :OUT_ARPS_OTHER, :OUT_CORRECTNODE, :OUT_CORRECTNODE_1,
      :OUT_IDFORMULS --CQ[9359]
      ;

  if (:NOMERROD1 = :ID) then
  for select ID, SMETATYPE, ID_S_RES
    from A_SMETA
    where NOMERROD = :ID
    into :OUT_ID, :OUT_SMETATYPE, :ID_S_RES
  do
  begin
    /*      */
    update A_SMETA s
      set
        s.rabmat         = :rabmat,
        s.TYPE_TRUD      = :TYPE_TRUD,
        s.tab            = :tab,
        s.alttab         = :alttab,
        s.id_edizm       = :id_edizm,
        s.edizm_type     = :edizm_type,
        s.normarash      = :normarash,
        s.ba             = :ba,
        s.bb             = :bb,
        s.bc             = :bc,
        s.bd             = :bd,
        s.be             = :be,
        s.bf             = :bf,
        s.bg             = :bg,
        s.bh             = :bh,
        s.bi             = :bi,
        s.bj             = :bj,
        --CQ[TIMUR 13178] -- [8E8B6724937D] -   ... .
        s.bn             = case when ((:bn = 0) and (:bo = 0)) then null else coalesce(:bn, s.bn) end,
        s.bo             = case when ((:bn = 0) and (:bo = 0)) then null else coalesce(:bo, s.bo) end,
        s.b_itogo        = coalesce(:b_itogo, s.b_itogo), -- CQ[14457] case when ((:bn = 0) and (:bo = 0)) then null else coalesce(:b_itogo, s.b_itogo) end,
        --CQ[TIMUR 13178]
        s.B_PR           = :B_PR, --[15352]
        s.ea             = :ea,
        s.eb             = :eb,
        s.ec             = :ec,
        s.ed             = :ed,
        s.ee             = :ee,
        s.ef             = :ef,
        s.eg             = :eg,
        s.eh             = :eh,
        s.ei             = :ei,
        s.ej             = :ej,
        s.ek             = :ek,

        s.pa             = :pa,
        s.pb             = :pb,
        s.pc             = :pc,
        s.pd             = :pd,
        s.pe             = :pe,
        s.vrpz           = :vrpz,
        s.idtipr         = :idtipr,
        s.ka             = :ka,
        s.kb             = :kb,
        s.kc             = :kc,
        s.kd             = :kd,
        s.ke             = :ke,
        s.kf             = :kf,
        s.kg             = :kg,
        s.kh             = :kh,
        s.ki             = :ki,
        s.kj             = :kj,
        s.kk             = :kk,
        s.kl             = :kl,
        s.km             = :km,
        s.K_ITOGO        = :K_ITOGO /*14460*/,
        s.K_PR           = :K_PR    /*15421*/,

        s.punktind       = :punktind,
        s.ma             = :ma,
        s.mb             = :mb,
        s.mc             = :mc,
        s.md             = :md,
        s.me             = :me,
        s.mf             = :mf,
        s.mg             = :mg,
        s.mh             = :mh,
        s.mi             = :mi,
        s.mj             = :mj,
        s.mk             = :mk,
        s.ml             = :ml,
        s.sstch          = :sstch,
        s.kodzak         = :kodzak,
        s.kodgp          = :kodgp,
        s.kodsp          = :kodsp,
        s.kodisp         = :kodisp,
        s.nach           = :nach,
        s.okonch         = :okonch,
        s.tiprab         = :tiprab,
        s.idnormativ     = :idnormativ,
        s.idnormativuniq = coalesce(:idnormativuniq, 0),
        s.kodir_group    = :kodir_group,
        s.kodir_podgroup = :kodir_podgroup,
        s.isgroupokp     = :isgroupokp,
        s.ARPS_OTHER     = :OUT_ARPS_OTHER,
        s.dorecalc       = :DORECALC,
        s.norm_guid      = :norm_guid,
        s.STATUS_REC_CEN = 0,
        s.vidrab         = :vidrab,
        s.asubtype       = :asubtype,
        s.CORRECTNODE    = :OUT_CORRECTNODE,
        s.CORRECTNODE_1  = :OUT_CORRECTNODE_1,
        s.IDFORMULS      = :IDFORMULS, --CQ[9359]
        s.CLCMODE = SETBIT(
                      SETBIT( coalesce(s.CLCMODE,0), 15, GETBIT(:CLCMODE, 15) ), -- CQ[12244]
                         16, GETBIT(:CLCMODE, 16))  --CQ[TIMUR 13178]
      where s.ID = :OUT_ID;
    --CQ[6945]  -          
    LIDNORMO = null;
    LIDPRICE = null;
    LROW = null;
    lCost = null;
    KOEF = null;
    select IDNORMO, IDPRICE, ROW, COST, KOEF from smeta_pricepos_info i where i.ID = :id
    into :LIDNORMO, :LIDPRICE, :LROW, :lCost, :KOEF;
    if ((LIDPRICE is not null) and (LIDPRICE <> 0)) then
    begin
      execute procedure set_smeta_priceposinfo(:OUT_ID, :LIDPRICE,  :LIDNORMO, :LROW, :lCost, :KOEF);
    end
    if (:ATYPE = 18) then
    begin
      execute procedure A_S_SYNHRON_SLAVE_RES( :IDUSER, 1, 0, :OUT_ID, :ID_S_RES )
        returning_values (:res_synhron);
      -- CQ[12244] -->   ,     a_s_synhron_slave_res
      update A_S_RES set CLCMODE = :CLCMODE_RES
      where ID = :ID_S_RES;
      -- CQ[12244] <--
    end

    suspend;
  end
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE A_SMETA_CENLVL_UPDATE (
*/
--[15352]
CREATE OR ALTER PROCEDURE A_SMETA_COPY_CENLVL_AS_IS (
    ID INTEGER,
    IDUSER INTEGER,
    IDLEVEL INTEGER)
AS
declare variable IDZONE integer;
declare variable IDINDEX integer;
declare variable ID_LEVEL_INDEX integer;
declare variable ID_LEVEL_VC integer;
declare variable BA double precision;
declare variable BB double precision;
declare variable BC double precision;
declare variable BD double precision;
declare variable BE double precision;
declare variable BF double precision;
declare variable BG double precision;
declare variable BH double precision;
declare variable BI double precision;
declare variable BJ double precision;
--CQ[TIMUR 13178]
declare variable BN double precision;
declare variable BO double precision;
declare variable B_ITOGO double precision;
--CQ[TIMUR 13178]
declare B_PR double precision; --[15352]
declare variable PUNKTIND varchar(42);
declare variable MA double precision;
declare variable MB double precision;
declare variable MC double precision;
declare variable MD double precision;
declare variable ME double precision;
declare variable MF double precision;
declare variable MG double precision;
declare variable MH double precision;
declare variable MI double precision;
declare variable PA double precision;
declare variable PB double precision;
declare variable PC double precision;
declare variable PD double precision;
declare variable INDEX_SPOSOBRASCH integer;
declare variable BASE_INFO integer;
declare variable INDEX_INFO integer;

-- MK CQ[12678]
declare variable RABMAT integer;
declare variable TAB varchar(42);

declare variable MJ double precision;
declare variable MK double precision;
declare variable ML double precision;
declare variable MM double precision;

declare M_PR double precision; --[15352]
begin
--[15352]

  for select 0, 0, 0, 0,
             BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BN, BO, B_ITOGO,
             B_PR, --[15352]
             PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI,
             PA, PB, PC,
             PD, null, 0, 0,
             RABMAT, TAB -- MK CQ[11461, 12678]
      from A_SMETA
      where ID = :ID
      into :IDZONE, :IDINDEX,
           :ID_LEVEL_INDEX, :ID_LEVEL_VC,
           :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
           :B_PR, --[15352]
           :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
           :PA, :PB, :PC,
           :PD, :INDEX_SPOSOBRASCH, :BASE_INFO, :INDEX_INFO,
           :RABMAT, :TAB -- MK CQ[11461, 12678]
  do
  begin
    /*CQ[10529]
    execute procedure A_SMETA_INS_OR_UPD_CENLVL (:ID, :IDLEVEL, :IDZONE, :IDINDEX,
          :ID_LEVEL_INDEX, :ID_LEVEL_VC, :BA, :BB, :BC, :BD, :BE,
          :BF, :BG, :BH, :BI, :BJ, :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :PA, :PB, :PC, :PD,
          :MF, :MG, :MH, :MI, :INDEX_SPOSOBRASCH, :BASE_INFO, :INDEX_INFO); */
    --CQ[10529]-->
    execute procedure A_SMETA_INS_OR_UPD_CENLVL (:ID, :IDLEVEL, :IDZONE, :ID_LEVEL_VC,
          :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
          :B_PR, --[15352]
          :PA, :PB, :PC, :PD,
          :BASE_INFO);


    -- MK CQ[11461, 12678] --->
    -- 
    ML = ME; --  
    -- 
    MM = MC; --  
    -- 
    MJ = MB; --  
    -- 
    if (:RABMAT = 0) then        -- 
      MK = MA; --  
    else if (:RABMAT = 1) then   -- 
    begin
      if (:TAB starting '2') then  --  
        MK = MD; --  
      else                       --  
        MK = ME; --  
    end
    else if (:RABMAT = 2) then   -- 
      MK = MC; --  
    else if (:RABMAT = 3) then   -- 
      MK = MB; --  
    -- MK CQ[11461, 12678] <---

    execute procedure A_SMETA_INS_OR_UPD_INDLVL (:ID, :IDLEVEL, :IDINDEX, :ID_LEVEL_INDEX,
          :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
          -- MK CQ[11461, 12678] --->
          :MJ, :MK, :ML, :MM,
          :M_PR, --[15352] - 
          :MA, :MB, :MC, :MD, :ME, :MJ, :MK, :ML, :MM,
          --1,1,1,1,1,1,1,1,1,1,1,1,1, --CQ[10529]
          -- MK CQ[11461, 12678] <---
          :INDEX_SPOSOBRASCH, :INDEX_INFO);
    --CQ[10529]<--
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE A_SMETA_INS_OR_UPD_CENLVL (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDZONE INTEGER,
    ID_LEVEL_VC INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    B_PR DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    BASE_INFO INTEGER)
AS
begin
--[15352]+

  if (not exists(select *
                 from A_SMETA
                 where ID = :ID)) then
  begin
    exception AE_RECORDNOTFOUND1;
    exit;
  end
  --CQ[10529]if (INDEX_SPOSOBRASCH is null) then
    --CQ[10529]INDEX_SPOSOBRASCH = 2;-- INDEX_SPOSOBRASCH - default =  
  if (not exists(select ID
                 from A_SMETA_CENLVL
                 where ((ID = :ID) and
                       (IDCENLVL = :IDCENLVL)))) then
    insert into A_SMETA_CENLVL (ID, IDCENLVL,
                                IDZONE,
                                --CQ[10529]IDINDEX,
                                --CQ[10529]ID_LEVEL_INDEX,
                                ID_LEVEL_VC, BA,
                                BB, BC, BD, BE,
                                BF, BG, BH, BI,
                                BJ, BN, BO, B_ITOGO,
                                B_PR, --[15352]
                                --CQ[10529]PUNKTIND, MA,
                                --CQ[10529]MB, MC, MD, ME,
                                --CQ[10529]MF, MG, MH, MI,
                                PA, PB, PC, PD,
                                --CQ[10529]INDEX_SPOSOBRASCH,
                                BASE_INFO,
                                --CQ[10529]INDEX_INFO
                                BASE_CALC_INFO, -- MK 19.06.2012 CQ[10565]
                                ID_VALUTE       -- MK CQ[11989]
                                )
    values (:ID, :IDCENLVL, :IDZONE,
            --CQ[10529]:IDINDEX, :ID_LEVEL_INDEX,
            :ID_LEVEL_VC, :BA,
            :BB, :BC, :BD, :BE, :BF, :BG, :BH,
            :BI, :BJ, :BN, :BO, :B_ITOGO,
            :B_PR, --[15352]
            --CQ[10529]:PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
            :PA, :PB, :PC, :PD, --CQ[10529]:INDEX_SPOSOBRASCH,
            :BASE_INFO, --CQ[10529], :INDEX_INFO
      ----<<>>      24 -- MK 19.06.2012 CQ[10565] 24 = 11000
      case when :BASE_INFO in (1/*csFromVC*/,2/*csDirect*/) then
            8/*24*/ -- MK 19.06.2012 CQ[10565] 24 = 11000/*cbUnknown*/ 8=01000[12113]
      else  15/*31*/ -- Sem 2012/07/03 [10567-.2] 31 = 11111/*cbNeedCalc*/ 15=01111[12113]
      end,
            1 -- MK CQ[11989]
            );
  else
    update A_SMETA_CENLVL C
    set C.IDZONE = :IDZONE,
        --CQ[10529]C.IDINDEX = :IDINDEX,
        --CQ[10529]C.ID_LEVEL_INDEX = :ID_LEVEL_INDEX,
        C.ID_LEVEL_VC = :ID_LEVEL_VC,
        C.BA = :BA,
        C.BB = :BB,
        C.BC = :BC,
        C.BD = :BD,
        C.BE = :BE,
        C.BF = :BF,
        C.BG = :BG,
        C.BH = :BH,
        C.BI = :BI,
        C.BJ = :BJ,
        --CQ[TIMUR 13178]
        C.BN = :BN,
        C.BO = :BO,
        C.B_ITOGO = :B_ITOGO,
        --CQ[TIMUR 13178]
        C.B_PR = :B_PR, --[15352]
        /*CQ[10529]C.PUNKTIND = :PUNKTIND,
        C.MA = :MA,
        C.MB = :MB,
        C.MC = :MC,
        C.MD = :MD,
        C.ME = :ME,
        C.MF = :MF,
        C.MG = :MG,
        C.MH = :MH,
        C.MI = :MI,*/
        C.PA = :PA,
        C.PB = :PB,
        C.PC = :PC,
        C.PD = :PD,
        --CQ[10529]C.INDEX_SPOSOBRASCH = :INDEX_SPOSOBRASCH,
        C.BASE_INFO = :BASE_INFO
        --CQ[10529]C.INDEX_INFO = :INDEX_INFO
    where (C.ID = :ID) and
          (C.IDCENLVL = :IDCENLVL);

end
^

--[15352]
CREATE OR ALTER PROCEDURE A_SMETA_INS_OR_UPD_INDLVL (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDINDEX INTEGER,
    ID_LEVEL_INDEX INTEGER,
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    M_PR DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    INDEX_SPOSOBRASCH INTEGER,
    INDEX_INFO INTEGER)
AS
begin
--[15352]+

  if (not exists(select *
                 from A_SMETA
                 where ID = :ID)) then
  begin
    exception AE_RECORDNOTFOUND1;
    exit;
  end
  if (INDEX_SPOSOBRASCH is null) then
    INDEX_SPOSOBRASCH = 2;-- INDEX_SPOSOBRASCH - default =  
  if (not exists(select ID
                 from A_SMETA_INDLVL
                 where ((ID = :ID) and
                       (IDCENLVL = :IDCENLVL)))) then
    insert into A_SMETA_INDLVL (ID, IDCENLVL, IDINDEX, ID_LEVEL_INDEX, PUNKTIND, MA, MB, MC, MD, ME,
                                MF, MG, MH, MI,
                                MJ, MK, ML, MM,
                                M_PR, --[15352]
                                DA, DB, DC,--CQ[10529]
                                DD, DE, DJ, DK, DL, DM,--CQ[10529]
                                INDEX_SPOSOBRASCH, INDEX_INFO)
    values (:ID, :IDCENLVL, :IDINDEX, :ID_LEVEL_INDEX, :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG,
            :MH, :MI,
            :MJ, :MK, :ML, :MM,
            :M_PR, --[15352]
            :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM,--CQ[10529]
            :INDEX_SPOSOBRASCH, :INDEX_INFO);
  else
    update A_SMETA_INDLVL C set
      C.IDINDEX = :IDINDEX,
      C.ID_LEVEL_INDEX = :ID_LEVEL_INDEX,
      C.PUNKTIND = :PUNKTIND,
      C.MA = :MA,
      C.MB = :MB,
      C.MC = :MC,
      C.MD = :MD,
      C.ME = :ME,
      C.MF = :MF,
      C.MG = :MG,
      C.MH = :MH,
      C.MI = :MI,
      --CQ[10529]-->
      C.MJ = :MJ,
      C.MK = :MK,
      C.ML = :ML,
      C.MM = :MM,
      C.M_PR = :M_PR, --[15352]
      C.DA = :DA,
      C.DB = :DB,
      C.DC = :DC,
      C.DD = :DD,
      C.DE = :DE,
      C.DJ = :DJ,
      C.DK = :DK,
      C.DL = :DL,
      C.DM = :DM,
      --CQ[10529]<--

      C.INDEX_SPOSOBRASCH = :INDEX_SPOSOBRASCH,
      C.INDEX_INFO = :INDEX_INFO
    where (C.ID = :ID) and
          (C.IDCENLVL = :IDCENLVL);

end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE A_SMETA_NL_IMP (
*/
--[15352]
/* 
CREATE OR ALTER PROCEDURE A_SMETA_SELECT_CLIPBOARD (
*/

--[15352]
CREATE OR ALTER PROCEDURE B_IMP_I_CORRECTION (
    IDUSER INTEGER,
    IMPMODE INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    MM VARCHAR(50),
    MN VARCHAR(50),
    MO VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    ML VARCHAR(50),
    MM_NEW VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER)
RETURNS (
    ID INTEGER)
AS
BEGIN
--[15352]
/*
  MM, MN, MO      
*/
  if (:ID_CORE_TYPE = 0) then
    ID_CORE_TYPE = null;

  IF (:IDGC <> 0) THEN
  BEGIN
/*
    IF (:COD <> '') THEN
      SELECT FIRST 1 C.ID
        FROM K_CORRECTION_TABLE C
        WHERE C.COD = :COD
          and C.IDGC = :IDGC
        plan (C INDEX (K_CORRECTION_TABLE_COD_IDX))
        INTO :ID;

    IF (:ID IS NOT NULL) THEN
      EXECUTE PROCEDURE K_CORRECTION_TABLE_UPDATE (
        :ID, :COD, :NAME, :MB, :MC, :MD, :ME, :MG, :MM, :NOTE, :IDUSER);
    ELSE
*/
    BEGIN

      --<rvs:2006/12/12> [1F01FADA57C7]
      if (:MM <> '' and :MM <> '*1') then
        --   
        ML = :MM;

      if (:MN <> '' and :MN <> '*1') then
        --  
        MM_NEW = :MN;

      if (:MO <> '' and :MO <> '*1') then
      begin
        -- 
        MG41 = :MO;
        MH41 = :MO;
        --      
        --    
      end
      --</rvs:2006/12/12>

      ID = GEN_ID (A_G_SMETA, 1);
      EXECUTE PROCEDURE K_CORRECTION_TABLE_INSERT (
        :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, /*:MG,*/ :MJ, MK,
        MG41, MH41, /*MN41, MO41,*/ML, MM_NEW,
        :NOTE, :IDUSER, :ID_CORE_TYPE, ''/*14459*/, ''/*15421*/);

      -- rvs:2006/12/12 -       [1F01FADA57C7]
      --/*       
      --   -  (!)         */
      --
      --if (:MM <> '' and :MM <> '*1') then
      --  /*      */
      --  insert into K_CORRECTION_RESURS(
      --            ID_SELF, ID_CORRECTION_TABLE, RABMAT, CORRECTION )
      --    values( gen_id(a_g_smeta, 1),    :ID,      3,        :MM );
      --
      --if (:MN <> '' and :MN <> '*1') then
      --  /*      */
      --  insert into K_CORRECTION_RESURS(
      --            ID_SELF, ID_CORRECTION_TABLE, RABMAT, CORRECTION )
      --    values( gen_id(a_g_smeta, 1),    :ID,      2,        :MN );
      --
      --if (:MO <> '' and :MO <> '*1') then
      --  /*      */
      --  insert into K_CORRECTION_RESURS(
      --            ID_SELF, ID_CORRECTION_TABLE, RABMAT, CORRECTION )
      --    values( gen_id(a_g_smeta, 1),    :ID,      1,        :MO );

    END
  END

  SUSPEND;

  WHEN ANY DO
  BEGIN
    ID = NULL;
    SUSPEND;
  END
END
^

--[15352]
CREATE OR ALTER PROCEDURE B_IMP_I_CORRECTION_V2 (
    IDUSER INTEGER,
    IMPMODE INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    MM VARCHAR(50),
    MN VARCHAR(50),
    MO VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    ML VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
RETURNS (
    ID INTEGER)
AS
begin
--[15352]+
  if (:ID_CORE_TYPE = 0) then
    ID_CORE_TYPE = null;

  if (:IDGC <> 0) then
  begin
    begin
      ID = gen_id(A_G_SMETA, 1);
      execute procedure K_CORRECTION_TABLE_INSERT(:ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, :MJ,
        MK, MG41, MH41, ML, MM, :NOTE, :IDUSER, :ID_CORE_TYPE, :M_ITOGO /*CQ[14459]*/, :M_PR /*CQ[15421]*/);
    end
  end
  suspend;
  when any do
  begin
    ID = null;
    suspend;
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE BASE_FORMUL_IU (
    ID INTEGER,
    IDCENLVL INTEGER,
    SBA VARCHAR(255),
    SBB VARCHAR(255),
    SBC VARCHAR(255),
    SBD VARCHAR(255),
    SBE VARCHAR(255),
    SBF VARCHAR(255),
    SBG VARCHAR(255),
    SBH VARCHAR(255),
    SBI VARCHAR(255),
    SBJ VARCHAR(255),
    SBQ VARCHAR(255))
AS
begin
--[15352]+
  if (exists(select * from A_SMETA_CENLVL_BASE_FORMUL where (ID = :ID) and (IDCENLVL = :IDCENLVL))) then
  begin
    update A_SMETA_CENLVL_BASE_FORMUL f
    set f.SBA = :SBA,
        f.SBB = :SBB,
        f.SBC = :SBC,
        f.SBD = :SBD,
        f.SBE = :SBE,
        f.SBF = :SBF,
        f.SBG = :SBG,
        f.SBH = :SBH,
        f.SBI = :SBI,
        f.SBJ = :SBJ,
        f.SBQ = :SBQ /*15353*/
    where (f.ID = :ID) and (f.IDCENLVL = :IDCENLVL);
  end
  else
  begin
    insert into A_SMETA_CENLVL_BASE_FORMUL(ID, IDCENLVL, SBA, SBB, SBC, SBD,
                                           SBE, SBF, SBG, SBH, SBI, SBJ, SBQ)
    values (:ID, :IDCENLVL, :SBA, :SBB, :SBC, :SBD,
            :SBE, :SBF, :SBG, :SBH, :SBI, :SBJ, :SBQ /*15353*/);
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE CORRECTIONS_EXP_XML (
    AID INTEGER,
    ATYPE INTEGER)
RETURNS (
    ID INTEGER,
    REPLACECORRECTION INTEGER,
    CORRECTIONRULE INTEGER,
    SPREADONEXISTSREC INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
begin
--[15352]+
  ID = :AID;-- 
  for select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM, CORRECTNODE, CORRECTNODE_1,
      K_ITOGO /*CQ[14462]*/, K_PR
  from DM_GET_CORRECTION_BY_TYPE(:AID, :ATYPE)
  where ID = :AID
  into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :CORRECTNODE,
       :CORRECTNODE_1, :K_ITOGO /*CQ[14462]*/, K_PR/*15421*/
  do
  begin
    if (ATYPE = 1) then
    begin
      SPREADONEXISTSREC = 1;
      select REPLACECORRECTION, CORRECTIONRULE
      from A_O_OBJECTPARAMS
      where NUMBER = :AID
      into :REPLACECORRECTION, :CORRECTIONRULE;
    end
    else
    if (ATYPE = 3) then
    begin
      select REPLACECORRECTION, CORRECTIONRULE, SPREADONEXISTSREC
      from A_O_PARAMS_LS
      where ID = :AID
      into :REPLACECORRECTION, :CORRECTIONRULE, :SPREADONEXISTSREC;
    end
    else
    if (ATYPE in (4, 5)) then
    begin
      select REPLACECORRECTION, CORRECTIONRULE, SPREADONEXISTSREC
      from A_O_PARAMS_R_PR
      where ID = :AID
      into :REPLACECORRECTION, :CORRECTIONRULE, :SPREADONEXISTSREC;
    end
  end
  suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE D_GET_CORRECTIONS (
    IDGROUP INTEGER,
    IDLIST BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDLISTCOUNT INTEGER,
    USE_IDLIST INTEGER,
    IDUSER INTEGER,
    ORDER_BY_USAGE INTEGER)
RETURNS (
    ID INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    ML VARCHAR(50),
    MM VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER,
    CORE_TYPE_NAME VARCHAR(100),
    USAGE INTEGER,
    USAGE_DATE DATE,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
declare variable REC_ID integer;
begin
--[15352]+
  if (USE_IDLIST is null) then USE_IDLIST = 0;
  if (ORDER_BY_USAGE is null) then ORDER_BY_USAGE = 0;

  REC_ID = gen_id(B_GEN_TEMP, 1) ;
  insert into B_TEMP_BLOB (ID, BLOB1) values (:REC_ID, :IDLIST);
  select BLOB1 from B_TEMP_BLOB where ID = :REC_ID into :IDLIST;
  delete from B_TEMP_BLOB where ID = :REC_ID;

  if (USE_IDLIST = 0)  then
  begin
    for select ID, IDGC, COD, NAME, MB, MC, MD, ME, /*MG,*/ MJ, MK, MG41, MH41, ML, MM, NOTE, ID_CORE_TYPE, USAGE, USAGE_DATE,
      M_ITOGO /*[14459]*/, M_PR /*15421*/
    from K_CORRECTION_TABLE_SELECT(:IDGROUP, :IDUSER, :ORDER_BY_USAGE)
    into :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, /*:MG,*/ :MJ, :MK, :MG41, :MH41, :ML, :MM, :NOTE, :ID_CORE_TYPE, :USAGE, :USAGE_DATE,
      :M_ITOGO /*[14459]*/, :M_PR /*15421*/
    do
    begin
      CORE_TYPE_NAME = '';
      if (not ID_CORE_TYPE is null) then
        select first 1 NAME from D_COR_TYPE where ID = :ID_CORE_TYPE into :CORE_TYPE_NAME;
      suspend;
    end
  end
  else
  begin
    if (ORDER_BY_USAGE = 0) then
    begin
      for select k.ID, coalesce(u.USAGE, 0), u.USAGE_DATE from S_INTFROMBLOB_SELECT (:IDLIST, :IDLISTCOUNT) B
        left join K_CORRECTION_TABLE k on (B.FVALUE = k.ID)
        left join D_CORRECTION_USAGE u on (u.ID_USER = :IDUSER) and (B.FVALUE = u.ID_CORRECTION)
        order by k.COD
        into :ID, :USAGE, :USAGE_DATE
      do
      for select ID, IDGC, COD, NAME, MB, MC, MD, ME, MJ, MK, MG41, MH41, ML, MM, NOTE, ID_CORE_TYPE,
        M_ITOGO /*[14459]*/, M_PR /*15421*/
        from K_CORRECTION_TABLE
        where ID = :ID
      into :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, :MJ, :MK, :MG41, :MH41, :ML, :MM, :NOTE, :ID_CORE_TYPE,
        :M_ITOGO /*[14459]*/, :M_PR /*15421*/
      do
      begin
        CORE_TYPE_NAME = null;
        if (not ID_CORE_TYPE is null) then
          select first 1 NAME from D_COR_TYPE where ID = :ID_CORE_TYPE into :CORE_TYPE_NAME;
        suspend;
      end

    end
    else
    if (ORDER_BY_USAGE = 1) then
    begin
      for select k.ID, coalesce(u.USAGE, 0), u.USAGE_DATE from S_INTFROMBLOB_SELECT (:IDLIST, :IDLISTCOUNT) B
        left join K_CORRECTION_TABLE k on (B.FVALUE = k.ID)
        left join D_CORRECTION_USAGE u on (u.ID_USER = :IDUSER) and (B.FVALUE = u.ID_CORRECTION)
        order by coalesce(u.USAGE, 0) desc, k.COD
        into :ID, :USAGE, :USAGE_DATE
      do
      for select ID, IDGC, COD, NAME, MB, MC, MD, ME, MJ, MK, MG41, MH41, ML, MM, NOTE, ID_CORE_TYPE,
        M_ITOGO /*[14459]*/, M_PR /*15421*/
        from K_CORRECTION_TABLE
        where ID = :ID
      into :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, :MJ, :MK, :MG41, :MH41, :ML, :MM, :NOTE, :ID_CORE_TYPE,
        :M_ITOGO /*[14459]*/, :M_PR /*15421*/
      do
      begin
        CORE_TYPE_NAME = null;
        if (not ID_CORE_TYPE is null) then
          select first 1 NAME from D_COR_TYPE where ID = :ID_CORE_TYPE into :CORE_TYPE_NAME;
        suspend;
      end
    end
    else
    if (ORDER_BY_USAGE = 2) then
    begin
      for select k.ID, coalesce(u.USAGE, 0), u.USAGE_DATE from S_INTFROMBLOB_SELECT (:IDLIST, :IDLISTCOUNT) B
        left join K_CORRECTION_TABLE k on (B.FVALUE = k.ID)
        left join D_CORRECTION_USAGE u on (u.ID_USER = :IDUSER) and (B.FVALUE = u.ID_CORRECTION)
        order by u.USAGE_DATE desc, k.COD
        into :ID, :USAGE, :USAGE_DATE
      do
      for select ID, IDGC, COD, NAME, MB, MC, MD, ME, MJ, MK, MG41, MH41, ML, MM, NOTE, ID_CORE_TYPE,
        M_ITOGO /*[14459]*/, M_PR /*15421*/
        from K_CORRECTION_TABLE
        where ID = :ID
      into :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, :MJ, :MK, :MG41, :MH41, :ML, :MM, :NOTE, :ID_CORE_TYPE,
        :M_ITOGO /*[14459]*/, :M_PR /*15421*/
      do
      begin
        CORE_TYPE_NAME = null;
        if (not ID_CORE_TYPE is null) then
          select first 1 NAME from D_COR_TYPE where ID = :ID_CORE_TYPE into :CORE_TYPE_NAME;
        suspend;
      end
    end


/*
    for select ID, IDGC, COD, NAME, MB, MC, MD, ME, MJ, MK, MG41, MH41, ML, MM, NOTE, ID_CORE_TYPE, USAGE
        from K_CORRECTION_TABLE_SELECT_EX(:IDUSER, :IDLIST, :IDLISTCOUNT)
        into :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, :MJ, :MK, :MG41, :MH41, :ML, :MM, :NOTE, :ID_CORE_TYPE, :USAGE
    do
    begin
      CORE_TYPE_NAME = null;
      if (not ID_CORE_TYPE is null) then
        select first 1 NAME from D_COR_TYPE where ID = :ID_CORE_TYPE into :CORE_TYPE_NAME;
      suspend;
    end
*/
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE D_GET_HIER_POPRS (
    ID_USER INTEGER,
    ID_HIER INTEGER)
RETURNS (
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
declare variable ATYPE integer;
begin
 --[15352]+
   ATYPE = null;

   select first 1 ATYPE from A_O_HIER where NUMBER = :ID_HIER into :ATYPE;

   if ( not ATYPE is null ) then
      if ( ATYPE = 3 ) then
         for select CORRECTNODE, CORRECTNODE_1, KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                    K_ITOGO, K_PR
           from A_O_PARAMS_LS
           where ID = :ID_HIER
         into :CORRECTNODE, :CORRECTNODE_1, KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
              :K_ITOGO /*CQ[14462]*/, :K_PR/*15421*/
         do
           suspend;
      else if ( ATYPE in (4,5) ) then
         for select CORRECTNODE, CORRECTNODE_1, KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                    K_ITOGO, K_PR
           from A_O_PARAMS_R_PR
           where ID = :ID_HIER
         into :CORRECTNODE, :CORRECTNODE_1, KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
              :K_ITOGO /*CQ[14462]*/, :K_PR/*15421*/
         do
            suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE D_GET_POPR_VALUE (
    IN_KA VARCHAR(50),
    IN_KB VARCHAR(50),
    IN_KC VARCHAR(50),
    IN_KD VARCHAR(50),
    IN_KE VARCHAR(50),
    IN_KF VARCHAR(50),
    IN_KG VARCHAR(50),
    IN_KH VARCHAR(50),
    IN_KI VARCHAR(50),
    IN_KJ VARCHAR(50),
    IN_KK VARCHAR(50),
    IN_KL VARCHAR(50),
    IN_KM VARCHAR(50),
    IN_K_ITOGO VARCHAR(50),
    IN_K_PR VARCHAR(50),
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    FROM_PRICE_POPRS INTEGER)
RETURNS (
    CORRECT VARCHAR(50))
AS
  declare variable RT_TRUD integer;
  declare variable RT_MASH integer;
  declare variable RT_MAT integer;

  declare variable TT_BUILD integer;
  declare variable TT_MASH integer;
begin
--[15352]+
  RT_TRUD = 1;
  RT_MASH = 2;
  RT_MAT  = 3;

  TT_BUILD = 1;
  TT_MASH  = 2;

  CORRECT = '';

  if (RABMAT = RT_TRUD) then
  begin
    if (TYPE_TRUD = TT_BUILD) then
    begin
      if (FROM_PRICE_POPRS = 1) then
        CORRECT = :IN_KE;
      else
        CORRECT = :IN_KG;
    end
    else
    if (TYPE_TRUD = TT_MASH) then
    begin
      if (FROM_PRICE_POPRS = 1) then
        CORRECT = :IN_KD;
      else
        CORRECT = :IN_KH;
    end
  end
  else
  if (RABMAT = RT_MAT) then
  begin
    if (FROM_PRICE_POPRS = 1) then
      CORRECT = :IN_KB;
    else
      CORRECT = :IN_KL;
  end
  else
  if (RABMAT = RT_MASH) then
  begin
    if (FROM_PRICE_POPRS = 1) then
      CORRECT = :IN_KC;
    else
      CORRECT = :IN_KM;
  end
  suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE D_GET_SMETA_REC (
    IDUSER INTEGER,
    IN_IDOBJECT INTEGER,
    IN_ID INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    STATUS_REC_CEN INTEGER,
    VIDRAB INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    RES_PRICE_COUNT INTEGER,
    SMETATYPE INTEGER,
    TYPE_TRUD INTEGER,
    IDFORMULS INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
declare variable lyear integer;
declare variable lmonth integer;
declare variable use_only_utv_procent integer;
BEGIN
--[15352]+
--[8443]
  SELECT FIRST 1 s.id, s.idhier, s.smetatype, s.number1, number2, number3,
              s.slaveparent, s.atype, s.rabmat, s.tab, s.alttab,
              s.name_id, s.id_edizm, s.edizm_type, s.koll, s.skoll, s.normarash,
              s.ba, s.bb, s.bc, s.bd, s.be, s.bf, s.bg, s.bh, s.bi, s.bj,
              --CQ[9359]s.sea,s.seb,s.sec,s.sed,s.see,s.sef,s.seg,s.seh,s.sei, s.sej, s.sek,
              s.ea, s.eb, s.ec, s.ed, s.ee, s.ef, s.eg, s.eh, s.ei, s.ej, s.ek,
              --CQ[9359]s.sra,s.srb,s.src,s.srd,s.sre,s.srf,s.srg,s.srh,s.sri,s.srj,s.srk,s.srl,s.srm,
              s.ra, s.rb, s.rc, s.rd, s.re, s.rf, s.rg, s.rh, s.ri, s.rj, s.rk, s.rl, s.rm,
              s.pa, s.pb, s.pc, s.pd, s.pe, s.vrpz, s.idtipr,
              s.ka, s.kb, s.kc, s.kd, s.ke, s.kf, s.kg, s.kh, s.ki, s.kj, s.kk, s.KL, s.KM,
              s.punktind, s.ma, s.mb, s.mc, s.md, s.me, s.mf, s.mg, s.mh, s.mi, s.mj, s.mk, s.ml,
              s.sstch, s.kodzak, s.kodgp, s.kodsp, s.kodisp, s.nach,
              s.okonch, s.tiprab, s.vidrab, s.idnormativ,/*coalesce (i.idprice,0)*/s.idnormativuniq, s.kodir_group, s.kodir_podgroup, s.isgroupokp, s.arps_other,
              s.id_s_res, s.pr_added_rec, s.norm_guid, s.status_rec_cen,
              s.utv, s.correctnode, s.correctnode_1, s.asubtype, s.clcmode, /*coalesce (i.idprice,0)*/s.idnormativuniq,
              S.type_trud, --CQ[TIMUR 6922]-->  TYPE_TRUD
              S.IDFORMULS/*CQ[9359]*/, S.K_ITOGO/*14460*/, S.K_PR/*15421*/
       FROM a_smeta s
      -- LEFT OUTER JOIN smeta_pricepos_info i ON i.id = s.id --CQ [6884]
       WHERE (s.id = :in_id)
       INTO :id, :idhier, :smetatype, :number1, number2, number3,
            :slaveparent, :atype, :rabmat, :tab, :alttab,
            :name_id, :id_edizm, :edizm_type, :koll, :skoll, :normarash,
            :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi, :bj,
            --CQ[9359]:sea,:seb,:sec,:sed,:see,:sef,:seg,:seh,:sei, :sej, :sek,
            :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
            --CQ[9359]:sra,:srb,:src,:srd,:sre,:srf,:srg,:srh,:sri,:srj,:srk,:srl,:srm,
            :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
            :pa, :pb, :pc, :pd, :pe, :vrpz, :idtipr,
            :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM, 
            :punktind, :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :mj, :mk, :ml,
            :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
            :okonch, :tiprab, :vidrab, :idnormativ, :idnormativuniq, :kodir_group, :kodir_podgroup, :isgroupokp, :arps_other,
            :id_s_res, :pr_added_rec, :norm_guid, :status_rec_cen,
            :utv, :CorrectNode, :CorrectNode_1, :asubtype, :CLCMODE, :RES_PRICE_COUNT,
            :TYPE_TRUD, --CQ[TIMUR 6922]-->  TYPE_TRUD
            :IDFORMULS/*CQ[9359]*/, :K_ITOGO/*14460*/, :K_PR/*15421*/;

    PR_NUMBER1 = 0; PR_NUMBER2 = 0; PR_NUMBER3 = 0;
    PR_VSEGO   = 0.0; PR_VIPOLNENO = 0.0;
    IF (NOT smetatype IN ( 15 , 16 )) THEN
    BEGIN
      EXECUTE PROCEDURE L_PR_GET_YEAR_MONTH ( :SMETATYPE, :iduser ) RETURNING_VALUES (:lyear, :lmonth);

      USE_ONLY_UTV_PROCENT = 0;
      SELECT FIRST 1 USE_ONLY_UTV_PROCENT FROM a_o_factparams WHERE number = :smetatype
      INTO :USE_ONLY_UTV_PROCENT;

      EXECUTE PROCEDURE l_pr_select_rec ( :id, :iduser, :IN_IDOBJECT, :lyear, :lmonth, :USE_ONLY_UTV_PROCENT , 1 )
      RETURNING_VALUES ( :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, PR_VSEGO, PR_VIPOLNENO, :PR_EXISTS_CHILDS );
    END

    EXECUTE PROCEDURE b_getname( :iduser, :name_id ) RETURNING_VALUES ( :name );
    EXECUTE PROCEDURE a_get_edizm( :iduser, :id_edizm, :edizm_type ) RETURNING_VALUES ( :edizm );


  SUSPEND;
END
^

--[15352]
CREATE OR ALTER PROCEDURE D_GET_SMETA_RECS (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLIST BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDLISTCOUNT INTEGER,
    WITHSTRUCT INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    CLCMODE_RES INTEGER,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    ID_LS INTEGER,
    ADDED_SMETATYPE INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
--CQ[TIMUR 13931] -    FULL_STRUCT_NAME, STRUCT_SHIFR, FFULL_STRUCT_NAME, FSTRUCT_SHIFR, NUMLSR_LS
declare variable REC_ID integer;
declare variable LAST_LS integer;
declare variable LAST_R integer;
declare variable LAST_PR integer;
declare variable FID integer;
declare variable FIDHIER integer;
declare variable FNUMBER1 integer;
declare variable FNUMBER2 integer;
declare variable FNUMBER3 integer;
declare variable FSLAVEPARENT integer;
declare variable FATYPE smallint;
declare variable FRABMAT integer;
declare variable FTAB varchar(42);
declare variable FALTTAB varchar(250);
declare variable FNAME blob sub_type 0 segment size 80;
declare variable FNAME_ID integer;
declare variable FEDIZM varchar(250);
declare variable FID_EDIZM integer;
declare variable FEDIZM_TYPE integer;
declare variable FKOLL double precision;
declare variable FSKOLL varchar(255);
declare variable FNORMARASH double precision;
declare variable FBA double precision;
declare variable FBB double precision;
declare variable FBC double precision;
declare variable FBD double precision;
declare variable FBE double precision;
declare variable FBF double precision;
declare variable FBG double precision;
declare variable FBH double precision;
declare variable FBI double precision;
declare variable FBJ double precision;
declare variable FSEA blob sub_type 0 segment size 80;
declare variable FSEB blob sub_type 0 segment size 80;
declare variable FSEC blob sub_type 0 segment size 80;
declare variable FSED blob sub_type 0 segment size 80;
declare variable FSEE blob sub_type 0 segment size 80;
declare variable FSEF blob sub_type 0 segment size 80;
declare variable FSEG blob sub_type 0 segment size 80;
declare variable FSEH blob sub_type 0 segment size 80;
declare variable FSEI blob sub_type 0 segment size 80;
declare variable FSEJ blob sub_type 0 segment size 80;
declare variable FSEK blob sub_type 0 segment size 80;
declare variable FEA double precision;
declare variable FEB double precision;
declare variable FEC double precision;
declare variable FED double precision;
declare variable FEE double precision;
declare variable FEF double precision;
declare variable FEG double precision;
declare variable FEH double precision;
declare variable FEI double precision;
declare variable FEJ double precision;
declare variable FEK double precision;
declare variable FSRA blob sub_type 0 segment size 80;
declare variable FSRB blob sub_type 0 segment size 80;
declare variable FSRC blob sub_type 0 segment size 80;
declare variable FSRD blob sub_type 0 segment size 80;
declare variable FSRE blob sub_type 0 segment size 80;
declare variable FSRF blob sub_type 0 segment size 80;
declare variable FSRG blob sub_type 0 segment size 80;
declare variable FSRH blob sub_type 0 segment size 80;
declare variable FSRI blob sub_type 0 segment size 80;
declare variable FSRJ blob sub_type 0 segment size 80;
declare variable FSRK blob sub_type 0 segment size 80;
declare variable FSRL blob sub_type 0 segment size 80;
declare variable FSRM blob sub_type 0 segment size 80;
declare variable FRA double precision;
declare variable FRB double precision;
declare variable FRC double precision;
declare variable FRD double precision;
declare variable FRE double precision;
declare variable FRF double precision;
declare variable FRG double precision;
declare variable FRH double precision;
declare variable FRI double precision;
declare variable FRJ double precision;
declare variable FRK double precision;
declare variable FRL double precision;
declare variable FRM double precision;
declare variable FPA double precision;
declare variable FPB double precision;
declare variable FPC double precision;
declare variable FPD double precision;
declare variable FPE double precision;
declare variable FVRPZ integer;
declare variable FIDTIPR integer;
declare variable FKA varchar(50);
declare variable FKB varchar(50);
declare variable FKC varchar(50);
declare variable FKD varchar(50);
declare variable FKE varchar(50);
declare variable FKF varchar(50);
declare variable FKG varchar(50);
declare variable FKH varchar(50);
declare variable FKI varchar(50);
declare variable FKJ varchar(50);
declare variable FKK varchar(50);
declare variable FKL varchar(50);
declare variable FKM varchar(50);
declare variable FK_ITOGO varchar(50);
declare variable FK_PR varchar(50);
declare variable FPUNKTIND varchar(42);
declare variable FMA double precision;
declare variable FMB double precision;
declare variable FMC double precision;
declare variable FMD double precision;
declare variable FME double precision;
declare variable FMF double precision;
declare variable FMG double precision;
declare variable FMH double precision;
declare variable FMI double precision;
declare variable FMJ double precision;
declare variable FMK double precision;
declare variable FML double precision;
declare variable FSSTCH integer;
declare variable FKODZAK integer;
declare variable FKODGP integer;
declare variable FKODSP integer;
declare variable FKODISP integer;
declare variable FNACH date;
declare variable FOKONCH date;
declare variable FTIPRAB integer;
declare variable FIDNORMATIV integer;
declare variable FIDNORMATIVUNIQ integer;
declare variable FKODIR_GROUP integer;
declare variable FKODIR_PODGROUP integer;
declare variable FISGROUPOKP integer;
declare variable FARPS_OTHER blob sub_type 0 segment size 80;
declare variable FID_S_RES integer;
declare variable FPR_NUMBER1 integer;
declare variable FPR_NUMBER2 integer;
declare variable FPR_NUMBER3 integer;
declare variable FPR_ADDED_REC integer;
declare variable FPR_VSEGO double precision;
declare variable FPR_VIPOLNENO double precision;
declare variable FPR_EXISTS_CHILDS integer;
declare variable FNORM_GUID varchar(100);
declare variable FCALK_BA integer;
declare variable FCALK_BB integer;
declare variable FCALK_BC integer;
declare variable FCALK_BD integer;
declare variable FCALK_BE integer;
declare variable FSTATUS_REC_CEN integer;
declare variable FIDREESTR integer;
declare variable FPCELLMEM integer;
declare variable FVIDRAB integer;
declare variable FISHAVECORRECTIONNR integer;
declare variable FCALK_BG integer;
declare variable FCALK_BG_READONLY integer;
declare variable FCALK_BH integer;
declare variable FCALK_BH_READONLY integer;
declare variable FUTV integer;
declare variable FCORRECTNODE blob sub_type 0 segment size 80;
declare variable FCORRECTNODE_1 blob sub_type 0 segment size 80;
declare variable FASUBTYPE integer;
declare variable FCLCMODE integer;
declare variable FS_BA double precision;
declare variable FS_BB double precision;
declare variable FS_BC double precision;
declare variable FS_BD double precision;
declare variable FS_BE double precision;
declare variable FS_BG double precision;
declare variable FS_BH double precision;
declare variable FISRESPOPR integer;
declare variable FTYPE_TRUD integer;
declare variable FSM_REC_ITOG double precision;
declare variable FUCH integer;
declare variable FSTRUCT_NAME varchar(255);
declare variable FFULL_STRUCT_NAME varchar(1024);
declare variable FSTRUCT_SHIFR varchar(1024); /* CQ[9609] */
declare variable FCLCMODE_RES integer;
declare variable FVIEW_NUMBER1 integer;
declare variable FVIEW_NUMBER2 integer;
declare variable FVIEW_NUMBER3 integer;
declare variable FID_LS integer;
declare variable FADDED_SMETATYPE integer;
begin
--[15352]+
-- 2013/09/06 -      + ComplexTest... ..  
-- 2014.11.19 - MK:        ( 
--              ), ..       
-- 2015.11.10 - Voyager.       
--------------------------------------------------------------------------------

--[8443]
--  WITHSTRUCT - Reserved
  LAST_LS=0;
  LAST_R=0;
  LAST_PR=0;

  if (:WITHSTRUCT is null) then
    WITHSTRUCT=0;

  if (:IDLISTCOUNT is null) then
    IDLISTCOUNT = 0;

  REC_ID = gen_id(B_GEN_TEMP, 1) ;
  insert into B_TEMP_BLOB (ID, BLOB1) values (:REC_ID, :IDLIST);
  select BLOB1 from B_TEMP_BLOB where ID = :REC_ID into :IDLIST;
  delete from B_TEMP_BLOB where ID = :REC_ID;

  for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE, RABMAT,
             TAB, ALTTAB, NAME, NAME_ID, EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
             BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
             SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
             EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
             SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
             RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
             PA, PB, PC, PD, PE, VRPZ, IDTIPR,
             KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
             PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
             SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH, TIPRAB, IDNORMATIV,
             IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, ARPS_OTHER,
             ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_ADDED_REC, PR_VSEGO,
             PR_VIPOLNENO, PR_EXISTS_CHILDS, NORM_GUID,
             CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB,
             ISHAVECORRECTIONNR,
             CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
             UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
             S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH,
             ISRESPOPR, TYPE_TRUD, SM_REC_ITOG, UCH, --    A_P_SMETA, RES_PRICE_COUNT
             STRUCT_NAME, FULL_STRUCT_NAME, IDFORMULS/*CQ[9359]*/, STRUCT_SHIFR/*CQ[9609]*/,
             NUMLSR_LS/*CQ[12881]*/, CLCMODE_RES/*CQ[12244]*/,
             VIEW_NUMBER1, VIEW_NUMBER2, VIEW_NUMBER3, ID_LS, ADDED_SMETATYPE/*MK CQ[12020]*/,
             K_ITOGO/*14460*/, K_PR/*15421*/
  from A_P_SMETA(:IDOBJECT, /*:IDLEVEL*/:IDOBJECT, :IDUSER, :SMETATYPE, /*:NLS*/0, /*:NR*/0, /*:NPR*/0, /*:IDLS*/0, /*:IDR*/0, /*:ALLREC*/1, /*:SENDER*/0)
  where (:IDLISTCOUNT=0) or (ID in (select fvalue from S_INTFROMBLOB_SELECT (:IDLIST,:IDLISTCOUNT)))
  into :ID, :IDHIER, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT, :ATYPE, :RABMAT,
       :TAB, :ALTTAB, :NAME, :NAME_ID, :EDIZM, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
       :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
       :SEA, :SEB, :SEC, :SED, :SEE, :SEF, :SEG, :SEH, :SEI, :SEJ, :SEK,
       :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
       :SRA, :SRB, :SRC, :SRD, :SRE, :SRF, :SRG, :SRH, :SRI, :SRJ, :SRK, :SRL, :SRM,
       :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
       :PA, :PB, :PC, :PD, :PE, :VRPZ, :IDTIPR,
       :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :kk, :KL, :KM,
       :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
       :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH, :TIPRAB, :IDNORMATIV,
       :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :ARPS_OTHER,
       :ID_S_RES, :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, :PR_ADDED_REC, :PR_VSEGO,
       :PR_VIPOLNENO, :PR_EXISTS_CHILDS, :NORM_GUID,
       :CALK_BA, :CALK_BB, :CALK_BC, :CALK_BD, :CALK_BE, :STATUS_REC_CEN, :IDREESTR, :PCELLMEM, :VIDRAB,
       :ISHAVECORRECTIONNR,
       :CALK_BG, :CALK_BG_READONLY, :CALK_BH, :CALK_BH_READONLY,
       :UTV, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE,
       :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH,
       :ISRESPOPR, :TYPE_TRUD, :SM_REC_ITOG, :UCH, --    A_P_SMETA, :RES_PRICE_COUNT
       :STRUCT_NAME, :FULL_STRUCT_NAME, :IDFORMULS/*CQ[9359]*/, :STRUCT_SHIFR/*CQ[9609]*/,
       :NUMLSR_LS/*CQ[12881]*/, :CLCMODE_RES/*CQ[12244]*/,
       :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3, :ID_LS, :ADDED_SMETATYPE/*MK CQ[12020]*/,
       :K_ITOGO/*14460*/, :K_PR/*15421*/
  do
  begin
    if (not ATYPE in (-5,-4,-3,3,4,5)) then
    begin
      if ((WITHSTRUCT<>0)and(not IDHIER in (LAST_LS, LAST_R, LAST_PR))) then
      begin
        FID =                  :ID;
        FIDHIER =              :IDHIER;
        FNUMBER1 =             :NUMBER1;
        FNUMBER2 =             :NUMBER2;
        FNUMBER3 =             :NUMBER3;
        FSLAVEPARENT =         :SLAVEPARENT;
        FATYPE =               :ATYPE;
        FRABMAT =              :RABMAT;
        FTAB =                 :TAB;
        FALTTAB =              :ALTTAB;
        FNAME =                :NAME;
        FNAME_ID =             :NAME_ID;
        FEDIZM =               :EDIZM;
        FID_EDIZM =            :ID_EDIZM;
        FEDIZM_TYPE =          :EDIZM_TYPE;
        FKOLL =                :KOLL;
        FSKOLL =               :SKOLL;
        FNORMARASH =           :NORMARASH;
        FBA =                  :BA;
        FBB =                  :BB;
        FBC =                  :BC;
        FBD =                  :BD;
        FBE =                  :BE;
        FBF =                  :BF;
        FBG =                  :BG;
        FBH =                  :BH;
        FBI =                  :BI;
        FBJ =                  :BJ;
        FSEA =                 :SEA;
        FSEB =                 :SEB;
        FSEC =                 :SEC;
        FSED =                 :SED;
        FSEE =                 :SEE;
        FSEF =                 :SEF;
        FSEG =                 :SEG;
        FSEH =                 :SEH;
        FSEI =                 :SEI;
        FSEJ =                 :SEJ;
        FSEK =                 :SEK;
        FEA =                  :EA;
        FEB =                  :EB;
        FEC =                  :EC;
        FED =                  :ED;
        FEE =                  :EE;
        FEF =                  :EF;
        FEG =                  :EG;
        FEH =                  :EH;
        FEI =                  :EI;
        FEJ =                  :EJ;
        FEK =                  :EK;
        FSRA =                 :SRA;
        FSRB =                 :SRB;
        FSRC =                 :SRC;
        FSRD =                 :SRD;
        FSRE =                 :SRE;
        FSRF =                 :SRF;
        FSRG =                 :SRG;
        FSRH =                 :SRH;
        FSRI =                 :SRI;
        FSRJ =                 :SRJ;
        FSRK =                 :SRK;
        FSRL =                 :SRL;
        FSRM =                 :SRM;
        FRA =                  :RA;
        FRB =                  :RB;
        FRC =                  :RC;
        FRD =                  :RD;
        FRE =                  :RE;
        FRF =                  :RF;
        FRG =                  :RG;
        FRH =                  :RH;
        FRI =                  :RI;
        FRJ =                  :RJ;
        FRK =                  :RK;
        FRL =                  :RL;
        FRM =                  :RM;
        FPA =                  :PA;
        FPB =                  :PB;
        FPC =                  :PC;
        FPD =                  :PD;
        FPE =                  :PE;
        FVRPZ =                :VRPZ;
        FIDTIPR =              :IDTIPR;
        FKA =                  :KA;
        FKB =                  :KB;
        FKC =                  :KC;
        FKD =                  :KD;
        FKE =                  :KE;
        FKF =                  :KF;
        FKG =                  :KG;
        FKH =                  :KH;
        FKI =                  :KI;
        FKJ =                  :KJ;
        FKK =                  :KK;
        FKL =                  :KL;
        FKM =                  :KM;
        FPUNKTIND =            :PUNKTIND;
        FMA =                  :MA;
        FMB =                  :MB;
        FMC =                  :MC;
        FMD =                  :MD;
        FME =                  :ME;
        FMF =                  :MF;
        FMG =                  :MG;
        FMH =                  :MH;
        FMI =                  :MI;
        FMJ =                  :MJ;
        FMK =                  :MK;
        FML =                  :ML;
        FSSTCH =               :SSTCH;
        FKODZAK =              :KODZAK;
        FKODGP =               :KODGP;
        FKODSP =               :KODSP;
        FKODISP =              :KODISP;
        FNACH =                :NACH;
        FOKONCH =              :OKONCH;
        FTIPRAB =              :TIPRAB;
        FIDNORMATIV =          :IDNORMATIV;
        FIDNORMATIVUNIQ =      :IDNORMATIVUNIQ;
        FKODIR_GROUP =         :KODIR_GROUP;
        FKODIR_PODGROUP =      :KODIR_PODGROUP;
        FISGROUPOKP =          :ISGROUPOKP;
        FARPS_OTHER =          :ARPS_OTHER;
        FID_S_RES =            :ID_S_RES;
        FPR_NUMBER1 =          :PR_NUMBER1;
        FPR_NUMBER2 =          :PR_NUMBER2;
        FPR_NUMBER3 =          :PR_NUMBER3;
        FPR_ADDED_REC =        :PR_ADDED_REC;
        FPR_VSEGO =            :PR_VSEGO;
        FPR_VIPOLNENO =        :PR_VIPOLNENO;
        FPR_EXISTS_CHILDS =    :PR_EXISTS_CHILDS;
        FNORM_GUID =           :NORM_GUID;
        FCALK_BA =             :CALK_BA;
        FCALK_BB =             :CALK_BB;
        FCALK_BC =             :CALK_BC;
        FCALK_BD =             :CALK_BD;
        FCALK_BE =             :CALK_BE;
        FSTATUS_REC_CEN =      :STATUS_REC_CEN;
        FIDREESTR =            :IDREESTR;
        FPCELLMEM =            :PCELLMEM;
        FVIDRAB =              :VIDRAB;
        FISHAVECORRECTIONNR =  :ISHAVECORRECTIONNR;
        FCALK_BG =             :CALK_BG;
        FCALK_BG_READONLY =    :CALK_BG_READONLY;
        FCALK_BH =             :CALK_BH;
        FCALK_BH_READONLY =    :CALK_BH_READONLY;
        FUTV =                 :UTV;
        FCORRECTNODE =         :CORRECTNODE;
        FCORRECTNODE_1 =       :CORRECTNODE_1;
        FASUBTYPE =            :ASUBTYPE;

        FCLCMODE =             :CLCMODE;
        FS_BA =                :S_BA;
        FS_BB =                :S_BB;
        FS_BC =                :S_BC;
        FS_BD =                :S_BD;
        FS_BE =                :S_BE;
        FS_BG =                :S_BG;
        FS_BH =                :S_BH;
        FISRESPOPR =           :ISRESPOPR;
        FTYPE_TRUD =           :TYPE_TRUD;
        FSM_REC_ITOG =         :SM_REC_ITOG;
        FUCH =                 :UCH;
        FSTRUCT_NAME =         :STRUCT_NAME;
        FFULL_STRUCT_NAME =    :FULL_STRUCT_NAME;

        FSTRUCT_SHIFR = :STRUCT_SHIFR;--CQ[9609]
        FCLCMODE_RES = :CLCMODE_RES; -- CQ[12244]

        -- MK CQ[12020] --->
        FVIEW_NUMBER1 = :VIEW_NUMBER1;
        FVIEW_NUMBER2 = :VIEW_NUMBER2;
        FVIEW_NUMBER3 = :VIEW_NUMBER3;
        FID_LS = :ID_LS;
        FADDED_SMETATYPE = :ADDED_SMETATYPE;
        -- MK CQ[12020] <---

        FK_ITOGO = :K_ITOGO; /*14460*/
        FK_PR = :K_PR; /*15421*/

        for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT,
                   D_GET_HIER_PARENTS.ATYPE, RABMAT, TAB, ALTTAB, NAME, NAME_ID,
                   EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
                   BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
                   SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
                   EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                   SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
                   RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                   PA, PB, PC, PD, PE, VRPZ, IDTIPR,
                   KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                   PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
                   SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH,
                   TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP,
                   ISGROUPOKP, ARPS_OTHER, ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3,
                   PR_ADDED_REC, PR_VSEGO, PR_VIPOLNENO, PR_EXISTS_CHILDS, NORM_GUID,
                   CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE,
                   STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB, ISHAVECORRECTIONNR,
                   CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
                   UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
                   S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH,
                   ISRESPOPR, TYPE_TRUD, SM_REC_ITOG, UCH,
                   STRUCT_NAME, FULL_STRUCT_NAME,
                   IDFORMULS/*CQ[9359]*/, STRUCT_SHIFR/*CQ[9609]*/, NUMLSR_LS/*CQ[12881]*/, CLCMODE_RES/*CQ[12244]*/, --
                   VIEW_NUMBER1, VIEW_NUMBER2, VIEW_NUMBER3, ID_LS, ADDED_SMETATYPE/*MK CQ[12020]*/,
                   K_ITOGO/*14460*/, K_PR/*15421*/
        from A_P_SMETA(:IDOBJECT, /*:IDLEVEL*/:IDOBJECT, :IDUSER, :SMETATYPE, /*:NLS*/0, /*:NR*/0, /*:NPR*/0, /*:IDLS*/0, /*:IDR*/0, /*:ALLREC*/1, /*:SENDER*/0)
        inner join D_GET_HIER_PARENTS(:IDUSER, :IDHIER, 3) on
        A_P_SMETA.ID=D_GET_HIER_PARENTS.ID
--        where ID in (select ID from D_GET_HIER_PARENTS(:IDUSER, :IDHIER, 3))
        order by D_GET_HIER_PARENTS.ATYPE
        into :ID, :IDHIER, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT,
             :ATYPE, :RABMAT, :TAB, :ALTTAB, :NAME, :NAME_ID,
             :EDIZM, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
             :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
             :SEA, :SEB, :SEC, :SED, :SEE, :SEF, :SEG, :SEH, :SEI, :SEJ, :SEK,
             :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
             :SRA, :SRB, :SRC, :SRD, :SRE, :SRF, :SRG, :SRH, :SRI, :SRJ, :SRK, :SRL, :SRM,
             :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
             :PA, :PB, :PC, :PD, :PE, :VRPZ, :IDTIPR,
             :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
             :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
             :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH,
             :TIPRAB, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP,
             :ISGROUPOKP, :ARPS_OTHER, :ID_S_RES, :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3,
             :PR_ADDED_REC, :PR_VSEGO, :PR_VIPOLNENO, :PR_EXISTS_CHILDS, :NORM_GUID,
             :CALK_BA, :CALK_BB, :CALK_BC, :CALK_BD, :CALK_BE,
             :STATUS_REC_CEN, :IDREESTR, :PCELLMEM, :VIDRAB, :ISHAVECORRECTIONNR,
             :CALK_BG, :CALK_BG_READONLY, :CALK_BH, :CALK_BH_READONLY,
             :UTV, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE,
             :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH,
             :ISRESPOPR, :TYPE_TRUD, :SM_REC_ITOG, :UCH,
             :STRUCT_NAME, :FULL_STRUCT_NAME,
             :IDFORMULS/*CQ[9359]*/, :STRUCT_SHIFR/*CQ[9609]*/, :NUMLSR_LS/*CQ[12881]*/, :CLCMODE_RES/*CQ[12244]*/, --
             :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3, :ID_LS, :ADDED_SMETATYPE/*MK CQ[12020]*/,
             :K_ITOGO/*14460*/, :K_PR/*15421*/
        do
        begin
          if ((ATYPE in (-3,3))and(ID<>LAST_LS)
             or(ATYPE in (-4,4))and(ID<>LAST_R)
             or(ATYPE in (-5,5))and(ID<>LAST_PR))
          then
            suspend;
          if (ATYPE in (-3,3)) then
            LAST_LS=:ID;
          else
          if (ATYPE in (-4,4)) then
            LAST_R=:ID;
          else
          if (ATYPE in (-5,5)) then
            LAST_PR=:ID;
        end
        ID =                  :FID;
        IDHIER =              :FIDHIER;
        NUMBER1 =             :FNUMBER1;
        NUMBER2 =             :FNUMBER2;
        NUMBER3 =             :FNUMBER3;
        SLAVEPARENT =         :FSLAVEPARENT;
        ATYPE =               :FATYPE;
        RABMAT =              :FRABMAT;
        TAB =                 :FTAB;
        ALTTAB =              :FALTTAB;
        NAME =                :FNAME;
        NAME_ID =             :FNAME_ID;
        EDIZM =               :FEDIZM;
        ID_EDIZM =            :FID_EDIZM;
        EDIZM_TYPE =          :FEDIZM_TYPE;
        KOLL =                :FKOLL;
        SKOLL =               :FSKOLL;
        NORMARASH =           :FNORMARASH;
        BA =                  :FBA;
        BB =                  :FBB;
        BC =                  :FBC;
        BD =                  :FBD;
        BE =                  :FBE;
        BF =                  :FBF;
        BG =                  :FBG;
        BH =                  :FBH;
        BI =                  :FBI;
        BJ =                  :FBJ;
        SEA =                 :FSEA;
        SEB =                 :FSEB;
        SEC =                 :FSEC;
        SED =                 :FSED;
        SEE =                 :FSEE;
        SEF =                 :FSEF;
        SEG =                 :FSEG;
        SEH =                 :FSEH;
        SEI =                 :FSEI;
        SEJ =                 :FSEJ;
        SEK =                 :FSEK;
        EA =                  :FEA;
        EB =                  :FEB;
        EC =                  :FEC;
        ED =                  :FED;
        EE =                  :FEE;
        EF =                  :FEF;
        EG =                  :FEG;
        EH =                  :FEH;
        EI =                  :FEI;
        EJ =                  :FEJ;
        EK =                  :FEK;
        SRA =                 :FSRA;
        SRB =                 :FSRB;
        SRC =                 :FSRC;
        SRD =                 :FSRD;
        SRE =                 :FSRE;
        SRF =                 :FSRF;
        SRG =                 :FSRG;
        SRH =                 :FSRH;
        SRI =                 :FSRI;
        SRJ =                 :FSRJ;
        SRK =                 :FSRK;
        SRL =                 :FSRL;
        SRM =                 :FSRM;
        RA =                  :FRA;
        RB =                  :FRB;
        RC =                  :FRC;
        RD =                  :FRD;
        RE =                  :FRE;
        RF =                  :FRF;
        RG =                  :FRG;
        RH =                  :FRH;
        RI =                  :FRI;
        RJ =                  :FRJ;
        RK =                  :FRK;
        RL =                  :FRL;
        RM =                  :FRM;
        PA =                  :FPA;
        PB =                  :FPB;
        PC =                  :FPC;
        PD =                  :FPD;
        PE =                  :FPE;
        VRPZ =                :FVRPZ;
        IDTIPR =              :FIDTIPR;
        KA =                  :FKA;
        KB =                  :FKB;
        KC =                  :FKC;
        KD =                  :FKD;
        KE =                  :FKE;
        KF =                  :FKF;
        KG =                  :FKG;
        KH =                  :FKH;
        KI =                  :FKI;
        KJ =                  :FKJ;
        KK =                  :FKK;
        KL =                  :FKL;
        KM =                  :FKM;
        PUNKTIND =            :FPUNKTIND;
        MA =                  :FMA;
        MB =                  :FMB;
        MC =                  :FMC;
        MD =                  :FMD;
        ME =                  :FME;
        MF =                  :FMF;
        MG =                  :FMG;
        MH =                  :FMH;
        MI =                  :FMI;
        MJ =                  :FMJ;
        MK =                  :FMK;
        ML =                  :FML;
        SSTCH =               :FSSTCH;
        KODZAK =              :FKODZAK;
        KODGP =               :FKODGP;
        KODSP =               :FKODSP;
        KODISP =              :FKODISP;
        NACH =                :FNACH;
        OKONCH =              :FOKONCH;
        TIPRAB =              :FTIPRAB;
        IDNORMATIV =          :FIDNORMATIV;
        IDNORMATIVUNIQ =      :FIDNORMATIVUNIQ;
        KODIR_GROUP =         :FKODIR_GROUP;
        KODIR_PODGROUP =      :FKODIR_PODGROUP;
        ISGROUPOKP =          :FISGROUPOKP;
        ARPS_OTHER =          :FARPS_OTHER;
        ID_S_RES =            :FID_S_RES;
        PR_NUMBER1 =          :FPR_NUMBER1;
        PR_NUMBER2 =          :FPR_NUMBER2;
        PR_NUMBER3 =          :FPR_NUMBER3;
        PR_ADDED_REC =        :FPR_ADDED_REC;
        PR_VSEGO =            :FPR_VSEGO;
        PR_VIPOLNENO =        :FPR_VIPOLNENO;
        PR_EXISTS_CHILDS =    :FPR_EXISTS_CHILDS;
        NORM_GUID =           :FNORM_GUID;
        CALK_BA =             :FCALK_BA;
        CALK_BB =             :FCALK_BB;
        CALK_BC =             :FCALK_BC;
        CALK_BD =             :FCALK_BD;
        CALK_BE =             :FCALK_BE;
        STATUS_REC_CEN =      :FSTATUS_REC_CEN;
        IDREESTR =            :FIDREESTR;
        PCELLMEM =            :FPCELLMEM;
        VIDRAB =              :FVIDRAB;
        ISHAVECORRECTIONNR =  :FISHAVECORRECTIONNR;
        CALK_BG =             :FCALK_BG;
        CALK_BG_READONLY =    :FCALK_BG_READONLY;
        CALK_BH =             :FCALK_BH;
        CALK_BH_READONLY =    :FCALK_BH_READONLY;
        UTV =                 :FUTV;
        CORRECTNODE =         :FCORRECTNODE;
        CORRECTNODE_1 =       :FCORRECTNODE_1;
        ASUBTYPE =            :FASUBTYPE;

        CLCMODE =             :FCLCMODE;
        S_BA =                :FS_BA;
        S_BB =                :FS_BB;
        S_BC =                :FS_BC;
        S_BD =                :FS_BD;
        S_BE =                :FS_BE;
        S_BG =                :FS_BG;
        S_BH =                :FS_BH;
        ISRESPOPR =           :FISRESPOPR;
        TYPE_TRUD =           :FTYPE_TRUD;
        SM_REC_ITOG =         :FSM_REC_ITOG;
        --UCH =                 :FUCH; --<<    ,  ,    ,   
        STRUCT_NAME =         :FSTRUCT_NAME;
        FULL_STRUCT_NAME =    :FFULL_STRUCT_NAME;
        STRUCT_SHIFR = :FSTRUCT_SHIFR;--CQ[9609]
        CLCMODE_RES = :FCLCMODE_RES; -- CQ[12244]

        -- MK CQ[12020] --->
        VIEW_NUMBER1 = :FVIEW_NUMBER1;
        VIEW_NUMBER2 = :FVIEW_NUMBER2;
        VIEW_NUMBER3 = :FVIEW_NUMBER3;
        ID_LS = :FID_LS;
        ADDED_SMETATYPE = :FADDED_SMETATYPE;
        -- MK CQ[12020] <---

        K_ITOGO = :FK_ITOGO; /*14460*/
        K_PR = FK_PR; /*15421*/

      end
      suspend;
    end
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE D_GET_SMETA_RECS_NL (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLIST BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDLISTCOUNT INTEGER,
    WITHSTRUCT INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
--CQ[TIMUR 13931] -    FULL_STRUCT_NAME, STRUCT_SHIFR, FFULL_STRUCT_NAME, FSTRUCT_SHIFR, NUMLSR_LS
declare variable REC_ID integer;
declare variable LAST_LS integer;
declare variable LAST_R integer;
declare variable LAST_PR integer;
declare variable FID integer;
declare variable FIDHIER integer;
declare variable FNUMBER1 integer;
declare variable FNUMBER2 integer;
declare variable FNUMBER3 integer;
declare variable FSLAVEPARENT integer;
declare variable FATYPE smallint;
declare variable FRABMAT integer;
declare variable FTAB varchar(42);
declare variable FALTTAB varchar(250);
declare variable FNAME blob sub_type 0 segment size 80;
declare variable FNAME_ID integer;
declare variable FEDIZM varchar(250);
declare variable FID_EDIZM integer;
declare variable FEDIZM_TYPE integer;
declare variable FKOLL double precision;
declare variable FSKOLL varchar(255);
declare variable FNORMARASH double precision;
declare variable FBA double precision;
declare variable FBB double precision;
declare variable FBC double precision;
declare variable FBD double precision;
declare variable FBE double precision;
declare variable FBF double precision;
declare variable FBG double precision;
declare variable FBH double precision;
declare variable FBI double precision;
declare variable FBJ double precision;
declare variable FSEA blob sub_type 0 segment size 80;
declare variable FSEB blob sub_type 0 segment size 80;
declare variable FSEC blob sub_type 0 segment size 80;
declare variable FSED blob sub_type 0 segment size 80;
declare variable FSEE blob sub_type 0 segment size 80;
declare variable FSEF blob sub_type 0 segment size 80;
declare variable FSEG blob sub_type 0 segment size 80;
declare variable FSEH blob sub_type 0 segment size 80;
declare variable FSEI blob sub_type 0 segment size 80;
declare variable FSEJ blob sub_type 0 segment size 80;
declare variable FSEK blob sub_type 0 segment size 80;
declare variable FEA double precision;
declare variable FEB double precision;
declare variable FEC double precision;
declare variable FED double precision;
declare variable FEE double precision;
declare variable FEF double precision;
declare variable FEG double precision;
declare variable FEH double precision;
declare variable FEI double precision;
declare variable FEJ double precision;
declare variable FEK double precision;
declare variable FSRA blob sub_type 0 segment size 80;
declare variable FSRB blob sub_type 0 segment size 80;
declare variable FSRC blob sub_type 0 segment size 80;
declare variable FSRD blob sub_type 0 segment size 80;
declare variable FSRE blob sub_type 0 segment size 80;
declare variable FSRF blob sub_type 0 segment size 80;
declare variable FSRG blob sub_type 0 segment size 80;
declare variable FSRH blob sub_type 0 segment size 80;
declare variable FSRI blob sub_type 0 segment size 80;
declare variable FSRJ blob sub_type 0 segment size 80;
declare variable FSRK blob sub_type 0 segment size 80;
declare variable FSRL blob sub_type 0 segment size 80;
declare variable FSRM blob sub_type 0 segment size 80;
declare variable FRA double precision;
declare variable FRB double precision;
declare variable FRC double precision;
declare variable FRD double precision;
declare variable FRE double precision;
declare variable FRF double precision;
declare variable FRG double precision;
declare variable FRH double precision;
declare variable FRI double precision;
declare variable FRJ double precision;
declare variable FRK double precision;
declare variable FRL double precision;
declare variable FRM double precision;
declare variable FPA double precision;
declare variable FPB double precision;
declare variable FPC double precision;
declare variable FPD double precision;
declare variable FPE double precision;
declare variable FVRPZ integer;
declare variable FIDTIPR integer;
declare variable FKA varchar(50);
declare variable FKB varchar(50);
declare variable FKC varchar(50);
declare variable FKD varchar(50);
declare variable FKE varchar(50);
declare variable FKF varchar(50);
declare variable FKG varchar(50);
declare variable FKH varchar(50);
declare variable FKI varchar(50);
declare variable FKJ varchar(50);
declare variable FKK varchar(50);
declare variable FKL varchar(50);
declare variable FKM varchar(50);
declare variable FK_ITOGO varchar(50);
declare variable FK_PR varchar(50);
declare variable FPUNKTIND varchar(42);
declare variable FMA double precision;
declare variable FMB double precision;
declare variable FMC double precision;
declare variable FMD double precision;
declare variable FME double precision;
declare variable FMF double precision;
declare variable FMG double precision;
declare variable FMH double precision;
declare variable FMI double precision;
declare variable FMJ double precision;
declare variable FMK double precision;
declare variable FML double precision;
declare variable FSSTCH integer;
declare variable FKODZAK integer;
declare variable FKODGP integer;
declare variable FKODSP integer;
declare variable FKODISP integer;
declare variable FNACH date;
declare variable FOKONCH date;
declare variable FTIPRAB integer;
declare variable FIDNORMATIV integer;
declare variable FIDNORMATIVUNIQ integer;
declare variable FKODIR_GROUP integer;
declare variable FKODIR_PODGROUP integer;
declare variable FISGROUPOKP integer;
declare variable FARPS_OTHER blob sub_type 0 segment size 80;
declare variable FID_S_RES integer;
declare variable FPR_NUMBER1 integer;
declare variable FPR_NUMBER2 integer;
declare variable FPR_NUMBER3 integer;
declare variable FPR_ADDED_REC integer;
declare variable FPR_VSEGO double precision;
declare variable FPR_VIPOLNENO double precision;
declare variable FPR_EXISTS_CHILDS integer;
declare variable FNORM_GUID varchar(100);
declare variable FCALK_BA integer;
declare variable FCALK_BB integer;
declare variable FCALK_BC integer;
declare variable FCALK_BD integer;
declare variable FCALK_BE integer;
declare variable FSTATUS_REC_CEN integer;
declare variable FIDREESTR integer;
declare variable FPCELLMEM integer;
declare variable FVIDRAB integer;
declare variable FISHAVECORRECTIONNR integer;
declare variable FCALK_BG integer;
declare variable FCALK_BG_READONLY integer;
declare variable FCALK_BH integer;
declare variable FCALK_BH_READONLY integer;
declare variable FUTV integer;
declare variable FCORRECTNODE blob sub_type 0 segment size 80;
declare variable FCORRECTNODE_1 blob sub_type 0 segment size 80;
declare variable FASUBTYPE integer;
declare variable FCLCMODE integer;
declare variable FS_BA double precision;
declare variable FS_BB double precision;
declare variable FS_BC double precision;
declare variable FS_BD double precision;
declare variable FS_BE double precision;
declare variable FS_BG double precision;
declare variable FS_BH double precision;
declare variable FISRESPOPR integer;
declare variable FTYPE_TRUD integer;
declare variable FSM_REC_ITOG double precision;
declare variable FUCH integer;
declare variable FSTRUCT_NAME varchar(255);
declare variable FFULL_STRUCT_NAME varchar(1024);
declare variable FSTRUCT_SHIFR varchar(1024); /* CQ[9609] */
begin
--[15352]+

-- MK 20.06.2012      (   )
--------------------------------------------------------------------------------

--[8443]
--  WITHSTRUCT - Reserved
  LAST_LS=0;
  LAST_R=0;
  LAST_PR=0;

  if (:WITHSTRUCT is null) then
    WITHSTRUCT=0;

  if (:IDLISTCOUNT is null) then
    IDLISTCOUNT = 0;

  REC_ID = gen_id(B_GEN_TEMP, 1) ;
  insert into B_TEMP_BLOB (ID, BLOB1) values (:REC_ID, :IDLIST);
  select BLOB1 from B_TEMP_BLOB where ID = :REC_ID into :IDLIST;
  delete from B_TEMP_BLOB where ID = :REC_ID;

  for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE, RABMAT,
             TAB, ALTTAB, NAME, NAME_ID, EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
             BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
             SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
             EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
             SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
             RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
             PA, PB, PC, PD, PE, VRPZ, IDTIPR,
             KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
             PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
             SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH, TIPRAB, IDNORMATIV,
             IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, ARPS_OTHER,
             ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_ADDED_REC, PR_VSEGO,
             PR_VIPOLNENO, PR_EXISTS_CHILDS, NORM_GUID,
             CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB,
             ISHAVECORRECTIONNR,
             CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
             UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
             S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH,
             ISRESPOPR, TYPE_TRUD, SM_REC_ITOG, UCH, --    A_P_SMETA, RES_PRICE_COUNT
             STRUCT_NAME, FULL_STRUCT_NAME,
             IDFORMULS/*CQ[9359]*/, STRUCT_SHIFR/*CQ[9609]*/, NUMLSR_LS/*CQ[12881]*/,
             K_ITOGO/*14460*/, K_PR/*15421*/
  from A_P_SMETA(:IDOBJECT, /*:IDLEVEL*/:IDOBJECT, :IDUSER, :SMETATYPE, /*:NLS*/0, /*:NR*/0, /*:NPR*/0, /*:IDLS*/0, /*:IDR*/0, /*:ALLREC*/1, /*:SENDER*/0)
  where (:IDLISTCOUNT=0) or (ID in (select fvalue from S_INTFROMBLOB_SELECT (:IDLIST,:IDLISTCOUNT)))
  into :ID, :IDHIER, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT, :ATYPE, :RABMAT,
       :TAB, :ALTTAB, :NAME, :NAME_ID, :EDIZM, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
       :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
       :SEA, :SEB, :SEC, :SED, :SEE, :SEF, :SEG, :SEH, :SEI, :SEJ, :SEK,
       :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
       :SRA, :SRB, :SRC, :SRD, :SRE, :SRF, :SRG, :SRH, :SRI, :SRJ, :SRK, :SRL, :SRM,
       :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
       :PA, :PB, :PC, :PD, :PE, :VRPZ, :IDTIPR,
       :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :kk, :KL, :KM,
       :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
       :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH, :TIPRAB, :IDNORMATIV,
       :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :ARPS_OTHER,
       :ID_S_RES, :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, :PR_ADDED_REC, :PR_VSEGO,
       :PR_VIPOLNENO, :PR_EXISTS_CHILDS, :NORM_GUID,
       :CALK_BA, :CALK_BB, :CALK_BC, :CALK_BD, :CALK_BE, :STATUS_REC_CEN, :IDREESTR, :PCELLMEM, :VIDRAB,
       :ISHAVECORRECTIONNR,
       :CALK_BG, :CALK_BG_READONLY, :CALK_BH, :CALK_BH_READONLY,
       :UTV, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE,
       :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH,
       :ISRESPOPR, :TYPE_TRUD, :SM_REC_ITOG, :UCH, --    A_P_SMETA, :RES_PRICE_COUNT
       :STRUCT_NAME, :FULL_STRUCT_NAME, :IDFORMULS/*CQ[9359]*/,
       :STRUCT_SHIFR/*CQ[9609]*/, :NUMLSR_LS/*CQ[12881]*/, :K_ITOGO/*14460*/, :K_PR/*15421*/
  do
  begin
    if (not ATYPE in (-5,-4,-3,3,4,5)) then
    begin

      select CA, CB, CC, CD, CE, CF, CG, CH, CI, CJ,
             EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
             RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
             PA, PB, PC, PD
      from A_SMETA_CENLVL
      where ID = :ID AND IDCENLVL = :IDCENLVL
      into
      :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
      :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
      :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
      :PA, :PB, :PC, :PD;

      if ((WITHSTRUCT<>0)and(not IDHIER in (LAST_LS, LAST_R, LAST_PR))) then
      begin
        FID =                  :ID;
        FIDHIER =              :IDHIER;
        FNUMBER1 =             :NUMBER1;
        FNUMBER2 =             :NUMBER2;
        FNUMBER3 =             :NUMBER3;
        FSLAVEPARENT =         :SLAVEPARENT;
        FATYPE =               :ATYPE;
        FRABMAT =              :RABMAT;
        FTAB =                 :TAB;
        FALTTAB =              :ALTTAB;
        FNAME =                :NAME;
        FNAME_ID =             :NAME_ID;
        FEDIZM =               :EDIZM;
        FID_EDIZM =            :ID_EDIZM;
        FEDIZM_TYPE =          :EDIZM_TYPE;
        FKOLL =                :KOLL;
        FSKOLL =               :SKOLL;
        FNORMARASH =           :NORMARASH;
        FBA =                  :BA;
        FBB =                  :BB;
        FBC =                  :BC;
        FBD =                  :BD;
        FBE =                  :BE;
        FBF =                  :BF;
        FBG =                  :BG;
        FBH =                  :BH;
        FBI =                  :BI;
        FBJ =                  :BJ;
        FSEA =                 :SEA;
        FSEB =                 :SEB;
        FSEC =                 :SEC;
        FSED =                 :SED;
        FSEE =                 :SEE;
        FSEF =                 :SEF;
        FSEG =                 :SEG;
        FSEH =                 :SEH;
        FSEI =                 :SEI;
        FSEJ =                 :SEJ;
        FSEK =                 :SEK;
        FEA =                  :EA;
        FEB =                  :EB;
        FEC =                  :EC;
        FED =                  :ED;
        FEE =                  :EE;
        FEF =                  :EF;
        FEG =                  :EG;
        FEH =                  :EH;
        FEI =                  :EI;
        FEJ =                  :EJ;
        FEK =                  :EK;
        FSRA =                 :SRA;
        FSRB =                 :SRB;
        FSRC =                 :SRC;
        FSRD =                 :SRD;
        FSRE =                 :SRE;
        FSRF =                 :SRF;
        FSRG =                 :SRG;
        FSRH =                 :SRH;
        FSRI =                 :SRI;
        FSRJ =                 :SRJ;
        FSRK =                 :SRK;
        FSRL =                 :SRL;
        FSRM =                 :SRM;
        FRA =                  :RA;
        FRB =                  :RB;
        FRC =                  :RC;
        FRD =                  :RD;
        FRE =                  :RE;
        FRF =                  :RF;
        FRG =                  :RG;
        FRH =                  :RH;
        FRI =                  :RI;
        FRJ =                  :RJ;
        FRK =                  :RK;
        FRL =                  :RL;
        FRM =                  :RM;
        FPA =                  :PA;
        FPB =                  :PB;
        FPC =                  :PC;
        FPD =                  :PD;
        FPE =                  :PE;
        FVRPZ =                :VRPZ;
        FIDTIPR =              :IDTIPR;
        FKA =                  :KA;
        FKB =                  :KB;
        FKC =                  :KC;
        FKD =                  :KD;
        FKE =                  :KE;
        FKF =                  :KF;
        FKG =                  :KG;
        FKH =                  :KH;
        FKI =                  :KI;
        FKJ =                  :KJ;
        FKK =                  :KK;
        FKL =                  :KL;
        FKM =                  :KM;
        FPUNKTIND =            :PUNKTIND;
        FMA =                  :MA;
        FMB =                  :MB;
        FMC =                  :MC;
        FMD =                  :MD;
        FME =                  :ME;
        FMF =                  :MF;
        FMG =                  :MG;
        FMH =                  :MH;
        FMI =                  :MI;
        FMJ =                  :MJ;
        FMK =                  :MK;
        FML =                  :ML;
        FSSTCH =               :SSTCH;
        FKODZAK =              :KODZAK;
        FKODGP =               :KODGP;
        FKODSP =               :KODSP;
        FKODISP =              :KODISP;
        FNACH =                :NACH;
        FOKONCH =              :OKONCH;
        FTIPRAB =              :TIPRAB;
        FIDNORMATIV =          :IDNORMATIV;
        FIDNORMATIVUNIQ =      :IDNORMATIVUNIQ;
        FKODIR_GROUP =         :KODIR_GROUP;
        FKODIR_PODGROUP =      :KODIR_PODGROUP;
        FISGROUPOKP =          :ISGROUPOKP;
        FARPS_OTHER =          :ARPS_OTHER;
        FID_S_RES =            :ID_S_RES;
        FPR_NUMBER1 =          :PR_NUMBER1;
        FPR_NUMBER2 =          :PR_NUMBER2;
        FPR_NUMBER3 =          :PR_NUMBER3;
        FPR_ADDED_REC =        :PR_ADDED_REC;
        FPR_VSEGO =            :PR_VSEGO;
        FPR_VIPOLNENO =        :PR_VIPOLNENO;
        FPR_EXISTS_CHILDS =    :PR_EXISTS_CHILDS;
        FNORM_GUID =           :NORM_GUID;
        FCALK_BA =             :CALK_BA;
        FCALK_BB =             :CALK_BB;
        FCALK_BC =             :CALK_BC;
        FCALK_BD =             :CALK_BD;
        FCALK_BE =             :CALK_BE;
        FSTATUS_REC_CEN =      :STATUS_REC_CEN;
        FIDREESTR =            :IDREESTR;
        FPCELLMEM =            :PCELLMEM;
        FVIDRAB =              :VIDRAB;
        FISHAVECORRECTIONNR =  :ISHAVECORRECTIONNR;
        FCALK_BG =             :CALK_BG;
        FCALK_BG_READONLY =    :CALK_BG_READONLY;
        FCALK_BH =             :CALK_BH;
        FCALK_BH_READONLY =    :CALK_BH_READONLY;
        FUTV =                 :UTV;
        FCORRECTNODE =         :CORRECTNODE;
        FCORRECTNODE_1 =       :CORRECTNODE_1;
        FASUBTYPE =            :ASUBTYPE;

        FCLCMODE =             :CLCMODE;
        FS_BA =                :S_BA;
        FS_BB =                :S_BB;
        FS_BC =                :S_BC;
        FS_BD =                :S_BD;
        FS_BE =                :S_BE;
        FS_BG =                :S_BG;
        FS_BH =                :S_BH;
        FISRESPOPR =           :ISRESPOPR;
        FTYPE_TRUD =           :TYPE_TRUD;
        FSM_REC_ITOG =         :SM_REC_ITOG;
        FUCH =                 :UCH;
        FSTRUCT_NAME =         :STRUCT_NAME;
        FFULL_STRUCT_NAME =    :FULL_STRUCT_NAME;

        FSTRUCT_SHIFR = :STRUCT_SHIFR;--CQ[9609]
        FK_ITOGO = :K_ITOGO; /*14460*/
        FK_PR = :K_PR; /*15421*/

        for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT,
                   D_GET_HIER_PARENTS.ATYPE, RABMAT, TAB, ALTTAB, NAME, NAME_ID,
                   EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
                   BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
                   SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
                   EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                   SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
                   RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                   PA, PB, PC, PD, PE, VRPZ, IDTIPR,
                   KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                   PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
                   SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH,
                   TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP,
                   ISGROUPOKP, ARPS_OTHER, ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3,
                   PR_ADDED_REC, PR_VSEGO, PR_VIPOLNENO, PR_EXISTS_CHILDS, NORM_GUID,
                   CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE,
                   STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB, ISHAVECORRECTIONNR,
                   CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
                   UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
                   S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH,
                   ISRESPOPR, TYPE_TRUD, SM_REC_ITOG, UCH,
                   STRUCT_NAME, FULL_STRUCT_NAME,
                   IDFORMULS/*CQ[9359]*/, STRUCT_SHIFR/*CQ[9609]*/, NUMLSR_LS/*CQ[12881]*/,
                   K_ITOGO/*14460*/, K_PR/*15421*/
        from A_P_SMETA(:IDOBJECT, /*:IDLEVEL*/:IDOBJECT, :IDUSER, :SMETATYPE, /*:NLS*/0, /*:NR*/0, /*:NPR*/0, /*:IDLS*/0, /*:IDR*/0, /*:ALLREC*/1, /*:SENDER*/0)
        inner join D_GET_HIER_PARENTS(:IDUSER, :IDHIER, 3) on
        A_P_SMETA.ID=D_GET_HIER_PARENTS.ID
--        where ID in (select ID from D_GET_HIER_PARENTS(:IDUSER, :IDHIER, 3))
        order by D_GET_HIER_PARENTS.ATYPE
        into :ID, :IDHIER, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT,
             :ATYPE, :RABMAT, :TAB, :ALTTAB, :NAME, :NAME_ID,
             :EDIZM, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
             :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
             :SEA, :SEB, :SEC, :SED, :SEE, :SEF, :SEG, :SEH, :SEI, :SEJ, :SEK,
             :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
             :SRA, :SRB, :SRC, :SRD, :SRE, :SRF, :SRG, :SRH, :SRI, :SRJ, :SRK, :SRL, :SRM,
             :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
             :PA, :PB, :PC, :PD, :PE, :VRPZ, :IDTIPR,
             :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
             :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
             :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH,
             :TIPRAB, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP,
             :ISGROUPOKP, :ARPS_OTHER, :ID_S_RES, :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3,
             :PR_ADDED_REC, :PR_VSEGO, :PR_VIPOLNENO, :PR_EXISTS_CHILDS, :NORM_GUID,
             :CALK_BA, :CALK_BB, :CALK_BC, :CALK_BD, :CALK_BE,
             :STATUS_REC_CEN, :IDREESTR, :PCELLMEM, :VIDRAB, :ISHAVECORRECTIONNR,
             :CALK_BG, :CALK_BG_READONLY, :CALK_BH, :CALK_BH_READONLY,
             :UTV, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE,
             :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH,
             :ISRESPOPR, :TYPE_TRUD, :SM_REC_ITOG, :UCH,
             :STRUCT_NAME, :FULL_STRUCT_NAME,
             :IDFORMULS/*CQ[9359]*/, :STRUCT_SHIFR/*CQ[9609]*/, :NUMLSR_LS/*CQ[12881]*/,
             :K_ITOGO/*14460*/, :K_PR/*15421*/
        do
        begin
          if ((ATYPE in (-3,3))and(ID<>LAST_LS)
             or(ATYPE in (-4,4))and(ID<>LAST_R)
             or(ATYPE in (-5,5))and(ID<>LAST_PR))
          then
            suspend;
          if (ATYPE in (-3,3)) then
            LAST_LS=:ID;
          else
          if (ATYPE in (-4,4)) then
            LAST_R=:ID;
          else
          if (ATYPE in (-5,5)) then
            LAST_PR=:ID;
        end
        ID =                  :FID;
        IDHIER =              :FIDHIER;
        NUMBER1 =             :FNUMBER1;
        NUMBER2 =             :FNUMBER2;
        NUMBER3 =             :FNUMBER3;
        SLAVEPARENT =         :FSLAVEPARENT;
        ATYPE =               :FATYPE;
        RABMAT =              :FRABMAT;
        TAB =                 :FTAB;
        ALTTAB =              :FALTTAB;
        NAME =                :FNAME;
        NAME_ID =             :FNAME_ID;
        EDIZM =               :FEDIZM;
        ID_EDIZM =            :FID_EDIZM;
        EDIZM_TYPE =          :FEDIZM_TYPE;
        KOLL =                :FKOLL;
        SKOLL =               :FSKOLL;
        NORMARASH =           :FNORMARASH;
        BA =                  :FBA;
        BB =                  :FBB;
        BC =                  :FBC;
        BD =                  :FBD;
        BE =                  :FBE;
        BF =                  :FBF;
        BG =                  :FBG;
        BH =                  :FBH;
        BI =                  :FBI;
        BJ =                  :FBJ;
        SEA =                 :FSEA;
        SEB =                 :FSEB;
        SEC =                 :FSEC;
        SED =                 :FSED;
        SEE =                 :FSEE;
        SEF =                 :FSEF;
        SEG =                 :FSEG;
        SEH =                 :FSEH;
        SEI =                 :FSEI;
        SEJ =                 :FSEJ;
        SEK =                 :FSEK;
        EA =                  :FEA;
        EB =                  :FEB;
        EC =                  :FEC;
        ED =                  :FED;
        EE =                  :FEE;
        EF =                  :FEF;
        EG =                  :FEG;
        EH =                  :FEH;
        EI =                  :FEI;
        EJ =                  :FEJ;
        EK =                  :FEK;
        SRA =                 :FSRA;
        SRB =                 :FSRB;
        SRC =                 :FSRC;
        SRD =                 :FSRD;
        SRE =                 :FSRE;
        SRF =                 :FSRF;
        SRG =                 :FSRG;
        SRH =                 :FSRH;
        SRI =                 :FSRI;
        SRJ =                 :FSRJ;
        SRK =                 :FSRK;
        SRL =                 :FSRL;
        SRM =                 :FSRM;
        RA =                  :FRA;
        RB =                  :FRB;
        RC =                  :FRC;
        RD =                  :FRD;
        RE =                  :FRE;
        RF =                  :FRF;
        RG =                  :FRG;
        RH =                  :FRH;
        RI =                  :FRI;
        RJ =                  :FRJ;
        RK =                  :FRK;
        RL =                  :FRL;
        RM =                  :FRM;
        PA =                  :FPA;
        PB =                  :FPB;
        PC =                  :FPC;
        PD =                  :FPD;
        PE =                  :FPE;
        VRPZ =                :FVRPZ;
        IDTIPR =              :FIDTIPR;
        KA =                  :FKA;
        KB =                  :FKB;
        KC =                  :FKC;
        KD =                  :FKD;
        KE =                  :FKE;
        KF =                  :FKF;
        KG =                  :FKG;
        KH =                  :FKH;
        KI =                  :FKI;
        KJ =                  :FKJ;
        KK =                  :FKK;
        KL =                  :FKL;
        KM =                  :FKM;
        PUNKTIND =            :FPUNKTIND;
        MA =                  :FMA;
        MB =                  :FMB;
        MC =                  :FMC;
        MD =                  :FMD;
        ME =                  :FME;
        MF =                  :FMF;
        MG =                  :FMG;
        MH =                  :FMH;
        MI =                  :FMI;
        MJ =                  :FMJ;
        MK =                  :FMK;
        ML =                  :FML;
        SSTCH =               :FSSTCH;
        KODZAK =              :FKODZAK;
        KODGP =               :FKODGP;
        KODSP =               :FKODSP;
        KODISP =              :FKODISP;
        NACH =                :FNACH;
        OKONCH =              :FOKONCH;
        TIPRAB =              :FTIPRAB;
        IDNORMATIV =          :FIDNORMATIV;
        IDNORMATIVUNIQ =      :FIDNORMATIVUNIQ;
        KODIR_GROUP =         :FKODIR_GROUP;
        KODIR_PODGROUP =      :FKODIR_PODGROUP;
        ISGROUPOKP =          :FISGROUPOKP;
        ARPS_OTHER =          :FARPS_OTHER;
        ID_S_RES =            :FID_S_RES;
        PR_NUMBER1 =          :FPR_NUMBER1;
        PR_NUMBER2 =          :FPR_NUMBER2;
        PR_NUMBER3 =          :FPR_NUMBER3;
        PR_ADDED_REC =        :FPR_ADDED_REC;
        PR_VSEGO =            :FPR_VSEGO;
        PR_VIPOLNENO =        :FPR_VIPOLNENO;
        PR_EXISTS_CHILDS =    :FPR_EXISTS_CHILDS;
        NORM_GUID =           :FNORM_GUID;
        CALK_BA =             :FCALK_BA;
        CALK_BB =             :FCALK_BB;
        CALK_BC =             :FCALK_BC;
        CALK_BD =             :FCALK_BD;
        CALK_BE =             :FCALK_BE;
        STATUS_REC_CEN =      :FSTATUS_REC_CEN;
        IDREESTR =            :FIDREESTR;
        PCELLMEM =            :FPCELLMEM;
        VIDRAB =              :FVIDRAB;
        ISHAVECORRECTIONNR =  :FISHAVECORRECTIONNR;
        CALK_BG =             :FCALK_BG;
        CALK_BG_READONLY =    :FCALK_BG_READONLY;
        CALK_BH =             :FCALK_BH;
        CALK_BH_READONLY =    :FCALK_BH_READONLY;
        UTV =                 :FUTV;
        CORRECTNODE =         :FCORRECTNODE;
        CORRECTNODE_1 =       :FCORRECTNODE_1;
        ASUBTYPE =            :FASUBTYPE;

        CLCMODE =             :FCLCMODE;
        S_BA =                :FS_BA;
        S_BB =                :FS_BB;
        S_BC =                :FS_BC;
        S_BD =                :FS_BD;
        S_BE =                :FS_BE;
        S_BG =                :FS_BG;
        S_BH =                :FS_BH;
        ISRESPOPR =           :FISRESPOPR;
        TYPE_TRUD =           :FTYPE_TRUD;
        SM_REC_ITOG =         :FSM_REC_ITOG;
        --UCH =                 :FUCH; --<<    ,  ,    ,   
        STRUCT_NAME =         :FSTRUCT_NAME;
        FULL_STRUCT_NAME =    :FFULL_STRUCT_NAME;
        STRUCT_SHIFR = :FSTRUCT_SHIFR;--CQ[9609]

        K_ITOGO = :FK_ITOGO; /*14460*/
        K_PR = :FK_PR; /*15421*/
      end
      suspend;
    end
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE D_GR_RES_SHOW_IN_SMETA_RECS_NL (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    ID_CEN INTEGER,
    ISGROUPMODE INTEGER,
    SMETATYPE INTEGER,
    WITHSTRUCT INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    PCELLMEM INTEGER,
    VIDRAB INTEGER,
    ISHAVECORRECTIONNR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    S_BA DOUBLE PRECISION,
    S_BB DOUBLE PRECISION,
    S_BC DOUBLE PRECISION,
    S_BD DOUBLE PRECISION,
    S_BE DOUBLE PRECISION,
    S_BG DOUBLE PRECISION,
    S_BH DOUBLE PRECISION,
    ISRESPOPR INTEGER,
    TYPE_TRUD INTEGER,
    SM_REC_ITOG DOUBLE PRECISION,
    UCH INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    CLCMODE_RES INTEGER,
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    ID_LS INTEGER,
    ADDED_SMETATYPE INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
--CQ[TIMUR 13931] -    FULL_STRUCT_NAME, STRUCT_SHIFR, FFULL_STRUCT_NAME, FSTRUCT_SHIFR, NUMLSR_LS
declare variable LAST_LS integer;
declare variable LAST_R integer;
declare variable LAST_PR integer;
declare variable FID integer;
declare variable FIDHIER integer;
declare variable FNUMBER1 integer;
declare variable FNUMBER2 integer;
declare variable FNUMBER3 integer;
declare variable FSLAVEPARENT integer;
declare variable FATYPE smallint;
declare variable FRABMAT integer;
declare variable FTAB varchar(42);
declare variable FALTTAB varchar(250);
declare variable FNAME blob sub_type 0 segment size 80;
declare variable FNAME_ID integer;
declare variable FEDIZM varchar(250);
declare variable FID_EDIZM integer;
declare variable FEDIZM_TYPE integer;
declare variable FKOLL double precision;
declare variable FSKOLL varchar(255);
declare variable FNORMARASH double precision;
declare variable FBA double precision;
declare variable FBB double precision;
declare variable FBC double precision;
declare variable FBD double precision;
declare variable FBE double precision;
declare variable FBF double precision;
declare variable FBG double precision;
declare variable FBH double precision;
declare variable FBI double precision;
declare variable FBJ double precision;
declare variable FSEA blob sub_type 0 segment size 80;
declare variable FSEB blob sub_type 0 segment size 80;
declare variable FSEC blob sub_type 0 segment size 80;
declare variable FSED blob sub_type 0 segment size 80;
declare variable FSEE blob sub_type 0 segment size 80;
declare variable FSEF blob sub_type 0 segment size 80;
declare variable FSEG blob sub_type 0 segment size 80;
declare variable FSEH blob sub_type 0 segment size 80;
declare variable FSEI blob sub_type 0 segment size 80;
declare variable FSEJ blob sub_type 0 segment size 80;
declare variable FSEK blob sub_type 0 segment size 80;
declare variable FEA double precision;
declare variable FEB double precision;
declare variable FEC double precision;
declare variable FED double precision;
declare variable FEE double precision;
declare variable FEF double precision;
declare variable FEG double precision;
declare variable FEH double precision;
declare variable FEI double precision;
declare variable FEJ double precision;
declare variable FEK double precision;
declare variable FSRA blob sub_type 0 segment size 80;
declare variable FSRB blob sub_type 0 segment size 80;
declare variable FSRC blob sub_type 0 segment size 80;
declare variable FSRD blob sub_type 0 segment size 80;
declare variable FSRE blob sub_type 0 segment size 80;
declare variable FSRF blob sub_type 0 segment size 80;
declare variable FSRG blob sub_type 0 segment size 80;
declare variable FSRH blob sub_type 0 segment size 80;
declare variable FSRI blob sub_type 0 segment size 80;
declare variable FSRJ blob sub_type 0 segment size 80;
declare variable FSRK blob sub_type 0 segment size 80;
declare variable FSRL blob sub_type 0 segment size 80;
declare variable FSRM blob sub_type 0 segment size 80;
declare variable FRA double precision;
declare variable FRB double precision;
declare variable FRC double precision;
declare variable FRD double precision;
declare variable FRE double precision;
declare variable FRF double precision;
declare variable FRG double precision;
declare variable FRH double precision;
declare variable FRI double precision;
declare variable FRJ double precision;
declare variable FRK double precision;
declare variable FRL double precision;
declare variable FRM double precision;
declare variable FPA double precision;
declare variable FPB double precision;
declare variable FPC double precision;
declare variable FPD double precision;
declare variable FPE double precision;
declare variable FVRPZ integer;
declare variable FIDTIPR integer;
declare variable FKA varchar(50);
declare variable FKB varchar(50);
declare variable FKC varchar(50);
declare variable FKD varchar(50);
declare variable FKE varchar(50);
declare variable FKF varchar(50);
declare variable FKG varchar(50);
declare variable FKH varchar(50);
declare variable FKI varchar(50);
declare variable FKJ varchar(50);
declare variable FKK varchar(50);
declare variable FKL varchar(50);
declare variable FKM varchar(50);
declare variable FK_ITOGO varchar(50);
declare variable FK_PR varchar(50);
declare variable FPUNKTIND varchar(42);
declare variable FMA double precision;
declare variable FMB double precision;
declare variable FMC double precision;
declare variable FMD double precision;
declare variable FME double precision;
declare variable FMF double precision;
declare variable FMG double precision;
declare variable FMH double precision;
declare variable FMI double precision;
declare variable FMJ double precision;
declare variable FMK double precision;
declare variable FML double precision;
declare variable FSSTCH integer;
declare variable FKODZAK integer;
declare variable FKODGP integer;
declare variable FKODSP integer;
declare variable FKODISP integer;
declare variable FNACH date;
declare variable FOKONCH date;
declare variable FTIPRAB integer;
declare variable FIDNORMATIV integer;
declare variable FIDNORMATIVUNIQ integer;
declare variable FKODIR_GROUP integer;
declare variable FKODIR_PODGROUP integer;
declare variable FISGROUPOKP integer;
declare variable FARPS_OTHER blob sub_type 0 segment size 80;
declare variable FID_S_RES integer;
declare variable FPR_NUMBER1 integer;
declare variable FPR_NUMBER2 integer;
declare variable FPR_NUMBER3 integer;
declare variable FPR_ADDED_REC integer;
declare variable FPR_VSEGO double precision;
declare variable FPR_VIPOLNENO double precision;
declare variable FPR_EXISTS_CHILDS integer;
declare variable FNORM_GUID varchar(100);
declare variable FCALK_BA integer;
declare variable FCALK_BB integer;
declare variable FCALK_BC integer;
declare variable FCALK_BD integer;
declare variable FCALK_BE integer;
declare variable FSTATUS_REC_CEN integer;
declare variable FIDREESTR integer;
declare variable FPCELLMEM integer;
declare variable FVIDRAB integer;
declare variable FISHAVECORRECTIONNR integer;
declare variable FCALK_BG integer;
declare variable FCALK_BG_READONLY integer;
declare variable FCALK_BH integer;
declare variable FCALK_BH_READONLY integer;
declare variable FUTV integer;
declare variable FCORRECTNODE blob sub_type 0 segment size 80;
declare variable FCORRECTNODE_1 blob sub_type 0 segment size 80;
declare variable FASUBTYPE integer;
declare variable FCLCMODE integer;
declare variable FS_BA double precision;
declare variable FS_BB double precision;
declare variable FS_BC double precision;
declare variable FS_BD double precision;
declare variable FS_BE double precision;
declare variable FS_BG double precision;
declare variable FS_BH double precision;
declare variable FISRESPOPR integer;
declare variable FTYPE_TRUD integer;
declare variable FSM_REC_ITOG double precision;
declare variable FUCH integer;
declare variable FSTRUCT_NAME varchar(255);
declare variable FFULL_STRUCT_NAME varchar(1024);
declare variable FSTRUCT_SHIFR varchar(1024); /* CQ[9609] */
declare variable ID_GROUPED_RES integer;
declare variable WHERE_LS integer;
declare variable WHERE_R integer;
declare variable WHERE_PR integer;
declare variable FCLCMODE_RES integer;
declare variable FVIEW_NUMBER1 integer;
declare variable FVIEW_NUMBER2 integer;
declare variable FVIEW_NUMBER3 integer;
declare variable FID_LS integer;
declare variable FADDED_SMETATYPE integer;
begin
--[15352]+
--[8443]
--  WITHSTRUCT - Reserved
  LAST_LS=0;
  LAST_R=0;
  LAST_PR=0;

  if (:WITHSTRUCT is null) then
    WITHSTRUCT=0;

  select id_grouped_res
    from d_gr_res_cen_levels
    where id = :id_cen
    into :id_grouped_res;

  if (id_grouped_res is null) then
     exception ae_resrecnotfound;

  --    ,       
  if (not exists(
          select * from d_grouped_res_source where id_grouped_res = :id_grouped_res )) then
    execute procedure d_make_grouped_res_source(:id_grouped_res, :isgroupmode);

  for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE, RABMAT,
             TAB, ALTTAB, NAME, NAME_ID, EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
             BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
             SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
             EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
             SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
             RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
             PA, PB, PC, PD, PE, VRPZ, IDTIPR,
             KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
             PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
             SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH, TIPRAB, IDNORMATIV,
             IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, ARPS_OTHER,
             ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_ADDED_REC, PR_VSEGO,
             PR_VIPOLNENO, PR_EXISTS_CHILDS, NORM_GUID,
             CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB,
             ISHAVECORRECTIONNR,
             CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
             UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
             S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH,
             ISRESPOPR, TYPE_TRUD, SM_REC_ITOG, UCH, --    A_P_SMETA, RES_PRICE_COUNT
             STRUCT_NAME, FULL_STRUCT_NAME,
             IDFORMULS, --CQ[9359]
             STRUCT_SHIFR, --CQ[9609]
             NUMLSR_LS, --CQ[12881]
             CLCMODE_RES, -- CQ[12244]
             VIEW_NUMBER1, VIEW_NUMBER2, VIEW_NUMBER3, ID_LS, ADDED_SMETATYPE, -- MK CQ[12020]
             K_ITOGO/*14460*/, K_PR/*15421*/
  from A_P_SMETA(:IDOBJECT, /*:IDLEVEL*/:IDOBJECT, :IDUSER, :SMETATYPE, /*:NLS*/0, /*:NR*/0, /*:NPR*/0, /*:IDLS*/0, /*:IDR*/0, /*:ALLREC*/1, /*:SENDER*/0)
  where exists(select * from D_GROUPED_RES_SOURCE GR
               where ((GR.ID_GROUPED_RES = :ID_GROUPED_RES) and
                      (GR.ID_SOURCE = A_P_SMETA.ID) and
                      (GR.ID_CEN = :ID_CEN)) ) --CQ[TIMUR 14379]
  into :ID, :IDHIER, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT, :ATYPE, :RABMAT,
       :TAB, :ALTTAB, :NAME, :NAME_ID, :EDIZM, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
       :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
       :SEA, :SEB, :SEC, :SED, :SEE, :SEF, :SEG, :SEH, :SEI, :SEJ, :SEK,
       :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
       :SRA, :SRB, :SRC, :SRD, :SRE, :SRF, :SRG, :SRH, :SRI, :SRJ, :SRK, :SRL, :SRM,
       :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
       :PA, :PB, :PC, :PD, :PE, :VRPZ, :IDTIPR,
       :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :kk, :KL, :KM,
       :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
       :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH, :TIPRAB, :IDNORMATIV,
       :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :ARPS_OTHER,
       :ID_S_RES, :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, :PR_ADDED_REC, :PR_VSEGO,
       :PR_VIPOLNENO, :PR_EXISTS_CHILDS, :NORM_GUID,
       :CALK_BA, :CALK_BB, :CALK_BC, :CALK_BD, :CALK_BE, :STATUS_REC_CEN, :IDREESTR, :PCELLMEM, :VIDRAB,
       :ISHAVECORRECTIONNR,
       :CALK_BG, :CALK_BG_READONLY, :CALK_BH, :CALK_BH_READONLY,
       :UTV, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE,
       :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH,
       :ISRESPOPR, :TYPE_TRUD, :SM_REC_ITOG, :UCH, --    A_P_SMETA, :RES_PRICE_COUNT
       :STRUCT_NAME, :FULL_STRUCT_NAME,
       :IDFORMULS, --CQ[9359]
       :STRUCT_SHIFR, --CQ[9609]
       :NUMLSR_LS, --CQ[12881]
       :CLCMODE_RES, -- CQ[12244]
       :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3, :ID_LS, :ADDED_SMETATYPE, -- MK CQ[12020]
       :K_ITOGO/*14460*/, :K_PR/*15421*/
  do
  begin
    if (not ATYPE in (-5,-4,-3,3,4,5)) then
    begin

      select CA, CB, CC, CD, CE, CF, CG, CH, CI, CJ,
             EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
             RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
             PA, PB, PC, PD
      from A_SMETA_CENLVL
      where ID = :ID AND IDCENLVL = :IDCENLVL
      into
      :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
      :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
      :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
      :PA, :PB, :PC, :PD;

      if ((WITHSTRUCT<>0)and(not IDHIER in (LAST_LS, LAST_R, LAST_PR))) then
      begin
        FID =                  :ID;
        FIDHIER =              :IDHIER;
        FNUMBER1 =             :NUMBER1;
        FNUMBER2 =             :NUMBER2;
        FNUMBER3 =             :NUMBER3;
        FSLAVEPARENT =         :SLAVEPARENT;
        FATYPE =               :ATYPE;
        FRABMAT =              :RABMAT;
        FTAB =                 :TAB;
        FALTTAB =              :ALTTAB;
        FNAME =                :NAME;
        FNAME_ID =             :NAME_ID;
        FEDIZM =               :EDIZM;
        FID_EDIZM =            :ID_EDIZM;
        FEDIZM_TYPE =          :EDIZM_TYPE;
        FKOLL =                :KOLL;
        FSKOLL =               :SKOLL;
        FNORMARASH =           :NORMARASH;
        FBA =                  :BA;
        FBB =                  :BB;
        FBC =                  :BC;
        FBD =                  :BD;
        FBE =                  :BE;
        FBF =                  :BF;
        FBG =                  :BG;
        FBH =                  :BH;
        FBI =                  :BI;
        FBJ =                  :BJ;
        FSEA =                 :SEA;
        FSEB =                 :SEB;
        FSEC =                 :SEC;
        FSED =                 :SED;
        FSEE =                 :SEE;
        FSEF =                 :SEF;
        FSEG =                 :SEG;
        FSEH =                 :SEH;
        FSEI =                 :SEI;
        FSEJ =                 :SEJ;
        FSEK =                 :SEK;
        FEA =                  :EA;
        FEB =                  :EB;
        FEC =                  :EC;
        FED =                  :ED;
        FEE =                  :EE;
        FEF =                  :EF;
        FEG =                  :EG;
        FEH =                  :EH;
        FEI =                  :EI;
        FEJ =                  :EJ;
        FEK =                  :EK;
        FSRA =                 :SRA;
        FSRB =                 :SRB;
        FSRC =                 :SRC;
        FSRD =                 :SRD;
        FSRE =                 :SRE;
        FSRF =                 :SRF;
        FSRG =                 :SRG;
        FSRH =                 :SRH;
        FSRI =                 :SRI;
        FSRJ =                 :SRJ;
        FSRK =                 :SRK;
        FSRL =                 :SRL;
        FSRM =                 :SRM;
        FRA =                  :RA;
        FRB =                  :RB;
        FRC =                  :RC;
        FRD =                  :RD;
        FRE =                  :RE;
        FRF =                  :RF;
        FRG =                  :RG;
        FRH =                  :RH;
        FRI =                  :RI;
        FRJ =                  :RJ;
        FRK =                  :RK;
        FRL =                  :RL;
        FRM =                  :RM;
        FPA =                  :PA;
        FPB =                  :PB;
        FPC =                  :PC;
        FPD =                  :PD;
        FPE =                  :PE;
        FVRPZ =                :VRPZ;
        FIDTIPR =              :IDTIPR;
        FKA =                  :KA;
        FKB =                  :KB;
        FKC =                  :KC;
        FKD =                  :KD;
        FKE =                  :KE;
        FKF =                  :KF;
        FKG =                  :KG;
        FKH =                  :KH;
        FKI =                  :KI;
        FKJ =                  :KJ;
        FKK =                  :KK;
        FKL =                  :KL;
        FKM =                  :KM;
        FPUNKTIND =            :PUNKTIND;
        FMA =                  :MA;
        FMB =                  :MB;
        FMC =                  :MC;
        FMD =                  :MD;
        FME =                  :ME;
        FMF =                  :MF;
        FMG =                  :MG;
        FMH =                  :MH;
        FMI =                  :MI;
        FMJ =                  :MJ;
        FMK =                  :MK;
        FML =                  :ML;
        FSSTCH =               :SSTCH;
        FKODZAK =              :KODZAK;
        FKODGP =               :KODGP;
        FKODSP =               :KODSP;
        FKODISP =              :KODISP;
        FNACH =                :NACH;
        FOKONCH =              :OKONCH;
        FTIPRAB =              :TIPRAB;
        FIDNORMATIV =          :IDNORMATIV;
        FIDNORMATIVUNIQ =      :IDNORMATIVUNIQ;
        FKODIR_GROUP =         :KODIR_GROUP;
        FKODIR_PODGROUP =      :KODIR_PODGROUP;
        FISGROUPOKP =          :ISGROUPOKP;
        FARPS_OTHER =          :ARPS_OTHER;
        FID_S_RES =            :ID_S_RES;
        FPR_NUMBER1 =          :PR_NUMBER1;
        FPR_NUMBER2 =          :PR_NUMBER2;
        FPR_NUMBER3 =          :PR_NUMBER3;
        FPR_ADDED_REC =        :PR_ADDED_REC;
        FPR_VSEGO =            :PR_VSEGO;
        FPR_VIPOLNENO =        :PR_VIPOLNENO;
        FPR_EXISTS_CHILDS =    :PR_EXISTS_CHILDS;
        FNORM_GUID =           :NORM_GUID;
        FCALK_BA =             :CALK_BA;
        FCALK_BB =             :CALK_BB;
        FCALK_BC =             :CALK_BC;
        FCALK_BD =             :CALK_BD;
        FCALK_BE =             :CALK_BE;
        FSTATUS_REC_CEN =      :STATUS_REC_CEN;
        FIDREESTR =            :IDREESTR;
        FPCELLMEM =            :PCELLMEM;
        FVIDRAB =              :VIDRAB;
        FISHAVECORRECTIONNR =  :ISHAVECORRECTIONNR;
        FCALK_BG =             :CALK_BG;
        FCALK_BG_READONLY =    :CALK_BG_READONLY;
        FCALK_BH =             :CALK_BH;
        FCALK_BH_READONLY =    :CALK_BH_READONLY;
        FUTV =                 :UTV;
        FCORRECTNODE =         :CORRECTNODE;
        FCORRECTNODE_1 =       :CORRECTNODE_1;
        FASUBTYPE =            :ASUBTYPE;

        FCLCMODE =             :CLCMODE;
        FS_BA =                :S_BA;
        FS_BB =                :S_BB;
        FS_BC =                :S_BC;
        FS_BD =                :S_BD;
        FS_BE =                :S_BE;
        FS_BG =                :S_BG;
        FS_BH =                :S_BH;
        FISRESPOPR =           :ISRESPOPR;
        FTYPE_TRUD =           :TYPE_TRUD;
        FSM_REC_ITOG =         :SM_REC_ITOG;
        FUCH =                 :UCH;
        FSTRUCT_NAME =         :STRUCT_NAME;
        FFULL_STRUCT_NAME =    :FULL_STRUCT_NAME;

        FSTRUCT_SHIFR = :STRUCT_SHIFR;--CQ[9609]
        FCLCMODE_RES = :CLCMODE_RES; -- CQ[12244]

        -- MK CQ[12020] --->
        FVIEW_NUMBER1 = :VIEW_NUMBER1;
        FVIEW_NUMBER2 = :VIEW_NUMBER2;
        FVIEW_NUMBER3 = :VIEW_NUMBER3;
        FID_LS = :ID_LS;
        FADDED_SMETATYPE = :ADDED_SMETATYPE;
        -- MK CQ[12020] <---

        FK_ITOGO = :K_ITOGO;
        FK_PR = :K_PR; /*15421*/

        --<[11536]>
        WHERE_LS = null;
        WHERE_R = null;
        WHERE_PR = null;
        for select ID, ATYPE
            from D_GET_HIER_PARENTS(:IDUSER, :IDHIER, 3)
            into :ID, :ATYPE
        do
        if (:ATYPE = 3) then WHERE_LS=:ID;
        else
        if (:ATYPE = 4) then WHERE_R=:ID;
        else
        if (:ATYPE = 5) then WHERE_PR=:ID;
        --</>

        for select ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT,
                   case when ATYPE < 0 then -ATYPE else ATYPE end/*[11536]D_GET_HIER_PARENTS.ATYPE*/,
                   RABMAT, TAB, ALTTAB, NAME, NAME_ID,
                   EDIZM, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
                   BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
                   SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
                   EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                   SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
                   RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                   PA, PB, PC, PD, PE, VRPZ, IDTIPR,
                   KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                   PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
                   SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH,
                   TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP,
                   ISGROUPOKP, ARPS_OTHER, ID_S_RES, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3,
                   PR_ADDED_REC, PR_VSEGO, PR_VIPOLNENO, PR_EXISTS_CHILDS, NORM_GUID,
                   CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE,
                   STATUS_REC_CEN, IDREESTR, PCELLMEM, VIDRAB, ISHAVECORRECTIONNR,
                   CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY,
                   UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE,
                   S_BA, S_BB, S_BC, S_BD, S_BE, S_BG, S_BH,
                   ISRESPOPR, TYPE_TRUD, SM_REC_ITOG, UCH,
                   STRUCT_NAME, FULL_STRUCT_NAME,
                   IDFORMULS, --CQ[9359]
                   STRUCT_SHIFR, --CQ[9609]
                   NUMLSR_LS, --CQ[12881]
                   CLCMODE_RES, -- CQ[12244]
                   VIEW_NUMBER1, VIEW_NUMBER2, VIEW_NUMBER3, ID_LS, ADDED_SMETATYPE, -- MK CQ[12020]
                   K_ITOGO/*14460*/, K_PR/*15421*/
        from A_P_SMETA(:IDOBJECT, /*:IDLEVEL*/:IDOBJECT, :IDUSER, :SMETATYPE, /*:NLS*/0, /*:NR*/0, /*:NPR*/0, /*:IDLS*/0, /*:IDR*/0, /*:ALLREC*/1, /*:SENDER=*/-1/*[11536]0*/)
        /*--[11536]
        inner join D_GET_HIER_PARENTS(:IDUSER, :IDHIER, 3) on
        A_P_SMETA.ID=D_GET_HIER_PARENTS.ID
--        where ID in (select ID from D_GET_HIER_PARENTS(:IDUSER, :IDHIER, 3))
        where D_GET_HIER_PARENTS.ATYPE is not null
        order by D_GET_HIER_PARENTS.ATYPE
        */
        --<[11536]>
        where ID in (:WHERE_LS, :WHERE_R, :WHERE_PR)
        --</>
        into :ID, :IDHIER, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT,
             :ATYPE,
             :RABMAT, :TAB, :ALTTAB, :NAME, :NAME_ID,
             :EDIZM, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
             :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
             :SEA, :SEB, :SEC, :SED, :SEE, :SEF, :SEG, :SEH, :SEI, :SEJ, :SEK,
             :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
             :SRA, :SRB, :SRC, :SRD, :SRE, :SRF, :SRG, :SRH, :SRI, :SRJ, :SRK, :SRL, :SRM,
             :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
             :PA, :PB, :PC, :PD, :PE, :VRPZ, :IDTIPR,
             :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
             :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
             :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH,
             :TIPRAB, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP,
             :ISGROUPOKP, :ARPS_OTHER, :ID_S_RES, :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3,
             :PR_ADDED_REC, :PR_VSEGO, :PR_VIPOLNENO, :PR_EXISTS_CHILDS, :NORM_GUID,
             :CALK_BA, :CALK_BB, :CALK_BC, :CALK_BD, :CALK_BE,
             :STATUS_REC_CEN, :IDREESTR, :PCELLMEM, :VIDRAB, :ISHAVECORRECTIONNR,
             :CALK_BG, :CALK_BG_READONLY, :CALK_BH, :CALK_BH_READONLY,
             :UTV, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE,
             :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BG, :S_BH,
             :ISRESPOPR, :TYPE_TRUD, :SM_REC_ITOG, :UCH,
             :STRUCT_NAME, :FULL_STRUCT_NAME,
             :IDFORMULS, --CQ[9359]
             :STRUCT_SHIFR, --CQ[9609]
             :NUMLSR_LS, --CQ[12881]
             :CLCMODE_RES, -- CQ[12244]
             :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3, :ID_LS, :ADDED_SMETATYPE, -- MK CQ[12020]
             :K_ITOGO/*14460*/, :K_PR/*15421*/
        do
        begin
          if ((ATYPE in (-3,3))and(ID<>LAST_LS)
             or(ATYPE in (-4,4))and(ID<>LAST_R)
             or(ATYPE in (-5,5))and(ID<>LAST_PR))
          then
            suspend;
          if (ATYPE in (-3,3)) then
            LAST_LS=:ID;
          else
          if (ATYPE in (-4,4)) then
            LAST_R=:ID;
          else
          if (ATYPE in (-5,5)) then
            LAST_PR=:ID;
        end
        ID =                  :FID;
        IDHIER =              :FIDHIER;
        NUMBER1 =             :FNUMBER1;
        NUMBER2 =             :FNUMBER2;
        NUMBER3 =             :FNUMBER3;
        SLAVEPARENT =         :FSLAVEPARENT;
        ATYPE =               :FATYPE;
        RABMAT =              :FRABMAT;
        TAB =                 :FTAB;
        ALTTAB =              :FALTTAB;
        NAME =                :FNAME;
        NAME_ID =             :FNAME_ID;
        EDIZM =               :FEDIZM;
        ID_EDIZM =            :FID_EDIZM;
        EDIZM_TYPE =          :FEDIZM_TYPE;
        KOLL =                :FKOLL;
        SKOLL =               :FSKOLL;
        NORMARASH =           :FNORMARASH;
        BA =                  :FBA;
        BB =                  :FBB;
        BC =                  :FBC;
        BD =                  :FBD;
        BE =                  :FBE;
        BF =                  :FBF;
        BG =                  :FBG;
        BH =                  :FBH;
        BI =                  :FBI;
        BJ =                  :FBJ;
        SEA =                 :FSEA;
        SEB =                 :FSEB;
        SEC =                 :FSEC;
        SED =                 :FSED;
        SEE =                 :FSEE;
        SEF =                 :FSEF;
        SEG =                 :FSEG;
        SEH =                 :FSEH;
        SEI =                 :FSEI;
        SEJ =                 :FSEJ;
        SEK =                 :FSEK;
        EA =                  :FEA;
        EB =                  :FEB;
        EC =                  :FEC;
        ED =                  :FED;
        EE =                  :FEE;
        EF =                  :FEF;
        EG =                  :FEG;
        EH =                  :FEH;
        EI =                  :FEI;
        EJ =                  :FEJ;
        EK =                  :FEK;
        SRA =                 :FSRA;
        SRB =                 :FSRB;
        SRC =                 :FSRC;
        SRD =                 :FSRD;
        SRE =                 :FSRE;
        SRF =                 :FSRF;
        SRG =                 :FSRG;
        SRH =                 :FSRH;
        SRI =                 :FSRI;
        SRJ =                 :FSRJ;
        SRK =                 :FSRK;
        SRL =                 :FSRL;
        SRM =                 :FSRM;
        RA =                  :FRA;
        RB =                  :FRB;
        RC =                  :FRC;
        RD =                  :FRD;
        RE =                  :FRE;
        RF =                  :FRF;
        RG =                  :FRG;
        RH =                  :FRH;
        RI =                  :FRI;
        RJ =                  :FRJ;
        RK =                  :FRK;
        RL =                  :FRL;
        RM =                  :FRM;
        PA =                  :FPA;
        PB =                  :FPB;
        PC =                  :FPC;
        PD =                  :FPD;
        PE =                  :FPE;
        VRPZ =                :FVRPZ;
        IDTIPR =              :FIDTIPR;
        KA =                  :FKA;
        KB =                  :FKB;
        KC =                  :FKC;
        KD =                  :FKD;
        KE =                  :FKE;
        KF =                  :FKF;
        KG =                  :FKG;
        KH =                  :FKH;
        KI =                  :FKI;
        KJ =                  :FKJ;
        KK =                  :FKK;
        KL =                  :FKL;
        KM =                  :FKM;
        PUNKTIND =            :FPUNKTIND;
        MA =                  :FMA;
        MB =                  :FMB;
        MC =                  :FMC;
        MD =                  :FMD;
        ME =                  :FME;
        MF =                  :FMF;
        MG =                  :FMG;
        MH =                  :FMH;
        MI =                  :FMI;
        MJ =                  :FMJ;
        MK =                  :FMK;
        ML =                  :FML;
        SSTCH =               :FSSTCH;
        KODZAK =              :FKODZAK;
        KODGP =               :FKODGP;
        KODSP =               :FKODSP;
        KODISP =              :FKODISP;
        NACH =                :FNACH;
        OKONCH =              :FOKONCH;
        TIPRAB =              :FTIPRAB;
        IDNORMATIV =          :FIDNORMATIV;
        IDNORMATIVUNIQ =      :FIDNORMATIVUNIQ;
        KODIR_GROUP =         :FKODIR_GROUP;
        KODIR_PODGROUP =      :FKODIR_PODGROUP;
        ISGROUPOKP =          :FISGROUPOKP;
        ARPS_OTHER =          :FARPS_OTHER;
        ID_S_RES =            :FID_S_RES;
        PR_NUMBER1 =          :FPR_NUMBER1;
        PR_NUMBER2 =          :FPR_NUMBER2;
        PR_NUMBER3 =          :FPR_NUMBER3;
        PR_ADDED_REC =        :FPR_ADDED_REC;
        PR_VSEGO =            :FPR_VSEGO;
        PR_VIPOLNENO =        :FPR_VIPOLNENO;
        PR_EXISTS_CHILDS =    :FPR_EXISTS_CHILDS;
        NORM_GUID =           :FNORM_GUID;
        CALK_BA =             :FCALK_BA;
        CALK_BB =             :FCALK_BB;
        CALK_BC =             :FCALK_BC;
        CALK_BD =             :FCALK_BD;
        CALK_BE =             :FCALK_BE;
        STATUS_REC_CEN =      :FSTATUS_REC_CEN;
        IDREESTR =            :FIDREESTR;
        PCELLMEM =            :FPCELLMEM;
        VIDRAB =              :FVIDRAB;
        ISHAVECORRECTIONNR =  :FISHAVECORRECTIONNR;
        CALK_BG =             :FCALK_BG;
        CALK_BG_READONLY =    :FCALK_BG_READONLY;
        CALK_BH =             :FCALK_BH;
        CALK_BH_READONLY =    :FCALK_BH_READONLY;
        UTV =                 :FUTV;
        CORRECTNODE =         :FCORRECTNODE;
        CORRECTNODE_1 =       :FCORRECTNODE_1;
        ASUBTYPE =            :FASUBTYPE;

        CLCMODE =             :FCLCMODE;
        S_BA =                :FS_BA;
        S_BB =                :FS_BB;
        S_BC =                :FS_BC;
        S_BD =                :FS_BD;
        S_BE =                :FS_BE;
        S_BG =                :FS_BG;
        S_BH =                :FS_BH;
        ISRESPOPR =           :FISRESPOPR;
        TYPE_TRUD =           :FTYPE_TRUD;
        SM_REC_ITOG =         :FSM_REC_ITOG;
        --UCH =                 :FUCH; --<<    ,  ,    ,   
        STRUCT_NAME =         :FSTRUCT_NAME;
        FULL_STRUCT_NAME =    :FFULL_STRUCT_NAME;
        STRUCT_SHIFR = :FSTRUCT_SHIFR;--CQ[9609]
        CLCMODE_RES = :FCLCMODE_RES;-- CQ[12244]

        -- MK CQ[12020] --->
        VIEW_NUMBER1 = :FVIEW_NUMBER1;
        VIEW_NUMBER2 = :FVIEW_NUMBER2;
        VIEW_NUMBER3 = :FVIEW_NUMBER3;
        ID_LS = :FID_LS;
        ADDED_SMETATYPE = :FADDED_SMETATYPE;
        -- MK CQ[12020] <---

        K_ITOGO = :FK_ITOGO;
        K_PR = :FK_PR; /*15421*/

      end
      suspend;
    end
  end
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE D_REPLACE_ONE_RES (
*/
--[15352]
CREATE OR ALTER PROCEDURE D_SET_POPR_VALUE (
    IN_KA VARCHAR(50),
    IN_KB VARCHAR(50),
    IN_KC VARCHAR(50),
    IN_KD VARCHAR(50),
    IN_KE VARCHAR(50),
    IN_KF VARCHAR(50),
    IN_KG VARCHAR(50),
    IN_KH VARCHAR(50),
    IN_KI VARCHAR(50),
    IN_KJ VARCHAR(50),
    IN_KK VARCHAR(50),
    IN_KL VARCHAR(50),
    IN_KM VARCHAR(50),
    IN_K_ITOGO VARCHAR(50),
    IN_K_PR VARCHAR(50),
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    CORRECT VARCHAR(50),
    TO_PRICE_POPRS INTEGER)
RETURNS (
    OUT_KA VARCHAR(50),
    OUT_KB VARCHAR(50),
    OUT_KC VARCHAR(50),
    OUT_KD VARCHAR(50),
    OUT_KE VARCHAR(50),
    OUT_KF VARCHAR(50),
    OUT_KG VARCHAR(50),
    OUT_KH VARCHAR(50),
    OUT_KI VARCHAR(50),
    OUT_KJ VARCHAR(50),
    OUT_KK VARCHAR(50),
    OUT_KL VARCHAR(50),
    OUT_KM VARCHAR(50),
    OUT_K_ITOGO VARCHAR(50),
    OUT_K_PR VARCHAR(50))
AS
  declare variable RT_TRUD integer;
  declare variable RT_MASH integer;
  declare variable RT_MAT integer;

  declare variable TT_BUILD integer;
  declare variable TT_MASH integer;
begin
--[15352]+
  RT_TRUD = 1;
  RT_MASH = 2;
  RT_MAT  = 3;

  TT_BUILD = 1;
  TT_MASH  = 2;

  OUT_KA = :IN_KA;
  OUT_KB = :IN_KB;
  OUT_KC = :IN_KC;
  OUT_KD = :IN_KD;
  OUT_KE = :IN_KE;
  OUT_KF = :IN_KF;
  OUT_KG = :IN_KG;
  OUT_KH = :IN_KH;
  OUT_KI = :IN_KI;
  OUT_KJ = :IN_KJ;
  OUT_KK = :IN_KK;
  OUT_KL = :IN_KL;
  OUT_KM = :IN_KM;
  OUT_K_ITOGO = :IN_K_ITOGO; /*14460*/
  OUT_K_PR = :IN_K_PR; /*15421*/
  
  if (RABMAT = RT_TRUD) then
  begin
    if (TYPE_TRUD = TT_BUILD) then
    begin
      if (TO_PRICE_POPRS = 1) then
        OUT_KE = :CORRECT;
      else
        OUT_KG = :CORRECT;
    end
    else
    if (TYPE_TRUD = TT_MASH) then
    begin
      if (TO_PRICE_POPRS = 1) then
        OUT_KD = :CORRECT;
      else
        OUT_KH = :CORRECT;
    end
  end
  else
  if (RABMAT = RT_MAT) then
  begin
    if (TO_PRICE_POPRS = 1) then
      OUT_KB = :CORRECT;
    else
      OUT_KL = :CORRECT;
  end
  else
  if (RABMAT = RT_MASH) then
  begin
    if (TO_PRICE_POPRS = 1) then
      OUT_KC = :CORRECT;
    else
      OUT_KM = :CORRECT;
  end
  suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_ADD_LEVEL_IN_SMETA_ONE (
    IDUSER INTEGER,
    IDSMETAREC INTEGER,
    IDLEVEL INTEGER)
AS
declare variable IDHIER integer;
--CQ[11104]  , .   AID = IDSMETAREC declare variable AID integer;
declare variable ARESID integer;
declare variable ATYPE integer;
declare variable TYPE_RAB integer;
declare variable VID_RAB integer;
declare variable PUNKTIND varchar(42);
declare variable SMETATYPE integer;
declare variable RABMAT integer;
declare variable IDNORMATIV integer;
declare variable SLAVEPARENT integer;
declare variable KODIR_PODGROUP integer;
declare variable BA double precision;
declare variable BB double precision;
declare variable BC double precision;
declare variable BD double precision;
declare variable BE double precision;

declare variable BF double precision;
declare variable BG double precision;
declare variable BH double precision;
declare variable BI double precision;
declare variable BJ double precision;
--CQ[TIMUR 13178]
declare variable BN double precision;
declare variable BO double precision;
declare variable B_ITOGO double precision;
--CQ[TIMUR 13178]

declare B_PR double precision; --[15352]

--declare variable APPLYONRES integer;
declare variable ID_S_RES integer;
--.  declare variable IDTR_STR integer;
declare variable IN_RES_COPY_FORMULS integer;
declare variable VRPZ integer;

declare variable RES_VRPZ integer;
declare variable RES_RABMAT integer;
declare variable RES_IDNORMATIV integer;
declare variable RES_KODIR_PODGROUP integer;
--:   declare variable RES_PUNKTIND varchar(42);
declare variable RES_ID_SOURCE integer;
declare variable RES_TYPE_RAB integer;
declare variable RES_VID_RAB integer;
declare variable RES_BB double precision;
declare variable RES_BC double precision;
declare variable RES_BD double precision;
declare variable RES_BE double precision;

declare variable TEMPFLOAT double precision;
declare variable TEMPINT integer;
declare variable NL_RES_IDZONE integer;
declare variable NL_RES_ID_LEVEL_VC integer;
declare variable NL_RES_BB double precision;
declare variable NL_RES_BC double precision;
declare variable NL_RES_BD double precision;
declare variable NL_RES_BE double precision;
declare variable NL_RES_BASE_INFO integer;

declare variable NL_ID_LEVEL_VC integer;
declare variable NL_IDZONE integer;
declare variable NL_ID_LEVEL_INDEX integer;
declare variable NL_IDINDEX integer;
declare variable NL_BA double precision;
declare variable NL_BB double precision;
declare variable NL_BC double precision;
declare variable NL_BD double precision;
declare variable NL_BE double precision;
declare NL_B_PR double precision; --[15352]
declare variable NL_MA double precision;
declare variable NL_MB double precision;
declare variable NL_MC double precision;
declare variable NL_MD double precision;
declare variable NL_PA double precision;
declare variable NL_PB double precision;
declare variable NL_PC double precision;
declare variable NL_PD double precision;
declare variable NL_ME double precision;
declare variable NL_MF double precision;
declare variable NL_MG double precision;
declare variable NL_MH double precision;
declare variable NL_MI double precision;
declare variable NL_PUNKTIND varchar(42);
declare variable NL_SPOSOB_RASCH integer;
declare variable NL_RES_VC integer;
declare variable NL_RES_INDEX integer;

declare variable IDTR integer;

--CQ[9769] -->
declare variable CENLVLSOURCEID integer;
declare variable BASEINFOSOURCE integer;
declare variable INDEXINFOSOURCE integer;
-- MK 11.04.2012 CQ[10342] --->
--declare variable PA double precision;
--declare variable PB double precision;
-- MK 11.04.2012 CQ[10342] <---
declare variable PC double precision;
declare variable PD double precision;
-- MK 11.04.2012 CQ[10342] --->
--declare variable MF double precision;
--declare variable MG double precision;
-- MK 11.04.2012 CQ[10342] <---
declare variable MH double precision;
declare variable MI double precision;
--CQ[9769] <--

declare IDOBJECT integer;
--declare SMETATYPE integer;

declare variable SEARCH_NORM_ID integer;
declare variable SEARCH_RESULT integer;
--declare variable ID_EDIZM integer;
--declare variable NAME_ID integer;
declare variable TAB varchar(42);
--declare variable ID_PUT_RAB integer;
--declare variable ID_PUT_MASH integer;
--declare variable ID_PUT_MAT integer;
--declare variable S_EDIZM_NAME VARCHAR(100);
--declare variable S_NAME_CRC integer;

declare NORM_GUID varchar(100);
declare RES_NORM_GUID varchar(100);

declare variable NL_MJ double precision;
declare variable NL_MK  double precision;
declare variable NL_ML double precision;
declare variable NL_MM double precision;
declare NL_M_PR double precision; --[15352]
declare variable NL_DA double precision;
declare variable NL_DB double precision;
declare variable NL_DC double precision;
declare variable NL_DD double precision;
declare variable NL_DE double precision;
declare variable NL_DJ double precision;
declare variable NL_DK  double precision;
declare variable NL_DL double precision;
declare variable NL_DM double precision;

declare variable NEED_APPLY_INDEX integer;

declare variable BASE_CALC_INFO integer;
declare variable MODE_KOMPNS_ST integer;
--[12113]declare variable APPLY_TO_ALL_LEVELS integer;
declare variable UCHIT_NDS integer;
declare APPLY_TO_ALL_IDLEVEL integer; --<<[12113]

-- MK CQ[13174]
declare variable VN_NEED_RECALC_ITOGO_B integer;
begin
--[15352]

-- stolen from DM_ADD_LEVEL_IN_SMETA .[A98BAC0A57D8]

--IDOBJECT integer

--  SMETATYPE = 15;

/*
  select IDHIER, SMETATYPE
    from A_SMETA
    where ID = :IDSMETAREC
    into :IDHIER, :SMETATYPE;
  ...
*/

  NEED_APPLY_INDEX = 1;--CQ[10929] :  = 1,    

/*
  for select IDHIER --NUMBER
      from S_O_HIER_SELECT2(:IDOBJECT) --L_H_SELTREE_HIER(:IDUSER, :IDOBJECT)
      into :IDHIER
  do
*/
  begin
    for select --CQ[11104]ID,
               ATYPE, TIPRAB, VIDRAB, PUNKTIND,
               IDHIER, SMETATYPE,
               RABMAT, IDNORMATIV, SLAVEPARENT,
               KODIR_PODGROUP, ID_S_RES,
               BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BN, BO, B_ITOGO, 
               B_PR, --[15352]
               --.  coalesce(IDTIPR, 0),
               VRPZ,
               TAB, --NAME_ID, ID_EDIZM, --CQ[10058]
               NORM_GUID
        from A_SMETA
        where ID = :IDSMETAREC
        --      IDHIER = :IDHIER and
        --      SMETATYPE = 15 --:        .     
        --      and
        --      ATYPE in (17, 18)
        into --CQ[11104]:AID,
             :ATYPE, :TYPE_RAB, :VID_RAB, :PUNKTIND,
             :IDHIER, :SMETATYPE,
             :RABMAT, :IDNORMATIV, :SLAVEPARENT, :KODIR_PODGROUP, :ID_S_RES,
             :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
             :B_PR, --[15352]
             --.  :IDTR_STR,
             :VRPZ,
             :TAB, --:NAME_ID, :ID_EDIZM, --CQ[10058]
             :NORM_GUID
    do
    begin
      -- MK CQ[13174]
      VN_NEED_RECALC_ITOGO_B = 0;


      if (:SMETATYPE = 15) then
      begin
        execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1/*ObgectType*/)
          returning_values (:IDOBJECT);

        select --PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT, --CQ[10058]
               RES_COPY_FORMULS, ID_TR,
               MODE_KOMPNS_ST, --CQ[10892]
               null --APPLY_TO_ALL_IDLEVEL --<<[12113] -    
          from A_O_OBJECTPARAMS
          where NUMBER = :IDOBJECT
          into --:ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, --CQ[10058]
               :IN_RES_COPY_FORMULS, :IDTR,
               :MODE_KOMPNS_ST,--CQ[10892]
               :APPLY_TO_ALL_IDLEVEL; --<<[12113]

      end
      else
      --CQ[9316]-->         exit;
      begin
        select RES_COPY_FORMULS, ID_TR,
          MODE_KOMPNS_ST, --CQ[10892]
          null --APPLY_TO_ALL_IDLEVEL --<<[12113] -    
          from a_o_factparams
          where NUMBER = :SMETATYPE
          into  :IN_RES_COPY_FORMULS, :IDTR,
          :MODE_KOMPNS_ST,--CQ[10892]
          :APPLY_TO_ALL_IDLEVEL; --<<[12113]
      end
      --CQ[9316]<--

/*[10430]
      --CQ[10058]-->
      --   
      -- <-- Voyager. . CQ[CQ9681].    Select  B_NNAME
      --select first 1 K_GETCRC32(NAME)
      --from B_GETNAME_EX(:IDUSER, :NAME_ID)
      --into :S_NAME_CRC;

      select CRC_NAME_TITLE from B_NNAME
      where ID = :NAME_ID into :S_NAME_CRC;

      --  
      select first 1 EDIZMNAME
      from B_GET_EDIZM(:ID_EDIZM)
      into :S_EDIZM_NAME;

      execute procedure T_FB_SEARCH_NORMATIV (:KODIR_PODGROUP, -1, :IDUSER, :TAB,
                 :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0, :S_NAME_CRC, :S_EDIZM_NAME, 0)
          returning_values (:SEARCH_NORM_ID, :SEARCH_RESULT);
*/
      execute procedure L_GET_NORMATIV_FROM_GUID_RES(:NORM_GUID, :TAB, :IDNORMATIV, :KODIR_PODGROUP, :RABMAT, :IDUSER)
          returning_values :SEARCH_NORM_ID, :KODIR_PODGROUP, :RABMAT, :SEARCH_RESULT;

      --  ,     
      if (SEARCH_RESULT = 0) then
      begin
        BJ = null; --
        execute procedure GET_NORM_BASE_COSTS(:SEARCH_NORM_ID, :RABMAT, :KODIR_PODGROUP)
        returning_values (:BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, /*BJ*/:B_ITOGO, :BN, :BO,
          :B_PR);
      end
      --CQ[10058]<--

      -- ID      
      --     (   ) if (:IDTR_STR = 0) then
      --.  IDTR_STR = :IDTR;
      --  , ,    (   )
      execute procedure A_S_GET_FORMUL_NRSPZU_NL_1(:IDUSER, :ATYPE, :SLAVEPARENT,
          --.  :IDTR_STR,
          :IDTR, :VRPZ, :IN_RES_COPY_FORMULS, :IDLEVEL/*[9751]*/)
      returning_values (:NL_PA, :NL_PB, :NL_PC, :NL_PD);

      --CQ[9769] -->
      CENLVLSOURCEID = null;
      BASEINFOSOURCE = null;
      INDEXINFOSOURCE = null;
      select first 1 IDCENLVL, BASE_INFO--CQ[10529], INDEX_INFO
      from A_SMETA_CENLVL
      where ID = :IDSMETAREC and --CQ[11104]:AID and
            IDCENLVL <> :IDLEVEL and
            (BASE_INFO = 2)--CQ[10529] or INDEX_INFO = 2)
      into :CENLVLSOURCEID, BASEINFOSOURCE;--CQ[10529], INDEXINFOSOURCE;

      --CQ[10529]>>         
      if (CENLVLSOURCEID is null) then
        select first 1 IDCENLVL, INDEX_INFO
        from A_SMETA_INDLVL
        where ID = :IDSMETAREC and --CQ[11104]:AID and
              IDCENLVL <> :IDLEVEL and
              (INDEX_INFO = 3)
        into :CENLVLSOURCEID, INDEXINFOSOURCE;

      if (CENLVLSOURCEID is not null) then
      begin
        for select C.BA, C.BB, C.BC, C.BD, C.BE, C.BF, C.BG, C.BH, C.BI, C.BJ, C.BN, C.BO, C.B_ITOGO,
            C.B_PR, --[15352]
            /*PA, PB,*/ C.PC, C.PD, /*MF, MG,*/ I.MH, I.MI,
            getbit(C.base_calc_info, 5) -- MK CQ[13174]
            from A_SMETA_CENLVL C
            join A_SMETA_INDLVL I on I.ID = C.ID and I.IDCENLVL = C.IDCENLVL --CQ[10529]
            where C.ID = :IDSMETAREC and --CQ[11104]:AID and
                  C.IDCENLVL = :CENLVLSOURCEID
            into :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN,  :BO, :B_ITOGO,
                 :B_PR, --[15352]
                 /*:PA, :PB,*/ :PC, :PD, /*:MF, :MG,*/ :MH, :MI,
                 :VN_NEED_RECALC_ITOGO_B -- MK CQ[13174]
        do
        begin
          if (BASEINFOSOURCE = 2) then
          begin
            -- MK 11.04.2012 CQ[10342] --->
            --NL_PA = :PA;
            --NL_PB = :PB;
            -- MK 11.04.2012 CQ[10342] <---
            NL_PC = :PC;
            NL_PD = :PD;
          end
        end
      end
      --CQ[9769] <--

      execute procedure NL_GET_CENLVL_NEW (:IDLEVEL,--CQ[10929]NL_GET_CENLVL(:IDLEVEL,
          case when :SMETATYPE > 999 then :SMETATYPE else :IDOBJECT end, :IDUSER, :TYPE_RAB,
          :VID_RAB, :ATYPE, :RABMAT, :IDHIER, :IDNORMATIV, :KODIR_PODGROUP, :PUNKTIND, 0, :BA, :BB,
          :BC, :BD, :BE,
          :B_PR, --[15352]
          :IDSMETAREC,--CQ[11104]:SLAVEPARENT,
          :NEED_APPLY_INDEX)--CQ[10929]
      returning_values (:NL_ID_LEVEL_VC, :NL_IDZONE, :NL_ID_LEVEL_INDEX, :NL_IDINDEX, :NL_BA,
          :NL_BB, :NL_BC, :NL_BD, :NL_BE,
          :NL_B_PR, --[15352]
          :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF, :NL_MG,
          :NL_MH, :NL_MI,
          :NL_MJ, :NL_MK, :NL_ML, :NL_MM, --CQ[10529]
          :NL_M_PR, --[15352]
          :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE, :NL_DJ, :NL_DK, :NL_DL, :NL_DM,--CQ[10529]
          :NL_PUNKTIND, :NL_SPOSOB_RASCH, :NL_RES_VC, :NL_RES_INDEX);

      --CQ[9769] -->
      --   
      if (NL_RES_INDEX = -2) then
      begin
        --  , ,   
        if (INDEXINFOSOURCE = 3) then
        begin
          -- MK 11.04.2012 CQ[10342] --->
          --NL_MF = :MF;
          --NL_MG = :MG;
          -- MK 11.04.2012 CQ[10342] <---
          NL_MH = :MH;
          NL_MI = :MI;
          NL_RES_INDEX = :INDEXINFOSOURCE;
        end

      end
      --   
      if (NL_RES_VC = -2) then
      begin
        if (BASEINFOSOURCE = 2) then
        begin
          NL_RES_VC = :BASEINFOSOURCE;
        end
      end
      --CQ[9769] <--

      --        
      /*CQ[10529]execute procedure A_SMETA_INS_OR_UPD_CENLVL(:AID, :IDLEVEL, :NL_IDZONE, :NL_IDINDEX,
          :NL_ID_LEVEL_INDEX, :NL_ID_LEVEL_VC, :NL_BA, :NL_BB, :NL_BC, :NL_BD, :NL_BE, :BF, :BG,
          :BH, :BI, :BJ, :NL_PUNKTIND, :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF, :NL_MG,
          :NL_MH, :NL_MI, :NL_PA, :NL_PB, :NL_PC, :NL_PD, :NL_SPOSOB_RASCH, :NL_RES_VC,
          :NL_RES_INDEX);*/
      --CQ[10529]-->
      execute procedure A_SMETA_INS_OR_UPD_CENLVL(:IDSMETAREC, --CQ[11104]:AID,
          :IDLEVEL, :NL_IDZONE, :NL_ID_LEVEL_VC,
          :NL_BA, :NL_BB, :NL_BC, :NL_BD, :NL_BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
          :NL_B_PR, --[15352]
          :NL_PA, :NL_PB, :NL_PC, :NL_PD, :NL_RES_VC);

      execute procedure A_SMETA_INS_OR_UPD_INDLVL(:IDSMETAREC, --CQ[11104]:AID,:AID,
          :IDLEVEL,:NL_IDINDEX, :NL_ID_LEVEL_INDEX,
          :NL_PUNKTIND, :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF, :NL_MG,
          :NL_MH, :NL_MI,
          :NL_MJ, :NL_MK, :NL_ML, :NL_MM, --CQ[10529]
          :NL_M_PR, --[15352]
          :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE, :NL_DJ, :NL_DK, :NL_DL, :NL_DM,--CQ[10529]
          :NL_SPOSOB_RASCH, :NL_RES_INDEX);

      execute procedure FILL_INDLVL_DESCR(:IDSMETAREC, --CQ[11104]:AID,:AID,
                                          :IDLEVEL, :NL_ID_LEVEL_INDEX, :NL_RES_INDEX); --CQ[10529]
      --CQ[10529]<--

      --CQ[10892]-->
      --[12113]APPLY_TO_ALL_LEVELS = GETBIT(:MODE_KOMPNS_ST, 12/*mksApplyToAllLevels*/);
      UCHIT_NDS = GETBIT(:MODE_KOMPNS_ST, 13/*mksWidhNDS*/);
      select coalesce(BASE_CALC_INFO, 0) from A_SMETA_CENLVL
      where ID = :IDSMETAREC and IDCENLVL = :IDLEVEL
      into :BASE_CALC_INFO;

      if (:UCHIT_NDS = 0) then
        BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 3/*bciUseNDS*/, 1);
      else
        BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 3/*bciUseNDS*/, 0);

      --<<>>[12113]if (:APPLY_TO_ALL_LEVELS = 0) then
      if (:IDLEVEL = :APPLY_TO_ALL_IDLEVEL) then
        BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 4/*bciApplyToAllLevels*/, 1);
      else
        BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 4/*bciApplyToAllLevels*/, 0);

      -- MK CQ[13174]
      if (:VN_NEED_RECALC_ITOGO_B = 0) then
        BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 5/*bciNeedRecalcItogoB*/, 0);
      else
        BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 5/*bciNeedRecalcItogoB*/, 1);

      update A_SMETA_CENLVL set BASE_CALC_INFO = :BASE_CALC_INFO
      where ID = :IDSMETAREC and IDCENLVL = :IDLEVEL;
      --CQ[10892]<--

      if (ATYPE = 17) then --  , 
      begin
        --  ,    
        for select R.ID, R.NORM_ID, coalesce(R.NORM_PODGROUP, 1), coalesce(R.RABMAT, 3),
                   R.ID_SOURCE, R.BB, R.BC, R.BD, R.BE,
                   R.TAB, --R.NAME_ID, R.IDEDIZM, --CQ[10058]
                   R.NORM_GUID
            from A_S_RES R
            left outer join A_SMETA S on S.ID_S_RES = R.ID
            where R.ID_SOURCE = :IDSMETAREC and --CQ[11104]:AID and
                  S.ID is null
            into :ARESID, :RES_IDNORMATIV, :RES_KODIR_PODGROUP, :RES_RABMAT, :RES_ID_SOURCE,
                 :RES_BB, :RES_BC, :RES_BD, :RES_BE,
                 :TAB, --:NAME_ID, :ID_EDIZM, --CQ[10058]
                 :RES_NORM_GUID
        do
        begin
/*[10430]
          --CQ[10058]-->
          --   
          -- <-- Voyager. . CQ[CQ9681].    Select  B_NNAME
          --select first 1 K_GETCRC32(NAME)
          --from B_GETNAME_EX(:IDUSER, :NAME_ID)
          --into :S_NAME_CRC;

          select CRC_NAME_TITLE from B_NNAME
          where ID = :NAME_ID into :S_NAME_CRC;

          --  
          select first 1 EDIZMNAME
          from B_GET_EDIZM(:ID_EDIZM)
          into :S_EDIZM_NAME;

          execute procedure T_FB_SEARCH_NORMATIV (:RES_KODIR_PODGROUP, -1, :IDUSER, :TAB,
                     :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0, 0:S_NAME_CRC, :S_EDIZM_NAME, 0)
          returning_values (:SEARCH_NORM_ID, :SEARCH_RESULT);
*/
          execute procedure L_GET_NORMATIV_FROM_GUID_RES(:RES_NORM_GUID, :TAB, :RES_IDNORMATIV, :RES_KODIR_PODGROUP, :RES_RABMAT, :IDUSER)
              returning_values :SEARCH_NORM_ID, :RES_KODIR_PODGROUP, :RES_RABMAT, :SEARCH_RESULT;

          --  ,     
          if (SEARCH_RESULT = 0) then
          begin
            execute procedure GET_NORM_BASE_COSTS(:SEARCH_NORM_ID, :RES_RABMAT, :RES_KODIR_PODGROUP)
            --[10430]execute procedure GET_NORM_BASE_COSTS(:SEARCH_NORM_ID, :RABMAT, :KODIR_PODGROUP)
            returning_values (:TEMPFLOAT, :RES_BB, :RES_BC, :RES_BD, :RES_BE, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
                :TEMPFLOAT); --[15352]
          end
          --CQ[10058]<--

          --      ,              compose
          --:    
          --select S.PUNKTIND, S.VRPZ
          --from L_FB_SEARCH_NORMATIV(:RES_IDNORMATIV, :RES_KODIR_PODGROUP, :RES_RABMAT, null, null, :IDUSER, null, null, null, null, null) S
          --into :RES_PUNKTIND, :RES_VRPZ;
          -- -->     
          RES_VRPZ = 0;
          if (RES_KODIR_PODGROUP > 1) then --B_ABC_OKP
          begin
            select VRPZ
            from B_ABC_OKP
            where ID = :SEARCH_NORM_ID
            into :RES_VRPZ;
          end
          else
          begin
            if (RES_RABMAT = 1) then
              RES_VRPZ = 0;
            else
              select VRPZ
              from B_RABMAT
              where ID = :SEARCH_NORM_ID
              into :RES_VRPZ;
          end
          -- <--

          --CQ[9769] -->
          CENLVLSOURCEID = null;
          BASEINFOSOURCE = null;
          select first 1 IDCENLVL, BASE_INFO
          from A_S_RES_CENLVL
          where ID = :ARESID and
                IDCENLVL <> :IDLEVEL and
                (BASE_INFO = 2)
          into :CENLVLSOURCEID, BASEINFOSOURCE;
          if (CENLVLSOURCEID is not null) then
          begin
            select BB, BC, BD, BE
            from A_S_RES_CENLVL
            where ID = :ARESID and
                  IDCENLVL = :CENLVLSOURCEID
            into :RES_BB, :RES_BC, :RES_BD, :RES_BE;
          end
          --CQ[9769] <--

          execute procedure NL_GET_RES_TYPE_VID_RAB(:IDHIER, :RES_ID_SOURCE, :SMETATYPE, :RES_VRPZ)
          returning_values (:RES_TYPE_RAB, :RES_VID_RAB);
          --  
          execute procedure NL_GET_CENLVL_NEW (:IDLEVEL,--CQ[10929]NL_GET_CENLVL(:IDLEVEL,
              case when :SMETATYPE > 999 then :SMETATYPE else :IDOBJECT end, :IDUSER, :RES_TYPE_RAB,
              :RES_VID_RAB, 0, :RES_RABMAT, :IDHIER, :SEARCH_NORM_ID, :RES_KODIR_PODGROUP, '', --:  :RES_PUNKTIND,
              0, 0, :RES_BB, :RES_BC, :RES_BD, :RES_BE,
              null, --[15352]
              :RES_ID_SOURCE,
              :NEED_APPLY_INDEX)--CQ[10929]
          returning_values (:NL_RES_ID_LEVEL_VC, :NL_RES_IDZONE, :TEMPINT, :TEMPINT, :TEMPFLOAT,
              :NL_RES_BB, :NL_RES_BC, :NL_RES_BD, :NL_RES_BE,
              :TEMPFLOAT, --[15352]
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
              :TEMPFLOAT, --[15352]
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, --CQ[10529]
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, --CQ[10529]

              :PUNKTIND,
              :TEMPINT, :NL_RES_BASE_INFO, :TEMPINT);
          --   
          if (NL_RES_BASE_INFO = -2) then
          begin
            if (BASEINFOSOURCE = 2) then
            begin
              NL_RES_BASE_INFO = :BASEINFOSOURCE;
            end
          end
          --CQ[9769] <--
          --insert   
          execute procedure A_S_RES_INS_OR_UPD_CENLVL(:IDUSER, :ARESID, :NL_RES_BB, :NL_RES_BC,
              :NL_RES_BD, :NL_RES_BE, :IDLEVEL, :NL_RES_IDZONE, :NL_RES_ID_LEVEL_VC,
              :NL_RES_BASE_INFO);
        end

        --   
        for select R.ID, R.NORM_ID, coalesce(R.NORM_PODGROUP, 1), coalesce(R.RABMAT, 3),
                   R.ID_SOURCE, R.BB, R.BC, R.BD, R.BE,
                   R.TAB, --R.NAME_ID, R.IDEDIZM, --CQ[10058]
                   R.NORM_GUID
            from M_ETALON_S_RES R
            where R.ID_SOURCE = :IDSMETAREC--CQ[11104]:AID
            into :ARESID, :RES_IDNORMATIV, :RES_KODIR_PODGROUP, :RES_RABMAT, :RES_ID_SOURCE,
                 :RES_BB, :RES_BC, :RES_BD, :RES_BE,
                 :TAB, --:NAME_ID, :ID_EDIZM, --CQ[10058]
                 :RES_NORM_GUID
        do
        begin
/*[10430]
          --CQ[10058]-->
          --   
          -- <-- Voyager. . CQ[CQ9681].    Select  B_NNAME
          --select first 1 K_GETCRC32(NAME)
          --from B_GETNAME_EX(:IDUSER, :NAME_ID)
          --into :S_NAME_CRC;

          select CRC_NAME_TITLE from B_NNAME
          where ID = :NAME_ID into :S_NAME_CRC;

          --  
          select first 1 EDIZMNAME
          from B_GET_EDIZM(:ID_EDIZM)
          into :S_EDIZM_NAME;

          execute procedure T_FB_SEARCH_NORMATIV (:RES_KODIR_PODGROUP, -1, :IDUSER, :TAB,
                     :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0, :S_NAME_CRC, :S_EDIZM_NAME, 0)
          returning_values (:SEARCH_NORM_ID, :SEARCH_RESULT);
*/
          execute procedure L_GET_NORMATIV_FROM_GUID_RES(:RES_NORM_GUID, :TAB, :RES_IDNORMATIV, :RES_KODIR_PODGROUP, :RES_RABMAT, :IDUSER)
              returning_values :SEARCH_NORM_ID, :RES_KODIR_PODGROUP, :RES_RABMAT, :SEARCH_RESULT;

          --  ,     
          if (SEARCH_RESULT = 0) then
          begin
            execute procedure GET_NORM_BASE_COSTS(:SEARCH_NORM_ID, :RES_RABMAT, :RES_KODIR_PODGROUP)
            --[10430]execute procedure GET_NORM_BASE_COSTS(:SEARCH_NORM_ID, :RABMAT, :KODIR_PODGROUP)
            returning_values (:TEMPFLOAT, :RES_BB, :RES_BC, :RES_BD, :RES_BE, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
                :TEMPFLOAT); --[15352]
          end
          --CQ[10058]<--

          --     (copy paste  )
          --:    select S.PUNKTIND, S.VRPZ
          --from L_FB_SEARCH_NORMATIV(:RES_IDNORMATIV, :RES_KODIR_PODGROUP, :RES_RABMAT, null, null, :IDUSER, null, null, null, null, null) S
          --into :RES_PUNKTIND, :RES_VRPZ;
          -- -->       (copy paste  )
          RES_VRPZ = 0;
          if (RES_KODIR_PODGROUP > 1) then --B_ABC_OKP
          begin
            select VRPZ
            from B_ABC_OKP
            where ID = :SEARCH_NORM_ID
            into :RES_VRPZ;
          end
          else
          begin
            if (RES_RABMAT = 1) then
              RES_VRPZ = 0;
            else
              select VRPZ
              from B_RABMAT
              where ID = :SEARCH_NORM_ID
              into :RES_VRPZ;
          end
          -- <--
          execute procedure NL_GET_RES_TYPE_VID_RAB(:IDHIER, :RES_ID_SOURCE, :SMETATYPE, :RES_VRPZ)
          returning_values (:RES_TYPE_RAB, :RES_VID_RAB);

          --   (copy paste  )
          execute procedure NL_GET_CENLVL_NEW (:IDLEVEL,--CQ[10929]NL_GET_CENLVL(:IDLEVEL,
              case when :SMETATYPE > 999 then :SMETATYPE else :IDOBJECT end, :IDUSER, :RES_TYPE_RAB,
              :RES_VID_RAB, 0, :RES_RABMAT, :IDHIER, :SEARCH_NORM_ID, :RES_KODIR_PODGROUP, '', --:  :RES_PUNKTIND,
              0, 0, :RES_BB, :RES_BC, :RES_BD, :RES_BE,
              null, --[15352]
              :RES_ID_SOURCE,
              :NEED_APPLY_INDEX)--CQ[10929]
          returning_values (:NL_RES_ID_LEVEL_VC, :NL_RES_IDZONE, :TEMPINT, :TEMPINT, :TEMPFLOAT,
              :NL_RES_BB, :NL_RES_BC, :NL_RES_BD, :NL_RES_BE,
              :TEMPFLOAT, --[15352]
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
              :TEMPFLOAT, --[15352]
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, --CQ[10529]
              :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, --CQ[10529]
              :PUNKTIND,
              :TEMPINT, :NL_RES_BASE_INFO, :TEMPINT);
          --insert   
          execute procedure A_S_ETALON_INS_OR_UPD_CENLVL(:IDUSER, :ARESID, :NL_RES_BB, :NL_RES_BC,
              :NL_RES_BD, :NL_RES_BE, :IDLEVEL, :NL_RES_IDZONE, :NL_RES_ID_LEVEL_VC,
              :NL_RES_BASE_INFO);
        end
      end
      else --       
      begin
        /*  
        execute procedure NL_GET_CENLVL (:IDLEVEL,
                                     case when :SMETATYPE > 999 then :SMETATYPE else :IDOBJECT end,
                                     :IDUSER, :TYPE_RAB,
                                     :VID_RAB, :ATYPE, :RABMAT, :IDHIER,
                                     :IDNORMATIV, :KODIR_PODGROUP, :PUNKTIND,
                                     0, :BA, :BB, :BC, :BD, :BE,
                                     :SLAVEPARENT)
        returning_values (:NL_ID_LEVEL_VC, :NL_IDZONE, :NL_ID_LEVEL_INDEX, :NL_IDINDEX,
                          :NL_BA, :NL_BB, :NL_BC, :NL_BD, :NL_BE,
                          :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF,
                          :NL_MG, :NL_MH, :NL_MI, :NL_PUNKTIND,
                          :NL_SPOSOB_RASCH, :NL_RES_VC, :NL_RES_INDEX );
        --        
        --    
        execute procedure A_SMETA_INSERT_CENLVL (:AID, :IDLEVEL, :NL_IDZONE, :NL_IDINDEX,
          :NL_ID_LEVEL_INDEX, :NL_ID_LEVEL_VC, :NL_BA, :NL_BB, :NL_BC, :NL_BD, :NL_BE,
          0, 0, 0, 0, 0, :NL_PUNKTIND, :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, 
          :NL_MF, :NL_MG, :NL_MH,  :NL_MI, :NL_SPOSOB_RASCH, :NL_RES_VC,  :NL_RES_INDEX); */
        --insert   
        if (ID_S_RES is not null) then
          execute procedure A_S_RES_INS_OR_UPD_CENLVL(:IDUSER, :ID_S_RES, :NL_BB, :NL_BC, :NL_BD,
              :NL_BE, :IDLEVEL, :NL_IDZONE, :NL_ID_LEVEL_VC, :NL_RES_VC);
      end
    end
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_ADD_LEVEL_IN_SMETA_ONE_EXT (
    IDUSER INTEGER,
    IDSMETAREC INTEGER,
    IDLEVEL INTEGER,
    APPLY_ALL_IDLEVEL INTEGER,
    APPLY_SNB_IDLEVEL INTEGER,
    MIN_DATE_IDLEVEL INTEGER)
AS
declare variable IDHIER integer;
declare variable ARESID integer;
declare variable ATYPE integer;
declare variable TYPE_RAB integer;
declare variable VID_RAB integer;
declare variable PUNKTIND varchar(42);
declare variable SMETATYPE integer;
declare variable RABMAT integer;
declare variable IDNORMATIV integer;
declare variable SLAVEPARENT integer;
declare variable KODIR_PODGROUP integer;
declare variable BA double precision;
declare variable BB double precision;
declare variable BC double precision;
declare variable BD double precision;
declare variable BE double precision;

declare variable BF double precision;
declare variable BG double precision;
declare variable BH double precision;
declare variable BI double precision;
declare variable BJ double precision;

--CQ[TIMUR 13178]
declare variable BN double precision;
declare variable BO double precision;
declare variable B_ITOGO double precision;
--CQ[TIMUR 13178]

declare B_PR double precision; --[15352]

declare variable ID_S_RES integer;
declare variable IN_RES_COPY_FORMULS integer;
declare variable VRPZ integer;

declare variable RES_BB double precision;
declare variable RES_BC double precision;
declare variable RES_BD double precision;
declare variable RES_BE double precision;

declare variable TEMPFLOAT double precision;
declare variable TEMPINT integer;
declare variable NL_RES_IDZONE integer;
declare variable NL_RES_BASE_INFO integer;

declare variable NL_ID_LEVEL_VC integer;
declare variable NL_IDZONE integer;
declare variable NL_ID_LEVEL_INDEX integer;
declare variable NL_IDINDEX integer;

declare variable NL_MA double precision;
declare variable NL_MB double precision;
declare variable NL_MC double precision;
declare variable NL_MD double precision;
declare variable NL_PA double precision;
declare variable NL_PB double precision;
declare variable NL_PC double precision;
declare variable NL_PD double precision;
declare variable NL_ME double precision;
declare variable NL_MF double precision;
declare variable NL_MG double precision;
declare variable NL_MH double precision;
declare variable NL_MI double precision;
declare variable NL_PUNKTIND varchar(42);
declare variable NL_SPOSOB_RASCH integer;
declare variable NL_RES_VC integer;
declare variable NL_RES_INDEX integer;

declare variable IDTR integer;

declare variable BASEINFOSOURCE integer;
declare variable INDEXINFOSOURCE integer;
declare variable PC double precision;
declare variable PD double precision;
declare variable MH double precision;
declare variable MI double precision;

declare IDOBJECT integer;

declare variable NL_MJ double precision;
declare variable NL_MK  double precision;
declare variable NL_ML double precision;
declare variable NL_MM double precision;
declare NL_M_PR double precision; --[15352]
declare variable NL_DA double precision;
declare variable NL_DB double precision;
declare variable NL_DC double precision;
declare variable NL_DD double precision;
declare variable NL_DE double precision;
declare variable NL_DJ double precision;
declare variable NL_DK double precision;
declare variable NL_DL double precision;
declare variable NL_DM double precision;

declare variable NEED_APPLY_INDEX integer;

declare variable MODE_KOMPNS_ST integer;
declare variable UCHIT_NDS integer;

declare variable SRC_BASE_CALC_INFO integer;

declare variable VN_APPLY_IDLEVEL integer;
declare variable ID_LEVEL_SRC integer;

-- MK CQ[13174]
declare variable VN_NEED_RECALC_ITOGO_B integer;
-- MK CQ[13701]
declare variable VN_BB double precision;
--[14593]declare variable VN_IS_LIC_VC integer;
declare variable VN_CURR_CENA_INFO integer;
declare variable VN_USE_CURRCENA double precision;

--<[14593]>
declare USE_MULTIRULES integer;
declare IDCLASS integer; --</>

-- MK CQ[14840]
declare variable VN_SRC_BASE_INFO integer;
declare variable VN_SRC_IDZONE integer;
declare variable VN_SRC_CURR_CENA_INFO integer;
begin
--[15352]

  -- ===========================================================================
  -- MK CQ[13105]          
  --     (      )
  --     DM_ADD_LEVEL_IN_SMETA_ONE_COPY
  -- ===========================================================================

  --   
  MIN_DATE_IDLEVEL = coalesce(MIN_DATE_IDLEVEL, 0);
  if (MIN_DATE_IDLEVEL = 0) then
    exception d_wrong_params '  DM_ADD_LEVEL_IN_SMETA_ONE_EXT';

  -- 
  NEED_APPLY_INDEX = 1;


  --     
  select first 1 ATYPE, TIPRAB, VIDRAB, PUNKTIND, IDHIER, SMETATYPE, RABMAT,
                 IDNORMATIV, SLAVEPARENT, KODIR_PODGROUP, ID_S_RES,
                 BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BN, BO, B_ITOGO,
                 B_PR, --[15352]
                 VRPZ
  from A_SMETA
  where ID = :IDSMETAREC
  into :ATYPE, :TYPE_RAB, :VID_RAB, :PUNKTIND, :IDHIER, :SMETATYPE, :RABMAT,
       :IDNORMATIV, :SLAVEPARENT, :KODIR_PODGROUP, :ID_S_RES,
       :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
       :B_PR, --[15352]
       :VRPZ;

  -- MK CQ[13174]
  VN_NEED_RECALC_ITOGO_B = 0;

  --       / 
  if (:SMETATYPE > 999) then --[14593]  SMETATYPE = 15,  
  begin
    IDCLASS = :SMETATYPE; --[14593]

    select RES_COPY_FORMULS, ID_TR, MODE_KOMPNS_ST
    from a_o_factparams
    where NUMBER = :SMETATYPE
    into  :IN_RES_COPY_FORMULS, :IDTR, :MODE_KOMPNS_ST;
  end
  else
  begin
    execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1)
    returning_values (:IDOBJECT);

    IDCLASS = :IDOBJECT; --[14593]

    select RES_COPY_FORMULS, ID_TR, MODE_KOMPNS_ST
    from A_O_OBJECTPARAMS
    where NUMBER = :IDOBJECT
    into :IN_RES_COPY_FORMULS, :IDTR, :MODE_KOMPNS_ST;
  end

  ------------------------------------------------------------------------------
  --  
  --         ---------
  -- 1.     
  VN_APPLY_IDLEVEL = 0;
  if (RABMAT = 3) then --   
  begin
    if (IDNORMATIV <> 0) then
      VN_APPLY_IDLEVEL = APPLY_SNB_IDLEVEL;
    else
      VN_APPLY_IDLEVEL = APPLY_ALL_IDLEVEL;
  end
  --         
  if (VN_APPLY_IDLEVEL <> 0) then
  begin
    if (not exists(
                   select *
                   from a_smeta_cenlvl c
                   where (c.id = :IDSMETAREC) and
                         (c.idcenlvl = :VN_APPLY_IDLEVEL)  and
                         (bin_and(c.base_calc_info, 7) = 1) -- 7 = 111, cbCalc
                  )
        ) then

      VN_APPLY_IDLEVEL = 0;
  end

  ID_LEVEL_SRC = VN_APPLY_IDLEVEL;
  if (ID_LEVEL_SRC = 0) then
  begin
    -- 2.        
    select first 1 c.idcenlvl
    from a_smeta_cenlvl c
    where (c.id = :IDSMETAREC) and
          (c.base_info = 2) -- csDirect
    --     -       - 
    --       (base_info = 2)
    into :ID_LEVEL_SRC;

    -- 3.    
    if (ID_LEVEL_SRC = 0) then
    begin
      -- MK CQ[14840] --->
      -- ,           ?
      select c.BASE_INFO, c.IDZONE, c.CURR_CENA_INFO
      from a_smeta_cenlvl c
      where (c.id = :IDSMETAREC) and (c.idcenlvl = :MIN_DATE_IDLEVEL)
      into :VN_SRC_BASE_INFO, :VN_SRC_IDZONE, :VN_SRC_CURR_CENA_INFO;

      --  ,       
      -- (. TclOneLevelCost.IsFromVC + TS_SmetaCalcBaseFrame.Fill_BER_Info)
      if (not ((VN_SRC_BASE_INFO = 1) and (VN_SRC_IDZONE > 999) and (VN_SRC_CURR_CENA_INFO <> 3))) then  -- 1 = csFromVC; 3 = cciVC
      -- MK CQ[14840] <---
        ID_LEVEL_SRC = MIN_DATE_IDLEVEL;
    end
  end

  --   -------------------------------------------------------------
  --  , ,    (   )
  execute procedure A_S_GET_FORMUL_NRSPZU_NL_1(:IDUSER, :ATYPE, :SLAVEPARENT,
      :IDTR, :VRPZ, :IN_RES_COPY_FORMULS, :IDLEVEL)
  returning_values (:NL_PA, :NL_PB, :NL_PC, :NL_PD);

  --         
  if (ID_LEVEL_SRC > 0) then -- MK CQ[14840]
  begin
    --      (+   )
    for select C.BA, C.BB, C.BC, C.BD, C.BE, C.BF, C.BG, C.BH, C.BI, C.BJ, C.BN, C.BO, C.B_ITOGO,
               C.B_PR, --[15352]
               C.PC, C.PD, c.base_info,I.MH, I.MI, i.index_info,
               getbit(C.base_calc_info, 5) -- MK CQ[13174]
    from A_SMETA_CENLVL C
    join A_SMETA_INDLVL I on I.ID = C.ID and I.IDCENLVL = C.IDCENLVL
    where (C.ID = :IDSMETAREC) and (C.IDCENLVL = :ID_LEVEL_SRC)
    into :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
         :B_PR, --[15352]
         :PC, :PD, :BASEINFOSOURCE, :MH, :MI, :INDEXINFOSOURCE,
         :VN_NEED_RECALC_ITOGO_B -- MK CQ[13174]
    do
    begin
      if (BASEINFOSOURCE = 2) then
      begin
        NL_PC = :PC;
        NL_PD = :PD;
      end
    end
  end
  -- MK CQ[14840] --->
  --       (       )
  else
  begin
    --      A_SMETA     
    --  (.  )

    --          
    select I.MH, I.MI, i.index_info
    from A_SMETA_INDLVL I
    where (i.ID = :IDSMETAREC) and (i.IDCENLVL = :MIN_DATE_IDLEVEL)
    into :MH, :MI, :INDEXINFOSOURCE;

    --     ""
    VN_NEED_RECALC_ITOGO_B = 1;
  end
  -- MK CQ[14840] <---

  --      -----------------------------------------
  execute procedure NL_GET_CENLVL_NEW (:IDLEVEL,
      :IDCLASS, --[14593]
      :IDUSER, :TYPE_RAB,
      :VID_RAB, :ATYPE, :RABMAT, :IDHIER, :IDNORMATIV, :KODIR_PODGROUP, :PUNKTIND, 0,
      :BA, :BB, :BC, :BD, :BE,
      :B_PR,  --[15352]
      :IDSMETAREC,
      :NEED_APPLY_INDEX)
  returning_values (:NL_ID_LEVEL_VC, :NL_IDZONE, :NL_ID_LEVEL_INDEX, :NL_IDINDEX,
      :TEMPFLOAT, :VN_BB, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
      --NL_BA     --NL_BB --NL_BC     --NL_BD     --NL_BE,
      :TEMPFLOAT, --[15352]
      :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF, :NL_MG,
      :NL_MH, :NL_MI,
      :NL_MJ, :NL_MK, :NL_ML, :NL_MM,
      :NL_M_PR, --[15352]
      :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE, :NL_DJ, :NL_DK, :NL_DL, :NL_DM,
      :NL_PUNKTIND, :NL_SPOSOB_RASCH, :NL_RES_VC, :NL_RES_INDEX);

  -- MK 15.04.2013 CQ[11182] --->
  if (ATYPE = 18) then
    execute procedure A_S_GET_NRSPZU_INDEX_NL_1(:IDUSER, :IDSMETAREC, :PUNKTIND,
                                                :SLAVEPARENT, :IDLEVEL, 3)
    returning_values(:NL_MF, :NL_MG, :NL_MH, :NL_MI);
  -- MK 15.04.2013 CQ[11182] <---

  --   
  if (NL_RES_INDEX = -2) then
  begin
    --    
    if (INDEXINFOSOURCE = 3) then
    begin
      NL_MH = :MH;
      NL_MI = :MI;
      NL_RES_INDEX = :INDEXINFOSOURCE;
    end
  end


  ------------------------------------------------------------------------------
  -- 
  --     
  execute procedure A_SMETA_INS_OR_UPD_CENLVL(:IDSMETAREC,
      :IDLEVEL, :NL_IDZONE, :NL_ID_LEVEL_VC,
      :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
      :B_PR, --[15352]
      :NL_PA, :NL_PB, :NL_PC, :NL_PD, :NL_RES_VC);

  --      
  SRC_BASE_CALC_INFO = case when (VN_APPLY_IDLEVEL > 0) then 2 else 0 end; -- 2 = cbFilled; 0 = cbUnknown
  UCHIT_NDS = GETBIT(:MODE_KOMPNS_ST, 13);                  -- mksWidhNDS
  if (:UCHIT_NDS = 0) then
    SRC_BASE_CALC_INFO = SETBIT(:SRC_BASE_CALC_INFO, 3, 1); -- bciUseNDS
  else
    SRC_BASE_CALC_INFO = SETBIT(:SRC_BASE_CALC_INFO, 3, 0); -- bciUseNDS

  -- MK CQ[13174]
  if (:VN_NEED_RECALC_ITOGO_B = 0) then
    SRC_BASE_CALC_INFO = SETBIT(:SRC_BASE_CALC_INFO, 5, 0); -- bciNeedRecalcItogoB
  else
    SRC_BASE_CALC_INFO = SETBIT(:SRC_BASE_CALC_INFO, 5, 1); -- bciNeedRecalcItogoB

  -- MK CQ[13701] --->
  VN_USE_CURRCENA = 0;
  VN_CURR_CENA_INFO = 0;

  --   
  if (:RABMAT = 3) then
  begin
    --             
    if ((NL_RES_VC = 1) and (NL_IDZONE > 0)) then
    begin
      --      
      /*[14593]
      select first 1 LIC_VC
      from GET_VC_LIC_INFO(:NL_IDZONE)
      into :VN_IS_LIC_VC;*/
      execute procedure NL_COMPOSE_USE_MULTIRULES_VC(:NL_ID_LEVEL_VC, :NL_IDZONE)
          returning_values :USE_MULTIRULES;

      --    (   )
      --[14593] if (VN_IS_LIC_VC <> 0) then
      --    (), ..    
      if (:USE_MULTIRULES = 0) then
      begin
        VN_USE_CURRCENA = VN_BB;
        VN_CURR_CENA_INFO = 3; -- cciVC
      end
    end
  end
  -- MK CQ[13701] <---

  update A_SMETA_CENLVL
  set BASE_CALC_INFO = :SRC_BASE_CALC_INFO,

      -- MK CQ[13701] --->
      CURR_CENA_INFO = :VN_CURR_CENA_INFO,
      CURR_CENA = :VN_USE_CURRCENA,
      --CURR_CENA = 0,
      -- MK CQ[13701] <---

      SOURCE_LEVEL_ID = case when (:VN_APPLY_IDLEVEL > 0) then :VN_APPLY_IDLEVEL else 0 end

  where (ID = :IDSMETAREC) and (IDCENLVL = :IDLEVEL);

  --      
  execute procedure A_SMETA_INS_OR_UPD_INDLVL(:IDSMETAREC,
      :IDLEVEL,:NL_IDINDEX, :NL_ID_LEVEL_INDEX,
      :NL_PUNKTIND, :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF, :NL_MG,
      :NL_MH, :NL_MI,
      :NL_MJ, :NL_MK, :NL_ML, :NL_MM,
      :NL_M_PR, --[15352]
      :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE, :NL_DJ, :NL_DK, :NL_DL, :NL_DM,
      :NL_SPOSOB_RASCH, :NL_RES_INDEX);

  execute procedure FILL_INDLVL_DESCR(:IDSMETAREC,
                                      :IDLEVEL, :NL_ID_LEVEL_INDEX, :NL_RES_INDEX);




  ------------------------------------------------------------------------------
  --  (  )

  -- MK CQ[14840] --->
  if (ID_LEVEL_SRC = 0) then
    ID_LEVEL_SRC = MIN_DATE_IDLEVEL;
  -- MK CQ[14840] <---

  if (ATYPE = 17) then --  , 
  begin
    --   ,     --------------------
    for select R.ID,
               R.BB, R.BC, R.BD, R.BE
    from A_S_RES R
    left outer join A_SMETA S on S.ID_S_RES = R.ID
    where R.ID_SOURCE = :IDSMETAREC and
          S.ID is null
    into :ARESID,
         :RES_BB, :RES_BC, :RES_BD, :RES_BE do
    begin
      --     
      select BB, BC, BD, BE, IDZONE, BASE_INFO
      from A_S_RES_CENLVL
      where (ID = :ARESID) and (IDCENLVL = :ID_LEVEL_SRC)
      into :RES_BB, :RES_BC, :RES_BD, :RES_BE, :NL_RES_IDZONE, :NL_RES_BASE_INFO;

      --   
      execute procedure A_S_RES_INS_OR_UPD_CENLVL(:IDUSER, :ARESID, :RES_BB, :RES_BC,
          :RES_BD, :RES_BE, :IDLEVEL, :NL_RES_IDZONE, 0, :NL_RES_BASE_INFO);
    end


    --     -------------------------------------
    for select R.ID,
               R.BB, R.BC, R.BD, R.BE
        from M_ETALON_S_RES R
        where R.ID_SOURCE = :IDSMETAREC
        into :ARESID,
             :RES_BB, :RES_BC, :RES_BD, :RES_BE
    do
    begin
      --     
      select BB, BC, BD, BE, IDZONE, BASE_INFO
      from A_S_ETALON_RES_CENLVL
      where (ID = :ARESID) and (IDCENLVL = :ID_LEVEL_SRC)
      into :RES_BB, :RES_BC, :RES_BD, :RES_BE, :NL_RES_IDZONE, :NL_RES_BASE_INFO;

      --insert   
      execute procedure A_S_ETALON_INS_OR_UPD_CENLVL(:IDUSER, :ARESID, :RES_BB, :RES_BC,
          :RES_BD, :RES_BE, :IDLEVEL, :NL_RES_IDZONE, 0,
          :NL_RES_BASE_INFO);
    end
    -- CQ[13105] <--
  end
  --        
  else if (ID_S_RES is not null) then
  begin
    -- insert   
    execute procedure A_S_RES_INS_OR_UPD_CENLVL(:IDUSER, :ID_S_RES, :BB, :BC, :BD,
        :BE, :IDLEVEL, :NL_IDZONE, :NL_ID_LEVEL_VC, :NL_RES_VC);
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_COPY_CORRECTION (
    AIDSOURCE INTEGER,
    AIDTARGET INTEGER)
AS
declare variable KA varchar(50);
declare variable KB varchar(50);
declare variable KC varchar(50);
declare variable KD varchar(50);
declare variable KE varchar(50);
declare variable KF varchar(50);
declare variable KG varchar(50);
declare variable KH varchar(50);
declare variable KI varchar(50);
declare variable KJ varchar(50);
declare variable KK varchar(50);
declare variable KL varchar(50);
declare variable KM varchar(50);
declare variable K_ITOGO varchar(50);
declare variable K_PR varchar(50);
declare variable CORRECTNODE blob sub_type 0 segment size 80;
declare variable CORRECTNODE_1 blob sub_type 0 segment size 80;
begin
 --[15352]
  for select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
             CORRECTNODE, CORRECTNODE_1, K_ITOGO /*CQ[14462]*/, K_PR /*CQ[15421]*/
  from CORRECTIONS
  where ID = :AIDSOURCE
  into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
       :CORRECTNODE, :CORRECTNODE_1, :K_ITOGO /*CQ[14462]*/, :K_PR /*CQ[15421]*/
  do
  begin
    execute procedure DM_SET_CORRECTION(:AIDTARGET,
      :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
      :K_ITOGO /*CQ[14462]*/, :K_PR /*CQ[15421]*/, :CORRECTNODE, :CORRECTNODE_1);
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_EXP_A_O_PARAMS_R_PR (
    PARAMID INTEGER)
RETURNS (
    ID INTEGER,
    NUMGLSSR INTEGER,
    TIPRAB INTEGER,
    SHIFR VARCHAR(1024),
    FULLNAME VARCHAR(1024),
    OPISANIE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ISPOLNIL_FIO VARCHAR(250),
    ISPOLNIL_DOLGN VARCHAR(100),
    PROVERIL_FIO VARCHAR(250),
    PROVERIL_DOLGN VARCHAR(100),
    UTVERDIL_FIO VARCHAR(250),
    UTVERDIL_DOLGN VARCHAR(100),
    SUBPODR_ID_ORG INTEGER,
    SUBPODR_NAME_ORG VARCHAR(255),
    SUBPODR_ID INTEGER,
    SUBPODR_FIO VARCHAR(250),
    SUBPODR_DOLGN VARCHAR(100),
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    GUID VARCHAR(100),
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    VELICHSTROBJ DOUBLE PRECISION,
    EDIZM VARCHAR(40),
    REPLACECORRECTION INTEGER,
    SPREADONEXISTSREC INTEGER,
    CORRECTIONRULE INTEGER)
AS
declare variable ATYPE smallint;
declare variable PARENTTYPE smallint;
declare variable TEMPVALUE integer;
declare variable PARENTID integer;
declare variable CUT_KA varchar(50);
declare variable CUT_KB varchar(50);
declare variable CUT_KC varchar(50);
declare variable CUT_KD varchar(50);
declare variable CUT_KE varchar(50);
declare variable CUT_KF varchar(50);
declare variable CUT_KG varchar(50);
declare variable CUT_KH varchar(50);
declare variable CUT_KI varchar(50);
declare variable CUT_KJ varchar(50);
declare variable CUT_KK varchar(50);
declare variable CUT_KL varchar(50);
declare variable CUT_KM varchar(50);
declare variable CUT_K_ITOGO varchar(50);
declare variable CUT_K_PR varchar(50);

--CQ[TIMUR 13931] -    SHIFR, FULLNAME
begin
 --[15352]+
  for select P.ID, P.NUMGLSSR, P.TIPRAB, P.SHIFR, P.FULLNAME, P.OPISANIE, P.ISPOLNIL_FIO, ISPOLNIL_DOLGN, PROVERIL_FIO,
             PROVERIL_DOLGN, P.UTVERDIL_FIO, P.UTVERDIL_DOLGN, P.SUBPODR_ID_ORG, P.SUBPODR_NAME_ORG, SUBPODR_ID,
             SUBPODR_FIO, SUBPODR_DOLGN, P.KA, P.KB, P.KC, P.KD, P.KE, P.KF, P.KG, P.KH, KI, KJ, KK, KL, KM, GUID, UTV,
             CORRECTNODE, CORRECTNODE_1, VELICHSTROBJ, P.EDIZM, P.REPLACECORRECTION, P.SPREADONEXISTSREC,
             P.CORRECTIONRULE, H.ATYPE,
             P.K_ITOGO /*CQ[14462]*/, P.K_PR /*15421*/
      from A_O_PARAMS_R_PR P
      join A_O_HIER H on H.NUMBER = P.ID
      where ID = :PARAMID
      into :ID, :NUMGLSSR, :TIPRAB, :SHIFR, :FULLNAME, :OPISANIE, :ISPOLNIL_FIO, :ISPOLNIL_DOLGN, :PROVERIL_FIO,
           PROVERIL_DOLGN, :UTVERDIL_FIO, :UTVERDIL_DOLGN, :SUBPODR_ID_ORG, :SUBPODR_NAME_ORG, :SUBPODR_ID,
           :SUBPODR_FIO, :SUBPODR_DOLGN, :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :GUID, :UTV,
           :CORRECTNODE, :CORRECTNODE_1, :VELICHSTROBJ, :EDIZM, :REPLACECORRECTION, :SPREADONEXISTSREC, :CORRECTIONRULE,
           :ATYPE, :K_ITOGO /*CQ[14462]*/, :K_PR /*15421*/
  do
  begin
    PARENTID = -1;
    PARENTTYPE = -1;
    if (ATYPE = 4) then --  ,    
    begin
      PARENTTYPE = 3;
      execute procedure A_H_GET_ID_PARENTATYPE(:PARAMID, :PARENTTYPE)
        returning_values (:PARENTID);
    end
    else
    if (ATYPE = 5) then --  ,    
    begin
      PARENTTYPE = 4;
      execute procedure A_H_GET_ID_PARENTATYPE(:PARAMID, :PARENTTYPE)
        returning_values (:PARENTID);
    end
    -- 
    for select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
        K_ITOGO /*CQ[14462]*/, K_PR /*15421*/
    from DM_GET_CORRECTION_BY_TYPE(:PARENTID, :PARENTTYPE)
    into :CUT_KA, :CUT_KB, :CUT_KC, :CUT_KD, :CUT_KE, :CUT_KF, :CUT_KG, :CUT_KH, :CUT_KI,
         :CUT_KJ, :CUT_KK, :CUT_KL, :CUT_KM, :CUT_K_ITOGO /*CQ[14462]*/, CUT_K_PR /*15421*/
    do
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KA, :CUT_KA, '', :TEMPVALUE)
        returning_values (:KA, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KB, :CUT_KB, '', :TEMPVALUE)
        returning_values (:KB, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KC, :CUT_KC, '', :TEMPVALUE)
        returning_values (:KC, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KD, :CUT_KD, '', :TEMPVALUE)
        returning_values (:KD, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KE, :CUT_KE, '', :TEMPVALUE)
        returning_values (:KE, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KF, :CUT_KF, '', :TEMPVALUE)
        returning_values (:KF, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KG, :CUT_KG, '', :TEMPVALUE)
        returning_values (:KG, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KH, :CUT_KH, '', :TEMPVALUE)
        returning_values (:KH, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KI, :CUT_KI, '', :TEMPVALUE)
        returning_values (:KI, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KJ, :CUT_KJ, '', :TEMPVALUE)
        returning_values (:KJ, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KK, :CUT_KK, '', :TEMPVALUE)
        returning_values (:KK, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KL, :CUT_KL, '', :TEMPVALUE)
        returning_values (:KL, :TEMPVALUE, :TEMPVALUE);
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KM, :CUT_KM, '', :TEMPVALUE)
        returning_values (:KM, :TEMPVALUE, :TEMPVALUE);
      -- CQ[14462] >>
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:K_ITOGO, :CUT_K_ITOGO, '', :TEMPVALUE)
        returning_values (:K_ITOGO, :TEMPVALUE, :TEMPVALUE);
      -- CQ[15421] >>
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:K_PR, :CUT_K_PR, '', :TEMPVALUE)
        returning_values (:K_PR, :TEMPVALUE, :TEMPVALUE);
    end
    suspend;
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_EXP_CORRECTIONS (
    AID INTEGER)
RETURNS (
    ID INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
declare variable ATYPE integer;
begin
 --[15352]+
  for select ATYPE
    from A_O_HIER
    where NUMBER = :AID
  into :ATYPE
  do
  begin
    for select ID, KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
        CORRECTNODE, CORRECTNODE_1, K_ITOGO, K_PR
      from DM_GET_CORRECTION_BY_TYPE(:AID, :ATYPE)
    into :ID, :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
         :CORRECTNODE, :CORRECTNODE_1, :K_ITOGO /*CQ[14462]*/, :K_PR /*15421*/
    do
      suspend;
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_GET_CORRECTION_BY_TYPE (
    AID INTEGER,
    ATYPE INTEGER)
RETURNS (
    ID INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
begin
--[15352]+
  ID = :AID;-- 
  if (ATYPE = 1) then
  begin
    for select coalesce(KA, ''), coalesce(KB, ''), coalesce(KC, ''), coalesce(KD, ''), coalesce(KE, ''),
               coalesce(KF, ''), coalesce(KG, ''), coalesce(KH, ''), coalesce(KI, ''), coalesce(KJ, ''),
               coalesce(KK, ''), coalesce(KL, ''), coalesce(KM, ''), CORRECTNODE, CORRECTNODE_1,
               coalesce(K_ITOGO, '') /*CQ[14462]*/, coalesce(K_PR, '') /*CQ[15421]*/
        from CORRECTIONS
        where ID = :AID
        into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
             :CORRECTNODE, :CORRECTNODE_1, :K_ITOGO /*CQ[14462]*/, :K_PR /*CQ[15421]*/
    do
    begin
      suspend;
    end
  end
  else
  if (ATYPE = 3) then
  begin
    for select coalesce(KA, ''), coalesce(KB, ''), coalesce(KC, ''), coalesce(KD, ''), coalesce(KE, ''),
               coalesce(KF, ''), coalesce(KG, ''), coalesce(KH, ''), coalesce(KI, ''), coalesce(KJ, ''),
               coalesce(KK, ''), coalesce(KL, ''), coalesce(KM, ''), CORRECTNODE, CORRECTNODE_1,
               coalesce(K_ITOGO, '') /*CQ[14462]*/, coalesce(K_PR, '') /*CQ[15421]*/
    from A_O_PARAMS_LS
    where ID = :AID
    into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
         :CORRECTNODE, :CORRECTNODE_1, :K_ITOGO /*CQ[14462]*/, :K_PR /*CQ[15421]*/
    do
    begin
      suspend;
    end
  end
  else
  if (ATYPE in (4, 5)) then
  begin
    for select coalesce(KA, ''), coalesce(KB, ''), coalesce(KC, ''), coalesce(KD, ''), coalesce(KE, ''),
               coalesce(KF, ''), coalesce(KG, ''), coalesce(KH, ''), coalesce(KI, ''), coalesce(KJ, ''),
               coalesce(KK, ''), coalesce(KL, ''), coalesce(KM, ''), CORRECTNODE, CORRECTNODE_1,
               coalesce(K_ITOGO, ''), coalesce(K_PR, '')
    from A_O_PARAMS_R_PR
    where ID = :AID
    into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
         :CORRECTNODE, :CORRECTNODE_1, :K_ITOGO /*CQ[14462]*/, :K_PR /*CQ[15421]*/
    do
    begin
      suspend;
    end
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_IMP_CORRECTIONS (
    ID INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
declare variable ATYPE integer;
begin
--[15352]+
  for select ATYPE
      from A_O_HIER
      where NUMBER = :ID
      into :ATYPE
  do
  begin
    if (ATYPE = 1) then
    begin
      execute procedure DM_SET_CORRECTION(:ID, :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
        :K_ITOGO/*CQ14462]*/,:K_PR/*CQ[15421]*/, :CORRECTNODE, :CORRECTNODE_1 );
    end
    else
    if (ATYPE = 3) then
    begin
      update A_O_PARAMS_LS set
        KA = :KA,
        KB = :KB,
        KC = :KC,
        KD = :KD,
        KE = :KE,
        KF = :KF,
        KG = :KG,
        KH = :KH,
        KI = :KI,
        KJ = :KJ,
        KK = :KK,
        KL = :KL,
        KM = :KM,
        K_ITOGO = :K_ITOGO, -- CQ14462]
        K_PR = :K_PR, -- CQ[15421]
        CORRECTNODE = :CORRECTNODE,
        CORRECTNODE_1 = :CORRECTNODE_1
      where ID = :ID;
    end
    else
    if (ATYPE in (4, 5)) then
    begin
      update A_O_PARAMS_R_PR set
        KA = :KA,
        KB = :KB,
        KC = :KC,
        KD = :KD,
        KE = :KE,
        KF = :KF,
        KG = :KG,
        KH = :KH,
        KI = :KI,
        KJ = :KJ,
        KK = :KK,
        KL = :KL,
        KM = :KM,
        K_ITOGO = :K_ITOGO, -- CQ14462]
        K_PR = :K_PR, -- CQ[15421]
        CORRECTNODE = :CORRECTNODE,
        CORRECTNODE_1 = :CORRECTNODE_1
      where ID = :ID;
    end
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_PARAMS_SET_DEF_CORRECTION (
    AID INTEGER,
    ATYPE INTEGER)
AS
declare variable APARENTID integer;
declare variable KA varchar(50);
declare variable KB varchar(50);
declare variable KC varchar(50);
declare variable KD varchar(50);
declare variable KE varchar(50);
declare variable KF varchar(50);
declare variable KG varchar(50);
declare variable KH varchar(50);
declare variable KI varchar(50);
declare variable KJ varchar(50);
declare variable KK varchar(50);
declare variable KL varchar(50);
declare variable KM varchar(50);
declare variable K_ITOGO varchar(50);
declare variable K_PR varchar(50);
declare variable CORRECTNODE blob sub_type 0 segment size 80;
declare variable CORRECTNODE_1 blob sub_type 0 segment size 80;

begin
 --[15352]
  if (ATYPE = 3) then --    ,    
  begin
    execute procedure A_H_GET_ID_PARENTATYPE(:AID, 1)
      returning_values (:APARENTID);
    for select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
               CORRECTNODE, CORRECTNODE_1, K_ITOGO, K_PR
      from CORRECTIONS
      where ID = :APARENTID
    into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
         :CORRECTNODE, :CORRECTNODE_1, :K_ITOGO /*CQ[14462]*/, :K_PR /*15421*/
    do
    begin
      update A_O_PARAMS_LS set
        KA = :KA,
        KB = :KB,
        KC = :KC,
        KD = :KD,
        KE = :KE,
        KF = :KF,
        KG = :KG,
        KH = :KH,
        KI = :KI,
        KJ = :KJ,
        KK = :KK,
        KL = :KL,
        KM = :KM,
        K_ITOGO = :K_ITOGO, /*CQ[14462]*/
        K_PR = :K_PR, /*CQ[15421]*/
        CORRECTNODE = :CORRECTNODE,
        CORRECTNODE_1 = :CORRECTNODE_1
      where ID = :AID;
    end
  end
  else
  if (ATYPE = 4) then --    ,    
  begin
    execute procedure A_H_GET_ID_PARENTATYPE(:AID, 3)
      returning_values (:APARENTID);
    for select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
        CORRECTNODE, CORRECTNODE_1, K_ITOGO, K_PR
      from A_O_PARAMS_LS
      where ID = :APARENTID
    into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
         :CORRECTNODE, :CORRECTNODE_1, :K_ITOGO /*CQ[14462]*/, :K_PR /*15421*/
    do
    begin
      update A_O_PARAMS_R_PR set
        KA = :KA,
        KB = :KB,
        KC = :KC,
        KD = :KD,
        KE = :KE,
        KF = :KF,
        KG = :KG,
        KH = :KH,
        KI = :KI,
        KJ = :KJ,
        KK = :KK,
        KL = :KL,
        KM = :KM,
        K_ITOGO = :K_ITOGO, -- CQ[14462]
        K_PR = :K_PR, /*CQ[15421]*/
        CORRECTNODE = :CORRECTNODE,
        CORRECTNODE_1 = :CORRECTNODE_1
      where ID = :AID;
    end
  end
  if (ATYPE = 5) then --    ,    
  begin
    execute procedure A_H_GET_ID_PARENTATYPE(:AID, 4)
      returning_values (:APARENTID);
    for select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
               CORRECTNODE, CORRECTNODE_1, K_ITOGO, K_PR
      from A_O_PARAMS_R_PR
      where ID = :APARENTID
    into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
         :CORRECTNODE, :CORRECTNODE_1, :K_ITOGO /*CQ[14462]*/, :K_PR /*15421*/
    do
    begin
      update A_O_PARAMS_R_PR set
        KA = :KA,
        KB = :KB,
        KC = :KC,
        KD = :KD,
        KE = :KE,
        KF = :KF,
        KG = :KG,
        KH = :KH,
        KI = :KI,
        KJ = :KJ,
        KK = :KK,
        KL = :KL,
        KM = :KM,
        K_ITOGO = :K_ITOGO, -- CQ[14462]
        K_PR = :K_PR, /*CQ[15421]*/
        CORRECTNODE = :CORRECTNODE,
        CORRECTNODE_1 = :CORRECTNODE_1
      where ID = :AID;
    end
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_REPLACE_CORRECTION (
    USERID INTEGER,
    AIDSTRUCT INTEGER,
    ATYPE INTEGER,
    SPREADONEXISTSREC INTEGER,
    KA_NEW VARCHAR(50),
    KA_OLD VARCHAR(50),
    KB_NEW VARCHAR(50),
    KB_OLD VARCHAR(50),
    KC_NEW VARCHAR(50),
    KC_OLD VARCHAR(50),
    KD_NEW VARCHAR(50),
    KD_OLD VARCHAR(50),
    KE_NEW VARCHAR(50),
    KE_OLD VARCHAR(50),
    KF_NEW VARCHAR(50),
    KF_OLD VARCHAR(50),
    KG_NEW VARCHAR(50),
    KG_OLD VARCHAR(50),
    KH_NEW VARCHAR(50),
    KH_OLD VARCHAR(50),
    KI_NEW VARCHAR(50),
    KI_OLD VARCHAR(50),
    KJ_NEW VARCHAR(50),
    KJ_OLD VARCHAR(50),
    KK_NEW VARCHAR(50),
    KK_OLD VARCHAR(50),
    KL_NEW VARCHAR(50),
    KL_OLD VARCHAR(50),
    KM_NEW VARCHAR(50),
    KM_OLD VARCHAR(50),
    K_ITOGO_NEW VARCHAR(50),
    K_ITOGO_OLD VARCHAR(50),
    K_PR_NEW VARCHAR(50),
    K_PR_OLD VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
declare variable ISCHANGEFLAG integer; --1 =    ; 0 =  
declare variable DORECALC integer; -- 1 =  ; 0 =  
declare variable ID integer;
declare variable OBJECTID integer;
declare variable KA varchar(50);
declare variable KB varchar(50);
declare variable KC varchar(50);
declare variable KD varchar(50);
declare variable KE varchar(50);
declare variable KF varchar(50);
declare variable KG varchar(50);
declare variable KH varchar(50);
declare variable KI varchar(50);
declare variable KJ varchar(50);
declare variable KK varchar(50);
declare variable KL varchar(50);
declare variable KM varchar(50);
declare variable K_ITOGO varchar(50);
declare variable K_PR varchar(50);
declare variable ERRORCOUNT integer;
declare variable RESERRORCOUNT integer;
declare variable AISERROR integer;
declare variable RECTYPE integer;
declare variable ISCLC integer;
declare variable MODE_KOMPNS_ST integer;
declare variable RES_COPY_POPR integer;
declare variable INDEXTYPE integer;
declare variable UCH integer;
declare variable CLCMODE integer;
declare variable RABMAT integer;
declare variable TYPETRUD integer;
declare variable COPY_TO_RES integer;
declare variable SLAVEPARENT integer;
declare variable RECCALCMODE integer;
declare variable ACLC integer;
declare variable ACOMPENS integer;
begin
--[15352]+
  DORECALC = 0;
  OBJECTID = 0;
  execute procedure A_H_GET_ID_PARENTATYPE(:AIDSTRUCT, 1)
    returning_values (:OBJECTID);
  if (OBJECTID < 0) then
    exit;
  select ISCLC, coalesce(MODE_KOMPNS_ST, 0), RES_COPY_POPR
  from A_O_OBJECTPARAMS
  where NUMBER = :OBJECTID
  into :ISCLC, :MODE_KOMPNS_ST, :RES_COPY_POPR;

  ACLC = GETBIT(:ISCLC, 0);
  ACOMPENS = GETBIT(MODE_KOMPNS_ST, 0);


  for select A.ID, A.KA, A.KB, A.KC, A.KD, A.KE, A.KF, A.KG, A.KH, A.KI, A.KJ, A.KK, A.KL, A.KM, A.ATYPE,
             coalesce(RES.UCH, 0), A.CLCMODE, A.RABMAT, A.TYPE_TRUD, A.SLAVEPARENT, A.K_ITOGO/*14460*/, A.K_PR/*15421*/
      from A_SMETA A
      left outer join A_S_RES RES on RES.ID = A.ID_S_RES
      where A.IDHIER = :AIDSTRUCT and
            A.UTV = 0
      into :ID, :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :RECTYPE, :UCH, :CLCMODE, :RABMAT,
           :TYPETRUD, :SLAVEPARENT, :K_ITOGO/*14460*/, :K_PR/*15421*/
  do
  begin
    ISCHANGEFLAG = 0;
    ERRORCOUNT = 0;
    AISERROR = 0;
    -- IndexType  
    COPY_TO_RES = :RES_COPY_POPR;
    if (RECTYPE = 18) then --CQ[9182]
    begin
      select CLCMODE
      from A_SMETA
      where ID = :SLAVEPARENT
      into :CLCMODE;
    end
    RECCALCMODE = GETBIT(:CLCMODE, 1);
    /* CQ[11307]-->   (. )
    execute procedure DM_GETSMETARECINDEXTYPE(:UCH, :RECCALCMODE, :RES_COPY_POPR, :ISCLC, :ACOMPENS)
      returning_values (:INDEXTYPE, :COPY_TO_RES); -- CQ[11307] */

    --CQ[11307]-->
    INDEXTYPE = 2;
    COPY_TO_RES = 1;
    --CQ[11307]<--

    --else
    --INDEXTYPE = 0;

    --  
    --KA
    if (RECTYPE = 17) then --   
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KA, :KA_OLD, :KA_NEW, :ISCHANGEFLAG)
        returning_values (:KA, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;

      /*14460*/
      /*???*/
      /*14460*/
    end
    --KB
    if ((RECTYPE = 17) or ((RABMAT = 3) and
        (INDEXTYPE <> 2))) then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KB, :KB_OLD, :KB_NEW, :ISCHANGEFLAG)
        returning_values (:KB, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    -- KC
    if ((RECTYPE = 17) or ((RABMAT = 2) and
        (INDEXTYPE <> 2))) then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KC, :KC_OLD, :KC_NEW, :ISCHANGEFLAG)
        returning_values (:KC, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KD
    if ((RECTYPE = 17) or ((RABMAT = 1) and
        (TYPETRUD = 2) and
        (INDEXTYPE <> 2))) then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KD, :KD_OLD, :KD_NEW, :ISCHANGEFLAG)
        returning_values (:KD, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KE
    if ((RECTYPE = 17) or ((RABMAT = 1) and
        (TYPETRUD = 1) and
        (INDEXTYPE <> 2))) then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KE, :KE_OLD, :KE_NEW, :ISCHANGEFLAG)
        returning_values (:KE, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KF
    if (RECTYPE = 17) then --   
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KF, :KF_OLD, :KF_NEW, :ISCHANGEFLAG)
        returning_values (:KF, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KG
    if (RECTYPE = 17) /*CQ[11307]-->     or ((RABMAT = 1) and
        (TYPETRUD = 1) and
        (INDEXTYPE = 2))) <--CQ[11307]*/ then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KG, :KG_OLD, :KG_NEW, :ISCHANGEFLAG)
        returning_values (:KG, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KH
    if (RECTYPE = 17) /*CQ[11307]-->      or ((RABMAT = 1) and
        (TYPETRUD = 2) and
        (INDEXTYPE = 2))) <--CQ[11307]*/ then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KH, :KH_OLD, :KH_NEW, :ISCHANGEFLAG)
        returning_values (:KH, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KI
    if (RECTYPE = 17) then --   
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KI, :KI_OLD, :KI_NEW, :ISCHANGEFLAG)
        returning_values (:KI, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KJ
    if (RECTYPE = 17) then --   
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KJ, :KJ_OLD, :KJ_NEW, :ISCHANGEFLAG)
        returning_values (:KJ, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KK
    if (RECTYPE = 17) then --   
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KK, :KK_OLD, :KK_NEW, :ISCHANGEFLAG)
        returning_values (:KK, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KL
    if (RECTYPE = 17) /*CQ[11307]-->     or ((RABMAT = 3) and
        (INDEXTYPE = 2))) <--CQ[11307]*/then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KL, :KL_OLD, :KL_NEW, :ISCHANGEFLAG)
        returning_values (:KL, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    --KM
    if (RECTYPE = 17) /*CQ[11307]-->     or ((RABMAT = 2) and
        (INDEXTYPE = 2))) <--CQ[11307]*/ then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KM, :KM_OLD, :KM_NEW, :ISCHANGEFLAG)
        returning_values (:KM, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    -- K_ITOGO CQ[14462]
    if (RECTYPE = 17)then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:K_ITOGO, :K_ITOGO_OLD, :K_ITOGO_NEW, :ISCHANGEFLAG)
        returning_values (:K_ITOGO, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end
    -- K_PR CQ[15421]
    if (RECTYPE = 17)then
    begin
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:K_PR, :K_PR_OLD, :K_PR_NEW, :ISCHANGEFLAG)
        returning_values (:K_PR, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
    end

    --    , 
    if (ISCHANGEFLAG = 1) then
    begin
      update A_SMETA set
        KA = :KA,
        KB = :KB,
        KC = :KC,
        KD = :KD,
        KE = :KE,
        KF = :KF,
        KG = :KG,
        KH = :KH,
        KI = :KI,
        KJ = :KJ,
        KK = :KK,
        KL = :KL,
        KM = :KM,
        K_ITOGO = :K_ITOGO/*14460*/,
        CORRECTNODE = :CORRECTNODE,
        CORRECTNODE_1 = :CORRECTNODE_1
      where ID = :ID;
      --  
      if (RECTYPE = 17) then --CQ[9182]
        execute procedure DM_REPLACE_RES_CORRECTION(:ID, :KG_NEW, :KG_OLD, :KH_NEW, :KH_OLD, :KL_NEW, :KL_OLD, :KM_NEW,
          :KM_OLD, :COPY_TO_RES, :ACLC, :RECCALCMODE, :ACOMPENS)
          returning_values (:RESERRORCOUNT);
      ERRORCOUNT = :ERRORCOUNT + :RESERRORCOUNT;
      --   
      DORECALC = 1;
    end
    if ((ERRORCOUNT > 0) and
        (OBJECTID <> -1)) then
    begin
      if (not(exists(select *
                     from D_BOOKMARK
                     where REC_ID = :ID and
                           ENTITY_ID = :OBJECTID))) then
        insert into D_BOOKMARK (USER_ID, REC_ID, ENTITY_ID, DESCR)
        values (:USERID, :ID, :OBJECTID, '   ');
    end

  end
  if (SPREADONEXISTSREC = 1) then -- 
  begin
    for select NUMBER, ATYPE
        from L_H_SELTREE_HIER(:USERID, :AIDSTRUCT)
        into :AIDSTRUCT, :ATYPE
    do
    begin
      execute procedure DM_REPLACE_CORRECTION(:USERID, :AIDSTRUCT, :ATYPE, 0, :KA_NEW, :KA_OLD, :KB_NEW, :KB_OLD,
        :KC_NEW, :KC_OLD, :KD_NEW, :KD_OLD, :KE_NEW, :KE_OLD, :KF_NEW, :KF_OLD, :KG_NEW, :KG_OLD, KH_NEW, :KH_OLD,
        :KI_NEW, :KI_OLD, :KJ_NEW, :KJ_OLD, :KK_NEW, :KK_OLD, :KL_NEW, :KL_OLD, :KM_NEW, :KM_OLD,
        :K_ITOGO_NEW, :K_ITOGO_OLD, :K_PR_NEW, :K_PR_OLD, :CORRECTNODE, :CORRECTNODE_1);
    end
    --      
  end
  if (DORECALC = 1) then
  begin
    if (OBJECTID <> -1) then
    begin
      update A_O_OBJECTPARAMS set
        DORECALK = SETBIT(DORECALK, 0, 1)
      where (NUMBER = :OBJECTID);
    end
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_SET_CORRECTION (
    AID INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80)
AS
begin
--[15352]+
  if (exists(select ID
             from CORRECTIONS
             where ID = :AID)) then
  begin
    update CORRECTIONS set
      KA = :KA,
      KB = :KB,
      KC = :KC,
      KD = :KD,
      KE = :KE,
      KF = :KF,
      KG = :KG,
      KH = :KH,
      KI = :KI,
      KJ = :KJ,
      KK = :KK,
      KL = :KL,
      KM = :KM,
      K_ITOGO = :K_ITOGO, -- CQ[14462]
      K_PR = :K_PR, -- CQ[15421]
      CORRECTNODE = :CORRECTNODE,
      CORRECTNODE_1 = :CORRECTNODE_1
    where ID = :AID;
  end
  else
  begin
    insert into CORRECTIONS (ID, KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
      CORRECTNODE, CORRECTNODE_1, K_ITOGO, K_PR) -- CQ[14462, 15421] + K_ITOGO+K_PR
    values (:AID, :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
      :CORRECTNODE, :CORRECTNODE_1, :K_ITOGO, :K_PR); -- CQ[14462, 15421] + K_ITOGO+K_PR
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_SPREADDOWN_CORRECTION (
    AIDSTRUCT INTEGER,
    ATYPE INTEGER,
    IDUSER INTEGER,
    KA_NEW VARCHAR(50),
    KA_OLD VARCHAR(50),
    KB_NEW VARCHAR(50),
    KB_OLD VARCHAR(50),
    KC_NEW VARCHAR(50),
    KC_OLD VARCHAR(50),
    KD_NEW VARCHAR(50),
    KD_OLD VARCHAR(50),
    KE_NEW VARCHAR(50),
    KE_OLD VARCHAR(50),
    KF_NEW VARCHAR(50),
    KF_OLD VARCHAR(50),
    KG_NEW VARCHAR(50),
    KG_OLD VARCHAR(50),
    KH_NEW VARCHAR(50),
    KH_OLD VARCHAR(50),
    KI_NEW VARCHAR(50),
    KI_OLD VARCHAR(50),
    KJ_NEW VARCHAR(50),
    KJ_OLD VARCHAR(50),
    KK_NEW VARCHAR(50),
    KK_OLD VARCHAR(50),
    KL_NEW VARCHAR(50),
    KL_OLD VARCHAR(50),
    KM_NEW VARCHAR(50),
    KM_OLD VARCHAR(50),
    K_ITOGO_NEW VARCHAR(50),
    K_ITOGO_OLD VARCHAR(50),
    K_PR_NEW VARCHAR(50),
    K_PR_OLD VARCHAR(50))
RETURNS (
    HAVEWRONG INTEGER)
AS
declare variable IDPR integer;
declare variable CHILDTYPE integer;
declare variable KA varchar(50);
declare variable KB varchar(50);
declare variable KC varchar(50);
declare variable KD varchar(50);
declare variable KE varchar(50);
declare variable KF varchar(50);
declare variable KG varchar(50);
declare variable KH varchar(50);
declare variable KI varchar(50);
declare variable KJ varchar(50);
declare variable KK varchar(50);
declare variable KL varchar(50);
declare variable KM varchar(50);
declare variable K_ITOGO varchar(50);
declare variable K_PR varchar(50);
declare variable ERRORCOUNT integer;
declare variable AISERROR integer;
declare variable ISCHANGEFLAG integer; --1 =    ; 0 =  

begin
 --[15352]+
  HAVEWRONG = 0;

  if (ATYPE not in (1, 3, 4)) then
  begin
    suspend;
    exit;
  end

  for select NUMBER, ATYPE
      from L_H_SELTREE_HIER(:IDUSER, :AIDSTRUCT)
      where ATYPE <> 0
      into :IDPR, :CHILDTYPE
  do
  begin
    --  -   
    for select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
               K_ITOGO, K_PR
    from DM_GET_CORRECTION_BY_TYPE(:IDPR, :CHILDTYPE)
    into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
         :K_ITOGO /*CQ[14462]*/, :K_PR/*15421*/
    do
    begin
      ISCHANGEFLAG = 0;
      ERRORCOUNT = 0;
      AISERROR = 0;
      --  
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KA, :KA_OLD, :KA_NEW, :ISCHANGEFLAG)
        returning_values (:KA, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KB, :KB_OLD, :KB_NEW, :ISCHANGEFLAG)
        returning_values (:KB, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KC, :KC_OLD, :KC_NEW, :ISCHANGEFLAG)
        returning_values (:KC, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KD, :KD_OLD, :KD_NEW, :ISCHANGEFLAG)
        returning_values (:KD, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KE, :KE_OLD, :KE_NEW, :ISCHANGEFLAG)
        returning_values (:KE, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KF, :KF_OLD, :KF_NEW, :ISCHANGEFLAG)
        returning_values (:KF, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KG, :KG_OLD, :KG_NEW, :ISCHANGEFLAG)
        returning_values (:KG, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KH, :KH_OLD, :KH_NEW, :ISCHANGEFLAG)
        returning_values (:KH, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KI, :KI_OLD, :KI_NEW, :ISCHANGEFLAG)
        returning_values (:KI, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KJ, :KJ_OLD, :KJ_NEW, :ISCHANGEFLAG)
        returning_values (:KJ, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KK, :KK_OLD, :KK_NEW, :ISCHANGEFLAG)
        returning_values (:KK, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KL, :KL_OLD, :KL_NEW, :ISCHANGEFLAG)
        returning_values (:KL, :ISCHANGEFLAG, :AISERROR);
      ERRORCOUNT = :ERRORCOUNT + :AISERROR;
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:KM, :KM_OLD, :KM_NEW, :ISCHANGEFLAG)
        returning_values (:KM, :ISCHANGEFLAG, :AISERROR);

      -- CQ[14462] >>
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:K_ITOGO, :K_ITOGO_OLD, :K_ITOGO_NEW, :ISCHANGEFLAG)
        returning_values (:K_ITOGO, :ISCHANGEFLAG, :AISERROR);

      -- CQ[15421] >>
      execute procedure DM_GET_CORRECTION_FOR_REPLACE(:K_PR, :K_PR_OLD, :K_PR_NEW, :ISCHANGEFLAG)
        returning_values (:K_PR, :ISCHANGEFLAG, :AISERROR);

      ERRORCOUNT = :ERRORCOUNT + :AISERROR;

      --    , 
      --    - 
      if (ISCHANGEFLAG = 1) then
        if (CHILDTYPE <> 3) then --      
        begin
          update A_O_PARAMS_R_PR set
            KA = :KA,
            KB = :KB,
            KC = :KC,
            KD = :KD,
            KE = :KE,
            KF = :KF,
            KG = :KG,
            KH = :KH,
            KI = :KI,
            KJ = :KJ,
            KK = :KK,
            KL = :KL,
            KM = :KM,
            K_ITOGO = :K_ITOGO, -- CQ[14462]
            K_PR = :K_PR -- CQ[15421]
          where ID = :IDPR;
        end
        else
        begin
          update A_O_PARAMS_LS set
            KA = :KA,
            KB = :KB,
            KC = :KC,
            KD = :KD,
            KE = :KE,
            KF = :KF,
            KG = :KG,
            KH = :KH,
            KI = :KI,
            KJ = :KJ,
            KK = :KK,
            KL = :KL,
            KM = :KM,
            K_ITOGO = :K_ITOGO, -- CQ[14462]
            K_PR = :K_PR -- CQ[15421]
          where ID = :IDPR;
        end
      if ((ERRORCOUNT > 0) or (ISCHANGEFLAG = 0)) then
        HAVEWRONG = HAVEWRONG + 1;
    end
  end
  suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE DM_UPDATE_OLD_IMP_R_PR_PARAMS (
    ID INTEGER)
AS
declare variable ATYPE integer;
declare variable PARENTID integer;
declare variable HAVEWRONG integer;

declare variable KA varchar(50);
declare variable KB varchar(50);
declare variable KC varchar(50);
declare variable KD varchar(50);
declare variable KE varchar(50);
declare variable KF varchar(50);
declare variable KG varchar(50);
declare variable KH varchar(50);
declare variable KI varchar(50);
declare variable KJ varchar(50);
declare variable KK varchar(50);
declare variable KL varchar(50);
declare variable KM varchar(50);
declare variable K_ITOGO varchar(50);
declare variable K_PR varchar(50);

declare variable UP_KA varchar(50);
declare variable UP_KB varchar(50);
declare variable UP_KC varchar(50);
declare variable UP_KD varchar(50);
declare variable UP_KE varchar(50);
declare variable UP_KF varchar(50);
declare variable UP_KG varchar(50);
declare variable UP_KH varchar(50);
declare variable UP_KI varchar(50);
declare variable UP_KJ varchar(50);
declare variable UP_KK varchar(50);
declare variable UP_KL varchar(50);
declare variable UP_KM varchar(50);
declare variable UP_K_ITOGO varchar(50);
declare variable UP_K_PR varchar(50);
begin
--[15352]
  for select P.KA, P.KB, P.KC, P.KD, P.KE, P.KF, P.KG, P.KH, P.KI, P.KJ, P.KK, P.KL, P.KM, H.ATYPE,
             P.K_ITOGO, P.K_PR
    from A_O_PARAMS_R_PR P
    join A_O_HIER H on H.NUMBER = P.ID
    where P.ID = :ID
  into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :ATYPE,
       :K_ITOGO/*CQ[14462]*/, :K_PR/*CQ[15421]*/
  do
  begin
    UP_KA = '';
    UP_KB = '';
    UP_KC = '';
    UP_KD = '';
    UP_KE = '';
    UP_KF = '';
    UP_KG = '';
    UP_KH = '';
    UP_KI = '';
    UP_KJ = '';
    UP_KK = '';
    UP_KL = '';
    UP_KM = '';
    UP_K_ITOGO = ''; -- CQ[14462]
    UP_K_PR = ''; -- CQ[15421]

    if (ATYPE = 4) then -- 
    begin
      execute procedure A_H_GET_ID_PARENTATYPE(:ID, 3)
        returning_values (:PARENTID);
      if (PARENTID > 0) then
        select coalesce(KA, ''), coalesce(KB, ''), coalesce(KC, ''), coalesce(KD, ''), coalesce(KE, ''),
               coalesce(KF, ''), coalesce(KG, ''), coalesce(KH, ''), coalesce(KI, ''), coalesce(KJ, ''),
               coalesce(KK, ''), coalesce(KL, ''), coalesce(KM, ''),
               coalesce(K_ITOGO, ''), coalesce(K_PR, '')
        from A_O_PARAMS_LS
        where ID = :PARENTID
        into :UP_KA, :UP_KB, :UP_KC, :UP_KD, :UP_KE, :UP_KF, :UP_KG, :UP_KH, :UP_KI,
             :UP_KJ, :UP_KK, :UP_KL, :UP_KM, :UP_K_ITOGO/*CQ[14462]*/, :UP_K_PR; /*CQ[15421]*/
    end
    else --  
    begin
      execute procedure A_H_GET_ID_PARENTATYPE(:ID, 4)
        returning_values (:PARENTID);
      if (PARENTID > 0) then
        select coalesce(KA, ''), coalesce(KB, ''), coalesce(KC, ''), coalesce(KD, ''), coalesce(KE, ''),
               coalesce(KF, ''), coalesce(KG, ''), coalesce(KH, ''), coalesce(KI, ''), coalesce(KJ, ''),
               coalesce(KK, ''), coalesce(KL, ''), coalesce(KM, ''),
               coalesce(K_ITOGO, ''), coalesce(K_PR, '')
        from A_O_PARAMS_R_PR
        where ID = :PARENTID
        into :UP_KA, :UP_KB, :UP_KC, :UP_KD, :UP_KE, :UP_KF, :UP_KG, :UP_KH, :UP_KI,
             :UP_KJ, :UP_KK, :UP_KL, :UP_KM, :UP_K_ITOGO,/*CQ[14462]*/ :UP_K_PR/*CQ[14462]*/;
    end
    -- 
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KA, :KA, 1, 0)
      returning_values (:KA, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KB, :KB, 1, 0)
      returning_values (:KB, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KC, :KC, 1, 0)
      returning_values (:KC, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KD, :KD, 1, 0)
      returning_values (:KD, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KE, :KE, 1, 0)
      returning_values (:KE, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KF, :KF, 1, 0)
      returning_values (:KF, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KG, :KG, 1, 0)
      returning_values (:KG, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KH, :KH, 1, 0)
      returning_values (:KH, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KI, :KI, 1, 0)
      returning_values (:KI, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KJ, :KJ, 1, 0)
      returning_values (:KJ, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KK, :KK, 1, 0)
      returning_values (:KK, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KL, :KL, 1, 0)
      returning_values (:KL, :HAVEWRONG);
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_KM, :KM, 1, 0)
      returning_values (:KM, :HAVEWRONG);
    -- CQ[14462] >>
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_K_ITOGO, :K_ITOGO, 1, 0)
      returning_values (:K_ITOGO, :HAVEWRONG);
    -- CQ[15421] >>
    execute procedure DM_UNITE_CORRECTION_ONE(:UP_K_PR, :K_PR, 1, 0)
      returning_values (:K_PR, :HAVEWRONG);

    --    - 
    update A_O_PARAMS_R_PR set
      KA = :KA,
      KB = :KB,
      KC = :KC,
      KD = :KD,
      KE = :KE,
      KF = :KF,
      KG = :KG,
      KH = :KH,
      KI = :KI,
      KJ = :KJ,
      KK = :KK,
      KL = :KL,
      KM = :KM,
      K_ITOGO = :K_ITOGO, -- CQ[14462]
      K_PR = :K_PR -- CQ[15421]
    where ID = :ID;
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE GET_NORM_BASE_COSTS (
    NORM_ID INTEGER,
    NORM_RABMAT INTEGER,
    NORM_PODGROUP INTEGER)
RETURNS (
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    B_PR DOUBLE PRECISION)
AS
declare TAB varchar(42);
begin
--[15352]+

  -- (17.04.2012):  copy_paste  T_GET_NORM_BASE_COSTS(7.0.0.13 )

  BA = 0.0;-- |
  BB = 0.0;-- |.
  BC = 0.0;-- |
  BD = 0.0;-- | .
  BE = 0.0;-- |
  BF = 0.0;-- |..
  BG = 0.0;-- | .
  BH = 0.0;-- |..
  BI = 0.0;-- |.
  --CQ[TIMUR 13178]
  BJ = 0.0;-- |
  PA = 0.0;-- |  
  PB = 0.0;-- |  
  --CQ[TIMUR 13178]

  if (NORM_PODGROUP > 1) then
  begin
    select
           case
             when RABMAT = 3 then coalesce(CENA, 0.0)
             else 0.0
           end,
           case
             when RABMAT = 2 then coalesce(CENA, 0.0)
             else 0.0
           end,
           case
             when RABMAT = 2 then coalesce(CENA, 0.0)
             else 0.0
           end,
           case
             when RABMAT = 1 then coalesce(CENA, 0.0)
             else 0.0
           end
    from B_ABC_OKP
    where ID = :NORM_ID
    into :BB, :BC, :BD, :BE;
  end
  else
  if (NORM_RABMAT = 1) then
  begin
    select coalesce(CENA, 0.0)
    from B_TRUD
    where ID = :NORM_ID
    into :BE;
  end
  else
  begin
    select BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB,
      BB_PR --[15352]
    from B_RABMAT
    where ID = :NORM_ID
    into :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :PA, :PB,
      :B_PR; --[15352]
  end
  suspend;
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE GET_ONE_INDEX_APPLY_INFO (
*/
--[15352]
/* 
CREATE OR ALTER PROCEDURE IMP_SMREC_FROM_XML (
*/
--[15352]
CREATE OR ALTER PROCEDURE K_CORRECTION_TABLE_INSERT (
    ID INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    ML VARCHAR(50),
    MM VARCHAR(50),
    NOTE VARCHAR(2000),
    IDUSER INTEGER,
    ID_CORE_TYPE INTEGER,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
BEGIN
--[15352]+
  INSERT INTO K_CORRECTION_TABLE (
    ID,
    IDGC,
    COD,
    NAME,
    MB,
    MC,
    MD,
    ME,
--    MG,
-->DEN 11/11/05
    MJ,
    MK,
--<DEN
-->DEN cq[3557]
    MG41,
    MH41,
--    MN41,
--    MO41,
--<DEN
-->DEN cq[4015]
    ML,
    MM,
--<DEN
    NOTE,
    ID_CORE_TYPE,
    M_ITOGO, -- CQ[14459]
    M_PR -- CQ[15421]
    )
  VALUES (
    :ID,
    :IDGC,
    :COD,
    :NAME,
    :MB,
    :MC,
    :MD,
    :ME,
--    :MG,
-->DEN 11/11/05
    :MJ,
    :MK,
--<DEN
-->DEN cq[3557]
    :MG41,
    :MH41,
--    :MN41,
--    :MO41,
--<DEN
-->DEN cq[4015]
    :ML,
    :MM,
--<DEN
    :NOTE,
    :ID_CORE_TYPE,
    :M_ITOGO, -- CQ[14459]
    :M_PR -- CQ[15421]
    );
END
^

--[15352]
CREATE OR ALTER PROCEDURE K_CORRECTION_TABLE_SELECT (
    ID_GC INTEGER,
    IDUSER INTEGER,
    ORDER_BY_USAGE INTEGER)
RETURNS (
    ID INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    ML VARCHAR(50),
    MM VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER,
    USAGE INTEGER,
    USAGE_DATE DATE,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
BEGIN
--[15352]+
  if (ORDER_BY_USAGE is null) then ORDER_BY_USAGE = 0;
  if (ORDER_BY_USAGE = 0) then
  begin
    FOR SELECT k.ID, k.IDGC, k.COD, k.NAME, k.MB, k.MC, k.MD, k.ME, k.MJ, k.MK,
             k.MG41, k.MH41, k.ML, k.MM, k.NOTE, k.ID_CORE_TYPE, coalesce(u.USAGE, 0), u.USAGE_DATE,
             k.M_ITOGO /*CQ[14459]*/, k.M_PR /*CQ[15421]*/
        FROM K_CORRECTION_TABLE k
        left join D_CORRECTION_USAGE u
          on (u.ID_USER = :IDUSER)
          and (k.ID = u.ID_CORRECTION)
        where (k.IDGC = :ID_GC)
        ORDER by k.cod
        INTO :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, :MJ, :MK,
             :MG41, :MH41, :ML, :MM, :NOTE, :ID_CORE_TYPE, :USAGE, :USAGE_DATE,
             :M_ITOGO /*CQ[14459]*/, :M_PR /*CQ[15421]*/
    DO
      SUSPEND;
  end
  else
  if (ORDER_BY_USAGE = 1) then
  begin
    FOR SELECT k.ID, k.IDGC, k.COD, k.NAME, k.MB, k.MC, k.MD, k.ME, k.MJ, k.MK,
             k.MG41, k.MH41, k.ML, k.MM, k.NOTE, k.ID_CORE_TYPE, coalesce(u.USAGE, 0), u.USAGE_DATE,
             k.M_ITOGO /*CQ[14459]*/, k.M_PR /*CQ[15421]*/
        FROM K_CORRECTION_TABLE k
        left join D_CORRECTION_USAGE u
          on (u.ID_USER = :IDUSER)
          and (k.ID = u.ID_CORRECTION)
        where (k.IDGC = :ID_GC)
        PLAN sort( JOIN (K INDEX (FK_K_CORRECTION_GR), U INDEX (IDX_D_CORRECTION_USAGE)) )
        ORDER by coalesce(u.USAGE, 0) desc, k.cod
        INTO :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, :MJ, :MK,
             :MG41, :MH41, :ML, :MM, :NOTE, :ID_CORE_TYPE, :USAGE, :USAGE_DATE,
             :M_ITOGO /*CQ[14459]*/, :M_PR /*CQ[15421]*/
    DO
      SUSPEND;
  end
  else
  if (ORDER_BY_USAGE = 1) then
  begin
    FOR SELECT k.ID, k.IDGC, k.COD, k.NAME, k.MB, k.MC, k.MD, k.ME, k.MJ, k.MK,
             k.MG41, k.MH41, k.ML, k.MM, k.NOTE, k.ID_CORE_TYPE, coalesce(u.USAGE, 0), u.USAGE_DATE,
             k.M_ITOGO /*CQ[14459]*/, k.M_PR /*CQ[15421]*/
        FROM K_CORRECTION_TABLE k
        left join D_CORRECTION_USAGE u
          on (u.ID_USER = :IDUSER)
          and (k.ID = u.ID_CORRECTION)
        where (k.IDGC = :ID_GC)
        PLAN sort( JOIN (K INDEX (FK_K_CORRECTION_GR), U INDEX (IDX_D_CORRECTION_USAGE)) )
        ORDER by u.USAGE_DATE desc, k.cod
        INTO :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, :MJ, :MK,
             :MG41, :MH41, :ML, :MM, :NOTE, :ID_CORE_TYPE, :USAGE, :USAGE_DATE,
             :M_ITOGO /*CQ[14459]*/, :M_PR /*CQ[15421]*/
    DO
      SUSPEND;
  end

END
^

--[15352]
CREATE OR ALTER PROCEDURE K_CORRECTION_TABLE_UPDATE (
    ID INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    ML VARCHAR(50),
    MM VARCHAR(50),
    NOTE VARCHAR(2000),
    IDUSER INTEGER,
    ID_CORE_TYPE INTEGER,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
BEGIN
--[15352]+
  UPDATE K_CORRECTION_TABLE
  SET COD = :COD,
      NAME = :NAME,
      MB = :MB,
      MC = :MC,
      MD = :MD,
      ME = :ME,
--      MG = :MG,
-->DEN 11/11/05
      MJ = :MJ,
      MK = :MK,
--<DEN
-->DEN cq[3557]
      MG41 = :MG41,
      MH41 = :MH41,
--      MN41 = :MN41,
--      MO41 = :MO41,
--<DEN
-->DEN cq[4015]
      ML = :ML,
      MM = :MM,
--<DEN
      NOTE = :NOTE,
      ID_CORE_TYPE = :ID_CORE_TYPE,
      M_ITOGO = :M_ITOGO, -- CQ[14459]
      M_PR = :M_PR  -- CQ[15421]
  WHERE (ID = :ID);
END
^

--[15352]
CREATE OR ALTER PROCEDURE K_GET_CORRECTIONS (
    IDGRCORR INTEGER,
    BASIS VARCHAR(42),
    IDUSER INTEGER)
RETURNS (
    ID INTEGER,
    IDGC INTEGER,
    COD VARCHAR(42),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    MB VARCHAR(50),
    MC VARCHAR(50),
    MD VARCHAR(50),
    ME VARCHAR(50),
    MJ VARCHAR(50),
    MK VARCHAR(50),
    MG41 VARCHAR(50),
    MH41 VARCHAR(50),
    NOTE VARCHAR(2000),
    ID_CORE_TYPE INTEGER,
    M_ITOGO VARCHAR(50),
    M_PR VARCHAR(50))
AS
DECLARE VARIABLE IDCORRECTION INTEGER;
begin
--[15352]+
  if( idgrcorr is null ) then exit;
--  for select distinct idc from K_USE_BASIS_TABLE where (idgc = :idgrcorr) and (tab = :basis ) into :idcorrection do
  for select distinct idc from K_USE_BASIS_TABLE where (idgc = :idgrcorr) and (:basis like tab) into :idcorrection do
    begin
        if( idcorrection is not null ) then
            begin
                select ID, IDGC, COD, NAME, MB, MC, MD, ME, /*MG,*/ MJ, MK, MG41, MH41, /*MN41, MO41,*/ NOTE, ID_CORE_TYPE,
                  M_ITOGO, M_PR
                from K_CORRECTION_TABLE where id = :idcorrection
                into :ID, :IDGC, :COD, :NAME, :MB, :MC, :MD, :ME, /*:MG,*/ :MJ, :MK, :MG41, :MH41, /*:MN41, :MO41,*/ :NOTE, :ID_CORE_TYPE,
                  :M_ITOGO/*[14459]*/, :M_PR/*15421*/;
                suspend;
            end
    end
end
^

--[15352]
CREATE OR ALTER PROCEDURE KD_COPY_PARAMS_LS (
    SOURCE_ID INTEGER,
    TARGET_ID INTEGER)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
declare variable    NUMGLSSR          INTEGER;
  declare variable    TIPRAB            INTEGER;
  declare variable    SHIFR             VARCHAR(1024);
  declare variable    FULLNAME          VARCHAR(1024);
  declare variable    NACH_STROY        DATE;
  declare variable    OKONCH_STROIT     DATE;
  declare variable    SPISOKSHERT       BLOB SUB_TYPE 1 SEGMENT SIZE 80;
  declare variable    OPISANIE          BLOB SUB_TYPE 1 SEGMENT SIZE 80;
  declare variable    ISPOLNIL_FIO      VARCHAR(250);
  declare variable    ISPOLNIL_DOLGN    VARCHAR(100);
  declare variable    PROVERIL_FIO      VARCHAR(250);
  declare variable    PROVERIL_DOLGN    VARCHAR(100);
  declare variable    UTVERDIL_FIO      VARCHAR(250);
  declare variable    UTVERDIL_DOLGN    VARCHAR(100);
  declare variable    SUBPODR_ID_ORG    INTEGER;
  declare variable    SUBPODR_NAME_ORG  VARCHAR(255);
  declare variable    SUBPODR_ID        INTEGER;
  declare variable    SUBPODR_FIO       VARCHAR(250);
  declare variable    SUBPODR_DOLGN     VARCHAR(100);
  declare variable    KA                VARCHAR(50);
  declare variable    KB                VARCHAR(50);
  declare variable    KC                VARCHAR(50);
  declare variable    KD                VARCHAR(50);
  declare variable    KE                VARCHAR(50);
  declare variable    KF                VARCHAR(50);
  declare variable    KG                VARCHAR(50);
  declare variable    KH                VARCHAR(50);
  declare variable    KI                VARCHAR(50);
  declare variable    KJ                VARCHAR(50);

  declare variable    KK                VARCHAR(50);
  declare variable    KL                VARCHAR(50);
  declare variable    KM                VARCHAR(50);
  declare variable    CORRECTNODE       BLOB SUB_TYPE TEXT;
  declare variable    CORRECTNODE_1     BLOB SUB_TYPE TEXT;

  declare variable    GUID              VARCHAR(100);

  declare variable VELICHSTROBJ DOUBLE PRECISION;
  declare variable EDIZM VARCHAR(40);
  declare variable CODE VARCHAR(512);
  --CQ[9077]
  declare variable REPLACECORRECTION  integer;
  declare variable SPREADONEXISTSREC  integer;
  declare variable CORRECTIONRULE  integer;
  --CQ[9077]
  declare variable    K_ITOGO        VARCHAR(50);
  declare variable    K_PR           VARCHAR(50);

declare NUMLSR_LS varchar (1024); --[15192]
begin
 --[15352]
  if (not exists(select id from A_O_PARAMS_LS where ID=:SOURCE_ID)) then
    exception KD_NO_PARAM_LS;
  for select
    NUMGLSSR,
    TIPRAB,
    SHIFR,
    FULLNAME,
    NACH_STROY,
    OKONCH_STROIT,
    SPISOKSHERT,
    OPISANIE,
    ISPOLNIL_FIO,
    ISPOLNIL_DOLGN,
    PROVERIL_FIO,
    PROVERIL_DOLGN,
    UTVERDIL_FIO,
    UTVERDIL_DOLGN,
    SUBPODR_ID_ORG,
    SUBPODR_NAME_ORG,
    SUBPODR_ID,
    SUBPODR_FIO,
    SUBPODR_DOLGN,
    KA,
    KB,
    KC,
    KD,
    KE,
    KF,
    KG,
    KH,
    KI,
    KJ,

    KK,
    KL,
    KM,
    CORRECTNODE,
    CORRECTNODE_1,

    GUID,

    VELICHSTROBJ,
    EDIZM,
    CODE,
    --CQ[9077]
    REPLACECORRECTION,
    SPREADONEXISTSREC,
    CORRECTIONRULE,
    --CQ[9077]
    K_ITOGO, -- CQ[14462]
    NUMLSR_LS, --[15192]
    K_PR --[15421]
  from A_O_PARAMS_LS where ID=:SOURCE_ID
  into
    :NUMGLSSR,
    :TIPRAB,
    :SHIFR,
    :FULLNAME,
    :NACH_STROY,
    :OKONCH_STROIT,
    :SPISOKSHERT,
    :OPISANIE,
    :ISPOLNIL_FIO,
    :ISPOLNIL_DOLGN,
    :PROVERIL_FIO,
    :PROVERIL_DOLGN,
    :UTVERDIL_FIO,
    :UTVERDIL_DOLGN,
    :SUBPODR_ID_ORG,
    :SUBPODR_NAME_ORG,
    :SUBPODR_ID,
    :SUBPODR_FIO,
    :SUBPODR_DOLGN,
    :KA,
    :KB,
    :KC,
    :KD,
    :KE,
    :KF,
    :KG,
    :KH,
    :KI,
    :KJ,

    :KK,
    :KL,
    :KM,
    :CORRECTNODE,
    :CORRECTNODE_1,

    :GUID,

    :VELICHSTROBJ,
    :EDIZM,
    :CODE,
    --CQ[9077]
    :REPLACECORRECTION,
    :SPREADONEXISTSREC,
    :CORRECTIONRULE,
    --CQ[9077]
    :K_ITOGO, -- CQ[14462]
    :NUMLSR_LS, --[15192]
    :K_PR --[15421]
  do
  begin
    if (not exists (select id from A_O_PARAMS_LS where id=:TARGET_ID)) then
    begin
      insert into A_O_PARAMS_LS (ID,TIPRAB) values (:TARGET_ID,1);
    end
    update A_O_PARAMS_LS set
      NUMGLSSR=:NUMGLSSR,
      TIPRAB=:TIPRAB,
      SHIFR=:SHIFR,
      FULLNAME=:FULLNAME,
      NACH_STROY=:NACH_STROY,
      OKONCH_STROIT=:OKONCH_STROIT,
      SPISOKSHERT=:SPISOKSHERT,
      OPISANIE=:OPISANIE,
      ISPOLNIL_FIO=:ISPOLNIL_FIO,
      ISPOLNIL_DOLGN=:ISPOLNIL_DOLGN,
      PROVERIL_FIO=:PROVERIL_FIO,
      PROVERIL_DOLGN=:PROVERIL_DOLGN,
      UTVERDIL_FIO=:UTVERDIL_FIO,
      UTVERDIL_DOLGN=:UTVERDIL_DOLGN,
      SUBPODR_ID_ORG=:SUBPODR_ID_ORG,
      SUBPODR_NAME_ORG=:SUBPODR_NAME_ORG,
      SUBPODR_ID=:SUBPODR_ID,
      SUBPODR_FIO=:SUBPODR_FIO,
      SUBPODR_DOLGN=:SUBPODR_DOLGN,
      KA=:KA,
      KB=:KB,
      KC=:KC,
      KD=:KD,
      KE=:KE,
      KF=:KF,
      KG=:KG,
      KH=:KH,
      KI=:KI,
      KJ=:KJ,

      KK=:KK,
      KL=:KL,
      KM=:KM,
      CORRECTNODE = :CORRECTNODE,
      CORRECTNODE_1 = :CORRECTNODE_1, -- MK 21.11.2008 : CORRECTNODE_1 = :CORRECTNODE,

      GUID=:GUID,

      VELICHSTROBJ = :VELICHSTROBJ,
      EDIZM = :EDIZM,
      CODE = :CODE,
      --CQ[9077]
      REPLACECORRECTION = :REPLACECORRECTION,
      SPREADONEXISTSREC = :SPREADONEXISTSREC,
      CORRECTIONRULE =:CORRECTIONRULE,
      --CQ[9077]
      K_ITOGO = :K_ITOGO, -- CQ[14462]
      NUMLSR_LS = :NUMLSR_LS, --[15192]
      K_PR = :K_PR -- CQ[15421]
    where ID=:TARGET_ID;

    --    
    delete from M_STRUCT_PARAMS_VRZUCL
      where (ID = :TARGET_ID);
    insert into M_STRUCT_PARAMS_VRZUCL (ID,
        VRIDDOC, VRNPPTEXT, VRPRVALUE,
        ZUIDDOC, ZUNPPTEXT, ZUPRVALUE,
        CLIDDOC, CLNPPTEXT, CLKOEF, CLZONE)
      select :TARGET_ID,
        VRIDDOC, VRNPPTEXT, VRPRVALUE,
        ZUIDDOC, ZUNPPTEXT, ZUPRVALUE,
        CLIDDOC, CLNPPTEXT, CLKOEF, CLZONE
      from M_STRUCT_PARAMS_VRZUCL
      where (ID = :SOURCE_ID);
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE KD_COPY_PARAMS_R_PR (
    SOURCE_ID INTEGER,
    TARGET_ID INTEGER)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
declare variable    NUMGLSSR          INTEGER;
  declare variable    TIPRAB            INTEGER;
  declare variable    SHIFR             VARCHAR(1024);
  declare variable    FULLNAME          VARCHAR(1024);
  declare variable    OPISANIE          BLOB SUB_TYPE 1 SEGMENT SIZE 80;
  declare variable    ISPOLNIL_FIO      VARCHAR(250);
  declare variable    ISPOLNIL_DOLGN    VARCHAR(100);
  declare variable    PROVERIL_FIO      VARCHAR(250);
  declare variable    PROVERIL_DOLGN    VARCHAR(100);
  declare variable    UTVERDIL_FIO      VARCHAR(250);
  declare variable    UTVERDIL_DOLGN    VARCHAR(100);
  declare variable    SUBPODR_ID_ORG    INTEGER;
  declare variable    SUBPODR_NAME_ORG  VARCHAR(255);
  declare variable    SUBPODR_ID        INTEGER;
  declare variable    SUBPODR_FIO       VARCHAR(250);
  declare variable    SUBPODR_DOLGN     VARCHAR(100);
  declare variable    KA                VARCHAR(50);
  declare variable    KB                VARCHAR(50);
  declare variable    KC                VARCHAR(50);
  declare variable    KD                VARCHAR(50);
  declare variable    KE                VARCHAR(50);
  declare variable    KF                VARCHAR(50);
  declare variable    KG                VARCHAR(50);
  declare variable    KH                VARCHAR(50);
  declare variable    KI                VARCHAR(50);
  declare variable    KJ                VARCHAR(50);

  declare variable    KK                VARCHAR(50);
  declare variable    KL                VARCHAR(50);
  declare variable    KM                VARCHAR(50);
  -- CQ[14462] >>
  declare variable    K_ITOGO           VARCHAR(50);
  declare variable    k_pr              VARCHAR(50);
  declare variable    CORRECTNODE       BLOB SUB_TYPE TEXT;
  declare variable    CORRECTNODE_1     BLOB SUB_TYPE TEXT;

  declare variable    GUID              VARCHAR(100);

  declare variable VELICHSTROBJ DOUBLE PRECISION;
  declare variable EDIZM VARCHAR(40);
  --CQ[9077]
  declare variable REPLACECORRECTION  integer;
  declare variable SPREADONEXISTSREC  integer;
  declare variable CORRECTIONRULE  integer;
  --CQ[9077]

begin
 --[15352]
  if (not exists(select id from A_O_PARAMS_r_pr where ID=:SOURCE_ID)) then
    exception KD_NO_PARAM_r_pr;
  for select
    NUMGLSSR,
    TIPRAB,
    SHIFR,
    FULLNAME,
    OPISANIE,
    ISPOLNIL_FIO,
    ISPOLNIL_DOLGN,
    PROVERIL_FIO,
    PROVERIL_DOLGN,
    UTVERDIL_FIO,
    UTVERDIL_DOLGN,
    SUBPODR_ID_ORG,
    SUBPODR_NAME_ORG,
    SUBPODR_ID,
    SUBPODR_FIO,
    SUBPODR_DOLGN,
    KA,
    KB,
    KC,
    KD,
    KE,
    KF,
    KG,
    KH,
    KI,
    KJ,

    KK,
    KL,
    KM,
    K_ITOGO, -- CQ[14462]
    K_PR, -- CQ[15421]
    CORRECTNODE,
    CORRECTNODE_1,

    GUID,

    VELICHSTROBJ,
    EDIZM,
    --CQ[9077]
    REPLACECORRECTION,
    SPREADONEXISTSREC,
    CORRECTIONRULE
    --CQ[9077]

  from A_O_PARAMS_r_pr where ID=:SOURCE_ID
  into
    :NUMGLSSR,
    :TIPRAB,
    :SHIFR,
    :FULLNAME,
    :OPISANIE,
    :ISPOLNIL_FIO,
    :ISPOLNIL_DOLGN,
    :PROVERIL_FIO,
    :PROVERIL_DOLGN,
    :UTVERDIL_FIO,
    :UTVERDIL_DOLGN,
    :SUBPODR_ID_ORG,
    :SUBPODR_NAME_ORG,
    :SUBPODR_ID,
    :SUBPODR_FIO,
    :SUBPODR_DOLGN,
    :KA,
    :KB,
    :KC,
    :KD,
    :KE,
    :KF,
    :KG,
    :KH,
    :KI,
    :KJ,

    :KK,
    :KL,
    :KM,
    :K_ITOGO, -- CQ[14462]
    :K_PR, -- CQ[15421]
    :CORRECTNODE,
    :CORRECTNODE_1,

    :GUID,

    :VELICHSTROBJ,
    :EDIZM,
    --CQ[9077]
    :REPLACECORRECTION,
    :SPREADONEXISTSREC,
    :CORRECTIONRULE
    --CQ[9077]

  do
  begin
    if (not exists (select id from A_O_PARAMS_r_pr where id=:TARGET_ID)) then
    begin
      insert into A_O_PARAMS_r_pr (ID,TIPRAB) values (:TARGET_ID,1);
    end
    update A_O_PARAMS_r_pr set
      NUMGLSSR=:NUMGLSSR,
      TIPRAB=:TIPRAB,
      SHIFR=:SHIFR,
      FULLNAME=:FULLNAME,
      OPISANIE=:OPISANIE,
      ISPOLNIL_FIO=:ISPOLNIL_FIO,
      ISPOLNIL_DOLGN=:ISPOLNIL_DOLGN,
      PROVERIL_FIO=:PROVERIL_FIO,
      PROVERIL_DOLGN=:PROVERIL_DOLGN,
      UTVERDIL_FIO=:UTVERDIL_FIO,
      UTVERDIL_DOLGN=:UTVERDIL_DOLGN,
      SUBPODR_ID_ORG=:SUBPODR_ID_ORG,
      SUBPODR_NAME_ORG=:SUBPODR_NAME_ORG,
      SUBPODR_ID=:SUBPODR_ID,
      SUBPODR_FIO=:SUBPODR_FIO,
      SUBPODR_DOLGN=:SUBPODR_DOLGN,
      KA=:KA,
      KB=:KB,
      KC=:KC,
      KD=:KD,
      KE=:KE,
      KF=:KF,
      KG=:KG,
      KH=:KH,
      KI=:KI,
      KJ=:KJ,

      KK=:KK,
      KL=:KL,
      KM=:KM,
      K_ITOGO = :K_ITOGO, -- CQ[14462]
      K_PR = :K_PR, -- CQ[15421]
      CORRECTNODE = :CORRECTNODE,
      CORRECTNODE_1 = :CORRECTNODE_1, -- MK 21.11.2008 : CORRECTNODE_1 = :CORRECTNODE,

      GUID=:GUID,

      VELICHSTROBJ = :VELICHSTROBJ,
      EDIZM = :EDIZM,
      --CQ[9077]
      REPLACECORRECTION = :REPLACECORRECTION,
      SPREADONEXISTSREC = :SPREADONEXISTSREC,
      CORRECTIONRULE =:CORRECTIONRULE
      --CQ[9077]
    where ID=:TARGET_ID;
    
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE L_BUFER_SELECT_ONE (
    IDUSER INTEGER,
    IDBUFER INTEGER,
    IDZONE INTEGER,
    FROM_RABMAT INTEGER)
RETURNS (
    IDNORMY INTEGER,
    RABMAT INTEGER,
    IDNAME INTEGER,
    IDUNIQUE INTEGER,
    TAB VARCHAR(42),
    FRTCH VARCHAR(250),
    ALTTAB VARCHAR(250),
    IDEDIZM INTEGER,
    EDIZMNAME VARCHAR(100),
    EDIZMFULLNAME VARCHAR(250),
    EDIZMKOEF DOUBLE PRECISION,
    IDABCOKP INTEGER,
    COMMENT VARCHAR(15),
    OKP VARCHAR(15),
    FRESN VARCHAR(21),
    RAZRAD DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    MO DOUBLE PRECISION,
    MP DOUBLE PRECISION,
    MQ DOUBLE PRECISION,
    MR DOUBLE PRECISION,
    MS DOUBLE PRECISION,
    MT DOUBLE PRECISION,
    VRPZ INTEGER,
    NTR INTEGER,
    BRUTTO DOUBLE PRECISION,
    NETTO DOUBLE PRECISION,
    VB DOUBLE PRECISION,
    VN DOUBLE PRECISION,
    PREISK VARCHAR(42),
    POSPREISK VARCHAR(42),
    MBETON DOUBLE PRECISION,
    MRKBETON VARCHAR(15),
    MMASHINE VARCHAR(25),
    VBETON DOUBLE PRECISION,
    TKALK VARCHAR(50),
    PUNKTIND VARCHAR(42),
    ZONE_BB DOUBLE PRECISION,
    ZONE_BC DOUBLE PRECISION,
    ZONE_BD DOUBLE PRECISION,
    ZONE_BE DOUBLE PRECISION,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDTCH INTEGER,
    IDSOSTAV INTEGER,
    IDTCARD INTEGER,
    IDESN INTEGER,
    IDPICTURE INTEGER,
    IDPOSTAV INTEGER,
    ISESN SMALLINT,
    IDWITHESN INTEGER,
    IDQUALIFIER INTEGER,
    ID_UNIQUE INTEGER,
    IDPODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    IDNORMA INTEGER,
    TYPE_TRUD INTEGER,
    ZONE_BA DOUBLE PRECISION,
    OUT_FROM_RABMAT INTEGER,
    BB_PR DOUBLE PRECISION)
AS
DECLARE VARIABLE IDALTEDIZM INTEGER;
--DECLARE VARIABLE ZONE_BA DOUBLE PRECISION;
DECLARE VARIABLE rabmat1 INTEGER;
DECLARE VARIABLE podgroup INTEGER;
BEGIN
--[15352]+

   if ( ( FROM_RABMAT is null ) or ( FROM_RABMAT = -1 ) ) then
   begin
      select first 1 rabmat, podgroup
      from b_bufer b
      where b.id = :IDBUFER into rabmat1, podgroup;

      if ( podgroup > 1 ) then
         FROM_RABMAT = 0;
      else if ( rabmat1 = 1 ) then
         FROM_RABMAT = 0;
      else
         FROM_RABMAT = 1;
   end

   -- MK 15.07.2006 CQ[6308]
   OUT_FROM_RABMAT = FROM_RABMAT;

   if ( FROM_RABMAT = 0 ) then
      for select IDNORMY, RABMAT, ID_UNIQUE, TAB, IDPODGROUP, ISGROUPOKP,
                 IDEDIZM, EDIZMNAME, EDIZMFULLNAME, IDNORMA, TABNORMA, COMMENT,
                 MMASHINE, CENA, RAZRAD, PUNKTIND, IDPOSTAV, VRPZ, NTR,
                 ZONE_CENA, NAME_TITLE, NAME_PART, IDQUALIFIER, TYPE_TRUD, IDNAME
          from S_BUFER_RESURS_SELECT_ONE ( :IDUSER, :IDBUFER, :IDZONE )
          into   IDNORMY, RABMAT, ID_UNIQUE, TAB, IDPODGROUP, ISGROUPOKP,
                 IDEDIZM, EDIZMNAME, EDIZMFULLNAME, IDNORMA, ALTTAB, COMMENT,
                 MMASHINE, BA, RAZRAD, PUNKTIND, IDPOSTAV, VRPZ, NTR,
                 ZONE_BA, NAME_TITLE, NAME_PART, IDQUALIFIER, TYPE_TRUD, IDNAME
      do
      begin
         -- MK 15.07.2006 CQ[6308] --->
         if (:IDUNIQUE is null) then
           IDUNIQUE = 0;
         if (:ISGROUPOKP is null) then
           ISGROUPOKP = 0;
         -- MK 15.07.2006 <---

         suspend;
      end
   else
   begin
      ID_UNIQUE = 0;
      IDPODGROUP = 1;
      ISGROUPOKP = 1;
      IDNORMA = null;
      TYPE_TRUD = 0;

      for select IDNORMY, RABMAT, IDNAME, IDUNIQUE, TAB, FRTCH, ALTTAB,
                 IDEDIZM, EDIZMNAME, EDIZMFULLNAME, EDIZMKOEF,
                 IDABCOKP, COMMENT, OKP, FRESN, RAZRAD,
                 BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
                 PA, PB, PC, PD, PE,
                 MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO, MP, MQ, MR, MS, MT,
                 VRPZ, NTR, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
                 MBETON, MRKBETON, MMASHINE, VBETON, TKALK, PUNKTIND,
                 ZONE_BA, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE,
                 NAME, NAME_TITLE, NAME_PART, IDTCH, IDSOSTAV, IDTCARD,
                 IDESN, IDPICTURE, IDPOSTAV, ISESN, IDWITHESN, IDQUALIFIER,
                 R.BB_PR --[15352]
          from S_BUFER_RABMAT_SELECT_ONE ( :IDUSER, :IDBUFER, :IDZONE )
          left join B_RABMAT R on R.ID = :IDBUFER
          into   IDNORMY, RABMAT, IDNAME, IDUNIQUE, TAB, FRTCH, ALTTAB,
                 IDEDIZM, EDIZMNAME, EDIZMFULLNAME, EDIZMKOEF,
                 IDABCOKP, COMMENT, OKP, FRESN, RAZRAD,
                 BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
                 PA, PB, PC, PD, PE,
                 MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO, MP, MQ, MR, MS, MT,
                 VRPZ, NTR, BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
                 MBETON, MRKBETON, MMASHINE, VBETON, TKALK, PUNKTIND,
                 ZONE_BA, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE,
                 NAME, NAME_TITLE, NAME_PART, IDTCH, IDSOSTAV, IDTCARD,
                 IDESN, IDPICTURE, IDPOSTAV, ISESN, IDWITHESN, IDQUALIFIER,
                 :BB_PR --[15352]
      do
         suspend;
   end
END
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE L_EXP_A_SMETA_N (
*/
--[15352]
CREATE OR ALTER PROCEDURE L_FB_READ_SBORNIK (
    IN_ID_SELF INTEGER,
    IN_ID_ABC_OKP INTEGER,
    IN_PODGROUP INTEGER,
    IN_RABMAT INTEGER,
    ID_USER INTEGER,
    ID_ZONE INTEGER)
RETURNS (
    ID_SELF INTEGER,
    PODGROUP INTEGER,
    RABMAT INTEGER,
    ID_ABC_OKP INTEGER,
    BEDA INTEGER,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDNAME INTEGER,
    ID_UNIQUE INTEGER,
    TAB VARCHAR(42),
    TABU VARCHAR(42),
    ALTTAB VARCHAR(250),
    IDEDIZM INTEGER,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(255),
    COMMENT VARCHAR(42),
    RAZRAD DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    NTR INTEGER,
    PUNKTIND VARCHAR(42),
    ISESN INTEGER,
    IDWITHESN INTEGER,
    CCURRENT_BA DOUBLE PRECISION,
    CCURRENT_BB DOUBLE PRECISION,
    CCURRENT_BC DOUBLE PRECISION,
    CCURRENT_BD DOUBLE PRECISION,
    CCURRENT_BE DOUBLE PRECISION,
    CCURRENT_ZONE INTEGER,
    IDQUALIFIER INTEGER,
    IDNORMTYPE INTEGER,
    NORM_GUID VARCHAR(100),
    IDREESTR INTEGER,
    ABC_OKP_NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_RABMAT INTEGER,
    ABC_OKP_IDNAME INTEGER,
    ABC_OKP_ID_UNIQUE INTEGER,
    ABC_OKP_TAB VARCHAR(42),
    ABC_OKP_TABU VARCHAR(42),
    ABC_OKP_IDGROUP INTEGER,
    ABC_OKP_IDPODGROUP INTEGER,
    ABC_OKP_ISGROUPOKP INTEGER,
    ABC_OKP_IDEDIZM INTEGER,
    ABC_OKP_EDIZM_NAME VARCHAR(100),
    ABC_OKP_EDIZM_FULLNAME VARCHAR(255),
    ABC_OKP_CENA DOUBLE PRECISION,
    ABC_OKP_RAZRAD DOUBLE PRECISION,
    ABC_OKP_VIDNR INTEGER,
    ABC_OKP_COMMENT VARCHAR(42),
    ABC_OKP_PUNKTIND VARCHAR(42),
    ABC_OKP_VRPZ INTEGER,
    ABC_OKP_NTR INTEGER,
    ABC_OKP_CCURRENT DOUBLE PRECISION,
    ABC_OKP_CCURRENT_ZONE INTEGER,
    ABC_OKP_IDQUALIFIER INTEGER,
    TYPE_TRUD INTEGER,
    ABC_OKP_TYPE_TRUD INTEGER,
    MA DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    BB_PR DOUBLE PRECISION)
AS
DECLARE VARIABLE ID_AO INTEGER;
DECLARE VARIABLE ID_RM INTEGER;
DECLARE VARIABLE CNT INTEGER;
DECLARE VARIABLE ZONE_CSMETN DOUBLE PRECISION;
DECLARE VARIABLE USE_RM INTEGER;
DECLARE VARIABLE ISZONEFIND INTEGER;
DECLARE VARIABLE ORDERVIEW INTEGER;
DECLARE VARIABLE POKAZ CHAR(8);
DECLARE VARIABLE INDTYPE VARCHAR(50);
DECLARE VARIABLE DOSTUP INTEGER;
DECLARE VARIABLE OK INTEGER;
DECLARE VARIABLE RM INTEGER;
DECLARE VARIABLE PG INTEGER;
DECLARE VARIABLE SB INTEGER;
DECLARE VARIABLE IS_VALID_REFERENCE INTEGER;
DECLARE VARIABLE ID_ZONE_DEF INTEGER;
begin
--[15352]+

/* return        _ORDERVIEW in ABC_OKP_IDIND */
/* return ABC_OKP_ORDERVIEW in ABC_OKP_VIDNR */
   ID_SELF  = 0;
   PODGROUP = 0;
   RABMAT   = 0;
   ID_ABC_OKP = 0;
   BEDA = 0;
   USE_RM = 0;


   ABC_OKP_IDGROUP = 0;
   ABC_OKP_ISGROUPOKP = 0;

   CCURRENT_ZONE = 0;
   ABC_OKP_CCURRENT_ZONE = 0;
   ABC_OKP_CCURRENT = 0;

   -- MK 30.08.2012 CQ[10722] --->
   -- null       ,    
   --       (     
   --        )
   CCURRENT_BA = null;
   CCURRENT_BB = null;
   CCURRENT_BC = null;
   CCURRENT_BD = null;
   CCURRENT_BE = null;

   --CCURRENT_BA = 0;
   --CCURRENT_BB = 0;
   --CCURRENT_BC = 0;
   --CCURRENT_BD = 0;
   --CCURRENT_BE = 0;
   -- MK 30.08.2012 CQ[10722] <---

   TYPE_TRUD = null;
   ABC_OKP_TYPE_TRUD = null;

   IDQUALIFIER = null;
   ABC_OKP_IDQUALIFIER = null;

   if (
        ( not ( IN_RABMAT in ( 0, 1, 2, 3 ) ) ) or
        ( IN_ID_SELF is null ) or
        ( IN_PODGROUP < -1 )
      ) then
   begin
      suspend;
      exit;
   end

   if ( id_user < 0 ) then
      id_user = -id_user;

   /*     B_RABMAT/B_TRUD     B_ABC_OKP */
   id_ao = 0;
   id_rm = 0;
   if ( IN_PODGROUP > 1 ) then
   begin
      if ( ( IN_ID_ABC_OKP is null ) or ( IN_ID_ABC_OKP <= 0 ) ) then
         IN_ID_ABC_OKP = IN_ID_SELF;
      for select ID, IDNORMA, rabmat, idpodgroup
          from b_abc_okp where id = :IN_ID_ABC_OKP /*and rabmat = :in_rabmat and idpodgroup = :in_podgroup*/
          into id_ao, id_rm, rm, pg
      do
      if ( rm = in_rabmat and pg = in_podgroup ) then
      begin
         execute procedure L_FB_ISVALIDREFERENCETORABMAT ( :id_ao, :id_rm , :rm )
            returning_values ( :is_valid_reference );

         if ( ( is_valid_reference = 0 ) or ( id_rm is null ) ) then
            id_rm = 0;
      end
   end
   else
   begin
      if ( IN_RABMAT = 1 ) then
         for select ID, IDABCOKP from b_trud where id = :IN_ID_SELF
             into id_rm, id_ao
         do
             id_rm = id_rm;
      else
         for select ID, IDABCOKP from b_rabmat where id = :IN_ID_SELF
             into id_rm, id_ao
         do
             id_rm = id_rm;
      if ( IN_ID_ABC_OKP > 0 ) then
         id_ao = IN_ID_ABC_OKP;
   end

   /* test pokaz */
   if ( id_rm > 0 ) then
      if ( IN_RABMAT <> 1 ) then
      begin
         ok = -1;    /* err */   
         for select IDREESTR from b_rabmat where id = :id_rm
             into IDREESTR
         do
            for select r.POKAZ, r.indtype, r.sbornik from b_reestr r where ( r.id = :idreestr ) /*and ( r.sbornik = 1 )*/
                into :POKAZ, :INDTYPE, :sb
            do
               if ( sb = 1 ) then
                  ok = 0;    /* found string in reestr  */

         if ( ok <> -1 ) then
         begin
               execute procedure M_K_TEST_POKAZ (:POKAZ, :INDTYPE, :idreestr, :ID_USER ) returning_values (:DOSTUP);
               if ( DOSTUP <> 0) then
                  ok = 1;
         end

         if ( ok <> 1 ) then
         begin
            ID_SELF  = 0;
            PODGROUP = 0;
            RABMAT   = 0;
            ID_ABC_OKP = 0;
            BEDA = 0;
            USE_RM = 0;

            ABC_OKP_IDGROUP = 0;
            ABC_OKP_ISGROUPOKP = 0;

            CCURRENT_ZONE = 0;
            ABC_OKP_CCURRENT_ZONE = 0;
            ABC_OKP_CCURRENT = 0;
            CCURRENT_BA = 0;
            CCURRENT_BB = 0;
            CCURRENT_BC = 0;
            CCURRENT_BD = 0;
            CCURRENT_BE = 0;

            suspend;
            exit;
         end
      end

   if ( id_ao > 0 ) then
      for select 
               ID, rabmat, ORDERVIEW, IDNAME, ID_UNIQUE, TAB, TABU,
               IDPODGROUP, ISGROUPOKP, IDEDIZM, CENA, RAZRAD,
               COMMENT, PUNKTIND, VRPZ, NTR, IDQUALIFIER, TYPE_TRUD
       from b_abc_okp
/***       where id = :id_ao and rabmat = :IN_RABMAT
 ***     , ..   "" 
 ***  (B_ABC_OKP_IDX_ORDERVIEW  RDB$PRIMARY??(PK_B_ABC_OKP)) */
       where id = :id_ao /*and rabmat = :IN_RABMAT /*    */
          into ID_ABC_OKP, ABC_OKP_RABMAT, ORDERVIEW, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE, ABC_OKP_TAB, ABC_OKP_TABU,
               ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP, ABC_OKP_IDEDIZM, ABC_OKP_CENA, ABC_OKP_RAZRAD,
               ABC_OKP_COMMENT, ABC_OKP_PUNKTIND, ABC_OKP_VRPZ, ABC_OKP_NTR, ABC_OKP_IDQUALIFIER,
               ABC_OKP_TYPE_TRUD
      do
      if (:ABC_OKP_RABMAT = :IN_RABMAT) then
      begin
          /*    - */ 
         ABC_OKP_IDQUALIFIER = NULL ;

         ID_SELF  = ID_ABC_OKP;
         PODGROUP = ABC_OKP_IDPODGROUP;
         RABMAT   = ABC_OKP_RABMAT;
         IDNAME   = ABC_OKP_IDNAME;
         ID_UNIQUE = ABC_OKP_ID_UNIQUE;
         TAB = ABC_OKP_TAB;
         TABU = ABC_OKP_TABU;
         IDEDIZM = ABC_OKP_IDEDIZM;
         COMMENT = ABC_OKP_COMMENT;
         if ( rabmat = 1 ) then
            BE = ABC_OKP_CENA;
         else if ( rabmat = 3 ) then
            BB = ABC_OKP_CENA;
         else if ( rabmat = 2 ) then
            BC = ABC_OKP_CENA;
         RAZRAD = ABC_OKP_RAZRAD;
         PUNKTIND = ABC_OKP_PUNKTIND;
          /*IDIND = ABC_OKP_IDIND;*/ 
         VRPZ = ABC_OKP_VRPZ;
         NTR = ABC_OKP_NTR;
         TYPE_TRUD = ABC_OKP_TYPE_TRUD;

         ABC_OKP_VIDNR = ORDERVIEW;
         IDQUALIFIER = ABC_OKP_IDQUALIFIER;

         if ( ID_ZONE >= -1 ) then
         begin

            execute procedure B_READ_ZONE_ABC_TSENY(:ID_USER, :ID_SELF, :ID_ZONE)
              returning_values :ZONE_CSMETN , :ISZONEFIND;

            if ( ISZONEFIND = 1 ) then
            begin
               ABC_OKP_CCURRENT_ZONE = ID_ZONE;
               ABC_OKP_CCURRENT = zone_csmetn;
               CCURRENT_ZONE = ID_ZONE;
               if ( RABMAT = 1 ) then
                  CCURRENT_BE = zone_csmetn;
               else if ( RABMAT = 2 ) then
                  CCURRENT_BC = zone_csmetn;
               else if ( RABMAT = 3 ) then
                  CCURRENT_BB = zone_csmetn;
            end
         end

      end


   if ( id_rm > 0 ) then
   begin
      PODGROUP = 1;
      if ( IN_RABMAT = 1 ) then
         for select  ID, ORDERVIEW, IDNAME, ID_UNIQUE, TAB, TABU, IDEDIZM, RAZRAD, CENA, TYPE_TRUD
             from b_trud where id = :id_rm
             into :ID_SELF, :ORDERVIEW, :IDNAME, :ID_UNIQUE, :TAB, :TABU, :IDEDIZM, :RAZRAD, :BE, :TYPE_TRUD
         do
         begin
            RABMAT = 1;
            USE_RM = 1;
         end
      else

         for select 
                    ID, IDREESTR, ORDERVIEW, IDNAME, ID_UNIQUE, TAB, TABU, RABMAT,
                    ALTTAB, IDEDIZM, COMMENT, RAZRAD,
                    BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE,
                    MA, MC, MB, MG, MH, BB_PR, --[15352]
                    VRPZ, NTR,
                    PUNKTIND, ISESN, IDWITHESN, IDQUALIFIER
             from b_rabmat where id = :id_rm /*and RABMAT = :IN_RABMAT*/
             into   ID_SELF, IDREESTR, ORDERVIEW, IDNAME, ID_UNIQUE, TAB, TABU, RABMAT,
                    ALTTAB, IDEDIZM, COMMENT, RAZRAD,
                    BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE,
                    :MA, :MC, :MB, :MG, :MH, :BB_PR, --[15352]
                    VRPZ, NTR,
                    PUNKTIND, ISESN, IDWITHESN, IDQUALIFIER

         do
         if ( RABMAT = IN_RABMAT ) then
         begin
            ID_SELF = ID_SELF;
            USE_RM = 1;
             /* sbornik name */ 
            for select  /*r.name,*/ r.norm_guid, r.POKAZ, r.IDTYPE, r.sbornik
                from b_reestr r where ( r.id = :idreestr )/* and ( r.sbornik = 1 )*/
                into :norm_guid, :POKAZ, :IDNORMTYPE, :sb
            do
               if ( sb = 1 ) then
                  ID_SELF = ID_SELF;

         end
   end

   if ( ABC_OKP_ISGROUPOKP is null ) then
      ABC_OKP_ISGROUPOKP = 0;

   /*   */

   NAME_PART = null;
   NAME_TITLE = null;
   ABC_OKP_NAME_PART = null;
   ABC_OKP_NAME_TITLE = null;

   if ( id_ao > 0 )
   then
      select NAME_TITLE , NAME_PART
      from b_getname_2 ( :ID_USER , :ABC_OKP_IDNAME )
      into :ABC_OKP_NAME_TITLE , :ABC_OKP_NAME_PART;
   if ( id_rm > 0 )
   then
      select NAME_TITLE , NAME_PART
      from b_getname_2 ( :ID_USER , :IDNAME )
      into :NAME_TITLE , :NAME_PART;
   else
   begin
      NAME_TITLE = ABC_OKP_NAME_TITLE;
      NAME_PART  = ABC_OKP_NAME_PART;
   end

   /* . . */

   if ( ABC_OKP_IDEDIZM > 0 ) then
      for select EDIZMNAME, EDIZMFULLNAME from B_GET_EDIZM(:IDEDIZM)
          into ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME
      do
      begin
         EDIZM_NAME      = ABC_OKP_EDIZM_NAME;
         EDIZM_FULLNAME  = ABC_OKP_EDIZM_FULLNAME;
      end

   if ( IDEDIZM > 0 ) then
      for select EDIZMNAME, EDIZMFULLNAME from B_GET_EDIZM(:IDEDIZM)
          into EDIZM_NAME, EDIZM_FULLNAME
      do
          CNT = CNT;


   if ( ID_ZONE >= -1 ) then
   begin

      if ( USE_RM = 1 ) then
      begin
         if ( RABMAT <> 1 ) then
            execute procedure B_READ_ZONE_RAB_TSENY(:ID_USER, :ID_SELF, :ID_ZONE)
              returning_values :CCURRENT_BA, :CCURRENT_BB, :CCURRENT_BC, :CCURRENT_BD, :CCURRENT_BE, :ISZONEFIND;
         else
            execute procedure B_READ_ZONE_TRUD_TSENY(:ID_USER, :ID_SELF, :ID_ZONE)
              returning_values :CCURRENT_BE, :ISZONEFIND;

         if ( ISZONEFIND <> 1 ) then
            CCURRENT_ZONE = 0;
         else
            CCURRENT_ZONE = ID_ZONE;

      end
   end

   /* if ( ID_SELF > 0 ) then */

   /* MK 28.08.2006 CQ[3611] ---> */
   -- 
   if (RABMAT = 1) then
      BA = BE;

   -- 
   else if (RABMAT = 2) then
      BA = BC;

   -- 
   else if (RABMAT = 3) then
      BA = BB;
   /* MK 25.08.2006 <--- */



      suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE L_FB_SEARCH_NORMATIV (
    HINT_IDNORMATIV INTEGER,
    HINT_PODGROUP INTEGER,
    HINT_RABMAT INTEGER,
    IN_PODGROUP INTEGER,
    IN_RABMAT INTEGER,
    ID_USER INTEGER,
    STAB VARCHAR(42),
    ID_PUT_RAB INTEGER,
    ID_PUT_MASH INTEGER,
    ID_PUT_MAT INTEGER,
    ID_ZONE INTEGER)
RETURNS (
    ID_SELF INTEGER,
    PODGROUP INTEGER,
    RABMAT INTEGER,
    ID_ABC_OKP INTEGER,
    BEDA1 INTEGER,
    BEDA2 INTEGER,
    BEDARAB INTEGER,
    BEDAMASH INTEGER,
    BEDAMAT INTEGER,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDNAME INTEGER,
    ID_UNIQUE INTEGER,
    TAB VARCHAR(42),
    TABU VARCHAR(42),
    ALTTAB VARCHAR(250),
    IDEDIZM INTEGER,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(255),
    COMMENT VARCHAR(42),
    RAZRAD DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    NTR INTEGER,
    PUNKTIND VARCHAR(42),
    ISESN INTEGER,
    IDWITHESN INTEGER,
    CCURRENT_BA DOUBLE PRECISION,
    CCURRENT_BB DOUBLE PRECISION,
    CCURRENT_BC DOUBLE PRECISION,
    CCURRENT_BD DOUBLE PRECISION,
    CCURRENT_BE DOUBLE PRECISION,
    CCURRENT_ZONE INTEGER,
    IDQUALIFIER INTEGER,
    IDNORMTYPE INTEGER,
    NORM_GUID VARCHAR(100),
    IDREESTR INTEGER,
    ABC_OKP_NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_RABMAT INTEGER,
    ABC_OKP_IDNAME INTEGER,
    ABC_OKP_ID_UNIQUE INTEGER,
    ABC_OKP_TAB VARCHAR(42),
    ABC_OKP_TABU VARCHAR(42),
    ABC_OKP_IDGROUP INTEGER,
    ABC_OKP_IDPODGROUP INTEGER,
    ABC_OKP_ISGROUPOKP INTEGER,
    ABC_OKP_IDEDIZM INTEGER,
    ABC_OKP_EDIZM_NAME VARCHAR(100),
    ABC_OKP_EDIZM_FULLNAME VARCHAR(255),
    ABC_OKP_CENA DOUBLE PRECISION,
    ABC_OKP_RAZRAD DOUBLE PRECISION,
    ABC_OKP_VIDNR INTEGER,
    ABC_OKP_COMMENT VARCHAR(42),
    ABC_OKP_PUNKTIND VARCHAR(42),
    ABC_OKP_VRPZ INTEGER,
    ABC_OKP_NTR INTEGER,
    ABC_OKP_CCURRENT DOUBLE PRECISION,
    ABC_OKP_CCURRENT_ZONE INTEGER,
    ABC_OKP_IDQUALIFIER INTEGER,
    TYPE_TRUD INTEGER,
    ABC_OKP_TYPE_TRUD INTEGER,
    MA DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    BB_PR DOUBLE PRECISION)
AS
declare variable id integer;
declare variable id_ao integer;
declare STAB_8 varchar(42); --[14280,12447]
begin
--[15352]+

/*
    IN_RABMAT:
     -1 - rabmat   ,      
      0,1,2,3 - rabmat   ,       (  ),
                   -     

    SEARCH_IN_PUT_RAB, SEARCH_IN_PUT_MASH, SEARCH_IN_PUT_MAT:
     -1 -    
      0 -     
    > 0 -      ID )

    IN_KODIR_PODGROUP
     -2 -    .
     -1 -   .
      0 -    AVS_OKP
      1 - id podgr. -  ,    AVS_OKP
    > 1 - id podgr.

    ID_ZONE 
     -1 -    
      0 -    
    > 0 - id  
*/
   ID_SELF = 0;
   ID_ABC_OKP = 0;

   if (stab is not null) then
   begin
     STAB_8 = S_TRANSLITERATE(:stab); --[14280,12447]
     stab = S_TRANSLITERATE_TAB(stab); --[12447]
   end

/*****************************************************************************
                         IN_IDNORMATIV
******************************************************************************/
   /*   ,    ,      
              -          */
   if ( ( HINT_IDNORMATIV <> 0 ) and ( HINT_RABMAT in ( 0 , 1 , 2 , 3 ) ) ) then
      if ( HINT_PODGROUP >= 0 ) then
         for select
                  ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA,
                  NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE,
                  TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, COMMENT, RAZRAD,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE,
                  MA, MC, MB, MG, MH, BB_PR, --[15352]
                  VRPZ, NTR, PUNKTIND, ISESN, IDWITHESN,
                  CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE, CCURRENT_ZONE,
                  IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR,
                  ABC_OKP_NAME_PART, ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE,
                  ABC_OKP_TAB, ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                  ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME,
                  ABC_OKP_CENA, ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND,
                  ABC_OKP_VRPZ, ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                  TYPE_TRUD, ABC_OKP_TYPE_TRUD
             from L_FB_READ_SBORNIK ( :HINT_IDNORMATIV, 0, :HINT_PODGROUP, :HINT_RABMAT, :ID_USER, :ID_ZONE )
             into ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA2,
                  NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE,
                  TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, COMMENT, RAZRAD,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE,
                  :MA, :MC, :MB, :MG, :MH, :BB_PR, --[15352]
                  VRPZ, NTR, PUNKTIND, ISESN, IDWITHESN,
                  CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE, CCURRENT_ZONE,
                  IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR,
                  ABC_OKP_NAME_PART, ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE,
                  ABC_OKP_TAB, ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                  ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME,
                  ABC_OKP_CENA, ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND,
                  ABC_OKP_VRPZ, ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                  TYPE_TRUD, ABC_OKP_TYPE_TRUD
         do
         begin
            if ( ( id_self <> 0 ) and (
                 ( stab is null ) or
                   ( stab = tabu ) or ( stab = ABC_OKP_TABU )
                  ) ) then
            begin
               /*  
               rabmat = hint_rabmat;
               PODGROUP = HINT_PODGROUP;
               */
               suspend;
               exit;
            end
         end

/*****************************************************************************
 *****************************************************************************
                                
 *****************************************************************************
/*****************************************************************************/

   ID_SELF = 0;
   ID_ABC_OKP = 0;

   if ( ( stab is null ) or ( lcktrimvarchar ( stab ) = '' ) ) then
   begin
      beda1 = 13;
      suspend;
      exit;
   end

   for select ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA1, BEDA2, BEDARAB, BEDAMASH, BEDAMAT
       from L_FB_SEARCH_ID ( :STAB_8/*[14280,12447]STAB*/, :IN_PODGROUP, :IN_RABMAT, :ID_USER, :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT , 0 , 1 )
       into :ID, :PODGROUP, :RABMAT, :ID_AO, :BEDA1, :BEDA2, :BEDARAB, :BEDAMASH, :BEDAMAT
   do
   begin
         for select
                  ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA,
                  NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE,
                  TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, COMMENT, RAZRAD,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE,
                  MA, MC, MB, MG, MH, BB_PR, --[15352]
                  VRPZ, NTR, PUNKTIND, ISESN, IDWITHESN,
                  CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE, CCURRENT_ZONE,
                  IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR,
                  ABC_OKP_NAME_PART, ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE,
                  ABC_OKP_TAB, ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                  ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME,
                  ABC_OKP_CENA, ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND,
                  ABC_OKP_VRPZ, ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                  TYPE_TRUD, ABC_OKP_TYPE_TRUD
             from L_FB_READ_SBORNIK ( :ID, :ID_AO, :PODGROUP, :RABMAT, :ID_USER, :ID_ZONE )
             into ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA2,
                  NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE,
                  TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, COMMENT, RAZRAD,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE,
                  :MA, :MC, :MB, :MG, :MH, :BB_PR, --[15352]
                  VRPZ, NTR, PUNKTIND, ISESN, IDWITHESN,
                  CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE, CCURRENT_ZONE,
                  IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR,
                  ABC_OKP_NAME_PART, ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE,
                  ABC_OKP_TAB, ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                  ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME,
                  ABC_OKP_CENA, ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND,
                  ABC_OKP_VRPZ, ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                  TYPE_TRUD, ABC_OKP_TYPE_TRUD
         do
         begin
            suspend;
            exit;
         end
         exit;
   end
end
^

--[15352]
CREATE OR ALTER PROCEDURE L_IMP_INS_SMSTR (
    ID_USER INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME_ID INTEGER,
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    SEA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SED BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SEK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    SRA BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRB BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRC BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRD BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRF BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRG BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRH BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRI BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRJ BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRK BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRL BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    SRM BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    DORECALC SMALLINT,
    ID_S_RES INTEGER,
    NOMERROD INTEGER,
    PR_ADDED_REC INTEGER,
    NOMERROD1 INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    TCH_GUID VARCHAR(100),
    NORM_GUID VARCHAR(100),
    OLD_ID INTEGER,
    OLD_NOMERROD INTEGER,
    OLD_NOMERROD1 INTEGER,
    STATUS_REC_CEN INTEGER,
    VIDRAB INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ASUBTYPE INTEGER,
    CLCMODE INTEGER,
    PRICE_GUID VARCHAR(100),
    PRICE_NORMOTAB VARCHAR(42),
    PRICE_NORMOGUID VARCHAR(100),
    ROW INTEGER,
    TYPE_TRUD INTEGER,
    KOEF DOUBLE PRECISION,
    CREATENAME_UW VARCHAR(100),
    CREATEDATE_UW DATE,
    CONFIRMNAME_UW VARCHAR(100),
    CONFIRMDATE_UW DATE,
    CHANGE_NAME_UW VARCHAR(100),
    CHANGE_DATE_UW DATE)
RETURNS (
    ID INTEGER)
AS
 /*$$IBE$$ declare variable cur_id_tr integer;
declare variable index_raschnrisp integer;
declare variable index_brat_zu_is integer;
declare variable res_copy_formuls integer;
declare variable id_price integer;
declare variable idnormo integer; $$IBE$$*/ 
begin /*$$IBE$$ 
--[15352] -  
   -- Voyager, 23.03.2012.    ,    L_IMP_INS_SMSTR_1
   -- Sem: ... L_IMP_INS_SMSTR_N
   exit;

   execute procedure a_set_g_number_obg ( 1 )  returning_values ( :id );

   SKOLL     = null;
   IDTIPR    = null;
   SSTCH     = null;
--   ID_S_RES  = null;
   NOMERROD  = 0;
   NOMERROD1 = null;

   if ( ( not OLD_NOMERROD is null ) and ( OLD_NOMERROD = OLD_ID ) ) then
      NOMERROD = ID;
   if ( ( not OLD_NOMERROD1 is null ) and ( OLD_NOMERROD1 = OLD_ID ) ) then
      NOMERROD1 = ID;

   if  (IDNORMATIV <> 0)  then   --:     GUID   
   begin
     execute procedure L_GET_NORMATIV_FROM_GUID ( :NORM_GUID, :TAB, :IDNORMATIV,
           :KODIR_PODGROUP, :RABMAT, :ID_USER )
        returning_values ( :IDNORMATIV, :KODIR_PODGROUP, :RABMAT );
   end

   if (
       ( vidrab is null ) or
       ( vidrab = 0 )
      )
   then
   begin

    select p.id_tr, p.index_raschnrisp, p.index_brat_zu_is, p.res_copy_formuls
    --from a_s_get_params_obj( :id_user, :idhier ) p
    from A_GET_PARAMS_OBJ_AKT( :id_user, :idhier, :SMETATYPE ) p
    into :cur_id_tr, :index_raschnrisp, :index_brat_zu_is, :res_copy_formuls;

    select f.res_vidrab
    from a_s_get_formuls ( :id_user,
                           :atype,
                           :slaveparent,
                           :cur_id_tr,
                           :vrpz,
                           :index_raschnrisp,
                           :index_brat_zu_is,
                           :res_copy_formuls,
                           :pa,
                           :pb,
                           :pc,
                           :pd,
                           :mf,
                           :mg,
                           :mh,
                           :mi ) f
    into :vidrab;

   end

   if ( tiprab < 1 ) then
      tiprab = 1;
   if ( vrpz < 0 ) then
      vrpz = 0;


    SELECT BA, BB, BC, BD, BE, BF, BG, BH, BI,  $$IBE$$*/ /*BJ,*/ /*$$IBE$$ 
           EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
           RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
           PA, PB, PC, PD,  $$IBE$$*/ /*PE,*/ /*$$IBE$$ 
           MA, MB, MC, MD, ME, MF, MG, MH, MI $$IBE$$*/ /*, MJ, MK, ML*/ /*$$IBE$$ 
    FROM L_S_APPENDREC_VALIDATE_PARAMS (
          :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, 0 $$IBE$$*/ /*:BJ*/ /*$$IBE$$ ,
          :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
          :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
          :PA, :PB, :PC, :PD, 0 $$IBE$$*/ /*:PE*/ /*$$IBE$$ ,
          :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, 0 $$IBE$$*/ /*:MJ*/ /*$$IBE$$ , 0 $$IBE$$*/ /*:MK*/ /*$$IBE$$ , 0 $$IBE$$*/ /*:ML*/ /*$$IBE$$  )
    INTO BA, BB, BC, BD, BE, BF, BG, BH, BI,  $$IBE$$*/ /*BJ,*/ /*$$IBE$$ 
         EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
         RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
         PA, PB, PC, PD,  $$IBE$$*/ /*PE,*/ /*$$IBE$$ 
         MA, MB, MC, MD, ME, MF, MG, MH, MI $$IBE$$*/ /*, MJ, MK, ML*/ /*$$IBE$$ ;

   if ( UTV is null ) then
      UTV = 0;
   if (IDNORMATIVUNIQ is null) then
     IDNORMATIVUNIQ = 0;

   insert into a_smeta (
      ID, IDHIER, SMETATYPE, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE, RABMAT,
      TAB, ALTTAB, NAME_ID, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
      BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
      -- SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK, --Voyager CQ[9984]
      EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
      -- SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM, --Voyager CQ[9984]
      RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
      PA, PB, PC, PD, PE,
      VRPZ, IDTIPR,
      KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
      PUNKTIND,
      MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
      SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH, TIPRAB,
      IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP,
      ARPS_OTHER, DORECALC, ID_S_RES, NOMERROD, PR_ADDED_REC, NOMERROD1, NORM_GUID,
      STATUS_REC_CEN, VIDRAB, UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE, TYPE_TRUD)
   values (
      :ID, :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT, :ATYPE, :RABMAT,
      :TAB, :ALTTAB, :NAME_ID, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
      :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
      -- :SEA, :SEB, :SEC, :SED, :SEE, :SEF, :SEG, :SEH, :SEI, :SEJ, :SEK, --Voyager CQ[9984]
      :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
      -- :SRA, :SRB, :SRC, :SRD, :SRE, :SRF, :SRG, :SRH, :SRI, :SRJ, :SRK, :SRL, :SRM, --Voyager CQ[9984]
      :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
      :PA, :PB, :PC, :PD, :PE,
      :VRPZ, :IDTIPR,
      :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, 
      :PUNKTIND,
      :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
      :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH, :TIPRAB,
      :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP,
      :ARPS_OTHER, :DORECALC, :ID_S_RES, :NOMERROD, :PR_ADDED_REC, :NOMERROD1, :NORM_GUID,
      :STATUS_REC_CEN, :VIDRAB, :UTV, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE, :TYPE_TRUD);

   if ((PRICE_GUID is not null) and (PRICE_GUID <> '')) then
     begin
       ID_PRICE = null;
       select first 1 PRICE_ID from PM_PRICE_GUID where PRICE_GUID = :PRICE_GUID into :ID_PRICE;

       if (PRICE_NORMOGUID is not null) then
       begin
         if (PRICE_NORMOGUID = '-1') then
         begin
           IDNORMO = -1;
         end
         else
         begin
           execute procedure L_GET_NORMATIV_FROM_GUID ( :PRICE_NORMOGUID, :PRICE_NORMOTAB, :IDNORMATIV,:KODIR_PODGROUP, :RABMAT, :ID_USER )
           returning_values ( :IDNORMO, :KODIR_PODGROUP, :RABMAT );
         end
       end
       if (IDNORMO = 0) then IDNORMO = null;
       if ((ID_PRICE is not null) or (IDNORMO is not null) or (ROW is not null)) then
       insert into  SMETA_PRICEPOS_INFO(ID, IDNORMO, IDPRICE, ROW, COST, KOEF) values (:ID, :IDNORMO, :ID_PRICE, :ROW, :BB, :KOEF);
     end

   if ( SMETATYPE <> 15 ) then
      if ( ( not PR_ADDED_REC is null ) and ( PR_ADDED_REC <> 0 ) ) then
         insert into l_s_pr_addinfo ( ID, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_VSEGO )
             values ( :ID, :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, :PR_VSEGO );

   --CQ[9060]-->
   if (CREATEDATE_UW is not null) then
   begin
     insert into SMETAUNIONWORKINFO (ID, CREATENAME, CREATEDATE, CONFIRMNAME, CONFIRMDATE,
                                     CHANGE_NAME, CHANGE_DATE)
     values (:ID, :CREATENAME_UW, :CREATEDATE_UW, :CONFIRMNAME_UW, :CONFIRMDATE_UW,
             :CHANGE_NAME_UW, :CHANGE_DATE_UW);
   end
   --CQ[9060]<--


 $$IBE$$*/ SUSPEND;
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE L_IMP_INS_SMSTR_N (
*/
--[15352]
CREATE OR ALTER PROCEDURE L_IMP_S_APPENDREC (
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EDIZM VARCHAR(100),
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    DORECALC INTEGER,
    ID_USER INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    DORECALL INTEGER,
    USE_ARGS_F INTEGER,
    USE_ARGS_P INTEGER,
    USE_ARGS_M INTEGER,
    USE_ARGS_K INTEGER,
    USE_OBJ_NASTR_F INTEGER,
    USE_OBJ_NASTR_M INTEGER,
    USE_OBJ_NASTR_K INTEGER,
    RECALL_FILL_FRM INTEGER,
    RECALL_FILL_PA INTEGER,
    RECALL_FILL_PB INTEGER,
    RECALL_FILL_PC INTEGER,
    RECALL_FILL_PD INTEGER,
    RECALL_FILL_NAME INTEGER,
    RECALL_FILL_EDIZM INTEGER,
    RECALL_FILL_BA INTEGER,
    RECALL_FILL_BB INTEGER,
    RECALL_FILL_BC INTEGER,
    RECALL_FILL_BD INTEGER,
    RECALL_FILL_BE INTEGER,
    RECALL_FILL_BF INTEGER,
    RECALL_FILL_BG INTEGER,
    RECALL_FILL_BH INTEGER,
    RECALL_FILL_BI INTEGER,
    ID_BLOB_GEN INTEGER,
    UTV INTEGER,
    ASUBTYPE INTEGER,
    IN_IDFORMULS INTEGER)
RETURNS (
    ID INTEGER,
    OUT_ID_OBJ INTEGER,
    OUT_ID_TR INTEGER,
    OUT_IDFORMULS INTEGER)
AS
--zonecen:read
--zonecen:(uses  L_S_APPENDREC)
DECLARE VARIABLE ID_S_RES INTEGER;
DECLARE VARIABLE NAME_ID INTEGER;
DECLARE VARIABLE ID_EDIZM INTEGER;
DECLARE VARIABLE F_ID_SELF INTEGER;
DECLARE VARIABLE F_PODGROUP INTEGER;
DECLARE VARIABLE F_RABMAT INTEGER;
DECLARE VARIABLE F_ID_ABC_OKP INTEGER;
DECLARE VARIABLE F_IDNAME INTEGER;
DECLARE VARIABLE F_ID_UNIQUE INTEGER;
DECLARE VARIABLE F_TAB VARCHAR(42);
DECLARE VARIABLE F_ALTTAB VARCHAR(250);
DECLARE VARIABLE F_IDEDIZM INTEGER;
DECLARE VARIABLE F_BA DOUBLE PRECISION;
DECLARE VARIABLE F_BB DOUBLE PRECISION;
DECLARE VARIABLE F_BC DOUBLE PRECISION;
DECLARE VARIABLE F_BD DOUBLE PRECISION;
DECLARE VARIABLE F_BE DOUBLE PRECISION;
DECLARE VARIABLE F_BF DOUBLE PRECISION;
DECLARE VARIABLE F_BG DOUBLE PRECISION;
DECLARE VARIABLE F_BH DOUBLE PRECISION;
DECLARE VARIABLE F_BI DOUBLE PRECISION;
DECLARE VARIABLE F_BJ DOUBLE PRECISION;
DECLARE VARIABLE F_PA DOUBLE PRECISION;
DECLARE VARIABLE F_PB DOUBLE PRECISION;
DECLARE VARIABLE F_PC DOUBLE PRECISION;
DECLARE VARIABLE F_PD DOUBLE PRECISION;
DECLARE VARIABLE F_PE DOUBLE PRECISION;
DECLARE VARIABLE F_VRPZ INTEGER;
DECLARE VARIABLE F_NTR INTEGER;
DECLARE VARIABLE F_PUNKTIND VARCHAR(42);
DECLARE VARIABLE F_CCURRENT_BA DOUBLE PRECISION;
DECLARE VARIABLE F_CCURRENT_BB DOUBLE PRECISION;
DECLARE VARIABLE F_CCURRENT_BC DOUBLE PRECISION;
DECLARE VARIABLE F_CCURRENT_BD DOUBLE PRECISION;
DECLARE VARIABLE F_CCURRENT_BE DOUBLE PRECISION;
DECLARE VARIABLE F_CCURRENT_ZONE INTEGER;
DECLARE VARIABLE F_ABC_OKP_ISGROUPOKP INTEGER;
DECLARE VARIABLE PUT_ID_RAB INTEGER;
DECLARE VARIABLE PUT_ID_MASH INTEGER;
DECLARE VARIABLE PUT_ID_MAT INTEGER;
DECLARE VARIABLE ID_ZONE INTEGER;
DECLARE VARIABLE B_DORECALL INTEGER;
DECLARE VARIABLE SKIP_OTHER INTEGER;
DECLARE VARIABLE SKIP_INS_SM_RES INTEGER;
DECLARE VARIABLE TMP INTEGER;
DECLARE VARIABLE NORM_GUID VARCHAR(100);
begin
-- [15352] -   ,    L_IMP_S_APPENDREC_NL

  if ( DORECALL is null ) then
     DORECALL = 0;

  execute procedure l_getbit ( DORECALL , 0 ) returning_values ( :B_DORECALL );
  execute procedure l_getbit ( DORECALL , 17 ) returning_values ( :SKIP_OTHER );

  execute procedure l_getbit ( DORECALL , 18 ) returning_values ( :SKIP_INS_SM_RES );
  execute procedure l_getbit ( DORECALL , 19 ) returning_values ( :TMP );
  SKIP_INS_SM_RES = TMP * 2 + SKIP_INS_SM_RES;

  execute procedure a_h_get_id_parentatype( :idhier, 1 ) returning_values ( :OUT_ID_OBJ );

  select PUT_ID_RAB , PUT_ID_MASH , PUT_ID_MAT , ID_ZONE , ID_TR
--  from A_S_GET_PARAMS_OBJ( :id_user, :idhier ) p
  from a_get_params_obj_akt( :id_user, :idhier, :smetatype ) p
  into :PUT_ID_RAB , :PUT_ID_MASH , :PUT_ID_MAT , :ID_ZONE , :OUT_ID_TR;

  NAME_ID = null;
  ID_EDIZM = null;
  NORM_GUID = null;

  if ( B_DORECALL <> 0 ) then
  begin

     for select ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP,
                  IDNAME, ID_UNIQUE, TAB, ALTTAB, IDEDIZM,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE,
                  VRPZ, NTR, PUNKTIND,
                  CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE, CCURRENT_ZONE,
                  ABC_OKP_ISGROUPOKP, NORM_GUID
         from l_fb_search_normativ ( 0 , 0 , 0 , -2 , -1 ,
                   -:ID_USER , lckuppervarchar ( :tab ) , :PUT_ID_RAB , :PUT_ID_MASH , :PUT_ID_MAT , :ID_ZONE )
         into F_ID_SELF, F_PODGROUP, F_RABMAT, F_ID_ABC_OKP,
                  F_IDNAME, F_ID_UNIQUE, F_TAB, F_ALTTAB, F_IDEDIZM,
                  F_BA, F_BB, F_BC, F_BD, F_BE, F_BF, F_BG, F_BH, F_BI, F_BJ, F_PA, F_PB, F_PC, F_PD, F_PE,
                  F_VRPZ, F_NTR, F_PUNKTIND,
                  F_CCURRENT_BA, F_CCURRENT_BB, F_CCURRENT_BC, F_CCURRENT_BD, F_CCURRENT_BE, F_CCURRENT_ZONE,
                  F_ABC_OKP_ISGROUPOKP, NORM_GUID
     do
        if ( F_ID_SELF <> 0 ) then
        begin
           if ( RECALL_FILL_NAME <> 0 ) then
           begin
              NAME_ID = F_IDNAME;
              NAME = null;
           end
           if ( SKIP_OTHER = 0 ) then
           begin
              -- MK CQ[14606] --->
              --    =  ,   
              --   -->    
              if ((TAB = PUNKTIND) and (TAB <> F_TAB)) then
                PUNKTIND = F_PUNKTIND;
              -- MK CQ[14606] <---

              TAB = F_TAB;
              ALTTAB = F_ALTTAB;
           end
           if ( RECALL_FILL_EDIZM <> 0 ) then
              ID_EDIZM = F_IDEDIZM;
           if ( RECALL_FILL_FRM <> 0 ) then
              VRPZ = F_VRPZ;
           /*
           PUNKTIND = F_PUNKTIND; */
           if ( RECALL_FILL_BA <> 0 ) then
              BA = F_BA;
           if ( RECALL_FILL_BB <> 0 ) then
              BB = F_BB;
           if ( RECALL_FILL_BC <> 0 ) then
              BC = F_BC;
           if ( RECALL_FILL_BD <> 0 ) then
              BD = F_BD;
           if ( RECALL_FILL_BE <> 0 ) then
              BE = F_BE;
           if ( RECALL_FILL_BF <> 0 ) then
              BF = F_BF;
           if ( RECALL_FILL_BG <> 0 ) then
              BG = F_BG;
           if ( RECALL_FILL_BH <> 0 ) then
              BH = F_BH;
           if ( RECALL_FILL_BI <> 0 ) then
              BI = F_BI;
           if ( RECALL_FILL_PA <> 0 ) then
           begin
              PA = F_PA;
              MF = PA;
           end
           if ( RECALL_FILL_PB <> 0 ) then
           begin
              PB = F_PB;
              MG = PB;
           end
           if ( RECALL_FILL_PC <> 0 ) then
           begin
              PC = F_PC;
              MH = PC;
           end
           if ( RECALL_FILL_PD <> 0 ) then
           begin
              PD = F_PD;
              MI = PD;
           end
           IDNORMATIV = F_ID_SELF;
           IDNORMATIVUNIQ = F_ID_UNIQUE;
           /*KODIR_GROUP */
           KODIR_PODGROUP = F_PODGROUP;
           ISGROUPOKP = F_ABC_OKP_ISGROUPOKP;
           if ( SKIP_OTHER = 0 ) then /* ???? */
              RABMAT = F_RABMAT;
        end
  end

   execute procedure A_SET_G_NUMBER_OBG ( 1 ) returning_values ( :id );

   if ( ID_EDIZM is null ) then
      execute procedure b_add_edizm_in_silence ( :ID_USER, :EDIZM, NULL )
      returning_values ( :ID_EDIZM );

    SELECT BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
           EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
           RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
           PA, PB, PC, PD, PE,
           MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML
    FROM L_S_APPENDREC_VALIDATE_PARAMS (
          :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
          :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
          :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
          :PA, :PB, :PC, :PD, :PE,
          :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML )
    INTO BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
         EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
         RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
         PA, PB, PC, PD, PE,
         MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML;

   execute procedure l_s_appendrec (
       :USE_ARGS_F, :USE_ARGS_P, :USE_ARGS_M, :USE_ARGS_K, :USE_OBJ_NASTR_F, :USE_OBJ_NASTR_M, :USE_OBJ_NASTR_K,
       :SKIP_INS_SM_RES,
       :ID_USER, :ID, :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3,
       :SLAVEPARENT, :ATYPE, :RABMAT, :TAB, :ALTTAB,
       :NAME, null, :ID_EDIZM,
--       null, null,
       :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
       :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
       :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
       :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
       :IDTIPR,
       :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
       :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH,
       :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP,
       :INSERT_TO_ATYPE, :INSERT_TO_ID, :ID_S_RES,
       :vrpz,
       :PA,  :PB,  :PC,  :PD,
       :TIPRAB,
       :PUNKTIND,
       :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
       :NORM_GUID, :UTV, :ASUBTYPE, IN_IDFORMULS );

   if ( ( RECALL_FILL_NAME <> 0 ) and ( not NAME_ID is null ) ) then
   begin
      update a_smeta s set
         s.name_id = :NAME_ID
      where s.id = :ID;
   end

/*
   update a_smeta s set
      BJ = :BJ,
      EJ = :EJ,
      PE = :PE,
      KJ = :KJ,
      DORECALC = :DORECALC
   where s.id = :ID;
*/


   /* set blobs separaterely */
   if ( not ARPS_OTHER is null ) then
      update a_smeta s set
         ARPS_OTHER = :ARPS_OTHER
      where s.id = :ID;

    OUT_IDFORMULS = IN_IDFORMULS;
END
^

--[15352]
CREATE OR ALTER PROCEDURE L_IMP_S_APPENDREC_NL (
    MODE INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    EDIZM VARCHAR(100),
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_USER INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    DORECALL INTEGER,
    USE_ARGS_F INTEGER,
    USE_ARGS_P INTEGER,
    USE_ARGS_M INTEGER,
    USE_ARGS_K INTEGER,
    USE_OBJ_NASTR_F INTEGER,
    USE_OBJ_NASTR_M INTEGER,
    USE_OBJ_NASTR_K INTEGER,
    RECALL_FILL_FRM INTEGER,
    RECALL_FILL_PA INTEGER,
    RECALL_FILL_PB INTEGER,
    RECALL_FILL_PC INTEGER,
    RECALL_FILL_PD INTEGER,
    RECALL_FILL_NAME INTEGER,
    RECALL_FILL_EDIZM INTEGER,
    RECALL_FILL_BA INTEGER,
    RECALL_FILL_BB INTEGER,
    RECALL_FILL_BC INTEGER,
    RECALL_FILL_BD INTEGER,
    RECALL_FILL_BE INTEGER,
    RECALL_FILL_BF INTEGER,
    RECALL_FILL_BG INTEGER,
    RECALL_FILL_BH INTEGER,
    RECALL_FILL_BI INTEGER,
    UTV INTEGER,
    ASUBTYPE INTEGER,
    IN_IDFORMULS INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    TAB_BLOB BLOB SUB_TYPE 1 SEGMENT SIZE 80)
RETURNS (
    ID INTEGER,
    OUT_ID_OBJ INTEGER,
    OUT_ID_TR INTEGER,
    OUT_IDFORMULS INTEGER)
AS
declare variable ID_S_RES integer;
declare variable NAME_ID integer;
declare variable ID_EDIZM integer;
declare variable F_ID_SELF integer;
declare variable F_PODGROUP integer;
declare variable F_RABMAT integer;
declare variable F_IDNAME integer;
declare variable F_ID_UNIQUE integer;
declare variable F_TAB varchar(42);
declare variable F_ALTTAB varchar(250);
declare variable F_IDEDIZM integer;
declare variable F_VRPZ integer;
declare variable F_ABC_OKP_ISGROUPOKP integer;
declare variable PUT_ID_RAB integer;
declare variable PUT_ID_MASH integer;
declare variable PUT_ID_MAT integer;
declare variable B_DORECALL integer;
declare variable SKIP_OTHER integer;
declare variable SKIP_INS_SM_RES integer;
declare variable TMP integer;
declare variable NORM_GUID varchar(100);

declare variable F_BF double precision;
declare variable F_BG double precision;
declare variable F_BH double precision;
declare variable F_BI double precision;
declare variable F_BJ double precision;
declare variable F_PA double precision;
declare variable F_PB double precision;
declare variable F_PC double precision;
declare variable F_PD double precision;

--CQ[TIMUR 13178]
declare variable CLCMODE integer;
declare variable ID_LEVEL integer;
declare variable BASE_CALC_INFO integer;
--CQ[TIMUR 13178]

-- MK CQ[14606]
DECLARE VARIABLE F_PUNKTIND VARCHAR(42);
begin
--[15352] - 

  --    L_IMP_S_APPENDREC
  --  MODE    .        ,   ...
  -- MODE = 0 -   

  MODE = coalesce(:MODE, 0);

  if (DORECALL is null) then
    DORECALL = 0;

  execute procedure L_GETBIT(DORECALL, 0)
  returning_values (:B_DORECALL);

  execute procedure L_GETBIT(DORECALL, 17)
  returning_values (:SKIP_OTHER);

  execute procedure L_GETBIT(DORECALL, 18)
  returning_values (:SKIP_INS_SM_RES);

  execute procedure L_GETBIT(DORECALL, 19)
  returning_values (:TMP);

  SKIP_INS_SM_RES = TMP * 2 + SKIP_INS_SM_RES;

  execute procedure A_H_GET_ID_PARENTATYPE(:IDHIER, 1)
  returning_values (:OUT_ID_OBJ);

  select PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT, ID_TR
  from A_GET_PARAMS_OBJ_AKT(:ID_USER, :IDHIER, :SMETATYPE) P
  into :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT, :OUT_ID_TR;

  NAME_ID = null;
  ID_EDIZM = null;
  NORM_GUID = null;
  ID_S_RES = null;

  if (B_DORECALL <> 0) then
  begin

    for select ID_SELF, PODGROUP, RABMAT, IDNAME, ID_UNIQUE, TAB, ALTTAB, IDEDIZM, VRPZ,
               ABC_OKP_ISGROUPOKP, NORM_GUID, PA, PB, PC, PD,
               PUNKTIND -- MK CQ[14606]
      from L_FB_SEARCH_NORMATIV(0, 0, 0, -2, -1, -:ID_USER, LCKUPPERVARCHAR(:TAB), :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT, 0)
      into F_ID_SELF, F_PODGROUP, F_RABMAT, F_IDNAME, F_ID_UNIQUE, F_TAB, F_ALTTAB, F_IDEDIZM,
           F_VRPZ, F_ABC_OKP_ISGROUPOKP, NORM_GUID, F_PA, F_PB, F_PC, F_PD,
           F_PUNKTIND -- MK CQ[14606]
    do
      if (F_ID_SELF <> 0) then
      begin
        if (RECALL_FILL_NAME <> 0) then
        begin
          NAME_ID = F_IDNAME;
          NAME = null;
        end
        if (SKIP_OTHER = 0) then
        begin
          -- MK CQ[14606] --->
          --    =  ,   
          --   -->    
          if ((TAB = PUNKTIND) and (TAB <> F_TAB)) then
            PUNKTIND = F_PUNKTIND;
          -- MK CQ[14606] <---

          TAB = F_TAB;
          ALTTAB = F_ALTTAB;
        end
        if (RECALL_FILL_EDIZM <> 0) then
          ID_EDIZM = F_IDEDIZM;
        if (RECALL_FILL_FRM <> 0) then
          VRPZ = F_VRPZ;
        -- B_DORECALL   ,       L_S_APPENDREC_NL
        if (RECALL_FILL_BA <> 0) then
          B_DORECALL = SETBIT(:B_DORECALL, 1, 1);
        if (RECALL_FILL_BB <> 0) then
          B_DORECALL = SETBIT(:B_DORECALL, 2, 1);
        if (RECALL_FILL_BC <> 0) then
          B_DORECALL = SETBIT(:B_DORECALL, 3, 1);
        if (RECALL_FILL_BD <> 0) then
          B_DORECALL = SETBIT(:B_DORECALL, 4, 1);
        if (RECALL_FILL_BE <> 0) then
          B_DORECALL = SETBIT(:B_DORECALL, 5, 1);

        if (RECALL_FILL_BF <> 0) then
          BF = F_BF;
        if (RECALL_FILL_BG <> 0) then
          BG = F_BG;
        if (RECALL_FILL_BH <> 0) then
          BH = F_BH;
        if (RECALL_FILL_BI <> 0) then
          BI = F_BI;
       if (RECALL_FILL_PA <> 0) then
        begin
          PA = F_PA;
          MF = PA;
        end
        if (RECALL_FILL_PB <> 0) then
        begin
          PB = F_PB;
          MG = PB;
        end
        if (RECALL_FILL_PC <> 0) then
        begin
          PC = F_PC;
          MH = PC;
        end
        if (RECALL_FILL_PD <> 0) then
        begin
          PD = F_PD;
          MI = PD;
        end

        IDNORMATIV = F_ID_SELF;
        IDNORMATIVUNIQ = F_ID_UNIQUE;
        KODIR_PODGROUP = F_PODGROUP;
        ISGROUPOKP = F_ABC_OKP_ISGROUPOKP;
        if (SKIP_OTHER = 0) then
          RABMAT = F_RABMAT;
      end
  end

  execute procedure A_SET_G_NUMBER_OBG(1)
  returning_values (:ID);

  if (ID_EDIZM is null) then
    execute procedure B_ADD_EDIZM_IN_SILENCE(:ID_USER, :EDIZM, null)
    returning_values (:ID_EDIZM);

  select BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK, RA, RB,
         RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM, PA, PB, PC, PD, PE, MA, MB, MC, MD, ME, MF, MG,
         MH, MI, MJ, MK, ML
  from L_S_APPENDREC_VALIDATE_PARAMS(:BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK, :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :PA, :PB, :PC, :PD, :PE, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML)
  into BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK, RA, RB,
       RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM, PA, PB, PC, PD, PE, MA, MB, MC, MD, ME, MF, MG,
       MH, MI, MJ, MK, ML;

  execute procedure L_S_APPENDREC_NL_2(:USE_ARGS_F, :USE_ARGS_P, :USE_ARGS_M, :USE_ARGS_K,
    :USE_OBJ_NASTR_F, :USE_OBJ_NASTR_M, :USE_OBJ_NASTR_K, :SKIP_INS_SM_RES, :ID_USER, :ID, :IDHIER,
    :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT, :ATYPE, :RABMAT, :TAB, :ALTTAB, :NAME,
    null, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH, :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH,
    :BI, :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK, :RA, :RB, :RC, :RD, :RE, :RF, :RG,
    :RH, :RI, :RJ, :RK, :RL, :RM, :IDTIPR, :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK,
    :KL, :KM, :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH, :IDNORMATIV,
    :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :INSERT_TO_ATYPE, :INSERT_TO_ID,
    :ID_S_RES, :VRPZ, :PA, :PB, :PC, :PD, :TIPRAB, :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG,
    :MH, :MI, :NORM_GUID, :UTV, :ASUBTYPE, IN_IDFORMULS, :B_DORECALL);

  if ((RECALL_FILL_NAME <> 0) and
      (not NAME_ID is null)) then
  begin
    update A_SMETA S set
      S.NAME_ID = :NAME_ID
    where S.ID = :ID;
  end

  --CQ[TIMUR 13178]
  CLCMODE = null;
  select CLCMODE
    from A_SMETA
    where ID = :ID
  into :CLCMODE;

  -- [8E8B6724937D] -   ... .
  if ((coalesce(:BN, 0) = 0) and (coalesce(:BO, 0) = 0)) then
    CLCMODE = SETBIT(:CLCMODE, 16, 0);
  else
  /*       ,           */
  if ((:BN is not null) or (:BO is not null)) then
    CLCMODE = SETBIT(:CLCMODE, 16, 1);
  --CQ[TIMUR 13178]

  --CQ[9314]-->
  update A_SMETA set
    CORRECTNODE = :CORRECTNODE,
    CORRECTNODE_1 = :CORRECTNODE_1,
    BN = :BN,  --CQ[TIMUR 13192]
    BO = :BO,  --CQ[TIMUR 13192]
    CLCMODE = :CLCMODE --CQ[TIMUR 13178]
  where ID = :ID;
  --CQ[9314]<--

  --CQ[TIMUR 13929, 14263]
  if (:TAB_BLOB is not null) then
    insert into A_SMETA_BLOB (ID, FIELD_NAME, FIELD_VALUE)
    values (:ID, 'TAB', :TAB_BLOB);

  --CQ[TIMUR 13178]
  for select L.ID
    from LEVEL_COST L
    where (L.IDOBJECT = case :SMETATYPE
                          when 15 then :OUT_ID_OBJ
                          when 16 then :OUT_ID_OBJ
                          else :SMETATYPE
                        end)
  into :ID_LEVEL
  do
  begin
     BASE_CALC_INFO = null;
     select BASE_CALC_INFO
       from A_SMETA_CENLVL
       where (ID = :ID) and (IDCENLVL = :ID_LEVEL)
     into :BASE_CALC_INFO;

     -- [8E8B6724937D] -   ... .
     if ((coalesce(:BN, 0) = 0) and (coalesce(:BO, 0) = 0)) then
       BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 5, 0);
     else
     /*       ,           */
     if ((:BN is not null) or (:BO is not null)) then
       BASE_CALC_INFO = SETBIT(:BASE_CALC_INFO, 5, 1);

     update A_SMETA_CENLVL set
       BN = :BN,  --CQ[TIMUR 13192]
       BO = :BO,  --CQ[TIMUR 13192]

       --CQ[TIMUR 13192] 1
       --B_ITOGO = case GETBIT(BASE_CALC_INFO, 5) when 1 then BB + BC + BE else B_ITOGO end,
       EN = case GETBIT(:BASE_CALC_INFO, 5) when 1 then :BN else EN end,
       EO = case GETBIT(:BASE_CALC_INFO, 5) when 1 then :BO else EO end,
       --CQ[TIMUR 13192] 1

       BASE_CALC_INFO = :BASE_CALC_INFO
     where (ID = :ID) and (IDCENLVL = :ID_LEVEL);
  end
  --CQ[TIMUR 13178]

  if (not ARPS_OTHER is null) then
    update A_SMETA S set
      ARPS_OTHER = :ARPS_OTHER
    where S.ID = :ID;

  OUT_IDFORMULS = IN_IDFORMULS;
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE L_PR_COPY_SMETA_TO_PR_ONE_REC (
*/
--[15352]
CREATE OR ALTER PROCEDURE L_S_APPENDREC (
    USE_ARGS_F INTEGER,
    USE_ARGS_P INTEGER,
    USE_ARGS_M INTEGER,
    USE_ARGS_K INTEGER,
    USE_OBJ_NASTR_F INTEGER,
    USE_OBJ_NASTR_M INTEGER,
    USE_OBJ_NASTR_K INTEGER,
    SKIP_INS_SM_RES INTEGER,
    IDUSER INTEGER,
    ID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    INSERT_TO_ATYPE INTEGER,
    INSERT_TO_ID INTEGER,
    ID_S_RES INTEGER,
    VRPZ INTEGER,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    TIPRAB INTEGER,
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    NORM_GUID VARCHAR(100),
    UTV INTEGER,
    ASUBTYPE INTEGER,
    IN_IDFORMULS INTEGER)
AS
DECLARE VARIABLE ID_CUR INTEGER;
DECLARE VARIABLE ATYPE_CUR INTEGER;
DECLARE VARIABLE CUR_ID_TR INTEGER;
DECLARE VARIABLE CUR_KOLL_PARENT DOUBLE PRECISION;
DECLARE VARIABLE PR_ADDED_REC INTEGER;
DECLARE VARIABLE PR_NUMBER1 INTEGER;
DECLARE VARIABLE PR_NUMBER2 INTEGER;
DECLARE VARIABLE ADDED_RES INTEGER;
DECLARE VARIABLE RES_KODIR_GROUP INTEGER;
DECLARE VARIABLE RES_KODIR_PODGROUP INTEGER;
DECLARE VARIABLE INDEX_ID_ORG INTEGER;
DECLARE VARIABLE INDEX_ID_GOD INTEGER;
DECLARE VARIABLE INDEX_ID_MES INTEGER;
DECLARE VARIABLE INDEX_NASNACHAUTO INTEGER;
DECLARE VARIABLE INDEX_ZAMENNASNACH INTEGER;
DECLARE VARIABLE INDEX_RASCHNRISP INTEGER;
DECLARE VARIABLE INDEX_BRAT_ZU_IS INTEGER;
DECLARE VARIABLE INDEX_UCHITNDS INTEGER;
DECLARE VARIABLE RES_COPY_INDEX INTEGER;
DECLARE VARIABLE RES_COPY_FORMULS INTEGER;
DECLARE VARIABLE RES_COPY_POPR INTEGER;
DECLARE VARIABLE S_PUNKTIND VARCHAR(42);
DECLARE VARIABLE S_MA DOUBLE PRECISION;
DECLARE VARIABLE S_MB DOUBLE PRECISION;
DECLARE VARIABLE S_MC DOUBLE PRECISION;
DECLARE VARIABLE S_MD DOUBLE PRECISION;
DECLARE VARIABLE S_ME DOUBLE PRECISION;
DECLARE VARIABLE S_MF DOUBLE PRECISION;
DECLARE VARIABLE S_MG DOUBLE PRECISION;
DECLARE VARIABLE S_MH DOUBLE PRECISION;
DECLARE VARIABLE S_MI DOUBLE PRECISION;
DECLARE VARIABLE S_PA DOUBLE PRECISION;
DECLARE VARIABLE S_PB DOUBLE PRECISION;
DECLARE VARIABLE S_PC DOUBLE PRECISION;
DECLARE VARIABLE S_PD DOUBLE PRECISION;
DECLARE VARIABLE S_VRPZ INTEGER;
DECLARE VARIABLE ID_TR INTEGER;
DECLARE VARIABLE INSERT_FORMULS_2 INTEGER;
DECLARE VARIABLE RES_APPLY_TAB INTEGER;
DECLARE VARIABLE ADDEDID INTEGER;
DECLARE VARIABLE id_zone INTEGER;
DECLARE VARIABLE name_id INTEGER;
DECLARE VARIABLE NEEDUPDATE_NAME_PART INTEGER;
DECLARE VARIABLE NEEDUPDATE_NAME_TITLE INTEGER;
DECLARE VARIABLE vidrab INTEGER;

declare variable WILDCARD_USED integer;

declare variable ID_LEVEL integer;
declare variable IDCLASS integer;
begin
--[15352] -   ,  L_IMP_S_APPENDREC

--zonecen:read
--zonecen:(uses A_S_ADD_RES)
--zonecen:(used in L_IMP_S_APPENDREC)
  WILDCARD_USED = 1;

  if ( USE_ARGS_F is null ) then
     USE_ARGS_F = 0;
  if ( USE_ARGS_P is null ) then
     USE_ARGS_P = 0;
  if ( USE_ARGS_M is null ) then
     USE_ARGS_M = 0;
  if ( USE_ARGS_K is null ) then
     USE_ARGS_K = 0;
  if ( USE_OBJ_NASTR_F is null ) then
     USE_OBJ_NASTR_F = 0;
  if ( USE_OBJ_NASTR_M is null ) then
     USE_OBJ_NASTR_M = 0;
  if ( USE_OBJ_NASTR_K is null ) then
     USE_OBJ_NASTR_K = 0;

/*
  INSERT_FORMULS:
    0 - from tip.rasch. , use obj params
    1 - from input args , don't use obj params
    2 - from tip.rasch. , don't use obj params
*/

/*
  SKIP_INS_SM_RES:
    bit 0:  0 - insert sm. res. for smetn. strings
            1 - don't insert sm.res for smetn. strings
    bit 1:  0 - don't copy podch. str. to sm. res.
            1 - copy podch. str. to sm. res.
*/

/*
  INSERT_FORMULS_2 = 0;
  if ( INSERT_FORMULS = 2 ) then
  begin
     INSERT_FORMULS = 0;
     INSERT_FORMULS_2 = 1;
  end
*/

 /* ?????????, ????? ??????? ????????? ??? ?????????? */
 id_cur = 0;

 select h.number
 from a_o_hier h
 where h.number = :idhier
 into :id_cur;

 if (id_cur <= 0) then exception A_H_MODIFY_DATA;
 /* +++++++++++++++++++++++++++++++++++++++++++++++++ */


 if ( atype = 17 ) then
    slaveparent = 0;

 /* ?????????, ???????????? ?????? ??? ??????????? */
 if (slaveparent <> 0)
 then
 begin

  id_cur = 0;

  select s.id, s.atype
  from a_smeta s
  where (s.id = :slaveparent) and
        (s.idhier = :idhier) and
        (s.smetatype = :smetatype)
  into :id_cur, :atype_cur;

  if ( (id_cur = 0) or
       ((atype = 18) and (NOT atype_cur IN (17, 18))) )
  then exception A_H_MODIFY_DATA;

 end
 /* +++++++++++++++++++++++++++++++++++++++++++++++++ */


 /* ????????????? ???? (???? ?????? ? ????? ??????? ??? ???? */
 execute procedure A_S_RENUM_BEFORE_INSERT(:idhier,
                                           :smetatype,
                                           :atype,
                                           :number1,
                                           :number2,
                                           :number3,
                                           1,
                                           :insert_to_atype,
                                           :id,
                                           :insert_to_id);

/***********************************************************/
/***********************************************************/

 if ( ( vrpz is null ) or ( vrpz < 0 ) )
 then vrpz = 0;

 if ( USE_ARGS_M = 0 ) then
 begin
   MA = 1; MB = 1; MC = 1; MD = 1; ME = 1; MF = 0; MG = 0; MH = 1; MI = 1;
 end
 if ( USE_ARGS_P = 0 ) then
 begin
    PA = 0; PB = 0; PC = 1; PD = 1;
 end
 if ( USE_ARGS_K = 0 ) then
 begin
    KA = ''; KB = ''; KC = ''; KD = ''; KE = ''; KF = ''; KG = ''; KH = ''; KI = ''; KJ = ''; KK = ''; KL = ''; KM = '';
 end

 if ( atype in (17, 18) )
 then
 begin

  select p.id_tr, p.RES_COPY_FORMULS, p.RES_COPY_POPR, p.INDEX_ID_ORG, p.INDEX_ID_GOD, p.INDEX_ID_MES, p.INDEX_NASNACHAUTO, p.INDEX_ZAMENNASNACH, p.INDEX_RASCHNRISP,
         p.INDEX_BRAT_ZU_IS, p.INDEX_UCHITNDS, p.RES_COPY_INDEX, p.kodir_group, p.kodir_podgroup,
         p.ID_TR, p.RES_APPLY_TAB, p.id_zone
--  from A_S_GET_PARAMS_OBJ( :iduser, :idhier ) p
  from a_get_params_obj_akt( :iduser, :idhier, :smetatype ) p
  into :cur_id_tr, :RES_COPY_FORMULS, :RES_COPY_POPR, :INDEX_ID_ORG, :INDEX_ID_GOD, :INDEX_ID_MES, :INDEX_NASNACHAUTO, :INDEX_ZAMENNASNACH, :INDEX_RASCHNRISP,
       :INDEX_BRAT_ZU_IS, :INDEX_UCHITNDS, :RES_COPY_INDEX, :res_kodir_group, :res_kodir_podgroup,
       :ID_TR, :RES_APPLY_TAB, :id_zone;


  --CQ[9299] <--

  -- MK 25.08.2011 CQ[9435] --->
  if (SMETATYPE = 15) then
    execute procedure A_H_GET_ID_PARENTATYPE(:IDHIER, 1) returning_values (:IDCLASS);
  else
    IDCLASS = SMETATYPE;



  --     CQ[9297]
  /*CQ[9291]
  if ( USE_OBJ_NASTR_M <> 0 ) then
  begin
   select i.RES_MA, i.RES_MB, i.RES_MC, i.RES_MD, i.RES_ME, i.RES_MF, i.RES_MG, i.RES_MH, i.RES_MI, i.RES_PA,
         i.RES_PB, i.RES_PC, i.RES_PD, i.RES_PUNKTIND
   from A_S_GET_INDEX ( :IDUSER,
                       :ID,
                       :SLAVEPARENT,
                       :ATYPE,
                       :INDEX_ID_ORG,
                       :INDEX_ID_GOD,
                       :INDEX_ID_MES,
                       :INDEX_NASNACHAUTO,
                       :INDEX_ZAMENNASNACH,
                       :INDEX_RASCHNRISP,
                       :INDEX_BRAT_ZU_IS,
                       :INDEX_UCHITNDS,
                       :RES_COPY_INDEX,
                       :MA,
                       :MB,
                       :MC,
                       :MD,
                       :ME,
                       :MF,
                       :MG,
                       :MH,
                       :MI,
                       :PA,
                       :PB,
                       :PC,
                       :PD,
                       :PUNKTIND,
                       0,
                       :WILDCARD_USED ) i
   into :S_MA, :S_MB, :S_MC, :S_MD, :S_ME, :S_MF, :S_MG, :S_MH, :S_MI, :S_PA, :S_PB, :S_PC, :S_PD, :S_PUNKTIND;

   begin
    PA = S_PA;
    PB = S_PB;
    PC = S_PC;
    PD = S_PD;
   end

   begin
    MA = S_MA;
    MB = S_MB;
    MC = S_MC;
    MD = S_MD;
    ME = S_ME;
    MF = S_MF;
    MG = S_MG;
    MH = S_MH;
    MI = S_MI;
    PUNKTIND = S_PUNKTIND;
   end
  end
  */

  if ( USE_OBJ_NASTR_F = 0 ) then
     if ( USE_ARGS_F = 0 ) then
     begin
        -- MK 1.03.2011 CQ[9123] --->
        if (not exists(select f.id from a_srf_f f where f.id_tr = :id_tr and f.number = :vrpz)) then
          vrpz = 0;
        -- MK 1.03.2011 CQ[9123] <---

        if ( exists ( select f.id from a_srf_f f where f.id_tr = :id_tr and f.number = :vrpz ) )
        then select
                  /*f.pa, f.pb, f.pc, f.pd,*/ f.atype, f.number_vr
             from a_srf_f f
             where f.id_tr = :id_tr and
                   f.number = :vrpz
             into
                /*:pa, :pb, :pc, :pd,*/ :tiprab, :vidrab;
        else select
                  /*f.pa, f.pb, f.pc, f.pd,*/ f.tiprab, f.vidrab
             from a_default_sei( :iduser ) f
             into
                /*:cur_pa, :cur_pb, :cur_pc, :cur_pd,*/ :tiprab, :vidrab;
     end

  if ( USE_OBJ_NASTR_F <> 0 ) then
  begin
   select f.res_vrpz,
          f.res_pa, f.res_pb, f.res_pc, f.res_pd,
          f.res_mf, f.res_mg, f.res_mh, f.res_mi, f.res_tiprab, f.res_vidrab
   from a_s_get_formuls (:IDUSER,
                         :ATYPE,
                         :SLAVEPARENT,
                         :cur_id_tr,
                         :VRPZ,
                         :INDEX_RASCHNRISP,
                         :INDEX_BRAT_ZU_IS,
                         :RES_COPY_FORMULS,
                         :PA,
                         :PB,
                         :PC,
                         :PD,
                         :MF,
                         :MG,
                         :MH,
                         :MI ) f
   into :S_vrpz,
        :S_pa, :S_pb, :S_pc, :S_pd, :S_mf, :S_mg, :S_mh, :S_mi, :tiprab, :vidrab;

   if ( USE_ARGS_F = 0 ) then
   begin
      vrpz = S_vrpz;
   end
   if ( USE_ARGS_P = 0 ) then
   begin
      pa = S_pa;
      pb = S_pb;
      pc = S_pc;
      pd = S_pd;
      mf = S_mf;
      mg = S_mg;
      mh = S_mh;
      mi = S_mi;
   end
  end

  if ( USE_OBJ_NASTR_K <> 0 ) then
   select p.ka, p.kb, p.kc, p.kd, p.ke, p.kf, p.kg, p.kh, p.ki, p.kj, p.kk, p.KL, p.KM
   from l_s_get_popr( :atype, :slaveparent, :RES_COPY_POPR, :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM ) p
   into :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM;

   if (
       ( vidrab is null ) or
       ( vidrab = 0 )
      )
   then
   begin

        select f.res_vidrab
        from a_s_get_formuls ( :iduser,
                               :atype,
                               :slaveparent,
                               :cur_id_tr,
                               :vrpz,
                               :index_raschnrisp,
                               :index_brat_zu_is,
                               :res_copy_formuls,
                               :pa,
                               :pb,
                               :pc,
                               :pd,
                               :mf,
                               :mg,
                               :mh,
                               :mi ) f
        into :vidrab;
    end
 end

 if (
     ( atype = 18 ) and
     ( normarash > 0 )
    )
 then
 begin

  cur_koll_parent = 0;

  select s.koll
  from a_smeta s
  where s.id = :slaveparent
  into :cur_koll_parent;

  koll = cur_koll_parent * normarash;

 end

 PR_ADDED_REC = 0;
 if ( not smetatype in ( 15 , 16 ) ) then
    PR_ADDED_REC = 1;


   if ( ( not atype in (17, 18) ) ) then
   begin
    if ( PA is null ) then
       PA = 0.0;
    if ( PB is null ) then
       PB = 0.0;
    if ( PC is null ) then
       PC = 1.0;
    if ( PD is null ) then
       PD = 1.0;
   end

   if ( ( not atype in (17, 18) ) ) then
   begin
    if ( MA is null ) then
       MA = 1.0;
    if ( MB is null ) then
       MB = 1.0;
    if ( MC is null ) then
       MC = 1.0;
    if ( MD is null ) then
       MD = 1.0;
    if ( ME is null ) then
       ME = 1.0;
    if ( MF is null ) then
       MF = 1.0;
    if ( MG is null ) then
       MG = 1.0;
    if ( MH is null ) then
       MH = 1.0;
    if ( MI is null ) then
       MI = 1.0;
   end

   if ( BA is null ) then
       BA = 0.0;
   if ( BB is null ) then
       BB = 0.0;
   if ( BC is null ) then
       BC = 0.0;
   if ( BD is null ) then
       BD = 0.0;
   if ( BE is null ) then
       BE = 0.0;
   if ( BF is null ) then
       BF = 0.0;
   if ( BG is null ) then
       BG = 0.0;
   if ( BH is null ) then
       BH = 0.0;
   if ( BI is null ) then
       BI = 0.0;

   if ( IDNORMATIV is null ) then
      IDNORMATIV = 0;
   if ( IDNORMATIVUNIQ is null ) then
      IDNORMATIVUNIQ = 0;
   if ( KODIR_GROUP is null ) then
      KODIR_GROUP = 1;
   if ( KODIR_PODGROUP is null ) then
      KODIR_PODGROUP = 1;
   if ( ISGROUPOKP is null ) then
      ISGROUPOKP = 0;


   if ( tiprab < 1 ) then
      tiprab = 1;
   if ( vrpz < 0 ) then
      vrpz = 0;

   begin

      NEEDUPDATE_NAME_PART  = 1;
      NEEDUPDATE_NAME_TITLE = 1;
      if ( NAME is null ) then
         NEEDUPDATE_NAME_PART = 0;
      if ( NAME_TITLE is null ) then
         NEEDUPDATE_NAME_TITLE = 0;

      NAME_ID = null;
      if ( ( NEEDUPDATE_NAME_PART <> 0 ) or ( NEEDUPDATE_NAME_TITLE <> 0 ) ) then
         SELECT IDNAME
         FROM B_WRITE_NAME_EX ( :IDUSER, -1, 0, :NAME, :NEEDUPDATE_NAME_PART,
                                :NAME_TITLE, :NEEDUPDATE_NAME_TITLE )
         INTO :NAME_ID;

      BEGIN

    /*     (.  ) */
    /*OUT_SEA = SEA;
    OUT_SEB = SEB;
    OUT_SEC = SEC;
    OUT_SED = SED;
    OUT_SEE = SEE;
    OUT_SEF = SEF;
    OUT_SEG = SEG;
    OUT_SEH = SEH;
    OUT_SEI = SEI;
    OUT_SRA = SRA;
    OUT_SRB = SRB;
    OUT_SRC = SRC;
    OUT_SRD = SRD;
    OUT_SRE = SRE;
    OUT_SRF = SRF;
    OUT_SRG = SRG;
    OUT_SRH = SRH;
    OUT_SRI = SRI;
    OUT_SRJ = SRJ;
    OUT_SRK = SRK;
    OUT_SRL = SRL;
    OUT_SRM = SRM;*/

    SELECT BA, BB, BC, BD, BE, BF, BG, BH, BI, /*BJ,*/
           EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
           RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
           PA, PB, PC, PD, /*PE,*/
           MA, MB, MC, MD, ME, MF, MG, MH, MI/*, MJ, MK, ML*/
    FROM L_S_APPENDREC_VALIDATE_PARAMS (
          :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, 0/*:BJ*/,
          :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
          :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
          :PA, :PB, :PC, :PD, 0/*:PE*/,
          :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, 0/*:MJ*/, 0/*:MK*/, 0/*:ML*/ )
    INTO BA, BB, BC, BD, BE, BF, BG, BH, BI, /*BJ,*/
         EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
         RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
         PA, PB, PC, PD, /*PE,*/
         MA, MB, MC, MD, ME, MF, MG, MH, MI/*, MJ, MK, ML*/;

    if ( UTV is null ) then
       UTV = 0;

         insert
           into a_smeta (id, idhier, smetatype, number1, number2, number3, slaveparent,
                atype, rabmat, tab, alttab,
                name_id, id_edizm, edizm_type, koll, skoll, normarash,
                ba, bb, bc, bd, be, bf, bg, bh, bi,
                ea, eb, ec, ed, ee, ef, eg, eh, ei, ej, ek,
                ra, rb, rc, rd, re, rf, rg, rh, ri, rj, rk, rl, rm,
                pa, pb, pc, pd, idtipr,
                ka, kb, kc, kd, ke, kf, kg, kh, ki, kj, kk, kl ,km,
                PUNKTIND,
                ma, mb, mc, md, me, mf, mg, mh, mi,
                sstch, kodzak, kodgp, kodsp, kodisp, nach,
                okonch, tiprab, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP,
                KODIR_PODGROUP, ISGROUPOKP, id_s_res, vrpz, PR_ADDED_REC, NORM_GUID, vidrab, utv, asubtype, IDFORMULS)
         values ( :id, :idhier, :smetatype, :number1, :number2, :number3, :slaveparent,
                :atype, :rabmat, :tab, :alttab,
                :name_id, :id_edizm, :edizm_type, :koll, :skoll, :normarash,
                :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi,
                :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
                :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
                :pa, :pb, :pc, :pd, :idtipr,
                :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM,
                :PUNKTIND,
                :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi,
                :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
                :okonch, :tiprab, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP,
                :KODIR_PODGROUP, :ISGROUPOKP, :id_s_res, :vrpz, :PR_ADDED_REC, :NORM_GUID, :vidrab, :utv, :asubtype, :IN_IDFORMULS);

      WHEN GDSCODE FOREIGN_KEY, GDSCODE BAD_SEGSTR_ID DO
      BEGIN

         insert
           into a_smeta (id, idhier, smetatype, number1, number2, number3, slaveparent,
                atype, rabmat, tab, alttab,
--                name_id,
                id_edizm, edizm_type, koll, skoll, normarash,
                ba, bb, bc, bd, be, bf, bg, bh, bi,
                ea, eb, ec, ed, ee, ef, eg, eh, ei, ej, ek,
                ra, rb, rc, rd, re, rf, rg, rh, ri, rj, rk, rl, rm,
                pa, pb, pc, pd, idtipr,
                ka, kb, kc, kd, ke, kf, kg, kh, ki, kj, kk, KL, KM,
                PUNKTIND,
                ma, mb, mc, md, me, mf, mg, mh, mi,
                sstch, kodzak, kodgp, kodsp, kodisp, nach,
                okonch, tiprab, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP,
                KODIR_PODGROUP, ISGROUPOKP, id_s_res, vrpz, PR_ADDED_REC, NORM_GUID, vidrab, utv, asubtype, IDFORMULS)
         values ( :id, :idhier, :smetatype, :number1, :number2, :number3, :slaveparent,
                :atype, :rabmat, :tab, :alttab,
--                :name_id,
                :id_edizm, :edizm_type, :koll, :skoll, :normarash,
                :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi,
                :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
                :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
                :pa, :pb, :pc, :pd, :idtipr,
                :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM,
                :PUNKTIND,
                :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi,
                :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
                :okonch, :tiprab, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP,
                :KODIR_PODGROUP, :ISGROUPOKP, :id_s_res, :vrpz, :PR_ADDED_REC, :NORM_GUID, :vidrab, :utv, :asubtype, :IN_IDFORMULS);


          SELECT IDNAME
          FROM B_WRITE_NAME_EX ( :IDUSER, 22, :ID, :NAME, 1,
                                 :NAME_TITLE, 1)
          INTO :NAME_ID;

        WHEN GDSCODE FOREIGN_KEY DO EXCEPTION B_E_RECORD_IS_LOCKED ;
        END
      END
   end

  --CQ[9297] -->
  for select L.ID
      from LEVEL_COST L
      where (L.IDOBJECT = :IDCLASS)
      into :ID_LEVEL
  do
  begin
    execute procedure A_SMETA_COPY_CENLVL_AS_IS(:ID,
        :IDUSER, :ID_LEVEL);
  end
  --CQ[9297] <--



 if (
--     ( ( SKIP_INS_SM_RES is null ) or ( SKIP_INS_SM_RES = 0 ) ) and
     ( ( SKIP_INS_SM_RES is null ) or ( SKIP_INS_SM_RES in (0,2) ) ) and /* bit 0 == 0*/
     ( atype = 17 )
    ) then

    /* MK 17.08.2006 CQ[3569]    -      */
    /*CQ[9297]for select ADDEDID
        from a_s_add_res ( :IDUSER, :id, :res_kodir_group, :res_kodir_podgroup, :id_zone,
                           0 , 0 , 0, :RES_APPLY_TAB, null, null, null, null, null, NULL, NULL, 0, 0)
        into ADDEDID
    do
       ADDEDID = ADDEDID; CQ[9297]*/
    --CQ[9297] -->
    --    ,      
    for select ADDEDID
        from a_s_add_res_nl ( :IDUSER, :id, :res_kodir_group, :res_kodir_podgroup, :id_zone,
                           0 , 0 , 0, :RES_APPLY_TAB, null, null, null, null, null, NULL, NULL, 0, 0, 1)
        into ADDEDID
    do
    begin
       ADDEDID = ADDEDID;
       --CQ[9297] -->
      for select L.ID
          from LEVEL_COST L
          where (L.IDOBJECT = :IDCLASS)
          into :ID_LEVEL
      do
      begin
        execute procedure A_S_RES_COPY_CENLVL_AS_IS(:ADDEDID,
            :IDUSER, :ID_LEVEL);
      end
      --CQ[9297] <--
    end
    --CQ[9297] <--

-- if ( ( not SKIP_INS_SM_RES is null ) and ( SKIP_INS_SM_RES <> 0 ) ) then
 if ( ( not SKIP_INS_SM_RES is null ) and ( SKIP_INS_SM_RES in (2,3) ) ) then /* bit 1 == 1*/
  if (
      ( not slaveparent is null ) and
      ( slaveparent > 0 ) and
      ( atype = 18 ) and
      ( id_s_res is null )
     )
  then
  begin


/*  select p.kodir_group, p.kodir_podgroup
  from a_s_get_params_obj( :iduser, :idhier )  p
  into :res_kodir_group, :res_kodir_podgroup;*/

    execute procedure a_s_res_slavetores ( :iduser,
                                          :id,
                                          :res_kodir_group,
                                          :res_kodir_podgroup,
                                          :IDNORMATIV,
                                          :KODIR_PODGROUP,
                                          :rabmat,
                                          :IDNORMATIV,
                                          0 ) --MK 17.08.2006 CQ[3569]
          returning_values ( :added_res );
  end


 if ( not smetatype in ( 15 , 16 ) ) then            /* lck */
 begin
  if ( atype = 17 ) then
  begin
   execute procedure L_PR_GET_MAX_NUMBER1 ( :idhier , :iduser ) RETURNING_VALUES ( :PR_NUMBER1 );
   insert into l_s_pr_addinfo ( id , PR_NUMBER1 , PR_NUMBER2 , PR_NUMBER3 ) values ( :id , :PR_NUMBER1 , :NUMBER2 , :NUMBER3 );
  end
  else
  begin
   execute procedure L_PR_GET_NUMBER_1_2 ( :SLAVEPARENT/*:id*/, :idhier , :iduser ) RETURNING_VALUES ( :PR_NUMBER1 , :PR_NUMBER2 );
   insert into l_s_pr_addinfo ( id , PR_NUMBER1 , PR_NUMBER2 , PR_NUMBER3 ) values ( :id , :PR_NUMBER1 , :PR_NUMBER2 , :NUMBER3 );
  end
 end                                                 /* lck */
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE L_S_APPENDREC_NL_2 (
*/
--[15352]
CREATE OR ALTER PROCEDURE L_S_APPENDREC_VALIDATE_PARAMS (
    IN_BA DOUBLE PRECISION,
    IN_BB DOUBLE PRECISION,
    IN_BC DOUBLE PRECISION,
    IN_BD DOUBLE PRECISION,
    IN_BE DOUBLE PRECISION,
    IN_BF DOUBLE PRECISION,
    IN_BG DOUBLE PRECISION,
    IN_BH DOUBLE PRECISION,
    IN_BI DOUBLE PRECISION,
    IN_BJ DOUBLE PRECISION,
    IN_EA DOUBLE PRECISION,
    IN_EB DOUBLE PRECISION,
    IN_EC DOUBLE PRECISION,
    IN_ED DOUBLE PRECISION,
    IN_EE DOUBLE PRECISION,
    IN_EF DOUBLE PRECISION,
    IN_EG DOUBLE PRECISION,
    IN_EH DOUBLE PRECISION,
    IN_EI DOUBLE PRECISION,
    IN_EJ DOUBLE PRECISION,
    IN_EK DOUBLE PRECISION,
    IN_RA DOUBLE PRECISION,
    IN_RB DOUBLE PRECISION,
    IN_RC DOUBLE PRECISION,
    IN_RD DOUBLE PRECISION,
    IN_RE DOUBLE PRECISION,
    IN_RF DOUBLE PRECISION,
    IN_RG DOUBLE PRECISION,
    IN_RH DOUBLE PRECISION,
    IN_RI DOUBLE PRECISION,
    IN_RJ DOUBLE PRECISION,
    IN_RK DOUBLE PRECISION,
    IN_RL DOUBLE PRECISION,
    IN_RM DOUBLE PRECISION,
    IN_PA DOUBLE PRECISION,
    IN_PB DOUBLE PRECISION,
    IN_PC DOUBLE PRECISION,
    IN_PD DOUBLE PRECISION,
    IN_PE DOUBLE PRECISION,
    IN_MA DOUBLE PRECISION,
    IN_MB DOUBLE PRECISION,
    IN_MC DOUBLE PRECISION,
    IN_MD DOUBLE PRECISION,
    IN_ME DOUBLE PRECISION,
    IN_MF DOUBLE PRECISION,
    IN_MG DOUBLE PRECISION,
    IN_MH DOUBLE PRECISION,
    IN_MI DOUBLE PRECISION,
    IN_MJ DOUBLE PRECISION,
    IN_MK DOUBLE PRECISION,
    IN_ML DOUBLE PRECISION)
RETURNS (
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION)
AS
begin
--[15352] -   ,     "not null"

   if ( IN_BA is null ) then BA = 0; else BA = IN_BA;
   if ( IN_BB is null ) then BB = 0; else BB = IN_BB;
   if ( IN_BC is null ) then BC = 0; else BC = IN_BC;
   if ( IN_BD is null ) then BD = 0; else BD = IN_BD;
   if ( IN_BE is null ) then BE = 0; else BE = IN_BE;
   if ( IN_BF is null ) then BF = 0; else BF = IN_BF;
   if ( IN_BG is null ) then BG = 0; else BG = IN_BG;
   if ( IN_BH is null ) then BH = 0; else BH = IN_BH;
   if ( IN_BI is null ) then BI = 0; else BI = IN_BI;
   if ( IN_BJ is null ) then BJ = 0; else BJ = IN_BJ;

   if ( IN_EA is null ) then EA = 0; else EA = IN_EA;
   if ( IN_EB is null ) then EB = 0; else EB = IN_EB;
   if ( IN_EC is null ) then EC = 0; else EC = IN_EC;
   if ( IN_ED is null ) then ED = 0; else ED = IN_ED;
   if ( IN_EE is null ) then EE = 0; else EE = IN_EE;
   if ( IN_EF is null ) then EF = 0; else EF = IN_EF;
   if ( IN_EG is null ) then EG = 0; else EG = IN_EG;
   if ( IN_EH is null ) then EH = 0; else EH = IN_EH;
   if ( IN_EI is null ) then EI = 0; else EI = IN_EI;
   if ( IN_EJ is null ) then EJ = 0; else EJ = IN_EJ;
   if ( IN_EK is null ) then EK = 0; else EK = IN_EK;

   if ( IN_RA is null ) then RA = 0; else RA = IN_RA;
   if ( IN_RB is null ) then RB = 0; else RB = IN_RB;
   if ( IN_RC is null ) then RC = 0; else RC = IN_RC;
   if ( IN_RD is null ) then RD = 0; else RD = IN_RD;
   if ( IN_RE is null ) then RE = 0; else RE = IN_RE;
   if ( IN_RF is null ) then RF = 0; else RF = IN_RF;
   if ( IN_RG is null ) then RG = 0; else RG = IN_RG;
   if ( IN_RH is null ) then RH = 0; else RH = IN_RH;
   if ( IN_RI is null ) then RI = 0; else RI = IN_RI;
   if ( IN_RJ is null ) then RJ = 0; else RJ = IN_RJ;
   if ( IN_RK is null ) then RK = 0; else RK = IN_RK;
   if ( IN_RL is null ) then RL = 0; else RL = IN_RL;
   if ( IN_RM is null ) then RM = 0; else RM = IN_RM;

   if ( IN_PA is null ) then PA = 0; else PA = IN_PA;
   if ( IN_PB is null ) then PB = 0; else PB = IN_PB;
   if ( IN_PC is null ) then PC = 1; else PC = IN_PC;
   if ( IN_PD is null ) then PD = 1; else PD = IN_PD;
   if ( IN_PE is null ) then PE = 0; else PE = IN_PE;

   if ( IN_MA is null ) then MA = 0; else MA = IN_MA;
   if ( IN_MB is null ) then MB = 0; else MB = IN_MB;
   if ( IN_MC is null ) then MC = 0; else MC = IN_MC;
   if ( IN_MD is null ) then MD = 0; else MD = IN_MD;
   if ( IN_ME is null ) then ME = 0; else ME = IN_ME;
   if ( IN_MF is null ) then MF = 0; else MF = IN_MF;
   if ( IN_MG is null ) then MG = 0; else MG = IN_MG;
   if ( IN_MH is null ) then MH = 0; else MH = IN_MH;
   if ( IN_MI is null ) then MI = 0; else MI = IN_MI;
   if ( IN_MJ is null ) then MJ = 0; else MJ = IN_MJ;
   if ( IN_MK is null ) then MK = 0; else MK = IN_MK;
   if ( IN_ML is null ) then ML = 0; else ML = IN_ML;

   suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE L_S_CREATE_IS (
    IDOBJECT INTEGER,
    IDLEVEL INTEGER,
    IDUSER INTEGER,
    SMETATYPE INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    IDLS INTEGER,
    IDR INTEGER,
    ALLREC INTEGER,
    SENDER INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    TYPE_TRUD INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_ID INTEGER,
    EDIZM VARCHAR(250),
    ID_EDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    IDTIPR INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    PUNKTIND VARCHAR(42),
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    SSTCH INTEGER,
    KODZAK INTEGER,
    KODGP INTEGER,
    KODSP INTEGER,
    KODISP INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    VIDRAB INTEGER,
    IDNORMATIV INTEGER,
    IDNORMATIVUNIQ INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    ARPS_OTHER BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    PR_NUMBER1 INTEGER,
    PR_NUMBER2 INTEGER,
    PR_NUMBER3 INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    PR_VIPOLNENO DOUBLE PRECISION,
    PR_EXISTS_CHILDS INTEGER,
    NORM_GUID VARCHAR(100),
    CALK_BA INTEGER,
    CALK_BB INTEGER,
    CALK_BC INTEGER,
    CALK_BD INTEGER,
    CALK_BE INTEGER,
    STATUS_REC_CEN INTEGER,
    IDREESTR INTEGER,
    CALK_BG INTEGER,
    CALK_BG_READONLY INTEGER,
    CALK_BH INTEGER,
    CALK_BH_READONLY INTEGER,
    UTV INTEGER,
    ASUBTYPE INTEGER,
    STRUCT_NAME VARCHAR(255),
    FULL_STRUCT_NAME VARCHAR(1024),
    IDFORMULS INTEGER,
    STRUCT_SHIFR VARCHAR(1024),
    NUMLSR_LS VARCHAR(1024),
    VIEW_NUMBER1 INTEGER,
    VIEW_NUMBER2 INTEGER,
    VIEW_NUMBER3 INTEGER,
    ID_LS INTEGER,
    ADDED_SMETATYPE INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    B_PR DOUBLE PRECISION)
AS
--CQ[TIMUR 13931] -    STRUCT_SHIFR, FULL_STRUCT_NAME, NUMLSR_LS
--DECLARE VARIABLE FULLNAME VARCHAR(300);
DECLARE VARIABLE CHECKNODE INTEGER;
--DECLARE VARIABLE CUR_SHIFR VARCHAR(60);
DECLARE VARIABLE ID_SELF INTEGER;
DECLARE VARIABLE IS_SHOW INTEGER;
DECLARE VARIABLE KEY2 INTEGER;
DECLARE VARIABLE CUR_PROJECTTYPE INTEGER;
DECLARE VARIABLE V_KOEF DOUBLE PRECISION;
DECLARE VARIABLE H_SMETATYPE INTEGER;
DECLARE VARIABLE NEW_ID INTEGER;
DECLARE VARIABLE ISH_ID INTEGER;
DECLARE VARIABLE PARAM_KODIR_GROUP INTEGER;
DECLARE VARIABLE PARAM_KODIR_PODGROUP INTEGER;
DECLARE VARIABLE ONLY_ONE_HIER INTEGER;
DECLARE VARIABLE KC6_SMETATYPE INTEGER;
DECLARE VARIABLE ISCLC INTEGER;
DECLARE VARIABLE MODE_KOMPNS_ST INTEGER;
DECLARE VARIABLE DOPANDHIGHTKOLL INTEGER;
DECLARE VARIABLE VN_PR_ADDED_REC INTEGER;
DECLARE VARIABLE INCLUDEACTSMODE INTEGER;
-- MK 20.10.2010 CQ[8684]
declare variable IsIncludeRec integer;
BEGIN
--[15352]+
--[8443]


  -- MK 22.05.2012 CQ[9460]  !!! ---------------------------------------
  --   STRUCT_SHIFR   ()   
  --   SAP (B_RABMAT.IDENT_KOD_MAT_SAP)

 NUMLSR_LS = null; --CQ[12881]
 kc6_smetatype = 15;
 IF ( smetatype < 0 ) THEN
 BEGIN
    smetatype = -smetatype;
    kc6_smetatype = 0;
 END

 SELECT p.ISCLC, p.MODE_KOMPNS_ST, p.kodir_group, p.kodir_podgroup
 FROM a_s_get_params_obj( :iduser, :idobject ) p
 INTO :ISCLC, :MODE_KOMPNS_ST, :param_kodir_group, :param_kodir_podgroup;

 -- MK 31.08.2009 CQ[7362] --->
 DopAndHightKoll = 0;
 IF ((getbit(:MODE_KOMPNS_ST, 5) = 0) AND (getbit(:MODE_KOMPNS_ST, 6) = 1)) THEN
   DopAndHightKoll = 1;
 -- MK 31.08.2009 CQ[7362] <---

 -- Voyager CQ[8457]
 INCLUDEACTSMODE = 0;
 if ( getbit(:MODE_KOMPNS_ST,7) > 0 ) THEN
    INCLUDEACTSMODE = 1;
 if ( getbit(:MODE_KOMPNS_ST,8) > 0 ) THEN
    INCLUDEACTSMODE = 2;
 -- <-- CQ[8457]

 SELECT projecttype
 FROM l_getprojecttype( :iduser )
 INTO :cur_projecttype;

   IS_SHOW = 1;
   KEY2 = GEN_ID ( LG_S_TMP_TBL_KEY2 , 1 );

   --           idobject (  idobject   id , , 
   --  only_one_hier = 1.        
   only_one_hier = 0;
   IF ( EXISTS (SELECT number FROM a_o_hier h WHERE ( h.number = :idobject ) AND ( h.atype IN (3,4,5) ) ) )
   THEN only_one_hier = 1;

   /*      :   = 15 */
   /*      :   = 0 */
   FOR SELECT ID_SELF, ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT
       FROM L_PR_CREATE_KC6_BASE ( :IDOBJECT, :KEY2, :kc6_smetatype, 0, 0, :IDUSER, :SENDER, :only_one_hier )
       INTO   ID_SELF, ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT
   DO
      IF ( ( ID_SELF IS NULL ) AND (SLAVEPARENT IN (26,27,28) ) ) THEN /* struct. str. for report */
      BEGIN
         ATYPE = SLAVEPARENT;
         SLAVEPARENT = 0;
         SUSPEND;
      END
      ELSE IF ( ID_SELF IS NULL ) THEN /* struct. str.  */
      BEGIN

         ATYPE = SLAVEPARENT;
         SLAVEPARENT = 0;

         -- MK CQ[12020] --->
         if (ATYPE = 3) then
           ID_LS = IDHIER;
         -- MK CQ[12020] <---

         -- MK 9.09.2010 CQ[8691] --->
         --CQ[9609]EXECUTE PROCEDURE a_h_GetName :IDHIER, :ATYPE RETURNING_VALUES :cur_shifr, :FULL_STRUCT_NAME;
         EXECUTE PROCEDURE a_h_GetName :IDHIER, :ATYPE RETURNING_VALUES :STRUCT_SHIFR, :FULL_STRUCT_NAME;--CQ[9609]

         if (ATYPE = 3) then --CQ[12881]
            SELECT NUMLSR_LS
            FROM A_O_PARAMS_LS
            WHERE id = :IDHIER
            INTO :NUMLSR_LS;
/*
         EXECUTE PROCEDURE a_h_GetName :IDHIER, :ATYPE RETURNING_VALUES :cur_shifr, :fullname;
         IF ( fullname IS NULL )
         THEN fullname = '';

         IF ( atype = 4 ) THEN
            fullname = '    ' || fullname;
         IF ( atype = 5 ) THEN
            fullname = '    ' || '    ' || fullname;

         name = copyvarchartoblob(fullname);
*/
         -- MK 9.09.2010 CQ[8691] <---

         view_number1 = null; view_number2 = null; view_number3 = null; -- MK CQ[12020]

         number1 = NULL; number2 = NULL; number3 = NULL; slaveparent = NULL; name_id = NULL;
         tab = NULL; alttab = NULL; edizm = NULL; id_edizm = NULL;
         edizm_type = NULL; koll = NULL; skoll = NULL; normarash = NULL;
         ba = NULL; bb = NULL; bc = NULL; bd = NULL; be = NULL; bf = NULL; bg = NULL; bh = NULL;
         bi = NULL; bj = NULL; /*CQ[9359]sea = NULL; seb = NULL; sec = NULL; sed = NULL; see = NULL; sef = NULL;
         seg = NULL; seh = NULL; sei = NULL; sej = NULL; sek = NULL;*/ ea = NULL; eb = NULL; ec = NULL; ed = NULL;
         ee = NULL; ef = NULL; eg = NULL; eh = NULL; ei = NULL; ej = NULL; ek = NULL; /*CQ[9359]sra = NULL; srb = NULL;
         src = NULL; srd = NULL; sre = NULL; srf = NULL; srg = NULL; srh = NULL; sri = NULL;
         srj = NULL; srk = NULL; srl = NULL; srm = null;*/
         ra = NULL; rb = NULL; rc = NULL;
         rd = NULL; re = NULL; rf = NULL; rg = NULL; rh = NULL; ri = NULL; rj = NULL; rk = NULL;
         rl = NULL; rm = NULL; pa = NULL; pb = NULL; pc = NULL; pd = NULL; pe = NULL; vrpz = NULL;
         idtipr = NULL;
         ka = NULL; kb = NULL; kc = NULL; kd = NULL; ke = NULL; kf = NULL; kg = NULL; kh = NULL;
         ki = NULL; kj = NULL; kk = NULL; kl = NULL; km = NULL; K_ITOGO = NULL; /*14460*/ K_PR = NULL; /*15421*/
         B_PR = null; --[15352]
         punktind = NULL; ma = NULL; mb = NULL; mc = NULL; md = NULL; me = NULL; mf = NULL; mg = NULL;
         mh = NULL; mi = NULL; mj = NULL; mk = NULL; ml = NULL; sstch = NULL; kodzak = NULL;
         kodgp = NULL; kodsp = NULL; kodisp = NULL; nach = NULL; okonch = NULL; tiprab = NULL; vidrab = NULL;
--         IDNORMATIV = null; IDNORMATIVUNIQ = null;
         KODIR_GROUP = NULL; KODIR_PODGROUP = NULL; ISGROUPOKP = NULL; ARPS_OTHER = NULL;
         id_s_res = NULL;
         pr_number1 = NULL; pr_number2 = NULL; pr_number3 = NULL; pr_added_rec = NULL; pr_vsego = NULL; pr_vipolneno = NULL; pr_exists_childs = NULL;
         status_rec_cen = NULL; idreestr = NULL;
         UTV = NULL; ASUBTYPE = NULL;
         IDFORMULS = null;--CQ[9359]
         checknode = NULL;
         SELECT hch.id
         FROM A_O_HIERCHECKING hch
         WHERE (hch.iduser = :iduser) AND
               (hch.idobject = :idobject) AND
               (hch.smetatype = 16) AND
               (hch.atype = 16) AND
               (hch.idelem = :id)
         INTO :checknode;

         EXECUTE PROCEDURE a_s_get_struct_put ( :iduser, :atype, :nls, :nr, :npr )
           RETURNING_VALUES ( :nls, :nr, :npr, :STRUCT_NAME/*srm*/ );


         IF ( atype = 3 ) THEN
         BEGIN
            idls = id;
            idr  = 0;
         END
         ELSE IF ( atype = 4 )
              THEN idr = id;


         idnormativ = idls;
         idnormativuniq = idr;


         IS_SHOW = 1;
/*         if ( (checknode is null) and ( ALLREC = 0 ) ) then
         begin
            atype = -atype;
            IS_SHOW = 0;
         end

         suspend;
          */


   IF ( cur_projecttype <> 1 )
   THEN
   BEGIN

--    if ( (checknode is null) and ( ALLREC = 0 ) ) then
--    begin
--     atype = -atype;
--     IS_SHOW = 0;
--    end
    IF (checknode IS NULL) THEN
    BEGIN
     atype = -atype;
     IF ( ALLREC = 0 ) THEN
        IS_SHOW = 0;
    END

    IF ( sender <> 1 OR atype > 0 )
    THEN SUSPEND;

   END
   ELSE IF ( sender = 1 )
        THEN SUSPEND;


      END
      ELSE /* smetn. str.  */
      BEGIN

/* id = idlevel; */

   IF (IS_SHOW > 0) THEN
   BEGIN
    FOR SELECT s.id, s.idhier, s.smetatype, /*s.number1, number2, number3, s.slaveparent,*/ s.atype,
               s.rabmat, s.TYPE_TRUD, s.tab, s.alttab,
               s.name_id, s.id_edizm, /*[12928]s.edizm_type,*/ s.koll, s.skoll, s.normarash,
               s.ba, s.bb, s.bc, s.bd, s.be, s.bf, s.bg, s.bh, s.bi, s.bj,
              --CQ[9359] s.sea,s.seb,s.sec,s.sed,s.see,s.sef,s.seg,s.seh,s.sei, s.sej, s.sek,
               s.ea, s.eb, s.ec, s.ed, s.ee, s.ef, s.eg, s.eh, s.ei, s.ej, s.ek,
               --CQ[9359]s.sra,s.srb,s.src,s.srd,s.sre,s.srf,s.srg,s.srh,s.sri,s.srj,s.srk,s.srl,s.srm,
               s.ra, s.rb, s.rc, s.rd, s.re, s.rf, s.rg, s.rh, s.ri, s.rj, s.rk, s.rl, s.rm,
               s.pa, s.pb, s.pc, s.pd, s.pe, s.vrpz, s.idtipr,
               s.ka, s.kb, s.kc, s.kd, s.ke, s.kf, s.kg, s.kh, s.ki, s.kj, s.kk, s.KL, s.KM,
               s.punktind, s.ma, s.mb, s.mc, s.md, s.me, s.mf, s.mg, s.mh, s.mi, s.mj, s.mk, s.ml,
               s.sstch, s.kodzak, s.kodgp, s.kodsp, s.kodisp, s.nach,
               s.okonch, s.tiprab, s.vidrab, s.IDNORMATIV, /*coalesce(i.idprice, 0)*/s.IDNORMATIVUNIQ,
               s.KODIR_GROUP, s.KODIR_PODGROUP, s.ISGROUPOKP, s.ARPS_OTHER,
               s.id_s_res, s.pr_added_rec, s.NORM_GUID, s.UTV, s.ASUBTYPE,
               s.IDFORMULS, --CQ[9359]
               -- MK:  -      (. [B70C259C] )
               -- MK 31.03.2016   CQ[14357]     ()
               v.number1, v.number2, v.number3/*MK CQ[12020]*/, s.K_ITOGO/*14460*/, s.K_PR, /*15421*/
               s.B_PR --[15352]
        FROM a_smeta s

        -- MK:  -      (. [B70C259C] )
        -- MK 31.03.2016   CQ[14357]     ()
        left outer join A_SMETA_VIEW_NUM v on s.id = v.id -- MK CQ[12020]

        --left outer join smeta_pricepos_info i on i.id = s.id -- CQ[6884]
        WHERE (s.ID = :id)
        ORDER BY s.number1, s.number2, s.number3
        INTO :id, :idhier, :smetatype, /*:number1, number2, number3, :slaveparent,*/ :atype,
             :rabmat, :TYPE_TRUD, :tab, :alttab,
             :name_id, :id_edizm, /*[12928]:edizm_type,*/ :koll, :skoll, :normarash,
             :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi, :bj,
             --CQ[9359]:sea,:seb,:sec,:sed,:see,:sef,:seg,:seh,:sei,:sej, :sek,
             :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
             --CQ[9359]:sra,:srb,:src,:srd,:sre,:srf,:srg,:srh,:sri,:srj,:srk,:srl,:srm,
             :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
             :pa, :pb, :pc, :pd, :pe, :vrpz, :idtipr,
             :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM, 
             :punktind, :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :mj, :mk, :ml,
             :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
             :okonch, :tiprab, :vidrab, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :ARPS_OTHER,
             :id_s_res, :pr_added_rec, :NORM_GUID, :UTV, :ASUBTYPE,
             :IDFORMULS, --CQ[9359]
             -- MK:  -      (. [B70C259C] )
             -- MK 31.03.2016   CQ[14357]     ()
             :view_number1, :view_number2, :view_number3/*MK CQ[12020]*/, :K_ITOGO/*14460*/, :K_PR, /*15421*/
             :B_PR --[15352]
    DO
    BEGIN
      EDIZM_TYPE = 0; --<<[12928]

      -- MK CQ[12020]
      ADDED_SMETATYPE = :smetatype;

      --<[15004]>
      if (:ADDED_SMETATYPE <> 15/*PSType*/) then
      begin
        view_number1 = null;
        view_number2 = null;
        view_number3 = null;
      end --</>

      -- MK 31.08.2009 CQ[7362]
      VN_PR_ADDED_REC = :PR_ADDED_REC;

      -- MK 20.10.2010 CQ[8684]
      IsIncludeRec = 0;


      -- MK 22.05.2012 CQ[9460] --->
      STRUCT_SHIFR = null; --    
      if ((idnormativ is not null) and (idnormativ > 0)) then
        select first 1 rm.ident_kod_mat_sap
        from b_rabmat rm
        where (rm.id = :idnormativ) and (rm.rabmat = 3) --   
        into :STRUCT_SHIFR;
      -- MK 22.05.2012 CQ[9460] <---


       /*       */

       /*               */
       /*    id     ->      */

       ish_id = id;
       new_id = id;

       -- Voyager CQ[8457] (        )
       --FOR SELECT NUMBER FROM A_O_HIER_SELECT_PR ( :IDUSER , :IDOBJECT , 0 , 0 )
       FOR SELECT NUMBER FROM A_O_HIER_SELECT_PR1_WITH_FILTER ( :IDUSER , :IDOBJECT , 0 , 0 , 0, 0, :INCLUDEACTSMODE)
       -- <-- CQ[8457]
           INTO H_SMETATYPE
       DO
          FOR SELECT s.id,
                 s.atype, s.rabmat, s.TYPE_TRUD, s.tab, s.alttab,
                 s.name_id, s.id_edizm, /*[12928]s.edizm_type,*/
                 -- s.koll, s.skoll,
                 s.normarash,
                 s.ba, s.bb, s.bc, s.bd, s.be, s.bf, s.bg, s.bh, s.bi, s.bj,
                 --CQ[9359]s.sea,s.seb,s.sec,s.sed,s.see,s.sef,s.seg,s.seh,s.sei,s.sej, s.sek,
                 s.ea, s.eb, s.ec, s.ed, s.ee, s.ef, s.eg, s.eh, s.ei, s.ej, s.ek,
                 --CQ[9359]s.sra,s.srb,s.src,s.srd,s.sre,s.srf,s.srg,s.srh,s.sri,s.srj,s.srk,s.srl,s.srm,
                 s.ra, s.rb, s.rc, s.rd, s.re, s.rf, s.rg, s.rh, s.ri, s.rj, s.rk, s.rl, s.rm,
                 s.pa, s.pb, s.pc, s.pd, s.pe, s.vrpz, s.idtipr,
                 s.ka, s.kb, s.kc, s.kd, s.ke, s.kf, s.kg, s.kh, s.ki, s.kj, s.kk, s.KL, s.KM,
                 s.punktind, s.ma, s.mb, s.mc, s.md, s.me, s.mf, s.mg, s.mh, s.mi, s.mj, s.mk, s.ml,
                 s.sstch, s.kodzak, s.kodgp, s.kodsp, s.kodisp, s.nach,
                 s.okonch, s.tiprab, s.vidrab, s.IDNORMATIV, /*coalesce(i.idprice, 0)*/s.IDNORMATIVUNIQ,
                 s.KODIR_GROUP, s.KODIR_PODGROUP, s.ISGROUPOKP, s.ARPS_OTHER,
                 s.id_s_res, s.pr_added_rec, s.NORM_GUID, s.UTV, s.ASUBTYPE,
                 s.IDFORMULS/*CQ[9359]*/, s.K_ITOGO/*14460*/, s.K_PR, /*15421*/
                 s.B_PR --[15352]
              FROM a_smeta s
              --left outer join smeta_pricepos_info i on i.id = s.id -- CQ[6884]
              WHERE s.NOMERROD1 = :ID AND s.SMETATYPE = :H_SMETATYPE
              INTO :new_id,
                :atype, :rabmat, :TYPE_TRUD, :tab, :alttab,
                :name_id, :id_edizm, /*[12928]:edizm_type,*/
                -- :koll, :skoll,
                :normarash,
                :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi, :bj,
                --CQ[9359]:sea,:seb,:sec,:sed,:see,:sef,:seg,:seh,:sei,:sej,:sek,
                :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
                --CQ[9359]:sra,:srb,:src,:srd,:sre,:srf,:srg,:srh,:sri,:srj,:srk,:srl,:srm,
                :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
                :pa, :pb, :pc, :pd, :pe, :vrpz, :idtipr,
                :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM,
                :punktind, :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :mj, :mk, :ml,
                :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
                :okonch, :tiprab, :vidrab, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :ARPS_OTHER,
                :id_s_res, :pr_added_rec, :NORM_GUID, :UTV, :ASUBTYPE,
                :IDFORMULS/*CQ[9359]*/, :K_ITOGO/*14460*/, :K_PR, /*15421*/
                :B_PR --[15352]
          DO
     -- MK 20.10.2010 CQ[8684] --->
          begin
             EDIZM_TYPE = 0; --<<[12928]
             if (:smetatype = :H_SMETATYPE) then
               IsIncludeRec = 1;

             --atype = atype;
          end

     --     
     if (:smetatype = 15) then
        IsIncludeRec = 1;
     -- MK 20.10.2010 CQ[8684] <---

     -- MK 2.09.2010  (    )
     -- CQ[TIMUR 10737] . ..     ID  .
     --                   .  L_SC_READ_ONE_HIER_NL
     id = new_id;
     -- CQ[TIMUR 10737]


     -- rvs:   A_CLC_PREPARE_B_E
     --calk_ba = 0; calk_bb = 0; calk_bc = 0; calk_bd = 0; calk_be = 0;
     --
     --execute procedure a_clc_prepare_b( :iduser, :id, :atype, :id_s_res, :ba, :bb, :bc, :bd, :be )
     --        returning_values( :ba, :bb, :bc, :bd, :be,
     --                          :calk_ba, :calk_bb, :calk_bc, :calk_bd, :calk_be );

     /*  CQ[9288] -    CQ[9308]
     SELECT BA, BB, BC, BD, BE, BG, BH,
            CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE,
            CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY
       FROM A_CLC_PREPARE_B_E_M(
         :ID, :ATYPE, :ID_S_RES, :PARAM_KODIR_GROUP, :PARAM_KODIR_PODGROUP, :ISCLC, :MODE_KOMPNS_ST,
         :BA, :BB, :BC, :BD, :BE, :BG, :BH, NULL)
       INTO :BA, :BB, :BC, :BD, :BE, :BG, :BH,
            :CALK_BA, :CALK_BB, :CALK_BC, :CALK_BD, :CALK_BE,
            :CALK_BG, :CALK_BG_READONLY, :CALK_BH, :CALK_BH_READONLY;  */


     EXECUTE PROCEDURE b_getname( :iduser, :name_id ) RETURNING_VALUES ( :name );
     -- MK 9.09.2010 CQ[8691] --->
     FULL_STRUCT_NAME = null;
     /* if (:name is not null) then
     begin
       if (LCKGETBLOBLENGTH(:name) <= 255) then
         FULL_STRUCT_NAME = S_SUBSTRING255(:name, 1, 255);
     end*/
     -- MK 9.09.2010 CQ[8691] <---

     EXECUTE PROCEDURE a_get_edizm( :iduser, :id_edizm, :edizm_type ) RETURNING_VALUES ( :edizm );

     -- MK CQ[12020] --->
     --      [B70C259C]
     -- MK 31.03.2016   CQ[14357]    
     -- (,   view_number . )
     --view_number1 = NUMBER1;
     --view_number2 = NUMBER2;
     --view_number3 = NUMBER3;
     -- MK CQ[12020] <---

     PR_NUMBER1 = NUMBER1; PR_NUMBER2 = NUMBER2; PR_NUMBER3 = NUMBER3;
     PR_VSEGO   = KOLL/*0.0*/;
     PR_VIPOLNENO = 0.0;
--     if ( not smetatype in ( 15 , 16 ) ) then
--     if ( smetatype <> 15 ) then
     BEGIN
        IF ( EXISTS ( SELECT id FROM l_s_pr_addinfo WHERE id = :ish_id ) ) THEN
        BEGIN
           EXECUTE PROCEDURE l_pr_select_rec ( :ish_id, :iduser, :IDOBJECT, 0, 0, 0, 0)
              RETURNING_VALUES ( :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, PR_VSEGO, PR_VIPOLNENO, :PR_EXISTS_CHILDS );
/*
           if ( ( not koll is null ) and ( koll <> 0 ) ) then
           begin
              v_koef = PR_VSEGO / KOLL;
              RA = RA * v_koef;
              RB = RB * v_koef;
              RC = RC * v_koef;
              RD = RD * v_koef;
              RE = RE * v_koef;
              RF = RF * v_koef;
              RG = RG * v_koef;
              RH = RH * v_koef;
              RI = RI * v_koef;
              RG = RJ * v_koef;
              RK = RK * v_koef;
           end
           KOLL = PR_VSEGO;
*/
        END
     END
     NUMBER1 = PR_NUMBER1;
     NUMBER2 = PR_NUMBER2;
     NUMBER3 = PR_NUMBER3;


     PR_VIPOLNENO = 0;

     SELECT FIRST 1 KOLL, RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM
     -- Voyager CQ[8457]
     --FROM L_PR_SELECT_REC_VERSIONS_ITOGI ( :ish_id , :IDUSER , :IDOBJECT , 0 , 0 , 0 , 1 )
     FROM V_PR_SELECT_REC_VERSIONS_ITOGI ( :ish_id , :IDUSER , :IDOBJECT , 0 , 0 , 0 , 1, :INCLUDEACTSMODE)
     -- <-- CQ[8457]
     INTO PR_VIPOLNENO , RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM;

     KOLL = PR_VIPOLNENO;

     SKOLL = NULL;

     STATUS_REC_CEN = NULL;
     IDREESTR = NULL;

     -- rvs:   A_CLC_PREPARE_B_E
     --calk_bg          = 0;
     --calk_bg_readonly = 0;
     --calk_bh          = 0;
     --calk_bh_readonly = 0;
     --
     --if ( atype = 17 )
     --then execute procedure a_s_get_trud_str_mash( :iduser,
     --                                              :id,
     --                                              :param_kodir_group,
     --                                              :param_kodir_podgroup,
     --                                              :bg,
     --                                              :bh )
     --     returning_values( :bg,
     --                       :bh,
     --                       :calk_bg,
     --                       :calk_bg_readonly,
     --                       :calk_bh,
     --                       :calk_bh_readonly );


     -- MK 31.08.2009 CQ[7362] --->
     --  :     
     if ((DopAndHightKoll = 0) or
         ((VN_PR_ADDED_REC = 1) or                            -- . 
          (LRoundN(:PR_VIPOLNENO, 6) > LRoundN(:PR_VSEGO, 6)) --  
         )
        )  then
     -- MK 31.08.2009 CQ[7362] <---

        if (:IsIncludeRec = 1) then -- MK 20.10.2010 CQ[8684]
          SUSPEND;

    END



   END

  END

  EXECUTE PROCEDURE l_pr_create_kc6_base_finalize ( :key2 );
END
^

--[15352]
CREATE OR ALTER PROCEDURE L_SELECT_HIER_CORRECTIONS (
    IDHIER INTEGER,
    ID_USER INTEGER)
RETURNS (
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
declare variable ATYPE integer;
begin
 --[15352]+
  ATYPE = null;

  select first 1 ATYPE from A_O_HIER where NUMBER = :IDHIER into :ATYPE;

  if ( not ATYPE is null ) then
     if ( ATYPE = 3 ) then
        for select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                   K_ITOGO, K_PR
          from A_O_PARAMS_LS
          where ID = :IDHIER
        into KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
             :K_ITOGO /*CQ[14462]*/, :K_PR /*CQ[15421]*/
        do
           suspend;
     else if ( ATYPE in (4,5) ) then
        for select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                   K_ITOGO, K_PR
          from A_O_PARAMS_R_PR
          where ID = :IDHIER
        into KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
             :K_ITOGO /*CQ[14462]*/, :K_PR /*CQ[15421]*/
        do
           suspend;
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE M_ADD_REC_TO_MERGED_AKT_NL (
*/
--[15352]
CREATE OR ALTER PROCEDURE M_AFTER_IMP_DOP_RAB_FROM_XML (
    ID_USER INTEGER,
    ID INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER,
    ATYPE INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    SLAVEPARENT INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    IDNORMATIV INTEGER,
    ID_EDIZM INTEGER,
    ID_NAME INTEGER,
    VRPZ INTEGER,
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    NORM_GUID VARCHAR(100),
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    VIDRAB INTEGER,
    UTV INTEGER,
    CLCMODE INTEGER,
    TYPE_TRUD INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ID_S_RES INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    K_ITOGO VARCHAR(50),
    B_PR DOUBLE PRECISION,
    K_PR VARCHAR(50))
AS
declare variable S_ORDERVIEW integer;
declare variable VN_SMETATYPE integer;
declare variable VN_ID integer;
declare variable VN_NUMBER1 integer;
declare variable VN_NUMBER2 integer;
declare variable NEW_ID integer;
declare variable VN_SLAVEPARENT integer;
declare variable VN_ID_S_RES integer;
declare variable VN_TMP integer;
begin
--[15352]+

-- todo: BA,....
  --  ,  
  select ORDERVIEW
  from SD_IMPACT_SELECTSTRUCT_GETFIRST(:ID_USER, :IDHIER, :SMETATYPE)
  into :S_ORDERVIEW;

  if (:S_ORDERVIEW > 0) then
  begin
    for select i.SMETATYPE
    from SD_IMPACT_SELECTSTRUCT(:ID_USER, :IDHIER) i
    where (i.ORDERVIEW >= :S_ORDERVIEW) and (i.SMETATYPE <> :SMETATYPE)
    into :VN_SMETATYPE do
    begin
      execute procedure M_GET_IDREC_TO_STRUCT(:IDHIER, :VN_SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3)
      returning_values (:VN_ID);

      --       -   
      if (VN_ID <> -1) then
      begin
        update a_smeta s
        set s.pr_added_rec = 0,
            s.nomerrod = :ID,
            s.nomerrod1 = :ID
        where (s.id = :VN_ID);
      end

      --    -  
      else
      begin
        --  , 
        if (not exists(
              select * from M_UTV_STRUCT_ELEM_IN_AKT
                where (ID_STRUCT = :IDHIER) and (ID_AKT = :VN_SMETATYPE))) then
        begin
          --   SLAVEPARENT
          VN_SLAVEPARENT = null;
          if (ATYPE = 18) then
          begin
             VN_TMP = null;
             select first 1 s.slaveparent
             from a_smeta s
             where (s.id = :ID)
             into :VN_TMP;

             if (VN_TMP is not null) then
             begin
               select first 1 s.id
               from a_smeta s
               where (s.nomerrod = :VN_TMP) and (s.smetatype = :VN_SMETATYPE)
               into :VN_SLAVEPARENT;
             end
          end

          --   ID_S_RES
          VN_ID_S_RES = null;
          if (ATYPE = 18) then
          begin
             select first 1 r.id
             from a_s_res r
             where (r.nomerrod = :ID_S_RES) and (r.smetatype = :VN_SMETATYPE)
             into :VN_ID_S_RES;
          end


          NEW_ID = gen_id( a_g_smeta, 1);

          --   Number
          select NUMBER1, NUMBER2
          from S_GET_NEW_NUMBERS(:ID_USER, :SLAVEPARENT, :IDHIER, :VN_SMETATYPE, :ATYPE,
                                 :NUMBER1, :NUMBER2, :ID)
          into :VN_NUMBER1, :VN_NUMBER2;

          VN_NUMBER1 = coalesce(VN_NUMBER1, 0);
          VN_NUMBER2 = coalesce(VN_NUMBER2, 0);

          --      
          KOLL = 0;
          SKOLL = null;

          --      
          insert into a_smeta (ID, IDHIER, SMETATYPE, ATYPE, NUMBER1, NUMBER2, NUMBER3,
                               SLAVEPARENT, RABMAT, TAB, ALTTAB, KOLL, SKOLL, NORMARASH,
                               VRPZ, NACH, OKONCH, TIPRAB, IDNORMATIV, ISGROUPOKP,
                               VIDRAB, UTV, CLCMODE, TYPE_TRUD, NORM_GUID, NOMERROD, NOMERROD1,
                               KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                               CORRECTNODE, CORRECTNODE_1, PR_ADDED_REC, ID_S_RES,
                               NAME_ID, KODIR_GROUP, KODIR_PODGROUP, ID_EDIZM,
                               BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BN, BO, B_ITOGO, -- <-- Voyager CQ[13244]
                               B_PR, --[15352]
                               K_ITOGO/*14460*/, K_PR/*15421*/)
          values (:NEW_ID, :IDHIER, :VN_SMETATYPE, :ATYPE, :VN_NUMBER1, :VN_NUMBER2, :NUMBER3,
                  :VN_SLAVEPARENT, :RABMAT, :TAB, :ALTTAB, :KOLL, :SKOLL, :NORMARASH,
                  :VRPZ, :NACH, :OKONCH, :TIPRAB, :IDNORMATIV, :ISGROUPOKP,
                  :VIDRAB, :UTV, :CLCMODE, :TYPE_TRUD, :NORM_GUID, :ID, :ID,
                  :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
                  :CORRECTNODE, :CORRECTNODE_1, 0, :VN_ID_S_RES,
                  :ID_NAME, :KODIR_GROUP, :KODIR_PODGROUP, :ID_EDIZM,
                  :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO, -- <-- Voyager CQ[13244]
                  :B_PR, --[15352]
                  :K_ITOGO/*14460*/, :K_PR/*15421*/);

          -- MK CQ[14357] --->
          --       XML   
          -- "    " 
          --       
          --       A_S_APPENDREC_NL 
          --    
          execute procedure m_set_view_nums_after_ins(:NEW_ID, :IDHIER, :VN_SMETATYPE,
                                                      :ATYPE, :VN_SLAVEPARENT,
                                                      :VN_NUMBER1, :VN_NUMBER2, :NUMBER3);

          ---- MK CQ[12020] --->
          --update a_smeta_view_num v
          --set v.NUMBER1 = :VN_NUMBER1,
          --    v.NUMBER2 = :VN_NUMBER2,
          --    v.NUMBER3 = :NUMBER3
          --where (v.id = :NEW_ID);
          -- MK CQ[12020] <---
          -- MK CQ[14357] <---

          --        
          --        
          if (ATYPE <> 19) then
            execute procedure M_SET_SM_REC_ENTITYS(:ID_USER, :NEW_ID);
        end
      end
    end
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE M_CORRECTION_STRUCT_IMP_XML (
    ID INTEGER,
    ATYPE INTEGER,
    REPLACECORRECTION INTEGER,
    CORRECTIONRULE INTEGER,
    SPREADONEXISTSREC INTEGER,
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80)
AS
begin
--[15352]+
  --   ----------------------------------------------------------------
  if (ATYPE = 1) then
  begin
    update CORRECTIONS
    set KA = :KA,
        KB = :KB,
        KC = :KC,
        KD = :KD,
        KE = :KE,
        KF = :KF,
        KG = :KG,
        KH = :KH,
        KI = :KI,
        KJ = :KJ,
        KK = :KK,
        KL = :KL,
        KM = :KM,
        K_ITOGO = :K_ITOGO, -- CQ[14462]
        K_PR = :K_PR, --[15421]
        CORRECTNODE = :CORRECTNODE,
        CORRECTNODE_1 = :CORRECTNODE_1
    where (ID = :ID);

    update A_O_OBJECTPARAMS
    set REPLACECORRECTION = :REPLACECORRECTION,
        CORRECTIONRULE = :CORRECTIONRULE
    where (NUMBER = :ID);
  end

  --   ---------------------------------------------------------------------
  else if (ATYPE = 3) then
  begin
    update A_O_PARAMS_LS
    set KA = :KA,
        KB = :KB,
        KC = :KC,
        KD = :KD,
        KE = :KE,
        KF = :KF,
        KG = :KG,
        KH = :KH,
        KI = :KI,
        KJ = :KJ,
        KK = :KK,
        KL = :KL,
        KM = :KM,
        K_ITOGO = :K_ITOGO, -- CQ[14462]
        K_PR = :K_PR, --[15421]
        CORRECTNODE = :CORRECTNODE,
        CORRECTNODE_1 = :CORRECTNODE_1,
        REPLACECORRECTION = :REPLACECORRECTION,
        CORRECTIONRULE = :CORRECTIONRULE,
        SPREADONEXISTSREC = :SPREADONEXISTSREC
    where (ID = :ID);
  end

  --  ,  ------------------------------------------------------------------
  else if (ATYPE in (4, 5)) then
  begin
    update A_O_PARAMS_R_PR
    set KA = :KA,
        KB = :KB,
        KC = :KC,
        KD = :KD,
        KE = :KE,
        KF = :KF,
        KG = :KG,
        KH = :KH,
        KI = :KI,
        KJ = :KJ,
        KK = :KK,
        KL = :KL,
        KM = :KM,
        K_ITOGO = :K_ITOGO, -- CQ[14462]
        K_PR = :K_PR, --[15421]
        CORRECTNODE = :CORRECTNODE,
        CORRECTNODE_1 = :CORRECTNODE_1,
        REPLACECORRECTION = :REPLACECORRECTION,
        CORRECTIONRULE = :CORRECTIONRULE,
        SPREADONEXISTSREC = :SPREADONEXISTSREC
    where (ID = :ID);
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE M_ET_RES_APPEND_NL (
    IDUSER INTEGER,
    ID INTEGER,
    ID_SOURCE INTEGER,
    NORM_ID INTEGER,
    NORM_PODGROUP INTEGER,
    KODIR_GROUP INTEGER,
    KODIR_PODGROUP INTEGER,
    ISGROUPOKP INTEGER,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    ALTTAB VARCHAR(250),
    NAME_ID INTEGER,
    IDEDIZM INTEGER,
    EDIZM_TYPE INTEGER,
    RASHOD DOUBLE PRECISION,
    RASHOD_BASE DOUBLE PRECISION,
    CORRECT VARCHAR(50),
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    VIDNR INTEGER,
    UCH INTEGER,
    STATUS_EDIT INTEGER,
    STATUS_DOB_V_ZENU INTEGER,
    STATUS_REC_CEN INTEGER,
    NOTE VARCHAR(255),
    NOMERROD INTEGER,
    NORM_GUID VARCHAR(100),
    TYPE_TRUD INTEGER,
    ET_NORM_ID INTEGER,
    ET_NORM_PODGROUP INTEGER,
    ET_KODIR_GROUP INTEGER,
    ET_KODIR_PODGROUP INTEGER,
    ET_ISGROUPOKP INTEGER,
    ET_RABMAT INTEGER,
    ET_TAB VARCHAR(42),
    ET_ALTTAB VARCHAR(250),
    ET_NAME_ID INTEGER,
    ET_IDEDIZM INTEGER,
    ET_EDIZM_TYPE INTEGER,
    ET_RASHOD DOUBLE PRECISION,
    ET_BB DOUBLE PRECISION,
    ET_BC DOUBLE PRECISION,
    ET_BD DOUBLE PRECISION,
    ET_BE DOUBLE PRECISION,
    ET_VIDNR INTEGER,
    ET_UCH INTEGER,
    ET_NORM_GUID VARCHAR(100),
    ET_TYPE_TRUD INTEGER,
    SENDER INTEGER,
    MODE INTEGER,
    VRPZ INTEGER,
    NEEDUPDCOST INTEGER,
    PASTE_AS_IS INTEGER)
AS
declare variable smetatype integer;
declare variable idhier integer;
declare variable s_skip_append_vip integer;
declare variable s_orderview integer;
declare variable s_nomerrod integer;
--CQ[9273]>>
declare variable TYPE_RAB integer;
declare variable VID_RAB integer;
declare variable IDOBJECT integer;
declare variable ID_LEVEL integer;
declare variable TEMPFLOAT double precision;
declare variable PUNKTIND varchar(42);
declare variable TEMPINT integer;

declare variable NL_IDZONE integer;
declare variable NL_ID_LEVEL_VC integer;
declare variable NL_BB double precision;
declare variable NL_BC double precision;
declare variable NL_BD double precision;
declare variable NL_BE double precision;
declare variable NL_BASE_INFO integer;

declare variable NL_ET_IDZONE integer;
declare variable NL_ET_ID_LEVEL_VC integer;
declare variable NL_ET_BB double precision;
declare variable NL_ET_BC double precision;
declare variable NL_ET_BD double precision;
declare variable NL_ET_BE double precision;
declare variable NL_ET_BASE_INFO integer;

declare variable VN_IDSTRUCT integer;

declare variable NEED_APPLY_INDEX integer;

begin
--[15352]

/*
     A_S_RES_APPEND
   (     )
*/

/*
   sender -   . :

          0 -  A_S_PASTE_SMETA_RECORD
          1 -       smeta.ru
                    NORM_GUID ,   NORM_ID   NORM_GUID  TAB.
          2 -


--------------------------------------------------------------------------------
   mode -   . :

          0 -     
          1 -    
          2 -    

   NEEDUPDCOST -      . 0 - (   Ctrl+Enter     ) 1 - 
*/



  NEED_APPLY_INDEX = 1;--CQ[10929] :  = 1,    

  NEEDUPDCOST = coalesce(:NEEDUPDCOST, 1);

/*      */
  if (:NOMERROD = 0) then
    NOMERROD = null;
  else
  if (:NOMERROD = -1) then
  begin
    S_SKIP_APPEND_VIP = -1;
    NOMERROD = null;
  end


 SMETATYPE = null;

 /*       */
 select first 1 s.smetatype, s.idhier, s.NOMERROD
 from a_smeta s
 where s.id = :id_source
 into :SMETATYPE, :IDHIER, :S_NOMERROD;

 /*      -    */
 if (SMETATYPE is null) then
 begin
    exception A_SMRECNOTFOUD;
    exit;
 end

 /*       smeta.ru */
 if (( sender = 1 ) and  (NORM_ID <> 0))   then   --:     GUID   
 begin
    if (:mode <> 2) then
       execute procedure L_GET_NORMATIV_FROM_GUID (:NORM_GUID, :TAB, :NORM_ID,
                                                   :NORM_PODGROUP, :RABMAT, :IDUSER )
       returning_values ( :NORM_ID, :NORM_PODGROUP, :RABMAT );

    if (:mode <> 1) then
       execute procedure L_GET_NORMATIV_FROM_GUID (:ET_NORM_GUID, :ET_TAB, :ET_NORM_ID,
                                                   :ET_NORM_PODGROUP, :ET_RABMAT, :IDUSER )
       returning_values ( :ET_NORM_ID, :ET_NORM_PODGROUP, :ET_RABMAT );
 end

 /*    */
 if (:mode <> 2) then
    insert into a_s_res (ID, ID_SOURCE, NORM_ID, NORM_PODGROUP, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, RABMAT,
                         TAB, ALTTAB, NAME_ID, IDEDIZM, EDIZM_TYPE, RASHOD, RASHOD_BASE, CORRECT, BB, BC, BD, BE,
                         VIDNR, UCH, STATUS_EDIT, STATUS_DOB_V_ZENU, STATUS_REC_CEN, NOTE, NORM_GUID, TYPE_TRUD,
                         SMETATYPE, IDHIER,
                         NOMERROD --CQ [6884] , ID_PRICE
                         )
    values (:ID, :ID_SOURCE, :NORM_ID, :NORM_PODGROUP, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :RABMAT,
            :TAB, :ALTTAB, :NAME_ID, :IDEDIZM, :EDIZM_TYPE, :RASHOD, :RASHOD_BASE, :CORRECT, :BB, :BC, :BD, :BE,
            :VIDNR, :UCH, :STATUS_EDIT, :STATUS_DOB_V_ZENU, :STATUS_REC_CEN, :NOTE, :norm_guid, :TYPE_TRUD,
            :SMETATYPE, :IDHIER, :NOMERROD --CQ [6884] , :ID_PRICE
            );

 /*    */
 if (:mode <> 1) then
    insert into m_etalon_s_res(id, id_source, norm_id, norm_podgroup, kodir_group,
                               kodir_podgroup, isgroupokp, rabmat, tab, alttab,
                               name_id, idedizm, edizm_type, rashod,
                               bb, bc, bd, be, vidnr, uch,
                               norm_guid, type_trud)
    values (:id, :id_source, :et_norm_id, :et_norm_podgroup, :et_kodir_group,
            :et_kodir_podgroup, :et_isgroupokp, :et_rabmat, :et_tab, :et_alttab,
            :et_name_id, :et_idedizm, :et_edizm_type, :et_rashod,
            :et_bb, :et_bc, :et_bd, :et_be, :et_vidnr, :et_uch,
            :et_norm_guid, :et_type_trud);

  --CQ[9273] -->    
  -- 
  execute procedure nl_get_res_type_vid_rab(:idhier, :id_source,  :SMETATYPE, :VRPZ)
    returning_values (:TYPE_RAB, :VID_RAB);
  execute procedure A_H_GET_ID_PARENTATYPE(:idhier, 1)
    returning_values (:IDOBJECT);

  -- MK 26.08.2011 CQ[9435] --->
  if (SMETATYPE = 15) then
    VN_IDSTRUCT = :IDOBJECT;
  else
    VN_IDSTRUCT = :SMETATYPE;
  -- MK 26.08.2011 CQ[9435] <---

  --        
  if ((:mode <> 2) and (:NEEDUPDCOST = 1))  then
  begin
    for select l.id
    from level_cost l
    where (l.idobject = :VN_IDSTRUCT /* CQ[9435] :IDOBJECT*/)
    --[AA5DC71D18EC]order by l.lorder
    into :ID_LEVEL do
    begin

      if (PASTE_AS_IS = 1) then
      begin
      --CQ[9298] -->
        execute procedure A_S_RES_UPDATE_CEN_NL (:IDUSER, :ID, :BB, :BC, :BD, :BE,
                                                 0, :ID_LEVEL, 0, 0, 0);
      --CQ[9298] <--
      end
      else
      begin
        execute procedure NL_GET_CENLVL_NEW (:ID_LEVEL,--CQ[10929]NL_GET_CENLVL (:ID_LEVEL,
                                         case when :SMETATYPE > 999 then :SMETATYPE else :IDOBJECT end,
                                         :IDUSER, :TYPE_RAB,
                                         :VID_RAB, 0/**/, :RABMAT, :IDHIER,
                                         :NORM_ID, :NORM_PODGROUP/*[11537.4]KODIR_PODGROUP*/, '',
                                         0/*IDZONE*/, 0/*BA*/, :BB, :BC, :BD, :BE,
                                         null, --[15352]
                                         :ID_SOURCE,
                                         :NEED_APPLY_INDEX)--CQ[10929]
        returning_values (:NL_ID_LEVEL_VC, :NL_IDZONE, :TEMPINT, :TEMPINT,
                          :TEMPFLOAT, :NL_BB, :NL_BC, :NL_BD, :NL_BE,
                          :TEMPFLOAT, --[15352]
                          :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
                          :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
                          :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
                          :TEMPFLOAT, --[15352]
                          :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,--CQ[10529]
                          :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,--CQ[10529]
                          :PUNKTIND,
                          :TEMPINT, :NL_BASE_INFO, :TEMPINT );
        --    
        execute procedure A_S_RES_UPDATE_CEN_NL (:IDUSER, :ID, :NL_BB, :NL_BC, :NL_BD, :NL_BE,
                                                 0, :ID_LEVEL, :NL_IDZONE, :NL_ID_LEVEL_VC, :NL_BASE_INFO);
      end
    end

  end
  --        
  if (:mode <> 1) then
  begin
    for select l.id
    from level_cost l
    where (l.idobject = :VN_IDSTRUCT /* CQ[9435] :IDOBJECT*/)
    order by l.lorder
    into :ID_LEVEL do
    begin
      if (PASTE_AS_IS = 1) then
      begin
      --CQ[9298] -->
        execute procedure A_S_ETALON_INS_OR_UPD_CENLVL (:IDUSER, :ID, :ET_BB, :ET_BC, :ET_BD, :ET_BE,
                                                 :ID_LEVEL, 0, 0, 0);
      --CQ[9298] <--
      end
      else
      begin
        execute procedure NL_GET_CENLVL_NEW (:ID_LEVEL,--CQ[10929]NL_GET_CENLVL (:ID_LEVEL,
                                         case when :SMETATYPE > 999 then :SMETATYPE else :IDOBJECT end,
                                         :IDUSER, :TYPE_RAB,
                                         :VID_RAB, 0/**/, :ET_RABMAT, :IDHIER,
                                         :ET_NORM_ID, :ET_NORM_PODGROUP/*[11537.4]ET_KODIR_PODGROUP*/, '',
                                         0/*IDZONE*/, 0/*BA*/, :ET_BB, :ET_BC, :ET_BD, :ET_BE,
                                         null, --[15352]
                                         0, --CQ[11104] .. ATYPE = 0   ID_SM_REC  :ID_SOURCE,
                                         :NEED_APPLY_INDEX)--CQ[10929]
        returning_values (:NL_ET_ID_LEVEL_VC, :NL_ET_IDZONE, :TEMPINT, :TEMPINT,
                          :TEMPFLOAT, :NL_ET_BB, :NL_ET_BC, :NL_ET_BD, :NL_ET_BE,
                          :TEMPFLOAT, --[15352]
                          :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
                          :TEMPFLOAT, :TEMPFLOAT,
                          :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,
                          :TEMPFLOAT, --[15352]
                          :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,--CQ[10529]
                          :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT, :TEMPFLOAT,--CQ[10529]
                          :PUNKTIND,
                          :TEMPINT, :NL_ET_BASE_INFO, :TEMPINT);
        --    
        execute procedure A_S_ETALON_INS_OR_UPD_CENLVL (:IDUSER, :ID, :NL_ET_BB, :NL_ET_BC, :NL_ET_BD, :NL_ET_BE,
                                                  :ID_LEVEL, :NL_ET_IDZONE, :NL_ET_ID_LEVEL_VC, :NL_ET_BASE_INFO);
      end

    end

  end
  --CQ[9273] <--

  /*     */
  if (:NOMERROD is not null or :S_SKIP_APPEND_VIP <> 0) then
    exit;

  if (:S_NOMERROD is null or :S_NOMERROD = 0) then
    S_NOMERROD = :ID_SOURCE;

  if (not exists( select *
        from A_SMETA
        where NOMERROD1 = :S_NOMERROD
          and SMETATYPE <> :SMETATYPE )) then
    exit;

  /*   */
  select ORDERVIEW
    from SD_IMPACT_SELECTSTRUCT_GETFIRST(:IDUSER, :ID_SOURCE, :SMETATYPE)
    into :S_ORDERVIEW;

  if (:S_ORDERVIEW > 0) then
  begin
    for select i.SMETATYPE
      from SD_IMPACT_SELECTSTRUCT(:IDUSER, :ID_SOURCE) i
      where (i.ORDERVIEW >= :S_ORDERVIEW)
      into :SMETATYPE
    do
    if (not exists( /* , */
          select * from M_UTV_STRUCT_ELEM_IN_AKT
            where ID_STRUCT = :IDHIER and ID_AKT = :SMETATYPE)) then
    for select ID
      from A_SMETA
      where NOMERROD1 = :S_NOMERROD
        and SMETATYPE = :SMETATYPE
      into :ID_SOURCE
    do
    /* (!):     :IDSOURCE   */
    execute procedure m_et_res_append_nl(:iduser, gen_id(a_g_smeta, 1), :id_source, :norm_id,
                                      :norm_podgroup, :kodir_group, :kodir_podgroup,
                                      :isgroupokp, :rabmat, :tab, :alttab, :name_id,
                                      :idedizm, :edizm_type, :rashod, :rashod_base,
                                      :correct, :bb, :bc, :bd, :be, :vidnr, :uch,
                                      :status_edit, :status_dob_v_zenu, :status_rec_cen,
                                      :note, :id, :norm_guid, :type_trud, :et_norm_id,
                                      :et_norm_podgroup, :et_kodir_group, :et_kodir_podgroup,
                                      :et_isgroupokp, :et_rabmat, :et_tab, :et_alttab,
                                      :et_name_id, :et_idedizm, :et_edizm_type, :et_rashod,
                                      :et_bb, :et_bc, :et_bd,
                                      :et_be, :et_vidnr, :et_uch,
                                      :et_norm_guid, :et_type_trud, :sender, :mode, --CQ [6884] , :ID_PRICE ,
                                      :vrpz, :NEEDUPDCOST, :PASTE_AS_IS --CQ[9273]
                                      );
  end
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE M_EXP_SM_REC (
*/

--[15352]
CREATE OR ALTER PROCEDURE M_FB_SEARCH_NORMATIV (
    IN_PODGROUP INTEGER,
    IN_RABMAT INTEGER,
    ID_USER INTEGER,
    STAB VARCHAR(42),
    ID_PUT_RAB INTEGER,
    ID_PUT_MASH INTEGER,
    ID_PUT_MAT INTEGER,
    ID_ZONE INTEGER,
    FETCH_ALL_SEARCH INTEGER)
RETURNS (
    ID_SELF INTEGER,
    PODGROUP INTEGER,
    RABMAT INTEGER,
    ID_ABC_OKP INTEGER,
    BEDA1 INTEGER,
    BEDA2 INTEGER,
    BEDARAB INTEGER,
    BEDAMASH INTEGER,
    BEDAMAT INTEGER,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    IDNAME INTEGER,
    ID_UNIQUE INTEGER,
    TAB VARCHAR(42),
    TABU VARCHAR(42),
    ALTTAB VARCHAR(250),
    IDEDIZM INTEGER,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(255),
    COMMENT VARCHAR(42),
    RAZRAD DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    PE DOUBLE PRECISION,
    VRPZ INTEGER,
    NTR INTEGER,
    PUNKTIND VARCHAR(42),
    ISESN INTEGER,
    IDWITHESN INTEGER,
    CCURRENT_BA DOUBLE PRECISION,
    CCURRENT_BB DOUBLE PRECISION,
    CCURRENT_BC DOUBLE PRECISION,
    CCURRENT_BD DOUBLE PRECISION,
    CCURRENT_BE DOUBLE PRECISION,
    CCURRENT_ZONE INTEGER,
    IDQUALIFIER INTEGER,
    IDNORMTYPE INTEGER,
    NORM_GUID VARCHAR(100),
    IDREESTR INTEGER,
    ABC_OKP_NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ABC_OKP_RABMAT INTEGER,
    ABC_OKP_IDNAME INTEGER,
    ABC_OKP_ID_UNIQUE INTEGER,
    ABC_OKP_TAB VARCHAR(42),
    ABC_OKP_TABU VARCHAR(42),
    ABC_OKP_IDGROUP INTEGER,
    ABC_OKP_IDPODGROUP INTEGER,
    ABC_OKP_ISGROUPOKP INTEGER,
    ABC_OKP_IDEDIZM INTEGER,
    ABC_OKP_EDIZM_NAME VARCHAR(100),
    ABC_OKP_EDIZM_FULLNAME VARCHAR(255),
    ABC_OKP_CENA DOUBLE PRECISION,
    ABC_OKP_RAZRAD DOUBLE PRECISION,
    ABC_OKP_VIDNR INTEGER,
    ABC_OKP_COMMENT VARCHAR(42),
    ABC_OKP_PUNKTIND VARCHAR(42),
    ABC_OKP_VRPZ INTEGER,
    ABC_OKP_NTR INTEGER,
    ABC_OKP_CCURRENT DOUBLE PRECISION,
    ABC_OKP_CCURRENT_ZONE INTEGER,
    ABC_OKP_IDQUALIFIER INTEGER,
    TYPE_TRUD INTEGER,
    ABC_OKP_TYPE_TRUD INTEGER,
    MA DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    BB_PR DOUBLE PRECISION,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAMECRC INTEGER)
AS
declare variable id integer;
declare variable id_ao integer;
begin
--[15352]+

   ID_SELF = 0;
   ID_ABC_OKP = 0;

   if (FETCH_ALL_SEARCH is null) then
     FETCH_ALL_SEARCH = 0;

   /*[14280]if (stab is not null) then
     stab = S_TRANSLITERATE_TAB(stab); --[12447]*/

   for select ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA1, BEDA2, BEDARAB,
              BEDAMASH, BEDAMAT
   from L_FB_SEARCH_ID (:STAB, :IN_PODGROUP, :IN_RABMAT, :ID_USER, :ID_PUT_RAB,
                        :ID_PUT_MASH, :ID_PUT_MAT , :FETCH_ALL_SEARCH , 1)
   into :ID, :PODGROUP, :RABMAT, :ID_AO, :BEDA1, :BEDA2, :BEDARAB, :BEDAMASH, :BEDAMAT
   do
   begin
         for select
                  ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA,
                  NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE,
                  TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, COMMENT, RAZRAD,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE,
                  MA, MC, MB, MG, MH, BB_PR, --[15352]
                  VRPZ, NTR, PUNKTIND, ISESN, IDWITHESN,
                  CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE, CCURRENT_ZONE,
                  IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR,
                  ABC_OKP_NAME_PART, ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE,
                  ABC_OKP_TAB, ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                  ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME,
                  ABC_OKP_CENA, ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND,
                  ABC_OKP_VRPZ, ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                  TYPE_TRUD, ABC_OKP_TYPE_TRUD
             from L_FB_READ_SBORNIK (:ID, :ID_AO, :PODGROUP, :RABMAT, :ID_USER, :ID_ZONE)
             into ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA2,
                  NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE,
                  TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, COMMENT, RAZRAD,
                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE,
                  :MA, :MC, :MB, :MG, :MH, :BB_PR, --[15352]
                  VRPZ, NTR, PUNKTIND, ISESN, IDWITHESN,
                  CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE, CCURRENT_ZONE,
                  IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR,
                  ABC_OKP_NAME_PART, ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE,
                  ABC_OKP_TAB, ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                  ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME,
                  ABC_OKP_CENA, ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND,
                  ABC_OKP_VRPZ, ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                  TYPE_TRUD, ABC_OKP_TYPE_TRUD
         do
         begin
           --   
           select first 1 NAME
           from B_GETNAME_EX(:ID_USER, :IDNAME)
           into :NAME;

           NAMECRC = 0;
           if (:NAME is not null) then
             NAMECRC = K_GETCRC32(:NAME);


            suspend;

            --       
            if (FETCH_ALL_SEARCH = 0) then
              exit;
         end
         --       
         if (FETCH_ALL_SEARCH = 0) then
           exit;
   end
end
^

--[15352]
CREATE OR ALTER PROCEDURE M_GET_ONE_RES_INDEX (
    ID_SOURCE INTEGER,
    ID_LEVEL INTEGER,
    IDCLASS INTEGER,
    INSMETA INTEGER,
    RABMAT INTEGER,
    IDHIER INTEGER,
    IDNORMATIV INTEGER,
    PODGROUP INTEGER,
    TYPE_RAB INTEGER,
    VID_RAB INTEGER,
    PUNKTIND VARCHAR(42),
    TYPE_TRUD INTEGER,
    ID_USER INTEGER)
RETURNS (
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION)
AS
declare variable VN_ATYPE integer;
declare variable VN_SPOSOB_RASCH integer;
--[12699]declare variable VN_RES_INDEX integer;
--[12699]declare variable VN_INDEX_INFO integer;

declare variable VN_MA double precision;
declare variable VN_MB double precision;
declare variable VN_MC double precision;
declare variable VN_MD double precision;
declare variable VN_ME double precision;
declare variable VN_MJ double precision;
declare variable VN_MK double precision;
declare variable VN_ML double precision;
declare variable VN_MM double precision;
declare variable VN_DA double precision;
declare variable VN_DB double precision;
declare variable VN_DC double precision;
declare variable VN_DD double precision;
declare variable VN_DE double precision;
declare variable VN_DJ double precision;
declare variable VN_DK double precision;
declare variable VN_DL double precision;
declare variable VN_DM double precision;
declare variable VN_ID_LEVEL_INDEX integer;

declare variable VN_MH double precision;
declare variable VN_MI double precision;
begin
--[15352]

  --        
  -- INSMETA = null      ,   
  -- INSMETA =      
  ------------------------------------------------------------------------------

  --       
  -- (     Compose)
  if (INSMETA is null) then
  begin
/*
-- MK 24.09.2014 CQ[12601]  --->
    --    
    select first 1 i.ma, i.mb, i.mc, i.md, i.me, i.mj, i.mk, i.ml, i.mm, 
                   i.da, i.db, i.dc, i.dd, i.de, i.dj, i.dk, i.dl, i.dm,
                   i.mh, i.mi, i.index_info
    from a_smeta_indlvl i
    where (i.id = :ID_SOURCE) and (i.idcenlvl = :ID_LEVEL)
    into :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
         :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM,
         :MH, :MI, :VN_INDEX_INFO;

    --       ,    
    --  ,     
    if (VN_INDEX_INFO <> 3) then -- ciDirect
    begin
-- MK 24.09.2014 CQ[12601]  <---
*/

      -- 0 - ,        
      -- . NL_GET_CENLVL_NEW [04534AF5]
      VN_ATYPE = 0; -- MK CQ[12599.5] = 17;
  
      --       

      select first 1 ID_LEVEL_INDEX, -- MK CQ[12672]
                     MA, MB, MC, MD, ME, MJ, MK, ML, MM,
                     DA, DB, DC, DD, DE, DJ, DK, DL, DM,
                     MH, MI, SPOSOB_RASCH --[12699], RES_INDEX
      from NL_GET_CENLVL_NEW(:ID_LEVEL, :IDCLASS, :ID_USER, :TYPE_RAB, :VID_RAB,
                             :VN_ATYPE, :RABMAT, :IDHIER, :IDNORMATIV, :PODGROUP,
                             :PUNKTIND, 0,
                             0, 0, 0, 0, 0,
                             null, --[15352]
                             0, 1)
      into :VN_ID_LEVEL_INDEX,       -- MK CQ[12672]
           :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
           :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM,
           :VN_MH, :VN_MI, :VN_SPOSOB_RASCH --[12699], :VN_RES_INDEX
           ;

      -- MK CQ[12672]  
      execute procedure A_S_GET_ZU_INDEX_NL_LITE(:IDCLASS, :ID_LEVEL, :ID_SOURCE,
                        :VN_ID_LEVEL_INDEX, :VN_MH, :VN_MI)
      returning_values (:MH, :MI);

      -- MK 3.10.2014 CQ[12678]  (  A_S_GET_INDEX_NL_NEW) --->
/*
      --      
      if (VN_RES_INDEX = 2) then
      begin
        --    
        VN_DA = VN_MA;
        VN_DB = VN_MB;
        VN_DC = VN_MC;
        VN_DD = VN_MD;
        VN_DE = VN_ME;
        VN_DJ = VN_MJ;
        VN_DK = VN_MK;
        VN_DL = VN_ML;
        VN_DM = VN_MM;
      end
  
      --         
      if (VN_RES_INDEX = 4) then
      begin
        --     
        VN_DC = VN_MC;
        VN_DD = VN_MD;
        VN_DE = VN_ME;
      end
*/
      -- MK 3.10.2014 CQ[12678] <---


/*
-- MK 24.09.2014 CQ[12601]  --->
    end
    else
    begin
      --CQ[TIMUR 12568]
      --    ,      
      VN_DC = VN_MC;
      VN_DD = VN_MD;
      VN_DE = VN_ME;
    end
-- MK 24.09.2014 CQ[12601]  <---
*/
  end

  --      
  -- (   )
  else
  begin
    select first 1 i.ma, i.mb, i.mc, i.md, i.me, i.mj, i.mk, i.ml, i.mm, 
                   i.da, i.db, i.dc, i.dd, i.de, i.dj, i.dk, i.dl, i.dm,
                   i.mh, i.mi, i.index_sposobrasch -- MK CQ[12498]
    from a_smeta_indlvl i
    where (i.id = :INSMETA) and (i.idcenlvl = :ID_LEVEL)
    into :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
         :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM,
         :MH, :MI, :VN_SPOSOB_RASCH; -- MK CQ[12498]

    -- MK CQ[12498] --->
    select first 1 s.tiprab
    from a_smeta s
    where (s.id = :INSMETA)
    into :TYPE_RAB;
    -- MK CQ[12498] <---
  end


  --    
  execute procedure M_GET_USED_INDEX(:RABMAT, :TYPE_RAB, :TYPE_TRUD, :VN_SPOSOB_RASCH,
                                     :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME,
                                     :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
                                     :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE,
                                     :VN_DJ, :VN_DK, :VN_DL, :VN_DM, :MH, :MI)
    returning_values (:MB, :MC, :MD, :ME, :DB, :DC, :DD, :DE, :MH, :MI);

  --suspend;   execute procedure
end
^

--[15352]
/*  
CREATE OR ALTER PROCEDURE NL_CTRL_ENTER_SMREC (
*/

--[15352]
CREATE OR ALTER PROCEDURE NL_GET_CENLVL_NEW (
    ID_LEVEL INTEGER,
    IDCLASS INTEGER,
    ID_USER INTEGER,
    TYPE_RAB INTEGER,
    VID_RAB INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    IDHIER INTEGER,
    IDNORMATIV INTEGER,
    PODGROUP INTEGER,
    IN_PUNKTIND VARCHAR(42),
    IN_IDZONE INTEGER,
    IN_BA DOUBLE PRECISION,
    IN_BB DOUBLE PRECISION,
    IN_BC DOUBLE PRECISION,
    IN_BD DOUBLE PRECISION,
    IN_BE DOUBLE PRECISION,
    IN_B_PR DOUBLE PRECISION,
    ID_SM_REC INTEGER,
    NEED_APPLY_INDEX INTEGER)
RETURNS (
    ID_LEVEL_VC INTEGER,
    IDZONE INTEGER,
    ID_LEVEL_INDEX INTEGER,
    IDINDEX INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    B_PR DOUBLE PRECISION,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    M_PR DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    PUNKTIND VARCHAR(42),
    SPOSOB_RASCH INTEGER,
    RES_VC INTEGER,
    RES_INDEX INTEGER)
AS
declare variable VN_RES integer;
--CQ[9291] declare variable VN_MAIN_SM_REC integer;
declare variable VN_ID_ZONE integer;
declare variable VN_ZONE_BA double precision;
declare variable VN_ZONE_BB double precision;
declare variable VN_ZONE_BC double precision;
declare variable VN_ZONE_BD double precision;
declare variable VN_ZONE_BE double precision;
--CQ[9291] declare variable VN_IS_USED_INDEX integer;
declare variable IdLevelIndex_MainStr integer;
declare variable IdIndex_MainStr integer;
declare variable ResCopyIndex_MainStr integer;
declare variable VN_MAIN_SM_REC integer;

declare SLAVECOMPOSEFROMMAINNEEDED integer;

declare FC_IDREESTR integer;
declare FC_ATYPE integer;
declare FC_RABMAT integer;
declare FC_IDNORMATIV integer;
declare FC_IDPODGROUP integer;
declare FC_PUNKTIND varchar(42);
--declare FC_ID_SM_REC integer; --[11537] -      ,     -   [11010]
declare FC_TYPE_RAB integer;
declare FC_VID_RAB integer;
declare FC_LOOP integer;

declare ID_ORG integer;
declare ID_YEAR integer;
declare ID_MONTH integer;
declare ID_IND integer;

--<[14593]>
declare INDEX_DX_ONLY integer; --</>
begin
--[15352]+

-- =============================================================================
--  :
-- ID_SM_REC -    .  " "  (ATYPE = 0)   = 0
-- =============================================================================
--  :
-- ID_LEVEL_VC -    
-- IDZONE -        
-- ID_LEVEL_INDEX -    
-- IDINDEX -       
-- BA .. BE -       (      )
-- MA .. MI -  (    ).     
--                ( ),    
-- SPOSOB_RASCH -    ( ,  )
-- RES_VC -   :
--          -2 -       
--          -1 -     
--          0  -     (   )
--          1  -    
--
-- RES_INDEX -    (    ):
-- (. A_SMETA_INDLVL.INDEX_INFO)
--             -2 -       
--             -1 -     
--             0  -     
--             1  -      ( )
--             2  -    
--             4  -   " " [10502] - c 7.10
--             5  -        (  7.11)
-- =============================================================================

  SLAVECOMPOSEFROMMAINNEEDED = 0;

  if (:ATYPE = 18) then
  begin
    --      
    select first 1 S.SLAVEPARENT
    from A_SMETA S
    where (S.ID = :ID_SM_REC)
    into :VN_MAIN_SM_REC;

    execute procedure NL_FIND_COMPOSE_UCH_FROM_MAIN1(:ID_SM_REC)
      returning_values :SLAVECOMPOSEFROMMAINNEEDED;

    if (:SLAVECOMPOSEFROMMAINNEEDED <> 0) then
    begin
      execute procedure NL_FIND_COMPOSE_GETPARAMSFOR(:ID_USER, :VN_MAIN_SM_REC, :ID_LEVEL)
        returning_values :FC_IDREESTR, :FC_TYPE_RAB, :FC_VID_RAB, :FC_ATYPE,
            :FC_RABMAT, :FC_PUNKTIND, :FC_IDNORMATIV, :FC_IDPODGROUP;
      --FC_ID_SM_REC = VN_MAIN_SM_REC;
    end
  end

  FC_LOOP = 1;
  while (:FC_LOOP > 0) do --<<[11537]
  begin
    FC_LOOP = 0;

    if (:SLAVECOMPOSEFROMMAINNEEDED = 0) then
    begin
      --    
      execute procedure L_S_SELECT_ID_REEST (:ID_USER, :IDNORMATIV, :RABMAT, :PODGROUP)
        returning_values (:FC_IDREESTR);
      FC_ATYPE = :ATYPE;
      FC_IDNORMATIV = :IDNORMATIV;
      FC_RABMAT = :RABMAT;
      FC_IDPODGROUP = :PODGROUP;
      FC_PUNKTIND = :IN_PUNKTIND;
      --FC_ID_SM_REC = :ID_SM_REC;
      FC_TYPE_RAB = :TYPE_RAB;
      FC_VID_RAB = :VID_RAB;
    end
  
    --      
    --CQ[10738]-->
    /*CQ[10738]
    execute procedure nl_find_compose (:ID_LEVEL, :IDCLASS, :ID_USER, :VN_IDREESTR,
                                       :TYPE_RAB, :VID_RAB, :ATYPE, :RABMAT, :IDHIER)
    returning_values (:ID_LEVEL_VC, :ID_LEVEL_INDEX); */
    execute procedure NL_FIND_COMPOSE_EX (
        :ID_LEVEL, :IDCLASS, :ID_USER,
        :FC_IDREESTR,
        :FC_TYPE_RAB, :FC_VID_RAB, :FC_ATYPE, :FC_RABMAT,
        :IDHIER,
        :FC_PUNKTIND, :FC_IDNORMATIV, :FC_IDPODGROUP)
      returning_values (:ID_LEVEL_VC, :ID_LEVEL_INDEX, :INDEX_DX_ONLY); --[14593]
    --CQ[10738]<--

    --<[11537]>
    if (:SLAVECOMPOSEFROMMAINNEEDED <> 0) then
    begin
      --    "    "
      if (:ID_LEVEL_INDEX is not null) then
      --   (  "  ")
      for select first 1 ID_ORG, ID_YEAR, ID_MONTH
        from LEVEL_INDEX
        where ID_COMPOSE = :ID_LEVEL_INDEX
          and coalesce(RES_COPY_INDEX, 0) = 0
        into :ID_ORG, :ID_YEAR, :ID_MONTH
      do
      begin
        execute procedure IND_RECORD_EXISTS(:ID_USER, :ID_ORG, :ID_YEAR, :ID_MONTH, :IN_PUNKTIND, 1)
          returning_values :ID_IND;
        --   -    
        if (:ID_IND is null) then
          ID_LEVEL_INDEX = null;
      end

      if (:ID_LEVEL_INDEX is null and :ID_LEVEL_VC is null) then --[11537.1]
      begin
        --  ,    
        FC_LOOP = 1;
        SLAVECOMPOSEFROMMAINNEEDED = 0;
      end
    end
    --</>
  end

  -- CQ[10929] :    NL_GET_CENLVL,        -->
  -- MK 25.10.2012 CQ[10839] --->
  if (ATYPE = 18) then --   
  begin
    IdLevelIndex_MainStr = 0; -- MK CQ[12869] null;

    --       Compose 
    -- MK CQ[12869] + coalesce, + idindex
    select first 1 coalesce(i.id_level_index, 0), coalesce(i.idindex, 0)
    from A_SMETA_INDLVL i
    where (i.id = :VN_MAIN_SM_REC) and (i.idcenlvl = :ID_LEVEL)
    into :IdLevelIndex_MainStr, :IdIndex_MainStr;

    -- MK CQ[12869] --->
    --      Compose
    --      
    if ((IdLevelIndex_MainStr = 0) and (IdIndex_MainStr > 0)) then
    begin
      --   Compose   
      select first 1 c.id
      from LEVEL_COMPOSE c
      join LEVEL_INDEX li on (c.id = li.id_compose)
      where (c.idclass = :IDCLASS) and (c.id_level = :ID_LEVEL) and
            (c.atype = 1) and (li.id_month = :IdIndex_MainStr)
      order by c.lorder
      into :IdLevelIndex_MainStr;
    end

    if (IdLevelIndex_MainStr > 0) then
    --if (IdLevelIndex_MainStr is not null) then
    -- MK CQ[12869] <---
    begin
      select li.res_copy_index
      from LEVEL_INDEX li
      where (li.id_compose = :IdLevelIndex_MainStr)
      into :ResCopyIndex_MainStr;

      if (:ResCopyIndex_MainStr <> 0) then
        ID_LEVEL_INDEX = IdLevelIndex_MainStr;
    end
  end
  -- MK 25.10.2012 CQ[10839] <---
  -- CQ[10929] <--



  --   ------------------------------------------------------------------
  RES_VC = -2;
  --  :      (    )
  IDZONE = IN_IDZONE;
  BA = IN_BA;
  BB = IN_BB;
  BC = IN_BC;
  BD = IN_BD;
  BE = IN_BE;
  B_PR = :IN_B_PR; --[15352]

  /* <<[10929] -      ,   ,   !
  --      
  if (:ID_LEVEL_VC is not null) then
  */
  begin
    --      
    execute procedure nl_check_vc(:ID_USER, :ID_LEVEL_VC, :ATYPE, :RABMAT,
                                  :IDNORMATIV, :PODGROUP)
    returning_values (:VN_RES, :VN_ID_ZONE, :VN_ZONE_BA, :VN_ZONE_BB,
                      :VN_ZONE_BC, :VN_ZONE_BD, :VN_ZONE_BE);

    --   :        
    if (:VN_RES > 0) then
    begin
      IDZONE = VN_ID_ZONE;
      BA = VN_ZONE_BA;
      BB = VN_ZONE_BB;
      BC = VN_ZONE_BC;
      BD = VN_ZONE_BD;
      BE = VN_ZONE_BE;
      if (:VN_ID_ZONE > 0) then --[15352] ???
        B_PR = null; --[15352]
    end

    RES_VC = VN_RES;
  end


  --  -------------------------------------------------------------------
  -- MK CQ[12599.5] --->
  -- [04534AF5] (  M_GET_ONE_RES_INDEX)
  if (ATYPE = 0) then
    ATYPE = 17;
  -- MK CQ[12599.5] <---

  execute procedure A_S_GET_INDEX_NL_NEW (
      :ID_LEVEL, :ID_USER, :ATYPE/*[11010]FC_ATYPE*/, :IN_PUNKTIND/*[11010]FC_PUNKTIND*/,
      :ID_LEVEL_INDEX, :ID_SM_REC/*[11537/11010]FC_ID_SM_REC*/, :NEED_APPLY_INDEX)
  returning_values (:IDINDEX, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
                    :MJ, :MK, :ML, :MM, --CQ[10529]
                    :M_PR, --[15352]
                    :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM,--CQ[10529]
                    :PUNKTIND, :SPOSOB_RASCH, :RES_INDEX);
  --<<[14593]
  if (:INDEX_DX_ONLY <> 0) then
  begin
    MA = 1.0;
    MB = 1.0; MC = 1.0; MD = 1.0; ME = 1.0;
    MF = 0.0; MG = 0.0;
    MH = 1.0; MI = 1.0;
    MJ = 1.0; MK = 1.0; ML = 1.0; MM = 1.0;
    M_PR = 1.0; --[15352]
  end

  suspend;
end
^

--[15352]
CREATE OR ALTER PROCEDURE NL_GET_RES_CENLVL (
    ID_LEVEL INTEGER,
    IDCLASS INTEGER,
    ID_USER INTEGER,
    TYPE_RAB INTEGER,
    VID_RAB INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    IDHIER INTEGER,
    IDNORMATIV INTEGER,
    PODGROUP INTEGER,
    IN_IDZONE INTEGER,
    IN_BB DOUBLE PRECISION,
    IN_BC DOUBLE PRECISION,
    IN_BD DOUBLE PRECISION,
    IN_BE DOUBLE PRECISION)
RETURNS (
    ID_LEVEL_VC INTEGER,
    IDZONE INTEGER,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    RES_VC INTEGER)
AS
declare variable VN_IDREESTR integer;
declare variable ID_LEVEL_INDEX integer;
declare variable VN_RES integer;
declare variable VN_ID_ZONE integer;
declare variable VN_ZONE_BA double precision;
declare variable VN_ZONE_BB double precision;
declare variable VN_ZONE_BC double precision;
declare variable VN_ZONE_BD double precision;
declare variable VN_ZONE_BE double precision;

declare variable NEED_APPLY_INDEX integer;

declare variable VN_ID_LEVEL_INDEX integer;
declare variable VN_IDINDEX integer;
declare variable VN_PUNKTIND varchar(42);
declare variable RES_INDEX integer;
declare variable VN_SPOSOB_RASCH integer;

declare variable VN_BA double precision;
declare VN_B_PR double precision; --[15352]
declare variable VN_MA double precision;
declare variable VN_MB double precision;
declare variable VN_MC double precision;
declare variable VN_MD double precision;
declare variable VN_ME double precision;
declare variable VN_MF double precision;
declare variable VN_MG double precision;
declare variable VN_MH double precision;
declare variable VN_MI double precision;
declare variable VN_MJ double precision;
declare variable VN_MK  double precision;
declare variable VN_ML double precision;
declare variable VN_MM double precision;
declare VN_M_PR double precision; --[15352]
declare variable VN_DA double precision;
declare variable VN_DB double precision;
declare variable VN_DC double precision;
declare variable VN_DD double precision;
declare variable VN_DE double precision;
declare variable VN_DJ double precision;
declare variable VN_DK  double precision;
declare variable VN_DL double precision;
declare variable VN_DM double precision;

begin
--[15352]

/*CQ[10929] --> :    CopyPaste  NL_GET_CENLVL_NEW
  .   ,      ...

-- ...       ,
--       ( ..    ),
--         ""
--    ""


-- =============================================================================
--  
-- ATYPE --  ( - 17,  - 18,  - 0

--  :
-- ID_LEVEL_VC -    
-- IDZONE -        
-- BA .. BE -       (      )
-- RES_VC -   :
--          -2 -       
--          -1 -     
--           0  -     (   )
--           1  -    
-- =============================================================================

  --    
  execute procedure L_S_SELECT_ID_REEST (:ID_USER, :IDNORMATIV, :RABMAT, :PODGROUP)
  returning_values (:VN_IDREESTR);

  --      
  --CQ[10738]-->
  --CQ[10738] execute procedure nl_find_compose (:ID_LEVEL, :IDCLASS, :ID_USER, :VN_IDREESTR,
  --                                   :TYPE_RAB, :VID_RAB, :ATYPE, :RABMAT, :IDHIER)
  --returning_values (:ID_LEVEL_VC, :ID_LEVEL_INDEX);
  execute procedure nl_find_compose_ex (:ID_LEVEL, :IDCLASS, :ID_USER, :VN_IDREESTR,
                                     :TYPE_RAB, :VID_RAB, :ATYPE, :RABMAT, :IDHIER,
                                     '', :IDNORMATIV, :PODGROUP)
  returning_values (:ID_LEVEL_VC, :ID_LEVEL_INDEX); 
  --CQ[10738]<--


  --   ------------------------------------------------------------------
  RES_VC = -2;
  --  :      (    )
  IDZONE = IN_IDZONE;
  BB = IN_BB;
  BC = IN_BC;
  BD = IN_BD;
  BE = IN_BE;

  --      
  if (:ID_LEVEL_VC is not null) then
  begin
    --      
    execute procedure nl_check_vc(:ID_USER, :ID_LEVEL_VC, :ATYPE, :RABMAT,
                                  :IDNORMATIV, :PODGROUP)
    returning_values (:VN_RES, :VN_ID_ZONE, :VN_ZONE_BA, :VN_ZONE_BB,
                      :VN_ZONE_BC, :VN_ZONE_BD, :VN_ZONE_BE);

    --   :        
    if (:VN_RES > 0) then
    begin
      IDZONE = VN_ID_ZONE;
      BB = VN_ZONE_BB;
      BC = VN_ZONE_BC;
      BD = VN_ZONE_BD;
      BE = VN_ZONE_BE;
    end

    RES_VC = VN_RES;
  end
  suspend;
  CQ[10929] <--*/

  --CQ[10929] -->
  NEED_APPLY_INDEX = 1;--CQ[10929] :  = 1,    
  --            
  EXECUTE PROCEDURE NL_GET_CENLVL_NEW (:ID_LEVEL,
                                  :IDCLASS,
                                  :ID_USER,
                                  :TYPE_RAB,
                                  :VID_RAB,
                                  :ATYPE,
                                  :RABMAT,
                                  :IDHIER,
                                  :IDNORMATIV,
                                  :PODGROUP,
                                  '',--PUNKTIND
                                  :IN_IDZONE,
                                  0.0,--NORM_BA,
                                  :IN_BB,
                                  :IN_BC,
                                  :IN_BD,
                                  :IN_BE,
                                  null, --[15352]
                                  0,--ID_SM_REC,
                                  :NEED_APPLY_INDEX)
  RETURNING_VALUES (:ID_LEVEL_VC,
                    :IDZONE,
                    :VN_ID_LEVEL_INDEX,
                    :VN_IDINDEX,
                    :VN_BA, :BB, :BC, :BD, :BE,
                    :VN_B_PR, --[15352]
                    :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH, :VN_MI,
                    :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
                    :VN_M_PR, --[15352]
                    :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM,
                    :VN_PUNKTIND, :VN_SPOSOB_RASCH, :RES_VC, :RES_INDEX);

  --CQ[10929] <--

end
^

--[15352]
CREATE OR ALTER PROCEDURE NL_RECALL_EMPTYNORMO_INDEX (
    IDUSER INTEGER,
    IDSMETASTR INTEGER,
    IDLEVEL INTEGER)
RETURNS (
    RECORDS_MODIFIED INTEGER)
AS
declare variable IDCLASS integer;
declare variable SMETATYPE integer;
declare variable IDHIER integer;
declare variable ID integer;
declare variable ATYPE integer;
declare variable RABMAT integer;
declare variable IDPODGROUP integer;
declare variable TIPRAB integer;
declare variable VIDRAB integer;
declare variable SMETA_PUNKTIND varchar(42);

declare variable ID_COMPOSE_INDEX integer;
declare variable ID_LEVEL_INDEX integer;
declare variable ID_COMPOSE_VC integer;
declare variable VN_IDINDEX integer;

declare variable VN_MA double precision;
declare variable VN_MB double precision;
declare variable VN_MC double precision;
declare variable VN_MD double precision;
declare variable VN_ME double precision;
declare variable VN_MF double precision;
declare variable VN_MG double precision;
declare variable VN_MH double precision;
declare variable VN_MI double precision;
declare variable VN_PUNKTIND varchar(42);
declare variable VN_SPOSOB_RASCH integer;
declare variable VN_RES_INDEX integer;

declare variable VN_MJ double precision;
declare variable VN_MK double precision;
declare variable VN_ML double precision;
declare variable VN_MM double precision;
declare VN_M_PR double precision; --[15352]
declare variable VN_DA double precision;
declare variable VN_DB double precision;
declare variable VN_DC double precision;
declare variable VN_DD double precision;
declare variable VN_DE double precision;
declare variable VN_DJ double precision;
declare variable VN_DK double precision;
declare variable VN_DL double precision;
declare variable VN_DM double precision;
declare variable NEED_APPLY_INDEX integer;

declare variable SLAVECOMPOSEFROMMAINNEEDED integer;
declare variable ID_S_RES integer;
--declare variable P_ISCLC integer;
--declare variable P_MODE_KOMPNS_ST integer;
--declare variable SM_CLCMODE integer;
declare variable SLAVEPARENT integer;
--declare variable IDREESTR integer;
declare variable IDNORMATIV integer;
declare variable NORM_GUID varchar(100);
declare variable TAB varchar(42);

declare variable FC_ATYPE integer;
--<[11010]>
declare FC_PUNKTIND varchar(42);
--</>
declare FC_IDREESTR integer;
declare FC_TIPRAB integer;
declare FC_VIDRAB integer;
declare FC_RABMAT integer;
declare FC_IDNORMATIV integer;
declare FC_IDPODGROUP integer;
declare FC_LOOP integer;

declare ID_ORG integer;
declare ID_YEAR integer;
declare ID_MONTH integer;
declare ID_IND integer;

--<[14593]>
declare INDEX_DX_ONLY integer; --</>
begin
--[15352]

  NEED_APPLY_INDEX = 1;--CQ[10929] :  = 1,    

  --CQ[10769]-->    A_S_PARAMS_TO_SMETA_NL_ONE
  RECORDS_MODIFIED = 0;
  --     (  , ..    )
  for select S.ID, S.ATYPE, S.IDHIER, S.SMETATYPE, S.RABMAT, S.KODIR_PODGROUP, S.TIPRAB, S.VIDRAB,
             I.ID_LEVEL_INDEX, coalesce(nullif(I.PUNKTIND, ''), S.PUNKTIND),
             I.MJ, I.MK, I.ML, I.MM,
             I.M_PR, --[15352]
             I.DA, I.DB, I.DC,
             I.DD, I.DE, I.DJ, I.DK, I.DL, I.DM,
             S.ID_S_RES, S.SLAVEPARENT, S.IDNORMATIV, S.NORM_GUID, S.TAB --CQ[10929]
    from A_SMETA S
    left join A_SMETA_CENLVL L on L.ID = S.ID and L.IDCENLVL = :IDLEVEL
    left outer join A_SMETA_INDLVL I on I.ID = S.ID and I.IDCENLVL = :IDLEVEL
    where S.ID = :IDSMETASTR
    into :ID, :ATYPE, :IDHIER, :SMETATYPE, :RABMAT, :IDPODGROUP, :TIPRAB, :VIDRAB,
         :ID_LEVEL_INDEX, :SMETA_PUNKTIND,
         :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
         :VN_M_PR, --[15352]
         :VN_DA, :VN_DB, :VN_DC,
         :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM,
         :ID_S_RES, :SLAVEPARENT, :IDNORMATIV, :NORM_GUID, :TAB --CQ[10929]
  do
  begin
    if (:ATYPE in (17 /*SmRec*/ , 18 /*ResRec*/ )) then
    begin
      if (:SMETATYPE > 999) then
        IDCLASS = :SMETATYPE;
      else
        execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1 /*ObgectType*/ )
          returning_values :IDCLASS;
    end
    else
      exit;

    --CQ[10929]-->
    if (:ID_S_RES is not null) then
      execute procedure NL_FIND_COMPOSE_UCH_FROM_MAIN1(:IDSMETASTR)
        returning_values :SLAVECOMPOSEFROMMAINNEEDED;
    else
      SLAVECOMPOSEFROMMAINNEEDED = 0;
    
    FC_LOOP = 1;
    while (:FC_LOOP > 0) do --<<[11537]
    begin
      FC_LOOP = 0;
  
      if (:SLAVECOMPOSEFROMMAINNEEDED <> 0) then
          execute procedure NL_FIND_COMPOSE_GETPARAMSFOR(:IDUSER, :SLAVEPARENT, :IDLEVEL)
            returning_values (:FC_IDREESTR, :FC_TIPRAB, :FC_VIDRAB, :FC_ATYPE, :FC_RABMAT, :FC_PUNKTIND, :FC_IDNORMATIV, :FC_IDPODGROUP);
      else
      begin
        execute procedure NL_GET_NORMBASE_LINK(
            :IDUSER, :RABMAT, :IDNORMATIV, :IDPODGROUP, :NORM_GUID, :TAB)
          returning_values (:FC_IDREESTR, :FC_RABMAT, :FC_IDNORMATIV, :FC_IDPODGROUP);
        FC_ATYPE = :ATYPE;
        FC_PUNKTIND = :SMETA_PUNKTIND; --<<[11010]
        FC_TIPRAB = :TIPRAB;
        FC_VIDRAB = :VIDRAB;
      end
      --CQ[10929]<--
  
      execute procedure NL_FIND_COMPOSE_EX(
          :IDLEVEL, :IDCLASS, :IDUSER,
          :FC_IDREESTR,
          :FC_TIPRAB, :FC_VIDRAB, :FC_ATYPE/*CQ[10929]ATYPE*/, :FC_RABMAT,
          :IDHIER,
          :FC_PUNKTIND/*[11010]SMETA_PUNKTIND*/, :FC_IDNORMATIV, :FC_IDPODGROUP)
        returning_values :ID_COMPOSE_VC, :ID_COMPOSE_INDEX, :INDEX_DX_ONLY; --[14593]

      --<[11537]>
      if (:SLAVECOMPOSEFROMMAINNEEDED <> 0) then
      begin
        --    "    "
        if (:ID_COMPOSE_INDEX is not null) then
        --   (  "  ")
        for select first 1 ID_ORG, ID_YEAR, ID_MONTH
          from LEVEL_INDEX
          where ID_COMPOSE = :ID_COMPOSE_INDEX
            and coalesce(RES_COPY_INDEX, 0) = 0
          into :ID_ORG, :ID_YEAR, :ID_MONTH
        do
        begin
          execute procedure IND_RECORD_EXISTS(:IDUSER, :ID_ORG, :ID_YEAR, :ID_MONTH, :SMETA_PUNKTIND, 1)
            returning_values :ID_IND;
          --   -    
          if (:ID_IND is null) then
            ID_COMPOSE_INDEX = null;
        end
  
        if (:ID_COMPOSE_INDEX is null and :ID_COMPOSE_VC is null) then --[11537.1]
        begin
          --  ,    
          FC_LOOP = 1;
          SLAVECOMPOSEFROMMAINNEEDED = 0;
        end
      end
      --</>
    end

    --  :   :COMPOSE_IDINDEX   :ID_COMPOSE_INDEX  _
    -- :COMPOSE_IDINDEX=0  :ID_COMPOSE_INDEX    
    VN_RES_INDEX = null;
    if (coalesce(:ID_COMPOSE_INDEX, 0) <> coalesce(:ID_LEVEL_INDEX, 0)) then
    begin
      --  
      --CQ[10929]execute procedure A_S_GET_INDEX_NL
      execute procedure A_S_GET_INDEX_NL_NEW --CQ[10929]
      (:IDLEVEL, :IDUSER, :ATYPE, :SMETA_PUNKTIND,
        :ID_COMPOSE_INDEX, :ID,
        :NEED_APPLY_INDEX)--CQ[10929]
      returning_values :VN_IDINDEX, :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH,
        :VN_MI, :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
        :VN_M_PR, --[15352]
        :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ,
        :VN_DK, :VN_DL, :VN_DM, :VN_PUNKTIND, :VN_SPOSOB_RASCH, :VN_RES_INDEX;
      -- :VN_RES_INDEX > 0:        ,
      --     ...      

      --<<[14593]
      if (:INDEX_DX_ONLY <> 0) then
      begin
        VN_MA = 1.0;
        VN_MB = 1.0; VN_MC = 1.0; VN_MD = 1.0; VN_ME = 1.0;
        VN_MF = 0.0; VN_MG = 0.0;
        VN_MH = 1.0; VN_MI = 1.0;
        VN_MJ = 1.0; VN_MK = 1.0; VN_ML = 1.0; VN_MM = 1.0;
        VN_M_PR = 1.0; --[15352]
      end
    end

    --       ...
    if (:VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0) then
    begin
      update A_SMETA_INDLVL set
        IDINDEX = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_IDINDEX else IDINDEX end,
        ID_LEVEL_INDEX = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :ID_COMPOSE_INDEX else ID_LEVEL_INDEX end,
        PUNKTIND = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_PUNKTIND else PUNKTIND end,
        MA = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MA else MA end,
        MB = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MB else MB end,
        MC = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MC else MC end,
        MD = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MD else MD end,
        ME = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_ME else ME end,
        MF = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MF else MF end,
        MG = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MG else MG end,
        MH = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MH else MH end,
        MI = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MI else MI end,
        INDEX_SPOSOBRASCH = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_SPOSOB_RASCH else INDEX_SPOSOBRASCH end,
        INDEX_INFO = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_RES_INDEX else INDEX_INFO end,
        MJ = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MJ else MJ end,
        MK = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MK else MK end,
        ML = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_ML else ML end,
        MM = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MM else MM end,
        M_PR = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_M_PR else M_PR end, --[15352]
        DA = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DA else DA end,
        DB = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DB else DB end,
        DC = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DC else DC end,
        DD = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DD else DD end,
        DE = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DE else DE end,
        DJ = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DJ else DJ end,
        DK = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DK else DK end,
        DL = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DL else DL end,
        DM = case when :VN_RES_INDEX = -2 /*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DM else DM end
      where (ID = :ID) and
            (IDCENLVL = :IDLEVEL) and
            (coalesce(:VN_RES_INDEX, 0) = -2 /*ciNotFound*/ or coalesce(:VN_RES_INDEX, 0) > 0);

      RECORDS_MODIFIED = :RECORDS_MODIFIED + row_count;

      if (row_count > 0) then
        execute procedure FILL_INDLVL_DESCR(:ID, :IDLEVEL, :ID_COMPOSE_INDEX, :VN_RES_INDEX);
    end
  end
  suspend;
  --CQ[10769]<--
end
^

--[15352]
/* 
CREATE OR ALTER PROCEDURE PASTE_SMETA_RECORD (
*/
--[15352]
CREATE OR ALTER PROCEDURE V_GET_PARAMS_LS (
    IDUSER INTEGER,
    IDHIER INTEGER)
RETURNS (
    ID INTEGER,
    NUMGLSSR INTEGER,
    TIPRAB INTEGER,
    SHIFR VARCHAR(1024),
    FULLNAME VARCHAR(1024),
    NACH_STROY DATE,
    OKONCH_STROIT DATE,
    SPISOKSHERT BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    OPISANIE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ISPOLNIL_FIO VARCHAR(250),
    ISPOLNIL_DOLGN VARCHAR(100),
    PROVERIL_FIO VARCHAR(250),
    PROVERIL_DOLGN VARCHAR(100),
    UTVERDIL_FIO VARCHAR(250),
    UTVERDIL_DOLGN VARCHAR(100),
    SUBPODR_ID_ORG INTEGER,
    SUBPODR_NAME_ORG VARCHAR(255),
    SUBPODR_ID INTEGER,
    SUBPODR_FIO VARCHAR(250),
    SUBPODR_DOLGN VARCHAR(100),
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    VELICHSTROBJ DOUBLE PRECISION,
    EDIZM VARCHAR(40),
    CODE VARCHAR(512),
    REPLACECORRECTION INTEGER,
    SPREADONEXISTSREC INTEGER,
    CORRECTIONRULE INTEGER,
    NUMGLSSR_CALCULATED INTEGER,
    REVISION VARCHAR(255),
    GUID VARCHAR(100),
    VRIDDOC INTEGER,
    VRDOCCAPTION VARCHAR(20),
    VRNPPTEXT VARCHAR(20),
    VRPRVALUE DOUBLE PRECISION,
    ZUIDDOC INTEGER,
    ZUDOCCAPTION VARCHAR(20),
    ZUNPPTEXT VARCHAR(20),
    ZUPRVALUE DOUBLE PRECISION,
    CLIDDOC INTEGER,
    CLDOCCAPTION VARCHAR(20),
    CLNPPTEXT VARCHAR(20),
    CLZONE INTEGER,
    CLKOEF DOUBLE PRECISION,
    NUMLSR_LS VARCHAR(1024))
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME, NUMLSR_LS
begin
 --[15352]+
    IDUSER = IDUSER; --    warning
    for select
        L.ID,
        L.NUMGLSSR, L.TIPRAB, L.SHIFR, L.FULLNAME, 
        L.NACH_STROY, L.OKONCH_STROIT, 
        L.SPISOKSHERT, L.OPISANIE,
        L.ISPOLNIL_FIO, L.ISPOLNIL_DOLGN, 
        L.PROVERIL_FIO, L.PROVERIL_DOLGN, 
        L.UTVERDIL_FIO, L.UTVERDIL_DOLGN, 
        L.SUBPODR_ID_ORG, L.SUBPODR_NAME_ORG, 
        L.SUBPODR_ID, L.SUBPODR_FIO, L.SUBPODR_DOLGN, 
        L.KA, L.KB, L.KC, L.KD, L.KE, 
        L.KF, L.KG, L.KH, L.KI, L.KJ, L.KK, 
        L.KL, L.KM,
        L.K_ITOGO, -- CQ[14462]
        L.K_PR, -- CQ[15421]
        CORRECTNODE, CORRECTNODE_1, 
        L.VELICHSTROBJ,
        L.EDIZM,  
        L.CODE, 
        L.UTV,
        L.REPLACECORRECTION, L.SPREADONEXISTSREC, L.CORRECTIONRULE,
        V.NUMGLSSR as NUMGLSSR_CALCULATED,
        L.REVISION,
        L.GUID, --[10787]E.GUID
        L.NUMLSR_LS -- Voyager CQ[12235]
     from A_O_PARAMS_LS L 
     join S_O_HIER_PARENT_OFTYPE (:IDHIER, 1) P 
     on L.ID = :IDHIER 
     left join A_O_OBJECTPARAMS O 
     on O.NUMBER = P.IDPARENT 
     left join V_SELECT_NUMGLSSR(:IDHIER) V on L.ID = :IDHIER
     --[10787]left join ENTITY_GUID E on E.ID = :IDHIER
     into
        :ID,
        :NUMGLSSR, :TIPRAB, :SHIFR, :FULLNAME,
        :NACH_STROY, :OKONCH_STROIT,
        :SPISOKSHERT, :OPISANIE,
        :ISPOLNIL_FIO, :ISPOLNIL_DOLGN,
        :PROVERIL_FIO, :PROVERIL_DOLGN,
        :UTVERDIL_FIO, :UTVERDIL_DOLGN,
        :SUBPODR_ID_ORG, :SUBPODR_NAME_ORG,
        :SUBPODR_ID, :SUBPODR_FIO, :SUBPODR_DOLGN,
        :KA, :KB, :KC, :KD, :KE,
        :KF, :KG, :KH, :KI, :KJ, :KK,
        :KL, :KM,
        :K_ITOGO, -- CQ[14462]
        :K_PR, -- CQ[15421]
        :CORRECTNODE, :CORRECTNODE_1,
        :VELICHSTROBJ,
        :EDIZM,
        :CODE,
        :UTV,
        :REPLACECORRECTION, :SPREADONEXISTSREC, :CORRECTIONRULE,
        :NUMGLSSR_CALCULATED,
        :REVISION,
        :GUID,
        :NUMLSR_LS
    do
    begin
      if (coalesce(:GUID, '') = '') then
      begin --<<[10787]
        GUID = COCREATEGUID();
        update A_O_PARAMS_LS
          set GUID = :GUID
          where ID = :ID;
      end

      -- <-- Voyager CQ[9758]
      select VRIDDOC, VRDOCCAPTION, VRNPPTEXT, VRPRVALUE, ZUIDDOC, ZUDOCCAPTION, ZUNPPTEXT, ZUPRVALUE, CLIDDOC, CLDOCCAPTION,
             CLNPPTEXT, CLZONE, CLKOEF
      from V_SELECT_VRZUCL_EXP_OBJ_XML(:ID)
      into :VRIDDOC, :VRDOCCAPTION, :VRNPPTEXT, :VRPRVALUE, :ZUIDDOC, :ZUDOCCAPTION, :ZUNPPTEXT, :ZUPRVALUE, :CLIDDOC,
           :CLDOCCAPTION, :CLNPPTEXT, :CLZONE, :CLKOEF;
      -- <-- CQ[9758]

      suspend;
    end
end
^

--[15352]
CREATE OR ALTER PROCEDURE V_GET_PARAMS_R_PR (
    IDUSER INTEGER,
    IDHIER INTEGER)
RETURNS (
    ID INTEGER,
    NUMGLSSR INTEGER,
    TIPRAB INTEGER,
    SHIFR VARCHAR(1024),
    FULLNAME VARCHAR(1024),
    OPISANIE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ISPOLNIL_FIO VARCHAR(250),
    ISPOLNIL_DOLGN VARCHAR(100),
    PROVERIL_FIO VARCHAR(250),
    PROVERIL_DOLGN VARCHAR(100),
    UTVERDIL_FIO VARCHAR(250),
    UTVERDIL_DOLGN VARCHAR(100),
    SUBPODR_ID_ORG INTEGER,
    SUBPODR_NAME_ORG VARCHAR(255),
    SUBPODR_ID INTEGER,
    SUBPODR_FIO VARCHAR(250),
    SUBPODR_DOLGN VARCHAR(100),
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50),
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    VELICHSTROBJ DOUBLE PRECISION,
    EDIZM VARCHAR(40),
    REPLACECORRECTION INTEGER,
    SPREADONEXISTSREC INTEGER,
    CORRECTIONRULE INTEGER,
    NUMGLSSR_CALCULATED INTEGER,
    GUID VARCHAR(100))
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
begin
 --[15352]+
  IDUSER = IDUSER; --    warning
  for select
      P.ID,
      P.NUMGLSSR, P.TIPRAB, P.SHIFR, P.FULLNAME,
      P.OPISANIE,
      P.ISPOLNIL_FIO, P.ISPOLNIL_DOLGN,
      P.PROVERIL_FIO, P.PROVERIL_DOLGN,
      P.UTVERDIL_FIO, P.UTVERDIL_DOLGN,
      P.SUBPODR_ID_ORG, P.SUBPODR_NAME_ORG,
      P.SUBPODR_ID, P.SUBPODR_FIO, P.SUBPODR_DOLGN,
      P.KA, P.KB, P.KC, P.KD, P.KE,
      P.KF, P.KG, P.KH, P.KI, P.KJ, P.KK,
      P.KL, P.KM,
      P.K_ITOGO, -- CQ[14462]
      P.K_PR,    -- CQ[15421]
      P.CORRECTNODE, P.CORRECTNODE_1,
      P.VELICHSTROBJ,
      P.EDIZM,
      P.UTV,
      P.REPLACECORRECTION, P.SPREADONEXISTSREC, P.CORRECTIONRULE,
      V.NUMGLSSR as NUMGLSSR_CALCULATED,
      P.GUID --[10787]E.GUID
  from A_O_PARAMS_R_PR P
  left join V_SELECT_NUMGLSSR(:IDHIER) V on P.ID = :IDHIER
  --[10787]left join ENTITY_GUID E on E.ID = :IDHIER
  where P.ID = :IDHIER
  into
      :ID,
      :NUMGLSSR, :TIPRAB, :SHIFR, :FULLNAME,
      :OPISANIE,
      :ISPOLNIL_FIO, :ISPOLNIL_DOLGN,
      :PROVERIL_FIO, :PROVERIL_DOLGN,
      :UTVERDIL_FIO, :UTVERDIL_DOLGN,
      :SUBPODR_ID_ORG, :SUBPODR_NAME_ORG,
      :SUBPODR_ID, :SUBPODR_FIO, :SUBPODR_DOLGN,
      :KA, :KB, :KC, :KD, :KE,
      :KF, :KG, :KH, :KI, :KJ, :KK,
      :KL, :KM,
      :K_ITOGO, -- CQ[14462]
      :K_PR,    -- CQ[15421]
      :CORRECTNODE, :CORRECTNODE_1,
      :VELICHSTROBJ,
      :EDIZM,
      :UTV,
      :REPLACECORRECTION, SPREADONEXISTSREC, CORRECTIONRULE,
      :NUMGLSSR_CALCULATED,
      :GUID
  do
  begin
    if (coalesce(:GUID, '') = '') then
    begin --<<[10787]
      GUID = COCREATEGUID();
      update A_O_PARAMS_R_PR
        set GUID = :GUID
        where ID = :ID;
    end
      suspend;
  end
end
^

--[15352]
CREATE OR ALTER PROCEDURE V_SELECT_ASMETA_FOR_EXP_ACT_XML (
    ID_USER INTEGER,
    ID_OBJ INTEGER,
    IN_SMETATYPE INTEGER,
    IDHIER INTEGER)
RETURNS (
    ID INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    NUMBER3 INTEGER,
    ATYPE SMALLINT,
    RABMAT INTEGER,
    TAB VARCHAR(42),
    NAME BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    EDIZM_NAME VARCHAR(100),
    EDIZM_FULLNAME VARCHAR(250),
    EDIZM_RELATION DOUBLE PRECISION,
    KOLL DOUBLE PRECISION,
    SKOLL VARCHAR(255),
    NORMARASH DOUBLE PRECISION,
    VRPZ INTEGER,
    ALTTAB VARCHAR(250),
    KA VARCHAR(50),
    KB VARCHAR(50),
    KC VARCHAR(50),
    KD VARCHAR(50),
    KE VARCHAR(50),
    KF VARCHAR(50),
    KG VARCHAR(50),
    KH VARCHAR(50),
    KI VARCHAR(50),
    KJ VARCHAR(50),
    KK VARCHAR(50),
    KL VARCHAR(50),
    KM VARCHAR(50),
    NACH DATE,
    OKONCH DATE,
    TIPRAB INTEGER,
    IDNORMATIV INTEGER,
    KODIR_GROUP_NAME VARCHAR(250),
    KODIR_PODGROUP_NAME VARCHAR(250),
    ISGROUPOKP INTEGER,
    NOMERROD INTEGER,
    PR_ADDED_REC INTEGER,
    PR_VSEGO DOUBLE PRECISION,
    VIDRAB INTEGER,
    UTV INTEGER,
    CORRECTNODE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CORRECTNODE_1 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    CLCMODE INTEGER,
    TYPE_TRUD INTEGER,
    IDFORMULS INTEGER,
    K_ITOGO VARCHAR(50),
    K_PR VARCHAR(50))
AS
declare variable ID_NAME integer;
declare variable PR_NUMBER1 integer;
declare variable PR_NUMBER2 integer;
declare variable PR_NUMBER3 integer;
declare variable PR_VIPOLNENO double precision;
declare variable PR_EXISTS_CHILDS integer;
begin
--[15352]+
    for select S.ID, S.IDHIER,
        S.NUMBER1, S.NUMBER2, S.NUMBER3, S.ATYPE, S.RABMAT, S.TAB, S.NAME_ID, E.NAME, E.FULLNAME, E.RELATION,
        S.KOLL, S.SKOLL, coalesce(S.NORMARASH,0), S.VRPZ, S.ALTTAB,
        S.KA, S.KB, S.KC, S.KD, S.KE, S.KF, S.KG, S.KH, S.KI, S.KJ, S.KK, S.KL, S.KM,
        S.NACH, S.OKONCH, S.TIPRAB, S.IDNORMATIV, GR.NAME, PGR.NAME, S.ISGROUPOKP,
        S.NOMERROD, S.PR_ADDED_REC, /*coalesce(S.PR_VSEGO,0),*/
        S.VIDRAB, S.UTV, S.CORRECTNODE, S.CORRECTNODE_1, S.CLCMODE, S.TYPE_TRUD, S.IDFORMULS,
        s.K_ITOGO/*14460*/, s.K_PR/*15421*/
    from L_EXP_A_SMETA_N(:ID_OBJ, :IN_SMETATYPE, :ID_USER) S
    --left join B_NNAME N on N.ID = S.NAME_ID
    left join B_EDIZM E on E.ID = S.ID_EDIZM
    left join B_GROUP GR on GR.ID = S.KODIR_GROUP
    left join B_PODGROUP PGR on PGR.ID = S.KODIR_PODGROUP
    where IDHIER = :IDHIER order by S.NUMBER1, S.NUMBER2, S.NUMBER3
    into :ID, :IDHIER,
        :NUMBER1, :NUMBER2, :NUMBER3, :ATYPE, :RABMAT, :TAB, :ID_NAME, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION,
        :KOLL, :SKOLL, :NORMARASH, :VRPZ, :ALTTAB,
        :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
        :NACH, :OKONCH, :TIPRAB, :IDNORMATIV, :KODIR_GROUP_NAME, :KODIR_PODGROUP_NAME, :ISGROUPOKP,
        :NOMERROD, :PR_ADDED_REC, /*:PR_VSEGO,*/
        :VIDRAB, :UTV, :CORRECTNODE, :CORRECTNODE_1, :CLCMODE, :TYPE_TRUD, :IDFORMULS,
        :K_ITOGO/*14460*/, :K_PR/*15421*/
    do
    begin
        execute procedure l_pr_select_rec (:id, :ID_USER, :ID_OBJ, 0, 0, 1 , 1)
        returning_values (:PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, PR_VSEGO, PR_VIPOLNENO, :PR_EXISTS_CHILDS );

        select NAME from B_GETNAME(:ID_USER, :ID_NAME) into :NAME;
        suspend;
    end
end
^
/* CQ[15489] >> */
create or alter procedure L_FB_READ_RESOURCES_LIST (
    IN_IDNORMATIV integer,
    IN_PODGROUP integer,
    IN_RABMAT integer,
    CURRENT_GROUP integer,
    CURRENT_PODGROUP integer,
    USE_ESN integer,
    ID_USER integer,
    MEMO blob sub_type 0 segment size 80,
    CNT integer)
returns (
    RES_ID_SELF integer,
    RES_ID_NORM integer,
    NORMA_RASH double precision,
    RES_VIDNR integer,
    RES_UCH integer,
    RES_RABMAT integer,
    ID_SELF integer,
    PODGROUP integer,
    ID_SELF_ORIG integer,
    PODGROUP_ORIG integer,
    IDRES_REESTR integer,
    STATUS integer)
AS
DECLARE VARIABLE RES_CNT INTEGER;
DECLARE VARIABLE LOOP INTEGER;
DECLARE VARIABLE WITHESN INTEGER;
DECLARE VARIABLE ID_RM INTEGER;
DECLARE VARIABLE IDPODGROUPNORM INTEGER;
DECLARE VARIABLE IDRES_RABMAT INTEGER;
DECLARE VARIABLE IDRES_ABC_OKP INTEGER;
DECLARE VARIABLE IDRES_TRUD INTEGER;
DECLARE VARIABLE DOSTUP INTEGER;
DECLARE VARIABLE IS_NULL INTEGER;
DECLARE VARIABLE IDABCOKP INTEGER;
DECLARE VARIABLE RM INTEGER;
DECLARE VARIABLE RM1 INTEGER;
DECLARE VARIABLE IS_FOUND INTEGER;
DECLARE VARIABLE IS_VALID_REFERENCE INTEGER;
DECLARE VARIABLE READ_ONE_RESURS INTEGER;
DECLARE VARIABLE ID_RESURS INTEGER;
DECLARE VARIABLE i INTEGER;
begin
   /*
      RES_ID_NORM - ID ,    .
             IN_IDNORMATIV       
   */

   ID_SELF = 0;
   RES_ID_NORM = 0;
   i = 0;

   READ_ONE_RESURS = 0;
   ID_RESURS = null;

   if ( CNT is null ) then
      CNT = 0;
   if (
        ( ( not MEMO is null ) and ( CNT > 0 ) )
        or
        ( ( not IN_IDNORMATIV is null ) and
          ( IN_PODGROUP is null ) and ( IN_RABMAT is null ) and ( CURRENT_GROUP is null ) and ( CURRENT_PODGROUP is null )
        )
      ) then
   begin
      READ_ONE_RESURS = 1;
      ID_RESURS = IN_IDNORMATIV;
   end
   else
   begin
      /*      */
      if ( not ( IN_RABMAT in ( 0, 2, 3 ) ) ) then
         exit;
      if ( ( IN_IDNORMATIV is null ) or ( IN_IDNORMATIV = 0 ) ) then
         exit;
   end

   LOOP = 0;
   if ( ( not USE_ESN is null ) and ( USE_ESN = 0 ) ) then
      LOOP = 1; /* don't search in esn */
   RES_CNT = 0;

   while (
           ( ( CNT = 0 ) and ( LOOP < 2 ) )  -- loop for esn
           or
           ( ( CNT <> 0 ) and ( i < CNT ) )  -- loop for blob
         ) do
   begin
      /*      */
      if ( ( IN_PODGROUP in ( 0 , 1 ) ) or ( READ_ONE_RESURS <> 0 ) ) then
      begin
         /*    */
         if ( ( READ_ONE_RESURS <> 0 ) and ( CNT <> 0 ) ) then
            ID_RESURS = readintfromblob ( MEMO , i );

         RES_CNT = 0;

--         for select ID, /*IDRES,*/ KOLL, VIDNR, UCH, RABMAT, idpodgroupnorm, IDRES_RABMAT, IDRES_ABC_OKP, IDRES_TRUD, IDRES_REESTR
--             from B_RESURS
--             where ( ( :READ_ONE_RESURS = 0 ) and
--                     ( idrab = :IN_IDNORMATIV ) and ( idgroup = :CURRENT_GROUP ) and ( idpodgroup = :CURRENT_PODGROUP )
--                   ) or
--                   ( ( :READ_ONE_RESURS <> 0 ) and
--                     ( ID = :ID_RESURS )
--                   )
--             order by rabmat
----             order by idrab , idgroup , idpodgroup , rabmat
--             into :RES_ID_SELF, /*:ID_SELF,*/ :NORMA_RASH, :RES_VIDNR, :RES_UCH, :RES_RABMAT, :idpodgroupnorm, :IDRES_RABMAT, :IDRES_ABC_OKP, :IDRES_TRUD, :IDRES_REESTR
--         do

         for select RES_ID_SELF
             from L_FB_READ_RES_LIST_IDS ( :IN_IDNORMATIV , :CURRENT_GROUP , :CURRENT_PODGROUP , :ID_RESURS , :READ_ONE_RESURS , :ID_USER )
             into  :RES_ID_SELF
         do
         for select first 1 /*IDRES,*/ KOLL, VIDNR, UCH, RABMAT, idpodgroupnorm, IDRES_RABMAT, IDRES_ABC_OKP, IDRES_TRUD, IDRES_REESTR
             from B_RESURS
             where ID = :RES_ID_SELF
             into /*:ID_SELF,*/ :NORMA_RASH, :RES_VIDNR, :RES_UCH, :RES_RABMAT, :idpodgroupnorm, :IDRES_RABMAT, :IDRES_ABC_OKP, :IDRES_TRUD, :IDRES_REESTR
         do
         begin
            STATUS = null;
            select first 1 status
            from B_RESURS_EX
            where id = :RES_ID_SELF
            into STATUS;

            if ( :RES_VIDNR is null ) then RES_VIDNR = 0;

            RES_ID_NORM = IN_IDNORMATIV;
            PODGROUP = idpodgroupnorm; -- CQ[15489] /*idpodgroupnorm */ CURRENT_PODGROUP;
            RES_CNT = RES_CNT + 1;

/**/
            if ( idpodgroupnorm > 1 ) then
               ID_SELF = IDRES_ABC_OKP;
            else if ( RES_RABMAT = 1 ) then
               ID_SELF = IDRES_TRUD;
            else
               ID_SELF = IDRES_RABMAT;
            IS_NULL = 0;
            if ( ID_SELF is null ) then
            begin
               ID_SELF = 0;
               IS_NULL = 1;
            end
            ID_SELF_ORIG = ID_SELF;
            PODGROUP_ORIG = PODGROUP;

/**/

            /*    L_FB_READ_SBORNIK     B_RABMAT  B_ABC_OKP */
            if ( idpodgroupnorm /*CURRENT_PODGROUP*/ > 1 ) then
            begin
              /*     B_RABMAT/B_TRUD */
              id_rm = 0;
              for select IDNORMA, rabmat from b_abc_okp where id = :ID_SELF
                  into id_rm, rm
              do
              begin
                 if ( id_rm is null ) then
                    id_rm = 0;

                 execute procedure L_FB_ISVALIDREFERENCETORABMAT ( :ID_SELF , :id_rm , :rm )
                    returning_values ( :is_valid_reference );

                 if ( ( is_valid_reference = 0 ) or ( id_rm is null ) ) then
                    id_rm = 0;
              end

              if ( id_rm > 0 ) then
              begin
                 PODGROUP = 1;
                 ID_SELF  = id_rm;
              end
            end

            if ( IS_NULL = 0 ) then
            begin
               execute procedure l_k_test_dostup ( :ID_SELF, :RES_RABMAT, :PODGROUP, :ID_USER ) returning_values ( :DOSTUP );
               if ( DOSTUP <> 0 ) then
                  suspend;
            end
            else
               suspend;
         end
      end
      /*     AVS_OKP */
      else
      begin
         exit;
      end

      if ( CNT = 0 ) then
      begin

         if ( READ_ONE_RESURS <> 0 ) then
            exit;

         if ( RES_CNT <> 0 ) then
            exit;
         if ( LOOP <> 0 ) then
            exit;
         if ( not IN_PODGROUP in ( 0 , 1 ) ) then /* IDWITHESN only in B_RABMAT */
            exit;
         /*   ,     ,      */
         WITHESN = 0;
         for select IDWITHESN from b_rabmat where id = :in_idnormativ into WITHESN
         do
            WITHESN = WITHESN;
         if ( ( WITHESN is null ) or ( WITHESN = 0 ) ) then
            exit;
         IN_IDNORMATIV = WITHESN;
         LOOP = LOOP + 1;

      end
      else
         i = i + 1;
   end
end
^

-- Voyager CQ[15110]
create or alter procedure V_UPGRADE_L_SSR
as
begin
  if (not exists(
      select * from RDB$RELATION_FIELDS F
        where (upper(F.RDB$RELATION_NAME) = 'L_SSR') and
              (upper(F.RDB$FIELD_NAME) = 'IS_USER_STRING'))) then
  begin
    execute statement
        'ALTER TABLE L_SSR ADD IS_USER_STRING B_D_INTEGER';
   end
end
^
execute procedure V_UPGRADE_L_SSR
^
drop procedure V_UPGRADE_L_SSR
^^

create or alter procedure T_SSR_EXP_XML_SELECT_ONE_REC (
    ID_SSR integer,
    ID     integer)
returns (
    ID_REC         integer,
    NM_GL          integer,
    NM_NACH        integer,
    NM_OBJ_STRUC   integer,
    OBJ_STRUC_TYPE integer,
    ID_OBJ_STRUC   integer,
    CALC_POLN      integer,
    NPP_GL         integer,
    NSR            varchar(1024),
    NAME           varchar(1024),
    RUS_NAME       varchar(30),
    UNIONS         integer,
    PRINT          smallint,
    I1_FRM         blob sub_type 0 segment size 80,
    I2_FRM         blob sub_type 0 segment size 80,
    I3_FRM         blob sub_type 0 segment size 80,
    I4_FRM         blob sub_type 0 segment size 80,
    I5_FRM         blob sub_type 0 segment size 80,
    I6_FRM         blob sub_type 0 segment size 80,
    I1_VAL         double precision,
    I2_VAL         double precision,
    I3_VAL         double precision,
    I4_VAL         double precision,
    I5_VAL         double precision,
    I6_VAL         double precision,
    TIP_ZATRAT     integer,
    STRUCT_GUID    varchar(100),
    IDVRZUCL       integer,
    VRIDDOC        integer,
    VRNPPTEXT      varchar(20),
    VRPRVALUE      double precision,
    ZUIDDOC        integer,
    ZUNPPTEXT      varchar(20),
    ZUPRVALUE      double precision,
    CLIDDOC        integer,
    CLNPPTEXT      varchar(20),
    CLZONE         integer,
    CLKOEF         double precision,
    IS_USER_STRING integer)
AS
--CQ[TIMUR 13931] -    NSR, NAME
begin

  select ID_REC, NM_GL, NM_NACH, NM_OBJ_STRUC, OBJ_STRUC_TYPE, ID_OBJ_STRUC, CALC_POLN,
         NPP_GL, NSR, NAME, RUS_NAME, UNIONS, PRINT,
         I1_FRM, I2_FRM, I3_FRM, I4_FRM, I5_FRM, I6_FRM,
         I1_VAL, I2_VAL, I3_VAL, I4_VAL, I5_VAL, I6_VAL,
         TIP_ZATRAT, IDVRZUCL
         , S.IS_USER_STRING -- Voyager CQ[15110]
  from L_SSR S where (ID_SSR = :ID_SSR) and (ID_REC = :ID)
  into :ID_REC, :NM_GL, :NM_NACH, :NM_OBJ_STRUC, :OBJ_STRUC_TYPE, :ID_OBJ_STRUC, :CALC_POLN,
       :NPP_GL, :NSR, :NAME, :RUS_NAME, :UNIONS, :PRINT,
       :I1_FRM, :I2_FRM, :I3_FRM, :I4_FRM, :I5_FRM, :I6_FRM,
       :I1_VAL, :I2_VAL, :I3_VAL, :I4_VAL, :I5_VAL, :I6_VAL,
       :TIP_ZATRAT, :IDVRZUCL
       , :IS_USER_STRING; -- Voyager CQ[15110]

  STRUCT_GUID = "";
  if (NM_OBJ_STRUC is not null) then
  begin
    if (OBJ_STRUC_TYPE = 1) then
      select GUID
        from ENTITY_GUID
      where ID = :ID_OBJ_STRUC
      into :STRUCT_GUID;

    else if (OBJ_STRUC_TYPE = 3) then
      select GUID
        from A_O_PARAMS_LS
      where ID = :ID_OBJ_STRUC
      into :STRUCT_GUID;

    else if ((OBJ_STRUC_TYPE = 4) or (OBJ_STRUC_TYPE = 5))  then
      select GUID
        from A_O_PARAMS_R_PR
      where ID = :ID_OBJ_STRUC
      into :STRUCT_GUID;
  end

  select VRIDDOC, VRNPPTEXT, VRPRVALUE,
         ZUIDDOC, ZUNPPTEXT, ZUPRVALUE,
         CLIDDOC, CLNPPTEXT, CLZONE, CLKOEF
  from V_SELECT_VRZUCL_EXP_OBJ_XML(:IDVRZUCL)
  into :VRIDDOC, :VRNPPTEXT, :VRPRVALUE,
       :ZUIDDOC, :ZUNPPTEXT, :ZUPRVALUE,
       :CLIDDOC, :CLNPPTEXT, :CLZONE, :CLKOEF;

  suspend;

end
^

create or alter procedure T_SSR_IMP_XML_ONE_REC (
    ID_SSR         integer,
    ID_REC         integer,
    NM_GL          integer,
    NM_NACH        integer,
    NM_OBJ_STRUC   integer,
    OBJ_STRUC_TYPE integer,
    ID_OBJ_STRUC   integer,
    CALC_POLN      integer,
    NPP_GL         integer,
    NSR            varchar(1024),
    NAME           varchar(1024),
    RUS_NAME       varchar(30),
    UNIONS         integer,
    PRINT          smallint,
    I1_FRM         blob sub_type 0 segment size 80,
    I2_FRM         blob sub_type 0 segment size 80,
    I3_FRM         blob sub_type 0 segment size 80,
    I4_FRM         blob sub_type 0 segment size 80,
    I5_FRM         blob sub_type 0 segment size 80,
    I6_FRM         blob sub_type 0 segment size 80,
    I1_VAL         double precision,
    I2_VAL         double precision,
    I3_VAL         double precision,
    I4_VAL         double precision,
    I5_VAL         double precision,
    I6_VAL         double precision,
    TIP_ZATRAT     integer,
    STRUCT_GUID    varchar(100),
    IDVRZUCL       integer,
    VRIDDOC        integer,
    VRNPPTEXT      varchar(20),
    VRPRVALUE      double precision,
    ZUIDDOC        integer,
    ZUNPPTEXT      varchar(20),
    ZUPRVALUE      double precision,
    CLIDDOC        integer,
    CLNPPTEXT      varchar(20),
    CLZONE         integer,
    CLKOEF         double precision,
    IS_USER_STRING integer)
AS
--CQ[TIMUR 13931] -    NSR, NAME
declare variable FIND_ID_OBJ_STRUC integer;
declare variable NEW_IDVRZUCL integer;
begin

  execute procedure T_FIND_STRUCT_BY_GUID (:STRUCT_GUID, :OBJ_STRUC_TYPE, :NAME, :NSR)
  returning_values :FIND_ID_OBJ_STRUC;

  if (FIND_ID_OBJ_STRUC is not null) then
    ID_OBJ_STRUC = FIND_ID_OBJ_STRUC;

  if ((IDVRZUCL = 0) or (IDVRZUCL is null)) then
    NEW_IDVRZUCL = null;
  else
    execute procedure A_SET_G_NUMBER_OBG 1 returning_values :NEW_IDVRZUCL;

  if (NEW_IDVRZUCL is not null) then
    insert into M_STRUCT_PARAMS_VRZUCL(ID, VRIDDOC, VRNPPTEXT, VRPRVALUE,
                                       ZUIDDOC, ZUNPPTEXT, ZUPRVALUE,
                                       CLIDDOC, CLNPPTEXT, CLKOEF, CLZONE)
    values(:NEW_IDVRZUCL, :VRIDDOC, :VRNPPTEXT, :VRPRVALUE,
           :ZUIDDOC, :ZUNPPTEXT, :ZUPRVALUE,
           :CLIDDOC, :CLNPPTEXT, :CLKOEF, :CLZONE);

  insert into L_SSR(
     ID_SSR, ID_REC, NM_GL, NM_NACH, NM_OBJ_STRUC, OBJ_STRUC_TYPE, ID_OBJ_STRUC, CALC_POLN,
     NPP_GL, NSR, NAME, RUS_NAME, UNIONS, PRINT,
     I1_FRM, I2_FRM, I3_FRM, I4_FRM, I5_FRM, I6_FRM,
     I1_VAL, I2_VAL, I3_VAL, I4_VAL, I5_VAL, I6_VAL,
     TIP_ZATRAT, IDVRZUCL
     ,IS_USER_STRING) -- Voyager CQ[15110]
  values(
     :ID_SSR, :ID_REC, :NM_GL, :NM_NACH, :NM_OBJ_STRUC, :OBJ_STRUC_TYPE, :ID_OBJ_STRUC, :CALC_POLN,
     :NPP_GL, :NSR, :NAME, :RUS_NAME, :UNIONS, :PRINT,
     :I1_FRM, :I2_FRM, :I3_FRM, :I4_FRM, :I5_FRM, :I6_FRM,
     :I1_VAL, :I2_VAL, :I3_VAL, :I4_VAL, :I5_VAL, :I6_VAL,
     :TIP_ZATRAT, :NEW_IDVRZUCL
     ,:IS_USER_STRING); --Voyager CQ[15110]

end
^

create or alter procedure T_SSR_IMP_XML_ONE_REC_ATOM (
    ID_SSR         integer,
    ID_REC         integer,
    NM_GL          integer,
    NM_NACH        integer,
    NM_OBJ_STRUC   integer,
    OBJ_STRUC_TYPE integer,
    ID_OBJ_STRUC   integer,
    CALC_POLN      integer,
    NPP_GL         integer,
    NSR            varchar(1024),
    NAME           varchar(1024),
    RUS_NAME       varchar(30),
    UNIONS         integer,
    PRINT          smallint,
    I1_FRM         blob sub_type 0 segment size 80,
    I2_FRM         blob sub_type 0 segment size 80,
    I3_FRM         blob sub_type 0 segment size 80,
    I4_FRM         blob sub_type 0 segment size 80,
    I5_FRM         blob sub_type 0 segment size 80,
    I6_FRM         blob sub_type 0 segment size 80,
    I1_VAL         double precision,
    I2_VAL         double precision,
    I3_VAL         double precision,
    I4_VAL         double precision,
    I5_VAL         double precision,
    I6_VAL         double precision,
    TIP_ZATRAT     integer,
    STRUCT_GUID    varchar(100),
    IDVRZUCL       integer,
    VRIDDOC        integer,
    VRNPPTEXT      varchar(20),
    VRPRVALUE      double precision,
    ZUIDDOC        integer,
    ZUNPPTEXT      varchar(20),
    ZUPRVALUE      double precision,
    CLIDDOC        integer,
    CLNPPTEXT      varchar(20),
    CLZONE         integer,
    CLKOEF         double precision,
    IS_USER_STRING integer)
AS
--CQ[TIMUR 13931] -    NSR, NAME
declare variable FIND_ID_OBJ_STRUC integer;
declare variable NEW_IDVRZUCL integer;
begin
  /* :     T_SSR_IMP_XML_ONE_REC.    . */

  if (coalesce(:ID_OBJ_STRUC, 0) = 0) then
  begin
    execute procedure T_FIND_STRUCT_BY_GUID (:STRUCT_GUID, :OBJ_STRUC_TYPE, :NAME, :NSR)
    returning_values :FIND_ID_OBJ_STRUC;
    if (:FIND_ID_OBJ_STRUC is not null) then
      ID_OBJ_STRUC = :FIND_ID_OBJ_STRUC;
  end

  if ((IDVRZUCL = 0) or (IDVRZUCL is null)) then
    NEW_IDVRZUCL = null;
  else
    execute procedure A_SET_G_NUMBER_OBG 1 returning_values :NEW_IDVRZUCL;

  if (NEW_IDVRZUCL is not null) then
    insert into M_STRUCT_PARAMS_VRZUCL(ID, VRIDDOC, VRNPPTEXT, VRPRVALUE,
                                       ZUIDDOC, ZUNPPTEXT, ZUPRVALUE,
                                       CLIDDOC, CLNPPTEXT, CLKOEF, CLZONE)
    values(:NEW_IDVRZUCL, :VRIDDOC, :VRNPPTEXT, :VRPRVALUE,
           :ZUIDDOC, :ZUNPPTEXT, :ZUPRVALUE,
           :CLIDDOC, :CLNPPTEXT, :CLKOEF, :CLZONE);

  insert into L_SSR(
     ID_SSR, ID_REC, NM_GL, NM_NACH, NM_OBJ_STRUC, OBJ_STRUC_TYPE, ID_OBJ_STRUC, CALC_POLN,
     NPP_GL, NSR, NAME, RUS_NAME, UNIONS, PRINT,
     I1_FRM, I2_FRM, I3_FRM, I4_FRM, I5_FRM, I6_FRM,
     I1_VAL, I2_VAL, I3_VAL, I4_VAL, I5_VAL, I6_VAL,
     TIP_ZATRAT, IDVRZUCL,
     IS_USER_STRING) -- Voyager CQ[15110]
  values(
     :ID_SSR, :ID_REC, :NM_GL, :NM_NACH, :NM_OBJ_STRUC, :OBJ_STRUC_TYPE, :ID_OBJ_STRUC, :CALC_POLN,
     :NPP_GL, :NSR, :NAME, :RUS_NAME, :UNIONS, :PRINT,
     :I1_FRM, :I2_FRM, :I3_FRM, :I4_FRM, :I5_FRM, :I6_FRM,
     :I1_VAL, :I2_VAL, :I3_VAL, :I4_VAL, :I5_VAL, :I6_VAL,
     :TIP_ZATRAT, :NEW_IDVRZUCL,
     :IS_USER_STRING); -- Voyager CQ[15110]

end
^
/* CQ[15489] >> */
create or alter procedure L_FB_SEARCH_ID_IN_ONE_PUT_VER_2 (
    ID_PUT integer,
    IN_RABMAT integer,
    STAB varchar(42),
    FETCHMODE integer)
returns (
    ID_SELF integer,
    ID_ABC_OKP integer,
    BEDA integer)
AS
declare variable PUTNAME_ID_SELF integer;
declare variable ID_REESTR integer;
declare variable ID_SBORNIK integer;
declare variable REESTR_CNT integer;
declare variable REESTR_PROCESS_CNT integer;
declare variable BAD_RASCEN_CNT integer;
declare variable IDABCOKP integer;
declare variable TABU1 varchar(42);
declare variable TABU2 varchar(42);
declare variable ORDERVIEW integer;
declare STAB_8 varchar(42);
begin

  -- CQ[15489]   ID        STAB.    L_FB_SEARCH_ID_IN_ONE_PUT

  ID_SELF = 0;
  ID_SBORNIK = 0;
  ID_ABC_OKP = 0;
  beda = 0;/*     */

  if (FETCHMODE is null) then
    FETCHMODE = 0;

  if (not(in_rabmat in (0, 1, 2, 3))) then
  begin
    beda = 3;/*  rabmat */
    suspend;
    exit;
  end

  STAB_8 = S_TRANSLITERATE(:STAB);--[14280,12447]
  STAB = S_TRANSLITERATE_TAB(STAB);--[12447]

  /*  */
  if (in_rabmat = 1) then
  begin
    for select ID, IDABCOKP, ORDERVIEW
      from b_trud t
      where t.tabu starting with :stab and
            S_TRANSLITERATE(t.TAB) starting with :STAB_8
      into :ID_SELF, :IDABCOKP, :ORDERVIEW
    do
      if (not ORDERVIEW is null) then
      /* if not in buffer */
      begin
        if ((IDABCOKP <> 0) and (not ID_ABC_OKP is null)) then
          for select ID
            from b_abc_okp
            where id = :IDABCOKP
            into :IDABCOKP
          do
            ID_ABC_OKP = IDABCOKP;
        suspend;
        if (FETCHMODE <> 1) then
          exit;
      end
    exit;
  end

  putname_id_self = null;
  select n.id
  from b_putname n
  where (n.id = :id_put) and
        /*  ( n.iduser = :id_user ) and */
        (n.rabmat = :in_rabmat)
  into :putname_id_self;

  if (putname_id_self is null) then
  begin
    beda = 1;/*     */
    suspend;
    exit;
  end

  reestr_cnt = 0;
  reestr_process_cnt = 0;
  bad_rascen_cnt = 0;
  for select v.idreestr
    from b_putview v
    where (v.idputname = :id_put)
    order by v.orderview
    into :id_reestr
  do
  begin
    reestr_cnt = reestr_cnt + 1;
    begin
      reestr_process_cnt = reestr_process_cnt + 1;
      for select id, idreestr, IDABCOKP, tabu
        from b_rabmat r
        where (r.idpapka = :id_reestr) and
              (r.tabu starting with :stab) and
              (S_TRANSLITERATE(r.TAB) starting with :STAB_8)
        into :id_self, :ID_SBORNIK, :IDABCOKP, :TABU1
      do
      begin
        if (exists(select *
                   from B_REESTR
                   where ID = :ID_SBORNIK and
                         IDPARENT > 0)) then --[15160]
        begin
          if ((IDABCOKP <> 0) and (not ID_ABC_OKP is null)) then
            for select ID, comment
              from b_abc_okp
              where id = :IDABCOKP
              into :IDABCOKP, :TABU2
            do
              if ((TABU2 is null) or
                  (TABU2 = '') or
                  (TABU1 = S_TRANSLITERATE_TAB(TABU2))) then --[12447]
                ID_ABC_OKP = IDABCOKP;
          suspend;
          if (FETCHMODE <> 1) then
            exit;
        end
      end
    end
  end

  /*    */

  ID_SBORNIK = 0;
  if (reestr_cnt = 0) then
  begin
    beda = 2;/*    */
    suspend;
    exit;
  end
  if (reestr_process_cnt = 0) then
  begin
    beda = 4;/*    ,      */
    suspend;
    exit;
  end
  if (bad_rascen_cnt <> 0) then
  begin
    beda = 5;/*    ,     
                       rabmat,    rabmat   */
    suspend;
    exit;
  end

  --  suspend;
end
^
/* CQ[15489] >> */
create or alter procedure L_FB_SEARCH_ID_TAB_START (
    STAB varchar(42),
    IN_RABMAT integer,
    ID_USER integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer,
    FETCHMODE integer,
    ID_PUT_TRUD integer)
returns (
    ID_SELF integer,
    PODGROUP integer,
    RABMAT integer,
    ID_ABC_OKP integer,
    BEDA1 integer,
    BEDA2 integer,
    BEDARAB integer,
    BEDAMASH integer,
    BEDAMAT integer)
AS
declare variable TRY_RABMAT integer;
declare variable CURR_RABMAT integer;
declare variable CURR_ID integer;
declare variable ID_PUT integer;
declare variable BEDA integer;
declare variable TRY_RAB integer;
declare variable TRY_MASH integer;
declare variable TRY_MAT integer;
declare variable TRY_RMM integer;
declare variable CNT integer;
declare variable DOSTUP integer;
begin

  -- CQ[15489]   ID        STAB.    L_FB_SEARCH_ID

  /*
    IN_RABMAT:
     -1 - rabmat   ,      
      0,1,2,3 - rabmat   ,       (  ),
                   -     

    ID_PUT_RAB, ID_PUT_MAT, ID_PUT_MAT:
     -1 -    
      0 -     
    > 0 -      ID )
*/

  ID_SELF = 0;
  PODGROUP = 0;
  RABMAT = 0;
  ID_ABC_OKP = 0;
  BEDA1 = 0;
  BEDA2 = 0;
  BEDARAB = 0;
  BEDAMASH = 0;
  BEDAMAT = 0;

  if (FETCHMODE is null) then
    FETCHMODE = 0;

  if (not(IN_RABMAT in (-1, 0, 1, 2, 3))) then
  begin
    beda1 = 3;/*  rabmat */
    suspend;
    exit;
  end

  if (id_user < 0) then
  begin
    id_user = -id_user;
    if (IsUsersTab(:stab) <> 0) then
      exit;
  end

  /*****************************************************************************
                         
******************************************************************************/

  /*   id_put -    */
  /*  */
  if (id_put_rab > 0) then
  begin
    CURR_ID = null;
    CNT = 0;
    for select id
      from b_putname
      where (id = :id_put_rab) and
            (rabmat = 0)
      into :CURR_ID
    do
      CNT = CNT + 1;
    if (cnt = 0) then
      bedarab = 1;/*     */
    else
    if (cnt > 1) then
      bedarab = 6;/*   id   */
    if (cnt <> 1) then
      id_put_rab = 0;/*      */
  end

  /*   id_put -    */
  /*  */
  if (id_put_mash > 0) then
  begin
    CURR_ID = null;
    CNT = 0;
    for select id
      from b_putname
      where (id = :id_put_mash) and
            (rabmat = 2)
      into :CURR_ID
    do
      CNT = CNT + 1;
    if (cnt = 0) then
      bedamash = 1;/*     */
    else
    if (cnt > 1) then
      bedamash = 6;/*   id   */
    if (cnt <> 1) then
      id_put_mash = 0;/*      */
  end

  /*   id_put -    */
  /*  */
  if (id_put_mat > 0) then
  begin
    CURR_ID = null;
    CNT = 0;
    for select id
      from b_putname
      where (id = :id_put_mat) and
            (rabmat = 3)
      into :CURR_ID
    do
      CNT = CNT + 1;
    if (cnt = 0) then
      bedamat = 1;/*     */
    else
    if (cnt > 1) then
      bedamat = 6;/*   id   */
    if (cnt <> 1) then
      id_put_mat = 0;/*      */
  end

  /* determine current id_put_rab , mash , mat */
  if (id_put_rab = -1) then
  begin
    select idput0
    from b_user_access u
    where u.id = :id_user
    into :id_put_rab;
    if ((id_put_rab is null) or
        (id_put_rab = 0)) then
      bedarab = 12;/*      */
  end
  if (id_put_mash = -1) then
  begin
    select idput2
    from b_user_access u
    where u.id = :id_user
    into :id_put_mash;
    if ((id_put_mash is null) or
        (id_put_mash = 0)) then
      bedamash = 12;/*      */
  end
  if (id_put_mat = -1) then
  begin
    select idput3
    from b_user_access u
    where u.id = :id_user
    into :id_put_mat;
    if ((id_put_mat is null) or
        (id_put_mat = 0)) then
      bedamat = 12;/*      */
  end

  if (IN_RABMAT <> -1) then
    TRY_RABMAT = -1;/*     RABMAT ,   ., ., . */
  else
    TRY_RABMAT = 0;/*    ,   ., . */
  /* TRY_xxx : 0 -    , 1 -   */
  TRY_RAB = 0;
  TRY_MASH = 0;
  TRY_MAT = 0;
  /*  */

  while (TRY_RABMAT < 4) do
  begin
    if (TRY_RABMAT = -1) then
      CURR_RABMAT = IN_RABMAT;
    else
      CURR_RABMAT = TRY_RABMAT;

    if (CURR_RABMAT = 0) then
      ID_PUT = id_put_rab;
    else
    if (CURR_RABMAT = 2) then
      ID_PUT = id_put_mash;
    else
    if (CURR_RABMAT = 3) then
      ID_PUT = id_put_mat;

    if (CURR_RABMAT = 0) then
      TRY_RMM = TRY_RAB;
    else
    if (CURR_RABMAT = 2) then
      TRY_RMM = TRY_mash;
    else
    if (CURR_RABMAT = 3) then
      TRY_RMM = TRY_mat;

    if ((id_put > 0) and (TRY_RMM = 0)) then
    begin
      TRY_RMM = 1;
      for select ID_SELF, ID_ABC_OKP, BEDA
        from L_FB_SEARCH_ID_IN_ONE_PUT_VER_2(:id_put, :CURR_RABMAT, :stab, :FETCHMODE)
        into :ID_SELF, :ID_ABC_OKP, :BEDA
      do
      begin
        RABMAT = CURR_RABMAT;
        if (ID_SELF <> 0) then
        begin
          execute procedure L_K_TEST_DOSTUP(:ID_SELF, :RABMAT, :PODGROUP, :ID_USER)
          returning_values (:DOSTUP);
          if (DOSTUP = 0) then
          begin
            ID_SELF = 0;
            PODGROUP = 0;
            ID_ABC_OKP = 0;
            BEDA1 = 0;
            BEDA2 = 0;
            BEDARAB = 0;
            BEDAMASH = 0;
            BEDAMAT = 0;
          end
          else
          begin
            PODGROUP = 1;
            suspend;
            if (FETCHMODE <> 1) then
              exit;
          end
        end
        if (RABMAT = 0) then
          BEDARAB = BEDA;
        else
        if (RABMAT = 2) then
          BEDAMASH = BEDA;
        else
        if (RABMAT = 3) then
          BEDAMAT = BEDA;

      end
    end

    if (CURR_RABMAT = 0) then
      TRY_RAB = TRY_RMM;
    else
    if (CURR_RABMAT = 2) then
      TRY_mash = TRY_RMM;
    else
    if (CURR_RABMAT = 3) then
      TRY_mat = TRY_RMM;

    TRY_RABMAT = TRY_RABMAT + 1;
    if (TRY_RABMAT = 1) then
      TRY_RABMAT = TRY_RABMAT + 1;
  end

  /*****************************************************************************
                        b_trud
******************************************************************************/

  /*       b_trud */
  if (IN_RABMAT in (-1, 1)) then
  begin
    if ((ID_PUT_TRUD is null) or
        (ID_PUT_TRUD <> 0)) then
    begin
      for select ID_SELF, ID_ABC_OKP, BEDA
        from L_FB_SEARCH_ID_IN_ONE_PUT_VER_2(0, 1, :stab, :FETCHMODE)
        into :ID_SELF, :ID_ABC_OKP, :BEDA1
      do
        if (ID_SELF <> 0) then
        begin
          RABMAT = 1;
          PODGROUP = 1;

          BEDA1 = 0;
          BEDA2 = 0;
          BEDARAB = 0;
          BEDAMASH = 0;
          BEDAMAT = 0;

          suspend;
          if (FETCHMODE <> 1) then
            exit;
        end
    end
  end

  /*****************************************************************************

******************************************************************************/

  if (ID_SELF = 0) then
    RABMAT = -1;

  --  suspend;
end
^
/* CQ[15489] >> */
create or alter procedure L_FB_LSHOWRES_VER_2 (
    MODE integer,
    STAB varchar(42),
    IDS blob sub_type 0 segment size 80,
    IN_IDNORMATIV integer,
    IN_PODGROUP integer,
    IN_RABMAT integer,
    CURRENT_GROUP integer,
    CURRENT_PODGROUP integer,
    ID_ZONE integer,
    ID_USER integer,
    USE_ESN integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer)
returns (
    RES_ID_SELF integer,
    RES_ID_NORM integer,
    NORMA_RASH double precision,
    RES_VIDNR integer,
    RES_UCH integer,
    RES_RABMAT integer,
    RES_IDRES integer,
    ID_SELF integer,
    PODGROUP integer,
    RABMAT integer,
    ID_ABC_OKP integer,
    BEDA integer,
    NAME_PART blob sub_type 0 segment size 80,
    NAME_TITLE blob sub_type 0 segment size 80,
    IDNAME integer,
    ID_UNIQUE integer,
    TAB varchar(42),
    TABU varchar(42),
    ALTTAB varchar(250),
    IDEDIZM integer,
    EDIZM_NAME varchar(100),
    EDIZM_FULLNAME varchar(255),
    comment varchar(42),
    RAZRAD double precision,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    VRPZ integer,
    NTR integer,
    PUNKTIND varchar(42),
    ISESN integer,
    IDWITHESN integer,
    CCURRENT_BA double precision,
    CCURRENT_BB double precision,
    CCURRENT_BC double precision,
    CCURRENT_BD double precision,
    CCURRENT_BE double precision,
    CCURRENT_ZONE integer,
    IDQUALIFIER integer,
    IDNORMTYPE integer,
    NORM_GUID varchar(100),
    IDREESTR integer,
    ABC_OKP_NAME_PART blob sub_type 0 segment size 80,
    ABC_OKP_NAME_TITLE blob sub_type 0 segment size 80,
    ABC_OKP_RABMAT integer,
    ABC_OKP_IDNAME integer,
    ABC_OKP_ID_UNIQUE integer,
    ABC_OKP_TAB varchar(42),
    ABC_OKP_TABU varchar(42),
    ABC_OKP_IDGROUP integer,
    ABC_OKP_IDPODGROUP integer,
    ABC_OKP_ISGROUPOKP integer,
    ABC_OKP_IDEDIZM integer,
    ABC_OKP_EDIZM_NAME varchar(100),
    ABC_OKP_EDIZM_FULLNAME varchar(255),
    ABC_OKP_CENA double precision,
    ABC_OKP_RAZRAD double precision,
    ABC_OKP_VIDNR integer,
    ABC_OKP_COMMENT varchar(42),
    ABC_OKP_PUNKTIND varchar(42),
    ABC_OKP_VRPZ integer,
    ABC_OKP_NTR integer,
    ABC_OKP_CCURRENT double precision,
    ABC_OKP_CCURRENT_ZONE integer,
    ABC_OKP_IDQUALIFIER integer,
    PROCENT_PARTNR double precision,
    IDVER_ABC_OKP integer,
    TYPE_TRUD integer,
    ABC_OKP_TYPE_TRUD integer)
AS
declare variable I integer;
declare variable IDS_ID_SELF integer;
declare variable IDS_RABMAT integer;
declare variable IDS_PODGR integer;
declare variable ID_BLOB_GEN integer;
begin
  -- CQ[15489] L_FB_LSHOWRES_VER_2

  if (not IDS is null) then
  begin
    /* clear blob */
    ID_BLOB_GEN = gen_id(B_GEN_TEMP, 1);
    insert into B_TEMP_BLOB (ID, BLOB1)
    values (:ID_BLOB_GEN, :IDS);
    select BLOB1
    from B_TEMP_BLOB
    where ID = :ID_BLOB_GEN
    into :IDS;
    delete from B_TEMP_BLOB
    where ID = :ID_BLOB_GEN;
  end

  IDVER_ABC_OKP = null;

  if (mode = 0) then -- lsrmRes
    for select RES_ID_SELF, RES_ID_NORM, NORMA_RASH, RES_VIDNR, RES_UCH, RES_RABMAT, RES_IDRES,
               ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA, NAME_PART, NAME_TITLE, IDNAME,
               ID_UNIQUE, TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, comment, RAZRAD,
               BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE, VRPZ, NTR, PUNKTIND,
               ISESN, IDWITHESN, CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE,
               CCURRENT_ZONE, IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR, ABC_OKP_NAME_PART,
               ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE, ABC_OKP_TAB,
               ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
               ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME, ABC_OKP_CENA,
               ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND, ABC_OKP_VRPZ,
               ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER, TYPE_TRUD,
               ABC_OKP_TYPE_TRUD
      from l_fb_read_resources(:IN_IDNORMATIV, :IN_PODGROUP, :IN_RABMAT, :CURRENT_GROUP, :CURRENT_PODGROUP, :ID_USER, :ID_ZONE, :USE_ESN, null, null)
      into RES_ID_SELF, RES_ID_NORM, NORMA_RASH, RES_VIDNR, RES_UCH, RES_RABMAT, RES_IDRES, ID_SELF,
           PODGROUP, RABMAT, ID_ABC_OKP, BEDA, NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE, TAB, TABU,
           ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, comment, RAZRAD, BA, BB, BC, BD, BE, BF, BG,
               BH, BI, BJ, PA, PB, PC, PD, PE, VRPZ, NTR, PUNKTIND, ISESN, IDWITHESN, CCURRENT_BA,
               CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE, CCURRENT_ZONE, IDQUALIFIER,
               IDNORMTYPE, norm_guid, IDREESTR, ABC_OKP_NAME_PART, ABC_OKP_NAME_TITLE,
               ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE, ABC_OKP_TAB, ABC_OKP_TABU,
               ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP, ABC_OKP_IDEDIZM,
               ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME, ABC_OKP_CENA, ABC_OKP_RAZRAD,
               ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND, ABC_OKP_VRPZ, ABC_OKP_NTR,
               ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER, TYPE_TRUD, ABC_OKP_TYPE_TRUD
    do
    begin
      PROCENT_PARTNR = 0;
      idver_abc_okp = null;
      if (:podgroup > 1) then
        select first 1 v.idver
        from b_abc_okp_ver v
        where v.idabcokp = :id_self
        into :idver_abc_okp;
      else
      if (ID_ABC_OKP <> 0) then
        select first 1 v.idver
        from b_abc_okp_ver v
        where v.idabcokp = :ID_ABC_OKP
        into :idver_abc_okp;
      suspend;
    end
  else
  if (mode = 1) then -- lsrmOKP, lsrmOKPAll
    for select ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA, NAME_PART, NAME_TITLE, IDNAME,
               ID_UNIQUE, TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, comment, RAZRAD,
               BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE, VRPZ, NTR, PUNKTIND,
               ISESN, IDWITHESN, CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE,
               CCURRENT_ZONE, IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR, ABC_OKP_NAME_PART,
               ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE, ABC_OKP_TAB,
               ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
               ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME, ABC_OKP_CENA,
               ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND, ABC_OKP_VRPZ,
               ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER, TYPE_TRUD,
               ABC_OKP_TYPE_TRUD
      from L_FB_READ_GROPUP_OKP(:STAB, :IN_PODGROUP, :IN_RABMAT, :ID_USER, :ID_ZONE)
      into ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA, NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE,
           TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, comment, RAZRAD, BA, BB, BC, BD,
               BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE, VRPZ, NTR, PUNKTIND, ISESN, IDWITHESN,
               CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE, CCURRENT_ZONE,
               IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR, ABC_OKP_NAME_PART, ABC_OKP_NAME_TITLE,
               ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE, ABC_OKP_TAB, ABC_OKP_TABU,
               ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP, ABC_OKP_IDEDIZM,
               ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME, ABC_OKP_CENA, ABC_OKP_RAZRAD,
               ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND, ABC_OKP_VRPZ, ABC_OKP_NTR,
               ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER, TYPE_TRUD, ABC_OKP_TYPE_TRUD
    do
    begin
      PROCENT_PARTNR = 0;
      idver_abc_okp = null;
      if (:podgroup > 1) then
        select first 1 v.idver
        from b_abc_okp_ver v
        where v.idabcokp = :id_self
        into :idver_abc_okp;
      else
      if (ID_ABC_OKP <> 0) then
        select first 1 v.idver
        from b_abc_okp_ver v
        where v.idabcokp = :ID_ABC_OKP
        into :idver_abc_okp;
      suspend;
    end
  else
  if (mode = 2) then -- SwitchToPartNR (  )
  begin
    if (IDS is null) then
      exit;

    /*  IN_IDNORMATIV     IDS.     3 */
    if (IN_IDNORMATIV = 0) then
      exit;
    i = 0;
    while (i < IN_IDNORMATIV) do
      i = i + 3;
    if (i <> IN_IDNORMATIV) then
      exit;

    i = 0;

    while (i < IN_IDNORMATIV) do
    begin
      IDS_ID_SELF = readintfromblob(ids, i);
      i = i + 1;
      IDS_RABMAT = readintfromblob(ids, i);
      i = i + 1;
      IDS_PODGR = readintfromblob(ids, i);
      i = i + 1;

      for select ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA, NAME_PART, NAME_TITLE, IDNAME,
                 ID_UNIQUE, TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, comment, RAZRAD,
                 BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE, VRPZ, NTR, PUNKTIND,
                 ISESN, IDWITHESN, CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE,
                 CCURRENT_ZONE, IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR, ABC_OKP_NAME_PART,
                 ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE, ABC_OKP_TAB,
                 ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                 ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME, ABC_OKP_CENA,
                 ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND, ABC_OKP_VRPZ,
                 ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                 TYPE_TRUD, ABC_OKP_TYPE_TRUD
        from L_FB_READ_SBORNIK(:IDS_ID_SELF, 0, :IDS_PODGR, :IDS_RABMAT, :ID_USER, :ID_ZONE)
        into ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA, NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE,
             TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, comment, RAZRAD, BA, BB, BC,
                 BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE, VRPZ, NTR, PUNKTIND, ISESN,
                 IDWITHESN, CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE,
                 CCURRENT_ZONE, IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR, ABC_OKP_NAME_PART,
                 ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE, ABC_OKP_TAB,
                 ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                 ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME, ABC_OKP_CENA,
                 ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND, ABC_OKP_VRPZ,
                 ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                 TYPE_TRUD, ABC_OKP_TYPE_TRUD
      do
        if (ID_SELF <> 0) then
        begin
          PROCENT_PARTNR = 0;
          idver_abc_okp = null;
          if (:podgroup > 1) then
            select first 1 v.idver
            from b_abc_okp_ver v
            where v.idabcokp = :id_self
            into :idver_abc_okp;
          else
          if (ID_ABC_OKP <> 0) then
            select first 1 v.idver
            from b_abc_okp_ver v
            where v.idabcokp = :ID_ABC_OKP
            into :idver_abc_okp;
          suspend;
        end
    end
  end
  else
  if (mode = 3) then -- lsrmFER2017
  begin
    for select ID_SELF, PODGROUP, RABMAT
      from L_FB_SEARCH_ID_TAB_START(:STAB, :IN_RABMAT, :ID_USER, :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 1, 1)
      into :ID_SELF, :PODGROUP, :RABMAT
    do
    begin
      for select ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA, NAME_PART, NAME_TITLE, IDNAME,
                 ID_UNIQUE, TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, comment, RAZRAD,
                 BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE, VRPZ, NTR, PUNKTIND,
                 ISESN, IDWITHESN, CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE,
                 CCURRENT_ZONE, IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR, ABC_OKP_NAME_PART,
                 ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE, ABC_OKP_TAB,
                 ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                 ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME, ABC_OKP_CENA,
                 ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND, ABC_OKP_VRPZ,
                 ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                 TYPE_TRUD, ABC_OKP_TYPE_TRUD
        from L_FB_READ_SBORNIK(:ID_SELF, 0, :PODGROUP, :RABMAT, :ID_USER, :ID_ZONE)
        into ID_SELF, PODGROUP, RABMAT, ID_ABC_OKP, BEDA, NAME_PART, NAME_TITLE, IDNAME, ID_UNIQUE,
             TAB, TABU, ALTTAB, IDEDIZM, EDIZM_NAME, EDIZM_FULLNAME, comment, RAZRAD, BA, BB, BC,
                 BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC, PD, PE, VRPZ, NTR, PUNKTIND, ISESN,
                 IDWITHESN, CCURRENT_BA, CCURRENT_BB, CCURRENT_BC, CCURRENT_BD, CCURRENT_BE,
                 CCURRENT_ZONE, IDQUALIFIER, IDNORMTYPE, norm_guid, IDREESTR, ABC_OKP_NAME_PART,
                 ABC_OKP_NAME_TITLE, ABC_OKP_RABMAT, ABC_OKP_IDNAME, ABC_OKP_ID_UNIQUE, ABC_OKP_TAB,
                 ABC_OKP_TABU, ABC_OKP_IDGROUP, ABC_OKP_IDPODGROUP, ABC_OKP_ISGROUPOKP,
                 ABC_OKP_IDEDIZM, ABC_OKP_EDIZM_NAME, ABC_OKP_EDIZM_FULLNAME, ABC_OKP_CENA,
                 ABC_OKP_RAZRAD, ABC_OKP_VIDNR, ABC_OKP_COMMENT, ABC_OKP_PUNKTIND, ABC_OKP_VRPZ,
                 ABC_OKP_NTR, ABC_OKP_CCURRENT, ABC_OKP_CCURRENT_ZONE, ABC_OKP_IDQUALIFIER,
                 TYPE_TRUD, ABC_OKP_TYPE_TRUD
      do
        if (ID_SELF <> 0) then
        begin
          PROCENT_PARTNR = 0;
          idver_abc_okp = null;
          if (:podgroup > 1) then
            select first 1 v.idver
            from b_abc_okp_ver v
            where v.idabcokp = :id_self
            into :idver_abc_okp;
          else
          if (ID_ABC_OKP <> 0) then
            select first 1 v.idver
            from b_abc_okp_ver v
            where v.idabcokp = :ID_ABC_OKP
            into :idver_abc_okp;
          suspend;
        end
    end
  end

end
^

--[15479]
--   
create or alter PROCEDURE S__A_LZ_RENAME_2(
    NAME_PREFIX VARCHAR(30),
    NAME_SUFFIX INTEGER,
    IDHIER integer,
    SMETATYPE integer)
AS
begin
  exit;
end
^
--[15479]
create or alter PROCEDURE S__A_LZ_RENAME_2(
    NAME_PREFIX VARCHAR(30),
    NAME_SUFFIX INTEGER,
    IDHIER INTEGER,
    SMETATYPE INTEGER)
AS
declare ID integer;
declare NAME_0 varchar(30);
declare PREFIX_LEN integer;
declare NAME_SUFFIX1 integer;
begin
  NAME_SUFFIX = coalesce(:NAME_SUFFIX,0);
  NAME_0 = :NAME_PREFIX || coalesce(nullif(:NAME_SUFFIX,0),'');
  NAME_0 = upper(:NAME_0 collate pxw_cyrl);
  PREFIX_LEN = strlen(:NAME_PREFIX);
  NAME_SUFFIX1 = :NAME_SUFFIX+1;

  for select ID
    from A_LZ
    where IDHIER=:IDHIER
      and SMETATYPE=:SMETATYPE
      and ATYPE=212 -- 
      and upper(AVAR collate pxw_cyrl)=:NAME_0
    into :ID
  do
  begin
    execute procedure S__A_LZ_RENAME_2 ( :NAME_PREFIX, :NAME_SUFFIX1, :IDHIER, :SMETATYPE );

    update A_LZ
      set AVAR=substr(AVAR,1,:PREFIX_LEN)||:NAME_SUFFIX1
      where ID=:ID;
  end
end
^
--[15479]
create or alter PROCEDURE S__A_LZ_RENAME(
    NAME_PREFIX VARCHAR(30),
    NAME_SUFFIX INTEGER)
AS
declare IDHIER integer;
declare SMETATYPE integer;

declare NAME_0 varchar(30);
--declare PREFIX_LEN integer;
--declare NAME_SUFFIX1 integer;
begin
  NAME_SUFFIX = coalesce(:NAME_SUFFIX,0);
  NAME_0 = :NAME_PREFIX || coalesce(nullif(:NAME_SUFFIX,0),'');
  NAME_0 = upper(:NAME_0 collate pxw_cyrl);
  --PREFIX_LEN = strlen(:NAME_PREFIX);
  --NAME_SUFFIX1 = :NAME_SUFFIX+1;

  for select IDHIER, SMETATYPE
    from A_LZ
    where upper(AVAR collate pxw_cyrl)=:NAME_0
    group by SMETATYPE, IDHIER, ATYPE
    having ATYPE=212 -- 
    into :IDHIER, :SMETATYPE
  do
  execute procedure S__A_LZ_RENAME_2 ( :NAME_PREFIX, :NAME_SUFFIX, :IDHIER, :SMETATYPE );
end
^

--[15479]
--    
CREATE or alter PROCEDURE S__T_LZ_TYPE_RENAME(
    NAME_PREFIX VARCHAR(100),
    NAME_SUFFIX INTEGER)
AS
declare NAME_0 varchar(100);
declare PREFIX_LEN integer;
declare NAME_SUFFIX1 integer;
begin
  NAME_SUFFIX = coalesce(:NAME_SUFFIX,0);
  NAME_0 = :NAME_PREFIX || coalesce(nullif(:NAME_SUFFIX,0),'');
  NAME_0 = upper(:NAME_0 collate pxw_cyrl);
  PREFIX_LEN = strlen(:NAME_PREFIX);
  NAME_SUFFIX1 = :NAME_SUFFIX+1;

  if (exists(
      select *
        from T_LZ_TYPE
        where upper(NAME collate pxw_cyrl)=:NAME_0 )) then
  begin
    execute procedure S__T_LZ_TYPE_RENAME ( :NAME_PREFIX, :NAME_SUFFIX1 );

    update T_LZ_TYPE
      set NAME=substr(NAME,1,:PREFIX_LEN)||:NAME_SUFFIX1
      where upper(NAME collate pxw_cyrl)=:NAME_0;
  end
end
^

create or alter procedure S__A_LZ_UPGRADE_INSERT_PR
AS
declare IDHIER integer;
declare SMETATYPE integer;
declare A_LZ_TYPE integer;
declare NUMBER integer;
declare ID integer;
declare RENUM integer;
declare VID integer;
declare IDUSER integer;
declare VN_PRECIT integer;
declare HTYPE integer;
begin
  -- [15479] -  
  --              -2001.16
  --               -2001.16
  --    ,  ,   order by IDHIER desc
  ------------------------------------------------------------------------------

  A_LZ_TYPE=230;
  IDUSER=null; -- not used

  for select A.IDHIER, A.SMETATYPE
    from A_LZ A
    group by A.SMETATYPE, A.IDHIER
    --order by IDHIER desc --<< [9984],[10759]      , 
    -- ..      ,  
    --      " ", -    ID
    --      (. [3E6E918C727A])
    into :IDHIER, :SMETATYPE
  do
  begin
    --ITOGS_PODR_ADDED = 0;

    -- MK 3.12.2010 CQ[8173] --->
    --        ()
    execute procedure A_GET_ID_OBJ_AKT(:IDHIER, :SMETATYPE)
    returning_values :NUMBER, :HTYPE;

    if (:HTYPE = 1) then
      select coalesce(p.PRECIT, -1)
        from A_O_OBJECTPARAMS p
        where NUMBER = :NUMBER
        into :VN_PRECIT;
    else
    if (:HTYPE = 8) then
      select coalesce(p.PRECIT, -1)
        from A_O_FACTPARAMS p
        where NUMBER = :NUMBER
        into :VN_PRECIT;

    if (VN_PRECIT > 5) then
      VN_PRECIT = -1;
    -- MK 3.12.2010 CQ[8173] <---

    for select N.ATYPE
      from A_LZ_NAMES N
      left join A_LZ L
      on L.IDHIER = :IDHIER and L.SMETATYPE = :SMETATYPE and L.ATYPE = N.ATYPE
      where N.IDGROUP = 200
        and N.ATYPE between 230 and 232
        and L.ID is null
        order by N.ATYPE --desc
      into :A_LZ_TYPE
    do
    begin
      -- 
      NUMBER = null;
      if (:A_LZ_TYPE = 230) then --:
        select max(NUMBER) + 1 --   217
          from A_LZ
          where IDHIER = :IDHIER
            and SMETATYPE = :SMETATYPE
            and ATYPE = 217
          into :NUMBER;
      else
      if (:A_LZ_TYPE = 231) then --:
        select max(NUMBER) + 1 --   203
          from A_LZ
          where IDHIER = :IDHIER
            and SMETATYPE = :SMETATYPE
            and ATYPE = 203
          into :NUMBER;
      else
      if (:A_LZ_TYPE = 232) then --:
        select max(NUMBER) + 1 --   205
          from A_LZ
          where IDHIER = :IDHIER
            and SMETATYPE = :SMETATYPE
            and ATYPE = 205
          into :NUMBER;

      if (:NUMBER is not null) then
      begin --     -    ,    
  
        --     
        ID = null;
        select A.ID
          from A_LZ A
          where A.IDHIER=:IDHIER
            and A.SMETATYPE=:SMETATYPE
            and A.NUMBER=:NUMBER
          into :ID;
        if (:ID is not null) then
        begin
          --    
          execute procedure A_LZ_RENUM (:IDUSER, :ID, :IDHIER, :SMETATYPE, :NUMBER+1)
            returning_values :RENUM;
          --   
          update A_LZ
            set NUMBER=:NUMBER+1
            where ID=:ID;
        end
    
        -- ,   VID
        VID =
          case
            when exists(
              select *
                from A_LZ A
                where A.IDHIER=:IDHIER
                  and A.SMETATYPE=:SMETATYPE
                  and A.VID=:A_LZ_TYPE)
            then 0
            else :A_LZ_TYPE
          end;
    
        --
        insert into A_LZ( ID, IDHIER, SMETATYPE,
              NUMBER, IDNAME, ATYPE, VID, PRECIS )
          values( gen_id( A_G_SMETA, 1 ), :IDHIER, :SMETATYPE,
              :NUMBER, :A_LZ_TYPE, :A_LZ_TYPE, :VID, :VN_PRECIT );
        --ITOGS_PODR_ADDED = :ITOGS_PODR_ADDED + row_count;
      end
    end

    --if (:SMETATYPE <> 16) then --<<     ,    ...
    --  --,  
    --  if (:ITOGS_PODR_ADDED > 0) then
    --    execute procedure S_UPGRADE_CALC(:IDHIER,:SMETATYPE);
  end
end^

create or alter procedure S__A_LZ_NAMES_UPGR_PR
AS
begin
  -- [15479] -  
  --              -2001.16
  --               -2001.16
  ------------------------------------------------------------------------------

  if (not exists(
      select * from A_LZ_NAMES N where N.ID = 230 ) ) then
  begin

    --   
    execute procedure S__T_LZ_TYPE_RENAME('', null);
    execute procedure S__T_LZ_TYPE_RENAME('', null);
    execute procedure S__T_LZ_TYPE_RENAME('', null);

    --  (   =203)
    update A_LZ_NAMES N1
      set N1.NUMBER = N1.NUMBER + 1  --   1 
      where N1.NUMBER > (select N2.NUMBER from A_LZ_NAMES N2 where N2.IDGROUP=N1.IDGROUP and N2.ATYPE=203);

    --  (   =205)
    update A_LZ_NAMES N1
      set N1.NUMBER = N1.NUMBER + 1  --   1 
      where N1.NUMBER > (select N2.NUMBER from A_LZ_NAMES N2 where N2.IDGROUP=N1.IDGROUP and N2.ATYPE=205);

    --  (    =217)
    update A_LZ_NAMES N1
      set N1.NUMBER = N1.NUMBER + 1  --   1 
      where N1.NUMBER > (select N2.NUMBER from A_LZ_NAMES N2 where N2.IDGROUP=N1.IDGROUP and N2.ATYPE=217);


    ----------------------------------------------------------------------------
    --   (=231)
    insert into A_LZ_NAMES ( ID,
        IDGROUP, NUMBER, ATYPE,
        AVAR, NAME, APRINT, NOTE )
    select 231,
        IDGROUP, NUMBER+1, 231,
        '', '   -2001.16', 3/* */, ''
    from A_LZ_NAMES
    where ID=203;

    --   (=232)
    insert into A_LZ_NAMES ( ID,
        IDGROUP, NUMBER, ATYPE,
        AVAR, NAME, APRINT, NOTE )
    select 232,
        IDGROUP, NUMBER+1, 232,
        '', '    -2001.16', 3/* */, ''
    from A_LZ_NAMES
    where ID=205;

    --   (=230)
    insert into A_LZ_NAMES ( ID,
        IDGROUP, NUMBER, ATYPE,
        AVAR, NAME, APRINT, NOTE )
    select 230,
        IDGROUP, NUMBER+1, 230,
        '', '   -2001.16', 3/* */, ''
    from A_LZ_NAMES
    where ID=217;

    ----------------------------------------------------------------------------
    --   (=231)
    insert into A_LZ_NAMES ( ID,
        IDGROUP, NUMBER, ATYPE,
        AVAR, NAME, APRINT, NOTE )
    select gen_id(A_G_SMETA,1),
        IDGROUP, NUMBER+1, 231,
        '', '   -2001.16', 3/* */, ''
    from A_LZ_NAMES
    where ATYPE=203 and IDGROUP<>200;

    --   (=232)
    insert into A_LZ_NAMES ( ID,
        IDGROUP, NUMBER, ATYPE,
        AVAR, NAME, APRINT, NOTE )
    select gen_id(A_G_SMETA,1),
        IDGROUP, NUMBER+1, 232,
        '', '    -2001.16', 3/* */, ''
    from A_LZ_NAMES
    where ATYPE=205 and IDGROUP<>200;

    --   (=230)
    insert into A_LZ_NAMES ( ID,
        IDGROUP, NUMBER, ATYPE,
        AVAR, NAME, APRINT, NOTE )
    select gen_id(A_G_SMETA,1),
        IDGROUP, NUMBER+1, 230,
        '', '   -2001.16', 3/* */, ''
    from A_LZ_NAMES
    where ATYPE=217 and IDGROUP<>200;

    ----------------------------------------------------------------------------
    --      (=225)
    insert into T_LZ_TYPE (ID,
        NAME, DESCR,
        IS_SYSTEM, FACTOR_TYPE)
    select 230,
        '', '   -2001.16',
        IS_SYSTEM, FACTOR_TYPE
    from T_LZ_TYPE
    where ID=217;

    --      (=226)
    insert into T_LZ_TYPE (ID,
        NAME, DESCR,
        IS_SYSTEM, FACTOR_TYPE)
    select 231,
        '', '   -2001.16',
        IS_SYSTEM, FACTOR_TYPE
    from T_LZ_TYPE
    where ID=203;

    --      (=227)
    insert into T_LZ_TYPE (ID,
        NAME, DESCR,
        IS_SYSTEM, FACTOR_TYPE)
    select 232,
        '', '    -2001.16',
        IS_SYSTEM, FACTOR_TYPE
    from T_LZ_TYPE
    where ID=205;


    --   ,     
    --     ...

    --  
    execute procedure S__A_LZ_RENAME ('', 0);
    execute procedure S__A_LZ_RENAME ('', 0);
    execute procedure S__A_LZ_RENAME ('', 0);

    --  , 
    execute procedure S__A_LZ_UPGRADE_INSERT_PR;
  end
end^

--[15479]
execute procedure S__A_LZ_NAMES_UPGR_PR
^
--[15479]
drop procedure S__A_LZ_NAMES_UPGR_PR
^
--[15479]
drop procedure S__T_LZ_TYPE_RENAME
^
--[15479]
drop procedure S__A_LZ_RENAME
^
--[15479]
drop procedure S__A_LZ_RENAME_2
^
--[15479]
drop procedure S__A_LZ_UPGRADE_INSERT_PR
^
/* CQ[15490] >> */
create or alter procedure L_FB_LSHOWRES_VER_2_NAMES (
    MODE integer,
    STAB varchar(42),
    IDS blob sub_type 0 segment size 80,
    IN_IDNORMATIV integer,
    IN_PODGROUP integer,
    IN_RABMAT integer,
    CURRENT_GROUP integer,
    CURRENT_PODGROUP integer,
    ID_ZONE integer,
    ID_USER integer,
    USE_ESN integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer)
returns (
    ID integer,
    IDNAME integer,
    SUB_ORDER integer,
    SUB_STR varchar(100))
AS
declare variable I integer;
declare variable IDS_ID_SELF integer;
declare variable IDS_RABMAT integer;
declare variable IDS_PODGR integer;
declare variable ID_BLOB_GEN integer;
begin
  for select ID_SELF, IDNAME
    from L_FB_LSHOWRES_VER_2(:MODE, :STAB, :IDS, :IN_IDNORMATIV, :IN_PODGROUP, :IN_RABMAT, :CURRENT_GROUP, :CURRENT_PODGROUP, :ID_ZONE,
    :ID_USER, :USE_ESN, :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT)
    into :ID, IDNAME
  do
  begin
    for select SUB_ORDER, SUB_STR
      from S_SELECT_FROM_NAME(:IDNAME)
      into :SUB_ORDER, :SUB_STR
    do
      suspend;
  end
end
^
/* CQ[15491] >> */
create or alter procedure B_READ_QUALIFIER_RABMAT_NAMES (
    IDUSER integer,
    IN_IDQUALIFIER integer,
    IN_RABMAT integer,
    IDZONE integer)
returns (
    ID integer,
    IDNAME integer,
    SUB_ORDER integer,
    SUB_STR varchar(100))
as
begin
  -- CQ[15491] >>
  for select ID, IDNAME
    from B_RABMAT R
    where R.IDQUALIFIER = :IN_IDQUALIFIER
    into :ID, :IDNAME
  do
    for select SUB_ORDER, SUB_STR
      from S_SELECT_FROM_NAME(:IDNAME)
      into :SUB_ORDER, :SUB_STR
    do
      suspend;
end
^

--[15195]
CREATE OR ALTER PROCEDURE A_LZ_GETITOG_OBJ_NL (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    IT DOUBLE PRECISION,
    RLM DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    RN DOUBLE PRECISION,
    RO DOUBLE PRECISION,
    RP DOUBLE PRECISION,
    R25 DOUBLE PRECISION,
    R26 DOUBLE PRECISION,
    R27 DOUBLE PRECISION,
    R28 DOUBLE PRECISION,
    R29 DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE A_LZ_SELECT1 (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLEVEL INTEGER,
    FILTERPRINT INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    ALLREC INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    ATYPE INTEGER,
    NUMBER INTEGER,
    AVAR VARCHAR(30),
    NAME VARCHAR(1050),
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITOG DOUBLE PRECISION,
    VID INTEGER,
    APRINT INTEGER,
    NOTE VARCHAR(255),
    UTV INTEGER,
    FACTOR_TYPE INTEGER,
    PRECIS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE A_LZ_SELECT1_1 (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLEVEL INTEGER,
    FILTERPRINT INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    ALLREC INTEGER,
    ID_CENLVL INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    ATYPE INTEGER,
    NUMBER INTEGER,
    AVAR VARCHAR(30),
    NAME VARCHAR(1050),
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITOG DOUBLE PRECISION,
    VID INTEGER,
    APRINT INTEGER,
    NOTE VARCHAR(255),
    UTV INTEGER,
    FACTOR_TYPE INTEGER,
    PRECIS INTEGER,
    ITOG_LEVEL DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE A_LZ_SELECT1_NL (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLEVEL INTEGER,
    FILTERPRINT INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    ALLREC INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    ATYPE INTEGER,
    NUMBER INTEGER,
    AVAR VARCHAR(30),
    NAME VARCHAR(1050),
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITOG DOUBLE PRECISION,
    VID INTEGER,
    APRINT INTEGER,
    NOTE VARCHAR(255),
    UTV INTEGER,
    FACTOR_TYPE INTEGER,
    PRECIS INTEGER,
    ITOG_LEVEL DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE A_S_CLONE_SMETA_REC_CENLVL (
    IDUSER INTEGER,
    IDSMRECSRC INTEGER,
    IDSMRECDST INTEGER,
    IDLEVELSRC INTEGER,
    NEEDCOPYEX INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE A_SMETA_APPLY_CENLVL (
    IDUSER INTEGER,
    IDSMRECSRC INTEGER,
    IDSMRECDST INTEGER)
RETURNS (
    NEED_FORMUL_RECALL INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE A_SMETA_INDLVL_DESC_CLONE (
    ID_SRC INTEGER,
    ID_DEST INTEGER,
    ID_LEVEL_SRC INTEGER,
    ID_LEVEL_DEST INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE A_SMETA_INDLVL_DESCR_IU (
    ID INTEGER,
    IDCENLVL INTEGER,
    NMA VARCHAR(255),
    NMB VARCHAR(255),
    NMC VARCHAR(255),
    NMD VARCHAR(255),
    NME VARCHAR(255),
    NMF VARCHAR(255),
    NMG VARCHAR(255),
    NMH VARCHAR(255),
    NMI VARCHAR(255),
    NMJ VARCHAR(255),
    NMK VARCHAR(255),
    NML VARCHAR(255),
    NMM VARCHAR(255),
    NMN VARCHAR(255),
    NDA VARCHAR(255),
    NDB VARCHAR(255),
    NDC VARCHAR(255),
    NDD VARCHAR(255),
    NDE VARCHAR(255),
    NDJ VARCHAR(255),
    NDK VARCHAR(255),
    NDL VARCHAR(255),
    NDM VARCHAR(255))
AS
BEGIN
  EXIT;
END
^

--[15195]
-- 
CREATE OR ALTER PROCEDURE B_ADD_IND_RECORD (
    IDUSER                integer,
    IDREESTR              integer,
    IDOGL                 integer,
    ORDERVIEW             integer,
    TAB                   varchar(42),
    PA                    double precision,
    PB                    double precision,
    BA                    double precision,
    BANDS                 double precision,
    ZBA                   double precision,
    BE                    double precision,
    BENDS                 double precision,
    ZBE                   double precision,
    BC                    double precision,
    BCNDS                 double precision,
    ZBC                   double precision,
    BB                    double precision,
    BBNDS                 double precision,
    ZBB                   double precision,
    BD                    double precision,
    BDNDS                 double precision,
    ZBD                   double precision,
    BB_PR                 double precision,
    PROCENTPRED           double precision,
    NAME_PART             blob sub_type 1 segment size 80,
    NAME_TITLE            blob sub_type 1 segment size 80,
    NEEDUPDATE_NAME_PART  integer,
    NEEDUPDATE_NAME_TITLE integer,
    ID_GEN                integer)
RETURNS (
    ID INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE B_ADD_IND_RECORD_INNER (
    IDUSER INTEGER,
    IDREESTR INTEGER,
    IDOGL INTEGER,
    ORDERVIEW INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    NAME_PART BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NEEDUPDATE_NAME_PART INTEGER,
    NEEDUPDATE_NAME_TITLE INTEGER,
    NEEDCHECKPARAMS INTEGER,
    BB_PR DOUBLE PRECISION)
RETURNS (
    ID INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE B_INIT_IND_RECORD_VALUES (
    IDUSER INTEGER,
    IN_PA DOUBLE PRECISION,
    IN_PB DOUBLE PRECISION,
    IN_BA DOUBLE PRECISION,
    IN_BANDS DOUBLE PRECISION,
    IN_ZBA DOUBLE PRECISION,
    IN_BE DOUBLE PRECISION,
    IN_BENDS DOUBLE PRECISION,
    IN_ZBE DOUBLE PRECISION,
    IN_BC DOUBLE PRECISION,
    IN_BCNDS DOUBLE PRECISION,
    IN_ZBC DOUBLE PRECISION,
    IN_BB DOUBLE PRECISION,
    IN_BBNDS DOUBLE PRECISION,
    IN_ZBB DOUBLE PRECISION,
    IN_BD DOUBLE PRECISION,
    IN_BDNDS DOUBLE PRECISION,
    IN_ZBD DOUBLE PRECISION,
    IN_PROCENTPRED DOUBLE PRECISION,
    IN_BB_PR DOUBLE PRECISION)
RETURNS (
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE B_READ_IND_RECORD_VALUES (
    IDUSER INTEGER,
    INDYEAR INTEGER,
    INDMONTH INTEGER,
    IDORG INTEGER,
    SHIFR VARCHAR(42),
    RAISE_EXCEPTION INTEGER,
    WILDCARD_USED INTEGER)
RETURNS (
    IDMONTH INTEGER,
    ID INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    DOSTUP INTEGER,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE B_READ_IND_RECORD_VALUES_1 (
    IDUSER INTEGER,
    INDYEAR INTEGER,
    INDMONTH INTEGER,
    IDORG INTEGER,
    SHIFR VARCHAR(42),
    RAISE_EXCEPTION INTEGER,
    WILDCARD_USED INTEGER)
RETURNS (
    IDMONTH INTEGER,
    ID INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    DOSTUP INTEGER,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE CHECK_CAN_CENLVL_USE_INDEX (
    ID_CENLVL INTEGER,
    IDCLASS INTEGER)
RETURNS (
    IS_CAN_USE_INDEX INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE D_GET_ITOG_NL (
    ID_USER INTEGER,
    OBJECT_ID INTEGER,
    SMETATYPE INTEGER,
    IDHIER INTEGER,
    VID INTEGER,
    ID_CENLVL INTEGER)
RETURNS (
    ID INTEGER,
    ITOG DOUBLE PRECISION,
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NEED_RECALC INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE D_GET_LZ (
    ID_USER INTEGER,
    ROOT_ID INTEGER,
    SMETA_TYPE INTEGER,
    OBJECT_ID INTEGER,
    AMODE INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    ID_PARENT INTEGER,
    ID_HIER INTEGER,
    IS_HIER INTEGER,
    ATYPE INTEGER,
    LZTYPE INTEGER,
    NUMBER INTEGER,
    AVAR VARCHAR(30),
    NAME VARCHAR(1024),
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITOG DOUBLE PRECISION,
    VID INTEGER,
    APRINT INTEGER,
    PRECIS INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE D_GET_LZ_OBJ_ITOG (
    LZTYPE INTEGER,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    IT DOUBLE PRECISION,
    RLM DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    RN DOUBLE PRECISION,
    RO DOUBLE PRECISION,
    RP DOUBLE PRECISION,
    R25 DOUBLE PRECISION,
    R26 DOUBLE PRECISION,
    R27 DOUBLE PRECISION,
    R28 DOUBLE PRECISION,
    R29 DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
RETURNS (
    ITOG DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE FILL_INDLVL_DESCR (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDCOMPOSE INTEGER,
    INDEX_INFO INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE FILL_INDLVL_DESCR_INDEX (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDCOMPOSE INTEGER,
    IGNORE_SBORNIK_FIELD INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE FILL_INDLVL_DESCR_INDEX_ITOG (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDCOMPOSE INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE IS_EMPTY_INDEX (
    IDNORMATIV INTEGER,
    RABMAT INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION)
RETURNS (
    IS_EMPTY INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE KD_CLONE_SMETA_REC_CENLVL (
    IDUSER INTEGER,
    IDSMRECSRC INTEGER,
    IDSMRECDST INTEGER,
    IDSESSIONTMP INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE L_IMP_ENSURE_HIER_LIMITIR (
    IDHIER INTEGER,
    SMETATYPE INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE LEVEL_INDEX_ITOG_IMPORT (
    ID_COMPOSE INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    NMA VARCHAR(255),
    NMB VARCHAR(255),
    NMC VARCHAR(255),
    NMD VARCHAR(255),
    NME VARCHAR(255),
    NMJ VARCHAR(255),
    NMK VARCHAR(255),
    NML VARCHAR(255),
    NMM VARCHAR(255),
    NMN VARCHAR(255),
    NDA VARCHAR(255),
    NDB VARCHAR(255),
    NDJ VARCHAR(255),
    NDK VARCHAR(255),
    NDL VARCHAR(255),
    NDM VARCHAR(255),
    NOTE VARCHAR(255),
    SPOSOBRASCH INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE LEVEL_INDEX_ITOG_IMPORT_XML (
    ID_COMPOSE INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    NMA VARCHAR(255),
    NMB VARCHAR(255),
    NMC VARCHAR(255),
    NMD VARCHAR(255),
    NME VARCHAR(255),
    NMJ VARCHAR(255),
    NMK VARCHAR(255),
    NML VARCHAR(255),
    NMM VARCHAR(255),
    NMN VARCHAR(255),
    NDA VARCHAR(255),
    NDB VARCHAR(255),
    NDJ VARCHAR(255),
    NDK VARCHAR(255),
    NDL VARCHAR(255),
    NDM VARCHAR(255),
    NOTE VARCHAR(255),
    SPOSOBRASCH INTEGER,
    COMPOSE_NAME VARCHAR(250),
    COMPOSE_LORDER INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE M_COPY_LEVEL_COMPOSES (
    ID_LEVEL_SRC INTEGER,
    ID_LEVEL_DST INTEGER,
    IDCLASS_SRC INTEGER,
    IDCLASS_DST INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE M_COPY_SMETA_CENLVL_ONE_REC (
    ID_SOURCE INTEGER,
    ID_TARGET INTEGER,
    ID_LEVEL_SOURCE INTEGER,
    ID_LEVEL_TARGET INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
CREATE OR ALTER PROCEDURE M_CREATE_BASE_CENLVL_ONSMETA (
    ID INTEGER,
    IDCENLVL INTEGER,
    ID_LEVEL_INDEX INTEGER,
    ID_LEVEL_VC INTEGER)
AS
BEGIN
  EXIT;
END
^

--[15195]
-- 
CREATE OR ALTER PROCEDURE MB_ADD_IND_RECORD (
    IDUSER               integer,
    IDREESTR             integer,
    IDOGL                integer,
    ORDERVIEW            integer,
    TAB                  varchar(42),
    PA                   double precision,
    PB                   double precision,
    BA                   double precision,
    BANDS                double precision,
    ZBA                  double precision,
    BE                   double precision,
    BENDS                double precision,
    ZBE                  double precision,
    BC                   double precision,
    BCNDS                double precision,
    ZBC                  double precision,
    BB                   double precision,
    BBNDS                double precision,
    ZBB                  double precision,
    BD                   double precision,
    BDNDS                double precision,
    ZBD                  double precision,
    PROCENTPRED          double precision,
    NAME_PART            blob sub_type 1 segment size 80,
    NEEDUPDATE_NAME_PART integer,
    NEED_REPLACE         integer,
    PR                   double precision)
RETURNS (
    ID INTEGER,
    IS_REPLACED INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE NL_FIND_COMPOSE_EX (
    ID_LEVEL INTEGER,
    IDCLASS INTEGER,
    ID_USER INTEGER,
    IDREESTR INTEGER,
    TYPE_RAB INTEGER,
    VID_RAB INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    IDHIER INTEGER,
    PUNKIND VARCHAR(42),
    IDNORMATIV INTEGER,
    PODGROUP INTEGER)
RETURNS (
    ID_COMPOSE_VC INTEGER,
    ID_COMPOSE_INDEX INTEGER,
    INDEX_DX_ONLY INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE NL_GET_IS_CENLVL (
    ID INTEGER,
    IDOBJECT INTEGER,
    IDCENLVL INTEGER,
    INCLUDEACTSMODE INTEGER,
    IDUSER INTEGER)
RETURNS (
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    CA DOUBLE PRECISION,
    CB DOUBLE PRECISION,
    CC DOUBLE PRECISION,
    CD DOUBLE PRECISION,
    CE DOUBLE PRECISION,
    CF DOUBLE PRECISION,
    CG DOUBLE PRECISION,
    CH DOUBLE PRECISION,
    CI DOUBLE PRECISION,
    CJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    CALCBMASK INTEGER,
    ID_LEVEL_VC INTEGER,
    BASE_INFO INTEGER,
    CURR_CENA DOUBLE PRECISION,
    BASE_CALC_INFO INTEGER,
    SOURCE_LEVEL_ID INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    EN DOUBLE PRECISION,
    EO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    C_ITOGO DOUBLE PRECISION,
    E_ITOGO DOUBLE PRECISION,
    CURR_CENA_INFO INTEGER,
    ID_VALUTE INTEGER,
    VALUTE_CURS DOUBLE PRECISION,
    VALUTE_DATE DATE,
    TRANSP DOUBLE PRECISION,
    ZAG_SKL DOUBLE PRECISION,
    ZAPCHAST DOUBLE PRECISION,
    TARA DOUBLE PRECISION,
    NACEN DOUBLE PRECISION,
    COMPLECT DOUBLE PRECISION,
    KOEFF_TYPE INTEGER,
    B_PR DOUBLE PRECISION,
    C_PR DOUBLE PRECISION,
    E_PR DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE NL_GET_IS_CENLVL_MANY (
    IDOBJECT INTEGER,
    IDCENLVL INTEGER,
    INCLUDEACTSMODE INTEGER,
    IDUSER INTEGER)
RETURNS (
    ID INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    CA DOUBLE PRECISION,
    CB DOUBLE PRECISION,
    CC DOUBLE PRECISION,
    CD DOUBLE PRECISION,
    CE DOUBLE PRECISION,
    CF DOUBLE PRECISION,
    CG DOUBLE PRECISION,
    CH DOUBLE PRECISION,
    CI DOUBLE PRECISION,
    CJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    CALCBMASK INTEGER,
    ID_LEVEL_VC INTEGER,
    BASE_INFO INTEGER,
    CURR_CENA DOUBLE PRECISION,
    BASE_CALC_INFO INTEGER,
    SOURCE_LEVEL_ID INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    EN DOUBLE PRECISION,
    EO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    C_ITOGO DOUBLE PRECISION,
    E_ITOGO DOUBLE PRECISION,
    CURR_CENA_INFO INTEGER,
    ID_VALUTE INTEGER,
    VALUTE_CURS DOUBLE PRECISION,
    VALUTE_DATE DATE,
    TRANSP DOUBLE PRECISION,
    ZAG_SKL DOUBLE PRECISION,
    ZAPCHAST DOUBLE PRECISION,
    TARA DOUBLE PRECISION,
    NACEN DOUBLE PRECISION,
    COMPLECT DOUBLE PRECISION,
    KOEFF_TYPE INTEGER,
    B_PR DOUBLE PRECISION,
    C_PR DOUBLE PRECISION,
    E_PR DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE S_CALC_INDEX_ON_RABMAT (
    IDUSER INTEGER,
    IDINDEX INTEGER,
    IDRABMAT INTEGER,
    IDZONE_B INTEGER,
    IDZONE_E INTEGER,
    ID_TR INTEGER,
    IDOGL INTEGER,
    INDEX_PRES INTEGER,
    ORDERVIEW INTEGER,
    CALCSMR INTEGER)
RETURNS (
    NUMBER INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE V_SELECT_LEVEL_IND_ITOG_EXP_XML (
    ID_USER INTEGER,
    ID_COMPOSE INTEGER)
RETURNS (
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    NMA VARCHAR(255),
    NMB VARCHAR(255),
    NMC VARCHAR(255),
    NMD VARCHAR(255),
    NME VARCHAR(255),
    NMJ VARCHAR(255),
    NMK VARCHAR(255),
    NML VARCHAR(255),
    NMM VARCHAR(255),
    NMN VARCHAR(255),
    NDA VARCHAR(255),
    NDB VARCHAR(255),
    NDJ VARCHAR(255),
    NDK VARCHAR(255),
    NDL VARCHAR(255),
    NDM VARCHAR(255),
    NOTE VARCHAR(255),
    SPOSOBRASCH INTEGER)
AS
BEGIN
  SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE A_LZ_GETITOG_OBJ_NL (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    IT DOUBLE PRECISION,
    RLM DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    RN DOUBLE PRECISION,
    RO DOUBLE PRECISION,
    RP DOUBLE PRECISION,
    R25 DOUBLE PRECISION,
    R26 DOUBLE PRECISION,
    R27 DOUBLE PRECISION,
    R28 DOUBLE PRECISION,
    R29 DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
begin
--[15352]+
--[15479]
 select coalesce( sum(case L.ATYPE when 201 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 202 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 203 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 204 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 205 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 206 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 207 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 208 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 209 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 210 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 211 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 216 then c.ITOG else null end), 0), --<<[7398] --<<[633526DDD29B]
        coalesce( sum(case L.ATYPE when 222 then c.ITOG else null end), 0), --<<[6929]
        coalesce( sum(case L.ATYPE when 213 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 223 then c.ITOG else null end), 0), -- CQ[8295]
        coalesce( sum(case L.ATYPE when 224 then c.ITOG else null end), 0), -- CQ[9349]

        -- MK CQ[9374] --->
        coalesce( sum(case L.ATYPE when 214 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 215 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 217 then c.ITOG else null end), 0),
        -- MK CQ[9374] <---

        --<<[12250]
        coalesce( sum(case L.ATYPE when 225 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 226 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 227 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 228 then c.ITOG else null end), 0),
        coalesce( sum(case L.ATYPE when 229 then c.ITOG else null end), 0),

        coalesce( sum(case L.ATYPE when 230 then c.ITOG else null end), 0), --[15479]
        coalesce( sum(case L.ATYPE when 231 then c.ITOG else null end), 0), --[15479]
        coalesce( sum(case L.ATYPE when 232 then c.ITOG else null end), 0)  --[15479]

   from A_H_SELSTRUCTLEVEL( 3, :IDOBJECT ) H
   join A_LZ L on L.IDHIER=H.NUMSTRUCT and L.SMETATYPE=:SMETATYPE
   left join a_lz_cenlvl c on c.id = l.id and c.idcenlvl = :IDCENLVL
   into :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :IT,
        :RLM, :ITOGO, :RN, :RO, :RP,
        :R25, :R26, :R27, :R28, :R29, --<<[12250]
        :R_PR, :RC_16, :RE_16; --[15479]

 suspend;--*/
end
^

--[15195]
CREATE OR ALTER PROCEDURE A_LZ_SELECT1 (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLEVEL INTEGER,
    FILTERPRINT INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    ALLREC INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    ATYPE INTEGER,
    NUMBER INTEGER,
    AVAR VARCHAR(30),
    NAME VARCHAR(1050),
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITOG DOUBLE PRECISION,
    VID INTEGER,
    APRINT INTEGER,
    NOTE VARCHAR(255),
    UTV INTEGER,
    FACTOR_TYPE INTEGER,
    PRECIS INTEGER)
AS
--CQ[TIMUR 13931] -    ANAME
declare variable HATYPE integer;
declare variable HCOUNTCHILDREN integer;
declare variable IDNAME integer;
declare variable LZTYPE integer;
declare variable LZ_OTYPE integer;
declare variable CHECKNODE integer;
declare variable IDLEVEL_ORIGINAL integer;
declare variable CURRENT_VID integer;
declare variable CUR_PROJECTTYPE integer;
declare variable O_RA double precision;
declare variable O_RB double precision;
declare variable O_RC double precision;
declare variable O_RD double precision;
declare variable O_RE double precision;
declare variable O_RF double precision;
declare variable O_RG double precision;
declare variable O_RH double precision;
declare variable O_RI double precision;
declare variable O_RJ double precision;
declare variable O_RK double precision;
declare variable O_RL double precision;
declare variable O_RM double precision;
declare variable O_IT double precision;
DECLARE VARIABLE O_RLM DOUBLE PRECISION;
DECLARE VARIABLE O_ITOGO DOUBLE PRECISION;

DECLARE VARIABLE O_RN DOUBLE PRECISION;
DECLARE VARIABLE O_RO DOUBLE PRECISION;
DECLARE VARIABLE O_RP DOUBLE PRECISION;

--[15479]
DECLARE VARIABLE O_R_PR DOUBLE PRECISION;
DECLARE VARIABLE O_RC_16 DOUBLE PRECISION;
DECLARE VARIABLE O_RE_16 DOUBLE PRECISION;

begin
--[15352]
--[15479]

 lztype = smetatype;
 /*if ( smetatype = 15 )
 then lztype = 21;
 else lztype = 22;*/

 idlevel_original = idlevel;

 current_vid = 200;

 select u.idlzgroup
 from b_user_access u
 where u.id = :iduser
 into :current_vid;

 select projecttype
 from l_getprojecttype( :iduser )
 into :cur_projecttype;

  --<rvs:00004533>
 for select IDHIER
   from S_O_HIER_SELECT_LEVEL_NF(:IDLEVEL_ORIGINAL)
   into :IDLEVEL
 do
 --</rvs:00004533>
 for select h.number, h.atype, h.countchildren
     from a_o_hier h
     where h.NUMBER = :IDLEVEL and --(h.parent = :idlevel_original) and <<rvs:00004533
           --(h.atype IN (0,3,4,5)) and <<rvs:00004533
           ( (h.subtype is null) or (h.subtype in (0,1,2,3,4,5) ) )
     order by h.sorting
     into :idlevel, :hatype, :hcountchildren
 do
 begin

  if (hatype > 0)
  then
  begin
-->DEN
   EXECUTE PROCEDURE M_H_GET_UTV(:idlevel, :hatype, :SMETATYPE) RETURNING_VALUES :UTV;
--
   select n.FULLNAME
   from a_h_GetName( :idlevel, :hatype ) n
   into :name;

   if ( hatype = 4 ) then
     name = '    ' || name;
   if ( hatype = 5 ) then
     name = '    ' || '    ' || name;

   id = idlevel; idhier = idlevel; atype = hatype; number = null; avar = null; formula = null;
   itog = null; vid = null; aprint = null;
   PRECIS = null;

   checknode = null;
   select first 1 hch.id
   from A_O_HIERCHECKING hch
   where (hch.iduser = :iduser) and
         (hch.idobject = :idobject) and
         (hch.smetatype = :smetatype) and
         (hch.atype = 25) and
         (hch.idelem = :idlevel)
   into :checknode;

   execute procedure a_s_get_struct_put ( :iduser, :atype, :nls, :nr, :npr )
           returning_values ( :nls, :nr, :npr, :note );

   if ( cur_projecttype <> 1 )
   then
   begin

    if (checknode is null)
    then atype = -atype;

    suspend;

   end

   if (
       ( allrec = 1 ) or
       ( atype > 0 )
      )
   then for select l.id, l.idhier, l.atype, l.number, l.idname, l.avar, l.name, l.formula, l.itog, l.vid,
                   l.aprint, l.note, t.FACTOR_TYPE, l.PRECIS
            from a_lz l
            left join T_LZ_TYPE t on (l.vid = t.ID)
            where l.idhier = :idlevel and l.smetatype = :lztype
            --PLAN SORT ((L INDEX (A_LZ_IDHIER_SMETATYPE_ATYPE)))
            order by l.number
--            order by l.idhier, l.smetatype
            into :id, :idhier, :atype, :number, :idname, :avar, :name, :formula,
                 :itog, :vid, :aprint, :note, :FACTOR_TYPE, :PRECIS
        do
        begin

         if (atype <> 212) then
           select n.avar, n.name, coalesce(:aprint, n.aprint), coalesce(:note, n.NOTE)
              from a_lz_names n
              where ( n.idgroup = :current_vid ) and
                    ( n.atype = :idname )
              into :avar, :name, :aprint, :note;


/*       MK  : (.  )
         if (
             ( filterprint = -1 ) or
             ( aprint = filterprint )
            )
         then suspend;
*/
           /* MK CQ[2437] 14.04.2006    ---> */
               /*   */
--DEN-->
           if ((allrec = 0) and (:IDOBJECT = :IDHIER)) then
             --suspend; --DEN .       cq[5877]
             allrec = 0;
           else
--<
           if ((filterprint = -1) or
               --   (  )
               ((filterprint in (0, 1, 2, 3)) and (aprint = filterprint)) or
               --     
               ((filterprint = 4) and ((aprint = 0) or ((aprint = 1) and (LRoundN(ITOG, 5) <> 0)) or ((aprint = 2) and (LRoundN(ITOG, 5) = 0)))) or
               --      
               ((filterprint = 5) and ((aprint = 3) or ((aprint = 1) and (LRoundN(ITOG, 5) = 0)) or ((aprint = 2) and (LRoundN(ITOG, 5) <> 0))))) then

              suspend;
           /* MK CQ[2437] <--- */

        else if ( allrec = 1 ) then

              begin
               if ( allrec = 1 ) then
               atype = -atype;
               suspend;

              end


        end

  end

  if (
      ( hcountchildren > 0 ) and
      ( cur_projecttype <> 1 )
     )
  then for select ID, IDHIER, ATYPE, NUMBER, AVAR, NAME, FORMULA,
                  ITOG, VID, APRINT, NOTE, UTV, FACTOR_TYPE, PRECIS
           from a_lz_select1( :iduser, :idobject, :smetatype, :idlevel, :filterprint, :nls, :nr, :npr, :allrec )
           into :id, :idhier, :atype, :number, :avar, :name, :formula,
                :itog, :vid, :aprint, :note, :UTV, :FACTOR_TYPE, :PRECIS
       do suspend;

 end

 if (
     ( idobject = idlevel_original ) and
     ( cur_projecttype <> 1 )
    )
 then
 begin

  id = idlevel_original;
  idhier = idlevel_original;

  lz_otype = 1;
  /*if ( smetatype = 15 )
  then lz_otype = 23;
  else lz_otype = 24;*/

  atype = lz_otype;

  checknode = null;

/*
  -- MK 25.08.2010   (.    )
  select first 1 hch.id
  from A_O_HIERCHECKING hch
  where (hch.iduser = :iduser) and
        (hch.idobject = :idobject) and
        (hch.smetatype = :smetatype) and
        (hch.atype = 25) and
        (hch.idelem = :idlevel_original)
  into :checknode;
*/
-->DEN

  utv = null;
  select first 1 utv from A_GET_PARAMS_OBJ_AKT(:iduser, :idobject, :smetatype)
  into :utv;
  if (:utv is null) then
    utv = 0;

--  atype = 1;
  select first 1 hch.id
  from A_O_HIERCHECKING hch
  where (hch.iduser = :iduser) and
        (hch.idobject = :idobject) and
        (hch.smetatype = :smetatype) and
        (hch.atype = 25) and
        (hch.idelem = :idobject)
  into :checknode;
  if ( checknode is null )
  then  atype = -atype;

  number = null; avar = null; name = '  :'; formula = null;
  itog = null; vid = null; aprint = null;
  PRECIS = null;

  execute procedure a_s_get_struct_put ( :iduser, :atype, :nls, :nr, :npr )
          returning_values ( :nls, :nr, :npr, :note );

  suspend;

  if (
      ( allrec = 1 ) or
      ( atype > 0 )
     )
  then
  begin

   if ( smetatype > 16 )
   then idlevel_original = smetatype;

   /*  ר */
   if ( allrec = 1 )
   then --select first 1 i.ra, rb, rc, rd, re, rf, rg, rh, ri, rj, rk, it
        --from a_lz_getitog_obj( :iduser, :idobject, :smetatype ) i
        --into :o_ra, :o_rb, :o_rc, :o_rd, :o_re, :o_rf, :o_rg, :o_rh, :o_ri, :o_rj, :o_rk, O_IT;

   -- MK 2.07.2013 CQ[11340] --->
   --   A_LZ_GETITOG_OBJ  ..  
   --   (   ).     
   --     
   begin
     O_RA = 0;
     O_RB = 0;
     O_RC = 0;
     O_RD = 0;
     O_RE = 0;
     O_RF = 0;
     O_RG = 0;
     O_RH = 0;
     O_RI = 0;
     O_RJ = 0;
     O_RK = 0;
     O_RL = 0;
     O_RM = 0;
     O_IT = 0;
     O_RLM = 0;
     O_ITOGO = 0;
     O_RN = 0;
     O_RO = 0;
     O_RP = 0;

     --[15479]
     O_R_PR = 0;
     O_RC_16 = 0;
     O_RE_16 = 0;
     --[15479]

     --execute procedure A_LZ_GETITOG_OBJ( :IDUSER, :IDOBJECT, :SMETATYPE )
     --returning_values :O_RA, :O_RB, :O_RC, :O_RD, :O_RE, :O_RF, :O_RG,
     --                 :O_RH, :O_RI, :O_RJ, :O_RK, :O_RL, :O_RM, :O_IT,
     --                 :O_RLM, :O_ITOGO, :O_RN, :O_RO, :O_RP;
   end
   -- MK 2.07.2013 CQ[11340] <---

   /* End  ר */

   for select l.itog, l.id, l.idhier, l.atype, l.number, l.idname, l.avar, l.name, l.formula, l.vid,
              l.aprint, l.note, t.FACTOR_TYPE, l.PRECIS
       from a_lz l
       left join T_LZ_TYPE t on (l.vid = t.ID)
       where l.idhier = :idlevel_original and l.smetatype = :smetatype
       --PLAN SORT ((L INDEX (A_LZ_IDHIER_SMETATYPE_ATYPE)))
       order by l.number
       into :itog, :id, :idhier, :atype, :number, :idname, :avar, :name, :formula,
            :vid, :aprint, :note, :FACTOR_TYPE, :PRECIS
   do
   begin

     if (atype <> 212) then
       select n.avar, n.name, coalesce(:aprint, n.aprint), coalesce(:note, n.NOTE)
         from a_lz_names n
         where ( n.idgroup = :current_vid ) and
               ( n.atype = :idname )
         into :avar, :name, :aprint, :note;

     /*  ר */
     if ( allrec = 1 )
     then
     begin
      /*
      if ( atype = 201 )
      then itog = o_ra;
      else if ( atype = 202 )
           then itog = o_rb;
           else if ( atype = 203 )
                then itog = o_rc;
                else if ( atype = 204 )
                     then itog = o_rd;
                     else if ( atype = 205 )
                          then itog = o_re;
                          else if ( atype = 206 )
                               then itog = o_rf;
                               else if ( atype = 207 )
                                    then itog = o_rg;
                                    else if ( atype = 208 )
                                         then itog = o_rh;
                                         else if ( atype = 209 )
                                              then itog = o_ri;
                                              else if ( atype = 210 )
                                                   then itog = o_rj;
                                                   else if ( atype = 211 )
                                                        then itog = o_rk;
                                                         else if ( atype = 213 )
                                                              then itog = o_IT;
      */
      ITOG =
        case :ATYPE
          when 201 then :O_RA
          when 202 then :O_RB
          when 203 then :O_RC
          when 204 then :O_RD
          when 205 then :O_RE
          when 206 then :O_RF
          when 207 then :O_RG
          when 208 then :O_RH
          when 209 then :O_RI
          when 210 then :O_RJ
          when 211 then :O_RK
          when 216 then :O_RL --<<[7398] --<<[633526DDD29B]
          when 222 then :O_RM
          when 213 then :O_IT
          when 223 then :O_RLM    -- CQ[8295]
          when 224 then :O_ITOGO  -- CQ[9349]

          -- MK CQ[9374] --->
          when 214 then :O_RN
          when 215 then :O_RO
          when 217 then :O_RP
          -- MK CQ[9374] <---

          --[15479]
          when 230 then :O_R_PR
          when 231 then :O_RC_16
          when 232 then :O_RE_16
          --[15479]

          else 0 --[12250]:ITOG
        end;

     end
     /* End  ר */
     else itog = 0;


     /* MK         */
     if (
         ( allrec = 1 ) or
         ( filterprint = -1 ) or
         ( aprint = filterprint ) or
         ( filterprint in (4, 5) )
        )
     then
        suspend;

     else if ( allrec = 1 )
          then
          /* MK 14.04.2006 -     */
          begin

            atype = -atype;
            suspend;

          end

   end

  end

 end
end
^

--[15195]
CREATE OR ALTER PROCEDURE A_LZ_SELECT1_1 (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLEVEL INTEGER,
    FILTERPRINT INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    ALLREC INTEGER,
    ID_CENLVL INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    ATYPE INTEGER,
    NUMBER INTEGER,
    AVAR VARCHAR(30),
    NAME VARCHAR(1050),
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITOG DOUBLE PRECISION,
    VID INTEGER,
    APRINT INTEGER,
    NOTE VARCHAR(255),
    UTV INTEGER,
    FACTOR_TYPE INTEGER,
    PRECIS INTEGER,
    ITOG_LEVEL DOUBLE PRECISION)
AS
--CQ[TIMUR 13931] -    NAME
declare variable HATYPE integer;
declare variable HCOUNTCHILDREN integer;
declare variable IDNAME integer;
declare variable LZTYPE integer;
declare variable LZ_OTYPE integer;
declare variable CHECKNODE integer;
declare variable IDLEVEL_ORIGINAL integer;
declare variable CURRENT_VID integer;
declare variable CUR_PROJECTTYPE integer;

declare variable O1_RA double precision;
declare variable O1_RB double precision;
declare variable O1_RC double precision;
declare variable O1_RD double precision;
declare variable O1_RE double precision;
declare variable O1_RF double precision;
declare variable O1_RG double precision;
declare variable O1_RH double precision;
declare variable O1_RI double precision;
declare variable O1_RJ double precision;
declare variable O1_RK double precision;
declare variable O1_RL double precision;
declare variable O1_RM double precision;
declare variable O1_IT double precision;
declare variable O1_RLM double precision;
declare variable O1_ITOGO double precision;

declare variable O1_RN double precision;
declare variable O1_RO double precision;
declare variable O1_RP double precision;

--<<[12250]
declare O1_R25 double precision;
declare O1_R26 double precision;
declare O1_R27 double precision;
declare O1_R28 double precision;
declare O1_R29 double precision;

--[15479]
declare variable O1_R_PR double precision;
declare variable O1_RC_16 double precision;
declare variable O1_RE_16 double precision;
begin
--[15352]
--[15479]

  -- -  A_LZ_SELECT1_NL,    
  LZTYPE = SMETATYPE;

  IDLEVEL_ORIGINAL = IDLEVEL;

  CURRENT_VID = 200;

  select U.IDLZGROUP
  from B_USER_ACCESS U
  where U.ID = :IDUSER
  into :CURRENT_VID;

  select PROJECTTYPE
  from L_GETPROJECTTYPE(:IDUSER)
  into :CUR_PROJECTTYPE;

  for select IDHIER
    from S_O_HIER_SELECT_LEVEL_NF(:IDLEVEL_ORIGINAL)
    into :IDLEVEL
  do
    for select H.NUMBER, H.ATYPE, H.COUNTCHILDREN
      from A_O_HIER H
      where H.NUMBER = :IDLEVEL and
            ((H.SUBTYPE is null) or (H.SUBTYPE in (0, 1, 2, 3, 4, 5)))
      order by H.SORTING
      into :IDLEVEL, :HATYPE, :HCOUNTCHILDREN
    do
    begin

      if (HATYPE > 0) then
      begin

        execute procedure M_H_GET_UTV(:IDLEVEL, :HATYPE, :SMETATYPE)
        returning_values :UTV;

        select N.FULLNAME
        from A_H_GETNAME(:IDLEVEL, :HATYPE) N
        into :NAME;

        if (HATYPE = 4) then
          NAME = '    ' || NAME;
        if (HATYPE = 5) then
          NAME = '    ' || '    ' || NAME;

        ID = IDLEVEL;
        IDHIER = IDLEVEL;
        ATYPE = HATYPE;
        NUMBER = null;
        AVAR = null;
        FORMULA = null;
        ITOG = null;
        VID = null;
        APRINT = null;
        PRECIS = null;

        CHECKNODE = null;
        select first 1 HCH.ID
        from A_O_HIERCHECKING HCH
        where (HCH.IDUSER = :IDUSER) and
              (HCH.IDOBJECT = :IDOBJECT) and
              (HCH.SMETATYPE = :SMETATYPE) and
              (HCH.ATYPE = 25) and
              (HCH.IDELEM = :IDLEVEL)
        into :CHECKNODE;

        execute procedure A_S_GET_STRUCT_PUT(:IDUSER, :ATYPE, :NLS, :NR, :NPR)
        returning_values (:NLS, :NR, :NPR, :NOTE);

        if (CUR_PROJECTTYPE <> 1) then
        begin

          if (CHECKNODE is null) then
            ATYPE = -ATYPE;

          suspend;

        end

        if ((ALLREC = 1) or (ATYPE > 0)) then
          for select L.ID, L.IDHIER, L.ATYPE, L.NUMBER, L.IDNAME, L.AVAR, L.NAME, L.FORMULA, L.ITOG,
                     L.VID, L.APRINT, L.NOTE, T.FACTOR_TYPE, L.PRECIS
            from A_LZ L
            left join T_LZ_TYPE T on (L.VID = T.ID)
            where L.IDHIER = :IDLEVEL and
                  L.SMETATYPE = :LZTYPE
            order by L.NUMBER
            into :ID, :IDHIER, :ATYPE, :NUMBER, :IDNAME, :AVAR, :NAME, :FORMULA, :ITOG, :VID,
                 :APRINT, :NOTE, :FACTOR_TYPE, :PRECIS
          do
          begin

            --CQ[9756]-->
            select first 1 C.ITOG
            from A_LZ_CENLVL C
            where (C.ID = :ID) and
                  (C.IDCENLVL = :ID_CENLVL)
            into :ITOG_LEVEL;
            --CQ[9756]<--

            if (ATYPE <> 212) then
              select N.AVAR, N.NAME, coalesce(:APRINT, N.APRINT), coalesce(:NOTE, N.NOTE)
              from A_LZ_NAMES N
              where (N.IDGROUP = :CURRENT_VID) and
                    (N.ATYPE = :IDNAME)
              into :AVAR, :NAME, :APRINT, :NOTE;

            if ((ALLREC = 0) and
                (:IDOBJECT = :IDHIER)) then
              ALLREC = 0;
            else
            if ((FILTERPRINT = -1) or
                --   (  )
                ((FILTERPRINT in (0, 1, 2, 3)) and
                (APRINT = FILTERPRINT)) or
                --     
                ((FILTERPRINT = 4) and
                ((APRINT = 0) or ((APRINT = 1) and
                (LROUNDN(ITOG, 5) <> 0)) or ((APRINT = 2) and
                (LROUNDN(ITOG, 5) = 0)))) or
                --      
                ((FILTERPRINT = 5) and
                ((APRINT = 3) or ((APRINT = 1) and
                (LROUNDN(ITOG, 5) = 0)) or ((APRINT = 2) and
                (LROUNDN(ITOG, 5) <> 0))))) then
              suspend;


            else
            if (ALLREC = 1) then


            begin
              if (ALLREC = 1) then
                ATYPE = -ATYPE;
              suspend;

            end

          end

      end

      if ((HCOUNTCHILDREN > 0) and
          (CUR_PROJECTTYPE <> 1)) then
        for select ID, IDHIER, ATYPE, NUMBER, AVAR, NAME, FORMULA, ITOG, VID, APRINT, NOTE, UTV,
                   FACTOR_TYPE, PRECIS, ITOG_LEVEL
          from A_LZ_SELECT1_1(:IDUSER, :IDOBJECT, :SMETATYPE, :IDLEVEL, :FILTERPRINT, :NLS, :NR, :NPR, :ALLREC, :ID_CENLVL)
          into :ID, :IDHIER, :ATYPE, :NUMBER, :AVAR, :NAME, :FORMULA, :ITOG, :VID, :APRINT, :NOTE,
               :UTV, :FACTOR_TYPE, :PRECIS, :ITOG_LEVEL
        do
          suspend;

    end

  if ((IDOBJECT = IDLEVEL_ORIGINAL) and
      (CUR_PROJECTTYPE <> 1)) then
  begin

    ID = IDLEVEL_ORIGINAL;
    IDHIER = IDLEVEL_ORIGINAL;

    LZ_OTYPE = 1;

    ATYPE = LZ_OTYPE;

    CHECKNODE = null;

    UTV = null;
    select first 1 UTV
    from A_GET_PARAMS_OBJ_AKT(:IDUSER, :IDOBJECT, :SMETATYPE)
    into :UTV;
    if (:UTV is null) then
      UTV = 0;

    --  atype = 1;
    select first 1 HCH.ID
    from A_O_HIERCHECKING HCH
    where (HCH.IDUSER = :IDUSER) and
          (HCH.IDOBJECT = :IDOBJECT) and
          (HCH.SMETATYPE = :SMETATYPE) and
          (HCH.ATYPE = 25) and
          (HCH.IDELEM = :IDOBJECT)
    into :CHECKNODE;
    if (CHECKNODE is null) then
      ATYPE = -ATYPE;

    NUMBER = null;
    AVAR = null;
    NAME = '  :';
    FORMULA = null;
    ITOG = null;
    VID = null;
    APRINT = null;
    PRECIS = null;

    execute procedure A_S_GET_STRUCT_PUT(:IDUSER, :ATYPE, :NLS, :NR, :NPR)
    returning_values (:NLS, :NR, :NPR, :NOTE);

    suspend;

    if ((ALLREC = 1) or (ATYPE > 0)) then
    begin

      if (SMETATYPE > 16) then
        IDLEVEL_ORIGINAL = SMETATYPE;

      /*  ר */
      if (ALLREC = 1) then
      begin
        --CQ[9756]-->
        execute procedure A_LZ_GETITOG_OBJ_NL(:IDUSER, :IDOBJECT, :SMETATYPE, :ID_CENLVL)
        returning_values :O1_RA, :O1_RB, :O1_RC, :O1_RD, :O1_RE, :O1_RF, :O1_RG, :O1_RH, :O1_RI,
          :O1_RJ, :O1_RK, :O1_RL, :O1_RM, :O1_IT, :O1_RLM, :O1_ITOGO, :O1_RN, :O1_RO, :O1_RP,
          :O1_R25, :O1_R26, :O1_R27, :O1_R28, :O1_R29, --<<[12250]
          :O1_R_PR, :O1_RC_16, :O1_RE_16; --[15479]
        --CQ[9756]<--
      end
      /* End  ר */

      for select L.ITOG, L.ID, L.IDHIER, L.ATYPE, L.NUMBER, L.IDNAME, L.AVAR, L.NAME, L.FORMULA,
                 L.VID, L.APRINT, L.NOTE, T.FACTOR_TYPE, L.PRECIS
        from A_LZ L
        left join T_LZ_TYPE T on (L.VID = T.ID)
        where L.IDHIER = :IDLEVEL_ORIGINAL and
              L.SMETATYPE = :SMETATYPE
              --PLAN SORT ((L INDEX (A_LZ_IDHIER_SMETATYPE_ATYPE)))
        order by L.NUMBER
        into :ITOG, :ID, :IDHIER, :ATYPE, :NUMBER, :IDNAME, :AVAR, :NAME, :FORMULA, :VID, :APRINT,
             :NOTE, :FACTOR_TYPE, :PRECIS
      do
      begin

        if (ATYPE <> 212) then
          select N.AVAR, N.NAME, coalesce(:APRINT, N.APRINT), coalesce(:NOTE, N.NOTE)
          from A_LZ_NAMES N
          where (N.IDGROUP = :CURRENT_VID) and
                (N.ATYPE = :IDNAME)
          into :AVAR, :NAME, :APRINT, :NOTE;

        /*  ר */
        if (ALLREC = 1) then
        begin
          ITOG = 0;
          --CQ[9756]-->
          ITOG_LEVEL = case :ATYPE
                         when 201 then :O1_RA
                         when 202 then :O1_RB
                         when 203 then :O1_RC
                         when 204 then :O1_RD
                         when 205 then :O1_RE
                         when 206 then :O1_RF
                         when 207 then :O1_RG
                         when 208 then :O1_RH
                         when 209 then :O1_RI
                         when 210 then :O1_RJ
                         when 211 then :O1_RK
                         when 216 then :O1_RL
                         when 222 then :O1_RM
                         when 213 then :O1_IT
                         when 223 then :O1_RLM
                         when 224 then :O1_ITOGO
                         -- MK CQ[9374] --->
                         when 214 then :O1_RN
                         when 215 then :O1_RO
                         when 217 then :O1_RP
                         -- MK CQ[9374] <---

                         --<<[12250]
                         when 225 then :O1_R25
                         when 226 then :O1_R26
                         when 227 then :O1_R27
                         when 228 then :O1_R28
                         when 229 then :O1_R29

                         --[15479]
                         when 230 then :O1_R_PR
                         when 231 then :O1_RC_16
                         when 232 then :O1_RE_16

                         else :ITOG
                       end;
          --CQ[9756]<--

        end

        /* End  ר */
        else
          ITOG = 0;

        /* MK         */
        if ((ALLREC = 1) or (FILTERPRINT = -1) or (APRINT = FILTERPRINT) or (FILTERPRINT in (4, 5))) then
          suspend;

        else
        if (ALLREC = 1) then
        /* MK 14.04.2006 -     */
        begin

          ATYPE = -ATYPE;
          suspend;

        end

      end

    end

  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE A_LZ_SELECT1_NL (
    IDUSER INTEGER,
    IDOBJECT INTEGER,
    SMETATYPE INTEGER,
    IDLEVEL INTEGER,
    FILTERPRINT INTEGER,
    NLS INTEGER,
    NR INTEGER,
    NPR INTEGER,
    ALLREC INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    ATYPE INTEGER,
    NUMBER INTEGER,
    AVAR VARCHAR(30),
    NAME VARCHAR(1050),
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITOG DOUBLE PRECISION,
    VID INTEGER,
    APRINT INTEGER,
    NOTE VARCHAR(255),
    UTV INTEGER,
    FACTOR_TYPE INTEGER,
    PRECIS INTEGER,
    ITOG_LEVEL DOUBLE PRECISION)
AS
--CQ[TIMUR 13931] -    ANAME
DECLARE VARIABLE HATYPE INTEGER;
DECLARE VARIABLE HCOUNTCHILDREN INTEGER;
DECLARE VARIABLE IDNAME INTEGER;
DECLARE VARIABLE LZTYPE INTEGER;
DECLARE VARIABLE LZ_OTYPE INTEGER;
DECLARE VARIABLE CHECKNODE INTEGER;
DECLARE VARIABLE IDLEVEL_ORIGINAL INTEGER;
DECLARE VARIABLE CURRENT_VID INTEGER;
DECLARE VARIABLE CUR_PROJECTTYPE INTEGER;
DECLARE VARIABLE O_RA DOUBLE PRECISION;
DECLARE VARIABLE O_RB DOUBLE PRECISION;
DECLARE VARIABLE O_RC DOUBLE PRECISION;
DECLARE VARIABLE O_RD DOUBLE PRECISION;
DECLARE VARIABLE O_RE DOUBLE PRECISION;
DECLARE VARIABLE O_RF DOUBLE PRECISION;
DECLARE VARIABLE O_RG DOUBLE PRECISION;
DECLARE VARIABLE O_RH DOUBLE PRECISION;
DECLARE VARIABLE O_RI DOUBLE PRECISION;
DECLARE VARIABLE O_RJ DOUBLE PRECISION;
DECLARE VARIABLE O_RK DOUBLE PRECISION;
DECLARE VARIABLE O_RL DOUBLE PRECISION;
DECLARE VARIABLE O_RM DOUBLE PRECISION;
DECLARE VARIABLE O_IT DOUBLE PRECISION;
DECLARE VARIABLE O_RLM DOUBLE PRECISION;
DECLARE VARIABLE O_ITOGO DOUBLE PRECISION;

DECLARE VARIABLE O_RN DOUBLE PRECISION;
DECLARE VARIABLE O_RO DOUBLE PRECISION;
DECLARE VARIABLE O_RP DOUBLE PRECISION;

--<<[12250]
declare O_R25 double precision;
declare O_R26 double precision;
declare O_R27 double precision;
declare O_R28 double precision;
declare O_R29 double precision;

--[15479]
DECLARE VARIABLE O_R_PR DOUBLE PRECISION;
DECLARE VARIABLE O_RC_16 DOUBLE PRECISION;
DECLARE VARIABLE O_RE_16 DOUBLE PRECISION;

DECLARE VARIABLE O1_RA DOUBLE PRECISION;
DECLARE VARIABLE O1_RB DOUBLE PRECISION;
DECLARE VARIABLE O1_RC DOUBLE PRECISION;
DECLARE VARIABLE O1_RD DOUBLE PRECISION;
DECLARE VARIABLE O1_RE DOUBLE PRECISION;
DECLARE VARIABLE O1_RF DOUBLE PRECISION;
DECLARE VARIABLE O1_RG DOUBLE PRECISION;
DECLARE VARIABLE O1_RH DOUBLE PRECISION;
DECLARE VARIABLE O1_RI DOUBLE PRECISION;
DECLARE VARIABLE O1_RJ DOUBLE PRECISION;
DECLARE VARIABLE O1_RK DOUBLE PRECISION;
DECLARE VARIABLE O1_RL DOUBLE PRECISION;
DECLARE VARIABLE O1_RM DOUBLE PRECISION;
DECLARE VARIABLE O1_IT DOUBLE PRECISION;
DECLARE VARIABLE O1_RLM DOUBLE PRECISION;
DECLARE VARIABLE O1_ITOGO DOUBLE PRECISION;

DECLARE VARIABLE O1_RN DOUBLE PRECISION;
DECLARE VARIABLE O1_RO DOUBLE PRECISION;
DECLARE VARIABLE O1_RP DOUBLE PRECISION;

--<<[12250]
declare O1_R25 double precision;
declare O1_R26 double precision;
declare O1_R27 double precision;
declare O1_R28 double precision;
declare O1_R29 double precision;

--[15479]
DECLARE VARIABLE O1_R_PR DOUBLE PRECISION;
DECLARE VARIABLE O1_RC_16 DOUBLE PRECISION;
DECLARE VARIABLE O1_RE_16 DOUBLE PRECISION;

DECLARE VARIABLE ID_TMP INTEGER;
DECLARE VARIABLE ID_CENLVL_1 INTEGER;
DECLARE VARIABLE ID_CENLVL_2 INTEGER;
BEGIN
--[15352]
--[15479]

 -- MK 21.06.2011 CQ[9329] --->
 --     
 --    2    ,     
 --     
 FOR SELECT c.id
 FROM LEVEL_COST c
 where c.IDOBJECT = case when :SMETATYPE > 999 then :SMETATYPE else :IDOBJECT end --<< 2011/08/26     
 ORDER BY c.lorder
 INTO :ID_TMP DO
 BEGIN
   IF (ID_CENLVL_1 IS NULL) THEN
     ID_CENLVL_1 = ID_TMP;
   ELSE IF (ID_CENLVL_2 IS NULL) THEN
     ID_CENLVL_2 = ID_TMP;
 END
 -- MK 21.06.2011 CQ[9329] <---



 lztype = smetatype;
 /*if ( smetatype = 15 )
 then lztype = 21;
 else lztype = 22;*/

 idlevel_original = idlevel;

 current_vid = 200;

 SELECT u.idlzgroup
 FROM b_user_access u
 WHERE u.id = :iduser
 INTO :current_vid;

 SELECT projecttype
 FROM l_getprojecttype( :iduser )
 INTO :cur_projecttype;

  --<rvs:00004533>
 FOR SELECT IDHIER
   FROM S_O_HIER_SELECT_LEVEL_NF(:IDLEVEL_ORIGINAL)
   INTO :IDLEVEL
 DO
 --</rvs:00004533>
 FOR SELECT h.number, h.atype, h.countchildren
     FROM a_o_hier h
     WHERE h.NUMBER = :IDLEVEL AND --(h.parent = :idlevel_original) and <<rvs:00004533
           --(h.atype IN (0,3,4,5)) and <<rvs:00004533
           ( (h.subtype IS NULL) OR (h.subtype IN (0,1,2,3,4,5) ) )
     ORDER BY h.sorting
     INTO :idlevel, :hatype, :hcountchildren
 DO
 BEGIN

  IF (hatype > 0)
  THEN
  BEGIN
-->DEN
   EXECUTE PROCEDURE M_H_GET_UTV(:idlevel, :hatype, :SMETATYPE) RETURNING_VALUES :UTV;
--
   SELECT n.FULLNAME
   FROM a_h_GetName( :idlevel, :hatype ) n
   INTO :name;

   IF ( hatype = 4 ) THEN
     name = '    ' || name;
   IF ( hatype = 5 ) THEN
     name = '    ' || '    ' || name;

   id = idlevel; idhier = idlevel; atype = hatype; number = NULL; avar = NULL; formula = NULL;
   itog = NULL; vid = NULL; aprint = NULL;
   PRECIS = NULL;

   checknode = NULL;
   SELECT FIRST 1 hch.id
   FROM A_O_HIERCHECKING hch
   WHERE (hch.iduser = :iduser) AND
         (hch.idobject = :idobject) AND
         (hch.smetatype = :smetatype) AND
         (hch.atype = 25) AND
         (hch.idelem = :idlevel)
   INTO :checknode;

   EXECUTE PROCEDURE a_s_get_struct_put ( :iduser, :atype, :nls, :nr, :npr )
           RETURNING_VALUES ( :nls, :nr, :npr, :note );

   IF ( cur_projecttype <> 1 )
   THEN
   BEGIN

    IF (checknode IS NULL)
    THEN atype = -atype;

    SUSPEND;

   END

   -- MK CQ[13927] --->
   if ((allrec <> 1) and (atype > 0)) then --    
   begin
     if (exists(select * from A_LZ_TEMPLATE_USE where (IDHIER = :IDHIER) and (SMETATYPE = :SMETATYPE))) then
     begin
       atype = 47;  -- . S_LZTEMPLATES.ATYPE
       note = null; ITOG = null; ITOG_LEVEL = null;
       name = null; --   
  
       suspend;
     end
   end
   -- MK CQ[13927] <---


   IF (
       ( allrec = 1 ) OR
       ( atype > 0 )
      )
   THEN FOR SELECT l.id, l.idhier, l.atype, l.number, l.idname, l.avar, l.name, l.formula, l.itog, l.vid,
                   l.aprint, l.note, t.FACTOR_TYPE, l.PRECIS
            FROM a_lz l
            LEFT JOIN T_LZ_TYPE t ON (l.vid = t.ID)
            WHERE l.idhier = :idlevel AND l.smetatype = :lztype
            --PLAN SORT ((L INDEX (A_LZ_IDHIER_SMETATYPE_ATYPE)))
            ORDER BY l.number
--            order by l.idhier, l.smetatype
            INTO :id, :idhier, :atype, :number, :idname, :avar, :name, :formula,
                 :itog, :vid, :aprint, :note, :FACTOR_TYPE, :PRECIS
        DO
        BEGIN
         -- MK 21.06.2011 CQ[9329] --->
         IF (ID_CENLVL_1 IS NOT NULL) THEN
         BEGIN
           SELECT FIRST 1 c.itog
           FROM a_lz_cenlvl c
           WHERE (c.id = :id) AND (c.idcenlvl = :ID_CENLVL_1)
           INTO :ITOG;
         END

         IF (ID_CENLVL_2 IS NOT NULL) THEN
         BEGIN
           SELECT FIRST 1 c.itog
           FROM a_lz_cenlvl c
           WHERE (c.id = :id) AND (c.idcenlvl = :ID_CENLVL_2)
           INTO :ITOG_LEVEL;
         END
         -- MK 21.06.2011 CQ[9329] <---

         IF (atype <> 212) THEN
           SELECT n.avar, n.name, COALESCE(:aprint, n.aprint), COALESCE(:note, n.NOTE)
              FROM a_lz_names n
              WHERE ( n.idgroup = :current_vid ) AND
                    ( n.atype = :idname )
              INTO :avar, :name, :aprint, :note;


           IF ((allrec = 0) AND (:IDOBJECT = :IDHIER)) THEN
             allrec = 0;
           ELSE
           IF ((filterprint = -1) OR
               --   (  )
               ((filterprint IN (0, 1, 2, 3)) AND (aprint = filterprint)) OR
               --     
               ((filterprint = 4) AND ((aprint = 0) OR ((aprint = 1) AND (LRoundN(ITOG, 5) <> 0)) OR ((aprint = 2) AND (LRoundN(ITOG, 5) = 0)))) OR
               --      
               ((filterprint = 5) AND ((aprint = 3) OR ((aprint = 1) AND (LRoundN(ITOG, 5) = 0)) OR ((aprint = 2) AND (LRoundN(ITOG, 5) <> 0))))) THEN

              SUSPEND;
           /* MK CQ[2437] <--- */

        ELSE IF ( allrec = 1 ) THEN

              BEGIN
               IF ( allrec = 1 ) THEN
               atype = -atype;
               SUSPEND;

              END


        END

  END

  IF (
      ( hcountchildren > 0 ) AND
      ( cur_projecttype <> 1 )
     )
  THEN FOR SELECT ID, IDHIER, ATYPE, NUMBER, AVAR, NAME, FORMULA,
                  ITOG, VID, APRINT, NOTE, UTV, FACTOR_TYPE, PRECIS,
                  ITOG_LEVEL
           FROM a_lz_select1_nl(:iduser, :idobject, :smetatype, :idlevel,
                                :filterprint, :nls, :nr, :npr, :allrec )
           INTO :id, :idhier, :atype, :number, :avar, :name, :formula,
                :itog, :vid, :aprint, :note, :UTV, :FACTOR_TYPE, :PRECIS,
                :ITOG_LEVEL
       DO SUSPEND;

 END

 IF (
     ( idobject = idlevel_original ) AND
     ( cur_projecttype <> 1 )
    )
 THEN
 BEGIN

  id = idlevel_original;
  idhier = idlevel_original;

  lz_otype = 1;
  /*if ( smetatype = 15 )
  then lz_otype = 23;
  else lz_otype = 24;*/

  atype = lz_otype;

  checknode = NULL;


  utv = NULL;
  SELECT FIRST 1 utv FROM A_GET_PARAMS_OBJ_AKT(:iduser, :idobject, :smetatype)
  INTO :utv;
  IF (:utv IS NULL) THEN
    utv = 0;

--  atype = 1;
  SELECT FIRST 1 hch.id
  FROM A_O_HIERCHECKING hch
  WHERE (hch.iduser = :iduser) AND
        (hch.idobject = :idobject) AND
        (hch.smetatype = :smetatype) AND
        (hch.atype = 25) AND
        (hch.idelem = :idobject)
  INTO :checknode;
  IF ( checknode IS NULL )
  THEN  atype = -atype;

  number = NULL; avar = NULL; name = '  :'; formula = NULL;
  itog = NULL; vid = NULL; aprint = NULL;
  PRECIS = NULL;

  EXECUTE PROCEDURE a_s_get_struct_put ( :iduser, :atype, :nls, :nr, :npr )
          RETURNING_VALUES ( :nls, :nr, :npr, :note );

  SUSPEND;


   -- MK CQ[13927] --->
   if ((allrec <> 1) and (atype > 0)) then --    
   begin
     if (smetatype > 16) then
       idlevel_original = smetatype;

     if (exists(select * from A_LZ_TEMPLATE_USE where (IDHIER = :idlevel_original) and (SMETATYPE = :SMETATYPE))) then
     begin
       atype = 47;  -- . S_LZTEMPLATES.ATYPE
       note = null;  ITOG = null; ITOG_LEVEL = null;
       name = null; --   
       IDHIER = :idlevel_original;

       suspend;
     end
   end
   -- MK CQ[13927] <---


  IF (
      ( allrec = 1 ) OR
      ( atype > 0 )
     )
  THEN
  BEGIN

   IF ( smetatype > 16 )
   THEN idlevel_original = smetatype;

   /*  ר */
   IF ( allrec = 1 )
   THEN --select first 1 i.ra, rb, rc, rd, re, rf, rg, rh, ri, rj, rk, it
        --from a_lz_getitog_obj( :iduser, :idobject, :smetatype ) i
        --into :o_ra, :o_rb, :o_rc, :o_rd, :o_re, :o_rf, :o_rg, :o_rh, :o_ri, :o_rj, :o_rk, O_IT;
   begin
        IF (ID_CENLVL_1 IS NOT NULL) THEN
          EXECUTE PROCEDURE A_LZ_GETITOG_OBJ_NL(:IDUSER, :IDOBJECT, :SMETATYPE, :ID_CENLVL_1)
            RETURNING_VALUES :O_RA, :O_RB, :O_RC, :O_RD, :O_RE, :O_RF, :O_RG,
                             :O_RH, :O_RI, :O_RJ, :O_RK, :O_RL, :O_RM, :O_IT,
                             :O_RLM, :O_ITOGO, :O_RN, :O_RO, :O_RP,
                             :O_R25, :O_R26, :O_R27, :O_R28, :O_R29, --<<[12250]
                             :O_R_PR, :O_RC_16, :O_RE_16; --[15479]

        IF (ID_CENLVL_2 IS NOT NULL) THEN
          EXECUTE PROCEDURE A_LZ_GETITOG_OBJ_NL(:IDUSER, :IDOBJECT, :SMETATYPE, :ID_CENLVL_2)
            RETURNING_VALUES :O1_RA, :O1_RB, :O1_RC, :O1_RD, :O1_RE, :O1_RF, :O1_RG,
                             :O1_RH, :O1_RI, :O1_RJ, :O1_RK, :O1_RL, :O1_RM, :O1_IT,
                             :O1_RLM, :O1_ITOGO, :O1_RN, :O1_RO, :O1_RP,
                             :O1_R25, :O1_R26, :O1_R27, :O1_R28, :O1_R29, --<<[12250]
                             :O1_R_PR, :O1_RC_16, :O1_RE_16; --[15479]
   end
   /* End  ר */

   FOR SELECT l.itog, l.id, l.idhier, l.atype, l.number, l.idname, l.avar, l.name, l.formula, l.vid,
              l.aprint, l.note, t.FACTOR_TYPE, l.PRECIS
       FROM a_lz l
       LEFT JOIN T_LZ_TYPE t ON (l.vid = t.ID)
       WHERE l.idhier = :idlevel_original AND l.smetatype = :smetatype
       --PLAN SORT ((L INDEX (A_LZ_IDHIER_SMETATYPE_ATYPE)))
       ORDER BY l.number
       INTO :itog, :id, :idhier, :atype, :number, :idname, :avar, :name, :formula,
            :vid, :aprint, :note, :FACTOR_TYPE, :PRECIS
   DO
   BEGIN

     IF (atype <> 212) THEN
       SELECT n.avar, n.name, COALESCE(:aprint, n.aprint), COALESCE(:note, n.NOTE)
         FROM a_lz_names n
         WHERE ( n.idgroup = :current_vid ) AND
               ( n.atype = :idname )
         INTO :avar, :name, :aprint, :note;

     /*  ר */
     IF ( allrec = 1 )
     THEN
     BEGIN
      ITOG = 0;
      IF (ID_CENLVL_1 IS NOT NULL) THEN
        ITOG =
          CASE :ATYPE
            WHEN 201 THEN :O_RA
            WHEN 202 THEN :O_RB
            WHEN 203 THEN :O_RC
            WHEN 204 THEN :O_RD
            WHEN 205 THEN :O_RE
            WHEN 206 THEN :O_RF
            WHEN 207 THEN :O_RG
            WHEN 208 THEN :O_RH
            WHEN 209 THEN :O_RI
            WHEN 210 THEN :O_RJ
            WHEN 211 THEN :O_RK
            WHEN 216 THEN :O_RL --<<[7398] --<<[633526DDD29B]
            WHEN 222 THEN :O_RM
            WHEN 213 THEN :O_IT
            when 223 then :O_RLM    -- CQ[8295]
            when 224 then :O_ITOGO  -- CQ[9349]

            -- MK CQ[9374] --->
            WHEN 214 THEN :O_RN
            WHEN 215 THEN :O_RO
            WHEN 217 THEN :O_RP
            -- MK CQ[9374] <---

            --<<[12250]
            when 225 then :O_R25
            when 226 then :O_R26
            when 227 then :O_R27
            when 228 then :O_R28
            when 229 then :O_R29

            --[15479]
            when 230 then :O_R_PR
            when 231 then :O_RC_16
            when 232 then :O_RE_16
            --[15479]

            ELSE :ITOG
          END;

      ITOG_LEVEL = 0;
      IF (ID_CENLVL_2 IS NOT NULL) THEN
        ITOG_LEVEL =
          CASE :ATYPE
            WHEN 201 THEN :O1_RA
            WHEN 202 THEN :O1_RB
            WHEN 203 THEN :O1_RC
            WHEN 204 THEN :O1_RD
            WHEN 205 THEN :O1_RE
            WHEN 206 THEN :O1_RF
            WHEN 207 THEN :O1_RG
            WHEN 208 THEN :O1_RH
            WHEN 209 THEN :O1_RI
            WHEN 210 THEN :O1_RJ
            WHEN 211 THEN :O1_RK
            WHEN 216 THEN :O1_RL --<<[7398] --<<[633526DDD29B]
            WHEN 222 THEN :O1_RM
            WHEN 213 THEN :O1_IT
            when 223 then :O1_RLM    -- CQ[8295]
            when 224 then :O1_ITOGO  -- CQ[9349]

            -- MK CQ[9374] --->
            WHEN 214 THEN :O1_RN
            WHEN 215 THEN :O1_RO
            WHEN 217 THEN :O1_RP
            -- MK CQ[9374] <---

            --<<[12250]
            when 225 then :O1_R25
            when 226 then :O1_R26
            when 227 then :O1_R27
            when 228 then :O1_R28
            when 229 then :O1_R29

            --[15479]
            when 230 then :O1_R_PR
            when 231 then :O1_RC_16
            when 232 then :O1_RE_16
            --[15479]

            ELSE :ITOG
          END;

     END
     /* End  ר */
     ELSE itog = 0;


     /* MK         */
     IF (
         ( allrec = 1 ) OR
         ( filterprint = -1 ) OR
         ( aprint = filterprint ) OR
         ( filterprint IN (4, 5) )
        )
     THEN
        SUSPEND;

     ELSE IF ( allrec = 1 )
          THEN
          /* MK 14.04.2006 -     */
          BEGIN

            atype = -atype;
            SUSPEND;

          END

   END

  END

 END
END
^

--[15195]
CREATE OR ALTER PROCEDURE A_S_CLONE_SMETA_REC_CENLVL (
    IDUSER INTEGER,
    IDSMRECSRC INTEGER,
    IDSMRECDST INTEGER,
    IDLEVELSRC INTEGER,
    NEEDCOPYEX INTEGER)
AS
declare IDZONE integer;
declare IDINDEX integer;
declare ID_LEVEL_INDEX integer;
declare ID_LEVEL_VC integer;
declare BA double precision;
declare BB double precision;
declare BC double precision;
declare BD double precision;
declare BE double precision;
declare BF double precision;
declare BG double precision;
declare BH double precision;
declare BI double precision;
declare BJ double precision;
declare BN double precision;
declare BO double precision;
declare B_ITOGO double precision;
declare B_PR double precision; --[15352]
declare CA double precision;
declare CB double precision;
declare CC double precision;
declare CD double precision;
declare CE double precision;
declare CF double precision;
declare CG double precision;
declare CH double precision;
declare CI double precision;
declare CJ double precision;
declare CN double precision;
declare CO double precision;
declare C_ITOGO double precision;
declare C_PR double precision; --[15352]
declare EA double precision;
declare EB double precision;
declare EC double precision;
declare ED double precision;
declare EE double precision;
declare EF double precision;
declare EG double precision;
declare EH double precision;
declare EI double precision;
declare EJ double precision;
declare EK double precision;
declare EN double precision;
declare EO double precision;
declare E_ITOGO double precision;
declare E_PR double precision; --[15352]
declare RA double precision;
declare RB double precision;
declare RC double precision;
declare RD double precision;
declare RE double precision;
declare RF double precision;
declare RG double precision;
declare RH double precision;
declare RI double precision;
declare RJ double precision;
declare RK double precision;
declare RL double precision;
declare RM double precision;
declare PA double precision;
declare PB double precision;
declare PC double precision;
declare PD double precision;
declare ITOGO double precision;
declare R_PR double precision; --[15352]
declare RC_16 double precision; --[15352]
declare RE_16 double precision; --[15352]
declare PUNKTIND varchar(42);
declare MA double precision;
declare MB double precision;
declare MC double precision;
declare MD double precision;
declare ME double precision;
declare MF double precision;
declare MG double precision;
declare MH double precision;
declare MI double precision;
declare INDEX_SPOSOBRASCH integer;
declare CALCBMASK integer;
declare BASE_INFO integer;
declare INDEX_INFO integer;
declare IDCLASS integer;
declare IDLEVEL integer;
declare IDHIER integer;
declare SMETATYPE integer;
declare ATYPE integer;
declare IDTR integer;
declare VRPZ integer;
declare RES_COPY_FORMULS integer;

declare IDRESSRC integer;
declare IDRESDST integer;

declare variable SLAVEPARENT integer;

declare variable MJ double precision;
declare variable MK  double precision;
declare variable ML double precision;
declare variable MM double precision;
declare M_PR double precision;
declare variable DA double precision;
declare variable DB double precision;
declare variable DC double precision;
declare variable DD double precision;
declare variable DE double precision;
declare variable DJ double precision;
declare variable DK  double precision;
declare variable DL double precision;
declare variable DM double precision;

declare variable VN_CURR_CENA double precision;
declare variable VN_BASE_CALC_INFO integer;
declare variable VN_SOURCE_LEVEL_ID integer;

-- MK CQ[11989]
declare variable VN_CURR_CENA_INFO integer;
declare variable VN_ID_VALUTE integer;
declare variable VN_VALUTE_CURS double precision;
declare variable VN_VALUTE_DATE date;
declare variable VN_TRANSP double precision;
declare variable VN_ZAG_SKL double precision;
declare variable VN_ZAPCHAST double precision;
declare variable VN_TARA double precision;
declare variable VN_NACEN double precision;
declare variable VN_COMPLECT double precision;
declare variable VN_KOEFF_TYPE integer;
begin
--[15352]
  --------------  !!!!! --------------
 -- :        
 --------------  !!!!! --------------


  --:     A_S_PASTE_SMETA_REC_CENLVL
  --NEEDCOPYEx    Ex    ,   

  NEEDCOPYEx = coalesce(NEEDCOPYEx, 1);

  select IDHIER, SMETATYPE, ATYPE, SLAVEPARENT, VRPZ
  from A_SMETA
  where ID = :IDSMRECDST
  into :IDHIER, :SMETATYPE, :ATYPE, :SLAVEPARENT, :VRPZ;

  if (:ATYPE in (17 /*SmRec*/ , 18 /*ResRec*/ )) then
  begin
    if (:SMETATYPE > 999) then
    begin
      IDCLASS = :SMETATYPE;
      select ID_TR, RES_COPY_FORMULS
      from A_O_FACTPARAMS
      where NUMBER = :IDCLASS
      into :IDTR, :RES_COPY_FORMULS;
    end
    else
    begin
      execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1 /*ObgectType*/ )
      returning_values :IDCLASS;
      select ID_TR, RES_COPY_FORMULS
      from A_O_OBJECTPARAMS
      where NUMBER = :IDCLASS
      into :IDTR, :RES_COPY_FORMULS;
    end
  end
  else
    exit;

  --    
  --CQ[TIMUR 13178] -   BN, BO, B_ITOGO, C_ITOGO, EN, EO, E_ITOGO, ITOGO
  for select C.IDZONE, I.IDINDEX, I.ID_LEVEL_INDEX, C.ID_LEVEL_VC,
             C.BA, C.BB, C.BC, C.BD, C.BE, C.BF, C.BG, C.BH, C.BI, C.BJ, C.BN, C.BO, C.B_ITOGO,
             C.B_PR, --[15352]
             C.CA, C.CB, C.CC, C.CD, C.CE, C.CF, C.CG, C.CH, C.CI, C.CJ, C.C_ITOGO,
             C.C_PR, --[15352]
             C.EA, C.EB, C.EC, C.ED, C.EE, C.EF, C.EG, C.EH, C.EI, C.EJ, C.EK, C.EN, C.EO, C.E_ITOGO,
             C.E_PR, --[15352]
             C.RA, C.RB, C.RC, C.RD, C.RE, C.RF, C.RG, C.RH, C.RI, C.RJ, C.RK, C.RL, C.RM, C.ITOGO,
             C.R_PR, C.RC_16, C.RE_16, --[15352]
             I.PUNKTIND, I.MA, I.MB, I.MC, I.MD, I.ME, I.MF, I.MG, I.MH, I.MI, I.INDEX_SPOSOBRASCH,
             C.CALCBMASK, C.BASE_INFO, I.INDEX_INFO,
             I.MJ, I.MK, I.ML, I.MM,
             I.M_PR, --[15352]
             I.DA, I.DB, I.DC, I.DD, I.DE, I.DJ, I.DK, I.DL, I.DM, --CQ[10529]
             C.CURR_CENA, C.BASE_CALC_INFO, C.SOURCE_LEVEL_ID,   -- MK 19.06.2012 CQ[10565]
             C.CURR_CENA_INFO, C.ID_VALUTE, C.VALUTE_CURS,       -- MK CQ[11989]
             C.VALUTE_DATE, C.TRANSP, C.ZAG_SKL,                 -- MK CQ[11989]
             C.ZAPCHAST, C.TARA, C.NACEN, C.COMPLECT,            -- MK CQ[11989]
             C.KOEFF_TYPE,                                       -- MK     8.9
             C.PA, C.PB, C.PC, C.PD -- CQ[12927]
      from A_SMETA_CENLVL C
      join A_SMETA_INDLVL I on I.ID = C.ID  and  I.IDCENLVL = C.IDCENLVL --CQ[10529]
      where C.ID = :IDSMRECSRC and
            C.IDCENLVL = :IDLEVELSRC
      into :IDZONE, :IDINDEX, :ID_LEVEL_INDEX, :ID_LEVEL_VC,
           :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
           :B_PR, --[15352]
           :CA, :CB, :CC, :CD, :CE, :CF, :CG, :CH, :CI, :CJ, :C_ITOGO,
           :C_PR, --[15352]
           :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK, :EN, :EO, :E_ITOGO,
           :E_PR, --[15352]
           :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :ITOGO,
           :R_PR, :RC_16, RE_16, --[15352]
           :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :INDEX_SPOSOBRASCH,
           :CALCBMASK, :BASE_INFO, :INDEX_INFO,
           :MJ, :MK, :ML, :MM,
           :M_PR, --[15352]
           :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM, --CQ[10529]
           :VN_CURR_CENA, :VN_BASE_CALC_INFO, :VN_SOURCE_LEVEL_ID, -- MK 19.06.2012 CQ[10565]
           :VN_CURR_CENA_INFO, :VN_ID_VALUTE, :VN_VALUTE_CURS,     -- MK CQ[11989]
           :VN_VALUTE_DATE, :VN_TRANSP, :VN_ZAG_SKL,               -- MK CQ[11989]
           :VN_ZAPCHAST, :VN_TARA, :VN_NACEN, :VN_COMPLECT,        -- MK CQ[11989]
           :VN_KOEFF_TYPE,                                         -- MK     8.9
           :PA, :PB, :PC, :PD -- CQ[12927]
  do
  begin
    if (:VN_BASE_CALC_INFO is null) then
      VN_BASE_CALC_INFO = 24; --<<[10584]
    --     -
    for select L.ID
        from LEVEL_COST L
        where L.IDOBJECT = :IDCLASS
        into :IDLEVEL
    do
    begin
      -- ..    -       
      -- CQ[12927] --> 
      -- execute procedure A_S_GET_FORMUL_NRSPZU_NL_1(:IDUSER, :ATYPE, :SLAVEPARENT, :IDTR, :VRPZ,
      --     :RES_COPY_FORMULS, :IDLEVEL)
      -- returning_values (:PA, :PB, :PC, :PD);
      -- CQ[12927]  <--
      update A_SMETA_CENLVL set
        IDZONE = :IDZONE,
        ID_LEVEL_VC = :ID_LEVEL_VC,
        BA = :BA,
        BB = :BB,
        BC = :BC,
        BD = :BD,
        BE = :BE,
        BF = :BF,
        BG = :BG,
        BH = :BH,
        BI = :BI,
        BJ = :BJ,
        BN = :BN, --CQ[TIMUR 13178]
        BO = :BO, --CQ[TIMUR 13178]
        B_ITOGO = :B_ITOGO, --CQ[TIMUR 13178]
        B_PR = :B_PR, --[15352]
        CA = :CA,
        CB = :CB,
        CC = :CC,
        CD = :CD,
        CE = :CE,
        CF = :CF,
        CG = :CG,
        CH = :CH,
        CI = :CI,
        CJ = :CJ,
        C_ITOGO = :C_ITOGO, --CQ[TIMUR 13178]
        C_PR = :C_PR, --[15352]
        EA = case when (:NEEDCOPYEx = 1) then :EA else null end,
        EB = case when (:NEEDCOPYEx = 1) then :EB else null end,
        EC = case when (:NEEDCOPYEx = 1) then :EC else null end,
        ED = case when (:NEEDCOPYEx = 1) then :ED else null end,
        EE = case when (:NEEDCOPYEx = 1) then :EE else null end,
        EF = case when (:NEEDCOPYEx = 1) then :EF else null end,
        EG = case when (:NEEDCOPYEx = 1) then :EG else null end,
        EH = case when (:NEEDCOPYEx = 1) then :EH else null end,
        EI = case when (:NEEDCOPYEx = 1) then :EI else null end,
        EJ = case when (:NEEDCOPYEx = 1) then :EJ else null end,
        EK = case when (:NEEDCOPYEx = 1) then :EK else null end,
        EN = case when (:NEEDCOPYEx = 1) then :EN else null end,           --CQ[TIMUR 13178]
        EO = case when (:NEEDCOPYEx = 1) then :EO else null end,           --CQ[TIMUR 13178]
        E_ITOGO = case when (:NEEDCOPYEx = 1) then :E_ITOGO else null end, --CQ[TIMUR 13178]
        E_PR = case when (:NEEDCOPYEx = 1) then :E_PR else null end, --[15352]
        -- CQ[12927] --> 
        RA = :RA,
        RB = :RB,
        RC = :RC,
        RD = :RD,
        RE = :RE,
        RF = :RF,
        RG = :RG,
        RH = :RH,
        RI = :RI,
        RJ = :RJ,
        RK = :RK,
        RL = :RL,
        RM = :RM,
        -- CQ[12927]  <--
        PA = :PA,
        PB = :PB,
        PC = :PC,
        PD = :PD,
        ITOGO =  :ITOGO, -- CQ[12927] case when (:IDLEVEL = :IDLEVELSRC) then :ITOGO else null end,
        R_PR = :R_PR, --[15352]
        RC_16 = :RC_16, --[15352]
        RE_16 = :RE_16, --[15352]
        CALCBMASK = :CALCBMASK,
        BASE_INFO = :BASE_INFO,
        /*CQ[10529]PUNKTIND = :PUNKTIND,
        MA = case when (:IDLEVEL = :IDLEVELSRC) then :MA else 1 end,
        MB = case when (:IDLEVEL = :IDLEVELSRC) then :MB else 1 end,
        MC = case when (:IDLEVEL = :IDLEVELSRC) then :MC else 1 end,
        MD = case when (:IDLEVEL = :IDLEVELSRC) then :MD else 1 end,
        ME = case when (:IDLEVEL = :IDLEVELSRC) then :ME else 1 end,
        MF = case when (:IDLEVEL = :IDLEVELSRC) then :MF else 0 end,
        MG = case when (:IDLEVEL = :IDLEVELSRC) then :MG else 0 end,
        MH = case when (:IDLEVEL = :IDLEVELSRC) then :MH else 1 end,
        MI = case when (:IDLEVEL = :IDLEVELSRC) then :MI else 1 end,
        IDINDEX = case when (:IDLEVEL = :IDLEVELSRC) then :IDINDEX else 0 end,
        ID_LEVEL_INDEX = case when (:IDLEVEL = :IDLEVELSRC) then :ID_LEVEL_INDEX else 0 end,
        INDEX_INFO = case when (:IDLEVEL = :IDLEVELSRC) then :INDEX_INFO else null end,
        INDEX_SPOSOBRASCH = :INDEX_SPOSOBRASCH*/

        /* --[10584.7]
        -- MK 19.06.2012 CQ[10565] --->
        --    
        CURR_CENA = 0,       --:VN_CURR_CENA,
        BASE_CALC_INFO = 24, --:VN_BASE_CALC_INFO, -- (24 = 11000)
        SOURCE_LEVEL_ID = 0  --:VN_SOURCE_LEVEL_ID
        -- MK 19.06.2012 CQ[10565] <---
        ++[10584.7] */
        CURR_CENA = :VN_CURR_CENA, -- CQ[12927] case when (:IDLEVEL = :IDLEVELSRC) then :VN_CURR_CENA else 0 end,
        BASE_CALC_INFO = :VN_BASE_CALC_INFO, -- CQ[12927]
        SOURCE_LEVEL_ID = 0, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then -1 else :IDLEVELSRC end,
        --

        -- MK CQ[11989] --->
        CURR_CENA_INFO = :VN_CURR_CENA_INFO, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_CURR_CENA_INFO else null end,
        ID_VALUTE = :VN_ID_VALUTE, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_ID_VALUTE else 1 end,
        VALUTE_CURS = :VN_VALUTE_CURS, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_VALUTE_CURS else null end,
        VALUTE_DATE = :VN_VALUTE_DATE, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_VALUTE_DATE else null end,
        TRANSP = :VN_TRANSP, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_TRANSP else 0 end,
        ZAG_SKL = :VN_ZAG_SKL, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_ZAG_SKL else 0 end,
        ZAPCHAST = :VN_ZAPCHAST, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_ZAPCHAST else 0 end,
        TARA = :VN_TARA, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_TARA else 0 end,
        NACEN = :VN_NACEN, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_NACEN else 0 end,
        COMPLECT = :VN_COMPLECT, -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_COMPLECT else 0 end,
        -- MK     8.9
        KOEFF_TYPE = :VN_KOEFF_TYPE -- CQ[13948] case when (:IDLEVEL = :IDLEVELSRC) then :VN_KOEFF_TYPE else 0 end
        -- MK CQ[11989] <---

      where (ID = :IDSMRECDST /*ID*/ ) and
            (IDCENLVL = :IDLEVEL /*IDCENLVL*/ );

      --CQ[10529]>>
      update A_SMETA_INDLVL set
        PUNKTIND = :PUNKTIND,
        MA = :MA,
        MB = :MB,
        MC = :MC,
        MD = :MD,
        ME = :ME,
        MF = :MF,
        MG = :MG,
        MH = :MH,
        MI = :MI,
        IDINDEX = :IDINDEX,
        ID_LEVEL_INDEX = case when (:IDLEVEL = :IDLEVELSRC) then :ID_LEVEL_INDEX else 0 end,
        INDEX_INFO = case when (:IDLEVEL = :IDLEVELSRC) then :INDEX_INFO else null end,
        INDEX_SPOSOBRASCH = :INDEX_SPOSOBRASCH,
        --CQ[10529]-->
        MJ = :MJ,
        MK = :MK,
        ML = :ML,
        MM = :MM,
        M_PR = :M_PR, --[15352]
        DA = :DA,
        DB = :DB,
        DC = :DC,
        DD = :DD,
        DE = :DE,
        DJ = :DJ,
        DK = :DK,
        DL = :DL,
        DM = :DM
        --CQ[10529]<--

      where (ID = :IDSMRECDST) and
            (IDCENLVL = :IDLEVEL);

      execute procedure A_SMETA_INDLVL_DESC_CLONE (:IDSMRECSRC, :IDSMRECDST, :IDLEVELSRC, :IDLEVEL);--CQ[10529]

      --   -  ,   
      IDRESDST = 0;
      --   
      --   A_S_PASTE_SMETA_RECORD      ID
      for select R.ID
          from M_ETALON_S_RES R
          where R.ID_SOURCE = :IDSMRECSRC
          order by R.ID_SOURCE, R.ID
          into :IDRESSRC
      do
      begin
        for select first 1 R.ID
            from M_ETALON_S_RES R
            where R.ID_SOURCE = :IDSMRECDST and
                  R.ID > :IDRESDST
            order by R.ID_SOURCE, R.ID
            into :IDRESDST
        do
        begin
          for select IDZONE, ID_LEVEL_VC, BB, BC, BD, BE, BASE_INFO
              from A_S_ETALON_RES_CENLVL L
              where L.ID = :IDRESSRC and
                    L.IDCENLVL = :IDLEVELSRC
              into :IDZONE, :ID_LEVEL_VC, :BB, :BC, :BD, :BE, :BASE_INFO
          do
          begin
            update A_S_ETALON_RES_CENLVL set
              IDZONE = :IDZONE,
              ID_LEVEL_VC = :ID_LEVEL_VC,
              BB = :BB,
              BC = :BC,
              BD = :BD,
              BE = :BE,
              BASE_INFO = :BASE_INFO
            where (ID = :IDRESDST) and
                  (IDCENLVL = :IDLEVEL);
          end
        end
      end
      IDRESDST = 0;
      --   
      --   A_S_PASTE_SMETA_RECORD      ID
      for select R.ID
          from A_S_RES R
          where R.ID_SOURCE = :IDSMRECSRC and
                not exists(select *
                           from A_SMETA S
                           where S.ID_S_RES = R.ID)
          order by R.ID_SOURCE, R.ID
          into :IDRESSRC
      do
        for select first 1 R.ID
            from A_S_RES R
            where R.ID_SOURCE = :IDSMRECDST and
                  not exists(select *
                             from A_SMETA S
                             where S.ID_S_RES = R.ID) and
                  R.ID > :IDRESDST
            order by R.ID_SOURCE, R.ID
            into :IDRESDST
        do
          for select IDZONE, ID_LEVEL_VC, BB, BC, BD, BE, BASE_INFO
              from A_S_RES_CENLVL L
              where L.ID = :IDRESSRC and
                    L.IDCENLVL = :IDLEVELSRC
              into :IDZONE, :ID_LEVEL_VC, :BB, :BC, :BD, :BE, :BASE_INFO
          do
          begin

            update A_S_RES_CENLVL set
              IDZONE = :IDZONE,
              ID_LEVEL_VC = :ID_LEVEL_VC,
              BB = :BB,
              BC = :BC,
              BD = :BD,
              BE = :BE,
              BASE_INFO = :BASE_INFO
            where (ID = :IDRESDST) and
                  (IDCENLVL = :IDLEVEL);
          end

    end
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE A_S_GET_INDEX_NL_NEW (
    ID_LEVEL INTEGER,
    ID_USER INTEGER,
    ATYPE INTEGER,
    IN_PUNKTIND VARCHAR(42),
    ID_LEVEL_INDEX INTEGER,
    ID_SM_REC INTEGER,
    NEED_APPLY_INDEX INTEGER)
RETURNS (
    IDINDEX INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MF DOUBLE PRECISION,
    MG DOUBLE PRECISION,
    MH DOUBLE PRECISION,
    MI DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    M_PR DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DC DOUBLE PRECISION,
    DD DOUBLE PRECISION,
    DE DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    PUNKTIND VARCHAR(42),
    SPOSOB_RASCH INTEGER,
    RES_INDEX INTEGER)
AS
declare variable VN_RES integer;
declare variable VN_MAIN_SM_REC integer;
declare variable VN_IS_USED_INDEX integer;

--declare TAB varchar(42);
--declare RABMAT integer;
--declare TYPE_TRUD integer;
--declare TIPRAB integer;

--declare I_MA double precision;
--declare I_MB double precision;
--declare I_MC double precision;
--declare I_MD double precision;
--declare I_ME double precision;
--declare I_MF double precision;
--declare I_MG double precision;
--declare I_SPOSOBRASCH integer;
declare OLD_LEVEL_INDEX integer;

-- MK 3.08.2012 CQ[10695]
declare variable VN_INDEX_INFO integer;
begin
--[15352]+

-- [10502]    7.10 - A_S_GET_INDEX_NL_OLD
--    
-- RES_INDEX . A_SMETA_CENLVL.INDEX_INFO
-- NEED_APPLY_INDEX -    ...
-- [10502]    ""   ,    
--   ""  

  RES_INDEX = -2;
  --      (  )
  if (:ATYPE in (17, 18)) then
  begin
    /*select first 1 TAB, RABMAT, TYPE_TRUD, TIPRAB
      from A_SMETA
      where ID=:ID_SM_REC
      into TAB, RABMAT, TYPE_TRUD, TIPRAB;*/

    --         
    select first 1 S.MA, S.MB, S.MC, S.MD, S.ME, S.MF, S.MG, S.MH, S.MI,
                   S.MJ, S.MK, S.ML, S.MM, --CQ[10529]
                   S.M_PR, --[15352]
                   S.DA, S.DB, S.DC, S.DD, S.DE, S.DJ, S.DK, S.DL, S.DM, --CQ[10529]
                   S.INDEX_SPOSOBRASCH, S.IDINDEX, S.PUNKTIND,
                   S.ID_LEVEL_INDEX,
                   S.INDEX_INFO -- MK 3.08.2012 CQ[10695]
    --CQ[10529]from A_SMETA_CENLVL S
    from A_SMETA_INDLVL S--CQ[10529]
    where (S.ID = :ID_SM_REC) and
          (S.IDCENLVL = :ID_LEVEL)
    into :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
         :MJ, :MK, :ML, :MM, --CQ[10529]
         :M_PR, --[15352]
         :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM, --CQ[10529]
         :SPOSOB_RASCH, :IDINDEX, :PUNKTIND,
         :OLD_LEVEL_INDEX,
         :VN_INDEX_INFO; -- MK 3.08.2012 CQ[10695]


    -- MK 3.08.2012 CQ[10695] --->
    --  "   /"    
    if (NEED_APPLY_INDEX = 0) then
    begin
      RES_INDEX = VN_INDEX_INFO;
    end
    else
    begin
    -- MK 3.08.2012 CQ[10695] <---

      --      (LEVEL_COMPOSE)
      if (:ID_LEVEL_INDEX is not null) then
      begin
        --  ""         (  PUNKTIND)...
        if ((PUNKTIND is null) or (PUNKTIND = '')) then
          VN_IS_USED_INDEX = 0;
        else
          VN_IS_USED_INDEX = 1;
        /*CQ[10529]    .
        -- ...  ""
        if (NEED_APPLY_INDEX <> 0) then
        begin
          VN_IS_USED_INDEX = 0;
          ID_LEVEL_INDEX = -1; --[10502]
        end*/
  
        --     
        execute procedure NL_CHECK_INDEX(:ID_USER,
            :ID_LEVEL_INDEX, :ATYPE, :IN_PUNKTIND,
            :VN_IS_USED_INDEX, :OLD_LEVEL_INDEX)
            returning_values (:VN_RES);
  
        if (:VN_RES = 1) then
        --     
        begin
          --      
          select first 1 S.SLAVEPARENT
          from A_SMETA S
          where (S.ID = :ID_SM_REC)
          into :VN_MAIN_SM_REC;
  
          --     
          select first 1 S.MA, S.MB, S.MC, S.MD,
                         S.ME, S.MF, S.MG, S.MH,
                         S.MI, S.INDEX_SPOSOBRASCH,
                         S.IDINDEX, S.PUNKTIND,
                         S.MJ, S.MK, S.ML, S.MM, --CQ[10529]
                         S.M_PR, --[15352]
                         S.DA, S.DB, S.DC, S.DD, S.DE, S.DJ, S.DK, S.DL, S.DM --CQ[10529]
          --CQ[10529]from A_SMETA_CENLVL S
          from A_SMETA_INDLVL S--CQ[10529]
          where (S.ID = :VN_MAIN_SM_REC) and
                (S.IDCENLVL = :ID_LEVEL)
          into :MA, :MB, :MC, :MD, :ME, :MF, :MG,
               :MH, :MI, :SPOSOB_RASCH, :IDINDEX,
               :PUNKTIND,
               :MJ, :MK, :ML, :MM, --CQ[10529]
               :M_PR, --[15352]
               :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM; --CQ[10529]
        end
  
        else
        if (:VN_RES = 4) then
        --     
        begin
          /*CQ[10529]for select first 1 MA, MB, MC, MD, ME, MJ, MK, SPOSOBRASCH
            from LEVEL_INDEX_ITOG
            where ID_COMPOSE = :ID_LEVEL_INDEX
            into :I_MA, :I_MB, :I_MC, :I_MD, :I_ME, :I_MF, :I_MG, :I_SPOSOBRASCH
          do
          begin
            execute procedure A_S_APPLY_INDEX_FROM_ITOG(
                :I_MA, :I_MB, :I_MC, :I_MD, :I_ME, :I_MF, :I_MG, :I_SPOSOBRASCH,
                :TAB, :RABMAT, :TYPE_TRUD, :TIPRAB)
              returning_values
                :MA, :MB, :MC, :MD, :ME, :SPOSOB_RASCH;
            IDINDEX = null;
            MF = null; --    - . ...
            MG = null;
            MH = null;
            MI = null;
          end*/
          select first 1 MA, MB, MC, MD, ME, MJ, SPOSOBRASCH,
               MK, ML, MM, MN/*[15352]*/,
               DA, DB, DJ, DK, DL, DM
          from LEVEL_INDEX_ITOG
          where ID_COMPOSE = :ID_LEVEL_INDEX
          into :MA, :MB, :MC, :MD, :ME, :MJ, :SPOSOB_RASCH,
               :MK, :ML, :MM, :M_PR/*[15352]*/,
               :DA, :DB, :DJ, :DK, :DL, :DM;
  
          MF = null; --    - . ...
          MG = null;
          MH = null;
          MI = null;
        end
  
        else
        if (:VN_RES > 5) then
        --     (VN_RES    b_ind)
        begin
          PUNKTIND = IN_PUNKTIND;
  
          -- MK 20.05.2013 CQ[11261] --->
          --     +  ""
          select first 1 I.ID_MONTH,
                         I.SPOSOB_RASCH,
                         I.MK
          from LEVEL_INDEX I
          where (I.ID_COMPOSE = :ID_LEVEL_INDEX)
          into :IDINDEX, :SPOSOB_RASCH,
               :MK;

          --select first 1 I.ID_MONTH,
          --               I.SPOSOB_RASCH,
          --               I.MJ, I.MK, I.DA, I.DB, I.DJ, I.DK --CQ[10529]
          --from LEVEL_INDEX I
          --where (I.ID_COMPOSE = :ID_LEVEL_INDEX)
          --into :IDINDEX, :SPOSOB_RASCH,
          --     :MJ, :MK, :DA, :DB, :DJ, :DK; --CQ[10529]
          -- MK 20.05.2013 CQ[11261] <---


          --    
          select I.BA, I.BB, I.BC, I.BD, I.BE,
                 I.BB_PR, --[15352]
                 I.PA, I.PB,
                 I.ZBA, I.ZBB,
                 I.BE, I.BC--CQ[10529]
          from B_IND I
          where (I.ID = :VN_RES)
          into :MA, :MB, :MC, :MD, :ME,
               :M_PR, --[15352]
               :MF, :MG,
               :MH, :MI,
               :ML, :MM;--CQ[10529]

          -- MK 20.05.2013 CQ[11261] --->
          MJ = MB; --  () = 
          --  - 
          DA = null;
          DB = null;
          DC = null;
          DD = null;
          DE = null;
          DJ = null;
          DK = null;
          DL = null;
          DM = null;
          -- MK 20.05.2013 CQ[11261] <---
  
          --      MI ( .)
          -- (. A_S_GET_INDEX   12.01.2005)
          if (:ATYPE = 18) then
          begin
            --      
            select first 1 S.SLAVEPARENT
            from A_SMETA S
            where (S.ID = :ID_SM_REC)
            into :VN_MAIN_SM_REC;
  
            MI = null;
  
            select first 1 MI from A_SMETA_INDLVL --CQ[10529]A_SMETA_CENLVL
            where (ID = :VN_MAIN_SM_REC) and
                  (IDCENLVL = :ID_LEVEL)
            into :MI;
          end
  
        end
        if (:VN_RES = 5) then --CQ[10519]    LEVEL_INDEX
        begin
          select first 1 I.MA, I.MB, I.MJ, I.MK, I.DA, I.DB, I.DJ, I.DK, I.SPOSOB_RASCH
          from LEVEL_INDEX I
          where (I.ID_COMPOSE = :ID_LEVEL_INDEX)
          into :MA, :MB, :MJ, :MK, :DA, :DB, :DJ, :DK, :SPOSOB_RASCH;

          -- MK 20.05.2013     CQ[11261] --->
          IDINDEX = 0;
          MC = null;
          MD = null;
          ME = null;
          MF = null;
          MG = null;
          MH = null;
          MI = null;
          ML = null;
          MM = null;
          M_PR = null;
          DC = null;
          DD = null;
          DE = null;
          DL = null;
          DM = null;
          -- MK 20.05.2013 <---
        end

        RES_INDEX = VN_RES;
        if (RES_INDEX > 5) then
          RES_INDEX = 2;
      end


      -- MK 3.08.2012 CQ[10695] --->
      --     ,   
      --        
      -- "   /"
      if (RES_INDEX < 0) then
      begin
        --     (    )
        IDINDEX = 0;
        MA = null;
        MB = null;
        MC = null;
        MD = null;
        ME = null;
        MF = null;
        MG = null;
        MH = null;
        MI = null;
        MJ = null;
        MK = null;
        ML = null;
        MM = null;
        M_PR = null;
        DA = null;
        DB = null;
        DC = null;
        DD = null;
        DE = null;
        DJ = null;
        DK = null;
        DL = null;
        DM = null;
        PUNKTIND  = null;
      end
    end
    -- MK 3.08.2012 CQ[10695] <---


    -- MK 3.10.2014 CQ[12678] --->
    --      
    if (RES_INDEX = 2) then
    begin
      --    
      DA = MA;
      DB = MB;
      DC = MC;
      DD = MD;
      DE = ME;
      DJ = MJ;
      DK = MK;
      DL = ML;
      DM = MM;
    end

    --         
    if (RES_INDEX = 4) then
    begin
      --     
      DC = MC;
      DD = MD;
      DE = ME;
    end
    -- MK 3.10.2014 CQ[12678] <---


    --    -   
    if ((MA is null) or (MA = 0)) then
      MA = 1;
    if ((MB is null) or (MB = 0)) then
      MB = 1;
    if ((MC is null) or (MC = 0)) then
      MC = 1;
    if ((MD is null) or (MD = 0)) then
      MD = 1;
    if ((ME is null) or (ME = 0)) then
      ME = 1;
    if (MF is null) then
      MF = 0;
    if (MG is null) then
      MG = 0;
    if ((MH is null) or (MH = 0)) then
      MH = 1;
    if ((MI is null) or (MI = 0)) then
      MI = 1;
    --CQ[10529]-->
    if ((MJ is null) or (MJ = 0)) then
      MJ = 1;
    if ((MK is null) or (MK = 0)) then
      MK = 1;
    if ((ML is null) or (ML = 0)) then
      ML = 1;
    if ((MM is null) or (MM = 0)) then
      MM = 1;
    if ((M_PR is null) or (M_PR = 0)) then
      M_PR = 1;
    if ((DA is null) or (DA = 0)) then
      DA = 1;
    if ((DB is null) or (DB = 0)) then
      DB = 1;
    if ((DC is null) or (DC = 0)) then
      DC = 1;
    if ((DD is null) or (DD = 0)) then
      DD = 1;
    if ((DE is null) or (DE = 0)) then
      DE = 1;
    if ((DJ is null) or (DJ = 0)) then
      DJ = 1;
    if ((DK is null) or (DK = 0)) then
      DK = 1;
    if ((DL is null) or (DL = 0)) then
      DL = 1;
    if ((DM is null) or (DM = 0)) then
      DM = 1;
    --CQ[10529]<--
  end
  --suspend;
end
^

--[15195]
CREATE OR ALTER PROCEDURE A_SMETA_APPLY_CENLVL (
    IDUSER INTEGER,
    IDSMRECSRC INTEGER,
    IDSMRECDST INTEGER)
RETURNS (
    NEED_FORMUL_RECALL INTEGER)
AS
declare IDZONE integer;
declare IDINDEX integer;
declare ID_LEVEL_INDEX integer;
declare ID_LEVEL_VC integer;
declare BA double precision;
declare BB double precision;
declare BC double precision;
declare BD double precision;
declare BE double precision;
declare BF double precision;
declare BG double precision;
declare BH double precision;
declare BI double precision;
declare BJ double precision;
--TIMUR[13178]
declare BN double precision;
declare BO double precision;
declare B_ITOGO double precision;
--TIMUR[13178]
declare B_PR double precision; --[15352]
declare CA double precision;
declare CB double precision;
declare CC double precision;
declare CD double precision;
declare CE double precision;
declare CF double precision;
declare CG double precision;
declare CH double precision;
declare CI double precision;
declare CJ double precision;
--TIMUR[13178]
declare C_ITOGO double precision;
--TIMUR[13178]
declare C_PR double precision; --[15352]
declare EA double precision;
declare EB double precision;
declare EC double precision;
declare ED double precision;
declare EE double precision;
declare EF double precision;
declare EG double precision;
declare EH double precision;
declare EI double precision;
declare EJ double precision;
declare EK double precision;
--TIMUR[13178]
declare EN double precision;
declare EO double precision;
declare E_ITOGO double precision;
--TIMUR[13178]
declare E_PR double precision; --[15352]
declare RA double precision;
declare RB double precision;
declare RC double precision;
declare RD double precision;
declare RE double precision;
declare RF double precision;
declare RG double precision;
declare RH double precision;
declare RI double precision;
declare RJ double precision;
declare RK double precision;
declare RL double precision;
declare RM double precision;
declare PA double precision;
declare PB double precision;
declare PC double precision;
declare PD double precision;
declare ITOGO double precision;
declare R_PR double precision; --[15352]
declare RC_16 double precision; --[15352]
declare RE_16 double precision; --[15352]
declare PUNKTIND varchar(42);
declare MA double precision;
declare MB double precision;
declare MC double precision;
declare MD double precision;
declare ME double precision;
declare MF double precision;
declare MG double precision;
declare MH double precision;
declare MI double precision;
declare INDEX_SPOSOBRASCH integer;
declare CALCBMASK integer;
declare BASE_INFO integer;
declare INDEX_INFO integer;
declare IDCLASS integer;
declare IDLEVEL integer;
declare IDHIER integer;
declare SMETATYPE integer;
declare ATYPE integer;
declare IDTR integer;
declare VRPZ integer;
declare RES_COPY_FORMULS integer;

declare IDRESSRC integer;
declare IDRESDST integer;

--CQ[10670]declare variable IDCLASSSRC integer;
declare variable IDHIERSRC integer;
--CQ[10670]declare variable SMETATYPESRC integer;

declare variable SLAVEPARENT integer;

declare variable MJ double precision;
declare variable MK  double precision;
declare variable ML double precision;
declare variable MM double precision;
declare M_PR double precision; --[15352]
declare variable DA double precision;
declare variable DB double precision;
declare variable DC double precision;
declare variable DD double precision;
declare variable DE double precision;
declare variable DJ double precision;
declare variable DK  double precision;
declare variable DL double precision;
declare variable DM double precision;

declare variable VN_CURR_CENA double precision;
declare variable VN_BASE_CALC_INFO integer;
declare variable VN_SOURCE_LEVEL_ID integer;

--CQ[10769]>>
declare variable IDNORMATIV_SRC integer;
declare variable IDCLASS_SRC integer;
declare variable SMETATYPE_SRC integer;
declare variable IDLEVEL_SRC integer;
declare variable IN_OTHER_OBJ integer;
declare variable RECORDS_MODIFIED integer;

declare variable COMPARE_RES integer;

declare P_ISCLC integer;
declare P_MODE_KOMPNS_ST integer;
declare CLCMODE integer;
declare SM_CLCMODE integer;
declare ID_S_RES integer;
declare SLAVECOMPOSEFROMMAINNEEDED integer;

-- MK CQ[11989]
declare variable VN_CURR_CENA_INFO integer;
declare variable VN_ID_VALUTE integer;
declare variable VN_VALUTE_CURS double precision;
declare variable VN_VALUTE_DATE date;
declare variable VN_TRANSP double precision;
declare variable VN_ZAG_SKL double precision;
declare variable VN_ZAPCHAST double precision;
declare variable VN_TARA double precision;
declare variable VN_NACEN double precision;
declare variable VN_COMPLECT double precision;
declare variable VN_KOEFF_TYPE integer;
begin
--[15352]

  NEED_FORMUL_RECALL = 0;
  IN_OTHER_OBJ = 0;


  --  -
  select coalesce(IDHIER, 0), SMETATYPE, ATYPE, SLAVEPARENT, VRPZ, CLCMODE, ID_S_RES
  from A_SMETA
  where ID = :IDSMRECDST
  into :IDHIER, :SMETATYPE, :ATYPE, :SLAVEPARENT, :VRPZ, :CLCMODE, :ID_S_RES;

  if (:ATYPE = 18/*ResRec*/) then
    select CLCMODE
      from A_SMETA
      where ID = :SLAVEPARENT
      into :SM_CLCMODE;
  else
    SM_CLCMODE = CLCMODE;

  if (:ATYPE in (17, 18 )) then
  begin
    if (:SMETATYPE > 999) then
    begin
      IDCLASS = :SMETATYPE;
      select ID_TR, RES_COPY_FORMULS, ISCLC, MODE_KOMPNS_ST
      from A_O_FACTPARAMS
      where NUMBER = :IDCLASS
      into :IDTR, :RES_COPY_FORMULS, :P_ISCLC, :P_MODE_KOMPNS_ST;
    end
    else
    begin
      execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1 )
      returning_values :IDCLASS;
      select ID_TR, RES_COPY_FORMULS, ISCLC, MODE_KOMPNS_ST
      from A_O_OBJECTPARAMS
      where NUMBER = :IDCLASS
      into :IDTR, :RES_COPY_FORMULS, :P_ISCLC, :P_MODE_KOMPNS_ST;
    end
  end
  else
    exit;

  --  ,    
  if (:IDSMRECSRC is null) then
  begin
    NEED_FORMUL_RECALL = 1;
    --     -
    for select L.ID
        from LEVEL_COST L
        where L.IDOBJECT = :IDCLASS
        into :IDLEVEL
    do
      execute procedure DM_ADD_LEVEL_IN_SMETA_ONE(:IDUSER, :IDSMRECDST, :IDLEVEL);
    suspend;
    exit;--
  end
  else
  begin
    SMETATYPE_SRC = 0;
    IDNORMATIV_SRC = 0;
    --  -
    select coalesce(IDHIER, 0),
           SMETATYPE, IDNORMATIV
    from A_SMETA
    where ID = :IDSMRECSRC
    into :IDHIERSRC,
         :SMETATYPE_SRC, :IDNORMATIV_SRC;

    IDCLASS_SRC = 0;
    if (SMETATYPE_SRC > 999) then
      IDCLASS_SRC = :SMETATYPE_SRC;
    else
      execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIERSRC, 1)
      returning_values :IDCLASS_SRC;

    --   
    if (:IDCLASS_SRC <> :IDCLASS) then
    begin
      --    ". ..  ,       (csDirect),  
      if ((IDNORMATIV_SRC <> 0) and
          not exists(select * from a_smeta_cenlvl where ID = :IDSMRECSRC and BASE_INFO = 2)) then
      begin
        NEED_FORMUL_RECALL = 1;
        --     -
        for select L.ID
            from LEVEL_COST L
            where L.IDOBJECT = :IDCLASS
            into :IDLEVEL
        do
          execute procedure DM_ADD_LEVEL_IN_SMETA_ONE(:IDUSER, :IDSMRECDST, :IDLEVEL);
        suspend;
        exit;--
      end
      else
        IN_OTHER_OBJ = 1;
    end
    --       ""
    --     -
    for select L.ID
        from LEVEL_COST L
        where L.IDOBJECT = :IDCLASS
        into :IDLEVEL
    do
    begin
      IDLEVEL_SRC = :IDLEVEL;
      -- "" 
      if (:IN_OTHER_OBJ = 1) then
      begin
        NEED_FORMUL_RECALL = 1;
        --     
        execute procedure NL_GET_SAME_LEVEL(:IDLEVEL, :IDCLASS, :IDSMRECSRC, :IDCLASS_SRC) returning_values (:IDLEVEL_SRC);
      end
      --
      for select C.IDZONE, I.IDINDEX, I.ID_LEVEL_INDEX, C.ID_LEVEL_VC,
               C.BA, C.BB, C.BC, C.BD, C.BE, C.BF, C.BG, C.BH, C.BI, C.BJ, C.BN, C.BO, C.B_ITOGO,
               C.B_PR, --[15352]
               C.CA, C.CB, C.CC, C.CD, C.CE, C.CF, C.CG, C.CH, C.CI, C.CJ, C.C_ITOGO,
               C.C_PR, --[15352]
               C.EA, C.EB, C.EC, C.ED, C.EE, C.EF, C.EG, C.EH, C.EI, C.EJ, C.EK, C.EN, C.EO, C.E_ITOGO,
               C.E_PR, --[15352]
               C.RA, C.RB, C.RC, C.RD, C.RE, C.RF, C.RG, C.RH, C.RI, C.RJ, C.RK, C.RL, C.RM, C.ITOGO,
               C.R_PR, C.RC_16, C.RE_16, --[15352]
               I.PUNKTIND, I.MA, I.MB, I.MC, I.MD, I.ME, I.MF, I.MG, I.MH, I.MI, I.INDEX_SPOSOBRASCH,
               C.CALCBMASK, C.BASE_INFO, I.INDEX_INFO,
               I.MJ, I.MK, I.ML, I.MM,
               I.M_PR,  --[15352]
               I.DA, I.DB, I.DC, I.DD, I.DE, I.DJ, I.DK, I.DL, I.DM, --CQ[10529]
               C.CURR_CENA, C.BASE_CALC_INFO, C.SOURCE_LEVEL_ID, -- MK 20.06.2012 CQ[10565]
               c.curr_cena_info, c.id_valute, c.valute_curs,     -- MK CQ[11989]
               c.valute_date, c.transp, c.zag_skl,               -- MK CQ[11989]
               c.zapchast, c.tara, c.nacen, c.complect,          -- MK CQ[11989]
               c.koeff_type,                                     -- MK     8.9
               C.PA, C.PB, C.PC, C.PD
        from A_SMETA_CENLVL C
        join A_SMETA_INDLVL I on I.ID = C.ID and I.IDCENLVL = C.IDCENLVL --CQ[10529]
        where ID = :IDSMRECSRC and
              IDCENLVL = :IDLEVEL_SRC
        into :IDZONE, :IDINDEX, :ID_LEVEL_INDEX, :ID_LEVEL_VC,
             :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
             :B_PR, --[15352]
             :CA, :CB, :CC, :CD, :CE, :CF, :CG, :CH, :CI, :CJ, :C_ITOGO,
             :C_PR, --[15352]
             :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK, :EN, :EO, :E_ITOGO,
             :E_PR, --[15352]
             :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :ITOGO,
             :R_PR, :RC_16, :RE_16, --[15352]
             :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :INDEX_SPOSOBRASCH,
             :CALCBMASK, :BASE_INFO, :INDEX_INFO,
             :MJ, :MK, :ML, :MM,
             :M_PR, --[15352]
             :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM, --CQ[10529]
             :VN_CURR_CENA, :VN_BASE_CALC_INFO, :VN_SOURCE_LEVEL_ID, -- MK 20.06.2012 CQ[10565]
             :VN_CURR_CENA_INFO, :VN_ID_VALUTE, :VN_VALUTE_CURS,     -- MK CQ[11989]
             :VN_VALUTE_DATE, :VN_TRANSP, :VN_ZAG_SKL,               -- MK CQ[11989]
             :VN_ZAPCHAST, :VN_TARA, :VN_NACEN, :VN_COMPLECT,        -- MK CQ[11989]
             :VN_KOEFF_TYPE,                                         -- MK     8.9
             :PA, :PB, :PC, :PD
      do
      begin
        --CQ[10769]-->
        if (:IN_OTHER_OBJ = 1) then
        begin
          --   ,      
          CA = 0.0;
          CB = 0.0;
          CC = 0.0;
          CD = 0.0;
          CE = 0.0;
          CF = 0.0;
          CG = 0.0;
          CH = 0.0;
          CI = 0.0;
          CJ = 0.0;
          C_ITOGO = 0.0;
          C_PR = null; --[15352]
          EA = 0.0;
          EB = 0.0;
          EC = 0.0;
          ED = 0.0;
          EE = 0.0;
          EF = 0.0;
          EG = 0.0;
          EH = 0.0;
          EI = 0.0;
          EJ = 0.0;
          EK = 0.0;
          EN = 0.0;
          EO = 0.0;
          E_ITOGO = 0.0;
          E_PR = null; --[15352]
          RA = 0.0;
          RB = 0.0;
          RC = 0.0;
          RD = 0.0;
          RE = 0.0;
          RF = 0.0;
          RG = 0.0;
          RH = 0.0;
          RI = 0.0;
          RJ = 0.0;
          RK = 0.0;
          RL = 0.0;
          RM = 0.0;
          ITOGO = 0.0;
          R_PR = null; --[15352]
          RC_16 = null; --[15352]
          RE_16 = null; --[15352]
          BASE_INFO = null;
          VN_SOURCE_LEVEL_ID = null;

          --    -        //CQ[10876]      
          --//CQ[10876]    , ..
          --        ,    -   
          --execute procedure A_S_GET_FORMUL_NRSPZU_NL_1(:IDUSER, :ATYPE, :SLAVEPARENT, :IDTR, :VRPZ,
          --  :RES_COPY_FORMULS, :IDLEVEL)
          --returning_values (:PA, :PB, :PC, :PD); */

        end
        --CQ[10769]<--
  
        update A_SMETA_CENLVL set
          IDZONE = :IDZONE,
          ID_LEVEL_VC = :ID_LEVEL_VC,
          BA = :BA,
          BB = :BB,
          BC = :BC,
          BD = :BD,
          BE = :BE,
          BF = :BF,
          BG = :BG,
          BH = :BH,
          BI = :BI,
          BJ = :BJ,
          BN = :BN,
          BO = :BO,
          B_ITOGO = :B_ITOGO,
          B_PR = :B_PR, --[15352]
          CA = :CA,
          CB = :CB,
          CC = :CC,
          CD = :CD,
          CE = :CE,
          CF = :CF,
          CG = :CG,
          CH = :CH,
          CI = :CI,
          CJ = :CJ,
          C_ITOGO = :C_ITOGO,
          C_PR = :C_PR, --[15352]
          EA = :EA,
          EB = :EB,
          EC = :EC,
          ED = :ED,
          EE = :EE,
          EF = :EF,
          EG = :EG,
          EH = :EH,
          EI = :EI,
          EJ = :EJ,
          EK = :EK,
          EN = :EN,
          EO = :EO,
          E_ITOGO = :E_ITOGO,
          E_PR = :E_PR, --[15352]
          RA = :RA,
          RB = :RB,
          RC = :RC,
          RD = :RD,
          RE = :RE,
          RF = :RF,
          RG = :RG,
          RH = :RH,
          RI = :RI,
          RJ = :RJ,
          RK = :RK,
          RL = :RL,
          RM = :RM,
          ITOGO = :ITOGO,
          R_PR = :R_PR, --[15352]
          RC_16 = :RC_16, --[15352]
          RE_16 = :RE_16, --[15352]
          PA = :PA,
          PB = :PB,
          PC = :PC,
          PD = :PD,
          CALCBMASK = :CALCBMASK,
          BASE_INFO = :BASE_INFO,
  
          -- MK 20.06.2012 CQ[10565] --->
          CURR_CENA = :VN_CURR_CENA,
          BASE_CALC_INFO = :VN_BASE_CALC_INFO,
          -- MK    (  ):  update  
          --  = ,   SOURCE_LEVEL_ID  
          SOURCE_LEVEL_ID = :VN_SOURCE_LEVEL_ID,
          -- MK 20.06.2012 CQ[10565] <---

          -- MK CQ[11989] --->
          CURR_CENA_INFO = :VN_CURR_CENA_INFO,
          ID_VALUTE = :VN_ID_VALUTE,
          VALUTE_CURS = :VN_VALUTE_CURS,
          VALUTE_DATE = :VN_VALUTE_DATE,
          TRANSP = :VN_TRANSP,
          ZAG_SKL = :VN_ZAG_SKL,
          ZAPCHAST = :VN_ZAPCHAST,
          TARA = :VN_TARA,
          NACEN = :VN_NACEN,
          COMPLECT = :VN_COMPLECT,
          KOEFF_TYPE = :VN_KOEFF_TYPE -- MK     8.9
          -- MK CQ[11989] <---

        where (ID = :IDSMRECDST) and
              (IDCENLVL = :IDLEVEL);
  
        update A_SMETA_INDLVL set
          IDINDEX = :IDINDEX,
          ID_LEVEL_INDEX = :ID_LEVEL_INDEX,
          PUNKTIND = :PUNKTIND,
          MA = :MA,
          MB = :MB,
          MC = :MC,
          MD = :MD,
          ME = :ME,
          MF = :MF,
          MG = :MG,
          MH = :MH,
          MI = :MI,
          MJ = :MJ,
          MK = :MK,
          ML = :ML,
          MM = :MM,
          M_PR = :M_PR, --[15352]
          DA = :DA,
          DB = :DB,
          DC = :DC,
          DD = :DD,
          DE = :DE,
          DJ = :DJ,
          DK = :DK,
          DL = :DL,
          DM = :DM,
          INDEX_SPOSOBRASCH = :INDEX_SPOSOBRASCH,
          INDEX_INFO = :INDEX_INFO
        where (ID = :IDSMRECDST) and
              (IDCENLVL = :IDLEVEL);
  
        execute procedure A_SMETA_INDLVL_DESC_CLONE (:IDSMRECSRC, :IDSMRECDST, :IDLEVEL, :IDLEVEL);
  
        if (:IDHIER <> :IDHIERSRC) then
        begin
          --         
          if (:IN_OTHER_OBJ = 1) then
          begin
            --:  execute procedure NL_RECALL_EMPTYNORMO_INDEX(:IDUSER, :IDSMRECDST, :IDLEVEL) returning_values (:RECORDS_MODIFIED);
          end
          else
          begin
            execute procedure NL_COMPARE_COMPOSE(:IDUSER, :IDSMRECSRC, :IDLEVEL_SRC, :IDSMRECDST, :IDLEVEL, 0)
            returning_values (:COMPARE_RES);
            if (COMPARE_RES = 0) then
            begin
              execute procedure NL_FIND_COMPOSE_UCH_FROM_MAIN(
                  :P_ISCLC, :P_MODE_KOMPNS_ST, :SM_CLCMODE, :ID_S_RES)
                returning_values :SLAVECOMPOSEFROMMAINNEEDED;

              execute procedure A_S_PARAMS_TO_SMETA_NL_ONE(
                  :IDUSER, :IDSMRECDST, :IDLEVEL, :SLAVECOMPOSEFROMMAINNEEDED)
                returning_values (:RECORDS_MODIFIED);
            end
          end
        end

        --   -  ,   
        IDRESDST = 0;
        --   
        --   A_S_PASTE_SMETA_RECORD      ID
        for select R.ID
            from M_ETALON_S_RES R
            where R.ID_SOURCE = :IDSMRECSRC
            order by R.ID_SOURCE, R.ID
            into :IDRESSRC
        do
        begin
          for select first 1 R.ID
              from M_ETALON_S_RES R
              where R.ID_SOURCE = :IDSMRECDST and
                    R.ID > :IDRESDST
              order by R.ID_SOURCE, R.ID
              into :IDRESDST
          do
          begin
            for select IDZONE, ID_LEVEL_VC, BB, BC, BD, BE, BASE_INFO
                from A_S_ETALON_RES_CENLVL L
                where L.ID = :IDRESSRC and
                      L.IDCENLVL = :IDLEVEL_SRC
                into :IDZONE, :ID_LEVEL_VC, :BB, :BC, :BD, :BE, :BASE_INFO
            do
            begin
              update A_S_ETALON_RES_CENLVL set
                IDZONE = :IDZONE,
                ID_LEVEL_VC = :ID_LEVEL_VC,
                BB = :BB,
                BC = :BC,
                BD = :BD,
                BE = :BE,
                BASE_INFO = :BASE_INFO
              where (ID = :IDRESDST) and
                    (IDCENLVL = :IDLEVEL);

              --         
              if ((:IDHIER <> :IDHIERSRC) and (:IN_OTHER_OBJ = 0)) then
              begin
                execute procedure NL_COMPARE_COMPOSE(:IDUSER, :IDRESSRC, :IDLEVEL_SRC, :IDRESDST, :IDLEVEL, 0)
                returning_values (:COMPARE_RES);
                if (COMPARE_RES = 0) then
                  execute procedure A_S_PARAMS_TO_ET_RES_NL_ONE(:IDUSER, :IDRESDST, :IDLEVEL) returning_values (:RECORDS_MODIFIED);
              end

            end
          end
        end
        IDRESDST = 0;
        --   
        --   A_S_PASTE_SMETA_RECORD      ID
        for select R.ID
            from A_S_RES R
            where R.ID_SOURCE = :IDSMRECSRC and
                  not exists(select *
                             from A_SMETA S
                             where S.ID_S_RES = R.ID)
            order by R.ID_SOURCE, R.ID
            into :IDRESSRC
        do
          for select first 1 R.ID
              from A_S_RES R
              where R.ID_SOURCE = :IDSMRECDST and
                    not exists(select *
                               from A_SMETA S
                               where S.ID_S_RES = R.ID) and
                    R.ID > :IDRESDST
              order by R.ID_SOURCE, R.ID
              into :IDRESDST
          do
            for select IDZONE, ID_LEVEL_VC, BB, BC, BD, BE, BASE_INFO
                from A_S_RES_CENLVL L
                where L.ID = :IDRESSRC and
                      L.IDCENLVL = :IDLEVEL_SRC
                into :IDZONE, :ID_LEVEL_VC, :BB, :BC, :BD, :BE, :BASE_INFO
            do
            begin
  
              update A_S_RES_CENLVL set
                IDZONE = :IDZONE,
                ID_LEVEL_VC = :ID_LEVEL_VC,
                BB = :BB,
                BC = :BC,
                BD = :BD,
                BE = :BE,
                BASE_INFO = :BASE_INFO
              where (ID = :IDRESDST) and
                    (IDCENLVL = :IDLEVEL);
              --         
              if ((:IDHIER <> :IDHIERSRC) and (:IN_OTHER_OBJ = 0)) then
              begin
                execute procedure NL_COMPARE_COMPOSE(:IDUSER, :IDRESSRC, :IDLEVEL_SRC, :IDRESDST, :IDLEVEL, 1)
                returning_values (:COMPARE_RES);
                if (COMPARE_RES = 0) then
                  execute procedure A_S_PARAMS_TO_RES_NL_ONE(:IDUSER, :IDRESDST, :IDLEVEL) returning_values (:RECORDS_MODIFIED);
              end
            end
      end
    end
  end
  suspend;
end
^

--[15195]
CREATE OR ALTER PROCEDURE A_SMETA_CENLVL_UPDATE (
    ID_USER INTEGER,
    ID INTEGER,
    IDCENLVL INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    CA DOUBLE PRECISION,
    CB DOUBLE PRECISION,
    CC DOUBLE PRECISION,
    CD DOUBLE PRECISION,
    CE DOUBLE PRECISION,
    CF DOUBLE PRECISION,
    CG DOUBLE PRECISION,
    CH DOUBLE PRECISION,
    CI DOUBLE PRECISION,
    CJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    CALCBMASK INTEGER,
    BASE_INFO INTEGER,
    CURR_CENA DOUBLE PRECISION,
    BASE_CALC_INFO INTEGER,
    SOURCE_LEVEL_ID INTEGER,
    BASECOSTCHANGED INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    EN DOUBLE PRECISION,
    EO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    C_ITOGO DOUBLE PRECISION,
    E_ITOGO DOUBLE PRECISION,
    B_PR DOUBLE PRECISION,
    C_PR DOUBLE PRECISION,
    E_PR DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION,
    CURR_CENA_INFO INTEGER,
    ID_VALUTE INTEGER,
    VALUTE_CURS DOUBLE PRECISION,
    VALUTE_DATE DATE,
    TRANSP DOUBLE PRECISION,
    ZAG_SKL DOUBLE PRECISION,
    ZAPCHAST DOUBLE PRECISION,
    TARA DOUBLE PRECISION,
    NACEN DOUBLE PRECISION,
    COMPLECT DOUBLE PRECISION,
    KOEFF_TYPE INTEGER)
RETURNS (
    R_COUNT INTEGER)
AS
declare ID_LEVEL_VC INTEGER;
declare IDZONE INTEGER;
DECLARE VARIABLE SAVE_CEN_TO_NB INTEGER;
DECLARE VARIABLE APPLY_ON_RES INTEGER;
declare IS_USE integer;
declare IDNORMATIV integer;
declare RABMAT integer;
declare PODGROUP integer;
declare SAVE_RESULT integer;
declare STATUS_REC_CEN integer;
begin
  update A_SMETA_CENLVL
  set
  BA = :BA, BB = :BB, BC = :BC, BD = :BD, BE = :BE, BF = :BF,
  BG = :BG, BH = :BH, BI = :BI, BJ = :BJ,
  CA = :CA, CB = :CB, CC = :CC, CD = :CD, CE = :CE, CF = :CF,
  CG = :CG, CH = :CH, CI = :CI, CJ = :CJ,
  EA = :EA, EB = :EB, EC = :EC, ED = :ED, EE = :EE, EF = :EF,
  EG = :EG, EH = :EH, EI = :EI, EJ = :EJ, EK = :EK,
  RA = :RA, RB = :RB, RC = :RC, RD = :RD, RE = :RE, RF = :RF,
  RG = :RG, RH = :RH, RI = :RI, RJ = :RJ, RK = :RK, RL = :RL, RM = :RM,
  PA = :PA, PB = :PB, PC = :PC, PD = :PD, ITOGO = :ITOGO, CalcBMask = :CalcBMask,
  /*ID_LEVEL_VC = :ID_LEVEL_VC,*/ BASE_INFO = :BASE_INFO,
  CURR_CENA = :CURR_CENA, BASE_CALC_INFO = :BASE_CALC_INFO, SOURCE_LEVEL_ID = :SOURCE_LEVEL_ID,

  -- MK CQ[13174] --->
  BN = :BN, BO = :BO, EN = :EN, EO = :EO,
  B_ITOGO = :B_ITOGO, C_ITOGO = :C_ITOGO, E_ITOGO = :E_ITOGO,
  -- MK CQ[13174] <---

  B_PR = :B_PR, C_PR = :C_PR, E_PR = :E_PR, R_PR = :R_PR, RC_16 = :RC_16, RE_16 = :RE_16, --[15352]

  -- MK CQ[11989] --->
  CURR_CENA_INFO = :CURR_CENA_INFO,
  ID_VALUTE = :ID_VALUTE,
  VALUTE_CURS = :VALUTE_CURS,
  VALUTE_DATE = :VALUTE_DATE,
  TRANSP = :TRANSP,
  ZAG_SKL = :ZAG_SKL,
  ZAPCHAST = :ZAPCHAST,
  TARA = :TARA,
  NACEN = :NACEN,
  COMPLECT = :COMPLECT,
  -- MK CQ[11989] <---

  KOEFF_TYPE = :KOEFF_TYPE -- MK CQ[13018]

  where (ID = :ID) and (IDCENLVL = :IDCENLVL);

  R_COUNT = row_count;

  if (:BASECOSTCHANGED <> 0) then
  -- MK 19.08.2013 CQ[11313] --->
  --      
  for select ID_COMPOSE_VC
  from NL_FIND_COMPOSE_FOR_SAVE_VC (:ID, :IDCENLVL, :ID_USER)
  into :ID_LEVEL_VC

  --    
  --for select ID_LEVEL_VC, IDZONE
  --  from A_SMETA_CENLVL
  --  where (ID = :ID) and (IDCENLVL = :IDCENLVL)
  --  into :ID_LEVEL_VC, :IDZONE
  -- MK 19.08.2013 CQ[11313] <---
  do
  begin
    --  
    for select ID_ZONE, SAVE_CEN_TO_NB, APPLY_ON_RES
      from LEVEL_VC
      where ID_COMPOSE = :ID_LEVEL_VC
      into :IDZONE, :SAVE_CEN_TO_NB, :APPLY_ON_RES
    do
    if (:IDZONE > 0 and :SAVE_CEN_TO_NB <> 0) then
    begin
      --  
      execute procedure M_CHECK_ZONE_USE(:ID_USER, :IDZONE)
          returning_values :IS_USE;

      if (:IS_USE >= 2) then
      --  
      begin
        select IDNORMATIV, RABMAT, KODIR_PODGROUP
          from A_SMETA
          where ID = :ID
          into :IDNORMATIV, :RABMAT, :PODGROUP;

        if (:RABMAT <> 0 or coalesce(:APPLY_ON_RES, 0) = 0) then
        execute procedure L_S_SAVE_CCURRENT_TO_NORMY(
            :ID_USER, :IDZONE, :IDNORMATIV, :RABMAT, :PODGROUP,
            :BA, :BB, :BC, :BD, :BE,
            null/*:ID*/, null/*:SOURCE_TYPE*/ )
          returning_values :SAVE_RESULT, :STATUS_REC_CEN;
      end
    end
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE A_SMETA_INDLVL_DESC_CLONE (
    ID_SRC INTEGER,
    ID_DEST INTEGER,
    ID_LEVEL_SRC INTEGER,
    ID_LEVEL_DEST INTEGER)
AS
declare variable NMA varchar(255);
declare variable NMB varchar(255);
declare variable NMC varchar(255);
declare variable NMD varchar(255);
declare variable NME varchar(255);
declare variable NMF varchar(255);
declare variable NMG varchar(255);
declare variable NMH varchar(255);
declare variable NMI varchar(255);
declare variable NMJ varchar(255);
declare variable NMK varchar(255);
declare variable NML varchar(255);
declare variable NMM varchar(255);
declare variable NMN varchar(255);
declare variable NDA varchar(255);
declare variable NDB varchar(255);
declare variable NDC varchar(255);
declare variable NDD varchar(255);
declare variable NDE varchar(255);
declare variable NDJ varchar(255);
declare variable NDK varchar(255);
declare variable NDL varchar(255);
declare variable NDM varchar(255);

begin
--[15352]
--[15354]+ NMN
  for select NMA, NMB, NMC, NMD, NME, NMF, NMG, NMH, NMI, NMJ, NMK, NML, NMM, NM_PR /*15354*/,
             NDA, NDB, NDC, NDD, NDE, NDJ, NDK, NDL, NDM
    from A_SMETA_INDLVL_DESCR
    where ID = :ID_SRC and
          IDCENLVL = :ID_LEVEL_SRC
    into :NMA, :NMB, :NMC, :NMD, :NME, :NMF, :NMG, :NMH, :NMI, :NMJ, :NMK, :NML, :NMM, :NMN/*15354*/,
         :NDA, :NDB, :NDC, :NDD, :NDE, :NDJ, :NDK, :NDL, :NDM
  do
  begin
    execute procedure A_SMETA_INDLVL_DESCR_IU(:ID_DEST, :ID_LEVEL_DEST, :NMA, :NMB, :NMC, :NMD,
      :NME, :NMF, :NMG, :NMH, :NMI, :NMJ, :NMK, :NML, :NMM, :NMN/*15354*/, :NDA, :NDB, :NDC, :NDD, :NDE, :NDJ,
      :NDK, :NDL, :NDM);
  end

end
^

--[15195]
CREATE OR ALTER PROCEDURE A_SMETA_INDLVL_DESCR_IU (
    ID INTEGER,
    IDCENLVL INTEGER,
    NMA VARCHAR(255),
    NMB VARCHAR(255),
    NMC VARCHAR(255),
    NMD VARCHAR(255),
    NME VARCHAR(255),
    NMF VARCHAR(255),
    NMG VARCHAR(255),
    NMH VARCHAR(255),
    NMI VARCHAR(255),
    NMJ VARCHAR(255),
    NMK VARCHAR(255),
    NML VARCHAR(255),
    NMM VARCHAR(255),
    NMN VARCHAR(255),
    NDA VARCHAR(255),
    NDB VARCHAR(255),
    NDC VARCHAR(255),
    NDD VARCHAR(255),
    NDE VARCHAR(255),
    NDJ VARCHAR(255),
    NDK VARCHAR(255),
    NDL VARCHAR(255),
    NDM VARCHAR(255))
AS
begin
--[15352]+
--[15354]+ NMN
  if (exists(select id from a_smeta_indlvl_descr where (id = :id) and (idcenlvl = :idcenlvl))) then
    update a_smeta_indlvl_descr
    set nma = :nma,
        nmb = :nmb,
        nmc = :nmc,
        nmd = :nmd,
        nme = :nme,
        nmf = :nmf,
        nmg = :nmg,
        nmh = :nmh,
        nmi = :nmi,
        nmj = :nmj,
        nmk = :nmk,
        nml = :nml,
        nmm = :nmm,
        nm_pr = :nmn, /*15354*/
        nda = :nda,
        ndb = :ndb,
        ndc = :ndc,
        ndd = :ndd,
        nde = :nde,
        ndj = :ndj,
        ndk = :ndk,
        ndl = :ndl,
        ndm = :ndm
    where (id = :id) and (idcenlvl = :idcenlvl);
  else
    insert into a_smeta_indlvl_descr (
        id,
        idcenlvl,
        nma,
        nmb,
        nmc,
        nmd,
        nme,
        nmf,
        nmg,
        nmh,
        nmi,
        nmj,
        nmk,
        nml,
        nmm,
        nm_pr, /*15354*/
        nda,
        ndb,
        ndc,
        ndd,
        nde,
        ndj,
        ndk,
        ndl,
        ndm)
    values (
        :id,
        :idcenlvl,
        :nma,
        :nmb,
        :nmc,
        :nmd,
        :nme,
        :nmf,
        :nmg,
        :nmh,
        :nmi,
        :nmj,
        :nmk,
        :nml,
        :nmm,
        :nmn, /*15354*/
        :nda,
        :ndb,
        :ndc,
        :ndd,
        :nde,
        :ndj,
        :ndk,
        :ndl,
        :ndm);
end
^

--[15195]
/* 
CREATE OR ALTER PROCEDURE A_SMETA_NL_IMP (
*/
--[15195]
/* 
CREATE OR ALTER PROCEDURE B_ADD_IND_RECORD (
*/
--[15195]
CREATE OR ALTER PROCEDURE B_ADD_IND_RECORD_INNER (
    IDUSER INTEGER,
    IDREESTR INTEGER,
    IDOGL INTEGER,
    ORDERVIEW INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    NAME_PART BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NEEDUPDATE_NAME_PART INTEGER,
    NEEDUPDATE_NAME_TITLE INTEGER,
    NEEDCHECKPARAMS INTEGER,
    BB_PR DOUBLE PRECISION)
RETURNS (
    ID INTEGER)
AS
declare variable tabu varchar(42);
declare variable idpapka integer;
declare variable id_name integer;
declare variable isreordered integer;
BEGIN
--[15352]+
--[15354]+ BB_PR
 IF ((TAB IS NOT NULL) AND (TAB <> '')) THEN BEGIN
    TAB = LCKTRIMVARCHAR(TAB);
    TABU = S_TRANSLITERATE(TAB);

    -- TODO CQ[5989] 
    IF (EXISTS (SELECT * FROM B_IND
                WHERE ((TABU  = :TABU) AND
                       (IDREESTR = :IDREESTR) AND
                       (ID <> :ID))))
    THEN BEGIN
       IF (NEEDCHECKPARAMS = 1)
       THEN EXCEPTION B_E_TAB_EXISTS;
       ELSE EXIT ;
    END
 END

 SELECT IDPARENT
 FROM B_REESTR
 WHERE ID = :IDREESTR
 INTO :IDPAPKA ;

 IF ((NEEDCHECKPARAMS = 1) AND (IDPAPKA IS NULL))
 THEN EXCEPTION B_E_NODE_NOTFOUND ;

 IF (IDOGL <= 0)
 THEN IDOGL = NULL ;
 IF (IDOGL IS NOT NULL)
 THEN
    IF (NOT EXISTS (SELECT * FROM B_OGL WHERE ID = :IDOGL))
    THEN IDOGL = NULL ;


 ID = GEN_ID(A_G_SMETA,1) ;

 IF (NEEDCHECKPARAMS = 1)
 THEN BEGIN
    if (:ORDERVIEW is null or :ORDERVIEW = 0) then
    begin
      select max(ORDERVIEW)
        from B_IND
        where IDREESTR = :IDREESTR
        into :ORDERVIEW ;

      -- MK 18.07.2012 CQ[10583] --->
      --    (. )
      --if (:ORDERVIEW is null) then
      --  ORDERVIEW = 1;
      --else
      --  ORDERVIEW = ORDERVIEW + 1;
      -- MK 18.07.2012 CQ[10583] <---
    end

    -- MK 18.07.2012 CQ[10583] --->
    --    (. )
    if (:ORDERVIEW is null) then
      ORDERVIEW = 1;
    else
      ORDERVIEW = ORDERVIEW + 1;
    -- MK 18.07.2012 CQ[10583] <---


    EXECUTE PROCEDURE B_WRITE_NEWORDER_IND(:IDUSER, :ID, :IDREESTR, :ORDERVIEW)
    RETURNING_VALUES (:ISREORDERED);
 END


 SELECT PA, PB, BA, BANDS, ZBA, BE, BENDS, ZBE,
        BC, BCNDS, ZBC, BB, BBNDS, ZBB, BD, BDNDS, ZBD, PROCENTPRED, BB_PR/*15354*/
 FROM B_INIT_IND_RECORD_VALUES (:IDUSER, :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE,
        :BC, :BCNDS, :ZBC, :BB, :BBNDS, :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :BB_PR/*15354*/)
 INTO   :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE,
        :BC, :BCNDS, :ZBC, :BB, :BBNDS, :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :BB_PR/*15354*/;

 ID_NAME = NULL;
 IF ((NEEDUPDATE_NAME_PART = 1) OR (NEEDUPDATE_NAME_TITLE = 1))
 THEN

    SELECT IDNAME
    FROM B_WRITE_NAME_EX ( :IDUSER, -1, 0, :NAME_PART, :NEEDUPDATE_NAME_PART,
                           :NAME_TITLE, :NEEDUPDATE_NAME_TITLE)
    INTO :ID_NAME;

 BEGIN
    INSERT INTO B_IND (ID, IDREESTR, IDOGL, ORDERVIEW, IDNAME, IDPAPKA, TAB, TABU,
                       PA, PB, BA, BANDS, ZBA, BE, BENDS, ZBE, BC, BCNDS, ZBC,
                       BB, BBNDS, ZBB, BD, BDNDS, ZBD, PROCENTPRED, BB_PR)
    VALUES            (:ID, :IDREESTR, :IDOGL, :ORDERVIEW, :ID_NAME, :IDPAPKA, :TAB, :TABU,
                       :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE, :BC, :BCNDS, :ZBC,
                       :BB, :BBNDS, :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :BB_PR);

    WHEN GDSCODE FOREIGN_KEY, GDSCODE BAD_SEGSTR_ID,
         gdscode deadlock, gdscode lock_conflict, gdscode lock_timeout
    DO BEGIN
       INSERT INTO B_IND (ID, IDREESTR, IDOGL, ORDERVIEW, IDPAPKA, TAB, TABU,
                          PA, PB, BA, BANDS, ZBA, BE, BENDS, ZBE, BC, BCNDS, ZBC,
                          BB, BBNDS, ZBB, BD, BDNDS, ZBD, PROCENTPRED, BB_PR)
       VALUES            (:ID, :IDREESTR, :IDOGL, :ORDERVIEW, :IDPAPKA, :TAB, :TABU,
                          :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE, :BC, :BCNDS, :ZBC,
                          :BB, :BBNDS, :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :BB_PR);

       IF ((NEEDUPDATE_NAME_PART = 1) OR (NEEDUPDATE_NAME_TITLE = 1))
       THEN
          SELECT IDNAME
          FROM B_WRITE_NAME_EX ( :IDUSER, 3, :ID, :NAME_PART, :NEEDUPDATE_NAME_PART,
                                 :NAME_TITLE, :NEEDUPDATE_NAME_TITLE)
          INTO :ID_NAME;


       WHEN GDSCODE FOREIGN_KEY,
         gdscode deadlock, gdscode lock_conflict, gdscode lock_timeout
       DO EXCEPTION B_E_RECORD_IS_LOCKED ;
    END
 END

 SUSPEND ;
END
^

--[15195]
CREATE OR ALTER PROCEDURE B_IMP_I_INDEX (
    IDUSER INTEGER,
    IDREESTR INTEGER,
    IDOGL INTEGER,
    ORDERVIEW INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    NAME_PART BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NEEDUPDATE_NAME_PART INTEGER,
    NEEDUPDATE_NAME_TITLE INTEGER,
    ID_GEN INTEGER,
    BB_PR DOUBLE PRECISION)
RETURNS (
    ID INTEGER)
AS
BEGIN
--[15352]+
--[15354]+ BB_PR
 IF ((NAME_PART IS NOT NULL) OR (NAME_TITLE IS NOT NULL)) THEN BEGIN
    IF (ID_GEN > 0) THEN BEGIN
       UPDATE B_TEMP_BLOB SET BLOB1 = :NAME_PART, BLOB2 = :NAME_TITLE WHERE ID = :ID_GEN;
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_GEN INTO :NAME_PART, :NAME_TITLE;
    END
    ELSE BEGIN
       ID_GEN = GEN_ID(B_GEN_TEMP, 1) ;
       INSERT INTO B_TEMP_BLOB(ID, BLOB1, BLOB2) VALUES (:ID_GEN, :NAME_PART, :NAME_TITLE);
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_GEN INTO :NAME_PART, :NAME_TITLE;
       DELETE FROM B_TEMP_BLOB WHERE ID = :ID_GEN ;
    END
 END

 SELECT ID
 FROM B_ADD_IND_RECORD_INNER(:IDUSER, :IDREESTR, :IDOGL, :ORDERVIEW, :TAB,
    :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE, :BC, :BCNDS, :ZBC,
    :BB, :BBNDS, :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :NAME_PART,
    :NAME_TITLE, :NEEDUPDATE_NAME_PART, :NEEDUPDATE_NAME_TITLE, 0, :BB_PR/*15354*/)
 INTO :ID;

 SUSPEND;
END
^

--[15195]
CREATE OR ALTER PROCEDURE B_INIT_IND_RECORD_VALUES (
    IDUSER INTEGER,
    IN_PA DOUBLE PRECISION,
    IN_PB DOUBLE PRECISION,
    IN_BA DOUBLE PRECISION,
    IN_BANDS DOUBLE PRECISION,
    IN_ZBA DOUBLE PRECISION,
    IN_BE DOUBLE PRECISION,
    IN_BENDS DOUBLE PRECISION,
    IN_ZBE DOUBLE PRECISION,
    IN_BC DOUBLE PRECISION,
    IN_BCNDS DOUBLE PRECISION,
    IN_ZBC DOUBLE PRECISION,
    IN_BB DOUBLE PRECISION,
    IN_BBNDS DOUBLE PRECISION,
    IN_ZBB DOUBLE PRECISION,
    IN_BD DOUBLE PRECISION,
    IN_BDNDS DOUBLE PRECISION,
    IN_ZBD DOUBLE PRECISION,
    IN_PROCENTPRED DOUBLE PRECISION,
    IN_BB_PR DOUBLE PRECISION)
RETURNS (
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
--[15352]+
--[15354]+ BB_PR
 IF (IN_PA IS NULL) THEN PA = 0  ; ELSE PA = IN_PA ;
 IF (IN_PB IS NULL) THEN PB = 0  ; ELSE PB = IN_PB ;

 IF ((IN_BA IS NULL)    OR (IN_BA <= 0))    THEN BA = 1  ;    ELSE BA = IN_BA ;
 IF ((IN_BANDS IS NULL) OR (IN_BANDS <= 0)) THEN BANDS = 1 ;  ELSE BANDS = IN_BANDS ;
 IF ((IN_ZBA IS NULL)   OR (IN_ZBA <= 0))   THEN ZBA = 1 ;    ELSE ZBA = IN_ZBA ;

 IF ((IN_BE IS NULL)    OR (IN_BE <= 0))    THEN BE = 1  ;    ELSE BE = IN_BE ;
 IF ((IN_BENDS IS NULL) OR (IN_BENDS <= 0)) THEN BENDS = 1 ;  ELSE BENDS = IN_BENDS ;
 IF ((IN_ZBE IS NULL)   OR (IN_ZBE <= 0))   THEN ZBE = 1 ;    ELSE ZBE = IN_ZBE ;

 IF ((IN_BC IS NULL)    OR (IN_BC <= 0))    THEN BC = 1  ;    ELSE BC = IN_BC ;
 IF ((IN_BCNDS IS NULL) OR (IN_BCNDS <= 0)) THEN BCNDS = 1 ;  ELSE BCNDS = IN_BCNDS ;
 IF ((IN_ZBC IS NULL)   OR (IN_ZBC <= 0))   THEN ZBC = 1 ;    ELSE ZBC = IN_ZBC ;

 IF ((IN_BB IS NULL)    OR (IN_BB <= 0))    THEN BB = 1  ;    ELSE BB = IN_BB ;
 IF ((IN_BBNDS IS NULL) OR (IN_BBNDS <= 0)) THEN BBNDS = 1 ;  ELSE BBNDS = IN_BBNDS ;
 IF ((IN_ZBB IS NULL)   OR (IN_ZBB <= 0))   THEN ZBB = 1 ;    ELSE ZBB = IN_ZBB ;

 IF ((IN_BD IS NULL)    OR (IN_BD <= 0))    THEN BD = 1  ;    ELSE BD = IN_BD ;
 IF ((IN_BDNDS IS NULL) OR (IN_BDNDS <= 0)) THEN BDNDS = 1 ;  ELSE BDNDS = IN_BDNDS ;
 IF ((IN_ZBD IS NULL)   OR (IN_ZBD <= 0))   THEN ZBD = 1 ;    ELSE ZBD = IN_ZBD ;

 IF ((IN_PROCENTPRED IS NULL) OR (IN_PROCENTPRED <= 0)) THEN PROCENTPRED = 1  ;  ELSE PROCENTPRED = IN_PROCENTPRED ;

 IF ((IN_BB_PR IS NULL) OR (IN_BB_PR <= 0)) THEN BB_PR = 1 ;  ELSE BB_PR = IN_BB_PR ; --[15354]

 SUSPEND ;
END
^

--[15195]
CREATE OR ALTER PROCEDURE B_READ_IND_RECORD_VALUES (
    IDUSER INTEGER,
    INDYEAR INTEGER,
    INDMONTH INTEGER,
    IDORG INTEGER,
    SHIFR VARCHAR(42),
    RAISE_EXCEPTION INTEGER,
    WILDCARD_USED INTEGER)
RETURNS (
    IDMONTH INTEGER,
    ID INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    DOSTUP INTEGER,
    BB_PR DOUBLE PRECISION)
AS
begin
--[15352]+
--[15354]+ BB_PR
 IDMONTH     = null;
 ID          = null;
 TAB         = null ;
 DOSTUP      = 1;

 select PA, PB,
     BA, BANDS, ZBA,
     BE, BENDS, ZBE,
     BC, BCNDS, ZBC,
     BB, BBNDS, ZBB,
     BD, BDNDS, ZBD,
     PROCENTPRED, BB_PR/*15354*/
 from B_INIT_IND_RECORD_VALUES(
     :IDUSER,
     :PA, :PB,
     :BA, :BANDS, :ZBA,
     :BE, :BENDS, :ZBE,
     :BC, :BCNDS, :ZBC,
     :BB, :BBNDS, :ZBB,
     :BD, :BDNDS, :ZBD,
     :PROCENTPRED, :BB_PR/*15354*/)
 into :PA, :PB,
     :BA, :BANDS, :ZBA,
     :BE, :BENDS, :ZBE,
     :BC, :BCNDS, :ZBC,
     :BB, :BBNDS, :ZBB,
     :BD, :BDNDS, :ZBD,
     :PROCENTPRED ,:BB_PR/*15354*/;/*

 execute procedure B_INIT_IND_RECORD_VALUES(
     :IDUSER,
     :PA, :PB,
     :BA, :BANDS, :ZBA,
     :BE, :BENDS, :ZBE,
     :BC, :BCNDS, :ZBC,
     :BB, :BBNDS, :ZBB,
     :BD, :BDNDS, :ZBD,
     :PROCENTPRED)
   returning_values
     :PA, :PB,
     :BA, :BANDS, :ZBA,
     :BE, :BENDS, :ZBE,
     :BC, :BCNDS, :ZBC,
     :BB, :BBNDS, :ZBB,
     :BD, :BDNDS, :ZBD,
     :PROCENTPRED;*/

 if (INDMONTH <= 12) then
    select IDMONTH
    from B_READ_IND_SBORNIK_PARAMS_EX (:IDUSER, :INDYEAR, :INDMONTH, :IDORG)
    into :IDMONTH ;
 else IDMONTH = INDMONTH ;


 if ((IDMONTH is null) or (SHIFR is null) or (SHIFR = '')) then suspend ;
 else begin
    if ( IDUSER <> 13 ) then  /* not from trigger */
    begin
      execute procedure L_CAN_USE_IND ( :iduser , :IDMONTH , :RAISE_EXCEPTION ) returning_values ( :dostup );
      if ( dostup = 0 ) then
        exit;
    end

    SHIFR = S_TRANSLITERATE(SHIFR) ;

    /*   -   -    ( ) */

    for select
         ID, TAB,
         PA, PB,
         BA, BANDS, ZBA,
         BE, BENDS, ZBE,
         BC, BCNDS, ZBC,
         BB, BBNDS, ZBB,
         BD, BDNDS, ZBD,
         PROCENTPRED, BB_PR/*15354*/
    from B_IND
    where IDREESTR = :IDMONTH
      and TABU = :SHIFR
    plan sort((B_IND index (B_IND_IDX_TABU)))
    order by ORDERVIEW
    into :ID, :TAB,
         :PA, :PB,
         :BA, :BANDS, :ZBA,
         :BE, :BENDS, :ZBE,
         :BC, :BCNDS, :ZBC,
         :BB, :BBNDS, :ZBB,
         :BD, :BDNDS, :ZBD,
         :PROCENTPRED, :BB_PR/*15354*/
    do
    begin
      suspend ;
      exit;
    end

     /*   -      */ 
    if (:WILDCARD_USED <> 0) then
      for select
          ID, TAB,
          PA, PB,
          BA, BANDS, ZBA,
          BE, BENDS, ZBE,
          BC, BCNDS, ZBC,
          BB, BBNDS, ZBB,
          BD, BDNDS, ZBD,
          PROCENTPRED, BB_PR/*15354*/
      from B_IND
      where IDREESTR = :IDMONTH
        and TABU_MASK = '' --<<[11189/11537] (2013/09/06)
        and :SHIFR like TABU
      /*plan (B_IND order B_IND_IDX_ORDERVIEW)*/
      order by IDREESTR, ORDERVIEW
      into :ID, :TAB,
           :PA, :PB,
           :BA, :BANDS, :ZBA,
           :BE, :BENDS, :ZBE,
           :BC, :BCNDS, :ZBC,
           :BB, :BBNDS, :ZBB,
           :BD, :BDNDS, :ZBD,
           :PROCENTPRED, :BB_PR/*15354*/
      do
      begin
        suspend ;
        exit;
      end

    suspend;
 end
end
^

--[15195]
CREATE OR ALTER PROCEDURE B_READ_IND_RECORD_VALUES_1 (
    IDUSER INTEGER,
    INDYEAR INTEGER,
    INDMONTH INTEGER,
    IDORG INTEGER,
    SHIFR VARCHAR(42),
    RAISE_EXCEPTION INTEGER,
    WILDCARD_USED INTEGER)
RETURNS (
    IDMONTH INTEGER,
    ID INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    DOSTUP INTEGER,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    BB_PR DOUBLE PRECISION)
AS
declare variable IDNAME integer;
BEGIN
--[15352]+
--[15354]+ BB_PR
-- Voyager CQ[13756]
--  ,   B_READ_IND_RECORD_VALUES +  

    execute procedure B_READ_IND_RECORD_VALUES(
        :IDUSER, :INDYEAR, :INDMONTH, :IDORG, :SHIFR, :RAISE_EXCEPTION, :WILDCARD_USED)
    returning_values
        :IDMONTH, :ID, :TAB, :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE, :BC, :BCNDS, :ZBC, :BB,
        :BBNDS, :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :DOSTUP, :BB_PR/*15354*/;

    if (ID is not NULL) then
    begin
        select first 1 I.IDNAME from B_IND I
        where I.ID = :ID
        into :IDNAME;

        execute procedure B_GETNAME(:IDUSER,:IDNAME) returning_values :NAME;
    end

    suspend;
END
^

--[15195]
CREATE OR ALTER PROCEDURE B_READ_RECORD_INDEX (
    IDUSER INTEGER,
    ID INTEGER,
    NEEDREADNAME INTEGER)
RETURNS (
    IDOGL INTEGER,
    ORDERVIEW INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    NEW_PAGE SMALLINT,
    IDNAME INTEGER,
    NAME_TITLE BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    NAME_PART BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    BB_PR DOUBLE PRECISION)
AS
BEGIN
--[15352]
--[15354]+BB_PR
 FOR SELECT
      IDOGL, ORDERVIEW, TAB, PA, PB, BA, BANDS,
      ZBA, BE, BENDS, ZBE, BC, BCNDS, ZBC, BB, BBNDS,
      ZBB, BD, BDNDS, ZBD, PROCENTPRED, NEW_PAGE,
      IDNAME, BB_PR /*15354*/
 FROM B_IND
 WHERE ID = :ID
 INTO IDOGL, ORDERVIEW, TAB, PA, PB, BA, BANDS,
      ZBA, BE, BENDS, ZBE, BC, BCNDS, ZBC, BB, BBNDS,
      ZBB, BD, BDNDS, ZBD, PROCENTPRED, NEW_PAGE,
      :IDNAME, :BB_PR /*15354 + MK CQ[15047, 15049]*/
 DO BEGIN

    SELECT PA, PB, BA, BANDS, ZBA, BE, BENDS, ZBE,
           BC, BCNDS, ZBC, BB, BBNDS, ZBB, BD, BDNDS, ZBD, PROCENTPRED, BB_PR /*15354*/
    FROM B_INIT_IND_RECORD_VALUES (:IDUSER, :PA, :PB, :BA, :BANDS, :ZBA,
         :BE, :BENDS, :ZBE, :BC, :BCNDS, :ZBC, :BB, :BBNDS, :ZBB,
         :BD, :BDNDS, :ZBD, :PROCENTPRED, :BB_PR /*15354*/)
    INTO PA, PB, BA, BANDS, ZBA, BE, BENDS, ZBE,
         BC, BCNDS, ZBC, BB, BBNDS, ZBB, BD, BDNDS, ZBD, PROCENTPRED, BB_PR /*15354*/;

    IF (NEEDREADNAME = 1)
    THEN
       SELECT NAME_TITLE, NAME_PART
       FROM B_GETNAME_2 (:IDUSER, :IDNAME)
       INTO :NAME_TITLE, :NAME_PART ;

    SUSPEND ;
 END
END
^

--[15195]
CREATE OR ALTER PROCEDURE B_WRITE_RECORD_INDEX (
    IDUSER INTEGER,
    ID INTEGER,
    IDREESTR INTEGER,
    IDOGL INTEGER,
    TAB VARCHAR(42),
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    BA DOUBLE PRECISION,
    BANDS DOUBLE PRECISION,
    ZBA DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BENDS DOUBLE PRECISION,
    ZBE DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BCNDS DOUBLE PRECISION,
    ZBC DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BBNDS DOUBLE PRECISION,
    ZBB DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BDNDS DOUBLE PRECISION,
    ZBD DOUBLE PRECISION,
    PROCENTPRED DOUBLE PRECISION,
    NAME_PART BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NAME_TITLE BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NEEDUPDATE_NAME_PART INTEGER,
    NEEDUPDATE_NAME_TITLE INTEGER,
    ID_GEN INTEGER,
    BB_PR DOUBLE PRECISION)
AS
DECLARE VARIABLE TABU VARCHAR(42);
DECLARE VARIABLE ID_NAME INTEGER;
BEGIN
--[15352]
--[15354]+ BB_PR
 IF ((ID_GEN <> -1) AND ((NAME_PART IS NOT NULL) OR (NAME_TITLE IS NOT NULL))) THEN BEGIN
    IF (ID_GEN > 0) THEN BEGIN
       UPDATE B_TEMP_BLOB SET BLOB1 = :NAME_PART, BLOB2 = :NAME_TITLE WHERE ID = :ID_GEN;
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_GEN INTO :NAME_PART, :NAME_TITLE;
    END
    ELSE BEGIN
       ID_GEN = GEN_ID(B_GEN_TEMP, 1) ;
       INSERT INTO B_TEMP_BLOB(ID, BLOB1, BLOB2) VALUES (:ID_GEN, :NAME_PART, :NAME_TITLE);
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_GEN INTO :NAME_PART, :NAME_TITLE;
       DELETE FROM B_TEMP_BLOB WHERE ID = :ID_GEN ;
    END
 END

 IF (NOT EXISTS (SELECT * FROM B_IND WHERE ID = :ID))
 THEN EXCEPTION B_E_IND_NOT_FOUND ;

 IF ((TAB IS NOT NULL) AND (TAB <> '')) THEN BEGIN
    TAB = LCKTRIMVARCHAR(TAB);
    TABU = S_TRANSLITERATE(LCKUPPERVARCHAR(TAB));

    IF (EXISTS (SELECT * FROM B_IND
                WHERE ((TABU  = :TABU) AND
                       (IDREESTR = :IDREESTR) AND
                       (ID <> :ID))))
    THEN EXCEPTION B_E_TAB_EXISTS ;
 END

 IF (IDOGL <= 0)
 THEN IDOGL = NULL ;
 IF (IDOGL IS NOT NULL)
 THEN
    IF (NOT EXISTS (SELECT * FROM B_OGL WHERE ID = :IDOGL))
    THEN IDOGL = NULL ;

 SELECT PA, PB, BA, BANDS, ZBA, BE, BENDS, ZBE,
        BC, BCNDS, ZBC, BB, BBNDS, ZBB, BD, BDNDS, ZBD, PROCENTPRED, BB_PR/*15354*/
 FROM B_INIT_IND_RECORD_VALUES (:IDUSER, :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE,
        :BC, :BCNDS, :ZBC, :BB, :BBNDS, :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :BB_PR/*15354*/)
 INTO   :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE,
        :BC, :BCNDS, :ZBC, :BB, :BBNDS, :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :BB_PR/*15354*/;

 BEGIN
    UPDATE B_IND
    SET IDREESTR = :IDREESTR, IDOGL = :IDOGL,
        TAB = :TAB, TABU = :TABU,
        PA = :PA, PB = :PB, BA = :BA, BANDS = :BANDS, ZBA = :ZBA,
        BE = :BE, BENDS = :BENDS, ZBE = :ZBE, BC = :BC,
        BCNDS = :BCNDS, ZBC = :ZBC, BB = :BB, BBNDS = :BBNDS,
        ZBB = :ZBB, BD = :BD, BDNDS = :BDNDS, ZBD = :ZBD,
        PROCENTPRED = :PROCENTPRED,
        BB_PR = :BB_PR -- MK CQ[15047, 15354]
    WHERE ID = :ID ;

    WHEN GDSCODE FOREIGN_KEY, GDSCODE BAD_SEGSTR_ID
    DO EXCEPTION B_E_RECORD_IS_LOCKED ;
 END

 IF ((NEEDUPDATE_NAME_PART = 1) OR (NEEDUPDATE_NAME_TITLE = 1))
 THEN
    SELECT IDNAME
    FROM B_WRITE_NAME_EX (:IDUSER, 3, :ID, :NAME_PART, :NEEDUPDATE_NAME_PART,
                          :NAME_TITLE, :NEEDUPDATE_NAME_TITLE)
    INTO :ID_NAME;
END
^

--[15195]
/* 
CREATE OR ALTER PROCEDURE CHECK_CAN_CENLVL_USE_INDEX (
*/
--[15195]
CREATE OR ALTER PROCEDURE D_GET_ITOG_NL (
    ID_USER INTEGER,
    OBJECT_ID INTEGER,
    SMETATYPE INTEGER,
    IDHIER INTEGER,
    VID INTEGER,
    ID_CENLVL INTEGER)
RETURNS (
    ID INTEGER,
    ITOG DOUBLE PRECISION,
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    NEED_RECALC INTEGER)
AS
declare variable O_RA double precision;
DECLARE VARIABLE O_RB DOUBLE PRECISION;
DECLARE VARIABLE O_RC DOUBLE PRECISION;
DECLARE VARIABLE O_RD DOUBLE PRECISION;
DECLARE VARIABLE O_RE DOUBLE PRECISION;
DECLARE VARIABLE O_RF DOUBLE PRECISION;
DECLARE VARIABLE O_RG DOUBLE PRECISION;
DECLARE VARIABLE O_RH DOUBLE PRECISION;
DECLARE VARIABLE O_RI DOUBLE PRECISION;
DECLARE VARIABLE O_RJ DOUBLE PRECISION;
DECLARE VARIABLE O_RK DOUBLE PRECISION;
DECLARE VARIABLE O_RL DOUBLE PRECISION;
DECLARE VARIABLE O_RM DOUBLE PRECISION;
DECLARE VARIABLE O_IT DOUBLE PRECISION;
DECLARE VARIABLE O_RLM DOUBLE PRECISION;
DECLARE VARIABLE O_ITOGO DOUBLE PRECISION;

DECLARE VARIABLE O_RN DOUBLE PRECISION;
DECLARE VARIABLE O_RO DOUBLE PRECISION;
DECLARE VARIABLE O_RP DOUBLE PRECISION;

--<<[12250]
declare O_R25 double precision;
declare O_R26 double precision;
declare O_R27 double precision;
declare O_R28 double precision;
declare O_R29 double precision;

--[15479]
declare variable O_R_PR double precision;
declare variable O_RC_16 double precision;
declare variable O_RE_16 double precision;

DECLARE VARIABLE LOOK_IN_LZ INTEGER;
DECLARE VARIABLE ITOG_TYPE integer;
begin
--[15352]
--[15479]

  ITOG = null;
  LOOK_IN_LZ = 1;
  NEED_RECALC = 0;
  ID = 0;

  --    / 
  if ((:IDHIER = :OBJECT_ID) or (:SMETATYPE = :IDHIER))  then
  begin
    select first 1 c.itog, l.FORMULA, l.ID, l.ATYPE
    from a_lz l
    left join a_lz_cenlvl c on (c.id = l.id) and (c.idcenlvl = :ID_CENLVL)
    where (l.IDHIER = :IDHIER) and (l.SMETATYPE = :SMETATYPE) and (l.vid = :VID)
    into :ITOG, :FORMULA, :ID, :ITOG_TYPE;

    if (ITOG_TYPE <> 212) then --  
    begin
      execute procedure A_LZ_GETITOG_OBJ_NL(:ID_USER, :OBJECT_ID, :SMETATYPE, :ID_CENLVL)
        returning_values :O_RA, :O_RB, :O_RC, :O_RD, :O_RE, :O_RF, :O_RG, :O_RH,
                         :O_RI, :O_RJ, :O_RK, :O_RL, :O_RM, :O_IT,
                         :O_RLM, :O_ITOGO, :O_RN, :O_RO, :O_RP,
                         :O_R25, :O_R26, :O_R27, :O_R28, :O_R29, --<<[12250]
                         :O_R_PR, :O_RC_16, :O_RE_16; --[15479]

      execute procedure D_GET_LZ_OBJ_ITOG(:ITOG_TYPE,
          :O_RA, :O_RB, :O_RC, :O_RD, :O_RE, :O_RF, :O_RG, :O_RH,
          :O_RI, :O_RJ, :O_RK, :O_RL, :O_RM, :o_it, :O_RLM, :O_ITOGO,
          :O_RN, :O_RO, :O_RP,
          :O_R25, :O_R26, :O_R27, :O_R28, :O_R29,  --<<[12250]
          :O_R_PR, :O_RC_16, :O_RE_16) --[15479]
        returning_values :ITOG;

      if (:ITOG is null) then
      begin
        LOOK_IN_LZ = 1;
        NEED_RECALC = 1;
      end
      else
        LOOK_IN_LZ = 0;
    end
    else
    begin
      LOOK_IN_LZ = 1;
      NEED_RECALC = 1;
    end
  end

  if (LOOK_IN_LZ = 1) then
  begin
    select first 1 c.ITOG, l.FORMULA, l.ID, l.ATYPE
    from a_lz l
    left join a_lz_cenlvl c on (c.id = l.id) and (c.idcenlvl = :ID_CENLVL)
    where (l.IDHIER = :IDHIER) and (l.SMETATYPE = :SMETATYPE) and (l.vid = :VID)
    into :ITOG, :FORMULA, :ID, :ITOG_TYPE;

    --    
    if ((NEED_RECALC = 0) and (ITOG_TYPE = 212)) then
      NEED_RECALC = 1;
  end

  if (ITOG is not null) then
    suspend;
end
^

--[15195]
CREATE OR ALTER PROCEDURE D_GET_LZ (
    ID_USER INTEGER,
    ROOT_ID INTEGER,
    SMETA_TYPE INTEGER,
    OBJECT_ID INTEGER,
    AMODE INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    ID_PARENT INTEGER,
    ID_HIER INTEGER,
    IS_HIER INTEGER,
    ATYPE INTEGER,
    LZTYPE INTEGER,
    NUMBER INTEGER,
    AVAR VARCHAR(30),
    NAME VARCHAR(1024),
    FORMULA BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ITOG DOUBLE PRECISION,
    VID INTEGER,
    APRINT INTEGER,
    PRECIS INTEGER)
AS
--CQ[TIMUR 13931] -    NAME
DECLARE VARIABLE O_RA DOUBLE PRECISION;
DECLARE VARIABLE O_RB DOUBLE PRECISION;
DECLARE VARIABLE O_RC DOUBLE PRECISION;
DECLARE VARIABLE O_RD DOUBLE PRECISION;
DECLARE VARIABLE O_RE DOUBLE PRECISION;
DECLARE VARIABLE O_RF DOUBLE PRECISION;
DECLARE VARIABLE O_RG DOUBLE PRECISION;
DECLARE VARIABLE O_RH DOUBLE PRECISION;
DECLARE VARIABLE O_RI DOUBLE PRECISION;
DECLARE VARIABLE O_RJ DOUBLE PRECISION;
DECLARE VARIABLE O_RK DOUBLE PRECISION;
DECLARE VARIABLE O_RL DOUBLE PRECISION;
DECLARE VARIABLE O_RM DOUBLE PRECISION;
DECLARE VARIABLE O_IT DOUBLE PRECISION;
DECLARE VARIABLE O_RLM DOUBLE PRECISION;
DECLARE VARIABLE O_ITOGO DOUBLE PRECISION;

DECLARE VARIABLE O_RN DOUBLE PRECISION;
DECLARE VARIABLE O_RO DOUBLE PRECISION;
DECLARE VARIABLE O_RP DOUBLE PRECISION;

--<<[12250]
declare O_R25 double precision;
declare O_R26 double precision;
declare O_R27 double precision;
declare O_R28 double precision;
declare O_R29 double precision;

--[15479]
declare O_R_PR double precision;
declare O_RC_16 double precision;
declare O_RE_16 double precision;

DECLARE VARIABLE IDNAME INTEGER;
DECLARE VARIABLE current_vid INTEGER;
DECLARE VARIABLE FHIER_ROOT INTEGER;
DECLARE VARIABLE FHIER_LZ INTEGER;
begin
--[15352]
--[15479]
/*
       
     

AMODE:
  . = 0 -    0 (     ROOT_ID)

(LxUtils 610)
ATYPE
  1 - 
  3 - 
  4 - 
  5 - 
  101 -  
  102 -  
*/


  select u.idlzgroup
  from b_user_access u
  where u.id = :ID_USER
  into :current_vid;

  if (current_vid is null) then
    current_vid = 200;

  if (SMETA_TYPE = ROOT_ID) then
    FHIER_ROOT = :OBJECT_ID;
  else
    FHIER_ROOT = :ROOT_ID;

  for
    select ID, ID_PARENT, ATYPE, FULLNAME from D_GET_HIER(:ID_USER, :FHIER_ROOT, 1, 1, null, 0)
    into :ID, :ID_PARENT, :ATYPE, :NAME
  do
  begin
    IS_HIER = 1;
    ID_HIER = :ID; 
    LZTYPE = null;
    AVAR = null;
    FORMULA = null;
    ITOG = null;
    NUMBER = null;
    suspend;
    IS_HIER = 0;
    ID_PARENT = :ID_HIER;

    if ((ID_HIER = :OBJECT_ID) and (SMETA_TYPE = ROOT_ID)) then
      FHIER_LZ = :SMETA_TYPE;
    else
      FHIER_LZ = :ID_HIER;

    if (ID_HIER = :OBJECT_ID) then
    begin
      --select i.ra, i.rb, i.rc, i.rd, i.re, i.rf, i.rg, i.rh, i.ri, i.rj, i.rk, i.IT
      --from a_lz_getitog_obj(:ID_USER, :OBJECT_ID, :SMETA_TYPE) i
      --into :o_ra, :o_rb, :o_rc, :o_rd, :o_re, :o_rf, :o_rg, :o_rh, :o_ri, :o_rj, :o_rk, :o_it;
      execute procedure A_LZ_GETITOG_OBJ_NL(:ID_USER, :OBJECT_ID, :SMETA_TYPE, :IDCENLVL)
        returning_values :O_RA, :O_RB, :O_RC, :O_RD, :O_RE, :O_RF, :O_RG,
                         :O_RH, :O_RI, :O_RJ, :O_RK, :O_RL, :O_RM, :O_IT,
                         :O_RLM, :O_ITOGO, :O_RN, :O_RO, :O_RP,
                         :O_R25, :O_R26, :O_R27, :O_R28, :O_R29, --<<[12250]
                         :O_R_PR, :O_RC_16, :O_RE_16; --[15479]
    end
    for
      select l.ID, l.ATYPE, l.AVAR, l.FORMULA, LC.ITOG, l.name, l.number, l.idname,
             l.vid, l.aprint, l.PRECIS
      from a_lz l
      left join A_LZ_CENLVL LC on LC.ID = L.ID and LC.IDCENLVL = :IDCENLVL --CQ[TIMUR 9523]
      where l.IDHIER = :FHIER_LZ and l.SMETATYPE = :SMETA_TYPE
      order by l.NUMBER
      into :ID, :LZTYPE, :AVAR, :FORMULA, :ITOG, :NAME, :number, :IDNAME, :VID,
           :APRINT, :PRECIS
    do
    begin

      -- MK 18.03.2010 CQ[7436] --->
      --  -   avar  name   select
      -- (    A_LZ_SELECT1)
      /*
      if ((idname > 0 )
      and (avar is null)
      and (name is null))
      then
        select n.avar, n.name
          from a_lz_names n
          where (n.idgroup = :current_vid) and (n.atype = :idname)
          into :avar, :name;
      */

      -- MK 29.05.2009:   aprint   A_LZ_SELECT1 --->
      -- MK 18.03.2010 CQ[7436]   avar  name ( )
      if (LZTYPE <> 212) then
        select coalesce(:aprint, n.aprint), n.avar, n.name
        from a_lz_names n
        where (n.idgroup = :current_vid) and (n.atype = :idname)
        into :aprint, :avar, :name;
      -- MK 29.05.2009 <---
      -- MK 18.03.2010 CQ[7436] <---


      --if ((LZTYPE >= 201) and (LZTYPE <= 211)) then
      --  ATYPE = 101;
      --else
      --  ATYPE = 102;
      ATYPE = --<<rvs:[6929]
        case :LZTYPE
          when 212 then 102
          else 101
        end;
      if (ID_HIER = :OBJECT_ID) then
        --select first 1 ITOG from D_GET_LZ_OBJ_ITOG(:LZTYPE, :O_RA, :O_RB, :O_RC, :O_RD, :O_RE, :O_RF, :O_RG, :O_RH, :O_RI, :O_RJ, :O_RK, :O_RL, :O_RM, :O_IT)
        --  into :ITOG;
        execute procedure D_GET_LZ_OBJ_ITOG(:LZTYPE,
            :O_RA, :O_RB, :O_RC, :O_RD, :O_RE, :O_RF, :O_RG, :O_RH,
            :O_RI, :O_RJ, :O_RK, :O_RL, :O_RM, :O_IT, :O_RLM, :O_ITOGO,
            :O_RN, :O_RO, :O_RP,
            :O_R25, :O_R26, :O_R27, :O_R28, :O_R29, --<<[12250]
            :O_R_PR, :O_RC_16, :O_RE_16) --[15479]
          returning_values :ITOG;
      suspend;
    end
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE D_GET_LZ_OBJ_ITOG (
    LZTYPE INTEGER,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    IT DOUBLE PRECISION,
    RLM DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    RN DOUBLE PRECISION,
    RO DOUBLE PRECISION,
    RP DOUBLE PRECISION,
    R25 DOUBLE PRECISION,
    R26 DOUBLE PRECISION,
    R27 DOUBLE PRECISION,
    R28 DOUBLE PRECISION,
    R29 DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
RETURNS (
    ITOG DOUBLE PRECISION)
AS
begin
--[15352]+
--[15479]
   /*
   if ( LZTYPE = 201 )
   then itog = :ra;
   else if ( LZTYPE = 202 )
        then itog = :rb;
        else if ( LZTYPE = 203 )
             then itog = :rc;
             else if ( LZTYPE = 204 )
                  then itog = :rd;
                  else if ( LZTYPE = 205 )
                       then itog = :re;
                       else if ( LZTYPE = 206 )
                            then itog = :rf;
                            else if ( LZTYPE = 207 )
                                 then itog = :rg;
                                 else if ( LZTYPE = 208 )
                                      then itog = :rh;
                                      else if ( LZTYPE = 209 )
                                           then itog = :ri;
                                           else if ( LZTYPE = 210 )
                                                then itog = :rj;
                                                else if ( LZTYPE = 211 )
                                                     then itog = :rk;
                                                     else if ( LZTYPE = 213 )
                                                          then itog = :it;
                                                          else itog = null;
   */

  ITOG =
    case :LZTYPE
      when 201 then :RA
      when 202 then :RB
      when 203 then :RC
      when 204 then :RD
      when 205 then :RE
      when 206 then :RF
      when 207 then :RG
      when 208 then :RH
      when 209 then :RI
      when 210 then :RJ
      when 211 then :RK
      when 216 then :RL --<<[7398] --<<[633526DDD29B]
      when 222 then :RM
      when 213 then :IT
      when 223 then :RLM    -- CQ[8295]
      when 224 then :ITOGO  -- CQ[9349]

      -- MK CQ[9374] --->
      when 214 then :RN
      when 215 then :RO
      when 217 then :RP
      -- MK CQ[9374] <---

      --<<[12250]
      when 225 then :R25
      when 226 then :R26
      when 227 then :R27
      when 228 then :R28
      when 229 then :R29

      when 230 then :R_PR  --[15479]
      when 231 then :RC_16 --[15479]
      when 232 then :RE_16 --[15479]

      else null
    end;

  suspend;
end
^

--[15195]
CREATE OR ALTER PROCEDURE FILL_INDLVL_DESCR (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDCOMPOSE INTEGER,
    INDEX_INFO INTEGER)
AS
declare variable SM_REC_ID_SRC integer;
begin
--[15352]
--[15354]
  if (INDEX_INFO <= 0) then
  begin
    --INDEX_INFO = -1    ,     
    --INDEX_INFO = 0    ,     

    -- MK 3.08.2012 CQ[10695] --->
    --  Compose     (INDEX_INFO = -2) 
    --     (    = -1)
    --  
    if (INDEX_INFO < 0) then
    begin
      execute procedure A_SMETA_INDLVL_DESCR_IU(:ID, :IDCENLVL, null, null, null,
                                                null, null, null, null, null,
                                                null, null, null, null, null,
                                                null/*15354*/, null, null, null, null,
                                                null, null, null, null, null);
    end
    -- MK 3.08.2012 CQ[10695] <---
  end
  else
  begin
    if (INDEX_INFO = 1) then
    begin
      SM_REC_ID_SRC = null;
      --     (SM_REC_ID_SRC)
      select first 1 S.SLAVEPARENT
      from A_SMETA S
      where (S.ID = :ID)
      into :SM_REC_ID_SRC;

      execute procedure A_SMETA_INDLVL_DESC_CLONE(:SM_REC_ID_SRC, :ID, :IDCENLVL, :IDCENLVL);
    end
    else
    begin
      if (INDEX_INFO = 4) then
      begin
        --      
        execute procedure FILL_INDLVL_DESCR_INDEX_ITOG(:ID, :IDCENLVL, :IDCOMPOSE);
      end
      else
      begin
        if (INDEX_INFO = 5) then
        begin
          --   
          execute procedure FILL_INDLVL_DESCR_INDEX(:ID, :IDCENLVL, :IDCOMPOSE, 0);
        end
        else
        begin
          --   ,       ,
          --    
          execute procedure FILL_INDLVL_DESCR_INDEX(:ID, :IDCENLVL, :IDCOMPOSE, 1);
        end
      end
    end
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE FILL_INDLVL_DESCR_INDEX (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDCOMPOSE INTEGER,
    IGNORE_SBORNIK_FIELD INTEGER)
AS
declare variable NMA varchar(255);
declare variable NMB varchar(255);
declare variable NMJ varchar(255);
declare variable NMK varchar(255);
declare variable NDA varchar(255);
declare variable NDB varchar(255);
declare variable NDJ varchar(255);
declare variable NDK varchar(255);
begin
--[15352]
--[15354]
  for select NMA, NMB, NMJ, NMK, NDA, NDB, NDJ, NDK
    from LEVEL_INDEX
    where ID_COMPOSE = :IDCOMPOSE
    into :NMA, :NMB, :NMJ, :NMK, :NDA, :NDB, :NDJ, :NDK
  do
  begin
    --  MA  MB   ,       
    if (IGNORE_SBORNIK_FIELD = 1) then
    begin
      NMA = null;
      NMB = null;
    end
    execute procedure A_SMETA_INDLVL_DESCR_IU(:ID, :IDCENLVL, :NMA, :NMB, null, null, null, null,
      null, null, null, :NMJ, :NMK, null, null, null/*15354*/, :NDA, :NDB, null, null, null, :NDJ, :NDK, null,
      null);
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE FILL_INDLVL_DESCR_INDEX_ITOG (
    ID INTEGER,
    IDCENLVL INTEGER,
    IDCOMPOSE INTEGER)
AS
declare variable NMA varchar(255);
declare variable NMB varchar(255);
declare variable NMC varchar(255);
declare variable NMD varchar(255);
declare variable NME varchar(255);
declare variable NMJ varchar(255);
declare variable NMK varchar(255);
declare variable NML varchar(255);
declare variable NMM varchar(255);
declare variable NMN varchar(255);/*15354*/
declare variable NDA varchar(255);
declare variable NDB varchar(255);
declare variable NDJ varchar(255);
declare variable NDK varchar(255);
declare variable NDL varchar(255);
declare variable NDM varchar(255);
begin
--[15352]
--[15354]
  for select NMA, NMB, NMC, NMD, NME, NMJ, NMK, NML, NMM, NMN/*15354*/,
             NDA, NDB, NDJ, NDK, NDL, NDM
    from LEVEL_INDEX_ITOG
    where ID_COMPOSE = :IDCOMPOSE
    into :NMA, :NMB, :NMC, :NMD, :NME, :NMJ, :NMK, :NML, :NMM, :NMN/*15354*/,
         :NDA, :NDB, :NDJ, :NDK, :NDL, :NDM
  do
  begin
    execute procedure A_SMETA_INDLVL_DESCR_IU(:ID, :IDCENLVL, :NMA, :NMB, :NMC, :NMD, :NME, null,
      null, null, null, :NMJ, :NMK, :NML, :NMM, :NMN/*15354*/, :NDA, :NDB, null, null, null, :NDJ, :NDK,
      :NDL, :NDM);
  end

end
^

--[15195]
CREATE OR ALTER PROCEDURE IS_EMPTY_INDEX (
    IDNORMATIV INTEGER,
    RABMAT INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION)
RETURNS (
    IS_EMPTY INTEGER)
AS
begin
--[15352]+
--[15354]

  --:    CQ[10738]
  -- ( ) :
  --)   (IDNormativ > 0)    
  --)     (RABMAT = 3  IDNormativ = 0/null)       

  IS_EMPTY = 1;
  if ((coalesce(:MA, 1) <> 1) or
      (coalesce(:MB, 1) <> 1) or
      (coalesce(:MC, 1) <> 1) or
      (coalesce(:MD, 1) <> 1) or
      (coalesce(:ME, 1) <> 1) or
      (coalesce(:MJ, 1) <> 1) or
      (coalesce(:MK, 1) <> 1) or
      (coalesce(:ML, 1) <> 1) or
      (coalesce(:MM, 1) <> 1) or
      (/*15354*/coalesce(:MN, 1) <> 1)) then
    IS_EMPTY = 0;
  if ((:IS_EMPTY = 1) and
      (coalesce(:RABMAT, 0) = 3) /*and
      (coalesce(IDNORMATIV, 0) = 0)*/) then -- MK  . [7FE7AD1744B6]
  begin
    if ((coalesce(:DA, 1) <> 1) or
        (coalesce(:DB, 1) <> 1) or
        (coalesce(:DJ, 1) <> 1) or
        (coalesce(:DK, 1) <> 1) or
        (coalesce(:DL, 1) <> 1) or
        (coalesce(:DM, 1) <> 1)) then
      IS_EMPTY = 0;
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE KD_CLONE_SMETA_REC_CENLVL (
    IDUSER INTEGER,
    IDSMRECSRC INTEGER,
    IDSMRECDST INTEGER,
    IDSESSIONTMP INTEGER)
AS
--declare ID integer;
--declare IDCENLVL integer;
declare IDZONE integer;
declare IDINDEX integer;
declare ID_LEVEL_INDEX integer;
declare ID_LEVEL_VC integer;
declare BA double precision;
declare BB double precision;
declare BC double precision;
declare BD double precision;
declare BE double precision;
declare BF double precision;
declare BG double precision;
declare BH double precision;
declare BI double precision;
declare BJ double precision;
--TIMUR[13178]
declare BN double precision;
declare BO double precision;
declare B_ITOGO double precision;
--TIMUR[13178]
declare B_PR double precision; --[15352]
declare CA double precision;
declare CB double precision;
declare CC double precision;
declare CD double precision;
declare CE double precision;
declare CF double precision;
declare CG double precision;
declare CH double precision;
declare CI double precision;
declare CJ double precision;
--TIMUR[13178]
declare C_ITOGO double precision;
--TIMUR[13178]
declare C_PR double precision; --[15352]
declare EA double precision;
declare EB double precision;
declare EC double precision;
declare ED double precision;
declare EE double precision;
declare EF double precision;
declare EG double precision;
declare EH double precision;
declare EI double precision;
declare EJ double precision;
declare EK double precision;
--TIMUR[13178]
declare EN double precision;
declare EO double precision;
declare E_ITOGO double precision;
--TIMUR[13178]
declare E_PR double precision; --[15352]
declare RA double precision;
declare RB double precision;
declare RC double precision;
declare RD double precision;
declare RE double precision;
declare RF double precision;
declare RG double precision;
declare RH double precision;
declare RI double precision;
declare RJ double precision;
declare RK double precision;
declare RL double precision;
declare RM double precision;
declare ITOGO double precision;
declare R_PR double precision; --[15352]
declare RC_16 double precision; --[15352]
declare RE_16 double precision; --[15352]
declare PA double precision;
declare PB double precision;
declare PC double precision;
declare PD double precision;
declare PUNKTIND varchar(42);
declare MA double precision;
declare MB double precision;
declare MC double precision;
declare MD double precision;
declare ME double precision;
declare MF double precision;
declare MG double precision;
declare MH double precision;
declare MI double precision;
declare INDEX_SPOSOBRASCH integer;
declare CALCBMASK integer;
declare BASE_INFO integer;
declare INDEX_INFO integer;

declare IDCLASSDST integer;
declare IDCLASSSRC integer;
declare IDLEVELDST integer;
declare IDLEVELSRC integer;

declare IDHIERSRC integer;
declare SMETATYPESRC integer;
declare ATYPESRC integer;

declare IDHIERDST integer;
declare SMETATYPEDST integer;
declare ATYPEDST integer;
declare SLAVEPARENTDST integer;
declare IDTRDST integer;
declare VRPZDST integer;
declare RES_COPY_FORMULSDST integer;

--declare RECORDS_MODIFIED integer;

declare IDRESSRC integer;
declare IDRESDST integer;

declare variable MJ double precision;
declare variable MK  double precision;
declare variable ML double precision;
declare variable MM double precision;
declare M_PR double precision; --[15352]
declare variable DA double precision;
declare variable DB double precision;
declare variable DC double precision;
declare variable DD double precision;
declare variable DE double precision;
declare variable DJ double precision;
declare variable DK  double precision;
declare variable DL double precision;
declare variable DM double precision;

declare variable VN_CURR_CENA double precision;
declare variable VN_BASE_CALC_INFO integer;
declare variable VN_SOURCE_LEVEL_ID integer;

-- MK CQ[11989]
declare variable VN_CURR_CENA_INFO integer;
declare variable VN_ID_VALUTE integer;
declare variable VN_VALUTE_CURS double precision;
declare variable VN_VALUTE_DATE date;
declare variable VN_TRANSP double precision;
declare variable VN_ZAG_SKL double precision;
declare variable VN_ZAPCHAST double precision;
declare variable VN_TARA double precision;
declare variable VN_NACEN double precision;
declare variable VN_COMPLECT double precision;
declare variable VN_KOEFF_TYPE integer;
begin
-- [15352]
  --  S_TEMP .   D_UniteCenlvlClasses.pas

  --:      A_S_PASTE_SMETA_REC_CENLVL
  --
  select IDHIER, SMETATYPE, ATYPE
    from A_SMETA
    where ID = :IDSMRECSRC
    into :IDHIERSRC, :SMETATYPESRC, :ATYPESRC;

  if (:ATYPESRC in (17/*SmRec*/,18/*ResRec*/)) then
  begin
    if (:SMETATYPESRC > 999) then
      IDCLASSSRC = :SMETATYPESRC;
    else
      execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIERSRC, 1/*ObgectType*/)
        returning_values :IDCLASSSRC;
  end
  else
    exit;


  select IDHIER, SMETATYPE, ATYPE, SLAVEPARENT, VRPZ
    from A_SMETA
    where ID = :IDSMRECDST
    into :IDHIERDST, :SMETATYPEDST, :ATYPEDST, :SLAVEPARENTDST, :VRPZDST;

  if (:ATYPEDST = :ATYPESRC) then
  begin
    if (:SMETATYPEDST > 999) then
    begin
      IDCLASSDST = :SMETATYPEDST;
      select ID_TR, RES_COPY_FORMULS
        from A_O_FACTPARAMS
        where NUMBER = :IDCLASSDST
        into :IDTRDST, :RES_COPY_FORMULSDST;
    end
    else
    begin
      execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIERDST, 1/*ObgectType*/)
        returning_values :IDCLASSDST;
      select ID_TR, RES_COPY_FORMULS
        from A_O_OBJECTPARAMS
        where NUMBER = :IDCLASSDST
        into :IDTRDST, :RES_COPY_FORMULSDST;
    end
  end
  else
    exit;

      
  --     -
  for select L.ID, T.N2
    from LEVEL_COST L
    left join S_TEMP T
      on T.IDGEN=:IDSESSIONTMP
      and T.ID=L.ID
      and T.N1=:IDCLASSSRC
    where L.IDOBJECT = :IDCLASSDST
    into :IDLEVELDST, :IDLEVELSRC
  do

  if (:IDLEVELSRC is not null) then
  --    

        for select /*ID, IDCENLVL,*/ C.IDZONE, I.IDINDEX,
            I.ID_LEVEL_INDEX, C.ID_LEVEL_VC,
            C.BA, C.BB, C.BC, C.BD, C.BE, C.BF, C.BG, C.BH, C.BI, C.BJ, C.BN, C.BO, C.B_ITOGO,
            C.B_PR, --[15352]
            C.CA, C.CB, C.CC, C.CD, C.CE, C.CF, C.CG, C.CH, C.CI, C.CJ, C.C_ITOGO,
            C.C_PR, --[15352]
            C.EA, C.EB, C.EC, C.ED, C.EE, C.EF, C.EG, C.EH, C.EI, C.EJ, C.EK, C.EN, C.EO, C.E_ITOGO,
            C.E_PR, --[15352]
            C.RA, C.RB, C.RC, C.RD, C.RE, C.RF, C.RG, C.RH, C.RI, C.RJ, C.RK, C.RL, C.RM, C.ITOGO,
            C.R_PR, C.RC_16, C.RE_16, --[15352]
            --PA, PB, PC, PD,
            I.PUNKTIND,
            I.MA, I.MB, I.MC, I.MD, I.ME, I.MF, I.MG, I.MH, I.MI,
            I.INDEX_SPOSOBRASCH, C.CALCBMASK, C.BASE_INFO, I.INDEX_INFO,
            I.MJ, I.MK, I.ML, I.MM,
            I.M_PR, --[15352]
            I.DA, I.DB, I.DC, I.DD, I.DE, I.DJ, I.DK, I.DL, I.DM, --CQ[10529]
            C.CURR_CENA, C.BASE_CALC_INFO, C.SOURCE_LEVEL_ID, -- MK 20.06.2012 CQ[10565]
            C.CURR_CENA_INFO, C.ID_VALUTE, C.VALUTE_CURS,     -- MK CQ[11989]
            C.VALUTE_DATE, C.TRANSP, C.ZAG_SKL,               -- MK CQ[11989]
            C.ZAPCHAST, C.TARA, C.NACEN, C.COMPLECT,          -- MK CQ[11989]
            C.KOEFF_TYPE                                      -- MK      8.9
          from A_SMETA_CENLVL C
          join A_SMETA_INDLVL I on I.ID = C.ID and I.IDCENLVL = C.IDCENLVL --CQ[10529]
          where C.ID = :IDSMRECSRC
            and C.IDCENLVL = :IDLEVELSRC
          into /*:ID, :IDCENLVL,*/ :IDZONE, :IDINDEX,
            :ID_LEVEL_INDEX, :ID_LEVEL_VC,
            :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO,
            :B_PR, --[15352]
            :CA, :CB, :CC, :CD, :CE, :CF, :CG, :CH, :CI, :CJ, :C_ITOGO,
            :C_PR, --[15352]
            :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK, :EN, :EO, :E_ITOGO,
            :E_PR, --[15352]
            :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :ITOGO,
            :R_PR, :RC_16, :RE_16, --[15352]
            --:PA, :PB, :PC, :PD,
            :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
            :INDEX_SPOSOBRASCH, :CALCBMASK, :BASE_INFO, :INDEX_INFO,
            :MJ, :MK, :ML, :MM,
            :M_PR, --[15352]
            :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM, --CQ[10529]
            :VN_CURR_CENA, :VN_BASE_CALC_INFO, :VN_SOURCE_LEVEL_ID, -- MK 20.06.2012 CQ[10565]
            :VN_CURR_CENA_INFO, :VN_ID_VALUTE, :VN_VALUTE_CURS,     -- MK CQ[11989]
            :VN_VALUTE_DATE, :VN_TRANSP, :VN_ZAG_SKL,               -- MK CQ[11989]
            :VN_ZAPCHAST, :VN_TARA, :VN_NACEN, :VN_COMPLECT,        -- MK CQ[11989]
            :VN_KOEFF_TYPE                                          -- MK      8.9
       do
       begin
         -- MK 20.06.2012 CQ[10565] --->
         --    ,   
         --    -
         if (:VN_SOURCE_LEVEL_ID > 0) then
         begin

           select /*first 1 T.ID*/ min(T.ID)--[10584] ,  , ..      
           from S_TEMP T
           where (T.IDGEN = :IDSESSIONTMP)
             and (T.N2 = :VN_SOURCE_LEVEL_ID)
             and (T.N1 = :IDCLASSSRC)
           into :VN_SOURCE_LEVEL_ID;
         end
         -- MK 20.06.2012 CQ[10565] <---

         --[10333]      :ID_LEVEL_INDEX
         select min(T.N2) --(null,   )
           from S_TEMP T
           where T.IDGEN=:IDSESSIONTMP
             and T.ID=:IDLEVELDST
             and T.N1=:ID_LEVEL_INDEX
           into :ID_LEVEL_INDEX;

         --[10333]      :ID_LEVEL_VC
         select min(T.N2) --(null,   )
           from S_TEMP T
           where T.IDGEN=:IDSESSIONTMP
             and T.ID=:IDLEVELDST
             and T.N1=:ID_LEVEL_VC
           into :ID_LEVEL_VC;

         -- ..    -       
         execute procedure A_S_GET_FORMUL_NRSPZU_NL_1(
             :IDUSER, :ATYPEDST, :SLAVEPARENTDST, :IDTRDST, :VRPZDST, :RES_COPY_FORMULSDST, :IDLEVELDST)
           returning_values (:PA, :PB, :PC, :PD);

         update A_SMETA_CENLVL
         set IDZONE = :IDZONE,
             --CQ[10529]IDINDEX = :IDINDEX,
             --CQ[10529]ID_LEVEL_INDEX = :ID_LEVEL_INDEX,
             ID_LEVEL_VC = :ID_LEVEL_VC,
             BA = :BA,
             BB = :BB,
             BC = :BC,
             BD = :BD,
             BE = :BE,
             BF = :BF,
             BG = :BG,
             BH = :BH,
             BI = :BI,
             BJ = :BJ,
             BN = :BN,
             BO = :BO,
             B_ITOGO = :B_ITOGO,
             B_PR = :B_PR, --[15352]
             CA = :CA,
             CB = :CB,
             CC = :CC,
             CD = :CD,
             CE = :CE,
             CF = :CF,
             CG = :CG,
             CH = :CH,
             CI = :CI,
             CJ = :CJ,
             C_ITOGO = :C_ITOGO,
             C_PR = :C_PR, --[15352]
             EA = :EA,
             EB = :EB,
             EC = :EC,
             ED = :ED,
             EE = :EE,
             EF = :EF,
             EG = :EG,
             EH = :EH,
             EI = :EI,
             EJ = :EJ,
             EK = :EK,
             EN = :EN,
             EO = :EO,
             E_ITOGO = :E_ITOGO,
             E_PR = :E_PR, --[15352]
             RA = :RA,
             RB = :RB,
             RC = :RC,
             RD = :RD,
             RE = :RE,
             RF = :RF,
             RG = :RG,
             RH = :RH,
             RI = :RI,
             RJ = :RJ,
             RK = :RK,
             RL = :RL,
             RM = :RM,
             ITOGO = :ITOGO,
             R_PR = :R_PR, --[15352]
             RC_16 = :RC_16, --[15352]
             RE_16 = :RE_16, --[15352]
             PA = :PA,
             PB = :PB,
             PC = :PC,
             PD = :PD,
             CALCBMASK = :CALCBMASK,
             BASE_INFO = :BASE_INFO,

             -- MK 20.06.2012 CQ[10565] --->
             CURR_CENA = :VN_CURR_CENA,
             BASE_CALC_INFO = :VN_BASE_CALC_INFO,
             SOURCE_LEVEL_ID = :VN_SOURCE_LEVEL_ID,
             -- MK 20.06.2012 CQ[10565] <---

             -- MK CQ[11989] --->
             CURR_CENA_INFO = :VN_CURR_CENA_INFO,
             ID_VALUTE = :VN_ID_VALUTE,
             VALUTE_CURS = :VN_VALUTE_CURS,
             VALUTE_DATE = :VN_VALUTE_DATE,
             TRANSP = :VN_TRANSP,
             ZAG_SKL = :VN_ZAG_SKL,
             ZAPCHAST = :VN_ZAPCHAST,
             TARA = :VN_TARA,
             NACEN = :VN_NACEN,
             COMPLECT = :VN_COMPLECT,
             -- MK      8.9
             KOEFF_TYPE = :VN_KOEFF_TYPE
             -- MK CQ[11989] <---


             /*--CQ[10529]PUNKTIND = :PUNKTIND,
             MA = :MA,
             MB = :MB,
             MC = :MC,
             MD = :MD,
             ME = :ME,
             MF = :MF,
             MG = :MG,
             MH = :MH,
             MI = :MI,
             INDEX_SPOSOBRASCH = :INDEX_SPOSOBRASCH,
             INDEX_INFO = :INDEX_INFO */
         where (ID = :IDSMRECDST/*ID*/) and
               (IDCENLVL = :IDLEVELDST/*IDCENLVL*/);

         update A_SMETA_INDLVL
         set
            IDINDEX = :IDINDEX,
            ID_LEVEL_INDEX = :ID_LEVEL_INDEX,
            PUNKTIND = :PUNKTIND,
            MA = :MA,
            MB = :MB,
            MC = :MC,
            MD = :MD,
            ME = :ME,
            MF = :MF,
            MG = :MG,
            MH = :MH,
            MI = :MI,
            --CQ[10529]-->
            MJ = :MJ,
            MK = :MK,
            ML = :ML,
            MM = :MM,
            M_PR = :M_PR, --[15352]
            DA = :DA,
            DB = :DB,
            DC = :DC,
            DD = :DD,
            DE = :DE,
            DJ = :DJ,
            DK = :DK,
            DL = :DL,
            DM = :DM,
            --CQ[10529]<--
            INDEX_SPOSOBRASCH = :INDEX_SPOSOBRASCH,
            INDEX_INFO = :INDEX_INFO
         where (ID = :IDSMRECDST) and
               (IDCENLVL = :IDLEVELDST);

         execute procedure A_SMETA_INDLVL_DESC_CLONE (:IDSMRECSRC, :IDSMRECDST, :IDLEVELSRC, :IDLEVELDST);--CQ[10529]
         --      
         -- ...  ,   


         --   -  ,   
/*
         for select ID, ID_SOURCE, NORM_ID, NORM_PODGROUP, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP,
             RABMAT, TAB, ALTTAB, NAME_ID, IDEDIZM, EDIZM_TYPE, RASHOD, BB, BC, BD, BE,
             VIDNR, UCH, NORM_GUID, TYPE_TRUD
           from M_ETALON_S_RES M
           where M.ID_SOURCE =
           into :ID, :ID_SOURCE, :NORM_ID, :NORM_PODGROUP, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP,
             :RABMAT, :TAB, :ALTTAB, :NAME_ID, :IDEDIZM, :EDIZM_TYPE, :RASHOD, :BB, :BC, :BD, :BE,
             :VIDNR, :UCH, :NORM_GUID, :TYPE_TRUD
*/

         IDRESDST = 0;
         --   
         --   A_S_PASTE_SMETA_RECORD      ID
         for select R.ID
           from M_ETALON_S_RES R
           where R.ID_SOURCE=:IDSMRECSRC
           order by R.ID_SOURCE, R.ID
           into :IDRESSRC
         do
         for select first 1 R.ID
           from M_ETALON_S_RES R
           where R.ID_SOURCE=:IDSMRECDST
             and R.ID > :IDRESDST
           order by R.ID_SOURCE, R.ID
           into :IDRESDST
         do
         for select IDZONE, ID_LEVEL_VC, BB, BC, BD, BE, BASE_INFO
           from A_S_ETALON_RES_CENLVL L
           where L.ID=:IDRESSRC
             and L.IDCENLVL=:IDLEVELSRC
           into :IDZONE, :ID_LEVEL_VC, :BB, :BC, :BD, :BE, :BASE_INFO
         do
         begin
           --[10333]      :ID_LEVEL_VC
           select min(T.N2) --(null,   )
             from S_TEMP T
             where T.IDGEN=:IDSESSIONTMP
               and T.ID=:IDLEVELDST
               and T.N1=:ID_LEVEL_VC
             into :ID_LEVEL_VC;

           update A_S_ETALON_RES_CENLVL
           set IDZONE = :IDZONE,
               ID_LEVEL_VC = :ID_LEVEL_VC,
               BB = :BB,
               BC = :BC,
               BD = :BD,
               BE = :BE,
               BASE_INFO = :BASE_INFO
           where (ID = :IDRESDST) and
                 (IDCENLVL = :IDLEVELDST);
         end

         IDRESDST = 0;
         --   
         --   A_S_PASTE_SMETA_RECORD      ID
         for select R.ID
           from A_S_RES R
           where R.ID_SOURCE=:IDSMRECSRC
             and not exists( select * from A_SMETA s where s.ID_S_RES = r.ID )
           order by R.ID_SOURCE, R.ID
           into :IDRESSRC
         do
         for select first 1 R.ID
           from A_S_RES R
           where R.ID_SOURCE=:IDSMRECDST
             and not exists( select * from A_SMETA s where s.ID_S_RES = r.ID )
             and R.ID > :IDRESDST
           order by R.ID_SOURCE, R.ID
           into :IDRESDST
         do
         for select IDZONE, ID_LEVEL_VC, BB, BC, BD, BE, BASE_INFO
           from A_S_RES_CENLVL L
           where L.ID=:IDRESSRC
             and L.IDCENLVL=:IDLEVELSRC
           into :IDZONE, :ID_LEVEL_VC, :BB, :BC, :BD, :BE, :BASE_INFO
         do
         begin
           --[10333]      :ID_LEVEL_VC
           select min(T.N2) --(null,   )
             from S_TEMP T
             where T.IDGEN=:IDSESSIONTMP
               and T.ID=:IDLEVELDST
               and T.N1=:ID_LEVEL_VC
             into :ID_LEVEL_VC;

           update A_S_RES_CENLVL
           set IDZONE = :IDZONE,
               ID_LEVEL_VC = :ID_LEVEL_VC,
               BB = :BB,
               BC = :BC,
               BD = :BD,
               BE = :BE,
               BASE_INFO = :BASE_INFO
           where (ID = :IDRESDST) and
                 (IDCENLVL = :IDLEVELDST);
         end

       end
  else
  --     - "", ...
  begin

    --  ,   LEVEL_COMPOSE-
    --execute procedure A_S_PARAMS_TO_SMETA_NL_ONE(:IDUSER, :IDSMRECDST, :IDLEVELDST)
    --    returning_values :RECORDS_MODIFIED;
    execute procedure DM_ADD_LEVEL_IN_SMETA_ONE(:IDUSER, :IDSMRECDST, :IDLEVELDST);
    --

    --      
    -- ...  ,   
    --if (:RECORDS_MODIFIED > 0) then
    --  update LEVEL_COST
    --    set NEEDCALC = 1
    --    where (ID = :IDLEVELDST)
    --      and (IDOBJECT = :IDCLASSDST)
    --      and coalesce(NEEDCALC, 0) <> 1;
            
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE L_IMP_ENSURE_HIER_LIMITIR (
    IDHIER INTEGER,
    SMETATYPE INTEGER)
AS
declare IDUSER integer;
declare A_LZ_TYPE integer;
declare NUMBER integer;
declare RENUM integer;
declare ID integer;
declare VID integer;
declare variable vn_PrecIt integer;
declare HTYPE integer;
--<<[12250]
declare ITOGS_PODR_ADDED integer;
begin
  --    A_ADD_LZ ()  A_LZ_APPEND ()
  --  ,   

  ITOGS_PODR_ADDED = 0; --<<[12250]

  -- MK 3.12.2010 CQ[8173] --->
  --        ()
  execute procedure A_GET_ID_OBJ_AKT(:IDHIER, :SMETATYPE)
  returning_values :NUMBER, :HTYPE;

  if (:HTYPE = 1) then
    select coalesce(p.PRECIT, -1)
      from A_O_OBJECTPARAMS p
      where NUMBER = :NUMBER
      into :vn_PrecIt;
  else
  if (:HTYPE = 8) then
    select coalesce(p.PRECIT, -1)
      from A_O_FACTPARAMS p
      where NUMBER = :NUMBER
      into :vn_PrecIt;

  if (vn_PrecIt > 5) then
    vn_PrecIt = -1;
  -- MK 3.12.2010 CQ[8173] <---

  for select N.ATYPE
    from A_LZ_NAMES N
    left join A_LZ L
    on L.IDHIER = :IDHIER and L.SMETATYPE = :SMETATYPE and L.ATYPE = N.ATYPE
    where N.IDGROUP = 200
      and N.ATYPE <> 212
      and L.ID is null
    --[9352]order by N.ATYPE desc
    order by --case when N.ATYPE between 225 and 229 then 216 - (N.ATYPE -225 +10) --<<[12250]
               --   when N.ATYPE=223 then 216 -1 else N.ATYPE end desc
             --      :
             case when N.ATYPE=223 then 216 -1 --  216
                  when N.ATYPE=229 then 216 -2 --  223,   216
                  when N.ATYPE between 225 and 228 then 216 -1 - (N.ATYPE -225) --<<[12250]
                  --  216   222,  225  222,
                  -- .. 225    216,
                  --  216  ...  -   
                  when N.ATYPE between 230 and 232 then 214 -1 --[15479]
                  --  217,   205,   214,215,217    214
                  else N.ATYPE end
             desc --    [12250]
    into :A_LZ_TYPE
  do
  begin

    -- 
    NUMBER = null;

    --[15479]
    if (:A_LZ_TYPE = 232) then --:
      select max(NUMBER) + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 205
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 231) then --:
      select max(NUMBER) + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 203
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 230) then --:
      select max(NUMBER) + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 217
        into :NUMBER;
    else

    --<[12250]>
    if (:A_LZ_TYPE = 229) then --:
      select max(NUMBER) + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 223
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 228) then --:
      select max(NUMBER) + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 227
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 227) then --:
      select max(NUMBER) + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 226
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 226) then --:
      select max(NUMBER) + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 225
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 225) then --:
      select max(NUMBER) + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 222
        into :NUMBER;
    else
    --</[12250]>
    if (:A_LZ_TYPE = 224) then --    
      select max(NUMBER) + 1 --    
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE not in (212,224)
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 222) then --:
      select NUMBER + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 202
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 217) then --:
      select max(NUMBER) + 1 -- 
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE in (205,214,215)
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 216) then --:
      select NUMBER + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 222
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 223) then --:
      select NUMBER + 1 --  
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE = 216
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 215) then --:
      select max(NUMBER) + 1 -- 
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE in (205,214)
        into :NUMBER;
    else
    if (:A_LZ_TYPE = 214) then --:
      select max(NUMBER) + 1 -- 
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and ATYPE in (205)
        into :NUMBER;


    if (:NUMBER is not null) then
    begin --     -    ,    

      -- (   1)
      ID = null;
      select ID
        from A_LZ
        where IDHIER = :IDHIER
          and SMETATYPE = :SMETATYPE
          and NUMBER = :NUMBER
        into :ID;
      if (:ID is not null) then
      begin
        execute procedure A_LZ_RENUM (:IDUSER, :ID, :IDHIER, :SMETATYPE, :NUMBER + 1)
          returning_values :RENUM;
        update A_LZ
          set NUMBER = :NUMBER + 1
          where ID = :ID;
      end

      -- ,   VID
      VID =
        case
          when exists(
            select *
              from A_LZ A
              where A.IDHIER=:IDHIER
                and A.SMETATYPE=:SMETATYPE
                and A.VID=:A_LZ_TYPE)
          then 0
          else :A_LZ_TYPE
        end;

      --
      insert into A_LZ( ID, IDHIER, SMETATYPE,
            NUMBER, IDNAME, ATYPE, VID, PRECIS )
        values( gen_id( A_G_SMETA, 1 ), :IDHIER, :SMETATYPE,
            :NUMBER, :A_LZ_TYPE, :A_LZ_TYPE, :VID, :vn_PrecIt );

      if (:SMETATYPE <> 16) then --<<     ,    ...
        --
        --<[12250]>
        if (:A_LZ_TYPE between 225 and 229) then
          ITOGS_PODR_ADDED = :ITOGS_PODR_ADDED + row_count;
        else
        --</[12250]>
        if (:A_LZ_TYPE=216) then --<< 
          execute procedure S_UPGRADE_OBORUD(:IDHIER,:SMETATYPE);
        else
        if (:A_LZ_TYPE=223) then --<<  
          execute procedure S_UPGRADE_OBORUD_ZAK(:IDHIER,:SMETATYPE);
        else
        if (:A_LZ_TYPE=224) then --<<     
          execute procedure S_UPGRADE_LZ_ITOGO(:IDHIER, :SMETATYPE);
        else
        if (:A_LZ_TYPE in (214,215,217)) then --<< , , 
          execute procedure S_UPGRADE_LZ_TIPRAB(:IDHIER, :SMETATYPE, :A_LZ_TYPE);
    end
  end

  if (:ITOGS_PODR_ADDED > 0) then
    execute procedure S_UPGRADE_OBORUD_PODR_MANY(:IDHIER,:SMETATYPE);
end
^

--[15195]
/* 
CREATE OR ALTER PROCEDURE L_S_APPENDREC_NL_2 (
*/
--[15195]
CREATE OR ALTER PROCEDURE L_SC_READ_ONE_HIER_NL (
    IN_SMETATYPE INTEGER,
    IN_IDHIER INTEGER,
    ID_USER INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    IDHIER INTEGER,
    NUMBER1 INTEGER,
    NUMBER2 INTEGER,
    ATYPE INTEGER,
    VRPZ INTEGER,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    RLM DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    RN DOUBLE PRECISION,
    RO DOUBLE PRECISION,
    RP DOUBLE PRECISION,
    R25 DOUBLE PRECISION,
    R26 DOUBLE PRECISION,
    R27 DOUBLE PRECISION,
    R28 DOUBLE PRECISION,
    R29 DOUBLE PRECISION,
    TIPRAB INTEGER,
    VIDRAB INTEGER,
    UTV INTEGER,
    CLCMODE INTEGER,
    RABMAT INTEGER,
    CB DOUBLE PRECISION,
    CURR_CENA DOUBLE PRECISION,
    TRANSP DOUBLE PRECISION,
    ZAG_SKL DOUBLE PRECISION,
    ZAPCHAST DOUBLE PRECISION,
    TARA DOUBLE PRECISION,
    NACEN DOUBLE PRECISION,
    COMPLECT DOUBLE PRECISION,
    KOEFF_TYPE INTEGER,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
declare variable key2 integer;
declare variable id_self integer;
declare variable id_obj integer;

DECLARE VARIABLE mode_kompns_st INTEGER;
DECLARE VARIABLE IS_Smetatype INTEGER;
DECLARE VARIABLE DopAndHightKoll INTEGER;
declare variable pr_added_rec integer;
declare variable PR_VSEGO DOUBLE PRECISION;
declare variable PR_VIPOLNENO DOUBLE PRECISION;
declare variable idobject integer;
DECLARE VARIABLE INCLUDEACTSMODE INTEGER;
-- MK 20.10.2010 CQ[8684] --->
declare variable smetatype integer;
declare variable IsIncludeRec integer;
-- MK 20.10.2010 CQ[8684] <---
declare variable VN_RABMAT integer;
declare variable VN_TYPE_TRUD integer;

declare variable NEW_ID integer;
declare variable H_SMETATYPE integer;

begin
--[15352]+
--[15479]
   if ( in_smetatype <> 16 ) then
   begin
      for select s.id, s.idhier, s.number1, s.number2, s.atype, s.vrpz,
                 l.ra, l.rb, l.rc, l.rd, l.re, l.rf, l.rg, l.rh, l.ri, l.rj, l.rk, l.rl, l.RM,
                 l.itogo,
                 s.tiprab , s.vidrab, s.utv, s.rabmat, s.type_trud,
                 s.CLCMODE, --CQ[TIMUR 9266]
                 -- MK CQ[15102, 15103] --->
                 l.cb, l.curr_cena, l.transp, l.zag_skl, l.zapchast, l.tara,
                 l.nacen, l.complect, l.koeff_type,
                 -- MK CQ[15102, 15103] <---
                 l.R_PR, l.RC_16, l.RE_16 --[15479]
          from a_smeta s
          left join A_SMETA_CENLVL L on L.ID = s.ID and L.IDCENLVL = :IDCENLVL
          where s.idhier = :in_idhier and s.smetatype = :in_smetatype
          order by s.number1, s.number2, s.number3 -- MK 1.02.2013 CQ[8962]
          into :id, :idhier, :number1, :number2, :atype, :vrpz,
               :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :RM,
               :ITOGO,
               :tiprab, :vidrab, :utv, :VN_RABMAT, :VN_TYPE_TRUD,
               :CLCMODE, --CQ[TIMUR 9266]
               -- MK CQ[15102, 15103] --->
               :CB, :CURR_CENA, :TRANSP, :ZAG_SKL, :ZAPCHAST, :TARA,
               :NACEN, :COMPLECT, :KOEFF_TYPE,
               -- MK CQ[15102, 15103] <---
               :R_PR, :RC_16, :RE_16 --[15479]
      do
      begin
        RABMAT = VN_RABMAT; -- MK CQ[15102, 15103]

        -- MK CQ[8295] --->
        --       
        --  ,   
        RLM = 0;
        if ((VN_RABMAT = 3) and (VN_TYPE_TRUD = 1)) then
          RLM = RL;
        -- MK CQ[8295] <---

        -- MK CQ[9374] --->
        RN = 0;
        RO = 0;
        RP = 0;

        -- 
        if (tiprab = 1) then
          RN = ITOGO - coalesce(R_PR, 0.0)/*[15479.X]*/;
        -- 
        else if (tiprab = 2) then
          RO = ITOGO - coalesce(R_PR, 0.0)/*[15479.X]*/;
        -- 
        else if (tiprab = 4) then
          RP = ITOGO - coalesce(R_PR, 0.0)/*[15479.X]*/;
        -- MK CQ[9374] <---

        --[15479.X]ITOGO = coalesce(ITOGO, 0.0) + coalesce(R_PR, 0.0); --[15479]

         --<<[12250] . S_UPGRADE_OBORUD_PODR_MANY
         R29 = case when coalesce(:VN_RABMAT, 0) <> 3 then null
                    when :VN_TYPE_TRUD <> 0           then null else :RL  end;
         R28 = case when coalesce(:VN_RABMAT, 0) <> 3 then coalesce(:RB,0) - coalesce(:RM,0)
                    when :VN_TYPE_TRUD <> 0           then null
                    when coalesce(:RL, 0) = 0         then :RB  else null end;
         R27 = case when coalesce(:VN_RABMAT, 0) <> 3 then :RM
                    when :VN_TYPE_TRUD <> 0
                     and coalesce(:RL, 0) = 0         then :RM  else null end;
         R26 = case when coalesce(:VN_RABMAT, 0) <> 3 then :RB
                    when coalesce(:RL, 0) = 0         then :RB  else null end;
         R25 = case when coalesce(:VN_RABMAT, 0) <> 3 then coalesce(:RB,0) - coalesce(:RM,0)
                    when :VN_TYPE_TRUD <> 0           then null else :RB  end;

        suspend;
      end
   end
   else
   begin
     -- MK 22.09.2009 CQ[7653] --->
     execute procedure S_O_HIER_PARENT_OFTYPE (:IN_IDHIER, 1)
     returning_values :idobject;

     SELECT p.MODE_KOMPNS_ST
     FROM a_s_get_params_obj(:ID_USER, :idobject) p
     INTO :MODE_KOMPNS_ST;

     --     
     DopAndHightKoll = 0;
     IF ((getbit(:MODE_KOMPNS_ST, 5) = 0) AND (getbit(:MODE_KOMPNS_ST, 6) = 1)) THEN
       DopAndHightKoll = 1;

     IS_Smetatype = 15; --    . 
     IF ((getbit(:MODE_KOMPNS_ST, 5) = 1) AND (getbit(:MODE_KOMPNS_ST, 6) = 0)) THEN
       IS_Smetatype = 0; --   . 
     -- MK 22.09.2009 CQ[7653] <---

     -- MK:   L_S_CREATE_IS (     )
     --Voyager CQ[8457]
     INCLUDEACTSMODE = 0;
     if ( getbit(:MODE_KOMPNS_ST,7) > 0 ) THEN
        INCLUDEACTSMODE = 1;
     if ( getbit(:MODE_KOMPNS_ST,8) > 0 ) THEN
        INCLUDEACTSMODE = 2;
     -- <-- CQ[8457]

      key2 = GEN_ID ( LG_S_TMP_TBL_KEY2 , 1 );
      execute procedure a_h_get_id_parentatype( :in_idhier, 1 ) returning_values ( :id_obj );


                         ------------- CQ[TIMUR 10737] -----------
      /*    ,        
         . L_S_CREATE_IS.    .
      */
                         ------------- CQ[TIMUR 10737] -----------

      /*      :   = 15 */
      /*      :   = 0 */

      IsIncludeRec = 0;

      for select id_self, id, idhier, number1, number2
          from L_PR_CREATE_KC6_BASE ( :in_idhier, :key2, :IS_Smetatype /*15*/, 0, 0,
                                      :id_user, 0, 1 )
          into id_self, id, idhier, number1, number2
      do
      if ( not id_self is null ) then  /* smetn. str. */

         /*     ,  ,  .   
                        */
         for select s.id, s.atype, s.vrpz, s.tiprab , s.vidrab, s.utv,
                    s.smetatype, s.rabmat, s.type_trud
             from a_smeta s
             where s.id = :id
             into :id, :atype, :vrpz, :tiprab, :vidrab, :utv,
                  :smetatype, :VN_RABMAT, :VN_TYPE_TRUD
         do
         begin
           IsIncludeRec = 0;

           /*      */
           /*    id     ->      */
           new_id = id;

           for select number
               from A_O_HIER_SELECT_PR1_WITH_FILTER (:id_user, :idobject, 0, 0, 0, 0, :includeactsmode)
               into :h_smetatype
           do
           begin
              for select s.id, s.atype, s.vrpz, s.tiprab , s.vidrab, s.utv,
                         s.smetatype, s.rabmat, s.type_trud
                  from a_smeta s
                  where (s.nomerrod1 = :id) and (s.smetatype = :h_smetatype)
                  into :new_id, :atype, :vrpz, :tiprab, :vidrab, :utv,
                       :smetatype, :VN_RABMAT, :VN_TYPE_TRUD
                  do
                  begin
                    if (smetatype = h_smetatype) then
                      IsIncludeRec = 1;
                  end
           end

           -- MK CQ[15102, 15103] --->
           --      
           RABMAT = VN_RABMAT;
           CB = 0;
           CURR_CENA = 0;
           TRANSP = 0;
           ZAG_SKL = 0;
           ZAPCHAST = 0;
           TARA = 0;
           NACEN = 0;
           COMPLECT = 0;
           KOEFF_TYPE = 0;
           -- MK CQ[15102, 15103] <---

           --     
           if (smetatype = 15) then
              IsIncludeRec = 1;
  
           id = new_id;

           if (IsIncludeRec = 1) then
           begin
  
             -- MK 22.09.2009 CQ[7653] --->
             execute procedure M_CHECK_BEFORE_LZ_REC_CALC(:ID_USER, :id, :IDOBJECT)
             returning_values (pr_added_rec, PR_VSEGO, PR_VIPOLNENO);
  
             -- MK 20.10.2010 CQ[8684] --->
             --   ,   PR_VIPOLNENO   
             --    (, , ...)
             --   coalesce(sum(       V_PR_SELECT_REC_VERSIONS_ITOGI
  
             -- MK:   L_S_CREATE_IS (     )
             -- Voyager CQ[8457]
             --from L_PR_SELECT_REC_VERSIONS_ITOGI(:id, :id_user, :id_obj, 0, 0, 0, 1)
             SELECT FIRST 1 KOLL, RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM, ITOGO,
                          R_PR, RC_16, RE_16 --[15479]
             FROM V_PR_SELECT_REC_VERSIONS_IT_NL (:id, :id_user, :id_obj, 0, 0, 0, 1, :INCLUDEACTSMODE, :IDCENLVL)
             -- <-- CQ[8457]
             into :PR_VIPOLNENO, :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :ITOGO,
                  :R_PR, :RC_16, :RE_16; --[15479]
             -- MK 20.10.2010 CQ[8684] <---
  
             --  :     
             if ((DopAndHightKoll = 0) or
                 ((PR_ADDED_REC = 1) or                               -- . 
                  (LRoundN(:PR_VIPOLNENO, 6) > LRoundN(:PR_VSEGO, 6)) --  
                 )
                )  then
             begin
             -- MK 22.09.2009 CQ[7653] <---
   
   
                -- MK CQ[8295] --->
                --       
                --  ,   
                RLM = 0;
                if ((VN_RABMAT = 3) and (VN_TYPE_TRUD = 1)) then
                  RLM = RL;
                -- MK CQ[8295] <---
   
                -- MK CQ[9374] --->
                RN = 0;
                RO = 0;
                RP = 0;
        
                -- 
                if (tiprab = 1) then
                  RN = ITOGO - coalesce(R_PR, 0.0)/*[15479.X]*/;
                -- 
                else if (tiprab = 2) then
                  RO = ITOGO - coalesce(R_PR, 0.0)/*[15479.X]*/;
                -- 
                else if (tiprab = 4) then
                  RP = ITOGO - coalesce(R_PR, 0.0)/*[15479.X]*/;
                -- MK CQ[9374] <---

                --[15479.X]ITOGO = coalesce(ITOGO, 0.0) + coalesce(R_PR, 0.0); --[15479]
   
               --<<[12250] . S_UPGRADE_OBORUD_PODR_MANY
               R29 = case when coalesce(:VN_RABMAT, 0) <> 3 then null
                          when :VN_TYPE_TRUD <> 0           then null else :RL  end;
               R28 = case when coalesce(:VN_RABMAT, 0) <> 3 then coalesce(:RB,0) - coalesce(:RM,0)
                          when :VN_TYPE_TRUD <> 0           then null
                          when coalesce(:RL, 0) = 0         then :RB  else null end;
               R27 = case when coalesce(:VN_RABMAT, 0) <> 3 then :RM
                          when :VN_TYPE_TRUD <> 0
                           and coalesce(:RL, 0) = 0         then :RM  else null end;
               R26 = case when coalesce(:VN_RABMAT, 0) <> 3 then :RB
                          when coalesce(:RL, 0) = 0         then :RB  else null end;
               R25 = case when coalesce(:VN_RABMAT, 0) <> 3 then coalesce(:RB,0) - coalesce(:RM,0)
                          when :VN_TYPE_TRUD <> 0           then null else :RB  end;
      
                suspend;
   
             end -- MK 22.09.2009 CQ[7653]
           end -- MK 20.10.2010 CQ[8684]
         end
      execute procedure l_pr_create_kc6_base_finalize ( :key2 );
   end
end
^

--[15195]
CREATE OR ALTER PROCEDURE LEVEL_INDEX_ITOG_IMPORT (
    ID_COMPOSE INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    NMA VARCHAR(255),
    NMB VARCHAR(255),
    NMC VARCHAR(255),
    NMD VARCHAR(255),
    NME VARCHAR(255),
    NMJ VARCHAR(255),
    NMK VARCHAR(255),
    NML VARCHAR(255),
    NMM VARCHAR(255),
    NMN VARCHAR(255),
    NDA VARCHAR(255),
    NDB VARCHAR(255),
    NDJ VARCHAR(255),
    NDK VARCHAR(255),
    NDL VARCHAR(255),
    NDM VARCHAR(255),
    NOTE VARCHAR(255),
    SPOSOBRASCH INTEGER)
AS
begin
--[15352]+
--[15354]
  insert into LEVEL_INDEX_ITOG (ID_COMPOSE,
    MA, MB, MC, MD, ME, MJ, MK, ML, MM, MN/*15354*/,
    DA, DB, DJ, DK, DL,
    DM, NMA, NMB, NMC, NMD, NME, NMJ, NMK, NML, NMM, NMN/*15354*/,
    NDA, NDB, NDJ, NDK, NDL, NDM,
    NOTE, SPOSOBRASCH)
  values (:ID_COMPOSE,
    :MA, :MB, :MC, :MD, :ME, :MJ, :MK, :ML, :MM, :MN/*15354*/,
    :DA, :DB, :DJ, :DK, :DL, :DM,
    :NMA, :NMB, :NMC, :NMD, :NME, :NMJ, :NMK, :NML, :NMM, :NMN/*15354*/,
    :NDA, :NDB, :NDJ, :NDK, :NDL, :NDM,
    :NOTE, :SPOSOBRASCH);
end
^

--[15195]
CREATE OR ALTER PROCEDURE LEVEL_INDEX_ITOG_IMPORT_XML (
    ID_COMPOSE INTEGER,
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    NMA VARCHAR(255),
    NMB VARCHAR(255),
    NMC VARCHAR(255),
    NMD VARCHAR(255),
    NME VARCHAR(255),
    NMJ VARCHAR(255),
    NMK VARCHAR(255),
    NML VARCHAR(255),
    NMM VARCHAR(255),
    NMN VARCHAR(255),
    NDA VARCHAR(255),
    NDB VARCHAR(255),
    NDJ VARCHAR(255),
    NDK VARCHAR(255),
    NDL VARCHAR(255),
    NDM VARCHAR(255),
    NOTE VARCHAR(255),
    SPOSOBRASCH INTEGER,
    COMPOSE_NAME VARCHAR(250),
    COMPOSE_LORDER INTEGER)
AS
begin
--[15352]+
--[15354]
  --       -------------------------
  update LEVEL_COMPOSE
  set NAME = :COMPOSE_NAME,
      LORDER = :COMPOSE_LORDER
  where (ID = :ID_COMPOSE);

  --   ----------------------------------------------------------
  execute procedure LEVEL_INDEX_ITOG_IMPORT(:ID_COMPOSE,
                           :MA, :MB, :MC, :MD, :ME, :MJ, :MK, :ML, :MM, :MN/*15354*/,
                           :DA, :DB, :DJ, :DK, :DL, :DM,
                           :NMA, :NMB, :NMC, :NMD, :NME, :NMJ, :NMK, :NML, :NMM, :NMN/*15354*/,
                           :NDA, :NDB, :NDJ, :NDK, :NDL, :NDM,
                           :NOTE, :SPOSOBRASCH);
end
^

--[15195]
CREATE OR ALTER PROCEDURE M_COPY_LEVEL_COMPOSES (
    ID_LEVEL_SRC INTEGER,
    ID_LEVEL_DST INTEGER,
    IDCLASS_SRC INTEGER,
    IDCLASS_DST INTEGER)
AS
declare variable vn_id_old integer;
declare variable vn_id_new integer;
declare variable vn_lorder integer;
declare variable vn_atype integer;
declare variable vn_name varchar(250);

declare variable vn_id_org integer;
declare variable vn_id_year integer;
declare variable vn_id_month integer;
declare variable vn_nasnach_auto integer;
declare variable vn_zamen_nasnach integer;
declare variable vn_res_copy_index integer;
declare variable vn_sposob_rasch integer;

declare variable vn_id_zone integer;
declare variable vn_save_cen_to_nb integer;
declare variable vn_apply_on_res integer;

declare variable vn_ma double precision;
declare variable vn_mb double precision;
declare variable vn_mc double precision;
declare variable vn_md double precision;
declare variable vn_me double precision;

declare variable vn_mj double precision;
declare variable vn_mk double precision;
declare variable vn_ml double precision;
declare variable vn_mm double precision;
declare variable vn_mn double precision; /*15354*/

declare variable vn_da double precision;
declare variable vn_db double precision;

declare variable vn_dj double precision;
declare variable vn_dk double precision;

declare variable vn_dl double precision;
declare variable vn_dm double precision;

declare variable vn_note varchar(255);

declare variable vn_nma varchar(255);
declare variable vn_nmb varchar(255);
declare variable vn_nmc varchar(255);
declare variable vn_nmd varchar(255);
declare variable vn_nme varchar(255);

declare variable vn_nmj varchar(255);
declare variable vn_nmk varchar(255);
declare variable vn_nml varchar(255);
declare variable vn_nmm varchar(255);
declare variable vn_nmn varchar(255); /*15354*/

declare variable vn_nda varchar(255);
declare variable vn_ndb varchar(255);

declare variable vn_ndj varchar(255);
declare variable vn_ndk varchar(255);

declare variable vn_ndl varchar(255);
declare variable vn_ndm varchar(255);

begin
--[15352]
--[15354]
  --       
  for select l.id, l.lorder, l.atype, l.name
  from level_compose l
  where (l.id_level = :ID_LEVEL_SRC) and (l.IDCLASS = :IDCLASS_SRC)
  into :vn_id_old, :vn_lorder, :vn_atype, :vn_name do
  begin
    --    
    vn_id_new = gen_id(a_g_smeta, 1);
    insert into level_compose (id, id_level, IDCLASS, lorder, atype, name)
    values (:vn_id_new, :ID_LEVEL_DST, :IDCLASS_DST, :vn_lorder, :vn_atype, :vn_name);

    --  - 
    if (:vn_atype = 1) then
    begin
      select first 1 li.id_org, li.id_year, li.id_month,
                     1, 1,--CQ[10554]li.nasnach_auto, li.zamen_nasnach,
                     li.res_copy_index, li.sposob_rasch,
                     li.ma, li.nma, li.mb, li.nmb, li.mj, li.nmj, li.mk, li.nmk,
                     li.da, li.nda, li.db, li.ndb, li.dj, li.ndj, li.dk, li.ndk,
                     li.note
      from level_index li
      where (li.id_compose = :vn_id_old)
      into :vn_id_org, :vn_id_year, :vn_id_month, :vn_nasnach_auto,
           :vn_zamen_nasnach, :vn_res_copy_index, :vn_sposob_rasch,
           :vn_ma, :vn_nma, :vn_mb, :vn_nmb, :vn_mj, :vn_nmj, :vn_mk, :vn_nmk,
           :vn_da, :vn_nda, :vn_db, :vn_ndb, :vn_dj, :vn_ndj, :vn_dk, :vn_ndk,
           :vn_note;

      insert into level_index (id_compose, id_org, id_year, id_month,
                               nasnach_auto, zamen_nasnach, res_copy_index,
                               sposob_rasch, note,
                               ma, nma, mb, nmb, mj, nmj, mk, nmk,
                               da, nda, db, ndb, dj, ndj, dk, ndk
                               )
      values (:vn_id_new, :vn_id_org, :vn_id_year, :vn_id_month,
              :vn_nasnach_auto, :vn_zamen_nasnach, :vn_res_copy_index,
              :vn_sposob_rasch, :vn_note,
              :vn_ma, :vn_nma, :vn_mb, :vn_nmb, :vn_mj, :vn_nmj, :vn_mk, :vn_nmk,
              :vn_da, :vn_nda, :vn_db, :vn_ndb, :vn_dj, :vn_ndj, :vn_dk, :vn_ndk
              );
    end

    --  -  
    else if (:vn_atype = 2) then
    begin
      select first 1 lv.id_zone, lv.save_cen_to_nb, lv.apply_on_res
      from level_vc lv
      where (lv.id_compose = :vn_id_old)
      into :vn_id_zone, :vn_save_cen_to_nb, :vn_apply_on_res;

      insert into level_vc (id_compose, id_zone, save_cen_to_nb, apply_on_res)
      values (:vn_id_new, :vn_id_zone, :vn_save_cen_to_nb, :vn_apply_on_res);
    end

    --  -   
    else if (:vn_atype = 3) then
    begin
      select first 1 ii.ma, ii.nma, ii.mb, ii.nmb, ii.mc, ii.nmc, ii.md, ii.nmd,
                     ii.me, ii.nme, ii.mj, ii.nmj, ii.mk, ii.nmk, ii.ml, ii.nml, ii.mm, ii.nmm,
                     ii.da, ii.nda, ii.db, ii.ndb, ii.dj, ii.ndj, ii.dk, ii.ndk,
                     ii.dl, ii.ndl, ii.dm, ii.ndm,
                     ii.note, ii.sposobrasch,
                     ii.mn, ii.nmn --[15354]
      from level_index_itog ii
      where (ii.id_compose = :vn_id_old)
      into :vn_ma, :vn_nma, :vn_mb, :vn_nmb, :vn_mc, :vn_nmc, :vn_md, :vn_nmd,
           :vn_me, :vn_nme, :vn_mj, :vn_nmj, :vn_mk, :vn_nmk, :vn_ml, :vn_nml, :vn_mm, :vn_nmm,
           :vn_da, :vn_nda, :vn_db, :vn_ndb, :vn_dj, :vn_ndj, :vn_dk, :vn_ndk,
           :vn_dl, :vn_ndl, :vn_dm,  :vn_ndm,
           :vn_note, :vn_sposob_rasch,
           :vn_mn, :vn_nmn; --[15354]

      insert into level_index_itog (id_compose, note,
        ma, nma, mb, nmb, mc, nmc, md, nmd, me, nme, mj, nmj, mk, nmk, ml, nml, mm, nmm,
        da, nda, db, ndb, dj, ndj, dk, ndk, dl, ndl, dm, ndm, sposobrasch,
        mn, nmn/*15354*/)
      values (:vn_id_new, :vn_note,
        :vn_ma, :vn_nma, :vn_mb, :vn_nmb, :vn_mc, :vn_nmc, :vn_md, :vn_nmd, :vn_me, :vn_nme,
        :vn_mj, :vn_nmj, :vn_mk, :vn_nmk, :vn_ml, :vn_nml, :vn_mm, :vn_nmm,
        :vn_da, :vn_nda, :vn_db, :vn_ndb, :vn_dj, :vn_ndj, :vn_dk, :vn_ndk,
        :vn_dl, :vn_ndl, :vn_dm, :vn_ndm, :vn_sposob_rasch,
        :vn_mn, :vn_nmn/*15354*/);
    end


    --    
    execute procedure M_COPY_LEVEL_RULES(:vn_id_old, :vn_id_new);
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE M_COPY_SMETA_CENLVL_ONE_REC (
    ID_SOURCE INTEGER,
    ID_TARGET INTEGER,
    ID_LEVEL_SOURCE INTEGER,
    ID_LEVEL_TARGET INTEGER)
AS
DECLARE VARIABLE VN_IDZONE INTEGER;
DECLARE VARIABLE VN_IDINDEX INTEGER;
DECLARE VARIABLE VN_ID_LEVEL_INDEX INTEGER;
DECLARE VARIABLE VN_ID_LEVEL_VC INTEGER;
DECLARE VARIABLE VN_BA DOUBLE PRECISION;
DECLARE VARIABLE VN_BB DOUBLE PRECISION;
DECLARE VARIABLE VN_BC DOUBLE PRECISION;
DECLARE VARIABLE VN_BD DOUBLE PRECISION;
DECLARE VARIABLE VN_BE DOUBLE PRECISION;
DECLARE VARIABLE VN_BF DOUBLE PRECISION;
DECLARE VARIABLE VN_BG DOUBLE PRECISION;
DECLARE VARIABLE VN_BH DOUBLE PRECISION;
DECLARE VARIABLE VN_BI DOUBLE PRECISION;
DECLARE VARIABLE VN_BJ DOUBLE PRECISION;
--CQ[TIMUR 13178]
DECLARE VARIABLE VN_BN DOUBLE PRECISION;
DECLARE VARIABLE VN_BO DOUBLE PRECISION;
DECLARE VARIABLE VN_B_ITOGO DOUBLE PRECISION;
--CQ[TIMUR 13178]
declare VN_B_PR double precision; --[15352]
DECLARE VARIABLE VN_CA DOUBLE PRECISION;
DECLARE VARIABLE VN_CB DOUBLE PRECISION;
DECLARE VARIABLE VN_CC DOUBLE PRECISION;
DECLARE VARIABLE VN_CD DOUBLE PRECISION;
DECLARE VARIABLE VN_CE DOUBLE PRECISION;
DECLARE VARIABLE VN_CF DOUBLE PRECISION;
DECLARE VARIABLE VN_CG DOUBLE PRECISION;
DECLARE VARIABLE VN_CH DOUBLE PRECISION;
DECLARE VARIABLE VN_CI DOUBLE PRECISION;
DECLARE VARIABLE VN_CJ DOUBLE PRECISION;
DECLARE VARIABLE VN_C_ITOGO DOUBLE PRECISION; --CQ[TIMUR 13178]
declare VN_C_PR double precision; --[15352]
DECLARE VARIABLE VN_EA DOUBLE PRECISION;
DECLARE VARIABLE VN_EB DOUBLE PRECISION;
DECLARE VARIABLE VN_EC DOUBLE PRECISION;
DECLARE VARIABLE VN_ED DOUBLE PRECISION;
DECLARE VARIABLE VN_EE DOUBLE PRECISION;
DECLARE VARIABLE VN_EF DOUBLE PRECISION;
DECLARE VARIABLE VN_EG DOUBLE PRECISION;
DECLARE VARIABLE VN_EH DOUBLE PRECISION;
DECLARE VARIABLE VN_EI DOUBLE PRECISION;
DECLARE VARIABLE VN_EJ DOUBLE PRECISION;
DECLARE VARIABLE VN_EK DOUBLE PRECISION;
--CQ[TIMUR 13178]
DECLARE VARIABLE VN_EN DOUBLE PRECISION;
DECLARE VARIABLE VN_EO DOUBLE PRECISION;
DECLARE VARIABLE VN_E_ITOGO DOUBLE PRECISION;
--CQ[TIMUR 13178]
declare VN_E_PR double precision; --[15352]
DECLARE VARIABLE VN_RA DOUBLE PRECISION;
DECLARE VARIABLE VN_RB DOUBLE PRECISION;
DECLARE VARIABLE VN_RC DOUBLE PRECISION;
DECLARE VARIABLE VN_RD DOUBLE PRECISION;
DECLARE VARIABLE VN_RE DOUBLE PRECISION;
DECLARE VARIABLE VN_RF DOUBLE PRECISION;
DECLARE VARIABLE VN_RG DOUBLE PRECISION;
DECLARE VARIABLE VN_RH DOUBLE PRECISION;
DECLARE VARIABLE VN_RI DOUBLE PRECISION;
DECLARE VARIABLE VN_RJ DOUBLE PRECISION;
DECLARE VARIABLE VN_RK DOUBLE PRECISION;
DECLARE VARIABLE VN_RL DOUBLE PRECISION;
DECLARE VARIABLE VN_RM DOUBLE PRECISION;
DECLARE VARIABLE VN_ITOGO DOUBLE PRECISION;
declare VN_R_PR double precision; --[15352]
declare VN_RC_16 double precision; --[15352]
declare VN_RE_16 double precision; --[15352]
DECLARE VARIABLE VN_PA DOUBLE PRECISION;
DECLARE VARIABLE VN_PB DOUBLE PRECISION;
DECLARE VARIABLE VN_PC DOUBLE PRECISION;
DECLARE VARIABLE VN_PD DOUBLE PRECISION;
DECLARE VARIABLE VN_PUNKTIND VARCHAR(42);
DECLARE VARIABLE VN_MA DOUBLE PRECISION;
DECLARE VARIABLE VN_MB DOUBLE PRECISION;
DECLARE VARIABLE VN_MC DOUBLE PRECISION;
DECLARE VARIABLE VN_MD DOUBLE PRECISION;
DECLARE VARIABLE VN_ME DOUBLE PRECISION;
DECLARE VARIABLE VN_MF DOUBLE PRECISION;
DECLARE VARIABLE VN_MG DOUBLE PRECISION;
DECLARE VARIABLE VN_MH DOUBLE PRECISION;
DECLARE VARIABLE VN_MI DOUBLE PRECISION;
DECLARE VARIABLE VN_INDEX_SPOSOBRASCH INTEGER;
DECLARE VARIABLE VN_CALCBMASK INTEGER;
DECLARE VARIABLE VN_BASE_INFO INTEGER;
DECLARE VARIABLE VN_INDEX_INFO INTEGER;

declare variable VN_MJ double precision;
declare variable VN_MK  double precision;
declare variable VN_ML double precision;
declare variable VN_MM double precision;
declare VN_M_PR double precision; --[15352]
declare variable VN_DA double precision;
declare variable VN_DB double precision;
declare variable VN_DC double precision;
declare variable VN_DD double precision;
declare variable VN_DE double precision;
declare variable VN_DJ double precision;
declare variable VN_DK  double precision;
declare variable VN_DL double precision;
declare variable VN_DM double precision;

declare variable VN_CURR_CENA double precision;
declare variable VN_BASE_CALC_INFO integer;
declare variable VN_SOURCE_LEVEL_ID integer;
declare variable VN_CALC_INFO integer;
declare variable VN_RABMAT integer;
-- MK CQ[11989]
declare variable VN_CURR_CENA_INFO integer;
declare variable VN_ID_VALUTE integer;
declare variable VN_VALUTE_CURS double precision;
declare variable VN_VALUTE_DATE date;
declare variable VN_TRANSP double precision;
declare variable VN_ZAG_SKL double precision;
declare variable VN_ZAPCHAST double precision;
declare variable VN_TARA double precision;
declare variable VN_NACEN double precision;
declare variable VN_COMPLECT double precision;
declare variable VN_KOEFF_TYPE integer;
begin
--[15352]
  for select C.IDZONE, I.IDINDEX, I.ID_LEVEL_INDEX, C.ID_LEVEL_VC,
         C.BA, C.BB, C.BC, C.BD, C.BE, C.BF, C.BG, C.BH, C.BI, C.BJ, C.BN, C.BO, C.B_ITOGO,
         C.B_PR, --[15352]
         C.CA, C.CB, C.CC, C.CD, C.CE, C.CF, C.CG, C.CH, C.CI, C.CJ, C.C_ITOGO,
         C.C_PR, --[15352]
         C.EA, C.EB, C.EC, C.ED, C.EE, C.EF, C.EG, C.EH, C.EI, C.EJ, C.EK, C.EN, C.EO, C.E_ITOGO,
         C.E_PR, --[15352]
         --C.RA, C.RB, C.RC, C.RD, C.RE, C.RF, C.RG, C.RH, C.RI, C.RJ, C.RK, C.RL, C.RM, C.ITOGO,
         C.PA, C.PB, C.PC, C.PD, I.PUNKTIND,
         I.MA, I.MB, I.MC, I.MD, I.ME, I.MF, I.MG, I.MH, I.MI,
         I.INDEX_SPOSOBRASCH, C.CALCBMASK, C.BASE_INFO, I.INDEX_INFO,
         I.MJ, I.MK, I.ML, I.MM,
         I.M_PR, --[15352]
         I.DA, I.DB, I.DC, I.DD, I.DE, I.DJ, I.DK, I.DL, I.DM, --CQ[10529]
         c.curr_cena, c.base_calc_info, c.source_level_id, -- MK 25.06.2012 CQ[10570]
         C.CURR_CENA_INFO, C.ID_VALUTE, C.VALUTE_CURS,     -- MK CQ[11989]
         C.VALUTE_DATE, C.TRANSP, C.ZAG_SKL,               -- MK CQ[11989]
         C.ZAPCHAST, C.TARA, C.NACEN, C.COMPLECT,          -- MK CQ[11989]
         C.KOEFF_TYPE                                      -- MK      8.9
  from A_SMETA_CENLVL C
  join A_SMETA_INDLVL I on I.ID = C.ID and I.IDCENLVL = C.IDCENLVL --CQ[10529]
  where (c.id = :ID_SOURCE) and (c.idcenlvl = :ID_LEVEL_SOURCE)
  into :VN_IDZONE, :VN_IDINDEX, :VN_ID_LEVEL_INDEX, :VN_ID_LEVEL_VC,
       :VN_BA, :VN_BB, :VN_BC, :VN_BD, :VN_BE, :VN_BF, :VN_BG, :VN_BH, :VN_BI, :VN_BJ, :VN_BN, :VN_BO, :VN_B_ITOGO,
       :VN_B_PR, --[15352]
       :VN_CA, :VN_CB, :VN_CC, :VN_CD, :VN_CE, :VN_CF, :VN_CG, :VN_CH, :VN_CI, :VN_CJ, :VN_C_ITOGO,
       :VN_C_PR, --[15352]
       :VN_EA, :VN_EB, :VN_EC, :VN_ED, :VN_EE, :VN_EF, :VN_EG, :VN_EH, :VN_EI, :VN_EJ, :VN_EK, :VN_EN, :VN_EO, :VN_E_ITOGO,
       :VN_E_PR, --[15352]
       --:VN_RA, :VN_RB, :VN_RC, :VN_RD, :VN_RE, :VN_RF, :VN_RG, :VN_RH, :VN_RI, :VN_RJ, :VN_RK, :VN_RL, :VN_RM, :VN_ITOGO,
       :VN_PA, :VN_PB, :VN_PC, :VN_PD, :VN_PUNKTIND,
       :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH, :VN_MI,
       :VN_INDEX_SPOSOBRASCH, :VN_CALCBMASK, :VN_BASE_INFO, :VN_INDEX_INFO,
       :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
       :VN_M_PR, --[15352]
       :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM, --CQ[10529]
       :vn_curr_cena, :vn_base_calc_info, :vn_source_level_id, -- MK 25.06.2012 CQ[10570]
       :VN_CURR_CENA_INFO, :VN_ID_VALUTE, :VN_VALUTE_CURS,     -- MK CQ[11989]
       :VN_VALUTE_DATE, :VN_TRANSP, :VN_ZAG_SKL,               -- MK CQ[11989]
       :VN_ZAPCHAST, :VN_TARA, :VN_NACEN, :VN_COMPLECT,        -- MK CQ[11989]
       :VN_KOEFF_TYPE                                          -- MK      8.9
  do
  begin
    --   (      )
    VN_RA = 0;
    VN_RB = 0;
    VN_RC = 0;
    VN_RD = 0;
    VN_RE = 0;
    VN_RF = 0;
    VN_RG = 0;
    VN_RH = 0;
    VN_RI = 0;
    VN_RJ = 0;
    VN_RK = 0;
    VN_RL = 0;
    VN_RM = 0;
    VN_ITOGO = 0;
    VN_R_PR = null; --[15352]
    VN_RC_16 = null; --[15352]
    VN_RE_16 = null; --[15352]

    -- MK 25.06.2012 CQ[10570] --->
    --        
    VN_CALC_INFO = bin_and(VN_BASE_CALC_INFO, 7/*cbCalcMask*/); -- 7 = 111

    --   
    select first 1 s.rabmat
    from a_smeta s
    where (s.id = :ID_SOURCE)
    into :VN_RABMAT;
    -- MK 25.06.2012 CQ[10570] <---

    --     ------------------------------------------------
    if (ID_LEVEL_SOURCE = ID_LEVEL_TARGET) then
    begin
      -- MK 25.06.2012 CQ[10570] --->
      if (VN_RABMAT = 3) then -- (. IsCalcBaseKind [7FE7AD1744B6])   
      begin
        --       
        -- CQ[13416] if (VN_CALC_INFO = 1/*cbCalc*/) then
        -- CQ[13416] begin
          -- CQ[13416] vn_source_level_id = -1;
          --  VN_BASE_CALC_INFO   ( )
        -- CQ[13416] end
        --       
        -- (,    ,  ,  )
        -- CQ[13416] else
        -- CQ[13416] begin
          -- CQ[13416] vn_source_level_id = -1;
  
          --     3,4 (      )
          -- MK CQ[13174] --->
          --    0,1,2    
          -- CQ[13416] VN_BASE_CALC_INFO = bin_and(VN_BASE_CALC_INFO,  bin_xor(7, -1)); -- bin_xor(7, -1) = 11111...11000
          --VN_BASE_CALC_INFO = bin_and(VN_BASE_CALC_INFO, 24); -- 24 = 11000
          -- MK CQ[13174] <---
          -- CQ[13416] VN_BASE_CALC_INFO = bin_or(VN_BASE_CALC_INFO, 4/*cbDirect*/);   -- 4 -   
        -- CQ[13416] end

        -- CQ[13416]  -->    (. ),  
        --             
        --        
        if (VN_CALC_INFO = 2) then -- cbFilled
        begin
          vn_source_level_id = -1;
          --     3,4 (      )
          VN_BASE_CALC_INFO = bin_and(VN_BASE_CALC_INFO,  bin_xor(7, -1)); -- bin_xor(7, -1) = 11111...11000
          VN_BASE_CALC_INFO = bin_or(VN_BASE_CALC_INFO, 4/*cbDirect*/);   -- 4 -   
        end
        else
        begin
          --  VN_BASE_CALC_INFO   ( )
          vn_source_level_id = -1;
        end
        -- CQ[13416]  <--


      end
      -- MK 25.06.2012 CQ[10570] <---
    end

    --     -------------------------------------------------
    else
    begin
      -- MK 21.02.2012 CQ[10095] --->
      --     1
      VN_MA = 1;
      VN_MB = 1;
      VN_MC = 1;
      VN_MD = 1;
      VN_ME = 1;
      VN_MF = 0; -- %
      VN_MG = 0; -- %
      VN_MH = 1; --   .
      VN_MI = 1; --   .

      VN_IDINDEX = 0;
      VN_ID_LEVEL_INDEX = 0;
      VN_INDEX_INFO = null;
      -- MK 21.02.2012 CQ[10095] <---

      --CQ[10529]-->
      VN_MJ = 1;
      VN_MK = 1;
      VN_ML = 1;
      VN_MM = 1;
      VN_M_PR = null;
      VN_DA = 1;
      VN_DB = 1;
      VN_DC = 1;
      VN_DD = 1;
      VN_DE = 1;
      VN_DJ = 1;
      VN_DK = 1;
      VN_DL = 1;
      VN_DM = 1;
      --CQ[10529]<--

      -- MK 25.06.2012 CQ[10570] --->
      if (VN_RABMAT = 3) then -- (. IsCalcBaseKind [7FE7AD1744B6])   
        if (VN_CALC_INFO = 1) then -- cbCalc -- CQ[13416]        
        begin
          --[12184]VN_CURR_CENA = 0;
          vn_source_level_id = ID_LEVEL_SOURCE;
    
          --     3,4 (      )
          -- MK CQ[13174] --->
          --    0,1,2    
          VN_BASE_CALC_INFO = bin_and(VN_BASE_CALC_INFO,  bin_xor(7, -1)); -- bin_xor(7, -1) = 11111...11000
          --VN_BASE_CALC_INFO = bin_and(VN_BASE_CALC_INFO, 24); -- 24 = 11000
          -- MK CQ[13174] <---
          VN_BASE_CALC_INFO = bin_or(VN_BASE_CALC_INFO, 2/*cbFilled*/);   -- 2 -      
        end
      -- MK 25.06.2012 CQ[10570] <---
    end

    if (exists(select * from A_SMETA_CENLVL where (id = :ID_TARGET) and (idcenlvl = :ID_LEVEL_TARGET))) then
    begin
      update A_SMETA_CENLVL
      set IDZONE = :VN_IDZONE,
          --CQ[10529]IDINDEX = :VN_IDINDEX,
          --CQ[10529]ID_LEVEL_INDEX = :VN_ID_LEVEL_INDEX,
          ID_LEVEL_VC = :VN_ID_LEVEL_VC,
          BA = :VN_BA,
          BB = :VN_BB,
          BC = :VN_BC,
          BD = :VN_BD,
          BE = :VN_BE,
          BF = :VN_BF,
          BG = :VN_BG,
          BH = :VN_BH,
          BI = :VN_BI,
          BJ = :VN_BJ,
          BN = :VN_BN,
          BO = :VN_BO,
          B_ITOGO = :VN_B_ITOGO,
          B_PR = :VN_B_PR, --[15352]
          CA = :VN_CA,
          CB = :VN_CB,
          CC = :VN_CC,
          CD = :VN_CD,
          CE = :VN_CE,
          CF = :VN_CF,
          CG = :VN_CG,
          CH = :VN_CH,
          CI = :VN_CI,
          CJ = :VN_CJ,
          C_ITOGO = :VN_C_ITOGO,
          C_PR = :VN_C_PR, --[15352]
          EA = :VN_EA,
          EB = :VN_EB,
          EC = :VN_EC,
          ED = :VN_ED,
          EE = :VN_EE,
          EF = :VN_EF,
          EG = :VN_EG,
          EH = :VN_EH,
          EI = :VN_EI,
          EJ = :VN_EJ,
          EK = :VN_EK,
          EN = :VN_EN,
          EO = :VN_EO,
          E_ITOGO = :VN_E_ITOGO,
          E_PR = :VN_E_PR, --[15352]
          RA = :VN_RA,
          RB = :VN_RB,
          RC = :VN_RC,
          RD = :VN_RD,
          RE = :VN_RE,
          RF = :VN_RF,
          RG = :VN_RG,
          RH = :VN_RH,
          RI = :VN_RI,
          RJ = :VN_RJ,
          RK = :VN_RK,
          RL = :VN_RL,
          RM = :VN_RM,
          ITOGO = :VN_ITOGO,
          R_PR = :VN_R_PR, --[15352]
          RC_16 = :VN_RC_16, --[15352]
          RE_16 = :VN_RE_16, --[15352]
          PA = :VN_PA,
          PB = :VN_PB,
          PC = :VN_PC,
          PD = :VN_PD,
          CALCBMASK = :VN_CALCBMASK,
          BASE_INFO = :VN_BASE_INFO,
          -- MK 25.06.2012 CQ[10570] --->
          CURR_CENA = :VN_CURR_CENA,
          BASE_CALC_INFO = :VN_BASE_CALC_INFO,
          SOURCE_LEVEL_ID = :VN_SOURCE_LEVEL_ID,
          -- MK 25.06.2012 CQ[10570] <---

          -- MK CQ[11989] --->
          CURR_CENA_INFO = :VN_CURR_CENA_INFO,
          ID_VALUTE = :VN_ID_VALUTE,
          VALUTE_CURS = :VN_VALUTE_CURS,
          VALUTE_DATE = :VN_VALUTE_DATE,
          TRANSP = :VN_TRANSP,
          ZAG_SKL = :VN_ZAG_SKL,
          ZAPCHAST = :VN_ZAPCHAST,
          TARA = :VN_TARA,
          NACEN = :VN_NACEN,
          COMPLECT = :VN_COMPLECT,
          -- MK      8.9
          KOEFF_TYPE = :VN_KOEFF_TYPE
          -- MK CQ[11989] <---


          /*--CQ[10529]PUNKTIND = :VN_PUNKTIND,
          MA = :VN_MA,
          MB = :VN_MB,
          MC = :VN_MC,
          MD = :VN_MD,
          ME = :VN_ME,
          MF = :VN_MF,
          MG = :VN_MG,
          MH = :VN_MH,
          MI = :VN_MI,
          INDEX_SPOSOBRASCH = :VN_INDEX_SPOSOBRASCH,
          INDEX_INFO = :VN_INDEX_INFO */
      where (ID = :ID_TARGET) and (IDCENLVL = :ID_LEVEL_TARGET);
    end

    else
    begin
      insert into A_SMETA_CENLVL (ID, IDCENLVL, IDZONE, --CQ[10529]IDINDEX, ID_LEVEL_INDEX,
                                  ID_LEVEL_VC,
                                  BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BN, BO, B_ITOGO,
                                  B_PR, --[15352]
                                  CA, CB, CC, CD, CE, CF, CG, CH, CI, CJ, C_ITOGO,
                                  C_PR, --[15352]
                                  EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK, EN, EO, E_ITOGO,
                                  E_PR, --[15352]
                                  RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM, ITOGO,
                                  R_PR, RC_16, RE_16, --[15352]
                                  PA, PB, PC, PD, --CQ[10529]PUNKTIND,
                                  --CQ[10529]MA, MB, MC, MD, ME, MF, MG, MH, MI,
                                  --CQ[10529]INDEX_SPOSOBRASCH,
                                  CALCBMASK, BASE_INFO,
                                  CURR_CENA, BASE_CALC_INFO, SOURCE_LEVEL_ID, --[10584.]
                                  --CQ[10529]INDEX_INFO
                                  CURR_CENA_INFO, ID_VALUTE, VALUTE_CURS, -- MK CQ[11989]
                                  VALUTE_DATE, TRANSP, ZAG_SKL,           -- MK CQ[11989]
                                  ZAPCHAST, TARA, NACEN, COMPLECT,        -- MK CQ[11989]
                                  KOEFF_TYPE                              -- MK      8.9
                                  )
      values (:ID_TARGET, :ID_LEVEL_TARGET, :VN_IDZONE, --CQ[10529]:VN_IDINDEX, :VN_ID_LEVEL_INDEX,
              :VN_ID_LEVEL_VC,
              :VN_BA, :VN_BB, :VN_BC, :VN_BD, :VN_BE, :VN_BF, :VN_BG, :VN_BH, :VN_BI, :VN_BJ, :VN_BN, :VN_BO, :VN_B_ITOGO,
              :VN_B_PR, --[15352]
              :VN_CA, :VN_CB, :VN_CC, :VN_CD, :VN_CE, :VN_CF, :VN_CG, :VN_CH, :VN_CI, :VN_CJ, :VN_C_ITOGO,
              :VN_C_PR, --[15352]
              :VN_EA, :VN_EB, :VN_EC, :VN_ED, :VN_EE, :VN_EF, :VN_EG, :VN_EH, :VN_EI, :VN_EJ, :VN_EK, :VN_EN, :VN_EO, :VN_E_ITOGO,
              :VN_E_PR, --[15352]
              :VN_RA, :VN_RB, :VN_RC, :VN_RD, :VN_RE, :VN_RF, :VN_RG, :VN_RH, :VN_RI, :VN_RJ, :VN_RK, :VN_RL, :VN_RM, :VN_ITOGO,
              :VN_R_PR, :VN_RC_16, :VN_RE_16, --[15352]
              :VN_PA, :VN_PB, :VN_PC, :VN_PD, --CQ[10529]:VN_PUNKTIND,
              --CQ[10529]:VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH, :VN_MI,
              --CQ[10529]:VN_INDEX_SPOSOBRASCH,
              :VN_CALCBMASK, :VN_BASE_INFO,
              :VN_CURR_CENA, :VN_BASE_CALC_INFO, :VN_SOURCE_LEVEL_ID,
              --CQ[10529]:VN_INDEX_INFO
              :VN_CURR_CENA_INFO, :VN_ID_VALUTE, :VN_VALUTE_CURS, -- MK CQ[11989]
              :VN_VALUTE_DATE, :VN_TRANSP, :VN_ZAG_SKL,           -- MK CQ[11989]
              :VN_ZAPCHAST, :VN_TARA, :VN_NACEN, :VN_COMPLECT,    -- MK CQ[11989]
              :VN_KOEFF_TYPE                                      -- MK      8.9
              );
    end

    --CQ[10529]-->
    if (exists(select * from A_SMETA_INDLVL where (id = :ID_TARGET) and (idcenlvl = :ID_LEVEL_TARGET))) then
    begin
      update A_SMETA_INDLVL
      set
          IDINDEX = :VN_IDINDEX,
          ID_LEVEL_INDEX = :VN_ID_LEVEL_INDEX,
          PUNKTIND = :VN_PUNKTIND,
          MA = :VN_MA,
          MB = :VN_MB,
          MC = :VN_MC,
          MD = :VN_MD,
          ME = :VN_ME,
          MF = :VN_MF,
          MG = :VN_MG,
          MH = :VN_MH,
          MI = :VN_MI,
          MJ = :VN_MJ,
          MK = :VN_MK,
          ML = :VN_ML,
          MM = :VN_MM,
          M_PR = :VN_M_PR, --[15352]
          DA = :VN_DA,
          DB = :VN_DB,
          DC = :VN_DC,
          DD = :VN_DD,
          DE = :VN_DE,
          DJ = :VN_DJ,
          DK = :VN_DK,
          DL = :VN_DL,
          DM = :VN_DM,
          INDEX_SPOSOBRASCH = :VN_INDEX_SPOSOBRASCH,
          INDEX_INFO = :VN_INDEX_INFO
      where (ID = :ID_TARGET) and (IDCENLVL = :ID_LEVEL_TARGET);
    end

    else
    begin
      insert into A_SMETA_INDLVL (ID, IDCENLVL, IDINDEX, ID_LEVEL_INDEX,
                                  PUNKTIND,
                                  MA, MB, MC, MD, ME, MF, MG, MH, MI,
                                  INDEX_SPOSOBRASCH, INDEX_INFO,
                                  MJ, MK, ML, MM,
                                  M_PR, --[15352]
                                  DA, DB, DC, DD, DE, DJ, DK, DL, DM
                                  )
      values (:ID_TARGET, :ID_LEVEL_TARGET, :VN_IDINDEX, :VN_ID_LEVEL_INDEX,
              :VN_PUNKTIND,
              :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH, :VN_MI,
              :VN_INDEX_SPOSOBRASCH, :VN_INDEX_INFO,
              :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
              :VN_M_PR, --[15352]
              :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM
              );
    end

    execute procedure A_SMETA_INDLVL_DESC_CLONE (:ID_SOURCE, :ID_TARGET, :ID_LEVEL_SOURCE, :ID_LEVEL_TARGET);--CQ[10529]

    --CQ[10529]<--

  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE M_CREATE_BASE_CENLVL_ONSMETA (
    ID INTEGER,
    IDCENLVL INTEGER,
    ID_LEVEL_INDEX INTEGER,
    ID_LEVEL_VC INTEGER)
AS
--KODIR_GROUP integer,
--KODIR_PODGROUP integer,
--ISCLC integer,
--MODE_KOMPNS_ST integer,
--IDZONE integer,
--IDINDEX integer,
--INDEX_RASCHNRISP integer,
--INDEX_BRAT_ZU_IS integer,
--INDEX_SPOSOBRASCH integer,
declare variable VN_ATYPE integer;
declare variable VN_ID_S_RES integer;
--declare variable VN_BA double precision;
--declare variable VN_BB double precision;
--declare variable VN_BC double precision;
--declare variable VN_BD double precision;
--declare variable VN_BE double precision;
--declare variable VN_BF double precision;
--declare variable VN_BG double precision;
--declare variable VN_BH double precision;
--declare variable VN_BI double precision;
--declare variable VN_BJ double precision;
--declare variable VN_CA double precision;
--declare variable VN_CB double precision;
--declare variable VN_CC double precision;
--declare variable VN_CD double precision;
--declare variable VN_CE double precision;
--declare variable VN_CF double precision;
--declare variable VN_CG double precision;
--declare variable VN_CH double precision;
--declare variable VN_CI double precision;
--declare variable VN_CJ double precision;
--declare variable VN_EA double precision;
--declare variable VN_EB double precision;
--declare variable VN_EC double precision;
--declare variable VN_ED double precision;
--declare variable VN_EE double precision;
--declare variable VN_EF double precision;
--declare variable VN_EG double precision;
--declare variable VN_EH double precision;
--declare variable VN_EI double precision;
--declare variable VN_EJ double precision;
--declare variable VN_EK double precision;
--declare variable VN_RA double precision;
--declare variable VN_RB double precision;
--declare variable VN_RC double precision;
--declare variable VN_RD double precision;
--declare variable VN_RE double precision;
--declare variable VN_RF double precision;
--declare variable VN_RG double precision;
--declare variable VN_RH double precision;
--declare variable VN_RI double precision;
--declare variable VN_RJ double precision;
--declare variable VN_RK double precision;
--declare variable VN_RL double precision;
--declare variable VN_RM double precision;
--declare variable VN_PA double precision;
--declare variable VN_PB double precision;
--declare variable VN_PC double precision;
--declare variable VN_PD double precision;
--declare variable VN_PUNKTIND varchar(42);
--declare variable VN_MA double precision;
--declare variable VN_MB double precision;
--declare variable VN_MC double precision;
--declare variable VN_MD double precision;
--declare variable VN_ME double precision;
--declare variable VN_MF double precision;
--declare variable VN_MG double precision;
--declare variable VN_MH double precision;
--declare variable VN_MI double precision;
--declare variable VN_MJ double precision;
--declare variable VN_MK double precision;
--declare variable VN_ML double precision;
--declare variable VN_MM double precision;

--declare variable VN_CALK_BA integer;
--declare variable VN_CALK_BB integer;
--declare variable VN_CALK_BC integer;
--declare variable VN_CALK_BD integer;
--declare variable VN_CALK_BE integer;
--declare variable VN_CALK_BG integer;
--declare variable VN_CALK_BG_READONLY integer;
--declare variable VN_CALK_BH integer;
--declare variable VN_CALK_BH_READONLY integer;
--declare variable VN_CALCBMASK integer;

--declare variable VN_dTmp1 double precision;
--declare variable VN_dTmp2 double precision;

declare variable VN_RES_ID integer;
--declare variable VN_RES_BB double precision;
--declare variable VN_RES_BC double precision;
--declare variable VN_RES_BD double precision;
--declare variable VN_RES_BE double precision;

--declare variable VN_SRL blob sub_type 0 segment size 80;
--declare variable VN_SRM blob sub_type 0 segment size 80;

declare IDHIER integer;
declare SMETATYPE integer;
declare IDOBJECT integer;
declare IDCENLVL_CURR integer;
declare NOMERROD integer;
declare RES_NOMERROD integer;
begin
--[15352]
  -- [10611.3]    M_CREATE_CURR_CENLVL
  --    ()       
  --   M_CREATE_CURR_CENLVL ,     
  --   (.  ),      

  --    ,       ,
  --     .        ...
  -- [10611.3c] ... -   
  --       .    

  select atype, id_s_res,
      IDHIER, SMETATYPE, NOMERROD
    from A_SMETA
    where ID = :ID
    into :VN_ATYPE, :VN_ID_S_RES,
        :IDHIER, SMETATYPE, NOMERROD;
  execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1/*:IDTYPE*/)
      returning_values :IDOBJECT;

  if (:VN_ATYPE in (17/*SmRec*/, 18/*ResRec*/)) then
    IDCENLVL_CURR = :IDOBJECT;
  else
    exit; -- .  -  

  --   ============================================================
  --       ()
  /*
  select first 1 l.ba, l.bb, l.bc, l.bd, l.be, l.bf, l.bg, l.bh, l.bi, l.bj,
                 0,0,0,0,0,0,0,0,0,0,
                   --l.ca, l.cb, l.cc, l.cd, l.ce, l.cf, l.cg, l.ch, l.ci, l.cj,
                 0,0,0,0,0,0,0,0,0,0,0,
                   --l.ea, l.eb, l.ec, l.ed, l.ee, l.ef, l.eg, l.eh, l.ei, l.ej, l.ek,
                 0,0,0,0,0,0,0,0,0,0,0,0,0,
                   --s.ra, s.rb, s.rc, s.rd, s.re, s.rf, s.rg, s.rh, s.ri, s.rj, s.rk, s.rl, s.rm,
                 l.pa, l.pb, l.pc, l.pd,
                 m.punktind,
                 m.ma, m.mb, m.mc, m.md, m.me, m.mf, m.mg, m.mh, m.mi,
                 m.MJ, m.MK, m.ML, m.MM --,
                 --s.srl, s.srm
    from a_smeta s
    left join A_SMETA_CENLVL l on l.ID = s.ID and l.IDCENLVL = :IDCENLVL
    left join A_SMETA_INDLVL m on m.ID = s.ID and l.IDCENLVL = :IDCENLVL
    where (s.id = :NOMERROD)
    into :VN_BA, :VN_BB, :VN_BC, :VN_BD, :VN_BE, :VN_BF, :VN_BG, :VN_BH, :VN_BI, :VN_BJ,
         :VN_CA, :VN_CB, :VN_CC, :VN_CD, :VN_CE, :VN_CF, :VN_CG, :VN_CH, :VN_CI, :VN_CJ,
         :VN_EA, :VN_EB, :VN_EC, :VN_ED, :VN_EE, :VN_EF, :VN_EG, :VN_EH, :VN_EI, :VN_EJ, :VN_EK,
         :VN_RA, :VN_RB, :VN_RC, :VN_RD, :VN_RE, :VN_RF, :VN_RG, :VN_RH, :VN_RI, :VN_RJ, :VN_RK, :VN_RL, :VN_RM,
         :VN_PA, :VN_PB, :VN_PC, :VN_PD,
         :VN_PUNKTIND,
         :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH, :VN_MI,
         :VN_MJ, :VN_MK, :VN_ML, :VN_MM; --,
         --:VN_SRL, :VN_SRM;
  */

  /* [10611.3]  , ..      
  --    , , 
  if (INDEX_RASCHNRISP = 2) then --      (MF|MG <-> PA|PB)
  begin
    VN_dTmp1 = VN_PA;
    VN_dTmp2 = VN_PB;

    VN_PA = VN_MF;
    VN_PB = VN_MG;

    VN_MF = VN_dTmp1;
    VN_MG = VN_dTmp2;
  end
  if (INDEX_BRAT_ZU_IS = 1) then --     (MH|MI <-> PC|PD)
  begin
    VN_dTmp1 = VN_PC;
    VN_dTmp2 = VN_PD;

    VN_PC = VN_MH;
    VN_PD = VN_MI;

    VN_MH = VN_dTmp1;
    VN_MI = VN_dTmp2;
  end
  */

  --VN_CALCBMASK = 0;
  --VN_CF = VN_BF;
  --VN_CI = VN_BI;
  --VN_CJ = null;

  /*
  -- [10611.3]    ,
  --    ..      
  --    (   ,       )
  --     c  
  select BA, BB, BC, BD, BE, BG, BH,
         CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, CALK_BG,
         CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY
  from M_TMP_A_CLC_PREPARE_B_E_M(:ID, :VN_ATYPE, :VN_ID_S_RES, :KODIR_GROUP,
                           :KODIR_PODGROUP, :ISCLC, :MODE_KOMPNS_ST,
                           :VN_BA, :VN_BB, :VN_BC, :VN_BD, :VN_BE, :VN_BG, :VN_BH, null)
  into :VN_CA, :VN_CB, :VN_CC, :VN_CD, :VN_CE, :VN_CG, :VN_CH,
       :VN_CALK_BA, :VN_CALK_BB, :VN_CALK_BC, :VN_CALK_BD, :VN_CALK_BE, :VN_CALK_BG,
       :VN_CALK_BG_READONLY, :VN_CALK_BH, :VN_CALK_BH_READONLY;


  --     
  -- (c) [8CAB39CCB815]
  VN_CALCBMASK = setbit(VN_CALCBMASK, 0, VN_CALK_BA);
  VN_CALCBMASK = setbit(VN_CALCBMASK, 1, VN_CALK_BB);
  VN_CALCBMASK = setbit(VN_CALCBMASK, 2, VN_CALK_BC);
  VN_CALCBMASK = setbit(VN_CALCBMASK, 3, VN_CALK_BD);
  VN_CALCBMASK = setbit(VN_CALCBMASK, 4, VN_CALK_BE);
  VN_CALCBMASK = setbit(VN_CALCBMASK, 6, VN_CALK_BG);
  VN_CALCBMASK = setbit(VN_CALCBMASK, 7, VN_CALK_BH);

  VN_CALCBMASK = setbit(VN_CALCBMASK, 22, VN_CALK_BG_READONLY);
  VN_CALCBMASK = setbit(VN_CALCBMASK, 23, VN_CALK_BH_READONLY);
  */

  --      
  -- (c) [3BD605ED0089]
  insert into A_SMETA_CENLVL (ID, IDCENLVL, IDZONE,
                              BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
                              B_PR, --[15352]
                              CA, CB, CC, CD, CE, CF, CG, CH, CI, CJ,
                              EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                              RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                              PA, PB, PC, PD,
                              CALCBMASK, ID_LEVEL_VC, BASE_INFO,
                              CURR_CENA, BASE_CALC_INFO, SOURCE_LEVEL_ID,
                              -- MK CQ[11989] --->
                              CURR_CENA_INFO, ID_VALUTE, VALUTE_CURS,
                              VALUTE_DATE, TRANSP, ZAG_SKL,
                              ZAPCHAST, TARA, NACEN, COMPLECT, KOEFF_TYPE
                              -- MK CQ[11989] <---
                              )
    select :ID, :IDCENLVL, l.IDZONE, --:IDZONE,
           l.ba, l.bb, l.bc, l.bd, l.be, l.bf, l.bg, l.bh, l.bi, l.bj,
           l.B_PR, --[15352]
           0,0,0,0,0,l.bf,0,0,l.bi,null,
           0,0,0,0,0,0,0,0,0,0,0,
           0,0,0,0,0,0,0,0,0,0,0,0,0,
           l.pa, l.pb, l.pc, l.pd,
           l.CALCBMASK, :ID_LEVEL_VC, l.BASE_INFO,
           l.CURR_CENA,
           --  :  ,  ,  - 
           case bin_and(coalesce(l.BASE_CALC_INFO, 0), 7/*cbCalcMask*/)
             when 1/*cbCalc*/ then
               l.BASE_CALC_INFO
             else
               --     3,4 (      )
               bin_and(coalesce(l.BASE_CALC_INFO, 0), 24)-- 24 = 11000
           end,
           -1,/*l.SOURCE_LEVEL_ID*/
           -- MK CQ[11989] --->
           CURR_CENA_INFO, ID_VALUTE, VALUTE_CURS,
           VALUTE_DATE, TRANSP, ZAG_SKL,
           ZAPCHAST, TARA, NACEN, COMPLECT, KOEFF_TYPE
           -- MK CQ[11989] <---

      from A_SMETA_CENLVL l
      where l.ID = :NOMERROD
        and l.IDCENLVL = :IDCENLVL;
    --values (:ID, :IDCENLVL, :IDZONE, --CQ[10529]:IDINDEX,
    --        :VN_BA, :VN_BB, :VN_BC, :VN_BD, :VN_BE, :VN_BF, :VN_BG, :VN_BH, :VN_BI, :VN_BJ,
    --        :VN_CA, :VN_CB, :VN_CC, :VN_CD, :VN_CE, :VN_CF, :VN_CG, :VN_CH, :VN_CI, :VN_CJ,
    --        :VN_EA, :VN_EB, :VN_EC, :VN_ED, :VN_EE, :VN_EF, :VN_EG, :VN_EH, :VN_EI, :VN_EJ, :VN_EK,
    --        :VN_RA, :VN_RB, :VN_RC, :VN_RD, :VN_RE, :VN_RF, :VN_RG, :VN_RH, :VN_RI, :VN_RJ, :VN_RK, :VN_RL, :VN_RM,
    --        :VN_PA, :VN_PB, :VN_PC, :VN_PD,
    --        --CQ[10529]:VN_PUNKTIND, :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH, :VN_MI,
    --        :VN_CALCBMASK,
    --        --CQ[10529]:ID_LEVEL_INDEX,
    --        :ID_LEVEL_VC
    --        --CQ[10529]:INDEX_SPOSOBRASCH
    --        );
    --CQ[10529]>>

  if (row_count = 0) then
  begin
    insert into A_SMETA_CENLVL (ID, IDCENLVL, IDZONE,
                                BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
                                B_PR, --[15352]
                                CA, CB, CC, CD, CE, CF, CG, CH, CI, CJ,
                                EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                                RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                                PA, PB, PC, PD,
                                CALCBMASK, ID_LEVEL_VC, BASE_INFO,
                                CURR_CENA, BASE_CALC_INFO, SOURCE_LEVEL_ID,
                                -- MK CQ[11989] --->
                                CURR_CENA_INFO, ID_VALUTE, VALUTE_CURS,
                                VALUTE_DATE, TRANSP, ZAG_SKL,
                                ZAPCHAST, TARA, NACEN, COMPLECT, KOEFF_TYPE
                                -- MK CQ[11989] <---
                                )
    select :ID, :IDCENLVL, l.IDZONE, --:IDZONE,
           l.ba, l.bb, l.bc, l.bd, l.be, l.bf, l.bg, l.bh, l.bi, l.bj,
           l.B_PR, --[15352]
           0,0,0,0,0,l.bf,0,0,l.bi,null,
           0,0,0,0,0,0,0,0,0,0,0,
           0,0,0,0,0,0,0,0,0,0,0,0,0,
           l.pa, l.pb, l.pc, l.pd,
           l.CALCBMASK, :ID_LEVEL_VC, l.BASE_INFO,
           0/*l.CURR_CENA*/,
           24, -- 24 = 11000,   (      )
           0,/*l.SOURCE_LEVEL_ID*/ --   
           -- MK CQ[11989] --->
           null, 1, null,
           null, 0, 0,
           0, TARA, 0, 0, 0
           -- MK CQ[11989] <---
      from A_SMETA_CENLVL l
      where l.ID = :ID
        and l.IDCENLVL = :IDCENLVL_CURR;

    -- [2012/11/02] -   ,    ;
    if (row_count > 0) then
    -- :[402BB0CA]
    --      
    insert into A_SMETA_INDLVL (ID, IDCENLVL, INDEX_SPOSOBRASCH, --CQ[10529] -- INDEX_SPOSOBRASCH - default =  
                                MA, MB, MC, MD, ME, MH, MI, MJ, MK, ML, MM,
                                DA, DB, DC, DD, DE, DJ, DK, DL, DM)
    values (:ID, :IDCENLVL, 2,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1);

  end
  else
    --        
    insert into A_SMETA_INDLVL (ID, IDCENLVL, IDINDEX,
                              PUNKTIND,
                              MA, MB, MC, MD, ME, MF, MG, MH, MI,
                              MJ, MK, ML, MM,
                              M_PR, --[15352]
                              DA, DB, DC, DD, DE, DJ, DK, DL, DM, 
                              ID_LEVEL_INDEX, INDEX_SPOSOBRASCH, INDEX_INFO )
    select :ID, :IDCENLVL, m.IDINDEX, --:IDINDEX,
           m.punktind,
           m.ma, m.mb, m.mc, m.md, m.me, m.mf, m.mg, m.mh, m.mi,
           m.MJ, m.MK, m.ML, m.MM,
           m.M_PR, --[15352]
           m.DA, m.DB, m.DC, m.DD, m.DE, m.DJ, m.DK, m.DL, m.DM, 
           :ID_LEVEL_INDEX, m.INDEX_SPOSOBRASCH, m.INDEX_INFO
      from A_SMETA_INDLVL m
      where m.ID = :NOMERROD
        and m.IDCENLVL = :IDCENLVL;
    --values (:ID, :IDCENLVL, :IDINDEX,
    --        :VN_PUNKTIND, :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH, :VN_MI,
    --        :ID_LEVEL_INDEX, :INDEX_SPOSOBRASCH
    --        );

  if (row_count > 0) then
  /*
  if (row_count = 0) then
    insert into A_SMETA_INDLVL (ID, IDCENLVL, IDINDEX,
                              PUNKTIND,
                              MA, MB, MC, MD, ME, MF, MG, MH, MI,
                              MJ, MK, ML, MM,
                              DA, DB, DC, DD, DE, DJ, DK, DL, DM, 
                              ID_LEVEL_INDEX, INDEX_SPOSOBRASCH, INDEX_INFO )
    select :ID, :IDCENLVL, m.IDINDEX, --:IDINDEX,
           m.punktind,
           m.ma, m.mb, m.mc, m.md, m.me, m.mf, m.mg, m.mh, m.mi,
           m.MJ, m.MK, m.ML, m.MM,
           m.DA, m.DB, m.DC, m.DD, m.DE, m.DJ, m.DK, m.DL, m.DM, 
           :ID_LEVEL_INDEX, m.INDEX_SPOSOBRASCH, m.INDEX_INFO
      from A_SMETA_INDLVL m
      where m.ID = :ID
        and m.IDCENLVL = :IDCENLVL_CURR;
  else
  */
  --     
  insert into A_SMETA_INDLVL_DESCR ( ID, IDCENLVL,
        NMA, NMB, NMC, NMD, NME, NMF, NMG, NMH, NMI, NMJ, NMK, NML, NMM,
        NM_PR, --[15352]
        NDA, NDB, NDC, NDD, NDE, NDJ, NDK, NDL, NDM )
    select :ID, :IDCENLVL,
        NMA, NMB, NMC, NMD, NME, NMF, NMG, NMH, NMI, NMJ, NMK, NML, NMM,
        NM_PR, --[15352]
        NDA, NDB, NDC, NDD, NDE, NDJ, NDK, NDL, NDM
      from A_SMETA_INDLVL_DESCR
      where ID = :NOMERROD
        and IDCENLVL = :IDCENLVL;


  /* [10611.3]         ,    
  --   %    =================================================
  -- % 
  if ((:VN_SRL is null) or (lckgetbloblength(:VN_SRL) = 0)) then
  begin
    update a_smeta s
    set s.srl = cast(:VN_PA as varchar(25))
    where (s.id = :ID);
  end

  -- % 
  if ((:VN_SRM is null) or (lckgetbloblength(:VN_SRM) = 0)) then
  begin
    update a_smeta s
    set s.srm = cast(:VN_PB as varchar(25))
    where (s.id = :ID);
  end
  */

  /* [10611.3]      , ... !!!
  --   () =============================================
  update SMETA_PRICEPOS_INFO i
  set IDCENLVL = :IDCENLVL
  where (i.id = :ID);
  */


  --   ===========================================================
  --     
  for select r.id, r.NOMERROD --, r.bb, r.bc, r.bd, r.be
    from a_s_res r
    where (r.id_source = :ID)
    into :VN_RES_ID, :RES_NOMERROD --, :VN_RES_BB, :VN_RES_BC, :VN_RES_BD, :VN_RES_BE
  do
  begin
    --     ()  
    insert into A_S_RES_CENLVL (ID, IDCENLVL, IDZONE,
                                BB, BC, BD, BE,
                                ID_LEVEL_VC)
      --[10611.3]
      select :VN_RES_ID, :IDCENLVL, rl.IDZONE,
          rl.BB, rl.BC, rl.BD, rl.BE,
          :ID_LEVEL_VC
        from A_S_RES_CENLVL rl
        where rl.ID = :RES_NOMERROD
          and rl.IDCENLVL = :IDCENLVL;
      --values (:VN_RES_ID, :IDCENLVL, :IDZONE,
      --        :VN_RES_BB, :VN_RES_BC, :VN_RES_BD, :VN_RES_BE,
      --        :ID_LEVEL_VC);
    if (row_count = 0) then
    -- [10611.3]     -    
    insert into A_S_RES_CENLVL (ID, IDCENLVL, IDZONE,
                                BB, BC, BD, BE,
                                ID_LEVEL_VC)
      select :VN_RES_ID, :IDCENLVL, rl.IDZONE,
          rl.BB, rl.BC, rl.BD, rl.BE,
          :ID_LEVEL_VC
        from A_S_RES_CENLVL rl
        where rl.ID = :VN_RES_ID
          and rl.IDCENLVL = :IDCENLVL_CURR;
  end


  --[10611.3]    ,    ,
  --     ,    ...
  --   =========================================================
  --     
  for select r.id --, r.bb, r.bc, r.bd, r.be
    from M_ETALON_S_RES r
    where (r.id_source = :ID)
    into :VN_RES_ID --, :VN_RES_BB, :VN_RES_BC, :VN_RES_BD, :VN_RES_BE
    do
  begin
    --     ()  
    insert into A_S_ETALON_RES_CENLVL (ID, IDCENLVL, IDZONE,
                                       BB, BC, BD, BE,
                                       ID_LEVEL_VC)
      select :VN_RES_ID, :IDCENLVL, el.IDZONE,
          el.BB, el.BC, el.BD, el.BE,
          :ID_LEVEL_VC
        from A_S_ETALON_RES_CENLVL el
        where el.ID = :VN_RES_ID
          and el.IDCENLVL = :IDCENLVL_CURR;
      --values (:VN_RES_ID, :IDCENLVL, :IDZONE,
      --        :VN_RES_BB, :VN_RES_BC, :VN_RES_BD, :VN_RES_BE,
      --        :ID_LEVEL_VC);
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE M_READ_LZ_CACHE (
    IN_ID_OBJ INTEGER,
    IN_SMETATYPE INTEGER,
    IN_ID_USER INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    ID INTEGER,
    ATYPE INTEGER,
    NUMBER INTEGER,
    ITOG DOUBLE PRECISION,
    PRECIS INTEGER,
    FORMULA_S VARCHAR(100),
    VID INTEGER)
AS
declare variable vn_id_hier integer;
DECLARE VARIABLE O_RA DOUBLE PRECISION;
DECLARE VARIABLE O_RB DOUBLE PRECISION;
DECLARE VARIABLE O_RC DOUBLE PRECISION;
DECLARE VARIABLE O_RD DOUBLE PRECISION;
DECLARE VARIABLE O_RE DOUBLE PRECISION;
DECLARE VARIABLE O_RF DOUBLE PRECISION;
DECLARE VARIABLE O_RG DOUBLE PRECISION;
DECLARE VARIABLE O_RH DOUBLE PRECISION;
DECLARE VARIABLE O_RI DOUBLE PRECISION;
DECLARE VARIABLE O_RJ DOUBLE PRECISION;
DECLARE VARIABLE O_RK DOUBLE PRECISION;
DECLARE VARIABLE O_RL DOUBLE PRECISION;
DECLARE VARIABLE O_RM DOUBLE PRECISION;
DECLARE VARIABLE O_IT DOUBLE PRECISION;
DECLARE VARIABLE O_RLM DOUBLE PRECISION;
DECLARE VARIABLE O_ITOGO DOUBLE PRECISION;
DECLARE VARIABLE O_RN DOUBLE PRECISION;
DECLARE VARIABLE O_RO DOUBLE PRECISION;
DECLARE VARIABLE O_RP DOUBLE PRECISION;
--<<[12250]
declare O_R25 double precision;
declare O_R26 double precision;
declare O_R27 double precision;
declare O_R28 double precision;
declare O_R29 double precision;

--[15479]
declare O_R_PR double precision;
declare O_RC_16 double precision;
declare O_RE_16 double precision;

declare variable vn_formula BLOB SUB_TYPE 1 SEGMENT SIZE 80;
declare C integer;
declare F integer;
declare L integer;
declare variable vn_PrecIt integer;
begin
--[15352]
--[15479]
/*
  -- MK 12.11.2010     
  --       
  select first 1 p.PRECIT
  from A_GET_PARAMS_OBJ_AKT(:IN_ID_USER, :IN_ID_OBJ, :IN_SMETATYPE) p
  into :vn_PrecIt;
  -- MK 12.11.2010 <---
*/

  -- MK CQ[15102, 15103] --->
  --       /
  --   
  select first 1 p.PRECIT
  from A_GET_PARAMS_OBJ_AKT(:IN_ID_USER, :IN_ID_OBJ, :IN_SMETATYPE) p
  into :vn_PrecIt;
  -- MK CQ[15102, 15103] <---

  --    ----------------------------------------------------
  for select NUMBER, ATYPE
  from L_H_SELTREE_HIER(:IN_ID_USER, :IN_ID_OBJ)
  into :vn_id_hier, :ATYPE
  do
  begin
    --  
    ID = :vn_id_hier;
    NUMBER = null;
    ITOG = null;
    FORMULA_S = null;
    -- MK CQ[15102, 15103] --->
    PRECIS = vn_PrecIt;
    --PRECIS = null;
    -- MK CQ[15102, 15103] <---
    suspend;

    --    
    for select l.ID, l.atype, VID, l.number, c.ITOG, l.PRECIS, l.formula,
               case
                 when FORMULA is null or LCKGETBLOBLENGTH(FORMULA) >= 100 then null
                 else S_SUBSTRING100(FORMULA, 1, 100)
               end
    from a_lz l
    left join a_lz_cenlvl c on c.id = l.id and c.idcenlvl = :IDCENLVL
    where (l.IDHIER = :vn_id_hier) and (l.SMETATYPE = :IN_SMETATYPE)
    order by l.NUMBER
    into :ID, :ATYPE, :VID, :NUMBER, :ITOG, :PRECIS, :vn_formula, :FORMULA_S
    do
    begin
/*
      -- MK 12.11.2010 --->
      PRECIS = vn_PrecIt;
      --    (  )
      if (:ATYPE in (207, 208)) then
        PRECIS = -1;
      -- MK 12.11.2010 <---
*/

      -- 
      if (:vn_formula is null or :FORMULA_S is not null) then
        suspend;
      else
      begin
        C = LCKGETBLOBLENGTH(:vn_formula);
        F = 1;
        L = 100;
        while (:F <= :C) do
        begin
          FORMULA_S = S_SUBSTRING100(:vn_formula, :F, :L);
          suspend;
          F = :F + :L;
        end
      end

    end
  end

  --   () ---------------------------------------------------------
  if (IN_SMETATYPE > 16) then
  begin
    ID = IN_SMETATYPE;
    ATYPE = 8;
    vn_id_hier = IN_SMETATYPE;
  end
  else
  begin
    ID = IN_ID_OBJ;
    ATYPE = 1;
    vn_id_hier = IN_ID_OBJ;
  end
  NUMBER = null;
  ITOG = null;
  FORMULA_S = null;
  -- MK CQ[15102, 15103] --->
  PRECIS = vn_PrecIt;
  --PRECIS = null;
  -- MK CQ[15102, 15103] <---
  suspend;

  begin -- MK 2.07.2013 CQ[11340]
    execute procedure A_LZ_GETITOG_OBJ_NL(:IN_ID_USER, :IN_ID_OBJ, :IN_SMETATYPE, :IDCENLVL)
    returning_values :O_RA, :O_RB, :O_RC, :O_RD, :O_RE, :O_RF, :O_RG, :O_RH,
                     :O_RI, :O_RJ, :O_RK, :O_RL, :O_RM, :O_IT, :O_RLM, :O_ITOGO,
                     :O_RN, :O_RO, :O_RP,
                     :O_R25, :O_R26, :O_R27, :O_R28, :O_R29, --<<[12250]
                     :O_R_PR, :O_RC_16, :O_RE_16; --[15479]

    -- MK 2.07.2013 CQ[11340] --->
    WHEN ANY DO
    begin
      O_RA = 0;
      O_RB = 0;
      O_RC = 0;
      O_RD = 0;
      O_RE = 0;
      O_RF = 0;
      O_RG = 0;
      O_RH = 0;
      O_RI = 0;
      O_RJ = 0;
      O_RK = 0;
      O_RL = 0;
      O_RM = 0;
      O_IT = 0;
      O_RLM = 0;
      O_ITOGO = 0;
      O_RN = 0;
      O_RO = 0;
      O_RP = 0;
      --<<[12250]
      O_R25 = 0;
      O_R26 = 0;
      O_R27 = 0;
      O_R28 = 0;
      O_R29 = 0;

      --[15479]
      O_R_PR = 0;
      O_RC_16 = 0;
      O_RE_16 = 0;
      --[15479]
    end
    -- MK 2.07.2013 CQ[11340] <---
  end   -- MK 2.07.2013 CQ[11340]

  for select l.ID, l.ATYPE, VID, l.number, l.PRECIS, l.formula,
             c.ITOG, -- MK CQ[14103]
             case
               when FORMULA is null or LCKGETBLOBLENGTH(FORMULA) >= 100 then null
               else S_SUBSTRING100(FORMULA, 1, 100)
             end
  from a_lz l
  left join a_lz_cenlvl c on c.id = l.id and c.idcenlvl = :IDCENLVL -- MK CQ[14103]
  where (l.idhier = :vn_id_hier) and (l.smetatype = :IN_SMETATYPE)
  order by l.number
  into :ID, :ATYPE, :VID, :NUMBER, :PRECIS, :vn_formula,
       :ITOG,        -- MK CQ[14103]
       :FORMULA_S
  do
  begin
    ITOG =
      case :ATYPE
        when 201 then :O_RA
        when 202 then :O_RB
        when 203 then :O_RC
        when 204 then :O_RD
        when 205 then :O_RE
        when 206 then :O_RF
        when 207 then :O_RG
        when 208 then :O_RH
        when 209 then :O_RI
        when 210 then :O_RJ
        when 211 then :O_RK
        when 216 then :O_RL
        when 222 then :O_RM
        when 223 then :O_RLM    -- CQ[8295]
        when 224 then :O_ITOGO  -- CQ[9349]
        -- CQ[9374] --->
        when 214 then :O_RN
        when 215 then :O_RO
        when 217 then :O_RP
        -- CQ[9374] <---

        --<<[12250]
        when 225 then :O_R25
        when 226 then :O_R26
        when 227 then :O_R27
        when 228 then :O_R28
        when 229 then :O_R29

        --[15479]
        when 230 then :O_R_PR
        when 231 then :O_RC_16
        when 232 then :O_RE_16

        -- MK CQ[14103] --->
        else :ITOG
        --else 0
        -- MK CQ[14103] <---
      end;

/*
    -- MK 12.11.2010 --->
    PRECIS = vn_PrecIt;
    --    (  )
    if (:ATYPE in (207, 208)) then
      PRECIS = -1;
    -- MK 12.11.2010 <---
*/

    -- 
    if (:vn_formula is null or :FORMULA_S is not null) then
      suspend;
    else
    begin
      C = LCKGETBLOBLENGTH(:vn_formula);
      F = 1;
      L = 100;
      while (:F <= :C) do
      begin
        FORMULA_S = S_SUBSTRING100(:vn_formula, :F, :L);
        suspend;
        F = :F + :L;
      end
    end

  end
end
^

--[15195]
/* 
CREATE OR ALTER PROCEDURE M_READ_SMETA_TO_CACHE (
*/
--[15195]
/* 
CREATE OR ALTER PROCEDURE MB_ADD_IND_RECORD (
*/
--[15195]
CREATE OR ALTER PROCEDURE NL_FIND_COMPOSE_EX (
    ID_LEVEL INTEGER,
    IDCLASS INTEGER,
    ID_USER INTEGER,
    IDREESTR INTEGER,
    TYPE_RAB INTEGER,
    VID_RAB INTEGER,
    ATYPE INTEGER,
    RABMAT INTEGER,
    IDHIER INTEGER,
    PUNKIND VARCHAR(42),
    IDNORMATIV INTEGER,
    PODGROUP INTEGER)
RETURNS (
    ID_COMPOSE_VC INTEGER,
    ID_COMPOSE_INDEX INTEGER,
    INDEX_DX_ONLY INTEGER)
AS
declare variable VN_USE_MULTIRULES integer;
declare variable VN_ID_COMPOSE integer;
declare variable VN_COMPOSE_TYPE integer;
declare variable INDEX_TECH_PART_ID integer;

declare variable ID_ORG integer;
declare variable ID_YEAR integer;
declare variable ID_MONTH integer;
declare variable ID_IND integer;
declare variable INDEX_IS_EMPTY integer;
declare variable MA double precision;
declare variable MB double precision;
declare variable MC double precision;
declare variable MD double precision;
declare variable ME double precision;
declare variable MJ double precision;
declare variable MK double precision;
declare variable ML double precision;
declare variable MM double precision;
declare variable MN double precision; --[15354]
declare variable DA double precision;
declare variable DB double precision;
declare variable DJ double precision;
declare variable DK double precision;
declare variable DL double precision;
declare variable DM double precision;

declare variable ID_ZONE integer;
declare variable IS_ZONE_FIND integer;
declare variable ZONE_TMP_VAL double precision;

--<[14593]>
declare ZBA double precision;
declare ZBB double precision;
declare ZBC double precision;
declare ZBD double precision;
declare ZBE double precision;
declare BA double precision;
declare BB double precision;
declare BC double precision;
declare BD double precision;
declare BE double precision;
--</>

-- MK CQ[12599.5]
declare variable APPLYONRES integer;
declare variable IS_ZONE_USED integer;
begin
--[15352]
--[15354]
  -- [14593]
  --    VN_USE_MULTIRULES
  --   INDEX_DX_ONLY     

  -- NL_FIND_COMPOSE_EX:
  -- :     NL_FIND_COMPOSE  CQ[10738]
  -- =============================================================================
  --  
  -- ATYPE --  ( - 17,  - 18,  - 0
  -- =============================================================================
  -- 
  ID_COMPOSE_VC = null;
  ID_COMPOSE_INDEX = null;
  INDEX_TECH_PART_ID = null;

  if (:ATYPE in (17, 18, 0)) then
  begin
    --      
    /* [14593] -    
    for select first 1 coalesce(L.USE_MULTIRULES, 0)
      from LEVEL_COST L
      where (L.ID = :ID_LEVEL) and
            (L.IDOBJECT = :IDCLASS)
      into :VN_USE_MULTIRULES
    do */
    --begin
      --    ,    
      for select ID_COMPOSE, COMPOSE_TYPE
        from NL_GET_USED_COMPOSE(:ID_LEVEL, :IDCLASS, :ID_USER, :IDREESTR, :TYPE_RAB, :VID_RAB, null/*:ATYPE*/, :RABMAT, :IDHIER)
        into :VN_ID_COMPOSE, :VN_COMPOSE_TYPE
      do
      begin
        if (:VN_COMPOSE_TYPE = 1) then
        -- 
        begin
          --       
          --      
          --[14593] if ((:ID_COMPOSE_VC is null) or (:VN_USE_MULTIRULES <> 0)) then
          if ((:ID_COMPOSE_VC is null)
          or (coalesce(:VN_USE_MULTIRULES, 0) <> 0)
          or (:INDEX_DX_ONLY <> 0)) then
          begin
            --      
            if (:ID_COMPOSE_INDEX is null) then
            begin
              --   
              select ID_ORG, ID_YEAR, ID_MONTH, MA, MB, MJ, MK, DA, DB, DJ, DK
              from LEVEL_INDEX
              where ID_COMPOSE = :VN_ID_COMPOSE
              into :ID_ORG, :ID_YEAR, :ID_MONTH, :MA, :MB, :MJ, :MK, :DA, :DB, :DJ, :DK;
              ID_IND = null;
              for select ID
                from IND_RECORD_EXISTS(:ID_USER, :ID_ORG, :ID_YEAR, :ID_MONTH, :PUNKIND, 1)
                into :ID_IND
              do
              begin
                if (coalesce(:ID_IND, 0) > 0) then
                  ID_COMPOSE_INDEX = :VN_ID_COMPOSE;
              end
              if ((:ID_COMPOSE_INDEX is null) and
                  (:INDEX_TECH_PART_ID is null)) then
              begin
                --   
                execute procedure IS_EMPTY_INDEX(:IDNORMATIV, :RABMAT,
                  :MA, :MB, 1, 1, 1, :MJ, :MK, 1, 1, 1/*:MN 15354*/,
                  :DA, :DB, :DJ, :DK, 1, 1)
                returning_values :INDEX_IS_EMPTY;
                --    .    Compose     
                --  Compose  
                if (:INDEX_IS_EMPTY = 0) then
                  INDEX_TECH_PART_ID = :VN_ID_COMPOSE;
              end
            end
          end
        end
        else
        if (:VN_COMPOSE_TYPE = 2) then
        --  
        begin
          --       
          --      
          --[14593] if ((:ID_COMPOSE_INDEX is null) or (:VN_USE_MULTIRULES <> 0)) then
          --begin
            --      
            if (:ID_COMPOSE_VC is null) then
              --     = ,   
              for select ID_ZONE, APPLY_ON_RES -- MK CQ[12599.5] + APPLY_ON_RES
                from LEVEL_VC
                where ((ID_COMPOSE = :VN_ID_COMPOSE) and
                      (ID_ZONE > 0))
                into :ID_ZONE, APPLYONRES -- MK CQ[12599.5] + APPLYONRES
              do
              begin
                -- MK CQ[12599.5] --->
                --      NL_CHECK_VC
                if (:APPLYONRES = 0  --  /
                 --  "     ":
                 or :ATYPE = 18                  --  
                 or :ATYPE = 17 and :RABMAT <> 0 -- c  -  
                   ) then
                begin
                -- MK CQ[12599.5] <---

                  --<<[14593]
                  execute procedure NL_COMPOSE_USE_MULTIRULES(
                      :ID_LEVEL, :IDCLASS, :VN_ID_COMPOSE, :ID_ZONE)
                    returning_values :VN_USE_MULTIRULES;

                  if ((:ID_COMPOSE_INDEX is null) or (:VN_USE_MULTIRULES <> 0)) then
                  begin
                    --   
                    execute procedure L_FILL_CCURRENT1_NL(
                        :IDNORMATIV, :RABMAT, :PODGROUP, :ID_ZONE, :ID_USER)
                      returning_values
                        :ZBA, :ZBB, :ZBC, :ZBD, :ZBE, :IS_ZONE_FIND; --[14593]
                    if (:IS_ZONE_FIND > 0) then
                    begin
                      --[14593] ID_COMPOSE_VC = :VN_ID_COMPOSE;
                      --<[14593]>
                        ID_COMPOSE_VC = :VN_ID_COMPOSE;
  
                        if (:VN_USE_MULTIRULES = 0) then
                        if (:RABMAT = 3) then  -- [7FE7AD1744B6]
                        begin
                          execute procedure L_FILL_CCURRENT1_NL(
                              :IDNORMATIV, :RABMAT, :PODGROUP, -3, :ID_USER)
                            returning_values
                              :BA, :BB, :BC, :BD, :BE, :IS_ZONE_FIND;
                          if (:BB <> 0.0) then
                            INDEX_DX_ONLY = 0;
                          else
                            INDEX_DX_ONLY = 1;
                        end
                      --</>
                    end
                    else
                      VN_USE_MULTIRULES = null;
                  end
                  else
                    VN_USE_MULTIRULES = null;

                end -- MK CQ[12599.5]
              end
          --end
        end
        else
        if (:VN_COMPOSE_TYPE = 3) then
        --   
        begin
          --       
          --      
          --[14593] if ((:ID_COMPOSE_VC is null) or (:VN_USE_MULTIRULES <> 0)) then
          if ((:ID_COMPOSE_VC is null)
          or (coalesce(:VN_USE_MULTIRULES, 0) <> 0)
          or (:INDEX_DX_ONLY <> 0)) then
          begin
            --      
            if ((:ID_COMPOSE_INDEX is null) and (:INDEX_TECH_PART_ID is null)) then
            begin
              for select MA, MB, MC, MD, ME, MJ, MK, ML, MM, MN/*15354*/,
                         DA, DB, DJ, DK, DL, DM
                from LEVEL_INDEX_ITOG
                where ID_COMPOSE = :VN_ID_COMPOSE
                into :MA, :MB, :MC, :MD, :ME, :MJ, :MK, :ML, :MM, :MN/*15354*/,
                     :DA, :DB, :DJ, :DK, :DL, :DM
              do
              begin
                --  
                execute procedure IS_EMPTY_INDEX(:IDNORMATIV, :RABMAT,
                  :MA, :MB, :MC, :MD, :ME, :MJ, :MK, :ML, :MM, :MN/*15354*/,
                  :DA, :DB, :DJ, :DK, :DL, :DM)
                returning_values :INDEX_IS_EMPTY;
                --   ,    Compose     
                --  Compose  
                if (:INDEX_IS_EMPTY = 0) then
                  -- MK CQ[12599.2] --->
                  ID_COMPOSE_INDEX = :VN_ID_COMPOSE;
                  --INDEX_TECH_PART_ID = :VN_ID_COMPOSE;
                  -- MK CQ[12599.2] <---
              end
            end
          end
        end
      end
    --end
    -- Compose Index      ,    Compose    ,   
    --[14593] if ((:ID_COMPOSE_VC is null) or (:VN_USE_MULTIRULES <> 0)) then
    --[14593]  if (:ID_COMPOSE_INDEX is null)  then
    if (:ID_COMPOSE_INDEX is null and INDEX_TECH_PART_ID <> 0) then
      if (:ID_COMPOSE_VC is null
       or coalesce(:VN_USE_MULTIRULES, 0) <> 0
       or :INDEX_DX_ONLY <> 0) then
          ID_COMPOSE_INDEX = :INDEX_TECH_PART_ID;
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE NL_GET_IS_CENLVL (
    ID INTEGER,
    IDOBJECT INTEGER,
    IDCENLVL INTEGER,
    INCLUDEACTSMODE INTEGER,
    IDUSER INTEGER)
RETURNS (
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    CA DOUBLE PRECISION,
    CB DOUBLE PRECISION,
    CC DOUBLE PRECISION,
    CD DOUBLE PRECISION,
    CE DOUBLE PRECISION,
    CF DOUBLE PRECISION,
    CG DOUBLE PRECISION,
    CH DOUBLE PRECISION,
    CI DOUBLE PRECISION,
    CJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    CALCBMASK INTEGER,
    ID_LEVEL_VC INTEGER,
    BASE_INFO INTEGER,
    CURR_CENA DOUBLE PRECISION,
    BASE_CALC_INFO INTEGER,
    SOURCE_LEVEL_ID INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    EN DOUBLE PRECISION,
    EO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    C_ITOGO DOUBLE PRECISION,
    E_ITOGO DOUBLE PRECISION,
    CURR_CENA_INFO INTEGER,
    ID_VALUTE INTEGER,
    VALUTE_CURS DOUBLE PRECISION,
    VALUTE_DATE DATE,
    TRANSP DOUBLE PRECISION,
    ZAG_SKL DOUBLE PRECISION,
    ZAPCHAST DOUBLE PRECISION,
    TARA DOUBLE PRECISION,
    NACEN DOUBLE PRECISION,
    COMPLECT DOUBLE PRECISION,
    KOEFF_TYPE INTEGER,
    B_PR DOUBLE PRECISION,
    C_PR DOUBLE PRECISION,
    E_PR DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
declare KOLL double precision; --[15352]
begin
--[15352]+

  /* [96BD98747D2D]
     CQ[TIMUR 10737] -       2- :
     1.     " "
     2.     "   ",   IDLEVEL =  
     3.         ->     .
        P.S.    (     , ), 
              .
                -     (  )
  */

  --    ,              
  CALCBMASK = null; ID_LEVEL_VC    = null; BASE_INFO       = null;
  CURR_CENA = null; BASE_CALC_INFO = null; SOURCE_LEVEL_ID = null;

  BA = 0; BB = 0; BC = 0; BD = 0; BE = 0; BF = 0; BG = 0; BH = 0; BI = 0; BJ = 0;
  CA = 0; CB = 0; CC = 0; CD = 0; CE = 0; CF = 0; CG = 0; CH = 0; CI = 0; CJ = 0;
  EA = 0; EB = 0; EC = 0; ED = 0; EE = 0; EF = 0; EG = 0; EH = 0; EI = 0; EJ = 0; EK = 0;
  PA = 0; PB = 0; PC = 1; PD = 1;
  B_PR = 0; C_PR = 0; E_PR = 0; --[15352]

  select BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, CA, CB, CC, CD, CE, CF, CG, CH, CI, CJ, EA, EB, EC,
         ED, EE, EF, EG, EH, EI, EJ, EK, PA, PB, PC, PD, CALCBMASK, ID_LEVEL_VC, BASE_INFO,
         CURR_CENA, BASE_CALC_INFO, SOURCE_LEVEL_ID, -- MK 20.06.2012 CQ[10565]
         BN, BO, EN, EO, B_ITOGO, C_ITOGO, E_ITOGO, -- MK  CQ[13174]
         B_PR, C_PR, E_PR, --[15352]
         CURR_CENA_INFO, ID_VALUTE, VALUTE_CURS, -- MK CQ[11989]
         VALUTE_DATE, TRANSP, ZAG_SKL,           -- MK CQ[11989]
         ZAPCHAST, TARA, NACEN, COMPLECT,        -- MK CQ[11989]
         KOEFF_TYPE                              -- MK CQ[13018]
  from A_SMETA_CENLVL
  where (ID = :ID) and
        (IDCENLVL = :IDCENLVL)
  into :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :CA, :CB, :CC, :CD, :CE, :CF, :CG, :CH,
       :CI, :CJ, :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK, :PA, :PB, :PC, :PD,
       :CALCBMASK, :ID_LEVEL_VC, :BASE_INFO,
       :CURR_CENA, :BASE_CALC_INFO, :SOURCE_LEVEL_ID, -- MK 20.06.2012 CQ[10565]
       :BN, :BO, :EN, :EO, :B_ITOGO, :C_ITOGO, :E_ITOGO, -- MK  CQ[13174]
       :B_PR, :C_PR, :E_PR, --[15352]
       :CURR_CENA_INFO, :ID_VALUTE, :VALUTE_CURS,     -- MK CQ[11989]
       :VALUTE_DATE, :TRANSP, :ZAG_SKL,               -- MK CQ[11989]
       :ZAPCHAST, :TARA, :NACEN, :COMPLECT,           -- MK CQ[11989]
       :KOEFF_TYPE;                                   -- MK CQ[13018]

  --           
  execute procedure V_PR_SELECT_REC_VERSIONS_IT_NL( --[15352]
      :ID, :IDUSER, :IDOBJECT, 0, 0, 0, 1, :INCLUDEACTSMODE, :IDCENLVL)
    returning_values :KOLL,
      :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :ITOGO,
      :R_PR, :RC_16, :RE_16; --[15352]

  -- CQ[12613] --->
  if (PC = 0) then
    PC = 1;
  if (PD = 0) then
    PD = 1;
  -- CQ[12613] <---

  suspend;
end
^

--[15195]
CREATE OR ALTER PROCEDURE NL_GET_IS_CENLVL_MANY (
    IDOBJECT INTEGER,
    IDCENLVL INTEGER,
    INCLUDEACTSMODE INTEGER,
    IDUSER INTEGER)
RETURNS (
    ID INTEGER,
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    BF DOUBLE PRECISION,
    BG DOUBLE PRECISION,
    BH DOUBLE PRECISION,
    BI DOUBLE PRECISION,
    BJ DOUBLE PRECISION,
    CA DOUBLE PRECISION,
    CB DOUBLE PRECISION,
    CC DOUBLE PRECISION,
    CD DOUBLE PRECISION,
    CE DOUBLE PRECISION,
    CF DOUBLE PRECISION,
    CG DOUBLE PRECISION,
    CH DOUBLE PRECISION,
    CI DOUBLE PRECISION,
    CJ DOUBLE PRECISION,
    EA DOUBLE PRECISION,
    EB DOUBLE PRECISION,
    EC DOUBLE PRECISION,
    ED DOUBLE PRECISION,
    EE DOUBLE PRECISION,
    EF DOUBLE PRECISION,
    EG DOUBLE PRECISION,
    EH DOUBLE PRECISION,
    EI DOUBLE PRECISION,
    EJ DOUBLE PRECISION,
    EK DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    PA DOUBLE PRECISION,
    PB DOUBLE PRECISION,
    PC DOUBLE PRECISION,
    PD DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    CALCBMASK INTEGER,
    ID_LEVEL_VC INTEGER,
    BASE_INFO INTEGER,
    CURR_CENA DOUBLE PRECISION,
    BASE_CALC_INFO INTEGER,
    SOURCE_LEVEL_ID INTEGER,
    BN DOUBLE PRECISION,
    BO DOUBLE PRECISION,
    EN DOUBLE PRECISION,
    EO DOUBLE PRECISION,
    B_ITOGO DOUBLE PRECISION,
    C_ITOGO DOUBLE PRECISION,
    E_ITOGO DOUBLE PRECISION,
    CURR_CENA_INFO INTEGER,
    ID_VALUTE INTEGER,
    VALUTE_CURS DOUBLE PRECISION,
    VALUTE_DATE DATE,
    TRANSP DOUBLE PRECISION,
    ZAG_SKL DOUBLE PRECISION,
    ZAPCHAST DOUBLE PRECISION,
    TARA DOUBLE PRECISION,
    NACEN DOUBLE PRECISION,
    COMPLECT DOUBLE PRECISION,
    KOEFF_TYPE INTEGER,
    B_PR DOUBLE PRECISION,
    C_PR DOUBLE PRECISION,
    E_PR DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
declare IDLEVEL integer;
declare SMETATYPE integer;
declare RETURN_ALL integer;

declare LYEAR integer;
declare LMONTH integer;
declare USE_ONLY_UTV_PROCENT integer;
declare SKIP_PS integer;

declare KOLL double precision;
begin
--[15352]+

--[13147] -   NL_GET_IS_CENLVL   

  IDLEVEL = :IDOBJECT;
  SMETATYPE = 16;
  RETURN_ALL = 1;

  LYEAR = 0;
  LMONTH = 0;
  USE_ONLY_UTV_PROCENT = 0;
  SKIP_PS = 1;

  for select ID
    from T_GET_SMETA_LIGHT(:IDOBJECT, :IDLEVEL, :IDUSER, :SMETATYPE, :RETURN_ALL)
    into ID
  do
  /*    ATYPE,     NL_GET_IS_CENLVL*/
  for select
      BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
      CA, CB, CC, CD, CE, CF, CG, CH, CI, CJ,
      EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
      PA, PB, PC, PD,
      CALCBMASK, ID_LEVEL_VC,
      BASE_INFO, CURR_CENA, BASE_CALC_INFO, SOURCE_LEVEL_ID, -- MK 20.06.2012 CQ[10565]
      BN, BO, EN, EO, B_ITOGO, C_ITOGO, E_ITOGO, -- MK  CQ[13174]
      B_PR, C_PR, E_PR, --[15352]
      CURR_CENA_INFO, ID_VALUTE, VALUTE_CURS, -- MK CQ[11989]
      VALUTE_DATE, TRANSP, ZAG_SKL,           -- MK CQ[11989]
      ZAPCHAST, TARA, NACEN, COMPLECT,        -- MK CQ[11989]
      KOEFF_TYPE                              -- MK CQ[13018]
    from A_SMETA_CENLVL
    where (ID = :ID)
      and (IDCENLVL = :IDCENLVL)
    into
      :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
      :CA, :CB, :CC, :CD, :CE, :CF, :CG, :CH, :CI, :CJ,
      :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
      :PA, :PB, :PC, :PD,
      :CALCBMASK, :ID_LEVEL_VC,
      :BASE_INFO, :CURR_CENA, :BASE_CALC_INFO, :SOURCE_LEVEL_ID, -- MK 20.06.2012 CQ[10565]
      :BN, :BO, :EN, :EO, :B_ITOGO, :C_ITOGO, :E_ITOGO, -- MK  CQ[13174]
      :B_PR, :C_PR, :E_PR, --[15352]
      :CURR_CENA_INFO, :ID_VALUTE, :VALUTE_CURS,     -- MK CQ[11989]
      :VALUTE_DATE, :TRANSP, :ZAG_SKL,               -- MK CQ[11989]
      :ZAPCHAST, :TARA, :NACEN, :COMPLECT,           -- MK CQ[11989]
      :KOEFF_TYPE                                    -- MK CQ[13018]
  do
  begin
    execute procedure V_PR_SELECT_REC_VERSIONS_IT_NL(
        :ID, :IDUSER, :IDOBJECT,
        :LYEAR, :LMONTH, :USE_ONLY_UTV_PROCENT, :SKIP_PS,
        :INCLUDEACTSMODE, :IDCENLVL)
      returning_values :KOLL,
        :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :ITOGO,
        :R_PR, :RC_16, RE_16; --[15352]
    suspend;
  end
  /*
  begin
    execute procedure NL_GET_IS_CENLVL(:ID, :IDOBJECT, :IDCENLVL, :INCLUDEACTSMODE, :IDUSER)
      returning_values
        :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
        :CA, :CB, :CC, :CD, :CE, :CF, :CG, :CH, :CI, :CJ,
        :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
        :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
        :PA, :PB, :PC, :PD,
        :ITOGO, :CALCBMASK, :ID_LEVEL_VC, :BASE_INFO,
        :CURR_CENA, :BASE_CALC_INFO, :SOURCE_LEVEL_ID;
    suspend;
  end
  */
end
^

--[15195]
CREATE OR ALTER PROCEDURE S_CALC_INDEX_ON_RABMAT (
    IDUSER INTEGER,
    IDINDEX INTEGER,
    IDRABMAT INTEGER,
    IDZONE_B INTEGER,
    IDZONE_E INTEGER,
    ID_TR INTEGER,
    IDOGL INTEGER,
    INDEX_PRES INTEGER,
    ORDERVIEW INTEGER,
    CALCSMR INTEGER)
RETURNS (
    NUMBER INTEGER)
AS
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE TAB VARCHAR(42);
DECLARE VARIABLE PA DOUBLE PRECISION;
DECLARE VARIABLE PB DOUBLE PRECISION;
DECLARE VARIABLE BA DOUBLE PRECISION;
DECLARE VARIABLE BANDS DOUBLE PRECISION;
DECLARE VARIABLE ZBA DOUBLE PRECISION;
DECLARE VARIABLE BE DOUBLE PRECISION;
DECLARE VARIABLE BENDS DOUBLE PRECISION;
DECLARE VARIABLE ZBE DOUBLE PRECISION;
DECLARE VARIABLE BC DOUBLE PRECISION;
DECLARE VARIABLE BCNDS DOUBLE PRECISION;
DECLARE VARIABLE ZBC DOUBLE PRECISION;
DECLARE VARIABLE BB DOUBLE PRECISION;
DECLARE VARIABLE BBNDS DOUBLE PRECISION;
DECLARE VARIABLE ZBB DOUBLE PRECISION;
DECLARE VARIABLE BD DOUBLE PRECISION;
DECLARE VARIABLE BDNDS DOUBLE PRECISION;
DECLARE VARIABLE ZBD DOUBLE PRECISION;
DECLARE VARIABLE PROCENTPRED DOUBLE PRECISION;
DECLARE VARIABLE VRPZ INTEGER;
begin
--[15352]
--[15354]
  for select first 1 ID, TAB, VRPZ
    from B_RABMAT
    where ID = :IDRABMAT
    into :ID, :TAB, :VRPZ
  do
  begin

    select BA, BB, BC, BD, BE
      from S_CALC_INDEX_ON_ZONES_RAB(:IDUSER, :ID, :IDZONE_B, :IDZONE_E, :INDEX_PRES)
      into :BA, :BB, :BC, :BD, :BE;

    --CQ[9863] -->
    if  (CALCSMR is null) then
      CALCSMR = 0;
    if (CALCSMR <> 1) then
      BA = 1;
    --CQ[9863] <--

    PA  = null;
    PB  = null;
    ZBA = null;
    ZBB = null;

    if (:ID_TR > 0 and :VRPZ is not null) then
      select PA, PB, PC, PD
        from A_SRF_F
        where ID_TR = :ID_TR
          and NUMBER = :VRPZ
        into :PA, :PB, :ZBA, :ZBB;

  /*
    if (exists (select * from B_IND
                where ((TABU  = :TABU) and
                       (IDREESTR = :IDREESTR) and
                       (ID <> :ID))))
    then exit ;
  */
    select NEWTAB
      from S_GEN_NEW_INDEX_TAB(:IDUSER, :TAB, :IDINDEX)
      into :TAB;

    select ID
    from  B_ADD_IND_RECORD_INNER(:IDUSER, :IDINDEX, :IDOGL, :ORDERVIEW, :TAB,
           :PA, :PB, :BA, :BANDS, :ZBA,  :BE, :BENDS, :ZBE,
           :BC, :BCNDS, :ZBC,  :BB, :BBNDS, :ZBB,  :BD, :BDNDS, :ZBD,
           :PROCENTPRED,
           null, null, 0, 0, 1, null/*15354*/)
    INTO :ID;

    NUMBER = :ID;
    suspend;
  end
end
^

--[15195]
CREATE OR ALTER PROCEDURE S_CALC_INDEX_ON_RRDATA (
    IDUSER INTEGER,
    IDREESTR INTEGER,
    SHIFR VARCHAR(42),
    BA DOUBLE PRECISION,
    BB DOUBLE PRECISION,
    BC DOUBLE PRECISION,
    BD DOUBLE PRECISION,
    BE DOUBLE PRECISION,
    NAME BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ORDERVIEW INTEGER)
RETURNS (
    ID INTEGER,
    REORDERED INTEGER)
AS
declare variable pa double precision;
declare variable pb double precision;
declare variable bands double precision;
declare variable zba double precision;
declare variable bends double precision;
declare variable zbe double precision;
declare variable bcnds double precision;
declare variable zbc double precision;
declare variable bbnds double precision;
declare variable zbb double precision;
declare variable bdnds double precision;
declare variable zbd double precision;
declare variable procentpred double precision;
declare variable idogl integer;
declare variable tabu varchar(42);
declare variable BB_PR double precision;
begin
--[15354]+ BB_PR
  if (:SHIFR is null) then
    exit;
  SHIFR = LCKTRIMVARCHAR(:SHIFR);
  if (:SHIFR = '') then
    exit;
  TABU = S_TRANSLITERATE(:SHIFR);

  select ID
    from B_IND
    where IDREESTR = :IDREESTR
      and TABU = :TABU
    into :ID;

  if (:ID is null) then
  begin
    select ID
      from B_ADD_IND_RECORD_INNER(:IDUSER, :IDREESTR, :IDOGL, :ORDERVIEW, :SHIFR,
           :PA, :PB, :BA, :BANDS, :ZBA,  :BE, :BENDS, :ZBE,
           :BC, :BCNDS, :ZBC, :BB, :BBNDS, :ZBB,  :BD, :BDNDS, :ZBD,
           :PROCENTPRED, :NAME, null, 1, 1, 1, :BB_PR /*15354*/)
      into :ID;
    REORDERED = 1;
    --exception d_wrong_params "id   Insert";
  end
  else
  begin
    execute procedure B_WRITE_RECORD_INDEX(:IDUSER, :ID, :IDREESTR, :IDOGL, :SHIFR,
           :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE,
           :BC, :BCNDS, :ZBC, :BB, :BBNDS, :ZBB, :BD, :BDNDS, :ZBD,
           :PROCENTPRED,
           :NAME, null, 1, 1, -1, 1 /*MK CQ[15047, 15354]*/);
  end

  suspend;
end
^

--[15195]
CREATE OR ALTER PROCEDURE V_PR_SELECT_REC_VERSIONS_IT_NL (
    IN_ID INTEGER,
    ID_USER INTEGER,
    ID_OBJ INTEGER,
    LYEAR INTEGER,
    LMONTH INTEGER,
    USE_ONLY_UTV_PROCENT INTEGER,
    SKIP_PS INTEGER,
    INCLUDEACTSMODE INTEGER,
    IDCENLVL INTEGER)
RETURNS (
    KOLL DOUBLE PRECISION,
    RA DOUBLE PRECISION,
    RB DOUBLE PRECISION,
    RC DOUBLE PRECISION,
    RD DOUBLE PRECISION,
    RE DOUBLE PRECISION,
    RF DOUBLE PRECISION,
    RG DOUBLE PRECISION,
    RH DOUBLE PRECISION,
    RI DOUBLE PRECISION,
    RJ DOUBLE PRECISION,
    RK DOUBLE PRECISION,
    RL DOUBLE PRECISION,
    RM DOUBLE PRECISION,
    ITOGO DOUBLE PRECISION,
    R_PR DOUBLE PRECISION,
    RC_16 DOUBLE PRECISION,
    RE_16 DOUBLE PRECISION)
AS
declare variable ID integer;
declare variable ATYPE integer;
declare variable CLCMODE integer;
declare variable SMETAPARENT integer;
declare variable VN_KOLL double precision;
declare variable VN_RA double precision;
declare variable VN_RB double precision;
declare variable VN_RC double precision;
declare variable VN_RD double precision;
declare variable VN_RE double precision;
declare variable VN_RF double precision;
declare variable VN_RG double precision;
declare variable VN_RH double precision;
declare variable VN_RI double precision;
declare variable VN_RJ double precision;
declare variable VN_RK double precision;
declare variable VN_RL double precision;
declare variable VN_RM double precision;
declare variable VN_ITOGO double precision;
declare VN_R_PR double precision; --[15352]
declare VN_RC_16 double precision; --[15352]
declare VN_RE_16 double precision; --[15352]
begin 
--[15352]+
    /*
        CQ[8457]      L_PR_SELECT_REC_VERSIONS_ITOGI 
        IncludeActsMode.  .   A_O_HIER_SELECT_PR1_WITH_FILTER
    */

   if ( SKIP_PS is null ) then
      SKIP_PS = 0;

  /* CQ[15156] -   ...     
   select coalesce(sum(S.KOLL), 0),
          coalesce(sum(L.RA), 0),
          coalesce(sum(L.RB), 0),
          coalesce(sum(L.RC), 0),
          coalesce(sum(L.RD), 0),
          coalesce(sum(L.RE), 0),
          coalesce(sum(L.RF), 0),
          coalesce(sum(L.RG), 0),
          coalesce(sum(L.RH), 0),
          coalesce(sum(L.RI), 0),
          coalesce(sum(L.RJ), 0),
          coalesce(sum(L.RK), 0),
          coalesce(sum(L.RL), 0),
          coalesce(sum(L.RM), 0),
          coalesce(sum(L.ITOGO), 0)
     from V_PR_SELECT_REC_VERSIONS ( :IN_ID, :ID_USER,
         :ID_OBJ, :LYEAR, :LMONTH, :USE_ONLY_UTV_PROCENT, :INCLUDEACTSMODE ) V
     left join A_SMETA S on S.ID = V.ID
     left join A_SMETA_CENLVL L on L.ID = V.ID and L.IDCENLVL = :IDCENLVL
     where :SKIP_PS = 0 or S.SMETATYPE <> 15
     into :KOLL,
          :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH,
          :RI, :RJ, :RK, :RL, :RM, :ITOGO; */

   KOLL = 0.0;
   RA = 0.0; RB = 0.0; RC = 0.0; RD = 0.0; RE = 0.0;
   RF = 0.0; RG = 0.0; RH = 0.0; RI = 0.0; RJ = 0.0;
   RK = 0.0; RL = 0.0; RM = 0.0; ITOGO = 0.0;
   R_PR = 0.0; RC_16 = 0.0; RE_16 = 0.0; --[15352]

   for select s.ID, s.ATYPE, s.CLCMODE, s.SLAVEPARENT, s.KOLL,
     L.RA, L.RB, L.RC, L.RD, L.RE, L.RF, L.RG, L.RH, L.RI, L.RJ, L.RK, L.RL, L.RM, L.ITOGO,
     L.R_PR, L.RC_16, L.RE_16 --[15352]
   from V_PR_SELECT_REC_VERSIONS ( :IN_ID, :ID_USER,
         :ID_OBJ, :LYEAR, :LMONTH, :USE_ONLY_UTV_PROCENT, :INCLUDEACTSMODE ) V
   left join A_SMETA s on s.ID = V.ID
   left join A_SMETA_CENLVL L on L.ID = V.ID and L.IDCENLVL = :IDCENLVL
   where :SKIP_PS = 0 or S.SMETATYPE <> 15
   into :ID, :ATYPE, :CLCMODE, :SMETAPARENT, :VN_KOLL,
        :VN_RA, :VN_RB, :VN_RC, :VN_RD, :VN_RE, :VN_RF, :VN_RG, :VN_RH,
        :VN_RI, :VN_RJ, :VN_RK, :VN_RL, :VN_RM, :VN_ITOGO,
        :VN_R_PR, :VN_RC_16, :VN_RE_16 --[15352]
   do
   begin
     if (ATYPE = 18) then
       select first 1 s.CLCMODE
         from A_SMETA s
       where (s.ID = :SMETAPARENT)
       into :CLCMODE;

     if (GETBIT(CLCMODE, 10) = 0) then
     begin
       KOLL = KOLL + coalesce(VN_KOLL,  0);

       RA = RA + coalesce(VN_RA, 0);
       RB = RB + coalesce(VN_RB, 0);
       RC = RC + coalesce(VN_RC, 0);
       RD = RD + coalesce(VN_RD, 0);
       RE = RE + coalesce(VN_RE, 0);
       RF = RF + coalesce(VN_RF, 0);
       RG = RG + coalesce(VN_RG, 0);
       RH = RH + coalesce(VN_RH, 0);
       RI = RI + coalesce(VN_RI, 0);
       RJ = RJ + coalesce(VN_RJ, 0);
       RK = RK + coalesce(VN_RK, 0);
       RL = RL + coalesce(VN_RL, 0);
       RM = RM + coalesce(VN_RM, 0);
       ITOGO = ITOGO + coalesce(VN_ITOGO, 0);
       R_PR = R_PR + coalesce(VN_R_PR, 0); --[15352]
       RC_16 = RC_16 + coalesce(VN_RC_16, 0); --[15352]
       RE_16 = RE_16 + coalesce(VN_RE_16, 0); --[15352]
     end
   end

   suspend;
end
^

--[15195]
CREATE OR ALTER PROCEDURE V_SELECT_LEVEL_IND_ITOG_EXP_XML (
    ID_USER INTEGER,
    ID_COMPOSE INTEGER)
RETURNS (
    MA DOUBLE PRECISION,
    MB DOUBLE PRECISION,
    MC DOUBLE PRECISION,
    MD DOUBLE PRECISION,
    ME DOUBLE PRECISION,
    MJ DOUBLE PRECISION,
    MK DOUBLE PRECISION,
    ML DOUBLE PRECISION,
    MM DOUBLE PRECISION,
    MN DOUBLE PRECISION,
    DA DOUBLE PRECISION,
    DB DOUBLE PRECISION,
    DJ DOUBLE PRECISION,
    DK DOUBLE PRECISION,
    DL DOUBLE PRECISION,
    DM DOUBLE PRECISION,
    NMA VARCHAR(255),
    NMB VARCHAR(255),
    NMC VARCHAR(255),
    NMD VARCHAR(255),
    NME VARCHAR(255),
    NMJ VARCHAR(255),
    NMK VARCHAR(255),
    NML VARCHAR(255),
    NMM VARCHAR(255),
    NMN VARCHAR(255),
    NDA VARCHAR(255),
    NDB VARCHAR(255),
    NDJ VARCHAR(255),
    NDK VARCHAR(255),
    NDL VARCHAR(255),
    NDM VARCHAR(255),
    NOTE VARCHAR(255),
    SPOSOBRASCH INTEGER)
AS
begin
--[15352]+
--[15354]

  ID_USER = ID_USER;

  for select
      MA, MB, MC, MD, ME, MJ, MK, ML, MM, MN/*15354*/,
      DA, DB, DJ, DK, DL, DM,
      NMA, NMB, NMC, NMD, NME, NMJ, NMK, NML, NMM, NMN/*15354*/,
      NDA, NDB, NDJ, NDK, NDL, NDM,
      NOTE, SPOSOBRASCH
  from LEVEL_INDEX_ITOG
  where ID_COMPOSE = :ID_COMPOSE
  into
      :MA, :MB, :MC, :MD, :ME, :MJ, :MK, :ML, :MM, :MN/*15354*/,
      :DA, :DB, :DJ, :DK, :DL, :DM,
      :NMA, :NMB, :NMC, :NMD, :NME, :NMJ, :NMK, :NML, :NMM, :NMN/*15354*/,
      :NDA, :NDB, :NDJ, :NDK, :NDL, :NDM,
      :NOTE, :SPOSOBRASCH
  do
    suspend;
end
^

--[15536,15352]
CREATE OR ALTER trigger A_SMETA_AU1 for A_SMETA
active after update position 1
as
declare variable SMETATYPE integer;
declare variable LOCKED integer;
declare variable LIDPRICE integer;
declare variable LIDNORMO integer;
declare variable LROW integer;
declare variable LCOST double precision;
declare variable LKOEF double precision; --CQ[7790]
declare variable LOUT_ID integer;
begin
  if (new.NOMERROD = 0)
  then /*     */
  if (  (old.RABMAT    is null and new.RABMAT    is null or old.RABMAT    = new.RABMAT    )
    and (old.TYPE_TRUD is null and new.TYPE_TRUD is null or old.TYPE_TRUD = new.TYPE_TRUD )
    and (old.TAB       is null and new.TAB       is null or old.TAB       = new.TAB       )
    and (old.NAME_ID   is null and new.NAME_ID   is null or old.NAME_ID   = new.NAME_ID   )
    and (old.ID_EDIZM  is null and new.ID_EDIZM  is null or old.ID_EDIZM  = new.ID_EDIZM  )
      and (old.BA is null and new.BA is null or old.BA = new.BA)
      and (old.BB is null and new.BB is null or old.BB = new.BB)
      and (old.BC is null and new.BC is null or old.BC = new.BC)
      and (old.BD is null and new.BD is null or old.BD = new.BD)
      and (old.BE is null and new.BE is null or old.BE = new.BE)
      and (old.BF is null and new.BF is null or old.BF = new.BF)
      and (old.BG is null and new.BG is null or old.BG = new.BG)
      and (old.BH is null and new.BH is null or old.BH = new.BH)
      and (old.BI is null and new.BI is null or old.BI = new.BI)
      and (old.BJ is null and new.BJ is null or old.BJ = new.BJ)

      -- MK CQ[13261]
      and (old.idnormativ is null and new.idnormativ is null or old.idnormativ = new.idnormativ)

      --CQ[TIMUR 13178]
      and (old.BN is null and new.BN is null or old.BN = new.BN)
      and (old.BO is null and new.BO is null or old.BO = new.BO)
      and (old.B_ITOGO is null and new.B_ITOGO is null or old.B_ITOGO = new.B_ITOGO)

      --[15536,15352]
      and (old.B_PR is null and new.B_PR is null or old.B_PR = new.B_PR) ) then
    SMETATYPE = :SMETATYPE; /*    */
  else
  begin
    if ( coalesce(old.RABMAT,10) <> coalesce(new.RABMAT,10) ) then --CQ[7755]
    begin
      delete from smeta_pricepos_info where id = new.ID ;
    end
  /*    -   */
    for select SMETATYPE, ID
      from A_SMETA
      where NOMERROD = new.ID
      into :SMETATYPE, :LOUT_ID
    do
    begin
      execute procedure S_SET_DORECALC(null, SMETATYPE, 0, 1)
        returning_values :LOCKED;
      --CQ[6945]  -          
      LIDNORMO = null;
      LIDPRICE = null;
      LROW = null;
      LCOST = null;
      LKOEF = null;
      select IDNORMO, IDPRICE, ROW, COST, KOEF from smeta_pricepos_info i where i.ID = new.ID
      into :LIDNORMO, :LIDPRICE, :LROW, :LCOST, :LKOEF;
      if ((LIDPRICE is not null) and (LIDPRICE <> 0)) then
      begin
        execute procedure set_smeta_priceposinfo(:LOUT_ID, :LIDPRICE,  :LIDNORMO, :LROW, :LCOST, :LKOEF);
      end
      else
      begin
        delete from smeta_pricepos_info where id = :LOUT_ID ;
      end
    end
  /*    */
    update A_SMETA
    set RABMAT = new.RABMAT,
        TYPE_TRUD = new.TYPE_TRUD,
        TAB = new.TAB,
        ALTTAB = new.ALTTAB,
        NAME_ID = new.NAME_ID,
        ID_EDIZM = new.ID_EDIZM,
        BA = new.BA,
        BB = new.BB,
        BC = new.BC,
        BD = new.BD,
        BE = new.BE,
        BF = new.BF,
        BG = new.BG,
        BH = new.BH,
        BI = new.BI,
        BJ = new.BJ,
        --CQ[TIMUR 13178]
        BN = new.BN,
        BO = new.BO,
        B_ITOGO = new.B_ITOGO,
        --CQ[TIMUR 13178]

        B_PR = new.B_PR, --[15536,15352]

        -- MK CQ[13261]
        idnormativ = new.idnormativ

    where NOMERROD = new.ID;
  end
end
^

--[15536,15352]
CREATE OR ALTER trigger A_SMETA_CENLVL_AU0 for A_SMETA_CENLVL
active after update position 0
AS
declare variable ID_REC_IN_ACT integer;
declare variable ID_S_RES integer;
declare variable RES_CHANGE integer;
declare variable SMSTR_CHANGE integer;
declare variable SMETATYPE integer;
declare variable LOCKED integer;
declare variable VN_USE_BB double precision;
-- MK 30.08.2013 CQ[11515] --->
--declare variable RES_BB double precision;
--declare variable RES_BC double precision;
--declare variable RES_BD double precision;
--declare variable RES_BE double precision;
-- MK 30.08.2013 CQ[11515] <---
declare variable VN_RABMAT integer;
declare variable VN_CURR_SPREAD integer;
declare variable VN_CURR_NULL integer;
declare variable VN_BASE_CALC_INFO integer;
declare variable VN_BASE_CALC_INFO_1 integer;

declare IDNORMATIV integer; --<<[12578.4]
begin

  select ID_S_RES, RABMAT
  from A_SMETA
  where ID = new.ID
  into :ID_S_RES, :VN_RABMAT;

  -- MK 30.08.2013 CQ[11515] --->
  --select BB, BC, BD, BE from A_S_RES_CENLVL where (ID = :ID_S_RES) and (IDCENLVL = new.IDCENLVL)
  --into :RES_BB, :RES_BC, :RES_BD, :RES_BE;
  -- MK 30.08.2013 CQ[11515] <---

  SMSTR_CHANGE = 1;
  RES_CHANGE = 1;
  if (ID_S_RES is null) then
    RES_CHANGE = 0;

  -- MK 30.08.2013 CQ[11515] --->
  if (
       (RES_CHANGE = 1) and
       (coalesce(old.BB, 0) = coalesce(new.BB, 0)) and
       (coalesce(old.BC, 0) = coalesce(new.BC, 0)) and
       (coalesce(old.BD, 0) = coalesce(new.BD, 0)) and
       (coalesce(old.BE, 0) = coalesce(new.BE, 0)) and
       -- MK CQ[12391]
       ((VN_RABMAT <> 3) or (coalesce(old.curr_cena, 0) = coalesce(new.curr_cena, 0)))
     )

  --if (
  --     (RES_CHANGE = 0) and
  --     ((old.BB is null and new.BB is null and RES_BB is null) or old.BB = new.BB or new.BB = RES_BB) and
  --     ((old.BC is null and new.BC is null and RES_BC is null) or old.BC = new.BC or new.BC = RES_BC) and
  --     ((old.BD is null and new.BD is null and RES_BD is null) or old.BD = new.BD or new.BD = RES_BD) and
  --     ((old.BE is null and new.BE is null and RES_BE is null) or old.BE = new.BE or new.BE = RES_BE)
  --   )
  -- MK 30.08.2013 CQ[11515] <---
  then
    RES_CHANGE = 0;
  -- MK 30.08.2013 CQ[11515] --->
  --else
  --  RES_CHANGE = 1;
  -- MK 30.08.2013 CQ[11515] <---

  if ( -- MK 30.08.2013 CQ[11515] (RES_CHANGE = 0) and
       (old.BA is null and new.BA is null or old.BA = new.BA) and
       -- MK CQ[12391] --->
       (old.BB is null and new.BB is null or old.BB = new.BB) and
       (old.BC is null and new.BC is null or old.BC = new.BC) and
       (old.BD is null and new.BD is null or old.BD = new.BD) and
       (old.BE is null and new.BE is null or old.BE = new.BE) and
       (old.curr_cena is null and new.curr_cena is null or old.curr_cena = new.curr_cena) and
       -- MK CQ[12391] <---
       (old.BF is null and new.BF is null or old.BF = new.BF) and
       (old.BG is null and new.BG is null or old.BG = new.BG) and
       (old.BH is null and new.BH is null or old.BH = new.BH) and
       (old.BI is null and new.BI is null or old.BI = new.BI) and
       (old.BJ is null and new.BJ is null or old.BJ = new.BJ) and

       --CQ[TIMUR 13178]
       (old.BN is null and new.BN is null or old.BN = new.BN) and
       (old.BO is null and new.BO is null or old.BO = new.BO) and
       (old.B_ITOGO is null and new.B_ITOGO is null or old.B_ITOGO = new.B_ITOGO) and
       --CQ[TIMUR 13178]

       (old.B_PR is null and new.B_PR is null or old.B_PR = new.B_PR) and --[15536,15352]

       -- MK CQ[13174] --->
       --   :
       -- 3 (bciUseNDS):    
       -- 5 (bciNeedRecalcItogoB):    ""
       (bin_and(coalesce(old.base_calc_info, 0), 104) = (bin_and(coalesce(new.base_calc_info, 0), 104)))
         -- 8(bciUseNDS)+32(bciNeedRecalcItogoB)+64(bciBBOtpFromSb)=104  --<<[14353] 40 = 101000
       -- CQ[12488]
       --(bin_and(coalesce(old.base_calc_info, 0), 8) = (bin_and(coalesce(new.base_calc_info, 0), 8))) -- 8 = 1000
       -- MK CQ[13174] <---
     )
  then
    SMSTR_CHANGE = 0;
  else
    SMSTR_CHANGE = 1;


  -- MK CQ[12391] --->
  -- MK CQ[13174] --->
  --   5 (bciNeedRecalcItogoB)
  VN_BASE_CALC_INFO_1 = bin_and(new.base_calc_info, 111);
    -- 7(cbCalcMask)+8(bciUseNDS)+32(bciNeedRecalcItogoB)+64(bciBBOtpFromSb)=111 --<<[14353] 47 = 101111
  --VN_BASE_CALC_INFO_1 = bin_and(new.base_calc_info, 15); -- 15 = 01111 CQ[12488]
  -- MK CQ[13174] <---
  VN_BASE_CALC_INFO = bin_and(new.base_calc_info, 7/*cbCalcMask*/);

  -- MK 25.09.2014 .  .  --->
  --VN_CURR_SPREAD = 0;
  --if ((:VN_RABMAT = 3) and (:VN_BASE_CALC_INFO in (1, 7))) then -- (cbCalc, cbNeedCalc)
  --  VN_CURR_SPREAD = 1;
  --VN_CURR_NULL = 0;
  --if ((:VN_RABMAT = 3) and (:VN_BASE_CALC_INFO = 4)) then       -- (cbDirect)
  --  VN_CURR_NULL = 1;
  -- MK CQ[12391] <---

  /*  ,   . */
  if (RES_CHANGE = 1) then
  begin
  -- MK 25.09.2014 --->
  --    http://forum.smeta.ru/post104236.html#p104236
  --    .       
  --        
  --      (  ..  )
  VN_CURR_SPREAD = 0;
  --      "  " -  
  -- (    )
  if ((:VN_RABMAT = 3) and (bin_and(new.base_calc_info, 8/*bciUseNDS*/) = 0)) then  -- 8 = 1000
    VN_CURR_SPREAD = 1;

  VN_CURR_NULL = 0;
  if (:VN_RABMAT = 3) then
    VN_CURR_NULL = 1;
  -- MK 25.09.2014 <---

    /*  ,   .       */
    if (ID_S_RES is not null) then
    begin
      -- MK CQ[12174] --->
      VN_USE_BB = new.BB;
      if (new.curr_cena_info = 3) then -- cciVC
        VN_USE_BB = new.curr_cena;
      -- MK CQ[12174] <---

      update A_S_RES_CENLVL
      set IDZONE =      new.IDZONE,
          ID_LEVEL_VC = new.ID_LEVEL_VC,
          BB =          :VN_USE_BB, -- CQ[12174]new.BB,
          BC =          new.BC,
          BD =          new.BD,
          BE =          new.BE,
          BASE_INFO =   new.BASE_INFO,
          -- MK CQ[12391]
          CURR_BB = case
                      when (:VN_CURR_SPREAD = 1) then
                        --<<>>[12907]new.curr_cena
                        nullif(new.curr_cena, 0)
                      else
                        case when (:VN_CURR_NULL = 1) then null else CURR_BB end
                    end

      where (ID = :ID_S_RES) and (IDCENLVL = new.IDCENLVL);
--      exception d_wrong_params 'dfbds';
    end
  end

    /*     */
  if (SMSTR_CHANGE = 1) then
  begin
    /*
       ,       
     BASE_INFO <> 2,        ,     .
     BASE_INFO = 2,          
    */
    -- MK CQ[12391] --->
    --            
    if ((:VN_BASE_CALC_INFO in (4/*cbDirect*/, 1/*cbCalc*/)) or
        (new.BASE_INFO = 2/*csDirect*/)) then -- MK CQ[13256]
    --if (new.BASE_INFO = 2/*csDirect*/) then
    -- MK CQ[12391] <---
    begin
      /*       */
      --CQ[10213] -    1 ,      
      if (exists(select * from LEVEL_COST_SIMPLE where ID = new.IDCENLVL and ATYPE = 1)) then
      begin
        for select ID, SMETATYPE,
                   RABMAT,                -- MK CQ[12391]
                   IDNORMATIV --<<[12578.4]
        from A_SMETA
        where NOMERROD = new.ID
        into :ID_REC_IN_ACT, :SMETATYPE,
             :VN_RABMAT,                  -- MK CQ[12391]
             :IDNORMATIV --<<[12578.4]
        do
        begin
          -- MK CQ[12391] --->
          VN_CURR_SPREAD = 0;
          if (:VN_RABMAT = 3) then
          begin /* --[12578.4]
            select first 1 bin_and(sc.base_calc_info, 16)     -- 16 = 10000
            from a_smeta_cenlvl sc
            where (sc.id = :ID_REC_IN_ACT) and (sc.idcenlvl = new.idcenlvl)
            into :VN_CURR_SPREAD; */
            --<<[12578.4]
            select
                case when new.idcenlvl =
                  case when :IDNORMATIV <> 0 then APPLY_TO_ALL_IDLEVEL_SNB else APPLY_TO_ALL_IDLEVEL end
                then 1 else 0 end
              from A_O_FACTPARAMS
              where NUMBER = :SMETATYPE
              into :VN_CURR_SPREAD;
          end
          -- MK CQ[12391] <---

          update a_smeta_cenlvl
          set BA = new.BA,
              BB = new.BB,
              BC = new.BC,
              BD = new.BD,
              BE = new.BE,
              BF = new.BF,
              BG = new.BG,
              BH = new.BH,
              BI = new.BI,
              BJ = new.BJ,
              --CQ[TIMUR 13178]
              BN = new.BN,
              BO = new.BO,
              B_ITOGO = new.B_ITOGO,
              --CQ[TIMUR 13178]

              B_PR = new.B_PR, --[15536,15352]

              -- MK CQ[12391] --->
              -- MK 19.09.2014        
              CURR_CENA = case when (IDCENLVL = new.idcenlvl) then new.curr_cena else CURR_CENA end,
              --<<[14406]     :
              CURR_CENA_INFO = case when (IDCENLVL = new.idcenlvl) then new.CURR_CENA_INFO else CURR_CENA_INFO end,

              -- MK CQ[13174] --->
              BASE_CALC_INFO = case
                                 when (IDCENLVL = new.idcenlvl) then
                                   :VN_BASE_CALC_INFO_1

                                 --    5 (bciNeedRecalcItogoB)
                                 when (bin_and(new.base_calc_info, 32) = 0) then
                                   setbit(BASE_CALC_INFO, 5, 0)
                                 else
                                   setbit(BASE_CALC_INFO, 5, 1)
                               end

              -- MK 19.09.2014 CQ[12578]  "  ..."   
              --BASE_CALC_INFO = case when (IDCENLVL = new.idcenlvl) then :VN_BASE_CALC_INFO_1 else BASE_CALC_INFO end
              -- MK CQ[13174] <---

              --CURR_CENA = new.curr_cena,
              --BASE_CALC_INFO = bin_or(bin_and(BASE_CALC_INFO, 16), :VN_BASE_CALC_INFO_1) -- 16 = 10000
              -- MK CQ[12391] <---

          where (ID = :ID_REC_IN_ACT) and --CQ[10213]    ,    (. ) and (IDCENLVL = new.IDCENLVL);
                -- MK CQ[12391]      "    ",
                --    ,  -   
                ((:VN_CURR_SPREAD <> 0) or (IDCENLVL = new.idcenlvl));



          execute procedure S_SET_DORECALC(null, SMETATYPE, 0, 1)
          returning_values :LOCKED;
        end
      end
    end
  end

end
^

--[15546]
CREATE OR ALTER PROCEDURE CHECK_CAN_CENLVL_USE_INDEX (
    ID_CENLVL INTEGER,
    IDCLASS INTEGER)
RETURNS (
    IS_CAN_USE_INDEX INTEGER)
AS
declare variable VN_ID_COMPOSE integer;
declare variable VN_COMPOSE_ATYPE integer;
declare variable VN_ID_MONTH integer;

declare variable VN_MA double precision;
declare variable VN_MB double precision;
declare variable VN_MC double precision;
declare variable VN_MD double precision;
declare variable VN_ME double precision;
declare variable VN_MJ double precision;
declare variable VN_MK double precision;
declare variable VN_ML double precision;
declare variable VN_MM double precision;
declare variable VN_MN double precision; /*15354*/

declare variable VN_DA double precision;
declare variable VN_DB double precision;
declare variable VN_DJ double precision;
declare variable VN_DK double precision;
declare variable VN_DL double precision;
declare variable VN_DM double precision;
begin
--[15352]
--[15354]
  IS_CAN_USE_INDEX = 0;

  for select c.id, c.atype
  from level_compose c
  where (c.id_level = :ID_CENLVL) and (c.idclass = :IDCLASS) and
        (c.atype in (1, 3)) -- ,   
  into :VN_ID_COMPOSE, :VN_COMPOSE_ATYPE do
  begin
    -- 
    if (VN_COMPOSE_ATYPE = 1) then
    begin
      select first 1 coalesce(i.id_month, 0),
                     i.ma, i.mb, i.mj, i.mk, i.da, i.db, i.dj, i.dk
      from level_index i
      where (i.id_compose = :VN_ID_COMPOSE)
      into :VN_ID_MONTH,
           :VN_MA, :VN_MB, :VN_MJ, :VN_MK, :VN_DA, :VN_DB, :VN_DJ, :VN_DK;

      --   
      if (VN_ID_MONTH > 0) then
      begin
        --   
        if (exists (select * from b_reestr where (id = :VN_ID_MONTH) and (rabmat = 100))) then
        begin
          IS_CAN_USE_INDEX = 1;
          suspend;
          exit;
        end
      end

      --    
      if ((VN_MA <> 1) or (VN_MB <> 1) or (VN_MJ <> 1) or (VN_MK <> 1) or
          (VN_DA <> 1) or (VN_DB <> 1) or (VN_DJ <> 1) or (VN_DK <> 1)
         ) then
      begin
        IS_CAN_USE_INDEX = 1;
        suspend;
        exit;
      end
    end

    --   
    if (VN_COMPOSE_ATYPE = 3) then
    begin
      select first 1 MA, MB, MC, MD, ME, MJ, MK, ML, MM,
                     MN/*15354*/, DA, DB, DJ, DK, DL, DM
      from LEVEL_INDEX_ITOG
      where (ID_COMPOSE = :VN_ID_COMPOSE)
      into :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
           :VN_MN/*15354*/, :VN_DA, :VN_DB, :VN_DJ, :VN_DK, :VN_DL, :VN_DM;

      --    
      if ((VN_MA <> 1) or (VN_MB <> 1) or (VN_MC <> 1) or (VN_MD <> 1) or (VN_ME <> 1) or
          (VN_MJ <> 1) or (VN_MK <> 1) or (VN_ML <> 1) or (VN_MM <> 1) or
          (coalesce(nullif(:VN_MN, 0), 1) <> 1/*15354*/) or --[15546,15352]
          (VN_DA <> 1) or (VN_DB <> 1) or (VN_DJ <> 1) or (VN_DK <> 1) or
          (VN_DL <> 1) or (VN_DM <> 1)
         ) then
      begin
        IS_CAN_USE_INDEX = 1;
        suspend;
        exit;
      end
    end
  end

  suspend;
end
^

--[15546]
CREATE OR ALTER PROCEDURE GET_ONE_INDEX_APPLY_INFO (
    IDUSER INTEGER,
    IDSMETASTR INTEGER,
    IDLEVEL INTEGER,
    NEW_LEVEL INTEGER)
RETURNS (
    OUT_INDEX_INFO INTEGER,
    OUT_IDINDEX INTEGER,
    OUT_IND_TYPE VARCHAR(50),
    OUT_IND_YEAR INTEGER,
    OUT_IND_MONTH INTEGER,
    OUT_PUNKTIND VARCHAR(42))
AS
declare variable SMETATYPE integer;
declare variable IDHIER integer;
declare variable ID integer;
declare variable ATYPE integer;
declare variable IDNORMATIV integer;
declare variable RABMAT integer;
declare variable IDPODGROUP integer;
declare variable TIPRAB integer;
declare variable VIDRAB integer;
declare variable ID_LEVEL_INDEX integer;
declare variable LEVEL_IDINDEX integer;
declare variable ID_COMPOSE_VC integer;
declare variable ID_COMPOSE_INDEX integer;
declare variable COMPOSE_IDINDEX integer;
declare variable VN_IDINDEX integer;
declare variable VN_MA double precision;
declare variable VN_MB double precision;
declare variable VN_MC double precision;
declare variable VN_MD double precision;
declare variable VN_ME double precision;
declare variable VN_MF double precision;
declare variable VN_MG double precision;
declare variable VN_MH double precision;
declare variable VN_MI double precision;
declare variable VN_PUNKTIND varchar(42);
declare variable VN_SPOSOB_RASCH integer;
declare variable VN_RES_INDEX integer;
declare variable IDCLASS integer;
declare variable NORM_GUID varchar(100);
declare variable ITOG_DIRTY_MASK integer;
declare variable DIRTY_MASK integer;
declare variable VN_MJ double precision;
declare variable VN_MK double precision;
declare variable VN_ML double precision;
declare variable VN_MM double precision;
declare VN_M_PR double precision; --[15352]
declare variable VN_DA double precision;
declare variable VN_DB double precision;
declare variable VN_DC double precision;
declare variable VN_DD double precision;
declare variable VN_DE double precision;
declare variable VN_DJ double precision;
declare variable VN_DK double precision;
declare variable VN_DL double precision;
declare variable VN_DM double precision;
declare variable NEED_APPLY_INDEX integer;
declare variable FC_IDREESTR integer;
declare variable FC_ATYPE integer;
declare variable FC_RABMAT integer;
declare variable FC_IDNORMATIV integer;
declare variable FC_IDPODGROUP integer;
declare variable FC_PUNKTIND varchar(42);
declare variable FC_TIPRAB integer;
declare variable FC_VIDRAB integer;
declare variable TAB varchar(42);

--<[14593]>
declare INDEX_DX_ONLY integer;
declare USE_MULTIRULES integer; --</>
begin
--[15352]

  --    A_S_PARAMS_TO_SMETA_NL_ONE
  --   !!!

  NEED_APPLY_INDEX = 1;

  --    
  for select S.ID, S.ATYPE,
      S.IDHIER, S.SMETATYPE,
      S.IDNORMATIV, S.RABMAT, S.KODIR_PODGROUP, S.TIPRAB, S.VIDRAB,
      I.ID_LEVEL_INDEX, I.IDINDEX,
      coalesce(nullif(I.PUNKTIND, ''), S.PUNKTIND), S.TAB, S.NORM_GUID,
      I.MJ, I.MK, I.ML, I.MM,
      I.M_PR, --[15352]
      I.DA, I.DB, I.DC, I.DD, I.DE, I.DJ, I.DK, I.DL, I.DM
    from A_SMETA S
    left outer join A_SMETA_INDLVL I on I.ID = S.ID and I.IDCENLVL = :IDLEVEL
    where S.ID = :IDSMETASTR
    into :ID, :ATYPE,
      :IDHIER, :SMETATYPE,
      :IDNORMATIV, :RABMAT, :IDPODGROUP, :TIPRAB, :VIDRAB,
      :ID_LEVEL_INDEX, :LEVEL_IDINDEX,
      :OUT_PUNKTIND, :TAB, :NORM_GUID,
      :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
      :VN_M_PR, --[15352]
      :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM
  do
  begin
    if (:ATYPE = 17) then -- SmRec only
    begin
      if (:SMETATYPE > 999) then
        IDCLASS = :SMETATYPE;
      else
        execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1/*ObgectType*/)
          returning_values :IDCLASS;
    end
    else
      exit;


    execute procedure NL_GET_NORMBASE_LINK(:IDUSER, :RABMAT, :IDNORMATIV,
                                           :IDPODGROUP, :NORM_GUID, :TAB)
    returning_values :FC_IDREESTR, :FC_RABMAT, :FC_IDNORMATIV, :FC_IDPODGROUP;
    FC_ATYPE = :ATYPE;
    FC_PUNKTIND = :OUT_PUNKTIND;
    FC_TIPRAB = :TIPRAB;
    FC_VIDRAB = :VIDRAB;

  --  
    execute procedure NL_FIND_COMPOSE_EX(
        :IDLEVEL, :IDCLASS, :IDUSER,
        :FC_IDREESTR,
        :FC_TIPRAB, :FC_VIDRAB, :FC_ATYPE, :FC_RABMAT,
        :IDHIER,
        :FC_PUNKTIND, :FC_IDNORMATIV, :FC_IDPODGROUP)
      returning_values :ID_COMPOSE_VC, :ID_COMPOSE_INDEX, :INDEX_DX_ONLY; --[14593]


    COMPOSE_IDINDEX = null;
  --    (  :ID_COMPOSE_INDEX)
    select CI.ID_MONTH, CI.DIRTY_MASK
      from LEVEL_INDEX CI
      where CI.ID_COMPOSE = :ID_COMPOSE_INDEX
      into :COMPOSE_IDINDEX, :DIRTY_MASK;

  --      
    select CT.DIRTY_MASK
      from LEVEL_INDEX_ITOG CT
      where CT.ID_COMPOSE = :ID_COMPOSE_INDEX
      into :ITOG_DIRTY_MASK;

  --  ...

  -- ...
  --  :   :COMPOSE_IDINDEX   :ID_COMPOSE_INDEX  _
  -- :COMPOSE_IDINDEX=0  :ID_COMPOSE_INDEX    
  --    
    VN_RES_INDEX = null;
    if ( coalesce(:COMPOSE_IDINDEX, 0) <> coalesce(:LEVEL_IDINDEX, 0)
      or coalesce(:ID_COMPOSE_INDEX, 0) <> coalesce(:ID_LEVEL_INDEX, 0)
      or coalesce(:ITOG_DIRTY_MASK, 0) <> 0
      or coalesce(:DIRTY_MASK, 0) <> 0
      or coalesce(:NEW_LEVEL, 0) <> 0)
    then
    begin
      --  
      execute procedure A_S_GET_INDEX_NL_NEW(
                :IDLEVEL, :IDUSER, :ATYPE,
                :OUT_PUNKTIND, :ID_COMPOSE_INDEX, :ID,
                :NEED_APPLY_INDEX)
            returning_values :VN_IDINDEX, :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME,
                :VN_MF, :VN_MG, :VN_MH, :VN_MI,
                :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
                :VN_M_PR, --[15352]
                :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM,
                :VN_PUNKTIND, :VN_SPOSOB_RASCH, :VN_RES_INDEX;
        -- :VN_RES_INDEX > 0:        ,
        --     ...      
      --<<[14593]
      if (:INDEX_DX_ONLY <> 0) then
      begin
        VN_MA = 1.0;
        VN_MB = 1.0; VN_MC = 1.0; VN_MD = 1.0; VN_ME = 1.0;
        VN_MF = 0.0; VN_MG = 0.0;
        VN_MH = 1.0; VN_MI = 1.0;
        VN_MJ = 1.0; VN_MK = 1.0; VN_ML = 1.0; VN_MM = 1.0;
        VN_M_PR = 1.0; --[15352]
      end
    end


    --        
    if (:VN_RES_INDEX in (2, 4, 5)) then -- ciFromSbInd, ciFromItog, ciFromSbTCH
    begin
      --   
      if ((VN_MA <> 1) or (VN_MB <> 1) or (VN_MC <> 1) or (VN_MD <> 1) or (VN_ME <> 1) or
          (VN_MF <> 0) or (VN_MG <> 0) or (VN_MH <> 1) or (VN_MI <> 1) or (VN_MJ <> 1) or
          (VN_MK <> 1) or (VN_ML <> 1) or (VN_MM <> 1) or
          (coalesce(nullif(:VN_M_PR, 0), 1) <> 1) or --[15352,15546]
          (VN_DA <> 1) or (VN_DB <> 1) or
          (VN_DC <> 1) or (VN_DD <> 1) or (VN_DE <> 1) or (VN_DJ <> 1) or (VN_DK <> 1) or
          (VN_DL <> 1) or (VN_DM <> 1)) then
      begin
        if ((coalesce(:NEW_LEVEL, 0) <> 0) or
             (exists(select * from A_SMETA_INDLVL where (ID = :ID)
                  and (IDCENLVL = :IDLEVEL)
                  and (coalesce(INDEX_INFO, 0) <> 3)  -- ciDirect
                  and (coalesce(IDINDEX, 0) <> coalesce(:VN_IDINDEX, 0)
                       or coalesce(MA, 0) <> coalesce(:VN_MA, 0)
                       or coalesce(MB, 0) <> coalesce(:VN_MB, 0)
                       or coalesce(MC, 0) <> coalesce(:VN_MC, 0)
                       or coalesce(MD, 0) <> coalesce(:VN_MD, 0)
                       or coalesce(ME, 0) <> coalesce(:VN_ME, 0)
                       or coalesce(MF, 0) <> coalesce(:VN_MF, 0)
                       or coalesce(MG, 0) <> coalesce(:VN_MG, 0)
                       or coalesce(MH, 0) <> coalesce(:VN_MH, 0)
                       or coalesce(MI, 0) <> coalesce(:VN_MI, 0)
                       or coalesce(INDEX_SPOSOBRASCH, 0) <> coalesce(:VN_SPOSOB_RASCH, 0)
                       or coalesce(MJ, 0) <> coalesce(:VN_MJ, 0)
                       or coalesce(MK, 0) <> coalesce(:VN_MK, 0)
                       or coalesce(ML, 0) <> coalesce(:VN_ML, 0)
                       or coalesce(MM, 0) <> coalesce(:VN_MM, 0)
                       or coalesce(M_PR, 0) <> coalesce(:VN_M_PR, 0) --[15352]
                       or coalesce(DA, 0) <> coalesce(:VN_DA, 0)
                       or coalesce(DB, 0) <> coalesce(:VN_DB, 0)
                       or coalesce(DC, 0) <> coalesce(:VN_DC, 0)
                       or coalesce(DE, 0) <> coalesce(:VN_DE, 0)
                       or coalesce(DJ, 0) <> coalesce(:VN_DJ, 0)
                       or coalesce(DK, 0) <> coalesce(:VN_DK, 0)
                       or coalesce(DL, 0) <> coalesce(:VN_DL, 0)
                       or coalesce(DM, 0) <> coalesce(:VN_DM, 0)
                      )
                  )
             )
           ) then
        begin
          OUT_INDEX_INFO = VN_RES_INDEX;
          OUT_IDINDEX = VN_IDINDEX;
          OUT_PUNKTIND = VN_PUNKTIND;
  
          if ((coalesce(OUT_IDINDEX, 0) > 0) and (VN_RES_INDEX = 2)) then -- 2 -> ciFromSbInd
          begin
            select first 1 r.god, r.orderview, r.indtype
            from b_reestr r
            where (r.id = :OUT_IDINDEX)
            into :OUT_IND_YEAR, :OUT_IND_MONTH, :OUT_IND_TYPE;
          end
          else
          begin
            OUT_IND_YEAR = null;
            OUT_IND_MONTH = null;
            OUT_IND_TYPE = null;
          end

          suspend;
        end
      end
    end
  end
end
^

--[15546]
CREATE OR ALTER PROCEDURE GET_ONE_INDEX_CHARGE_INFO (
    ID_REC INTEGER,
    CENLVL_ID INTEGER)
RETURNS (
    TAB VARCHAR(42),
    CENLVL_NAME VARCHAR(250),
    CENLVL_YEAR INTEGER,
    CENLVL_PERIOD INTEGER,
    CENLVL_MONTH INTEGER,
    ATYPE INTEGER,
    INDEX_INFO INTEGER,
    IDINDEX INTEGER,
    IND_TYPE VARCHAR(50),
    IND_YEAR INTEGER,
    IND_MONTH INTEGER,
    PUNKTIND VARCHAR(42),
    IS_HAVE_INDEX INTEGER)
AS
declare variable VN_SMETATYPE integer;
declare variable VN_IDHIER integer;
declare variable VN_IDCLASS integer;

declare variable VN_MA double precision;
declare variable VN_MB double precision;
declare variable VN_MC double precision;
declare variable VN_MD double precision;
declare variable VN_ME double precision;
declare variable VN_MF double precision;
declare variable VN_MG double precision;
declare variable VN_MH double precision;
declare variable VN_MI double precision;
declare variable VN_MJ double precision;
declare variable VN_MK double precision;
declare variable VN_ML double precision;
declare variable VN_MM double precision;
declare VN_M_PR double precision; --[15546,15352]

declare variable VN_DA double precision;
declare variable VN_DB double precision;
declare variable VN_DC double precision;
declare variable VN_DD double precision;
declare variable VN_DE double precision;
declare variable VN_DJ double precision;
declare variable VN_DK double precision;
declare variable VN_DL double precision;
declare variable VN_DM double precision;
begin
--[15546,15352]
  IS_HAVE_INDEX = 0;

  ATYPE = null;
  select first 1 s.atype, s.tab, s.smetatype, s.idhier
  from a_smeta s
  where (s.id = :ID_REC)
  into :ATYPE, :TAB, :VN_SMETATYPE, :VN_IDHIER;

  if (ATYPE is not null) then
  begin
    --     
    select first 1 i.index_info, i.idindex, i.punktind,
                   i.MA, i.MB, i.MC, i.MD, i.ME, i.MF, i.MG, i.MH, i.MI,
                   i.MJ, i.MK, i.ML, i.MM,
                   i.M_PR, --[15546,15352]
                   i.DA, i.DB, i.DC, i.DD, i.DE,
                   i.DJ, i.DK, i.DL, i.DM
    from a_smeta_indlvl i
    where (i.id = :ID_REC) and (i.idcenlvl = :CENLVL_ID)
    into :INDEX_INFO, :IDINDEX, :PUNKTIND,
         :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH, :VN_MI,
         :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
         :VN_M_PR, --[15546,15352]
         :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE,
         :VN_DJ, :VN_DK, :VN_DL, :VN_DM;

    --   
    if ((VN_MA <> 1) or (VN_MB <> 1) or (VN_MC <> 1) or (VN_MD <> 1) or (VN_ME <> 1) or
        (VN_MF <> 0) or (VN_MG <> 0) or (VN_MH <> 1) or (VN_MI <> 1) or (VN_MJ <> 1) or
        (VN_MK <> 1) or (VN_ML <> 1) or (VN_MM <> 1) or
        (coalesce(nullif(:VN_M_PR, 0), 1) <> 1) or --[15546,15352]
        (VN_DA <> 1) or (VN_DB <> 1) or
        (VN_DC <> 1) or (VN_DD <> 1) or (VN_DE <> 1) or (VN_DJ <> 1) or (VN_DK <> 1) or
        (VN_DL <> 1) or (VN_DM <> 1)) then

      IS_HAVE_INDEX = 1;


    --   -        
    if (IS_HAVE_INDEX = 1) then
    begin
      if ((coalesce(IDINDEX, 0) > 0) and (INDEX_INFO = 2)) then -- 2 -> ciFromSbInd
      begin
        select first 1 r.god, r.orderview, r.indtype
        from b_reestr r
        where (r.id = :IDINDEX)
        into :IND_YEAR, :IND_MONTH, :IND_TYPE;
      end

      if (VN_SMETATYPE > 999) then
        VN_IDCLASS = VN_SMETATYPE;
      else
        execute procedure A_H_GET_ID_PARENTATYPE(:VN_IDHIER, 1)
        returning_values (:VN_IDCLASS);
  
      --    
      select first 1 c.name, c.lyear, c.lperiod, c.lmonth
      from level_cost c
      where (c.idobject = :VN_IDCLASS) and (c.id = :CENLVL_ID)
      into :CENLVL_NAME, :CENLVL_YEAR, :CENLVL_PERIOD, :CENLVL_MONTH;
    end
  end


  suspend;
end
^

--[15559]
/* 
create or alter procedure B_IMP_I_PODGROUP (
*/
-- Voyager CQ[15363]
/* 
create or alter procedure IMP_SMREC_FROM_XML (
*/
-- CQ[15361]
create or alter procedure L_EXP_A_SMETA_N (
    ID_OBJ integer,
    IN_SMETATYPE integer,
    ID_USER integer)
returns (
    ID integer,
    IDHIER integer,
    SMETATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE smallint,
    RABMAT integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NAME_ID integer,
    ID_EDIZM integer,
    EDIZM_TYPE integer,
    KOLL double precision,
    SKOLL varchar(255),
    NORMARASH double precision,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    BN double precision,
    BO double precision,
    B_ITOGO double precision,
    B_PR double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    VRPZ integer,
    IDTIPR integer,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    K_ITOGO varchar(50),
    K_PR varchar(50),
    PUNKTIND varchar(42),
    SSTCH integer,
    KODZAK integer,
    KODGP integer,
    KODSP integer,
    KODISP integer,
    NACH date,
    OKONCH date,
    TIPRAB integer,
    IDNORMATIV integer,
    IDNORMATIVUNIQ integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ISGROUPOKP integer,
    ARPS_OTHER blob sub_type 0 segment size 80,
    DORECALC smallint,
    ID_S_RES integer,
    NOMERROD integer,
    PR_ADDED_REC integer,
    NOMERROD1 integer,
    PR_NUMBER1 integer,
    PR_NUMBER2 integer,
    PR_NUMBER3 integer,
    PR_VSEGO double precision,
    TCH_GUID varchar(100),
    NORM_GUID varchar(100),
    STATUS_REC_CEN integer,
    VIDRAB integer,
    UTV integer,
    CORRECTNODE blob sub_type 0 segment size 80,
    CORRECTNODE_1 blob sub_type 0 segment size 80,
    ASUBTYPE integer,
    CLCMODE integer,
    PRICE_GUID varchar(50),
    PRICE_NORMOTAB varchar(42),
    PRICE_NORMOGUID varchar(100),
    ROW integer,
    TYPE_TRUD integer,
    KOEF double precision,
    IDFORMULS integer,
    CREATENAME_UW varchar(100),
    CREATEDATE_UW date,
    CONFIRMNAME_UW varchar(100),
    CONFIRMDATE_UW date,
    CHANGE_NAME_UW varchar(100),
    CHANGE_DATE_UW date)
AS
--declare variable hatype integer;
declare variable price_normoid integer;
/*
--  -  
--  -  
    EA double precision,
    EB double precision,
    EC double precision,
    ED double precision,
    EE double precision,
    EF double precision,
    EG double precision,
    EH double precision,
    EI double precision,
    EJ double precision,
    EK double precision,
--  -  
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
--  -  
--  -  
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
--   ... ,     
    SEA blob sub_type 0 segment size 80,
    SEB blob sub_type 0 segment size 80,
    SEC blob sub_type 0 segment size 80,
    SED blob sub_type 0 segment size 80,
    SEE blob sub_type 0 segment size 80,
    SEF blob sub_type 0 segment size 80,
    SEG blob sub_type 0 segment size 80,
    SEH blob sub_type 0 segment size 80,
    SEI blob sub_type 0 segment size 80,
    SEJ blob sub_type 0 segment size 80,
    SEK blob sub_type 0 segment size 80,
    SRA blob sub_type 0 segment size 80,
    SRB blob sub_type 0 segment size 80,
    SRC blob sub_type 0 segment size 80,
    SRD blob sub_type 0 segment size 80,
    SRE blob sub_type 0 segment size 80,
    SRF blob sub_type 0 segment size 80,
    SRG blob sub_type 0 segment size 80,
    SRH blob sub_type 0 segment size 80,
    SRI blob sub_type 0 segment size 80,
    SRJ blob sub_type 0 segment size 80,
    SRK blob sub_type 0 segment size 80,
    SRL blob sub_type 0 segment size 80,
    SRM blob sub_type 0 segment size 80)
*/
begin
--[15352]+
/*
      
     L_EXP_A_SMETA
*/
   for select ID
       from L_EXP_A_SMETA_IDS(:ID_OBJ, :IN_SMETATYPE, :ID_USER)
       into :ID
   do
   --for select IDHIER, atype from L_EXP_H_SELTREE ( :ID_USER , :ID_OBJ )
   --    into  :IDHIER, hatype
   --do
   --  if ( hatype <> 0 ) then
       for select --a.ID,
             a.IDHIER, a.SMETATYPE, a.NUMBER1, a.NUMBER2, a.NUMBER3,
             a.SLAVEPARENT, a.ATYPE, a.RABMAT, a.TAB, a.ALTTAB, a.NAME_ID,
             a.ID_EDIZM, a.EDIZM_TYPE, a.KOLL, a.SKOLL, a.NORMARASH,
             a.BA, a.BB, a.BC, a.BD, a.BE, a.BF, a.BG, a.BH, a.BI, a.BJ,
             a.BN, a.BO, a.B_ITOGO, -- CQ[13182]
             --a.EA, a.EB, a.EC, a.ED, a.EE, a.EF, a.EG, a.EH, a.EI, a.EJ, a.EK,
             --a.RA, a.RB, a.RC, a.RD, a.RE, a.RF, a.RG, a.RH, a.RI, a.RJ, a.RK, a.RL, a.RM,
             a.PA, a.PB, a.PC, a.PD, a.PE, a.VRPZ, a.IDTIPR,
             a.KA, a.KB, a.KC, a.KD, a.KE, a.KF,a.KG, a.KH, a.KI, a.KJ, a.KK, a.KL, a.KM,
             a.PUNKTIND,
             --a.MA, a.MB, a.MC, a.MD, a.ME, a.MF, a.MG, a.MH, a.MI, a.MJ, a.MK, a.ML,
             a.SSTCH, a.KODZAK, a.KODGP, a.KODSP, a.KODISP, a.NACH, a.OKONCH, a.TIPRAB,
             a.IDNORMATIV, a.IDNORMATIVUNIQ/*coalesce(s.idprice,0)*/, a.KODIR_GROUP, a.KODIR_PODGROUP, a.ISGROUPOKP,
             a.ARPS_OTHER, a.DORECALC, a.ID_S_RES, a.NOMERROD, a.PR_ADDED_REC, a.NOMERROD1,
             a.NORM_GUID, a.STATUS_REC_CEN, a.VIDRAB, a.UTV, a.CORRECTNODE, a.CORRECTNODE_1, a.ASUBTYPE,
             a.CLCMODE, a.TYPE_TRUD, a.IDFORMULS, a.K_ITOGO/*14460*/,
             a.B_PR/*15361*/, a.K_PR/*15421*/

           from A_SMETA a
           --left outer join smeta_pricepos_info  s on s.Id = a.ID
           --where IDHIER = :IDHIER and SMETATYPE = :IN_SMETATYPE
           where a.ID=:ID
           into --:ID,
             :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3,
             :SLAVEPARENT, :ATYPE, :RABMAT, :TAB, :ALTTAB, :NAME_ID,
             :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
             :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
             :BN, :BO, :B_ITOGO, -- CQ[13182]
             --:EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
             --:RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
             :PA, :PB, :PC, :PD, :PE, :VRPZ, :IDTIPR,
             :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
             :PUNKTIND,
             --:MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
             :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH, :TIPRAB,
             :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP,
             :ARPS_OTHER, :DORECALC, :ID_S_RES, :NOMERROD, :PR_ADDED_REC, :NOMERROD1,
             :NORM_GUID, :STATUS_REC_CEN, :VIDRAB, :UTV, :CORRECTNODE, :CORRECTNODE_1,
             :ASUBTYPE, :CLCMODE , :TYPE_TRUD, :IDFORMULS, :K_ITOGO/*14460*/,
             :B_PR/*15361*/, :K_PR/*15421*/

       do
       begin
          /*--CQ[9961]--> :         
          SEA = null;
          SEB = null;
          SEC = null;
          SED = null;
          SEE = null;
          SEF = null;
          SEG = null;
          SEH = null;
          SEI = null;
          SEJ = null;
          SEK = null;
          SRA = null;
          SRB = null;
          SRC = null;
          SRD = null;
          SRE = null;
          SRF = null;
          SRG = null;
          SRH = null;
          SRI = null;
          SRJ = null;
          SRK = null;
          SRL = null;
          SRM = null;
          */--CQ[9961]<--

          if ( :SMETATYPE <> 15 ) then
             for select first 1 PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_VSEGO
                 from l_s_pr_addinfo where ID = :ID
                 into PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_VSEGO
             do
                 ID = ID;

          PRICE_GUID = null;
          PRICE_NORMOTAB = null;
          PRICE_NORMOGUID = null;
          ROW = null;
         /*         IDNORMATIVUNIQ    
         if ( (IDNORMATIVUNIQ is not null) and (IDNORMATIVUNIQ <> 0)) then
          begin    */
            -- select PRICE_GUID from PM_PRICE_GUID where PRICE_ID = :IDNORMATIVUNIQ into :PRICE_GUID;
          PRICE_NORMOID = null;
          ROW = null;
          select  p.price_guid,
          case
            when b.ID is not null then b.id
            else i.idnormo
          end,
          b.tab, i.row, i.koef from smeta_pricepos_info i
          left outer join PM_PRICE_GUID p on p.price_id = i.idprice
          left outer join B_RABMAT b on b.id = i.idnormo
          where (i.id = :ID) and (i.idcenlvl = 0) -- MK CQ[12393] +  
          into :PRICE_GUID,:PRICE_NORMOID, :PRICE_NORMOTAB, :ROW, :KOEF;
          if (PRICE_NORMOID is not null) then
          begin
            /*execute procedure L_EXP_GET_NORM_GUID ( :PRICE_NORMOID, :KODIR_GROUP, :KODIR_PODGROUP, :RABMAT, :NORM_GUID, :ID_USER )
             returning_values ( :PRICE_NORMOGUID ); CQ[7662]*/
             execute procedure d_get_rabmat_sbornik_guid ( :PRICE_NORMOID) returning_values ( :PRICE_NORMOGUID ); --CQ[7662]
          end
          else
          begin
            PRICE_NORMOGUID = null;
          end
          if (PRICE_NORMOID = -1) then PRICE_NORMOGUID = '-1';
         -- end


          execute procedure L_EXP_GET_NORM_GUID ( :IDNORMATIV, :KODIR_GROUP, :KODIR_PODGROUP,
                        :RABMAT, :NORM_GUID, :ID_USER )
              returning_values ( :NORM_GUID );

          TCH_GUID = null;
          if ( ( not SSTCH is null ) and ( SSTCH <> 0 ) ) then
             for select first 1 NORM_GUID from b_reestr_doc
                 where id = :sstch
                 into TCH_GUID
             do
                SSTCH = SSTCH;

          --CQ[9060]-->
          CREATENAME_UW = null;
          CREATEDATE_UW = null;
          CONFIRMNAME_UW = null;
          CONFIRMDATE_UW = null;
          CHANGE_NAME_UW = null;
          CHANGE_DATE_UW = null;
          if (ATYPE = 17) then
          begin
            select CREATENAME, CREATEDATE, CONFIRMNAME, CONFIRMDATE,
                   CHANGE_NAME, CHANGE_DATE
            from SMETAUNIONWORKINFO
            where ID = :ID
            into :CREATENAME_UW, :CREATEDATE_UW, :CONFIRMNAME_UW, :CONFIRMDATE_UW,
                 :CHANGE_NAME_UW, :CHANGE_DATE_UW;
          end
          --CQ{9060]<--

          -- MK CQ[12613] --->
          if ((PC is null) or (PC = 0)) then
            PC = 1;
          if ((PD is null) or (PD = 0)) then
            PD = 1;
          -- MK CQ[12613] <---

          suspend;
       end
end
^


-- CQ[15361]
create or alter procedure A_SMETA_NL_EXP (
    ID_OBJ integer,
    IN_SMETATYPE integer,
    ID_USER integer)
returns (
    ID integer,
    IDCENLVL integer,
    IDHIER integer,
    IDZONE integer,
    ID_LEVEL_VC integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    BN double precision,
    BO double precision,
    B_PR double precision,
    B_ITOGO double precision,
    CA double precision,
    CB double precision,
    CC double precision,
    CD double precision,
    CE double precision,
    CF double precision,
    CG double precision,
    CH double precision,
    CI double precision,
    CJ double precision,
    C_PR double precision,
    C_ITOGO double precision,
    EA double precision,
    EB double precision,
    EC double precision,
    ED double precision,
    EE double precision,
    EF double precision,
    EG double precision,
    EH double precision,
    EI double precision,
    EJ double precision,
    EK double precision,
    EN double precision,
    EO double precision,
    E_PR double precision,
    E_ITOGO double precision,
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    R_PR double precision,
    RC_16 double precision,
    RE_16 double precision,
    ITOGO double precision,
    CALCBMASK integer,
    BASE_INFO integer,
    CURR_CENA double precision,
    BASE_CALC_INFO integer,
    SOURCE_LEVEL_ID integer,
    IDINDEX integer,
    ID_LEVEL_INDEX integer,
    PUNKTIND varchar(42),
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    M_PR double precision,
    DA double precision,
    DB double precision,
    DC double precision,
    DD double precision,
    DE double precision,
    DJ double precision,
    DK double precision,
    DL double precision,
    DM double precision,
    INDEX_SPOSOBRASCH integer,
    INDEX_INFO integer,
    NMA varchar(255),
    NMB varchar(255),
    NMC varchar(255),
    NMD varchar(255),
    NME varchar(255),
    NMF varchar(255),
    NMG varchar(255),
    NMH varchar(255),
    NMI varchar(255),
    NMJ varchar(255),
    NMK varchar(255),
    NML varchar(255),
    NMM varchar(255),
    NM_PR varchar(255),
    NDA varchar(255),
    NDB varchar(255),
    NDC varchar(255),
    NDD varchar(255),
    NDE varchar(255),
    NDJ varchar(255),
    NDK varchar(255),
    NDL varchar(255),
    NDM varchar(255),
    CURR_CENA_INFO integer,
    ID_VALUTE integer,
    VALUTE_CURS double precision,
    VALUTE_DATE date,
    TRANSP double precision,
    ZAG_SKL double precision,
    ZAPCHAST double precision,
    TARA double precision,
    NACEN double precision,
    COMPLECT double precision,
    BB_STORE double precision,
    CB_STORE double precision,
    CURR_CENA_STORE double precision,
    KOEFF_TYPE integer)
AS
begin
  for select ID, /*[10525]*/IDHIER
    from L_EXP_A_SMETA_IDS(:ID_OBJ, :IN_SMETATYPE, :ID_USER)
    into :ID, /*[10525]*/:IDHIER
  do
  begin
    --
    for select IDCENLVL, IDZONE, ID_LEVEL_VC, BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
               BN, BO, B_ITOGO, -- CQ[13182]
               CA, CB, CC, CD, CE, CF, CG, CH, CI, CJ,
               C_ITOGO, -- CQ[13182]
               EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
               EN, EO, E_ITOGO, -- CQ[13182]
               RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM, PA, PB, PC, PD,
               ITOGO, CALCBMASK, BASE_INFO,
               CURR_CENA, BASE_CALC_INFO, SOURCE_LEVEL_ID,
               CURR_CENA_INFO, ID_VALUTE, VALUTE_CURS, VALUTE_DATE, TRANSP, -- MK CQ[11996]
               ZAG_SKL, ZAPCHAST, TARA, NACEN, COMPLECT,                    -- MK CQ[11996]
               KOEFF_TYPE,                                                  -- MK CQ[13018]
               B_PR, C_PR, E_PR, R_PR, RC_16, RE_16 -- MK CQ[15361]
      from A_SMETA_CENLVL
      where ID = :ID
      into :IDCENLVL, :IDZONE, :ID_LEVEL_VC, :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
           :BN, :BO, :B_ITOGO, -- CQ[13182]
           :CA, :CB, :CC, :CD, :CE, :CF, :CG, :CH, :CI, :CJ,
           :C_ITOGO, -- CQ[13182]
           :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
           :EN, :EO, :E_ITOGO, -- CQ[13182]
           :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :PA, :PB, :PC,
           :PD, :ITOGO, :CALCBMASK, :BASE_INFO, :CURR_CENA, :BASE_CALC_INFO, :SOURCE_LEVEL_ID,
           :CURR_CENA_INFO, :ID_VALUTE, :VALUTE_CURS, :VALUTE_DATE, :TRANSP, -- MK CQ[11996]
           :ZAG_SKL, :ZAPCHAST, :TARA, :NACEN,: COMPLECT,                    -- MK CQ[11996]
           :KOEFF_TYPE,                                                      -- MK CQ[13018]
           :B_PR, :C_PR, :E_PR, :R_PR, :RC_16, :RE_16 -- MK CQ[15361]
    do
    begin
      -- MK CQ[12613] --->
      if ((PC is null) or (PC = 0)) then
        PC = 1;
      if ((PD is null) or (PD = 0)) then
        PD = 1;
      -- MK CQ[12613] <---

      --
      select IDINDEX, ID_LEVEL_INDEX, PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM,
             DA, DB, DC, DD, DE, DJ, DK, DL, DM, INDEX_SPOSOBRASCH, INDEX_INFO,
             M_PR -- MK CQ[15361]
      from A_SMETA_INDLVL
      where ID = :ID and
            IDCENLVL = :IDCENLVL
      into :IDINDEX, :ID_LEVEL_INDEX, :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ,
           :MK, :ML, :MM, :DA, :DB, :DC, :DD, :DE, :DJ, :DK, :DL, :DM, :INDEX_SPOSOBRASCH,
           :INDEX_INFO,
           :M_PR; -- MK CQ[15361]
      -- 
      select NMA, NMB, NMC, NMD, NME, NMF, NMG, NMH, NMI, NMJ, NMK, NML, NMM, NDA, NDB, NDC, NDD,
             NDE, NDJ, NDK, NDL, NDM,
             NM_PR -- MK CQ[15361]
      from A_SMETA_INDLVL_DESCR
      where ID = :ID and
            IDCENLVL = :IDCENLVL
      into :NMA, :NMB, :NMC, :NMD, :NME, :NMF, :NMG, :NMH, :NMI, :NMJ, :NMK, :NML, :NMM, :NDA, :NDB,
           :NDC, :NDD, :NDE, :NDJ, :NDK, :NDL, :NDM,
           :NM_PR; -- MK CQ[15361]

      -- MK CQ[11996] --->
      BB_STORE = null;
      CB_STORE = null;
      CURR_CENA_STORE = CURR_CENA;

      --      
      if (CURR_CENA_INFO = 3/*cciVC*/) then
      begin
        --   
        BB_STORE = BB;
        CB_STORE = CB;
        --      ( ) -  
        BA = CURR_CENA;
        BB = CURR_CENA;
        CA = CURR_CENA;
        CB = CURR_CENA;
        --   
        CURR_CENA = 0;
      end
      --        
      else if (CURR_CENA_INFO in (1/*cciDirect*/, 2/*cciMonitiring*/, 4/*cciBBOtpFromSb*/)) then --[14353]
      begin
        --     
        if (coalesce(ID_VALUTE, 0) > 1) then
        begin
          --       ( )
          CURR_CENA = CURR_CENA * VALUTE_CURS;
        end
      end
      -- MK CQ[11996] <---

      suspend;
    end
  end
end
^

-- CQ[15361]
create or alter procedure L_IMP_INS_SMSTR_N (
    ID_USER integer,
    IDHIER integer,
    SMETATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE smallint,
    RABMAT integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NAME_ID integer,
    ID_EDIZM integer,
    EDIZM_TYPE integer,
    KOLL double precision,
    SKOLL varchar(255),
    NORMARASH double precision,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    BN double precision,
    BO double precision,
    B_PR double precision,
    B_ITOGO double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    VRPZ integer,
    IDTIPR integer,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    K_ITOGO varchar(50),
    K_PR varchar(50),
    PUNKTIND varchar(42),
    SSTCH integer,
    KODZAK integer,
    KODGP integer,
    KODSP integer,
    KODISP integer,
    NACH date,
    OKONCH date,
    TIPRAB integer,
    IDNORMATIV integer,
    IDNORMATIVUNIQ integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ISGROUPOKP integer,
    ARPS_OTHER blob sub_type 0 segment size 80,
    DORECALC smallint,
    ID_S_RES integer,
    NOMERROD integer,
    PR_ADDED_REC integer,
    NOMERROD1 integer,
    PR_NUMBER1 integer,
    PR_NUMBER2 integer,
    PR_NUMBER3 integer,
    PR_VSEGO double precision,
    TCH_GUID varchar(100),
    NORM_GUID varchar(100),
    OLD_ID integer,
    OLD_NOMERROD integer,
    OLD_NOMERROD1 integer,
    STATUS_REC_CEN integer,
    VIDRAB integer,
    UTV integer,
    CORRECTNODE blob sub_type 0 segment size 80,
    CORRECTNODE_1 blob sub_type 0 segment size 80,
    ASUBTYPE integer,
    CLCMODE integer,
    PRICE_GUID varchar(100),
    PRICE_NORMOTAB varchar(42),
    PRICE_NORMOGUID varchar(100),
    ROW integer,
    TYPE_TRUD integer,
    KOEF double precision,
    CREATENAME_UW varchar(100),
    CREATEDATE_UW date,
    CONFIRMNAME_UW varchar(100),
    CONFIRMDATE_UW date,
    CHANGE_NAME_UW varchar(100),
    CHANGE_DATE_UW date)
returns (
    ID integer,
    IDPAPKA integer)
AS
declare variable cur_id_tr integer;
declare variable res_copy_formuls integer;
declare variable id_price integer;
declare variable idnormo integer;

/*
    SEA blob sub_type 0 segment size 80,
    SEB blob sub_type 0 segment size 80,
    SEC blob sub_type 0 segment size 80,
    SED blob sub_type 0 segment size 80,
    SEE blob sub_type 0 segment size 80,
    SEF blob sub_type 0 segment size 80,
    SEG blob sub_type 0 segment size 80,
    SEH blob sub_type 0 segment size 80,
    SEI blob sub_type 0 segment size 80,
    SEJ blob sub_type 0 segment size 80,
    SEK blob sub_type 0 segment size 80,
    SRA blob sub_type 0 segment size 80,
    SRB blob sub_type 0 segment size 80,
    SRC blob sub_type 0 segment size 80,
    SRD blob sub_type 0 segment size 80,
    SRE blob sub_type 0 segment size 80,
    SRF blob sub_type 0 segment size 80,
    SRG blob sub_type 0 segment size 80,
    SRH blob sub_type 0 segment size 80,
    SRI blob sub_type 0 segment size 80,
    SRJ blob sub_type 0 segment size 80,
    SRK blob sub_type 0 segment size 80,
    SRL blob sub_type 0 segment size 80,
    SRM blob sub_type 0 segment size 80,
*/
declare EA double precision;
declare EB double precision;
declare EC double precision;
declare ED double precision;
declare EE double precision;
declare EF double precision;
declare EG double precision;
declare EH double precision;
declare EI double precision;
declare EJ double precision;
declare EK double precision;

declare RA double precision;
declare RB double precision;
declare RC double precision;
declare RD double precision;
declare RE double precision;
declare RF double precision;
declare RG double precision;
declare RH double precision;
declare RI double precision;
declare RJ double precision;
declare RK double precision;
declare RL double precision;
declare RM double precision;

declare MA double precision;
declare MB double precision;
declare MC double precision;
declare MD double precision;
declare ME double precision;
declare MF double precision;
declare MG double precision;
declare MH double precision;
declare MI double precision;
declare MJ double precision;
declare MK double precision;
declare ML double precision;

declare IDCLASS integer;
begin
--[15352]+
   execute procedure a_set_g_number_obg ( 1 )  returning_values ( :id );

   SKOLL     = null;
   IDTIPR    = null;
   SSTCH     = null;
--   ID_S_RES  = null;
   NOMERROD  = 0;
   NOMERROD1 = null;

   if ( ( not OLD_NOMERROD is null ) and ( OLD_NOMERROD = OLD_ID ) ) then
      NOMERROD = ID;
   if ( ( not OLD_NOMERROD1 is null ) and ( OLD_NOMERROD1 = OLD_ID ) ) then
      NOMERROD1 = ID;

   if  (IDNORMATIV <> 0)  then   --:     GUID   
   begin
     execute procedure L_GET_NORMATIV_FROM_GUID ( :NORM_GUID, :TAB, :IDNORMATIV,
           :KODIR_PODGROUP, :RABMAT, :ID_USER )
        returning_values ( :IDNORMATIV, :KODIR_PODGROUP, :RABMAT );

     --<< [9984]      
     if (:KODIR_PODGROUP = 1 and :RABMAT <> 1) then
       select R.IDPAPKA
         from B_RABMAT R
         where R.ID = :IDNORMATIV
         into :IDPAPKA;
   end

   if (
       ( vidrab is null ) or
       ( vidrab = 0 )
      )
   then
   begin

    select p.id_tr, p.res_copy_formuls
      --from a_s_get_params_obj( :id_user, :idhier ) p
      from A_GET_PARAMS_OBJ_AKT( :id_user, :idhier, :SMETATYPE ) p
      into :cur_id_tr, res_copy_formuls;

    select f.RES_VIDRAB
      from A_S_GET_FORMULS_DM ( :ID_USER,
          :ATYPE, :SLAVEPARENT, :CUR_ID_TR, :VRPZ, :RES_COPY_FORMULS, :TIPRAB ) f
      into :VIDRAB;

   end

   if ( tiprab < 1 ) then
      tiprab = 1;
   if ( vrpz < 0 ) then
      vrpz = 0;

    execute procedure L_S_APPENDREC_VALIDATE_PARAMS(
        :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
        :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
        :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
        :PA, :PB, :PC, :PD, :PE,
        :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML)
      returning_values
        :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
        :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
        :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
        :PA, :PB, :PC, :PD, :PE,
        :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML;

   if ( UTV is null ) then
      UTV = 0;
   if (IDNORMATIVUNIQ is null) then
     IDNORMATIVUNIQ = 0;

   insert into a_smeta (
      ID, IDHIER, SMETATYPE, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE, RABMAT,
      TAB, ALTTAB, NAME_ID, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
      BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ,
      BN, BO, B_ITOGO, -- CQ[13182]
      -- SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK, --Voyager CQ[9984]
      EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
      -- SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM, --Voyager CQ[9984]
      RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
      PA, PB, PC, PD, PE,
      VRPZ, IDTIPR,
      KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
      PUNKTIND,
      MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
      SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH, TIPRAB,
      IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP,
      ARPS_OTHER, DORECALC, ID_S_RES, NOMERROD, PR_ADDED_REC, NOMERROD1, NORM_GUID,
      STATUS_REC_CEN, VIDRAB, UTV, CORRECTNODE, CORRECTNODE_1, ASUBTYPE, CLCMODE, TYPE_TRUD, K_ITOGO,
      K_PR/*15421*/, B_PR/*15361*/)
   values (
      :ID, :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT, :ATYPE, :RABMAT,
      :TAB, :ALTTAB, :NAME_ID, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
      :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ,
      :BN, :BO, :B_ITOGO, -- CQ[13182]
      -- :SEA, :SEB, :SEC, :SED, :SEE, :SEF, :SEG, :SEH, :SEI, :SEJ, :SEK, --Voyager CQ[9984]
      :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
      -- :SRA, :SRB, :SRC, :SRD, :SRE, :SRF, :SRG, :SRH, :SRI, :SRJ, :SRK, :SRL, :SRM, --Voyager CQ[9984]
      :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
      :PA, :PB, :PC, :PD, :PE,
      :VRPZ, :IDTIPR,
      :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, 
      :PUNKTIND,
      :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML,
      :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH, :TIPRAB,
      :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP,
      :ARPS_OTHER, :DORECALC, :ID_S_RES, :NOMERROD, :PR_ADDED_REC, :NOMERROD1, :NORM_GUID,
      :STATUS_REC_CEN, :VIDRAB, :UTV, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE, :TYPE_TRUD,
      :K_ITOGO/*14460*/, :K_PR/*15421*/, :B_PR/*15361*/);

   -- MK 17.10.2013 CQ[11675] --->
   if (:SMETATYPE > 999) then
   begin
     IDCLASS = :SMETATYPE;
   end
   else
   begin
     execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1) returning_values :IDCLASS;
   end

   if (ATYPE in (17, 19)) then
     execute procedure DOCUMENT_LOG_INS(:ID, :IDCLASS, :ATYPE);
   -- MK 17.10.2013 CQ[11675] <---

   if ((PRICE_GUID is not null) and (PRICE_GUID <> '')) then
     begin
       ID_PRICE = null;
       select first 1 PRICE_ID from PM_PRICE_GUID where PRICE_GUID = :PRICE_GUID into :ID_PRICE;

       if (PRICE_NORMOGUID is not null) then
       begin
         if (PRICE_NORMOGUID = '-1') then
         begin
           IDNORMO = -1;
         end
         else
         begin
           execute procedure L_GET_NORMATIV_FROM_GUID ( :PRICE_NORMOGUID, :PRICE_NORMOTAB, :IDNORMATIV,:KODIR_PODGROUP, :RABMAT, :ID_USER )
           returning_values ( :IDNORMO, :KODIR_PODGROUP, :RABMAT );
         end
       end
       if (IDNORMO = 0) then IDNORMO = null;
       if ((ID_PRICE is not null) or (IDNORMO is not null) or (ROW is not null)) then
       insert into  SMETA_PRICEPOS_INFO(ID, IDNORMO, IDPRICE, ROW, COST, KOEF) values (:ID, :IDNORMO, :ID_PRICE, :ROW, :BB, :KOEF);
     end

   if ( SMETATYPE <> 15 ) then
      if ( ( not PR_ADDED_REC is null ) and ( PR_ADDED_REC <> 0 ) ) then
         insert into l_s_pr_addinfo ( ID, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_VSEGO )
             values ( :ID, :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, :PR_VSEGO );
   --CQ[9060]-->
   if (CREATEDATE_UW is not null) then
   begin
     insert into SMETAUNIONWORKINFO (ID, CREATENAME, CREATEDATE, CONFIRMNAME, CONFIRMDATE,
                                     CHANGE_NAME, CHANGE_DATE)
     values (:ID, :CREATENAME_UW, :CREATEDATE_UW, :CONFIRMNAME_UW, :CONFIRMDATE_UW,
             :CHANGE_NAME_UW, :CHANGE_DATE_UW);
   end
   --CQ[9060]<--
end
^

-- CQ[15361]
create or alter procedure A_SMETA_NL_IMP (
    ID integer,
    IDCENLVL integer,
    IDZONE integer,
    ID_LEVEL_VC integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    BN double precision,
    BO double precision,
    B_ITOGO double precision,
    B_PR double precision,
    CA double precision,
    CB double precision,
    CC double precision,
    CD double precision,
    CE double precision,
    CF double precision,
    CG double precision,
    CH double precision,
    CI double precision,
    CJ double precision,
    C_ITOGO double precision,
    C_PR double precision,
    EA double precision,
    EB double precision,
    EC double precision,
    ED double precision,
    EE double precision,
    EF double precision,
    EG double precision,
    EH double precision,
    EI double precision,
    EJ double precision,
    EK double precision,
    EN double precision,
    EO double precision,
    E_ITOGO double precision,
    E_PR double precision,
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    ITOGO double precision,
    R_PR double precision,
    RC_16 double precision,
    RE_16 double precision,
    CALCBMASK integer,
    BASE_INFO integer,
    CURR_CENA double precision,
    BASE_CALC_INFO integer,
    SOURCE_LEVEL_ID integer,
    IDINDEX integer,
    ID_LEVEL_INDEX integer,
    PUNKTIND varchar(42),
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    MM double precision,
    M_PR double precision,
    DA double precision,
    DB double precision,
    DC double precision,
    DD double precision,
    DE double precision,
    DJ double precision,
    DK double precision,
    DL double precision,
    DM double precision,
    INDEX_SPOSOBRASCH integer,
    INDEX_INFO integer,
    NMA varchar(255),
    NMB varchar(255),
    NMC varchar(255),
    NMD varchar(255),
    NME varchar(255),
    NMF varchar(255),
    NMG varchar(255),
    NMH varchar(255),
    NMI varchar(255),
    NMJ varchar(255),
    NMK varchar(255),
    NML varchar(255),
    NMM varchar(255),
    NM_PR varchar(255),
    NDA varchar(255),
    NDB varchar(255),
    NDC varchar(255),
    NDD varchar(255),
    NDE varchar(255),
    NDJ varchar(255),
    NDK varchar(255),
    NDL varchar(255),
    NDM varchar(255),
    CURR_CENA_INFO integer,
    ID_VALUTE integer,
    VALUTE_CURS double precision,
    VALUTE_DATE date,
    TRANSP double precision,
    ZAG_SKL double precision,
    ZAPCHAST double precision,
    TARA double precision,
    NACEN double precision,
    COMPLECT double precision,
    KOEFF_TYPE integer)
AS
declare IDCLASS integer;
declare variable SMETATYPE integer;
declare IDHIER integer;
begin
--[15352]+
--[15354]

  --
  update A_SMETA_CENLVL set
    IDZONE = :IDZONE,
    ID_LEVEL_VC = :ID_LEVEL_VC,
    BA = :BA,
    BB = :BB,
    BC = :BC,
    BD = :BD,
    BE = :BE,
    BF = :BF,
    BG = :BG,
    BH = :BH,
    BI = :BI,
    BJ = :BJ,
    -- CQ[13182] -->
    BN = :BN,
    BO = :BO,
    B_ITOGO = :B_ITOGO,
    -- CQ[13182] <--
    B_PR = :B_PR, --[15352]
    CA = :CA,
    CB = :CB,
    CC = :CC,
    CD = :CD,
    CE = :CE,
    CF = :CF,
    CG = :CG,
    CH = :CH,
    CI = :CI,
    CJ = :CJ,
    -- CQ[13182] -->
    C_ITOGO = :C_ITOGO,
    -- CQ[13182] <--
    C_PR = :C_PR, --[15352]
    EA = :EA,
    EB = :EB,
    EC = :EC,
    ED = :ED,
    EE = :EE,
    EF = :EF,
    EG = :EG,
    EH = :EH,
    EI = :EI,
    EJ = :EJ,
    EK = :EK,
    -- CQ[13182] -->
    EN = :EN,
    EO = :EO,
    E_ITOGO = :E_ITOGO,
    -- CQ[13182] <--
    E_PR = :E_PR, --[15352]
    RA = :RA,
    RB = :RB,
    RC = :RC,
    RD = :RD,
    RE = :RE,
    RF = :RF,
    RG = :RG,
    RH = :RH,
    RI = :RI,
    RJ = :RJ,
    RK = :RK,
    RL = :RL,
    RM = :RM,
    PA = :PA,
    PB = :PB,
    PC = :PC,
    PD = :PD,
    ITOGO = :ITOGO,
    R_PR = :R_PR, --[15352]
    RC_16 = :RC_16, --[15352]
    RE_16 = :RE_16, --[15352]
    CALCBMASK = :CALCBMASK,
    BASE_INFO = :BASE_INFO,
    CURR_CENA = :CURR_CENA,
    BASE_CALC_INFO = :BASE_CALC_INFO,
    SOURCE_LEVEL_ID = :SOURCE_LEVEL_ID,

    -- MK CQ[11996] --->
    CURR_CENA_INFO = :CURR_CENA_INFO,
    ID_VALUTE = :ID_VALUTE,
    VALUTE_CURS = :VALUTE_CURS,
    VALUTE_DATE = :VALUTE_DATE,
    TRANSP = :TRANSP,
    ZAG_SKL = :ZAG_SKL,
    ZAPCHAST = :ZAPCHAST,
    TARA = :TARA,
    NACEN = :NACEN,
    COMPLECT = :COMPLECT,
    -- MK CQ[11996] <---

    -- MK CQ[13018]
    KOEFF_TYPE = :KOEFF_TYPE

  where (ID = :ID) and
        (IDCENLVL = :IDCENLVL);

  --CQ[TIMUR 13756] - (056)  3
  if (coalesce(IDINDEX, 0) = 0) then
  begin
    select SMETATYPE, IDHIER
      from A_SMETA where ID = :ID
    into :SMETATYPE, :IDHIER;

    if (SMETATYPE > 999) then
      IDCLASS = SMETATYPE;
    else
      execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1)
      returning_values :IDCLASS;

    -- Voyager CQ[14580,14637]
    --  SPOSOB_RASCH,          
    select SBORNIKID, /*SPOSOB_RASCH,*/ ID_LEVEL_INDEX
      from NL_GET_APPLICABLE_INDEXSBORNIK(:ID, :IDCENLVL, :IDCLASS, null/*:ID_USER*/)
    into :IDINDEX, /*:INDEX_SPOSOBRASCH,*/ :ID_LEVEL_INDEX;
  end
  --CQ[TIMUR 13756] - (056)  3

  --
  update A_SMETA_INDLVL set
    IDINDEX = :IDINDEX,
    ID_LEVEL_INDEX = :ID_LEVEL_INDEX,
    PUNKTIND = :PUNKTIND,
    MA = :MA,
    MB = :MB,
    MC = :MC,
    MD = :MD,
    ME = :ME,
    MF = :MF,
    MG = :MG,
    MH = :MH,
    MI = :MI,
    MJ = :MJ,
    MK = :MK,
    ML = :ML,
    MM = :MM,
    M_PR = :M_PR, --[15352]

    -- MK CQ[12678] --->
    DA = case when :INDEX_INFO = 2 then :MA else :DA end,
    DB = case when :INDEX_INFO = 2 then :MB else :DB end,
    DC = case when :INDEX_INFO in (2, 4) then :MC else :DC end,
    DD = case when :INDEX_INFO in (2, 4) then :MD else :DD end,
    DE = case when :INDEX_INFO in (2, 4) then :ME else :DE end,
    DJ = case when :INDEX_INFO = 2 then :MJ else :DJ end,
    DK = case when :INDEX_INFO = 2 then :MK else :DK end,
    DL = case when :INDEX_INFO = 2 then :ML else :DL end,
    DM = case when :INDEX_INFO = 2 then :MM else :DM end,

    --DA = :DA,
    --DB = :DB,
    --DC = :DC,
    --DD = :DD,
    --DE = :DE,
    --DJ = :DJ,
    --DK = :DK,
    --DL = :DL,
    --DM = :DM,
    -- MK CQ[12678] <---


    INDEX_SPOSOBRASCH = :INDEX_SPOSOBRASCH,
    INDEX_INFO = :INDEX_INFO
  where (ID = :ID) and
        (IDCENLVL = :IDCENLVL);
  -- 
  execute procedure A_SMETA_INDLVL_DESCR_IU(:ID, :IDCENLVL,
     :NMA, :NMB, :NMC, :NMD, :NME, :NMF, :NMG, :NMH, :NMI, :NMJ, :NMK, :NML, :NMM, :NM_PR/*15354, 15361*/,
     :NDA, :NDB, :NDC, :NDD, :NDE, :NDJ, :NDK, :NDL, :NDM);

end
^


-- CQ[15361]
create or alter procedure L_S_APPENDREC_NL_2 (
    USE_ARGS_F integer,
    USE_ARGS_P integer,
    USE_ARGS_M integer,
    USE_ARGS_K integer,
    USE_OBJ_NASTR_F integer,
    USE_OBJ_NASTR_M integer,
    USE_OBJ_NASTR_K integer,
    SKIP_INS_SM_RES integer,
    IDUSER integer,
    ID integer,
    IDHIER integer,
    SMETATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE smallint,
    RABMAT integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NAME blob sub_type 0 segment size 80,
    NAME_TITLE blob sub_type 0 segment size 80,
    ID_EDIZM integer,
    EDIZM_TYPE integer,
    KOLL double precision,
    SKOLL varchar(255),
    NORMARASH double precision,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    EA double precision,
    EB double precision,
    EC double precision,
    ED double precision,
    EE double precision,
    EF double precision,
    EG double precision,
    EH double precision,
    EI double precision,
    EJ double precision,
    EK double precision,
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
    IDTIPR integer,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    SSTCH integer,
    KODZAK integer,
    KODGP integer,
    KODSP integer,
    KODISP integer,
    NACH date,
    OKONCH date,
    IDNORMATIV integer,
    IDNORMATIVUNIQ integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ISGROUPOKP integer,
    INSERT_TO_ATYPE integer,
    INSERT_TO_ID integer,
    ID_S_RES integer,
    VRPZ integer,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    TIPRAB integer,
    PUNKTIND varchar(42),
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    NORM_GUID varchar(100),
    UTV integer,
    ASUBTYPE integer,
    IN_IDFORMULS integer,
    B_DORECALL integer)
AS
declare B_PR double precision; --[15352]
declare E_PR double precision; --[15352]
declare R_PR double precision; --[15352]
declare RC_16 double precision; --[15352]
declare RE_16 double precision; --[15352]

declare variable ID_CUR integer;
declare variable ATYPE_CUR integer;
declare variable CUR_ID_TR integer;
declare variable CUR_KOLL_PARENT double precision;
declare variable PR_ADDED_REC integer;
declare variable PR_NUMBER1 integer;
declare variable PR_NUMBER2 integer;
declare variable ADDED_RES integer;
declare variable RES_KODIR_GROUP integer;
declare variable RES_KODIR_PODGROUP integer;
declare variable INDEX_ID_ORG integer;
declare variable INDEX_ID_GOD integer;
declare variable INDEX_ID_MES integer;
declare variable INDEX_NASNACHAUTO integer;
declare variable INDEX_ZAMENNASNACH integer;
declare variable INDEX_RASCHNRISP integer;
declare variable INDEX_BRAT_ZU_IS integer;
declare variable INDEX_UCHITNDS integer;
declare variable RES_COPY_INDEX integer;
declare variable RES_COPY_FORMULS integer;
declare variable RES_COPY_POPR integer;
declare variable S_PUNKTIND varchar(42);
declare variable S_MA double precision;
declare variable S_MB double precision;
declare variable S_MC double precision;
declare variable S_MD double precision;
declare variable S_ME double precision;
declare variable S_MF double precision;
declare variable S_MG double precision;
declare variable S_MH double precision;
declare variable S_MI double precision;
declare variable S_PA double precision;
declare variable S_PB double precision;
declare variable S_PC double precision;
declare variable S_PD double precision;
declare variable S_VRPZ integer;
declare variable ID_TR integer;
declare variable INSERT_FORMULS_2 integer;
declare variable RES_APPLY_TAB integer;
declare variable ADDEDID integer;
declare variable ID_ZONE integer;
declare variable NAME_ID integer;
declare variable NEEDUPDATE_NAME_PART integer;
declare variable NEEDUPDATE_NAME_TITLE integer;
declare variable VIDRAB integer;

declare variable WILDCARD_USED integer;

declare variable ID_LEVEL integer;
declare variable IDCLASS integer;

declare variable ID_LEVEL_VC integer;
declare variable BJ double precision;
declare variable ITOGO double precision;
declare variable CALCBMASK integer;
declare variable BASE_INFO integer;
declare variable CURR_CENA double precision;
declare variable BASE_CALC_INFO integer;
declare variable SOURCE_LEVEL_ID integer;
declare variable IDINDEX integer;
declare variable ID_LEVEL_INDEX integer;
declare variable MJ double precision;
declare variable MK double precision;
declare variable ML double precision;
declare variable MM double precision;
declare M_PR double precision; --[15352]
declare variable INDEX_SPOSOBRASCH integer;
declare variable INDEX_INFO integer;
declare variable NEED_APPLY_INDEX integer;

declare variable NL_BA double precision;
declare variable NL_BB double precision;
declare variable NL_BC double precision;
declare variable NL_BD double precision;
declare variable NL_BE double precision;
declare NL_B_PR double precision; --[15352]
declare variable NL_MA double precision;
declare variable NL_MB double precision;
declare variable NL_MC double precision;
declare variable NL_MD double precision;
declare variable NL_ME double precision;
declare variable NL_MF double precision;
declare variable NL_MG double precision;
declare variable NL_MH double precision;
declare variable NL_MI double precision;
declare variable NL_MJ double precision;
declare variable NL_MK double precision;
declare variable NL_ML double precision;
declare variable NL_MM double precision;
declare NL_M_PR double precision; --[15352]
declare variable NL_DA double precision;
declare variable NL_DB double precision;
declare variable NL_DC double precision;
declare variable NL_DD double precision;
declare variable NL_DE double precision;
declare variable NL_DJ double precision;
declare variable NL_DK double precision;
declare variable NL_DL double precision;
declare variable NL_DM double precision;
declare variable NL_ID_LEVEL_VC integer;
declare variable NL_IDZONE integer;
declare variable NL_ID_LEVEL_INDEX integer;
declare variable NL_IDINDEX integer;
declare variable NL_PUNKTIND varchar(42);
declare variable NL_SPOSOB_RASCH integer;
declare variable NL_RES_VC integer;
declare variable NL_RES_INDEX integer;
declare variable SYNCRON_RES integer;
declare variable FORMULS blob sub_type 1 segment size 80;

begin
--[15352] - 
  /*
  INSERT_FORMULS:
  0 - from tip.rasch. , use obj params
  1 - from input args , don't use obj params
  2 - from tip.rasch. , don't use obj params

  SKIP_INS_SM_RES:
  bit 0:  0 - insert sm. res. for smetn. strings
          1 - don't insert sm.res for smetn. strings
  bit 1:  0 - don't copy podch. str. to sm. res.
          1 - copy podch. str. to sm. res.

  B_DORECALL:
    0 bit  - Need Recall cost
    1 bit  - RECALL_FILL_BA
    2 bit  - RECALL_FILL_BB
    3 bit  - RECALL_FILL_BC
    4 bit  - RECALL_FILL_BD
    5 bit  - RECALL_FILL_BE
  */

  WILDCARD_USED = 1;

  --CQ[9297]  1 -->
  FORMULS = null;
  select FORMULS from SRF_FORMULS
  where ID = :IN_IDFORMULS
  into :FORMULS;
  --CQ[9297] <--

  B_DORECALL = coalesce(:B_DORECALL, 0);

  if (USE_ARGS_F is null) then
    USE_ARGS_F = 0;
  if (USE_ARGS_P is null) then
    USE_ARGS_P = 0;
  if (USE_ARGS_M is null) then
    USE_ARGS_M = 0;
  if (USE_ARGS_K is null) then
    USE_ARGS_K = 0;
  if (USE_OBJ_NASTR_F is null) then
    USE_OBJ_NASTR_F = 0;
  if (USE_OBJ_NASTR_M is null) then
    USE_OBJ_NASTR_M = 0;
  if (USE_OBJ_NASTR_K is null) then
    USE_OBJ_NASTR_K = 0;

  ID_CUR = 0;

  select H.NUMBER
  from A_O_HIER H
  where H.NUMBER = :IDHIER
  into :ID_CUR;

  if (ID_CUR <= 0) then
    exception A_H_MODIFY_DATA;

  if (ATYPE = 17) then
    SLAVEPARENT = 0;

  if (SLAVEPARENT <> 0) then
  begin

    ID_CUR = 0;

    select S.ID, S.ATYPE
    from A_SMETA S
    where (S.ID = :SLAVEPARENT) and
          (S.IDHIER = :IDHIER) and
          (S.SMETATYPE = :SMETATYPE)
    into :ID_CUR, :ATYPE_CUR;

    if ((ID_CUR = 0) or ((ATYPE = 18) and
        (not ATYPE_CUR in (17, 18)))) then
      exception A_H_MODIFY_DATA;

  end

  execute procedure A_S_RENUM_BEFORE_INSERT(:IDHIER, :SMETATYPE, :ATYPE, :NUMBER1, :NUMBER2,
    :NUMBER3, 1, :INSERT_TO_ATYPE, :ID, :INSERT_TO_ID);

  /***********************************************************/
  /***********************************************************/

  if ((VRPZ is null) or (VRPZ < 0)) then
    VRPZ = 0;

  -- USE_ARGS_M = 1 -    
  if (USE_ARGS_M = 0) then
  begin
    MA = 1;
    MB = 1;
    MC = 1;
    MD = 1;
    ME = 1;
    MF = 0;
    MG = 0;
    MH = 1;
    MI = 1;
  end
  -- USE_ARGS_P = 1 -  ,     
  if (USE_ARGS_P = 0) then
  begin
    PA = 0;
    PB = 0;
    PC = 1;
    PD = 1;
  end
  -- USE_ARGS_K = 1 -    
  if (USE_ARGS_K = 0) then
  begin
    KA = '';
    KB = '';
    KC = '';
    KD = '';
    KE = '';
    KF = '';
    KG = '';
    KH = '';
    KI = '';
    KJ = '';
    KK = '';
    KL = '';
    KM = '';
  end

  if (ATYPE in (17, 18)) then
  begin

    select P.ID_TR, P.RES_COPY_FORMULS, P.RES_COPY_POPR, P.INDEX_ID_ORG, P.INDEX_ID_GOD,
           P.INDEX_ID_MES, P.INDEX_NASNACHAUTO, P.INDEX_ZAMENNASNACH, P.INDEX_RASCHNRISP,
           P.INDEX_BRAT_ZU_IS, P.INDEX_UCHITNDS, P.RES_COPY_INDEX, P.KODIR_GROUP, P.KODIR_PODGROUP,
           P.ID_TR, P.RES_APPLY_TAB, P.ID_ZONE
    from A_GET_PARAMS_OBJ_AKT(:IDUSER, :IDHIER, :SMETATYPE) P
    into :CUR_ID_TR, :RES_COPY_FORMULS, :RES_COPY_POPR, :INDEX_ID_ORG, :INDEX_ID_GOD, :INDEX_ID_MES,
         :INDEX_NASNACHAUTO, :INDEX_ZAMENNASNACH, :INDEX_RASCHNRISP, :INDEX_BRAT_ZU_IS,
         :INDEX_UCHITNDS, :RES_COPY_INDEX, :RES_KODIR_GROUP, :RES_KODIR_PODGROUP, :ID_TR,
         :RES_APPLY_TAB, :ID_ZONE;

    --CQ[9299] <--

    -- MK 25.08.2011 CQ[9435] --->
    if (SMETATYPE = 15) then
      execute procedure A_H_GET_ID_PARENTATYPE(:IDHIER, 1)
      returning_values (:IDCLASS);
    else
      IDCLASS = SMETATYPE;

    if (USE_OBJ_NASTR_F = 0) then
      if (USE_ARGS_F = 0) then
      begin
        -- MK 1.03.2011 CQ[9123] --->
        if (not exists(select F.ID
                       from A_SRF_F F
                       where F.ID_TR = :ID_TR and
                             F.NUMBER = :VRPZ)) then
          VRPZ = 0;
        -- MK 1.03.2011 CQ[9123] <---

        if (exists(select F.ID
                   from A_SRF_F F
                   where F.ID_TR = :ID_TR and
                         F.NUMBER = :VRPZ)) then
          select
                 /*f.pa, f.pb, f.pc, f.pd,*/ F.ATYPE, F.NUMBER_VR, F.IDFORMULS,
                 S.FORMULS --CQ[9297]  1
          from A_SRF_F F
          left outer join SRF_FORMULS S on S.ID = F.IDFORMULS  --CQ[9297]  1
          where F.ID_TR = :ID_TR and
                F.NUMBER = :VRPZ
          into /*:pa, :pb, :pc, :pd,*/ :TIPRAB, :VIDRAB, :IN_IDFORMULS,
               :FORMULS; --CQ[9297]  1
        else
        begin
          select
                 /*f.pa, f.pb, f.pc, f.pd,*/ F.TIPRAB, F.VIDRAB, F.FORMULS
          --CQ[9297]from A_DEFAULT_SEI(:IDUSER) F
          from A_DEFAULT_SEI_FORMULS(:IDUSER) F
          into /*:cur_pa, :cur_pb, :cur_pc, :cur_pd,*/ :TIPRAB, :VIDRAB, :FORMULS;

          --CQ[9297]-->
          execute procedure SRF_FORMULS_WRITE(:IDUSER, -1, -1, -1, :FORMULS)
          returning_values (:IN_IDFORMULS, :FORMULS);
          --CQ[9297]<--
        end
      end

    if (USE_OBJ_NASTR_K <> 0) then
      select P.KA, P.KB, P.KC, P.KD, P.KE, P.KF, P.KG, P.KH, P.KI, P.KJ, P.KK, P.KL, P.KM
      from L_S_GET_POPR(:ATYPE, :SLAVEPARENT, :RES_COPY_POPR, :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM) P
      into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM;

    --CQ[9297] -->
    if (USE_OBJ_NASTR_F <> 0) then
    begin
      select RES_VRPZ, RES_TIPRAB, RES_VIDRAB, RES_IDFORMULS, RES_PA, RES_PB, RES_PC, RES_PD
      from A_S_GET_FORMULS_DM(:IDUSER, :ATYPE, :SLAVEPARENT, :CUR_ID_TR, :VRPZ, :RES_COPY_FORMULS, :TIPRAB)
      into :S_VRPZ, :TIPRAB, :VIDRAB, :IN_IDFORMULS, :S_PA, :S_PB, :S_PC, :S_PD;
      if (USE_ARGS_F = 0) then
      begin
        VRPZ = S_VRPZ;
      end
      --CQ[9297]  1 -->
      FORMULS = null;
      select FORMULS from SRF_FORMULS
      where ID = :IN_IDFORMULS
      into :FORMULS;
      --CQ[9297] <--
    end
    else
    --CQ[9297] <--
    if ((VIDRAB is null) or (VIDRAB = 0)) then
    begin
      --CQ[9297] -->
      select RES_VIDRAB
      from A_S_GET_FORMULS_DM(:IDUSER, :ATYPE, :SLAVEPARENT, :CUR_ID_TR, :VRPZ, :RES_COPY_FORMULS, :TIPRAB)
      into :VIDRAB;
      --CQ[9297] <--
    end
  end

  if ((ATYPE = 18) and
      (NORMARASH > 0)) then
  begin
    CUR_KOLL_PARENT = 0;
    select S.KOLL
    from A_SMETA S
    where S.ID = :SLAVEPARENT
    into :CUR_KOLL_PARENT;

    KOLL = CUR_KOLL_PARENT * NORMARASH;
  end

  PR_ADDED_REC = 0;
  if (not SMETATYPE in (15, 16)) then
    PR_ADDED_REC = 1;

  if ((not ATYPE in (17, 18))) then
  begin
    if (PA is null) then
      PA = 0.0;
    if (PB is null) then
      PB = 0.0;
    if (PC is null) then
      PC = 1.0;
    if (PD is null) then
      PD = 1.0;
  end

  if ((not ATYPE in (17, 18))) then
  begin
    if (MA is null) then
      MA = 1.0;
    if (MB is null) then
      MB = 1.0;
    if (MC is null) then
      MC = 1.0;
    if (MD is null) then
      MD = 1.0;
    if (ME is null) then
      ME = 1.0;
    if (MF is null) then
      MF = 1.0;
    if (MG is null) then
      MG = 1.0;
    if (MH is null) then
      MH = 1.0;
    if (MI is null) then
      MI = 1.0;
  end

  if (BA is null) then
    BA = 0.0;
  if (BB is null) then
    BB = 0.0;
  if (BC is null) then
    BC = 0.0;
  if (BD is null) then
    BD = 0.0;
  if (BE is null) then
    BE = 0.0;
  if (BF is null) then
    BF = 0.0;
  if (BG is null) then
    BG = 0.0;
  if (BH is null) then
    BH = 0.0;
  if (BI is null) then
    BI = 0.0;

  if (IDNORMATIV is null) then
    IDNORMATIV = 0;
  if (IDNORMATIVUNIQ is null) then
    IDNORMATIVUNIQ = 0;
  if (KODIR_GROUP is null) then
    KODIR_GROUP = 1;
  if (KODIR_PODGROUP is null) then
    KODIR_PODGROUP = 1;
  if (ISGROUPOKP is null) then
    ISGROUPOKP = 0;

  if (TIPRAB < 1) then
    TIPRAB = 1;
  if (VRPZ < 0) then
    VRPZ = 0;

  NEEDUPDATE_NAME_PART = 1;
  NEEDUPDATE_NAME_TITLE = 1;
  if (NAME is null) then
    NEEDUPDATE_NAME_PART = 0;
  if (NAME_TITLE is null) then
    NEEDUPDATE_NAME_TITLE = 0;

  NAME_ID = null;
  if ((NEEDUPDATE_NAME_PART <> 0) or (NEEDUPDATE_NAME_TITLE <> 0)) then
    select IDNAME
    from B_WRITE_NAME_EX(:IDUSER, -1, 0, :NAME, :NEEDUPDATE_NAME_PART, :NAME_TITLE, :NEEDUPDATE_NAME_TITLE)
    into :NAME_ID;

  select BA, BB, BC, BD, BE, BF, BG, BH, BI, /*BJ,*/
         EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
         RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
         PA, PB, PC, PD, /*PE,*/
         MA, MB, MC, MD, ME, MF, MG, MH, MI /*, MJ, MK, ML*/
  from L_S_APPENDREC_VALIDATE_PARAMS(:BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, 0 /*:BJ*/ ,
          :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
          :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
          :PA, :PB, :PC, :PD, 0 /*:PE*/ ,
          :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, 0 /*:MJ*/ , 0 /*:MK*/ , 0 /*:ML*/ )
  into BA, BB, BC, BD, BE, BF, BG, BH, BI, /*BJ,*/
       EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
       RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
       PA, PB, PC, PD, /*PE,*/
       MA, MB, MC, MD, ME, MF, MG, MH, MI /*, MJ, MK, ML*/ ;

  if (UTV is null) then
    UTV = 0;
  begin
    -- MK CQ[12072]
    if (ATYPE = 19) then
      IN_IDFORMULS = null;

    --  
    insert into A_SMETA (ID, IDHIER, SMETATYPE, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE,
                         RABMAT, TAB, ALTTAB, NAME_ID, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
                         BA, BB, BC, BD, BE, BF, BG, BH, BI,
                         EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                         RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                         PA, PB, PC, PD,
                         IDTIPR,
                         KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                         PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI,
                         SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH,
                         TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP,
                         ISGROUPOKP, ID_S_RES, VRPZ, PR_ADDED_REC, NORM_GUID, VIDRAB,
                         UTV, ASUBTYPE, IDFORMULS)
    values (:ID, :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT, :ATYPE,
            :RABMAT, :TAB, :ALTTAB, :NAME_ID, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
            :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
            :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
            :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
            :PA, :PB, :PC, :PD,
            :IDTIPR,
            :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
            :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
            :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH,
            :TIPRAB, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP,
            :KODIR_PODGROUP, :ISGROUPOKP, :ID_S_RES, :VRPZ, :PR_ADDED_REC, :NORM_GUID, :VIDRAB,
            :UTV, :ASUBTYPE, :IN_IDFORMULS);

    when gdscode FOREIGN_KEY, gdscode BAD_SEGSTR_ID do
    begin

      --CQ[9297]  -->
      if  (:FORMULS is not null) then
        IN_IDFORMULS = null;
      --CQ[9297] <--

      insert into A_SMETA (ID, IDHIER, SMETATYPE, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE,
                           RABMAT, TAB, ALTTAB, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
                           BA, BB, BC, BD, BE, BF, BG, BH, BI,
                           EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                           RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                           PA, PB, PC, PD,
                           IDTIPR,
                           KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                           PUNKTIND, MA, MB, MC, MD, ME, MF, MG, MH, MI,
                           SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH,
                           TIPRAB, IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP,
                           ISGROUPOKP, ID_S_RES, VRPZ, PR_ADDED_REC, NORM_GUID, VIDRAB,
                           UTV, ASUBTYPE, IDFORMULS)
      values (:ID, :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT, :ATYPE,
              :RABMAT, :TAB, :ALTTAB, :ID_EDIZM, :EDIZM_TYPE, :KOLL, :SKOLL, :NORMARASH,
              :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
              :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK,
              :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
              :PA, :PB, :PC, :PD,
              :IDTIPR,
              :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
              :PUNKTIND, :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,
              :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, :NACH, :OKONCH,
              :TIPRAB, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP,
              :ISGROUPOKP, :ID_S_RES, :VRPZ, :PR_ADDED_REC, :NORM_GUID, :VIDRAB,
              :UTV, :ASUBTYPE, :IN_IDFORMULS);

      select IDNAME
      from B_WRITE_NAME_EX(:IDUSER, 22, :ID, :NAME, 1, :NAME_TITLE, 1)
      into :NAME_ID;


      --CQ[9297]  -->
      if  (:FORMULS is not null) then
        execute procedure SRF_FORMULS_WRITE(:IDUSER, -1, :ID, 2, :FORMULS)
        returning_values (:IN_IDFORMULS, :FORMULS);
      --CQ[9297] <--

      when gdscode FOREIGN_KEY do
        exception B_E_RECORD_IS_LOCKED;
    end
  end

  -- MK CQ[12020, 14608] --->
  update a_smeta_view_num
  set number1 = :NUMBER1,
      number2 = :NUMBER2,
      number3 = :NUMBER3
  where (id = :ID);
  -- MK CQ[12020, 14608] <---


  --CQ[9297]  -->
  for select L.ID
    from LEVEL_COST L
    where (L.IDOBJECT = :IDCLASS)
    into :ID_LEVEL
  do
  begin
    ID_LEVEL_VC = null;
    BJ = null;
    ITOGO = 0.0;
    CALCBMASK = null;
    BASE_INFO = null;
    CURR_CENA = 0.0;
    BASE_CALC_INFO = null;
    SOURCE_LEVEL_ID = null;
    IDINDEX = null;
    ID_LEVEL_INDEX = null;

    -- MK 2.08.2012 CQ[11461] --->
    -- 
    ML = ME; --  
    -- 
    MM = MC; --  
    -- 
    MJ = MB; --  
    -- 
    if (:RABMAT = 0) then        -- 
      MK = MA; --  
    else if (:RABMAT = 1) then   -- 
    begin
      if (:TAB starting '2') then  --  
        MK = MD; --  
      else                       --  
        MK = ME; --  
    end
    else if (:RABMAT = 2) then   -- 
      MK = MC; --  
    else if (:RABMAT = 3) then   -- 
      MK = MB; --  

    --MJ = 1;
    --MK = 1;
    --ML = 1;
    --MM = 1;
    -- MK 2.08.2012 CQ[11461] <---

    INDEX_SPOSOBRASCH = 2;
    INDEX_INFO = null;
    NEED_APPLY_INDEX = 1;

    -- USE_OBJ_NASTR_M = 1 -      
    if ((USE_OBJ_NASTR_M <> 0) or (GETBIT(:B_DORECALL, 0) = 1)) then
    begin
      execute procedure NL_GET_CENLVL_NEW(:ID_LEVEL, :IDCLASS, :IDUSER, :TIPRAB, :VIDRAB, :ATYPE,
        :RABMAT, :IDHIER, :IDNORMATIV, :KODIR_PODGROUP, :PUNKTIND, 0,
        :BA, :BB, :BC, :BD, :BE,
        :B_PR, --[15352]
        :ID, :NEED_APPLY_INDEX)
      returning_values (:NL_ID_LEVEL_VC, :NL_IDZONE, :NL_ID_LEVEL_INDEX, :NL_IDINDEX,
        :NL_BA, :NL_BB, :NL_BC, :NL_BD, :NL_BE,
        :NL_B_PR, --[15352]
        :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME,
        :NL_MF, :NL_MG, :NL_MH, :NL_MI,
        :NL_MJ, :NL_MK, :NL_ML, :NL_MM,
        :NL_M_PR, --[15352]
        :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE,
        :NL_DJ, :NL_DK, :NL_DL, :NL_DM,
        :NL_PUNKTIND, :NL_SPOSOB_RASCH, :NL_RES_VC, :NL_RES_INDEX);
    end

    if (GETBIT(:B_DORECALL, 0) = 1) then
    begin
      if (GETBIT(:B_DORECALL, 1) = 1) then
        BA = NL_BA;
      if (GETBIT(:B_DORECALL, 2) = 1) then
        BB = NL_BB;
      if (GETBIT(:B_DORECALL, 3) = 1) then
        BC = NL_BC;
      if (GETBIT(:B_DORECALL, 4) = 1) then
        BD = NL_BD;
      if (GETBIT(:B_DORECALL, 5) = 1) then
        BE = NL_BE;
    end

    if (USE_OBJ_NASTR_M <> 0) then
    begin
      MA = NL_MA;
      MB = NL_MB;
      MC = NL_MC;
      MD = NL_MD;
      ME = NL_ME;
      MF = NL_MF;
      MG = NL_MG;
      MH = NL_MH;
      MI = NL_MI;
      MJ = NL_MJ;
      MK = NL_MK;
      ML = NL_ML;
      MM = NL_MM;
      PUNKTIND = NL_PUNKTIND;
      INDEX_SPOSOBRASCH = :NL_SPOSOB_RASCH;
      INDEX_INFO = :NL_RES_INDEX;
      IDINDEX = :NL_IDINDEX;
      ID_LEVEL_INDEX = :NL_ID_LEVEL_INDEX;
    end
    else
    begin
      -- MK CQ[12678] --->
      NL_DA = :MA;
      NL_DB = :MB;
      NL_DC = :MC;
      NL_DD = :MD;
      NL_DE = :ME;

      NL_DJ = :MJ;
      NL_DK = :MK;
      NL_DL = :ML;
      NL_DM = :MM;

      --NL_DA = null;
      --NL_DB = null;
      --NL_DC = null;
      --NL_DD = null;
      --NL_DE = null;
      --NL_DJ = null;
      --NL_DK = null;
      --NL_DL = null;
      --NL_DM = null;
      -- MK CQ[12678] <---
    end

    --USE_OBJ_NASTR_F = 1 -      
    if ((USE_OBJ_NASTR_F <> 0) and
        (USE_ARGS_P = 0)) then
    begin
      PA = S_PA;
      PB = S_PB;
      PC = S_PC;
      PD = S_PD;
    end

    execute procedure A_SMETA_NL_IMP(:ID, :ID_LEVEL, :ID_ZONE, :ID_LEVEL_VC, --
      :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, -- Bx
      null, null, null, -- CQ[13182]
      :B_PR, --[15352]
      :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, -- Cx
      null, -- CQ[13182]
      :B_PR, --[15352]
      :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK, -- Ex
      null, null, null, -- CQ[13182]
      :E_PR, --[15352]
      :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, -- Rx
      :PA, :PB, :PC, :PD, :ITOGO,
      :R_PR, :RC_16, :RE_16, --[15352]
      :CALCBMASK, :BASE_INFO, :CURR_CENA, :BASE_CALC_INFO,
      :SOURCE_LEVEL_ID, :IDINDEX, :ID_LEVEL_INDEX, :PUNKTIND, --
      :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :MJ, :MK, :ML, :MM, --Mx
      :M_PR, --[15352]
      :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE, :NL_DJ, :NL_DK, :NL_DL, :NL_DM, --Dx
      :INDEX_SPOSOBRASCH, :INDEX_INFO, --
      null, null, null, null, null, null, null, null, null, null, null, null, null, null, -- NMx  15361 + null  NM_PR
      null, null, null, null, null, null, null, null, null, --NDx
      null, 1, null, null, null, null, null, null, null, null,  -- MK CQ[11996]
      null);                                                    -- MK CQ[13018]
  end
  --CQ[9297] <--

  if (((SKIP_INS_SM_RES is null) or (SKIP_INS_SM_RES in (0, 2))) and


      (ATYPE = 17)) then


    /* MK 17.08.2006 CQ[3569]    -      */
    /*CQ[9297]for select ADDEDID
        from a_s_add_res ( :IDUSER, :id, :res_kodir_group, :res_kodir_podgroup, :id_zone,
                           0 , 0 , 0, :RES_APPLY_TAB, null, null, null, null, null, NULL, NULL, 0, 0)
        into ADDEDID
    do
       ADDEDID = ADDEDID; CQ[9297]*/
    --CQ[9297] -->
    for select ADDEDID
      from A_S_ADD_RES_NL(:IDUSER, :ID, :RES_KODIR_GROUP, :RES_KODIR_PODGROUP,
          :ID_ZONE, 0, 0, 0, :RES_APPLY_TAB, null, null, null,
          null, null, null, null, 0, 0, 1)
      into ADDEDID
    do
    begin
      ADDEDID = ADDEDID;
    end
  --CQ[9297] <--

  if ((not SKIP_INS_SM_RES is null) and
      (SKIP_INS_SM_RES in (2, 3))) then
    /* bit 1 == 1*/
    if ((not SLAVEPARENT is null) and
        (SLAVEPARENT > 0) and
        (ATYPE = 18) and
        (ID_S_RES is null)) then
    begin

      execute procedure A_S_RES_SLAVETORES(:IDUSER, :ID, :RES_KODIR_GROUP, :RES_KODIR_PODGROUP,
        :IDNORMATIV, :KODIR_PODGROUP, :RABMAT, :IDNORMATIV, 0) --MK 17.08.2006 CQ[3569]
      returning_values (:ADDED_RES);

      --CQ[9297]-->
      for select L.ID
        from LEVEL_COST L
        where (L.IDOBJECT = :IDCLASS)
        into :ID_LEVEL
      do
      begin
        execute procedure A_S_SYNHRON_SLAVE_RES_NL(:IDUSER, 1, 0, :ID, :ADDED_RES, :ID_LEVEL)
        returning_values :SYNCRON_RES;
      end
      --CQ[9297]<--
    end

  if (not SMETATYPE in (15, 16)) then
  begin
    if (ATYPE = 17) then
    begin
      execute procedure L_PR_GET_MAX_NUMBER1(:IDHIER, :IDUSER)
      returning_values (:PR_NUMBER1);
      insert into L_S_PR_ADDINFO (ID, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3)
      values (:ID, :PR_NUMBER1, :NUMBER2, :NUMBER3);
    end
    else
    begin
      execute procedure L_PR_GET_NUMBER_1_2(:SLAVEPARENT, :IDHIER, :IDUSER)
      returning_values (:PR_NUMBER1, :PR_NUMBER2);
      insert into L_S_PR_ADDINFO (ID, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3)
      values (:ID, :PR_NUMBER1, :PR_NUMBER2, :NUMBER3);
    end
  end
end
^

--[15559.Q]
create or alter procedure B_EXP_RECORD_ABC_OKP (
    IDUSER integer,
    IN_ID integer)
returns (
    ID integer,
    IDPODGROUP integer,
    RABMAT integer,
    ORDERVIEW integer,
    ID_UNIQUE integer,
    TAB varchar(42),
    TABU varchar(42),
    ISGROUPOKP integer,
    IDNAME integer,
    IDEDIZM integer,
    comment varchar(42),
    CENA double precision,
    RAZRAD double precision,
    PUNKTIND varchar(42),
    IDPOSTAV integer,
    VRPZ integer,
    NTR integer,
    NEW_PAGE integer,
    IDQUALIFIER integer,
    IDNORMA integer,
    IDREESTRNORMA integer,
    IDABCGROUP integer,
    IDABCVERSION integer,
    TYPE_TRUD integer)
AS
DECLARE VARIABLE IS_OK_REFERENCE INTEGER;
BEGIN
 FOR SELECT ID, RABMAT, ORDERVIEW, ID_UNIQUE, IDPODGROUP, TAB, TABU,
     ISGROUPOKP, IDNAME, IDEDIZM, CENA, RAZRAD, PUNKTIND, VRPZ, NTR,
     IDNORMA, COMMENT, IDPOSTAV, IDQUALIFIER, NEW_PAGE, TYPE_TRUD
 FROM B_ABC_OKP
 WHERE ID = :IN_ID
    INTO ID, :RABMAT, :ORDERVIEW, :ID_UNIQUE, :IDPODGROUP, :TAB, :TABU,
     :ISGROUPOKP, :IDNAME, :IDEDIZM, :CENA, :RAZRAD, :PUNKTIND, :VRPZ, :NTR,
     :IDNORMA, :COMMENT, :IDPOSTAV, :IDQUALIFIER, :NEW_PAGE, :TYPE_TRUD
 DO BEGIN
    --[12447.9]     :
    if (:TAB <> '') then
      TABU = S_TRANSLITERATE(:TAB);

    /*    - */
    --[15559.Q]IDQUALIFIER = NULL ;

    IF (IDNORMA IS NOT NULL) THEN BEGIN
       EXECUTE PROCEDURE L_FB_ISVALIDREFERENCETORABMAT(:ID, :IDNORMA, :RABMAT)
       RETURNING_VALUES IS_OK_REFERENCE;

       IF (IS_OK_REFERENCE = 0)
       THEN IDNORMA = NULL ;
       ELSE
          IF (RABMAT = 1)
          THEN IDREESTRNORMA = 1;
          ELSE
             SELECT IDREESTR
             FROM B_RABMAT
             WHERE ID = :IDNORMA
             INTO :IDREESTRNORMA ;
    END

    SELECT IDABCGROUP, IDVER
    FROM B_ABC_OKP_VER
    WHERE IDABCOKP = :ID
    INTO IDABCGROUP, IDABCVERSION;

    IF (IDABCVERSION IS NULL)
    THEN IDABCVERSION = -1;

    SUSPEND;
 END
END
^

--[15559.Q]
create or alter procedure B_IMP_I_ABC_OKP_2 (
    IDUSER integer,
    IMPMODE integer,
    IDPODGROUP integer,
    RABMAT integer,
    ORDERVIEW integer,
    ID_UNIQUE integer,
    TAB varchar(42),
    TABU varchar(42),
    ISGROUPOKP integer,
    IDNAME integer,
    IDEDIZM integer,
    comment varchar(42),
    CENA double precision,
    RAZRAD double precision,
    PUNKTIND varchar(42),
    IDPOSTAV integer,
    VRPZ integer,
    NTR integer,
    NEW_PAGE integer,
    IDQUALIFIER integer,
    IDNORMA integer,
    IDABCGROUP integer,
    IDABCVERSION integer,
    TYPE_TRUD integer)
returns (
    ID integer)
AS
DECLARE VARIABLE REORDERING INTEGER;
DECLARE VARIABLE AINSERTING INTEGER;
DECLARE VARIABLE IDNAME_OLD INTEGER;
BEGIN
 IF (:IDEDIZM = 0) THEN IDEDIZM = NULL;
 IF (:IDNAME = 0) THEN IDNAME = NULL;
 IF (:IDQUALIFIER = 0) THEN IDQUALIFIER = NULL;
 IF (:IDNORMA = 0) THEN IDNORMA = NULL;
 IF (:IDABCGROUP = 0) THEN IDABCGROUP = NULL;
 IF (:IDABCVERSION < 0) THEN IDABCVERSION = NULL;

  if (:IMPMODE = 3) then ORDERVIEW = null; /*   */

 /*    - */
 --[15559.Q]IDQUALIFIER = NULL ;

 IF (:TABU <> '' AND :IDPODGROUP > 1) THEN
 BEGIN
    --[14280]TABU = S_TRANSLITERATE_TAB(:TABU); --[12447.9]

    IF ((IDABCGROUP IS NOT NULL) AND (IDABCVERSION IS NOT NULL))
    THEN
       SELECT ID, NAMEID
       FROM B_IMP_F_ABC_OKP_VER(:IDUSER, :IDABCGROUP, :IDABCVERSION)
       INTO ID, IDNAME_OLD ;
    ELSE
       SELECT ID, NAMEID
       FROM B_IMP_F_ABC_OKP(:IDUSER, :IDPODGROUP, :RABMAT, :TABU, :IDNAME, :IDEDIZM)
       INTO ID, IDNAME_OLD ;

    TABU = S_TRANSLITERATE_TAB(:TABU); --[14280,12447.9]

    IF (:ID IS NULL) THEN
    BEGIN
       ID = GEN_ID (A_G_SMETA, 1);
       AINSERTING = 1;
    END
    else
    if (:IMPMODE = 3) then
      select ORDERVIEW /* 4/03/09 - update   */
        from B_ABC_OKP
        where ID = :ID
        into :ORDERVIEW;

    IF (:ORDERVIEW = -1) THEN
    /*    -    */
      REORDERING = 0;
    ELSE
    BEGIN

      IF (:ORDERVIEW IS NULL OR :ORDERVIEW <= 0)
      THEN
      begin
         SELECT MAX(ORDERVIEW) + 1
         FROM B_ABC_OKP
         WHERE RABMAT = :RABMAT AND
               IDPODGROUP = :IDPODGROUP
         INTO :ORDERVIEW;

        IF (ORDERVIEW IS NULL) THEN
          ORDERVIEW = 1;
          /*    -    
        ELSE
          REORDERING = 1; */
      end
      else
      if (:IMPMODE = 3) then /* 4/03/09 */
         REORDERING = 0; /* update   */
      /*   2008/07/03 [AE711D958997]
      else
         REORDERING = 1; */

    END

    IF (:REORDERING = 1)
    THEN
       EXECUTE PROCEDURE B_WRITE_NEWORDER_ABC_OKP (
           :IDUSER, :ID, :IDPODGROUP, :RABMAT, :ORDERVIEW )
       RETURNING_VALUES (:REORDERING);

    IF (:AINSERTING = 1)
    THEN
       INSERT INTO B_ABC_OKP (
           ID, RABMAT, ORDERVIEW, IDNAME, ID_UNIQUE, TAB, TABU,
           IDPODGROUP, ISGROUPOKP, IDEDIZM, CENA, RAZRAD, IDPOSTAV, IDNORMA,
           COMMENT, PUNKTIND, VRPZ, NTR, IDQUALIFIER, NEW_PAGE, TYPE_TRUD )
         VALUES (
           :ID, :RABMAT, :ORDERVIEW, :IDNAME, :ID_UNIQUE, :TAB, :TABU,
           :IDPODGROUP, :ISGROUPOKP, :IDEDIZM, :CENA, :RAZRAD, :IDPOSTAV, :IDNORMA,
           :COMMENT, :PUNKTIND, :VRPZ, :NTR, :IDQUALIFIER, :NEW_PAGE, :TYPE_TRUD );
    ELSE
    /*if (:IMPMODE <> 3) then /*  3 - update  -   */
    BEGIN
       UPDATE B_ABC_OKP
       SET RABMAT      = :RABMAT,
           ORDERVIEW   = :ORDERVIEW,
           IDNAME      = :IDNAME,
           ID_UNIQUE   = :ID_UNIQUE,
           TAB         = :TAB,
           TABU        = :TABU,
           IDPODGROUP  = :IDPODGROUP,
           ISGROUPOKP  = :ISGROUPOKP,
           IDEDIZM     = :IDEDIZM,
           CENA        = :CENA,
           RAZRAD      = :RAZRAD,
           IDPOSTAV    = :IDPOSTAV,
           IDNORMA     = :IDNORMA,
           COMMENT     = :COMMENT,
           PUNKTIND    = :PUNKTIND,
           VRPZ        = :VRPZ,
           NTR         = :NTR,
           IDQUALIFIER = :IDQUALIFIER,
           NEW_PAGE    = :NEW_PAGE,
           TYPE_TRUD   = :TYPE_TRUD
       WHERE ID = :ID;

       IF (:IDNAME_OLD IS NOT NULL AND
          (:IDNAME IS NULL OR :IDNAME_OLD <> :IDNAME))
       THEN
          EXECUTE PROCEDURE B_DELETE_NAIMENOVANIE (:IDUSER, :IDNAME_OLD);
    END

    /* if (:IMPMODE <> 3) -   */
    IF ((IDABCGROUP IS NOT NULL) AND (IDABCVERSION IS NOT NULL))
    THEN
       IF ((AINSERTING = 1) OR
           (NOT (EXISTS(SELECT * FROM B_ABC_OKP_VER WHERE IDABCOKP = :ID))))
       THEN
          INSERT INTO B_ABC_OKP_VER(IDABCOKP, IDABCGROUP, IDVER)
          VALUES (:ID, :IDABCGROUP, :IDABCVERSION) ;
       ELSE
          UPDATE B_ABC_OKP_VER
          SET IDABCGROUP = :IDABCGROUP,
              IDVER      = :IDABCVERSION
          WHERE (IDABCOKP = :ID) ;
 END

 SUSPEND;
END
^
/* CQ[15565] >> */
create or alter procedure SEARCH_FIRST_NORM_IN_QUALIFIER (
    IDQUALIFIER integer,
    RABMAT integer)
returns (
    ID integer,
    TAB varchar(42),
    NORM_GUID varchar(100))
AS
declare variable IDQUALIFIER_CHILD integer;
begin
  -- CQ[15565] >>
  ID = null;
  TAB = null;
  NORM_GUID = null;
  if (:IDQUALIFIER is null) then
    suspend;
  select first 1 b.ID, b.TAB, r.NORM_GUID
  from B_RABMAT b
  left outer join B_REESTR r on r.ID = b.IDREESTR
  where b.IDQUALIFIER = :IDQUALIFIER and
        b.RABMAT = :RABMAT
  order by b.IDQUALIFIER, b.TABU asc
  into :ID, :TAB, :NORM_GUID;

  if (:ID is null) then
  begin
    for select ID
      from B_QUALIFIER
      where IDPARENT = :IDQUALIFIER
      order by ORDERVIEW
      into :IDQUALIFIER_CHILD
    do
    begin
      ID = null;
      TAB = null;
      NORM_GUID = null;
      select ID, TAB, NORM_GUID
      from SEARCH_FIRST_NORM_IN_QUALIFIER(:IDQUALIFIER_CHILD, :RABMAT)
      into :ID, :TAB, :NORM_GUID;
      if (:ID is not null) then
      begin
        suspend;
        exit;
      end
    end
  end
  else
    suspend;
end
^

--[15515]
create or alter procedure GET_SM_CEN_CRC (
    ID integer,
    IDCLASS integer)
returns (
    CRC integer)
AS
declare variable VN_CA double precision;
declare variable VN_CB double precision;
declare variable VN_CC double precision;
declare variable VN_CD double precision;
declare variable VN_CE double precision;
declare variable VN_CF double precision;
declare variable VN_CG double precision;
declare variable VN_CH double precision;
declare variable VN_CI double precision;
declare variable VN_CJ double precision;

declare variable VN_EA double precision;
declare variable VN_EB double precision;
declare variable VN_EC double precision;
declare variable VN_ED double precision;
declare variable VN_EE double precision;
declare variable VN_EF double precision;
declare variable VN_EG double precision;
declare variable VN_EH double precision;
declare variable VN_EI double precision;
declare variable VN_EJ double precision;
declare variable VN_EK double precision;

declare variable VN_RA double precision;
declare variable VN_RB double precision;
declare variable VN_RC double precision;
declare variable VN_RD double precision;
declare variable VN_RE double precision;
declare variable VN_RF double precision;
declare variable VN_RG double precision;
declare variable VN_RH double precision;
declare variable VN_RI double precision;
declare variable VN_RJ double precision;
declare variable VN_RK double precision;
declare variable VN_RL double precision;
declare variable VN_RM double precision;

declare variable VN_PA double precision;
declare variable VN_PB double precision;
declare variable VN_PC double precision;
declare variable VN_PD double precision;
declare variable VN_ITOGO double precision;

declare variable VN_CRC integer;
declare variable VN_IDLEVEL integer;

declare variable VN_BN double precision;
declare variable VN_BO double precision;
declare variable VN_B_ITOGO double precision;

declare variable VN_C_ITOGO double precision;

declare variable VN_EN double precision;
declare variable VN_EO double precision;
declare variable VN_E_ITOGO double precision;

declare variable VN_NR_SP_FLAG integer;

declare C_PR double precision;
declare E_PR double precision;
declare R_PR double precision;
declare RC_16 double precision;
declare RE_16 double precision;
begin
--[15352,15515]
  CRC = 0;

  -- CQ[13232] -->
  VN_NR_SP_FLAG = 0;
  select GETBIT(coalesce(CLCMODE, 0), 16)
  from A_SMETA where ID = :ID
  into :VN_NR_SP_FLAG;
  -- CQ[13232] <--

  for select l.id
  from level_cost l
  where (l.idobject = :IDCLASS)
  order by l.lorder
  into :VN_IDLEVEL do
  begin
    for select
         C.CA, C.CB, C.CC, C.CD, C.CE, C.CF, C.CG, C.CH, C.CI, C.CJ,
         C.EA, C.EB, C.EC, C.ED, C.EE, C.EF, C.EG, C.EH, C.EI, C.EJ, C.EK,
         C.RA, C.RB, C.RC, C.RD, C.RE, C.RF, C.RG, C.RH, C.RI, C.RJ, C.RK, C.RL, C.RM,
         C.PA, C.PB, C.PC, C.PD, C.ITOGO,
         C.BN, C.BO, C.B_ITOGO, C.C_ITOGO, C.EN, C.EO, C.E_ITOGO, -- CQ[13232]
         C.C_PR, C.E_PR, C.R_PR, C.RC_16, C.RE_16 --[15515]
    from a_smeta_cenlvl c
    where (c.id = :ID) and (c.idcenlvl = :VN_IDLEVEL)
    into
       :VN_CA, :VN_CB, :VN_CC, :VN_CD, :VN_CE, :VN_CF, :VN_CG, :VN_CH, :VN_CI, :VN_CJ,
       :VN_EA, :VN_EB, :VN_EC, :VN_ED, :VN_EE, :VN_EF, :VN_EG, :VN_EH, :VN_EI, :VN_EJ, :VN_EK,
       :VN_RA, :VN_RB, :VN_RC, :VN_RD, :VN_RE, :VN_RF, :VN_RG, :VN_RH, :VN_RI, :VN_RJ, :VN_RK, :VN_RL, :VN_RM,
       :VN_PA, :VN_PB, :VN_PC, :VN_PD, :VN_ITOGO,
       :VN_BN, :VN_BO, :VN_B_ITOGO, :VN_C_ITOGO, :VN_EN, :VN_EO, :VN_E_ITOGO, -- CQ[13232]
       :C_PR, :E_PR, :R_PR, :RC_16, :RE_16 --[15515]
    do
    begin
      -- MK CQ[12613] --->
      if ((VN_PC is null) or (VN_PC = 0)) then
        VN_PC = 1;
      if ((VN_PD is null) or (VN_PD = 0)) then
        VN_PD = 1;
      -- MK CQ[12613] <---

      --  CRC
      VN_CRC = 0;
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CA, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CB, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CC, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CD, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CE, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CF, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CG, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CH, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CI, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_CJ, 0));
  
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EA, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EB, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EC, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_ED, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EE, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EF, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EG, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EH, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EI, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EJ, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EK, 0));
  
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RA, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RB, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RC, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RD, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RE, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RF, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RG, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RH, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RI, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RJ, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RK, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RL, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_RM, 0));
  
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_PA, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_PB, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_PC, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_PD, 0));
      VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_ITOGO, 0));
  
      -- CQ[13232] -->
      if (:VN_NR_SP_FLAG = 1) then
      begin
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_BN, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_BO, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_B_ITOGO, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_C_ITOGO, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EN, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_EO, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:VN_E_ITOGO, 0));
      end
      -- CQ[13232] <--

      --[15515]:   ,   ,    CRC
      if (coalesce(:C_PR, 0) <> 0 or
          coalesce(:E_PR, 0) <> 0 or
          coalesce(:R_PR, 0) <> 0 or
          coalesce(:RC_16, 0) <> 0 or
          coalesce(:RE_16, 0) <> 0) then
      begin
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:C_PR, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:E_PR, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:R_PR, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:RC_16, 0));
        VN_CRC = GET_DOUBLE_CRC(VN_CRC, coalesce(:RE_16, 0));
      end

      --       
      CRC = GET_INTEGER_CRC(CRC, coalesce(:VN_CRC, 0));
    end
  end

  suspend;
end
^

--------------------------------------------------------------------
--                           10.0.0.9, 9.2.1.9, 10.0.0.10
--------------------------------------------------------------------

-- Voyager CQ[15107]
create or alter procedure V_UPGRADE_L_SSR
as
begin
  if (not exists(
      select * from RDB$RELATION_FIELDS F
        where (upper(F.RDB$RELATION_NAME) = 'L_SSR') and
              (upper(F.RDB$FIELD_NAME) = 'IS_NOT_CALC'))) then
  begin
    execute statement
        'ALTER TABLE L_SSR ADD IS_NOT_CALC B_D_INTEGER';
   end
end
^
execute procedure V_UPGRADE_L_SSR
^
drop procedure V_UPGRADE_L_SSR
^^

--[15108]
create or alter procedure T__BASEUPGRADE_SSR
as
begin
  if (not exists(
      select * from RDB$RELATION_FIELDS F
        where (upper(F.RDB$RELATION_NAME) = 'L_SSR_PARAMS_NL') and
              (upper(F.RDB$FIELD_NAME) = 'SSR_STROIT_SUM'))) then
  begin
    execute statement 'ALTER TABLE L_SSR_PARAMS_NL ADD SSR_STROIT_SUM S_DOUBLE';
    execute statement 'ALTER TABLE L_SSR_PARAMS_NL ADD SSR_MONTAG_SUM S_DOUBLE';
    execute statement 'ALTER TABLE L_SSR_PARAMS_NL ADD SSR_OBORUD_SUM S_DOUBLE';
    execute statement 'ALTER TABLE L_SSR_PARAMS_NL ADD SSR_OTHER_SUM S_DOUBLE';
  end
end
^
execute procedure T__BASEUPGRADE_SSR
^
drop procedure T__BASEUPGRADE_SSR
^^


-- CQ[15115]
-- 
create or alter procedure M_GET_SMETA_LIGHT (
    START_ID_HIER integer,
    SMETATYPE integer)
returns (
    ID integer,
    ATYPE smallint,
    RABMAT integer)
AS
begin
    suspend;
end
^

--------------------------------------------------------------------
--                           10.0.0.10 ( 2017/04/04)
--------------------------------------------------------------------

/* CQ[15585] >> */
create or alter procedure IMP_SMREC_FROM_XML (
    ID_USER integer,
    IDHIER integer,
    IDOBJECT integer,
    SMETATYPE integer,
    ATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    RABMAT integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    KOLL double precision,
    SKOLL varchar(255),
    NORMARASH double precision,
    EDIZM_NAME varchar(100),
    EDIZM_FULLNAME varchar(250),
    EDIZM_RELATION double precision,
    NAME blob sub_type 0 segment size 80,
    VRPZ integer,
    NACH date,
    OKONCH date,
    TIPRAB integer,
    NORM_GUID varchar(100),
    KODIR_GROUP_NAME varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ISGROUPOKP integer,
    PR_VSEGO double precision,
    VIDRAB integer,
    UTV integer,
    CLCMODE integer,
    TYPE_TRUD integer,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    CORRECTNODE blob sub_type 0 segment size 80,
    CORRECTNODE_1 blob sub_type 0 segment size 80,
    ID_S_RES integer,
    REC_ADD_MODE integer,
    IDNORMATIV integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    BN double precision,
    BO double precision,
    B_ITOGO double precision,
    VIEW_NUMBER1 integer,
    VIEW_NUMBER2 integer,
    VIEW_NUMBER3 integer,
    K_ITOGO varchar(50),
    B_PR double precision,
    K_PR varchar(50))
returns (
    ID integer,
    NEW_ID_PS integer)
AS
declare variable I integer;
declare variable ID_NAME integer;
declare variable KODIR_GROUP integer;
declare variable KODIR_PODGROUP integer;
declare variable ID_EDIZM integer;
--declare variable ID_GROUP_EDIZM integer;
-- declare variable IDNORMATIV integer;
declare variable NOMERROD integer;
declare variable PR_ADDED_REC integer;
-- CQ[14238, 13929] declare variable NEW_ID_PS integer;
declare variable VN_NUMBER1 integer;
declare variable VN_NUMBER2 integer;
declare variable VN_SLAVEPARENT integer;
declare variable VN_ID_S_RES integer;
declare variable cur_id_tr integer;
declare variable res_copy_formuls integer;
-- MK CQ[12020, 14278]
declare variable VN_CLCMODE integer;
begin
--[15352]+
  -- ===========================================================================
  --       XML
  -- ===========================================================================

  ------------------------------------------------------------------------------
  -- REC_ADD_MODE -      (   (SMETATYPE <> 15))
  -- 0 -     (SMETATYPE = 15),  
  -- 1 -        .    <-- Voyager CQ[11418] ,   
  -- 2 -  .    (. ),       - .
  -- 3 -  . 


  ID = gen_id( a_g_smeta, 1); --      -- CQ[14238, 13929]  NEW_ID  ID

  NEW_ID_PS = 0; -- CQ[14238, 13929]

  --    ----------------------------------------------
  if (:UTV is null) then UTV = 0;
  if (:EDIZM_RELATION is null) then EDIZM_RELATION = 1;
  KODIR_GROUP = 1;
  KODIR_PODGROUP = 1;
  -- CQ[13026] IDNORMATIV = 0;
  NOMERROD = 0;
  PR_ADDED_REC = 0;
  if (ID_S_RES = 0) then
    ID_S_RES = null;
  ISGROUPOKP = coalesce(ISGROUPOKP, 0);


   --    blob -----------------------------------------------------
   I = gen_id( B_GEN_TEMP, 1 );
   insert into B_TEMP_BLOB(ID, BLOB1, SEA, SEB) values (:I, :NAME, :CORRECTNODE, :CORRECTNODE_1);
   select BLOB1, SEA, SEB from B_TEMP_BLOB where ID = :I into :NAME, :CORRECTNODE, :CORRECTNODE_1;
   delete from B_TEMP_BLOB where ID = :I;


  --      ------------------------
  select first 1 n.IDNAME
  from B_WRITE_NAIMENOVANIE (:ID_USER, -1, 0, :NAME) n
  into :ID_NAME;

  if (ATYPE <> 19) then --  
  begin
    --  KODIR_GROUP, KODIR_PODGROUP ---------------------------------------
    -- Voyager CQ[10981]
    --execute procedure M_FIND_KODIRS_ID_FOR_IMP (:SMETATYPE, :KODIR_GROUP_NAME,
    execute procedure V_FIND_KODIRS_ID_FOR_IMP (:IDOBJECT, :SMETATYPE, :KODIR_GROUP_NAME,
                                                :KODIR_PODGROUP_NAME)
    returning_values (:KODIR_GROUP, :KODIR_PODGROUP);
  
  
    --  ID_EDIZM ----------------------------------------------------------
    /*ID_EDIZM = null;
    if (coalesce(EDIZM_NAME, '') <> '') then
    begin
      if (coalesce(EDIZM_FULLNAME, '') = '') then
          EDIZM_FULLNAME = EDIZM_NAME;

      execute procedure B_FIND_EDIZM(:ID_USER, :EDIZM_NAME, :EDIZM_FULLNAME)
      returning_values (:ID_EDIZM);

      --    -   
      if (:ID_EDIZM is null) then
      begin
        execute procedure B_GEN_DEF_EDGROUP_ID(:ID_USER)
        returning_values (:ID_GROUP_EDIZM);
        execute procedure B_ADD_EDIZM (:ID_USER, :ID_GROUP_EDIZM, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION)
        returning_values (:ID_EDIZM);
      end
    end*/

    --:     ,    Copy Paste   
    execute procedure IMP_EDIZM (:ID_USER, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION)
    returning_values (:ID_EDIZM);
  
      -- <-- Voyager CQ[12939]
      IDNORMATIV = coalesce(IDNORMATIV,0);
      execute procedure L_GET_NORMATIV_FROM_GUID ( :NORM_GUID, :TAB, :IDNORMATIV,
        :KODIR_PODGROUP, :RABMAT, :ID_USER )
      returning_values ( :IDNORMATIV, :KODIR_PODGROUP, :RABMAT );
    
      --   IDNORMATIV ------------------------------------------------
      --      /    
      /*
      execute procedure m_find_normativ(:IDHIER, :SMETATYPE, :KODIR_PODGROUP,
                                        :RABMAT, :ID_USER, :TAB)
      returning_values (:IDNORMATIV);
      */
      -- <-- Voyager CQ[12939]
  end

   -- <-- Voyager CQ[10981]
   --    ,      sob/sobx
   if (VIDRAB = -1) then --      SobToXML
   begin
    select p.id_tr, p.res_copy_formuls
      --from a_s_get_params_obj( :id_user, :idhier ) p
      from A_GET_PARAMS_OBJ_AKT( :id_user, :idhier, :SMETATYPE ) p
      into :cur_id_tr, res_copy_formuls;

    select f.RES_VIDRAB
      from A_S_GET_FORMULS_DM ( :ID_USER,
          :ATYPE, :SLAVEPARENT, :CUR_ID_TR, :VRPZ, :RES_COPY_FORMULS, :TIPRAB ) f
      into :VIDRAB;

    --    -  
    if (VIDRAB = -1) then
        VIDRAB = 0;
   end
   -- <-- Voyager CQ[10981]


  --      : .   
  if (SMETATYPE <> 15) then
  begin
    --        .   
    -- Voyager CQ[11418].   (    ,  )  ,  .
    if (REC_ADD_MODE = 1) then
    begin
      VN_SLAVEPARENT = null;
      VN_ID_S_RES = null;

      if (ATYPE in (18, 19)) then
      begin
        --  SLAVEPARENT  
        if (coalesce(:SLAVEPARENT, 0) > 0) then
        begin
          select first 1 s.nomerrod
          from a_smeta s
          where (s.ID = :SLAVEPARENT)
          into :VN_SLAVEPARENT;
        end

        --  VN_ID_S_RES  
        if ((ATYPE = 18) and (coalesce(:ID_S_RES, 0) > 0)) then
        begin
          select first 1 r.nomerrod
          from a_s_res r
          where (r.id = :ID_S_RES)
          into :VN_ID_S_RES;
        end
      end


      -- CQ[13116] -->
      -- CQ[15585] :     
      -- if (:ATYPE = 17) then -- SmRec
      -- CLCMODE = SetBit(coalesce(:CLCMODE, 0), 17, 1); -- NeedPaidClcMode
      -- CQ[13116] <--

      --    
      NEW_ID_PS = gen_id( a_g_smeta, 1);
      insert into a_smeta (ID, IDHIER, SMETATYPE, ATYPE, NUMBER1, NUMBER2, NUMBER3,
                           SLAVEPARENT, RABMAT, TAB, ALTTAB, KOLL, SKOLL, NORMARASH,
                           VRPZ, NACH, OKONCH, TIPRAB, IDNORMATIV, ISGROUPOKP,
                           VIDRAB, UTV, CLCMODE, TYPE_TRUD, NORM_GUID, NOMERROD, NOMERROD1,
                           KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                           CORRECTNODE, CORRECTNODE_1, PR_ADDED_REC, ID_S_RES,
                           NAME_ID, KODIR_GROUP, KODIR_PODGROUP, ID_EDIZM,
                           BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BN, BO, B_ITOGO, -- <-- Voyager CQ[13244]
                           B_PR, --[15352]
                           K_ITOGO/*14460*/, K_PR)
      values (:NEW_ID_PS, :IDHIER, 15, :ATYPE, :NUMBER1, :NUMBER2, :NUMBER3,
              :VN_SLAVEPARENT, :RABMAT, :TAB, :ALTTAB, /*:KOLL <-Voyager CQ[11418]*/:PR_VSEGO, /*:SKOLL <-Voyager CQ[11418]  1*/NULL, :NORMARASH,
              :VRPZ, :NACH, :OKONCH, :TIPRAB, :IDNORMATIV, :ISGROUPOKP,
              :VIDRAB, :UTV, :CLCMODE, :TYPE_TRUD, :NORM_GUID, 0, :NEW_ID_PS,
              :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
              :CORRECTNODE, :CORRECTNODE_1, 0, :VN_ID_S_RES,
              :ID_NAME, :KODIR_GROUP, :KODIR_PODGROUP, :ID_EDIZM,
              :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO, -- <-- Voyager CQ[13244]
              :B_PR, --[15352]
              :K_ITOGO/*14460*/, :K_PR/*15421*/);


      -- MK CQ[12020] --->
      -- MK CQ[14278] --->
      VN_CLCMODE = 0;
      if (coalesce(VN_SLAVEPARENT, 0) <> 0) then
      begin
        select getbit(coalesce(s.clcmode, 0), 10)
        from a_smeta s
        where (s.id = :VN_SLAVEPARENT)
        into :VN_CLCMODE;
      end
      else
        VN_CLCMODE = getbit(:CLCMODE, 10);

      --     
      if (VN_CLCMODE = 1) then
      begin
        update a_smeta_view_num v
        set v.NUMBER1 = null,
            v.NUMBER2 = null,
            v.NUMBER3 = null
        where (v.id = :NEW_ID_PS);
      end
      else
      -- MK CQ[14278] <---
      begin
        -- MK CQ[12020, 14357]  NUMBERx  VIEW_NUMBERx + case
        update a_smeta_view_num v
        set v.NUMBER1 = case when :VIEW_NUMBER1 = -1 then null else :VIEW_NUMBER1 end,
            v.NUMBER2 = case when :VIEW_NUMBER2 = -1 then null else :VIEW_NUMBER2 end,
            v.NUMBER3 = case when :VIEW_NUMBER3 = -1 then null else :VIEW_NUMBER3 end
        where (v.id = :NEW_ID_PS);
      end
      -- MK CQ[12020] <---

      NOMERROD = NEW_ID_PS;
      PR_ADDED_REC = 0;

      --        
      --        
      if (ATYPE <> 19) then
        execute procedure M_SET_SM_REC_ENTITYS(:ID_USER, :NEW_ID_PS);
    end
    --  .    ( )
    else if (REC_ADD_MODE = 2) then
    begin
      execute procedure M_FIND_PROEKT_REC(:ID_USER, :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3)
      returning_values(:NEW_ID_PS);

      --  -  
      if (NEW_ID_PS <> -1) then
      begin
        NOMERROD = NEW_ID_PS;
        PR_ADDED_REC = 0;
      end

      --   -  . 
      else
      begin
        NOMERROD = 0;
        PR_ADDED_REC = 1;
      end
    end
    --  . 
    else if (REC_ADD_MODE = 3) then
    begin
      NOMERROD = 0;
      PR_ADDED_REC = 1;
    end
  end



  ------------------------------------------------------------------------------
  --   Number
  select NUMBER1, NUMBER2
  from S_GET_NEW_NUMBERS(:ID_USER, :SLAVEPARENT, :IDHIER, :SMETATYPE, :ATYPE,
                         :NUMBER1, :NUMBER2, :NOMERROD)
  into :VN_NUMBER1, :VN_NUMBER2;

  VN_NUMBER1 = coalesce(VN_NUMBER1, 0);
  VN_NUMBER2 = coalesce(VN_NUMBER2, 0);

  -- CQ[13116] -->
  if (:ATYPE = 17) then -- SmRec
  begin
    -- CQ[15585] :     
    -- CLCMODE = SetBit(coalesce(:CLCMODE, 0), 17, 0); -- NeedPaidClcMode
    -- if ((:SMETATYPE = 15) -- PsType
    -- or (:PR_ADDED_REC = 1)) then
      -- CLCMODE = SetBit(coalesce(:CLCMODE, 0), 17, 1); -- NeedPaidClcMode
    -- CQ[15585] -->  
    if ((:SMETATYPE <> 15) -- PsType
       and (:PR_ADDED_REC = 0)) then
      CLCMODE = SetBit(coalesce(:CLCMODE, 0), 17, 0); -- NeedPaidClcMode
    -- CQ[15585] <--
  end
  -- CQ[13116] <--

  --      
  insert into a_smeta (ID, IDHIER, SMETATYPE, ATYPE, NUMBER1, NUMBER2, NUMBER3,
                       SLAVEPARENT, RABMAT, TAB, ALTTAB, KOLL, SKOLL, NORMARASH,
                       VRPZ, NACH, OKONCH, TIPRAB, IDNORMATIV, ISGROUPOKP,
                       VIDRAB, UTV, CLCMODE, TYPE_TRUD, NORM_GUID, NOMERROD,
                       NOMERROD1,
                       KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                       CORRECTNODE, CORRECTNODE_1, PR_ADDED_REC, ID_S_RES,
                       NAME_ID, KODIR_GROUP, KODIR_PODGROUP, ID_EDIZM,
                       BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BN, BO, B_ITOGO, -- <-- Voyager CQ[13244]
                       B_PR, --[15352]
                       K_ITOGO/*14460*/, K_PR/*15421*/)
  values (:ID, :IDHIER, :SMETATYPE, :ATYPE, :VN_NUMBER1, :VN_NUMBER2, :NUMBER3,   -- CQ[14238, 13929]  NEW_ID  ID
          :SLAVEPARENT, :RABMAT, :TAB, :ALTTAB, :KOLL, :SKOLL, :NORMARASH,
          :VRPZ, :NACH, :OKONCH, :TIPRAB, :IDNORMATIV, :ISGROUPOKP,
          :VIDRAB, :UTV, :CLCMODE, :TYPE_TRUD, :NORM_GUID, :NOMERROD,
          case when :NOMERROD = 0 then :ID else :NOMERROD end,   -- CQ[14238, 13929]  NEW_ID  ID
          :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
          :CORRECTNODE, :CORRECTNODE_1, :PR_ADDED_REC, :ID_S_RES,
          :ID_NAME, :KODIR_GROUP, :KODIR_PODGROUP, :ID_EDIZM,
          :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO, -- <-- Voyager CQ[13244]
          :B_PR, --[15352]
          :K_ITOGO/*14460*/, :K_PR/*15421*/);

  -- MK 09.12.2016 --->
  --    :   ,  
  --         
  -- MK. 26.12.2016 :         = 0
  --  ,        
  -- (   )
  --if ((SMETATYPE <> 15) and (NEW_ID_PS > 0) and (KOLL <> 0)) then
  --begin
  --  update a_smeta
  --  set UTV = 1
  -- where (ID = :NEW_ID_PS) and (coalesce(UTV, 0) = 0);
  --end
  -- MK 09.12.2016 <---

  -- MK CQ[12020] --->
  -- MK CQ[14278] --->
  VN_CLCMODE = 0;
  if (coalesce(SLAVEPARENT, 0) <> 0) then
  begin
    select getbit(coalesce(s.clcmode, 0), 10)
    from a_smeta s
    where (s.id = :SLAVEPARENT)
    into :VN_CLCMODE;
  end
  else
    VN_CLCMODE = getbit(:CLCMODE, 10);

  --     
  if (VN_CLCMODE = 1) then
  begin
    update a_smeta_view_num v
    set v.NUMBER1 = null,
        v.NUMBER2 = null,
        v.NUMBER3 = null
    where (v.id = :ID);
  end
  else
  -- MK CQ[14278] <---
  begin
    -- MK CQ[12020, 14357]  VN_NUMBERx  VIEW_NUMBERx + case
    update a_smeta_view_num v
    set v.NUMBER1 = case when :VIEW_NUMBER1 = -1 then null else :VIEW_NUMBER1 end,
        v.NUMBER2 = case when :VIEW_NUMBER2 = -1 then null else :VIEW_NUMBER2 end,
        v.NUMBER3 = case when :VIEW_NUMBER3 = -1 then null else :VIEW_NUMBER3 end
    where (v.id = :ID);  -- CQ[14238, 13929]  NEW_ID  ID
  end
  -- MK CQ[12020] <---

  --   .    (   ):
  -- [A33098F2] Voyager, 26.12.2016.   (ATYPE <> 19) ,
  --     l_s_pr_addinfo.    ,
  --              ,
  -- ..     PR_NUMBER1 = NULL
  if (/*(ATYPE <> 19) and */((NOMERROD = 0) or (SMETATYPE = 15))) then
  begin
    if (SMETATYPE <> 15) then
    begin
      --  .   
      insert into l_s_pr_addinfo (ID, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_VSEGO)
      values (:ID, :NUMBER1, :NUMBER2, :NUMBER3, :PR_VSEGO);  -- CQ[14238, 13929]  NEW_ID  ID
    end

    if (ATYPE <> 19) then -- [A33098F2] Voyager, 26.12.2016.   (ATYPE <> 19) 
    begin
        if (ATYPE = 17) then  -- SmRec // CQ[15585]      
          CLCMODE = SetBit(coalesce(:CLCMODE, 0), 17, 0); -- CQ[13116] NeedPaidClcMode
    
        --        
        -- NOMERROD    .     
        execute procedure M_AFTER_IMP_DOP_RAB_FROM_XML(:ID_USER, :ID, :IDHIER,  -- CQ[14238, 13929]  NEW_ID  ID
                :SMETATYPE, :ATYPE, :NUMBER1, :NUMBER2, :NUMBER3, :SLAVEPARENT,
                :RABMAT, :TAB, :ALTTAB, :KOLL, :SKOLL, :NORMARASH, :IDNORMATIV,
                :ID_EDIZM, :ID_NAME, :VRPZ, :NACH, :OKONCH, :TIPRAB, :NORM_GUID,
                :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP,
                :VIDRAB, :UTV, :CLCMODE, :TYPE_TRUD, :KA, :KB, :KC, :KD, :KE, :KF,
                :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :CORRECTNODE, :CORRECTNODE_1,
                :ID_S_RES,
                :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO, -- <-- Voyager CQ[13244]
                :K_ITOGO/*14460*/,
                :B_PR, --[15352]
                :K_PR/*15421*/);
    end
  end

  suspend;
end
^

--     
/* 
create or alter procedure B_TEST_IND_CANSUSPEND (
*/

--[15584]
create or alter procedure A_S_RES_APPLAY_CORRECTION_1 (
    IDUSER integer,
    RES_RABMAT integer,
    RES_TRUDTYPE integer,
    RES_MASKA varchar(42),
    RES_CORRECT varchar(50),
    RES_CORRECT_REPLACE integer,
    RES_ID integer)
returns (
    ID_SM_REC_CH_TRUD integer,
    ID_SL_REC_CH_NR_AND_KOLL integer)
AS
DECLARE VARIABLE ID_SL_REC INTEGER;
DECLARE VARIABLE APPLAY_CORRECT VARCHAR(50);
DECLARE VARIABLE CALC_RASHOD_IFLAG INTEGER;
DECLARE VARIABLE APPLAY_RASHOD DOUBLE PRECISION;
DECLARE VARIABLE CUR_RES_CORRECT VARCHAR(50);
DECLARE VARIABLE CUR_RES_TAB VARCHAR(42);
DECLARE VARIABLE CUR_RES_RABMAT INTEGER;
DECLARE VARIABLE CUR_RES_RASHOD_BASE DOUBLE PRECISION;
DECLARE VARIABLE CUR_RES_RASHOD DOUBLE PRECISION;
DECLARE VARIABLE CUR_RES_TYPE_TRUD INTEGER;
DECLARE VARIABLE CUR_RES_ID_SOURCE INTEGER;
DECLARE VARIABLE SM_KOLL DOUBLE PRECISION;
DECLARE VARIABLE BOOL_DOIT INTEGER;
declare variable AISCHANGED integer;--CQ[9144]
declare variable AISERROR integer;--CQ[9144]

declare KOLL double precision; --<<[12901]
begin
 if ( res_correct is null )
 then res_correct = '';

 if (
     ( res_maska is null ) or
     ( res_maska = '' )
    )
 then res_maska = '%';

 select
      r.rabmat,
      case R.RABMAT
        when 1 then
          coalesce (
            nullif(R.TYPE_TRUD, 0),
            case when R.TAB starting '2' then 2 else 1 end )
        else 0
      end,
      r.rashod, r.rashod_base,
      r.correct, r.tab, r.id_source
 from a_s_res r
 where r.id = :res_id
 into :cur_res_rabmat,
      :cur_res_type_trud,
      :cur_res_rashod, :cur_res_rashod_base,
      :cur_res_correct, :cur_res_tab, :cur_res_id_source;


 -- Kir
 if ( cur_res_type_trud is null ) then
  cur_res_type_trud = 0;

 if ( cur_res_correct is null ) then cur_res_correct = '';

 id_sl_rec = null;

 bool_doit=1;
--DEN-->18/4/5 cq [571]          
 if ((res_rabmat=-1)and(res_trudtype=-1)) then
 begin

--   res_rabmat = :cur_res_rabmat;
--   res_trudtype = :cur_res_type_trud;
   bool_doit=1;
 end
 else
--<--DEN
 if (res_rabmat<>1) then
 begin
   if
   (
     ( cur_res_rabmat = res_rabmat ) and
     ( cur_res_tab like res_maska )
   )
   then
     bool_doit=1;
   else
     bool_doit=0;
 end
 else
 begin
   /* Kir */
   if( res_trudtype = 0 ) then
      res_trudtype = cur_res_type_trud; /*rvs: */
   /* --- */
   if
   (
     ( cur_res_rabmat = res_rabmat ) and
     ( cur_res_tab like res_maska ) and
     ( cur_res_type_trud = res_trudtype )
   )
   then
     bool_doit=1;
   else
     bool_doit=0;
 end

 -- MK 7.09.2009 CQ[7593] --->
 --   ,   ,     
 if ((bool_doit = 1) and (res_correct_replace = 1) and
    (cur_res_correct = res_correct)) then
   bool_doit = 0;
 -- MK 7.09.2009 CQ[7593] <---

 if (bool_doit=1) then
 begin

  /*CQ[9144]if ( res_correct_replace <> 1 ) then
  begin
    applay_correct = D_UNITEPOPR(cur_res_correct, res_correct, 1);
  end
  else
    applay_correct = res_correct; */
  --CQ[9144] -->
  if (res_correct_replace = 1) then
    applay_correct = res_correct;
  else
  if (res_correct_replace = 2) then
   execute procedure DM_GET_CORRECTION_FOR_REPLACE(cur_res_correct,res_correct, '', 0)
     returning_values (:applay_correct, :AISCHANGED, :AISERROR);--CQ[9144]
  else
    applay_correct = D_UNITEPOPR(cur_res_correct, res_correct, 1);

  --CQ[9144] <--


  select first 1 iflag, ditognormrash
  from k_calculatenormrash( :applay_correct, :cur_res_rashod_base, :iduser )
  into :calc_rashod_iflag, :applay_rashod;


  /*  --CQ[TIMUR 8701]     (  IF)  cq [571]    Update- ( [IB2-3EC])
  update a_s_res r1
  set r1.correct = :applay_correct
  where r1.id = :res_id;
  */

--  if (
--DEN-->18/4/5 cq [571]
--      ((res_rabmat=-1)and(res_trudtype=-1))or
--<--DEN
--      (( calc_rashod_iflag = 1 ) and
--      ( cur_res_rashod <> applay_rashod ))
--     )

--  then

  begin


   update a_s_res r1
   set r1.correct = :applay_correct, --[IB2-3EC] -  . --CQ[TIMUR 8701]
       r1.rashod = :applay_rashod,
       r1.status_edit = 1
   where r1.id = :res_id
      and (r1.correct is null     or r1.correct <> :applay_correct --CQ[TIMUR 8701] -    Update (   ,    )
        or r1.rashod is null      or r1.rashod <> :applay_rashod
        or r1.status_edit is null or r1.status_edit <> 1);

   select first 1 s.id,
     s.KOLL --<<[12901]
   from a_smeta s
   where s.id_s_res = :res_id
   into :id_sl_rec,
     :KOLL; --<<[12901]

   if (
       ( cur_res_rabmat = 1 ) and
       ( cur_res_type_trud in (1,2) )
      )
   then
   begin

    if ( (cur_res_rashod <> applay_rashod) or
         (cur_res_correct <> applay_correct) ) --[15584]
    then
      id_sl_rec_ch_nr_and_koll = id_sl_rec;
    id_sm_rec_ch_trud = null;

    suspend;

   end

   if ( not ( id_sl_rec is null ) )
   then
   begin

    sm_koll = 0;

    select coalesce(s.koll, 0)
    from a_smeta s
    where s.id = :cur_res_id_source
    into :sm_koll;

    --<<>>[12901] KOLL = :sm_koll * :applay_rashod;
    if ( (coalesce(:sm_koll,0) = 0 )
      or ( LROUNDN(coalesce(:KOLL,0)/:sm_koll,6/*ciRangeNormRash*/) <>
           LROUNDN(coalesce(:applay_rashod,0),6/*ciRangeNormRash*/) )
       ) then
      --<<>>[13292]KOLL = :sm_koll * :applay_rashod;
      KOLL = LROUNDN(:sm_koll * :applay_rashod, 6/*ciRangeNormRash*/);

    update a_smeta s
    set s.koll = :KOLL,
        s.normarash = :applay_rashod
    where s.id = :id_sl_rec
      and (s.koll is null      or s.koll <> :KOLL --CQ[TIMUR 8701] -    Update (   ,    )
        or s.normarash is null or s.normarash <> :applay_rashod);

    if ( (cur_res_rashod <> applay_rashod) or
         (cur_res_correct <> applay_correct) ) --[15584]
    then
      id_sl_rec_ch_nr_and_koll = id_sl_rec;
    id_sm_rec_ch_trud = null;

    suspend;

   end

  end

 end

end
^

--------------------------------------------------------------------
--                           10.0.0.11, 9.2.1.10
--------------------------------------------------------------------


-- CQ[15112]
create or alter procedure L_STR_GETNODEHIERARCHY_1 (
    ID_NODE integer)
returns (
    ID_SELF integer,
    ID_PARENT integer,
    INV_LEVEL integer)
AS
BEGIN
   INV_LEVEL = 0;
   id_parent = ID_NODE;
   WHILE (NOT id_parent IS NULL) DO
   BEGIN
      id_self = NULL;
      SELECT id_self, id_parent
      FROM l_stroyki
      WHERE ID_SELF = :id_parent
      INTO :id_self, :id_parent;

      INV_LEVEL = INV_LEVEL + 1;
      ID_NODE = id_parent;
      if (NOT id_self IS NULL) then
         SUSPEND;
      else
         Exit;
   END
END
^

-- CQ[15112]
-- 
create or alter procedure L_STR_SSR_READOBJS_2 (
    ID_USER integer,
    ID_SELF integer,
    KOD integer,
    MODE integer,
    ONLY_OBJ integer,
    IN_LEVEL integer,
    OBJECT_ROOT integer)
returns (
    NUMBER integer,
    PARENT integer,
    ID_TYPE smallint,
    SUBTYPE smallint,
    SORTING integer,
    COUNTCHILDREN integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    NUMGLSSR integer,
    OUT_LEVEL integer,
    DEF_KOD_SSR integer,
    ID_TYPE_STROYKI integer,
    NUMLSR_LS varchar(1024))
AS
begin
  suspend;
end
^


-- CQ[15112]
-- 
create or alter procedure L_STR_SSR_READOBJS_1 (
    ID_USER integer,
    ID_SELF integer,
    KOD integer,
    MODE integer,
    ONLY_OBJ integer,
    IN_LEVEL integer)
returns (
    NUMBER integer,
    PARENT integer,
    ID_TYPE smallint,
    SUBTYPE smallint,
    SORTING integer,
    COUNTCHILDREN integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    NUMGLSSR integer,
    OUT_LEVEL integer,
    DEF_KOD_SSR integer,
    ID_TYPE_STROYKI integer,
    NUMLSR_LS varchar(1024))
AS
begin
  suspend;
end
^

/*15620*/
create or alter procedure L_COPYSHABTOSSR (
    ID_SSR integer,
    ID_SHAB integer,
    ID_USER integer)
AS
--CQ[TIMUR 13931] -    NSR, NAME, FRM_NAME
DECLARE VARIABLE NM_GL INTEGER;
DECLARE VARIABLE NM_NACH INTEGER;
DECLARE VARIABLE NM_OBJ_STRUC INTEGER;
DECLARE VARIABLE ID_REC INTEGER;
DECLARE VARIABLE OBJ_STRUC_TYPE INTEGER;
DECLARE VARIABLE ID_OBJ_STRUC INTEGER;
DECLARE VARIABLE CALC_POLN SMALLINT;
DECLARE VARIABLE NPP_GL SMALLINT;
DECLARE VARIABLE NSR VARCHAR(1024);
DECLARE VARIABLE NAME VARCHAR(1024);
DECLARE VARIABLE RUS_NAME VARCHAR(30);
DECLARE VARIABLE UNIONS INTEGER;
DECLARE VARIABLE PRINT SMALLINT;
DECLARE VARIABLE TEXT_DOC BLOB;
DECLARE VARIABLE APP_DATA INTEGER;
DECLARE VARIABLE I1_FRM BLOB;
DECLARE VARIABLE I1_VAL DOUBLE PRECISION;
DECLARE VARIABLE I1_STATE SMALLINT;
DECLARE VARIABLE I2_FRM BLOB;
DECLARE VARIABLE I2_VAL DOUBLE PRECISION;
DECLARE VARIABLE I2_STATE SMALLINT;
DECLARE VARIABLE I3_FRM BLOB;
DECLARE VARIABLE I3_VAL DOUBLE PRECISION;
DECLARE VARIABLE I3_STATE SMALLINT;
DECLARE VARIABLE I4_FRM BLOB;
DECLARE VARIABLE I4_VAL DOUBLE PRECISION;
DECLARE VARIABLE I4_STATE SMALLINT;
DECLARE VARIABLE I5_FRM BLOB;
DECLARE VARIABLE I5_VAL DOUBLE PRECISION;
DECLARE VARIABLE I5_STATE SMALLINT;
DECLARE VARIABLE I6_FRM BLOB;
DECLARE VARIABLE I6_VAL DOUBLE PRECISION;
DECLARE VARIABLE I6_STATE SMALLINT;
DECLARE VARIABLE FRM_NM_FRM INTEGER;
DECLARE VARIABLE FRM_NAME VARCHAR(255);
DECLARE VARIABLE FRM_RUS_NAME VARCHAR(30);
DECLARE VARIABLE FRM_APP_DATA INTEGER;
DECLARE VARIABLE FRM_I_FRM BLOB;
DECLARE VARIABLE FRM_I_VAL DOUBLE PRECISION;
DECLARE VARIABLE FRM_I_STATE SMALLINT;
DECLARE VARIABLE TIP_ZATRAT INTEGER;
BEGIN
/*
    .. ID_REC   ->       SSR
*/
  execute procedure L_SSR_REALIGNGENERATORS ( :ID_SHAB );

  DELETE FROM  L_SSR         WHERE ( ID_SSR = :ID_SSR );
  DELETE FROM  L_SSR_FORMULS WHERE ( ID_SSR = :ID_SSR );

  FOR SELECT 
       NM_GL, NM_NACH, NM_OBJ_STRUC, ID_REC, OBJ_STRUC_TYPE, ID_OBJ_STRUC, CALC_POLN,
       NPP_GL, NSR, NAME, RUS_NAME, UNIONS, PRINT, TEXT_DOC, APP_DATA,
       I1_FRM, I1_VAL, I1_STATE,
       I2_FRM, I2_VAL, I2_STATE,
       I3_FRM, I3_VAL, I3_STATE,
       I4_FRM, I4_VAL, I4_STATE,
       I5_FRM, I5_VAL, I5_STATE,
       I6_FRM, I6_VAL, I6_STATE, /*15620 + I6_FRM */
       TIP_ZATRAT
       /*VOZVRAT*/
  FROM L_SSR WHERE ( ID_SSR = :ID_SHAB )
  INTO
       :NM_GL, :NM_NACH, :NM_OBJ_STRUC, :ID_REC, :OBJ_STRUC_TYPE, :ID_OBJ_STRUC, :CALC_POLN,
       :NPP_GL, :NSR, :NAME, :RUS_NAME, :UNIONS, :PRINT, :TEXT_DOC, :APP_DATA,
       :I1_FRM, :I1_VAL, :I1_STATE,
       :I2_FRM, :I2_VAL, :I2_STATE,
       :I3_FRM, :I3_VAL, :I3_STATE,
       :I4_FRM, :I4_VAL, :I4_STATE,
       :I5_FRM, :I5_VAL, :I5_STATE,
       :I6_FRM, :I6_VAL, :I6_STATE, /*15620 + I6_FRM */
       :TIP_ZATRAT
       /*:VOZVRAT*/
  DO
     INSERT INTO L_SSR (
       ID_SSR, NM_GL, NM_NACH, NM_OBJ_STRUC, ID_REC, OBJ_STRUC_TYPE, ID_OBJ_STRUC, CALC_POLN,
       NPP_GL, NSR, NAME, RUS_NAME, UNIONS, PRINT, TEXT_DOC, APP_DATA,
       I1_FRM, I1_VAL, I1_STATE,
       I2_FRM, I2_VAL, I2_STATE,
       I3_FRM, I3_VAL, I3_STATE,
       I4_FRM, I4_VAL, I4_STATE,
       I5_FRM, I5_VAL, I5_STATE,
       I6_FRM, I6_VAL, I6_STATE,
       TIP_ZATRAT)
       /*VOZVRAT )*/
    VALUES  (
       :ID_SSR, :NM_GL, :NM_NACH, :NM_OBJ_STRUC, :ID_REC, :OBJ_STRUC_TYPE, :ID_OBJ_STRUC, :CALC_POLN,
       :NPP_GL, :NSR, :NAME, :RUS_NAME, :UNIONS, :PRINT, :TEXT_DOC, 0,
       :I1_FRM, :I1_VAL, -1,
       :I2_FRM, :I2_VAL, -1,
       :I3_FRM, :I3_VAL, -1,
       :I4_FRM, :I4_VAL, -1,
       :I5_FRM, :I5_VAL, -1,
       :I6_FRM, :I6_VAL, -1,
       :TIP_ZATRAT );
      /*:VOZVRAT );*/

  FOR SELECT NM_FRM, NAME, RUS_NAME, APP_DATA, I_FRM, I_VAL, I_STATE
  FROM L_SSR_FORMULS WHERE ( ID_SSR = :ID_SHAB )
  INTO
    :FRM_NM_FRM, :FRM_NAME, :FRM_RUS_NAME, :FRM_APP_DATA,
    :FRM_I_FRM, :FRM_I_VAL, :FRM_I_STATE
  DO
    INSERT INTO L_SSR_FORMULS (
        ID_SSR, NM_FRM, NAME, RUS_NAME, APP_DATA, I_FRM, I_VAL, I_STATE )
    VALUES (
        :ID_SSR, :FRM_NM_FRM, :FRM_NAME, :FRM_RUS_NAME, 0, :FRM_I_FRM, :FRM_I_VAL, -1 );

  IF (ID_SHAB < 0) THEN
    ID_SHAB = -ID_SHAB;

  EXECUTE PROCEDURE  L_COPYSSRPARAMS ( ID_SSR , ID_SHAB);

END^


/*15620*/
create or alter procedure L_COPYSSRTOSHAB (
    ID_SSR_DEST integer,
    ID_SSR_SRC integer,
    ID_USER integer)
AS
--CQ[TIMUR 13931] -    NSR, NAME, FRM_NAME
DECLARE VARIABLE NM_GL INTEGER;
DECLARE VARIABLE NM_NACH INTEGER;
DECLARE VARIABLE NM_OBJ_STRUC INTEGER;
DECLARE VARIABLE ID_REC INTEGER;
DECLARE VARIABLE OBJ_STRUC_TYPE INTEGER;
DECLARE VARIABLE ID_OBJ_STRUC INTEGER;
DECLARE VARIABLE CALC_POLN SMALLINT;
DECLARE VARIABLE NPP_GL SMALLINT;
DECLARE VARIABLE NSR VARCHAR(1024);
DECLARE VARIABLE NAME VARCHAR(1024);
DECLARE VARIABLE RUS_NAME VARCHAR(30);
DECLARE VARIABLE UNIONS INTEGER;
DECLARE VARIABLE PRINT SMALLINT;
DECLARE VARIABLE TEXT_DOC BLOB;
DECLARE VARIABLE APP_DATA INTEGER;
DECLARE VARIABLE I1_FRM BLOB;
DECLARE VARIABLE I1_VAL DOUBLE PRECISION;
DECLARE VARIABLE I1_STATE SMALLINT;
DECLARE VARIABLE I2_FRM BLOB;
DECLARE VARIABLE I2_VAL DOUBLE PRECISION;
DECLARE VARIABLE I2_STATE SMALLINT;
DECLARE VARIABLE I3_FRM BLOB;
DECLARE VARIABLE I3_VAL DOUBLE PRECISION;
DECLARE VARIABLE I3_STATE SMALLINT;
DECLARE VARIABLE I4_FRM BLOB;
DECLARE VARIABLE I4_VAL DOUBLE PRECISION;
DECLARE VARIABLE I4_STATE SMALLINT;
DECLARE VARIABLE I5_FRM BLOB;
DECLARE VARIABLE I5_VAL DOUBLE PRECISION;
DECLARE VARIABLE I5_STATE SMALLINT;
DECLARE VARIABLE I6_FRM BLOB;
DECLARE VARIABLE I6_VAL DOUBLE PRECISION;
DECLARE VARIABLE I6_STATE SMALLINT;
DECLARE VARIABLE FRM_NM_FRM INTEGER;
DECLARE VARIABLE FRM_NAME VARCHAR(255);
DECLARE VARIABLE FRM_RUS_NAME VARCHAR(30);
DECLARE VARIABLE FRM_APP_DATA INTEGER;
DECLARE VARIABLE FRM_I_FRM BLOB;
DECLARE VARIABLE FRM_I_VAL DOUBLE PRECISION;
DECLARE VARIABLE FRM_I_STATE SMALLINT;
DECLARE VARIABLE TIP_ZATRAT INTEGER;
BEGIN
  FOR SELECT 
       NM_GL, NM_NACH, NM_OBJ_STRUC, ID_REC, OBJ_STRUC_TYPE, ID_OBJ_STRUC, CALC_POLN,
       NPP_GL, NSR, NAME, RUS_NAME, UNIONS, PRINT, TEXT_DOC, APP_DATA,
       I1_FRM, I1_VAL, I1_STATE,
       I2_FRM, I2_VAL, I2_STATE,
       I3_FRM, I3_VAL, I3_STATE,
       I4_FRM, I4_VAL, I4_STATE,
       I5_FRM, I5_VAL, I5_STATE,
       I6_FRM, I6_VAL, I6_STATE,
       TIP_ZATRAT
       /*VOZVRAT */
  FROM L_SSR WHERE ( ID_SSR = :ID_SSR_SRC ) AND ( NM_OBJ_STRUC = 0 ) AND ( UNIONS <= 0 )
           and IDVRZUCL is null --<<      
  INTO
       :NM_GL, :NM_NACH, :NM_OBJ_STRUC, :ID_REC, :OBJ_STRUC_TYPE, :ID_OBJ_STRUC, :CALC_POLN,
       :NPP_GL, :NSR, :NAME, :RUS_NAME, :UNIONS, :PRINT, :TEXT_DOC, :APP_DATA,
       :I1_FRM, :I1_VAL, :I1_STATE,
       :I2_FRM, :I2_VAL, :I2_STATE,
       :I3_FRM,  :I3_VAL, :I3_STATE,
       :I4_FRM, :I4_VAL, :I4_STATE,
       :I5_FRM, :I5_VAL,  :I5_STATE,
       :I6_FRM, :I6_VAL, :I6_STATE,
       :TIP_ZATRAT
       /*:VOZVRAT */
  DO
  BEGIN
     INSERT INTO L_SSR (
       ID_SSR, NM_GL, NM_NACH, NM_OBJ_STRUC, ID_REC, OBJ_STRUC_TYPE, ID_OBJ_STRUC, CALC_POLN,
       NPP_GL, NSR,  NAME, RUS_NAME, UNIONS, PRINT, TEXT_DOC, APP_DATA,
       I1_FRM, I1_VAL, I1_STATE,
       I2_FRM, I2_VAL, I2_STATE,
       I3_FRM, I3_VAL, I3_STATE,
       I4_FRM, I4_VAL, I4_STATE,
       I5_FRM, I5_VAL, I5_STATE,
       I6_FRM, I6_VAL, I6_STATE,
       TIP_ZATRAT )
       /*VOZVRAT ) */
    VALUES  (
       :ID_SSR_DEST, :NM_GL, :NM_NACH, :NM_OBJ_STRUC, :ID_REC, :OBJ_STRUC_TYPE, :ID_OBJ_STRUC,
       :CALC_POLN, :NPP_GL, :NSR, :NAME, :RUS_NAME, :UNIONS, :PRINT, :TEXT_DOC, 0,
       :I1_FRM, :I1_VAL, -1,
       :I2_FRM, :I2_VAL, -1,
       :I3_FRM, :I3_VAL, -1,
       :I4_FRM, :I4_VAL, -1,
       :I5_FRM, :I5_VAL, -1,
       :I6_FRM, :I6_VAL, -1,
       :TIP_ZATRAT );
       /*:VOZVRAT ); */
  END

  FOR SELECT
     NM_FRM, NAME, RUS_NAME, APP_DATA, I_FRM, I_VAL, I_STATE
  FROM L_SSR_FORMULS WHERE ( ID_SSR = :ID_SSR_SRC )
  INTO
    :FRM_NM_FRM, :FRM_NAME, :FRM_RUS_NAME, :FRM_APP_DATA,
    :FRM_I_FRM, :FRM_I_VAL, :FRM_I_STATE
  DO
    INSERT INTO L_SSR_FORMULS (
        ID_SSR, NM_FRM, NAME, RUS_NAME, APP_DATA, I_FRM, I_VAL, I_STATE )
    VALUES (
        :ID_SSR_DEST, :FRM_NM_FRM, :FRM_NAME, :FRM_RUS_NAME, 0, :FRM_I_FRM, :FRM_I_VAL, -1 );

  IF (ID_SSR_DEST < 0) THEN
    ID_SSR_DEST = -ID_SSR_DEST;

  EXECUTE PROCEDURE  L_COPYSSRPARAMS ( ID_SSR_DEST , ID_SSR_SRC );

END^

--------------------------------------------------------------------
--                           9.2.1.11 (10.0.0.11 - )
--------------------------------------------------------------------

--[15629]
/* 
create or alter procedure L_FB_SEARCH_ID_IN_ONE_PUT (
*/
--[15610]
/* 
create or alter procedure ALLOW_EDIT_SPEC_REC (
*/
--[15610]
/* 
create or alter procedure MARK_SPEC_EDIT_MODE (
*/
--[15610]
create or alter procedure S_RRDATA_SELECT_SPEC_TROW_CRC (
    IDSMREC integer)
returns (
    CRC integer)
AS
begin
  suspend;
  --exit;
end^

--[15610]
-- 
create or alter procedure S_RR_SELECT_KKS (
    IDOBJECT integer,
    IDRR integer)
returns (
    ID integer,
    RABMAT integer,
    IDSMREC integer,
    TIP_IZM varchar(5),
    ISKS_NS_ID integer,
    COD_RTM varchar(60),
    FIELD_VALUE blob sub_type 1 segment size 80)
AS
begin
          suspend;
end
^
--[15610]
/* 
create or alter procedure IS_SPEC_REC (
*/
--[15610]
create or alter procedure ALLOW_EDIT_SPEC_REC (
    ID_REC integer,
    IDUSER integer)
returns (
    RESULT integer)
AS
declare variable VN_ID_OBG integer;
declare variable VN_SPEC_INFO integer;
declare variable VN_SPEC_IDHIER integer;
declare variable VN_SPEC_ISKS_NS_ID integer;
begin
  RESULT = 1;

  --  SPEC_REC_SUPPORT_EDIT_MODE
  if (exists (
        select * from B_USER_ACCESS
          where ID=ABS(:IDUSER)
            and BIN_AND(PROJECT_MODES,4/*pm15213mask*/)<>0 )
      ) then
  begin

    execute procedure IS_SPEC_REC(1/*FIND_CHILD*/, :ID_REC, 15/*SMETATYPE*/)
    returning_values :VN_SPEC_ISKS_NS_ID, :ID_REC, VN_SPEC_IDHIER;
  
    if (VN_SPEC_ISKS_NS_ID is not null) then
    begin

      execute procedure S_O_HIER_PARENT_OFTYPE (:VN_SPEC_IDHIER, 1)
      returning_values :VN_ID_OBG;
  
      --     
      VN_SPEC_INFO = null;
      select SPEC_INFO
        from A_O_OBJECTPARAMS
        where (NUMBER = :VN_ID_OBG)
      into :VN_SPEC_INFO;
  
      if ( (GETBIT(VN_SPEC_INFO, 0/*siSpecReadOnly*/) = 1) and (VN_SPEC_ISKS_NS_ID <> 0) ) then
        RESULT = 0;
    end

  end
end^

--[15610]
create or alter procedure MARK_SPEC_EDIT_MODE (
    IDUSER integer,
    NUMBER integer,
    EDIT_MODE_VALUE integer)
AS
declare variable VN_OBJ integer;
declare variable VN_ID integer;
declare variable VN_TMP integer;
declare variable VN_ATYPE integer;
declare variable VN_RABMAT integer;
declare variable VN_NEED_UPDATE_OBJ_PARAM integer;
declare variable VN_SPEC_ISKS_NS_ID integer;
begin

  EDIT_MODE_VALUE = coalesce(EDIT_MODE_VALUE, 0);

  select ATYPE from A_O_HIER
    where NUMBER = :NUMBER
  into :VN_ATYPE;

  -- , , ... 
  if ( (VN_ATYPE = 3) or (VN_ATYPE = 4) or (VN_ATYPE = 5) ) then
  begin
    execute procedure S_O_HIER_PARENT_OFTYPE (:NUMBER, 1)
    returning_values :VN_OBJ;

    VN_ATYPE = 1;
    NUMBER = VN_OBJ;
  end

  -- 
  if (VN_ATYPE = 1) then
  begin
    VN_NEED_UPDATE_OBJ_PARAM = 1;
    VN_OBJ = NUMBER;

    --     ...
    for select NUMBER
      from L_H_SELTREE_HIER(:IDUSER, :NUMBER)
      into :NUMBER
    do
    begin
      --    
      for select ID, ATYPE, RABMAT
         from A_SMETA
         where (IDHIER = :NUMBER) and (SMETATYPE = 15)
         order by IDHIER, SMETATYPE, NUMBER1, NUMBER2, NUMBER3
      into :VN_ID, :VN_ATYPE, :VN_RABMAT
      do
      begin
        if ( (VN_ATYPE = 17) and (VN_RABMAT = 3) ) then
        begin
          execute procedure IS_SPEC_REC(1/*FIND_CHILD*/, :VN_ID, 15/*SMETATYPE*/)
          returning_values :VN_SPEC_ISKS_NS_ID, :VN_TMP, :VN_TMP;
  
          -- ...
          if (VN_SPEC_ISKS_NS_ID is not null) then
          begin
            update A_SMETA
              set UTV = :EDIT_MODE_VALUE
            where (ID = :VN_ID);
  
            if (VN_NEED_UPDATE_OBJ_PARAM = 1) then
            begin
              --      
              update A_O_OBJECTPARAMS
                set SPEC_INFO = SETBIT(SPEC_INFO, 0/*siSpecReadOnly*/, :EDIT_MODE_VALUE)
              where (NUMBER = :VN_OBJ);
     
              VN_NEED_UPDATE_OBJ_PARAM = 0;
            end
          end
        end
      end
    end
  end
  else
  -- 
  if (VN_ATYPE = 0) then
  begin

    --      ...
    for select NUMBER, ATYPE
      from L_H_SELTREE1(:IDUSER, :NUMBER, 0)
      into :NUMBER, :VN_ATYPE
    do
    begin
      if (VN_ATYPE = 1) then
         execute procedure MARK_SPEC_EDIT_MODE(:IDUSER, :NUMBER, :EDIT_MODE_VALUE);
    end
  end
end^

--[15610]
/* 
create or alter procedure IS_SPEC_REC (
*/
--[15610]
/* 
create or alter procedure S_RRDATA_SELECT_SPEC_TROW_CRC (
*/
--[15610]
-- 
create or alter procedure S_RRBASE_SELECT_RES (
    IDUSER integer,
    IDTEMP integer,
    IDBASE integer,
    IDHIER integer,
    IDTYPE integer,
    ISHIRED integer,
    P_GROUP integer,
    P_PODGR integer,
    IDZONE integer,
    RABMATMASK integer,
    IDCENLVL integer)
returns (
    RABMAT integer,
    RABMAT_EX integer,
    TAB varchar(42),
    IDNAME integer,
    IDEDIZM integer,
    IDNORMY integer,
    PODGROUP integer,
    ISGROKP integer,
    KOLL double precision,
    CENA double precision,
    STOIM double precision,
    CENAT double precision,
    STOIMT double precision,
    IDRES integer,
    DM_IDNORMO integer,
    DM_IDPRICE integer,
    DM_ROW integer,
    DM_COST double precision,
    DM_KOEF double precision,
    ID_TAB_LONG integer)
AS
begin
            suspend;
end^

--[15610]
/* 
create or alter procedure M_GET_SMETA_LIGHT (
*/
--[15610]
/* 
create or alter procedure S_RR_SELECT_KKS (
*/

--------------------------------------------------------------------
--                           10.0.0.12
--------------------------------------------------------------------

-- Voyager CQ[15412]
create or alter procedure MB_ADD_IND_RECORD (
    IDUSER               integer,
    IDREESTR             integer,
    IDOGL                integer,
    ORDERVIEW            integer,
    TAB                  varchar(42),
    PA                   double precision,
    PB                   double precision,
    BA                   double precision,
    BANDS                double precision,
    ZBA                  double precision,
    BE                   double precision,
    BENDS                double precision,
    ZBE                  double precision,
    BC                   double precision,
    BCNDS                double precision,
    ZBC                  double precision,
    BB                   double precision,
    BBNDS                double precision,
    ZBB                  double precision,
    BD                   double precision,
    BDNDS                double precision,
    ZBD                  double precision,
    PROCENTPRED          double precision,
    NAME_PART            blob sub_type 1 segment size 80,
    NEEDUPDATE_NAME_PART integer,
    NEED_REPLACE         integer,
    PR                   double precision)
returns (
    ID          integer,
    IS_REPLACED integer)
AS
declare variable OldId INTEGER;
declare variable OldOrderview INTEGER;
declare variable OldIdogl INTEGER;
declare variable IdTmp integer;
begin
--[15352]
--[15354]+ BB_PR
  ID = 0;
  IS_REPLACED = 0;

  if (:NAME_PART is not null) then
  begin
    IdTmp = GEN_ID(B_GEN_TEMP, 1) ;
    INSERT INTO B_TEMP_BLOB(ID, BLOB1) VALUES (:IdTmp, :NAME_PART);
    SELECT BLOB1 FROM B_TEMP_BLOB WHERE ID = :IdTmp INTO :NAME_PART;
    DELETE FROM B_TEMP_BLOB WHERE ID = :IdTmp ;
  end

  --        
  OldId = null;
  select first 1 i.id, i.orderview, i.idogl
  from B_IND i
  where (i.idreestr = :IDREESTR) and (i.tabu = S_TRANSLITERATE(:TAB))
  into :OldId, :OldOrderview, :OldIdogl;

  --        
  if (:OldId is not null) then
  begin
    --    
    if (:NEED_REPLACE = 1) then  
    begin
      IS_REPLACED = 1;
      --   
      delete
      from B_IND i
      where (i.id = :OldId);

      --  
      execute procedure b_add_ind_record_inner(:iduser, :idreestr, :OldIdogl, :OldOrderview, :tab, :pa, :pb,
                            :ba, :bands, :zba, :be, :bends, :zbe, :bc, :bcnds, :zbc,
                            :bb, :bbnds, :zbb, :bd, :bdnds, :zbd, :procentpred,
                            :name_part, null, :needupdate_name_part,
                            0, 0,
                            :PR) -- Voyager CQ[15494]
      returning_values(:ID);
    end
  end

  --       -  
  else
  begin
    execute procedure b_add_ind_record_inner(:iduser, :idreestr, :idogl, :orderview, :tab, :pa, :pb,
                          :ba, :bands, :zba, :be, :bends, :zbe, :bc, :bcnds, :zbc,
                          :bb, :bbnds, :zbb, :bd, :bdnds, :zbd, :procentpred,
                          :name_part, null, :needupdate_name_part,
                          0, 0,
                          :PR) -- Voyager CQ[15494]
    returning_values(:ID);
  end
end
^


-- MK CQ[15429]
update M_SM_CHECK_REPORT_XSL
set
DATA = 
'<?xml version="1.0" encoding="WINDOWS-1251"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">



  <!-- [  STYLES: CSS- ] -->
  <xsl:template match="STYLES">
    <head>
    <style>
      .HEAD_CAPTION  {font-size:   120%;    font-weight:  bold;          }
      .HEAD_DATE    {        font-weight:  bold;    color:    #cccccc;}
      .HEAD_TABLE    {                      }
      .HEAD_COL    {width:    250;                  }

      .BODY_TABLE    {width:   100%;                  }
      .BODY_COL1    {                      }
      .BODY_COL2    {                      }
      .BODY_COL3    {                      }
      .BODY_COL4    {                      }
      .BODY_TABLEHEAD  {background-color: #9999cc;                }

      .TR_LS       {background-color: #dddddd;          color:    #0000ff;}
      .TR_R       {background-color: #e6e6e6;          color:    #0000ff;}
      .TR_PR    {background-color: #e6e6e6;          color:    #0000ff;}
      .TR_STR    {background-color: #f3f3f3;                }
      .TR_ITEM    {background-color: #eeeeff;          margin-left:  15;  }
      .TR_RES_CHANGE  {background-color: #ffdddd;          margin-left:  15;  }
      .TR_RES_ADD    {background-color: #ffdddd;          margin-left:  15;  }
      .TR_RES_DEL    {background-color: #ffdddd;          margin-left:  15;  }
      .TR_RES    {background-color: #ffeeee;          margin-left:  15;  }
      .TR_INFO    {background-color: #f3f3f3;                }

      .TD_LS        {vertical-align:   top;    font-weight:  bold;    padding-left:  5;  }
      .TD_R    {vertical-align:   top;    font-weight:  bold;    padding-left:  5;  }
      .TD_PR    {vertical-align:   top;    font-weight:  bold;    padding-left:  5;  }
      .TD_STR    {vertical-align:   top;    font-weight:  bold;    padding-left:  5;  }
      .TD_ITEM    {vertical-align:   top;            padding-left:  25;  }
      .TD_RES_CHANGE  {vertical-align:   top;    font-weight:  bold;    padding-left:  25;  }
      .TD_RES_ADD    {vertical-align:   top;    font-weight:  bold;    padding-left:  25;  }
      .TD_RES_DEL    {vertical-align:   top;    font-weight:  bold;    padding-left:  25;  }
      .TD_RES    {vertical-align:   top;            padding-left:  40;  }
      .TD_INFO    {        font-style:  italic;    padding-left:  5;  }
      .TD_INFO_TEXT  {text-align:     left;  font-style:  italic;    padding-left:  10;  }

      .COL_TRUE    {                color:    #007700;}
      .COL_FALSE    {                color:    #ff0000;}

      .COL_SMETA,
      .COL_SMETA_SMALL  {                color:    #770000;}

      .COL_BASE,
      .COL_BASE_SMALL  {                color:    #aa0000;}

      .COL_SMETA_SMALL,
      .COL_BASE_SMALL  {font-size:   70%;                  }

      .COL_SMETA_CALC  {background-color: #dddddd;  float:    left;    width:    50%;  }
      .COL_SMETA_CALC_SMALL {font-size:   70%;                  }

      .UTV    {        font-weight:  bold;    color:    #ff0000;}
      .NOT_FOUND    {        font-weight:  bold;    color:    #ff0000;}
      .NUMBER_OF    {                color:    #aa00aa;}

    </style>
    </head>
  </xsl:template>



  <!-- [  ] -->
  <xsl:template match="/">
<xsl:apply-templates select="report/STYLES" />
  <center>
  <span class="HEAD_CAPTION"> </span>
  </center>
<xsl:apply-templates select="report/HEADINFO" />
<xsl:apply-templates select="report/BODYINFO" />
  </xsl:template>



  <!-- [ / ] -->
  <xsl:template match="HEADINFO">
  <center>
  <span class="HEAD_DATE"> <xsl:value-of select="DATE" /> &#160;<xsl:value-of select="TIME" /></span>
  </center>
  <table class="HEAD_TABLE">
  <col class="HEAD_COL" align="left" />
  <tr><th> :    </th><td><xsl:value-of select="OBJECTNAME" />  </td></tr>
  <tr><th>:        </th><td><xsl:value-of select="SHIFR" />  </td></tr>
  <tr><th> :      </th><td><xsl:value-of select="CALCMODE" />  </td></tr>
  <tr><th> :      </th><td><xsl:value-of select="TIP_RASCH" />  </td></tr>
  <tr><th> :      </th><td><xsl:value-of select="CORRECT_SB" />  </td></tr>
  <tr><th> :            </th><td><xsl:value-of select="CEN_LVL" />    </td></tr>
  <tr><th> :  </th><td class="NUMBER_OF">[<xsl:value-of select="@changed" />  <xsl:value-of select="@total" />]  </td></tr>
  </table>

    <xsl:variable name="myutv">
      <xsl:choose>
        <xsl:when test="@utv=''true''">
    <xsl:choose>
      <xsl:when test="@isSmeta=''true''">    </xsl:when>
      <xsl:when test="@isSmeta=''false''">   </xsl:when>
    </xsl:choose>
        </xsl:when>
              <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    &#160;<span class="UTV"><xsl:value-of select="$myutv" /></span>

  <br /><br />
  </xsl:template>



  <!-- [ / ] -->
  <xsl:template match="BODYINFO">
  <table class="BODY_TABLE" border="1" cellspacing="0">
  <col class="BODY_COL1" width="25%" />
  <col class="BODY_COL2" width="37%" align="center" />
  <col class="BODY_COL3" width="10"  align="center" />
  <col class="BODY_COL4" width="37%" align="center" />
  <tr class="BODY_TABLEHEAD"><td>&#160;</td><th></th><th></th><th></th></tr>
<xsl:apply-templates select="item_ls" />
  </table>
  </xsl:template>



  <!-- [ // ] -->
  <xsl:template match="item_ls">
  <tr class="TR_LS">
  <td class="TD_LS"> <xsl:value-of select="number" /> <xsl:value-of select="name" />

    <xsl:variable name="myutv">
      <xsl:choose>
        <xsl:when test="@utv=''true''"> () </xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <span class="UTV"><xsl:value-of select="$myutv" /></span>

  </td>
  <td class="NUMBER_OF" colspan="3">[<xsl:value-of select="@changed" />  <xsl:value-of select="@total" />]  </td>
  </tr>
<xsl:apply-templates select="item_str" />
<xsl:apply-templates select="item_razdel" />
  </xsl:template>



  <!-- [ /// ] -->
  <xsl:template match="item_razdel">
  <tr class="TR_R">
  <td class="TD_R"><xsl:value-of select="number" /> <xsl:value-of select="name" />

    <xsl:variable name="myutv">
      <xsl:choose>
        <xsl:when test="@utv=''true''"> () </xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <span class="UTV"><xsl:value-of select="$myutv" /></span>

  </td>
  <td class="NUMBER_OF" colspan="3">[<xsl:value-of select="@changed" />  <xsl:value-of select="@total" />]  </td>
  </tr>
<xsl:apply-templates select="item_str" />
<xsl:apply-templates select="item_podrazdel" />
  </xsl:template>



  <!-- [ //// ] -->
  <xsl:template match="item_podrazdel">
  <tr class="TR_PR">
  <td class="TD_PR"><xsl:value-of select="number" /> <xsl:value-of select="name" />

    <xsl:variable name="myutv">
      <xsl:choose>
        <xsl:when test="@utv=''true''"> () </xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <span class="UTV"><xsl:value-of select="$myutv" /></span>

  </td>
  <td class="NUMBER_OF" colspan="3">[<xsl:value-of select="@changed" />  <xsl:value-of select="@total" />]  </td>
  </tr>
<xsl:apply-templates select="item_str" />
  </xsl:template>



  <!-- [ //.../ ] -->
  <xsl:template match="item_str">

    <xsl:variable name="myutv">
      <xsl:choose>
        <xsl:when test="@utv=''true''"> () </xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

  <tr class="TR_STR">
  <td class="TD_STR"><xsl:value-of select="number" /> <xsl:value-of select="tab" /> <span class="UTV"><xsl:value-of select="$myutv" /></span>  </td>

    <xsl:choose>
      <xsl:when test="@found=''false''"><td class="NOT_FOUND" colspan="3">(&#160;)  </td>  </xsl:when>
      <xsl:otherwise><td class="NUMBER_OF" colspan="3">[<xsl:value-of select="@changed" />  <xsl:value-of select="@total" />]  </td>  </xsl:otherwise>
    </xsl:choose>

  </tr>
<xsl:apply-templates select="item_res_add" />
<xsl:apply-templates select="item_res_del" />
<xsl:apply-templates select="item_res_change" />
<xsl:apply-templates select="item" />
<xsl:apply-templates select="item_folder" />
  </xsl:template>



  <!-- [ //...// ] -->
  <xsl:template match="item_folder">
<xsl:apply-templates select="item_res_add" />
<xsl:apply-templates select="item_res_del" />
<xsl:apply-templates select="item_res_change" />
<xsl:apply-templates select="item_info" />
<xsl:apply-templates select="item" />
  </xsl:template>



  <!-- [ //.../// ] -->
  <xsl:template match="item">

    <xsl:variable name="isChanged">
      <xsl:choose>
        <xsl:when test="@changes = ''true''">COL_TRUE</xsl:when>
        <xsl:otherwise>COL_FALSE</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

          <xsl:variable name="isSmallFont">
            <xsl:choose>
              <xsl:when test="@type_id = 2">
    <xsl:choose>
      <xsl:when test="@sub_type_id > 13">
        <xsl:choose>
          <xsl:when test="36 > @sub_type_id">_SMALL</xsl:when>
          <xsl:otherwise></xsl:otherwise>
        </xsl:choose>
                  </xsl:when>
      <xsl:otherwise></xsl:otherwise>
    </xsl:choose>
        </xsl:when>
              <xsl:otherwise></xsl:otherwise>
            </xsl:choose>
          </xsl:variable>

  <tr class="TR_ITEM">
  <td class="TD_ITEM"><xsl:value-of select="name" />  </td>
  <td class="COL_SMETA{$isSmallFont}">

  <xsl:if test="smeta_calc"><div class="COL_SMETA_CALC"><xsl:value-of select="smeta_calc" />&#160;<span class="COL_SMETA_CALC_SMALL">()</span></div>  </xsl:if>

  <xsl:value-of select="base" />  </td>
  <td class="{$isChanged}"><xsl:value-of select="@action" />  </td>
  <td class="COL_BASE{$isSmallFont}"><xsl:value-of select="smeta" />  </td>
  </tr>
  </xsl:template>



  <!-- [ //...//_ ] -->
  <xsl:template match="item_res_change">
  <tr class="TR_RES_CHANGE">
  <td class="TD_RES_CHANGE"> <xsl:value-of select="tab" />  </td>
  <td class="NUMBER_OF" colspan="3">[<xsl:value-of select="@changed" />  <xsl:value-of select="@total" />]  </td>
  </tr>
<xsl:apply-templates select="item_res" />
  </xsl:template>



  <!-- [ //...//_ ] -->
  <xsl:template match="item_res_add">

    <xsl:variable name="isChanged">
      <xsl:choose>
        <xsl:when test="@changes = ''true''">COL_TRUE</xsl:when>
        <xsl:otherwise>COL_FALSE</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

  <tr class="TR_RES_ADD">
  <td class="TD_RES_ADD"> <xsl:value-of select="tab" />  </td>
  <td class="COL_SMETA">&#160;  </td>
  <td class="{$isChanged}"><xsl:value-of select="@action" />  </td>
  <td class="COL_BASE"> (  )  </td>
  </tr>
  </xsl:template>



  <!-- [ //...//_ ] -->
  <xsl:template match="item_res_del">

    <xsl:variable name="isChanged">
      <xsl:choose>
        <xsl:when test="@changes = ''true''">COL_TRUE</xsl:when>
        <xsl:otherwise>COL_FALSE</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

  <tr class="TR_RES_DEL">
  <td class="TD_RES_DEL"> <xsl:value-of select="tab" />  </td>
  <td class="COL_SMETA"> (  )  </td>
  <td class="{$isChanged}"><xsl:value-of select="@action" />  </td>
  <td class="COL_BASE">&#160;  </td>
  </tr>
  </xsl:template>



  <!-- [ //...///_ ] -->
  <xsl:template match="item_res">

    <xsl:variable name="isChanged">
      <xsl:choose>
        <xsl:when test="@changes = ''true''">COL_TRUE</xsl:when>
        <xsl:otherwise>COL_FALSE</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

  <tr class="TR_RES">
  <td class="TD_RES"><xsl:value-of select="name" />  </td>
  <td class="COL_SMETA"><xsl:value-of select="base" />  </td>
  <td class="{$isChanged}"><xsl:value-of select="@action" />  </td>
  <td class="COL_BASE"><xsl:value-of select="smeta" />  </td>
  </tr>
  </xsl:template>



  <!-- [ //.../_ ] -->
  <xsl:template match="item_info">
  <tr class="TR_INFO">
  <td class="TD_INFO"><xsl:value-of select="name" />  </td>
  <td class="TD_INFO_TEXT" colspan="3"><xsl:value-of select="value" />  </td>
  </tr>
  </xsl:template>


</xsl:stylesheet>
'

where (ID_SELF = 1)
^

-- Voyager CQ[15494]
create or alter procedure B_ADD_IND_RECORD (
    IDUSER                integer,
    IDREESTR              integer,
    IDOGL                 integer,
    ORDERVIEW             integer,
    TAB                   varchar(42),
    PA                    double precision,
    PB                    double precision,
    BA                    double precision,
    BANDS                 double precision,
    ZBA                   double precision,
    BE                    double precision,
    BENDS                 double precision,
    ZBE                   double precision,
    BC                    double precision,
    BCNDS                 double precision,
    ZBC                   double precision,
    BB                    double precision,
    BBNDS                 double precision,
    ZBB                   double precision,
    BD                    double precision,
    BDNDS                 double precision,
    ZBD                   double precision,
    BB_PR                 double precision,
    PROCENTPRED           double precision,
    NAME_PART             blob sub_type 1 segment size 80,
    NAME_TITLE            blob sub_type 1 segment size 80,
    NEEDUPDATE_NAME_PART  integer,
    NEEDUPDATE_NAME_TITLE integer,
    ID_GEN                integer)
returns (
    ID integer)
AS
BEGIN
--[15352]
--[15354]+ BB_PR
-- BB_PR -       
-- ExpIndexXML.dll  ImpIndexXML.dll,       Excel
-----------------------------------------------------------------------
-- Voyager CQ[15494]  BB_PR
 IF ((NAME_PART IS NOT NULL) OR (NAME_TITLE IS NOT NULL)) THEN BEGIN
    IF (ID_GEN > 0) THEN BEGIN
       UPDATE B_TEMP_BLOB SET BLOB1 = :NAME_PART, BLOB2 = :NAME_TITLE WHERE ID = :ID_GEN;
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_GEN INTO :NAME_PART, :NAME_TITLE;
    END
    ELSE BEGIN
       ID_GEN = GEN_ID(B_GEN_TEMP, 1) ;
       INSERT INTO B_TEMP_BLOB(ID, BLOB1, BLOB2) VALUES (:ID_GEN, :NAME_PART, :NAME_TITLE);
       SELECT BLOB1, BLOB2 FROM B_TEMP_BLOB WHERE ID = :ID_GEN INTO :NAME_PART, :NAME_TITLE;
       DELETE FROM B_TEMP_BLOB WHERE ID = :ID_GEN ;
    END
 END

 SELECT ID
 FROM B_ADD_IND_RECORD_INNER(:IDUSER, :IDREESTR, :IDOGL, :ORDERVIEW, :TAB,
    :PA, :PB, :BA, :BANDS, :ZBA, :BE, :BENDS, :ZBE, :BC, :BCNDS, :ZBC,
    :BB, :BBNDS, :ZBB, :BD, :BDNDS, :ZBD, :PROCENTPRED, :NAME_PART,
    :NAME_TITLE, :NEEDUPDATE_NAME_PART, :NEEDUPDATE_NAME_TITLE, 1,
    :BB_PR) -- Voyager CQ[15494]
 INTO :ID;

 SUSPEND;
END
^

--[15205]
create or alter procedure B_TEST_IND_CANSUSPEND (
    IDUSER integer,
    REESTR_ID integer,
    OGL_ID integer,
    LIKETABU varchar(88),
    NNAMES blob sub_type 0 segment size 80,
    LIMIT integer)
returns (
    ID integer,
    NAME_TITLE blob sub_type 0 segment size 80,
    NAME_PART blob sub_type 0 segment size 80)
AS
DECLARE VARIABLE IDNAME INTEGER;
DECLARE VARIABLE RES SMALLINT;

declare I_IDOGL integer;
BEGIN
 IF (LIMIT IS NULL) THEN LIMIT = -1 ;

 IF ((LIKETABU IS NULL) OR (LIKETABU = '%')) THEN
 begin
   FOR SELECT ID, IDNAME, IDOGL FROM B_IND I
      WHERE (IDREESTR = :REESTR_ID)
        --[15205]AND ((SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_OGL(:IDUSER, :OGL_ID, I.IDOGL)) = 1)
      ORDER BY IDREESTR, ORDERVIEW
      INTO :ID, :IDNAME, :I_IDOGL DO
      --[15205]:
      if (:OGL_ID = -1 or (SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_OGL(:IDUSER, :OGL_ID, :I_IDOGL)) = 1) then
      BEGIN
         RES = 1;
         IF (NNAMES IS NULL)
         THEN BEGIN
            SELECT NAME_TITLE, NAME_PART
            FROM B_GETNAME_2 (:IDUSER, :IDNAME)
            INTO :NAME_TITLE, :NAME_PART ;
         END
         ELSE
            SELECT NAME_TITLE, NAME_PART, RES
            FROM S_SEARCH_INNAME(:IDNAME, :NNAMES)
            INTO :NAME_TITLE, :NAME_PART, :RES;

         IF (RES <> 0) THEN BEGIN
            SUSPEND ;
            LIMIT = LIMIT - 1 ;
            IF (LIMIT = 0)
            THEN EXIT ;
         END
      END
 end
 ELSE
 if (:LIKETABU containing '_' or :LIKETABU containing '%') then --[15205]
 begin
   FOR SELECT ID, IDNAME, IDOGL FROM B_IND I
      WHERE (IDREESTR = :REESTR_ID)
        AND (TABU LIKE :LIKETABU ESCAPE '_') --[14343,12447] ?..
        --[15205]AND ((SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_OGL(:IDUSER,:OGL_ID,I.IDOGL)) = 1)
      ORDER BY IDREESTR, ORDERVIEW
      INTO :ID, :IDNAME, :I_IDOGL DO
      --[15205]
      if (:OGL_ID = -1 or (SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_OGL(:IDUSER, :OGL_ID, :I_IDOGL)) = 1) then
      BEGIN
         RES = 1;
         IF (NNAMES IS NULL)
         THEN BEGIN
            SELECT NAME_TITLE, NAME_PART
            FROM B_GETNAME_2 (:IDUSER, :IDNAME)
            INTO :NAME_TITLE, :NAME_PART ;
         END
         ELSE
            SELECT NAME_TITLE, NAME_PART, RES
            FROM S_SEARCH_INNAME(:IDNAME, :NNAMES)
            INTO :NAME_TITLE, :NAME_PART, :RES;

         IF (RES <> 0) THEN BEGIN
            SUSPEND ;
            LIMIT = LIMIT - 1 ;
            IF (LIMIT = 0)
            THEN EXIT ;
         END
      END
 end
 else
 -- LIKETABU  
 begin --[15205]
   FOR SELECT ID, IDNAME, IDOGL FROM B_IND I
      WHERE (IDREESTR = :REESTR_ID)
        and (TABU = :LIKETABU) --[155205] AND (TABU LIKE :LIKETABU ESCAPE '_') --[14343,12447] ?..
        --[15205]AND ((SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_OGL(:IDUSER,:OGL_ID,I.IDOGL)) = 1)
      ORDER BY IDREESTR, ORDERVIEW
      INTO :ID, :IDNAME, :I_IDOGL DO
      --[15205]
      if (:OGL_ID = -1 or (SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_OGL(:IDUSER, :OGL_ID, :I_IDOGL)) = 1) then
      BEGIN
         RES = 1;
         IF (NNAMES IS NULL)
         THEN BEGIN
            SELECT NAME_TITLE, NAME_PART
            FROM B_GETNAME_2 (:IDUSER, :IDNAME)
            INTO :NAME_TITLE, :NAME_PART ;
         END
         ELSE
            SELECT NAME_TITLE, NAME_PART, RES
            FROM S_SEARCH_INNAME(:IDNAME, :NNAMES)
            INTO :NAME_TITLE, :NAME_PART, :RES;

         IF (RES <> 0) THEN BEGIN
            SUSPEND ;
            LIMIT = LIMIT - 1 ;
            IF (LIMIT = 0)
            THEN EXIT ;
         END
      END
 end
END
^

--[15205]
create or alter procedure B_TEST_RABMAT_CANSUSPEND_3 (
    IDUSER integer,
    REESTR_ID integer,
    OGL_ID integer,
    IDQUALIFIER integer,
    SHOWRECORDSTYPE integer,
    LIKETABU varchar(88),
    NNAMES blob sub_type 0 segment size 80,
    NSOSTS blob sub_type 0 segment size 80,
    LIMIT integer)
returns (
    ID integer,
    NAME_TITLE blob sub_type 1 segment size 80,
    NAME_PART blob sub_type 1 segment size 80)
AS
DECLARE VARIABLE IDNAME INTEGER;
DECLARE VARIABLE RES integer;
declare IDSOSTAV integer;
declare IDTITLE integer;
declare CONTENTS blob;
--[A3CFAA420975]

declare R_IDOGL integer; --[15205]
declare R_IDQUALIFIER integer; --[15205]
BEGIN
 IF (LIMIT IS NULL)
 THEN LIMIT = -1 ;

 IF (IDQUALIFIER IS NULL)
 THEN IDQUALIFIER = -1;

 if (:LIKETABU is null) then
   LIKETABU = '%';

  FOR SELECT ID, IDNAME, IDSOSTAV, R.IDOGL, R.IDQUALIFIER FROM B_RABMAT R
    WHERE (IDREESTR = :REESTR_ID)
      AND (S_TRANSLITERATE(TAB)/*[14343]TABU*/ LIKE :LIKETABU ESCAPE '_')
      --[15205]AND ((SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_OGL(:IDUSER, :OGL_ID, R.IDOGL)) <> 0)
      --[15205]AND ((SELECT CANSUSPEND FROM B_TEST_IS_RABMAT_RECORD_RESURS(:IDUSER, R.ID, :SHOWRECORDSTYPE)) <> 0)
      --[15205]AND ((SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_QUALIFIER(:IDUSER, :IDQUALIFIER, R.IDQUALIFIER)) <> 0)
    ORDER BY IDREESTR, ORDERVIEW
    -- 2.5    ORDER BY /*IDREESTR,*/ ORDERVIEW --   c 600     10%
    INTO :ID, :IDNAME, :IDSOSTAV, :R_IDOGL, :R_IDQUALIFIER DO
  --[15205]:
  if ( (:OGL_ID = -1 or (SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_OGL(:IDUSER, :OGL_ID, :R_IDOGL)) <> 0)
   and (:SHOWRECORDSTYPE in (1,2) or (SELECT CANSUSPEND FROM B_TEST_IS_RABMAT_RECORD_RESURS(:IDUSER, :ID, :SHOWRECORDSTYPE)) <> 0)
   and (:IDQUALIFIER = -1 or (SELECT CANSUSPEND FROM B_TEST_IS_RECORDS_FOR_QUALIFIER(:IDUSER, :IDQUALIFIER, :R_IDQUALIFIER)) <> 0)
     ) then
  BEGIN
    RES = 1;
    IF (:NNAMES IS NULL)
    THEN BEGIN
      execute procedure B_GETNAME_2 (:IDUSER, :IDNAME)
        returning_values :IDTITLE, :NAME_TITLE, :NAME_PART;
    END
    ELSE
      execute procedure S_SEARCH_INNAME (:IDNAME, :NNAMES)
        returning_values :NAME_TITLE, :NAME_PART, :RES;

    if (:RES <> 0 and
        :NSOSTS is not null) then
      execute procedure S_SEARCH_INSOST (:IDSOSTAV, :NSOSTS)
        returning_values :CONTENTS, :RES;

    IF (RES <> 0) THEN BEGIN
       SUSPEND ;
       LIMIT = LIMIT - 1 ;
       IF (LIMIT = 0)
       THEN EXIT ;
    END
  END
END
^

--[15205]
create or alter procedure IND_RECORD_EXISTS (
    IDUSER integer,
    IDORG integer,
    INDYEAR integer,
    INDMONTH integer,
    SHIFR varchar(42),
    WILDCARD_USED integer)
returns (
    ID integer)
AS
declare variable IDMONTH integer;
begin
  --:     B_READ_IND_RECORD_VALUES  CQ[10738]
  IDMONTH = null;
  ID = null;

  if (INDMONTH <= 12) then
    select IDMONTH
    from B_READ_IND_SBORNIK_PARAMS_EX(:IDUSER, :INDYEAR, :INDMONTH, :IDORG)
    into :IDMONTH;
  else
    IDMONTH = INDMONTH;

  if ((IDMONTH is null) or (SHIFR is null) or (SHIFR = '')) then
    suspend;
  else
  begin
    SHIFR = S_TRANSLITERATE(SHIFR);
    /*   -   -    ( ) */
    for select ID
      from B_IND
      where IDREESTR = :IDMONTH
        and TABU = :SHIFR
      --plan sort((B_IND index(B_IND_IDX_TABU))) --[15205] -    fb2.5
      order by IDREESTR, ORDERVIEW
      into :ID
    do
    begin
      suspend;
      exit;
    end
    /*   -      */
    if (:WILDCARD_USED <> 0) then
      for select ID
        from B_IND
        where IDREESTR = :IDMONTH
          and TABU_MASK = '' --<<[11189]
          and :SHIFR like TABU
        order by IDREESTR, ORDERVIEW
        into :ID
      do
      begin
        suspend;
        exit;
      end
    suspend;
  end
end
^

--[15205]
create or alter procedure M_SEARCH_IN_SBORNIK_INDEX (
    IDUSER integer,
    REESTR_ID integer,
    OGL_ID integer,
    LIKETABU varchar(88),
    NNAMES blob sub_type 0 segment size 80,
    LIMIT integer,
    PRICES blob sub_type 0 segment size 80,
    INVERTPRICES integer,
    MODE integer,
    FLD_STR varchar(50),
    FLD_DOUBLE double precision)
returns (
    ID integer)
AS
begin
   ID = -1;

   /*   TAB */
   if (MODE = 1) then
   begin
      --[15205]    
      if (:LIKETABU is null) then
      begin
        if (:FLD_STR containing '_' or :FLD_STR containing '%') then
          LIKETABU = null;
        else
          LIKETABU = S_TRANSLITERATE(:FLD_STR);
      end

      select first 1 i.id
      from B_READ_SBORNIK_INDEX(:IDUSER, :REESTR_ID, :OGL_ID, :LIKETABU, :NNAMES, :LIMIT, :PRICES, :INVERTPRICES) i
      where (i.tab = :FLD_STR)
      into :ID;
   end

   if (ID is null) then
      ID = -1;
   suspend;
end
^

-- Voyager CQ[15500]
create or alter procedure M_FB_SEARCH_NORMATIV_EX (
    IN_PODGROUP integer,
    IN_RABMAT   integer,
    ID_USER     integer,
    STAB        varchar(42),
    ID_PUT_RAB  integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT  integer,
    ID_ZONE     integer,
    SNAME_CRC   integer,
    SNAME_ID    integer,
    SEDIZM      varchar(100))
returns (
    ID_SELF                integer,
    PODGROUP               integer,
    RABMAT                 integer,
    ID_ABC_OKP             integer,
    BEDA1                  integer,
    BEDA2                  integer,
    BEDARAB                integer,
    BEDAMASH               integer,
    BEDAMAT                integer,
    NAME_PART              blob sub_type 1 segment size 80,
    NAME_TITLE             blob sub_type 1 segment size 80,
    IDNAME                 integer,
    ID_UNIQUE              integer,
    TAB                    varchar(42),
    TABU                   varchar(42),
    ALTTAB                 varchar(250),
    IDEDIZM                integer,
    EDIZM_NAME             varchar(100),
    EDIZM_FULLNAME         varchar(255),
    comment varchar(42),
    RAZRAD                 double precision,
    BA                     double precision,
    BB                     double precision,
    BC                     double precision,
    BD                     double precision,
    BE                     double precision,
    BF                     double precision,
    BG                     double precision,
    BH                     double precision,
    BI                     double precision,
    BJ                     double precision,
    PA                     double precision,
    PB                     double precision,
    PC                     double precision,
    PD                     double precision,
    PE                     double precision,
    VRPZ                   integer,
    NTR                    integer,
    PUNKTIND               varchar(42),
    ISESN                  integer,
    IDWITHESN              integer,
    CCURRENT_BA            double precision,
    CCURRENT_BB            double precision,
    CCURRENT_BC            double precision,
    CCURRENT_BD            double precision,
    CCURRENT_BE            double precision,
    CCURRENT_ZONE          integer,
    IDQUALIFIER            integer,
    IDNORMTYPE             integer,
    NORM_GUID              varchar(100),
    IDREESTR               integer,
    ABC_OKP_NAME_PART      blob sub_type 1 segment size 80,
    ABC_OKP_NAME_TITLE     blob sub_type 1 segment size 80,
    ABC_OKP_RABMAT         integer,
    ABC_OKP_IDNAME         integer,
    ABC_OKP_ID_UNIQUE      integer,
    ABC_OKP_TAB            varchar(42),
    ABC_OKP_TABU           varchar(42),
    ABC_OKP_IDGROUP        integer,
    ABC_OKP_IDPODGROUP     integer,
    ABC_OKP_ISGROUPOKP     integer,
    ABC_OKP_IDEDIZM        integer,
    ABC_OKP_EDIZM_NAME     varchar(100),
    ABC_OKP_EDIZM_FULLNAME varchar(255),
    ABC_OKP_CENA           double precision,
    ABC_OKP_RAZRAD         double precision,
    ABC_OKP_VIDNR          integer,
    ABC_OKP_COMMENT        varchar(42),
    ABC_OKP_PUNKTIND       varchar(42),
    ABC_OKP_VRPZ           integer,
    ABC_OKP_NTR            integer,
    ABC_OKP_CCURRENT       double precision,
    ABC_OKP_CCURRENT_ZONE  integer,
    ABC_OKP_IDQUALIFIER    integer,
    TYPE_TRUD              integer,
    ABC_OKP_TYPE_TRUD      integer,
    BB_PR                  double precision)
AS
declare variable NAMECRC INTEGER;
declare variable V_EDIZM VARCHAR(100);
--[15371, 15408]
declare variable S_NAME_PART blob sub_type Text;
declare variable S_NAME_TITLE blob sub_type Text;
declare variable EQUAL_NAME_PART INTEGER;
declare variable EQUAL_NAME_TITLE INTEGER;
declare variable EQUAL_FULL_NAME INTEGER;
--[15371, 15408]
begin

  S_NAME_PART = null;
  S_NAME_TITLE = null;

  if (SEDIZM is not null) then
    SEDIZM = S_TRANSLITERATE(SEDIZM);

  for select m.id_self, m.podgroup, m.rabmat, m.id_abc_okp, m.beda1, m.beda2,
             m.bedarab, m.bedamash, m.bedamat, m.name_part, m.name_title, m.idname,
             m.id_unique, m.tab, m.tabu, m.alttab, m.idedizm, m.edizm_name,
             m.edizm_fullname, m.comment, m.razrad, m.ba, m.bb, m.bc, m.bd, m.be,
             m.bf, m.bg, m.bh, m.bi, m.bj, m.pa, m.pb, m.pc, m.pd, m.pe, m.vrpz,
             m.ntr, m.punktind, m.isesn, m.idwithesn, m.ccurrent_ba, m.ccurrent_bb,
             m.ccurrent_bc, m.ccurrent_bd, m.ccurrent_be, m.ccurrent_zone, m.idqualifier,
             m.idnormtype, m.norm_guid, m.idreestr, m.abc_okp_name_part,
             m.abc_okp_name_title, m.abc_okp_rabmat, m.abc_okp_idname,
             m.abc_okp_id_unique, m.abc_okp_tab, m.abc_okp_tabu, m.abc_okp_idgroup,
             m.abc_okp_idpodgroup, m.abc_okp_isgroupokp, m.abc_okp_idedizm,
             m.abc_okp_edizm_name, m.abc_okp_edizm_fullname, m.abc_okp_cena,
             m.abc_okp_razrad, m.abc_okp_vidnr, m.abc_okp_comment, m.abc_okp_punktind,
             m.abc_okp_vrpz, m.abc_okp_ntr, m.abc_okp_ccurrent, m.abc_okp_ccurrent_zone,
             m.abc_okp_idqualifier, m.type_trud, m.abc_okp_type_trud, m.namecrc,
             m.BB_PR -- Voyager CQ[15500]
  from m_fb_search_normativ(:in_podgroup, :in_rabmat, :id_user, :stab, :id_put_rab,
                            :id_put_mash, :id_put_mat, :id_zone, 1) m
  into :id_self, :podgroup, :rabmat, :id_abc_okp, :beda1, :beda2, :bedarab, :bedamash,
       :bedamat, :name_part, :name_title, :idname, :id_unique, :tab, :tabu, :alttab,
       :idedizm, :edizm_name, :edizm_fullname, :comment, :razrad, :ba, :bb, :bc, :bd,
       :be, :bf, :bg, :bh, :bi, :bj, :pa, :pb, :pc, :pd, :pe, :vrpz, :ntr, :punktind,
       :isesn, :idwithesn, :ccurrent_ba, :ccurrent_bb, :ccurrent_bc, :ccurrent_bd,
       :ccurrent_be, :ccurrent_zone, :idqualifier, :idnormtype, :norm_guid, :idreestr,
       :abc_okp_name_part, :abc_okp_name_title, :abc_okp_rabmat, :abc_okp_idname,
       :abc_okp_id_unique, :abc_okp_tab, :abc_okp_tabu, :abc_okp_idgroup, :abc_okp_idpodgroup,
       :abc_okp_isgroupokp, :abc_okp_idedizm, :abc_okp_edizm_name, :abc_okp_edizm_fullname,
       :abc_okp_cena, :abc_okp_razrad, :abc_okp_vidnr, :abc_okp_comment, :abc_okp_punktind,
       :abc_okp_vrpz, :abc_okp_ntr, :abc_okp_ccurrent, :abc_okp_ccurrent_zone, :abc_okp_idqualifier,
       :type_trud, :abc_okp_type_trud, :namecrc,
       :BB_PR -- Voyager CQ[15500]
       do
  begin

    if (id_self > 0) then --[15371]
    begin
      --    
      if (ABC_OKP_ISGROUPOKP = 0) then
      begin
        --     (  L_FB_SEARCH_NORMATIV)
        suspend;
        exit;
      end
  
      --    -       
      else
      begin
        -- [15371, 15408] -->
          --   ,
          --      (   )
        EQUAL_FULL_NAME  = 0;
        if (:SNAME_CRC = :NAMECRC) then
          EQUAL_FULL_NAME = 1; --     

        if (EQUAL_FULL_NAME = 0) then
        begin                              

          --   ...
          if ((S_NAME_TITLE is null) and (S_NAME_PART is null)) then
            select NAME_TITLE, NAME_PART
              from B_GETNAME_2(:ID_USER, :SNAME_ID)
            into :S_NAME_TITLE, :S_NAME_PART;

          /* 1.      
          ================================================================== */
          EQUAL_NAME_TITLE = 0;
          if ( ((S_NAME_TITLE is null) or (LCKGETBLOBLENGTH(S_NAME_TITLE) = 0)) and
               ((ABC_OKP_NAME_TITLE is null) or (LCKGETBLOBLENGTH(ABC_OKP_NAME_TITLE) = 0)) )
          then
            EQUAL_NAME_TITLE = 1; --    
          else
          begin
            --          ,    
            if ( (S_NAME_TITLE is not null) and (ABC_OKP_NAME_TITLE is not null) and
                 (LCKGETBLOBLENGTH(S_NAME_TITLE) = LCKGETBLOBLENGTH(ABC_OKP_NAME_TITLE)) )
            then
            begin
              if (upper(S_NAME_TITLE) = upper(ABC_OKP_NAME_TITLE)) then
                EQUAL_NAME_TITLE = 1;
            end
          end

          /* 2.      
          ================================================================== */
          EQUAL_NAME_PART = 0;
          if ( ((S_NAME_PART is null) or (LCKGETBLOBLENGTH(S_NAME_PART) = 0)) and
               ((ABC_OKP_NAME_PART is null) or (LCKGETBLOBLENGTH(ABC_OKP_NAME_PART) = 0)) )
          then
            EQUAL_NAME_PART = 1; --    
          else
          begin
            --          ,    
            if ( (S_NAME_PART is not null) and (ABC_OKP_NAME_PART is not null) and
                 (LCKGETBLOBLENGTH(S_NAME_PART) = LCKGETBLOBLENGTH(ABC_OKP_NAME_PART)) )
            then
            begin
              if (upper(S_NAME_PART) = upper(ABC_OKP_NAME_PART)) then
                EQUAL_NAME_PART = 1;
            end
          end

          if ((EQUAL_NAME_TITLE = 1) and (EQUAL_NAME_PART = 1)) then
            EQUAL_FULL_NAME = 1;
        end
        -- <--[15371, 15408]

        if (EQUAL_FULL_NAME = 1) then
        begin
          V_EDIZM = null;
          if (EDIZM_NAME is not null) then
            V_EDIZM = S_TRANSLITERATE(EDIZM_NAME);
  
          --    -    
          if (:SEDIZM = :V_EDIZM) then
          begin
            suspend;
            exit;
          end
        end
      end
    end
  end

  --    -    
  -- ( -  ;  -  ,   . .)
  id_self = 0;
  suspend;
end
^

/* 
create or alter procedure M_CONVERT_OBJ_VNB (
*/
-- MK CQ[15499]
create or alter procedure M_GET_RASCEN_DATA_TO_UNION_NL (
    ID_OBJ integer,
    SMETATYPE integer,
    SELECT_TYPE integer,
    MEMO blob sub_type 0 segment size 80,
    CNT integer,
    ID_USER integer,
    IDLEVEL integer)
returns (
    ID integer,
    TAB varchar(42),
    NAME blob sub_type 0 segment size 80,
    EDIZM varchar(250),
    KOLL double precision,
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
    UTV integer,
    LS_ID integer,
    IDFORMULS integer,
    SOSTAV blob sub_type 0 segment size 80,
    R_PR double precision,
    RC_16 double precision,
    RE_16 double precision,
    ITOGO double precision)
AS
DECLARE VARIABLE ID_BLOB_GEN INTEGER;
declare variable s_id integer;
declare variable name_id integer;
declare variable id_edizm integer;
declare variable edizm_type integer;
declare variable idhier integer;
declare variable LC_ATYPE INTEGER;
declare variable IDNORMATIV integer;
begin

/*
  :    M_GET_RASCEN_DATA_TO_UNION
*/


/*
  SELECT_TYPE
              4 , 5 - Smetn. Res.
*/


   /* clear blob */
   if ( not MEMO is null ) then
   begin
       ID_BLOB_GEN = GEN_ID(B_GEN_TEMP, 1);
       INSERT INTO B_TEMP_BLOB(ID, BLOB1) VALUES (:ID_BLOB_GEN, :MEMO);
       SELECT BLOB1 FROM B_TEMP_BLOB WHERE ID = :ID_BLOB_GEN INTO :MEMO;
       DELETE FROM B_TEMP_BLOB WHERE ID = :ID_BLOB_GEN;
   end



   --   
   if (SELECT_TYPE = 4) then
   begin
      if (SMETATYPE = 16) then
      begin
         LC_ATYPE = 16;
      end
      else if (SMETATYPE = 15) then
      begin
         LC_ATYPE = 15;
      end
      else
      begin
         LC_ATYPE = 15;
      end

      --    
      for select IDNODE
      from A_H_HIERLOADCHECKED(:ID_USER, :ID_OBJ, :SMETATYPE, :LC_ATYPE)
      into :idhier  do
      begin
         for select s.id, s.tab, s.id_edizm, s.edizm_type, s.name_id, s.koll,
                    c.ra, c.rb, c.rc, c.rd, c.re, c.rf, c.rg, c.rh, c.ri, c.rj, c.rk, c.RL, c.RM,
                    s.utv, s.idformuls, s.IDNORMATIV,
                    c.r_pr, c.rc_16, c.re_16, c.itogo -- MK CQ[15499]
         from a_smeta s
         join a_smeta_cenlvl c on c.id = s.id
         where (s.IDHIER = :idhier) and (s.smetatype = :smetatype) and (s.atype in (17, 18)) --CQ[7941]
               and (c.idcenlvl = :IDLEVEL)
         --and ( (s.atype = 18) or ((s.atype = 17) and (s.Rabmat = 0)) ) --CQ[7941]  -      
         order by s.number1, s.number2, s.number3
         into :id, :tab, :id_edizm, :edizm_type, :name_id, :koll,
              :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :RL, :RM,
              :utv, :idformuls, :IDNORMATIV,
              :R_PR, :RC_16, :RE_16, :ITOGO -- MK CQ[15499]
         do
         begin
            execute procedure b_getname(:id_user, :name_id) returning_values (:name);
            execute procedure a_get_edizm(:id_user, :id_edizm, :edizm_type) returning_values (:edizm) ;
            execute procedure s_o_hier_parent_oftype(:idhier, 3) returning_values :ls_id;

            --CQ[7941]    
            SOSTAV = null;
            select S.contents from B_Rabmat R
            left outer join B_Sost S on R.IDSostav = S.ID
            where R.ID = :IDNORMATIV
            into :SOSTAV;
            --CQ[7941]

            suspend;
         end
      end
   end


   --   
   else if (SELECT_TYPE = 5) then
   begin
      --      
      for select FVALUE
      from S_INTFROMBLOB_SELECT (:MEMO, :CNT)
      into :s_id  do
      begin
         select first 1 s.id, s.tab, s.id_edizm, s.edizm_type, s.name_id, s.koll,
                        c.ra, c.rb, c.rc, c.rd, c.re, c.rf, c.rg, c.rh, c.ri, c.rj, c.rk, c.RL, c.RM,
                        s.utv, s.idhier, s.idformuls, s.IDNORMATIV,
                        c.r_pr, c.rc_16, c.re_16, c.itogo -- MK CQ[15499]
         from a_smeta s
         join a_smeta_cenlvl c on c.id = s.id
         where (s.id = :s_id) and (c.idcenlvl = :IDLEVEL)
         into :id, :tab, :id_edizm, :edizm_type, :name_id, :koll,
              :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :RL, :RM,
              :utv, :idhier, :idformuls, :IDNORMATIV,
              :R_PR, :RC_16, :RE_16, :ITOGO; -- MK CQ[15499]

         execute procedure b_getname(:id_user, :name_id) returning_values (:name);
         execute procedure a_get_edizm(:id_user, :id_edizm, :edizm_type) returning_values (:edizm) ;
         execute procedure s_o_hier_parent_oftype(:idhier, 3) returning_values :ls_id;

         --CQ[7941]    
         SOSTAV = null;
         select S.contents from  B_Rabmat R
         left outer join B_Sost S on R.IDSostav = S.ID
         where R.ID = :IDNORMATIV
         into :SOSTAV;
        --CQ[7941]
         suspend;
      end
   end

end
^


-- MK CQ[15499]
create or alter procedure M_IU_UNION_WORK (
    IDUSER integer,
    IDREESTR integer,
    NAME_PART blob sub_type 1 segment size 80,
    TAB varchar(42),
    IDEDIZM integer,
    RAZRAD double precision,
    NR double precision,
    SP double precision,
    SOSTAV_RAB blob sub_type 1 segment size 80,
    ID_TR integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BN double precision,
    BO double precision,
    B_ITOGO double precision,
    BB_PR double precision,
    NEW_ID integer,
    KOLL double precision,
    RES_UNION_INFO varchar(250),
    TAB_UNION_MAT varchar(42),
    TAB_UNION_MASH varchar(42),
    ID_SB_MATER integer,
    ID_SB_MASH integer,
    SAVE_PRICE_MODE integer,
    MODE integer)
returns (
    ID integer,
    VN_ID_FORMULA integer,
    IDFORMULS integer)
AS
declare variable i integer;
declare variable vn_idsostav integer;
declare variable vn_number_formula integer;
declare variable vn_rec_count integer;
declare variable vn_recordexists integer;
declare variable VN_ID_NAME integer;
begin
/*
  MODE -  
     0 -   
     1 -   
*/


   ID = -1;
   VN_ID_FORMULA = 0;
   IDFORMULS = null;

   --    blob -----------------------------------------------------
   I = gen_id( B_GEN_TEMP, 1 );
   insert into B_TEMP_BLOB(ID, BLOB1, BLOB2) values (:I, :NAME_PART, :SOSTAV_RAB);
   select BLOB1, BLOB2 from B_TEMP_BLOB where ID = :I into :NAME_PART, :SOSTAV_RAB;
   delete from B_TEMP_BLOB where ID = :I;

   --     -------------------------------------
   if (MODE = 0) then --      
   begin
     execute procedure B_TEST_RABMAT_RECORD_EXISTS(:IDUSER, :IDREESTR, 0, S_TRANSLITERATE/*[14280]_TAB*/(:TAB)) --[12447]
     returning_values :vn_recordexists;
     if (:vn_recordexists = 1) then
        exception B_E_TAB_EXISTS;
   end

   --    
   else if (MODE = 1) then
   begin
     --     
     if (not exists(select * from b_rabmat where (id = :NEW_ID))) then
       exception AE_RECORDNOTFOUND1;

     --    
     select first 1 r.vrpz, r.idreestr
     from b_rabmat r
     where (r.id = :NEW_ID)
     into :VN_NUMBER_FORMULA, :IDREESTR;
   end

   --     -------------------------------------------------
   --     
   if (not exists(select * from A_SRF_TR t where (t.id = :ID_TR))) then
      exception A_SRF_NOTFOUND_TR;

   --    
   if (MODE = 1) then
   begin
     VN_ID_FORMULA = null;
     --       
     select first 1 f.id
     from A_SRF_F f
     where (f.id_tr = :ID_TR) and (f.number = :VN_NUMBER_FORMULA)
     into :VN_ID_FORMULA;
   end

   --       (     )
   if ((MODE = 0) or (VN_ID_FORMULA is null))  then ----CQ[10110]  (MODE = 1) 
   begin
     --    
     execute procedure A_SRF_F_APPEND_WITH_NR_SP_ZU(:IDUSER, :ID_TR, :TAB, :NR, :SP, 1, 1, 1)
     returning_values :VN_NUMBER_FORMULA, :VN_ID_FORMULA;
   end

   /*--    
   update A_SRF_F f
   set f.shifr = :TAB,
       f.srj = :SRJ,
       f.srk = :SRK
   where (f.id = :VN_ID_FORMULA);*/

   select IDFORMULS from A_SRF_F where ID = :VN_ID_FORMULA into :IDFORMULS;


   --    --------------------------------------
   if (MODE = 0) then --     
   begin
     --    
     execute procedure B_ADD_RABMAT_RECORD(:IDUSER, :IDREESTR, null, null, null, :NAME_PART, null, -1)
     returning_values :ID;

     --   
     update b_rabmat r
     set r.id = :NEW_ID
     where (r.id = :ID);
   end

   else if (MODE = 1) then --    
   begin
     --  
     execute procedure B_WRITE_NAIMENOVANIE(:IDUSER, 0, :NEW_ID, :NAME_PART)
     returning_values (:VN_ID_NAME, :NAME_PART);
   end

   --      
   ID = :NEW_ID;

   --    -   
   update a_o_objectparams p
   set p.velichstrobj = :KOLL,         --   
       p.boss_fio = :RES_UNION_INFO,   -- .      
       p.boss_dolgn = :TAB_UNION_MAT,  --    
       p.boss_otdel = :TAB_UNION_MASH, --    
       p.genpodr_id = :ID_SB_MATER,    --    ( )
       p.subpodr_id = :ID_SB_MASH,     --    ( )
       p.subpodr_id_org = :SAVE_PRICE_MODE -- MK CQ[15499]     

   where p.number = :ID;

   --       
   update b_rabmat r
   set r.rabmat     = 0,
       r.tab        = :TAB,
       --r.tabu       = S_TRANSLITERATE_TAB(:TAB),  --    --[12447]
       r.alttab     = :TAB,
       r.punktind   = :TAB,
       r.idedizm    = :IDEDIZM,
       r.razrad     = :RAZRAD,
       r.ntr        = :ID_TR,
       r.vrpz       = :VN_NUMBER_FORMULA,
       r.ba         = :BA,
       r.bb         = :BB,
       r.bc         = :BC,
       r.bd         = :BD,
       r.be         = :BE,
       r.bf         = :BF,
       r.bg         = :BG,
       r.bh         = :BH,
       r.bi         = :BI,
       --CQ[TIMUR 13223]
       r.BJ         = :B_ITOGO,
       r.PA         = :BN,
       r.PB         = :BO,
       --CQ[TIMUR 13223]
       r.bb_pr      = :BB_PR -- MK CQ[15499]

       --r.createdate = 'now'                   --   now  default
   where (r.id = :ID);


   --      ----------------------------------
   execute procedure B_CALC_RABMAT_RECORDCOUNT(:IDUSER, :IDREESTR, 1)
   returning_values :VN_REC_COUNT;

   update b_reestr br
   set br.childcount = :VN_REC_COUNT
   where (br.id = :IDREESTR);


   --   -------------------------------------------------------------
   execute procedure B_FIND_AND_WRITE_SOSTAVRABOT(:IDUSER, :ID, null, :SOSTAV_RAB)
   returning_values :VN_IDSOSTAV;

   suspend;
end
^


-- MK CQ[15499]
create or alter procedure M_S_UNION_WORK (
    ID integer)
returns (
    TAB varchar(42),
    IDEDIZM integer,
    KOLL double precision,
    NAME blob sub_type 1 segment size 80,
    RES_UNION_INFO varchar(250),
    TAB_UNION_MAT varchar(42),
    TAB_UNION_MASH varchar(42),
    EDIZMNAME varchar(100),
    ID_SB_MATER integer,
    ID_SB_MASH integer,
    IDREESTR integer,
    IDFORMULS integer,
    SAVE_PRICE_MODE integer)
AS
declare variable VN_IDNAME integer;
declare variable VN_NTR integer;
declare variable VN_VRPZ integer;
begin
  for select r.tab, r.idedizm, r.idname, r.idreestr, r.ntr, r.vrpz
  from b_rabmat r
  where r.id = :ID
  into :TAB, :IDEDIZM, :VN_IDNAME, :IDREESTR, :VN_NTR, :VN_VRPZ do
  begin
    select NAME
    from B_GETNAME_EX(null, :VN_IDNAME)
    into :NAME;

    select EDIZMNAME
    from B_GET_EDIZM (:IDEDIZM)
    into :EDIZMNAME;

    select p.velichstrobj, p.boss_fio,
           substring(p.boss_dolgn from 1 for 42),
           substring(p.boss_otdel from 1 for 42),
           p.genpodr_id, p.subpodr_id,
           p.subpodr_id_org -- MK CQ[15499]
    from a_o_objectparams p
    where (p.number = :ID)
    into :KOLL, :RES_UNION_INFO,
         :TAB_UNION_MAT,
         :TAB_UNION_MASH,
         :ID_SB_MATER, :ID_SB_MASH,
         :SAVE_PRICE_MODE; -- MK CQ[15499]


    IDFORMULS = 0;
    if ((:VN_NTR is not null) and (:VN_VRPZ is not null)) then
    begin
      select first 1 f.idformuls
      from A_SRF_F f
      where (f.id_tr = :VN_NTR) and (f.number = :VN_VRPZ)
      into :IDFORMULS;
    end

    suspend;
  end
end
^


-- MK CQ[14654]
-- 
create or alter procedure D_GET_HIER (
    ID_USER integer,
    ROOT_ID integer,
    RETURN_ROOT integer,
    AMODE integer,
    DATA_INT integer,
    ONE_LEVEL_ONLY integer)
returns (
    ID integer,
    ID_PARENT integer,
    ATYPE integer,
    SUBTYPE integer,
    FULLNAME varchar(1024),
    SHIFR varchar(1024),
    NUMLSR_LS varchar(1024),
    UTV integer,
    CHILDCOUNT integer,
    SORTING integer,
    REVISION varchar(255))
AS
begin
    suspend;
end
^

-- MK CQ[14654]
create or alter procedure D_GET_OBJ_LEVEL (
    ID_PARENT integer,
    ID_USER integer)
returns (
    NUMBER integer,
    PARENT integer,
    ATYPE integer,
    SUBTYPE integer,
    SORTING integer,
    COUNTCHILDREN integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VIEW_DOSTUP_EXISTS integer)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
  declare variable IS_DOSTUP_VIRTUAL integer;
  declare variable FPARENT integer;
begin
  --CQ[TIMUR 9332]
  EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, :ID_PARENT, 0)
  RETURNING_VALUES :ID_PARENT;

  for select NUMBER, PARENT, ATYPE, SUBTYPE, SORTING, COUNTCHILDREN
    from A_O_HIER
    where PARENT = :ID_PARENT
      and ATYPE in (0,1,8,14,15,16,18,19)
      and (SUBTYPE is NULL or SUBTYPE in (0,1,8,14,15,16,18,19))
    plan sort ((A_O_HIER index (I_PARENT)))
    order by SORTING
    into :NUMBER, :PARENT, :ATYPE, :SUBTYPE, :SORTING, :COUNTCHILDREN
  do
  begin
    -- MK CQ[14654]   A_H_GETNAME
    if ((AType = 1) or ((AType = 0) and (coalesce(SubType, 0) = 0))) then -- MK CQ[14654]  coalesce
    begin
      execute procedure D_GET_DOSTUP2(:ID_USER, 37, :NUMBER)
        returning_values :VIEW_DOSTUP_EXISTS, :IS_DOSTUP_VIRTUAL;
    end
    else
      VIEW_DOSTUP_EXISTS = 1;

    if (VIEW_DOSTUP_EXISTS = 1) then -- MK CQ[14654]
    begin
      execute procedure A_H_GETNAME(:NUMBER, :ATYPE)
      returning_values :SHIFR, :FULLNAME;

      suspend;
      FPARENT = NUMBER;
      for select NUMBER, PARENT, ATYPE, SUBTYPE, SORTING, COUNTCHILDREN, SHIFR, FULLNAME, VIEW_DOSTUP_EXISTS
        from D_GET_OBJ_LEVEL(:FPARENT, :ID_USER)
        into :NUMBER, :PARENT, :ATYPE, :SUBTYPE, :SORTING, :COUNTCHILDREN, :SHIFR, :FULLNAME, :VIEW_DOSTUP_EXISTS
      do
        suspend;
    end
  end

end
^

-- Voyager CQ[15696]
create or alter procedure V_TMP_FILL_M_PR
AS
begin
  if (not exists(select ID_SELF
                 from M_GLOBAL_PARAMS
                 where PARAM_NAME = '15696_CORRECT_M_PR')) then
  begin
    update A_SMETA_INDLVL
    set M_PR = null
    where (
             (MA = 1.0)
         and (MB = 1.0)
         and (MC = 1.0)
         and (MD = 1.0)
         and (ME = 1.0)
         and (MF = 0.0)
         and (MG = 0.0)
         and (MH = 1.0)
         and (MI = 1.0)
         and (MJ = 1.0)
         and (MK = 1.0)
         and (ML = 1.0)
         and (MM = 1.0)
         and (DA = 1.0)
         and (DB = 1.0)
         and (DC = 1.0)
         and (DD = 1.0)
         and (DE = 1.0)
         and (DJ = 1.0)
         and (DK = 1.0)
         and (DL = 1.0)
         and (DM = 1.0)
         and (M_PR = 0.0)
     );

     execute procedure M_PUT_GLOBAL_PARAM('15696_CORRECT_M_PR', 1, null, null);
  end
end
^

execute procedure V_TMP_FILL_M_PR;
^

drop procedure V_TMP_FILL_M_PR;
^^

CREATE OR ALTER TRIGGER A_SMETA_INDLVL_BIU0 FOR A_SMETA_INDLVL
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
begin
  -- Voyager CQ[15696]
 if (
         (new.MA = 1.0)
     and (new.MB = 1.0)
     and (new.MC = 1.0)
     and (new.MD = 1.0)
     and (new.ME = 1.0)
     and (new.MF = 0.0)
     and (new.MG = 0.0)
     and (new.MH = 1.0)
     and (new.MI = 1.0)
     and (new.MJ = 1.0)
     and (new.MK = 1.0)
     and (new.ML = 1.0)
     and (new.MM = 1.0)
     and (new.DA = 1.0)
     and (new.DB = 1.0)
     and (new.DC = 1.0)
     and (new.DD = 1.0)
     and (new.DE = 1.0)
     and (new.DJ = 1.0)
     and (new.DK = 1.0)
     and (new.DL = 1.0)
     and (new.DM = 1.0)
     and (new.M_PR = 0.0)
 )
 then
    new.M_PR = Null;
end
^


-- MK CQ[15661]
create or alter procedure A_S_PARAMS_TO_SMETA_NL_ONE (
    IDUSER integer,
    IDSMETASTR integer,
    IDLEVEL integer,
    SLAVECOMPOSEFROMMAINNEEDED integer)
returns (
    RECORDS_MODIFIED integer)
AS
--declare IDOBJECT integer;
declare SMETATYPE integer;
declare IDHIER integer;
declare ID integer;
declare ATYPE integer;
--declare IDSMREC integer;
declare IDNORMATIV integer;
declare RABMAT integer;
declare IDPODGROUP integer;
declare TIPRAB integer;
declare VIDRAB integer;
declare ID_LEVEL_INDEX integer;
declare LEVEL_IDINDEX integer;
declare ID_LEVEL_VC integer;
declare LEVEL_IDZONE integer;
declare ID_COMPOSE_VC integer;
declare COMPOSE_IDZONE integer;
declare ID_COMPOSE_INDEX integer;
declare COMPOSE_IDINDEX integer;
declare VN_RES_ZONE integer;
declare VN_IDZONE integer;
declare VN_ZONE_BA double precision;
declare VN_ZONE_BB double precision;
declare VN_ZONE_BC double precision;
declare VN_ZONE_BD double precision;
declare VN_ZONE_BE double precision;
--declare LEVEL_PUNKTIND varchar(42);
--declare SMETA_PUNKTIND varchar(42);
--declare LEVEL_INDEX_EXISTS integer;
declare PUNKTIND varchar(42);

declare VN_IDINDEX integer;
declare VN_MA double precision;
declare VN_MB double precision;
declare VN_MC double precision;
declare VN_MD double precision;
declare VN_ME double precision;
declare VN_MF double precision;
declare VN_MG double precision;
declare VN_MH double precision;
declare VN_MI double precision;
declare VN_PUNKTIND varchar(42);
declare VN_SPOSOB_RASCH integer;
declare VN_RES_INDEX integer;

declare ID_RES integer;

declare IDCLASS integer;

declare variable BA double precision;
declare variable BB double precision;
declare variable BC double precision;
declare variable BD double precision;
declare variable BE double precision;
declare B_PR double precision; --[15352]

--declare variable SEARCH_NORM_ID integer;
--declare variable SEARCH_RESULT integer;
--declare variable ID_EDIZM integer;
--declare variable NAME_ID integer;
declare variable TAB varchar(42);
--declare variable ID_PUT_RAB integer;
--declare variable ID_PUT_MASH integer;
--declare variable ID_PUT_MAT integer;
--declare variable S_EDIZM_NAME VARCHAR(100);
--declare variable S_NAME_CRC integer;

declare NORM_GUID varchar(100);
declare ITOG_DIRTY_MASK integer;

--CQ[10519]>>
declare DIRTY_MASK integer;

declare variable VN_MJ double precision;
declare variable VN_MK  double precision;
declare variable VN_ML double precision;
declare variable VN_MM double precision;
declare VN_M_PR double precision; --[15352]
declare variable VN_DA double precision;
declare variable VN_DB double precision;
declare variable VN_DC double precision;
declare variable VN_DD double precision;
declare variable VN_DE double precision;
declare variable VN_DJ double precision;
declare variable VN_DK  double precision;
declare variable VN_DL double precision;
declare variable VN_DM double precision;

declare variable VN_BASE_CALC_INFO integer;
declare variable VN_CALC_INFO integer;

declare variable TMP_ROW_COUNT integer;

declare variable NEED_APPLY_INDEX integer;
declare SLAVEPARENT integer;
declare FC_IDREESTR integer;
declare FC_ATYPE integer;
declare FC_RABMAT integer;
declare FC_IDNORMATIV integer;
declare FC_IDPODGROUP integer;
declare FC_PUNKTIND varchar(42);
declare FC_TIPRAB integer;
declare FC_VIDRAB integer;
declare FC_LOOP integer;

declare ID_ORG integer;
declare ID_YEAR integer;
declare ID_MONTH integer;
declare ID_IND integer;


--[14593]declare variable VN_IS_LIC_VC integer;
declare variable VN_USE_BA double precision;
declare variable VN_USE_BB double precision;
declare variable VN_USE_CURRCENA double precision;
declare variable VN_CURR_CENA_INFO integer;

-- MK CQ[13030]
declare variable VN_KOEFF_MANUAL integer;
declare variable VN_TRANSP double precision;
declare variable VN_ZAG_SKL double precision;
declare variable VN_ZAPCHAST double precision;
declare variable VN_TARA double precision;
declare variable VN_NACEN double precision;
declare variable VN_COMPLECT double precision;
declare variable VN_KOEFF_TYPE integer;
declare variable VN_NEED_FILL_INDLVL_DESCR integer; --CQ[TIMUR 13988]

--<<[14316]
declare UPDATE_SMETA_PUNKTIND integer;

-- MK CQ[14313] --->
declare variable VN_NEED_SPREAD_BB integer;
declare variable NEW_curr_cena double precision;
-- MK CQ[14313] <---

--<[14353]>
declare VN_BB_OTP double precision; --</>
--<[14593]>
declare INDEX_DX_ONLY integer;
declare USE_MULTIRULES integer; --</>
begin
--[15352]

  --     GET_ONE_INDEX_APPLY_INFO
  --     GET_VC_APPLY_LIST (CLOUD !!!)
  --   !!!

  RECORDS_MODIFIED = 0;

  NEED_APPLY_INDEX = 1;--CQ[10929] :  = 1,    
--<<[9293]

  -- IDCLASS code
  /*
  select IDHIER, SMETATYPE, ATYPE
    from A_SMETA
    where ID = :IDSMETASTR
    into :IDHIER, :SMETATYPE, :ATYPE;
  -->>[0872E9EBC059]
  */
  --

  --     (,   ,   )
  /*
  for select ID, IDOBJECT
    from LEVEL_COST
    where ID = :IDLEVEL
      and IDOBJECT = :IDCLASS
    into :IDLEVEL, :IDCLASS
  do
  */
  begin -- for suspend/exit

    --    ( )
    /*
    for select IDHIER
      from S_O_HIER_SELECT2(:IDOBJECT) --<<     (    )
      into :IDHIER
    do
    */

    --     (  , ..    )
    for select S.ID, S.ATYPE, S.SLAVEPARENT, --case when S.ATYPE = 17 then S.ID else S.SLAVEPARENT end,
        S.IDHIER, S.SMETATYPE, --<<[0872E9EBC059]
        S.IDNORMATIV, S.RABMAT, S.KODIR_PODGROUP, S.TIPRAB, S.VIDRAB,
        I.ID_LEVEL_INDEX, I.IDINDEX,
        coalesce(nullif(I.PUNKTIND, ''), S.PUNKTIND), --I.PUNKTIND, S.PUNKTIND, --CQ[10396]
        L.ID_LEVEL_VC, case L.IDZONE when 0 then -3 else L.IDZONE end,
        S.BA, S.BB, S.BC, S.BD, S.BE, S.TAB, --s.ID_EDIZM, s.NAME_ID, --CQ[10058]
        S.B_PR, --[15352]
        S.NORM_GUID,
        I.MJ, I.MK, I.ML, I.MM,
        I.M_PR, --[15352]
        I.DA, I.DB, I.DC, I.DD, I.DE, I.DJ, I.DK, I.DL, I.DM, --CQ[10529]
        L.BASE_CALC_INFO, -- MK 19.06.2012 CQ[10565]
        getbit(L.koeff_type, 9) -- MK CQ[13030] 9 - ciKoeffManual
      from A_SMETA S
      left join A_SMETA_CENLVL L on L.ID = S.ID and L.IDCENLVL = :IDLEVEL
      left outer join A_SMETA_INDLVL I on I.ID = S.ID and I.IDCENLVL = :IDLEVEL --CQ[10529]
      where S.ID = :IDSMETASTR
      into :ID, :ATYPE, :SLAVEPARENT, --:IDSMREC,
        :IDHIER, :SMETATYPE, --<<[0872E9EBC059]
        :IDNORMATIV, :RABMAT, :IDPODGROUP, :TIPRAB, :VIDRAB,
        :ID_LEVEL_INDEX, :LEVEL_IDINDEX,
        :PUNKTIND/*[11010]FC_PUNKTIND*/, --:LEVEL_PUNKTIND, :SMETA_PUNKTIND, --CQ[10396]
        :ID_LEVEL_VC, :LEVEL_IDZONE,
        :BA, :BB, :BC, :BD, :BE, :TAB, --:ID_EDIZM, :NAME_ID, --CQ[10058]
        :B_PR, --[15352]
        :NORM_GUID,
        :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
        :VN_M_PR, --[15352]
        :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM, --CQ[10529]
        :VN_BASE_CALC_INFO, -- MK 19.06.2012 CQ[10565]
        :VN_KOEFF_MANUAL -- MK CQ[13030]
    do
    begin

      -- IDCLASS code
      --<<[0872E9EBC059]
      if (:ATYPE in (17/*SmRec*/,18/*ResRec*/)) then
      begin
        if (:SMETATYPE > 999) then
          IDCLASS = :SMETATYPE;
        else
          execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1/*ObgectType*/)
            returning_values :IDCLASS;
      end
      else
        exit;
      --

      -- MK CQ[14313] --->
      --          
      -- (  : TclIndexRules._GetResATAType)
      VN_NEED_SPREAD_BB = 0;
      if (RABMAT = 3) then
      begin
        -- 
        if (:SMETATYPE > 999) then
        begin
          select case when :IDNORMATIV <> 0 then f.apply_to_all_idlevel_snb else f.apply_to_all_idlevel end
          from a_o_factparams f
          where (f.number = :IDCLASS)
          into :VN_NEED_SPREAD_BB;
        end
        -- 
        else
        begin
          select case when :IDNORMATIV <> 0 then o.apply_to_all_idlevel_snb else o.apply_to_all_idlevel end
          from a_o_objectparams o
          where (o.number = :IDCLASS)
          into :VN_NEED_SPREAD_BB;
        end

        if (VN_NEED_SPREAD_BB = IDLEVEL) then
          VN_NEED_SPREAD_BB = 1;
        else
          VN_NEED_SPREAD_BB = 0;
      end
      -- MK CQ[14313] <---


      -- MK 22.06.2012 CQ[10565]
      --         (,  )
      VN_CALC_INFO = 0/*cbUnknown*/;

      FC_LOOP = 1;
      while (:FC_LOOP > 0) do --<<[11537]
      begin
        FC_LOOP = 0;

        if (:SLAVECOMPOSEFROMMAINNEEDED <> 0) then
          execute procedure NL_FIND_COMPOSE_GETPARAMSFOR(:IDUSER, :SLAVEPARENT, :IDLEVEL)
            returning_values :FC_IDREESTR, :FC_TIPRAB, :FC_VIDRAB, :FC_ATYPE, :FC_RABMAT, :FC_PUNKTIND, :FC_IDNORMATIV, :FC_IDPODGROUP;
        else
        begin
          execute procedure NL_GET_NORMBASE_LINK(
              :IDUSER, :RABMAT, :IDNORMATIV, :IDPODGROUP, :NORM_GUID, :TAB)
            returning_values :FC_IDREESTR, :FC_RABMAT, :FC_IDNORMATIV, :FC_IDPODGROUP;

          --<[14316]>
          if (nullif(:PUNKTIND, '') is null) then
            if (:FC_IDNORMATIV <> 0) then
            begin
              select PUNKTIND
                from M_FB_READ_SBORNIK(:FC_IDNORMATIV, :FC_IDPODGROUP, :FC_RABMAT)
                into :PUNKTIND;
              if (:PUNKTIND <> '') then
                UPDATE_SMETA_PUNKTIND = 1;
            end
            else
              PUNKTIND = :TAB; --<<[14316.2]    -   
          --</>

          FC_ATYPE = :ATYPE;
          FC_PUNKTIND = :PUNKTIND; /*<<[11010]*/
          FC_TIPRAB = :TIPRAB;
          FC_VIDRAB = :VIDRAB;
        end
  
      --  
        --CQ[10738]-->
        /*CQ[10738] 
        execute procedure NL_FIND_COMPOSE(
            :IDLEVEL,
            :IDCLASS,
            :IDUSER,
            :IDREESTR,
            :TIPRAB,
            :VIDRAB,
            :FC_ATYPE,
            :FC_RABMAT,
            :IDHIER)
          returning_values :ID_COMPOSE_VC, :ID_COMPOSE_INDEX;*/
        --if ((LEVEL_PUNKTIND is null) or (LEVEL_PUNKTIND = '')) then
        --    PUNKTIND = :SMETA_PUNKTIND; --CQ[10396]
        execute procedure NL_FIND_COMPOSE_EX(
            :IDLEVEL, :IDCLASS, :IDUSER,
            :FC_IDREESTR,
            :FC_TIPRAB, :FC_VIDRAB, :FC_ATYPE, :FC_RABMAT,
            :IDHIER,
            :FC_PUNKTIND, :FC_IDNORMATIV, :FC_IDPODGROUP)
          returning_values :ID_COMPOSE_VC, :ID_COMPOSE_INDEX, :INDEX_DX_ONLY; --[14593]
        --CQ[10738]<--
  
        --<[11537]>
        if (:SLAVECOMPOSEFROMMAINNEEDED <> 0) then
        begin
          --    "    "
          if (:ID_COMPOSE_INDEX is not null) then
          --   (  "  ")
          for select first 1 ID_ORG, ID_YEAR, ID_MONTH
            from LEVEL_INDEX
            where ID_COMPOSE = :ID_COMPOSE_INDEX
              and coalesce(RES_COPY_INDEX, 0) = 0
            into :ID_ORG, :ID_YEAR, :ID_MONTH
          do
          begin
            execute procedure IND_RECORD_EXISTS(:IDUSER, :ID_ORG, :ID_YEAR, :ID_MONTH, :PUNKTIND, 1)
              returning_values :ID_IND;
            --   -    
            if (:ID_IND is null) then
              ID_COMPOSE_INDEX = null;
          end

          if (:ID_COMPOSE_INDEX is null and :ID_COMPOSE_VC is null) then --[11537.1]
          begin
            --  ,    
            FC_LOOP = 1;
            SLAVECOMPOSEFROMMAINNEEDED = 0;
          end
        end
        --</>
      end

    --    (  :ID_COMPOSE_VC)
      select min(case when :ATYPE = 17 and :RABMAT = 0 and CV.APPLY_ON_RES <> 0 then -3 else CV.ID_ZONE end)
        from LEVEL_VC CV
        where CV.ID_COMPOSE = :ID_COMPOSE_VC
        into :COMPOSE_IDZONE;

      COMPOSE_IDINDEX = null;--CQ[10519]
    --    (  :ID_COMPOSE_INDEX)
      select CI.ID_MONTH,--CQ[10519]min(CI.ID_MONTH)
             CI.DIRTY_MASK--CQ[10519]
        from LEVEL_INDEX CI
        where CI.ID_COMPOSE = :ID_COMPOSE_INDEX
        into :COMPOSE_IDINDEX,
             :DIRTY_MASK; --CQ[10519]

    --       [10502]
      select CT.DIRTY_MASK
        from LEVEL_INDEX_ITOG CT
        where CT.ID_COMPOSE = :ID_COMPOSE_INDEX
        into :ITOG_DIRTY_MASK;

    --  ...

    -- ...
    --  :   :COMPOSE_IDINDEX   :ID_COMPOSE_INDEX  _
    -- :COMPOSE_IDINDEX=0  :ID_COMPOSE_INDEX    
      VN_RES_INDEX = null;
      if ( coalesce(:COMPOSE_IDINDEX, 0) <> coalesce(:LEVEL_IDINDEX, 0)
        or coalesce(:ID_COMPOSE_INDEX, 0) <> coalesce(:ID_LEVEL_INDEX, 0)
        /*[10502]*/or coalesce(:ITOG_DIRTY_MASK, 0) <> 0
        /*[10519]*/or coalesce(:DIRTY_MASK, 0) <> 0) --CQ
      then
      begin
        --  
        --execute procedure NL_CHECK_INDEX(:IDUSER, :COMPOSE_IDINDEX, :ATYPE, :LEVEL_PUNKTIND, :LEVEL_INDEX_EXISTS)
        --  returning_values (:VN_RES_INDEX);
        -- _    A_S_GET_INDEX_NL
        /*CQ[10738]  
        if ((LEVEL_PUNKTIND is null) or (LEVEL_PUNKTIND = '')) then
          LEVEL_PUNKTIND = :SMETA_PUNKTIND; --CQ[10396]
        */

        --[10502]
        /*
        execute procedure A_S_GET_INDEX_NL(:IDLEVEL, :IDUSER, :ATYPE,
                  :LEVEL_PUNKTIND, :ID_COMPOSE_INDEX, :ID)
              returning_values :VN_IDINDEX, :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME,
                  :VN_MF, :VN_MG, :VN_MH, :VN_MI, :VN_PUNKTIND, :VN_SPOSOB_RASCH, :VN_RES_INDEX;
        */
        --CQ[10929]execute procedure A_S_GET_INDEX_NL(
        execute procedure A_S_GET_INDEX_NL_NEW(
                  :IDLEVEL, :IDUSER, :ATYPE/*[11010]FC_ATYPE*/,
                  :PUNKTIND/*[11010]FC_PUNKTIND*/, :ID_COMPOSE_INDEX, :ID,
                  :NEED_APPLY_INDEX)--CQ[10929]
              returning_values :VN_IDINDEX, :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME,
                  :VN_MF, :VN_MG, :VN_MH, :VN_MI,
                  :VN_MJ, :VN_MK, :VN_ML, :VN_MM, --CQ[10529]
                  :VN_M_PR, --[15352]
                  :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM, --CQ[10529]
                  :VN_PUNKTIND, :VN_SPOSOB_RASCH, :VN_RES_INDEX;
          -- :VN_RES_INDEX > 0:        ,
          -- [10502]    ...      
        --<<[14593]
        if (:INDEX_DX_ONLY <> 0) then
        begin
          VN_MA = 1.0;
          VN_MB = 1.0; VN_MC = 1.0; VN_MD = 1.0; VN_ME = 1.0;
          VN_MF = 0.0; VN_MG = 0.0;
          VN_MH = 1.0; VN_MI = 1.0;
          VN_MJ = 1.0; VN_MK = 1.0; VN_ML = 1.0; VN_MM = 1.0;
          VN_M_PR = 1.0; --[15352]
        end
      end

    -- ... :
    --  :    :COMPOSE_IDZONE   :ID_COMPOSE_VC  
      VN_RES_ZONE = null;
      if (not ( (ID_LEVEL_VC is null) and (:ID_COMPOSE_VC is null) ) and --CQ[10529]       Compose   BASE_INFO
        --CQ[11096](( coalesce(:COMPOSE_IDZONE, 0) <> coalesce(:LEVEL_IDZONE, 0)
                   (( coalesce(NULLIF(:COMPOSE_IDZONE, -3), 0) <> coalesce(NULLIF(:LEVEL_IDZONE, -3), 0)--CQ[11096] IDZONE = null -   (= -3)
        or coalesce(:ID_COMPOSE_VC, 0) <> coalesce(:ID_LEVEL_VC, 0) ))) then
      begin
        -- MK CQ[11989] --->
        --   
        VN_USE_BA = BA;
        VN_USE_BB = BB;
        VN_USE_CURRCENA = 0.0;
        VN_CURR_CENA_INFO = null;
        -- MK CQ[11989] <---

        if (:IDNORMATIV is not null) then --CQ[10058]
        begin
          --  
          execute procedure NL_CHECK_VC(:IDUSER, :ID_COMPOSE_VC, :ATYPE,
                  :RABMAT, :IDNORMATIV, :IDPODGROUP)
              returning_values :VN_RES_ZONE, :VN_IDZONE,
                  :VN_ZONE_BA, :VN_ZONE_BB, :VN_ZONE_BC, :VN_ZONE_BD, :VN_ZONE_BE;
          --    (:IDZONE = -3),    (:IDZONE = 0)
          -- :VN_RES_ZONE > 0:        

          -- MK 22.06.2012 CQ[10565]
          if (VN_RES_ZONE > 0) then
          begin
            VN_CALC_INFO = 3/*cbFromNB*/; --     (  )

            -- MK CQ[11989] --->
            --   
            VN_USE_BA = VN_ZONE_BA;
            VN_USE_BB = VN_ZONE_BB;

            --  
            if (RABMAT = 3) then -- [7FE7AD1744B6]
            begin
              --     
              if (VN_IDZONE > 0) then
              begin
                --      
                /*[14593]
                select first 1 LIC_VC
                from GET_VC_LIC_INFO(:VN_IDZONE)
                into :VN_IS_LIC_VC;*/
                execute procedure NL_COMPOSE_USE_MULTIRULES_VC(:ID_COMPOSE_VC, :VN_IDZONE)
                    returning_values :USE_MULTIRULES;
        
                --    (   )
                --[14593] if (VN_IS_LIC_VC <> 0) then
                --    (), ..    
                if (:USE_MULTIRULES = 0) then
                begin
                  VN_USE_BA = BA;
                  VN_USE_BB = BB;
                  VN_USE_CURRCENA = VN_ZONE_BB;
                  VN_CURR_CENA_INFO = 3; -- cciVC
                end

                begin -- [14353] (066)  05 -  
                  VN_BASE_CALC_INFO = BIN_AND( :VN_BASE_CALC_INFO,
                    BIN_XOR(64/*bciBBOtpFromSb*/, -1) );
                end
              end

              else
              if (BIN_AND(:VN_BASE_CALC_INFO, 64/*bciBBOtpFromSb*/) <> 0) then
              begin --<<[14353]     
                --    ...
                --  
                select BB_OTP
                  from B_RABMAT
                  where ID = :IDNORMATIV
                  into :VN_BB_OTP;
                if (:VN_BB_OTP <> 0) then
                begin --  ,  
                  VN_USE_CURRCENA = :VN_BB_OTP;
                  VN_CURR_CENA_INFO = 4/*cciBBOtpFromSb*/;
                  VN_CALC_INFO = 1/*cbCalc*/;
                end
                --     
                --else
                --begin --  
                --  VN_BASE_CALC_INFO = BIN_AND( :VN_BASE_CALC_INFO,
                --    BIN_XOR(64/*bciBBOtpFromSb*/, -1) );
                --end
              end

            end
            -- MK CQ[11989] <---
          end
        end
        else
        begin
          --CQ[10058]-->
          VN_RES_ZONE = 0;
          ID_COMPOSE_VC = null;
          VN_IDZONE = -3;
          VN_ZONE_BA = :BA;
          VN_ZONE_BB = :BB;
          VN_ZONE_BC = :BC;
          VN_ZONE_BD = :BD;
          VN_ZONE_BE = :BE;
          --CQ[10058]<--
        end
      end

      TMP_ROW_COUNT = 0;--CQ[10685]

    --       ...
      if ( coalesce(:VN_RES_ZONE, 0) > 0 ) then
      begin
        -- MK CQ[12365] --->
        --    
        delete from a_smeta_cenlvl_base_formul f
        where (f.id = :ID) and (f.idcenlvl = :IDLEVEL);
        -- MK CQ[12365] <---

      --  

        -- MK 19.06.2012 CQ[10565] --->
        --     3,4 (      )
        -- MK CQ[13174] --->
        --   3,4    5  (bciNeedRecalcItogoB)
        --[14353]VN_BASE_CALC_INFO = bin_and(VN_BASE_CALC_INFO, 56); -- 56 = 111000
        --[14353] -       
        VN_BASE_CALC_INFO = BIN_AND(:VN_BASE_CALC_INFO, BIN_XOR(7/*cbCalcMask*/, -1));
        --VN_BASE_CALC_INFO = bin_and(VN_BASE_CALC_INFO, 24); -- 24 = 11000
        -- MK CQ[13174] <---
        VN_BASE_CALC_INFO = bin_or(VN_BASE_CALC_INFO, VN_CALC_INFO);
        -- MK 19.06.2012 CQ[10565] <---

        update A_SMETA_CENLVL
        set IDZONE      = case when :VN_RES_ZONE > 0 then :VN_IDZONE else IDZONE end,
            ID_LEVEL_VC = case when :VN_RES_ZONE > 0 then :ID_COMPOSE_VC else ID_LEVEL_VC end,
            BA          = case when :VN_RES_ZONE > 0 then :VN_USE_BA /*CQ[11989]:VN_ZONE_BA*/ else BA end,
            BB          = case when :VN_RES_ZONE > 0 then :VN_USE_BB /*CQ[11989]:VN_ZONE_BB*/ else BB end,
            BC          = case when :VN_RES_ZONE > 0 then :VN_ZONE_BC else BC end,
            BD          = case when :VN_RES_ZONE > 0 then :VN_ZONE_BD else BD end,
            BE          = case when :VN_RES_ZONE > 0 then :VN_ZONE_BE else BE end,
            B_PR        = case when :VN_RES_ZONE > 0 then null else B_PR end, --[15352]
            BASE_INFO   = case when :VN_RES_ZONE > 0 then :VN_RES_ZONE else BASE_INFO end,
            --[10584.4]BASE_CALC_INFO = :VN_BASE_CALC_INFO -- MK 19.06.2012 CQ[10565]
            CURR_CENA       = case when :VN_RES_ZONE > 0 then :VN_USE_CURRCENA /*CQ[11989]0.0*/ else CURR_CENA end,
            BASE_CALC_INFO  = case when :VN_RES_ZONE > 0 then :VN_BASE_CALC_INFO else BASE_CALC_INFO end,
            SOURCE_LEVEL_ID = case when :VN_RES_ZONE > 0 then 0 else SOURCE_LEVEL_ID end,

            -- MK CQ[11989] --->
            CURR_CENA_INFO = case when :VN_RES_ZONE > 0 then :VN_CURR_CENA_INFO else CURR_CENA_INFO end,
            ID_VALUTE = case when :VN_RES_ZONE > 0 then 1 else ID_VALUTE end,
            VALUTE_CURS = case when :VN_RES_ZONE > 0 then null else VALUTE_CURS end,
            VALUTE_DATE = case when :VN_RES_ZONE > 0 then null else VALUTE_DATE end,
            TRANSP = case when :VN_RES_ZONE > 0 then 0 else TRANSP end,
            ZAG_SKL = case when :VN_RES_ZONE > 0 then 0 else ZAG_SKL end,
            ZAPCHAST = case when :VN_RES_ZONE > 0 then 0 else ZAPCHAST end,
            TARA = case when :VN_RES_ZONE > 0 then 0 else TARA end,
            NACEN = case when :VN_RES_ZONE > 0 then 0 else NACEN end,
            COMPLECT = case when :VN_RES_ZONE > 0 then 0 else COMPLECT end
            -- MK CQ[11989] <---

            --BF..BJ,
            --CA..CJ,
            --EA..EK,
            --RA..RM,
            --PA..PD,
            --ITOGO,
            --CALCBMASK,
            --CQ[10529]IDINDEX           = case when :VN_RES_INDEX > 0 then :VN_IDINDEX else IDINDEX end,
            --CQ[10529]ID_LEVEL_INDEX    = case when :VN_RES_INDEX > 0 then :ID_COMPOSE_INDEX else ID_LEVEL_INDEX end,
            --CQ[10529]PUNKTIND          = case when :VN_RES_INDEX > 0 then :VN_PUNKTIND else PUNKTIND end,
            --CQ[10529]MA                = case when :VN_RES_INDEX > 0 then :VN_MA else MA end,
            --CQ[10529]MB                = case when :VN_RES_INDEX > 0 then :VN_MB else MB end,
            --CQ[10529]MC                = case when :VN_RES_INDEX > 0 then :VN_MC else MC end,
            --CQ[10529]MD                = case when :VN_RES_INDEX > 0 then :VN_MD else MD end,
            --CQ[10529]ME                = case when :VN_RES_INDEX > 0 then :VN_ME else ME end,
            --CQ[10529]MF                = case when :VN_RES_INDEX > 0 then :VN_MF else MF end,
            --CQ[10529]MG                = case when :VN_RES_INDEX > 0 then :VN_MG else MG end,
            --CQ[10529]MH                = case when :VN_RES_INDEX > 0 then :VN_MH else MH end,
            --CQ[10529]MI                = case when :VN_RES_INDEX > 0 then :VN_MI else MI end,
            --CQ[10529]INDEX_SPOSOBRASCH = case when :VN_RES_INDEX > 0 then :VN_SPOSOB_RASCH else INDEX_SPOSOBRASCH end,
            --CQ[10529]INDEX_INFO        = case when :VN_RES_INDEX > 0 then :VN_RES_INDEX else INDEX_INFO end
        where (ID = :ID)
          and (IDCENLVL = :IDLEVEL)
          and (coalesce(BASE_INFO, 0) <> 2)  --csDirect CQ[10863]
          and ( coalesce(:VN_RES_ZONE, 0) > 0 and
                  ( coalesce(IDZONE, 0) <> coalesce(:VN_IDZONE, 0)
                 or coalesce(ID_LEVEL_VC, 0) <> coalesce(:ID_COMPOSE_VC, 0)
                 or coalesce(BA, 0) <> coalesce(:VN_ZONE_BA, 0)
                 or coalesce(BB, 0) <> coalesce(:VN_ZONE_BB, 0)
                 or coalesce(BC, 0) <> coalesce(:VN_ZONE_BC, 0)
                 or coalesce(BD, 0) <> coalesce(:VN_ZONE_BD, 0)
                 or coalesce(BE, 0) <> coalesce(:VN_ZONE_BE, 0)
                 or coalesce(B_PR, 0) <> 0 --[15352]
                 or coalesce(BASE_INFO, 0) <> coalesce(:VN_RES_ZONE, 0)
                 --[10584.4]:
                   or coalesce(CURR_CENA, 0.0) <> 0.0
                   or coalesce(BASE_CALC_INFO, 0) <> :VN_BASE_CALC_INFO
                   or coalesce(SOURCE_LEVEL_ID, 0) <> 0
                 --
                  )
             --CQ[10529]or coalesce(:VN_RES_INDEX, 0) > 0 and
                  --CQ[10529]( coalesce(IDINDEX, 0) <> coalesce(:VN_IDINDEX, 0)
                 --CQ[10529]or coalesce(ID_LEVEL_INDEX, 0) <> coalesce(:ID_COMPOSE_INDEX, 0)
                 --CQ[10529]or coalesce(PUNKTIND, 0) <> coalesce( :VN_PUNKTIND, 0)
                --CQ[10529] or coalesce(MA, 0) <> coalesce(:VN_MA, 0)
                 --CQ[10529]or coalesce(MB, 0) <> coalesce(:VN_MB, 0)
                 --CQ[10529]or coalesce(MC, 0) <> coalesce(:VN_MC, 0)
                 --CQ[10529]or coalesce(MD, 0) <> coalesce(:VN_MD, 0)
                 --CQ[10529]or coalesce(ME, 0) <> coalesce(:VN_ME, 0)
                 --CQ[10529]or coalesce(MF, 0) <> coalesce(:VN_MF, 0)
                 --CQ[10529]or coalesce(MG, 0) <> coalesce(:VN_MG, 0)
                 --CQ[10529]or coalesce(MH, 0) <> coalesce(:VN_MH, 0)
                 --CQ[10529]or coalesce(MI, 0) <> coalesce(:VN_MI, 0)
                 --CQ[10529]or coalesce(INDEX_SPOSOBRASCH, 0) <> coalesce(:VN_SPOSOB_RASCH, 0)
                 --CQ[10529]or coalesce(INDEX_INFO, 0) <> coalesce(:VN_RES_INDEX, 0)
                  --CQ[10529])
              )
          ;

        TMP_ROW_COUNT = row_count;--CQ[10685]
      end

    -- MK CQ[13030]       --->
    --  ()       
    if ((ATYPE in (17, 18)) and (RABMAT = 3) and (VN_KOEFF_MANUAL = 0)) then
    begin
      select case when (:TIPRAB = 3) then l.OBORUD_TRANSP else l.MATER_TRANSP end,
             case when (:TIPRAB = 3) then l.OBORUD_ZAG_SKL else l.MATER_ZAG_SKL end,
             case when (:TIPRAB = 3) then l.OBORUD_ZAPCHAST else l.MATER_ZAPCHAST end,
             case when (:TIPRAB = 3) then l.OBORUD_TARA else l.MATER_TARA end,
             case when (:TIPRAB = 3) then l.OBORUD_NACEN else l.MATER_NACEN end,
             case when (:TIPRAB = 3) then l.OBORUD_COMPLECT else l.MATER_COMPLECT end,
             case when (:TIPRAB = 3) then l.OBORUD_KOEFF_TYPE else l.MATER_KOEFF_TYPE end
      from level_cost l
      where (l.idobject = :IDCLASS) and (l.id = :IDLEVEL)
      into :VN_TRANSP, :VN_ZAG_SKL, :VN_ZAPCHAST, :VN_TARA, :VN_NACEN, :VN_COMPLECT, :VN_KOEFF_TYPE;

      --    ,    
      if (getbit(VN_KOEFF_TYPE, 31) = 1) then -- 31 - ciKoeffDirty
      begin
        --       ( )
        VN_KOEFF_TYPE = bin_and(VN_KOEFF_TYPE, 63); -- 63 = 111111
  
        update a_smeta_cenlvl
        set TRANSP = :VN_TRANSP,
            ZAG_SKL = :VN_ZAG_SKL,
            ZAPCHAST = :VN_ZAPCHAST,
            TARA = :VN_TARA,
            NACEN = :VN_NACEN,
            COMPLECT = :VN_COMPLECT,
            -- 575 = 1000111111 ..   0-5( )  9(.  ) ciKoeffManual
            KOEFF_TYPE = bin_or(bin_and(KOEFF_TYPE, bin_xor(575, -1)), :VN_KOEFF_TYPE)
  
        where (ID = :IDSMETASTR) and (IDCENLVL = :IDLEVEL);


        if (TMP_ROW_COUNT <= 0) then
          TMP_ROW_COUNT = row_count;
      end
    end
    -- MK CQ[13030] <---


    -- <-- Voyager CQ[11690]
    --         NL_CTRL_ENTER_SMREC
    if (ATYPE = 18) then
    begin
      execute procedure A_S_GET_NRSPZU_INDEX_NL_1(:IDUSER, :IDSMETASTR, :VN_PUNKTIND,
                                                  :SLAVEPARENT, :IDLEVEL, 2)
      returning_values(:VN_MF, :VN_MG, :VN_MH, :VN_MI);
      update A_SMETA_INDLVL
      set
        MH                = :VN_MH,
        MI                = :VN_MI
      where (ID = :ID)
        and (IDCENLVL = :IDLEVEL)
        and (
            coalesce(MH, 0) <> coalesce(:VN_MH, 0)
            or coalesce(MI, 0) <> coalesce(:VN_MI, 0)
            );

      -- MK 2.12.2013   CQ[11679]
      if (TMP_ROW_COUNT <= 0) then
        TMP_ROW_COUNT = row_count;
     end
     -- <-- Voyager CQ[11690]

      --CQ[TIMUR 13988]   ,       Compose 
      select case when INDEX_INFO <> 3 then 1 else 0 end
        from A_SMETA_INDLVL
        where (ID = :ID) and (IDCENLVL = :IDLEVEL)
      into :VN_NEED_FILL_INDLVL_DESCR;

      if (VN_NEED_FILL_INDLVL_DESCR = 1) then --CQ[TIMUR 13988]
      begin
        if (exists(select * from LEVEL_INDEX CI where CI.ID_COMPOSE = :ID_COMPOSE_INDEX)) then
        begin
          execute procedure FILL_INDLVL_DESCR(:ID, :IDLEVEL, :ID_COMPOSE_INDEX, 5/*:VN_RES_INDEX*/);
          VN_NEED_FILL_INDLVL_DESCR = 0;
        end
        else
        if (exists(select * from LEVEL_INDEX_ITOG CT where CT.ID_COMPOSE = :ID_COMPOSE_INDEX)) then
        begin
          execute procedure FILL_INDLVL_DESCR(:ID, :IDLEVEL, :ID_COMPOSE_INDEX, 4/*:VN_RES_INDEX*/);
          VN_NEED_FILL_INDLVL_DESCR = 0;
        end
      end
      --CQ[TIMUR 13988]

      --       ...
      if ( :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 ) then
      begin

        update A_SMETA_INDLVL
        set
            IDINDEX           = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_IDINDEX else IDINDEX end,
            ID_LEVEL_INDEX    = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :ID_COMPOSE_INDEX else ID_LEVEL_INDEX end,
            PUNKTIND          = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_PUNKTIND else PUNKTIND end,
            MA                = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MA else MA end,
            MB                = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MB else MB end,
            MC                = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MC else MC end,
            MD                = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MD else MD end,
            ME                = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_ME else ME end,
            MF                = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MF else MF end,
            MG                = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MG else MG end,
            MH                = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MH else MH end,
            MI                = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MI else MI end,
            INDEX_SPOSOBRASCH = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_SPOSOB_RASCH else INDEX_SPOSOBRASCH end,
            INDEX_INFO        = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_RES_INDEX else INDEX_INFO end,
            --CQ[10529]-->
            MJ  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MJ else MJ end,
            MK  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MK else MK end,
            ML  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_ML else ML end,
            MM  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_MM else MM end,
            M_PR = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_M_PR else M_PR end, --[15352]
            DA  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DA else DA end,
            DB  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DB else DB end,
            DC  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DC else DC end,
            DD  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DD else DD end,
            DE  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DE else DE end,
            DJ  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DJ else DJ end,
            DK  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DK else DK end,
            DL  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DL else DL end,
            DM  = case when :VN_RES_INDEX = -2/*ciNotFound*/ or :VN_RES_INDEX > 0 then :VN_DM else DM end
            --CQ[10529]<--
        where (ID = :ID)
          and (IDCENLVL = :IDLEVEL)
          and (coalesce(INDEX_INFO, 0) <> 3)  --ciDirect CQ[10863]
          and ( coalesce(:VN_RES_INDEX, 0) = -2/*ciNotFound*/ or coalesce(:VN_RES_INDEX, 0) > 0 and
                  ( coalesce(IDINDEX, 0) <> coalesce(:VN_IDINDEX, 0)
                 or coalesce(ID_LEVEL_INDEX, 0) <> coalesce(:ID_COMPOSE_INDEX, 0)
                 or coalesce(PUNKTIND, 0) <> coalesce( :VN_PUNKTIND, 0)
                 or coalesce(MA, 0) <> coalesce(:VN_MA, 0)
                 or coalesce(MB, 0) <> coalesce(:VN_MB, 0)
                 or coalesce(MC, 0) <> coalesce(:VN_MC, 0)
                 or coalesce(MD, 0) <> coalesce(:VN_MD, 0)
                 or coalesce(ME, 0) <> coalesce(:VN_ME, 0)
                 or coalesce(MF, 0) <> coalesce(:VN_MF, 0)
                 or coalesce(MG, 0) <> coalesce(:VN_MG, 0)
                 or coalesce(MH, 0) <> coalesce(:VN_MH, 0)
                 or coalesce(MI, 0) <> coalesce(:VN_MI, 0)
                 or coalesce(INDEX_SPOSOBRASCH, 0) <> coalesce(:VN_SPOSOB_RASCH, 0)
                 or coalesce(INDEX_INFO, 0) <> coalesce(:VN_RES_INDEX, 0)
                 --CQ[10529]-->
                 or coalesce(MJ, 0) <> coalesce(:VN_MJ, 0)
                 or coalesce(MK, 0) <> coalesce(:VN_MK, 0)
                 or coalesce(ML, 0) <> coalesce(:VN_ML, 0)
                 or coalesce(MM, 0) <> coalesce(:VN_MM, 0)
                 or coalesce(M_PR, 0) <> coalesce(:VN_M_PR, 0) --[15352]
                 or coalesce(DA, 0) <> coalesce(:VN_DA, 0)
                 or coalesce(DB, 0) <> coalesce(:VN_DB, 0)
                 or coalesce(DC, 0) <> coalesce(:VN_DC, 0)
                 or coalesce(DE, 0) <> coalesce(:VN_DE, 0)
                 or coalesce(DJ, 0) <> coalesce(:VN_DJ, 0)
                 or coalesce(DK, 0) <> coalesce(:VN_DK, 0)
                 or coalesce(DL, 0) <> coalesce(:VN_DL, 0)
                 or coalesce(DM, 0) <> coalesce(:VN_DM, 0)
                 --CQ[10529]<--
                  )
              )
          ;

        --CQ[10685]RECORDS_MODIFIED = :RECORDS_MODIFIED + row_count;
        --CQ[10685]-->
        if (TMP_ROW_COUNT <= 0) then
          TMP_ROW_COUNT = row_count;
        --CQ[10685]<--

        --   ,  
        if ((row_count > 0) and (VN_NEED_FILL_INDLVL_DESCR = 1)) then --CQ[TIMUR 13988] if (row_count > 0) then
          execute procedure FILL_INDLVL_DESCR(:ID, :IDLEVEL, :ID_COMPOSE_INDEX, :VN_RES_INDEX); --CQ[10529]

        --<[14316]>
        if (:UPDATE_SMETA_PUNKTIND <> 0) then
          update A_SMETA set PUNKTIND=:PUNKTIND where ID=:ID;
        --</>
      end

      RECORDS_MODIFIED = :RECORDS_MODIFIED + :TMP_ROW_COUNT;

      -- ,    
      --    () 
      if (:ATYPE = 17) then --CQ[10863]     and coalesce(:VN_RES_ZONE, 0) > 0) then
      begin
      --          
      --   ,    ;
      -- REM:  "       "
      --            

      -- 
        for select ID, NORM_ID, NORM_PODGROUP, RABMAT, --, TYPE_TRUD
            RE.BB, RE.BC, RE.BD, RE.BE, RE.TAB, --RE.IDEDIZM, RE.NAME_ID, --CQ[10058]
            RE.NORM_GUID

            from M_ETALON_S_RES RE
            where RE.ID_SOURCE = :ID
              -- and KODIR_GROUP, KODIR_PODGROUP
            into :ID_RES, :IDNORMATIV, :IDPODGROUP, :RABMAT, --, :TYPE_TRUD
                 :BB, :BC, :BD, :BE, :TAB, --:ID_EDIZM, :NAME_ID, --CQ[10058]
                 :NORM_GUID
        do
        begin
/*[10430]
          --   
          -- <-- Voyager. . CQ[CQ9681].    Select  B_NNAME
          --select first 1 K_GETCRC32(NAME)
          --from B_GETNAME_EX(:IDUSER, :NAME_ID)
          --into :S_NAME_CRC;
          select CRC_NAME_TITLE from B_NNAME
          where ID = :NAME_ID into :S_NAME_CRC;
    
          --  
          select first 1 EDIZMNAME
          from B_GET_EDIZM(:ID_EDIZM)
          into :S_EDIZM_NAME;
    
          execute procedure T_FB_SEARCH_NORMATIV (:IDPODGROUP, -1, :IDUSER, :TAB,
                     :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0, :S_NAME_CRC, :S_EDIZM_NAME, 0)
          returning_values (:SEARCH_NORM_ID, :SEARCH_RESULT);
*/

          /*  :   A_S_PARAMS_TO_ET_RES_NL_ONE

          execute procedure L_GET_NORMATIV_FROM_GUID_RES(
              :NORM_GUID, :TAB, :IDNORMATIV, :IDPODGROUP, :RABMAT, :IDUSER)
            returning_values :SEARCH_NORM_ID, :IDPODGROUP, :RABMAT, :SEARCH_RESULT;
          --   ,      
          if (SEARCH_RESULT <> 0) then
            IDNORMATIV = null;
          else
            IDNORMATIV = :SEARCH_NORM_ID;
          --CQ[10058]

          if (:IDNORMATIV is not null) then
          begin
            --  
            execute procedure NL_CHECK_VC(:IDUSER, :ID_COMPOSE_VC, 0,
                    :RABMAT, :IDNORMATIV, :IDPODGROUP)
                returning_values :VN_RES_ZONE, :VN_IDZONE,
                    :VN_ZONE_BA, :VN_ZONE_BB, :VN_ZONE_BC, :VN_ZONE_BD, :VN_ZONE_BE;
          end
          else
          begin
            --CQ[10058]-->
            VN_RES_ZONE = 0;
            ID_COMPOSE_VC = null;
            VN_IDZONE = -3;
            VN_ZONE_BB = :BB;
            VN_ZONE_BC = :BC;
            VN_ZONE_BD = :BD;
            VN_ZONE_BE = :BE;
            --CQ[10058]<--
          end

          --  ,   
          if (:VN_RES_ZONE > 0) then
          begin
            update A_S_ETALON_RES_CENLVL
              set IDZONE = :VN_IDZONE,
                  ID_LEVEL_VC = :ID_COMPOSE_VC,
                  BB = :VN_ZONE_BB,
                  BC = :VN_ZONE_BC,
                  BD = :VN_ZONE_BD,
                  BE = :VN_ZONE_BE,
                  BASE_INFO = :VN_RES_ZONE
              where (ID = :ID_RES)
                and (IDCENLVL = :IDLEVEL)
                and ( coalesce(:VN_RES_ZONE, 0) > 0 and
                        ( coalesce(IDZONE, 0) <> coalesce(:VN_IDZONE, 0)
                       or coalesce(ID_LEVEL_VC, 0) <> coalesce(:ID_COMPOSE_VC, 0)
                       or coalesce(BB, 0) <> coalesce(:VN_ZONE_BB, 0)
                       or coalesce(BC, 0) <> coalesce(:VN_ZONE_BC, 0)
                       or coalesce(BD, 0) <> coalesce(:VN_ZONE_BD, 0)
                       or coalesce(BE, 0) <> coalesce(:VN_ZONE_BE, 0)
                       or coalesce(BASE_INFO, 0) <> coalesce(:VN_RES_ZONE, 0)
                        )
                    );
            RECORDS_MODIFIED = :RECORDS_MODIFIED + row_count;
          end */
          execute procedure A_S_PARAMS_TO_ET_RES_NL_ONE(:IDUSER, :ID_RES, :IDLEVEL) returning_values :TMP_ROW_COUNT;
          RECORDS_MODIFIED = :RECORDS_MODIFIED + :TMP_ROW_COUNT;
        end




/* :   A_S_PARAMS_TO_RES_NL_ONE

        for select ID, NORM_ID, NORM_PODGROUP, RABMAT, --, TYPE_TRUD
                   RS.BB, RS.BC, RS.BD, RS.BE, RS.TAB, --RS.IDEDIZM, RS.NAME_ID, --CQ[10058]
                   RS.NORM_GUID
            from A_S_RES RS
            where RS.ID_SOURCE = :ID
              --and KODIR_GROUP, KODIR_PODGROUP, 
              and not exists(select * from A_SMETA S where S.ID_S_RES = RS.ID) --<<  ,    
            into :ID_RES, :IDNORMATIV, :IDPODGROUP, :RABMAT,  --, :TYPE_TRUD
                 :BB, :BC, :BD, :BE, :TAB, --:ID_EDIZM, :NAME_ID, --CQ[10058]
                 :NORM_GUID
        do
        begin
/*[10430]
          --   
          -- <-- Voyager. . CQ[CQ9681].    Select  B_NNAME
          --select first 1 K_GETCRC32(NAME)
          --from B_GETNAME_EX(:IDUSER, :NAME_ID)
          --into :S_NAME_CRC;
          select CRC_NAME_TITLE from B_NNAME
          where ID = :NAME_ID into :S_NAME_CRC;

          --  
          select first 1 EDIZMNAME
          from B_GET_EDIZM(:ID_EDIZM)
          into :S_EDIZM_NAME;
    
          execute procedure T_FB_SEARCH_NORMATIV (:IDPODGROUP, -1, :IDUSER, :TAB,
                     :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0, :S_NAME_CRC, :S_EDIZM_NAME, 0)
          returning_values (:SEARCH_NORM_ID, :SEARCH_RESULT);
*//*
          execute procedure L_GET_NORMATIV_FROM_GUID_RES(
              :NORM_GUID, :TAB, :IDNORMATIV, :IDPODGROUP, :RABMAT, :IDUSER)
            returning_values :SEARCH_NORM_ID, :IDPODGROUP, :RABMAT, :SEARCH_RESULT;
          --   ,      
          if (SEARCH_RESULT <> 0) then
            IDNORMATIV = null;
          else
            IDNORMATIV = :SEARCH_NORM_ID;
          --CQ[10058]

          if (:IDNORMATIV is not null) then
          begin
            --  
            execute procedure NL_CHECK_VC(:IDUSER, :ID_COMPOSE_VC, 0,--:ATYPE
                    :RABMAT, :IDNORMATIV, :IDPODGROUP)
                returning_values :VN_RES_ZONE, :VN_IDZONE,
                    :VN_ZONE_BA, :VN_ZONE_BB, :VN_ZONE_BC, :VN_ZONE_BD, :VN_ZONE_BE;
          end
          else
          begin
            --CQ[10058]-->
            VN_RES_ZONE = 0;
            VN_IDZONE = -3;
            VN_ZONE_BB = :BB;
            VN_ZONE_BC = :BC;
            VN_ZONE_BD = :BD;
            VN_ZONE_BE = :BE;
            --CQ[10058]<--
          end

          if (:VN_RES_ZONE > 0) then
          begin
            update A_S_RES_CENLVL
              set IDZONE = :VN_IDZONE,
                  ID_LEVEL_VC = :ID_LEVEL_VC,
                  BB = :VN_ZONE_BB,
                  BC = :VN_ZONE_BC,
                  BD = :VN_ZONE_BD,
                  BE = :VN_ZONE_BE,
                  BASE_INFO = :VN_RES_ZONE
              where (ID = :ID_RES)
                and (IDCENLVL = :IDLEVEL)
                and ( coalesce(:VN_RES_ZONE, 0) > 0 and
                        ( coalesce(IDZONE, 0) <> coalesce(:VN_IDZONE, 0)
                       or coalesce(ID_LEVEL_VC, 0) <> coalesce(:ID_COMPOSE_VC, 0)
                       or coalesce(BB, 0) <> coalesce(:VN_ZONE_BB, 0)
                       or coalesce(BC, 0) <> coalesce(:VN_ZONE_BC, 0)
                       or coalesce(BD, 0) <> coalesce(:VN_ZONE_BD, 0)
                       or coalesce(BE, 0) <> coalesce(:VN_ZONE_BE, 0)
                       or coalesce(BASE_INFO, 0) <> coalesce(:VN_RES_ZONE, 0)
                        )
                    );
            RECORDS_MODIFIED = :RECORDS_MODIFIED + row_count;
          end
        end*/

      -- MK CQ[15661]     if (:ATYPE = 17) then
      -- .  [4A02A968]

        for select RS.ID
            from A_S_RES RS
            where RS.ID_SOURCE = :ID

              and not exists(select * from A_SMETA S where S.ID_S_RES = RS.ID) --<<  ,    
            into :ID_RES
        do
        begin
          execute procedure A_S_PARAMS_TO_RES_NL_ONE(:IDUSER, :ID_RES, :IDLEVEL) returning_values :TMP_ROW_COUNT;
          RECORDS_MODIFIED = :RECORDS_MODIFIED + :TMP_ROW_COUNT;
        end

      end

      -- MK CQ[15661] --->
      --     if (:ATYPE = 17) then
      -- .  [4A02A968]

      -- MK CQ[14313] --->
      --        
      --      
      if (VN_NEED_SPREAD_BB <> 0) then
      begin
        select L.curr_cena
        from A_SMETA_CENLVL L
        where (L.id = :IDSMETASTR) and (L.idcenlvl = :IDLEVEL)
        into :NEW_curr_cena;

        --    -      
        if (NEW_curr_cena <> 0) then
        begin
          --     
          update A_SMETA_CENLVL c
          set c.source_level_id = -1
          where (c.id = :IDSMETASTR) and (c.idcenlvl = :IDLEVEL);

          --     
          update A_SMETA_CENLVL c
          set c.source_level_id = :IDLEVEL,
              c.base_calc_info = bin_or( 2/*cbFilled*/,
                  bin_and(c.base_calc_info, bin_xor(7/*cbCalcMask*/, -1)) ) --[14353]
          where (c.id = :IDSMETASTR) and (c.idcenlvl <> :IDLEVEL);
        end
      end
      -- MK CQ[14313] <---
      -- MK CQ[15661] <---

    end

    --   
    /*>>[10216] -    
    if (:RECORDS_MODIFIED > 0) then
      if (:SMETATYPE > 999) then
        update A_O_FACTPARAMS PA
          set PA.DORECALK = SETBIT(coalesce(PA.DORECALK, 0), 0, 1)
          where PA.NUMBER = :IDCLASS
            and coalesce(PA.DORECALK, 0) <> SETBIT(COALESCE(PA.DORECALK, 0), 0, 1);
      else
        update A_O_OBJECTPARAMS PO
          set PO.DORECALK = SETBIT(COALESCE(PO.DORECALK, 0), 0, 1)
          where PO.NUMBER = :IDCLASS
            and coalesce(PO.DORECALK, 0) <> SETBIT(COALESCE(PO.DORECALK, 0), 0, 1);
    */
    suspend;
    exit;
  end -- for suspend/exit
end
^

--[15662]
/* 
create or alter procedure NL_CTRL_ENTER_SMREC (
*/

-- MK CQ[15662.1]
/* 
create or alter procedure A_S_RES_TO_SLAVEREC_NL_2 (
*/
-- Voyager CQ[15722,15725]
create or alter procedure D_INDEXPARAMS1_CREATE
AS
begin
  if (not exists(select * from RDB$RELATIONS
      where upper(RDB$RELATION_NAME) = 'D_INDEXPARAMS1') ) then
  begin

    execute statement
    'CREATE TABLE D_INDEXPARAMS1 ('||
    '    ID_REESTR  A_INTEGERNOTNULL NOT NULL,'||
    '    SB_NUMBER  B_D_VARCHAR50,'||
    '    NR_OT_ZPM  B_D_DOUBLE,'||
    '    SP_OT_ZPM  B_D_DOUBLE'||
    ')';

    execute statement
        'ALTER TABLE D_INDEXPARAMS1 ADD CONSTRAINT FK_ID_REESTR_IDX ' ||
        'FOREIGN KEY (ID_REESTR) REFERENCES B_REESTR (ID) ON DELETE CASCADE';
  end
end
^
execute procedure D_INDEXPARAMS1_CREATE
^
drop procedure D_INDEXPARAMS1_CREATE
^^

create or alter procedure D_GET_INDEXPARAMS (
    ID_REESTR integer)
returns (
    ATYPE              integer,
    INDEXPARAMS_ID     integer,
    NAME               varchar(250),
    DESCR              blob sub_type 1 segment size 80,
    AYEAR              integer,
    AMONTH             integer,
    INDEX_NASNACHAUTO  integer,
    INDEX_ZAMENNASNACH integer,
    INDEX_UCHITNDS     integer,
    INDEX_SPOSOBRASCH  integer,
    INDEX_RASCHNRISP   integer,
    INDEX_BRAT_ZU_IS   integer,
    INDEX_FOT          integer,
    HAS_VALUES         integer,
    SB_NUMBER          varchar(50),
    NR_OT_ZPM          double precision,
    SP_OT_ZPM          double precision)
AS
  declare variable FID integer;
  declare variable FIDPARENT integer;
begin
/*ATYPE: 0 - , 1 - , 2 - */
  select INDEXPARAMS_ID, ATYPE
  from D_FIND_INDEXPARAMS_ID(:ID_REESTR)
  into INDEXPARAMS_ID, ATYPE;

  if (INDEXPARAMS_ID is null) then
    exit;

  select first 1 r.NAME, r.VIX_DAN, r.GOD, r.ORDERVIEW
  from B_REESTR r
  where r.ID = :INDEXPARAMS_ID /* and r.RABMAT = 100*/
  into NAME, DESCR, AYEAR, AMONTH;

  select first 1 ID, INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS,
                 INDEX_SPOSOBRASCH, INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS,
                 INDEX_FOT, HAS_VALUES
  from D_INDEXPARAMS
  where ID = :INDEXPARAMS_ID
  into INDEXPARAMS_ID, INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS,
       INDEX_SPOSOBRASCH, INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS,
       INDEX_FOT, HAS_VALUES;

  -- <-- Voyager CQ[15722,15725]
  select first 1 SB_NUMBER,NR_OT_ZPM, SP_OT_ZPM
  from D_INDEXPARAMS1
  where ID_REESTR = :ID_REESTR
  into :SB_NUMBER, :NR_OT_ZPM, :SP_OT_ZPM;
  -- <-- Voyager CQ[15722,15725]

  if (INDEXPARAMS_ID is null) then
    exit;
  suspend;
end
^

create or alter procedure D_SAVE_INDEXPARAMS_1 (
    ID_REESTR integer,
    SB_NUMBER varchar(50),
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision)
AS
begin
  if (exists(select ID_REESTR from D_INDEXPARAMS1 P where P.ID_REESTR = :ID_REESTR)) then
    update D_INDEXPARAMS1 P
    set
      P.SB_NUMBER = :SB_NUMBER,
      P.NR_OT_ZPM = :NR_OT_ZPM,
      P.SP_OT_ZPM = :SP_OT_ZPM
    where
      P.ID_REESTR = :ID_REESTR;
  else
  begin
    insert into D_INDEXPARAMS1 (ID_REESTR, SB_NUMBER, NR_OT_ZPM, SP_OT_ZPM)
    values (:ID_REESTR, :SB_NUMBER, :NR_OT_ZPM, :SP_OT_ZPM);
  end
end
^

create or alter procedure D_SAVE_INDEXPARAMS (
    ID_REESTR integer,
    NAME varchar(250),
    DESCR blob sub_type 1 segment size 80,
    INDEX_NASNACHAUTO integer,
    INDEX_ZAMENNASNACH integer,
    INDEX_UCHITNDS integer,
    INDEX_SPOSOBRASCH integer,
    INDEX_RASCHNRISP integer,
    INDEX_BRAT_ZU_IS integer,
    INDEX_FOT integer,
    SB_NUMBER varchar(50),
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision)
returns (
    OUT_INDEXPARAMS_ID integer,
    OUT_ATYPE integer)
AS
begin
/*ATYPE: 0 - , 2 - , 3 - */
  select INDEXPARAMS_ID, ATYPE
  from D_FIND_INDEXPARAMS_ID(:ID_REESTR)
  into OUT_INDEXPARAMS_ID, OUT_ATYPE;

  if (OUT_INDEXPARAMS_ID is null) then
    exit;
/*     */
/*  if (OUT_ATYPE = 0) then*/
    update B_REESTR
    set NAME = :NAME,
        VIX_DAN = :DESCR
    where ID = :OUT_INDEXPARAMS_ID; /*:ID_REESTR;*/
/*  else
  begin
    update B_REESTR
    set NAME = :NAME
    where ID = :OUT_INDEXPARAMS_ID;

    update B_REESTR
    set VIX_DAN = :DESCR
    where ID = :ID_REESTR;
  end*/


  -- <-- Voyager CQ[15722,15725]
  if (OUT_ATYPE = 3) then /*    */
    execute procedure D_SAVE_INDEXPARAMS_1 (:ID_REESTR, :SB_NUMBER, :NR_OT_ZPM, :SP_OT_ZPM);
  -- <-- Voyager CQ[15722,15725]

  update D_INDEXPARAMS
  set INDEX_NASNACHAUTO = :INDEX_NASNACHAUTO,
      INDEX_ZAMENNASNACH = :INDEX_ZAMENNASNACH,
      INDEX_UCHITNDS = :INDEX_UCHITNDS,
      INDEX_SPOSOBRASCH = :INDEX_SPOSOBRASCH,
      INDEX_RASCHNRISP = :INDEX_RASCHNRISP,
      INDEX_BRAT_ZU_IS = :INDEX_BRAT_ZU_IS,
      INDEX_FOT = :INDEX_FOT,
      HAS_VALUES = 1
  where (ID = :OUT_INDEXPARAMS_ID);
  if (OUT_INDEXPARAMS_ID is not null) then
    suspend;
end
^

--[15721]
create or alter procedure B_READ_DOCUMENT (
    IDUSER integer,
    ID integer,
    IDNORMY integer,
    RABMAT integer,
    PODGROUP integer,
    DOCTYPE integer)
returns (
    DOCEXISTS integer,
    NAME varchar(250),
    CONTENTS blob sub_type 1 segment size 80,
    PATHTOFILE blob sub_type 1 segment size 80,
    FINDFRAGMENT varchar(250),
    POKAZ varchar(8),
    GOD integer,
    NOMER integer,
    ISSYSTEM_MASK smallint)
AS
DECLARE VARIABLE IDREESTR INTEGER;
DECLARE VARIABLE IDCONTENTS INTEGER;
BEGIN
 IF (ID = 0)
 THEN ID = NULL ;

 IF (IDNORMY  = 0)
 THEN IDNORMY  = NULL ;

 IF (ID IS NULL)  THEN
    IF ((IDNORMY IS NOT NULL) AND (RABMAT <> 1)) THEN BEGIN
       IF (:PODGROUP > 1)
       THEN
          SELECT IDNORMA
          FROM B_ABC_OKP
          WHERE ID = :IDNORMY
          INTO :IDNORMY ;

       IF (IDNORMY IS NOT NULL) THEN BEGIN
          IF (DOCTYPE = 100) THEN BEGIN
             SELECT IDTCH, FRTCH, IDREESTR
             FROM B_RABMAT
             WHERE ID = :IDNORMY
             INTO :ID, :FINDFRAGMENT, :IDREESTR ;

             IF (ID IS NULL) THEN
                SELECT IDTCH
                FROM B_REESTR
                WHERE ID = :IDREESTR
                INTO :ID ;
          END
          ELSE
          IF (DOCTYPE = 101) THEN BEGIN
             SELECT IDESN, FRESN
             FROM B_RABMAT
             WHERE ID = :IDNORMY
             INTO :ID, :FINDFRAGMENT ;
          END ELSE
          IF (DOCTYPE = 103) THEN BEGIN
             SELECT IDTCARD
             FROM B_RABMAT
             WHERE ID = :IDNORMY
             INTO :ID ;
          END
       END
    END

 DOCEXISTS = 0;
 IF (ID IS NOT NULL)
 THEN
    FOR SELECT ID, NAME, IDCONTENTS, PATHTOFILE, POKAZ, GOD, NOMER,
               ISSYSTEM -- MK CQ[15721]
    FROM B_REESTR_DOC
    WHERE ID = :ID
    INTO :ID, :NAME, :IDCONTENTS, :PATHTOFILE, :POKAZ, :GOD, :NOMER,
         :ISSYSTEM_MASK -- MK CQ[15721]
    DO BEGIN
       DOCEXISTS = 1;

       IF (IDCONTENTS IS NOT NULL)
       THEN
          SELECT CONTENTS
          FROM B_READ_DOC_CONTENTS(:IDUSER, :IDCONTENTS)
          INTO :CONTENTS ;

       SUSPEND;
    END
END
^

--[15721]
create or alter procedure B_SET_REESTR_DOC_SYSTEM_MODE (
    IDUSER integer,
    IDREESTR integer,
    IN_ISSYSTEM integer,
    ISSYSTEM_MODE integer)
AS
DECLARE VARIABLE ID INTEGER;
BEGIN
 -- ISSYSTEM_MODE -        B_REESTR_DOC.ISSYSTEM
 --       :ISSYSTEM

 -- CQ[15721] --->
 IN_ISSYSTEM = coalesce(IN_ISSYSTEM, 0);
 ISSYSTEM_MODE = coalesce(ISSYSTEM_MODE, 0);
 if (not IN_ISSYSTEM in (0, 1)) then
   exit;
 if (not ISSYSTEM_MODE in (0, 1)) then
   exit;
 -- CQ[15721] <---

 FOR SELECT IDREESTR
 FROM B_READ_REESTR_DOC_NODE_CHILDS(:IDUSER, :IDREESTR, 1, 0)
 INTO :ID
 DO BEGIN
    UPDATE B_REESTR_DOC
    -- CQ[15721] --->
    SET ISSYSTEM =  setbit(ISSYSTEM, :ISSYSTEM_MODE, :IN_ISSYSTEM)
    --SET ISSYSTEM = :ISSYSTEM
    -- CQ[15721] <---
    WHERE ID = :ID ;
 END
END
^

--[15721]
create or alter procedure B_SET_REESTR_DOC_SYSTEM_MODE_EX (
    IDUSER integer,
    SETBLOB blob sub_type 0 segment size 80,
    SETCOUNT integer,
    IN_ISSYSTEM integer,
    ISSYSTEM_MODE integer)
AS
DECLARE VARIABLE IDREESTR INTEGER;
DECLARE VARIABLE ID_TMP INTEGER;
BEGIN
  --  ISSYSTEM_MODE .  B_SET_REESTR_DOC_SYSTEM_MODE

 ID_TMP = GEN_ID(B_GEN_TEMP, 1) ;
 INSERT INTO B_TEMP_BLOB (ID, BLOB1) VALUES (:ID_TMP, :SETBLOB);
 SELECT BLOB1 FROM B_TEMP_BLOB WHERE ID = :ID_TMP INTO :SETBLOB;
 DELETE FROM B_TEMP_BLOB WHERE ID = :ID_TMP ;

 FOR SELECT FVALUE
 FROM S_INTFROMBLOB_SELECT(:SETBLOB, :SETCOUNT)
 INTO :IDREESTR
 DO
    -- CQ[15721] --->
    EXECUTE PROCEDURE B_SET_REESTR_DOC_SYSTEM_MODE(:IDUSER, :IDREESTR, :IN_ISSYSTEM, :ISSYSTEM_MODE);
    --EXECUTE PROCEDURE B_SET_REESTR_DOC_SYSTEM_MODE(:IDUSER, :IDREESTR, :ISSYSTEM) ;
    -- CQ[15721] <---
END
^

--[15721]
create or alter procedure B_DELETE_REESTR_DOC (
    IDUSER integer,
    ID integer,
    NEEDTESTSYSTEM integer)
AS
declare variable issystem smallint;
declare variable refcount smallint;
declare variable is_system_mode integer;
declare variable doctype integer;
BEGIN
 IF (ID = 0)
 THEN ID = NULL;

 IF (NEEDTESTSYSTEM IS NULL)
 THEN NEEDTESTSYSTEM = 1;

 IF (ID IS NOT NULL) THEN BEGIN
    IF (NEEDTESTSYSTEM = 1)
    THEN
       SELECT IS_SYSTEM_MODE
       FROM L_IS_SYSTEM_MODE(:IDUSER)
       INTO :IS_SYSTEM_MODE;
    ELSE
       IS_SYSTEM_MODE = 1;

    IF (IS_SYSTEM_MODE = 1)
    THEN BEGIN
       REFCOUNT = 0;

       SELECT DOCTYPE
       FROM B_GET_DOC_TYPE(:IDUSER, :ID)
       INTO :DOCTYPE;

       IF (DOCTYPE = 100)
       THEN

          --IF (EXISTS(SELECT * FROM B_REESTR WHERE IDTCH = :ID))
          --THEN REFCOUNT = 1;    -- cq 151 .   

          REFCOUNT = 0; -- cq 151

       IF (REFCOUNT < 1) THEN BEGIN
          DELETE FROM B_REESTR_DOC
          WHERE ID = :ID;

          WHEN GDSCODE FOREIGN_KEY DO EXIT ;
          WHEN GDSCODE DEADLOCK, GDSCODE LOCK_CONFLICT, GDSCODE LOCK_TIMEOUT DO EXIT ;
       END
    END
    ELSE BEGIN
       IF (NEEDTESTSYSTEM = 1)
       THEN
          -- MK CQ[15721] --->
          SELECT getbit(ISSYSTEM, 0)
          --SELECT ISSYSTEM
          -- MK CQ[15721] <---
          FROM B_REESTR_DOC
          WHERE ID = :ID
          INTO :ISSYSTEM;
       ELSE
          ISSYSTEM = 0;

       IF (ISSYSTEM = 1)
       THEN EXCEPTION B_E_CANT_DELETE_SYSTEM_INFO ;
       ELSE BEGIN
          REFCOUNT = 0;

          SELECT DOCTYPE
          FROM B_GET_DOC_TYPE(:IDUSER, :ID)
          INTO :DOCTYPE;

          IF (DOCTYPE = 100)
          THEN

             --IF (EXISTS(SELECT * FROM B_REESTR WHERE IDTCH = :ID))
             --THEN REFCOUNT = 1;    -- cq 151 .   

          REFCOUNT = 0; -- cq 151

          IF (REFCOUNT < 1) THEN BEGIN
             DELETE FROM B_REESTR_DOC
             WHERE ID = :ID;

             WHEN GDSCODE FOREIGN_KEY DO EXIT ;
             WHEN GDSCODE DEADLOCK, GDSCODE LOCK_CONFLICT, GDSCODE LOCK_TIMEOUT DO EXIT ;
          END
       END
    END
 END
END
^

--[15721]
create or alter procedure B_IMP_I_REESTR_DOC (
    IDUSER integer,
    IMPMODE integer,
    ID integer,
    IDPARENT integer,
    NEEDSHOW integer,
    ISSYSTEM integer,
    ISPAPKA integer,
    GOD integer,
    NOMER integer,
    NAME varchar(250),
    ID_UNIQUE integer,
    POKAZ varchar(8),
    ORDERVIEW integer,
    PATHTOFILE blob sub_type 0 segment size 80,
    TAB varchar(25),
    NORM_GUID varchar(100),
    IDCONTENTS integer)
returns (
    ID_NEW integer)
AS
DECLARE VARIABLE REORDERING INTEGER;
DECLARE VARIABLE INSERTING_ INTEGER;
DECLARE VARIABLE IDCONTENTS_OLD INTEGER;
DECLARE VARIABLE ISSYSTEM_OLD INTEGER;
BEGIN
  IF (:IDCONTENTS = 0) THEN IDCONTENTS = NULL;

  IF (:ORDERVIEW IS NULL OR :ORDERVIEW <= 0)
  THEN
    SELECT MAX(ORDERVIEW) + 1
      FROM B_REESTR_DOC
      WHERE IDPARENT = :IDPARENT
      INTO :ORDERVIEW;
  ELSE
    REORDERING = 1;

  IF (ORDERVIEW IS NULL) THEN
    ORDERVIEW = 1;
  ELSE
    REORDERING = 1;

  IF (:ID BETWEEN 1 AND 999) THEN
    -- MK CQ[15721] --->
    SELECT ID, IDCONTENTS, getbit(ISSYSTEM, 0)
    --SELECT ID, IDCONTENTS, ISSYSTEM
    -- MK CQ[15721] <---
      FROM B_REESTR_DOC D
      WHERE ID = :ID
      INTO :ID_NEW, :IDCONTENTS_OLD, :ISSYSTEM_OLD;
  ELSE
  IF (:NORM_GUID <> '') THEN
    -- MK CQ[15721] --->
    SELECT FIRST 1 ID, IDCONTENTS, getbit(ISSYSTEM, 0)
    --SELECT FIRST 1 ID, IDCONTENTS, ISSYSTEM
    -- MK CQ[15721] <---
      FROM B_REESTR_DOC D
      WHERE D.NORM_GUID = :NORM_GUID
      INTO :ID_NEW, :IDCONTENTS_OLD, :ISSYSTEM_OLD;
  ELSE
  BEGIN
    SUSPEND;
    EXIT;
  END

  IF (:ID_NEW IS NULL) THEN
  BEGIN
    ID_NEW = GEN_ID (A_G_SMETA, 1);
    INSERTING_ = 1;
  END

  IF (:REORDERING = 1) THEN
    EXECUTE PROCEDURE B_WRITE_NEWORDER_REESTR_DOC(
        :IDUSER, :ID_NEW, :IDPARENT, :ORDERVIEW )
      RETURNING_VALUES (:REORDERING);

  IF (:ID_NEW IS NOT NULL) THEN
  IF (:INSERTING_ = 1) THEN
    INSERT INTO B_REESTR_DOC ( ID, IDPARENT, NEEDSHOW,
        ISSYSTEM, ISPAPKA, GOD, NOMER, NAME, ID_UNIQUE, POKAZ, ORDERVIEW,
        PATHTOFILE, TAB, NORM_GUID, IDCONTENTS )
      VALUES (:ID_NEW, :IDPARENT, :NEEDSHOW,
        :ISSYSTEM, :ISPAPKA, :GOD, :NOMER, :NAME, :ID_UNIQUE, :POKAZ, :ORDERVIEW,
        :PATHTOFILE, :TAB, :NORM_GUID, :IDCONTENTS);
  ELSE
  BEGIN
    -- MK CQ[15721] --->
    IF (:ISSYSTEM_OLD = 1) THEN setbit(ISSYSTEM, 0, 1);
    --IF (:ISSYSTEM_OLD = 1) THEN ISSYSTEM = 1;
    -- MK CQ[15721] <---

    UPDATE B_REESTR_DOC
      SET
        IDPARENT   = :IDPARENT,
        NEEDSHOW   = :NEEDSHOW,
        ISSYSTEM   = :ISSYSTEM,
        ISPAPKA    = :ISPAPKA,
        GOD        = :GOD,
        NOMER      = :NOMER,
        NAME       = :NAME,
        ID_UNIQUE  = :ID_UNIQUE,
        POKAZ      = :POKAZ,
        ORDERVIEW  = :ORDERVIEW,
        PATHTOFILE = :PATHTOFILE,
        TAB        = :TAB,
        IDCONTENTS = :IDCONTENTS
      WHERE ID = :ID_NEW;

    IF (:IDCONTENTS_OLD IS NOT NULL AND
       (:IDCONTENTS IS NULL OR :IDCONTENTS_OLD <> :IDCONTENTS))
    THEN
      EXECUTE PROCEDURE B_DELETE_DOC_CONTENTS (:IDUSER, :IDCONTENTS_OLD);
  END

  SUSPEND;
END
^

/* 
create or alter procedure B_IMP_I_PODGROUP (
*/

--------------------------------------------------------------------
--                           10.0.0.13
--------------------------------------------------------------------

create or alter procedure T_TMP_GENERATOR_CREATE
as
begin
  if (not exists(select * from RDB$GENERATORS G
      where upper(G.RDB$GENERATOR_NAME) = 'GEN_A_LZ_DYNAMIC_EXPORT_ID')) then
  begin
    execute statement 'CREATE GENERATOR GEN_A_LZ_DYNAMIC_EXPORT_ID;';
  end
end
^

execute procedure T_TMP_GENERATOR_CREATE
^

drop procedure T_TMP_GENERATOR_CREATE
^^

create or alter procedure T_TMP_A_LZ_DYNAMIC_CREATE
AS
begin
  if (not exists(select * from RDB$RELATIONS
      where upper(RDB$RELATION_NAME) = 'A_LZ_DYNAMIC') ) then
  begin

    execute statement
    'CREATE TABLE A_LZ_DYNAMIC ( '||
    '    IDHIER     A_INTEGERNOTNULL NOT NULL,'||
    '    SMETATYPE  A_INTEGERNOTNULL,'||
    '    AVAR       A_VARCHAR30 NOT NULL,'||
    '    NOTE       A_VARCHAR255,'||
    '    APRINT     A_INTEGER,'||
    '    ID_EXPORT  A_INTEGERNOTNULL'||
    ')';

    execute statement
        'ALTER TABLE A_LZ_DYNAMIC ADD CONSTRAINT PK_A_LZ_DYNAMIC ' ||
        'PRIMARY KEY (SMETATYPE, IDHIER, AVAR)';

    execute statement
        'ALTER TABLE A_LZ_DYNAMIC ADD CONSTRAINT FK_A_LZ_DYNAMIC_IDHIER ' ||
        'FOREIGN KEY (IDHIER) REFERENCES A_O_HIER (NUMBER) ' ||
        'ON DELETE CASCADE ON UPDATE CASCADE';

    execute statement
        'CREATE UNIQUE INDEX A_LZ_DYNAMIC_EXPORT_IDX ON A_LZ_DYNAMIC (ID_EXPORT)';
  end
end
^

execute procedure T_TMP_A_LZ_DYNAMIC_CREATE
^

drop procedure T_TMP_A_LZ_DYNAMIC_CREATE
^^

CREATE OR ALTER TRIGGER A_LZ_DYNAMIC_BI_0 FOR A_LZ_DYNAMIC
ACTIVE BEFORE INSERT POSITION 0
as
begin
  new.ID_export = gen_id(GEN_A_LZ_DYNAMIC_EXPORT_ID, 1);
end
^

CREATE OR ALTER TRIGGER A_O_HIER_TR_BD FOR A_O_HIER
ACTIVE BEFORE DELETE POSITION 1
AS
declare variable aid integer;
declare IDUSER integer;
BEGIN
 UPDATE a_o_hier
 SET countchildren = countchildren-1
 WHERE number = OLD.parent;

/*<-------->[8618]* /
 if ( old.atype = 1)
 then delete from a_o_hier h
      where h.number in ( select number
                          from A_O_HIER_SELECT_M29 ( 10, old.number ) );
/*</-------->*/
/*<++++++++>[8618]*/
  if ( old.ATYPE = 1) then
  begin
    for select number
      from A_O_HIER_SELECT_M29 ( :IDUSER, old.NUMBER )
      into :AID
    do
    delete from A_O_HIER h
      where h.NUMBER = :AID;

    delete from A_O_HIER
      where PARENT=old.NUMBER
      and ATYPE not in (0,3,4,5,18); --    

    delete from A_O_HIER
      where PARENT=old.NUMBER
      and ATYPE in (0,3,4,5); -- ;    ()
  end
/*</++++++++>*/

-- begin

  DELETE FROM a_o_hier
  WHERE parent = OLD.number;

/*  when sqlcode -913 , gdscode lock_conflict , gdscode lock_timeout , gdscode deadlock do
  begin

   for select h.number
       from a_o_hier h
       where h.parent = OLD.number
       into :aid
   do insert into s_temp( id, n1 ) values (:aid, old.atype);


  end

 end*/

 DELETE FROM A_O_HIERCHECKING a WHERE a.idelem = OLD.number;

 EXECUTE PROCEDURE a_h_DeleteParam OLD.atype, OLD.number;


/*
 delete from a_a_bl_wr1 b1
 where b1.id_hier_struct = old.number;

 execute procedure a_a_exec_delclass(old.number, old.atype);
*/
 /* MK CQ[85, 1619]*/
--DEN 23/5/5   A_O_HIER_BD0 execute procedure M_TRY_O_HIER_ELEM_DELETE(old.number, old.atype);


 delete from a_smeta s
 where s.idhier = old.number;

 if ( old.atype = 3 )
 then delete from a_s_lvars l
      where l.idls = old.number;
 else if ( old.atype = 8 )
      then
      begin

       delete from a_lz l
              where l.smetatype = old.number;

       delete from A_LZ_DYNAMIC where SMETATYPE=old.number; -- TFS[30] TFS[31] TFS[32]

       DELETE FROM A_O_HIERCHECKING a WHERE a.smetatype = OLD.number;

      end
END
^

/* TFS[30] >> */
create or alter procedure A_LZ_UPDATE (
    IDUSER integer,
    ID integer,
    IDHIER integer,
    SMETATYPE integer,
    ATYPE integer,
    NUMBER integer,
    AVAR varchar(30),
    NAME varchar(255),
    FORMULA blob sub_type 1 segment size 80,
    VID integer,
    APRINT integer,
    NOTE varchar(255),
    PRECIS integer)
returns (
    MULTIUPDATE integer)
AS
DECLARE VARIABLE CUR_ID INTEGER;
DECLARE VARIABLE CUR_VID INTEGER;
DECLARE VARIABLE renum INTEGER;
declare variable current_vid integer;
declare variable LZ_NAME_APRINT integer;
declare variable LZ_NAME_NOTE varchar(255);
declare variable IDNAME integer;
begin

 multiupdate = 0;

 cur_vid = null;

 if (not exists(select * from T_LZ_TYPE where id = :VID)) then
   VID = 0;


 -- TFS[30] -->     ,      
 if (:ATYPE = 300) then -- LZ_DINAMIC_ITOG
 begin
   update A_LZ_DYNAMIC set NOTE = :NOTE, APRINT = :APRINT
   where IDHIER = :IDHIER and SMETATYPE = :SMETATYPE and AVAR = :AVAR;
   if (row_count = 0) then
     insert into A_LZ_DYNAMIC (IDHIER, SMETATYPE, AVAR, NOTE, APRINT)
     values (:IDHIER, :SMETATYPE, :AVAR, :NOTE, :APRINT);
   suspend;
   exit;
 end



 -- TFS[30] <--

 select l.vid, l.IDNAME
 from a_lz l
 where l.id = :id
 into :cur_vid, :IDNAME;

 if ( not cur_vid is null )
 then
 begin

  if ( cur_vid <> :vid )
  then
  begin

   cur_id = null;

   for select l.id
     from a_lz l
     where (
           ( l.idhier = :idhier ) and
           ( l.smetatype = :smetatype ) and
           ( l.vid = :vid )
          )
     into :cur_id
   do
   begin
     if ( not cur_id is null )
     then
     begin
       update a_lz l
          set l.vid = 0
          where l.id = :cur_id;
       multiupdate = 1;
     end
   end



  end

 end

 execute procedure a_lz_renum ( :iduser, :id, :idhier, :smetatype, :number )
         returning_values ( :renum );

 if ( renum > 0 )
 then multiupdate = 1;

-- current_vid
 if (atype <> 212) then
 begin
   select u.idlzgroup from b_user_access u where u.id = :iduser into :current_vid;
   select n.NOTE, n.APRINT from A_LZ_NAMES n
   where (n.idgroup = :current_vid) and (n.atype = :IDNAME)
   into LZ_NAME_NOTE, LZ_NAME_APRINT;

   if (:NOTE = :LZ_NAME_NOTE) then NOTE = null;
   if (:APRINT = :LZ_NAME_APRINT) then APRINT = null;
 end


 update a_lz l
 set l.atype =     :atype,
     l.number =    :number,
     l.avar  =     :avar,
     l.name  =     :name,
     l.formula =   :formula,
     l.vid =       :vid,
     l.aprint =    :aprint,
     l.note =      :note,
     l.PRECIS =    :PRECIS  -- MK 2.12.2010 CQ[8173]
 where l.id = :id;


 suspend;
end
^

--TFS[32]
create or alter procedure A_S_GET_ID_TO_VAR (
    IDUSER integer,
    ID integer,
    KODFIELD varchar(1))
returns (
    VAR varchar(70))
AS
DECLARE VARIABLE RECIDHIER INTEGER;
DECLARE VARIABLE RECNUMBER1 INTEGER;
DECLARE VARIABLE RECNUMBER2 INTEGER;
DECLARE VARIABLE RECTYPE INTEGER;
DECLARE VARIABLE CUR_ATYPEHIER INTEGER;
DECLARE VARIABLE CUR_PARENT INTEGER;
DECLARE VARIABLE CUR_NUMBER INTEGER;
DECLARE VARIABLE VARLS VARCHAR(10);
DECLARE VARIABLE VARR VARCHAR(10);
DECLARE VARIABLE VARPR VARCHAR(10);
DECLARE VARIABLE NPPSTRUCT INTEGER;
DECLARE VARIABLE LVNAME VARCHAR(30);
DECLARE VARIABLE LVID INTEGER;
DECLARE VARIABLE CUR_SMETATYPE INTEGER;
DECLARE VARIABLE CUR_ID_OBJ INTEGER;
DECLARE VARIABLE AVAR VARCHAR(30);

declare variable current_vid integer;
declare variable res_cur_idname integer;

declare VAR_PREFIX integer;
begin

  VAR_PREFIX = 1; --[9456.R2]        

 var = '  ';

 varls = '';
 varr =  '';
 varpr = '';

 recidhier = null;

 if ( KODFIELD in ('V', 'I') )
 then
 begin

  if ( KODFIELD = 'V' )
  then
  begin

   -- MK CQ[14380, 12020]   number ( . )
   select s.idhier, /*s.number1, s.number2,*/ s.atype
   from a_smeta s
   where s.id = :id
   into :recidhier, /*:recnumber1, :recnumber2,*/ :rectype;

   -- MK CQ[14380, 12020] --->
   select first 1 v.number1, v.number2
   from a_smeta_view_num v
   where (v.id = :id)
   into :recnumber1, :recnumber2;
   -- MK CQ[14380, 12020] <---

   if ( recidhier is null )
   then
   begin

    suspend;

    exit;

   end

  end
  else if ( KODFIELD = 'I' )
       then
       begin

        select l.idhier, l.smetatype
        from a_lz l
        where l.id = :id
        into :recidhier, :cur_smetatype;

        if ( recidhier is null )
        then
        begin

         suspend;

         exit;

        end

        execute procedure a_h_get_id_parentatype( :recidhier, 1 ) returning_values ( :cur_id_obj );

        avar = null;

        /*if ( cur_smetatype in (21,23) )
        then cur_smetatype = 15;
        else cur_smetatype = 16;*/

        select l.avar, l.idname
        from a_lz l
        where l.id = :id
        into :avar, :res_cur_idname;

--declare variable current_vid integer;
--declare variable res_cur_idname integer;

        if (
            ( res_cur_idname > 0 ) and
            ( avar is null )
           )
        then
        begin

         current_vid = 200;

         select u.idlzgroup
         from b_user_access u
         where u.id = :iduser
         into :current_vid;

         select n.avar
         from a_lz_names n
         where ( n.idgroup = :current_vid ) and
               ( n.atype = :res_cur_idname )
         into :avar;

        end


/*        select l.avar
        from a_lz_select1 ( :iduser,
                            :cur_id_obj,
                            :cur_smetatype,
                            :cur_id_obj,
                            -1,
                            0,
                            0,
                            0,
                            1 ) l
        where l.id = :id
        into :avar;*/

/*        if ( avar is null )
        then exception ae_bl_wr3_rec_notfound;*/


        if ( cur_id_obj = recidhier or
             cur_smetatype = recidhier )
        then
        begin

         var = '..' || LCKUPPERVARCHAR( avar );
         suspend;

         exit;

        end

       end

  execute procedure a_f_get_visual_struct( :iduser, :recidhier )
          returning_values( :varls, :varr, :varpr );

  /*cur_atypehier = null;
  select h.atype, h.parent, h.number
  from a_o_hier h
  where h.number = :recidhier
  into :cur_atypehier, :cur_parent, :cur_number;

  if ( cur_atypehier is null )
  then exception a_elstructnotfound;
  else
  begin

   if ( cur_atypehier = 3 )
   then
   begin

    execute procedure a_h_getnumhier( :cur_number, :cur_parent )
            returning_values ( :nppstruct );
    varls = '' || nppstruct || '.';

   end
   else if ( cur_atypehier = 4 )
        then
        begin

         execute procedure a_h_getnumhier( :cur_number, :cur_parent )
                 returning_values ( :nppstruct );
         varr =  '' || nppstruct || '.';

         while ( cur_atypehier <> 3 and not cur_atypehier is null ) do
          select h.atype, h.parent, h.number
          from a_o_hier h
          where h.number = :cur_parent
          into :cur_atypehier, :cur_parent, :cur_number;

         if ( cur_atypehier = 3 )
         then
         begin

          execute procedure a_h_getnumhier( :cur_number, :cur_parent )
                  returning_values ( :nppstruct );
          varls = '' || nppstruct || '.';

         end
         else
         begin

          varls = '';
          varr =  '';
          varpr = '';

         end

        end
        else if ( cur_atypehier = 5 )
             then
             begin

              execute procedure a_h_getnumhier( :cur_number, :cur_parent )
                      returning_values ( :nppstruct );
              varpr =  '' || nppstruct || '.';

              while ( cur_atypehier <> 4 and not cur_atypehier is null ) do
               select h.atype, h.parent, h.number
               from a_o_hier h
               where h.number = :cur_parent
               into :cur_atypehier, :cur_parent, :cur_number;

              if ( cur_atypehier = 4 )
              then
              begin

               execute procedure a_h_getnumhier( :cur_number, :cur_parent )
                       returning_values ( :nppstruct );
               varr =  '' || nppstruct || '.';

               while ( cur_atypehier <> 3 and not cur_atypehier is null ) do
               select h.atype, h.parent, h.number
               from a_o_hier h
               where h.number = :cur_parent
               into :cur_atypehier, :cur_parent, :cur_number;

               if ( cur_atypehier = 3 )
               then
               begin

                execute procedure a_h_getnumhier( :cur_number, :cur_parent )
                        returning_values ( :nppstruct );
                varls = '' || nppstruct || '.';

               end
               else
               begin

                varls = '';
                varr =  '';
                varpr = '';

               end

              end
              else
              begin

               varls = '';
               varr =  '';
               varpr = '';

              end

             end
             else exception a_typeunknown1;

  end*/

  if ( varls <> '' )
  then
  begin

   if ( KODFIELD = 'V' )
   then
   begin

    if ( rectype = 17 )
    then var = varls || varr || varpr || kodfield || recnumber1;
    else if ( rectype = 18 )
         then var = varls || varr || varpr || kodfield || recnumber1 || '.' || recnumber2;
         else var = '';

   end
   else if ( KODFIELD = 'I' )
        then var = '.' || varls || varr || varpr || LCKUPPERVARCHAR( avar );

  end

 end
 else if ( KODFIELD = 'L' )
      then
      begin

       lvid = null;

       select l.id, case when :VAR_PREFIX <> 0 then '.' else '' end || l.name
       from a_s_lvars l
       where l.id = :id
       into :lvid, :lvname;

       if ( not ( lvid is null ) )
       then var = lvname;
       else --   :
       begin

         --[9456.R2] -   
         select case when :VAR_PREFIX <> 0 then '.' else '' end || G.NAME
           from GLOBAL_VARS G
           where G.ID=:ID
           into :VAR;

       end

      end
 else if ( KODFIELD = 'D' ) --TFS[32]
      then
      begin

        RECIDHIER = ID;
        if (exists(select *
                     from A_O_HIER h
                   where (h.NUMBER = :RECIDHIER)))
        then
        begin
          execute procedure A_H_GET_ID_PARENTATYPE(:RECIDHIER, 1)
            returning_values(:CUR_ID_OBJ);

          if (CUR_ID_OBJ = RECIDHIER) then
          begin
  
           VAR = '..';
           suspend;
  
           exit;
          end

          execute procedure a_f_get_visual_struct( :iduser, :recidhier )
               returning_values( :varls, :varr, :varpr );

          if (varLS <> '' ) then
            VAR = '.' || varLS || varR || varPR;
        
        end
      end

 suspend;

end^

--TFS[30],TFS[31]
create or alter procedure L_PR_COPY_LIMITIR (
    ID_OBJ integer,
    ID_PR integer,
    LYEAR integer,
    LMONTH integer,
    ID_USER integer)
returns (
    ID integer,
    OLD_ID integer,
    IDHIER integer,
    SMETATYPE_LAST_PR integer)
AS
DECLARE VARIABLE LZ_NUMBER INTEGER;
DECLARE VARIABLE LZ_IDNAME INTEGER;
DECLARE VARIABLE LZ_AVAR   VARCHAR(30);
DECLARE VARIABLE LZ_NAME   VARCHAR(255);
DECLARE VARIABLE LZ_FORMULA BLOB;
DECLARE VARIABLE LZ_ITOG    DOUBLE PRECISION;
DECLARE VARIABLE LZ_VID     INTEGER;
DECLARE VARIABLE LZ_NOTE    VARCHAR(255);
DECLARE VARIABLE LZ_APRINT  INTEGER;
DECLARE VARIABLE LZ_TYPE  INTEGER;
DECLARE VARIABLE NEW_IDHIER INTEGER;
DECLARE VARIABLE PRECIS INTEGER;
-- MK CQ[13927] --->
declare variable VN_HAVE_USER_ITOG integer;
declare variable VN_ID_TEMPLATE integer;
declare variable VN_TEMPLATE_NAME varchar(250);
declare variable VN_INFO integer;
-- MK CQ[13927] <---
begin
   SMETATYPE_LAST_PR = 15;

   for select NUMBER
       from a_o_hier_select_pr ( :id_user, :id_obj, :lyear, :lmonth )
       where NUMBER <> :ID_PR
       into SMETATYPE_LAST_PR
   do
       SMETATYPE_LAST_PR = SMETATYPE_LAST_PR;

--  for select NUMSTRUCT
--      from A_H_SELTREE ( :ID_USER , :id_obj , 0 , 0 ) h
--      where h.atype in (1,3,4,5)
--      into :IDHIER

--   for select NUMBER
--       from A_H_SELTREE_MODE ( :ID_USER , 1 , :id_obj , 1 , 0 ) h
--       into :IDHIER

   for select NUMBER
       from L_PR_COPY_LIMITIR_SELTREE ( :ID_USER , :id_obj , :SMETATYPE_LAST_PR )
       into :IDHIER
   do
   -- MK CQ[13927] --->
   begin
       VN_HAVE_USER_ITOG = 0;
   -- MK CQ[13927] <---

       if ( ( :IDHIER = :SMETATYPE_LAST_PR ) or ( :IDHIER = :id_obj ) ) then
         NEW_IDHIER = :ID_PR;
       else
         NEW_IDHIER = :IDHIER;

       --TFS[30],TFS[31]
       insert into A_LZ_DYNAMIC (
           IDHIER, SMETATYPE,
           AVAR, NOTE, APRINT)
         select
           :NEW_IDHIER, :ID_PR,
           AVAR, NOTE, APRINT
         from A_LZ_DYNAMIC
         where IDHIER = :IDHIER
           and SMETATYPE = :SMETATYPE_LAST_PR;

       for select lz.id, lz.number, lz.idname, lz.avar,
              lz.name, lz.formula, lz.itog, lz.vid, lz.note, lz.aprint, lz.ATYPE,
              lz.PRECIS
           from a_lz lz
           where lz.idhier = :idhier and lz.smetatype = :SMETATYPE_LAST_PR -->cq[4963] and lz.atype = 212
           order by lz.number
           into  :OLD_ID, :LZ_NUMBER, :LZ_IDNAME, :LZ_AVAR,
                 :LZ_NAME, :LZ_FORMULA, :LZ_ITOG, :LZ_VID, :LZ_NOTE, :LZ_APRINT, :LZ_TYPE,
                 :PRECIS
       do
       begin

           if ( ( not (LZ_FORMULA is null) ) and ( LckGetBlobLength ( LZ_FORMULA ) <> 0 ) ) then
              LZ_ITOG = 0; -- 3.3 CQ: 2662

           if (LZ_TYPE = 212) then
           begin
             VN_HAVE_USER_ITOG = 1; -- MK CQ[13927]

             execute procedure a_set_g_number_obg ( 1 ) returning_values ( :id );
             execute procedure am_lz_append ( :ID_USER , :id , :NEW_IDHIER, :ID_PR, 212,
               :LZ_NUMBER, :LZ_IDNAME, :LZ_AVAR,
               :LZ_NAME, :LZ_FORMULA, :LZ_ITOG, :LZ_VID, :LZ_APRINT, :LZ_NOTE, :PRECIS);
             suspend;
           end
           else
           begin -->cq[4963]
             ID = null;
             select lz.ID from A_LZ lz where (lz.IDHIER = :NEW_IDHIER) and (lz.SMETATYPE = :ID_PR) and (lz.ATYPE = :LZ_TYPE) into :ID;
             if (not ID is null) then
             begin
               update A_LZ lz
               set lz.APRINT = :LZ_APRINT,
                   lz.PRECIS = :PRECIS
               where lz.ID = :ID;
             end
           end

       end
   -- MK CQ[13927] --->
       --       
       if (VN_HAVE_USER_ITOG = 1) then
       begin
         --         
         for select u.id_template, u.template_name, u.info
         from A_LZ_TEMPLATE_USE u
         where (IDHIER = :IDHIER) and (SMETATYPE = :SMETATYPE_LAST_PR)
         into :VN_ID_TEMPLATE, :VN_TEMPLATE_NAME, :VN_INFO do
         begin
           --  -   
           insert into A_LZ_TEMPLATE_USE(IDHIER, SMETATYPE,
                                         ID_TEMPLATE, TEMPLATE_NAME, INFO)
           values (:NEW_IDHIER, :ID_PR,
                   :VN_ID_TEMPLATE, :VN_TEMPLATE_NAME, :VN_INFO);
         end
       end
   end
   -- MK CQ[13927] <---
end
^

--TFS[143]
create or alter procedure L_FILL_CCURRENT1_NL (
    IDNORMATIV integer,
    RABMAT integer,
    PODGROUP integer,
    ID_ZONE integer,
    ID_USER integer)
returns (
    ZONE_BA double precision,
    ZONE_BB double precision,
    ZONE_BC double precision,
    ZONE_BD double precision,
    ZONE_BE double precision,
    ISZONEFIND integer)
AS
begin
--zonecen:read(zero)
   /*
        ZONE_BA  ZONE_BB/ZONE_BC/ZONE_BE,     ,
          .      .   . 
        29, ,  
   */

   ZONE_BA = null;-- n-level 0.0;
   ZONE_BB = null;-- n-level 0.0;
   ZONE_BC = null;-- n-level 0.0;
   ZONE_BD = null;-- n-level 0.0;
   ZONE_BE = null;-- n-level 0.0;

   ISZONEFIND = 0;

   if ( ( id_zone <= 0 ) and ( id_zone <> -3 ) ) then
      exit;

   --if ( (id_zone = -3) AND ( (IDNORMATIV is null) or (IDNORMATIV=0) ) ) then
   -- [8459] -     ,     
   if ( IDNORMATIV is null or IDNORMATIV=0 ) then
      exit;

         if ( podgroup > 1 ) then
            if ( id_zone = -3 ) then
               for select CENA from b_abc_okp where id = :idnormativ into ZONE_BA
               do
                  ISZONEFIND = 1;
            else
               execute procedure B_READ_ZONE_ABC_TSENY(:ID_USER, :IDNORMATIV, :ID_ZONE)
                 returning_values :ZONE_BA, :ISZONEFIND;

         else

         if ( RABMAT <> 1 ) then
         begin
            if ( id_zone = -3 ) then
               for select BA , BB , BC , BD , BE
                   from b_rabmat where id = :idnormativ
                   into ZONE_BA , ZONE_BB , ZONE_BC , ZONE_BD , ZONE_BE
               do
                  ISZONEFIND = 1;
            else
               execute procedure B_READ_ZONE_RAB_TSENY(:ID_USER, :IDNORMATIV, :ID_ZONE)
                 returning_values :ZONE_BA, :ZONE_BB, :ZONE_BC, :ZONE_BD, :ZONE_BE, :ISZONEFIND;


            if ( ISZONEFIND <> 0 ) then
            begin
               if ( rabmat = 3 ) then
                  ZONE_BA = ZONE_BB;
               else if ( rabmat = 2 ) then
                  ZONE_BA = ZONE_BC;
               else if ( rabmat = 1 ) then
                  ZONE_BA = ZONE_BE;
            end
         end

         else /* rabmat = 1 */
            if ( id_zone = -3 ) then
               for select CENA from b_trud where id = :idnormativ into ZONE_BA
               do
                  ISZONEFIND = 1;
            else
               execute procedure B_READ_ZONE_TRUD_TSENY(:ID_USER, :IDNORMATIV, :ID_ZONE)
                 returning_values :ZONE_BA, :ISZONEFIND;

         if ( (:ID_ZONE <> -3) and --TFS[143]
            (ZONE_BA is null) and  --CQ[10815]
            (ZONE_BB is null) and (ZONE_BC is null) and
            (ZONE_BD is null) and (ZONE_BE is null)) then
           ISZONEFIND = 0;


         if ( ZONE_BA is null ) then
            ZONE_BA = 0;
         if ( ZONE_BB is null ) then
            ZONE_BB = 0;
         if ( ZONE_BC is null ) then
            ZONE_BC = 0;
         if ( ZONE_BD is null ) then
            ZONE_BD = 0.;
         if ( ZONE_BE is null ) then
            ZONE_BE = 0;

         if ( ( podgroup > 1 ) or ( rabmat = 1 ) ) then
            if ( rabmat = 3 ) then
               ZONE_BB = ZONE_BA;
            else if ( rabmat = 2 ) then
               ZONE_BC = ZONE_BA;
            else if ( rabmat = 1 ) then
               ZONE_BE = ZONE_BA;

end
^

--TFS[143]
create or alter procedure NL_CTRL_ENTER_SMREC (
    IDOBJECT integer,
    SMETATYPE integer,
    ID_USER integer,
    NEED_APPLY_INDEX integer,
    NEED_APPLY_FORMUL integer,
    SEARCH_PUNKTIND varchar(42),
    ID_SM_REC integer,
    IN_IDTR integer,
    IN_VRPZ integer,
    IN_RES_COPY_FORMULS integer,
    UPDATE_ALL_ACT integer)
returns (
    ID_LEVEL integer,
    RES_VC integer,
    RES_INDEX integer,
    ID_S_RES integer)
AS
DECLARE VARIABLE VN_TYPE_RAB INTEGER;
DECLARE VARIABLE VN_VID_RAB INTEGER;
DECLARE VARIABLE VN_ATYPE INTEGER;
DECLARE VARIABLE VN_RABMAT INTEGER;
DECLARE VARIABLE VN_IDHIER INTEGER;
DECLARE VARIABLE VN_IDNORMATIV INTEGER;
DECLARE VARIABLE VN_PODGROUP INTEGER;
DECLARE VARIABLE VN_PUNKTIND VARCHAR(42);
DECLARE VARIABLE VN_IDZONE INTEGER;

DECLARE VARIABLE VN_NORM_BA DOUBLE PRECISION;
DECLARE VARIABLE VN_NORM_BB DOUBLE PRECISION;
DECLARE VARIABLE VN_NORM_BC DOUBLE PRECISION;
DECLARE VARIABLE VN_NORM_BD DOUBLE PRECISION;
DECLARE VARIABLE VN_NORM_BE DOUBLE PRECISION;

DECLARE VARIABLE VN_BA DOUBLE PRECISION;
DECLARE VARIABLE VN_BB DOUBLE PRECISION;
DECLARE VARIABLE VN_BC DOUBLE PRECISION;
DECLARE VARIABLE VN_BD DOUBLE PRECISION;
DECLARE VARIABLE VN_BE DOUBLE PRECISION;

DECLARE VARIABLE VN_BF DOUBLE PRECISION;
DECLARE VARIABLE VN_BG DOUBLE PRECISION;
DECLARE VARIABLE VN_BH DOUBLE PRECISION;
DECLARE VARIABLE VN_BI DOUBLE PRECISION;
DECLARE VARIABLE VN_BJ DOUBLE PRECISION;

DECLARE VARIABLE VN_BN DOUBLE PRECISION;
DECLARE VARIABLE VN_BO DOUBLE PRECISION;
DECLARE VARIABLE VN_B_ITOGO DOUBLE PRECISION;

DECLARE VARIABLE VN_ID_LEVEL_VC INTEGER;
DECLARE VARIABLE VN_ID_LEVEL_INDEX INTEGER;
DECLARE VARIABLE VN_IDINDEX INTEGER;
DECLARE VARIABLE VN_MA DOUBLE PRECISION;
DECLARE VARIABLE VN_MB DOUBLE PRECISION;
DECLARE VARIABLE VN_MC DOUBLE PRECISION;
DECLARE VARIABLE VN_MD DOUBLE PRECISION;
DECLARE VARIABLE VN_ME DOUBLE PRECISION;
DECLARE VARIABLE VN_MF DOUBLE PRECISION;
DECLARE VARIABLE VN_MG DOUBLE PRECISION;
DECLARE VARIABLE VN_MH DOUBLE PRECISION;
DECLARE VARIABLE VN_MI DOUBLE PRECISION;
DECLARE VARIABLE VN_SPOSOB_RASCH INTEGER;

DECLARE VARIABLE VN_SLAVEPARENT INTEGER;
DECLARE VARIABLE VN_PA DOUBLE PRECISION;
DECLARE VARIABLE VN_PB DOUBLE PRECISION;
DECLARE VARIABLE VN_PC DOUBLE PRECISION;
DECLARE VARIABLE VN_PD DOUBLE PRECISION;

DECLARE VARIABLE LOCKED INTEGER;

DECLARE VARIABLE VN_IDSTRUCT INTEGER;
DECLARE VARIABLE VN_CALCBMASK INTEGER;

DECLARE VARIABLE ID_SM_REC_ACT INTEGER;

DECLARE VARIABLE VN_MJ DOUBLE PRECISION;
DECLARE VARIABLE VN_MK  DOUBLE PRECISION;
DECLARE VARIABLE VN_ML DOUBLE PRECISION;
DECLARE VARIABLE VN_MM DOUBLE PRECISION;
DECLARE VARIABLE VN_DA DOUBLE PRECISION;
DECLARE VARIABLE VN_DB DOUBLE PRECISION;
DECLARE VARIABLE VN_DC DOUBLE PRECISION;
DECLARE VARIABLE VN_DD DOUBLE PRECISION;
DECLARE VARIABLE VN_DE DOUBLE PRECISION;
DECLARE VARIABLE VN_DJ DOUBLE PRECISION;
DECLARE VARIABLE VN_DK  DOUBLE PRECISION;
DECLARE VARIABLE VN_DL DOUBLE PRECISION;
DECLARE VARIABLE VN_DM DOUBLE PRECISION;

declare variable VN_BASE_CALC_INFO integer;

--[14593]declare variable VN_IS_LIC_VC integer;
declare variable VN_USE_BA double precision;
declare variable VN_USE_BB double precision;
declare variable VN_USE_CURRCENA double precision;
declare variable VN_CURR_CENA_INFO integer;

--<[14353]>
declare VN_BB_OTP double precision; --</>

--<[14593]>
declare USE_MULTIRULES integer;
declare IDCLASS integer; --</>

--[15352]
declare VN_MMAT double precision;
declare VN_MOBORUD double precision;
declare VN_MGARB double precision;
declare VN_MGRUNT double precision;
declare VN_VGRUNT double precision;
declare VN_B_PR double precision;
declare VN_NORM_B_PR double precision;
declare VN_M_PR double precision;

--<[15662]>
declare APPLY_TO_ALL_IDLEVEL_SNB integer;
declare SOURCE_LEVEL_ID integer; --</>
BEGIN
--[15352]

  --     
  SELECT FIRST 1 s.tiprab, s.vidrab, s.atype, s.rabmat, s.idhier, s.idnormativ,
                 s.kodir_podgroup, s.ba, s.bb, s.bc, s.bd, s.be,
                 s.bn, s.bo, s.b_itogo, --CQ[TIMUR 13178]
                 s.MMAT, s.MOBORUD, s.MGARB, s.MGRUNT, s.VGRUNT, --[15352]
                 s.B_PR, --[15352]
                 s.bf, s.bg, s.bh, s.bi, s.bj, s.slaveparent, s.ID_S_RES
  FROM a_smeta s
  WHERE (s.id = :ID_SM_REC)
  INTO :VN_TYPE_RAB, :VN_VID_RAB, :VN_ATYPE, :VN_RABMAT, :VN_IDHIER, :VN_IDNORMATIV,
       :VN_PODGROUP, :VN_NORM_BA, :VN_NORM_BB, :VN_NORM_BC, :VN_NORM_BD, :VN_NORM_BE,
       :VN_BN, :VN_BO, :VN_B_ITOGO, --CQ[TIMUR 13178]
       :VN_MMAT, :VN_MOBORUD, :VN_MGARB, :VN_MGRUNT, :VN_VGRUNT, --[15352]
       :VN_NORM_B_PR, --[15352]
       :VN_BF, :VN_BG, :VN_BH, :VN_BI, :VN_BJ, :VN_SLAVEPARENT, :ID_S_RES;

  --   VN_Bx      ( ),
  --      .
  VN_IDZONE = 0; --. TFS[143]

  -- MK 26.08.2011 CQ[9435] --->
  IF (:SMETATYPE = 15) THEN
    VN_IDSTRUCT = :IDOBJECT;
  ELSE
    VN_IDSTRUCT = :SMETATYPE;
  -- MK 26.08.2011 CQ[9435] <---

  IDCLASS = CASE WHEN :SMETATYPE > 999 THEN :SMETATYPE ELSE :IDOBJECT END; --[14593]

  -- MK CQ[12365] --->
  --      (   )
  delete from a_smeta_cenlvl_base_formul f
  where (f.id = :ID_SM_REC);
  -- MK CQ[12365] <---


  --      
  FOR SELECT ID
  FROM LEVEL_COST
  WHERE (IDOBJECT = :VN_IDSTRUCT) -- CQ[9435] :IDOBJECT)
  --[AA5DC71D18EC]order by l.lorder
  INTO :ID_LEVEL DO
  BEGIN

    --        
    IF (:NEED_APPLY_FORMUL <> 0) THEN
    BEGIN
      --  , ,    (   )
      EXECUTE PROCEDURE A_S_GET_FORMUL_NRSPZU_NL_1 (:ID_USER, :VN_ATYPE, :VN_SLAVEPARENT,
          :IN_IDTR, :IN_VRPZ, :IN_RES_COPY_FORMULS, :ID_LEVEL)
      RETURNING_VALUES (:VN_PA, :VN_PB, :VN_PC, :VN_PD);
    END

    --      
    IF (:NEED_APPLY_INDEX <> 0) THEN
    BEGIN
      --       ,   
      --      (  )
      IF((:SEARCH_PUNKTIND IS NULL) OR (:SEARCH_PUNKTIND = '')) THEN
      BEGIN
        SELECT FIRST 1 c.punktind
        FROM a_smeta_indlvl c--CQ[10529]a_smeta_cenlvl c
        WHERE (c.id = :ID_SM_REC) AND (c.idcenlvl = :ID_LEVEL)
        INTO :VN_PUNKTIND;
      END
      ELSE
        VN_PUNKTIND = SEARCH_PUNKTIND;
    END
    --     
    -- (  "    "    )
    ELSE
      VN_PUNKTIND = NULL;

    --       
    IF (:NEED_APPLY_FORMUL = 0) THEN
    BEGIN
      --    , , 
      SELECT FIRST 1 c.pa, c.pb, c.pc, c.pd
      FROM a_smeta_cenlvl c
      WHERE (c.id = :ID_SM_REC) AND (c.idcenlvl = :ID_LEVEL)
      INTO :VN_PA, :VN_PB, :VN_PC, :VN_PD;

      -- MK CQ[12613] --->
      if ((VN_PC is null) or (VN_PC = 0)) then
        VN_PC = 1;
      if ((VN_PD is null) or (VN_PD = 0)) then
        VN_PD = 1;
      -- MK CQ[12613] <---
    END

    --            
    EXECUTE PROCEDURE NL_GET_CENLVL_NEW (:ID_LEVEL,
                                    :IDCLASS, --[14593]
                                    :ID_USER,
                                    :VN_TYPE_RAB,
                                    :VN_VID_RAB,
                                    :VN_ATYPE,
                                    :VN_RABMAT,
                                    :VN_IDHIER,
                                    :VN_IDNORMATIV,
                                    :VN_PODGROUP,
                                    :VN_PUNKTIND,
                                    0 /*TFS[143] :VN_IDZONE*/,
                                    :VN_NORM_BA,
                                    :VN_NORM_BB,
                                    :VN_NORM_BC,
                                    :VN_NORM_BD,
                                    :VN_NORM_BE,
                                    :VN_NORM_B_PR, --[15352]
                                    :ID_SM_REC,
                                    :NEED_APPLY_INDEX)
    RETURNING_VALUES (:VN_ID_LEVEL_VC,
                      :VN_IDZONE,
                      :VN_ID_LEVEL_INDEX,
                      :VN_IDINDEX,
                      :VN_BA, :VN_BB, :VN_BC, :VN_BD, :VN_BE,
                      :VN_B_PR, --[15352]
                      :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME, :VN_MF, :VN_MG, :VN_MH, :VN_MI,
                      :VN_MJ, :VN_MK, :VN_ML, :VN_MM, --CQ[10529]
                      :VN_M_PR, --[15352]
                      :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM,--CQ[10529]
                      :VN_PUNKTIND, :VN_SPOSOB_RASCH, :RES_VC, :RES_INDEX);


    -- MK 9.04.2013 CQ[11129] --->
    if (VN_ATYPE = 18) then
      execute procedure A_S_GET_NRSPZU_INDEX_NL_1(:ID_USER, :ID_SM_REC, :VN_PUNKTIND,
                                                  :VN_SLAVEPARENT, :ID_LEVEL, 2)
      returning_values(:VN_MF, :VN_MG, :VN_MH, :VN_MI);
    -- MK 9.04.2013 CQ[11129] <---


    -- MK 12.04.2012 CQ[10342] + 20.06.2012 CQ[10565] --->
    --     
    SELECT c.calcbmask, c.base_calc_info
    FROM a_smeta_cenlvl c
    WHERE (c.id = :ID_SM_REC) AND (c.idcenlvl = :ID_LEVEL)
    INTO :VN_CALCBMASK, :VN_BASE_CALC_INFO;

    --       
    VN_CALCBMASK = setbit(VN_CALCBMASK, 30, 0);
    VN_CALCBMASK = setbit(VN_CALCBMASK, 31, 0);

    -- MK 20.06.2012 CQ[10565]
    --     3,4 (      )
    -- MK CQ[13174] --->
    --   0..2
    VN_BASE_CALC_INFO = bin_and(VN_BASE_CALC_INFO, bin_xor(7/*cbCalcMask*/, -1)); -- bin_xor(7, -1) = 11111...11000
    --   5 (bciNeedRecalcItogoB)
    VN_BASE_CALC_INFO = setbit(VN_BASE_CALC_INFO, 5, 0);

    --VN_BASE_CALC_INFO = bin_and(VN_BASE_CALC_INFO, 24); -- 24 = 11000
    -- MK CQ[13174] <---
    VN_BASE_CALC_INFO = bin_or(VN_BASE_CALC_INFO, 3/*cbFromNB*/);   --    
    -- MK 12.04.2012 CQ[10342] <---

    -- MK CQ[11989] --->
    --   
    VN_USE_BA = VN_BA;
    VN_USE_BB = VN_BB;
    VN_USE_CURRCENA = 0;
    VN_CURR_CENA_INFO = null;

    SOURCE_LEVEL_ID = 0; --[15662]

    --  
    if (VN_RABMAT = 3) then -- [7FE7AD1744B6]
    begin
      --     
      if (VN_IDZONE > 0) then
      begin
        --      
        /*[14593]
        select first 1 LIC_VC
        from GET_VC_LIC_INFO(:VN_IDZONE)
        into :VN_IS_LIC_VC;*/
        execute procedure NL_COMPOSE_USE_MULTIRULES_VC(:VN_ID_LEVEL_VC, :VN_IDZONE)
            returning_values :USE_MULTIRULES;

        --    (   )
        --[14593]if (VN_IS_LIC_VC <> 0) then
        --    (), ..    
        if (:USE_MULTIRULES = 0) then
        begin
          VN_USE_BA = VN_NORM_BA;
          VN_USE_BB = VN_NORM_BB;
          VN_USE_CURRCENA = VN_BB;
          VN_CURR_CENA_INFO = 3; -- cciVC

          --<[15662]> [CCC9F17B]
          if (:VN_USE_BB = 0) then
          begin
            if (:SMETATYPE > 999) then
              select APPLY_TO_ALL_IDLEVEL_SNB from A_O_FACTPARAMS where NUMBER=:SMETATYPE into :APPLY_TO_ALL_IDLEVEL_SNB;
            else
              select APPLY_TO_ALL_IDLEVEL_SNB from A_O_OBJECTPARAMS where NUMBER=:IDOBJECT into :APPLY_TO_ALL_IDLEVEL_SNB;
            if (:APPLY_TO_ALL_IDLEVEL_SNB = :ID_LEVEL) then
              SOURCE_LEVEL_ID = -1/*cSourceLevel_ToAll*/;
          end
          --</>
        end

        begin -- [14353] (066)  05 -  
          VN_BASE_CALC_INFO = BIN_AND( :VN_BASE_CALC_INFO,
            BIN_XOR(64/*bciBBOtpFromSb*/, -1) );
        end
      end

      else
      if (BIN_AND(:VN_BASE_CALC_INFO, 64/*bciBBOtpFromSb*/) <> 0) then
      begin --<<[14353]     
        --    ...
        --  
        --select BB_OTP
        --  from B_RABMAT
        --  where ID = :VN_IDNORMATIV
        --  into :VN_BB_OTP;
        --if (:VN_BB_OTP <> 0) then
        --begin --  ,  
        --  VN_USE_CURRCENA = :VN_BB_OTP;
        --  VN_CURR_CENA_INFO = 4/*cciBBOtpFromSb*/;
        --  VN_BASE_CALC_INFO = BIN_OR( 1/*cbCalc*/,
        --    BIN_AND(:VN_BASE_CALC_INFO, BIN_XOR(7/*cbCalcMask*/, -1)) );
        --end
        --     
        --else
        begin --  
          VN_BASE_CALC_INFO = BIN_AND( :VN_BASE_CALC_INFO,
            BIN_XOR(64/*bciBBOtpFromSb*/, -1) );
        end
      end
    end
    -- MK CQ[11989] <---

    --        
    UPDATE a_smeta_cenlvl c
    SET c.idzone =            :VN_IDZONE,
        --CQ[10529]c.idindex =           :VN_IDINDEX,
        --CQ[10529]c.id_level_index =    :VN_ID_LEVEL_INDEX,
        c.id_level_vc =       :VN_ID_LEVEL_VC,
        c.ba =                :VN_USE_BA, -- MK CQ[11989] :VN_BA,
        c.bb =                :VN_USE_BB, -- MK CQ[11989] :VN_BB,
        c.bc =                :VN_BC,
        c.bd =                :VN_BD,
        c.be =                :VN_BE,
        c.bf =                :VN_BF,
        c.bg =                :VN_BG,
        c.bh =                :VN_BH,
        c.bi =                :VN_BI,
        c.bj =                :VN_BJ,
        --CQ[TIMUR 13178]
        c.bn =                :VN_BN,
        c.bo =                :VN_BO,
        c.b_itogo =           :VN_B_ITOGO,
        --CQ[TIMUR 13178]
        c.B_PR =              :VN_B_PR, --[15352]
        c.pa =                :VN_PA,
        c.pb =                :VN_PB,
        c.pc =                :VN_PC,
        c.pd =                :VN_PD,
        c.base_info =         :RES_VC,
        c.calcbmask =         :VN_CALCBMASK,     -- MK 12.04.2012 CQ[10342]

        -- MK 20.06.2012 CQ[10565] --->
        c.curr_cena =         :VN_USE_CURRCENA, -- MK CQ[11989] 0,
        c.base_calc_info =    :VN_BASE_CALC_INFO,
        c.source_level_id =   :SOURCE_LEVEL_ID, --[15662]
        -- MK 20.06.2012 CQ[10565] <---

        -- MK CQ[11989] --->
        c.CURR_CENA_INFO = :VN_CURR_CENA_INFO, -- MK CQ[11989] null,
        c.ID_VALUTE = 1,
        c.VALUTE_CURS = null,
        c.VALUTE_DATE = null

        -- MK CQ[13030]
        -- ,      . 
        --c.TRANSP = 0,
        --c.ZAG_SKL = 0,
        --c.ZAPCHAST = 0,
        --c.TARA = 0,
        --c.NACEN = 0,
        --c.COMPLECT = 0
        -- MK CQ[11989] <---



        /*--CQ[10529]c.punktind =          :VN_PUNKTIND,
        c.ma =                :VN_MA,
        c.mb =                :VN_MB,
        c.mc =                :VN_MC,
        c.md =                :VN_MD,
        c.me =                :VN_ME,
        c.mf =                :VN_MF,
        c.mg =                :VN_MG,
        c.mh =                :VN_MH,
        c.mi =                :VN_MI,
        c.index_sposobrasch = :VN_SPOSOB_RASCH,
        c.index_info =        :RES_INDEX,*/
    WHERE (c.id = :ID_SM_REC) AND (c.idcenlvl = :ID_LEVEL);

    --CQ[10529]>>
    UPDATE a_smeta_indlvl
    SET
        idindex =           :VN_IDINDEX,
        id_level_index =    :VN_ID_LEVEL_INDEX,
        punktind =          :VN_PUNKTIND,
        ma =                :VN_MA,
        mb =                :VN_MB,
        mc =                :VN_MC,
        md =                :VN_MD,
        me =                :VN_ME,
        mf =                :VN_MF,
        mg =                :VN_MG,
        mh =                :VN_MH,
        mi =                :VN_MI,
        MJ =                :VN_MJ,
        MK =                :VN_MK,
        ML =                :VN_ML,
        MM =                :VN_MM,
        M_PR =              :VN_M_PR, --[15352]
        DA =                :VN_DA,
        DB =                :VN_DB,
        DC =                :VN_DC,
        DD =                :VN_DD,
        DE =                :VN_DE,
        DJ =                :VN_DJ,
        DK =                :VN_DK,
        DL =                :VN_DL,
        DM =                :VN_DM,
        index_sposobrasch = :VN_SPOSOB_RASCH,
        index_info =        :RES_INDEX
    WHERE (id = :ID_SM_REC) AND (idcenlvl = :ID_LEVEL);

    IF (:NEED_APPLY_INDEX <> 0) THEN -- MK 3.08.2012 CQ[10695]
      EXECUTE PROCEDURE FILL_INDLVL_DESCR(:ID_SM_REC, :ID_LEVEL, :VN_ID_LEVEL_INDEX, :RES_INDEX); --CQ[10529]

    -- MK CQ[12483] --->
    --     
    if ((VN_ATYPE = 18) and (ID_S_RES is not null)) then
    begin
      --      
      update A_S_RES_CENLVL
      set CURR_BB =     null,
          CURR_BC =     null,
          CURR_BD =     null,
          CURR_BE =     null
      where (ID = :ID_S_RES) and (IDCENLVL = :ID_LEVEL);
    end
    -- MK CQ[12483] <---


    SUSPEND;

  END

  -- MK CQ[13030]       
  if ((VN_ATYPE in (17, 18)) and (VN_RABMAT = 3)) then
    execute procedure M_FILL_REC_KOEFFS(:ID_SM_REC);


  --   CQ[9282] -->
  IF (UPDATE_ALL_ACT = 1) THEN
    FOR SELECT ID, SMETATYPE, IDTIPR, VRPZ
    FROM A_SMETA
    WHERE NOMERROD = :ID_SM_REC
    INTO :ID_SM_REC_ACT,--CQ[10455]ID_SM_REC,
         :SMETATYPE, :IN_IDTR, :IN_VRPZ DO
    BEGIN
      FOR SELECT ID_LEVEL, RES_VC, RES_INDEX, ID_S_RES
      FROM NL_CTRL_ENTER_SMREC(:IDOBJECT,
                               :SMETATYPE,
                               :ID_USER,
                               :NEED_APPLY_INDEX,
                               :NEED_APPLY_FORMUL,
                               :SEARCH_PUNKTIND,
                               :ID_SM_REC_ACT,--CQ[10455]:ID_SM_REC,
                               :IN_IDTR,
                               :IN_VRPZ,
                               :IN_RES_COPY_FORMULS,
                               0)
      INTO :ID_LEVEL, :RES_VC, :RES_INDEX, :ID_S_RES
      DO
      BEGIN
        --   .
        EXECUTE PROCEDURE S_SET_DORECALC(NULL, SMETATYPE, 0, 1)
        RETURNING_VALUES :LOCKED;
      END
    END
END
^
/* TFS[29] >> */
/* 
create or alter procedure L_STR_SSR_READOBJS_2 (
*/
/* 
create or alter procedure L_STR_SSR_READOBJS_1 (
*/
create or alter procedure L_STR_SSR_READOBJS (
    ID_USER integer,
    ID_SELF integer,
    KOD integer,
    MODE integer,
    ONLY_OBJ integer,
    IN_LEVEL integer)
returns (
    NUMBER integer,
    PARENT integer,
    ID_TYPE smallint,
    SUBTYPE smallint,
    SORTING integer,
    COUNTCHILDREN integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    NUMGLSSR integer,
    OUT_LEVEL integer,
    DEF_KOD_SSR integer,
    NUMLSR_LS varchar(1024))
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
DECLARE VARIABLE KODSTROYKI INTEGER;
DECLARE VARIABLE KODDOG INTEGER;
DECLARE VARIABLE DO_SKIP INTEGER;
DECLARE VARIABLE IGNORE INTEGER;
DECLARE VARIABLE DUMMY INTEGER;
DECLARE VARIABLE ATYPE INTEGER;
begin

/*
   mode 0 -    
   mode 1 -    id_str_dog
   mode 2 -    
   mode 3 -    id_str_dog
   mode 4 -  

   mode 5 - .   // MK CQ[3427] 22.05.2006

   mode 83 -      
*/

  --CQ[TIMUR 9332]
  if (mode in (0,1,2,3)) then
    ATYPE = 0;
  else
    ATYPE = mode;



  EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, :ID_SELF, ATYPE)
  RETURNING_VALUES :ID_SELF;

  NUMBER = ID_SELF;
  For Select Number , Parent , aType , SubType , Sorting , CountChildren
      from a_o_hier where Parent = :ID_SELF
      order by sorting
      into :NUMBER , :PARENT , :ID_TYPE , :SUBTYPE , :SORTING , :CountChildren
  do
  begin
     OUT_LEVEL = IN_LEVEL;

     NUMGLSSR = 0;

     DO_SKIP = 0;
     IGNORE  = 0;
     DEF_KOD_SSR = null; --CQ[TIMUR 9078]
     DUMMY = NULL; --CQ[TIMUR 9556]

     NUMLSR_LS = null; -- TFS[29]

     /*  */
     IF (id_type = 0) THEN 
     BEGIN
        SELECT shifr, fullname, DEF_KOD_SSR --CQ[TIMUR 9078]
        FROM a_o_FolderParams
        WHERE number = :number
        INTO :shifr, :fullname, :DEF_KOD_SSR; --CQ[TIMUR 9078]

        if ( Only_Obj <> 0 ) then
           if ( not ( ( SUBTYPE is null ) or ( SUBTYPE = 0 ) ) ) then
              DO_SKIP = 1;
        if ( not ( ( SUBTYPE is null ) or ( SUBTYPE in (0,1,2,3,4) ) ) ) then
           DO_SKIP = 1;
     END
     /*  */
     ELSE IF ( (id_type = 1) or (id_type = -1)) THEN
     BEGIN
        SELECT shifr, fullname, KodStroyki, KodDog, NUMGLSSR
        FROM a_o_objectparams
        WHERE number = :number
        INTO :shifr, :fullname, :KodStroyki, :KodDog, :NUMGLSSR;

        if (MODE = 0) then
           if ( ( KodStroyki IS NULL ) or ( KodStroyki <= 0 ) ) then
              DO_SKIP = 0;
           else
           begin
              SELECT id_self FROM l_stroyki WHERE id_self = :KodStroyki into DUMMY;
              if ( DUMMY IS NULL ) then
                 DO_SKIP = 0;
              else
                 DO_SKIP = 1;
           end
        else if (MODE = 1) then
        begin
           if ( KodStroyki = KOD ) then
              DO_SKIP = 0;
           else
              DO_SKIP = 1;
        end
        else if (MODE = 2) then
           if ( ( KodDog IS NULL ) or ( KodDog <= 0 ) ) then
              DO_SKIP = 0;
           else
           begin
              SELECT id_self FROM l_stroyki WHERE id_self = :KodDog into DUMMY;
              if ( DUMMY IS NULL ) then
                 DO_SKIP = 0;
              else
                 DO_SKIP = 1;
           end
        else if (MODE = 3) then
        begin
           if ( KodDog = KOD ) then
              DO_SKIP = 0;
           else
              DO_SKIP = 1;
        end
        else if (MODE = 83) then --[9543]
        begin
           DO_SKIP = 1;

           select first 1 0
             from L_STR_GETNODEHIERARCHY(:KodStroyki)
             where ID_SELF = :KOD
             into :DO_SKIP;
        end
        else
           DO_SKIP = 0;
     END
     /* , ,  */
     ELSE IF ( (id_type IN (3,-3)) and ( Only_Obj = 0 ) ) THEN
     BEGIN
        SELECT shifr, fullname, NUMGLSSR,
        NUMLSR_LS -- TFS[29]
        FROM a_o_params_ls
        WHERE id = :number
        INTO :shifr, :fullname, :NUMGLSSR,
        :NUMLSR_LS; -- TFS[29]
     END
     ELSE IF ( (id_type IN (4,5,-4,-5)) and ( Only_Obj = 0 ) ) THEN
     BEGIN
        SELECT shifr, fullname, NUMGLSSR
        FROM a_o_params_r_pr
        WHERE id = :number
        INTO :shifr, :fullname, :NUMGLSSR;
     END
     ELSE
        DO_SKIP = 1;

     if ( DO_SKIP = 0 ) then
     begin
        if ( IGNORE = 0 ) then
           suspend;

        For Select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR,
            NUMLSR_LS -- TFS[29]
            from L_STR_SSR_READOBJS (:ID_USER, :number, :Kod, :Mode, :Only_Obj, :IN_LEVEL + 1 )
            into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR,
            :NUMLSR_LS -- TFS[29]
        do suspend;
     end
  end
end
^
create or alter procedure L_STR_SSR_READOBJS_1 (
    ID_USER integer,
    ID_SELF integer,
    KOD integer,
    MODE integer,
    ONLY_OBJ integer,
    IN_LEVEL integer)
returns (
    NUMBER integer,
    PARENT integer,
    ID_TYPE smallint,
    SUBTYPE smallint,
    SORTING integer,
    COUNTCHILDREN integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    NUMGLSSR integer,
    OUT_LEVEL integer,
    DEF_KOD_SSR integer,
    ID_TYPE_STROYKI integer,
    NUMLSR_LS varchar(1024))
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
DECLARE VARIABLE KODSTROYKI INTEGER;
DECLARE VARIABLE KODDOG INTEGER;
DECLARE VARIABLE DO_SKIP INTEGER;
DECLARE VARIABLE IGNORE INTEGER;
DECLARE VARIABLE DUMMY INTEGER;
DECLARE VARIABLE ATYPE INTEGER;

declare OBJECT_ROOT integer;
declare OBJECT_PARENT integer;
declare TMP_NUMBER integer;
declare TMP_PARENT integer;

declare variable vn_id integer;
begin

/*
   mode 0 -    
   mode 1 -    id_str_dog
   mode 2 -    
   mode 3 -    id_str_dog
   mode 4 -  

   mode 5 - .   // MK CQ[3427] 22.05.2006

   mode 83 -      
   mode 84 - ,    
   mode 85 -  ,        KOD  ( )
*/

  -- MK CQ[15112] --->
  if (MODE = 85) then
  begin
    EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, 0/**/, 1/**/) --   ,   -   0  1
    RETURNING_VALUES :OBJECT_ROOT;

    --  
    for select ID_SELF
    from L_STR_GETNODEHIERARCHY_1(:KOD)
    order by INV_LEVEL desc
    into :vn_id do
    begin
      NUMLSR_LS = null; -- TFS[29]
      --   
      if (vn_id = KOD) then
      begin
        --      
        for select NUMBER, PARENT, ID_TYPE, SUBTYPE, SORTING, COUNTCHILDREN,
                   SHIFR, FULLNAME, NUMGLSSR, OUT_LEVEL, DEF_KOD_SSR, ID_TYPE_STROYKI,
                   NUMLSR_LS -- TFS[29]
        from L_STR_SSR_READOBJS_2(:ID_USER, :vn_id, :KOD, 84, :ONLY_OBJ, :IN_LEVEL, :OBJECT_ROOT)
        into :NUMBER, :PARENT, :ID_TYPE, :SUBTYPE, :SORTING, :COUNTCHILDREN,
             :SHIFR, :FULLNAME, :NUMGLSSR, :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI,
             :NUMLSR_LS -- TFS[29]
        do
          suspend;
      end

      --    
      else
      begin
        NUMLSR_LS = null; -- TFS[29]
        --        
        select ID_SELF, ID_PARENT, 0, 0, 0, COUNTCHILDREN,
               SHIFR, NAME, 0, :IN_LEVEL, null, ID_TYPE
        from L_STROYKI
        where ID_SELF = :vn_id
          and ID_TYPE in (8/*ntsPrj*/,1/*ntsStr*/,2/*ntsOcher*/,3/*ntsPK*/,7/*ntsFolderStr*/)
        into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren,
             :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI;

        suspend;
        IN_LEVEL = IN_LEVEL + 1;
      end
    end


    exit;
  end
  -- MK CQ[15112] <---

  if (MODE = 84) then
  begin
    EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, 0/**/, 1/**/) --   ,   -   0  1
    RETURNING_VALUES :OBJECT_ROOT;

     --    ( )
    for select ID_SELF, ID_PARENT, 0/*ID_TYPE*/, 0/**/, 0/**/, COUNTCHILDREN, SHIFR, NAME, 0/**/, :IN_LEVEL, null/**/, ID_TYPE
        from L_STROYKI
        where ID_PARENT = :ID_SELF
          and ID_TYPE in (8/*ntsPrj*/,1/*ntsStr*/,2/*ntsOcher*/,3/*ntsPK*/,7/*ntsFolderStr*/)
        into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI
    do
    begin
        NUMLSR_LS = null; -- TFS[29]
        if (:NUMBER = :KOD or :PARENT = :KOD) then -- ,    (PARENT)  (NUMBER)  
        begin
          CountChildren = :COUNTCHILDREN + 1; --  
          suspend; --  

          TMP_NUMBER = :NUMBER; --           
          TMP_PARENT = :PARENT;

          --   ,   
          for select NUMBER
            from A_O_OBJECTPARAMS
            where KODSTROYKI = :TMP_NUMBER
            into :NUMBER
          do
          begin
            -- ,      "",
            -- .. PARENT   = :OBJECT_ROOT

            OBJECT_PARENT = NUMBER; --        
            while (OBJECT_PARENT is not null) do
            begin
              select min(PARENT)
                from A_O_HIER
                where NUMBER = :OBJECT_PARENT
                into :OBJECT_PARENT;

              if (:OBJECT_PARENT = :OBJECT_ROOT) then
              begin
                --   - 
                OUT_LEVEL = IN_LEVEL;

                NUMGLSSR = 0;

                DO_SKIP = 0;
                IGNORE  = 0;
                DEF_KOD_SSR = null; --CQ[TIMUR 9078]
                DUMMY = NULL; --CQ[TIMUR 9556]

                ID_TYPE_STROYKI = null;

                for SELECT first 1 shifr, fullname, KodStroyki, KodDog, NUMGLSSR, :IN_LEVEL + 1
                  FROM a_o_objectparams
                  WHERE number = :number
                  INTO :shifr, :fullname, :KodStroyki, :KodDog, :NUMGLSSR, :OUT_LEVEL
                do
                begin
                  ID_TYPE = 1; -- 
                  PARENT = TMP_NUMBER; --   
                  NUMLSR_LS = null; -- TFS[29]
                  suspend; -- 

                  for select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR,
                    NUMLSR_LS -- TFS[29]
                    from L_STR_SSR_READOBJS (:ID_USER, :number, :Kod, 1/*:Mode*/, :Only_Obj, :IN_LEVEL + 2 )
                    into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR,
                    :NUMLSR_LS -- TFS[29]
                  do
                  suspend; --  

                end
              end
            end

          end

          NUMBER = :TMP_NUMBER; --     
          PARENT = :TMP_PARENT;
        end
        else
          suspend; --   ,  


        --   
        for select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR, ID_TYPE_STROYKI,
          NUMLSR_LS -- TFS[29]
          from L_STR_SSR_READOBJS_1 (:ID_USER, :number, case when :NUMBER = :KOD or :PARENT = :KOD then :number else :Kod end, :Mode, :Only_Obj, :IN_LEVEL + 1 )
          into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI,
          :NUMLSR_LS --TFS[29]
        do
        suspend; --  

    end

    exit;
  end


  --     
  --  , ..            
  For Select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR
      from L_STR_SSR_READOBJS (:ID_USER, :ID_SELF, :Kod, :Mode, :Only_Obj, :IN_LEVEL )
      into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR
  do suspend;


end
^
create or alter procedure L_STR_SSR_READOBJS_2 (
    ID_USER integer,
    ID_SELF integer,
    KOD integer,
    MODE integer,
    ONLY_OBJ integer,
    IN_LEVEL integer,
    OBJECT_ROOT integer)
returns (
    NUMBER integer,
    PARENT integer,
    ID_TYPE smallint,
    SUBTYPE smallint,
    SORTING integer,
    COUNTCHILDREN integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    NUMGLSSR integer,
    OUT_LEVEL integer,
    DEF_KOD_SSR integer,
    ID_TYPE_STROYKI integer,
    NUMLSR_LS varchar(1024))
AS
DECLARE VARIABLE KODSTROYKI INTEGER;
DECLARE VARIABLE KODDOG INTEGER;
DECLARE VARIABLE DO_SKIP INTEGER;
DECLARE VARIABLE IGNORE INTEGER;
DECLARE VARIABLE DUMMY INTEGER;
DECLARE VARIABLE ATYPE INTEGER;

--declare OBJECT_ROOT integer;
declare OBJECT_PARENT integer;
declare TMP_NUMBER integer;
declare TMP_PARENT integer;
begin

  --      (,  , )
  for select ID_SELF, ID_PARENT, 0, 0, 0, COUNTCHILDREN,
             SHIFR, NAME, 0, :IN_LEVEL, null, ID_TYPE
  from L_STROYKI
  where ID_SELF = :ID_SELF
        and ID_TYPE in (8/*ntsPrj*/,1/*ntsStr*/,2/*ntsOcher*/,3/*ntsPK*/,7/*ntsFolderStr*/)
  into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren ,
       :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI
  do
  begin
      NUMLSR_LS = null; -- TFS[29]
      if (:NUMBER = :KOD or :PARENT = :KOD) then -- ,    (PARENT)  (NUMBER)  
      begin
        CountChildren = :COUNTCHILDREN + 1; --  
        suspend; --  

        TMP_NUMBER = :NUMBER; --           
        TMP_PARENT = :PARENT;

        --   ,   
        for select NUMBER
          from A_O_OBJECTPARAMS
          where KODSTROYKI = :TMP_NUMBER
          into :NUMBER
        do
        begin
          -- ,      "",
          -- .. PARENT   = :OBJECT_ROOT

          OBJECT_PARENT = NUMBER; --        
          while (OBJECT_PARENT is not null) do
          begin
            select min(PARENT)
              from A_O_HIER
              where NUMBER = :OBJECT_PARENT
              into :OBJECT_PARENT;

            if (:OBJECT_PARENT = :OBJECT_ROOT) then
            begin
              --   - 
              OUT_LEVEL = IN_LEVEL;

              NUMGLSSR = 0;

              DO_SKIP = 0;
              IGNORE  = 0;
              DEF_KOD_SSR = null; --CQ[TIMUR 9078]
              DUMMY = NULL; --CQ[TIMUR 9556]

              ID_TYPE_STROYKI = null;

              for SELECT first 1 shifr, fullname, KodStroyki, KodDog, NUMGLSSR, :IN_LEVEL + 1
                FROM a_o_objectparams
                WHERE number = :number
                INTO :shifr, :fullname, :KodStroyki, :KodDog, :NUMGLSSR, :OUT_LEVEL
              do
              begin
                ID_TYPE = 1; -- 
                PARENT = TMP_NUMBER; --   
                NUMLSR_LS = null; -- TFS[29]
                suspend; -- 

                for select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR,
                  NUMLSR_LS -- TFS[29]
                  from L_STR_SSR_READOBJS (:ID_USER, :number, :Kod, 1/*:Mode*/, :Only_Obj, :IN_LEVEL + 2 )
                  into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR,
                  :NUMLSR_LS -- TFS[29]
                do
                suspend; --  

              end
            end
          end

        end

        NUMBER = :TMP_NUMBER; --     
        PARENT = :TMP_PARENT;
      end
      else
        suspend; --   ,  


      --   
      for select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR, ID_TYPE_STROYKI,
        NUMLSR_LS -- TFS[29]
        from L_STR_SSR_READOBJS_1 (:ID_USER, :number, case when :NUMBER = :KOD or :PARENT = :KOD then :number else :Kod end, :Mode, :Only_Obj, :IN_LEVEL + 1)
        into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI,
        :NUMLSR_LS -- TFS[29]
      do
      suspend; --  

  end

end
^

--TFS[246]

create or alter procedure S__UP_B_RABMAT_TABSOOTV
as
begin

  if (not exists(
      select * from RDB$RELATIONS r
      where upper(r.RDB$RELATION_NAME) = 'B_RABMAT_TABSOOTV')) then
  begin

execute statement
'CREATE TABLE B_RABMAT_TABSOOTV ('||
'    IDREESTR  S_INTEGER /* S_INTEGER = INTEGER */,'||
'    TAB       S_VARCHAR42 /* S_VARCHAR42 = VARCHAR(42) */,'||
'    IDPAPKA   S_INTEGER /* S_INTEGER = INTEGER */,'||
'    TABU      S_VARCHAR42 /* S_VARCHAR42 = VARCHAR(42) */,'||
'    TABFROM   S_VARCHAR42 /* S_VARCHAR42 = VARCHAR(42) */,'||
'    TABUFROM  S_VARCHAR42 /* S_VARCHAR42 = VARCHAR(42) */'||
')';

execute statement
'ALTER TABLE B_RABMAT_TABSOOTV'||
' ADD CONSTRAINT FK_B_RABMAT_TABSOOTV_IDREESTR FOREIGN KEY (IDREESTR)'||
' REFERENCES B_REESTR (ID) ON DELETE CASCADE ON UPDATE CASCADE';

execute statement
'CREATE INDEX B_RABMAT_TABSOOTV_IDX_P_TABUFRO ON B_RABMAT_TABSOOTV (IDPAPKA, TABUFROM)';
execute statement
'CREATE INDEX B_RABMAT_TABSOOTV_IDX_R_TAB ON B_RABMAT_TABSOOTV (IDREESTR, TAB)';

  end
end
^

execute procedure S__UP_B_RABMAT_TABSOOTV
^

drop procedure S__UP_B_RABMAT_TABSOOTV
^

/* Trigger: B_RABMAT_TABSOOTV_BIU0 */
CREATE OR ALTER TRIGGER B_RABMAT_TABSOOTV_BIU0 FOR B_RABMAT_TABSOOTV
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
begin
--TFS[246]
  if (new.TAB <> '') then
    new.TABU = S_TRANSLITERATE_TAB(new.TAB);
  else
    new.TABU = new.TAB;
--TFS[246]
  if (new.TABFROM <> '') then
    new.TABUFROM = S_TRANSLITERATE_TAB(new.TABFROM);
  else
    new.TABUFROM = new.TABFROM;
--TFS[246]
  if (new.IDPAPKA is null or old.IDREESTR<>new.IDREESTR) then
    select IDPARENT from B_REESTR where ID=new.IDREESTR into new.IDPAPKA;
end
^

CREATE OR ALTER trigger B_REESTR_AU2 for B_REESTR
active after update position 2
AS
begin
--TFS[246]
  if (coalesce(old.IDPARENT,0) <> coalesce(new.IDPARENT,0)) then
    update B_RABMAT_TABSOOTV
      set IDPAPKA=new.IDPARENT
      where IDREESTR=new.ID;
end
^

--[TFS 248]
create or alter procedure L_FB_SEARCH_ID_IN_ONE_PUT (
    ID_PUT integer,
    IN_RABMAT integer,
    STAB varchar(42),
    FETCHMODE integer)
returns (
    ID_SELF integer,
    ID_ABC_OKP integer,
    BEDA integer)
AS
DECLARE VARIABLE PUTNAME_ID_SELF INTEGER;
DECLARE VARIABLE ID_REESTR INTEGER;
DECLARE VARIABLE ID_SBORNIK INTEGER;
DECLARE VARIABLE REESTR_CNT INTEGER;
DECLARE VARIABLE REESTR_PROCESS_CNT INTEGER;
DECLARE VARIABLE BAD_RASCEN_CNT INTEGER;
DECLARE VARIABLE IDABCOKP INTEGER;
DECLARE VARIABLE TABU1 VARCHAR(42);
DECLARE VARIABLE TABU2 VARCHAR(42);
DECLARE VARIABLE ORDERVIEW INTEGER;
declare STAB_8 varchar(42);
declare STAB_SOOTV varchar(42);
begin
   ID_SELF = 0;
   ID_SBORNIK = 0;
   ID_ABC_OKP = 0;
   beda = 0; /*     */

   if ( FETCHMODE is null ) then
      FETCHMODE = 0;

   if ( not ( in_rabmat in ( 0, 1, 2 , 3 ) ) ) then
   begin
      beda = 3; /*  rabmat */
      suspend;
      exit;
   end

   STAB_8 = S_TRANSLITERATE ( :STAB ); --[14280,12447]
   STAB = S_TRANSLITERATE_TAB ( STAB ); --[12447]

   /*  */
   if ( in_rabmat = 1 ) then
   begin
      for select ID, IDABCOKP , ORDERVIEW from b_trud t where t.tabu = :stab
          order by case when S_TRANSLITERATE(t.TAB)=:STAB_8 then 0 else t.ORDERVIEW end --[14280,12447]
          into :ID_SELF, :IDABCOKP, :ORDERVIEW
      do
      if ( not ORDERVIEW is null ) then /* if not in buffer */
      begin
         if ( ( IDABCOKP <> 0 ) and ( not ID_ABC_OKP is null ) ) then
            for select ID from b_abc_okp where id = :IDABCOKP
                into :IDABCOKP
            do
               ID_ABC_OKP = IDABCOKP;
         suspend;
         if ( FETCHMODE <> 1 ) then
            exit;
      end
      exit;
   end

   putname_id_self = null;
   select n.id from b_putname n where ( n.id = :id_put ) and
                                          /*  ( n.iduser = :id_user ) and */
                                          ( n.rabmat = :in_rabmat )
          into :putname_id_self;

   if ( putname_id_self is null ) then
   begin
      beda = 1; /*     */
      suspend;
      exit;
   end

   reestr_cnt = 0;
   reestr_process_cnt = 0;
   bad_rascen_cnt = 0;

   /*[15629] -   
   for select v.idreestr from b_putview v where ( v.idputname = :id_put )
                                          order by v.orderview
       into :id_reestr
   do
   begin
      reestr_cnt = reestr_cnt + 1;

      begin
        reestr_process_cnt = reestr_process_cnt + 1;
            for select id, idreestr, IDABCOKP, tabu
                from b_rabmat r where ( r.idpapka = :id_reestr ) and ( r.tabu = :stab )
                order by case when S_TRANSLITERATE(r.TAB)=:STAB_8 then 0 else r.ORDERVIEW end --[14280,12447]
                into :id_self, :ID_SBORNIK, :IDABCOKP, :TABU1
            do
            begin*/

   -->[15629]
   for select R.ID, R.IDREESTR, R.IDABCOKP, R.TABU
      from B_PUTVIEW P
      left join B_RABMAT R on (R.IDPAPKA=P.IDREESTR) and (R.TABU = :STAB)
    where (P.IDPUTNAME = :ID_PUT)
      and R.ID is not null
    order by case when S_TRANSLITERATE(R.TAB)=:STAB_8 then 0 else 1 end,
             P.ORDERVIEW, R.ORDERVIEW
   into :ID_SELF, :ID_SBORNIK, :IDABCOKP, :TABU1
   do
   --<[15629]
   begin
     reestr_cnt = reestr_cnt + 1;
     if (exists(select * from B_REESTR where ID=:ID_SBORNIK and IDPARENT>0)) then --[15160]
     begin
       if ( (IDABCOKP <> 0) and (not ID_ABC_OKP is null) ) then
         for select ID, COMMENT from B_ABC_OKP where ID = :IDABCOKP
           into :IDABCOKP, :TABU2
         do
           if ( (TABU2 is null) or (TABU2 = '') or (TABU1 = S_TRANSLITERATE_TAB(TABU2)) ) then --[12447]
             ID_ABC_OKP = IDABCOKP;

       suspend;

       if ( FETCHMODE <> 1 ) then
         exit;
     end
   end

   --TFS[248]
   for select R.ID, R.IDREESTR, R.IDABCOKP, R.TABU
     from B_PUTVIEW P
     left join B_RABMAT_TABSOOTV S on (S.IDPAPKA=P.IDREESTR) and (S.TABUFROM = :STAB)
     left join B_RABMAT R on R.IDREESTR=S.IDREESTR and R.TABU=S.TABU and R.TAB=S.TAB
   where (P.IDPUTNAME = :ID_PUT) and (R.ID is not null)
   order by case when S_TRANSLITERATE(S.TABFROM)=:STAB_8 then 0 else 1 end,
             P.ORDERVIEW, R.ORDERVIEW
   into :ID_SELF, :ID_SBORNIK, :IDABCOKP, :TABU1
   do
   begin
     reestr_cnt = reestr_cnt + 1;
     if (exists(select * from B_REESTR where ID=:ID_SBORNIK and IDPARENT>0)) then --[15160]
     begin
       if ( (IDABCOKP <> 0) and (not ID_ABC_OKP is null) ) then
         for select ID, COMMENT from B_ABC_OKP where ID = :IDABCOKP
           into :IDABCOKP, :TABU2
         do
           if ( (TABU2 is null) or (TABU2 = '') or (TABU1 = S_TRANSLITERATE_TAB(TABU2)) ) then --[12447]
             ID_ABC_OKP = IDABCOKP;

       suspend;

       if ( FETCHMODE <> 1 ) then
         exit;
     end
   end
   --TFS[248]

   /*    */

   ID_SBORNIK = 0;
   if ( reestr_cnt = 0 ) then
   begin
      beda = 2; /*    */
      suspend;
      exit;
   end
   if ( reestr_process_cnt = 0 ) then
   begin
      beda = 4; /*    ,      */
      suspend;
      exit;
   end
   if ( bad_rascen_cnt <> 0 ) then
   begin
      beda = 5; /*    ,     
                       rabmat,    rabmat   */
      suspend;
      exit;
   end

   suspend;
end
^


/* TFS[37] >> */
create or alter procedure M_READ_SMETA_TO_CACHE (
    IN_ID_OBJ integer,
    IN_SMETATYPE integer,
    IN_ID_USER integer,
    IDCENLVL integer)
returns (
    ID integer,
    IDHIER integer,
    NUMBER1 integer,
    NUMBER2 integer,
    ATYPE integer,
    VRPZ integer,
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
    RLM double precision,
    ITOGO double precision,
    RN double precision,
    RO double precision,
    RP double precision,
    R25 double precision,
    R26 double precision,
    R27 double precision,
    R28 double precision,
    R29 double precision,
    TIPRAB integer,
    VIDRAB integer,
    UTV integer,
    CLCMODE integer,
    R_PR double precision,
    RC_16 double precision,
    RE_16 double precision,
    RABMAT integer,
    CB double precision,
    CURR_CENA double precision,
    TRANSP double precision,
    ZAG_SKL double precision,
    ZAPCHAST double precision,
    TARA double precision,
    NACEN double precision,
    COMPLECT double precision,
    KOEFF_TYPE integer)
AS
declare variable vn_idhier integer;
declare variable vn_atype integer;
declare variable checknode integer;
declare variable hch_atype integer;
--CQ[10121]declare variable CLCMODE integer;   --CQ[TIMUR 9266]
declare variable P_CLCMODE integer; --CQ[TIMUR 9266]
--CQ[10121]declare variable SKIP_STR integer; --CQ[TIMUR 9266]
declare variable ORIGINAL_CLCMODE integer;
begin
--[15352]+
--[15479]
  for select NUMBER, ATYPE
  from L_H_SELTREE_HIER(:IN_ID_USER, :IN_ID_OBJ)
  into :vn_idhier, :vn_atype
  do
  begin
    --  
    ID = vn_idhier;
    IDHIER = vn_idhier;
    ATYPE = vn_atype;
    NUMBER1 = null; NUMBER2 = null; VRPZ = null; TIPRAB = null; VIDRAB = null;
    RA = null; RB = null; RC = null;  RD = null;  RE = null;  RF = null;  RG = null;
    RH = null; RI = null; RJ = null; RK = null; RL = null; RM = null; UTV = null;
    RLM = null; ITOGO = null;
    RN = null; RO = null; RP = null;
    R25 = null; R26 = null; R27 = null; R28 = null; R29 = null; --<<[12250]
    -- MK CQ[15102, 15103] --->
    RABMAT = null; CB = null; CURR_CENA = null;
    TRANSP = null; ZAG_SKL = null; ZAPCHAST = null;
    TARA = null; NACEN = null; COMPLECT = null; KOEFF_TYPE = null;
    -- MK CQ[15102, 15103] <---

    R_PR = null; RC_16 = null; RE_16 = null; --[15479]

    hch_atype = 15;
    if (:IN_SMETATYPE = 16) then hch_atype = 16;
    checknode = null;
    select hch.id
    from A_O_HIERCHECKING hch
    where (hch.iduser = :IN_ID_USER) and
          (hch.idobject = :IN_ID_OBJ) and
          (hch.smetatype = :IN_SMETATYPE) and
          (hch.atype = :hch_atype) and
          (hch.idelem = :vn_idhier)
    INTO :checknode;
    if (checknode is null) then ATYPE = -ATYPE;

    suspend;

    P_CLCMODE = 0;
    --     
    for select s.ID, s.NUMBER1, s.NUMBER2, s.ATYPE, s.VRPZ, s.RA, s.RB, s.RC,
               s.RD, s.RE, s.RF, s.RG, s.RH, s.RI, s.RJ, s.RK, s.RL, s.RM,
               s.RLM, s.ITOGO, s.RN, s.RO, s.RP,
               s.R25, s.R26, s.R27, s.R28, s.R29, --<<[12250]
               s.TIPRAB, s.VIDRAB, s.UTV,
               s.CLCMODE,
               -- MK CQ[15102, 15103] --->
               s.rabmat, s.cb, s.curr_cena, s.transp, s.zag_skl, s.zapchast,
               s.tara, s.nacen, s.complect, s.koeff_type,
               -- MK CQ[15102, 15103] <---
               s.R_PR, s.RC_16, s.RE_16 --[15479]
    from L_SC_READ_ONE_HIER_NL(:IN_SMETATYPE, :vn_idhier, :IN_ID_USER, :IDCENLVL) s
    order by s.NUMBER1, s.NUMBER2
    into :ID, :NUMBER1, :NUMBER2, :ATYPE, :VRPZ, :RA, :RB, :RC,
         :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM,
         :RLM, :ITOGO, :RN, :RO, :RP,
         :R25, :R26, :R27, :R28, :R29, --<<[12250]
         :TIPRAB, :VIDRAB, :UTV, :CLCMODE,
         -- MK CQ[15102, 15103] --->
         :RABMAT, :CB, :CURR_CENA, :TRANSP, :ZAG_SKL, :ZAPCHAST,
         :TARA, :NACEN, :COMPLECT, :KOEFF_TYPE,
         -- MK CQ[15102, 15103] <---
         :R_PR, :RC_16, :RE_16 --[15479]
    do
    begin
      --CQ[TIMUR 9266]

      if (ATYPE = 17) then  -- SmRec
        P_CLCMODE = CLCMODE;

      ORIGINAL_CLCMODE = CLCMODE; -- TFS[37]
      CLCMODE = P_CLCMODE; --CQ[10121]

      -- TFS[37] --> A_SMETA.CLCMODE  18-21
      -- :      (CQ[9266])   CLCMODE    
      --     CLCMODE,   1 ,     
      --     
      if ((ATYPE = 18) or (ATYPE = 19)) then -- ResRec, CommentRec
      begin
        CLCMODE = setbit(:CLCMODE, 18, getbit(ORIGINAL_CLCMODE, 18));
        CLCMODE = setbit(:CLCMODE, 19, getbit(ORIGINAL_CLCMODE, 19));
        CLCMODE = setbit(:CLCMODE, 20, getbit(ORIGINAL_CLCMODE, 20));
        CLCMODE = setbit(:CLCMODE, 21, getbit(ORIGINAL_CLCMODE, 21));
      end
      -- TFS[37] <--

      /*CQ[10121]
      SKIP_STR = GETBIT(:P_CLCMODE, 10);

      if (SKIP_STR <> 0) then
      begin
        RA = 0;
        RB = 0;
        RC = 0;
        RD = 0;
        RE = 0;
        RF = 0;
        RG = 0;
        RH = 0;
        RI = 0;
        RJ = 0;
        RK = 0;
        RL = 0;
        RM = 0;
        RLM = 0;
        ITOGO = 0;
        RN = 0;
        RO = 0;
        RP = 0;
      end   */
      --CQ[TIMUR 9266]

      suspend;
    end
  end
end
^








-- MK TFS[223]
create or alter procedure M_TEMP_CREATE_TABLE
AS
BEGIN

 if (not exists(select *
          from RDB$RELATIONS F
          where (upper(F.RDB$RELATION_NAME) = 'RM_REGION_CONTENTS')))
  then
  begin
  
    execute statement 'CREATE TABLE RM_REGION_CONTENTS ('  ||
                      'ID  A_INTEGERNOTNULL, ' ||
                      'ID_REGION A_INTEGERNOTNULL, ' ||
                      'ID_ENTITY A_INTEGER, ' ||
                      'ENTITY_TYPE A_INTEGER)';

    execute statement 'ALTER TABLE RM_REGION_CONTENTS ADD CONSTRAINT PK_RM_REGION_CONTENTS PRIMARY KEY (ID)';

    execute statement 'CREATE INDEX RM_REGION_CONTENTS_IDX1 ON RM_REGION_CONTENTS (ID_REGION, ID_ENTITY)';
    execute statement 'CREATE INDEX RM_REGION_CONTENTS_IDX2 ON RM_REGION_CONTENTS (ID_ENTITY)';
  end

END
^
execute procedure M_TEMP_CREATE_TABLE
^
drop procedure M_TEMP_CREATE_TABLE
^^



-- MK TFS[223]
create or alter procedure M_TEMP_CREATE_TABLE
AS
BEGIN

 if (not exists(select *
          from RDB$RELATIONS F
          where (upper(F.RDB$RELATION_NAME) = 'RM_ROLES')))
  then
  begin
  
    execute statement 'CREATE TABLE RM_ROLES ('  ||
                      'ID  A_INTEGERNOTNULL, ' ||
                      'NAME L_VARCHAR_512, ' ||
                      'DESCR A_MEMOTEXT)';

    execute statement 'ALTER TABLE RM_ROLES ADD CONSTRAINT PK_RM_ROLES PRIMARY KEY (ID)';

    execute statement 'CREATE INDEX RM_ROLES_IDX1 ON RM_ROLES (NAME)';
  end

END
^
execute procedure M_TEMP_CREATE_TABLE
^
drop procedure M_TEMP_CREATE_TABLE
^^



-- MK TFS[223]
create or alter procedure M_TEMP_CREATE_TABLE
AS
BEGIN

 if (not exists(select *
          from RDB$RELATIONS F
          where (upper(F.RDB$RELATION_NAME) = 'RM_SET_RIGHTS')))
  then
  begin
  
    execute statement 'CREATE TABLE RM_SET_RIGHTS ('  ||
                      'ID  A_INTEGERNOTNULL, ' ||
                      'ID_ROLE A_INTEGERNOTNULL, ' ||
                      'NAME L_VARCHAR_512, ' ||
                      'DESCR A_MEMOTEXT, ' ||
                      'DOSTUPSET S_VARCHAR16B)';

    execute statement 'ALTER TABLE RM_SET_RIGHTS ADD CONSTRAINT PK_RM_SET_RIGHTS PRIMARY KEY (ID)';

    execute statement 'CREATE INDEX RM_SET_RIGHTS_IDX1 ON RM_SET_RIGHTS (ID_ROLE)';
    execute statement 'CREATE INDEX RM_SET_RIGHTS_IDX2 ON RM_SET_RIGHTS (NAME)';
  end

END
^
execute procedure M_TEMP_CREATE_TABLE
^
drop procedure M_TEMP_CREATE_TABLE
^^



-- MK TFS[223]
create or alter procedure M_TEMP_CREATE_TABLE
AS
BEGIN

 if (not exists(select *
          from RDB$RELATIONS F
          where (upper(F.RDB$RELATION_NAME) = 'RM_ASSIGNED_ROLES')))
  then
  begin
  
    execute statement 'CREATE TABLE RM_ASSIGNED_ROLES ('  ||
                      'ID  A_INTEGERNOTNULL, ' ||
                      'ID_OWNER A_INTEGERNOTNULL, ' ||
                      'ID_ROLE A_INTEGER)';

    execute statement 'ALTER TABLE RM_ASSIGNED_ROLES ADD CONSTRAINT PK_RM_ASSIGNED_ROLES PRIMARY KEY (ID)';

    execute statement 'CREATE INDEX RM_ASSIGNED_ROLES_IDX1 ON RM_ASSIGNED_ROLES (ID_OWNER, ID_ROLE)';
    execute statement 'CREATE INDEX RM_ASSIGNED_ROLES_IDX2 ON RM_ASSIGNED_ROLES (ID_ROLE)';
  end

END
^
execute procedure M_TEMP_CREATE_TABLE
^
drop procedure M_TEMP_CREATE_TABLE
^^





-- MK TFS[223, 316]
create or alter procedure RM_GET_DOSTUP3 (
    ACTOR_ID integer,
    ACTION_ID integer,
    STRUCT_ID integer)
returns (
    IS_DOSTUP integer,
    IS_VIRTUAL integer)
AS
declare variable VN_ID_ENTITY integer;
declare variable VN_ID_PARENT_ENTITY integer;
declare variable VN_ID_SET_RIGHTS integer;
declare variable VN_DOSTUPSET varchar(16) character set OCTETS;
begin
  IS_DOSTUP = 0;
  IS_VIRTUAL = 0; --      


  --  "" -     +
  -- "" -    
  if ((STRUCT_ID = 517) or (ACTOR_ID = 10)) then
  begin
    IS_DOSTUP = 1;
  end
  else
  begin
    ----------------------------------------------------------------------------
    --   ,      
    if (STRUCT_ID <> -1) then
    begin
      --   -     , 
      --        
      --       
      if (ACTION_ID = 37) then -- 37 = DD_VIEW_OBJORFOLDER (. D_Dostup.pas)
      begin
        --    
        for select coalesce(rc.id_entity, 0)
        from RM_REGION_CONTENTS rc
        where (rc.id_region = :ACTOR_ID)
        into :VN_ID_ENTITY do
        begin
          while ((:VN_ID_ENTITY > 0) and (IS_DOSTUP = 0)) do
          begin
            if (VN_ID_ENTITY = STRUCT_ID) then
              IS_DOSTUP = 1;

            if (IS_DOSTUP = 0) then
            begin
              VN_ID_PARENT_ENTITY = null;
              select h.PARENT
              from A_O_HIER h
              where (h.NUMBER = :VN_ID_ENTITY) and
                    (h.PARENT <> :VN_ID_ENTITY) --   
              into :VN_ID_PARENT_ENTITY;
      
              VN_ID_ENTITY = coalesce(VN_ID_PARENT_ENTITY, 0);
            end
          end
        end

        --     ,  
        --        
        for select sr.id
        from RM_ASSIGNED_ROLES ar
        left join RM_SET_RIGHTS sr on (sr.id_role = ar.id_role)
        where (ar.id_owner = :ACTOR_ID) and (sr.id is not null)
        into :VN_ID_SET_RIGHTS do
        begin
          for select coalesce(rc.id_entity, 0)
          from RM_REGION_CONTENTS rc
          where (rc.id_region = :VN_ID_SET_RIGHTS)
          into :VN_ID_ENTITY do
          begin
            while ((:VN_ID_ENTITY > 0) and (IS_DOSTUP = 0)) do
            begin
              if (VN_ID_ENTITY = STRUCT_ID) then
                IS_DOSTUP = 1;

              if (IS_DOSTUP = 0) then
              begin
                VN_ID_PARENT_ENTITY = null;
                select h.PARENT
                from A_O_HIER h
                where (h.NUMBER = :VN_ID_ENTITY) and
                      (h.PARENT <> :VN_ID_ENTITY) --   
                into :VN_ID_PARENT_ENTITY;
    
                VN_ID_ENTITY = coalesce(VN_ID_PARENT_ENTITY, 0);
              end
            end
          end
        end
      end

      --    -  :
      --   
      if (IS_DOSTUP = 0) then
      begin
        --    ,      
        VN_ID_ENTITY = STRUCT_ID;
        while ((:VN_ID_ENTITY > 0) and (IS_DOSTUP = 0)) do
        begin
          if (exists
               (select * from RM_REGION_CONTENTS rc
                where (rc.id_region = :ACTOR_ID) and (rc.id_entity = :VN_ID_ENTITY)
               )
             ) then
    
            IS_DOSTUP = 1; --     -    
    
          --    ,       
          if (IS_DOSTUP = 0) then
          begin
            VN_ID_PARENT_ENTITY = null;
            select h.PARENT
            from A_O_HIER h
            where (h.NUMBER = :VN_ID_ENTITY) and
                  (h.PARENT <> :VN_ID_ENTITY) --   
            into :VN_ID_PARENT_ENTITY;
    
            VN_ID_ENTITY = coalesce(VN_ID_PARENT_ENTITY, 0);
          end

          --TFS[316]        
          -- ..   RM_GET_OPENED_ENTITYS
          if (:VN_ID_ENTITY in (517, 1)) then
            IS_DOSTUP = 1;
        end
      end
    end
  
    ----------------------------------------------------------------------------
    -- ,  
    --    -       
    if (IS_DOSTUP = 0) then
    begin
      --        
      for select sr.id, sr.dostupset
      from RM_ASSIGNED_ROLES ar
      left join RM_SET_RIGHTS sr on (sr.id_role = ar.id_role)
      where (ar.id_owner = :ACTOR_ID) and (sr.id is not null)
      into :VN_ID_SET_RIGHTS, :VN_DOSTUPSET do
      begin
  
        --        
        if (STRUCT_ID <> -1) then
        begin
          --    ,
          --       
          VN_ID_ENTITY = STRUCT_ID;
          while ((:VN_ID_ENTITY > 0) and (IS_DOSTUP = 0)) do
          begin
            if (exists
                 (select * from RM_REGION_CONTENTS rc
                  where (rc.id_region = :VN_ID_SET_RIGHTS) and (rc.id_entity = :VN_ID_ENTITY)
                 )
               ) then
            begin
              --      
              if (VN_DOSTUPSET is not null) then
                IS_DOSTUP = case when S_GETBIT(:VN_DOSTUPSET, :ACTION_ID) <> 0 then 1 else 0 end;
            end
      
            --    ,    
            --   
            if (IS_DOSTUP = 0) then
            begin
              VN_ID_PARENT_ENTITY = null;
              select h.PARENT
              from A_O_HIER h
              where (h.NUMBER = :VN_ID_ENTITY) and
                    (h.PARENT <> :VN_ID_ENTITY) --   
              into :VN_ID_PARENT_ENTITY;
  
              VN_ID_ENTITY = coalesce(VN_ID_PARENT_ENTITY, 0);
            end
          end
        end
  
        --         
        else
        begin
          --      
          if (VN_DOSTUPSET is not null) then
            IS_DOSTUP = case when S_GETBIT(:VN_DOSTUPSET, :ACTION_ID) <> 0 then 1 else 0 end;
        end
      end
    end
  end

  suspend;
end
^

-- MK TFS[223]
create or alter procedure GET_DOSTUP2 (
    ACTOR_ID integer,
    ACTION_ID integer,
    STRUCT_ID integer)
returns (
    IS_DOSTUP integer,
    IS_VIRTUAL integer)
AS
declare DOSTUPSET varchar(16) character set OCTETS;
begin
--  GET_DOSTUP

  -- MK TFS[223] --->
  --   PRIVILEGE_ROLE_MODEL
  if (exists (
        select * from B_USER_ACCESS
          where ID = ABS(:ACTOR_ID)
            and BIN_AND(PROJECT_MODES, 8/*pmTFS223mask*/) <> 0)
      ) then
  begin
    execute procedure rm_get_dostup3(:ACTOR_ID, :ACTION_ID, :STRUCT_ID)
    returning_values :IS_DOSTUP, :IS_VIRTUAL;
  end
  else
  -- MK TFS[223] <---
  begin
    execute procedure GET_DOSTUPSET(:ACTOR_ID, :STRUCT_ID)
        returning_values :DOSTUPSET, :IS_VIRTUAL;
  
    IS_DOSTUP = case when S_GETBIT(:DOSTUPSET, :ACTION_ID) <> 0 then 0 else 1 end;
  end

  suspend;
end
^

-- MK TFS[223]
create or alter procedure D_GET_DOSTUP2 (
    ACTOR_ID integer,
    ACTION_ID integer,
    STRUCT_ID integer)
returns (
    IS_DOSTUP integer,
    IS_VIRTUAL integer)
AS
declare DOSTUPSET varchar(16) character set OCTETS;
begin
--  D_GET_DOSTUP

  -- MK TFS[223] --->
  --   PRIVILEGE_ROLE_MODEL
  if (exists (
        select * from B_USER_ACCESS
          where ID = ABS(:ACTOR_ID)
            and BIN_AND(PROJECT_MODES, 8/*pmTFS223mask*/) <> 0)
      ) then
  begin
    execute procedure rm_get_dostup3(:ACTOR_ID, :ACTION_ID, :STRUCT_ID)
    returning_values :IS_DOSTUP, :IS_VIRTUAL;
  end
  else
  -- MK TFS[223] <---

  begin
    execute procedure D_GET_DOSTUPSET(:ACTOR_ID, :STRUCT_ID)
        returning_values :DOSTUPSET, :IS_VIRTUAL;
  
    IS_DOSTUP = case when S_GETBIT(:DOSTUPSET, :ACTION_ID) <> 0 then 0 else 1 end;
  end

  suspend;
end
^

-- MK TFS[223]
create or alter procedure RM_GET_REGION (
    ID_REGION integer)
returns (
    ENTITY_ID integer)
AS
declare variable VN_ENTITY_ID integer;
declare variable VN_ENTITY_TYPE integer;
begin
  --   
  for select rc.id_entity, rc.entity_type
  from RM_REGION_CONTENTS rc
  where (rc.id_region = :ID_REGION)
  into :VN_ENTITY_ID, :VN_ENTITY_TYPE do
  begin
    --    
    if (VN_ENTITY_TYPE = 0) then
    begin
      for select sf.IDHIER
      from V_SELECT_FOLDERS(:VN_ENTITY_ID) sf
      into :ENTITY_ID do
      begin
        --  
        suspend;

        --   
        VN_ENTITY_ID = ENTITY_ID;
        for select h.number
        from a_o_hier h
        where (h.parent = :VN_ENTITY_ID) and (h.atype = 1)
        into :ENTITY_ID do
        begin
          suspend;
        end
      end
    end
    --   
    else
    begin
      ENTITY_ID = VN_ENTITY_ID;
      suspend;
    end
  end
end
^

-- MK TFS[223]
create or alter procedure RM_GET_USER_UP_FOLDERS (
    ACTOR_ID integer)
returns (
    ENTITY_ID integer)
AS
declare variable VN_ID_ENTITY integer;
declare variable VN_ID_PARENT_ENTITY integer;
declare variable VN_ID_SET_RIGHTS integer;
begin
  --       
  --          
  ------------------------------------------------------------------------------

  --   
  for select coalesce(rc.id_entity, 0)
  from RM_REGION_CONTENTS rc
  where (rc.id_region = :ACTOR_ID)
  into :VN_ID_ENTITY do
  begin
    --    
    while (:VN_ID_ENTITY > 0) do
    begin
      VN_ID_PARENT_ENTITY = null;
      select h.PARENT
      from A_O_HIER h
      where (h.NUMBER = :VN_ID_ENTITY) and
            (h.PARENT <> :VN_ID_ENTITY) --   
      into :VN_ID_PARENT_ENTITY;

      VN_ID_ENTITY = coalesce(VN_ID_PARENT_ENTITY, 0);
      if (VN_ID_ENTITY > 0) then
      begin
        ENTITY_ID = VN_ID_ENTITY;
        suspend;
      end
    end
  end

  --         
  for select sr.id
  from RM_ASSIGNED_ROLES ar
  left join RM_SET_RIGHTS sr on (sr.id_role = ar.id_role)
  where (ar.id_owner = :ACTOR_ID) and (sr.id is not null)
  into :VN_ID_SET_RIGHTS do
  begin
    for select coalesce(rc.id_entity, 0)
    from RM_REGION_CONTENTS rc
    where (rc.id_region = :VN_ID_SET_RIGHTS)
    into :VN_ID_ENTITY do
    begin
      --    
      while (:VN_ID_ENTITY > 0) do
      begin
        VN_ID_PARENT_ENTITY = null;
        select h.PARENT
        from A_O_HIER h
        where (h.NUMBER = :VN_ID_ENTITY) and
              (h.PARENT <> :VN_ID_ENTITY) --   
        into :VN_ID_PARENT_ENTITY;

        VN_ID_ENTITY = coalesce(VN_ID_PARENT_ENTITY, 0);
        if (VN_ID_ENTITY > 0) then
        begin
          ENTITY_ID = VN_ID_ENTITY;
          suspend;
        end
      end
    end
  end
end
^

-- MK TFS[223]
create or alter procedure RM_IS_ENTITY_IN_REGION (
    ENTITY_ID integer,
    ID_REGION integer)
returns (
    IS_PART_OF integer)
AS
declare variable VN_ID_ENTITY integer;
declare variable VN_ID_PARENT_ENTITY integer;
begin
  IS_PART_OF = 0;

  --    ,      
  VN_ID_ENTITY = ENTITY_ID;
  while ((:VN_ID_ENTITY > 0) and (IS_PART_OF = 0)) do
  begin
    if (exists
         (select * from RM_REGION_CONTENTS rc
          where (rc.id_region = :ID_REGION) and (rc.id_entity = :VN_ID_ENTITY)
         )
       ) then

      IS_PART_OF = 1; --   

    --    ,       
    if (IS_PART_OF = 0) then
    begin
      VN_ID_PARENT_ENTITY = null;
      select h.PARENT
      from A_O_HIER h
      where (h.NUMBER = :VN_ID_ENTITY) and
            (h.PARENT <> :VN_ID_ENTITY) --   
      into :VN_ID_PARENT_ENTITY;

      VN_ID_ENTITY = coalesce(VN_ID_PARENT_ENTITY, 0);
    end
  end

  suspend;
end
^

-- MK TFS[223]
create or alter procedure RM_GET_ENTITY_CONTENT (
    IN_ENTITY_ID integer,
    IN_ENTITY_TYPE integer)
returns (
    ENTITY_ID integer,
    ENTITY_TYPE integer,
    PARENT integer,
    NAME varchar(1024))
AS
begin
  --    
  if (IN_ENTITY_TYPE = 0) then
  begin
    --  
    ENTITY_ID = :IN_ENTITY_ID;
    ENTITY_TYPE = :IN_ENTITY_TYPE;
    PARENT = 0;
    select f.fullname
    from a_o_folderparams f
    where (f.number = :ENTITY_ID)
    into :NAME;

    suspend;

    --    
    for select NUMBER, PARENT, ATYPE, FULLNAME
    from D_GET_OBJECTS_AND_FOLDERS(null, :ENTITY_ID)
    into :ENTITY_ID, :PARENT, :ENTITY_TYPE, :NAME do
    begin
      suspend;
    end
  end
  --   
  else if (IN_ENTITY_TYPE = 1) then
  begin
    ENTITY_ID = :IN_ENTITY_ID;
    ENTITY_TYPE = :IN_ENTITY_TYPE;
    PARENT = 0;
    select o.fullname
    from a_o_objectparams o
    where (o.number = :ENTITY_ID)
    into :NAME;

    suspend;
  end
end
^

-- MK TFS[223]
create or alter procedure RM_ADD_USER (
    IDUSER integer,
    NAME varchar(50),
    PSW varchar(10),
    ID_GROUP integer,
    FULLNAME varchar(100),
    DESCRIPTION varchar(250),
    CREATE_WORK_REGION integer)
returns (
    ID integer)
AS
declare variable VN_GROUP_FOLDER_ID integer;
declare variable VN_USER_FOLDER_ID integer;
declare variable VN_ID_ROLE integer;
begin
  --    
  execute procedure B_ADD_USER(:IDUSER, :NAME, :PSW, :ID_GROUP, :FULLNAME, :DESCRIPTION)
  returning_values :ID;

  --    (  )
  if (ID > 0) then
  begin
    CREATE_WORK_REGION = coalesce(CREATE_WORK_REGION, 0);
    ID_GROUP = coalesce(ID_GROUP, 0);
  
    --        
    if ((CREATE_WORK_REGION <> 0) and (ID_GROUP > 0)) then
    begin
      --   
      VN_GROUP_FOLDER_ID = null;
      select first 1 rc.ID_ENTITY
      from RM_REGION_CONTENTS rc
      where (rc.ID_REGION = :ID_GROUP) and (rc.ENTITY_TYPE = 0)
      into :VN_GROUP_FOLDER_ID;
  
      --      
      if ((VN_GROUP_FOLDER_ID is not null) and
          exists(select * from a_o_hier h where (h.number = :VN_GROUP_FOLDER_ID) and (h.atype = 0))
         ) then
      begin
        --   
        execute procedure D_CREATE_HIER_FOLDER(:IDUSER, :VN_GROUP_FOLDER_ID, :NAME, 0)
        returning_values :VN_USER_FOLDER_ID;

        --      
        insert into RM_REGION_CONTENTS(ID, ID_REGION, ID_ENTITY, ENTITY_TYPE)
        values (gen_id(A_G_SMETA, 1), :ID, :VN_USER_FOLDER_ID, 0);
      end
    end

    --      (      )
    if (ID_GROUP > 0) then
    begin
      --      
      for select ar.id_role
      from RM_ASSIGNED_ROLES ar
      where (ar.id_owner = :ID_GROUP)
      into :VN_ID_ROLE do
      begin
        --      
        insert into RM_ASSIGNED_ROLES(ID, ID_OWNER, ID_ROLE)
        values(gen_id(A_G_SMETA, 1), :ID, :VN_ID_ROLE);
      end
    end
  end

  suspend;
end
^


-- MK TFS[223]
CREATE OR ALTER TRIGGER B_USER_GROUPS_BD1 FOR B_USER_GROUPS
ACTIVE BEFORE DELETE POSITION 0
as
begin
  -- TFS[223]
  delete from RM_REGION_CONTENTS where ID_REGION = old.id;
  delete from RM_ASSIGNED_ROLES where ID_OWNER = old.id;
end
^

-- MK TFS[223]
CREATE OR ALTER TRIGGER B_USER_ACCESS_BD1 FOR B_USER_ACCESS
ACTIVE BEFORE DELETE POSITION 0
as
begin
  -- TFS[223]
  delete from RM_REGION_CONTENTS where ID_REGION = old.id;
  delete from RM_ASSIGNED_ROLES where ID_OWNER = old.id;
end
^

-- MK TFS[223]
CREATE OR ALTER TRIGGER RM_SET_RIGHTS_BD1 FOR RM_SET_RIGHTS
ACTIVE BEFORE DELETE POSITION 0
as
begin
  -- TFS[223]
  delete from RM_REGION_CONTENTS where ID_REGION = old.id;
end
^

-- MK TFS[223]
CREATE OR ALTER TRIGGER A_O_HIER_BD1 FOR A_O_HIER
ACTIVE BEFORE DELETE POSITION 0
as
begin
  -- TFS[223]
  delete from RM_REGION_CONTENTS where ID_ENTITY = old.number;
end
^

-- MK TFS[223]
CREATE OR ALTER TRIGGER RM_ROLES_BD1 FOR RM_ROLES
ACTIVE BEFORE DELETE POSITION 0
as
begin
  -- TFS[223]
  delete from RM_SET_RIGHTS where ID_ROLE = old.id;
  delete from RM_ASSIGNED_ROLES where ID_ROLE = old.id;
end
^



--TFS[249]
create or alter procedure A_S_ADD_RES_NL_2 (
    IDUSER integer,
    ID_SOURCE integer,
    AGROUP integer,
    APODGROUP integer,
    ID_ZONE integer,
    ZAMEN integer,
    INSERT_ALL integer,
    INSERT_SLAVE integer,
    RES_APPLY_TAB integer,
    SM_REC_IDNORMATIV integer,
    SM_REC_KODIR_PODGROUP integer,
    SM_REC_RABMAT integer,
    SM_REC_IDHIER integer,
    SM_REC_SMETATYPE integer,
    IDLIST blob sub_type 0 segment size 80,
    IDLIST_COUNT integer,
    MODE integer,
    APPLY_POPR_MODE integer,
    PASTE_AS_IS integer)
returns (
    ADDED_RES integer,
    ADDED_SLAVE integer,
    ADDEDID integer,
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
    OUT_SMETATYPE integer,
    DELETED_SLAVE integer,
    OUT_IDFORMULS integer)
AS
/* --[12309]
    OUT_SEA blob sub_type 0 segment size 80,
    OUT_SEB blob sub_type 0 segment size 80,
    OUT_SEC blob sub_type 0 segment size 80,
    OUT_SED blob sub_type 0 segment size 80,
    OUT_SEE blob sub_type 0 segment size 80,
    OUT_SEF blob sub_type 0 segment size 80,
    OUT_SEG blob sub_type 0 segment size 80,
    OUT_SEH blob sub_type 0 segment size 80,
    OUT_SEI blob sub_type 0 segment size 80,
    OUT_SEJ blob sub_type 0 segment size 80,
    OUT_SEK blob sub_type 0 segment size 80,
    OUT_SRA blob sub_type 0 segment size 80,
    OUT_SRB blob sub_type 0 segment size 80,
    OUT_SRC blob sub_type 0 segment size 80,
    OUT_SRD blob sub_type 0 segment size 80,
    OUT_SRE blob sub_type 0 segment size 80,
    OUT_SRF blob sub_type 0 segment size 80,
    OUT_SRG blob sub_type 0 segment size 80,
    OUT_SRH blob sub_type 0 segment size 80,
    OUT_SRI blob sub_type 0 segment size 80,
    OUT_SRJ blob sub_type 0 segment size 80,
    OUT_SRK blob sub_type 0 segment size 80,
    OUT_SRL blob sub_type 0 segment size 80,
    OUT_SRM blob sub_type 0 segment size 80,
*/
declare variable SEARCH_ID_SELF integer;
declare variable SEARCH_PODGROUP integer;
declare variable SEARCH_RABMAT integer;
declare variable SEARCH_TAB varchar(42);
declare variable SEARCH_ALTTAB varchar(250);
declare variable SEARCH_IDNAME integer;
declare variable SEARCH_IDEDIZM integer;
declare variable SEARCH_NORMA_RASH double precision;
declare variable SEARCH_CCURRENT_BB double precision;
declare variable SEARCH_CCURRENT_BC double precision;
declare variable SEARCH_CCURRENT_BD double precision;
declare variable SEARCH_CCURRENT_BE double precision;
declare variable SEARCH_RES_VIDNR integer;
declare variable SEARCH_RES_UCH integer;
declare variable SEARCH_CCURRENT_ZONE integer;
declare variable SEARCH_BB double precision;
declare variable SEARCH_BC double precision;
declare variable SEARCH_BD double precision;
declare variable SEARCH_BE double precision;
declare variable SEARCH_ABC_OKP_ISGROUPOKP integer;
declare variable RESULT_BB double precision;
declare variable RESULT_BC double precision;
declare variable RESULT_BD double precision;
declare variable RESULT_BE double precision;
declare variable CUR_ID_RES integer;
declare variable RESULT_ADDED_SLAVE integer;
declare variable SEARCH_COMMENT varchar(42);
declare variable RES_APPLY_TAB_FOR_VALERA integer;
declare variable SEARCH_ID_ABC_OKP integer;
declare variable SEARCH_ABC_OKP_IDPODGROUP integer;
declare variable SEARCH_ABC_OKP_ID_NAME integer;
declare variable SEARCH_ABC_OKP_TAB varchar(42);
declare variable SEARCH_ABC_OKP_IDEDIZM integer;
declare variable SEARCH_ABC_OKP_CENA double precision;
declare variable SEARCH_ABC_OKP_CCURRENT double precision;
declare variable SEARCH_NORM_GUID varchar(100);
declare variable SEARCH_TYPE_TRUD integer;
declare variable ISCLC integer;
declare variable STATUS_DOB_V_ZENU integer;
declare variable P_KODIR_PODGROUP integer;
declare variable P_PUT_ID_RAB integer;
declare variable P_PUT_ID_MASH integer;
declare variable P_PUT_ID_MAT integer;
declare variable P_ID_ZONE integer;
declare variable CUR_STATUS_REC_CEN integer;
declare variable ET_SEARCH_ID_SELF integer;
declare variable ET_SEARCH_PODGROUP integer;
declare variable ET_SEARCH_RABMAT integer;
declare variable ET_SEARCH_ALTTAB varchar(250);
declare variable ET_SEARCH_IDNAME integer;
declare variable ET_SEARCH_IDEDIZM integer;
declare variable ET_RESULT_BB double precision;
declare variable ET_RESULT_BC double precision;
declare variable ET_RESULT_BD double precision;
declare variable ET_RESULT_BE double precision;
declare variable ET_SEARCH_NORM_GUID varchar(100);
declare variable SM_ID integer;
declare variable DOB_UCH integer;
declare variable DOB_NEUCH integer;
declare variable RES_RECALL integer;
declare variable SM_REC_CLCMODE integer;
declare variable H_ATYPE integer;
declare variable H_NUMBER integer;
declare variable SM_BA double precision;
declare variable SM_BB double precision;
declare variable SM_BC double precision;
declare variable SM_BD double precision;
declare variable SM_BE double precision;
declare variable DELETED_RES integer;
--declare variable NOZONEMODE integer;
declare variable IN_ID_ZONE integer;
declare variable MIN_SLAVEPARENT_ID integer;
--CQ[9273]>>
--declare variable IDNORMATIVUNIQ integer;
--declare variable PUNKTIND varchar(42);
declare variable VRPZ integer;
declare variable NEEDUPDCOST integer;

declare variable iMODE_KOMPNS_ST integer;
declare variable iMatResToSlave integer;
declare variable iNotUchResToSlave integer;
declare variable iAllResToSlave integer;
declare variable iRABMAT integer;

--[12309]
declare RES_SEARCH_OTHER_BASE integer;
declare SM_REC_IDNORMATIV_NEW integer;
declare TAB_TRUD_SUFFIX varchar(10);
declare R_IDPUT_MASH integer;
declare R_IDPUT_MAT integer;
declare R_IDFOLDER integer;
declare LEAVE_HANDMAID integer; --TFS[249]
begin
--  A_S_ADD_RES_NL,  . . [12309,12380]
  /*
  :LEAVE_HANDMAID --TFS[249]
    0 -  
    1 -  ,     (  )

   MODE:
      0 -  +  
      1 -   
      2 -   

   rvs:2007/01/30 -  --->>         <<---   [1EA78E6C027D]
        ID- (IDLIST + IDLIST_COUNT)
     , ,     2.3   
            
            , 
              .
       ,   ID-,  
               
       
*/

/* 2014/06/24 -  :
    :AGROUP     == A_O_OBJECTPARAMS.KODIR_GROUP
    :APODGROUP  == A_O_OBJECTPARAMS.KODIR_PODGROUP
    :ID_ZONE       7.0
    :ZAMEN (*)  == A_O_OBJECTPARAMS.NE_OBNUL_RES
    :INSERT_ALL == (A_O_OBJECTPARAMS.RES_TOLKO_NEUCHT_RES = 0)
    :INSERT_SLAVE == A_O_OBJECTPARAMS.RES_ZANOSIT_S_RES
    :RES_APPLY_TAB == A_O_OBJECTPARAMS.RES_APPLY_TAB
    :SM_REC_*
    :IDLIST
    :IDLIST_COUNT
    :APPLY_POPR_MODE  = -  
    :PASTE_AS_IS -    (NL_GET_CENLVL_NEW) -  
*/

/* (*)
    :ZAMEN -     ,   ,
               ""     
             (     )
     0 == A_O_OBJECTPARAMS.NE_OBNUL_RES ( )
     1 [12309] -     -2001 .2014
                   (. L_FB_READ_RES_SEARCH_OTHER_BASE)
                         
     2 TFS[249] - [9AF9923D] . 
                 ,    
*/
  LEAVE_HANDMAID = GETBIT(coalesce(:ZAMEN, 0), 2); --TFS[249] [9AF9923D]
  RES_SEARCH_OTHER_BASE = GETBIT(coalesce(:ZAMEN, 0), 1);
  ZAMEN = GETBIT(coalesce(:ZAMEN, 0), 0);

  --zonecen:read(zero)
  --zonecen:(used in L_S_APPENDREC)

  -- MK 12.09.2007         
  --        .
  --    (0),        
  MIN_SLAVEPARENT_ID = 0;

  ADDED_RES = 0;
  ADDED_SLAVE = 0;
  RESULT_ADDED_SLAVE = 0;

  RA = 0;
  RB = 0;
  RC = 0;
  RD = 0;
  RE = 0;
  RF = 0;
  RG = 0;
  RH = 0;
  RI = 0;
  RJ = 0;
  RK = 0;
  RL = 0;
  RM = 0;

  /* OUT_Sxx = null   */

  /*    ,     -   */
  --<rvs:2006/08/15> -  ,      [0DEA78317B39]
  --if ( not exists (select *
  --                 from a_smeta s
  --                 where s.id = :id_source) )
  --then exception ae_recordnotfound1;
  begin
    select ID,
           coalesce(nullif(:SM_REC_IDNORMATIV, 0), IDNORMATIV),
           coalesce(nullif(:SM_REC_KODIR_PODGROUP, 0), KODIR_PODGROUP),
           coalesce(:SM_REC_RABMAT, RABMAT),
           coalesce(nullif(:SM_REC_IDHIER, 0), IDHIER),
           coalesce(nullif(:SM_REC_SMETATYPE, 0), SMETATYPE),
           coalesce(CLCMODE, 0), BA, BB, BC, BD,
           BE
    from A_SMETA
    where ID = :ID_SOURCE
    into :SM_ID, :SM_REC_IDNORMATIV,
         :SM_REC_KODIR_PODGROUP, :SM_REC_RABMAT,
         :SM_REC_IDHIER, :SM_REC_SMETATYPE,
         :SM_REC_CLCMODE, :SM_BA, :SM_BB, :SM_BC,
         :SM_BD, :SM_BE;
    if (:SM_ID is null) then
      exception AE_RECORDNOTFOUND1;
  end
  --</rvs:2006/08/15>

  -- MK 19.10.2006  CQ[3021]    CQ[3934] --->

  /*CQ[9273]-->????????????
  :          
  execute procedure D_GET_NOZONEMODE(:SM_REC_IDHIER,
      :SM_REC_SMETATYPE)
      returning_values :NOZONEMODE;
  IN_ID_ZONE = ID_ZONE;
  if (NOZONEMODE = 1) then
    ID_ZONE = 0;  <--CQ[9273]*/
  ID_ZONE = 0; --CQ[9273]       
  -- MK 19.10.2006 <---

  /*        */
  if (exists(select *
             from A_S_RES R
             where R.ID_SOURCE = :ID_SOURCE)) then
  begin

    /* zamen -      NE_OBNUL_RES   
      (        (0-)) */
    if (ZAMEN = 1) then
    begin
      /*     */
      if (MODE = 1) then
      begin
        suspend;
        exit;
      end

      /*       */
      if (MODE = 0) then
        MODE = 2;
    end

    /*           ID,  
             kodir_group  kodir_podgroup */
    else
    if (:IDLIST is null or coalesce(:IDLIST_COUNT, 0) <= 0) then --DEN     
    begin
      --[1EA78E6C027D]
      if (MODE <> 2) then
      begin
        delete from A_S_RES R
        where (R.ID_SOURCE = :ID_SOURCE) and
              (R.KODIR_GROUP = :AGROUP) and
              (R.KODIR_PODGROUP = :APODGROUP)
          --TFS[249]:
          and ( :LEAVE_HANDMAID=0
                or not (R.UCH=0 and coalesce(R.NORM_ID,0)=0) );
        DELETED_RES = case
                        when row_count > 0 then 1
                        else 0
                      end;--rvs:00003695

      end
    end

    --rvs:2007/09/11 -     :
    --   ID-,    ,      
    -- (!)         -    
    else
    begin
      ZAMEN = 1;
      -- MK 12.09.2007      
      -- (      )
      MIN_SLAVEPARENT_ID = gen_id(A_G_SMETA, 0);
    end

  end

  if (coalesce(:ZAMEN, 0) <> 1) then
  begin
    --[1EA78E6C027D]

    --<rvs:2006/08/17>
    SM_REC_CLCMODE = SETBIT(:SM_REC_CLCMODE, 1, 0);
    update A_SMETA
    set CLCMODE = :SM_REC_CLCMODE
    where ID = :ID_SOURCE and
          coalesce(CLCMODE, 0) <> :SM_REC_CLCMODE;

    update A_SMETA --<<rvs:00004440
    set CLCMODE = SETBIT(coalesce(CLCMODE, 0), 1, 0)
    where NOMERROD = :ID_SOURCE and
          GETBIT(coalesce(CLCMODE, 0), 1) <> 0;
    --</rvs:2006/08/17>
  end

  /* MK CQ[3569] 20.07.2006 */
  if (MODE <> 1) then
    /* MK 24.08.2006       */
    --: 10164;    ID    
    --        
    if (coalesce(:IDLIST_COUNT, 0) <= 0 ) then
      execute procedure M_ETALON_S_RES_DELETE(:IDUSER,
          :ID_SOURCE, :AGROUP, :APODGROUP);

  /*    :
       -        
       +      
  */
  if (coalesce(DELETED_RES, 0) <> 0 or --rvs:00003695

      (ZAMEN <> 1) and
      (INSERT_SLAVE = 1) and
      (MODE <> 2) /* MK 25.07.2006 */
      ) then
  begin
    /*       ,     */
    -- rvs:2006/08/15 - [03D7D9D67102]  "coalesce"     "a_lz_testonnull"
    select coalesce(sum(S.RA), 0),
           coalesce(sum(S.RB), 0),
           coalesce(sum(S.RC), 0),
           coalesce(sum(S.RD), 0),
           coalesce(sum(S.RE), 0),
           coalesce(sum(S.RF), 0),
           coalesce(sum(S.RG), 0),
           coalesce(sum(S.RH), 0),
           coalesce(sum(S.RI), 0),
           coalesce(sum(S.RJ), 0),
           coalesce(sum(S.RK), 0),
           coalesce(sum(S.RL), 0),
           coalesce(sum(S.RM), 0)
    from A_SMETA S
    where (S.SLAVEPARENT = :ID_SOURCE) and
          (S.ATYPE = 18)
    into :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH,
         :RI, :RJ, :RK, :RL, :RM;

    /*        */
    delete from A_SMETA S
    where (S.SLAVEPARENT = :ID_SOURCE) and
          (S.ATYPE = 18)
          --TFS[249]:
      and (:LEAVE_HANDMAID=0
            or not exists (
                select * from A_S_RES R
                  where R.ID=S.ID_S_RES
                   --and R.ID_SOURCE=S.ID and R.KODIR_GROUP=:AGROUP and R.KODIR_PODGROUP=:APODGROUP
                    and (R.UCH=0 and coalesce(R.NORM_ID,0)=0) ));

    DELETED_SLAVE = case
                      when row_count > 0 then 1
                      else 0
                    end;
  end

  /* MK 20.07.2006 , .  sum(s.ra) (   sum) NULL   */
  /*  NULL   0 */
  -- rvs:[03D7D9D67102]
  --execute procedure a_lz_testonnull( :iduser, :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk )
  --        returning_values ( :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk );

  /*     ,         */
  --<rvs:2006/08/15> - [0DEA78317B39]   ,      A_SMETA
  --if ( sm_rec_idnormativ is null ) then
  --   select s.idnormativ, s.kodir_podgroup, s.rabmat, s.idhier, s.smetatype
  --   from a_smeta s
  --   where s.id = :id_source
  --   into :sm_rec_idnormativ, :sm_rec_kodir_podgroup, :sm_rec_rabmat, :sm_rec_idhier, :SM_REC_SMETATYPE;

  SEARCH_NORM_GUID = null;

  --------------------------------------------------------------------------------
  --------------------------------------------------------------------------------

  iMODE_KOMPNS_ST = 0; -- CQ[12633]


  execute procedure A_GET_ID_OBJ_AKT(:SM_REC_IDHIER,
      :SM_REC_SMETATYPE)
      returning_values :H_NUMBER, :H_ATYPE;

  if (:H_ATYPE = 1) then
    select ISCLC, KODIR_PODGROUP, PUT_ID_RAB,
           PUT_ID_MASH, PUT_ID_MAT,
           /*<rvs:00003021>ID_ZONE*/ :ID_ZONE,
           MODE_KOMPNS_ST -- CQ[12633]
    from A_O_OBJECTPARAMS
    where NUMBER = :H_NUMBER
    into :ISCLC, :P_KODIR_PODGROUP, :P_PUT_ID_RAB,
         :P_PUT_ID_MASH, :P_PUT_ID_MAT,
         :P_ID_ZONE,
         :iMODE_KOMPNS_ST -- CQ[12633]
         ;
  else
  if (:H_ATYPE = 8) then
    select ISCLC, KODIR_PODGROUP, PUT_ID_RAB,
           PUT_ID_MASH, PUT_ID_MAT,
           /*<rvs:00003021>ID_ZONE*/ :ID_ZONE,
           MODE_KOMPNS_ST -- CQ[12633]
    from A_O_FACTPARAMS
    where NUMBER = :H_NUMBER
    into :ISCLC, :P_KODIR_PODGROUP, :P_PUT_ID_RAB,
         :P_PUT_ID_MASH, :P_PUT_ID_MAT,
         :P_ID_ZONE,
         :iMODE_KOMPNS_ST -- CQ[12633]
        ;

  if (bin_and(coalesce(:ISCLC, 0), 7) = 3) then
    INSERT_SLAVE = 0;--<<rvs:00004197

  execute procedure A_S_RES_GET_DEF_ST_DOB_V_CENU3(:ISCLC,
      :SM_REC_CLCMODE, :SM_BA, :SM_BB, :SM_BC,
      :SM_BD, :SM_BE)
      returning_values :DOB_UCH, :DOB_NEUCH,
      :RES_RECALL;

  --<rvs:2006/08/17> -       " ,   "
  if (:RES_RECALL <> 0) then
  begin
    --[1EA78E6C027D]

    SM_REC_CLCMODE = SETBIT(:SM_REC_CLCMODE, 1, 1);
    update A_SMETA
    set CLCMODE = :SM_REC_CLCMODE
    where ID = :ID_SOURCE;

    update A_SMETA --<<rvs:00004440
    set CLCMODE = SETBIT(coalesce(CLCMODE, 0), 1, 1)
    where NOMERROD = :ID_SOURCE and
          GETBIT(coalesce(CLCMODE, 0), 1) <> 1;

    INSERT_SLAVE = 0;--<<rvs:00004197
  end
  --</rvs:2006/08/15>

  -- CQ[12633] -->
  if (:iMODE_KOMPNS_ST is null) then
    iMODE_KOMPNS_ST = 0;
  iMatResToSlave = 0;
  iNotUchResToSlave = 0;
  iAllResToSlave = 0;
  --   
  --  : INSERT_SLAVE = 0 -  
  if (:INSERT_SLAVE = 1) then
  begin
    --  
    iMatResToSlave = GetBit(:iMODE_KOMPNS_ST, 15 /* mksResOnlyMatRes */);
    --  
    if (:INSERT_ALL = 0) then
      iNotUchResToSlave = 1;
    --  
    if ((:iMatResToSlave = 0) and (:iNotUchResToSlave = 0)) then
      iAllResToSlave = 1;
  end

  -- CQ[12633] <--

  --<<[12309]:
  if (:RES_SEARCH_OTHER_BASE <> 0) then
    execute procedure L_FB_READ_RES_SEARCH_OTHER_BASE(:IDUSER,
        :SM_REC_IDNORMATIV, :SM_REC_KODIR_PODGROUP, :SM_REC_RABMAT)
      returning_values
        :SM_REC_IDNORMATIV_NEW, :TAB_TRUD_SUFFIX, :R_IDPUT_MASH, :R_IDPUT_MAT;

  /*     */
  for select R.ID_SELF, R.PODGROUP,
             R.RABMAT, R.TAB, R.ALTTAB, R.IDNAME,
             R.IDEDIZM, R.NORMA_RASH,
             R.CCURRENT_ZONE, R.BB, R.BC, R.BD,
             R.BE, R.CCURRENT_BB, R.CCURRENT_BC,
             R.CCURRENT_BD, R.CCURRENT_BE,
             coalesce(R.RES_VIDNR, 0), R.RES_UCH,
             R.ABC_OKP_ISGROUPOKP, comment,
             ID_ABC_OKP, ABC_OKP_IDPODGROUP,
             ABC_OKP_IDNAME, ABC_OKP_TAB,
             ABC_OKP_IDEDIZM, ABC_OKP_CENA,
             ABC_OKP_CCURRENT, R.NORM_GUID,
             coalesce(R.TYPE_TRUD, 0)
      from L_FB_READ_RESOURCES(
          coalesce(:SM_REC_IDNORMATIV_NEW, :SM_REC_IDNORMATIV), --[12309]:SM_REC_IDNORMATIV
          :SM_REC_KODIR_PODGROUP, :SM_REC_RABMAT, :AGROUP, :APODGROUP, :IDUSER,
          :ID_ZONE, 1, :IDLIST, :IDLIST_COUNT) R
      order by R.RABMAT, R.TAB
      into :SEARCH_ID_SELF,
           :SEARCH_PODGROUP, :SEARCH_RABMAT,
           :SEARCH_TAB, :SEARCH_ALTTAB,
           :SEARCH_IDNAME, :SEARCH_IDEDIZM,
           :SEARCH_NORMA_RASH,
           :SEARCH_CCURRENT_ZONE, :SEARCH_BB,
           :SEARCH_BC, :SEARCH_BD, :SEARCH_BE,
           :SEARCH_CCURRENT_BB,
           :SEARCH_CCURRENT_BC,
           :SEARCH_CCURRENT_BD,
           :SEARCH_CCURRENT_BE, :SEARCH_RES_VIDNR,
           :SEARCH_RES_UCH,
           :SEARCH_ABC_OKP_ISGROUPOKP,:SEARCH_COMMENT,
           :SEARCH_ID_ABC_OKP,
           :SEARCH_ABC_OKP_IDPODGROUP,
           :SEARCH_ABC_OKP_ID_NAME,
           :SEARCH_ABC_OKP_TAB,
           :SEARCH_ABC_OKP_IDEDIZM,
           :SEARCH_ABC_OKP_CENA,
           :SEARCH_ABC_OKP_CCURRENT,
           :SEARCH_NORM_GUID, :SEARCH_TYPE_TRUD

  do
  --if ( search_id_self <> 0 )
  --then
  if ( :SM_REC_IDNORMATIV_NEW is null --<<  
    --[12309,12380]    :
    or :SEARCH_RES_UCH <> 0 ) then
  begin
    RES_APPLY_TAB_FOR_VALERA = RES_APPLY_TAB + 1;

    select IDRES, PODGROUP, ID_NAME, TAB, ALTTAB,
           IDEDIZM, BB, BC, BD, BE, CCURRENT_BB,
           CCURRENT_BC, CCURRENT_BD, CCURRENT_BE
    from L_FB_REALIGN_RESULTS(:IDUSER, 0, 0, :RES_APPLY_TAB_FOR_VALERA,
        :SEARCH_RABMAT, :APODGROUP, :SEARCH_ID_SELF, :SEARCH_PODGROUP,
        :SEARCH_IDNAME, null, :SEARCH_TAB, :SEARCH_ALTTAB, :SEARCH_COMMENT,
        :SEARCH_IDEDIZM, null, null, :SEARCH_BB, :SEARCH_BC, :SEARCH_BD,
        :SEARCH_BE, :SEARCH_CCURRENT_BB, :SEARCH_CCURRENT_BC, :SEARCH_CCURRENT_BD,
        :SEARCH_CCURRENT_BE, null, :SEARCH_ID_ABC_OKP, :SEARCH_ABC_OKP_IDPODGROUP,
        :SEARCH_ABC_OKP_ID_NAME, null, :SEARCH_ABC_OKP_TAB, :SEARCH_ABC_OKP_IDEDIZM,
        null, null, :SEARCH_ABC_OKP_CENA, :SEARCH_ABC_OKP_CCURRENT, null)
    into :SEARCH_ID_SELF, :SEARCH_PODGROUP,
         :SEARCH_IDNAME, :SEARCH_TAB,
         :SEARCH_ALTTAB, :SEARCH_IDEDIZM,
         :SEARCH_BB, :SEARCH_BC, :SEARCH_BD,
         :SEARCH_BE, :SEARCH_CCURRENT_BB,
         :SEARCH_CCURRENT_BC, :SEARCH_CCURRENT_BD,
         :SEARCH_CCURRENT_BE;

    --<<[12309,12380]
    if (:SM_REC_IDNORMATIV_NEW is not null) then
    begin
      if (:SEARCH_RABMAT = 1
      and :SEARCH_PODGROUP = 1
      and :TAB_TRUD_SUFFIX is not null) then
      --    
         select first 1 TAB, ID --first  
           from B_TRUD
           where TABU = S_TRANSLITERATE(:SEARCH_TAB || :TAB_TRUD_SUFFIX)
             and ORDERVIEW is not null
         into :SEARCH_TAB, :SEARCH_ID_SELF;

      if (:SEARCH_RABMAT in (2,3)) then
      begin
        SEARCH_ID_SELF = null;
        for select IDREESTR
          from S_OERRA_SELECT_REESTR_FROMPUTI(:SEARCH_RABMAT, :R_IDPUT_MASH, :R_IDPUT_MAT)
          into :R_IDFOLDER
        do
        for select first 1 ID, RABMAT, 1
          from B_RABMAT
          where IDPAPKA=:R_IDFOLDER
            and TABU=S_TRANSLITERATE(:SEARCH_TAB)
          into :SEARCH_ID_SELF, :SEARCH_RABMAT, :SEARCH_PODGROUP
        do
        execute procedure A_CLC_SEARCH_RES_2(:IDUSER, :P_KODIR_PODGROUP, :P_ID_ZONE,
            :SEARCH_ID_SELF, :SEARCH_PODGROUP, :SEARCH_RABMAT,
            :SEARCH_ALTTAB, :SEARCH_IDNAME, :SEARCH_IDEDIZM,
            :RESULT_BB, :RESULT_BC, :RESULT_BD, :RESULT_BE,
            :SEARCH_NORM_GUID,
            :CUR_STATUS_REC_CEN, :SEARCH_TAB)
          returning_values (:SEARCH_ID_SELF,
            :SEARCH_PODGROUP, :SEARCH_RABMAT,
            :SEARCH_ALTTAB, :SEARCH_IDNAME,
            :SEARCH_IDEDIZM, :RESULT_BB, :RESULT_BC,
            :RESULT_BD, :RESULT_BE,
            :SEARCH_NORM_GUID, :CUR_STATUS_REC_CEN);
      end
      else
        execute procedure A_CLC_SEARCH_RES(:IDUSER,
          :P_KODIR_PODGROUP, null, --[12309]:P_PUT_ID_RAB
          null, null, --[12309]:P_PUT_ID_MASH :P_PUT_ID_MAT
          :P_ID_ZONE,
          :SEARCH_ID_SELF, :SEARCH_PODGROUP,
          :SEARCH_RABMAT, :SEARCH_ALTTAB,
          :SEARCH_IDNAME, :SEARCH_IDEDIZM,
          :RESULT_BB, :RESULT_BC, :RESULT_BD,
          :RESULT_BE, :SEARCH_NORM_GUID,
          :CUR_STATUS_REC_CEN, :SEARCH_TAB)
        returning_values (:SEARCH_ID_SELF,
          :SEARCH_PODGROUP, :SEARCH_RABMAT,
          :SEARCH_ALTTAB, :SEARCH_IDNAME,
          :SEARCH_IDEDIZM, :RESULT_BB, :RESULT_BC,
          :RESULT_BD, :RESULT_BE,
          :SEARCH_NORM_GUID, :CUR_STATUS_REC_CEN);
    end

    -- ,    
    if (:SEARCH_ID_SELF <> 0) then  --<<[12903]
    begin

      --<rvs:00003021>
      if (:ID_ZONE = -1) then
      begin
        RESULT_BB = 0.0;
        RESULT_BC = 0.0;
        RESULT_BD = 0.0;
        RESULT_BE = 0.0;
      end
      else
  
      --</rvs:00003021>
      if (ID_ZONE > 0 and
          SEARCH_CCURRENT_ZONE > 0) then
      begin
        RESULT_BB = SEARCH_CCURRENT_BB;
        RESULT_BC = SEARCH_CCURRENT_BC;
        RESULT_BD = SEARCH_CCURRENT_BD;
        RESULT_BE = SEARCH_CCURRENT_BE;
      end
      else
      begin
        RESULT_BB = SEARCH_BB;
        RESULT_BC = SEARCH_BC;
        RESULT_BD = SEARCH_BD;
        RESULT_BE = SEARCH_BE;
      end
  
      if (RESULT_BB is null) then
        RESULT_BB = 0;
      if (RESULT_BC is null) then
        RESULT_BC = 0;
      if (RESULT_BD is null) then
        RESULT_BD = 0;
      if (RESULT_BE is null) then
        RESULT_BE = 0;
  
      CUR_ID_RES = gen_id(A_G_SMETA, 1);
  
      RES_APPLY_TAB_FOR_VALERA = RES_APPLY_TAB + 1;
  
      /* MK CQ[3569] 27.07.2006 ---> */
      /*            
         (         
         "  ,    ")*/
  
      ET_SEARCH_ID_SELF = SEARCH_ID_SELF;
      ET_SEARCH_PODGROUP = SEARCH_PODGROUP;
      ET_SEARCH_RABMAT = SEARCH_RABMAT;
      ET_SEARCH_ALTTAB = SEARCH_ALTTAB;
      ET_SEARCH_IDNAME = SEARCH_IDNAME;
      ET_SEARCH_IDEDIZM = SEARCH_IDEDIZM;
      ET_RESULT_BB = RESULT_BB;
      ET_RESULT_BC = RESULT_BC;
      ET_RESULT_BD = RESULT_BD;
      ET_RESULT_BE = RESULT_BE;
      ET_SEARCH_NORM_GUID = SEARCH_NORM_GUID;
  
      /* MK <--- */
  
      --<rvs:2006/08/15> -    (. A_S_RES_GET_DEF_ST_DOB_V_CENU3)
      --execute procedure a_s_res_get_def_st_dob_v_cenu ( :iduser,
      --                                                  :id_source,
      --                                                  :search_res_uch,
      --                                                  null,
      --                                                  :sm_rec_idhier )
      --        returning_values ( :status_dob_v_zenu );
      --</rvs:2006/08/15>
  
      --  <rvs:2006/08/15> -   ...
      if (:RES_RECALL <> 0) then
      begin
        CUR_STATUS_REC_CEN = null;
  
        execute procedure A_CLC_SEARCH_RES(:IDUSER,
            :P_KODIR_PODGROUP, :P_PUT_ID_RAB,
            :P_PUT_ID_MASH, :P_PUT_ID_MAT,
            :P_ID_ZONE,
            :SEARCH_ID_SELF, :SEARCH_PODGROUP,
            :SEARCH_RABMAT, :SEARCH_ALTTAB,
            :SEARCH_IDNAME, :SEARCH_IDEDIZM,
            :RESULT_BB, :RESULT_BC, :RESULT_BD,
            :RESULT_BE, :SEARCH_NORM_GUID,
            :CUR_STATUS_REC_CEN, :SEARCH_TAB)
            returning_values (:SEARCH_ID_SELF,
            :SEARCH_PODGROUP, :SEARCH_RABMAT,
            :SEARCH_ALTTAB, :SEARCH_IDNAME,
            :SEARCH_IDEDIZM, :RESULT_BB, :RESULT_BC,
            :RESULT_BD, :RESULT_BE,
            :SEARCH_NORM_GUID, :CUR_STATUS_REC_CEN);
        STATUS_DOB_V_ZENU = 1;
      end
      else
        STATUS_DOB_V_ZENU = case
                              when :SEARCH_RES_UCH <> 0 then :DOB_UCH
                              else :DOB_NEUCH
                            end;
  
      /*   A_S_RES_APPEND     
      insert into a_s_res ( id,
                            id_source,
                            norm_id,
                            norm_podgroup,
                            kodir_group,
                            kodir_podgroup,
                            isgroupokp,
                            rabmat,
                            tab,
                            alttab,
                            name_id,
                            idedizm,
                            rashod,
                            rashod_base,
                            bb,
                            bc,
                            bd,
                            be,
                            vidnr,
                            uch,
                            status_dob_v_zenu,
                            norm_guid,
                            type_trud,
                            SMETATYPE,
                            IDHIER
                             )
                   values ( :cur_id_res,
                            :id_source,
                            :search_id_self,
                            :search_podgroup,
                            :agroup,
                            :apodgroup,
                            :search_abc_okp_isgroupokp,
                            :search_rabmat,
                            :search_tab,
                            :search_alttab,
                            :search_idname,
                            :search_idedizm,
                            :search_norma_rash,
                            :search_norma_rash,
                            :result_bb,
                            :result_bc,
                            :result_bd,
                            :result_be,
                            :search_res_vidnr,
                            :search_res_uch,
                            :status_dob_v_zenu,
                            :search_norm_guid,
                            :search_type_trud,
                            :SM_REC_SMETATYPE,
                            :SM_REC_IDHIER
                           );
      */
  
      -- MK 13.09.2012 --->
      -- MK:       
      ----CQ[9273] -->       A_S_RES_TO_SLAVEREC_NL  M_ET_RES_APPEND_NL
      --IDNORMATIVUNIQ = 0;
      --PUNKTIND = '';
      --VRPZ = 0;
      --
      --select S.PUNKTIND, S.VRPZ, S.ID_UNIQUE
      --from L_FB_SEARCH_NORMATIV(:SEARCH_ID_SELF, :SEARCH_PODGROUP, :SEARCH_RABMAT, null, null, :IDUSER, null, null, null, null, null) S
      --into :PUNKTIND, :VRPZ, :IDNORMATIVUNIQ;
      ----CQ[9273] <--
      -- MK 13.09.2012 <---
  
      -- CQ[12633] -->
      -- if ((INSERT_SLAVE = 1) and (MODE <> 2) and
      --     (SEARCH_RES_UCH = 0 or INSERT_ALL = 1) and (:CUR_ID_RES > MIN_SLAVEPARENT_ID)) then
      --   NEEDUPDCOST = 0;
      -- else
      --   NEEDUPDCOST = 1;
      NEEDUPDCOST = 1;
      if ((INSERT_SLAVE = 1) and (MODE <> 2) and (:CUR_ID_RES > MIN_SLAVEPARENT_ID)) then
      begin
          --   
       if ((:iAllResToSlave = 1)
         --        -  
         or ((:iNotUchResToSlave = 1) and (:iMatResToSlave = 1) and (:SEARCH_RES_UCH = 0) and (:SEARCH_RABMAT = 3 /*rmMater*/))
         --        
         or ((:iNotUchResToSlave = 1) and (:iMatResToSlave = 0) and (:SEARCH_RES_UCH = 0))
         --       - 
         or ((:iMatResToSlave = 1) and (:iNotUchResToSlave = 0) and (:SEARCH_RABMAT = 3 /*rmMater*/))) then
           NEEDUPDCOST = 0;
      end
      -- CQ[12633] <--
  
      /*     a_s_res,     */
      execute procedure M_ET_RES_APPEND_NL(:IDUSER,
          :CUR_ID_RES, :ID_SOURCE, :SEARCH_ID_SELF,
          :SEARCH_PODGROUP, :AGROUP, :APODGROUP,
          :SEARCH_ABC_OKP_ISGROUPOKP,
          :SEARCH_RABMAT, :SEARCH_TAB,
          :SEARCH_ALTTAB, :SEARCH_IDNAME,
          :SEARCH_IDEDIZM, 0 --:edizm_type
          , :SEARCH_NORMA_RASH, :SEARCH_NORMA_RASH,
          null, --:correct,
          :RESULT_BB, :RESULT_BC, :RESULT_BD,
          :RESULT_BE, :SEARCH_RES_VIDNR,
          :SEARCH_RES_UCH, 0, --:status_edit
          :STATUS_DOB_V_ZENU, null, null, 0, --:status_rec_cen,:note ,:nomerrod
          :SEARCH_NORM_GUID, :SEARCH_TYPE_TRUD,
          :ET_SEARCH_ID_SELF, :ET_SEARCH_PODGROUP,
          :AGROUP, :APODGROUP,
          :SEARCH_ABC_OKP_ISGROUPOKP,
          :ET_SEARCH_RABMAT, :SEARCH_TAB,
          :ET_SEARCH_ALTTAB, :ET_SEARCH_IDNAME,
          :ET_SEARCH_IDEDIZM, 0, --:et_edizm_type
          :SEARCH_NORMA_RASH, :ET_RESULT_BB,
          :ET_RESULT_BC, :ET_RESULT_BD,
          :ET_RESULT_BE, :SEARCH_RES_VIDNR,
          :SEARCH_RES_UCH, :ET_SEARCH_NORM_GUID,
          :SEARCH_TYPE_TRUD, 0, --:sender
          :MODE, --CQ [6884]  , null,
          :VRPZ, :NEEDUPDCOST, :PASTE_AS_IS --CQ[9273]
          );
  
      --execute procedure A_S_RES_APPEND(
      --  :IDUSER, :cur_id_res, :ID_SOURCE,
      --  :search_id_self, :search_podgroup, :agroup, :apodgroup, :search_abc_okp_isgroupokp,
      --  :search_rabmat, :search_tab, :search_alttab, :search_idname, :search_idedizm,
      --  0/*:EDIZM_TYPE*/, :search_norma_rash, :search_norma_rash, null/*:CORRECT*/,
      --  :result_bb, :result_bc, :result_bd, :result_be, :search_res_vidnr, :search_res_uch,
      --  0/*:STATUS_EDIT*/, :status_dob_v_zenu, null/*:STATUS_REC_CEN*/,
      --  null/*:NOTE*/, :search_norm_guid, :search_type_trud, :MODE/*:SENDER*/, 0/*:NOMERROD*/);
  
      ADDED_RES = 1;
    end
  end

--    ,    .
--
if (:SM_REC_IDNORMATIV_NEW is not null) then
begin

  /*     */
  for select R.ID_SELF, R.PODGROUP,
             R.RABMAT, R.TAB, R.ALTTAB, R.IDNAME,
             R.IDEDIZM, R.NORMA_RASH,
             R.CCURRENT_ZONE, R.BB, R.BC, R.BD,
             R.BE, R.CCURRENT_BB, R.CCURRENT_BC,
             R.CCURRENT_BD, R.CCURRENT_BE,
             coalesce(R.RES_VIDNR, 0), R.RES_UCH,
             R.ABC_OKP_ISGROUPOKP, comment,
             ID_ABC_OKP, ABC_OKP_IDPODGROUP,
             ABC_OKP_IDNAME, ABC_OKP_TAB,
             ABC_OKP_IDEDIZM, ABC_OKP_CENA,
             ABC_OKP_CCURRENT, R.NORM_GUID,
             coalesce(R.TYPE_TRUD, 0)
      from L_FB_READ_RESOURCES(
          :SM_REC_IDNORMATIV,
          :SM_REC_KODIR_PODGROUP, :SM_REC_RABMAT, :AGROUP, :APODGROUP, :IDUSER,
          :ID_ZONE, 1, :IDLIST, :IDLIST_COUNT) R
      order by R.RABMAT, R.TAB
      into :SEARCH_ID_SELF,
           :SEARCH_PODGROUP, :SEARCH_RABMAT,
           :SEARCH_TAB, :SEARCH_ALTTAB,
           :SEARCH_IDNAME, :SEARCH_IDEDIZM,
           :SEARCH_NORMA_RASH,
           :SEARCH_CCURRENT_ZONE, :SEARCH_BB,
           :SEARCH_BC, :SEARCH_BD, :SEARCH_BE,
           :SEARCH_CCURRENT_BB,
           :SEARCH_CCURRENT_BC,
           :SEARCH_CCURRENT_BD,
           :SEARCH_CCURRENT_BE, :SEARCH_RES_VIDNR,
           :SEARCH_RES_UCH,
           :SEARCH_ABC_OKP_ISGROUPOKP,:SEARCH_COMMENT,
           :SEARCH_ID_ABC_OKP,
           :SEARCH_ABC_OKP_IDPODGROUP,
           :SEARCH_ABC_OKP_ID_NAME,
           :SEARCH_ABC_OKP_TAB,
           :SEARCH_ABC_OKP_IDEDIZM,
           :SEARCH_ABC_OKP_CENA,
           :SEARCH_ABC_OKP_CCURRENT,
           :SEARCH_NORM_GUID, :SEARCH_TYPE_TRUD

  do
  --if ( search_id_self <> 0 )
  --then
  if ( coalesce(:SEARCH_RES_UCH,0) = 0 ) then
  begin
    RES_APPLY_TAB_FOR_VALERA = RES_APPLY_TAB + 1;

    select IDRES, PODGROUP, ID_NAME, TAB, ALTTAB,
           IDEDIZM, BB, BC, BD, BE, CCURRENT_BB,
           CCURRENT_BC, CCURRENT_BD, CCURRENT_BE
    from L_FB_REALIGN_RESULTS(:IDUSER, 0, 0, :RES_APPLY_TAB_FOR_VALERA,
        :SEARCH_RABMAT, :APODGROUP, :SEARCH_ID_SELF, :SEARCH_PODGROUP,
        :SEARCH_IDNAME, null, :SEARCH_TAB, :SEARCH_ALTTAB, :SEARCH_COMMENT,
        :SEARCH_IDEDIZM, null, null, :SEARCH_BB, :SEARCH_BC, :SEARCH_BD,
        :SEARCH_BE, :SEARCH_CCURRENT_BB, :SEARCH_CCURRENT_BC, :SEARCH_CCURRENT_BD,
        :SEARCH_CCURRENT_BE, null, :SEARCH_ID_ABC_OKP, :SEARCH_ABC_OKP_IDPODGROUP,
        :SEARCH_ABC_OKP_ID_NAME, null, :SEARCH_ABC_OKP_TAB, :SEARCH_ABC_OKP_IDEDIZM,
        null, null, :SEARCH_ABC_OKP_CENA, :SEARCH_ABC_OKP_CCURRENT, null)
    into :SEARCH_ID_SELF, :SEARCH_PODGROUP,
         :SEARCH_IDNAME, :SEARCH_TAB,
         :SEARCH_ALTTAB, :SEARCH_IDEDIZM,
         :SEARCH_BB, :SEARCH_BC, :SEARCH_BD,
         :SEARCH_BE, :SEARCH_CCURRENT_BB,
         :SEARCH_CCURRENT_BC, :SEARCH_CCURRENT_BD,
         :SEARCH_CCURRENT_BE;

    --<rvs:00003021>
    if (:ID_ZONE = -1) then
    begin
      RESULT_BB = 0.0;
      RESULT_BC = 0.0;
      RESULT_BD = 0.0;
      RESULT_BE = 0.0;
    end
    else

    --</rvs:00003021>
    if (ID_ZONE > 0 and
        SEARCH_CCURRENT_ZONE > 0) then
    begin
      RESULT_BB = SEARCH_CCURRENT_BB;
      RESULT_BC = SEARCH_CCURRENT_BC;
      RESULT_BD = SEARCH_CCURRENT_BD;
      RESULT_BE = SEARCH_CCURRENT_BE;
    end
    else
    begin
      RESULT_BB = SEARCH_BB;
      RESULT_BC = SEARCH_BC;
      RESULT_BD = SEARCH_BD;
      RESULT_BE = SEARCH_BE;
    end

    if (RESULT_BB is null) then
      RESULT_BB = 0;
    if (RESULT_BC is null) then
      RESULT_BC = 0;
    if (RESULT_BD is null) then
      RESULT_BD = 0;
    if (RESULT_BE is null) then
      RESULT_BE = 0;

    CUR_ID_RES = gen_id(A_G_SMETA, 1);

    RES_APPLY_TAB_FOR_VALERA = RES_APPLY_TAB + 1;

    /* MK CQ[3569] 27.07.2006 ---> */
    /*            
       (         
       "  ,    ")*/

    ET_SEARCH_ID_SELF = SEARCH_ID_SELF;
    ET_SEARCH_PODGROUP = SEARCH_PODGROUP;
    ET_SEARCH_RABMAT = SEARCH_RABMAT;
    ET_SEARCH_ALTTAB = SEARCH_ALTTAB;
    ET_SEARCH_IDNAME = SEARCH_IDNAME;
    ET_SEARCH_IDEDIZM = SEARCH_IDEDIZM;
    ET_RESULT_BB = RESULT_BB;
    ET_RESULT_BC = RESULT_BC;
    ET_RESULT_BD = RESULT_BD;
    ET_RESULT_BE = RESULT_BE;
    ET_SEARCH_NORM_GUID = SEARCH_NORM_GUID;

    /* MK <--- */

    --<rvs:2006/08/15> -    (. A_S_RES_GET_DEF_ST_DOB_V_CENU3)
    --execute procedure a_s_res_get_def_st_dob_v_cenu ( :iduser,
    --                                                  :id_source,
    --                                                  :search_res_uch,
    --                                                  null,
    --                                                  :sm_rec_idhier )
    --        returning_values ( :status_dob_v_zenu );
    --</rvs:2006/08/15>

    --  <rvs:2006/08/15> -   ...
    if (:RES_RECALL <> 0) then
    begin
      CUR_STATUS_REC_CEN = null;

      execute procedure A_CLC_SEARCH_RES(:IDUSER,
          :P_KODIR_PODGROUP, :P_PUT_ID_RAB,
          :P_PUT_ID_MASH, :P_PUT_ID_MAT,
          :P_ID_ZONE,
          :SEARCH_ID_SELF, :SEARCH_PODGROUP,
          :SEARCH_RABMAT, :SEARCH_ALTTAB,
          :SEARCH_IDNAME, :SEARCH_IDEDIZM,
          :RESULT_BB, :RESULT_BC, :RESULT_BD,
          :RESULT_BE, :SEARCH_NORM_GUID,
          :CUR_STATUS_REC_CEN, :SEARCH_TAB)
          returning_values (:SEARCH_ID_SELF,
          :SEARCH_PODGROUP, :SEARCH_RABMAT,
          :SEARCH_ALTTAB, :SEARCH_IDNAME,
          :SEARCH_IDEDIZM, :RESULT_BB, :RESULT_BC,
          :RESULT_BD, :RESULT_BE,
          :SEARCH_NORM_GUID, :CUR_STATUS_REC_CEN);
      STATUS_DOB_V_ZENU = 1;
    end
    else
      STATUS_DOB_V_ZENU = case
                            when :SEARCH_RES_UCH <> 0 then :DOB_UCH
                            else :DOB_NEUCH
                          end;

    /*   A_S_RES_APPEND     
    insert into a_s_res ( id,
                          id_source,
                          norm_id,
                          norm_podgroup,
                          kodir_group,
                          kodir_podgroup,
                          isgroupokp,
                          rabmat,
                          tab,
                          alttab,
                          name_id,
                          idedizm,
                          rashod,
                          rashod_base,
                          bb,
                          bc,
                          bd,
                          be,
                          vidnr,
                          uch,
                          status_dob_v_zenu,
                          norm_guid,
                          type_trud,
                          SMETATYPE,
                          IDHIER
                           )
                 values ( :cur_id_res,
                          :id_source,
                          :search_id_self,
                          :search_podgroup,
                          :agroup,
                          :apodgroup,
                          :search_abc_okp_isgroupokp,
                          :search_rabmat,
                          :search_tab,
                          :search_alttab,
                          :search_idname,
                          :search_idedizm,
                          :search_norma_rash,
                          :search_norma_rash,
                          :result_bb,
                          :result_bc,
                          :result_bd,
                          :result_be,
                          :search_res_vidnr,
                          :search_res_uch,
                          :status_dob_v_zenu,
                          :search_norm_guid,
                          :search_type_trud,
                          :SM_REC_SMETATYPE,
                          :SM_REC_IDHIER
                         );
    */

    -- MK 13.09.2012 --->
    -- MK:       
    ----CQ[9273] -->       A_S_RES_TO_SLAVEREC_NL  M_ET_RES_APPEND_NL
    --IDNORMATIVUNIQ = 0;
    --PUNKTIND = '';
    --VRPZ = 0;
    --
    --select S.PUNKTIND, S.VRPZ, S.ID_UNIQUE
    --from L_FB_SEARCH_NORMATIV(:SEARCH_ID_SELF, :SEARCH_PODGROUP, :SEARCH_RABMAT, null, null, :IDUSER, null, null, null, null, null) S
    --into :PUNKTIND, :VRPZ, :IDNORMATIVUNIQ;
    ----CQ[9273] <--
    -- MK 13.09.2012 <---

    -- CQ[12633] -->
    -- if ((INSERT_SLAVE = 1) and (MODE <> 2) and
    --     (SEARCH_RES_UCH = 0 or INSERT_ALL = 1) and (:CUR_ID_RES > MIN_SLAVEPARENT_ID)) then
    --   NEEDUPDCOST = 0;
    -- else
    --   NEEDUPDCOST = 1;
    NEEDUPDCOST = 1;
    if ((INSERT_SLAVE = 1) and (MODE <> 2) and (:CUR_ID_RES > MIN_SLAVEPARENT_ID)) then
    begin
        --   
     if ((:iAllResToSlave = 1)
       --        -  
       or ((:iNotUchResToSlave = 1) and (:iMatResToSlave = 1) and (:SEARCH_RES_UCH = 0) and (:SEARCH_RABMAT = 3 /*rmMater*/))
       --        
       or ((:iNotUchResToSlave = 1) and (:iMatResToSlave = 0) and (:SEARCH_RES_UCH = 0))
       --       - 
       or ((:iMatResToSlave = 1) and (:iNotUchResToSlave = 0) and (:SEARCH_RABMAT = 3 /*rmMater*/))) then
         NEEDUPDCOST = 0;
    end
    -- CQ[12633] <--

    /*     a_s_res,     */
    execute procedure M_ET_RES_APPEND_NL(:IDUSER,
        :CUR_ID_RES, :ID_SOURCE, :SEARCH_ID_SELF,
        :SEARCH_PODGROUP, :AGROUP, :APODGROUP,
        :SEARCH_ABC_OKP_ISGROUPOKP,
        :SEARCH_RABMAT, :SEARCH_TAB,
        :SEARCH_ALTTAB, :SEARCH_IDNAME,
        :SEARCH_IDEDIZM, 0 --:edizm_type
        , :SEARCH_NORMA_RASH, :SEARCH_NORMA_RASH,
        null, --:correct,
        :RESULT_BB, :RESULT_BC, :RESULT_BD,
        :RESULT_BE, :SEARCH_RES_VIDNR,
        :SEARCH_RES_UCH, 0, --:status_edit
        :STATUS_DOB_V_ZENU, null, null, 0, --:status_rec_cen,:note ,:nomerrod
        :SEARCH_NORM_GUID, :SEARCH_TYPE_TRUD,
        :ET_SEARCH_ID_SELF, :ET_SEARCH_PODGROUP,
        :AGROUP, :APODGROUP,
        :SEARCH_ABC_OKP_ISGROUPOKP,
        :ET_SEARCH_RABMAT, :SEARCH_TAB,
        :ET_SEARCH_ALTTAB, :ET_SEARCH_IDNAME,
        :ET_SEARCH_IDEDIZM, 0, --:et_edizm_type
        :SEARCH_NORMA_RASH, :ET_RESULT_BB,
        :ET_RESULT_BC, :ET_RESULT_BD,
        :ET_RESULT_BE, :SEARCH_RES_VIDNR,
        :SEARCH_RES_UCH, :ET_SEARCH_NORM_GUID,
        :SEARCH_TYPE_TRUD, 0, --:sender
        :MODE, --CQ [6884]  , null,
        :VRPZ, :NEEDUPDCOST, :PASTE_AS_IS --CQ[9273]
        );

    --execute procedure A_S_RES_APPEND(
    --  :IDUSER, :cur_id_res, :ID_SOURCE,
    --  :search_id_self, :search_podgroup, :agroup, :apodgroup, :search_abc_okp_isgroupokp,
    --  :search_rabmat, :search_tab, :search_alttab, :search_idname, :search_idedizm,
    --  0/*:EDIZM_TYPE*/, :search_norma_rash, :search_norma_rash, null/*:CORRECT*/,
    --  :result_bb, :result_bc, :result_bd, :result_be, :search_res_vidnr, :search_res_uch,
    --  0/*:STATUS_EDIT*/, :status_dob_v_zenu, null/*:STATUS_REC_CEN*/,
    --  null/*:NOTE*/, :search_norm_guid, :search_type_trud, :MODE/*:SENDER*/, 0/*:NOMERROD*/);

    ADDED_RES = 1;

  end

end

  /*    :
       +      
  */
  if ((INSERT_SLAVE = 1) and
      (MODE <> 2)) then
    /* MK 25.07.2006 */
    for select ID, UCH,
               RABMAT -- CQ[12633]
               --from A_S_RES_SELECT (:iduser, :id_source, :agroup, :apodgroup, 0 )
        from A_S_RES --rvs:00003784 -  ..    ,    
        where ID_SOURCE = :ID_SOURCE and
              KODIR_GROUP = :AGROUP and
              KODIR_PODGROUP = :APODGROUP

          and not exists (select * from A_SMETA where ID_S_RES=A_S_RES.ID) --TFS[249]

        into :CUR_ID_RES, :SEARCH_RES_UCH,
             :iRABMAT -- CQ[12633]
    do
      -- CQ[12633] -->
      -- if ((SEARCH_RES_UCH = 0 or INSERT_ALL = 1) and

     if (
       --   
       ((:iAllResToSlave = 1)
       --        -  
       or ((:iNotUchResToSlave = 1) and (:iMatResToSlave = 1) and (:SEARCH_RES_UCH = 0) and (:iRABMAT = 3 /*rmMater*/))
       --        
       or ((:iNotUchResToSlave = 1) and (:iMatResToSlave = 0) and (:SEARCH_RES_UCH = 0))
       --       - 
       or ((:iMatResToSlave = 1) and (:iNotUchResToSlave = 0) and (:iRABMAT = 3 /*rmMater*/)))
       and
      -- CQ[12633] <--
          -- MK 12.09.2007   :   
          --         (  ) +
          --      (  )
          (:CUR_ID_RES > MIN_SLAVEPARENT_ID)) then
      begin

        for select ADDED_SLAVE, /*CQ[9359]OUT_SEA, OUT_SEB,
                   OUT_SEC, OUT_SED, OUT_SEE,
                   OUT_SEF, OUT_SEG, OUT_SEH,
                   OUT_SEI, OUT_SEJ, OUT_SEK,
                   OUT_SRA, OUT_SRB, OUT_SRC,
                   OUT_SRD, OUT_SRE, OUT_SRF,
                   OUT_SRG, OUT_SRH, OUT_SRI,
                   OUT_SRJ, OUT_SRK, OUT_SRL,
                   OUT_SRM, */OUT_SMETATYPE,
                   OUT_IDFORMULS --CQ[9359]
            --CQ[9273]from A_S_RES_TO_SLAVEREC_NL(:IDUSER, :CUR_ID_RES, :ID_SOURCE,
            --    null , null , 0, :IN_ID_ZONE, :APPLY_POPR_MODE, 0/*[9273]*/, null)
            -- MK 13.09.2012 from A_S_RES_TO_SLAVEREC_NL(:IDUSER, :CUR_ID_RES, :ID_SOURCE,
            --    :PUNKTIND , :VRPZ , 0, :IN_ID_ZONE, :APPLY_POPR_MODE, 0/*[9273]*/,
            --    :IDNORMATIVUNIQ, :PASTE_AS_IS)
            from A_S_RES_TO_SLAVEREC_NL_2(:IDUSER, :CUR_ID_RES, :ID_SOURCE, null ,
                null, 0, :IN_ID_ZONE, :APPLY_POPR_MODE, 0/*[9273]*/, 0, :PASTE_AS_IS)
            into :RESULT_ADDED_SLAVE, /*CQ[9359]:OUT_SEA,
                 :OUT_SEB, :OUT_SEC, :OUT_SED,
                 :OUT_SEE, :OUT_SEF, :OUT_SEG,
                 :OUT_SEH, :OUT_SEI, :OUT_SEJ,
                 :OUT_SEK, :OUT_SRA, :OUT_SRB,
                 :OUT_SRC, :OUT_SRD, :OUT_SRE,
                 :OUT_SRF, :OUT_SRG, :OUT_SRH,
                 :OUT_SRI, :OUT_SRJ, :OUT_SRK,
                 :OUT_SRL, :OUT_SRM,*/
                 :OUT_SMETATYPE,
                 :OUT_IDFORMULS --CQ[9359]
        do
        begin

          if (ADDED_SLAVE = 0 and
              RESULT_ADDED_SLAVE > 0) then
            ADDED_SLAVE = 1;
          ADDEDID = RESULT_ADDED_SLAVE;
          suspend;
        end
      end

  if ((ADDED_SLAVE = 0) and
      (MODE <> 2)) then
  begin
  /* --[12309]
    OUT_SEA = null;
    OUT_SEB = null;
    OUT_SEC = null;
    OUT_SED = null;
    OUT_SEE = null;
    OUT_SEF = null;
    OUT_SEG = null;
    OUT_SEH = null;
    OUT_SEI = null;
    OUT_SEJ = null;
    OUT_SEK = null;
    OUT_SRA = null;
    OUT_SRB = null;
    OUT_SRC = null;
    OUT_SRD = null;
    OUT_SRE = null;
    OUT_SRF = null;
    OUT_SRG = null;
    OUT_SRH = null;
    OUT_SRI = null;
    OUT_SRJ = null;
    OUT_SRK = null;
    OUT_SRL = null;
    OUT_SRM = null;
  */
    OUT_IDFORMULS = 0; --CQ[9359]
    suspend;
  end
end
^
/* TFS[35] >> */
create or alter procedure RM_REGION_CONTENTS_XML_EXPORT (
    iID integer)
returns (
    ID integer,
    ID_REGION integer,
    ID_ENTITY integer,
    ENTITY_TYPE integer,
    FULLNAME varchar(1024),
    SHIFR varchar(1024),
    GUID varchar(100))
as
begin
  -- TFS[35] >>
  for select ID, ID_REGION, ID_ENTITY, ENTITY_TYPE
    from RM_REGION_CONTENTS
    where ID = :iID
    into :ID, :ID_REGION, :ID_ENTITY, :ENTITY_TYPE
  do
  begin
    GUID = null;
    SHIFR = null;
    FULLNAME = null;
    if (:ENTITY_TYPE = 0) -- FolderType
    then
      select FULLNAME, SHIFR, GUID
      from a_o_FolderParams
      where number = :ID_ENTITY
      into :FULLNAME, :SHIFR, :GUID;
    else
    if (:ENTITY_TYPE = 1) -- ObgectType
    then
    begin
      select FULLNAME, SHIFR
      from a_o_objectparams
      where number = :ID_ENTITY
      into :FULLNAME, :SHIFR;

      select GUID
      from ENTITY_GUID
      where ID = :ID_ENTITY
      into :GUID;

    end
    if (coalesce(:GUID, '') = '') then
    begin
      if (:ENTITY_TYPE = 0) then -- FolderType
      begin
        GUID = COCREATEGUID();
        update a_o_FolderParams set
          GUID = :GUID
        where number = :ID_ENTITY;
      end
      else
      if (:ENTITY_TYPE = 1) then -- ObgectType
      begin
        insert into ENTITY_GUID (ID)
        values (:ID_ENTITY);
        select GUID
        from ENTITY_GUID
        where ID = :ID_ENTITY
        into :GUID;
      end
    end
    suspend;
  end
end
^

--TFS[250]
create or alter procedure T_TFS_250
AS
begin
  if (not exists(select * from RDB$RELATIONS
      where upper(RDB$RELATION_NAME) = 'GTT_CONVERT_OBJ_VNB_BAD_EDIZM') ) then
  begin

    execute statement
      'CREATE GLOBAL TEMPORARY TABLE GTT_CONVERT_OBJ_VNB_BAD_EDIZM ( '||
      '    ID_SOURCE      INTEGER NOT NULL, '||
      '    ID_RES         INTEGER, '||
      '    SM_ID_EDIZM    INTEGER, '||
      '    NORM_ID_EDIZM  INTEGER, '||
      '    EDIZMRELATION  DOUBLE PRECISION DEFAULT 1 '||
      ') ON COMMIT PRESERVE ROWS';      --ON COMMIT DELETE ROWS

    execute statement
        'CREATE UNIQUE INDEX GTT_BAD_EDIZM_IDS_EDIZ  ON ' ||
        'GTT_CONVERT_OBJ_VNB_BAD_EDIZM (SM_ID_EDIZM, NORM_ID_EDIZM)';
  end
end
^

execute procedure T_TFS_250;
^

drop procedure T_TFS_250;
^^

--TFS[250]
/* 
create or alter procedure M_CONVERT_OBJ_VNB (
*/

--TFS[250]
/* 
create or alter procedure M_CONVERT_OBJ_VNB_RES (
*/

--TFS[250]
create or alter procedure FILL_BAD_RELATION_EDIZM_RES (
    ID_SOURCE integer,
    IDUSER integer,
    IN_PODGROUP integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer)
AS
declare variable RES_ID integer;
declare variable RES_TAB varchar(42);
declare variable RES_RABMAT integer;
declare variable RES_NAME_ID integer;
declare variable RES_IDEDIZM integer;
declare variable V_ID_SELF integer;
declare variable V_IDEDIZM integer;
declare variable V_STAB varchar(42);
declare variable V_PODGROUP integer;
declare variable V_TAB varchar(42);
declare variable EDIZMSUCCESS integer;
declare variable OLD_EDIZMIDGROUP integer;
declare variable NEW_EDIZMIDGROUP integer;
declare variable RES_NAME_CRC integer;
declare variable RES_EDIZM_NAME varchar(100);
declare variable ID_CUR_PODGROUP integer;
declare variable ID_CUR_NAME integer;
declare variable IDOBJECT integer;
declare variable VN_IDHIER integer;
declare variable VN_NORM_ID integer;
declare variable V_ABC_OKP_IDPODGROUP integer;
declare variable V_ABC_OKP_TAB varchar(42);
declare variable V_ID_ABC_OKP integer;
declare variable V_ABC_OKP_COMMENT varchar(42);
declare variable V_RES_APPLY_TAB integer;
begin
  --cq[9301] chinger ->
  select first 1 s.idhier
  from a_smeta s
  where s.id = :ID_SOURCE
  into :VN_IDHIER;

  execute procedure S_O_HIER_PARENT_OFTYPE (:VN_IDHIER, 1)
  returning_values  :IDOBJECT;

  --[15371]
  select RES_APPLY_TAB
    from A_O_OBJECTPARAMS
    where (NUMBER = :IDOBJECT)
  into :V_RES_APPLY_TAB;

  for select ID, RABMAT, TAB, NAME_ID, IDEDIZM,
             NORM_PODGROUP, NAME_ID, NORM_ID
  from A_S_RES
  where (ID_SOURCE = :ID_SOURCE)
  into :RES_ID, :RES_RABMAT, :RES_TAB, :RES_NAME_ID, :RES_IDEDIZM,
       :ID_CUR_PODGROUP, :ID_CUR_NAME, :VN_NORM_ID
  do
  begin
    RES_NAME_CRC = 0;
    select CRC_NAME_TITLE from B_NNAME where ID=:RES_NAME_ID into :RES_NAME_CRC;

    --  
    select first 1 EDIZMNAME
      from B_GET_EDIZM(:RES_IDEDIZM)
    into :RES_EDIZM_NAME;
    -- MK 24.12.2007 <---

    --           -- MK 24.12.2007 CQ[5749] --->
    V_STAB = upper(:RES_TAB);
    select first 1 ID_SELF, IDEDIZM, PODGROUP, TAB,
       ID_ABC_OKP, ABC_OKP_IDPODGROUP, ABC_OKP_TAB, ABC_OKP_COMMENT
    from M_FB_SEARCH_NORMATIV_EX(:IN_PODGROUP, :RES_RABMAT/*-1*/, :IDUSER, :V_STAB,
            :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0,
            :RES_NAME_CRC, :RES_NAME_ID/*[15371, 15408]*/, :RES_EDIZM_NAME)
    into :V_ID_SELF, :V_IDEDIZM,  :V_PODGROUP, :V_TAB,
         :V_ID_ABC_OKP, :V_ABC_OKP_IDPODGROUP, :V_ABC_OKP_TAB, :V_ABC_OKP_COMMENT;

    -- ...   B_ABC_OKP  --[15371] -->
    if ((V_ID_SELF = 0) and (ID_CUR_PODGROUP > 1)) then
    begin

      V_TAB = null;
      select upper(TAB) from B_ABC_OKP
        where (ID = :VN_NORM_ID)
      into :V_TAB;

      if (V_TAB is not null) then
        V_STAB = V_TAB;
      else
        --       0.0-0-0-->9999990001
        execute procedure M_CONVERT_RES_TAB(:IDUSER, :V_STAB, :ID_CUR_NAME)
          returning_values (:V_STAB);

      if (V_STAB is not null) then
        select first 1 ID_SELF, IDEDIZM, PODGROUP, TAB,
           ID_ABC_OKP, ABC_OKP_IDPODGROUP, ABC_OKP_TAB, ABC_OKP_COMMENT
        from M_FB_SEARCH_NORMATIV_EX(:IN_PODGROUP, :RES_RABMAT/*-1*/, :IDUSER, :V_STAB,
                :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0,
                :RES_NAME_CRC, :RES_NAME_ID/*[15371, 15408]*/, :RES_EDIZM_NAME)
        into :V_ID_SELF, :V_IDEDIZM, :V_PODGROUP, :V_TAB,
             :V_ID_ABC_OKP, :V_ABC_OKP_IDPODGROUP, :V_ABC_OKP_TAB, :V_ABC_OKP_COMMENT;
    end -- <--[15371]

    --  
    if (V_ID_SELF > 0) then
    begin

      --[15371] --> 9999990001-->0.0-0-0
      --    :  - 0
      if (:V_PODGROUP > 1) then
        if ((:V_RES_APPLY_TAB = 0) and (:V_ABC_OKP_COMMENT <> '')) then
           V_TAB = :V_ABC_OKP_COMMENT;

      --       ABC,     ABC
      if (:V_PODGROUP = 1) then --    
        if ((ID_CUR_PODGROUP > 1) and (:V_ID_ABC_OKP > 0)) then
        begin
          V_ID_SELF = V_ID_ABC_OKP;
          V_PODGROUP = V_ABC_OKP_IDPODGROUP;
          if (:V_RES_APPLY_TAB <> 0) then
            V_TAB = V_ABC_OKP_TAB;
        end
      -- <--[15371]

      --   
      --if (v_ABC_OKP_ISGROUPOKP = 0) then -- MK 24.12.2007 CQ[5749] 
      begin
        --     
        if (RES_IDEDIZM <> V_IDEDIZM) then
        begin
          EdizmSuccess = 0;
          --     .    
          --     
          select first 1 IDGROUP
            from B_FIND_EDIZM_EX(:IDUSER, :RES_IDEDIZM, '')
          into :OLD_EDIZMIDGROUP;

          select first 1 IDGROUP
            from B_FIND_EDIZM_EX(:IDUSER, :V_IDEDIZM, '')
          into :NEW_EDIZMIDGROUP;

          --          
          --   . 
          if ((OLD_EDIZMIDGROUP is not null) and (NEW_EDIZMIDGROUP is not null) and
              (OLD_EDIZMIDGROUP = NEW_EDIZMIDGROUP)) then
          begin
            EDIZMSUCCESS = 1;
          end
        end
        --    
        else
          EDIZMSUCCESS = 1;

        if (EDIZMSUCCESS = 0) then
        begin
          if (not exists(
                select * from GTT_CONVERT_OBJ_VNB_BAD_EDIZM
                  where SM_ID_EDIZM = :RES_IDEDIZM and
                        NORM_ID_EDIZM = :V_IDEDIZM))
          then
          begin
            insert into GTT_CONVERT_OBJ_VNB_BAD_EDIZM (
              ID_SOURCE, ID_RES, SM_ID_EDIZM, NORM_ID_EDIZM)
            values (
              :ID_SOURCE, :RES_ID, :RES_IDEDIZM, :V_IDEDIZM);
          end

        end

      end
    end
  end
end^

--TFS[250]
create or alter procedure FILL_BAD_RELATION_EDIZM_SM_STR (
    IDOBJECT integer,
    IDUSER integer,
    IN_PODGROUP integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer)
AS
declare variable ID_SOURCE integer;
declare variable RABMAT integer;
declare variable SM_IDEDIZM integer;
declare variable EDIZMSUCCESS integer;
declare variable TAB varchar(42);
declare variable OLD_EDIZMIDGROUP integer;
declare variable NEW_EDIZMIDGROUP integer;
declare variable S_NAME_CRC integer;
declare variable S_EDIZM_NAME varchar(100);
declare variable ID_CUR_PODGROUP integer;
declare variable ID_CUR_NORMATIV integer;
declare variable ID_CUR_NAME integer;
declare variable PM_RES_APPLY_TAB integer;

declare variable V_TAB varchar(42);
declare variable V_STAB varchar(42);
declare variable V_ABC_OKP_TAB varchar(42);
declare variable V_ABC_OKP_COMMENT varchar(42);
declare variable V_ID_SELF integer;
declare variable V_IDEDIZM integer;
declare variable V_PODGROUP integer;
declare variable V_ABC_OKP_IDPODGROUP integer;
declare variable V_ID_ABC_OKP integer;
declare variable V_NORMATIV_IS_TSN integer;
begin

  --    ()
  select first 1
    RES_APPLY_TAB
    from A_H_GETOBJECTPARAM (:IDUSER, :IDOBJECT)
  into :PM_RES_APPLY_TAB;

  --     
  for select ID, RABMAT, TAB, ID_EDIZM, IDNORMATIV, KODIR_PODGROUP,
      NAME_ID, case when NAME is null then 0 else K_GETCRC32(upper(NAME)) end
  from A_P_SMETA (:IDOBJECT, :IDOBJECT, :IDUSER, 15, 0, 0, 0, null, null, 0, /*SENDER*/0)
  where (ATYPE = 17) or (ATYPE = 18)
  into :ID_SOURCE, :RABMAT, :TAB, :SM_IDEDIZM, :ID_CUR_NORMATIV, ID_CUR_PODGROUP,
       :ID_CUR_NAME, :S_NAME_CRC
  do
  begin

    -- MK 24.12.2007 CQ[5749] --->
    select first 1 EDIZMNAME
      from B_GET_EDIZM(:SM_IDEDIZM)
    into :S_EDIZM_NAME;

    --      
    V_STAB = upper(:TAB);
    select first 1 ID_SELF, IDEDIZM, PODGROUP, TAB,
      ID_ABC_OKP, ABC_OKP_IDPODGROUP, ABC_OKP_TAB, ABC_OKP_COMMENT
    from M_FB_SEARCH_NORMATIV_EX(:IN_PODGROUP, :RABMAT/*-1*/, :IDUSER, :V_STAB,
      :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0,
      :S_NAME_CRC, :ID_CUR_NAME/*[15371, 15408]*/, :S_EDIZM_NAME)
    into
      :V_ID_SELF, :V_IDEDIZM, :V_PODGROUP, :V_TAB,
      :V_ID_ABC_OKP, :V_ABC_OKP_IDPODGROUP, :V_ABC_OKP_TAB, :V_ABC_OKP_COMMENT;

    --          ,
    --     ABC_OKP --[15371] -->
    if ((V_ID_SELF = 0) and (ID_CUR_PODGROUP > 1)) then
    begin

      V_TAB = null;
      select upper(TAB) from B_ABC_OKP
        where (ID = :ID_CUR_NORMATIV)
      into :V_TAB;

      if (V_TAB is not null) then
        V_STAB = V_TAB;
      else
        --       0.0-0-0-->9999990001
        execute procedure M_CONVERT_RES_TAB(:IDUSER, :V_STAB, :ID_CUR_NAME)
          returning_values (:V_STAB);

      if (V_STAB is not null) then
        select first 1
          ID_SELF, IDEDIZM, PODGROUP, TAB,
          ID_ABC_OKP, ABC_OKP_IDPODGROUP, ABC_OKP_TAB, ABC_OKP_COMMENT
        from M_FB_SEARCH_NORMATIV_EX(:IN_PODGROUP, :RABMAT/*-1*/, :IDUSER, :V_STAB,
              :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0,
              :S_NAME_CRC, :ID_CUR_NAME/*[15371, 15408]*/, :S_EDIZM_NAME)
        into
          :V_ID_SELF, :V_IDEDIZM, :V_PODGROUP, :V_TAB,
          :V_ID_ABC_OKP, :V_ABC_OKP_IDPODGROUP, :V_ABC_OKP_TAB, :V_ABC_OKP_COMMENT;
    end

    --  
    if (V_ID_SELF > 0) then
    begin

      --[15371] --> 9999990001-->0.0-0-0
      --    :  - 0
      if (:V_PODGROUP > 1) then
        if ((:PM_RES_APPLY_TAB = 0) and (:V_ABC_OKP_COMMENT <> '')) then
           V_TAB = :V_ABC_OKP_COMMENT;

      --       ABC,     ABC
      if (:V_PODGROUP = 1) then --    
        if ((ID_CUR_PODGROUP > 1) and (:V_ID_ABC_OKP > 0)) then
        begin
          V_ID_SELF = V_ID_ABC_OKP;
          V_PODGROUP = V_ABC_OKP_IDPODGROUP;
          if (:PM_RES_APPLY_TAB <> 0) then
            V_TAB = V_ABC_OKP_TAB;
        end
      -- <--[15371]

      --   
      --if (v_ABC_OKP_ISGROUPOKP = 0) then -- MK 24.12.2007 CQ[5749] 
      begin
        --      ----------------------------
        if (SM_IDEDIZM <> V_IDEDIZM) then
        begin
          EDIZMSUCCESS = 0;
          --   
          select first 1 IDGROUP
            from B_FIND_EDIZM_EX(:IDUSER, :SM_IDEDIZM, '')
          into :OLD_EDIZMIDGROUP;

          select first 1 IDGROUP
            from B_FIND_EDIZM_EX(:IDUSER, :V_IDEDIZM, '')
          into :NEW_EDIZMIDGROUP;

          --          
          if ((OLD_EDIZMIDGROUP is not null) and (NEW_EDIZMIDGROUP is not null) and
              (OLD_EDIZMIDGROUP = NEW_EDIZMIDGROUP)) then
          begin
            EDIZMSUCCESS = 1;
          end
        end
        --    
        else
          EDIZMSUCCESS = 1;

        /* [15371]       ,  . .  
             ...*/
        if (EDIZMSUCCESS = 0) then
        begin
          execute procedure NORMATIV_IS_TSN(:V_ID_SELF)
             returning_values (:V_NORMATIV_IS_TSN);

          if (:V_NORMATIV_IS_TSN > 0) then /*tsn_mccs, tsn_mge*/
            EDIZMSUCCESS = 1;
        end
        --[15371]

        if (EDIZMSUCCESS = 0) then
        begin
          if (not exists(
                select * from GTT_CONVERT_OBJ_VNB_BAD_EDIZM
                  where SM_ID_EDIZM = :SM_IDEDIZM and
                        NORM_ID_EDIZM = :V_IDEDIZM))
          then
          begin
            insert into GTT_CONVERT_OBJ_VNB_BAD_EDIZM (
              ID_SOURCE, ID_RES, SM_ID_EDIZM, NORM_ID_EDIZM)
            values (
              :ID_SOURCE, null/*:ID_RES*/, :SM_IDEDIZM, :V_IDEDIZM);
          end

        end
      end
    end

    execute procedure FILL_BAD_RELATION_EDIZM_RES(:ID_SOURCE, :IDUSER,
      :IN_PODGROUP, :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT);

  end
end^

--TFS[250]
create or alter procedure GTT_BAD_EDIZM_SELECT (
    IDUSER integer)
returns (
    SM_EDIZM_NAME varchar(100),
    SM_ID_EDIZM integer,
    NORM_EDIZM_NAME varchar(100),
    NORM_ID_EDIZM integer,
    EDIZM_RELATION integer)
AS
begin
  for select SM_ID_EDIZM, NORM_ID_EDIZM, EDIZMRELATION
    from GTT_CONVERT_OBJ_VNB_BAD_EDIZM
  group by SM_ID_EDIZM, NORM_ID_EDIZM, EDIZMRELATION
  into :SM_ID_EDIZM, :NORM_ID_EDIZM, :EDIZM_RELATION
  do
  begin
     select first 1 NAME
       from B_FIND_EDIZM_EX(:IDUSER, :SM_ID_EDIZM, '')
     into :SM_EDIZM_NAME;

     select first 1 NAME
       from B_FIND_EDIZM_EX(:IDUSER, :NORM_ID_EDIZM, '')
     into :NORM_EDIZM_NAME;

     suspend;
  end
end^

--TFS[250]
create or alter procedure T_GET_PUTI (
    ID_REESTR_RAB integer)
returns (
    ID_PUT_U integer,
    ID_PUT_0 integer,
    ID_PUT_2 integer,
    ID_PUT_3 integer)
AS
declare variable ISSBORNIK integer;
declare variable IDFOLDER integer;
begin
  --ID_REESTR_RAB -   

  ID_PUT_U = null; --
  ID_PUT_0 = null; --
  ID_PUT_2 = null; --
  ID_PUT_3 = null; --

  select SBORNIK, IDPARENT
    from B_REESTR where ID = :ID_REESTR_RAB
  into :ISSBORNIK, :IDFOLDER;

  if (ISSBORNIK = 1) then ID_REESTR_RAB = :IDFOLDER;

  select first 1 n.ID
    from B_PUTVIEW v
    left join B_PUTNAME n on n.ID = v.IDPUTNAME
  where v.IDREESTR = :ID_REESTR_RAB
  into :ID_PUT_0;

  --      ...
  if (ID_PUT_0 is not null) then
  begin
    select first 1 ID, IDPUT2, IDPUT3
      from B_PUTNAME
    where IDPUT0 = :ID_PUT_0
    into :ID_PUT_U, :ID_PUT_2, :ID_PUT_3;

    suspend;
  end

end^
/* TFS[35] >> */
create or alter procedure rm_roles_imp_xml (
    NAME varchar(512),
    DESCR blob sub_type 1 segment size 80)
returns (
    ID_ROLE integer)
as
begin
  ID_ROLE = null;
  name = coalesce(:name, '');
  select id
  from rm_roles
  where name = :name
  into :ID_ROLE;
  if (:ID_ROLE is null) then
  begin
    ID_ROLE = gen_id(a_g_smeta, 1);
    insert into rm_roles (id, name, descr)
    values (:ID_ROLE, :NAME, :DESCR);
  end
  else
  begin
    update rm_roles set
      descr = :DESCR
    where (id = :ID_ROLE);
    --      , ..  .. 
    delete from RM_SET_RIGHTS
    where ID_ROLE = :ID_ROLE;
  end

end
^
create or alter procedure T_IMPORT_USER_GROUP (
    NAME varchar(250),
    IS_SYSTEM smallint,
    DESCRIPTION varchar(250),
    GROUP_ACCESS varchar(250))
returns (
    ID integer)
AS
begin
  --        RM_USER_GROUPS_IMP_XML
  select g.id from b_user_groups g
  where upper(g.name) = upper(:name) and IS_SYSTEM =: IS_SYSTEM
  into :ID;

  if (:ID is null) then
  begin
    ID = gen_id(a_g_smeta, 1);
    insert into b_user_groups (id, name, IS_SYSTEM, description, group_access)
    values (:id, :name,:IS_SYSTEM, :description, :group_access);
  end
  else
  begin
    update b_user_groups g
    set g.description = :description
    where (g.id = :id);
  end

  suspend;
end
^
create or alter procedure T_IMPORT_USER (
    NAME varchar(50),
    FULLNAME varchar(50),
    PSW varchar(10),
    DESCRIPTION varchar(250),
    ID_GROUP integer)
returns (
    ID integer)
AS
begin
  --        RM_USERS_IMP_XML
  select first 1 US.ID from b_user_access US
  where  upper(US.name) = upper(:name)
  into :ID;

  if (:ID is null) then
  begin
    ID = gen_id(a_g_smeta, 1);

    insert into b_users (id, isused)
    values (:id,  0);

    /* CQ[TIMUR 13166] -   B_USER_ACCESS_AI0 */
    -- Voyager CQ[13166]
    --  ,    V_SET_SETTINGS_TO_USERS

    insert into b_userdata (id, userdata)
    values (:id,  null);

    INSERT INTO L_USERS_PARAMS (ID_USER) VALUES(:ID) ;

    INSERT INTO M_USERS_PARAMS (ID) VALUES(:ID);

    insert into b_user_access (id, isworking, NAME, FULLNAME, PSW, id_group, DESCRIPTION, idput0, idput2, idput3, idgroup, 

idpodgroup, user_access, idlzgroup, idtn, projecttype, status_key, id_default_buf_template)
    values (:id, 0, :name, :FULLNAME, :PSW, :id_group, :DESCRIPTION, null, null, null, 1, 1, '', 200, null, 0, 0, null);

  end
  else
  begin
    if (:ID <> 10) then
         update b_user_access u
         set u.FULLNAME = :FULLNAME,
             u.DESCRIPTION = :DESCRIPTION
         where u.ID = :ID;
  end

  suspend;
end
^
create or alter procedure RM_USER_GROUPS_IMP_XML (
    NAME varchar(250),
    IS_SYSTEM smallint,
    DESCRIPTION varchar(250),
    GROUP_ACCESS varchar(250))
returns (
    ID integer)
as
begin
  --        T_IMPORT_USER_GROUP
  select g.id
  from b_user_groups g
  where upper(g.name) = upper(:name) and
        IS_SYSTEM = :IS_SYSTEM
  into :ID;

  if (:ID is null) then
  begin
    ID = gen_id(a_g_smeta, 1);
    insert into b_user_groups (id, name, IS_SYSTEM, description, group_access)
    values (:id, :name, :IS_SYSTEM, :description, :group_access);
  end
  else
  begin
    update b_user_groups g set
      g.description = :description
    where (g.id = :id);
    --         , ..  .. 
    delete from rm_assigned_roles
    where id_owner = :ID;
    delete from rm_region_contents
    where id_region = :ID;
  end
end
^
create or alter procedure RM_USERS_IMP_XML (
    NAME varchar(50),
    FULLNAME varchar(50),
    PSW varchar(10),
    DESCRIPTION varchar(250),
    ID_GROUP integer)
returns (
    ID integer)
as
begin
  --        T_IMPORT_USER
  select first 1 US.ID
  from b_user_access US
  where upper(US.name) = upper(:name)
  into :ID;

  if (:ID is null) then
  begin
    ID = gen_id(a_g_smeta, 1);

    insert into b_users (id, isused)
    values (:id, 0);

    insert into b_userdata (id, userdata)
    values (:id, null);

    insert into L_USERS_PARAMS (ID_USER)
    values (:ID);

    insert into M_USERS_PARAMS (ID)
    values (:ID);

    insert into b_user_access (id, isworking, NAME, FULLNAME, PSW, id_group, DESCRIPTION, idput0,
                               idput2, idput3, idgroup,

                               idpodgroup, user_access, idlzgroup, idtn, projecttype, status_key,
                               id_default_buf_template)
    values (:id, 0, :name, :FULLNAME, :PSW, :id_group, :DESCRIPTION, null, null, null, 1, 1, '',
            200, null, 0, 0, null);

  end
  else
  begin
    if (:ID <> 10) then
    begin
      update b_user_access u set
        u.FULLNAME = :FULLNAME,
        u.DESCRIPTION = :DESCRIPTION,
        u.ID_GROUP = :ID_GROUP -- TFS[302]
      where u.ID = :ID;
      --         , ..  .. 
      delete from rm_assigned_roles
      where id_owner = :ID;
      delete from rm_region_contents
      where id_region = :ID;
    end
  end
end
^
create or alter procedure RM_REGION_CONTENTS_IMP_XML (
    ID_REGION integer,
    ID_ENTITY integer,
    ENTITY_TYPE integer,
    FULLNAME varchar(1024),
    SHIFR varchar(1024),
    GUID varchar(100))
returns (
    ID integer)
AS
declare variable VN_FULLNAME varchar(1024);
declare variable VN_SHIFR varchar(1024);
declare variable VN_GUID varchar(100);
begin
  ID = null;
  VN_FULLNAME = '';
  VN_SHIFR = '';
  VN_GUID = '';
  if (:ENTITY_TYPE = 0) then -- FolderType
  begin
    --       
    select coalesce(fullname, ''), coalesce(shifr, ''), coalesce(guid, '')
    from a_o_folderparams
    where number = :ID_ENTITY
    into :VN_FULLNAME, :VN_SHIFR, :VN_GUID;
    if ((:VN_FULLNAME = :FULLNAME) and (:VN_SHIFR = :SHIFR) and (:VN_GUID = :GUID)) then
    begin
      --         
      ID_ENTITY = :ID_ENTITY;--    warning
    end
    else
    begin
      --   ,        guid
      ID_ENTITY = null;
      select first 1 NUMBER
      from a_o_folderparams
      where (FULLNAME = :FULLNAME) and
            (SHIFR = :SHIFR) and
            (GUID = :GUID)
      into :ID_ENTITY;
      --   ,      
      if (:ID_ENTITY is null) then
        select first 1 NUMBER
        from a_o_folderparams
        where (FULLNAME = :FULLNAME) and
              (SHIFR = :SHIFR)
        into :ID_ENTITY;
    end
  end
  else
  if (:ENTITY_TYPE = 1) then -- ObgectType
  begin
    --       
    select coalesce(p.fullname, ''), coalesce(p.shifr, ''), coalesce(g.guid, '')
    from a_o_objectparams p
    left outer join entity_guid g on g.id = p.number
    where number = :ID_ENTITY
    into :VN_FULLNAME, :VN_SHIFR, :VN_GUID;
    if ((:VN_FULLNAME = :FULLNAME) and (:VN_SHIFR = :SHIFR) and (:VN_GUID = :GUID)) then
    begin
      --         
      ID_ENTITY = :ID_ENTITY;--    warning
    end
    else
    begin
      --   ,        guid
      ID_ENTITY = null;
      select first 1 p.NUMBER
      from a_o_objectparams p
      left outer join entity_guid g on g.id = p.number
      where (p.FULLNAME = :FULLNAME) and
            (p.SHIFR = :SHIFR) and
            (g.GUID = :GUID)
      into :ID_ENTITY;
      --   ,      
      if (:ID_ENTITY is null) then
        select first 1 NUMBER
        from a_o_objectparams
        where (FULLNAME = :FULLNAME) and
              (SHIFR = :SHIFR)
        into :ID_ENTITY;
    end
  end
  if (not(:ID_ENTITY is null)) then
  begin
    ID = gen_id(a_g_smeta, 1);
    insert into RM_REGION_CONTENTS (ID, ID_REGION, ID_ENTITY, ENTITY_TYPE)
    values (:ID, :ID_REGION, :ID_ENTITY, :ENTITY_TYPE);
  end
end
^

--------------------------------------------------------------------
--                           10.0.1.0, 10.0.0.14
--------------------------------------------------------------------

-- MK TFS[316]
create or alter procedure RM_GET_OPENED_ENTITYS
returns (
    ENTITY_ID integer)
AS
declare variable VN_ENTITY_ID integer;
begin
  -- ..   RM_GET_DOSTUP3 (. TFS[316])

  --  ""
  for select sf.IDHIER
  from V_SELECT_FOLDERS(517) sf
  into :ENTITY_ID do
  begin
    --  
    suspend;

    --   
    VN_ENTITY_ID = ENTITY_ID;
    for select h.number
    from a_o_hier h
    where (h.parent = :VN_ENTITY_ID) and (h.atype = 1)
    into :ENTITY_ID do
    begin
      suspend;
    end
  end


  --  ""
  for select sf.IDHIER
  from V_SELECT_FOLDERS(1) sf
  into :ENTITY_ID do
  begin
    --  
    suspend;

    --   
    VN_ENTITY_ID = ENTITY_ID;
    for select h.number
    from a_o_hier h
    where (h.parent = :VN_ENTITY_ID) and (h.atype = 1)
    into :ENTITY_ID do
    begin
      suspend;
    end
  end
end
^
/* TFS[318] >> */
create or alter procedure L_STR_SSR_READOBJS (
    ID_USER integer,
    ID_SELF integer,
    KOD integer,
    MODE integer,
    ONLY_OBJ integer,
    IN_LEVEL integer)
returns (
    NUMBER integer,
    PARENT integer,
    ID_TYPE smallint,
    SUBTYPE smallint,
    SORTING integer,
    COUNTCHILDREN integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    NUMGLSSR integer,
    OUT_LEVEL integer,
    DEF_KOD_SSR integer,
    NUMLSR_LS varchar(1024))
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
DECLARE VARIABLE KODSTROYKI INTEGER;
DECLARE VARIABLE KODDOG INTEGER;
DECLARE VARIABLE DO_SKIP INTEGER;
DECLARE VARIABLE IGNORE INTEGER;
DECLARE VARIABLE DUMMY INTEGER;
-- TFS[318] DECLARE VARIABLE ATYPE INTEGER;
begin

/*
   mode 0 -    
   mode 1 -    id_str_dog
   mode 2 -    
   mode 3 -    id_str_dog
   mode 4 -  

   mode 5 - .   // MK CQ[3427] 22.05.2006

   mode 83 -      
*/

  --CQ[TIMUR 9332]
  -- TFS[318] , .. ATYPE     ,      ID_USER
  -- if (mode in (0,1,2,3)) then
  --   ATYPE = 0;
  --  else
  --    ATYPE = mode;

  -- EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, :ID_SELF, ATYPE)
  -- RETURNING_VALUES :ID_SELF;

  -- TFS[318] -->
  if (coalesce(:ID_USER, 0) < 0) then
  begin
    EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, :ID_SELF, 0) --   (.  )     
    RETURNING_VALUES :ID_SELF;
  end
  -- TFS[318] <--


  NUMBER = ID_SELF;
  For Select Number , Parent , aType , SubType , Sorting , CountChildren
      from a_o_hier where Parent = :ID_SELF
      order by sorting
      into :NUMBER , :PARENT , :ID_TYPE , :SUBTYPE , :SORTING , :CountChildren
  do
  begin
     OUT_LEVEL = IN_LEVEL;

     NUMGLSSR = 0;

     DO_SKIP = 0;
     IGNORE  = 0;
     DEF_KOD_SSR = null; --CQ[TIMUR 9078]
     DUMMY = NULL; --CQ[TIMUR 9556]

     NUMLSR_LS = null; -- TFS[29]

     /*  */
     IF (id_type = 0) THEN 
     BEGIN
        SELECT shifr, fullname, DEF_KOD_SSR --CQ[TIMUR 9078]
        FROM a_o_FolderParams
        WHERE number = :number
        INTO :shifr, :fullname, :DEF_KOD_SSR; --CQ[TIMUR 9078]

        if ( Only_Obj <> 0 ) then
           if ( not ( ( SUBTYPE is null ) or ( SUBTYPE = 0 ) ) ) then
              DO_SKIP = 1;
        if ( not ( ( SUBTYPE is null ) or ( SUBTYPE in (0,1,2,3,4) ) ) ) then
           DO_SKIP = 1;
     END
     /*  */
     ELSE IF ( (id_type = 1) or (id_type = -1)) THEN
     BEGIN
        SELECT shifr, fullname, KodStroyki, KodDog, NUMGLSSR
        FROM a_o_objectparams
        WHERE number = :number
        INTO :shifr, :fullname, :KodStroyki, :KodDog, :NUMGLSSR;

        if (MODE = 0) then
           if ( ( KodStroyki IS NULL ) or ( KodStroyki <= 0 ) ) then
              DO_SKIP = 0;
           else
           begin
              SELECT id_self FROM l_stroyki WHERE id_self = :KodStroyki into DUMMY;
              if ( DUMMY IS NULL ) then
                 DO_SKIP = 0;
              else
                 DO_SKIP = 1;
           end
        else if (MODE = 1) then
        begin
           if ( KodStroyki = KOD ) then
              DO_SKIP = 0;
           else
              DO_SKIP = 1;
        end
        else if (MODE = 2) then
           if ( ( KodDog IS NULL ) or ( KodDog <= 0 ) ) then
              DO_SKIP = 0;
           else
           begin
              SELECT id_self FROM l_stroyki WHERE id_self = :KodDog into DUMMY;
              if ( DUMMY IS NULL ) then
                 DO_SKIP = 0;
              else
                 DO_SKIP = 1;
           end
        else if (MODE = 3) then
        begin
           if ( KodDog = KOD ) then
              DO_SKIP = 0;
           else
              DO_SKIP = 1;
        end
        else if (MODE = 83) then --[9543]
        begin
           DO_SKIP = 1;

           select first 1 0
             from L_STR_GETNODEHIERARCHY(:KodStroyki)
             where ID_SELF = :KOD
             into :DO_SKIP;
        end
        else
           DO_SKIP = 0;
     END
     /* , ,  */
     ELSE IF ( (id_type IN (3,-3)) and ( Only_Obj = 0 ) ) THEN
     BEGIN
        SELECT shifr, fullname, NUMGLSSR,
        NUMLSR_LS -- TFS[29]
        FROM a_o_params_ls
        WHERE id = :number
        INTO :shifr, :fullname, :NUMGLSSR,
        :NUMLSR_LS; -- TFS[29]
     END
     ELSE IF ( (id_type IN (4,5,-4,-5)) and ( Only_Obj = 0 ) ) THEN
     BEGIN
        SELECT shifr, fullname, NUMGLSSR
        FROM a_o_params_r_pr
        WHERE id = :number
        INTO :shifr, :fullname, :NUMGLSSR;
     END
     ELSE
        DO_SKIP = 1;

     if ( DO_SKIP = 0 ) then
     begin
        if ( IGNORE = 0 ) then
           suspend;

        For Select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR,
            NUMLSR_LS -- TFS[29]
            from L_STR_SSR_READOBJS (:ID_USER, :number, :Kod, :Mode, :Only_Obj, :IN_LEVEL + 1 )
            into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR,
            :NUMLSR_LS -- TFS[29]
        do suspend;
     end
  end
end
^

create or alter procedure RM_GET_MODE (
    IDUSER integer,
    PARAM_NAME varchar(60))
returns (
    MODE integer)
AS
declare variable PARAM_VALUE integer;
begin
  --     
  -- MODE:
  --      0 -     
  --      1 -     
  --
  -- PARAM_VALUE:
  --              0 -  
  --              1 - ,      
  --              2 -   ()
  ------------------------------------------------------------------------------

  MODE = 0;

  PARAM_VALUE = null;
  select first 1 INT_VALUE
  from M_GET_GLOBAL_PARAM(:PARAM_NAME)
  into :PARAM_VALUE;
  PARAM_VALUE = coalesce(PARAM_VALUE, 0);

  if (PARAM_VALUE = 2) then       --  
    MODE = 1;
  else if (PARAM_VALUE = 1) then  -- ,      
  begin
    --    
    if (exists
         (select * from RM_REGION_CONTENTS rc
          where (rc.id_region = :IDUSER)
         )
       ) then

      MODE = 1;

    --    
    if (MODE = 0) then
    begin
      --    
      if (exists
           (select * from RM_ASSIGNED_ROLES ar
            where (ar.id_owner = :IDUSER)
           )
         ) then
  
        MODE = 1;

    end
  end

  suspend;
end
^

create or alter procedure D_GET_HIER (
    ID_USER integer,
    ROOT_ID integer,
    RETURN_ROOT integer,
    AMODE integer,
    DATA_INT integer,
    ONE_LEVEL_ONLY integer)
returns (
    ID integer,
    ID_PARENT integer,
    ATYPE integer,
    SUBTYPE integer,
    FULLNAME varchar(1024),
    SHIFR varchar(1024),
    NUMLSR_LS varchar(1024),
    UTV integer,
    CHILDCOUNT integer,
    SORTING integer,
    REVISION varchar(255))
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME, NUMLSR_LS
declare variable FPARAM_ID integer;
declare variable FIDPARENT integer;
declare variable FIDPARENT1 integer;
declare variable FBASKETTYPE integer;
declare variable FINBASKETCOUNT integer;
declare variable LYEAR integer;
declare variable LPERIOD integer;
declare variable LMONTH integer;
declare variable IDAKTCENLVL integer;
declare variable OBJCHILDCOUNT integer; /* CQ[9793] */
declare variable VN_IDCLASS integer;
-- MK CQ[14654]
declare variable VN_VIEW_DOSTUP_EXISTS integer;
declare variable VN_IS_DOSTUP_VIRTUAL integer;
begin
--AMODE = 17/*MODE_FOLDERS*/ [01.09.2017]

  REVISION = ''; --CQ[10103]    
  NUMLSR_LS = '';  --CQ[12881]
  if (ONE_LEVEL_ONLY is null) then ONE_LEVEL_ONLY = 0;

  if (AMODE is null) then
    AMODE = 0;

  if (AMODE = -1)  then
  begin
    ID = ROOT_ID;
    suspend;
    exit;
  end

  FIDPARENT = :ROOT_ID;
  if (RETURN_ROOT is null) then
    RETURN_ROOT = 0;

  if (RETURN_ROOT <> 0) then
  begin
    if ((AMODE in (0,6,8,14,15,16,17/*MODE_FOLDERS*/)) and (ROOT_ID = 0))  then  -- MK CQ[9301]  16
    begin
--      if (ROOT_ID = 0) then
      begin
        ID         = 0;
        ATYPE      = -1;
        SUBTYPE    = 0;
        if (AMODE = 8) then
        begin
          FULLNAME   = '';
          SHIFR      = '';
          ID_PARENT  = -1;
          ROOT_ID = 0;
        end
        else
        begin
          FULLNAME   = '';
          SHIFR      = '';
          ID_PARENT  = -1;
        end
        UTV        = 0;
        CHILDCOUNT = 0;
        SORTING    = 0;
        suspend;
      end
    end
    else
    if (AMODE <> 7) then
    begin
      select first 1 h.NUMBER, h.ATYPE, h.COUNTCHILDREN, SORTING
      from A_O_HIER h
      where h.NUMBER = :FIDPARENT
      into :ID, :ATYPE, :CHILDCOUNT, :SORTING;

      select p.PARAM_ID, p.FULLNAME, p.SHIFR, p.NUMLSR_LS, p.UTV, p.REVISION
      from D_GET_HIER_PARAMS(:ID, :ATYPE) p
      into :FPARAM_ID, :FULLNAME, :SHIFR, :NUMLSR_LS, :UTV, :REVISION;
      if (ID_PARENT is null) then
      suspend;
      --chinger cq[9301] ->
      -- MK 17.01.2012   CQ[9958]    
      if (:AMODE = 16) then
      begin
        for select c.ID, c.ID_PARENT, c.ATYPE, c.SUBTYPE, c.FULLNAME,
                     c.SHIFR, c.UTV, c.CHILDCOUNT, c.SORTING
        from MD_GET_OBJ_CENLVL(:ID) c
          into ID, ID_PARENT, ATYPE, SUBTYPE, FULLNAME,
               SHIFR, UTV, CHILDCOUNT, SORTING do
        begin
          SUBTYPE = 0;
          VN_IDCLASS = :ID_PARENT;
          select count(*)
          from GET_CENLVL_COMPOSE(:ID, :VN_IDCLASS ) c
          into :CHILDCOUNT;
          suspend;

          ID_PARENT = :ID;
          UTV = 0;
          SUBTYPE = 0;
          SHIFR = '';
          for select c.id, c.lorder, c.HIER_TYPE, c.name
              from GET_CENLVL_COMPOSE(:ID, :VN_IDCLASS) c
          into :ID, :SORTING, :ATYPE, :FULLNAME
          do begin
            CHILDCOUNT = 0;
            suspend;
          end
        end
      end
    end
  end
  ID_PARENT = 0;

  if ((AMODE in (6,7)) and (ROOT_ID = 0)) then -- 
  begin
    FINBASKETCOUNT = 0;
    FBASKETTYPE = 12;
    /*FIDPARENT1 = 1;*/

    --CQ[TIMUR 9332]
    EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, 1/*:FIDPARENT1*/, :FBASKETTYPE)
    RETURNING_VALUES :FIDPARENT1;

    for select ID, ID_PARENT, ATYPE, SUBTYPE, FULLNAME, SHIFR, UTV, CHILDCOUNT, SORTING
    from D_GET_HIER(:ID_USER, :FIDPARENT1, 0, 0, :DATA_INT, :ONE_LEVEL_ONLY)
    into :ID, :ID_PARENT, :ATYPE, :SUBTYPE, :FULLNAME, :SHIFR, :UTV, :CHILDCOUNT, :SORTING
    do
    begin
      FINBASKETCOUNT = :FINBASKETCOUNT + 1;
      if ((AMODE = 7) and (ID_PARENT = 1)) then
        ID_PARENT = 0;
      else
      if (FIDPARENT1 = ID_PARENT) then
        ID_PARENT = 1; --CQ[TIMUR 9332]

      FBASKETTYPE = 13;
      suspend;
    end
    if (AMODE = 7) then
    begin
      ID         = 0;
      ID_PARENT  = -1;
    end
    else
    begin
      ID         = 1;
      ID_PARENT  = 0;
    end
    ATYPE      = :FBASKETTYPE;
    SUBTYPE    = 0;
    FULLNAME   = '';
    SHIFR      = '';
    UTV        = 0;
    CHILDCOUNT = :FINBASKETCOUNT;
    SORTING    = 0;
    suspend;

    if (AMODE = 7) then
      exit;
    AMODE = 0;
  end

  --CQ[TIMUR 9332]
  IF ((ID_PARENT = 0) AND (ID_USER < 0)) then

    EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, :FIDPARENT,
        --iif(:AMODE = 17/*MODE_FOLDERS*/, 0/*MODE_OBJECTS*/, :AMODE) --  case when :AMODE=17 then 0 else :AMODE end
        decode(:AMODE, 17/*MODE_FOLDERS*/, 0/*MODE_OBJECTS*/, :AMODE) --  case :AMODE when 17 then 0 else :AMODE end
        )
    RETURNING_VALUES :FIDPARENT;

  if ((FIDPARENT = 0) and (AMODE = 8) and (ROOT_ID = 0)) then
    FIDPARENT = 2;

  for select h.NUMBER, h.ATYPE, h.SUBTYPE, h.COUNTCHILDREN, h.SORTING
    from A_O_HIER h
    where h.PARENT = :FIDPARENT
    order by h.SORTING
    into :ID, :ATYPE, :SUBTYPE, :CHILDCOUNT, :SORTING
  do
  begin
    ID_PARENT = ROOT_ID;
    if (
    --   ( ,      
    -- MK 12.11.2011 CQ[9446] +     (AMODE = 14)
       ((AMODE in (0,6,14,16)) and (((:ATYPE = 0)and((:SUBTYPE is null)or(:SUBTYPE = 0))) or (:ATYPE = 1)))
    -- 
    or ((AMODE = 17/*MODE_FOLDERS*/) and ((:ATYPE = 0)and((:SUBTYPE is null)or(:SUBTYPE = 0))))
    --    
--    or ((AMODE = 6) and (((:ATYPE = 0)and((:SUBTYPE is null)or(:SUBTYPE = 0))) or (:ATYPE = 1)))
    -- 
    or ((AMODE = 1) and ((:ATYPE = 0) or (:ATYPE = 3) or (:ATYPE = 4) or (:ATYPE = 5)))

    or ( (AMODE = 2)  and ((:ATYPE = 18) or (:ATYPE = 19) or (:ATYPE = 8)))
    --    (AMODE = 15) CQ[9793]
    or ((AMODE = 15) and ((:ATYPE = 18) or (:ATYPE = 19) or (:ATYPE = 8) or (:ATYPE = 1) or ((:ATYPE = 0) and ((:SUBTYPE is null)or(:SUBTYPE = 0)))))
    --M29  
    or ((AMODE = 3) and (((:ATYPE = 0)and(:SUBTYPE = 9)) or (:ATYPE = 9)))
    --  
    or ((AMODE = 4) and (((:ATYPE = 0)and(:SUBTYPE = 10)) or (:ATYPE = 10)))
    --3  
    or ((AMODE = 5) and (((:ATYPE = 0)and(:SUBTYPE = 11)) or (:ATYPE = 11)))
    --
    or ((AMODE = 8)
      and
      ((((:ATYPE = 0)and(:SUBTYPE = 33)) or (:ATYPE = 33)
      or (:ATYPE = 18) or (:ATYPE = 19) or (:ATYPE = 8)
      or ((:ATYPE = 0)and((:SUBTYPE is null) or (:SUBTYPE = 0))) or (:ATYPE = 1))))

      )
    then
    begin
      -- MK CQ[14654] --->
      VN_VIEW_DOSTUP_EXISTS = 1;
         --      
      if ((DATA_INT = 1) and
         --       
          ((:ATYPE = 1) or ((:ATYPE = 0) and (coalesce(:SUBTYPE, 0) = 0)))
         ) then
      begin
        -- 37 = DD_VIEW_OBJORFOLDER (. D_Dostup.pas)
        execute procedure D_GET_DOSTUP2(:ID_USER, 37, :ID)
        returning_values :VN_VIEW_DOSTUP_EXISTS, :VN_IS_DOSTUP_VIRTUAL;
      end

      if (VN_VIEW_DOSTUP_EXISTS = 1) then
      begin
      -- MK CQ[14654] <---
        select p.PARAM_ID, p.FULLNAME, p.SHIFR, p.NUMLSR_LS, p.UTV, p.REVISION
        from D_GET_HIER_PARAMS(:ID, :ATYPE) p
        into :FPARAM_ID, :FULLNAME, :SHIFR, :NUMLSR_LS, :UTV, :REVISION;
  
        /* MK CQ[3328] 27.04.2006 ---> */
        /*  ,       - - */
        if ((AMODE = 1) and (DATA_INT is not null) and (DATA_INT > 16)) then
        begin
           execute procedure M_H_GET_UTV(:ID, :ATYPE, :DATA_INT)
           returning_values :UTV;
        end
        /* MK <--- */
  
        if ((AMODE = 15) and (:ATYPE = 8)) then
          CHILDCOUNT = 2;
        suspend;
  
  
        FIDPARENT1 = :ID;
  
        -- MK 12.11.2011 CQ[9446] --->
        if (
              ((AMODE = 14) and (:ATYPE = 1))
           or ((AMODE = 15) and (:ATYPE in (1,8)))
           or (AMODE = 16)
           )   --CQ[9793]
        then
        begin
          --CQ[9793]-->
          ObjChildCount = 0;
          if ((AMODE = 15) and (ATYPE = 1)) then
            ObjChildCount = CHILDCOUNT;
          --CQ[9793]<--
          --chinger cq[9301] ->
          -- MK 17.01.2012   CQ[9958]    
          for select c.ID, c.ID_PARENT, c.ATYPE, c.SUBTYPE, c.FULLNAME,
                     c.SHIFR, c.UTV, c.CHILDCOUNT, c.SORTING
          from MD_GET_OBJ_CENLVL(:FIDPARENT1) c
          into ID, ID_PARENT, ATYPE, SUBTYPE, FULLNAME,
               SHIFR, UTV, CHILDCOUNT, SORTING do
          begin
            if (AMODE = 15) then
              SUBTYPE = 0;
            if (AMODE = 16) then
            begin
              SUBTYPE = 0;
              select count(*)
              from GET_CENLVL_COMPOSE(:ID, :ID_PARENT) c
              into :CHILDCOUNT;
            end
            suspend;
            if (AMODE = 16) then
            begin
              UTV = 0;
              SUBTYPE = 0;
              SHIFR = '';
              ID_PARENT = :ID;
              for select c.id, c.lorder, c.HIER_TYPE, c.name
                  from GET_CENLVL_COMPOSE(:ID, :FIDPARENT1) c
              into :ID, :SORTING, :ATYPE, :FULLNAME
              do begin
                CHILDCOUNT = 0;
                suspend;
              end
            end
          end
          --CQ[9793]-->
          if ((AMODE = 15) and (ObjChildCount > 0)) then
            CHILDCOUNT = ObjChildCount;
          --CQ[9793]<--
  
  /*
          --       
          execute procedure M_GET_AKT_CENLVL(:ID) returning_values :IdAktCenLvl;
          if (IdAktCenLvl is null) then IdAktCenLvl = 0;
  
          CHILDCOUNT = 0;
          ATYPE = 44;
          ID_PARENT = :ID;
          --    
          for select l.id, l.lorder, l.lyear, l.lperiod, l.lmonth, l.name
          from level_cost l
          where (l.idobject = :ID_PARENT)
          order by l.lorder
          into :ID, :SORTING, :lYear, :lPeriod, :lMonth, :FULLNAME do
          begin
            --   (__)    
            if ((lYear is null) or (lYear < 0) or (lYear > 9999)) then
              lYear = 0;
            if ((lPeriod is null) or (lPeriod < 1) or (lPeriod > 4)) then
              lPeriod = 0;
            if ((lMonth is null) or (lMonth < 1) or (lMonth > 12)) then
              lMonth = 0;
  
            SHIFR = cast(:lYear as varchar(4)) || '_';
            SHIFR = SHIFR || cast(:lPeriod as varchar(1)) || '_';
            SHIFR = SHIFR || cast(:lMonth as varchar(2));
  
            --      
            if (:ID = :IdAktCenLvl) then
              SUBTYPE = 1;
            else
              SUBTYPE = 0;
  
            suspend;
          end
  */
        end
        -- MK 12.11.2011 CQ[9446] <---
  
  
        if ((ONE_LEVEL_ONLY = 0) and ((CHILDCOUNT > 0) or ((AMODE = 8)and(ATYPE = 33))))  then
          for select ID, ID_PARENT, ATYPE, SUBTYPE, FULLNAME, SHIFR, NUMLSR_LS, UTV, CHILDCOUNT, SORTING, REVISION
          from D_GET_HIER(:ID_USER, :FIDPARENT1, 0, :AMODE, :DATA_INT, :ONE_LEVEL_ONLY)
          into :ID, :ID_PARENT, :ATYPE, :SUBTYPE, :FULLNAME, :SHIFR, :NUMLSR_LS, :UTV, :CHILDCOUNT, :SORTING, :REVISION
          do
            suspend;

      end -- MK CQ[14654]
    end
  end
end
^

--------------------------------------------------------------------
--                           10.0.1.1, 10.0.0.14+ (???)
--------------------------------------------------------------------


--TFS[329],TFS[69]
create or alter procedure S__UPGRADE_SPEC_NM_NAME
AS
begin
  if (not exists(
      select * from RDB$FIELDS
      where upper(RDB$FIELD_NAME)='S_VARCHAR1000')) then
  begin
execute statement
'CREATE DOMAIN S_VARCHAR1000 AS VARCHAR(1000) CHARACTER SET WIN1251 COLLATE WIN1251';

execute statement
'update RDB$RELATION_FIELDS set RDB$FIELD_SOURCE = ''S_VARCHAR1000''' ||
' where (RDB$FIELD_NAME = ''NM_NAME'')' ||
' and (RDB$RELATION_NAME = ''SPEC_TROW'')' ||
' and (RDB$FIELD_SOURCE = ''S_VARCHAR510'')';
  end
end
^
execute procedure S__UPGRADE_SPEC_NM_NAME
^
drop procedure S__UPGRADE_SPEC_NM_NAME
^
/* TFS[357] >> */
delete from  d_indexparams1  where SB_NUMBER = '' and NR_OT_ZPM = 0 and SP_OT_ZPM = 0
^

--TFS[338],TFS[242]
create or alter procedure S__UPGRADE_SMETA_BLOB_IDHIER
as
begin
  if (not exists(select * from RDB$RELATION_FIELDS r
      where r.RDB$RELATION_NAME='A_SMETA_BLOB'
        and r.RDB$FIELD_NAME='IDHIER')) then
  begin
execute statement
'ALTER TABLE A_SMETA_BLOB ADD IDHIER S_INTEGER';

execute statement
'alter table A_SMETA_BLOB'||
' alter ID position 1,'||
' alter IDHIER position 2,'||
' alter FIELD_NAME position 3,'||
' alter FIELD_VALUE position 4';
  end
end
^
execute procedure S__UPGRADE_SMETA_BLOB_IDHIER
^
drop procedure S__UPGRADE_SMETA_BLOB_IDHIER
^

create or alter procedure S__UPGRADE_SMETA_BLOB_IDHIER2
as
begin
  if (not exists(select * from RDB$INDICES r
      where r.RDB$RELATION_NAME='A_SMETA_BLOB'
        and r.RDB$INDEX_NAME='A_SMETA_BLOB_IDX_IDHIER')) then
  begin

execute statement
'update A_SMETA_BLOB'||
' set IDHIER = (select IDHIER from A_SMETA where ID=A_SMETA_BLOB.ID)'||
' where IDHIER is null';

execute statement
'CREATE INDEX A_SMETA_BLOB_IDX_IDHIER ON A_SMETA_BLOB (IDHIER, FIELD_NAME, ID)';

  end
end
^
execute procedure S__UPGRADE_SMETA_BLOB_IDHIER2
^
drop procedure S__UPGRADE_SMETA_BLOB_IDHIER2
^


--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_SMETA_BLOB_BI1 FOR A_SMETA_BLOB
ACTIVE BEFORE INSERT POSITION 1
AS
begin
  if (new.IDHIER is null) then
    select IDHIER from A_SMETA where ID = new.ID
     into new.IDHIER;
end
^
--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_SMETA_AU3 FOR A_SMETA
ACTIVE AFTER UPDATE POSITION 3
AS
begin
--[13929]
  if (old.TAB <> coalesce(new.TAB, '') and char_length(old.TAB) = 42) then
    delete from A_SMETA_BLOB where ID=old.ID and FIELD_NAME='TAB';
--TFS[338]
  if (old.IDHIER <> new.IDHIER) then
    update A_SMETA_BLOB set IDHIER = new.IDHIER
      where ID = old.ID;
end
^

--TFS[338],TFS[242]
create or alter procedure A_S_HIER_SELECT (
    IDUSER integer,
    HATYPE integer,
    AID integer,
    IDOBJECT integer,
    SMETATYPE integer,
    IN_NLS integer,
    IN_NR integer,
    IN_NPR integer,
    IN_IDLS integer,
    IN_IDR integer,
    CUR_PROJECTTYPE integer,
    ALLREC integer,
    SENDER integer,
    CUR_ID_ZONE integer,
    CUR_SAVECENZONETONORMBASE integer,
    CUR_ID_TR integer,
    PARAM_KODIR_GROUP integer,
    PARAM_KODIR_PODGROUP integer,
    SHOW_ZERO_STRINGS integer,
    ISCLC integer,
    MODE_KOMPNS_ST integer,
    NO_SUSPEND_STRUCT_REC integer)
returns (
    ID integer,
    IDHIER integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE smallint,
    RABMAT integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    NAME blob sub_type 0 segment size 80,
    NAME_ID integer,
    EDIZM varchar(250),
    ID_EDIZM integer,
    EDIZM_TYPE integer,
    KOLL double precision,
    SKOLL varchar(255),
    NORMARASH double precision,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    EA double precision,
    EB double precision,
    EC double precision,
    ED double precision,
    EE double precision,
    EF double precision,
    EG double precision,
    EH double precision,
    EI double precision,
    EJ double precision,
    EK double precision,
    RA double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    RL double precision,
    RM double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    PE double precision,
    VRPZ integer,
    IDTIPR integer,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    PUNKTIND varchar(42),
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    MJ double precision,
    MK double precision,
    ML double precision,
    SSTCH integer,
    KODZAK integer,
    KODGP integer,
    KODSP integer,
    KODISP integer,
    NACH date,
    OKONCH date,
    TIPRAB integer,
    IDNORMATIV integer,
    IDNORMATIVUNIQ integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ISGROUPOKP integer,
    ARPS_OTHER blob sub_type 0 segment size 80,
    ID_S_RES integer,
    PR_NUMBER1 integer,
    PR_NUMBER2 integer,
    PR_NUMBER3 integer,
    PR_ADDED_REC integer,
    PR_VSEGO double precision,
    PR_VIPOLNENO double precision,
    PR_EXISTS_CHILDS integer,
    NORM_GUID varchar(100),
    CALK_BA integer,
    CALK_BB integer,
    CALK_BC integer,
    CALK_BD integer,
    CALK_BE integer,
    STATUS_REC_CEN integer,
    IDREESTR integer,
    PCELLMEM integer,
    VIDRAB integer,
    NLS integer,
    NR integer,
    NPR integer,
    IDLS integer,
    IDR integer,
    ISHAVECORRECTIONNR integer,
    CALK_BG integer,
    CALK_BG_READONLY integer,
    CALK_BH integer,
    CALK_BH_READONLY integer,
    UTV integer,
    CORRECTNODE blob sub_type 0 segment size 80,
    CORRECTNODE_1 blob sub_type 0 segment size 80,
    ASUBTYPE integer,
    CLCMODE integer,
    S_BA double precision,
    S_BB double precision,
    S_BC double precision,
    S_BD double precision,
    S_BE double precision,
    S_BG double precision,
    S_BH double precision,
    ISRESPOPR integer,
    TYPE_TRUD integer,
    UCH integer,
    STRUCT_NAME varchar(255),
    FULL_STRUCT_NAME varchar(1024),
    IDFORMULS integer,
    STRUCT_SHIFR varchar(1024),
    NUMLSR_LS varchar(1024),
    CLCMODE_RES integer,
    VIEW_NUMBER1 integer,
    VIEW_NUMBER2 integer,
    VIEW_NUMBER3 integer,
    ADDED_SMETATYPE integer,
    PR_VIPOLNENO_TOTAL double precision,
    K_ITOGO varchar(50),
    ISKS_NS_ID integer,
    COD_RTM varchar(60),
    COD_RTM_BLOB blob sub_type 1 segment size 80,
    K_PR varchar(50),
    B_PR double precision)
AS
--CQ[TIMUR 13931] -    FULL_STRUCT_NAME, STRUCT_SHIFR, NUMLSR_LS
--declare variable cur_shifr varchar(60);
--declare variable fullname varchar(300);
declare variable checknode integer;
declare variable lyear integer;
declare variable lmonth integer;
declare variable use_only_utv_procent integer;
declare variable is_buffer integer;
declare variable is_Union integer;

declare P_CLCMODE integer;

declare variable VN_NOMERROD integer;
declare variable TMP_DOUBLE integer;

declare variable SP_IDHIER integer;
declare variable SP_NUMBER integer;
declare variable UTV_SPEC_REC integer;

declare COD_RTM_EXISTS integer;
begin
--[15352]+
--[8443]

  -- MK 29.03.2010 CQ[7436] ( 2) --->
  --     SHOW_ZERO_STRINGS   ,
  --        0,  
  --  .      
  -- NO_SUSPEND_STRUCT_REC,        .
  --   NO_SUSPEND_STRUCT_REC = 1      
  --    ,     
  -- MK 29.03.2010 CQ[7436] ( 2) <---


  -- MK 22.05.2012 CQ[9460]  !!! ---------------------------------------
  --   STRUCT_SHIFR   ()   
  --   SAP (B_RABMAT.IDENT_KOD_MAT_SAP)

  -- MK CQ[12020]
  -- ADDED_SMETATYPE - SmetaType      


 -- MK 23.01.2012 CQ[9054]
 is_Union = GETBIT(coalesce(:MODE_KOMPNS_ST, 0), 30);

 CLCMODE_RES = 0; -- CQ[12244]
 NUMLSR_LS = null; --CQ[12881]

 Is_Buffer = 0;
 atype = hatype;
 id = aid;
 if (atype > 0)
 then
 begin


  if ( not SMETATYPE in ( 15 , 16 ) ) then
  begin
   execute procedure L_PR_GET_YEAR_MONTH ( :SMETATYPE, :iduser ) returning_values ( :lyear, :lmonth );
   USE_ONLY_UTV_PROCENT = 0;
   for select USE_ONLY_UTV_PROCENT from a_o_factparams where number = :smetatype
       into   USE_ONLY_UTV_PROCENT
   DO
      USE_ONLY_UTV_PROCENT = USE_ONLY_UTV_PROCENT;

  end


  if (NO_SUSPEND_STRUCT_REC = 0) then -- MK 20.10.2008 CQ[6704]
  begin

    EXECUTE PROCEDURE M_H_GET_UTV :aid, :hatype, :SMETATYPE RETURNING_VALUES :UTV;

    -- MK 9.09.2010 CQ[8691] --->
    --EXECUTE PROCEDURE a_h_GetName :aid, :hatype RETURNING_VALUES :cur_shifr, :FULL_STRUCT_NAME;
    EXECUTE PROCEDURE a_h_GetName :aid, :hatype RETURNING_VALUES :STRUCT_SHIFR, :FULL_STRUCT_NAME;--CQ[9609]

    if (hatype = 3) then --CQ[12881]
      SELECT NUMLSR_LS
      FROM A_O_PARAMS_LS
      WHERE id = :aid
      INTO :NUMLSR_LS;
/*
    EXECUTE PROCEDURE a_h_GetName :aid, :hatype RETURNING_VALUES :cur_shifr, :fullname;
    if ( fullname is null )
    then fullname = '';

    if ( atype = 4 ) then
       fullname = '    ' || fullname;
    if ( atype = 5 ) then
       fullname = '    ' || '    ' || fullname;

    name = copyvarchartoblob(fullname);
    --<rvs:00002552>
    NAME_ID = gen_id(B_GEN_TEMP, 1) ;
    insert into B_TEMP_BLOB(ID, BLOB1) values (:NAME_ID, :NAME);
    select BLOB1 from B_TEMP_BLOB where ID = :NAME_ID into :NAME;
    delete from B_TEMP_BLOB where ID = :NAME_ID;
    --</rvs:00002552>
*/
    -- MK 9.09.2010 CQ[8691] <---



    idhier = aid;

    view_number1 = null; view_number2 = null; view_number3 = null; -- MK CQ[12020]
    ADDED_SMETATYPE = null; -- MK CQ[12020]

    number1 = null; number2 = null; number3 = null; slaveparent = null; name_id = null;
    tab = null; alttab = null; edizm = null; id_edizm = null;
    edizm_type = null; koll = null; skoll = null; normarash = null;
    ba = null; bb = null; bc = null; bd = null; be = null; bf = null; bg = null; bh = null;
    bi = null; bj = null; /*CQ[9359] sea = null; seb = null; sec = null; sed = null; see = null; sef = null;
    seg = null; seh = null; sei = null; sej = null; sek = null;*/ ea = null; eb = null; ec = null; ed = null;
    ee = null; ef = null; eg = null; eh = null; ei = null; ej = null; ek = null; /*CQ[9359]sra = null; srb = null;
     src = null; srd = null; sre = null; srf = null; srg = null; srh = null; sri = null;
    srj = null; srk = null; srl = null; srm = null;*/ ra = null; rb = null; rc = null;
    rd = null; re = null; rf = null; rg = null; rh = null; ri = null; rj = null; rk = null;
    rl = null; rm = null; pa = null; pb = null; pc = null; pd = null; pe = null; vrpz = null;
    idtipr = null;
    ka = null; kb = null; kc = null; kd = null; ke = null; kf = null; kg = null; kh = null;
    ki = null; kj = null; kk = null; KL = null; KM = null; K_ITOGO = null/*14460*/; K_PR = null; /*15421*/
    B_PR = null; --[15352]
    punktind = null; ma = null; mb = null; mc = null; md = null; me = null; mf = null; mg = null;
    mh = null; mi = null; mj = null; mk = null; ml = null; sstch = null; kodzak = null;
    kodgp = null; kodsp = null; kodisp = null; nach = null; okonch = null; tiprab = null; vidrab = null;
    /*idnormativ = null; idnormativuniq = null;*/ kodir_group = null; kodir_podgroup = null; isgroupokp = null; arps_other = null;
    id_s_res = null;
    pr_number1 = null; pr_number2 = null; pr_number3 = null; pr_added_rec = null; pr_vsego = null; pr_vipolneno = null; pr_exists_childs = null; /* lck */
    norm_guid = null; status_rec_cen = null; idreestr = null;
    PCELLMEM = null; IsHaveCorrectionNR = null; CorrectNode = null; CorrectNode = null; asubtype = null;
    CLCMODE = null;
    TYPE_TRUD = null;
     --              RES_PRICE_COUNT = null;
    IDFORMULS = null;--CQ[9359]
    checknode = null;

    ISKS_NS_ID = null; COD_RTM = null; COD_RTM_BLOB = null; -- <-- Voyager CQ[14886,15191]

    select first 1 hch.id --[14124] (isc_sing_select_err) select hch.id
    from A_O_HIERCHECKING hch
    where (hch.iduser = :iduser) and
          (hch.idobject = :idobject) and
          (hch.smetatype = :smetatype) and
          (hch.atype = 15) and
          (hch.idelem = :aid)
    INTO :checknode;

    execute procedure a_s_get_struct_put ( :iduser, :atype, :in_nls, :in_nr, :in_npr )
            returning_values ( :nls, :nr, :npr, :STRUCT_NAME/*SRM*/ );


    if ( atype = 3 )
    then in_idls = aid;
    else if ( atype = 4 )
         then in_idr = aid;


    idnormativ = in_idls;
    idnormativuniq = in_idr;

    idls = in_idls;
    idr = in_idr;


    /*       */  /* MK CQ[991] */
    /*        */
    /* MK CQ[3495] 21.06.2006 */
    execute procedure M_IS_STRUCT_IN_BUFFER(:idobject, :IDUSER)
    returning_values :Is_Buffer;

    if ( cur_projecttype <> 1 )
    then
    begin

--   if (
--       ( checknode is null ) and
--       ( allrec <> 1 )
--      )
     /* MK CQ[991] */
     -- MK 23.01.2012 CQ[9054] --->
     if (( checknode is null ) and (Is_Buffer = 0) and (is_Union = 0)) then atype = -atype;
     --if (( checknode is null ) and (Is_Buffer = 0)) then atype = -atype;
     -- MK 23.01.2012 CQ[9054] <---

     if ( sender <> 1 or atype > 0 ) /*   ,   ,   */
     then
     begin


        /*     */
        -- MK 23.01.2012 CQ[9054] --->
        if ((Is_Buffer = 0) and (is_Union = 0)) then suspend;
        --if ( Is_Buffer = 0 ) then suspend;
        -- MK 23.01.2012 CQ[9054] <---



     end

    end
    else if ( sender = 1 )
         then suspend;
  end


  if (:SENDER <> -1 ) then --<<[11536]
--  if (atype > 0) then
  if ( (atype > 0) or (allrec <> 0) ) then
  begin

   if ( ( show_zero_strings <> 0 ) and ( smetatype > 17 ) ) then
   begin

      utv = 0;
      select first 1 utv from l_is_hier_utv ( :aid , :smetatype , :iduser ) into utv;
      if ( utv <> 0 ) then
         show_zero_strings = 0;
   end

   -- TFS[338],TFS[242]
   if (:SMETATYPE=15/*PSType*/ and exists(select * from A_SMETA_BLOB where IDHIER=:aid and FIELD_NAME='COD_RTM')) then
     COD_RTM_EXISTS = 1;

   for select s.id, s.idhier, s.smetatype, s.number1, s.number2, s.number3, s.slaveparent, s.atype, s.rabmat, s.tab, s.alttab,
              s.name_id, s.id_edizm, /*[12928]s.edizm_type,*/ s.koll, s.skoll, s.normarash,
              s.ba, s.bb, s.bc, s.bd, s.be, s.bf, s.bg, s.bh, s.bi, s.bj,
              --CQ[9359]s.sea,s.seb,s.sec,s.sed,s.see,s.sef,s.seg,s.seh,s.sei, s.sej, s.sek,
              s.ea, s.eb, s.ec, s.ed, s.ee, s.ef, s.eg, s.eh, s.ei, s.ej, s.ek,
              --CQ[9359]s.sra,s.srb,s.src,s.srd,s.sre,s.srf,s.srg,s.srh,s.sri,s.srj,s.srk,s.srl,s.srm,
              s.ra, s.rb, s.rc, s.rd, s.re, s.rf, s.rg, s.rh, s.ri, s.rj, s.rk, s.rl, s.rm,
              s.pa, s.pb, s.pc, s.pd, s.pe, s.vrpz, s.idtipr,
              s.ka, s.kb, s.kc, s.kd, s.ke, s.kf, s.kg, s.kh, s.ki, s.kj, s.kk, s.KL, s.KM,
              s.punktind, s.ma, s.mb, s.mc, s.md, s.me, s.mf, s.mg, s.mh, s.mi, s.mj, s.mk, s.ml,
              s.sstch, s.kodzak, s.kodgp, s.kodsp, s.kodisp, s.nach,
              s.okonch, s.tiprab, s.vidrab, s.idnormativ, /*coalesce(i.idprice,0)*/s.idnormativuniq, s.kodir_group, s.kodir_podgroup, s.isgroupokp, s.arps_other,
              s.id_s_res, s.pr_added_rec, s.norm_guid, s.status_rec_cen,
              s.utv, s.correctnode, s.correctnode_1, s.asubtype, s.clcmode, --              /*coalesce(i.idprice,0)*/s.idnormativuniq,
              s.TYPE_TRUD/*[6921]*/, s.IDFORMULS/*CQ[9359]*/,
              s.nomerrod, v.number1, v.number2, v.number3/*MK CQ[12020]*/, s.K_ITOGO/*14460*/, s.K_PR /*15421*/,
              s.B_PR --[15352]
       from a_smeta s
       left outer join A_SMETA_VIEW_NUM v on s.id = v.id -- MK CQ[12020]
       --left outer join smeta_pricepos_info i on i.id = s.id --CQ[6884]
       where (s.IDHIER = :aid) and
             (s.smetatype = :smetatype)
       order by s.number1, s.number2, s.number3
       into :id, :idhier, :smetatype, :number1, number2, number3, :slaveparent, :atype, :rabmat, :tab, :alttab,
            :name_id, :id_edizm, /*[12928]:edizm_type,*/ :koll, :skoll, :normarash,
            :ba, :bb, :bc, :bd, :be, :bf, :bg, :bh, :bi, :bj,
            --CQ[9359]:sea,:seb,:sec,:sed,:see,:sef,:seg,:seh,:sei, :sej, :sek,
            :ea, :eb, :ec, :ed, :ee, :ef, :eg, :eh, :ei, :ej, :ek,
            --CQ[9359]:sra,:srb,:src,:srd,:sre,:srf,:srg,:srh,:sri,:srj,:srk,:srl,:srm,
            :ra, :rb, :rc, :rd, :re, :rf, :rg, :rh, :ri, :rj, :rk, :rl, :rm,
            :pa, :pb, :pc, :pd, :pe, :vrpz, :idtipr,
            :ka, :kb, :kc, :kd, :ke, :kf, :kg, :kh, :ki, :kj, :kk, :KL, :KM, 
            :punktind, :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi, :mj, :mk, :ml,
            :sstch, :kodzak, :kodgp, :kodsp, :kodisp, :nach,
            :okonch, :tiprab, :vidrab, :idnormativ, :idnormativuniq, :kodir_group, :kodir_podgroup, :isgroupokp, :arps_other,
            :id_s_res, :pr_added_rec, :norm_guid, :status_rec_cen,
            :utv, :CorrectNode, :CorrectNode_1, :asubtype, :CLCMODE, --              :RES_PRICE_COUNT,
            :TYPE_TRUD/*[6921]*/, :IDFORMULS/*CQ[9359]*/,
            :VN_NOMERROD, :view_number1, :view_number2, :view_number3/*MK CQ[12020]*/, :K_ITOGO/*14460*/, :K_PR /*15421*/,
            :B_PR --[15352]
   do
   begin
      EDIZM_TYPE = 0; --<<[12928]

      -- MK CQ[12020] --->
      if (VN_NOMERROD = 0) then
        ADDED_SMETATYPE = SMETATYPE;
      else
      begin
        ADDED_SMETATYPE = null;
        select first 1 s1.smetatype
        from a_smeta s1
        where (s1.id = :VN_NOMERROD)
        into :ADDED_SMETATYPE;

        --   "" 
        ADDED_SMETATYPE = coalesce(ADDED_SMETATYPE, 0);
      end
      -- MK CQ[12020] <---

      /* MK 8.09.2006 CQ[3594] */
      S_BA = ba;
      S_BB = bb;
      S_BC = bc;
      S_BD = bd;
      S_BE = be;
      S_BG = bg;
      S_BH = bh;


      -- MK 22.05.2012 CQ[9460] --->
      STRUCT_SHIFR = null; --    
      if ((idnormativ is not null) and (idnormativ > 0)) then
        select first 1 rm.ident_kod_mat_sap
        from b_rabmat rm
        where (rm.id = :idnormativ) and (rm.rabmat = 3) --   
        into :STRUCT_SHIFR;
      -- MK 22.05.2012 CQ[9460] <---


      /*CQ[9223]if (Rabmat <> 3) then
        idnormativuniq = 0;*/
    --TYPE_TRUD = null;
    UCH = null;
  /*  --             
  if (atype = 17) then
    begin
--      idnormativuniq = 0;
      select count(*) from A_S_RES a
      left outer join smeta_pricepos_info i on i.id = a.id -- CQ [6884]
      where (a.ID_SOURCE = :id) and (i.idprice--ID_PRICE is not null) into :RES_PRICE_COUNT;
    end*/
    if (atype = 18) then
    begin
      if (Rabmat = 1) then
      begin
        select /*[6921]r.TYPE_TRUD,*/ r.UCH,
          r.CLCMODE -- CQ[12244]
        from A_S_RES r where r.ID = :id_s_res
        into /*[6921]:TYPE_TRUD,*/ :UCH,
          :CLCMODE_RES; -- CQ[12244]
        TYPE_TRUD = coalesce(nullif(:TYPE_TRUD, 0), case when :TAB starting '2' then 2 else 1 end);
      end
      else
      begin

        select r.UCH, --             , i.idprice/*, r.ID_PRICE*/
          r.CLCMODE -- CQ[12244]
          from A_S_RES r
          --left outer join smeta_pricepos_info i on i.id = r.id -- CQ [6884]
          where r.ID = :id_s_res
          into :UCH, --             , :RES_PRICE_COUNT;
            :CLCMODE_RES; -- CQ[12244]

         --              if (RES_PRICE_COUNT is null) then RES_PRICE_COUNT = 0;

      end
-->DEN cq[4178]
      if (normarash is null) then normarash = 0;
    end
    else
    begin
      normarash = null;
    end
--<


    if (
        ( cur_id_zone > 0 ) and
        ( cur_savecenzonetonormbase <> 0 )
       )
    then
       execute procedure l_s_select_id_reest ( :iduser , :idnormativ , :RABMAT , :kodir_podgroup ) returning_values ( :IDREESTR );
    else idreestr = null;

    -- rvs:   A_CLC_PREPARE_B_E
    --calk_ba = 0; calk_bb = 0; calk_bc = 0; calk_bd = 0; calk_be = 0;
    --
    --execute procedure a_clc_prepare_b( :iduser, :id, :atype, :id_s_res, :ba, :bb, :bc, :bd, :be )
    --        returning_values( :ba, :bb, :bc, :bd, :be,
    --                          :calk_ba, :calk_bb, :calk_bc, :calk_bd, :calk_be );

    /*CQ[9288]       
    select CLCMODE,
           BA, BB, BC, BD, BE, BG, BH,
           CALK_BA, CALK_BB, CALK_BC, CALK_BD, CALK_BE, CALK_BG, CALK_BG_READONLY, CALK_BH, CALK_BH_READONLY
      from A_CLC_PREPARE_B_E_M(
        :ID, :ATYPE, :ID_S_RES, :PARAM_KODIR_GROUP, :PARAM_KODIR_PODGROUP, :ISCLC, :MODE_KOMPNS_ST,
        :BA, :BB, :BC, :BD, :BE, :BG, :BH, null)
      into :P_CLCMODE,
           :BA, :BB, :BC, :BD, :BE, :BG, :BH,
           :CALK_BA, :CALK_BB, :CALK_BC, :CALK_BD, :CALK_BE, :CALK_BG, :CALK_BG_READONLY, :CALK_BH, :CALK_BH_READONLY;
    CQ[9288]*/

    --<[8168]> .  [AE2874690A54]
    if (:ATYPE = 17) then
    begin
      if (GETBIT(:P_CLCMODE, 6) <> 0) then
        CLCMODE = SETBIT(:CLCMODE, 6, 1);
      if (GETBIT(:P_CLCMODE, 7) <> 0) then
        CLCMODE = SETBIT(:CLCMODE, 7, 1);
    end
    --</[8168]>

    execute procedure b_getname( :iduser, :name_id ) returning_values ( :name );
    -- MK 9.09.2010 CQ[8691] --->
    FULL_STRUCT_NAME = null;
    if (:name is not null) then
    begin
      --CQ[TIMUR 13931]
      --if (LCKGETBLOBLENGTH(:name) <= 255) then
      --  FULL_STRUCT_NAME = S_SUBSTRING255(:name, 1, 255);

      if (LCKGETBLOBLENGTH(:name) <= 1024) then
        FULL_STRUCT_NAME = S_SUBSTRING1024(:name, 1, 1024);
      --CQ[TIMUR 13931]
    end
    -- MK 9.09.2010 CQ[8691] <---


    execute procedure a_get_edizm( :iduser, :id_edizm, :edizm_type ) returning_values ( :edizm );


    ISRESPOPR = 0;
    IsHaveCorrectionNR = 0;
    if (:ATYPE = 17) then
      execute procedure T_ISRESPOPR(:ID, null, :PARAM_KODIR_GROUP, :PARAM_KODIR_PODGROUP)
      returning_values (:ISRESPOPR);
    else
    if (:ATYPE = 18)
    then
      execute procedure T_ISRESPOPR(null, :ID_S_RES, :PARAM_KODIR_GROUP, :PARAM_KODIR_PODGROUP)
      returning_values (:IsHaveCorrectionNR);

    -- lck
    PR_NUMBER1 = 0; PR_NUMBER2 = 0; PR_NUMBER3 = 0;
    PR_VSEGO   = 0.0; PR_VIPOLNENO = 0.0;
    if ( not smetatype in ( 15 , 16 ) ) then
    begin
       execute procedure l_pr_select_rec ( :id, :iduser, :IDOBJECT, :lyear, :lmonth, :USE_ONLY_UTV_PROCENT , 1)
          returning_values ( :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, PR_VSEGO, PR_VIPOLNENO, :PR_EXISTS_CHILDS );
       -- CQ[12834] -->
      --  PR_VIPOLNENO_TOTAL       ,
      --        
      --               
      execute procedure l_pr_select_rec ( :id, :iduser, :IDOBJECT, 9999, 12, :USE_ONLY_UTV_PROCENT , 1)
        returning_values ( :TMP_DOUBLE, :TMP_DOUBLE, :TMP_DOUBLE, :TMP_DOUBLE, :PR_VIPOLNENO_TOTAL, :TMP_DOUBLE);
      -- CQ[12834] <--
    end
    -- lck

    -- MK CQ[12020] --->
    --  ,          
    -- (   )
    if ((ADDED_SMETATYPE = 15) and (SMETATYPE > 999) and (coalesce(VN_NOMERROD, 0) > 0)) then
    begin
      select first 1 v.number1, v.number2, v.number3
      from a_smeta_view_num v
      where (v.id = :VN_NOMERROD)
      into :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3;
    end
    -- MK CQ[12020] <---

    if ( sender = 2 )
    then
    begin

     if ( :rabmat = 3 and :vrpz in (14, 15 ) )
     then execute procedure a_getbrutto_netto( :iduser, :idnormativ, :kodir_podgroup, :rabmat )
          returning_values ( :mk, :ml );

     if ( :atype in (17,18) )
     then select f.atype
          from a_srf_f f
          where f.id_tr = :cur_id_tr and
                f.number = :vrpz
          into :sstch;

     idnormativ = in_idls;

    end

    PCELLMEM = null;

    --TFS[338],TFS[242] -  ...
    if (:COD_RTM_EXISTS <> 0) then
      if (exists(select * from A_SMETA_BLOB where ID=:ID and FIELD_NAME='COD_RTM')) then
        COD_RTM = ' '; --    .       
      else
        COD_RTM = null;
/*$$IBEC$$     -- <-- Voyager CQ[14886,15191]
    --  -  ISKS_NS_ID  COD_RTM
    -- <-- Voyager CQ[14886,15211]
    -- Upd:       ISKS_NS_ID  COD_RTM   
    --  
    ISKS_NS_ID = null;
    COD_RTM = null;
    COD_RTM_BLOB = null;
    --      [31A30561]  A_SMETA_BD1!
    if ((:RABMAT = 3)  $$IBEC$$*//*or (:ATYPE = 19)*//*$$IBEC$$ ) then
    begin
        --     (),  
        if ( exists(select ST.IDSMREC from SPEC_TROW ST where ST.IDSMREC = :ID)) then
        begin
             $$IBEC$$*//*
            select
            first 1 --,   ,   [15211]
             ST.ISKS_NS_ID, ST.COD_RTM, ST.IDHIER, ST.ROW_NUMBER
            from SPEC_TROW ST
            where ST.IDSMREC = :ID
            into :ISKS_NS_ID, :COD_RTM, :SP_IDHIER, :SP_NUMBER;

            COD_RTM_BLOB = null;
            if (STRLEN(COD_RTM) = 60) then
                select STB.FIELD_VALUE
                from  SPEC_TROW_BLOB STB
                where STB.IDHIER = :SP_IDHIER and STB.ROW_NUMBER = :SP_NUMBER
                and STB.FIELD_NAME = 'COD_RTM'
                into :COD_RTM_BLOB;
            *//*$$IBEC$$ 
        end
        --        
        --  (    "")
        else
    end
    else
    begin
       --       null
       -- ISKS_NS_ID = null;
       -- COD_RTM = null;
       -- COD_RTM_BLOB = null;
    end
    -- <-- Voyager CQ[14886,15191] $$IBEC$$*/


    -- rvs:   A_CLC_PREPARE_B_E
    --calk_bg          = 0;
    --calk_bg_readonly = 0;
    --calk_bh          = 0;
    --calk_bh_readonly = 0;
    --
    --if ( :atype = 17 )
    --then execute procedure a_s_get_trud_str_mash( :iduser,
    --                                              :id,
    --                                              :param_kodir_group,
    --                                              :param_kodir_podgroup,
    --                                              :bg,
    --                                              :bh )
    --     returning_values( :bg,
    --                       :bh,
    --                       :calk_bg,
    --                       :calk_bg_readonly,
    --                       :calk_bh,
    --                       :calk_bh_readonly );


    --
    -- MK 29.03.2010 CQ[7436] ( 2) --->
    if ((NO_SUSPEND_STRUCT_REC = 1) or (show_zero_strings <> 0) or (atype = 19) or (LROUNDN(koll, 6) <> 0) )
    --if ( ( show_zero_strings <> 0 ) or ( atype = 19 ) or ( LROUNDN(koll, 3) <> 0 ) )
    -- MK 29.03.2010 CQ[7436] ( 2) <---
    then suspend;

   end

  end

 end
end
^

--TFS[338],TFS[242]
create or alter procedure IS_SPEC_REC (
    FIND_CHILD integer,
    ID_REC integer,
    SMETATYPE integer)
returns (
    SPEC_ISKS_NS_ID integer,
    SPEC_ID_REC integer,
    SPEC_IDHIER integer)
AS
declare variable VN_ID integer;
declare variable VN_RABMAT integer;
declare variable VN_ATYPE integer;
declare variable VN_FIND_REC integer;

declare IDOBJECT integer;
declare IDHIER integer;
begin
-- Sem: [54D0B9CA] -  ,    ...
--         (!!!)
-- :SPEC_IDHIER -  SPEC_TROW.IDHIER == SPEC_ROOT.IDHIER,       A_SMETA.IDHIER (!!!)


  if (:SMETATYPE <> 15/*PSType*/ ) then
    exit;

  --  ...
  select first 1 ISKS_NS_ID, IDSMREC, IDHIER --,   ,   [15211]
    from SPEC_TROW
    where IDSMREC = :ID_REC
  into :SPEC_ISKS_NS_ID, :SPEC_ID_REC, :SPEC_IDHIER;

  --   ...      (    )
  if ( (SPEC_ISKS_NS_ID  is null) and
       (SPEC_ID_REC is null) and
       (SPEC_IDHIER is null) and
       (FIND_CHILD = 1) ) then
  begin

    select IDHIER
      from A_SMETA
      where (ID = :ID_REC)
    into :IDHIER;

    --<[08.09.2017]>
    --    ,      ...
    execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, /*:IDTYPE=*/ 1)
      returning_values :IDOBJECT;
    --,     
    select first 1 H.IDHIER
      from S_O_HIER_SELECT_LEVEL_NF(:IDOBJECT) H
      left join SPEC_ROOT R on R.IDHIER=H.IDHIER
      where R.IDHIER is not null
    into :SPEC_IDHIER;
    --</[08.09.2017]>

    if (:SPEC_IDHIER is not null) then
    begin
      --[54D0B9CA]      ...      
      VN_FIND_REC = null;
      for select ID, RABMAT, ATYPE
         from A_SMETA
         where (IDHIER = :IDHIER) and (SMETATYPE = :SMETATYPE)
         order by --IDHIER desc, -- PLAN SORT,         ???
                  --SMETATYPE desc,
                  NUMBER1 desc,
                  NUMBER2 desc,
                  NUMBER3  desc
      into :VN_ID, :VN_RABMAT, :VN_ATYPE
      do
      begin
  
        if (VN_FIND_REC is not null) then
        begin
          if ( (VN_RABMAT <> 3) or (VN_ATYPE <> 17) )  then
            exit;
  
          select first 1 ISKS_NS_ID, IDSMREC, IDHIER --,   ,   [15211]
            from SPEC_TROW
            where IDSMREC = :VN_ID
          into :SPEC_ISKS_NS_ID, :SPEC_ID_REC, :SPEC_IDHIER;
    
          if (SPEC_ISKS_NS_ID is not null) then
            exit;
        end
  
        if ( (VN_ID = ID_REC) and (VN_RABMAT = 3) and (VN_ATYPE = 17) ) then
          VN_FIND_REC = VN_ID;
      end
    end
  end
end
^

--TFS[338],TFS[242]
create or alter procedure M_GET_SMETA_LIGHT (
    START_ID_HIER integer,
    SMETATYPE integer)
returns (
    ID integer,
    ATYPE smallint,
    RABMAT integer)
AS
declare variable VN_ID_HIER integer;
begin
  --         
  --   ( START_ID_HIER,     IdObject)
  --              
  --       (  )
  --  START_ID_HIER =       /
  ------------------------------------------------------------------------------

  --    
  select h.atype
  from a_o_hier h
  where (h.number = :START_ID_HIER)
  into :ATYPE;

  --     , , ,    +   
  if (ATYPE in (3,4,5)) then -- LSType, RType, PRType
  begin
    ID = START_ID_HIER;
    RABMAT = null;
    suspend;

    --     
    for select s.id, s.atype, s.rabmat
    from a_smeta s
    where (s.idhier = :START_ID_HIER) and (s.smetatype = :SMETATYPE)
    order by s.idhier, s.smetatype, --[08.09.2017]  
        s.number1, s.number2, s.number3
    into :ID, :ATYPE, :RABMAT do
    begin
      suspend;
    end
  end

  --       
  for select NUMBER, ATYPE
  from L_H_SELTREE_HIER(null, :START_ID_HIER)
  into :VN_ID_HIER, :ATYPE do
  begin
    --  
    if (ATYPE <> 0) then -- FolderType
    begin
      --   
      ID = VN_ID_HIER;
      RABMAT = null;
      suspend;

      --     
      for select s.id, s.atype, s.rabmat
      from a_smeta s
      where (s.idhier = :VN_ID_HIER) and (s.smetatype = :SMETATYPE)
      order by s.idhier, s.smetatype, --[08.09.2017]  
          s.number1, s.number2, s.number3
      into :ID, :ATYPE, :RABMAT do
      begin
        suspend;
      end
    end
  end
end
^

--TFS[338],TFS[242]
create or alter procedure S_RR_SELECT_KKS (
    IDOBJECT integer,
    IDRR integer)
returns (
    ID integer,
    RABMAT integer,
    IDSMREC integer,
    TIP_IZM varchar(5),
    ISKS_NS_ID integer,
    COD_RTM varchar(60),
    FIELD_VALUE blob sub_type 1 segment size 80)
AS
declare variable VN_ID_RES_RR integer;
declare variable VN_ID_HIER integer;
declare variable VN_IDSMREC integer;
declare variable NUMBER1 integer;
declare variable SPEC_ID_HIER integer;
declare SMETATYPE integer;
declare COD_RTM_EXISTS integer;
begin
  SMETATYPE = 15;

  --<[08.09.2017]>
  --    ,      ...
  --execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, /*:IDTYPE=*/ 1)
    --returning_values :IDOBJECT;
  --,     
  select first 1 H.IDHIER
    from S_O_HIER_SELECT_LEVEL_NF(:IDOBJECT) H
    left join SPEC_ROOT R on R.IDHIER=H.IDHIER
    where R.IDHIER is not null
  into :SPEC_ID_HIER;
  --</[08.09.2017]>
  if (:SPEC_ID_HIER is null) then
  -- TFS[338],TFS[242]
    select 1
      from S_O_HIER_SELECT_LEVEL_NF(:IDOBJECT) H
        where exists(select * from A_SMETA_BLOB where IDHIER=H.IDHIER and FIELD_NAME='COD_RTM')
      rows 1 --  first 1
      into :COD_RTM_EXISTS;

  if (:SPEC_ID_HIER is not null or :COD_RTM_EXISTS <> 0) then -- TFS[338],TFS[242]
  for select IDDATA
    from S_RRDATA R
    where (IDRR = :IDRR)
  into :VN_ID_RES_RR
  do
  begin
    ID = null;
    select first 1 IDRES, NUMBER, IDHIER
      from S_RRSOURCE_RAB
      where IDRES  = :VN_ID_RES_RR
    into :ID, :NUMBER1, :VN_ID_HIER;

    if (ID is not null) then
    begin
      for select S.ID, S.RABMAT
        from A_SMETA S
        where (S.IDHIER = :VN_ID_HIER)
          and (S.SMETATYPE = :SMETATYPE)
          and (S.NUMBER1 = :NUMBER1)
          and (S.NUMBER2 = 0) --    -
          and (S.NUMBER3 = 0)
      into :VN_IDSMREC, :RABMAT
      do
      if (:RABMAT = 3/*rmMater*/) then -- ...

      if (:COD_RTM_EXISTS <> 0) then
      begin --<TFS[338],TFS[242]>    A_SMETA_BLOB
        for select FIELD_VALUE
          from A_SMETA_BLOB
          where ID = :VN_IDSMREC and FIELD_NAME='COD_RTM'
          into :FIELD_VALUE
        do
        begin
          -- COD_RTM   , ..         ...
          --               :
          COD_RTM = substring(:FIELD_VALUE from 1 for 60);
          if (char_length(:COD_RTM) < 60) then
            FIELD_VALUE = null;
          IDSMREC = :VN_IDSMREC;
          suspend;
        end
      end --</TFS[338],TFS[242]>  -   
      else
      begin
        execute procedure IS_SPEC_REC(1/*FIND_CHILD*/, :VN_IDSMREC, :SMETATYPE)
        returning_values :ISKS_NS_ID, :IDSMREC, :SPEC_ID_HIER;

        for select T.TIP_IZM, T.ISKS_NS_ID,
            coalesce(nullif(T.COD_RTM, ''), T.COD_MCS), --TFS[337],TFS[242] +COD_MCS
            coalesce(R.FIELD_VALUE, M.FIELD_VALUE) --TFS[337],TFS[242] +COD_MCS
          from SPEC_TROW T
          left outer join SPEC_TROW_BLOB R
            on T.IDHIER = R.IDHIER and T.ROW_NUMBER = R.ROW_NUMBER and R.FIELD_NAME = 'COD_RTM'
          left outer join SPEC_TROW_BLOB M --TFS[337],TFS[242] +COD_MCS
            on T.IDHIER = M.IDHIER and T.ROW_NUMBER = M.ROW_NUMBER and M.FIELD_NAME = 'COD_MCS'
          where (T.IDSMREC = :IDSMREC)
        into :TIP_IZM, :ISKS_NS_ID, :COD_RTM,  :FIELD_VALUE
        do
          suspend;
      end
    end
  end
end
^

--TFS[338],TFS[242]
create or alter procedure S_RRDATA_SELECT_SPEC_TROW_CRC (
    IDSMREC integer)
returns (
    CRC integer)
AS
declare variable COD_RTM varchar(60);
declare variable VN_SPEC_ISKS_NS_ID integer;
declare variable VN_SPEC_ID_REC integer;
declare variable VN_SPEC_IDHIER integer;
declare variable FIELD_VALUE blob sub_type text;
begin

  CRC = 0;
  execute procedure IS_SPEC_REC(1/*FIND_CHILD*/, :IDSMREC, 15/*SMETATYPE*/)
  returning_values :VN_SPEC_ISKS_NS_ID, :VN_SPEC_ID_REC, VN_SPEC_IDHIER;

  if (VN_SPEC_ID_REC is not null) then
    for select
        coalesce(nullif(T.COD_RTM, ''), T.COD_MCS),
        coalesce(R.FIELD_VALUE, M.FIELD_VALUE)
      from SPEC_TROW T
      left outer join SPEC_TROW_BLOB R
        on T.IDHIER = R.IDHIER and T.ROW_NUMBER = R.ROW_NUMBER and R.FIELD_NAME = 'COD_RTM'
      left outer join SPEC_TROW_BLOB M
        on T.IDHIER = M.IDHIER and T.ROW_NUMBER = M.ROW_NUMBER and M.FIELD_NAME = 'COD_MCS'
      where /*(T.IDHIER = :VN_SPEC_IDHIER) and -   ???*/ (T.IDSMREC = :VN_SPEC_ID_REC)
      order by T.ISKS_NS_ID
    into :COD_RTM, :FIELD_VALUE
    do
    begin
      if (FIELD_VALUE is not null) then
        CRC = GET_INTEGER_CRC( CRC, K_GETCRC32(FIELD_VALUE) );
      else
        CRC = GET_INTEGER_CRC( CRC, K_GETCRC32S(coalesce(COD_RTM, '')) );
    end
  else
  if (:VN_SPEC_IDHIER is null) then
  --TFS[338],TFS[242]         COD_RTM
  begin
    select FIELD_VALUE
      from A_SMETA_BLOB
      where ID=:IDSMREC and FIELD_NAME='COD_RTM'
      into :FIELD_VALUE;
    if (FIELD_VALUE is not null) then
      CRC = GET_INTEGER_CRC( CRC, K_GETCRC32(:FIELD_VALUE));
  end

  suspend;
end
^

--TFS[338],TFS[242]
create or alter procedure A_S_PASTE_SMETA_RECORD (
    IDUSER integer,
    IDRECORD integer,
    IDHIER integer,
    SMETATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE integer,
    INSERT_TO_ATYPE integer,
    INSERT_TO_ID integer,
    SLAVEPARENT_INSERT integer,
    VSEGO double precision,
    TOBUFFER integer,
    COPY_RES_UCH_STATUS integer)
returns (
    ID integer,
    OUT_SMETATYPE integer,
    OUT_IDFORMULS integer)
AS
declare variable new_id integer;
declare variable rabmat integer;
declare variable type_trud integer;
declare variable tab varchar(42);
declare variable alttab varchar(250);
declare variable name_id integer;
declare variable id_edizm integer;
declare variable edizm_type integer;
declare variable koll double precision;
declare variable skoll varchar(255);
declare variable normarash double precision;
declare variable ba double precision;
declare variable bb double precision;
declare variable bc double precision;
declare variable bd double precision;
declare variable be double precision;
declare variable bf double precision;
declare variable bg double precision;
declare variable bh double precision;
declare variable bi double precision;

declare variable ea double precision;
declare variable eb double precision;
declare variable ec double precision;
declare variable ed double precision;
declare variable ee double precision;
declare variable ef double precision;
declare variable eg double precision;
declare variable eh double precision;
declare variable ei double precision;
declare variable ej double precision;
declare variable ek double precision;

declare variable IDFORMULS integer;
declare variable ra double precision;
declare variable rb double precision;
declare variable rc double precision;
declare variable rd double precision;
declare variable re double precision;
declare variable rf double precision;
declare variable rg double precision;
declare variable rh double precision;
declare variable ri double precision;
declare variable rj double precision;
declare variable rk double precision;
declare variable rl double precision;
declare variable rm double precision;
declare variable pa double precision;
declare variable pb double precision;
declare variable pc double precision;
declare variable pd double precision;
declare variable vrpz integer;
declare variable idtipr integer;
declare variable ka varchar(50);
declare variable kb varchar(50);
declare variable kc varchar(50);
declare variable kd varchar(50);
declare variable ke varchar(50);
declare variable kf varchar(50);
declare variable kg varchar(50);
declare variable kh varchar(50);
declare variable ki varchar(50);
declare variable kj varchar(50);
declare variable kk varchar(50);
declare variable kl varchar(50);
declare variable km varchar(50);
declare variable K_ITOGO varchar(50);
declare variable K_PR varchar(50);
declare variable sstch integer;
declare variable kodzak integer;
declare variable kodgp integer;
declare variable kodsp integer;
declare variable kodisp integer;
declare variable tiprab integer;
declare variable idnormativ integer;
declare variable idnormativuniq integer;
declare variable kodir_group integer;
declare variable kodir_podgroup integer;
declare variable isgroupokp integer;
declare variable punktind varchar(42);
declare variable id_s_res integer;
declare variable norm_guid varchar(100);
declare variable res_norm_id integer;
declare variable res_norm_podgroup integer;
--[10217]declare variable res_kodir_group integer;
--[10217]declare variable res_kodir_podgroup integer;
declare variable res_isgroupokp integer;
declare variable res_rabmat integer;
declare variable res_type_trud integer;
declare variable res_tab varchar(42);
declare variable res_alttab varchar(250);
declare variable res_name_id integer;
declare variable res_idedizm integer;
declare variable res_edizm_type integer;
declare variable res_rashod double precision;
declare variable res_bb double precision;
declare variable res_bc double precision;
declare variable res_bd double precision;
declare variable res_be double precision;
declare variable res_vidnr integer;
declare variable res_uch integer;
declare variable res_status_edit integer;
declare variable res_status_dob_v_zenu integer;
declare variable res_status_rec_cen integer;
declare variable res_note varchar(255);
declare variable res_id_res integer;
declare variable res_norm_guid varchar(100);
declare variable res_rashod_base double precision;
declare variable res_correct varchar(50);
declare variable et_new_id integer;
declare variable et_norm_id integer;
declare variable et_norm_podgroup integer;
--[10217]declare variable et_kodir_group integer;
--[10217]declare variable et_kodir_podgroup integer;
declare variable et_isgroupokp integer;
declare variable et_rabmat integer;
declare variable et_type_trud integer;
declare variable et_tab varchar(42);
declare variable et_alttab varchar(250);
declare variable et_name_id integer;
declare variable et_idedizm integer;
declare variable et_edizm_type integer;
declare variable et_rashod double precision;
declare variable et_bb double precision;
declare variable et_bc double precision;
declare variable et_bd double precision;
declare variable et_be double precision;
declare variable et_vidnr integer;
declare variable et_uch integer;
declare variable et_norm_guid varchar(100);
declare variable vidrab integer;
declare variable atype_source integer;
declare variable slaveparent_source integer;
declare variable ma double precision;
declare variable mb double precision;
declare variable mc double precision;
declare variable md double precision;
declare variable me double precision;
declare variable mf double precision;
declare variable mg double precision;
declare variable mh double precision;
declare variable mi double precision;
declare variable dest_param_kodir_group integer;
declare variable dest_param_kodir_podgroup integer;
declare variable copy_res_id integer;
declare variable smetatype1 integer;
declare variable source_idhier integer;
declare variable target_idhier integer;
declare variable correctnode blob sub_type 0 segment size 80;
declare variable correctnode_1 blob sub_type 0 segment size 80;
declare variable asubtype integer;
declare variable res_id_res_old integer;
declare variable clcmode integer;
declare variable isclc integer;
declare variable dob_uch integer;
declare variable dob_neuch integer;
declare variable res_recall integer;
declare variable p_put_id_rab integer;
declare variable p_put_id_mash integer;
declare variable p_put_id_mat integer;
--[10217]declare variable p_id_zone integer;
declare variable h_number integer;
declare variable h_atype integer;
declare variable mode_kompns_st integer;
declare variable s_clcmode integer;
declare variable s_idhier integer;
declare variable s_smetatype integer;
declare variable src_isclc integer;
declare variable src_mode_kompns_st integer;
declare variable res_dob_v_cenu integer;
declare variable sm_clcmode integer;
declare variable s_ba double precision;
declare variable s_bb double precision;
declare variable s_bc double precision;
declare variable s_bd double precision;
declare variable s_be double precision;
declare variable dest_res_id integer;
declare variable apply_index_as_is integer;
declare variable source_number integer;
declare variable source_atype integer;
--[10217]declare variable src_index_raschnrisp integer;
--[10217]declare variable src_index_brat_zu_is integer;
--[10217]declare variable dst_index_raschnrisp integer;
--[10217]declare variable dst_index_brat_zu_is integer;
declare variable id_price integer;
declare variable row integer;
declare variable price_normoid integer;
declare variable cost double precision;
declare variable KOEF double precision; --CQ[7790]
--declare NE_OBNUL_IND integer;
--declare NE_OBNUL_FORMULS integer;
declare variable CLCMODE_RES integer;
declare variable BN double precision;
declare variable BO double precision;
declare variable B_ITOGO double precision;
declare variable src_param_kodir_group integer;
declare variable src_param_kodir_podgroup integer;

declare variable FIELD_VALUE BLOB SUB_TYPE 1 SEGMENT SIZE 80;

declare B_PR double precision; --[15352]
begin
--[15352]

/*
      (  [9751]  .)
  IDFORMULS       ,
          
     . .. ""   
        ,    
         ...
       -   .
     ""  
         
    ,        , 
         
*/
   CORRECTNODE = null;
   CORRECTNODE_1 = null;
   copy_res_id = null;

   CLCMODE_RES = 0; -- CQ[12244]

   smetatype1 = smetatype;
   if ( smetatype in ( 15 , 16 ) ) then
      execute procedure a_h_get_id_parentatype ( idhier , 1 )
             returning_values ( smetatype1 );
   if ( smetatype = 16 ) then
      smetatype1 = -smetatype1;

   DEST_PARAM_KODIR_GROUP = 1;
   DEST_PARAM_KODIR_PODGROUP = 1;

   SRC_PARAM_KODIR_GROUP = 1;
   SRC_PARAM_KODIR_PODGROUP = 1;

   --    () 
   begin
     execute procedure A_GET_ID_OBJ_AKT(:IDHIER, :SMETATYPE)
       returning_values :H_NUMBER, :H_ATYPE;
   
     if (:H_ATYPE = 1) then
       select f.KODIR_GROUP, f.KODIR_PODGROUP,
           f.ISCLC, f.MODE_KOMPNS_ST,
           --[10217]f.INDEX_RASCHNRISP, f.INDEX_BRAT_ZU_IS,
           --[10217]f.ID_ZONE,
           f.PUT_ID_RAB, f.PUT_ID_MASH, f.PUT_ID_MAT
         from A_O_OBJECTPARAMS f
         where f.NUMBER = :H_NUMBER
         into :DEST_PARAM_KODIR_GROUP, :DEST_PARAM_KODIR_PODGROUP,
           :ISCLC, :MODE_KOMPNS_ST,
           --[10217]:DST_INDEX_RASCHNRISP, :DST_INDEX_BRAT_ZU_IS,
           --[10217]:P_ID_ZONE,
           :P_PUT_ID_RAB, :P_PUT_ID_MASH, :P_PUT_ID_MAT;
     else
     if (:H_ATYPE = 8) then
       select p.KODIR_GROUP, p.KODIR_PODGROUP,
           p.ISCLC, p.MODE_KOMPNS_ST,
           --[10217]p.INDEX_RASCHNRISP, p.INDEX_BRAT_ZU_IS,
           --[10217]p.ID_ZONE,
           p.PUT_ID_RAB, p.PUT_ID_MASH, p.PUT_ID_MAT
         from A_O_FACTPARAMS p
         where p.NUMBER = :H_NUMBER
         into :DEST_PARAM_KODIR_GROUP, :DEST_PARAM_KODIR_PODGROUP,
           :ISCLC, :MODE_KOMPNS_ST,
           --[10217]:DST_INDEX_RASCHNRISP, :DST_INDEX_BRAT_ZU_IS,
           --[10217]:P_ID_ZONE,
           :P_PUT_ID_RAB, :P_PUT_ID_MASH, :P_PUT_ID_MAT;

     --[10217]DST_INDEX_RASCHNRISP = coalesce(:DST_INDEX_RASCHNRISP, 0);
     --[10217]DST_INDEX_BRAT_ZU_IS = coalesce(:DST_INDEX_BRAT_ZU_IS, 0);
   end

   For Select RABMAT, /*[6921]*/TYPE_TRUD, TAB, ALTTAB, NAME_ID, ID_EDIZM, EDIZM_TYPE,
              KOLL, SKOLL, NORMARASH,
              BA, BB, BC, BD, BE,
              BA, BB, BC, BD, BE,
              BF, BG, BH, BI,
              EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK, RA, RB, RC, RD, RE,
              RF, RG, RH, RI, RJ, RK, RL, RM, IDTIPR, KA, KB, KC, KD, KE,
              KF, KG, KH, KI, KJ, KK, KL, KM, 
              SSTCH, KODZAK, KODGP, KODSP, KODISP,
              IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, VRPZ,
              IDFORMULS,--CQ[9359]
              PA, PB, PC, PD, TIPRAB, PUNKTIND, ID_S_RES,
              atype, a.norm_guid, a.vidrab, a.slaveparent, a.ma, a.mb, a.mc, a.md,
              a.me, a.mf, a.mg, a.mh, a.mi, a.correctnode,
              a.idhier, a.correctnode_1, a.asubtype,
              coalesce(a.CLCMODE, 0), --<<rvs:00004098
              a.IDHIER, a.SMETATYPE,
              a.BN, a.BO, a.B_ITOGO/*CQ[13179]*/, a.K_ITOGO,/*14460*/
              a.B_PR /*[15352]*/, a.K_PR /*15421*/
   FROM A_SMETA A
   WHERE A.id = :IDRECORD
   Into       :RABMAT, /*[6921]*/TYPE_TRUD, :TAB, :ALTTAB, :NAME_ID, :ID_EDIZM, :EDIZM_TYPE,
              :KOLL, :SKOLL, :NORMARASH,
              :BA, :BB, :BC, :BD, :BE,
              :S_BA, :S_BB, :S_BC, :S_BD, :S_BE,
              :BF, :BG, :BH, :BI,
              :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK, :RA, :RB, :RC, :RD, :RE,
              :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :IDTIPR, :KA, :KB, :KC, :KD, :KE,
              :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, 
              :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP,
              :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :VRPZ,
              :IDFORMULS,--CQ[9359]
              :PA, :PB, :PC, :PD, :TIPRAB, :PUNKTIND, :ID_S_RES,
              :atype_source, :norm_guid, :vidrab, :slaveparent_source, :ma, :mb, :mc, :md,
              :me, :mf, :mg, :mh, :mi, :CORRECTNODE,
              :SOURCE_IDHIER, :CORRECTNODE_1, :asubtype,
              :CLCMODE, --<<rvs:00004098
              :S_IDHIER, :S_SMETATYPE,
              :BN, :BO, :B_ITOGO/*CQ[13179]*/, :K_ITOGO,/*14460*/
              :B_PR /*[15352]*/, :K_PR /*15421*/
   Do Begin
--     if (atype_source = 18) then
--     begin
--       select ID_PRICE from A_S_RES where ID = :ID into :ID_PRICE;
--     end
     --   - 
     execute procedure A_GET_ID_OBJ_AKT(:S_IDHIER, :S_SMETATYPE)
       returning_values :SOURCE_NUMBER, :SOURCE_ATYPE;
       
     if (:H_ATYPE = 1) then
       select --[10217]f.INDEX_RASCHNRISP, f.INDEX_BRAT_ZU_IS,
              f.ISCLC, f.MODE_KOMPNS_ST,
              KODIR_GROUP, KODIR_PODGROUP
         from A_O_OBJECTPARAMS f
         where f.NUMBER = :SOURCE_NUMBER
         into --[10217]:SRC_INDEX_RASCHNRISP, :SRC_INDEX_BRAT_ZU_IS,
              :SRC_ISCLC, :SRC_MODE_KOMPNS_ST,
              :SRC_PARAM_KODIR_GROUP, :SRC_PARAM_KODIR_PODGROUP;
     else
     if (:H_ATYPE = 8) then
       select --[10217]p.INDEX_RASCHNRISP, p.INDEX_BRAT_ZU_IS,
              p.ISCLC, p.MODE_KOMPNS_ST,
              KODIR_GROUP, KODIR_PODGROUP
         from A_O_FACTPARAMS p
         where p.NUMBER = :SOURCE_NUMBER
         into --[10217]:SRC_INDEX_RASCHNRISP, :SRC_INDEX_BRAT_ZU_IS,
              :SRC_ISCLC, :SRC_MODE_KOMPNS_ST,
              :SRC_PARAM_KODIR_GROUP, :SRC_PARAM_KODIR_PODGROUP;

     --[10217]SRC_INDEX_RASCHNRISP = coalesce(:SRC_INDEX_RASCHNRISP, 0);
     --[10217]SRC_INDEX_BRAT_ZU_IS = coalesce(:SRC_INDEX_BRAT_ZU_IS, 0);

-- DEN cq[4532] -->
--    if ((SOURCE_NUMBER = H_NUMBER) and (SOURCE_ATYPE = H_ATYPE)) then
      APPLY_INDEX_AS_IS = 1;
--    else
--      APPLY_INDEX_AS_IS = 0;
--<

    --<rvs:00004623> - . 
    --if (:SRC_INDEX_RASCHNRISP = 1 and :DST_INDEX_RASCHNRISP <> 1 or
    --    :SRC_INDEX_RASCHNRISP <> 1 and :DST_INDEX_RASCHNRISP = 1 ) then
    --  select :PA, :PB, :MF, :MG
    --    from RDB$DATABASE
    --    into :MF, :MG, :PA, :PB;
    --if (:SRC_INDEX_BRAT_ZU_IS = 0 and :DST_INDEX_BRAT_ZU_IS <> 0 or
    --    :SRC_INDEX_BRAT_ZU_IS <> 0 and :DST_INDEX_BRAT_ZU_IS = 0 ) then
    --  select :PC, :PD, :MH, :MI
    --    from RDB$DATABASE
    --    into :MH, :MI, :PC, :PD;
    --</rvs:00004623>
    execute procedure SWAP_NRSP_AND_ZU(:SOURCE_NUMBER, :h_number, :pa, :pb, :pc, :pd, :mf, :mg, :mh, :mi)
        returning_values :pa, :pb, :pc, :pd, :mf, :mg, :mh, :mi;

    /*       */
    if( :tobuffer = 1 ) then
    begin
      --<[13898]>
      SKOLL = :SKOLL;
      --SKOLL = null;
      --/*   ,          . */
      --/* MK [CQ2883] 14.03.2006 ---> */
      --select first 1 s.skoll
      --from a_smeta s
      --where (s.id = :IDRECORD) and (not (s.skoll like '%{%'))
      --into :SKOLL;
      --/* MK <--- */
      --</>
    end
    else
    begin
      execute procedure s_o_hier_parent_oftype (SOURCE_IDHIER, 3)
      returning_values :SOURCE_IDHIER;

      execute procedure s_o_hier_parent_oftype (IDHIER, 3)
      returning_values :TARGET_IDHIER;

      if (SOURCE_IDHIER<>TARGET_IDHIER) then
      begin
        SKOLL = null;
        /*   ,          . */
        /* MK [CQ2883] 14.03.2006 ---> */
        select first 1 s.skoll
        from a_smeta s
        where (s.id = :IDRECORD) and (not (s.skoll like '%{%'))
        into :SKOLL;
        /* MK <--- */
      end
    end


    ID = null;
    if ( not (
         ( atype_source = 18 ) and ( atype = 18 ) and ( slaveparent_source = slaveparent_insert )
         ) ) then
    begin

      NEW_ID = gen_id(a_g_smeta, 1) ;

   if (ATYPE = 17) then
     begin
        for select IDPRICE, IDNORMO, ROW, COST, KOEF from SMETA_PRICEPOS_INFO
        where ID = :IDRECORD
        into :ID_PRICE, :PRICE_NORMOID, :ROW, :cost,  :KOEF
        do
          execute procedure SET_SMETA_PRICEPOSINFO(:NEW_ID , :ID_PRICE, :PRICE_NORMOID, :ROW, :COST, :KOEF);
      end
/*        */

      --<rvs:2006/11/28>
      --copy_res_id = null;
      --if ( :atype = 18 )
      --then select first 1 s.id_s_res
      --     from a_smeta s
      --     where s.id = :idrecord
      --     into :copy_res_id;
      copy_res_id = :id_s_res;
      --</rvs:2006/11/28>


       --   
       begin
         if (:ATYPE_SOURCE <> 17) then
         begin
           select CLCMODE, BA, BB, BC, BD, BE
             from A_SMETA
             where ID = :SLAVEPARENT_SOURCE
             into :SM_CLCMODE, :S_BA, :S_BB, :S_BC, :S_BD, :S_BE;
           SM_CLCMODE = coalesce(:SM_CLCMODE, 0);
         end
         --<rvs:00004108> -   2006/12/12
         else
           SM_CLCMODE = :CLCMODE;
         --</rvs:00004108>

         --<rvs:00004103>
         if (BIN_AND(:SM_CLCMODE, 3) <> 2) then
         begin
           --      -   

           if (getbit(:MODE_KOMPNS_ST, 31) <> 0) then
           --  
           begin
             --   
             -- < >

             if (getbit(:SRC_MODE_KOMPNS_ST, 31) = 0) then
             --    
             begin
               execute procedure A_CLC_GET_MODE (:SRC_ISCLC)
                 returning_values :S_CLCMODE;
               SM_CLCMODE = BIN_OR(
                   case :S_CLCMODE
                       when 1 then 1
                       when 2 then 3
                              else 0
                   end,
                 BIN_AND(:SM_CLCMODE, BIN_XOR(3, -1)));
             end
             --      -   
           end
           else
           --   
           begin
             --   CLCMODE
             SM_CLCMODE = BIN_AND(:SM_CLCMODE, BIN_XOR(3, -1));
           end

           if (:ATYPE_SOURCE = 17) then -- CQ[TIMUR 14250] if (:INSERT_TO_ATYPE = 17) then
             CLCMODE = :SM_CLCMODE;
         end

         --  STATUS_DOB_V_CENU  
         execute procedure A_S_RES_GET_DEF_ST_DOB_V_CENU3 (:ISCLC, :SM_CLCMODE, :S_BA, :S_BB, :S_BC, :S_BD, :S_BE)
           returning_values :DOB_UCH, :DOB_NEUCH, :RES_RECALL;
         --</rvs:00004103>

         if (:copy_res_id <> 0) then
         begin
           select case when r.UCH <> 0 then :DOB_UCH else :DOB_NEUCH end --CQ [6884] , ID_PRICE
             from A_S_RES r
             where r.ID = :copy_res_id
             into :RES_DOB_V_CENU; --CQ [6884] , :ID_PRICE;

         end
       end


      -- CQ[14220] [13929] -->
      FIELD_VALUE = null;
      select FIELD_VALUE from A_SMETA_BLOB
      where ID = :IDRECORD and FIELD_NAME='TAB'
      into :FIELD_VALUE;
      -- CQ[14220] [13929] <--

      /* MK 20.03.2007 CQ[4761] ---> */
      if (COPY_RES_UCH_STATUS is null) then
         COPY_RES_UCH_STATUS = 1;
      /* MK 20.03.2007 <--- */

      for select
          OUT_ID, OUT_SMETATYPE,

          OUT_IDFORMULS --CQ[9359]
       from A_S_APPENDREC_NL (:IDUSER, :NEW_ID, :IDHIER, :SMETATYPE, :NUMBER1,
              :NUMBER2, :NUMBER3, :SLAVEPARENT, :ATYPE,
              :RABMAT, /*[6921]*/:TYPE_TRUD, :TAB, :ALTTAB, :NAME_ID, :ID_EDIZM, :EDIZM_TYPE,
              :KOLL, :SKOLL, :NORMARASH, :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
              :EA, :EB, :EC, :ED, :EE, :EF, :EG, :EH, :EI, :EJ, :EK, :RA, :RB, :RC, :RD, :RE,
              :RF, :RG, :RH, :RI, :RJ, :RK, :RL, :RM, :IDTIPR, :KA, :KB, :KC, :KD, :KE,
              :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, 
              :SSTCH, :KODZAK, :KODGP, :KODSP, :KODISP, null, null,
              :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP,
              :INSERT_TO_ATYPE, :INSERT_TO_ID, null, :VRPZ,
               :PA, :PB, :PC, :PD, :TIPRAB, :PUNKTIND, :norm_guid,
              :vidrab, :APPLY_INDEX_AS_IS/*1 <<rvs:00004189*/, 1/*APPLAY_FORMULS_AS_IS*/, 1/*APPLAY_POPR_AS_IS*/,
              :ma, :mb, :mc, :md, :me, :mf, :mg, :mh, :mi,
              /* MK 20.03.2007 CQ[4761] ---> */
              case when (:COPY_RES_UCH_STATUS = 1) then :copy_res_id else null end,
              --:copy_res_id
              /* MK 20.03.2007 <--- */

              0, :CORRECTNODE, :CORRECTNODE_1, :asubtype, :CLCMODE, :RES_DOB_V_CENU, 0,
              :IDFORMULS, --CQ[9359]
              :BN, :BO, :B_ITOGO/*CQ[13179]*/, :K_ITOGO,/*14460*/
              :B_PR,/*[15352]*/ :K_PR /*15421*/
              )
         into
              :ID, :OUT_SMETATYPE,
              OUT_IDFORMULS--CQ[9359]
         do
         begin
           if ((ATYPE_SOURCE = 17) and (RABMAT = 0)) then
             execute procedure UPDATE_SMETA_UNION_INFO(:IDNORMATIV, :IDRECORD, :ID);  --CQ[TIMUR 9063]
           -- CQ[14220] [13929] -->
           if (not :FIELD_VALUE is null) then
             insert into A_SMETA_BLOB (ID, FIELD_NAME, FIELD_VALUE)
             values (:ID, 'TAB', :FIELD_VALUE);
          -- CQ[14220] [13929] <--
           suspend;
         end

      if ( not VSEGO is null ) then
      begin
         update l_s_pr_addinfo set pr_vsego = :VSEGO where id = :NEW_ID;
         if ( SMETATYPE = 15 ) then
            update a_smeta set koll = :VSEGO where id = :NEW_ID;
      end

       --if (ATYPE = 17) then
     /* begin
        for select IDPRICE, IDNORMO, ROW, COST from SMETA_PRICEPOS_INFO
        where ID = :IDRECORD
        into :ID_PRICE, :PRICE_NORMOID, :ROW, :COST
        do
          execute procedure SET_SMETA_PRICEPOSINFO(:NEW_ID , :ID_PRICE, :PRICE_NORMOID, :ROW, :COST);
      end   */

--         if ((ATYPE = 18) and (ID_PRICE is not null) and (:COPY_RES_ID <> 0)) then
--         begin
--           select ID_S_RES from A_SMETA where ID = :NEW_ID into :DEST_RES_ID;
--           update A_S_RES set ID_PRICE = :ID_PRICE where ID = :DEST_RES_ID;
--         end

         --<rvs:00004103>
         --     

         if (:RES_RECALL <> 0 and :COPY_RES_ID <> 0) then
         begin
           select ID_S_RES from A_SMETA where ID = :NEW_ID into :DEST_RES_ID;

           execute procedure A_S_RES_RECALL_ONE_RES (:IDUSER,
                                                     :H_NUMBER,
                                                     :DEST_RES_ID,
                                                     :SMETATYPE,
                                                     :VRPZ,
                                                     :DEST_PARAM_KODIR_PODGROUP,
                                                     :P_PUT_ID_RAB,
                                                     :P_PUT_ID_MASH,
                                                     :P_PUT_ID_MAT,
                                                     0,
                                                     1);
         end
         --</rvs:00004103>
      /* MK 20.07.2006   */
      /*     --------------------> */
      if ( atype_source = 17 ) then
      begin
         /*      ------------------------------ */
         for select r.id, r.norm_id, r.norm_podgroup, --[10217]r.kodir_group, r.kodir_podgroup,
                      r.isgroupokp, r.rabmat, r.TYPE_TRUD, r.tab, r.alttab, r.name_id, r.idedizm, r.edizm_type,
                      r.rashod, r.rashod_base, r.correct, r.bb, r.bc, r.bd, r.be,
                      r.vidnr, r.uch, r.status_edit,
                      case when r.UCH <> 0 then :DOB_UCH else :DOB_NEUCH end, --<<r.status_dob_v_zenu,
                      r.status_rec_cen, r.note, r.norm_guid, --CQ [6884]  , r.ID_PRICE
                      r.CLCMODE -- CQ[12244]
         from a_s_res r
         where (ID_SOURCE = :IDRECORD) and
               (KODIR_GROUP = :SRC_PARAM_KODIR_GROUP) and
               (KODIR_PODGROUP = :SRC_PARAM_KODIR_PODGROUP) --[15371]   ,  
           and not exists (select * from a_smeta s  where s.id_s_res = r.id )
         /*[9751]   ,       ...
            :   ,     ,     
             . ORDER BY ID   ID    
                ,    ...*/
         order by r.id_source, r.ID /*[9751] id_source   SORT-INDEX ,
                fb1.5     ORDER-INDEX */
         into :res_id_res_old, :res_norm_id, :res_norm_podgroup, --[10217]:res_kodir_group, :res_kodir_podgroup,
              :res_isgroupokp, :res_rabmat, :RES_TYPE_TRUD, :res_tab, :res_alttab, :res_name_id, :res_idedizm, :res_edizm_type,
              :res_rashod, :res_rashod_base, :res_correct, :res_bb, :res_bc, :res_bd, :res_be,
              :res_vidnr, :res_uch, :res_status_edit,
              :res_status_dob_v_zenu,
              :res_status_rec_cen, :res_note, :res_norm_guid, --CQ [6884] , :ID_PRICE
              :CLCMODE_RES  -- CQ[12244]
         do
         begin
             -- <-- Voyager CQ[11332]
             --   ,  ,  A_S_RES.
             --              
             if ( (TOBUFFER = 1) and (coalesce(:res_norm_id,0) = 0)) then
             begin
                 select first 1 CL.BB, CL.BC, CL.BD, CL.BE
                 from A_S_RES_CENLVL CL
                 where CL.ID = :res_id_res_old
                 order by CL.IDCENLVL
                 into :res_bb, :res_bc, :res_bd, :res_be;
    
                 update A_S_RES R
                 set
                    R.BB = :res_bb,
                    R.BC = :res_bc,
                    R.BD = :res_bd,
                    R.BE = :res_be
                 WHERE 
                    R.ID = :res_id_res_old;
             end
             -- <-- Voyager CQ[11332]

            res_id_res = gen_id(a_g_smeta, 1) ;
            for select IDPRICE, IDNORMO, ROW, COST, KOEF from SMETA_PRICEPOS_INFO
            where ID = :res_id_res_old
            into :ID_PRICE, :PRICE_NORMOID, :ROW, :COST, :KOEF
            do
              execute procedure SET_SMETA_PRICEPOSINFO(:res_id_res , :ID_PRICE, :PRICE_NORMOID, :ROW, :COST, :KOEF);
/* MK 20.07.2006     m_et_res_append,      */
/*
            --   (   )
            insert into a_s_res ( id, id_source, norm_id, norm_podgroup, kodir_group, kodir_podgroup,
                                  isgroupokp, rabmat, tab, alttab, name_id, idedizm, edizm_type,
                                  rashod, rashod_base, correct, bb, bc, bd, be, vidnr, uch,
                                  status_edit, status_dob_v_zenu, status_rec_cen, note,

                                  nomerrod, smetatype, norm_guid, idhier, type_trud )
                   values ( :res_id_res, :NEW_ID, :res_norm_id, :res_norm_podgroup, :DEST_PARAM_KODIR_GROUP, :DEST_PARAM_KODIR_PODGROUP,
                            :res_isgroupokp, :res_rabmat, :res_tab, :res_alttab, :res_name_id, :res_idedizm, :res_edizm_type,
                            :res_rashod, :res_rashod_base, :res_correct, :res_bb, :res_bc, :res_bd, :res_be, :res_vidnr, :res_uch,
                            :res_status_edit, :res_status_dob_v_zenu, :res_status_rec_cen, :res_note,
                            null, :smetatype1, :res_norm_guid, :idhier, :res_type_trud );
*/

            /* MK CQ[3572], CQ[3569] 20.07.2006 */
            /*        (mode = 1) */
            execute procedure m_et_res_append(:iduser, :res_id_res, :NEW_ID, :res_norm_id,
                                              :res_norm_podgroup, :DEST_PARAM_KODIR_GROUP,
                                              :DEST_PARAM_KODIR_PODGROUP,
                                              :res_isgroupokp, :res_rabmat, :res_tab, :res_alttab, :res_name_id,
                                              :res_idedizm, :res_edizm_type, :res_rashod, :res_rashod_base,
                                              :res_correct, :res_bb, :res_bc, :res_bd, :res_be, :res_vidnr,
                                              :res_uch, :res_status_edit, :res_status_dob_v_zenu,
                                              :res_status_rec_cen, :res_note, null,--:nomerrod,
                                              :res_norm_guid, :res_type_trud,

                                              null,--:et_norm_id
                                              null,--:et_norm_podgroup
                                              null,--:et_kodir_group
                                              null,--:et_kodir_podgroup
                                              null,--:et_isgroupokp
                                              null,--:et_rabmat
                                              null,--:et_tab
                                              null,--:et_alttab
                                              null,--:et_name_id
                                              null,--:et_idedizm
                                              null,--:et_edizm_type
                                              null,--:et_rashod
                                              null,--:et_bb
                                              null,--:et_bc
                                              null,--:et_bd
                                              null,--:et_be
                                              null,--:et_vidnr
                                              null,--:et_uch
                                              null,--:et_norm_guid
                                              null,--:et_type_trud

                                              0,--:sender
                                              1, --:mode (1 -  )
                                              CLCMODE_RES);-- CQ[12244]
                                              --CQ [6884]  :ID_PRICE);

            --[13929,14220]
            if (char_length(:RES_TAB)=42) then
              insert into A_S_RES_BLOB (ID, FIELD_NAME, FIELD_VALUE)
                select :RES_ID_RES, FIELD_NAME, FIELD_VALUE from A_S_RES_BLOB
                    where ID=:RES_ID_RES_OLD and FIELD_NAME='TAB';

         end -- end for select   


         --<rvs:00004103>
         --         
         if (:RES_RECALL <> 0) then
         begin
           --   
           execute procedure A_S_RES_RECALL_NL (:IDUSER, :NEW_ID, :H_NUMBER, 1);
         end
         --</rvs:00004103>

           /*      -----------------------------
              ( ,          ) */
         for select r.norm_id, r.norm_podgroup, --[10217]r.kodir_group, r.kodir_podgroup,
                    r.isgroupokp, r.rabmat, r.TYPE_TRUD, r.tab, r.alttab, r.name_id, r.idedizm, r.edizm_type,
                    r.rashod, r.bb, r.bc, r.bd, r.be,
                    r.vidnr, r.uch,
                    r.norm_guid
         from m_etalon_s_res r
         where (ID_SOURCE = :IDRECORD) and
               (KODIR_GROUP = :SRC_PARAM_KODIR_GROUP) and
               (KODIR_PODGROUP = :SRC_PARAM_KODIR_PODGROUP) --[15371]   ,  
         order by r.id_source, r.ID --<<[9751]
         into :et_norm_id, :et_norm_podgroup, --[10217]:et_kodir_group, :et_kodir_podgroup,
              :et_isgroupokp, :et_rabmat, :ET_TYPE_TRUD, :et_tab, :et_alttab, :et_name_id, :et_idedizm, :et_edizm_type,
              :et_rashod, :et_bb, :et_bc, :et_bd, :et_be,
              :et_vidnr, :et_uch,
              :et_norm_guid
         do
         begin
            et_new_id = gen_id(a_g_smeta, 1);

            /*        (mode = 2) */
            execute procedure m_et_res_append(:iduser, :et_new_id, :NEW_ID,
                                              null/*:res_norm_id*/,
                                              null/*:res_norm_podgroup*/,
                                              null/*:DEST_PARAM_KODIR_GROUP*/,
                                              null/*:DEST_PARAM_KODIR_PODGROUP*/,
                                              null/*:res_isgroupokp*/,
                                              null/*:res_rabmat*/,
                                              null/*:res_tab*/,
                                              null/*:res_alttab*/,
                                              null/*:res_name_id*/,
                                              null/*:res_idedizm*/,
                                              null/*:res_edizm_type*/,
                                              null/*:res_rashod*/,
                                              null/*:res_rashod_base*/,
                                              null/*:res_correct*/,
                                              null/*:res_bb*/,
                                              null/*:res_bc*/,
                                              null/*:res_bd*/,
                                              null/*:res_be*/,
                                              null/*:res_vidnr*/,
                                              null/*:res_uch*/,
                                              null/*:res_status_edit*/,
                                              null/*:res_status_dob_v_zenu*/,
                                              null/*:res_status_rec_cen*/,
                                              null/*:res_note*/,
                                              null/*:nomerrod*/,
                                              null/*:res_norm_guid*/,
                                              null/*:res_type_trud*/,

                                              :et_norm_id, :et_norm_podgroup,
                                              /* MK 28.11.2006 CQ[4110] ---> */
                                              :DEST_PARAM_KODIR_GROUP,
                                              :DEST_PARAM_KODIR_PODGROUP,
                                              --:et_kodir_group, :et_kodir_podgroup,
                                              /* MK 28.11.2006 <--- */


                                              :et_isgroupokp,
                                              :et_rabmat, :et_tab, :et_alttab, :et_name_id, :et_idedizm,
                                              :et_edizm_type, :et_rashod,
                                              :et_bb, :et_bc, :et_bd, :et_be, :et_vidnr, :et_uch,
                                              :et_norm_guid, :et_type_trud,

                                              0/*:sender*/,
                                              2, /*:mode ( )*/
                                              0);-- CQ[12244] CLCMODE_RES = 0
                                              --CQ [6884]  null);

         end -- end for select   

      end
           /*     <---------- */


    end
   End
END
^

--TFS[338],TFS[242]
create or alter procedure A_S_RES_TO_SLAVEREC_NL_2 (
    IDUSER integer,
    ID_RES integer,
    ID_SMREC integer,
    PUNKTIND varchar(42),
    VRPZ integer,
    INSERT_MODE integer,
    IDZONE integer,
    APPLY_POPR_MODE integer,
    ISMANUAL integer,
    IDNORMATIVUNIQ integer,
    PASTE_AS_IS integer)
returns (
    ADDED_SLAVE integer,
    OUT_SMETATYPE integer,
    OUT_IDFORMULS integer)
AS
--   
-- ISMANUAL - 1 -    ( ), 0 -    Ctrl_Enter
declare variable CUR_ID_SM integer;
declare variable CUR_IDHIER integer;
declare variable CUR_SMETATYPE integer;
declare variable CUR_NUMBER1 integer;
declare variable CUR_NUMBER2 integer;
declare variable NEW_NUMBER2 integer;
declare variable CUR_RABMAT integer;
declare variable CUR_TYPE_TRUD integer;
declare variable CUR_TAB varchar(42);
declare variable CUR_ALTTAB varchar(250);
declare variable CUR_NAME_ID integer;
declare variable CUR_IDEDIZM integer;
declare variable CUR_EDIZM_TYPE integer;
declare variable CUR_KOLL_SMREC double precision;
declare variable CUR_RASHOD_RES double precision;
declare variable CUR_RASHOD_BASE double precision;
declare variable NEW_KOLL double precision;
declare variable CUR_BA double precision;
declare variable CUR_BB double precision;
declare variable CUR_BC double precision;
declare variable CUR_BD double precision;
declare variable CUR_BE double precision;
declare CUR_B_PR double precision; --[15352]
declare variable CUR_NORM_ID integer;
declare variable CUR_IDNORMATIVUNIQ integer;
declare variable CUR_NORM_PODGROUP integer;
declare variable CUR_KODIR_GROUP integer;
declare variable CUR_KODIR_PODGROUP integer;
declare variable CUR_ISGROUPOKP integer;
declare variable CUR_INSERT_TO_ATYPE integer;
declare variable CUR_INSERT_TO_ID integer;
declare variable CUR_NORM_GUID varchar(100);
declare variable CUR_CORRECT varchar(50);
declare variable NEW_ATYPE integer;
declare variable NEW_SLAVEPARENT integer;
declare variable NEW_ID_RES integer;
declare variable NEW_RASHOD_RES double precision;
declare variable TMP_ID integer;

--declare variable res_pz double precision;
--declare variable res_zp_mash double precision;
--declare variable mode_kompns_st integer;

declare RES_TYPE_TRUD integer;

declare variable RES_NOMERROD integer;
declare variable S_ORDERVIEW integer;
declare variable ID_S_RES integer;
declare variable IDSOURCE integer;

declare variable NOZONEMODE integer;

declare variable ZONE_BA double precision;
declare variable ZONE_BB double precision;
declare variable ZONE_BC double precision;
declare variable ZONE_BD double precision;
declare variable ZONE_BE double precision;
declare variable ISZONEFIND integer;

declare variable KA varchar(50);
declare variable KB varchar(50);
declare variable KC varchar(50);
declare variable KD varchar(50);
declare variable KE varchar(50);
declare variable KF varchar(50);
declare variable KG varchar(50);
declare variable KH varchar(50);
declare variable KI varchar(50);
declare variable KJ varchar(50);
declare variable KK varchar(50);
declare variable KL varchar(50);
declare variable KM varchar(50);
declare variable K_ITOGO varchar(50);
declare variable K_PR varchar(50);

declare variable ID_SM_REC_CH_TRUD integer;
declare variable ID_SL_REC_CH_NR_AND_KOLL integer;

declare variable CUR_UCH integer;
declare variable NEED_CONVERT_POPR integer;
declare variable COPY_RES_POPR integer;
declare variable CALC_MODE integer;
declare variable CUR_CLCMODE integer;
declare variable NEW_CLCMODE integer;

declare variable CORRECTNODE blob sub_type TEXT;
declare variable CORRECTNODE_1 blob sub_type TEXT;

declare variable TMP_CORRECT varchar(50);

--CQ[9273]>>
declare variable TYPE_RAB integer;
declare variable VID_RAB integer;
declare variable IDOBJECT integer;
declare variable ID_LEVEL integer;

declare variable NL_ID_LEVEL_VC integer;
declare variable NL_IDZONE integer; 
declare variable NL_ID_LEVEL_INDEX integer;
declare variable NL_IDINDEX integer; 
declare variable NL_BA double precision;
declare variable NL_BB double precision;
declare variable NL_BC double precision;
declare variable NL_BD double precision;
declare variable NL_BE double precision;
declare NL_B_PR double precision; --[15352]
declare variable NL_MA double precision;
declare variable NL_MB double precision;
declare variable NL_MC double precision;
declare variable NL_MD double precision;
declare variable NL_ME double precision;
declare variable NL_MF double precision;
declare variable NL_MG double precision;
declare variable NL_MH double precision;
declare variable NL_MI double precision;
declare variable NL_PUNKTIND varchar(42);
declare variable NL_SPOSOB_RASCH integer;
declare variable NL_RES_VC integer; 
declare variable NL_RES_INDEX integer;
declare variable VN_PA double precision;
declare variable VN_PB double precision;
declare variable VN_PC double precision;
declare variable VN_PD double precision;

declare variable IN_RES_COPY_FORMULS integer;
declare variable APPLYONRES integer;
declare variable IDTR integer;

declare variable VN_IDSTRUCT integer;

-- MK 2.05.2012 CQ[10381]
declare variable VN_IS_UNION integer;
declare variable VN_SKOLL varchar(255);
declare variable VN_UKR_KOLL double precision;


declare variable NL_MJ double precision;
declare variable NL_MK  double precision;
declare variable NL_ML double precision;
declare variable NL_MM double precision;
declare NL_M_PR double precision; --[15352]
declare variable NL_DA double precision;
declare variable NL_DB double precision;
declare variable NL_DC double precision;
declare variable NL_DD double precision;
declare variable NL_DE double precision;
declare variable NL_DJ double precision;
declare variable NL_DK  double precision;
declare variable NL_DL double precision;
declare variable NL_DM double precision;

declare variable NEED_APPLY_INDEX integer;

-- MK  CQ[12391]
declare variable VN_CURR_BB double precision;
declare variable VN_ID_REC_IN_SMETA integer;
declare variable VN_NEED_CHECK_IDX_MAIN_REC integer;

--[14593]declare variable VN_IS_LIC_VC integer;
declare variable VN_USE_BA double precision;
declare variable VN_USE_BB double precision;
declare variable VN_USE_CURRCENA double precision;
declare variable VN_CURR_CENA_INFO integer;
declare variable VN_NORM_BA double precision;
declare variable VN_NORM_BB double precision;

--<[14593]>
declare IDCLASS integer;
declare USE_MULTIRULES integer; --</>

-- MK CQ[14930] --->
declare variable VN_SM_TIPRAB integer;
declare variable VN_PROJECT_MODES integer;
-- MK CQ[14930] <---

-- MK CQ[15662.1] --->
declare APPLY_TO_ALL_IDLEVEL_SNB integer;
declare SOURCE_LEVEL_ID integer;
-- MK CQ[15662.1] <---
begin
--[15352]

  /*
  APPLY_POPR_MODE = 0  - RES_COPY_POPR
  APPLY_POPR_MODE = 1  - 
  APPLY_POPR_MODE = 2  -  ()
  APPLY_POPR_MODE = 3  - 
*/
  ADDED_SLAVE = 0;

  NEED_APPLY_INDEX = 1;--CQ[10929] :  = 1,    

  if (INSERT_MODE is null) then
    INSERT_MODE = 0;

  /* semenov -  NULL  
 OUT_SEA = null; OUT_SEB = null; OUT_SEC = null; OUT_SED = null; OUT_SEE = null;
                 OUT_SEF = null; OUT_SEG = null; OUT_SEH = null; OUT_SEI = null;
 OUT_SRA = null; OUT_SRB = null; OUT_SRC = null; OUT_SRD = null; OUT_SRE = null;
                 OUT_SRF = null; OUT_SRG = null; OUT_SRH = null; OUT_SRI = null;
                 OUT_SRJ = null; OUT_SRK = null; OUT_SRL = null; OUT_SRM = null;
*/

  if (not exists(select *
                 from A_SMETA S
                 where S.ID = :ID_SMREC)) then
    exit;

  if (not exists(select *
                 from A_S_RES R
                 where R.ID = :ID_RES)) then
    exit;

  CUR_ID_SM = gen_id(A_G_SMETA, 1);

  select S.IDHIER, S.SMETATYPE, S.NUMBER1, S.KOLL,
         S.ATYPE, S.CLCMODE, S.CORRECTNODE,
         S.CORRECTNODE_1,
         S.TIPRAB -- MK CQ[14930]
  from A_SMETA S
  where S.ID = :ID_SMREC
  into :CUR_IDHIER, :CUR_SMETATYPE, :CUR_NUMBER1,
       :CUR_KOLL_SMREC, :CUR_INSERT_TO_ATYPE,
       :CUR_CLCMODE, :CORRECTNODE, :CORRECTNODE_1,
       :VN_SM_TIPRAB; -- MK CQ[14930]

  NEW_CLCMODE = 0;
  if (GETBIT(:CUR_CLCMODE, 8) <> 0) then
    NEW_CLCMODE = SETBIT(NEW_CLCMODE, 8, 1);
  if (GETBIT(:CUR_CLCMODE, 9) <> 0) then
    NEW_CLCMODE = SETBIT(NEW_CLCMODE, 9, 1);

  -- CQ[12244] -->
  /* --[12489,12244]
  if (INSERT_MODE = 1) then
    NEW_CLCMODE = SETBIT(NEW_CLCMODE, 15, 1); */
  -- CQ[12244] <--

  --DEN-->21/3/5
  execute procedure D_GET_NOZONEMODE(:CUR_IDHIER,
      :CUR_SMETATYPE)
      returning_values :NOZONEMODE;
  --<

  -- MK 2.05.2012 CQ[10381]
  execute procedure M_IS_HIER_IN_UNION(:CUR_IDHIER) returning_values :VN_IS_UNION;


  if (INSERT_MODE <> 0) then
  begin
    TMP_ID = null;
    select first 1 ID_SOURCE
    from A_S_RES
    where ID = :ID_RES
    into TMP_ID;
    if (not TMP_ID is null) then
      select first 1 KOLL
      from A_SMETA
      where ID = :TMP_ID
      into CUR_KOLL_SMREC;
  end

  if (INSERT_MODE = 0) then
  begin
    NEW_ATYPE = 18;
    NEW_SLAVEPARENT = ID_SMREC;
    NEW_ID_RES = ID_RES;

    NEW_NUMBER2 = 1;
    for select S.NUMBER2
        from A_SMETA S
        where S.SLAVEPARENT = :ID_SMREC
        into :CUR_NUMBER2
    do
      if (NEW_NUMBER2 <= :CUR_NUMBER2) then
        NEW_NUMBER2 = :CUR_NUMBER2 + 1;
  end
  else
  begin
    NEW_ATYPE = 17;
    NEW_SLAVEPARENT = 0;
    NEW_ID_RES = null;

    CUR_NUMBER1 = CUR_NUMBER1 + 1;
    NEW_NUMBER2 = 0;
  end

  CUR_NORM_GUID = null;

  select R.RABMAT, R.TAB, R.ALTTAB, R.NAME_ID,
         R.IDEDIZM, R.EDIZM_TYPE, R.RASHOD,
         R.RASHOD_BASE, R.BB, R.BC, R.BD, R.BE,
         R.NORM_ID, R.KODIR_GROUP,
         R.KODIR_PODGROUP, R.ISGROUPOKP,
         R.NORM_PODGROUP, R.NORM_GUID, R.NOMERROD,
         R.CORRECT, R.UCH, R.TYPE_TRUD
  from A_S_RES R
  where R.ID = :ID_RES
  into :CUR_RABMAT, :CUR_TAB, :CUR_ALTTAB,
       :CUR_NAME_ID, :CUR_IDEDIZM,
       :CUR_EDIZM_TYPE, :CUR_RASHOD_RES,
       :CUR_RASHOD_BASE, :CUR_BB, :CUR_BC,
       :CUR_BD, :CUR_BE, :CUR_NORM_ID,
       :CUR_KODIR_GROUP, :CUR_KODIR_PODGROUP,
       :CUR_ISGROUPOKP, :CUR_NORM_PODGROUP,
       :CUR_NORM_GUID, :RES_NOMERROD,
       :CUR_CORRECT, :CUR_UCH, :RES_TYPE_TRUD;
  -->DEN cq[4009]
  if (CUR_RABMAT = 1) then
    CUR_TYPE_TRUD = coalesce(nullif(:RES_TYPE_TRUD, 0), case
                                                          when :CUR_TAB starting '2' then 2
                                                          else 1
                                                        end);
--<

  CUR_BA = CUR_BB + CUR_BC + CUR_BE;
  
  
  --DEN-->21/3/5
  if ((NOZONEMODE = 1) and
      (CUR_RABMAT <> 0)) then
  begin
    execute procedure L_FILL_CCURRENT1(:CUR_NORM_ID,
        :CUR_RABMAT, :CUR_NORM_PODGROUP, :IDZONE,
        :IDUSER)
        returning_values :ZONE_BA, :ZONE_BB,
        :ZONE_BC, :ZONE_BD, :ZONE_BE, :ISZONEFIND;
    if ((ISZONEFIND = 1) or (IDZONE = -1)) then
    begin
      CUR_BB = :ZONE_BB;
      CUR_BC = :ZONE_BC;
      CUR_BD = :ZONE_BD;
      CUR_BE = :ZONE_BE;
      CUR_BA = :ZONE_BA;
    end
  end
  --<
  
  CUR_INSERT_TO_ID = ID_SMREC;
  
  if (INSERT_MODE = 0) then
  begin
    CUR_INSERT_TO_ATYPE = 17;
  
    /*if ( exists ( select * - semenov -   ,   ...
                  from a_smeta s
                  where ( s.slaveparent = :id_smrec ) and
                        ( s.atype = 19 ) ) )
    then*/ for select S.ID
        from A_SMETA S
        where (S.SLAVEPARENT = :ID_SMREC) and
              (S.ATYPE = 19) and
              (S.NUMBER2 = 0)
        order by S.NUMBER1
        into :CUR_INSERT_TO_ID
    do
      CUR_INSERT_TO_ATYPE = 19;
  end
  
  CUR_IDNORMATIVUNIQ = IDNORMATIVUNIQ;--CQ[9223]
  if ((PUNKTIND is null) and
      (VRPZ is null)) then
    select S.PUNKTIND, S.VRPZ, S.ID_UNIQUE,
           s.ba, s.bb              -- MK CQ[11989, 12174]
    from L_FB_SEARCH_NORMATIV(:CUR_NORM_ID, :CUR_NORM_PODGROUP, :CUR_RABMAT, null, null, :IDUSER, null, null, null, null, null) S
    into :PUNKTIND, :VRPZ, :CUR_IDNORMATIVUNIQ, --CQ[9223] CUR_IDNORMATIVUNIQ
         :VN_NORM_BA, :VN_NORM_BB; -- MK CQ[11989, 12174]
  
  /*    . ,
     NOMERROD  ,    */
  
  --CQ[11307] NEW_KOLL = :CUR_RASHOD_RES * :CUR_KOLL_SMREC;
  
  NEW_RASHOD_RES = CUR_RASHOD_RES;
  
  --CQ[11307] -->    if (INSERT_MODE <> 0) then
  --CQ[11307] <--NEW_RASHOD_RES = null;
  
  -->DEN cq[4009]
  CALC_MODE = 0;
  --  if (insert_mode = 0) then
  begin
    if ((not APPLY_POPR_MODE is null) and
        (GETBIT(:CUR_CLCMODE, 1) <> 0)) then
      APPLY_POPR_MODE = SETBIT(:APPLY_POPR_MODE, 3, 1);
    select COPY_RES_POPR, CALC_MODE
    from D_DECODE_APPLY_POPR_MODE(:APPLY_POPR_MODE)
    into :COPY_RES_POPR, :CALC_MODE;
  
    --CQ[11307] -->        .  .
    -- select RESULT
    --from D_NEED_CONVERT_POPR(:APPLY_POPR_MODE, :CUR_UCH)
    --CQ[11307] <-- into :NEED_CONVERT_POPR;
  
    NEED_CONVERT_POPR = 0; --CQ[11307]
  end
  --  else
  --    NEED_CONVERT_POPR = 0;
  
  if (/*(insert_mode = 0) and */ (CUR_UCH <> 0) and
      (CALC_MODE = 1)) then
  -- cq [4477]  insert_mode  ..            
  begin
    --CQ[11307] -->
    if (NEW_RASHOD_RES > 0) then
      NEW_RASHOD_RES = :NEW_RASHOD_RES * -1;
  
    if (CUR_RASHOD_BASE > 0) then
      CUR_RASHOD_BASE = :CUR_RASHOD_BASE * -1;
  
    NEW_KOLL = :NEW_RASHOD_RES * :CUR_KOLL_SMREC;
  
    if (insert_mode = 1) then -- CQ[12534]
      NEW_CLCMODE = SETBIT(NEW_CLCMODE, 15, 1); --<<[12489,12244]
  
    update A_S_RES R
    set R.RASHOD = :NEW_RASHOD_RES,
        R.RASHOD_BASE = :CUR_RASHOD_BASE,
        CLCMODE = SETBIT(coalesce(CLCMODE, 0), 15, 1) -- CQ[12244]
    where R.ID = :ID_RES;
    --CQ[11307] <--
  
  
    --CQ[11307] --> if (CUR_RASHOD_BASE > 0) then
      --NEW_RASHOD_RES = :CUR_RASHOD_BASE * -1;
    --else
      --NEW_RASHOD_RES = :CUR_RASHOD_BASE;
    --NEW_KOLL = :NEW_RASHOD_RES * :CUR_KOLL_SMREC;
  
    --update A_S_RES R
    --set R.RASHOD = :NEW_RASHOD_RES,
        --R.RASHOD_BASE = :NEW_RASHOD_RES,
        --R.CORRECT = ''
    --CQ[11307] <-- where R.ID = :ID_RES;
  
  end
  else
  begin
    NEW_KOLL = :NEW_RASHOD_RES * :CUR_KOLL_SMREC; --CQ[11307]
  end


  
  if ((COPY_RES_POPR = 1) and (INSERT_MODE <> 1)) then--CQ[11307] ((NEED_CONVERT_POPR <> 0)) then
  begin
    select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ,
           KK, KL, KM, K_ITOGO /*14460*/, K_PR /*15421*/
    from A_SMETA
    where ID = :ID_SMREC
    into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH,
         :KI, :KJ, :KK, :KL, :KM, :K_ITOGO/*14460*/, :K_PR /*15421*/;
  end
  else
  begin
    KA = '';
    KB = '';
    KC = '';
    KD = '';
    KE = '';
    KF = '';
    KG = '';
    KH = '';
    KI = '';
    KJ = '';
    KK = '';
    KL = '';
    KM = '';
    K_ITOGO = ''; /*14460*/
    K_PR = ''; /*15421*/
  end
  
  -- MK 1.09.2009 CQ[7406]
  select GP.CORRECT
    from D_GET_POPR_VALUE(:KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
      :K_ITOGO/*14460*/, :K_PR/*15421*/, :CUR_RABMAT, :CUR_TYPE_TRUD, :NEED_CONVERT_POPR) GP
  into :TMP_CORRECT;
  
  --CQ[11307] -->
  if ((COPY_RES_POPR = 1) and (INSERT_MODE <> 1)) then
  begin
    CUR_CORRECT = TMP_CORRECT;
    KA = '';
    KB = '';
    KC = '';
    KD = '';
    KE = '';
    KF = '';
    KG = '';
    KH = '';
    KI = '';
    KJ = '';
    KK = '';
    KL = '';
    KM = '';
    K_ITOGO = ''; /*14460*/
    K_PR = ''; /*15421*/

    update A_S_RES R
    set R.CORRECT = :CUR_CORRECT
    where R.ID = :ID_RES;
  end
  --CQ[11307] <--
  
  
  
  
  if (INSERT_MODE = 1) then
  begin
    -- MK 1.09.2009 CQ[7406] --->
    CUR_CORRECT = TMP_CORRECT;
    --select gp.CORRECT from D_GET_POPR_VALUE(:KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :CUR_RABMAT, :CUR_TYPE_TRUD, :NEED_CONVERT_POPR) gp
    --into :CUR_CORRECT;
    -- MK 1.09.2009 CQ[7406] <---
  
    KA = '';
    KB = '';
    KC = '';
    KD = '';
    KE = '';
    KF = '';
    KG = '';
    KH = '';
    KI = '';
    KJ = '';
    KK = '';
    KL = '';
    KM = '';
    K_ITOGO = ''; /*14460*/
    K_PR = ''; /*15421*/
  end
  
  -- MK 1.09.2009 CQ[7406] --->
  else
  begin
    if (TMP_CORRECT = '') then
    begin
      CORRECTNODE = null;
      CORRECTNODE_1 = null;
    end
  end
  -- MK 1.09.2009 CQ[7406] <---
  
  if (COPY_RES_POPR = 1) then--CQ[11307] (NEED_CONVERT_POPR <> 0) then
    select OUT_KA, OUT_KB, OUT_KC, OUT_KD, OUT_KE,
           OUT_KF, OUT_KG, OUT_KH, OUT_KI, OUT_KJ,
           OUT_KK, OUT_KL, OUT_KM, OUT_K_ITOGO/*14460*/
    from D_SET_POPR_VALUE(:KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM,
      :K_ITOGO/*14460*/, :K_PR/*15421*/, :CUR_RABMAT, :CUR_TYPE_TRUD, :CUR_CORRECT, :INSERT_MODE)
    into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH,
         :KI, :KJ, :KK, :KL, :KM, :K_ITOGO/*14460*/;
  

  --CQ[9359]execute procedure A_S_APPENDREC
      execute procedure A_S_APPENDREC_NL --CQ[9359]
      (:IDUSER,
      :CUR_ID_SM, :CUR_IDHIER, :CUR_SMETATYPE,
      :CUR_NUMBER1, :NEW_NUMBER2, 0,
      :NEW_SLAVEPARENT, :NEW_ATYPE, :CUR_RABMAT,
      /*[6921]*/ :RES_TYPE_TRUD, :CUR_TAB,
      :CUR_ALTTAB, :CUR_NAME_ID, :CUR_IDEDIZM,
      :CUR_EDIZM_TYPE, :NEW_KOLL, '',
      :NEW_RASHOD_RES, CUR_BA, CUR_BB, CUR_BC,
      CUR_BD, CUR_BE, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, :KA, :KB, :KC, :KD, :KE, :KF, :KG,
      :KH, :KI, :KJ, :KK, :KL, :KM, null, null,
      null, null, null, null, null, :CUR_NORM_ID,
      coalesce(:CUR_IDNORMATIVUNIQ, 0), --CQ[9223]0,
      :CUR_KODIR_GROUP,
      :CUR_NORM_PODGROUP /*:cur_kodir_podgroup*/ ,
      :CUR_ISGROUPOKP, :CUR_INSERT_TO_ATYPE,
      :CUR_INSERT_TO_ID, :NEW_ID_RES, :VRPZ,
      /*--CQ[9359]null, null, null, null, null, null, null, null,
      null, null, null, null, null, null, null,
      null, null, null, null, null, null, null,
      null, null,*/ null, null, null, null, null,
      PUNKTIND, CUR_NORM_GUID, 0/*VIDRAB*/,
      1/*APPLAY_INDEX_AS_IS*/ /*Q[9273] 0       */,
      0/*APPLAY_FORMULS_AS_IS*/,
      0/*APPLAY_POPR_AS_IS*/,
      1, 1, 1, 1, 1, 0, 0, 1, 1, null, -1, :CORRECTNODE,
      :CORRECTNODE_1, null, :NEW_CLCMODE, null, 0,
      null, --CQ[9359] -      
      null, null, null/*CQ[13179]*/, :K_ITOGO/*14460*/,
      null, --[15352]
      K_PR /*15421*/
      )
      returning_values (
      :OUT_IDFORMULS, --CQ[9359]
      :ADDED_SLAVE,:OUT_SMETATYPE
      );


    -- MK CQ[14930] --->
    if ((ISMANUAL = 1) and (INSERT_MODE = 1)) then --    
    begin
      if (CUR_RABMAT in (2, 3)) then --    
      begin
        select coalesce(u.project_modes, 0)
        from b_user_access u
        where (u.id = :IDUSER)
        into :VN_PROJECT_MODES;

        --    ()
        if (bin_and(VN_PROJECT_MODES, 2) <> 0) then -- 2 - pm14930mask
        begin
          --      
          -- (        )
          update a_smeta s1
          set s1.tiprab = :VN_SM_TIPRAB,
          -- CQ[14938] -->
              s1.vidrab = case :CUR_RABMAT
                            when 2 then s1.vidrab -- rmMash
                            else
                              case :VN_SM_TIPRAB -- rmMater
                                when 1 then 8 -- ciTRStroit -> 
                                when 2 then 12 -- ciTRMontag -> 
                                else s1.vidrab
                              end
                          end
          -- CQ[14938] <--
          where (s1.id = :CUR_ID_SM);
        end
      end
    end
    -- MK CQ[14930] <---


    --<<[13929]
    if (char_length(:CUR_TAB)=42) then
      insert into A_SMETA_BLOB (ID, FIELD_NAME, FIELD_VALUE)
        select :CUR_ID_SM, FIELD_NAME, FIELD_VALUE from A_S_RES_BLOB
          where ID=:ID_RES and FIELD_NAME='TAB';

   --CQ[9273] -->    
    -- 
    select TIPRAB, VIDRAB/*, IDTIPR*/ from  a_smeta
    where ID = :CUR_ID_SM
    into :TYPE_RAB, :VID_RAB/*, :IDTR*/;
    /*execute procedure nl_get_res_type_vid_rab(:CUR_IDHIER, :ID_SMREC,  :SMETATYPE, :VRPZ)
      returning_values (:TYPE_RAB, :VID_RAB);*/
    execute procedure A_H_GET_ID_PARENTATYPE(:CUR_IDHIER, 1)
      returning_values (:IDOBJECT);
  
    -- MK 5.04.2013   CQ[11129] --->
    if (CUR_SMETATYPE = 15) then
    begin
      select o.RES_COPY_FORMULS, o.id_tr,
             o.APPLY_TO_ALL_IDLEVEL_SNB -- MK CQ[15662.1]
      from a_o_objectparams o
      where NUMBER = :IDOBJECT
      into :IN_RES_COPY_FORMULS, :IDTR,
           :APPLY_TO_ALL_IDLEVEL_SNB;   -- MK CQ[15662.1]
    end
    else
    begin
      select f.RES_COPY_FORMULS, f.id_tr,
             f.APPLY_TO_ALL_IDLEVEL_SNB -- MK CQ[15662.1]
      from a_o_factparams f
      where NUMBER = :CUR_SMETATYPE
      into :IN_RES_COPY_FORMULS, :IDTR,
           :APPLY_TO_ALL_IDLEVEL_SNB;   -- MK CQ[15662.1]
    end

    --select RES_COPY_FORMULS,
    --       coalesce(VELICHSTROBJ, 1)  -- CQ[10381]
    --from a_o_objectparams
    --where NUMBER = :IDOBJECT
    --into :IN_RES_COPY_FORMULS,
    --     :VN_UKR_KOLL;                -- CQ[10381]
    -- MK 5.04.2013   CQ[11129] <---
  
    -- MK 3.05.2012 CQ[10381] --->
    if (:VN_IS_UNION = 1) then
    begin
      -- MK 5.04.2013   CQ[11129] (  )
      select coalesce(VELICHSTROBJ, 1)
      from a_o_objectparams
      where NUMBER = :IDOBJECT
      into :VN_UKR_KOLL;
  
      VN_SKOLL = cast(NEW_KOLL as varchar(255));
      if (VN_UKR_KOLL > 0) then
        NEW_KOLL = NEW_KOLL / VN_UKR_KOLL;
  
      update a_smeta s
      set s.skoll = :VN_SKOLL,
          s.koll = :NEW_KOLL
      where s.id = :ADDED_SLAVE;
    end
    -- MK 3.05.2012 CQ[10381] <---
  
  
    -- MK 25.08.2011 CQ[9435] --->
    if (CUR_SMETATYPE = 15) then
      VN_IDSTRUCT = IDOBJECT;
    else
      VN_IDSTRUCT = CUR_SMETATYPE;
    -- MK 25.08.2011 CQ[9435] <---
  
    IDCLASS = case when :CUR_SMETATYPE > 999 then :CUR_SMETATYPE else :IDOBJECT end;  --[14593]
  
    --        
    for select l.id
    from level_cost l
    where (l.idobject = :VN_IDSTRUCT)
    --[AA5DC71D18EC]order by l.lorder
    into :ID_LEVEL do
    begin
      if (PASTE_AS_IS = 1) then --    
      begin
      --CQ[9298] -->
        execute procedure A_SMETA_COPY_CENLVL_AS_IS(:CUR_ID_SM,
                    :IDUSER, :ID_LEVEL);
      --CQ[9298] <--
      end
      else
      begin
        --  , ,       
        execute procedure A_S_GET_FORMUL_NRSPZU_NL_1 (:IDUSER, :NEW_ATYPE, :ID_SMREC,
              :IDTR, :VRPZ, :IN_RES_COPY_FORMULS, :ID_LEVEL)
        returning_values (:VN_PA, :VN_PB, :VN_PC, :VN_PD);
  
  
        --CQ[10929]execute procedure NL_GET_CENLVL
        execute procedure NL_GET_CENLVL_NEW --CQ[10929]
                         (:ID_LEVEL,
                          :IDCLASS,  --[14593]
                          :IDUSER, :TYPE_RAB,
                          :VID_RAB, :NEW_ATYPE, :CUR_RABMAT, :CUR_IDHIER,
                          :CUR_NORM_ID, :CUR_NORM_PODGROUP/*[11537.4]CUR_KODIR_PODGROUP*/, :PUNKTIND,
                          0/*IDZONE*/, :CUR_BA, :CUR_BB, :CUR_BC, :CUR_BD, :CUR_BE,
                          :CUR_B_PR, --[15352]
                          :CUR_ID_SM,
                          :NEED_APPLY_INDEX) --CQ[10929]
        returning_values (:NL_ID_LEVEL_VC, :NL_IDZONE, :NL_ID_LEVEL_INDEX, :NL_IDINDEX,
                          :NL_BA, :NL_BB, :NL_BC, :NL_BD, :NL_BE,
                          :NL_B_PR, --[15352]
                          :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF,
                          :NL_MG, :NL_MH, :NL_MI,
                          :NL_MJ, :NL_MK, :NL_ML, :NL_MM, --CQ[10529]
                          :NL_M_PR, --[15352]
                          :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE, :NL_DJ, :NL_DK, :NL_DL, :NL_DM,--CQ[10529]
                          :NL_PUNKTIND,
                          :NL_SPOSOB_RASCH, :NL_RES_VC, :NL_RES_INDEX );
  
  
        -- MK 8.04.2013 CQ[11129] --->
        execute procedure A_S_GET_NRSPZU_INDEX_NL_1(:IDUSER, :CUR_ID_SM, :PUNKTIND,
                                                    :ID_SMREC, :ID_LEVEL, :ISMANUAL)
        returning_values(:NL_MF, :NL_MG, :NL_MH, :NL_MI);
        -- MK 8.04.2013 CQ[11129] <---
  
        -- MK CQ[12391] --->
        VN_CURR_BB = null;
        --      
        if (CUR_RABMAT = 3) then
        begin
          select first 1 c.curr_bb
          from a_s_res_cenlvl c
          where (c.id = :ID_RES) and (c.idcenlvl = :ID_LEVEL)
          into :VN_CURR_BB;
        end
  
        -- MK 21.07.2014
        --         
        --    ,  :
        -- 1.      (   
        --    )    .     
        -- 2.    -     
        --    ,   .    -  
        --      Compose  Rules ( NL_GET_CENLVL_NEW ).
  
        if (ISMANUAL = 1) then --      
        begin
          VN_NEED_CHECK_IDX_MAIN_REC = 1;
  
          --    .     , 
          --         ,  
          --    Compose  Rules
          if (INSERT_MODE = 1) then
          begin
            --         
            VN_ID_REC_IN_SMETA = null;
            select first 1 s.id
            from a_smeta s
            where (s.id_s_res = :ID_RES)
            into :VN_ID_REC_IN_SMETA;
  
            --   -     
            if (VN_ID_REC_IN_SMETA is not null) then
            begin
              select first 1 i.idindex, i.id_level_index, i.punktind,
                             i.ma, i.mb, i.mc, i.md, i.me, i.mf, i.mg,
                             i.mh, i.mi, i.mj, i.mk, i.ml, i.mm,
                             i.M_PR, --[15352]
                             i.da, i.db, i.dc, i.dd, i.de, i.dj, i.dk, i.dl, i.dm,
                             i.index_sposobrasch, i.index_info
              from a_smeta_indlvl i
              where (i.id = :VN_ID_REC_IN_SMETA) and (i.idcenlvl = :ID_LEVEL)
              into :NL_IDINDEX, :NL_ID_LEVEL_INDEX, :NL_PUNKTIND,
                   :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF, :NL_MG,
                   :NL_MH, :NL_MI, :NL_MJ, :NL_MK, :NL_ML, :NL_MM,
                   :NL_M_PR, --[15352]
                   :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE, :NL_DJ, :NL_DK, :NL_DL, :NL_DM,
                   :NL_SPOSOB_RASCH, :NL_RES_INDEX;
  
              VN_NEED_CHECK_IDX_MAIN_REC = 0;
            end
          end
  
/*
-- MK 24.09.2014 CQ[12601]  --->
          --      
          if (VN_NEED_CHECK_IDX_MAIN_REC = 1) then
          begin
            --    ,    
            select first 1 i.idindex, i.id_level_index, i.punktind,
                           i.ma, i.mb, i.mc, i.md, i.me, i.mf, i.mg,
                           i.mh, i.mi, i.mj, i.mk, i.ml, i.mm,
                           i.da, i.db, i.dc, i.dd, i.de, i.dj, i.dk, i.dl, i.dm,
                           i.index_sposobrasch, i.index_info
            from a_smeta_indlvl i
            where (i.id = :ID_SMREC) and (i.idcenlvl = :ID_LEVEL) and
                  (i.index_info = 3)   -- ciDirect
            into :NL_IDINDEX, :NL_ID_LEVEL_INDEX, :NL_PUNKTIND,
                 :NL_MA, :NL_MB, :NL_MC, :NL_MD, :NL_ME, :NL_MF, :NL_MG,
                 :NL_MH, :NL_MI, :NL_MJ, :NL_MK, :NL_ML, :NL_MM,
                 :NL_DA, :NL_DB, :NL_DC, :NL_DD, :NL_DE, :NL_DJ, :NL_DK, :NL_DL, :NL_DM,
                 :NL_SPOSOB_RASCH, :NL_RES_INDEX;
          end
-- MK 24.09.2014 CQ[12601]  <---
*/
        end
        -- MK CQ[12391] <---
  
  
        --    
        APPLYONRES = 0;
        if (NL_ID_LEVEL_VC is not null) then
        begin
          select coalesce(APPLY_ON_RES, 0) from LEVEL_VC
          where ID_COMPOSE = :NL_ID_LEVEL_VC
          into :APPLYONRES;
        end
        if ((APPLYONRES = 0) and (ISMANUAL <> 0)) then
        --  ( Ctrl+Enter)          . ,
        --     
        begin --!!! 2012/07/09 [B20A7A3DA1A5]        NL_BA??????
          select IDZONE, ID_LEVEL_VC, BB, BC, BD, BE, BASE_INFO from a_s_res_cenlvl
          -- MK 30.08.2013 CQ[11515] --->
          where (id = :ID_RES) and (idcenlvl = :ID_LEVEL)
          --where (id = :NEW_ID_RES) and (idcenlvl = :ID_LEVEL)
  
            --<<[10929] -   (  ),  IDZONE  :
            and (coalesce(nullif(IDZONE, 0), -3) = coalesce(nullif(:NL_IDZONE, 0), -3))
            --and (coalesce(nullif(IDZONE, 0), -3) = :NL_IDZONE)
          -- MK 30.08.2013 CQ[11515] <---
          into :NL_IDZONE, :NL_ID_LEVEL_VC, :NL_BB, :NL_BC, :NL_BD, :NL_BE, :NL_RES_VC;

          -- MK   CQ[11989, 12174],      (. 2012/07/09 [B20A7A3DA1A5])
          NL_BA = NL_BB + NL_BC + NL_BE;
        end

        SOURCE_LEVEL_ID = 0; -- MK CQ[15662.1]

        -- MK CQ[11989, 12174] --->
        --   
        VN_USE_BA = NL_BA;
        VN_USE_BB = NL_BB;
        VN_USE_CURRCENA = VN_CURR_BB; --0;     8.9
        VN_CURR_CENA_INFO = null;
  
        if (VN_CURR_BB is null) then --     8.9 (      )
        begin
          --  
          if (CUR_RABMAT = 3) then -- [7FE7AD1744B6]
          begin
            --     
            if (NL_IDZONE > 0) then
            begin
              --      
              /*[14593]
              select first 1 LIC_VC
              from GET_VC_LIC_INFO(:NL_IDZONE)
              into :VN_IS_LIC_VC;*/
              execute procedure NL_COMPOSE_USE_MULTIRULES_VC(:NL_ID_LEVEL_VC, :NL_IDZONE)
                  returning_values :USE_MULTIRULES;
      
              --    (   )
              --[14593] if (VN_IS_LIC_VC <> 0) then
              --    (), ..    
              if (:USE_MULTIRULES = 0) then
              begin
                VN_USE_BA = VN_NORM_BA;
                VN_USE_BB = VN_NORM_BB;
                VN_USE_CURRCENA = NL_BB;
                VN_CURR_CENA_INFO = 3; -- cciVC


                -- MK CQ[15662.1] [CCC9F17B] --->
                if (:VN_USE_BB = 0) then
                begin
                  if (:APPLY_TO_ALL_IDLEVEL_SNB = :ID_LEVEL) then
                    SOURCE_LEVEL_ID = -1/*cSourceLevel_ToAll*/;
                end
                -- MK CQ[15662.1] <---
              end
            end
          end
        end
        else
          --     8.9
          VN_CURR_CENA_INFO = 1; -- cciDirect
        -- MK CQ[11989, 12174] <---


        --        
        update a_smeta_cenlvl c
        set c.idzone = :NL_IDZONE,
            --CQ[10529]c.idindex = :NL_IDINDEX,
            --CQ[10529]c.id_level_index = :NL_ID_LEVEL_INDEX,
            c.id_level_vc = :NL_ID_LEVEL_VC,
            c.ba = :VN_USE_BA, -- MK CQ[11989, 12174]:NL_BA,
            c.bb = :VN_USE_BB, -- MK CQ[11989, 12174]:NL_BB,
            c.bc = :NL_BC,
            c.bd = :NL_BD,
            c.be = :NL_BE,
            c.B_PR = :NL_B_PR, --[15352]
            c.bf = 0,
            c.bg = 0,
            c.bh = 0,
            c.bi = 0,
            c.bj = 0,
            c.pa = :VN_PA,
            c.pb = :VN_PB,
            c.pc = :VN_PC,
            c.pd = :VN_PD,
            c.base_info = :NL_RES_VC,

            -- MK CQ[11989, 12174] --->
            c.CURR_CENA = :VN_USE_CURRCENA,
            c.CURR_CENA_INFO = :VN_CURR_CENA_INFO,
            -- MK CQ[11989, 12174] <---

            c.source_level_id =   :SOURCE_LEVEL_ID, -- MK CQ[15662.1]

            -- MK CQ[12391] --->
            --c.curr_cena = :VN_CURR_BB, --      8.9 (. )
            --    ,     "  "
            c.base_calc_info = case
                                 -- MK CQ[15662.1] --->
                                 --when :VN_CURR_BB is null then
                                 --  c.base_calc_info
                                 when (:VN_CURR_BB is null) and (coalesce(:VN_CURR_CENA_INFO, 0) = 3)  then
                                   --   3   cbFromNB
                                   bin_or(bin_and(c.base_calc_info, bin_xor(7/*cbCalcMask*/, -1)), 3/*cbFromNB*/) -- bin_xor(7, -1) = 11111...11000
                                 when (:VN_CURR_BB is null) and (coalesce(:VN_CURR_CENA_INFO, 0) <> 3)  then
                                   --   3   cbNeedCalc
                                   bin_or(bin_and(c.base_calc_info, bin_xor(7/*cbCalcMask*/, -1)), 7/*cbNeedCalc*/) -- bin_xor(7, -1) = 11111...11000
                                 -- MK CQ[15662.1] <---
                                 else
                                   -- MK CQ[13174] --->
                                   -- ,      5 (bciNeedRecalcItogoB)
                                   setbit(c.base_calc_info, 3, 0)
                                   --bin_and(c.base_calc_info, 23) -- 23 = 10111
                                   -- MK CQ[13174] <---
                               end
            -- MK CQ[12391] <---

  
            --[10584] CURR_CENA, BASE_CALC_INFO, SOURCE_LEVEL_ID  , ..    
            /*--CQ[10529]c.punktind = :NL_PUNKTIND,
            c.ma = :NL_MA,
            c.mb = :NL_MB,
            c.mc = :NL_MC,
            c.md = :NL_MD,
            c.me = :NL_ME,
            c.mf = :NL_MF,
            c.mg = :NL_MG,
            c.mh = :NL_MH,
            c.mi = :NL_MI,
            c.index_sposobrasch = :NL_SPOSOB_RASCH,
            c.index_info = :NL_RES_INDEX*/
        where (c.id = :CUR_ID_SM) and (c.idcenlvl = :ID_LEVEL);
  
        update a_smeta_indlvl
        set
            idindex = :NL_IDINDEX,
            id_level_index = :NL_ID_LEVEL_INDEX,
            punktind = :NL_PUNKTIND,
            ma = :NL_MA,
            mb = :NL_MB,
            mc = :NL_MC,
            md = :NL_MD,
            me = :NL_ME,
            mf = :NL_MF,
            mg = :NL_MG,
            mh = :NL_MH,
            mi = :NL_MI,
            --CQ[10529]-->
            MJ = :NL_MJ,
            MK = :NL_MK,
            ML = :NL_ML,
            MM = :NL_MM,
            M_PR = :NL_M_PR, --[15352]
            DA = :NL_DA,
            DB = :NL_DB,
            DC = :NL_DC,
            DD = :NL_DD,
            DE = :NL_DE,
            DJ = :NL_DJ,
            DK = :NL_DK,
            DL = :NL_DL,
            DM = :NL_DM,
            --CQ[10529]<--
  
            index_sposobrasch = :NL_SPOSOB_RASCH,
            index_info = :NL_RES_INDEX
        where (id = :CUR_ID_SM) and (idcenlvl = :ID_LEVEL);
  
        execute procedure FILL_INDLVL_DESCR(:CUR_ID_SM, :ID_LEVEL, :NL_ID_LEVEL_INDEX, :NL_RES_INDEX); --CQ[10529]
  
        --    .   update 
        /*  :   ->        
        if (not ((APPLYONRES <> 1) and (ISMANUAL = 1))) then --(NL_RES_VC = 1) then
        begin
          execute procedure A_S_RES_UPDATE_CEN_NL (:IDUSER, :NEW_ID_RES, :NL_BB, :NL_BC, :NL_BD, :NL_BE,
                                                   0, :ID_LEVEL, :NL_IDZONE, :NL_ID_LEVEL_VC, :NL_RES_VC);
        end*/
      end
    end

    -- MK CQ[13030]       
    if ((NEW_ATYPE in (17, 18)) and (CUR_RABMAT = 3)) then
      execute procedure M_FILL_REC_KOEFFS(:ADDED_SLAVE);

    --CQ[9273] <--
  
  -->DEN cq[4009]
  
  --CQ[11307] if (NEED_CONVERT_POPR <> 0) then
  --CQ[11307] NEED_CONVERT_POPR  = 0,  A_S_RES_APPLAY_CORRECTION, 
  --      
  if ((COPY_RES_POPR = 1) and (INSERT_MODE <> 1)) then
  begin
    execute procedure A_S_RES_APPLAY_CORRECTION(:IDUSER,
        0, null, :ID_RES, :CUR_RABMAT,
        :CUR_TYPE_TRUD, '', '', 0, --CQ[11307] '', 1,
        :APPLY_POPR_MODE)
        returning_values :ID_SM_REC_CH_TRUD,
        :ID_SL_REC_CH_NR_AND_KOLL;
  end
  
  -- update a_s_res r set r.CORRECT = '' where r.ID = :id_res;
  --<
  
  /*added_slave = cur_id_sm; - semenov -   */
  
  suspend;
  
  /*    */
  if (:RES_NOMERROD <> 0) then
    exit;
  
  /*   ,   */
  select ORDERVIEW
  from SD_IMPACT_SELECTSTRUCT_GETFIRST(:IDUSER, :ID_SMREC, :CUR_SMETATYPE)
  into :S_ORDERVIEW;
  
  if (:S_ORDERVIEW > 0) then
  begin
  
    for select I.SMETATYPE
        from SD_IMPACT_SELECTSTRUCT(:IDUSER, :ID_SMREC) I
        where (I.ORDERVIEW >= :S_ORDERVIEW)
        into :OUT_SMETATYPE
    do
      if (not exists(/* , */
      select *
      from M_UTV_STRUCT_ELEM_IN_AKT
      where ID_STRUCT = :CUR_IDHIER and
            ID_AKT = :OUT_SMETATYPE)) then
      begin
        /*    ,    */
        for select ID, ID_SOURCE
            from A_S_RES
            where NOMERROD = :ID_RES and
                  SMETATYPE = :OUT_SMETATYPE
            into :ID_S_RES, :IDSOURCE
        do
          /* (!):     :IDSOURCE   */
          /*     */
          for select ADDED_SLAVE, OUT_SMETATYPE,
                     OUT_IDFORMULS
              --CQ{9273] from A_S_RES_TO_SLAVEREC(:IDUSER, :ID_S_RES, :IDSOURCE, :PUNKTIND, :VRPZ, :INSERT_MODE, :IDZONE, :APPLY_POPR_MODE)
              from A_S_RES_TO_SLAVEREC_NL_2(:IDUSER, :ID_S_RES, :IDSOURCE, :PUNKTIND, :VRPZ, :INSERT_MODE, :IDZONE, :APPLY_POPR_MODE, :ISMANUAL, :IDNORMATIVUNIQ, :PASTE_AS_IS)
              into :ADDED_SLAVE, :OUT_SMETATYPE,
                   :OUT_IDFORMULS
          do
          begin
            /*      */
            update A_SMETA
            set NOMERROD = :CUR_ID_SM,
                /*     */
                NOMERROD1 = :CUR_ID_SM,
                PR_ADDED_REC = 0
            where ID = :ADDED_SLAVE;
            /*   */
            delete from L_S_PR_ADDINFO
            where ID = :ADDED_SLAVE;
            suspend;
          end
  
      end
  end
end
^

--TFS[338],TFS[242]
create or alter procedure D_MAKE_GROUPED_RES (
    ID_USER integer,
    ID_CLASS integer,
    ID_OBJ_LEVEL integer,
    ID_GR_LEVEL integer,
    IDLIST blob sub_type 0 segment size 80,
    IDLISTCOUNT integer,
    ISGROUPMODE integer)
AS
declare variable rabmat integer;
declare variable type_trud integer;
declare variable idnormativ integer;
declare variable tab varchar(42);
declare variable name_id integer;
declare variable id_edizm integer;
declare variable cena double precision;
declare variable KOLL double precision;
declare variable KOLL_IN_SMETA double precision;  -- CQ[TIMUR 7621] -->
declare variable id_price integer;
declare variable source integer;
declare variable edizm varchar(255);

/*--[12699]
declare variable bb double precision;
declare variable bc double precision;
declare variable bd double precision;
declare variable be double precision;
*/

declare variable CURR_BA double precision;
declare variable CURR_BB double precision;
declare variable CURR_BC double precision;
declare variable CURR_BD double precision;
declare variable CURR_BE double precision;

declare variable MB double precision;
declare variable MC double precision;
declare variable MD double precision;
declare variable ME double precision;
declare variable DB double precision;
declare variable DC double precision;
declare variable DD double precision;
declare variable DE double precision;
declare variable MH double precision;
declare variable MI double precision;

declare variable alttab varchar(250);
/*declare variable uch integer;
declare variable dob_v_cenu integer;*/
declare variable norm_guid varchar(100);
declare variable kodir_group integer;
declare variable kodir_podgroup integer;
declare variable isgroupokp integer;
declare variable vidnr integer;
declare variable id_gr integer;
declare variable source_count integer;
declare variable source_count_0_gr integer;
declare variable source_count_1_gr integer;
declare variable source_count_2_gr integer;
declare variable id_source integer;
--[12699]declare variable nomer_rod integer;
declare variable rec_id integer;
declare variable razrad double precision;
declare variable row integer;
declare variable costed_normoid integer;
declare variable koef double precision;   --CQ[7790]
declare TIPRAB integer;

declare ID_OBJECT integer;
declare SMETATYPE integer;
declare IN_KODIR_GROUP integer;
declare IN_KODIR_PODGROUP integer;

declare ID_CEN integer;
declare variable ID_RES integer;
declare variable GR_RES_CRC integer;
declare variable fvalue integer;
--[12699]declare variable IDHIER integer;

--[12699]declare variable CENA_PRICE double precision;--CQ[9742]
-- CQ[12341]>>

declare variable ID_PRICE_INFO integer;

-- <-- Voyager CQ[12349]
declare variable CENA_SOURCE integer;
declare variable IS_FROM_VC integer;
declare variable CURR_IS_FROM_VC integer;
-- <-- Voyager CQ[12349]

declare IDTR integer;

declare variable FIELD_VALUE BLOB SUB_TYPE 1 SEGMENT SIZE 80;
begin

  if (:IDLIST is not null) then
  begin
    REC_ID = gen_id(B_GEN_TEMP, 1) ;
    insert into B_TEMP_BLOB (ID, BLOB1) values (:REC_ID, :IDLIST);
    select BLOB1 from B_TEMP_BLOB where ID = :REC_ID into :IDLIST;
    delete from B_TEMP_BLOB where ID = :REC_ID;
  end

--***************************************
--  delete from D_GROUPED_RES where ID_USER = :ID_USER;

--      D_GROUPED_RES   , ..    
--  Dead Lock Conflict

--         
--***************************************

    --  ID_CLASS:
    SMETATYPE = null;
    select
        NUMBER, KODIR_GROUP, KODIR_PODGROUP, ID_TR
    from A_O_FACTPARAMS
    where
        NUMBER = :ID_CLASS
    into
        :SMETATYPE, :IN_KODIR_GROUP, :IN_KODIR_PODGROUP, :IDTR;

    if (:SMETATYPE is null) then
        select
            NUMBER, 15, KODIR_GROUP, KODIR_PODGROUP, ID_TR
        from A_O_OBJECTPARAMS
        where
            NUMBER = :ID_CLASS
        into
            :ID_OBJECT,  :SMETATYPE, :IN_KODIR_GROUP, :IN_KODIR_PODGROUP, :IDTR;
    else
        execute procedure S_O_HIER_PARENT_OFTYPE(:ID_CLASS, 1/**/)
        returning_values :ID_OBJECT;


    idlistcount = coalesce(idlistcount, 0);
    if (idlistcount = -1) then -- ,   (    )
        exit;

    if (ISGROUPMODE = 0) then --   
    begin
        --     (  ),   ID   D_GR_SESSION_SMETAREC_LIST
        if (:IDLISTCOUNT > 0) then
        begin
          --  ,       
          if ( not exists(select * from D_GR_SESSION_SMETAREC_LIST where SESSION_KEY = :ID_USER) ) then
            for select fvalue
              from S_INTFROMBLOB_SELECT (:IDLIST, :IDLISTCOUNT)
              into :fvalue
            do
            begin
              insert into D_GR_SESSION_SMETAREC_LIST(SESSION_KEY,ID_SMETAREC)
              values (:ID_USER,:fvalue);
            end
        end
        /*
        else --    -     
            for select IDNODE
            from V_SELECT_HIER_FOR_REPLACE_RES(:ID_USER, :ID_OBJECT, :SMETATYPE, :SMETATYPE, :ISGROUPMODE)
            into IDHIER do
                for select ID from A_SMETA where IDHIER = :IDHIER
                into :fvalue do
                begin
                    --  ,       
                    if ( not exists(select SESSION_KEY from D_GR_SESSION_SMETAREC_LIST where (SESSION_KEY = :ID_USER) and (ID_SMETAREC = :fvalue) ) ) then
                        insert into D_GR_SESSION_SMETAREC_LIST(SESSION_KEY,ID_SMETAREC)
                        values (:ID_USER,:fvalue);
                end
        */
    end

    --     D_GR_SESSION_IDOBJECT_LIST (   )
    insert into D_GR_SESSION_IDOBJECT_LIST(
        SESSION_KEY, ID_CLASS, ID_GR_LEVEL, ID_OBJECT_LEVEL)
    values(
        :ID_USER, :ID_CLASS, :ID_GR_LEVEL, :ID_OBJ_LEVEL);

    --            
    for select
        ID, coalesce(RABMAT,0), coalesce(TYPE_TRUD, 0), coalesce(IDNORMATIV, 0), coalesce(TAB, ''),coalesce(NAME_ID, 0), coalesce(ID_EDIZM, 0), coalesce(TIPRAB, 0),
        --[12699]coalesce(BB, 0.0), coalesce(BC, 0.0), coalesce(BD, 0.0), coalesce(BE, 0.0),
        coalesce(CURR_BB, 0.0), coalesce(CURR_BC, 0.0), coalesce(CURR_BD, 0.0), coalesce(CURR_BE, 0.0),
        MB,  MC, MD, ME, DB,  DC, DD, DE, MH, MI,
        KOLL, KOLL_IN_SMETA,
        SOURCE, SOURCE_COUNT, SOURCE_COUNT_0, SOURCE_COUNT_1, SOURCE_COUNT_2, GR_RES_CRC,
        CENA_SOURCE, IS_FROM_VC -- <-- Voyager CQ[12349]
    from D_GET_GROUPED_RES(:ID_USER, :ID_OBJECT, :SMETATYPE, :ID_OBJ_LEVEL,
        :IN_KODIR_GROUP, :IN_KODIR_PODGROUP, :ISGROUPMODE, :IDTR)
    into
        :ID_RES, :RABMAT, :TYPE_TRUD, :IDNORMATIV, :TAB, :NAME_ID, :ID_EDIZM, :TIPRAB,
        --[12699]:BB, :BC, :BD, :BE,
        :CURR_BB, :CURR_BC, :CURR_BD, :CURR_BE,
        :MB,  :MC, :MD, :ME, :DB,  :DC, :DD, :DE, :MH, :MI, :KOLL, :KOLL_IN_SMETA,
        :SOURCE, :SOURCE_COUNT, :SOURCE_COUNT_0_GR, :SOURCE_COUNT_1_GR, :SOURCE_COUNT_2_GR, :GR_RES_CRC,
        :CENA_SOURCE, :IS_FROM_VC -- <-- Voyager CQ[12349]
    do
    begin
        --     ID  , ID       
        --   
        ID_GR = null;
        select
            ID
        from D_GROUPED_RES
        where
            ID_USER    = :ID_USER and
            GR_RES_CRC = :GR_RES_CRC --and

            -- <-- Voyager CQ[12349]
            --    CQ[12374], .   CQ[12349]
            /*
            --CQ[TIMUR 12374] -     
            BB = :BB and
            BC = :BC and
            BD = :BD and
            BE = :BE
            --CQ[TIMUR 12374] -     
            */
            -- <-- Voyager CQ[12349]

            /*
            RABMAT     = :RABMAT and
            TYPE_TRUD  = :TYPE_TRUD and
            TAB        = :TAB and
            NAME_ID    = :NAME_ID and
            ID_EDIZM   = :ID_EDIZM and
            TIPRAB     = :TIPRAB and
            IDNORMATIV = :IDNORMATIV
            */
        into
            :ID_GR;

        if (ID_GR is NULL) then --    - 
        begin
            ID_GR = gen_id(A_G_SMETA, 1);

            --     ID_RES    D_GROUPED_RES (        )
            ID_SOURCE = NULL;
            --[12699]CENA_PRICE = null;--CQ[9742]
            select R.ID_SOURCE,-- CQ[12341]  coalesce(I.idprice, 0),
                   R.ALTTAB, /*R.UCH, R.STATUS_DOB_V_ZENU, */ R.NORM_GUID,
                   R.KODIR_GROUP, R.NORM_PODGROUP, R.ISGROUPOKP, R.VIDNR --[12699], coalesce(R.NOMERROD, 0)
                   -- CQ[12341] i.ROW, i.idnormo, i.KOEF, i.COST--CQ[9742]
            from A_S_RES R
            -- CQ[12341] left join smeta_pricepos_info i on i.ID = R.ID  --  join       
            where R.ID = :ID_RES  -- and (R.KODIR_GROUP = :IN_KODIR_GROUP and R.KODIR_PODGROUP = :IN_KODIR_PODGROUP)
            into :ID_SOURCE, -- CQ[12341] :ID_PRICE,
                 :ALTTAB, /*:UCH, :DOB_V_CENU, */:NORM_GUID,
                 :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :VIDNR --[12699], :NOMER_ROD
                 -- CQ[12341] :ROW, :COSTED_NORMOID, :KOEF,
                 -- CQ[12341] :CENA_PRICE --CQ[9742]
                 ;

            -- CQ[12587] -->  (  ) -- CQ[12587]  CQ[12549]  CQ[12341]
            -- CQ[12341] -->
            --        smeta_pricepos_info
            -- ID_PRICE = null;
            -- ROW = null;
            -- COSTED_NORMOID = null;
            -- select first 1 i.IDPRICE, i.ROW, i.idnormo, i.KOEF, i.COST from smeta_pricepos_info i
            -- where i.ID = :ID_RES and ((i.IDCENLVL = :ID_OBJ_LEVEL) or (i.IDCENLVL = 0))
            -- into :ID_PRICE, :ROW, :COSTED_NORMOID, :KOEF, :CENA_PRICE;
            -- CQ[12341] <--
            -- CQ[12587] <---

            FIELD_VALUE = null;
            if (ID_SOURCE is not null) then
            begin
              -- CQ[TIMUR 13929, 14255]
              if (char_length(:TAB)=42) then
              select FIELD_VALUE from A_S_RES_BLOB
                where ID = :ID_RES and FIELD_NAME='TAB'
              into :FIELD_VALUE;
            end
            else
            begin --    -   A_SMETA.
              --[12699]CENA_PRICE = null;--CQ[9742]
              -- CQ[12587] ID_PRICE_INFO = null;
              select -- CQ[12341] coalesce(I.idprice, 0),
                     r.ALTTAB, R.NORM_GUID, R.KODIR_GROUP, R.KODIR_PODGROUP, R.ISGROUPOKP, 0 --[12699], coalesce(R.NOMERROD, 0)
                     -- CQ[12587] , R.ID_S_RES -- CQ[12341]
                     -- CQ[12341] i.ROW, i.idnormo, i.KOEF, i.COST--CQ[9742]
              from A_SMETA R
              -- CQ[12341] left outer join smeta_pricepos_info  i on i.ID = R.ID --  join       
              where R.ID = :ID_RES
              into -- CQ[12341]:ID_PRICE,
                   :ALTTAB, :NORM_GUID, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :VIDNR --[12699], :NOMER_ROD
                   -- CQ[12587] , :A_S_RES_ID -- CQ[12341]
                   -- CQ[12341]:ROW, :COSTED_NORMOID, :KOEF, :CENA_PRICE --CQ[9742]
                   ;

              -- CQ[12587] -->  (  ) -- CQ[12587]  CQ[12549]  CQ[12341]
              -- CQ[12341] -->
              --        smeta_pricepos_info
              -- ID_PRICE = null;
              -- ROW = null;
              -- COSTED_NORMOID = null;
              -- if (A_S_RES_ID = 0) then
                -- A_S_RES_ID = :ID_RES;
              -- select i.IDPRICE, i.ROW, i.idnormo, i.KOEF, i.COST from smeta_pricepos_info i
              -- where i.ID = :A_S_RES_ID  and ((i.IDCENLVL = :ID_OBJ_LEVEL) or (i.IDCENLVL = 0))
              -- into :ID_PRICE, :ROW, :COSTED_NORMOID, :KOEF, :CENA_PRICE;
              -- CQ[12341] <--
              -- CQ[12587] <--

              ID_SOURCE = :ID_RES;

              -- CQ[TIMUR 13929, 14255]
              if (char_length(:TAB)=42) then
              select FIELD_VALUE from A_SMETA_BLOB
                where ID = :ID_SOURCE and FIELD_NAME='TAB'
              into :FIELD_VALUE;
            end

            execute procedure A_GET_EDIZM (:ID_USER , :ID_EDIZM , 0)
                returning_values (:EDIZM);

            execute procedure M_GET_RESURS_FROM_NORMATIV(:RABMAT, :IN_KODIR_PODGROUP, :IDNORMATIV)
                returning_values :RAZRAD;

            insert into D_GROUPED_RES(
                ID, KOL, KOL_IN_SMETA, SOURCE, SOURCE_COUNT, SOURCE_COUNT_0, SOURCE_COUNT_1, SOURCE_COUNT_2, UCH, DOB_V_CENU, GR_RES_CRC,
                ID_USER, RABMAT, IDNORMATIV, TAB, NAME_ID, ID_EDIZM, TYPE_TRUD, TIPRAB,
                ID_PRICE, ALTTAB, NORM_GUID, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, VIDNR,
                EDIZM, RAZRAD, EDIZM_KOEF, ROW, ID_RES, ID_SOURCE, COSTED_NORMOID, KOEF
                --BB, BC, BD, BE --CQ[TIMUR 12374]     --BB --CQ[9742]
                )
            values(
                :ID_GR, :KOLL, :KOLL_IN_SMETA, :SOURCE,  :SOURCE_COUNT, :SOURCE_COUNT_0_GR, :SOURCE_COUNT_1_GR, :SOURCE_COUNT_2_GR, 0 /*UCH*/ ,0 /*DOB_V_CENU*/,:GR_RES_CRC,
                :ID_USER, :RABMAT, :IDNORMATIV, :TAB, :NAME_ID, :ID_EDIZM, :TYPE_TRUD, :TIPRAB,
                :ID_PRICE, :ALTTAB, :NORM_GUID, :KODIR_GROUP, :KODIR_PODGROUP, :ISGROUPOKP, :VIDNR,
                :EDIZM, :RAZRAD, 1.0, :ROW, :ID_RES, :ID_SOURCE, :COSTED_NORMOID, :KOEF
                --:BB, :BC, :BD, :BE --:CENA_PRICE --CQ[9742]
                );

            insert into D_GR_RES_CRC_SMETATYPE (SESSION_KEY, GR_RES_CRC, ID_CLASS)
              values (:ID_USER, :GR_RES_CRC, :ID_CLASS);

            -- CQ[TIMUR 13929, 14255]
            if (FIELD_VALUE is not null) then
              insert into D_GROUPED_RES_BLOB (ID_GROUPED_RES, FIELD_NAME, FIELD_VALUE)
              values (:ID_GR, 'TAB', :FIELD_VALUE);

        end
        else --   -  
        begin
            update D_GROUPED_RES
              set
                KOL = KOL + :KOLL,
                KOL_IN_SMETA = KOL_IN_SMETA + :KOLL_IN_SMETA,
                SOURCE = BIN_OR(SOURCE, :SOURCE),
                SOURCE_COUNT = SOURCE_COUNT + :SOURCE_COUNT,
                SOURCE_COUNT_0 = SOURCE_COUNT_0 + :SOURCE_COUNT_0_GR,
                SOURCE_COUNT_1 = SOURCE_COUNT_1 + :SOURCE_COUNT_1_GR,
                SOURCE_COUNT_2 = SOURCE_COUNT_2 + :SOURCE_COUNT_2_GR
                --UCH = UCH, -- ,    
                --DOB_V_CENU = DOB_V_CENU -- ,    
              where
                ID = :ID_GR;

            if (not exists(select * from D_GR_RES_CRC_SMETATYPE
                      where SESSION_KEY = :ID_USER
                        and GR_RES_CRC = :GR_RES_CRC
                        and ID_CLASS = :ID_CLASS)) then
              insert into D_GR_RES_CRC_SMETATYPE (SESSION_KEY, GR_RES_CRC, ID_CLASS)
                values (:ID_USER, :GR_RES_CRC, :ID_CLASS);
        end

        --   
        -- <-- Voyager CQ[9621]
        ID_CEN = NULL;

        /*-  ... [408116AC0E47]*/
        CURR_BA = ( :CURR_BB + :CURR_BC + :CURR_BE );

        select
            ID,
            IS_FROM_VC -- Voyager CQ[12349]
        from D_GR_RES_CEN_LEVELS
        where (ID_GR_RES_LEVEL = :ID_GR_LEVEL) and (ID_GROUPED_RES = :ID_GR)
            and BA = :CURR_BA --<< [408116AC0E47] -     D_GR_RES_CEN_LEVELS_IDX1
            and BB = :CURR_BB
            and BC = :CURR_BC
            and BD = :CURR_BD
            and BE = :CURR_BE

            and MB = :MB
            and MC = :MC
            and MD = :MD
            and ME = :ME
            and DB = :DB
            and DC = :DC
            and DD = :DD
            and DE = :DE

            and MH = :MH
            and MI = :MI
        into
            :ID_CEN,
            :CURR_IS_FROM_VC; -- Voyager CQ[12349]

        if (ID_CEN is NULL) then
        begin --     
            ID_CEN = gen_id(A_G_SMETA, 1);

            execute procedure M_GET_CENA_FOR_REPLACE_RES(RABMAT, TYPE_TRUD, CURR_BE, CURR_BC, CURR_BD, CURR_BB)
            returning_values :CENA;


            -- CQ[12587] -->    CQ[12549]   
            -- CQ[12549] -->
            --        smeta_pricepos_info
            ID_PRICE = null;
            ROW = null;
            COSTED_NORMOID = null;
            KOEF = null;
            ID_PRICE_INFO = null;
            if (:RABMAT = 3) then
            begin
              select ID_S_RES from A_SMETA
              where ID = :ID_RES
              into :ID_PRICE_INFO;
              if (:ID_PRICE_INFO is null) then
                ID_PRICE_INFO = :ID_RES;
              select i.IDPRICE, i.ROW, i.idnormo, i.KOEF --[12699], i.COST
              from smeta_pricepos_info i
              where i.ID = :ID_PRICE_INFO  and ((i.IDCENLVL = :ID_OBJ_LEVEL) or (i.IDCENLVL = 0))
              into :ID_PRICE, :ROW, :COSTED_NORMOID, :KOEF --[12699], :CENA_PRICE
              ;
            end

            -- CQ[12549] <--


            INSERT INTO D_GR_RES_CEN_LEVELS(ID,ID_GR_RES_LEVEL,ID_GROUPED_RES,
              BA, BB, BC, BD, BE, CENA, KOLL, KOLL_IN_SMETA,
              GR_RES_CEN_CRC,
              ID_PRICE, ROW, COSTED_NORMOID, KOEF, -- CQ[12341]
              MB, MC, MD, ME, DB, DC, DD, DE, MH, MI,
              CENA_SOURCE, IS_FROM_VC /* Voyager CQ[12349] */ )
            values(:ID_CEN, :ID_GR_LEVEL, :ID_GR,
              :CURR_BA, :CURR_BB, :CURR_BC, :CURR_BD, :CURR_BE, :CENA, :KOLL, :KOLL_IN_SMETA,
                /*[E475BAF1BF50]*/
                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(

                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(

                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(

                GET_DOUBLE_CRC(
                GET_DOUBLE_CRC(

                   0,
                   coalesce(:CURR_BB, 0.0)
                ), coalesce(:CURR_BC, 0.0)
                ), coalesce(:CURR_BD, 0.0)
                ), coalesce(:CURR_BE, 0.0)
                --CQ[TIMUR 14379]
                ), coalesce(:MB, 0.0)
                ), coalesce(:MC, 0.0)
                ), coalesce(:MD, 0.0)
                ), coalesce(:ME, 0.0)

                ), coalesce(:DB, 0.0)
                ), coalesce(:DC, 0.0)
                ), coalesce(:DD, 0.0)
                ), coalesce(:DE, 0.0)

                ), coalesce(:MH, 0.0)
                ), coalesce(:MI, 0.0)
                --CQ[TIMUR 14379]
                ),
                -- CQ[12341] -->
                :ID_PRICE, :ROW, :COSTED_NORMOID, :KOEF,
                :MB, :MC, :MD, :ME, :DB, :DC, :DD, :DE, :MH, :MI,
                :CENA_SOURCE, :IS_FROM_VC /* Voyager CQ[12349] */ );
        end
        else --   
        begin
            update D_GR_RES_CEN_LEVELS
            set
                KOLL = KOLL + :KOLL,
                KOLL_IN_SMETA = KOLL_IN_SMETA + :KOLL_IN_SMETA,
                CENA_SOURCE = BIN_OR(CENA_SOURCE, :CENA_SOURCE)
            where
                ID = :ID_CEN;

            -- Voyager CQ[12349]

            if ((CURR_IS_FROM_VC = 0) and (IS_FROM_VC = 1) ) then --    ,    
                update D_GR_RES_CEN_LEVELS
                set
                    IS_FROM_VC = 1
                where
                    ID = :ID_CEN;


            -- CQ[12341] -->
            /*if (ID_PRICE > 0) then
              update D_GR_RES_CEN_LEVELS
              set
                  ID_PRICE = :ID_PRICE,
                  ROW = :ROW,
                  COSTED_NORMOID = :COSTED_NORMOID,
                  KOEF = :KOEF
              where
                  ID = :ID_CEN;*/
            -- CQ[12341] <--
        end
        -- <-- Voyager CQ[9621]
    end
end
^

--TFS[338],TFS[242]
create or alter procedure D_REPLACE_ONE_RES (
    ID_RES integer,
    ID_USER integer,
    REPLACE_CORRECTION integer,
    RABMAT integer,
    TYPE_TRUD integer,
    IDNORMATIV integer,
    TAB varchar(42),
    TAB_BLOB blob sub_type 1 segment size 80,
    NAME_ID integer,
    ID_EDIZM integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    ID_PRICE integer,
    STATUS integer,
    ALTTAB varchar(255),
    NORM_GUID varchar(100),
    KODIR_PODGROUP integer,
    ISGROUPOKP integer,
    CORRECT varchar(50),
    VIDNR integer,
    NAME blob sub_type 1 segment size 80,
    SOURCE_UTV integer,
    NOMER_ROD integer,
    SOURCE integer,
    EDIZM_KOEF double precision,
    RES_IDOBJECT integer,
    TIPRAB integer,
    ISGROUPMODE integer)
returns (
    RESULT integer,
    NEW_TIPRAB integer)
AS
declare variable SMETA_ID integer;
declare variable FIND_VRPZ integer;
declare variable NEED_RECALC integer; /* CQ[TIMUR 9651] */
declare variable RES_ID_SOURCE integer;
declare variable RES_NORM_PODGROUP integer;
declare variable RES_KODIR_GROUP integer;
declare variable RES_KODIR_PODGROUP integer;
declare variable RES_ISGROUPOKP integer;
declare variable RES_RABMAT integer;
declare variable RES_TAB varchar(42);
declare variable RES_ALTTAB varchar(250);
declare variable RES_IDEDIZM integer;
declare variable RES_EDIZM_TYPE integer;
declare variable RES_RASHOD double precision;
declare variable RES_RASHOD_BASE double precision;
declare variable RES_CORRECT varchar(50);
declare variable RES_BA double precision;
declare variable RES_BB double precision;
declare variable RES_BC double precision;
declare variable RES_BD double precision;
declare variable RES_BE double precision;
declare variable RES_VIDNR integer;
declare variable RES_UCH integer;
declare variable RES_STATUS_EDIT integer;
declare variable RES_STATUS_DOB_V_ZENU integer;
declare variable RES_STATUS_REC_CEN integer;
declare variable RES_NOTE varchar(255);
declare variable RES_NORM_GUID varchar(100);
declare variable UPDATE_ALL_ACTS integer;
declare variable NEED_UPDATE_NAME integer;
declare variable NEED_UPDATE_NAME_ID integer;
declare variable RES_IDHIER integer;
declare variable RES_SMETATYPE integer;
declare variable RES_NUMBER1 integer;
declare variable RES_NUMBER2 integer;
declare variable RES_NUMBER3 integer;
declare variable RES_SLAVEPARENT integer;
declare variable RES_ATYPE smallint;
declare variable RES_KOLL double precision;
declare variable RES_SKOLL varchar(255);
declare variable RES_NORMARASH double precision;
declare variable RES_BF double precision;
declare variable RES_BG double precision;
declare variable RES_BH double precision;
declare variable RES_BI double precision;
declare variable RES_BJ double precision;
declare variable RES_EA double precision;
declare variable RES_EB double precision;
declare variable RES_EC double precision;
declare variable RES_ED double precision;
declare variable RES_EE double precision;
declare variable RES_EF double precision;
declare variable RES_EG double precision;
declare variable RES_EH double precision;
declare variable RES_EI double precision;
declare variable RES_EJ double precision;
declare variable RES_EK double precision;
declare variable RES_RA double precision;
declare variable RES_RB double precision;
declare variable RES_RC double precision;
declare variable RES_RD double precision;
declare variable RES_RE double precision;
declare variable RES_RF double precision;
declare variable RES_RG double precision;
declare variable RES_RH double precision;
declare variable RES_RI double precision;
declare variable RES_RJ double precision;
declare variable RES_RK double precision;
declare variable RES_RL double precision;
declare variable RES_RM double precision;
declare variable RES_PA double precision;
declare variable RES_PB double precision;
declare variable RES_PC double precision;
declare variable RES_PD double precision;
declare variable RES_PE double precision;
declare variable RES_VRPZ integer;
declare variable RES_IDTIPR integer;
declare variable RES_KA varchar(50);
declare variable RES_KB varchar(50);
declare variable RES_KC varchar(50);
declare variable RES_KD varchar(50);
declare variable RES_KE varchar(50);
declare variable RES_KF varchar(50);
declare variable RES_KG varchar(50);
declare variable RES_KH varchar(50);
declare variable RES_KI varchar(50);
declare variable RES_KJ varchar(50);
declare variable RES_KK varchar(50);
declare variable RES_KL varchar(50);
declare variable RES_KM varchar(50);
declare variable RES_K_ITOGO varchar(50);
declare variable RES_K_PR varchar(50);
declare variable RES_PUNKTIND varchar(42);
declare variable RES_MA double precision;
declare variable RES_MB double precision;
declare variable RES_MC double precision;
declare variable RES_MD double precision;
declare variable RES_ME double precision;
declare variable RES_MF double precision;
declare variable RES_MG double precision;
declare variable RES_MH double precision;
declare variable RES_MI double precision;
declare variable RES_MJ double precision;
declare variable RES_MK double precision;
declare variable RES_ML double precision;
declare variable RES_SSTCH integer;
declare variable RES_KODZAK integer;
declare variable RES_KODGP integer;
declare variable RES_KODSP integer;
declare variable RES_KODISP integer;
declare variable RES_NACH date;
declare variable RES_OKONCH date;
declare variable RES_TIPRAB integer;
declare variable RES_IDNORMATIVUNIQ integer;
declare variable NEW_IDNORMATIVUNIQ integer;
declare variable RES_ARPS_OTHER blob sub_type 1 segment size 80;
declare variable RES_ID_S_RES integer;
declare variable RES_PR_NUMBER1 integer;
declare variable RES_PR_NUMBER2 integer;
declare variable RES_PR_NUMBER3 integer;
declare variable RES_PR_VSEGO double precision;
declare variable RES_VIDRAB integer;
declare variable RES_CALK_BG integer;
declare variable RES_CALK_BH integer;
declare variable RES_UTV integer;
declare variable RES_CORRECTNODE blob sub_type 1 segment size 80;
declare variable RES_CORRECTNODE_1 blob sub_type 1 segment size 80;
declare variable RES_ASUBTYPE integer;
declare variable RES_CLCMODE integer;
declare variable RES_TYPE_TRUD integer;
declare variable RENUM integer;
declare variable REFR_TRUD_STR_MASH integer;
declare variable OUT_ID integer;
declare variable OUT_SMETATYPE integer;
declare variable OUT_ARPS_OTHER blob sub_type 1 segment size 80;
declare variable OUT_CORRECTNODE blob sub_type 1 segment size 80;
declare variable OUT_CORRECTNODE_1 blob sub_type 1 segment size 80;
declare variable RES_IDFORMULS integer; /* CQ[9359] */
declare variable OUT_IDFORMULS integer; /* CQ[9359] */
declare variable S_NAME_ID integer;
declare variable CLCMODE_RES integer; /* CQ[12244] */

-- MK CQ[12020]
declare variable RES_VIEW_NUMBER1 integer;
declare variable RES_VIEW_NUMBER2 integer;
declare variable RES_VIEW_NUMBER3 integer;

declare variable RES_TAB_BLOB blob sub_type 1;
BEGIN
--[15352]
--[12491]ID_PRICE  
--[8443]
  RES_IDNORMATIVUNIQ = 0;--CQ[9223]
  CLCMODE_RES = 0; -- CQ[12244]

  IF (BA IS NULL) THEN BA = (:BB + :BC + :BE);
  IF (EDIZM_KOEF IS NULL) THEN EDIZM_KOEF = 1;

  IF (SOURCE_UTV <> 0) THEN
    RESULT = 1; --  
  ELSE
  -- MK 25.08.2009 CQ[7622] --->
  IF (STATUS = 2) THEN --   
  --IF (GETBIT(STATUS,  1) = 1) THEN --  
  -- MK 25.08.2009 CQ[7622] <---
  BEGIN
    IF (NOMER_ROD <> 0) THEN
      RESULT = 2; --    
    ELSE
    BEGIN
      IF (:SOURCE = 2) THEN
        DELETE FROM A_SMETA WHERE ID = :ID_RES;
      ELSE
      if (:SOURCE = 1) then
      begin
        if (:ISGROUPMODE <> 0) then --       
          delete from A_SMETA where ID_S_RES = :ID_RES; --<< [9782]
        delete from A_S_RES where ID = :ID_RES;
      end
      else
        DELETE FROM A_S_RES WHERE ID = :ID_RES;
      RESULT = 0;
    END
  END
  ELSE
  -- MK 25.08.2009 CQ[7622] --->
  IF (STATUS = 1) THEN --  
  --IF (GETBIT(STATUS,  0) = 1) THEN --
  -- MK 25.08.2009 CQ[7622] <---
  BEGIN
    -- 
    IF (SOURCE = 2) THEN
    BEGIN

      SELECT RES.SMETATYPE, RES.IDHIER, RES.NUMBER1, RES.NUMBER2, RES.NUMBER3, RES.SLAVEPARENT, RES.ATYPE,
        RES.RABMAT, RES.TAB, RES.ALTTAB, RES.ID_EDIZM, RES.EDIZM_TYPE,
        RES.KOLL, RES.SKOLL, RES.NORMARASH,
        RES.BA, RES.BB, RES.BC, RES.BD, RES.BE, RES.BF, RES.BG, RES.BH, RES.BI, RES.BJ,
        --CQ[9359]RES.SEA, RES.SEB, RES.SEC, RES.SED, RES.SEE, RES.SEF, RES.SEG, RES.SEH, RES.SEI, RES.SEJ, RES.SEK,
        RES.EA, RES.EB, RES.EC, RES.ED, RES.EE, RES.EF, RES.EG, RES.EH, RES.EI, RES.EJ, RES.EK,
        --CQ[9359]RES.SRA, RES.SRB, RES.SRC, RES.SRD, RES.SRE, RES.SRF, RES.SRG, RES.SRH, RES.SRI, RES.SRJ, RES.SRK, RES.SRL, RES.SRM,
        RES.RA, RES.RB, RES.RC, RES.RD, RES.RE, RES.RF, RES.RG, RES.RH, RES.RI, RES.RJ, RES.RK, RES.RL, RES.RM,
        RES.PA, RES.PB, RES.PC, RES.PD, RES.PE, RES.VRPZ, RES.IDTIPR,
        RES.KA, RES.KB, RES.KC, RES.KD, RES.KE, RES.KF, RES.KG, RES.KH, RES.KI, RES.KJ, RES.KK, RES.KL, RES.KM,
        RES.PUNKTIND, RES.MA, RES.MB, RES.MC, RES.MD, RES.ME, RES.MF, RES.MG, RES.MH, RES.MI, RES.MJ, RES.MK, RES.ML,
        RES.SSTCH, RES.KODZAK, RES.KODGP, RES.KODSP, RES.KODISP, RES.NACH, RES.OKONCH, RES.TIPRAB,
        RES.KODIR_GROUP, RES.KODIR_PODGROUP, RES.ISGROUPOKP, RES.ARPS_OTHER,
        RES.ID_S_RES, RES.PR_NUMBER1, RES.PR_NUMBER2, RES.PR_NUMBER3,
        RES.PR_VSEGO, RES.NORM_GUID, RES.STATUS_REC_CEN, RES.VIDRAB, 0/*RES.CALK_BG*/, 0/*RES.CALK_BH*/, RES.UTV,
        RES.CORRECTNODE, RES.CORRECTNODE_1, RES.ASUBTYPE, RES.CLCMODE, RES.IDNORMATIVUNIQ,
        RES.TYPE_TRUD,  --CQ[TIMUR 6922]-->  TYPE_TRUD
        RES.IDFORMULS, RES.K_ITOGO, RES.K_PR
      FROM D_GET_SMETA_REC(:ID_USER, :RES_IDOBJECT, :ID_RES) RES
      INTO :RES_SMETATYPE, :RES_IDHIER, :RES_NUMBER1, :RES_NUMBER2, :RES_NUMBER3, :RES_SLAVEPARENT, :RES_ATYPE,
        :RES_RABMAT, :RES_TAB, :RES_ALTTAB, :RES_IDEDIZM, :RES_EDIZM_TYPE,
        :RES_KOLL, :RES_SKOLL, :RES_NORMARASH,
        RES_BA, :RES_BB, :RES_BC, :RES_BD, :RES_BE, :RES_BF, :RES_BG, :RES_BH, :RES_BI, :RES_BJ,
        --CQ[9359]:RES_SEA, :RES_SEB, :RES_SEC, :RES_SED, :RES_SEE, :RES_SEF, :RES_SEG, :RES_SEH, :RES_SEI, :RES_SEJ, :RES_SEK,
        :RES_EA, :RES_EB, :RES_EC, :RES_ED, :RES_EE, :RES_EF, :RES_EG, :RES_EH, :RES_EI, :RES_EJ, :RES_EK,
        --CQ[9359]:RES_SRA, :RES_SRB, :RES_SRC, :RES_SRD, :RES_SRE, :RES_SRF, :RES_SRG, :RES_SRH, :RES_SRI, :RES_SRJ, :RES_SRK, :RES_SRL, :RES_SRM,
        :RES_RA, :RES_RB, :RES_RC, :RES_RD, :RES_RE, :RES_RF, :RES_RG, :RES_RH, :RES_RI, :RES_RJ, :RES_RK, :RES_RL, :RES_RM,
        :RES_PA, :RES_PB, :RES_PC, :RES_PD, :RES_PE, :RES_VRPZ, :RES_IDTIPR,
        :RES_KA, :RES_KB, :RES_KC, :RES_KD, :RES_KE, :RES_KF, :RES_KG, :RES_KH, :RES_KI, :RES_KJ, :RES_KK, :RES_KL, :RES_KM,
        :RES_PUNKTIND, :RES_MA, :RES_MB, :RES_MC, :RES_MD, :RES_ME, :RES_MF, :RES_MG, :RES_MH, :RES_MI, :RES_MJ, :RES_MK, :RES_ML,
        :RES_SSTCH, :RES_KODZAK, :RES_KODGP, :RES_KODSP, :RES_KODISP, :RES_NACH, :RES_OKONCH, :RES_TIPRAB,
        :RES_KODIR_GROUP, :RES_KODIR_PODGROUP, :RES_ISGROUPOKP, :RES_ARPS_OTHER, :RES_ID_S_RES, :RES_PR_NUMBER1, :RES_PR_NUMBER2, :RES_PR_NUMBER3,
        :RES_PR_VSEGO, :RES_NORM_GUID, :RES_STATUS_REC_CEN,  :RES_VIDRAB,  :RES_CALK_BG, :RES_CALK_BH, :RES_UTV,
        :RES_CORRECTNODE, :RES_CORRECTNODE_1, :RES_ASUBTYPE, :RES_CLCMODE, :RES_IDNORMATIVUNIQ,
        :RES_TYPE_TRUD,  --CQ[TIMUR 6922]-->  TYPE_TRUD;
        :RES_IDFORMULS/*CQ[9359]*/, :RES_K_ITOGO/*14460*/, :RES_K_PR/*15421*/;

      RES_KOLL = RES_KOLL * EDIZM_KOEF;

      SMETA_ID = :ID_RES;

      -- CQ[12244] -->   ,     D_GET_SMETA_REC
      select CLCMODE from A_S_RES
      where ID = :RES_ID_S_RES
      into :CLCMODE_RES;
      -- CQ[12244] <--

      -- MK CQ[12020] --->
      --      
      select first 1 v.number1, v.number2, v.number3
      from a_smeta_view_num v
      where (v.id = :ID_RES)
      into :RES_VIEW_NUMBER1, :RES_VIEW_NUMBER2, :RES_VIEW_NUMBER3;
      -- MK CQ[12020] <---

      -- CQ[TIMUR 13929, 14255]
      RES_TAB_BLOB = null;
      select FIELD_VALUE
        from A_SMETA_BLOB
        where ID = :ID_RES and FIELD_NAME='TAB'
      into :RES_TAB_BLOB;
      -- CQ[TIMUR 13929, 14255]
    END
    --     
    ELSE
    BEGIN
      SELECT RES.ID_SOURCE, RES.NORM_PODGROUP, RES.KODIR_GROUP, RES.KODIR_PODGROUP, RES.ISGROUPOKP,
          RES.RABMAT, RES.TAB, RES.ALTTAB, RES.IDEDIZM, RES.EDIZM_TYPE, RES.RASHOD, RES.RASHOD_BASE, RES.CORRECT,
          RES.BB, RES.BC, RES.BD, RES.BE,
          RES.VIDNR, RES.UCH, RES.STATUS_EDIT, RES.STATUS_DOB_V_ZENU, RES.STATUS_REC_CEN,
          RES.NOTE, RES.NORM_GUID, RES.TYPE_TRUD,
          RES.CLCMODE -- CQ[12244]
      FROM A_S_RES RES
      WHERE ID = :ID_RES
      INTO :RES_ID_SOURCE, :RES_NORM_PODGROUP, :RES_KODIR_GROUP, :RES_KODIR_PODGROUP, :RES_ISGROUPOKP,
          :RES_RABMAT, :RES_TAB, :RES_ALTTAB, :RES_IDEDIZM, :RES_EDIZM_TYPE, :RES_RASHOD, :RES_RASHOD_BASE, :RES_CORRECT,
          :RES_BB, :RES_BC, :RES_BD, :RES_BE,
          :RES_VIDNR, :RES_UCH, :RES_STATUS_EDIT, :RES_STATUS_DOB_V_ZENU, :RES_STATUS_REC_CEN,
          :RES_NOTE, :RES_NORM_GUID, :RES_TYPE_TRUD,
          :CLCMODE_RES; -- CQ[12244]

      RES_RASHOD_BASE = RES_RASHOD_BASE * EDIZM_KOEF;

      --<[7461]>
      RES_TIPRAB = null;
      SMETA_ID = null;

      if (:SOURCE = 1) then
      begin
        select S.ID, S.TIPRAB, S.IDNORMATIVUNIQ, S.VRPZ --CQ[9223] IDNORMATIVUNIQ
          from A_SMETA S
          where S.ID_S_RES = :ID_RES
          into :SMETA_ID, :RES_TIPRAB, :RES_IDNORMATIVUNIQ, :RES_VRPZ; --CQ[9223]
      end
      --</[7461]>

      -- CQ[TIMUR 13929, 14255]
      RES_TAB_BLOB = null;
      if (char_length(:RES_TAB)=42) then
      select FIELD_VALUE
        from A_S_RES_BLOB
        where ID = :ID_RES and FIELD_NAME='TAB'
      into :RES_TAB_BLOB;
      -- CQ[TIMUR 13929, 14255]
    END

    --<[7461]>
    NEW_TIPRAB = case :RABMAT
                   when 3 then
                     nullif( :TIPRAB, case :RES_TIPRAB /*[B690580EBEC1]*/ when 3 then 3 else 0 end )
                   else
                     null
                 end;
    --</[7461]>

    --CQ[TIMUR 9651]
    NEED_RECALC = 0;
    IF ((NEW_TIPRAB IS NOT NULL) AND (ISGROUPMODE <> 0)) THEN
    BEGIN

       EXECUTE PROCEDURE S_SELECT_VRPZ_TIPRAB(:SMETA_ID, :NEW_TIPRAB)
           RETURNING_VALUES :RES_IDFORMULS, :FIND_VRPZ;

       if (FIND_VRPZ = -3) then
         RES_VRPZ = RES_VRPZ; --  
       else
         RES_VRPZ = FIND_VRPZ;

       RES_TIPRAB = NEW_TIPRAB;

       NEED_RECALC = 1;
    END

    IF ( (RABMAT <> RES_RABMAT) OR (TYPE_TRUD <> RES_TYPE_TRUD) ) THEN
      NEED_RECALC = 1;

    IF ((NEED_RECALC = 1) AND (ISGROUPMODE <> 0)) THEN
    BEGIN

      IF (RES_SMETATYPE > 999) THEN
        UPDATE A_O_FACTPARAMS F
          SET F.DORECALK = SETBIT(coalesce(F.DORECALK,0),0,1)
        WHERE (F.NUMBER = :RES_IDOBJECT);
      ELSE
      begin
        UPDATE A_O_OBJECTPARAMS O
          SET O.DORECALK = SETBIT(coalesce(O.DORECALK,0),0,1)
        WHERE (O.NUMBER = :RES_IDOBJECT);

      end
    END
    --CQ[TIMUR 9651]

    IF ( (TAB <> RES_TAB) OR
         (B_COMPAREBLOB(:TAB_BLOB, :RES_TAB_BLOB) = 0) OR -- CQ[TIMUR 13929, 14255])
         (ID_EDIZM <> RES_IDEDIZM) OR
         (RABMAT <> RES_RABMAT) OR
         (TYPE_TRUD <> RES_TYPE_TRUD)
       )
    THEN UPDATE_ALL_ACTS = 1;
    ELSE UPDATE_ALL_ACTS = 0;

    --   [7461]  [7549]:  TIPRAB  - ,
    -- ..   ,      [7549],   ...
    IF ( (NOMER_ROD <> 0) AND ( (UPDATE_ALL_ACTS = 1) or (/*[7461]*/:NEW_TIPRAB is not null) ) ) THEN
      RESULT = 3;
    ELSE
    BEGIN
      IF (NAME_ID = -1) THEN NEED_UPDATE_NAME = 1; ELSE NEED_UPDATE_NAME = 0;
        
      IF (RES_STATUS_EDIT = 0) THEN
      BEGIN 
        IF ( (NEED_UPDATE_NAME <> 0) OR (KODIR_PODGROUP <> RES_NORM_PODGROUP) OR (ISGROUPOKP <> RES_ISGROUPOKP) OR
             (RABMAT <> RES_RABMAT) OR (TAB <> RES_TAB) OR (B_COMPAREBLOB(:TAB_BLOB, :RES_TAB_BLOB) = 0) OR -- CQ[TIMUR 13929, 14255])
             (ALTTAB <> RES_ALTTAB) OR (ID_EDIZM <> RES_IDEDIZM)
          /*OR (BB <> RES_BB) OR (BC <> RES_BC) OR (BD <> RES_BD) OR (BE <> RES_BE)*/
          OR (VIDNR <> RES_VIDNR) OR (NORM_GUID <> RES_NORM_GUID) OR (TYPE_TRUD <> RES_TYPE_TRUD) )
        THEN
          RES_STATUS_EDIT = 1;
      END

      IF (NEED_UPDATE_NAME <> 0) THEN NEED_UPDATE_NAME_ID = 0; ELSE NEED_UPDATE_NAME_ID = 1;

      --IF ((ID_ZONE <> 0) AND (SAVE_ZONE_TO_NORMY = 0)) THEN RES_STATUS_REC_CEN = 2;
      RES_STATUS_REC_CEN = null;

      --  
      IF (SOURCE = 2) THEN
      BEGIN
        --[12491]IF (ID_PRICE IS NULL) THEN ID_PRICE = 0;
        --CQ[9223] -->
        NEW_IDNORMATIVUNIQ = 0;--CQ[9223]
        select ID_UNIQUE from l_fb_search_normativ(:IDNORMATIV, :KODIR_PODGROUP, :RABMAT,
                                 null,null, :ID_USER, null, null, null, null, null )
        into :NEW_IDNORMATIVUNIQ;

        if (NEW_IDNORMATIVUNIQ = 0) then
          NEW_IDNORMATIVUNIQ = :RES_IDNORMATIVUNIQ;
        --CQ[9223] <--

        FOR SELECT RENUM, REFR_TRUD_STR_MASH, OUT_ID, OUT_SMETATYPE,
                   /*CQ[9359]OUT_SEA, OUT_SEB, OUT_SEC, OUT_SED, OUT_SEE, OUT_SEF, OUT_SEG, OUT_SEH,
                   OUT_SEI, OUT_SEJ, OUT_SEK,
                   OUT_SRA, OUT_SRB, OUT_SRC, OUT_SRD, OUT_SRE, OUT_SRF, OUT_SRG, OUT_SRH,
                   OUT_SRI, OUT_SRJ, OUT_SRK, OUT_SRL, OUT_SRM,*/
                   OUT_IDFORMULS, --CQ[9359]
                   OUT_ARPS_OTHER, OUT_CORRECTNODE, OUT_CORRECTNODE_1
        --CQ[9359]FROM A_S_UPDATEREC(:ID_USER, :ID_RES, :RES_IDHIER, :RES_SMETATYPE, :RES_NUMBER1, :RES_NUMBER2, :RES_NUMBER3,
        FROM A_S_UPDATEREC_NL(:ID_USER, :ID_RES, :RES_IDHIER, :RES_SMETATYPE, :RES_NUMBER1, :RES_NUMBER2, :RES_NUMBER3,
          :RES_SLAVEPARENT, :RES_ATYPE, :RABMAT, :TYPE_TRUD, :TAB, :ALTTAB, :NAME_ID/*[9906]NEED_UPDATE_NAME_ID*/, :NAME,
          :ID_EDIZM, :RES_EDIZM_TYPE, :RES_KOLL, :RES_SKOLL, :RES_NORMARASH,
          :RES_BA, :RES_BB, :RES_BC, :RES_BD, :RES_BE,/*[9771,56E11100FBCE]:BA, :BB, :BC, :BD, :BE,*/
          :RES_BF, :RES_BG, :RES_BH, :RES_BI, :RES_BJ,
          null/*:RES_BN*/, null/*:RES_BO*/, null/*:RES_B_ITOGO*/, --CQ[TIMUR 13178]
          null/*B_PR*/, --[15352]
          --CQ[9359]:RES_SEA, :RES_SEB, :RES_SEC, :RES_SED, :RES_SEE, :RES_SEF, :RES_SEG, :RES_SEH, :RES_SEI, :RES_SEJ, :RES_SEK,
          :RES_EA, :RES_EB, :RES_EC, :RES_ED, :RES_EE, :RES_EF, :RES_EG, :RES_EH, :RES_EI, :RES_EJ, :RES_EK,
          --CQ[9359]:RES_SRA, :RES_SRB, :RES_SRC, :RES_SRD, :RES_SRE, :RES_SRF, :RES_SRG, :RES_SRH, :RES_SRI, :RES_SRJ, :RES_SRK, :RES_SRL, :RES_SRM,
          :RES_RA, :RES_RB, :RES_RC, :RES_RD, :RES_RE, :RES_RF, :RES_RG, :RES_RH, :RES_RI, :RES_RJ, :RES_RK, :RES_RL, :RES_RM,
          :RES_PA, :RES_PB, :RES_PC, :RES_PD, :RES_PE, :RES_VRPZ, :RES_IDTIPR, :RES_KA, :RES_KB, :RES_KC, :RES_KD, :RES_KE, :RES_KF, :RES_KG, :RES_KH, :RES_KI, :RES_KJ, :RES_KK, :RES_KL, :RES_KM,
          :RES_PUNKTIND, :RES_MA, :RES_MB, :RES_MC, :RES_MD, :RES_ME, :RES_MF, :RES_MG, :RES_MH, :RES_MI, :RES_MJ, :RES_MK, :RES_ML,
          :RES_SSTCH, :RES_KODZAK, :RES_KODGP, :RES_KODSP, :RES_KODISP, :RES_NACH, :RES_OKONCH,
          :RES_TIPRAB, :IDNORMATIV, coalesce(:NEW_IDNORMATIVUNIQ, 0)/*CQ[9223] :ID_PRICE*/, :RES_KODIR_GROUP, :KODIR_PODGROUP, :RES_ISGROUPOKP,
          :RES_ARPS_OTHER, 0, :RES_ID_S_RES, :NEED_UPDATE_NAME, --CQ[9359]0,
          :RES_PR_NUMBER1, :RES_PR_NUMBER2, :RES_PR_NUMBER3, :RES_PR_VSEGO, :RES_NORM_GUID,
          0, 0, 0, 0, 0,
          :RES_STATUS_REC_CEN, :RES_VIDRAB, :RES_CALK_BG, :RES_CALK_BH, :RES_UTV, :UPDATE_ALL_ACTS,
          :RES_CORRECTNODE, :RES_CORRECTNODE_1, :RES_ASUBTYPE, :RES_CLCMODE,
          :RES_IDFORMULS/*CQ[9359]*/, :CLCMODE_RES/*CQ[12244]*/,
          :RES_VIEW_NUMBER1, :RES_VIEW_NUMBER2, :RES_VIEW_NUMBER3/*MK CQ[12020]*/, :RES_K_ITOGO/*14460*/, :RES_K_PR/*15421*/
          )
        INTO :RENUM, :REFR_TRUD_STR_MASH, :OUT_ID, :OUT_SMETATYPE,
             /*CQ[9359]:OUT_SEA, :OUT_SEB, :OUT_SEC, :OUT_SED, :OUT_SEE, :OUT_SEF, :OUT_SEG, :OUT_SEH,
             :OUT_SEI, :OUT_SEJ, :OUT_SEK,
             :OUT_SRA, :OUT_SRB, :OUT_SRC, :OUT_SRD, :OUT_SRE, :OUT_SRF, :OUT_SRG, :OUT_SRH,
             :OUT_SRI, :OUT_SRJ, :OUT_SRK, :OUT_SRL, :OUT_SRM,*/
             :OUT_IDFORMULS, --CQ[9359]
             :OUT_ARPS_OTHER, :OUT_CORRECTNODE, :OUT_CORRECTNODE_1
        DO
        BEGIN
          ID_USER = ID_USER; --     
          /* rvs:2009/08/28
                      ...
                     
                      
                  
             ...
             ..   ,    (   "")
               SmetaFrame       
             (      ,     -   )
           */

        END

        --[9906]    NAME_ID,     - ...
        --    A_S_RES_UPDATE: lck CQ 2306 -     L_REPL_RES  D_TestSmResFmUnit 08.09.2005...
        if (:NEED_UPDATE_NAME_ID <> 0 and :NAME_ID > 0) then --if ( NEEDUPDATENAME_ID <> 0 ) then
        begin
          select A.NAME_ID
            from A_SMETA A
            where A.ID = :ID_RES
            into :S_NAME_ID;

          if (coalesce(:S_NAME_ID, 0) <> coalesce(:NAME_ID, 0)) then
          begin
            update A_SMETA A
              set A.NAME_ID = nullif(:NAME_ID, 0)
              where A.ID = :ID_RES;

            if (row_count > 0) then
              execute procedure b_delete_naimenovanie (null, :S_NAME_ID);
          end
        end

       --CQ[TIMUR 13929, 14255]
       if (:TAB_BLOB is not null) then
       begin
         update A_SMETA_BLOB
           set FIELD_VALUE = :TAB_BLOB
         where ID = :ID_RES and FIELD_NAME='TAB';

         if (row_count = 0) then
           insert into A_SMETA_BLOB (ID, FIELD_NAME, FIELD_VALUE)
           values (:ID_RES, 'TAB', :TAB_BLOB);
       end
       --CQ[TIMUR 13929, 14255]

      END
      ELSE
      -- 
      BEGIN

        if (SOURCE = 1) then
        BEGIN
          NEW_IDNORMATIVUNIQ = 0;
          SELECT ID_UNIQUE FROM L_FB_SEARCH_NORMATIV (:IDNORMATIV, :RES_KODIR_PODGROUP, :RABMAT,
                                                      NULL,NULL, :ID_USER, NULL, NULL, NULL, NULL, NULL )

          INTO :NEW_IDNORMATIVUNIQ;

          IF (NEW_IDNORMATIVUNIQ = 0) THEN
            NEW_IDNORMATIVUNIQ = :RES_IDNORMATIVUNIQ;

          UPDATE A_SMETA S SET
            S.IDNORMATIVUNIQ = COALESCE(:NEW_IDNORMATIVUNIQ, 0),
            --      
            S.IDFORMULS = case when ((:NEED_RECALC <> 0) and (:NEW_TIPRAB is not null)) then :RES_IDFORMULS else S.IDFORMULS end,
            S.VRPZ      = case when ((:NEED_RECALC <> 0) and (:NEW_TIPRAB is not null)) then :RES_VRPZ else S.VRPZ end,
            S.TIPRAB    = case when ((:NEED_RECALC <> 0) and (:NEW_TIPRAB is not null)) then :NEW_TIPRAB else S.TIPRAB end
          WHERE ID      = :SMETA_ID;

        END
        --CQ[9223] <--


        EXECUTE PROCEDURE A_S_RES_UPDATE (:ID_USER, :ID_RES, :RES_ID_SOURCE , :IDNORMATIV,
            :KODIR_PODGROUP, :RES_KODIR_GROUP, :RES_KODIR_PODGROUP, :ISGROUPOKP, :RABMAT,
            :TAB, :ALTTAB, :NAME, :NAME_ID, :ID_EDIZM, :RES_EDIZM_TYPE, :RES_RASHOD,
            :RES_RASHOD_BASE, :RES_CORRECT,
            :RES_BB, :RES_BC, :RES_BD, :RES_BE,/*[9771,56E11100FBCE]:BB, :BC, :BD, :BE,*/
            :VIDNR, :RES_UCH, :RES_STATUS_EDIT, :RES_STATUS_DOB_V_ZENU,
            :RES_STATUS_REC_CEN, :RES_NOTE, :NEED_UPDATE_NAME, :NEED_UPDATE_NAME_ID,
            :NORM_GUID, :TYPE_TRUD, :UPDATE_ALL_ACTS); --CQ[6884]   , :ID_PRICE);

        EXECUTE PROCEDURE A_S_RES_APPLAY_CORRECTION_1(:ID_USER, :RABMAT, :TYPE_TRUD, '%', :CORRECT, :REPLACE_CORRECTION, :ID_RES)
        RETURNING_VALUES :RES_UCH, :RES_STATUS_DOB_V_ZENU; -- 

        --CQ[TIMUR 13929, 14255]
        if (:TAB_BLOB is not null) then
        begin
          update A_S_RES_BLOB
            set FIELD_VALUE = :TAB_BLOB
          where ID = :ID_RES and FIELD_NAME='TAB';

          if (row_count = 0) then
            insert into A_S_RES_BLOB (ID, FIELD_NAME, FIELD_VALUE)
            values (:ID_RES, 'TAB', :TAB_BLOB);
        end
        --CQ[TIMUR 13929, 14255]

      END

      --IF ((ID_ZONE <> 0) AND (SAVE_ZONE_TO_NORMY <> 0)) THEN
      --  EXECUTE PROCEDURE L_S_SAVE_CCURRENT_TO_NORMY(:ID_USER, :ID_ZONE, :IDNORMATIV, :RABMAT, :KODIR_PODGROUP, :BA, :BB, :BC, :BD, :BE, :ID_RES, /*SOURCE_TYPE*/ 1)
      --  RETURNING_VALUES (:RESULT, :RES_STATUS_REC_CEN);
      RESULT = 0;
    END
  END
  SUSPEND;
END
^

--TFS[338],TFS[242]
create or alter procedure L_PR_COPY_SMETA_TO_PR_ONE_REC (
    IN_ID integer,
    ID_PR integer,
    ID_USER integer,
    NEW_SLAVEPARENT integer,
    NEW_NUMBER1 integer,
    NEW_NUMBER2 integer,
    NEW_NUMBER3 integer,
    PR_ID_OBJ integer,
    PR_LYEAR integer,
    PR_LMONTH integer,
    PR_IDLEVEL integer,
    NEW_VIEW_NUMBER1 integer,
    NEW_VIEW_NUMBER2 integer,
    NEW_VIEW_NUMBER3 integer)
returns (
    ID integer)
AS
declare variable s_id integer;
declare variable s_idhier integer;
declare variable s_smetatype integer;
declare variable s_number1 integer;
declare variable s_number2 integer;
declare variable s_number3 integer;
declare variable s_slaveparent integer;
declare variable s_atype integer;
declare variable sm_rabmat integer;
declare variable sm_type_trud integer;
declare variable s_tab varchar(42);
declare variable s_alttab varchar(250);
declare variable s_name_id integer;
declare variable s_id_edizm integer;
declare variable s_edizm_type integer;
declare variable s_koll double precision;
declare variable s_skoll varchar(255);
declare variable s_normarash double precision;
-- MK CQ[9412]   ,       Bx
--   ,     -         
declare variable s_ba double precision;
declare variable s_bb double precision;
declare variable s_bc double precision;
declare variable s_bd double precision;
declare variable s_be double precision;
declare variable s_bf double precision;
declare variable s_bg double precision;
declare variable s_bh double precision;
declare variable s_bi double precision;
declare variable s_bj double precision;
--CQ[TIMUR 13178]
declare variable s_bn double precision;
declare variable s_bo double precision;
declare variable s_b_itogo double precision;
--CQ[TIMUR 13178]
/*CQ[9359]declare variable s_sea blob sub_type 0 segment size 80;
declare variable s_seb blob sub_type 0 segment size 80;
declare variable s_sec blob sub_type 0 segment size 80;
declare variable s_sed blob sub_type 0 segment size 80;
declare variable s_see blob sub_type 0 segment size 80;
declare variable s_sef blob sub_type 0 segment size 80;
declare variable s_seg blob sub_type 0 segment size 80;
declare variable s_seh blob sub_type 0 segment size 80;
declare variable s_sei blob sub_type 0 segment size 80;
declare variable s_sej blob sub_type 0 segment size 80;
declare variable s_sek blob sub_type 0 segment size 80; */
/*CQ[9412]declare variable s_ea double precision;
declare variable s_eb double precision;
declare variable s_ec double precision;
declare variable s_ed double precision;
declare variable s_ee double precision;
declare variable s_ef double precision;
declare variable s_eg double precision;
declare variable s_eh double precision;
declare variable s_ei double precision;
declare variable s_ej double precision;
declare variable s_ek double precision;*/
/*CQ[9359]declare variable s_sra blob sub_type 0 segment size 80;
declare variable s_srb blob sub_type 0 segment size 80;
declare variable s_src blob sub_type 0 segment size 80;
declare variable s_srd blob sub_type 0 segment size 80;
declare variable s_sre blob sub_type 0 segment size 80;
declare variable s_srf blob sub_type 0 segment size 80;
declare variable s_srg blob sub_type 0 segment size 80;
declare variable s_srh blob sub_type 0 segment size 80;
declare variable s_sri blob sub_type 0 segment size 80;
declare variable s_srj blob sub_type 0 segment size 80;
declare variable s_srk blob sub_type 0 segment size 80;
declare variable s_srl blob sub_type 0 segment size 80;
declare variable s_srm blob sub_type 0 segment size 80;*/
/*CQ[9412]declare variable s_ra double precision;
declare variable s_rb double precision;
declare variable s_rc double precision;
declare variable s_rd double precision;
declare variable s_re double precision;
declare variable s_rf double precision;
declare variable s_rg double precision;
declare variable s_rh double precision;
declare variable s_ri double precision;
declare variable s_rj double precision;
declare variable s_rk double precision;
declare variable s_rl double precision;
declare variable s_rm double precision;
declare variable s_pa double precision;
declare variable s_pb double precision;
declare variable s_pc double precision;
declare variable s_pd double precision;
declare variable s_pe double precision;*/
declare variable s_vrpz integer;
declare variable s_idtipr integer;
declare variable s_ka varchar(50);
declare variable s_kb varchar(50);
declare variable s_kc varchar(50);
declare variable s_kd varchar(50);
declare variable s_ke varchar(50);
declare variable s_kf varchar(50);
declare variable s_kg varchar(50);
declare variable s_kh varchar(50);
declare variable s_ki varchar(50);
declare variable s_kj varchar(50);
declare variable s_kk varchar(50);
declare variable s_kl varchar(50);
declare variable s_km varchar(50);
declare variable s_k_itogo varchar(50);
declare variable s_k_pr varchar(50);
declare variable s_punktind varchar(42);
/*CQ[9412]declare variable s_ma double precision;
declare variable s_mb double precision;
declare variable s_mc double precision;
declare variable s_md double precision;
declare variable s_me double precision;
declare variable s_mf double precision;
declare variable s_mg double precision;
declare variable s_mh double precision;
declare variable s_mi double precision;
declare variable s_mj double precision;
declare variable s_mk double precision;
declare variable s_ml double precision;*/
declare variable s_sstch integer;
declare variable s_kodzak integer;
declare variable s_kodgp integer;
declare variable s_kodsp integer;
declare variable s_kodisp integer;
declare variable s_nach date;
declare variable s_okonch date;
declare variable s_tiprab integer;
declare variable s_idnormativ integer;
declare variable s_idnormativuniq integer;
declare variable s_kodir_group integer;
declare variable s_kodir_podgroup integer;
declare variable s_isgroupokp integer;
declare variable s_arps_other blob sub_type 0 segment size 80;
declare variable s_dorecalc integer;
declare variable s_id_s_res integer;
declare variable s_nomerrod integer;
declare variable s_nomerrod1 integer;
declare variable s_res_id integer;
declare variable s_res_id_source integer;
declare variable s_res_norm_id integer;
declare variable s_res_norm_podgroup integer;
declare variable s_res_kodir_group integer;
declare variable s_res_kodir_podgroup integer;
declare variable s_res_isgroupokp integer;
declare variable s_res_rabmat integer;
declare variable res_type_trud integer;
declare variable s_res_tab varchar(42);
declare variable s_res_alttab varchar(250);
declare variable s_res_name_id integer;
declare variable s_res_idedizm integer;
declare variable s_res_edizm_type integer;
declare variable s_res_rashod double precision;
declare variable s_res_bb double precision;
declare variable s_res_bc double precision;
declare variable s_res_bd double precision;
declare variable s_res_be double precision;
declare variable s_res_vidnr integer;
declare variable s_res_uch integer;
declare variable s_res_status_edit integer;
declare variable s_res_status_dob_v_zenu integer;
declare variable s_res_status_rec_cen integer;
declare variable s_res_note varchar(255);
declare variable s_res_nomerrod integer;
declare variable s_res_smetatype integer;
declare variable id_s_res integer;
declare variable id_res integer;
declare variable slaveparent integer;
declare variable s_pr_added_rec integer;
declare variable id_source integer;
declare variable id_s_res1 integer;
declare variable dummy integer;
declare variable h_smetatype integer;
declare variable s_norm_guid varchar(100);
declare variable s_res_norm_guid varchar(100);
declare variable s_status_rec_cen integer;
declare variable s_vidrab integer;
declare variable s_asubtype integer;
declare variable res_rashod_base double precision;
declare variable res_correct varchar(50);
declare variable s_correctnode blob sub_type 0 segment size 80;
declare variable s_correctnode_1 blob sub_type 0 segment size 80;
declare variable s_clcmode integer;
declare variable d_normoid integer;
declare variable d_row integer;
declare variable d_priceid integer;
declare variable d_cost double precision ;
declare variable D_KOEF double precision; --CQ[7790]
declare variable F_ID integer; --CQ[TIMUR 8612]
declare variable IDFORMULS integer;--CQ[9359]
declare variable VN_ID_TR integer;
declare variable VN_RES_COPY_FORMULS integer;
declare variable CLCMODE_RES integer;
-- MK CQ[12020]
declare variable VN_VIEW_NUMBER1 integer;
declare variable VN_VIEW_NUMBER2 integer;
declare variable VN_VIEW_NUMBER3 integer;
declare variable vn_clcmode integer;

declare variable FIELD_VALUE BLOB SUB_TYPE 1 SEGMENT SIZE 80;
begin
--[15352]
/*
  if NEW_SLAVEPARENT < 0 - calculate SLAVEPARENT , NUMBER1 , NUMBER2 , NUMBER3
  if NEW_SLAVEPARENT >= 0 - use NEW_SLAVEPARENT , NEW_NUMBER1 , NEW_NUMBER2 , NEW_NUMBER3
*/

 res_rashod_base = null;
 res_correct     = null;
 res_type_trud   = null;

         /*      */
         for select
                 s.ID, s.IDHIER, s.SMETATYPE, s.NUMBER1, s.NUMBER2, s.NUMBER3, s.SLAVEPARENT, s.ATYPE,
                 s.RABMAT, /*[6921]*/S.TYPE_TRUD, s.TAB, s.ALTTAB, s.NAME_ID, s.ID_EDIZM, s.EDIZM_TYPE, s.KOLL, s.SKOLL, s.NORMARASH,
                 s.BA, s.BB, s.BC, s.BD, s.BE, s.BF, s.BG, s.BH, s.BI, s.BJ, s.BN, s.BO, s.B_ITOGO,
                 --CQ[9359]s.SEA, s.SEB, s.SEC, s.SED, s.SEE, s.SEF, s.SEG, s.SEH, s.SEI, s.SEJ, s.SEK,
                 --CQ[9412]s.EA, s.EB, s.EC, s.ED, s.EE, s.EF, s.EG, s.EH, s.EI, s.EJ, s.EK,
                 --CQ[9359]s.SRA, s.SRB, s.SRC, s.SRD, s.SRE, s.SRF, s.SRG, s.SRH, s.SRI, s.SRJ, s.SRK, s.SRL, s.SRM,
                 --CQ[9412]s.RA, s.RB, s.RC, s.RD, s.RE, s.RF, s.RG, s.RH, s.RI, s.RJ, s.RK, s.RL, s.RM,
                 --CQ[9412]s.PA, s.PB, s.PC, s.PD, s.PE,
                 s.VRPZ, s.IDTIPR,
                 s.KA, s.KB, s.KC, s.KD, s.KE, s.KF, s.KG, s.KH, s.KI, s.KJ, s.KK, s.KL, s.KM,
                 s.PUNKTIND,
                 --CQ[9412]s.MA, s.MB, s.MC, s.MD, s.ME, s.MF, s.MG, s.MH, s.MI, s.MJ, s.MK, s.ML,
                 s.SSTCH, s.KODZAK, s.KODGP, s.KODSP, s.KODISP, s.NACH, s.OKONCH, s.TIPRAB,
                 s.IDNORMATIV, s.IDNORMATIVUNIQ, s.KODIR_GROUP, s.KODIR_PODGROUP, s.ISGROUPOKP,
                 s.ARPS_OTHER, s.DORECALC, s.ID_S_RES, s.NOMERROD, s.PR_ADDED_REC, s.NOMERROD1, s.norm_guid, s.STATUS_REC_CEN, s.VIDRAB,
                 s.CORRECTNODE, s.CORRECTNODE_1, --<<rvs:00005545
                 s.CLCMODE, --<<rvs:00004440
                 s.ASUBTYPE,
                 s.IDFORMULS, --CQ[9359]
                 s.k_itogo /*14460*/, s.k_pr/*15421*/
            from a_smeta s
            where s.id = :IN_ID
--            order by idhier, smetatype, NUMBER1, NUMBER2, NUMBER3
            into S_ID, S_IDHIER, S_SMETATYPE, S_NUMBER1, S_NUMBER2, S_NUMBER3, S_SLAVEPARENT, S_ATYPE,
                 SM_RABMAT, /*[6921]*/SM_TYPE_TRUD, S_TAB, S_ALTTAB, S_NAME_ID, S_ID_EDIZM, S_EDIZM_TYPE, S_KOLL, S_SKOLL, S_NORMARASH,
                 S_BA, S_BB, S_BC, S_BD, S_BE, S_BF, S_BG, S_BH, S_BI, S_BJ, S_BN, S_BO, S_B_ITOGO,
                 --CQ[9359]S_SEA, S_SEB, S_SEC, S_SED, S_SEE, S_SEF, S_SEG, S_SEH, S_SEI, S_SEJ, S_SEK,
                 --CQ[9412]S_EA, S_EB, S_EC, S_ED, S_EE, S_EF, S_EG, S_EH, S_EI, S_EJ, S_EK,
                 --CQ[9359]S_SRA, S_SRB, S_SRC, S_SRD, S_SRE, S_SRF, S_SRG, S_SRH, S_SRI, S_SRJ, S_SRK, S_SRL, S_SRM,
                 --CQ[9412]S_RA, S_RB, S_RC, S_RD, S_RE, S_RF, S_RG, S_RH, S_RI, S_RJ, S_RK, S_RL, S_RM,
                 --CQ[9412]S_PA, S_PB, S_PC, S_PD, S_PE,
                 S_VRPZ, S_IDTIPR,
                 S_KA, S_KB, S_KC, S_KD, S_KE, S_KF, S_KG, S_KH, S_KI, S_KJ, S_KK, S_KL, S_KM,
                 S_PUNKTIND,
                 --CQ[9412]S_MA, S_MB, S_MC, S_MD, S_ME, S_MF, S_MG, S_MH, S_MI, S_MJ, S_MK, S_ML,
                 S_SSTCH, S_KODZAK, S_KODGP, S_KODSP, S_KODISP, S_NACH, S_OKONCH, S_TIPRAB,
                 S_IDNORMATIV, S_IDNORMATIVUNIQ, S_KODIR_GROUP, S_KODIR_PODGROUP, S_ISGROUPOKP,
                 S_ARPS_OTHER, S_DORECALC, S_ID_S_RES, S_NOMERROD, S_PR_ADDED_REC, S_NOMERROD1, :s_norm_guid, :S_STATUS_REC_CEN, S_VIDRAB,
                 S_CORRECTNODE, S_CORRECTNODE_1, --<<rvs:00005545
                 S_CLCMODE, --<<rvs:00004440
                 S_ASUBTYPE,
                 :IDFORMULS, --CQ[9359]
                 :s_k_itogo /*14460*/, :s_k_pr/*15421*/
         do
         begin
            /* recive last values for sm. str. ( for version sm.str in last procentov. ) */

            --CQ[TIMUR 8612]
            --for select NUMBER from A_O_HIER_SELECT_PR ( :ID_USER , :PR_ID_OBJ , :PR_LYEAR , :PR_LMONTH )
            --into H_SMETATYPE

            -- MK CQ[12020] --->
            --     
            if ((NEW_SLAVEPARENT is null) or (NEW_SLAVEPARENT < 0)) then
            begin
              select first 1 v.number1, v.number2, v.number3
              from  A_SMETA_VIEW_NUM v
              where (v.id = :IN_ID)
              into :VN_VIEW_NUMBER1, :VN_VIEW_NUMBER2, :VN_VIEW_NUMBER3;
            end
            -- MK CQ[12020] <---

            -- MK 14.03.2011 CQ[9190] --->
            execute procedure T_GET_ACTUAL_REC_TO_VIP(:ID_USER, 1, :IN_ID, :PR_ID_OBJ, :PR_LYEAR, :PR_LMONTH)
            returning_values(:F_ID);
            --select ID from T_GET_ACTUAL_REC_TO_VIP(:ID_USER, 1, :IN_ID, :PR_ID_OBJ, :PR_LYEAR, :PR_LMONTH)
            --into F_ID;
            -- MK 14.03.2011 CQ[9190] <---
            --CQ[TIMUR 8612]

            if (F_ID is not null) then --CQ[TIMUR 8612]
            begin
               select first 1
                         s.TAB, s.ALTTAB, s.NAME_ID, s.ID_EDIZM, s.EDIZM_TYPE, s.KOLL, s.SKOLL, s.NORMARASH,
                         s.BA, s.BB, s.BC, s.BD, s.BE, s.BF, s.BG, s.BH, s.BI, s.BJ, s.BN, s.BO, s.B_ITOGO,
                         --CQ[9359]s.SEA, s.SEB, s.SEC, s.SED, s.SEE, s.SEF, s.SEG, s.SEH, s.SEI, s.SEJ, s.SEK,
                         --CQ[9412]s.EA, s.EB, s.EC, s.ED, s.EE, s.EF, s.EG, s.EH, s.EI, s.EJ, s.EK,
                         --CQ[9359]s.SRA, s.SRB, s.SRC, s.SRD, s.SRE, s.SRF, s.SRG, s.SRH, s.SRI, s.SRJ, s.SRK, s.SRL, s.SRM,
                         --CQ[9412]s.RA, s.RB, s.RC, s.RD, s.RE, s.RF, s.RG, s.RH, s.RI, s.RJ, s.RK, s.RL, s.RM,
                         --CQ[9412]s.PA, s.PB, s.PC, s.PD, s.PE,
                         s.VRPZ, s.IDTIPR,
                         s.KA, s.KB, s.KC, s.KD, s.KE, s.KF, s.KG, s.KH, s.KI, s.KJ, s.KK, s.KL, s.KM,
                         s.PUNKTIND,
                         --CQ[9412]s.MA, s.MB, s.MC, s.MD, s.ME, s.MF, s.MG, s.MH, s.MI, s.MJ, s.MK, s.ML,
                         s.SSTCH, s.KODZAK, s.KODGP, s.KODSP, s.KODISP, s.NACH, s.OKONCH, s.TIPRAB,
                         s.IDNORMATIV, s.IDNORMATIVUNIQ, s.KODIR_GROUP, s.KODIR_PODGROUP, s.ISGROUPOKP,
                         s.ARPS_OTHER, s.DORECALC, s.norm_guid, s.STATUS_REC_CEN, s.VIDRAB,
                         s.CORRECTNODE, s.CORRECTNODE_1, --<<rvs:00005545
                         s.CLCMODE, --<<rvs:00004440
                         s.ASUBTYPE,
                         --s.IDFORMULS --CQ[9359] -- MK 28.02.2013 CQ[11107] 
                         s.k_itogo /*14460*/, s.k_pr/*15421*/
                      from a_smeta s
                      --where s.NOMERROD1 = :IN_ID AND s.SMETATYPE = :H_SMETATYPE --CQ[TIMUR 8612]
                      where s.ID = :F_ID
                   into /*S_ID, S_IDHIER, S_SMETATYPE, S_NUMBER1, S_NUMBER2, S_NUMBER3, S_SLAVEPARENT, S_ATYPE, SM_RABMAT, [6921]SM_TYPE_TRUD,*/
                         S_TAB, S_ALTTAB, S_NAME_ID, S_ID_EDIZM, S_EDIZM_TYPE, S_KOLL, S_SKOLL, S_NORMARASH,
                         S_BA, S_BB, S_BC, S_BD, S_BE, S_BF, S_BG, S_BH, S_BI, S_BJ, S_BN, S_BO, S_B_ITOGO,
                         --CQ[9359]S_SEA, S_SEB, S_SEC, S_SED, S_SEE, S_SEF, S_SEG, S_SEH, S_SEI, S_SEJ, S_SEK,
                         --CQ[9412]S_EA, S_EB, S_EC, S_ED, S_EE, S_EF, S_EG, S_EH, S_EI, S_EJ, S_EK,
                         --CQ[9359]S_SRA, S_SRB, S_SRC, S_SRD, S_SRE, S_SRF, S_SRG, S_SRH, S_SRI, S_SRJ, S_SRK, S_SRL, S_SRM,
                         --CQ[9412]S_RA, S_RB, S_RC, S_RD, S_RE, S_RF, S_RG, S_RH, S_RI, S_RJ, S_RK, S_RL, S_RM,
                         --CQ[9412]S_PA, S_PB, S_PC, S_PD, S_PE,
                         S_VRPZ, S_IDTIPR,
                         S_KA, S_KB, S_KC, S_KD, S_KE, S_KF, S_KG, S_KH, S_KI, S_KJ, S_KK, S_KL, S_KM,
                         S_PUNKTIND,
                         --CQ[9412]S_MA, S_MB, S_MC, S_MD, S_ME, S_MF, S_MG, S_MH, S_MI, S_MJ, S_MK, S_ML,
                         S_SSTCH, S_KODZAK, S_KODGP, S_KODSP, S_KODISP, S_NACH, S_OKONCH, S_TIPRAB,
                         S_IDNORMATIV, S_IDNORMATIVUNIQ, S_KODIR_GROUP, S_KODIR_PODGROUP, S_ISGROUPOKP,
                         S_ARPS_OTHER, S_DORECALC, s_norm_guid, s_STATUS_REC_CEN, s_VIDRAB,
                         S_CORRECTNODE, S_CORRECTNODE_1, --<<rvs:00005545
                         S_CLCMODE, --<<rvs:00004440
                         S_ASUBTYPE,
                         --:IDFORMULS --CQ[9359] -- MK 28.02.2013 CQ[11107] 
                         s_k_itogo/*14460*/, s_k_pr/*15421*/
                         ;
                 /*, S_ID_S_RES, S_NOMERROD, S_PR_ADDED_REC, S_NOMERROD1 */

              -- CQ[14228] [13929] -->
              FIELD_VALUE = null;
              select FIELD_VALUE from A_SMETA_BLOB
              where ID = :F_ID and FIELD_NAME='TAB'
              into :FIELD_VALUE;
              -- CQ[14228] [13929] <--

            end
            -- MK 28.02.2013 CQ[11107] --->
            else
            begin
              --       ,  .    
              --       
              --  
              if (S_SMETATYPE > 999) then
              begin
                --       
                VN_ID_TR = null;
                select first 1 f.id_tr, f.res_copy_formuls
                from a_o_factparams f
                where (f.number = :ID_PR)
                into :VN_ID_TR, :VN_RES_COPY_FORMULS;

                select first 1 RES_IDFORMULS
                from A_S_GET_FORMULS_DM(:ID_USER, :S_ATYPE, :S_SLAVEPARENT,
                                        :VN_ID_TR, :S_VRPZ, :VN_RES_COPY_FORMULS, null)
                into :IDFORMULS;
              end

              -- CQ[14228] [13929] -->
              FIELD_VALUE = null;
              select FIELD_VALUE from A_SMETA_BLOB
              where ID = :IN_ID and FIELD_NAME='TAB'
              into :FIELD_VALUE;
              -- CQ[14228] [13929] <--

            end
            -- MK 28.02.2013 CQ[11107] <---

            -- MK   CQ[14357] --->
            --          
            if (S_ATYPE = 18) then
            begin
              select getbit(s1.clcmode, 10)
              from a_smeta s1
              where (s1.id = :S_SLAVEPARENT)
              into :vn_clcmode;
            end
            else
            -- MK   CQ[14357] <---
              vn_clcmode = getbit(:S_CLCMODE, 10); -- MK CQ[12020]

            execute procedure a_set_g_number_obg ( 1 ) RETURNING_VALUES ( ID );

            if ( ( NEW_SLAVEPARENT is null ) or ( NEW_SLAVEPARENT < 0 ) ) then
            begin
               NEW_NUMBER1 = S_NUMBER1;
               NEW_NUMBER2 = S_NUMBER2;
               NEW_NUMBER3 = S_NUMBER3;

               SLAVEPARENT = 0;
               if ( S_SLAVEPARENT <> 0 ) then
               begin
                  for select first 1 ID from a_smeta
                                where idhier = :s_idhier and
                                      smetatype = :ID_PR and
                                      nomerrod = :s_slaveparent
                      into SLAVEPARENT
                  do
                      SLAVEPARENT = SLAVEPARENT;
               end

               -- MK CQ[12020] --->
               NEW_VIEW_NUMBER1 = VN_VIEW_NUMBER1;
               NEW_VIEW_NUMBER2 = VN_VIEW_NUMBER2;
               NEW_VIEW_NUMBER3 = VN_VIEW_NUMBER3;
               -- MK CQ[12020] <---
            end
            else
               SLAVEPARENT = NEW_SLAVEPARENT;

            -- MK 18.08.2011 CQ[9412]    () --->
/*
            if (:H_SMETATYPE is not null) then
            begin
              select pa, pb, pc, pd, mf, mg, mh, mi
              from swap_nrsp_and_zu(:H_SMETATYPE, :PR_ID_OBJ, :s_pa, :s_pb, :s_pc, :s_pd, :s_mf, :s_mg, :s_mh, :s_mi)
              into :s_pa, :s_pb, :s_pc, :s_pd, :s_mf, :s_mg, :s_mh, :s_mi;
            end
*/
            -- CQ[9412] <---
            /*      */


            insert into a_smeta (
                 ID, IDHIER, SMETATYPE, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE,
                 RABMAT, /*[6921]*/TYPE_TRUD, TAB, ALTTAB, NAME_ID, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
                 BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BN, BO, B_ITOGO,
                 --CQ[9359]SEA, SEB, SEC, SED, SEE, SEF, SEG, SEH, SEI, SEJ, SEK,
                 --CQ[9412]EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK,
                 --CQ[9359]SRA, SRB, SRC, SRD, SRE, SRF, SRG, SRH, SRI, SRJ, SRK, SRL, SRM,
                 RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM,
                 --CQ[9412]PA, PB, PC, PD, PE,
                 VRPZ, IDTIPR,
                 KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
                 PUNKTIND,
                 --CQ[9412]MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML,
                 SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH, TIPRAB,
                 IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP,
                 ARPS_OTHER, DORECALC, ID_S_RES, NOMERROD, norm_guid, STATUS_REC_CEN, VIDRAB,
                 CORRECTNODE, CORRECTNODE_1, --<<rvs:00005545
                 CLCMODE, --<<rvs:00004440
                 ASUBTYPE,
                 IDFORMULS, --CQ[9359]
                 K_ITOGO /*14460*/, k_pr/*15421*/
                  )
            values (
                 :ID, :S_IDHIER, :ID_PR, :NEW_NUMBER1, :NEW_NUMBER2, :NEW_NUMBER3, :SLAVEPARENT, :S_ATYPE,
                 :SM_RABMAT, /*[6921]*/:SM_TYPE_TRUD, :S_TAB, :S_ALTTAB, :S_NAME_ID, :S_ID_EDIZM, :S_EDIZM_TYPE, /*:KOLL*/0, /*null*/:S_SKOLL , :S_NORMARASH,
                 :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BF, :S_BG, :S_BH, :S_BI, :S_BJ, :S_BN, :S_BO, :S_B_ITOGO,
                 --CQ[9359]:S_SEA, :S_SEB, :S_SEC, :S_SED, :S_SEE, :S_SEF, :S_SEG, :S_SEH, :S_SEI, :S_SEJ, :s_sek,
                 --CQ[9412]:S_EA, :S_EB, :S_EC, :S_ED, :S_EE, :S_EF, :S_EG, :S_EH, :S_EI, :S_EJ, :s_ek,
                 --CQ[9359]:S_SRA, :S_SRB, :S_SRC, :S_SRD, :S_SRE, :S_SRF, :S_SRG, :S_SRH, :S_SRI, :S_SRJ, :S_SRK, :S_SRL, :S_SRM,
                 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                 --CQ[9412]:S_PA, :S_PB, :S_PC, :S_PD, :S_PE,
                 :S_VRPZ, :S_IDTIPR,
                 :S_KA, :S_KB, :S_KC, :S_KD, :S_KE, :S_KF, :S_KG, :S_KH, :S_KI, :S_KJ, :S_KK, :S_KL, :S_KM,
                 :S_PUNKTIND,
                 --CQ[9412]:S_MA, :S_MB, :S_MC, :S_MD, :S_ME, :S_MF, :S_MG, :S_MH, :S_MI, :S_MJ, :S_MK, :S_ML,
                 :S_SSTCH, :S_KODZAK, :S_KODGP, :S_KODSP, :S_KODISP, :S_NACH, :S_OKONCH, :S_TIPRAB,
                 :S_IDNORMATIV, :S_IDNORMATIVUNIQ, :S_KODIR_GROUP, :S_KODIR_PODGROUP, :S_ISGROUPOKP,
                 :S_ARPS_OTHER, :S_DORECALC, /*:ID_S_RES*/ null, :S_ID, :s_norm_guid, null, :s_VIDRAB,
                 :S_CORRECTNODE, :S_CORRECTNODE_1, --<<rvs:00005545
                 :S_CLCMODE, --<<rvs:00004440
                 :s_asubtype,
                 :IDFORMULS,
                 :S_K_ITOGO /*14460*/, :S_K_PR/*15421*/
                  );

            -- CQ[14228] [13929] -->
           if (not :FIELD_VALUE is null) then
             insert into A_SMETA_BLOB (ID, FIELD_NAME, FIELD_VALUE)
             values (:ID, 'TAB', :FIELD_VALUE);
          -- CQ[14228] [13929] <--

            -- MK CQ[12020] --->
            --   A_SMETA_VIEW_NUM   
            update A_SMETA_VIEW_NUM v
            set v.number1 = case when :vn_clcmode = 0 then :NEW_VIEW_NUMBER1 else null end,
                v.number2 = case when :vn_clcmode = 0 then :NEW_VIEW_NUMBER2 else null end,
                v.number3 = case when :vn_clcmode = 0 then :NEW_VIEW_NUMBER3 else null end
            where (v.id = :ID);
            -- MK CQ[12020] <---

            -- MK 15.10.2013 CQ[11675]
            if (S_ATYPE in (17, 19)) then
              execute procedure DOCUMENT_LOG_INS(:ID, :ID_PR, :S_ATYPE);


            --     
            for select first 1 IDNORMO, IDPRICE, ROW, COST, KOEF from smeta_pricepos_info
            where ID = :IN_ID
                  and ((IDCENLVL = :PR_IDLEVEL) or (IDCENLVL = 0))   -- CQ[12347]
            into :D_NORMOID, :D_PRICEID, :D_ROW, :d_cost, :D_KOEF
            do
            begin
              execute procedure set_smeta_priceposinfo_nl(:ID, 0, :D_PRICEID, :D_NORMOID, :D_ROW, :d_cost, :D_KOEF ); -- CQ[12347]
            end

            if ((S_ATYPE = 17) and (SM_RABMAT = 0)) then
              execute procedure UPDATE_SMETA_UNION_INFO(:S_IDNORMATIV, :IN_ID, :ID);  --CQ[TIMUR 9063]

            -- MK 18.08.2011 CQ[9412]          
            if (:S_ATYPE in (17, 18)) then
              --CQ[9439] execute procedure M_COPY_SMETA_CENLVL (coalesce(:F_ID, :IN_ID), :ID, :PR_ID_OBJ);

              -- MK CQ[10095] --->
              execute procedure M_COPY_SMETA_CENLVL (coalesce(:F_ID, :IN_ID), :ID, :ID_PR, :PR_IDLEVEL);
              --execute procedure M_COPY_SMETA_CENLVL_ONE_REC (coalesce(:F_ID, :IN_ID), :ID, :PR_IDLEVEL, :PR_IDLEVEL);--CQ[9439]
              -- MK CQ[10095] <---


/* ========================================================================== */
            /*     (       ) */
            for select ID from L_PR_GET_S_RES ( :ID_USER , :S_ID , :PR_ID_OBJ , :PR_LYEAR , :PR_LMONTH )
                into S_RES_ID
            do
            for select a.ID, a.ID_SOURCE, a.NORM_ID, a.NORM_PODGROUP,
                       a.KODIR_GROUP, a.KODIR_PODGROUP, a.ISGROUPOKP, a.RABMAT, a.TYPE_TRUD,
                       a.TAB, a.ALTTAB, a.NAME_ID, a.IDEDIZM, a.EDIZM_TYPE,
                       a.RASHOD, a.rashod_base, a.correct,
                       a.BB, a.BC, a.BD, a.BE,
                       a.VIDNR, a.UCH,
                       a.STATUS_EDIT, a.STATUS_DOB_V_ZENU, a.STATUS_REC_CEN,
                       a.NOTE, a.NOMERROD, a.SMETATYPE, a.norm_guid, -- CQ [6884] , a.id_price
                       a.CLCMODE -- CQ[12244]
                from a_s_res a
                where ID = :S_RES_ID
--            for select * from a_s_res
--                where id_source = :S_ID
--                order by rabmat, tab
                into  S_RES_ID, S_RES_ID_SOURCE, S_RES_NORM_ID, S_RES_NORM_PODGROUP,
                      S_RES_KODIR_GROUP, S_RES_KODIR_PODGROUP, S_RES_ISGROUPOKP, S_RES_RABMAT, :RES_TYPE_TRUD,
                      S_RES_TAB, S_RES_ALTTAB, S_RES_NAME_ID, S_RES_IDEDIZM, S_RES_EDIZM_TYPE,
                      S_RES_RASHOD, :res_rashod_base, :res_correct,
                      S_RES_BB, S_RES_BC, S_RES_BD, S_RES_BE,
                      S_RES_VIDNR, S_RES_UCH,
                      S_RES_STATUS_EDIT, S_RES_STATUS_DOB_V_ZENU, S_RES_STATUS_REC_CEN,
                      S_RES_NOTE, S_RES_NOMERROD, S_RES_SMETATYPE, :s_res_norm_guid, -- CQ [6884] , :ID_PRICE
                      :CLCMODE_RES -- CQ[12244]
            do
            begin

               /* recive last values for sm. res. ( for version sm. res. in last procentov. ) */

               --CQ[TIMUR 8612]         -       
               --for select NUMBER from A_O_HIER_SELECT_PR ( :ID_USER , :PR_ID_OBJ , :PR_LYEAR , :PR_LMONTH )
               --into H_SMETATYPE

               -- MK 14.03.2011 CQ[9190] --->
               execute procedure T_GET_ACTUAL_REC_TO_VIP(:ID_USER, 2, :S_RES_ID, :PR_ID_OBJ, :PR_LYEAR, :PR_LMONTH)
               returning_values(:F_ID);
               --select ID from T_GET_ACTUAL_REC_TO_VIP(:ID_USER, 2, :S_RES_ID, :PR_ID_OBJ, :PR_LYEAR, :PR_LMONTH)
               --into F_ID;
               -- MK 14.03.2011 CQ[9190] <---
               --CQ[TIMUR 8612]

               if (F_ID is not null) then --CQ[TIMUR 8612]
               begin
                  select first 1
                            /*ID, ID_SOURCE,*/ r.NORM_ID, r.NORM_PODGROUP,
                            r.KODIR_GROUP, r.KODIR_PODGROUP, r.ISGROUPOKP, r.RABMAT,
                            r.TAB, r.ALTTAB, r.NAME_ID, r.IDEDIZM, r.EDIZM_TYPE,
                            r.RASHOD,
                            r.BB, r.BC, r.BD, r.BE,
                            r.VIDNR, r.UCH,
                            r.STATUS_EDIT, r.STATUS_DOB_V_ZENU, r.STATUS_REC_CEN,
                            r.NOTE/*, S_RES_NOMERROD, S_RES_SMETATYPE*/, r.norm_guid,
                            r.rashod_base, r.correct, r.type_trud, -- CQ [6884] ,  r.ID_PRICE
                            r.CLCMODE -- CQ[12244]
                      from a_s_res r
                      --where smetatype = :H_SMETATYPE and NOMERROD = :S_RES_ID --CQ[TIMUR 8612]
                      where ID = :F_ID
                      into  /*S_RES_ID, S_RES_ID_SOURCE,*/ S_RES_NORM_ID, S_RES_NORM_PODGROUP,
                            S_RES_KODIR_GROUP, S_RES_KODIR_PODGROUP, S_RES_ISGROUPOKP, S_RES_RABMAT,
                            S_RES_TAB, S_RES_ALTTAB, S_RES_NAME_ID, S_RES_IDEDIZM, S_RES_EDIZM_TYPE,
                            S_RES_RASHOD,
                            S_RES_BB, S_RES_BC, S_RES_BD, S_RES_BE,
                            S_RES_VIDNR, S_RES_UCH,
                            S_RES_STATUS_EDIT, S_RES_STATUS_DOB_V_ZENU, S_RES_STATUS_REC_CEN,
                            S_RES_NOTE/*, S_RES_NOMERROD, S_RES_SMETATYPE*/, :s_res_norm_guid,
                            :res_rashod_base, :res_correct, :res_type_trud, -- CQ [6884] , :ID_PRICE
                            :CLCMODE_RES -- CQ[12244]
                            ;

                      -- MK CQ[14228] [13929] -->
                      FIELD_VALUE = null;
                      if (char_length(:S_RES_TAB)=42) then
                        select FIELD_VALUE
                          from A_S_RES_BLOB
                          where (ID = :F_ID) and (FIELD_NAME = 'TAB')
                        into :FIELD_VALUE;
                      -- MK CQ[14228] [13929] <--
               end
               -- MK CQ[14228] [13929] -->
               else
               begin
                 FIELD_VALUE = null;
                 if (char_length(:S_RES_TAB)=42) then
                   select FIELD_VALUE
                     from A_S_RES_BLOB
                     where (ID = :S_RES_ID) and (FIELD_NAME = 'TAB')
                   into :FIELD_VALUE;
               end
               -- MK CQ[14228] [13929] <--

               execute procedure a_set_g_number_obg ( 1 ) RETURNING_VALUES ( ID_RES );

               execute procedure a_s_res_append ( :ID_USER,
                      :ID_RES, :ID, :S_RES_NORM_ID, :S_RES_NORM_PODGROUP,
                      :S_RES_KODIR_GROUP, :S_RES_KODIR_PODGROUP, :S_RES_ISGROUPOKP, :S_RES_RABMAT,
                      :S_RES_TAB, :S_RES_ALTTAB, :S_RES_NAME_ID, :S_RES_IDEDIZM, :S_RES_EDIZM_TYPE,
                      :S_RES_RASHOD, :res_rashod_base, :res_correct,
                      :S_RES_BB, :S_RES_BC, :S_RES_BD, :S_RES_BE,
                      :S_RES_VIDNR, :S_RES_UCH,
                      :S_RES_STATUS_EDIT, :S_RES_STATUS_DOB_V_ZENU, :S_RES_STATUS_REC_CEN,
                      :S_RES_NOTE, :s_res_norm_guid, :res_type_trud, 1,
                      :S_RES_ID/*   */, 1, -- CQ [6884] , :ID_PRICE);
                      :CLCMODE_RES -- CQ[12244]
                      );

               -- MK CQ[14228] [13929] -->
               if (FIELD_VALUE is not null) then
               begin
                 insert into A_S_RES_BLOB (ID, FIELD_NAME, FIELD_VALUE)
                 values (:ID_RES, 'TAB', :FIELD_VALUE);
               end
               -- MK CQ[14228] [13929] <--

                --     
                for select first 1 IDNORMO, IDPRICE, ROW, COST, KOEF from smeta_pricepos_info
                where ID = :S_RES_ID
                      and ((IDCENLVL = :PR_IDLEVEL) or (IDCENLVL = 0))   -- CQ[12347]
                into :D_NORMOID, :D_PRICEID, :D_ROW, :d_cost, :D_KOEF
                do
                begin
                  execute procedure set_smeta_priceposinfo_nl(:ID_RES, 0, :D_PRICEID, :D_NORMOID, :D_ROW, :d_cost, :D_KOEF ); -- CQ[12347]
                end



                -- M_COPY_S_RES_CENLVL
                -- MK 18.08.2011 CQ[9412]          
                --CQ[9439] execute procedure M_COPY_S_RES_CENLVL (coalesce(:F_ID, :S_RES_ID), :ID_RES, :PR_ID_OBJ);
                --CQ[10374]execute procedure M_COPY_S_RES_CENLVL_ONE_REC (coalesce(:F_ID, :S_RES_ID), :ID_RES, :PR_IDLEVEL, :PR_IDLEVEL);--CQ[9439]
                 execute procedure M_COPY_S_RES_CENLVL (coalesce(:F_ID, :S_RES_ID), :ID_RES, :ID_PR, :PR_IDLEVEL);--CQ[10374]

/*
semenov -  , -,   
               update a_s_res set
                  NOMERROD = :S_RES_ID,
                  SMETATYPE = :ID_PR
               where id = :ID_RES;
*/
--               insert into a_s_res (
--                      ID, ID_SOURCE, NORM_ID, NORM_PODGROUP,
--                      KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, RABMAT,
--                      TAB, ALTTAB, NAME_ID, IDEDIZM, EDIZM_TYPE,
--                      RASHOD, BB, BC, BD, BE, VIDNR, UCH,
--                      STATUS_EDIT, STATUS_DOB_V_ZENU, STATUS_REC_CEN,
--                      NOTE, NOMERROD, SMETATYPE )
--                    values (
--                      :ID_RES, :ID, :S_RES_NORM_ID, :S_RES_NORM_PODGROUP,
--                      :S_RES_KODIR_GROUP, :S_RES_KODIR_PODGROUP, :S_RES_ISGROUPOKP, :S_RES_RABMAT,
--                      :S_RES_TAB, :S_RES_ALTTAB, :S_RES_NAME_ID, :S_RES_IDEDIZM, :S_RES_EDIZM_TYPE,
--                      :S_RES_RASHOD, :S_RES_BB, :S_RES_BC, :S_RES_BD, :S_RES_BE, :S_RES_VIDNR, :S_RES_UCH,
--                      :S_RES_STATUS_EDIT, :S_RES_STATUS_DOB_V_ZENU, :S_RES_STATUS_REC_CEN,
--                      :S_RES_NOTE, :S_RES_ID, /*:S_SMETATYPE*/ :ID_PR );

--               _break;
            end



            /*           ID_S_RES */
            ID_S_RES = null;
            if ( ( not S_ID_S_RES is null ) and ( S_ID_S_RES <> 0 ) ) then
            begin
               for select first 1 ID, ID_SOURCE from a_s_res
--                   where NOMERROD = :S_ID_S_RES and SMETATYPE = :S_SMETATYPE /* ??? */
                   where NOMERROD = :S_ID_S_RES and SMETATYPE = :id_pr
                   into ID_S_RES1, ID_SOURCE
               do
                  for select first 1 smetatype from a_smeta where id = :ID_SOURCE and smetatype = :id_pr
                      into dummy
                  do
                      ID_S_RES = ID_S_RES1;

               if (ID_S_RES is null ) then
               begin

                  for select first 1 NOMERROD from a_s_res
                      where ID = :S_ID_S_RES
                      into  :S_ID_S_RES
                  do
                      for select first 1 ID, ID_SOURCE from a_s_res
                          where NOMERROD = :S_ID_S_RES and SMETATYPE = :id_pr
                          into ID_S_RES1, ID_SOURCE
                      do
                          for select first 1 smetatype from a_smeta where id = :ID_SOURCE and smetatype = :id_pr
                              into dummy
                          do
                            ID_S_RES = ID_S_RES1;
               end
            end

            update a_smeta
               set ID_S_RES = :ID_S_RES
            where ID = :ID;


/* ========================================================================== */
            /*    */
            for select ID, ID_SOURCE, NORM_ID, NORM_PODGROUP,
                       KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, RABMAT, type_trud,
                       TAB, ALTTAB, NAME_ID, IDEDIZM, EDIZM_TYPE,
                       RASHOD, BB, BC, BD, BE, VIDNR, UCH,
                       norm_guid
            from m_etalon_s_res
            where id_source = :S_ID
            into  S_RES_ID, S_RES_ID_SOURCE, S_RES_NORM_ID, S_RES_NORM_PODGROUP,
                  S_RES_KODIR_GROUP, S_RES_KODIR_PODGROUP, S_RES_ISGROUPOKP, S_RES_RABMAT, :res_type_trud,
                  S_RES_TAB, S_RES_ALTTAB, S_RES_NAME_ID, S_RES_IDEDIZM, S_RES_EDIZM_TYPE,
                  S_RES_RASHOD, S_RES_BB, S_RES_BC, S_RES_BD, S_RES_BE, S_RES_VIDNR, S_RES_UCH,
                  :s_res_norm_guid do
            begin
               execute procedure a_set_g_number_obg ( 1 ) RETURNING_VALUES ( ID_RES );

               /* MK CQ[3569] 25.07.2006 ---> */
               /*        (mode = 2) */
               execute procedure m_et_res_append(:ID_USER, :ID_RES, :ID,
                                                 null/*:res_norm_id*/,
                                                 null/*:res_norm_podgroup*/,
                                                 null/*:source_param_kodir_group*/,
                                                 null/*:source_param_kodir_podgroup*/,
                                                 null/*:res_isgroupokp*/,
                                                 null/*:res_rabmat*/,
                                                 null/*:res_tab*/,
                                                 null/*:res_alttab*/,
                                                 null/*:res_name_id*/,
                                                 null/*:res_idedizm*/,
                                                 null/*:res_edizm_type*/,
                                                 null/*:res_rashod*/,
                                                 null/*:res_rashod_base*/,
                                                 null/*:res_correct*/,
                                                 null/*:res_bb*/,
                                                 null/*:res_bc*/,
                                                 null/*:res_bd*/,
                                                 null/*:res_be*/,
                                                 null/*:res_vidnr*/,
                                                 null/*:res_uch*/,
                                                 null/*:res_status_edit*/,
                                                 null/*:res_status_dob_v_zenu*/,
                                                 null/*:res_status_rec_cen*/,
                                                 null/*:res_note*/,
                                                 :S_RES_ID/*:nomerrod*/,
                                                 null/*:res_norm_guid*/,
                                                 null/*:res_type_trud*/,

                                                 :S_RES_NORM_ID, :S_RES_NORM_PODGROUP,
                                                 :S_RES_KODIR_GROUP, :S_RES_KODIR_PODGROUP, :S_RES_ISGROUPOKP,
                                                 :S_RES_RABMAT, :S_RES_TAB, :S_RES_ALTTAB,
                                                 :S_RES_NAME_ID, :S_RES_IDEDIZM, :S_RES_EDIZM_TYPE,
                                                 :S_RES_RASHOD,
                                                 :S_RES_BB, :S_RES_BC, :S_RES_BD, :S_RES_BE,
                                                 :S_RES_VIDNR, :S_RES_UCH,
                                                 :s_res_norm_guid, :res_type_trud,

                                                 1/*:sender*/,
                                                 2,/*:mode*/
                                                 0 -- CQ[12244] CLCMODE_RES = 0
                                                 );
                                                 --CQ [6884]  null);
               --CQ[10973] execute procedure DM_COPY_ET_RES_CENLVL (coalesce(:F_ID, :S_RES_ID), :ID_RES, :ID_PR, :PR_IDLEVEL);--CQ[10374]
               execute procedure DM_COPY_ET_RES_CENLVL (:S_RES_ID, :ID_RES, :ID_PR, :PR_IDLEVEL);--CQ[10973]
            end
            /* MK <--- */


            suspend;
         end
end
^

--TFS[338],TFS[242]
create or alter procedure L_PR_CREATE_KC6_1 (
    ID_OBJ integer,
    IN_SMETATYPE integer,
    ID_USER integer,
    LYEAR integer,
    USE_ONLY_UTV_PROCENT integer,
    SENDER integer,
    STOIMMODE integer,
    HIERCHECKING_SMETATYPE integer,
    HIERCHECKING_ATYPE integer,
    HIERCHECKING_MUST_EXISTS integer,
    NEED_NAME_EDIZM integer,
    ID_CENLVL integer,
    ID_PS_CENLVL integer)
returns (
    ID_SELF integer,
    ID integer,
    IDHIER integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    SLAVEPARENT integer,
    ATYPE integer,
    BMP integer,
    NPP varchar(21),
    TAB varchar(42),
    NAME blob sub_type 0 segment size 80,
    EDIZM varchar(250),
    KOLL double precision,
    RA double precision,
    RA_NET double precision,
    RB double precision,
    RC double precision,
    RD double precision,
    RE double precision,
    RF double precision,
    RG double precision,
    RH double precision,
    RI double precision,
    RJ double precision,
    RK double precision,
    PA double precision,
    PB double precision,
    KOLL_PRIOR double precision,
    RA_PRIOR double precision,
    KOLL_YEAR double precision,
    RA_YEAR double precision,
    KOLL_OST double precision,
    RA_OST double precision,
    IDSRES integer,
    IDNORMO integer,
    SMETAPARENT integer,
    RABMAT integer,
    TYPE_TRUD integer,
    ID_EDIZM integer,
    TIPRAB integer,
    TAB_LONG blob sub_type 1 segment size 80,
    CLCMODE integer)
AS
DECLARE VARIABLE CLCMODE_17 INTEGER;
--CQ[TIMUR 13931] -    cur_shifr, fullname
DECLARE VARIABLE key2 INTEGER;
DECLARE VARIABLE id_name INTEGER;
--declare variable id_edizm integer; --CQ[TIMUR 7475]
DECLARE VARIABLE edizm_type INTEGER;
DECLARE VARIABLE smetatype INTEGER;
DECLARE VARIABLE cur_shifr VARCHAR(1024);
DECLARE VARIABLE fullname VARCHAR(1024);
DECLARE VARIABLE number INTEGER;
DECLARE VARIABLE nomerrod INTEGER;
DECLARE VARIABLE koll_loc DOUBLE PRECISION;
DECLARE VARIABLE ra_loc DOUBLE PRECISION;
DECLARE VARIABLE id1 INTEGER;
--declare variable pr_number1 integer;
--declare variable pr_number2 integer;
--declare variable pr_number3 integer;
--declare variable pr_vsego double precision;
--declare variable pr_exists_childs integer;
DECLARE VARIABLE lyear1 INTEGER;
DECLARE VARIABLE lmonth INTEGER;
DECLARE VARIABLE lyear2 INTEGER;
DECLARE VARIABLE lmonth2 INTEGER;
DECLARE VARIABLE checknode INTEGER;
DECLARE VARIABLE koll_ra DOUBLE PRECISION;
--DECLARE VARIABLE rd DOUBLE PRECISION;
--DECLARE VARIABLE rj DOUBLE PRECISION;
--DECLARE VARIABLE rk DOUBLE PRECISION;

--[15286] DECLARE VARIABLE nr_ot_zpm DOUBLE PRECISION;
--[15286] DECLARE VARIABLE sp_ot_zpm DOUBLE PRECISION;
DECLARE VARIABLE MF DOUBLE PRECISION;
DECLARE VARIABLE MG DOUBLE PRECISION;
DECLARE VARIABLE INDEX_RASCHNRISP INTEGER;

--[15286] DECLARE VARIABLE rd_loc DOUBLE PRECISION;
--[15286] DECLARE VARIABLE rj_loc DOUBLE PRECISION;
--[15286] DECLARE VARIABLE rk_loc DOUBLE PRECISION;
--[15286] DECLARE VARIABLE pa_loc DOUBLE PRECISION;
--[15286] DECLARE VARIABLE pb_loc DOUBLE PRECISION;

-- MK 15.05.2012 CQ[9744]
DECLARE VARIABLE VN_ID_CENLVL_BASE INTEGER;
DECLARE VARIABLE VN_ID_CENLVL_WORK INTEGER;
declare variable VN_ID_STRUCT integer;
BEGIN
   KEY2 = GEN_ID ( LG_S_TMP_TBL_KEY2 , 1 );

/*
   LYEAR1 = LYEAR - 1;
   LMONTH = 12;
   if ( LYEAR = 0 ) then
   begin
      LYEAR1 = 0;
      LMONTH = 0;
   end
*/

   -- MK 15.05.2012 CQ[9744] --->
   /*CQ[10944]
   IF (ID_CENLVL = ID_OBJ) THEN
   BEGIN
     EXECUTE PROCEDURE M_GET_AKT_CENLVL(:ID_OBJ)
     RETURNING_VALUES :VN_ID_CENLVL_BASE;
   END
   ELSE
     VN_ID_CENLVL_BASE = ID_CENLVL; */
   VN_ID_CENLVL_BASE = :ID_PS_CENLVL;--CQ[10944]
   -- MK 15.05.2012 CQ[9744] <---


   IF ( HIERCHECKING_SMETATYPE IS NULL ) THEN
      HIERCHECKING_SMETATYPE = 0;
   IF ( HIERCHECKING_ATYPE IS NULL ) THEN
      HIERCHECKING_ATYPE = 0;
   IF ( HIERCHECKING_MUST_EXISTS IS NULL ) THEN
      HIERCHECKING_MUST_EXISTS = 0;
   IF ( NEED_NAME_EDIZM IS NULL ) THEN
      NEED_NAME_EDIZM = 0;


   LYEAR1 = 0;
   LMONTH = 0;
   IF ( LYEAR = 0 ) THEN
   BEGIN
      LYEAR2 = 0;
      LMONTH2 = 0;
   END
   ELSE
   BEGIN
      LYEAR2 = LYEAR - 1;
      LMONTH2 = 13;
   END

   IF ( ( StoimMode IS NULL ) OR ( NOT StoimMode IN ( 0,1 /* ,2  [15286] */ ) ) ) THEN
      StoimMode = 0;

   checknode = 0;

--[15286]    nr_ot_zpm = 0;
--[15286]    sp_ot_zpm = 0;
   -- MK 15.05.2012 CQ[9744] --->
   --  -   . [921DE75F]
   --select first 1 a.nr_ot_zpm, a.sp_ot_zpm from a_o_objectparams a where number = :ID_OBJ into :pa, :pb;
   -- MK 15.05.2012 CQ[9744] <---


   FOR SELECT ID_SELF, ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT
       FROM L_PR_CREATE_KC6_BASE ( :ID_OBJ, :KEY2, :IN_SMETATYPE, :LYEAR1 , :LMONTH, :ID_USER, :SENDER, 0 )
       INTO   ID_SELF, ID, IDHIER, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT
   DO
      IF ( ID_SELF IS NULL ) THEN /* struct. str.  */
      BEGIN
         ATYPE = SLAVEPARENT;
         SLAVEPARENT = 0;

         EXECUTE PROCEDURE a_h_GetName :IDHIER, :ATYPE RETURNING_VALUES :cur_shifr, :fullname;
         IF ( fullname IS NULL ) THEN
            fullname = '';
         NAME = COPYVARCHARTOBLOB_1024(FULLNAME); --CQ[TIMUR 13931] name = copyvarchartoblob(fullname);

       NPP = NULL; TAB = NULL; EDIZM = NULL; KOLL = NULL; KOLL_RA = NULL;
       RA = NULL; RA_NET = NULL; RB = NULL; RC = NULL; RD = NULL; RE = NULL;
       RF = NULL; RG = NULL; RH = NULL; RI = NULL; RJ = NULL; RK = NULL; PA = NULL; PB = NULL;
       KOLL_PRIOR = NULL; RA_PRIOR = NULL;

       TAB_LONG = NULL; -- <-- Voyager CQ[13929,14786]

       IF ( NOT ATYPE IN ( 26,27,28 ) ) THEN
       BEGIN

         IF ( ( HIERCHECKING_SMETATYPE <> 0 ) AND ( HIERCHECKING_ATYPE <> 0 ) ) THEN
         BEGIN
           checknode = NULL;

           SELECT hch.id
           FROM A_O_HIERCHECKING hch
           WHERE (hch.iduser = :id_user) AND
                 (hch.idobject = :id_obj) AND
--                 (hch.smetatype = 17) and
--                 (hch.atype = 15) and
                 (hch.smetatype = :HIERCHECKING_SMETATYPE) AND
                 (hch.atype = :HIERCHECKING_ATYPE) AND
                 (hch.idelem = :IDHIER)
           INTO :checknode;

           IF  ( ( HIERCHECKING_MUST_EXISTS <> 0 ) AND ( checknode IS NULL ) ) THEN        -- ,      (   -  )
             ATYPE = -ATYPE;
           ELSE IF ( HIERCHECKING_MUST_EXISTS = 0 ) THEN  -- ,      (    -  )
              IF ( NOT checknode IS NULL ) THEN
              BEGIN
                 ATYPE = -ATYPE;
                 checknode = NULL;
             END
             ELSE
                 checknode = 0;

         END

       END

         BMP = ATYPE;
         TYPE_TRUD = NULL;
         SUSPEND;

      END
      ELSE IF ( NOT checknode IS NULL ) THEN /* smetn. str. in visible structure */
      BEGIN
         -- MK 15.05.2012 CQ[9744] --->
         FOR SELECT s.ATYPE, s.TAB, s.NAME_ID, s.id_edizm, s.edizm_type, s.KOLL,
                    s.SMETATYPE, s.NOMERROD, s.RABMAT, s.ID_S_RES,
                    s.IDNORMATIV, s.SLAVEPARENT, s.RABMAT, s.TYPE_TRUD, s.TIPRAB, s.CLCMODE /*[15050]*/
             FROM a_smeta s
             WHERE (s.id = :id)
             INTO  :ATYPE, :TAB, :ID_NAME, :id_edizm, :edizm_type, :KOLL,
                   :SMETATYPE, :NOMERROD, :BMP, :IDSRES,
                   :IDNORMO, :SMETAPARENT, :RABMAT, :TYPE_TRUD, :TIPRAB, :CLCMODE /*[15050]*/

         --for select ATYPE, TAB, NAME_ID, id_edizm, edizm_type, KOLL, RA, RD, RJ, RK, SMETATYPE, NOMERROD, RABMAT, ID_S_RES, IDNORMATIV, SLAVEPARENT, RABMAT, TYPE_TRUD, TIPRAB
         --    from a_smeta where id = :id
         --    into   ATYPE, TAB, ID_NAME, id_edizm, edizm_type, KOLL, RA, RD, RJ, RK, SMETATYPE, NOMERROD, BMP, IDSRES, IDNORMO, SMETAPARENT, RABMAT, :TYPE_TRUD, :TIPRAB
         -- MK 15.05.2012 CQ[9744] <---
         DO
         BEGIN
             --[15050]
             if (ATYPE = 18) then
               select first 1 s.CLCMODE
                 from a_smeta s
               where (s.ID = :SMETAPARENT)
               into :CLCMODE;
             else
             if (ATYPE = 19) then CLCMODE = 0;

             if (GETBIT(:CLCMODE, 10) = 1) then KOLL = 0;
             --[15050]

             -- <-- Voyager CQ[13929,14786]
             TAB_LONG = NULL;
             if (char_length(:TAB) = 42) then
             begin
                 select SB.FIELD_VALUE from A_SMETA_BLOB SB
                 where SB.ID = :ID and SB.FIELD_NAME='TAB'
                 into :TAB_LONG;
             end
             -- <-- Voyager CQ[13929,14786]

             -- MK 15.05.2012 CQ[9744] --->
             VN_ID_CENLVL_WORK = CASE WHEN :SMETATYPE = 15 THEN :VN_ID_CENLVL_BASE ELSE :ID_CENLVL END;
             VN_ID_STRUCT = CASE WHEN :SMETATYPE = 15 THEN :ID_OBJ ELSE :SMETATYPE END;

             --   . [921DE75F]
             -- (             )
             SELECT FIRST 1 /*[15286] nr_ot_zpm, sp_ot_zpm, */ INDEX_RASCHNRISP
             FROM level_cost
             WHERE (id = :VN_ID_CENLVL_WORK) AND (idobject = :VN_ID_STRUCT)
             INTO /*:nr_ot_zpm, :sp_ot_zpm, [15286] */ :INDEX_RASCHNRISP;

             --<<[11204]
             RA = NULL; RB = NULL; RC = NULL; RD = NULL; RE = NULL;
             RF = NULL; RG = NULL; RH = NULL; RI = NULL; RJ = NULL; RK = NULL;
             PA = NULL; PB = NULL;

             --CQ[NORILSKY NIKEL] -   Source      ,    -6  RA
             select first 1
                  c.RA, --[15286]
                  case when :STOIMMODE=0 then c.ITOGO else c.RA end,  --[15286]
                  c.RB, c.RC, c.RD, c.RE, c.RF, c.RG, c.RH, c.RI, c.RJ, c.RK, c.pa,  c.PB
               from a_smeta_cenlvl c
               where (c.id = :id) and
                     (c.idcenlvl = :VN_ID_CENLVL_WORK) and
                     (GETBIT(:CLCMODE, 10) = 0) --[15050]
             into :RA_NET/*[15286]*/, :RA, :RB, :RC, :RD, :RE, :RF, :RG, :RH, :RI, :RJ, :RK, :PA, :PB;

             --<<[11204]
             MF = NULL; MG = NULL;

             SELECT FIRST 1 ind.MF, ind.MG
             FROM a_smeta_indlvl ind
             WHERE (ind.id = :id) AND (ind.idcenlvl = :VN_ID_CENLVL_WORK)
             INTO :MF, :MG;

             --[15286] RA_NET = RA;
             PA = case :INDEX_RASCHNRISP when 1 then PA when 2 then MF end;
             PB = case :INDEX_RASCHNRISP when 1 then PB when 2 then MG end;
             --CQ[NORILSKY NIKEL]

             -- MK 15.05.2012 CQ[9744] <---
             IF ( ATYPE = 18 ) THEN
                BMP = BMP + 100;
             ELSE IF ( ATYPE = 19 ) THEN
                BMP = 19;
             ELSE
                BMP = 0;

             IF ( NEED_NAME_EDIZM <> 0 ) THEN
             BEGIN
                EXECUTE PROCEDURE b_getname ( :ID_USER, :ID_NAME ) RETURNING_VALUES ( :NAME );
                EXECUTE PROCEDURE a_get_edizm( :id_user, :id_edizm, :edizm_type ) RETURNING_VALUES ( :edizm );
             END
             ELSE
             BEGIN
                name = NULL;
                edizm = NULL;
             END

             --CQ[11172]EXECUTE PROCEDURE l_pr_kc6_calc_ra(:StoimMode, :RA, :RD, :RJ, :RK, :PA, :PB) RETURNING_VALUES (:RA);
             --[15286] EXECUTE PROCEDURE l_pr_kc6_calc_ra(:StoimMode, :RA, :RD, :RJ, :RK, :nr_ot_zpm, :sp_ot_zpm) RETURNING_VALUES (:RA);--CQ[11172]


             IF ( koll IS NULL ) THEN
                koll = 0;
             KOLL_RA = koll;
             IF ( NOT SMETATYPE IN ( 15 , 16 ) ) THEN
             BEGIN
                KOLL = 0;
                FOR SELECT FIRST 1 pr_vsego FROM l_s_pr_addinfo WHERE id = :id INTO koll
                DO
                BEGIN
                   IF ( koll IS NULL ) THEN
                      koll = 0.0;
                   IF ( NOT RA IS NULL ) THEN
                      IF ( ( NOT KOLL_RA IS NULL ) AND ( KOLL_RA <> 0.0 ) ) THEN
                         RA = RA * KOLL / KOLL_RA;
                END
             END

             NPP = '';
             if (:SMETATYPE = :IN_SMETATYPE) then --[15004]      (   )
             begin
               -- MK CQ[14646] --->
               select v.number1, v.number2, v.number3
               from a_smeta_view_num v
               where (v.id = :ID)
               into :NUMBER1, :NUMBER2, :NUMBER3;
               -- MK CQ[14646] <---

               -- MK CQ[14357] --->
               if (NUMBER1 is not null) then
               begin
                 IF ((atype = 17) or (NUMBER2 = 0)) THEN
                 --IF ( atype = 17 ) THEN
               -- MK CQ[14357] <---
                    NPP = CAST (NUMBER1 AS VARCHAR(10) );
                 ELSE IF ( atype = 18 ) THEN
                    NPP = CAST (NUMBER1 AS VARCHAR(10) ) || '.' || CAST (NUMBER2 AS VARCHAR(10) );
               end -- MK CQ[14357]
             end
             else
             begin --[15004]      ,  excel  
               NUMBER1 = null;
               NUMBER2 = null;
               NUMBER3 = null;
             end

             --CQ[10944]-->
             if (ATYPE = 19) then
               KOLL = NULL;
             --CQ[10944]<--

             KOLL_PRIOR = null; --CQ[10944]0.0;
             RA_PRIOR   = 0.0;
             IF ( ATYPE IN ( 17, 18 ) ) THEN
             BEGIN
                FOR SELECT NUMBER FROM A_O_HIER_SELECT_PR1 ( :ID_USER, :ID_OBJ, :LYEAR2 , :LMONTH2, :USE_ONLY_UTV_PROCENT , 0 )
                    INTO   NUMBER
                DO
                BEGIN
                   --[15286] PA_LOC = 0;
                   --[15286] PB_LOC = 0;
--                   select first 1 a.nr_ot_zpm, a.sp_ot_zpm from a_o_factparams a where number = :ID_OBJ into :pa_LOC, :pb_LOC;

                   /*--[15286] 
                   -- MK 15.05.2012 CQ[9744] --->
                   SELECT FIRST 1 nr_ot_zpm, sp_ot_zpm
                   FROM level_cost
                   WHERE (id = :ID_CENLVL) AND (idobject = :NUMBER)
                   INTO :pa_LOC, :pb_LOC;*/

                   for select
                     case when :STOIMMODE=0 then c.ITOGO else c.RA end,  --[15286]
                     s.KOLL, s.ID --[15286] , c.RD, c.RJ, c.RK
                   from A_SMETA s
                   join a_smeta_cenlvl c on (s.id = c.id) and (c.idcenlvl = :ID_CENLVL)
                   where (s.NOMERROD1 = :ID) and
                         (s.SMETATYPE = :NUMBER) and
                         (GETBIT(s.CLCMODE, 10) = 0) --[15050]
                   into RA_LOC, KOLL_LOC, ID1 --[15286] , RD_LOC, RJ_LOC, RK_LOC

                   --if ( NUMBER = ID_OBJ ) then
                   --   select first 1 a.nr_ot_zpm, a.sp_ot_zpm from a_o_objectparams a where number = :NUMBER into :pa_LOC, :pb_LOC;
                   --else
                   --   select first 1 a.nr_ot_zpm, a.sp_ot_zpm from a_o_factparams a where number = :NUMBER into :pa_LOC, :pb_LOC;
                   --for select KOLL , RA , ID , RD , RJ , RK
                   --    from A_SMETA
                   --    where  ( NOMERROD1 = :ID ) and ( SMETATYPE = :NUMBER )
                   --    into   KOLL_LOC , RA_LOC , ID1 , RD_LOC , RJ_LOC , RK_LOC
                   -- MK 15.05.2012 CQ[9744] <---
                   DO
                   BEGIN
/*
                      KOLL_LOC = null;
                      execute procedure l_pr_select_rec ( :id1, :id_user, :ID_OBJ, :lyear1, :Lmonth, :USE_ONLY_UTV_PROCENT )
                          RETURNING_VALUES ( :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, :PR_VSEGO, :KOLL_LOC, :PR_EXISTS_CHILDS );
*/
                      IF ( NOT KOLL_LOC IS NULL ) THEN
                         KOLL_PRIOR = coalesce(:KOLL_PRIOR, 0.0) + KOLL_LOC;
                      --[15286] EXECUTE PROCEDURE l_pr_kc6_calc_ra ( :StoimMode , :ra_LOC , :rd_LOC , :rj_LOC , :rk_LOC , :pa_LOC , :pb_LOC ) RETURNING_VALUES ( :ra_LOC );
                      IF ( NOT RA_LOC IS NULL ) THEN
                         RA_PRIOR = RA_PRIOR + RA_LOC;
                   END
                END
             END
             KOLL_YEAR = 0.0;
             RA_YEAR   = 0.0;
             KOLL_OST  = 0.0;
             RA_OST    = 0.0;

/*
             if ( ATYPE in ( 18, 19 ) ) then
             begin
             end
*/
             SUSPEND;
         END
      END
   EXECUTE PROCEDURE l_pr_create_kc6_base_finalize ( :key2 );
END
^

--TFS[338],TFS[242]
create or alter procedure M_ADD_REC_TO_MERGED_AKT_NL (
    SOURCE_REC_ID integer,
    RES_KOLL double precision,
    MERGE_AKT_ID integer,
    ID_OBJ integer,
    IS_DOP integer,
    NEW_SLAVEPARENT integer,
    ID_USER integer,
    ID_BASE_CENLVL integer,
    S_NUMBER1 integer,
    S_NUMBER2 integer,
    S_NUMBER3 integer)
returns (
    NEW_ID integer)
AS
declare variable s_id integer;
declare variable s_idhier integer;
--declare variable s_number1 integer;
--declare variable s_number2 integer;
--declare variable s_number3 integer;
declare variable s_atype integer;
declare variable sm_rabmat integer;
declare variable sm_type_trud integer;
declare variable s_tab varchar(42);
declare variable s_alttab varchar(250);
declare variable s_name_id integer;
declare variable s_id_edizm integer;
declare variable s_edizm_type integer;
declare variable s_skoll varchar(255);
declare variable s_normarash double precision;
declare variable s_ba double precision;
declare variable s_bb double precision;
declare variable s_bc double precision;
declare variable s_bd double precision;
declare variable s_be double precision;
declare variable s_bf double precision;
declare variable s_bg double precision;
declare variable s_bh double precision;
declare variable s_bi double precision;
declare variable s_bj double precision;

declare variable s_bn double precision;
declare variable s_bo double precision;
declare variable s_b_itogo double precision;

declare variable s_vrpz integer;
declare variable s_idtipr integer;
declare variable s_ka varchar(50);
declare variable s_kb varchar(50);
declare variable s_kc varchar(50);
declare variable s_kd varchar(50);
declare variable s_ke varchar(50);
declare variable s_kf varchar(50);
declare variable s_kg varchar(50);
declare variable s_kh varchar(50);
declare variable s_ki varchar(50);
declare variable s_kj varchar(50);
declare variable s_kk varchar(50);
declare variable s_kl varchar(50);
declare variable s_km varchar(50);
declare variable s_k_itogo varchar(50);
declare variable s_k_pr varchar(50);
declare variable s_punktind varchar(42);
declare variable s_sstch integer;
declare variable s_kodzak integer;
declare variable s_kodgp integer;
declare variable s_kodsp integer;
declare variable s_kodisp integer;
declare variable s_nach date;
declare variable s_okonch date;
declare variable s_tiprab integer;
declare variable s_idnormativ integer;
declare variable s_idnormativuniq integer;
declare variable s_kodir_group integer;
declare variable s_kodir_podgroup integer;
declare variable s_isgroupokp integer;
declare variable s_arps_other blob sub_type 0 segment size 80;
declare variable s_dorecalc integer;
declare variable s_id_s_res integer;
declare variable s_res_id integer;
declare variable s_res_norm_id integer;
declare variable s_res_norm_podgroup integer;
declare variable s_res_kodir_group integer;
declare variable s_res_kodir_podgroup integer;
declare variable s_res_isgroupokp integer;
declare variable s_res_rabmat integer;
declare variable res_type_trud integer;
declare variable s_res_tab varchar(42);
declare variable s_res_alttab varchar(250);
declare variable s_res_name_id integer;
declare variable s_res_idedizm integer;
declare variable s_res_edizm_type integer;
declare variable s_res_rashod double precision;
declare variable s_res_bb double precision;
declare variable s_res_bc double precision;
declare variable s_res_bd double precision;
declare variable s_res_be double precision;
declare variable s_res_vidnr integer;
declare variable s_res_uch integer;
declare variable s_res_status_edit integer;
declare variable s_res_status_dob_v_zenu integer;
declare variable s_res_status_rec_cen integer;
declare variable s_res_note varchar(255);
declare variable s_res_nomerrod integer;
declare variable id_s_res integer;
declare variable id_res integer;
declare variable id_source integer;
declare variable id_s_res1 integer;
declare variable dummy integer;
declare variable s_norm_guid varchar(100);
declare variable s_res_norm_guid varchar(100);
declare variable s_vidrab integer;
declare variable s_asubtype integer;
declare variable res_rashod_base double precision;
declare variable res_correct varchar(50);
declare variable s_correctnode blob sub_type 0 segment size 80;
declare variable s_correctnode_1 blob sub_type 0 segment size 80;
declare variable s_clcmode integer;
declare variable d_normoid integer;
declare variable d_row integer;
declare variable d_priceid integer;
declare variable d_cost double precision;
declare variable D_KOEF double precision; --CQ[7790]
declare variable New_Nomerrod INTEGER;
declare variable Pr_Vsego double precision;
declare variable IDFORMULS integer; --CQ[9359]
declare variable CLCMODE_RES integer;
-- MK CQ[12020]
declare variable PR_NUMBER1 integer;
declare variable PR_NUMBER2 integer;
declare variable PR_NUMBER3 integer;
declare variable VIEW_NUMBER1 integer;
declare variable VIEW_NUMBER2 integer;
declare variable VIEW_NUMBER3 integer;

declare variable FIELD_VALUE BLOB SUB_TYPE 1 SEGMENT SIZE 80;
declare variable RES_FIELD_VALUE BLOB SUB_TYPE 1 SEGMENT SIZE 80;

begin
--[15352]
  -- MK        L_PR_COPY_SMETA_TO_PR_ONE_REC
  -- MK 17.01.2013 CQ[10124]   M_ADD_REC_TO_MERGED_AKT   

  -- MK 08.10.2015 CQ[12918]
  --  S_NUMBER1, S_NUMBER2, S_NUMBER3  

  NEW_ID = GEN_ID(a_g_smeta, 1);

  -- ===========================================================================
  --     
  for select
         s.ID, s.IDHIER,
         --s.NUMBER1, s.NUMBER2, s.NUMBER3,
         s.ATYPE,
         s.RABMAT, S.TYPE_TRUD, s.TAB, s.ALTTAB, s.NAME_ID, s.ID_EDIZM,
         s.EDIZM_TYPE, s.SKOLL, s.NORMARASH,
         s.BA, s.BB, s.BC, s.BD, s.BE, s.BF, s.BG, s.BH, s.BI, s.BJ, s.BN, s.BO, s.B_ITOGO,
         s.VRPZ, s.IDTIPR,
         s.KA, s.KB, s.KC, s.KD, s.KE, s.KF, s.KG, s.KH, s.KI, s.KJ, s.KK, s.KL, s.KM,
         s.PUNKTIND,
         s.SSTCH, s.KODZAK, s.KODGP, s.KODSP, s.KODISP, s.NACH, s.OKONCH, s.TIPRAB,
         s.IDNORMATIV, s.IDNORMATIVUNIQ, s.KODIR_GROUP, s.KODIR_PODGROUP, s.ISGROUPOKP,
         s.ARPS_OTHER, s.DORECALC, s.ID_S_RES, s.norm_guid, s.VIDRAB,
         s.CORRECTNODE, s.CORRECTNODE_1, s.CLCMODE, s.ASUBTYPE,
         s.IDFORMULS/*CQ[9359]*/, v.number1, v.number2, v.number3/*MK CQ[12020]*/,
         s.k_itogo/*14460*/, s.k_pr/*15421*/
    from a_smeta s
    left outer join A_SMETA_VIEW_NUM v on s.id = v.id -- MK CQ[12020]
    where s.id = :SOURCE_REC_ID
    into S_ID, S_IDHIER,
         --S_NUMBER1, S_NUMBER2, S_NUMBER3,
         S_ATYPE,
         SM_RABMAT, SM_TYPE_TRUD, S_TAB, S_ALTTAB, S_NAME_ID, S_ID_EDIZM,
         S_EDIZM_TYPE, S_SKOLL, S_NORMARASH,
         S_BA, S_BB, S_BC, S_BD, S_BE, S_BF, S_BG, S_BH, S_BI, S_BJ, S_BN, S_BO, S_B_ITOGO,
         S_VRPZ, S_IDTIPR,
         S_KA, S_KB, S_KC, S_KD, S_KE, S_KF, S_KG, S_KH, S_KI, S_KJ, S_KK, S_KL, S_KM,
         S_PUNKTIND,
         S_SSTCH, S_KODZAK, S_KODGP, S_KODSP, S_KODISP, S_NACH, S_OKONCH, S_TIPRAB,
         S_IDNORMATIV, S_IDNORMATIVUNIQ, S_KODIR_GROUP, S_KODIR_PODGROUP, S_ISGROUPOKP,
         S_ARPS_OTHER, S_DORECALC, S_ID_S_RES, :s_norm_guid, S_VIDRAB,
         S_CORRECTNODE, S_CORRECTNODE_1, S_CLCMODE, S_ASUBTYPE,
         :IDFORMULS/* --*/, :view_number1, :view_number2, :view_number3/*MK CQ[12020]*/,
         :s_k_itogo/*14460*/, :s_k_pr/*15421*/
  do
  begin
    --     . 
    Pr_Vsego = null;
    --[12918]New_Nomerrod = 0;
    if (:IS_DOP <> 0) then
    begin
      select first 1 pa.pr_vsego,
                     pa.pr_number1, pa.pr_number2, pa.pr_number3 -- MK CQ[12020]
      from L_S_PR_ADDINFO pa
      where (pa.id = :SOURCE_REC_ID)
      into :Pr_Vsego,
      --<<>>[12918]:PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3; -- MK CQ[12020]
      :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3;
    end
    --[12918]else
    begin
      New_Nomerrod = :S_ID;
    end

    --    
    S_SKOLL = null;

    -- CQ[14225] [13929] -->
    FIELD_VALUE = null;
    select FIELD_VALUE from A_SMETA_BLOB
    where ID = :SOURCE_REC_ID and FIELD_NAME='TAB'
    into :FIELD_VALUE;
    -- CQ[14225] [13929] <--

    --     
    insert into a_smeta (
         ID, IDHIER, SMETATYPE, NUMBER1, NUMBER2, NUMBER3, SLAVEPARENT, ATYPE,
         RABMAT, TYPE_TRUD, TAB, ALTTAB, NAME_ID, ID_EDIZM, EDIZM_TYPE, KOLL, SKOLL, NORMARASH,
         BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BN, BO, B_ITOGO,
         VRPZ, IDTIPR,
         KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM,
         PUNKTIND,
         SSTCH, KODZAK, KODGP, KODSP, KODISP, NACH, OKONCH, TIPRAB,
         IDNORMATIV, IDNORMATIVUNIQ, KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP,
         ARPS_OTHER, DORECALC, ID_S_RES, NOMERROD, PR_ADDED_REC,
         norm_guid, STATUS_REC_CEN, VIDRAB, CORRECTNODE, CORRECTNODE_1,
         CLCMODE, ASUBTYPE, IDFORMULS/*CQ[9359]*/, k_itogo/*14460*/, k_pr/*15421*/ )
    values (
         :NEW_ID, :S_IDHIER, :MERGE_AKT_ID, :S_NUMBER1, :S_NUMBER2, :S_NUMBER3, :NEW_SLAVEPARENT, :S_ATYPE,
         :SM_RABMAT, :SM_TYPE_TRUD, :S_TAB, :S_ALTTAB, :S_NAME_ID, :S_ID_EDIZM, :S_EDIZM_TYPE, :RES_KOLL, :S_SKOLL , :S_NORMARASH,
         :S_BA, :S_BB, :S_BC, :S_BD, :S_BE, :S_BF, :S_BG, :S_BH, :S_BI, :S_BJ, :S_BN, :S_BO, :S_B_ITOGO,
         :S_VRPZ, :S_IDTIPR,
         :S_KA, :S_KB, :S_KC, :S_KD, :S_KE, :S_KF, :S_KG, :S_KH, :S_KI, :S_KJ, :S_KK, :S_KL, :S_KM,
         :S_PUNKTIND,
         :S_SSTCH, :S_KODZAK, :S_KODGP, :S_KODSP, :S_KODISP, :S_NACH, :S_OKONCH, :S_TIPRAB,
         :S_IDNORMATIV, :S_IDNORMATIVUNIQ, :S_KODIR_GROUP, :S_KODIR_PODGROUP, :S_ISGROUPOKP,
         :S_ARPS_OTHER, :S_DORECALC, /*:ID_S_RES*/ null, /*:S_ID*/ :New_Nomerrod, 0/*[12918]:IS_DOP*/,
         :s_norm_guid, null, :s_VIDRAB, :S_CORRECTNODE, :S_CORRECTNODE_1, :S_CLCMODE, :s_asubtype,
         :IDFORMULS/*CQ[9359]*/, :s_k_itogo/*14460*/, :s_k_pr/*15421*/);

    -- CQ[14225] [13929] -->
   if (not :FIELD_VALUE is null) then
     insert into A_SMETA_BLOB (ID, FIELD_NAME, FIELD_VALUE)
     values (:NEW_ID, 'TAB', :FIELD_VALUE);
    -- CQ[14225] [13929] <--

    --<<[12918]
    if (:IS_DOP <> 0) then
    begin
      if (:S_ATYPE = 17/*SmRec*/) then
      begin
        select coalesce(max(AN.NUMBER1),0) + 1
          from A_SMETA A
          join A_SMETA_VIEW_NUM AN on A.ID=AN.ID
          where A.IDHIER=:S_IDHIER
            and A.SMETATYPE=:MERGE_AKT_ID
          into :VIEW_NUMBER1;
        VIEW_NUMBER2 = 0;
        VIEW_NUMBER3 = 0;
      end
      else
      if (:S_ATYPE = 18/*ResRec*/) then
      begin
        select AN.NUMBER1
          from A_SMETA A
          join A_SMETA_VIEW_NUM AN on A.ID=AN.ID
          where A.ID=:NEW_SLAVEPARENT
          into :VIEW_NUMBER1;
        select coalesce(max(AN.NUMBER2),0) + 1
          from A_SMETA A
          join A_SMETA_VIEW_NUM AN on A.ID=AN.ID
          where A.SLAVEPARENT=:NEW_SLAVEPARENT
          into :VIEW_NUMBER2;
        VIEW_NUMBER3 = 0;
      end
      else
      if (:S_ATYPE = 19/*CommentRec*/) then
      begin
        select AN.NUMBER1, AN.NUMBER2
          from A_SMETA A
          join A_SMETA_VIEW_NUM AN on A.ID=AN.ID
          where A.ID=:NEW_SLAVEPARENT
          into :VIEW_NUMBER1, :VIEW_NUMBER2;
        select coalesce(max(AN.NUMBER3),0) + 1
          from A_SMETA A
          join A_SMETA_VIEW_NUM AN on A.ID=AN.ID
          where A.SLAVEPARENT=:NEW_SLAVEPARENT
          into :VIEW_NUMBER3;
      end
    end


    -- MK CQ[12020] --->
    update a_smeta_view_num v
    set v.number1 = :view_number1,
        v.number2 = :view_number2,
        v.number3 = :view_number3
    where (v.id = :NEW_ID);
    -- MK CQ[12020] <---


    -- MK 17.10.2013 CQ[11675]
    if (S_ATYPE in (17, 19)) then
      execute procedure DOCUMENT_LOG_INS(:NEW_ID, :MERGE_AKT_ID, :S_ATYPE);


    --     
    for select first 1 IDNORMO, IDPRICE, ROW, COST, KOEF
    from smeta_pricepos_info
    where ID = :SOURCE_REC_ID
          and ((IDCENLVL = :ID_BASE_CENLVL) or (IDCENLVL = 0))   -- CQ[12347]
    into :D_NORMOID, :D_PRICEID, :D_ROW, :d_cost, :D_KOEF
    do
    begin
      execute procedure set_smeta_priceposinfo_nl(:NEW_ID, 0, :D_PRICEID, :D_NORMOID, :D_ROW, :d_cost, :D_KOEF ); -- CQ[12347]
    end

    if ((S_ATYPE = 17) and (SM_RABMAT = 0)) then
      execute procedure UPDATE_SMETA_UNION_INFO(:S_IDNORMATIV, :SOURCE_REC_ID, :NEW_ID);  --CQ[TIMUR 9063]

    -- MK 17.01.2013 CQ[10124]          
    if (:S_ATYPE in (17, 18)) then
      execute procedure M_COPY_SMETA_CENLVL (:SOURCE_REC_ID, :NEW_ID, :MERGE_AKT_ID, :ID_BASE_CENLVL);

    /*[12918]
    --  .      
    if ((:IS_DOP <> 0) and (:Pr_Vsego is not null) and (:S_ATYPE in (17, 18))) then
    begin
      insert into L_S_PR_ADDINFO(ID, PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_VSEGO)
      -- MK CQ[12020] --->
      values (:NEW_ID, :PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, :Pr_Vsego);
      --values (:NEW_ID, :S_NUMBER1, :S_NUMBER2, :S_NUMBER3, :Pr_Vsego);
      -- MK CQ[12020] <---
    end*/

    -- =========================================================================
    --    
    for select ID
    from a_s_res
    where id_source = :S_ID
    order by rabmat, tab
    into :S_RES_ID do
    begin
      ID_RES = GEN_ID(a_g_smeta, 1);

      --   
      select first 1 a.ID, a.NORM_ID, a.NORM_PODGROUP,
                     a.KODIR_GROUP, a.KODIR_PODGROUP, a.ISGROUPOKP, a.RABMAT, a.TYPE_TRUD,
                     a.TAB, a.ALTTAB, a.NAME_ID, a.IDEDIZM, a.EDIZM_TYPE,
                     a.RASHOD, a.rashod_base, a.correct, a.BB, a.BC, a.BD, a.BE, a.VIDNR, a.UCH,
                     a.STATUS_EDIT, a.STATUS_DOB_V_ZENU, a.STATUS_REC_CEN,
                     a.NOTE, a.NOMERROD, a.norm_guid,
                     a.CLCMODE -- CQ[12244]
      from a_s_res a
      where ID = :S_RES_ID
      into  S_RES_ID, S_RES_NORM_ID, S_RES_NORM_PODGROUP,
            S_RES_KODIR_GROUP, S_RES_KODIR_PODGROUP, S_RES_ISGROUPOKP, S_RES_RABMAT, :RES_TYPE_TRUD,
            S_RES_TAB, S_RES_ALTTAB, S_RES_NAME_ID, S_RES_IDEDIZM, S_RES_EDIZM_TYPE,
            S_RES_RASHOD, :res_rashod_base, :res_correct, S_RES_BB, S_RES_BC, S_RES_BD, S_RES_BE, S_RES_VIDNR, S_RES_UCH,
            S_RES_STATUS_EDIT, S_RES_STATUS_DOB_V_ZENU, S_RES_STATUS_REC_CEN,
            S_RES_NOTE, S_RES_NOMERROD, :s_res_norm_guid,
            :CLCMODE_RES -- CQ[12244]
            ;

      -- CQ[14225] [13929] -->
    RES_FIELD_VALUE = null;
    if (char_length(:S_RES_TAB)=42) then
      select FIELD_VALUE from A_S_RES_BLOB
        where ID = :S_RES_ID and FIELD_NAME='TAB'
      into :RES_FIELD_VALUE;
    -- CQ[14225] [13929] <--

      --     
      execute procedure a_s_res_append ( :ID_USER,
             :ID_RES, :NEW_ID, :S_RES_NORM_ID, :S_RES_NORM_PODGROUP,
             :S_RES_KODIR_GROUP, :S_RES_KODIR_PODGROUP, :S_RES_ISGROUPOKP, :S_RES_RABMAT,
             :S_RES_TAB, :S_RES_ALTTAB, :S_RES_NAME_ID, :S_RES_IDEDIZM, :S_RES_EDIZM_TYPE,
             :S_RES_RASHOD, :res_rashod_base, :res_correct, :S_RES_BB, :S_RES_BC,
             :S_RES_BD, :S_RES_BE, :S_RES_VIDNR, :S_RES_UCH,
             :S_RES_STATUS_EDIT, :S_RES_STATUS_DOB_V_ZENU, :S_RES_STATUS_REC_CEN,
             :S_RES_NOTE, :s_res_norm_guid, :res_type_trud, 1,
             /*:S_RES_ID - nomerrod     */ -1, 1,
             :CLCMODE_RES -- CQ[12244]
             );

       -- CQ[14225] [13929] -->
       if (:RES_FIELD_VALUE is not null) then
         insert into A_S_RES_BLOB (ID, FIELD_NAME, FIELD_VALUE)
         values (:ID_RES, 'TAB', :RES_FIELD_VALUE);
       -- CQ[14225] [13929] <--

       --     
       for select first 1 IDNORMO, IDPRICE, ROW, COST, KOEF
       from smeta_pricepos_info
       where ID = :S_RES_ID
             and ((IDCENLVL = :ID_BASE_CENLVL) or (IDCENLVL = 0))   -- CQ[12347]
       into :D_NORMOID, :D_PRICEID, :D_ROW, :d_cost, :D_KOEF
       do
       begin
         execute procedure set_smeta_priceposinfo_nl(:ID_RES, 0, :D_PRICEID, :D_NORMOID, :D_ROW, :d_cost, :D_KOEF );  -- CQ[12347]
       end

       -- MK 17.01.2013 CQ[10124]      
       execute procedure M_COPY_S_RES_CENLVL (:S_RES_ID, :ID_RES, :MERGE_AKT_ID, :ID_BASE_CENLVL);

       --  nomerrod       
       --  .   NomerRod    
       -- (      ID_S_RES   )
       if ((S_RES_NOMERROD is null) or (S_RES_NOMERROD = 0)) then
         S_RES_NOMERROD = :S_RES_ID;

       update a_s_res r
       set r.NOMERROD = :S_RES_NOMERROD
       where (r.id = :ID_RES);
    end



    -- =========================================================================
    --           ID_S_RES
    ID_S_RES = null;
    if (( not S_ID_S_RES is null) and (S_ID_S_RES <> 0)) then
    begin
       select first 1 ID, ID_SOURCE
       from a_s_res
       where NOMERROD = :S_ID_S_RES and SMETATYPE = :MERGE_AKT_ID
       into ID_S_RES1, ID_SOURCE;

       for select first 1 smetatype
       from a_smeta
       where id = :ID_SOURCE and smetatype = :MERGE_AKT_ID
       into dummy
       do
         ID_S_RES = ID_S_RES1;

       if (ID_S_RES is null) then
       begin
         select first 1 NOMERROD
         from a_s_res
         where ID = :S_ID_S_RES
         into  :S_ID_S_RES;

         select first 1 ID, ID_SOURCE
         from a_s_res
         where NOMERROD = :S_ID_S_RES and SMETATYPE = :MERGE_AKT_ID
         into ID_S_RES1, ID_SOURCE;

         for select first 1 smetatype
         from a_smeta
         where id = :ID_SOURCE and smetatype = :MERGE_AKT_ID
         into dummy
         do
           ID_S_RES = ID_S_RES1;
       end
    end
    update a_smeta
       set ID_S_RES = :ID_S_RES
    where ID = :NEW_ID;


    -- =========================================================================

    --   
    for select ID, NORM_ID, NORM_PODGROUP,
               KODIR_GROUP, KODIR_PODGROUP, ISGROUPOKP, RABMAT, type_trud,
               TAB, ALTTAB, NAME_ID, IDEDIZM, EDIZM_TYPE,
               RASHOD, BB, BC, BD, BE, VIDNR, UCH,
               norm_guid
    from m_etalon_s_res
    where id_source = :S_ID
    into  S_RES_ID, S_RES_NORM_ID, S_RES_NORM_PODGROUP,
          S_RES_KODIR_GROUP, S_RES_KODIR_PODGROUP, S_RES_ISGROUPOKP, S_RES_RABMAT, :res_type_trud,
          S_RES_TAB, S_RES_ALTTAB, S_RES_NAME_ID, S_RES_IDEDIZM, S_RES_EDIZM_TYPE,
          S_RES_RASHOD, S_RES_BB, S_RES_BC, S_RES_BD, S_RES_BE, S_RES_VIDNR, S_RES_UCH,
          :s_res_norm_guid do
    begin
       ID_RES = GEN_ID(a_g_smeta, 1);

       --    (mode = 2)
       execute procedure m_et_res_append(:ID_USER, :ID_RES, :NEW_ID,
                                         null/*:res_norm_id*/,
                                         null/*:res_norm_podgroup*/,
                                         null/*:source_param_kodir_group*/,
                                         null/*:source_param_kodir_podgroup*/,
                                         null/*:res_isgroupokp*/,
                                         null/*:res_rabmat*/,
                                         null/*:res_tab*/,
                                         null/*:res_alttab*/,
                                         null/*:res_name_id*/,
                                         null/*:res_idedizm*/,
                                         null/*:res_edizm_type*/,
                                         null/*:res_rashod*/,
                                         null/*:res_rashod_base*/,
                                         null/*:res_correct*/,
                                         null/*:res_bb*/,
                                         null/*:res_bc*/,
                                         null/*:res_bd*/,
                                         null/*:res_be*/,
                                         null/*:res_vidnr*/,
                                         null/*:res_uch*/,
                                         null/*:res_status_edit*/,
                                         null/*:res_status_dob_v_zenu*/,
                                         null/*:res_status_rec_cen*/,
                                         null/*:res_note*/,
                                         -1 /*:S_RES_ID :nomerrod*/, --    
                                         null/*:res_norm_guid*/,
                                         null/*:res_type_trud*/,
                                         :S_RES_NORM_ID, :S_RES_NORM_PODGROUP,
                                         :S_RES_KODIR_GROUP, :S_RES_KODIR_PODGROUP, :S_RES_ISGROUPOKP,
                                         :S_RES_RABMAT, :S_RES_TAB, :S_RES_ALTTAB,
                                         :S_RES_NAME_ID, :S_RES_IDEDIZM, :S_RES_EDIZM_TYPE,
                                         :S_RES_RASHOD,
                                         :S_RES_BB, :S_RES_BC, :S_RES_BD, :S_RES_BE,
                                         :S_RES_VIDNR, :S_RES_UCH,
                                         :s_res_norm_guid, :res_type_trud,
                                         1/*:sender*/,
                                         2,
                                         0  -- CQ[12244] CLCMODE_RES = 0
                                         );/*:mode*/

      -- MK 17.01.2013 CQ[10124]
      execute procedure DM_COPY_ET_RES_CENLVL (:S_RES_ID, :ID_RES, :MERGE_AKT_ID, :ID_BASE_CENLVL);
    end

    suspend;
  end
end
^

--TFS[338],TFS[242]
create or alter procedure S_RRBASE_SELECT_ONSMETA (
    IDUSER integer,
    IDTEMP integer,
    IDBASE integer,
    IDRR integer,
    IDTYPE integer,
    ISHIRED integer,
    HIER blob sub_type 0 segment size 80,
    HCOUNT integer,
    P_GROUP integer,
    P_PODGR integer,
    IDZONE integer,
    RABMATMASK integer,
    IDCENLVL integer)
returns (
    IDHIER integer,
    RABMAT integer,
    TYPE_TRUD integer,
    TIPRAB integer,
    TAB varchar(42),
    IDNAME integer,
    IDEDIZM integer,
    IDNORMY integer,
    PODGROUP integer,
    ISGROKP integer,
    KOLL double precision,
    CENA double precision,
    STOIM double precision,
    CENAT double precision,
    STOIMT double precision,
    IDRES integer,
    DM_IDNORMO integer,
    DM_IDPRICE integer,
    DM_ROW integer,
    DM_COST double precision,
    DM_KOEF double precision,
    FIELD_VALUE blob sub_type 1 segment size 80)
AS
declare variable RABMAT_EX integer;

declare variable ID_TAB_LONG integer; -- Voyager CQ[13929,14259]
begin
  if (:ISHIRED is null or :ISHIRED = 0) then
  /*    */
  begin
    HIER = null;/* S_INTFROMBLOB_SELECT     = :HCOUNT */
    HCOUNT = :IDRR;
  end
  /*
  else / *    * /
    ;
  */

  if (:IDTYPE in (15, 8, 9)) then
  /*   ,   29 */
  begin
    if (:IDTYPE = 8) then
      IDTYPE = :IDBASE;

    for select FVALUE
        from S_INTFROMBLOB_SELECT(:HIER, :HCOUNT)
        into :IDHIER
    do
      for select RABMAT_EX, TAB, IDNAME, IDEDIZM, min(IDNORMY), min(PODGROUP), min(ISGROKP), sum(KOLL), CENA,
                 sum(STOIM), CENAT, sum(STOIMT), IDRES, DM_IDNORMO, DM_IDPRICE, DM_ROW, DM_COST, DM_KOEF --  CQ [6826]  
                 ,min(ID_TAB_LONG) -- Voyager CQ[13929,14259]
          from S_RRBASE_SELECT_RES(:IDUSER, :IDTEMP, :IDBASE, :IDHIER, :IDTYPE, :ISHIRED, :P_GROUP, :P_PODGR, :IDZONE, :RABMATMASK, :IDCENLVL)
          group by IDRES, RABMAT_EX, TAB, IDNAME, IDEDIZM, CENA, CENAT, DM_IDNORMO, DM_IDPRICE, DM_ROW, DM_COST, DM_KOEF
          --,FIELD_VALUE -- Voyager CQ[13929,14259]
          into :RABMAT_EX, :TAB, :IDNAME, :IDEDIZM, :IDNORMY, :PODGROUP, :ISGROKP, :KOLL, :CENA, :STOIM, :CENAT,
               :STOIMT, :IDRES, :DM_IDNORMO, :DM_IDPRICE, :DM_ROW, :DM_COST, :DM_KOEF --  CQ [6826]  
               ,:ID_TAB_LONG -- Voyager CQ[13929,14259]
      do
      begin
        -- <-- Voyager CQ[13929,14259]
        --       :IDRES,
        --     :ID   
        --   A_SMETA_BLOB  A_S_RES_BLOB
        FIELD_VALUE = NULL;
        if (char_length(:TAB) = 42) then
        begin
            select SB.FIELD_VALUE from A_S_RES_BLOB SB
            where SB.ID = :ID_TAB_LONG and SB.FIELD_NAME='TAB'
            into :FIELD_VALUE;

            if (:FIELD_VALUE is null) then
                select SB.FIELD_VALUE from A_SMETA_BLOB SB
                where SB.ID = :ID_TAB_LONG and SB.FIELD_NAME='TAB'
                into :FIELD_VALUE;
        end
        -- <-- Voyager CQ[13929,14259]

        /*   */
        /*  
      if (:IDZONE = -2) then
      begin
        CENAT = :CENA;
        STOIMT = :STOIM;
      end
      */

        /* [7462]       RABMAT_EX  -3  -4 */
        if (:RABMAT_EX in (-3, -4)) then
        begin
          RABMAT_EX = -:RABMAT_EX;
          TIPRAB = 3;
        end
        else
          TIPRAB = 0;

        /*   RABMAT  TYPE_TRUD */
        /*CQ[9116]select RABMAT_EX, TYPE_TRUD
        from S_RRDATA_GET_RABMAT_EX(:IDUSER, :RABMAT_EX, null)
        into :RABMAT, :TYPE_TRUD;*/
        execute procedure S_RRDATA_GET_RABMAT_EX(:IDUSER, :RABMAT_EX, null)
          returning_values (:RABMAT, :TYPE_TRUD);--CQ[9116]
        suspend;
      end

  end
end
^

--TFS[338],TFS[242]
create or alter procedure S_RRBASE_SELECT_RES (
    IDUSER integer,
    IDTEMP integer,
    IDBASE integer,
    IDHIER integer,
    IDTYPE integer,
    ISHIRED integer,
    P_GROUP integer,
    P_PODGR integer,
    IDZONE integer,
    RABMATMASK integer,
    IDCENLVL integer)
returns (
    RABMAT integer,
    RABMAT_EX integer,
    TAB varchar(42),
    IDNAME integer,
    IDEDIZM integer,
    IDNORMY integer,
    PODGROUP integer,
    ISGROKP integer,
    KOLL double precision,
    CENA double precision,
    STOIM double precision,
    CENAT double precision,
    STOIMT double precision,
    IDRES integer,
    DM_IDNORMO integer,
    DM_IDPRICE integer,
    DM_ROW integer,
    DM_COST double precision,
    DM_KOEF double precision,
    ID_TAB_LONG integer)
AS
declare variable ID integer;
declare variable BB double precision;
declare variable BC double precision;
declare variable BE double precision;
declare variable SMKOLL double precision;

declare variable NAME blob;
declare variable SOURCEHIER integer;
declare variable SLAVEPARENT integer;

declare variable NUMBER1 integer;
declare variable RABMAT1 integer;
declare variable TAB1 varchar(42);
declare variable IDNAME1 integer;
declare variable IDEDIZM1 integer;
declare variable IDNORMY1 integer;

declare variable TYPE_TRUD integer;
declare variable TMP_TYPE_TRUD integer; --CQ[9116]
declare variable TMP_NAME blob sub_type 1 segment size 8; --CQ[9116]
declare variable TMP_ID integer; --[9927]    [9116]:
--    ID, ..      ...where xxx=:ID...
declare TIPRAB integer;
declare variable IS_OBORUD integer;
declare variable CLCMODE integer;
declare variable CLCMODE_RES integer;

declare variable ATYPE integer;
declare variable ID_S_RES integer;

-- <-- Voyager CQ[13929,14259]
--declare variable ID_TAB_LONG integer;
declare variable FIELD_VALUE blob sub_type 1 segment size 80 character set Win1251;

declare variable CRC_SPEC_ROW integer;
begin

  if (:IDTYPE = 15/*PSType*/ or /*    */
      :IDTYPE > 999) then
  /*   */
  begin

    for select IDHIER
        from S_RRBASE_HIER_SELECT(:IDUSER, :IDHIER, :ISHIRED)
        into :SOURCEHIER
    do
      for select A.ID, A.NUMBER1, A.KOLL, A.RABMAT,
                 case --<<[9533]
                   when A.RABMAT=1 then
                     coalesce( nullif(A.TYPE_TRUD, 0),
                       case when A.TAB starting '2' then 2 else 1 end )
                   else A.TYPE_TRUD
                 end,
                 A.TIPRAB, A.TAB, A.NAME_ID, A.ID_EDIZM,
                 A.IDNORMATIV, A.KODIR_PODGROUP, A.ISGROUPOKP, A.KOLL,
                 L.EB, L.EC, L.EE, --<<>>[9748]A.EB, A.EC, A.EE,
                 S.IDNORMO, S.IDPRICE, S.ROW, S.COST, S.KOEF, --CQ[7790]
                 coalesce(A.CLCMODE, 0), -- CQ[12320]
                 A.ATYPE, A.ID_S_RES -- CQ[14312]
          from A_SMETA A --//CQ[TIMUR 6923]    TYPE_TRUD
          left join A_SMETA_CENLVL L on L.ID=A.ID and L.IDCENLVL=:IDCENLVL
          left outer join SMETA_PRICEPOS_INFO S on (S.ID = A.ID) and ((S.IDCENLVL = L.IDCENLVL) or (S.IDCENLVL = 0)) --  CQ [6826] + CQ[12341]
          where A.SMETATYPE = :IDTYPE
            and ((A.ATYPE = 17/*SmRec*/) or (/*CQ[TIMUR 13979]*/ A.ATYPE = 18/*ResRec*/))
            and A.IDHIER = :SOURCEHIER
          into :ID, :NUMBER1, :SMKOLL, :RABMAT1,
               :TYPE_TRUD,
               :TIPRAB, :TAB1, :IDNAME1, :IDEDIZM1,
               :IDNORMY1, :PODGROUP, :ISGROKP, :KOLL,
               :BB, :BC, :BE,
               :DM_IDNORMO, :DM_IDPRICE, :DM_ROW, :DM_COST, :DM_KOEF,
               :CLCMODE, -- CQ[12320]
               :ATYPE, :ID_S_RES -- CQ[14312]
      do
        begin
        ID_TAB_LONG = :ID; -- Voyager CQ[13929,14259]

        -- CQ[14312] -->
        CLCMODE_RES = 0;
        if (:ATYPE = 18) then -- ResRec
        begin
          select coalesce(CLCMODE, 0) from A_S_RES
          where ID = :ID_S_RES
          into :CLCMODE_RES;
        end
        -- CQ[14312] <--

        /*   */
        if (--     
            (GETBIT(:RABMATMASK, 16/*trSkipEmptyKoll*/) = 0 or :SMKOLL <> 0.0) and
            --      CQ[TIMUR 6584]-->
            (GETBIT(:RABMATMASK, 18/*trSkipNegativeKoll*/) = 0 or :SMKOLL >= 0.0) and
            -- CQ[12320]     
            (GETBIT(:CLCMODE, 10) = 0) and
            -- CQ[12244]      
            ((:RABMAT = 0) or (GETBIT(:CLCMODE, 15) = 0))
            )
            then
        if (not ((:ATYPE = 18) and (GETBIT(:CLCMODE_RES, 15) > 0))) then -- CQ[14312]
        begin

          --//CQ[TIMUR 6923] -  RABMAT_EX   
          /*CQ[9116]select RABMAT_EX
          from S_RRDATA_GET_RABMAT_EX(:IDUSER, :RABMAT1, :TYPE_TRUD)
          into :RABMAT_EX;*/

          execute procedure S_RRDATA_GET_RABMAT_EX(:IDUSER, :RABMAT1, :TYPE_TRUD)
            returning_values (:RABMAT_EX, :TMP_TYPE_TRUD);--CQ[9116]

          -- MK 16.09.2009 CQ[7676] --->
          IS_OBORUD = 0;
          if (:RABMAT1 = 3 and
              :TIPRAB = 3 and
              ((:TYPE_TRUD is null) or (:TYPE_TRUD = 0))) then
            IS_OBORUD = 1;
          -- MK 16.09.2009 CQ[7676] <---

          if (:RABMAT1 between 1 and 3) then
            if (
                -- MK 16.09.2009 CQ[7676] --->
                -- CQ[TIMUR 8157] -  ABS, ..     
                --  RABMAT_EX = -1,  -1   !
                ((IS_OBORUD = 0) and (GETBIT(:RABMATMASK, abs(:RABMAT_EX)) <> 0)) or
                ((IS_OBORUD = 1) and (GETBIT(:RABMATMASK, 5/*trOboryd*/) <> 0))

                --      - (   ) CQ[TIMUR 6923]
                --( (GETBIT(:RABMATMASK, :RABMAT1) <> 0) and (RABMAT_EX <> 4) ) or
                --  -     CQ[TIMUR 6923]
                --( (RABMAT_EX = 4) and (GETBIT(:RABMATMASK, RABMAT_EX) <> 0) )
                -- MK 16.09.2009 CQ[7676] <---
                ) then
            begin
              RABMAT = :RABMAT1;
              TAB = :TAB1;
              IDNAME = :IDNAME1;
              IDEDIZM = :IDEDIZM1;
              IDNORMY = :IDNORMY1;

              -- [7462]: ()
              if (:RABMAT_EX in (3, 4) and
                  :TIPRAB = 3) then
                RABMAT_EX = -:RABMAT_EX;
              else
                TIPRAB = 0;

              execute procedure S_RES_STOIM(:KOLL, :BB, :BC, :BE)
                returning_values :CENA, :STOIM;

              --[9533] -     
              --/*    */
              --if (RABMAT = 1) then --//CQ[TIMUR 6923]   ,   
              --  /*CQ[9116]select TYPE_TRUD
              --  from S_GET_TYPE_TRUD(:IDUSER, :IDNORMY, :RABMAT, :PODGROUP)
              --  into :TYPE_TRUD;*/
              --  execute procedure S_GET_TYPE_TRUD(:IDUSER, :IDNORMY, :RABMAT, :PODGROUP)
              --    returning_values (:TYPE_TRUD);--CQ[9116]

              --CQ[9116] select CRC
              --CQ[9116] from S_RRBASE_SELECT_RES_GR(:IDUSER, :RABMAT_EX, :TAB, :IDNAME, :IDEDIZM, :IDNORMY, :CENA, :CENAT)
              --CQ[9116] into :IDRES;

              execute procedure S_RRBASE_SELECT_RES_GR(
                  :IDUSER, :RABMAT_EX, :TAB, :IDNAME, :IDEDIZM, :IDNORMY, :CENA, :CENAT)
                returning_values (:IDRES);--CQ[9116]

              -- <-- Voyager CQ[13929,14259]
              if (char_length(TAB) = 42) then
              begin
                 FIELD_VALUE = null;
                 select SB.FIELD_VALUE
                 from A_SMETA_BLOB SB
                   where ( (SB.ID = :ID) and (FIELD_NAME = 'TAB') )
                 into :FIELD_VALUE;
                 if (:FIELD_VALUE is not null) then
                    IDRES = K_GETCRC32S(:IDRES || ' ' || :FIELD_VALUE);
              end
              -- <-- Voyager CQ[13929,14259]

              -->[15610]
              if ((RABMAT1 = 3) and (ATYPE = 17)) then
              begin
                execute procedure S_RRDATA_SELECT_SPEC_TROW_CRC(:ID)
                returning_values :CRC_SPEC_ROW;

                if (CRC_SPEC_ROW <> 0) then
                  IDRES = GET_INTEGER_CRC(IDRES, CRC_SPEC_ROW);
              end
              --<[15610]

              --CQ[9116] insert into S_TEMP(IDGEN, ID, N1, N2)
              --CQ[9116] select :IDTEMP, :IDRES, :IDHIER, ID
              --CQ[9116]  from S_RRSOURCE_RAB_INSERT(:IDUSER, null/*:IDRES*/, :SOURCEHIER,
              --CQ[9116] :NUMBER1, :RABMAT1, :TAB1, :IDNAME1, :IDEDIZM1, :SMKOLL, :KOLL);

              --CQ[9116] -->
              execute procedure S_RRSOURCE_RAB_INSERT(
                  :IDUSER, null, :SOURCEHIER, :NUMBER1, :RABMAT1, :TAB1, :IDNAME1,
                  :IDEDIZM1, :SMKOLL, :KOLL)
                returning_values (:TMP_ID);
              insert into S_TEMP (IDGEN, ID, N1, N2)
              values (:IDTEMP, :IDRES, :IDHIER, :TMP_ID);
              --CQ[9116]  <--
              suspend;
            end

          for select R.RABMAT,
                     case --<<[9533]
                       when R.RABMAT=1 then
                         coalesce( nullif(R.TYPE_TRUD, 0),
                           case when R.TAB starting '2' then 2 else 1 end )
                       else R.TYPE_TRUD
                     end,
                     A.TIPRAB, R.TAB, R.NAME_ID, R.IDEDIZM,
                     R.NORM_ID, R.NORM_PODGROUP, R.ISGROUPOKP, R.RASHOD * :SMKOLL,
                     L.BB, L.BC, L.BE,--<<>>[9748]R.BB, R.BC, R.BE,
                     S.IDNORMO, S.IDPRICE, S.ROW, S.COST, S.KOEF, --CQ[7790]
                     coalesce(R.CLCMODE, 0) -- CQ[12244]
                     ,R.ID -- <-- Voyager CQ[13929,14259]
              from A_S_RES R
              left join A_S_RES_CENLVL L on L.ID=R.ID and L.IDCENLVL=:IDCENLVL
              left outer join SMETA_PRICEPOS_INFO S on (S.ID = R.ID) and ((S.IDCENLVL = L.IDCENLVL) or (S.IDCENLVL = 0))--  CQ [6826] + CQ[12341]
              left join A_SMETA A on A.ID_S_RES = R.ID
              where R.ID_SOURCE = :ID
                and R.KODIR_GROUP = :P_GROUP
                and R.KODIR_PODGROUP = :P_PODGR
                and not exists(select * /*CQ[TIMUR 13979]*/
                               from A_SMETA A
                               where A.ID_S_RES = R.ID)
              into :RABMAT,
                   :TYPE_TRUD,
                   :TIPRAB, :TAB, :IDNAME, :IDEDIZM,
                   :IDNORMY, :PODGROUP, :ISGROKP, :KOLL,
                   :BB, :BC, :BE,
                   :DM_IDNORMO, :DM_IDPRICE, :DM_ROW, :DM_COST, :DM_KOEF,
                   :CLCMODE_RES -- CQ[12244]
                   ,:ID_TAB_LONG -- <-- Voyager CQ[13929,14259]
          do
          begin

            if (GETBIT(:CLCMODE_RES, 15) = 0) then -- CQ[12244]
            begin
                /*  */
    
                --//CQ[TIMUR 6923] -  RABMAT_EX  
                /*CQ[9116]select RABMAT_EX
              from S_RRDATA_GET_RABMAT_EX(:IDUSER, :RABMAT, :TYPE_TRUD)
              into :RABMAT_EX;*/
                execute procedure S_RRDATA_GET_RABMAT_EX(:IDUSER, :RABMAT, :TYPE_TRUD)
                  returning_values (:RABMAT_EX, :TMP_TYPE_TRUD);--CQ[9116]
    
                -- MK 16.09.2009 CQ[7676] --->
                IS_OBORUD = 0;
                if (:RABMAT = 3 and
                    :TIPRAB = 3 and
                    ((:TYPE_TRUD is null) or (:TYPE_TRUD = 0))) then
                  IS_OBORUD = 1;
                -- MK 16.09.2009 CQ[7676] <---
    
                if (
                    -- MK 16.09.2009 CQ[7676] --->
                    -- CQ[TIMUR 8157] -  ABS, ..     
                    --  RABMAT_EX = -1,  -1   !
                    ((IS_OBORUD = 0) and (GETBIT(:RABMATMASK, abs(:RABMAT_EX)) <> 0)) or
                    ((IS_OBORUD = 1) and (GETBIT(:RABMATMASK, 5) <> 0))
    
                    --      - (   ) CQ[TIMUR 6923]
                    --( (GETBIT(:RABMATMASK, :RABMAT) <> 0) and (RABMAT_EX <> 4) ) or
                    --  -    CQ[TIMUR 6923]
                    --( (RABMAT_EX = 4) and (GETBIT(:RABMATMASK, RABMAT_EX) <> 0) )
                    ) then
                begin
    
                  if (
                      --     
                      (GETBIT(:RABMATMASK, 16 /*(*1)*/ ) = 0 or :KOLL <> 0.0) and
                      --       CQ[TIMUR 6584]-->
                      (GETBIT(:RABMATMASK, 18) = 0 or :KOLL >= 0.0) ) then
                  begin
                    -- [7462]: ()
                    if (:RABMAT_EX in (3, 4) and
                        :TIPRAB = 3) then
                      RABMAT_EX = -:RABMAT_EX;
                    else
                      TIPRAB = 0;
    
                    execute procedure S_RES_STOIM(:KOLL, :BB, :BC, :BE)
                      returning_values :CENA, :STOIM;
    
                    --CQ[9116]select CRC
                    --CQ[9116]from S_RRBASE_SELECT_RES_GR(:IDUSER, :RABMAT_EX, :TAB, :IDNAME, :IDEDIZM, :IDNORMY, :CENA, :CENAT)
                    --CQ[9116]into :IDRES;
                    execute procedure S_RRBASE_SELECT_RES_GR(
                        :IDUSER, :RABMAT_EX, :TAB, :IDNAME, :IDEDIZM, :IDNORMY, :CENA, :CENAT)
                      returning_values (:IDRES);--CQ[9116]

                     -- <-- Voyager CQ[13929,14259]
                     if (char_length(TAB) = 42) then
                     begin
                         FIELD_VALUE = null;
                         select SB.FIELD_VALUE from A_S_RES_BLOB SB
                         where SB.ID = :ID_TAB_LONG and SB.FIELD_NAME='TAB'
                         into :FIELD_VALUE;
                         if (:FIELD_VALUE is not null) then
                            IDRES = K_GETCRC32S(:IDRES || ' ' || FIELD_VALUE);
                     end
                     -- <-- Voyager CQ[13929,14259]

                    --CQ[9116] insert into S_TEMP(IDGEN, ID, N1, N2)
                    --CQ[9116] select :IDTEMP, :IDRES, :IDHIER, ID
                    --CQ[9116]  from S_RRSOURCE_RAB_INSERT(:IDUSER, null/*:IDRES*/, :SOURCEHIER,
                    --CQ[9116] :NUMBER1, :RABMAT1, :TAB1, :IDNAME1, :IDEDIZM1, :SMKOLL, :KOLL);
    
                    --CQ[9116] -->
                    execute procedure S_RRSOURCE_RAB_INSERT(
                        :IDUSER, null, :SOURCEHIER, :NUMBER1, :RABMAT1, :TAB1, :IDNAME1,
                        :IDEDIZM1, :SMKOLL, :KOLL)
                      returning_values (:TMP_ID);
                    insert into S_TEMP (IDGEN, ID, N1, N2)
                    values (:IDTEMP, :IDRES, :IDHIER, :TMP_ID);
                    --CQ[9116]  <--
                    suspend;
                  end
                end
              end
          end
        end
        end

  end
  else
  if (:IDTYPE = 9) then
  /*  29 */
  begin

    for select IDHIER
        from S_RRBASE_HIER_SELECT(:IDUSER, :IDHIER, :ISHIRED)
        into :SOURCEHIER
    do
      for select M.ID_SELF, M.RABMAT,
                 case --<<[9533]
                   when M.RABMAT=1 then
                     coalesce( nullif(M.TYPE_TRUD, 0),
                       case when M.TAB starting '2' then 2 else 1 end )
                   else M.TYPE_TRUD
                 end,
                 M.TIPRAB, M.NAME, substring(M.TAB from 1 for 42), M.ID_EDIZM,
                 M.IDNORMATIV, M.KODIR_PODGROUP, M.ISGROUPOKP, M.RASHODALL,
                 M.CSMETN, M.CSMETNALL, S.CCURRENT, S.CCURRENTALL,
                 M.SLAVEPARENT, SI.IDNORMO, SI.IDPRICE, SI.ROW, SI.COST, SI.KOEF --CQ[7790]
          from L_M29 M
          left outer join M29_PRICEPOS_INFO SI on SI.ID = M.ID_SELF --  CQ [6826]  
          left join L_M29_SPIS S on S.ID_REC = M.ID_SELF and S.ID_SPIS = 0
          /* and S.CCURRENT_ZONE = :IDZONE */
          where M.ID_M29 = :IDBASE
            and M.IDHIER = :SOURCEHIER
            and ( M.NUMBER2 <> 0 /*  */
               or M.NUMBER2 = 0 and M.RABMAT <> 0) /*    */
            and M.NUMBER3 = 0
          into :ID, :RABMAT,
               :TYPE_TRUD,
               :TIPRAB, :NAME, :TAB, :IDEDIZM,
               :IDNORMY, :PODGROUP, :ISGROKP, :KOLL,
               :CENA, :STOIM, :CENAT, :STOIMT,
               :SLAVEPARENT, :DM_IDNORMO, :DM_IDPRICE, :DM_ROW, :DM_COST, :DM_KOEF
      do
      begin

        --//CQ[TIMUR 6923] -  RABMAT_EX  
        /*CQ[9116]select RABMAT_EX
          from S_RRDATA_GET_RABMAT_EX(:IDUSER, :RABMAT, :TYPE_TRUD)
          into :RABMAT_EX;*/

        execute procedure S_RRDATA_GET_RABMAT_EX(:IDUSER, :RABMAT, :TYPE_TRUD)
          returning_values (:RABMAT_EX, :TMP_TYPE_TRUD);--CQ[9116]

        -- MK 16.09.2009 CQ[7676] --->
        IS_OBORUD = 0;
        if (:RABMAT = 3 and
            :TIPRAB = 3 and
            ((:TYPE_TRUD is null) or (:TYPE_TRUD = 0))) then
          IS_OBORUD = 1;
        -- MK 16.09.2009 CQ[7676] <---

        if (
            -- MK 16.09.2009 CQ[7676] --->
            -- CQ[TIMUR 8157] -  ABS, ..     
            --  RABMAT_EX = -1,  -1   !
            ((IS_OBORUD = 0) and (GETBIT(:RABMATMASK, abs(:RABMAT_EX)) <> 0)) or
            ((IS_OBORUD = 1) and (GETBIT(:RABMATMASK, 5/*trOboryd*/) <> 0))

            --      - (   ) CQ[TIMUR 6923]
            --((GETBIT(:RABMATMASK, :RABMAT) <> 0) and (RABMAT_EX <> 4)) or
            --  -    CQ[TIMUR 6923]
            --((RABMAT_EX = 4) and (GETBIT(:RABMATMASK, RABMAT_EX) <> 0))
            ) then
        begin
          if (
              --     
              (GETBIT(:RABMATMASK, 16 /*trSkipEmptyKoll*/ ) = 0 or :KOLL <> 0.0) and
              --       CQ[TIMUR 6584]-->
              (GETBIT(:RABMATMASK, 18/*trSkipNegativeKoll*/) = 0 or :KOLL >= 0.0) ) then
          begin

            /*CQ[9116]select IDNAME
            from B_WRITE_NAIMENOVANIE(:IDUSER, -1, null, :NAME)
            into :IDNAME;*/
            execute procedure B_WRITE_NAIMENOVANIE(:IDUSER, -1, null, :NAME)
              returning_values (:IDNAME, :TMP_NAME);--CQ[9116]

            --[9533] -     
            --/*    */
            --if (RABMAT = 1) then --//CQ[TIMUR 6923]   ,   
            --  /*CQ[9116]select TYPE_TRUD
            --  from S_GET_TYPE_TRUD(:IDUSER, :IDNORMY, :RABMAT, :PODGROUP)
            --  into :TYPE_TRUD;*/
            --  execute procedure S_GET_TYPE_TRUD(:IDUSER, :IDNORMY, :RABMAT, :PODGROUP)
            --    returning_values (:TYPE_TRUD);--CQ[9116]

            -- [7462]: ()
            if (:RABMAT_EX in (3, 4) and
                :TIPRAB = 3) then
              RABMAT_EX = -:RABMAT_EX;
            else
              TIPRAB = 0;

            /*CQ[9116]select CRC
            from S_RRBASE_SELECT_RES_GR(:IDUSER, :RABMAT_EX, :TAB, :IDNAME, :IDEDIZM, :IDNORMY, :CENA, :CENAT)
            into :IDRES;*/
            execute procedure S_RRBASE_SELECT_RES_GR(
                :IDUSER, :RABMAT_EX, :TAB, :IDNAME, :IDEDIZM, :IDNORMY, :CENA, :CENAT)
              returning_values (:IDRES);--CQ[9116]

            if (:SLAVEPARENT is null or :SLAVEPARENT = 0) then
              SLAVEPARENT = :ID;

            for select first 1 RABMAT, NAME, substring(TAB from 1 for 42), ID_EDIZM, RASHODALL, NUMBER1
                from L_M29
                where ID_SELF = :SLAVEPARENT
                into :RABMAT1, :NAME, :TAB1, :IDEDIZM1, :SMKOLL, :NUMBER1
            do
            begin
              /*CQ[9116]select IDNAME
              from B_WRITE_NAIMENOVANIE(:IDUSER, -1, null, :NAME)
              into :IDNAME1;*/
              execute procedure B_WRITE_NAIMENOVANIE(:IDUSER, -1, null, :NAME)
                returning_values (:IDNAME1, :TMP_NAME);--CQ[9116]

              --CQ[9116] insert into S_TEMP(IDGEN, ID, N1, N2)
              --CQ[9116] select :IDTEMP, :IDRES, :IDHIER, ID
              --CQ[9116]  from S_RRSOURCE_RAB_INSERT(:IDUSER, null/*:IDRES*/, :SOURCEHIER,
              --CQ[9116] :NUMBER1, :RABMAT1, :TAB1, :IDNAME1, :IDEDIZM1, :SMKOLL, :KOLL);

              --CQ[9116] -->
              execute procedure S_RRSOURCE_RAB_INSERT(
                  :IDUSER, null, :SOURCEHIER, :NUMBER1, :RABMAT1, :TAB1, :IDNAME1,
                  :IDEDIZM1, :SMKOLL, :KOLL)
                returning_values (:TMP_ID);
              insert into S_TEMP (IDGEN, ID, N1, N2)
              values (:IDTEMP, :IDRES, :IDHIER, :TMP_ID);
              --CQ[9116]  <--
            end

            suspend;
          end
        end
      end
  end
end
^

--TFS[338],TFS[242]
create or alter procedure VV_M29_FILL_TAB_FROM_TAB_LONG (
    TAB varchar(42),
    SMETA_ID integer,
    S_RES_ID integer)
returns (
    TAB60 varchar(60),
    TAB_LONG blob sub_type 1 segment size 80)
AS
begin
    TAB60 = TAB;
    if (char_length(TAB) = 42) then
    begin
      TAB_LONG = NULL;
      if (:SMETA_ID is not null) then
          select FIELD_VALUE
            from A_SMETA_BLOB
            where ID = :SMETA_ID and FIELD_NAME = 'TAB'
          into :TAB_LONG;
      else
      if (:S_RES_ID is not null) then
          select FIELD_VALUE
            from A_S_RES_BLOB
            where ID = :S_RES_ID and FIELD_NAME = 'TAB'
          into :TAB_LONG;
      if (:TAB_LONG is not null) then
      begin        --
        TAB60 = substring ( :TAB_LONG from 1 for 60 );
        if (char_length(:TAB_LONG) <= 60) then
          TAB_LONG = null;
      end
    end
end
^

--TFS[338],TFS[242]
CREATE OR ALTER trigger A_SMETA_BLOB_AD0 for 
active after delete position 0
AS
declare ID_S_RES integer;
begin
--[13929]   
  if (old.FIELD_NAME='TAB') then
  begin
    select ID_S_RES from A_SMETA
      where ID = old.ID
      into :ID_S_RES;
    if (:ID_S_RES is null) then
      exit;
    delete from A_S_RES_BLOB
      where ID=:ID_S_RES and FIELD_NAME='TAB';
  end
end
^

--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_SMETA_BLOB_AIU0 FOR A_SMETA_BLOB
ACTIVE AFTER INSERT OR UPDATE POSITION 0
AS
declare ID_S_RES integer;
declare FIELD_VALUE blob sub_type text;
begin
--[13929]   
  if (new.FIELD_VALUE is null) then --      
    exit;
  if (new.FIELD_NAME='TAB') then --  
  begin
    select ID_S_RES from A_SMETA
      where ID = new.ID
      into :ID_S_RES;
    if (:ID_S_RES is null) then
      exit;
    select FIELD_VALUE from A_S_RES_BLOB
      where ID=:ID_S_RES and FIELD_NAME='TAB'
      into :FIELD_VALUE;
    if (:FIELD_VALUE is null or B_COMPAREBLOB(:FIELD_VALUE, new.FIELD_VALUE) = 0) then
    begin
      update A_S_RES_BLOB
        set FIELD_VALUE=new.FIELD_VALUE
        where ID=:ID_S_RES and FIELD_NAME='TAB';
      if (row_count = 0) then
      insert into A_S_RES_BLOB (ID, FIELD_NAME, FIELD_VALUE)
        values (:ID_S_RES, 'TAB', new.FIELD_VALUE);
    end
  end
end
^

--TFS[338],TFS[242]
CREATE OR ALTER trigger A_SMETA_BLOB_BIU0 for 
active before insert or update position 0
as
declare variable CRC_SM_REC integer;
declare variable CRC_TAB_BLOB integer;
declare variable CRC_NAME_TITLE integer;
declare variable NAME_ID integer;
declare variable NORM_GUID varchar(100);
declare variable TAB varchar(42);
declare variable ALTTAB varchar(250);

declare variable ID_EDIZM integer;
declare variable RABMAT integer;
declare variable TYPE_TRUD integer;
declare variable TIPRAB integer;
begin
  /* copyright [83D8FA78914B] */
  if ( new.FIELD_NAME = 'TAB'
     and ( old.FIELD_VALUE is null
        or new.FIELD_VALUE is null and old.FIELD_VALUE is not null
        or B_COMPAREBLOB(old.FIELD_VALUE, new.FIELD_VALUE) = 0 ) )
  then
  begin

    select TAB, ALTTAB, NAME_ID, NORM_GUID, ID_EDIZM, RABMAT, TYPE_TRUD, TIPRAB
      from A_SMETA
      where ID = new.ID
    into :TAB, :ALTTAB, :NAME_ID, :NORM_GUID, :ID_EDIZM, :RABMAT, :TYPE_TRUD, :TIPRAB;

    CRC_NAME_TITLE = Null;
    select CRC_NAME_TITLE
      from B_NNAME
      where ID = :NAME_ID
    into :CRC_NAME_TITLE; -- Voyager CQ[9681]

    if (char_length(new.FIELD_VALUE) > 0) then
      CRC_TAB_BLOB = K_GETCRC32(new.FIELD_VALUE);

    --CQ[TIMUR 13444]    CRC
    CRC_SM_REC =
      K_GETCRC32S(
        coalesce(:NORM_GUID, '')   ||
        coalesce(CRC_TAB_BLOB, '') ||
        coalesce(:TAB, '')         ||
        coalesce(:ALTTAB, '')      ||
        coalesce(:CRC_NAME_TITLE,0)||
        coalesce(:ID_EDIZM, 0)     ||
        coalesce(:RABMAT, 0)       ||
        case when :RABMAT = 1 then
           coalesce(nullif(:TYPE_TRUD, 0), case when :TAB starting '2' then 2 else 1 end)
         else
           coalesce(:TYPE_TRUD, 0)
        end ||
        case :TIPRAB/*[B690580EBEC1]*/ when 3 then 3 else 0 end );

    update A_SMETA set
      GR_RES_CRC = :CRC_SM_REC
    where ID = new.ID;

  end

end
^

--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_SMETA_BU0 FOR A_SMETA
ACTIVE BEFORE UPDATE POSITION 0
AS
declare variable CRC_NAME_TITLE INTEGER;
declare variable CRC_TAB_BLOB integer;
declare variable FIELD_VALUE BLOB SUB_TYPE 1 SEGMENT SIZE 80;
begin
 if (
     ( new.atype = 17 ) and
     ( new.number1 <> old.number1 )
    )
 then update a_smeta s
      set s.number1 = new.number1
      where s.slaveparent = new.id;

 if (
     ( new.atype = 18 ) and
     (( new.number2 <> old.number2 ) or
     ( new.number1 <> old.number1 ))
    )
 then update a_smeta s
      set s.number1 = new.number1,
      s.number2 = new.number2
      where s.slaveparent = new.id;


-->DEN cq [2678] 18/11/5
 if ((new.atype = 19 ) and (new.idnormativ = 1)) then
 begin
   new.NUMBER1 = 0;
   new.NUMBER2 = 0;
   new.NUMBER3 = 1;
 end
--<DEN

  /* copyright [83D8FA78914B] */
  if
     (coalesce(old.RABMAT, 0) <> coalesce(new.RABMAT, 0) or
      coalesce(old.TYPE_TRUD, 0) <> coalesce(new.TYPE_TRUD, 0) or
      coalesce(old.TAB, '') <> coalesce(new.TAB, '') or
      coalesce(old.NAME_ID, 0) <> coalesce(new.NAME_ID, 0) or
      coalesce(old.ID_EDIZM, 0) <> coalesce(new.ID_EDIZM, 0) or
      coalesce(old.NORM_GUID, '') <> coalesce(new.NORM_GUID, '') or --[12404]coalesce(old.IDNORMATIV, 0) <> coalesce(new.IDNORMATIV, 0) or
      case old.TIPRAB/*[B690580EBEC1]*/ when 3 then 3 else 0 end <> case new.TIPRAB/*[B690580EBEC1]*/ when 3 then 3 else 0 end or
      coalesce(old.ALTTAB, '') <> coalesce(new.ALTTAB, '') ) then
  begin

    CRC_NAME_TITLE = Null;
    select CRC_NAME_TITLE
      from B_NNAME
      where ID = new.NAME_ID
    into :CRC_NAME_TITLE; -- Voyager CQ[9681]

    -- CQ[TIMUR 13929, 14255]
    CRC_TAB_BLOB = null;
    if (char_length(new.TAB) = 42) then
    begin
      select FIELD_VALUE
        from A_SMETA_BLOB
        where (ID = new.ID) and (FIELD_NAME = 'TAB')
      into :FIELD_VALUE;

      if (char_length(:FIELD_VALUE) > 0) then
        CRC_TAB_BLOB = K_GETCRC32(:FIELD_VALUE);
    end
    -- CQ[TIMUR 13929, 14255]

    --CQ[TIMUR 13444]    CRC
    new.GR_RES_CRC =
      K_GETCRC32S(
        coalesce(new.NORM_GUID, '') ||
        coalesce(:CRC_TAB_BLOB, '') ||
        coalesce(new.TAB, '')       ||
        coalesce(new.ALTTAB, '')    ||
        coalesce(:CRC_NAME_TITLE,0) ||
        coalesce(new.ID_EDIZM, 0)   ||
        coalesce(new.RABMAT, 0)     ||
        case when new.RABMAT = 1 then
           coalesce(nullif(new.TYPE_TRUD, 0), case when new.TAB starting '2' then 2 else 1 end)
         else
           coalesce(new.TYPE_TRUD, 0)
        end ||
        case new.TIPRAB/*[B690580EBEC1]*/ when 3 then 3 else 0 end );

--CQ[TIMUR 13444]    CRC.    
--    new.GR_RES_CRC =
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      K_GETCRC32S(
--         coalesce(new.TAB, '')
--      ), coalesce(new.RABMAT, 0)
--      ), case when new.RABMAT = 1 then
--           coalesce(nullif(new.TYPE_TRUD, 0), case when new.TAB starting '2' then 2 else 1 end)
--         else
--           coalesce(new.TYPE_TRUD, 0)
--         end
--      ), coalesce(:CRC_NAME_TITLE,0) --coalesce(new.NAME_ID, 0) Voyager CQ[9681]
--      ), coalesce(new.ID_EDIZM, 0)
--      ), K_GETCRC32S(
--         coalesce(new.NORM_GUID, '') )--[12404]coalesce(new.IDNORMATIV, 0)
--      ), case new.TIPRAB/*[B690580EBEC1]*/ when 3 then 3 else 0 end
--      ), K_GETCRC32S(
--         coalesce(new.ALTTAB, '') )
--      );
  end

end
^

--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_SMETA_L_BI0 FOR A_SMETA
ACTIVE BEFORE INSERT POSITION 0
as
/*  declare variable KA VARCHAR(50);
  declare variable KB VARCHAR(50);
  declare variable KC VARCHAR(50);
  declare variable KD VARCHAR(50);
  declare variable KE VARCHAR(50);
  declare variable KF VARCHAR(50);
  declare variable KG VARCHAR(50);
  declare variable KH VARCHAR(50);
  declare variable KI VARCHAR(50);
  declare variable KJ VARCHAR(50);
  declare variable KK VARCHAR(50);
  declare variable KL VARCHAR(50);
  declare variable KM VARCHAR(50);
*/
declare variable CRC_NAME_TITLE INTEGER;
declare variable CRC_TAB_BLOB integer;
declare variable FIELD_VALUE BLOB SUB_TYPE 1 SEGMENT SIZE 80;
begin
   if ( ( new.nomerrod is null ) or ( new.nomerrod = 0 ) ) then
      new.nomerrod1 = new.id;
   else
      new.nomerrod1 = new.nomerrod;

/*   if (new.ATYPE = 18) then
   begin
     select KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM
     from A_SMETA where ID = new.SLAVEPARENT
     into :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM;
     if (new.KA = '') then new.KA = :KA;
     if (new.KB = '') then new.KB = :KB;
     if (new.KC = '') then new.KC = :KC;
     if (new.KD = '') then new.KD = :KD;
     if (new.KE = '') then new.KE = :KE;
     if (new.KF = '') then new.KF = :KF;
     if (new.KG = '') then new.KG = :KG;
     if (new.KH = '') then new.KH = :KH;
     if (new.KI = '') then new.KI = :KI;
     if (new.KJ = '') then new.KJ = :KJ;
     if (new.KK = '') then new.KK = :KK;
     if (new.KL = '') then new.KL = :KL;
     if (new.KM = '') then new.KM = :KM;
   end
*/

  /* copyright [83D8FA78914B] */
  begin
    CRC_NAME_TITLE = Null;
    select CRC_NAME_TITLE
      from B_NNAME
      where ID = new.NAME_ID
    into :CRC_NAME_TITLE; -- Voyager CQ[9681]

    -- CQ[TIMUR 13929, 14255]
    CRC_TAB_BLOB = null;
    if (char_length(new.TAB) = 42) then
    begin
      select FIELD_VALUE
        from A_SMETA_BLOB
        where (ID = new.ID) and (FIELD_NAME = 'TAB')
      into :FIELD_VALUE;

      if (char_length(FIELD_VALUE) > 0) then
        CRC_TAB_BLOB = K_GETCRC32(:FIELD_VALUE);
    end
    -- CQ[TIMUR 13929, 14255]

    --CQ[TIMUR 13444]    CRC
    new.GR_RES_CRC =
      K_GETCRC32S(
        coalesce(new.NORM_GUID, '') ||
        coalesce(:CRC_TAB_BLOB, '') ||
        coalesce(new.TAB, '')       ||
        coalesce(new.ALTTAB, '')    ||
        coalesce(:CRC_NAME_TITLE,0) ||
        coalesce(new.ID_EDIZM, 0)   ||
        coalesce(new.RABMAT, 0)     ||
        case when new.RABMAT = 1 then
           coalesce(nullif(new.TYPE_TRUD, 0), case when new.TAB starting '2' then 2 else 1 end)
         else
           coalesce(new.TYPE_TRUD, 0)
        end ||
        case new.TIPRAB/*[B690580EBEC1]*/ when 3 then 3 else 0 end );

--CQ[TIMUR 13444]    CRC.    
--    new.GR_RES_CRC =
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      K_GETCRC32S(
--         coalesce(new.TAB, '')
--      ), coalesce(new.RABMAT, 0)
--      ), case when new.RABMAT = 1 then
--           coalesce(nullif(new.TYPE_TRUD, 0), case when new.TAB starting '2' then 2 else 1 end)
--         else
--           coalesce(new.TYPE_TRUD, 0)
--         end
--      ), coalesce(CRC_NAME_TITLE,0) --coalesce(new.NAME_ID, 0) Voyager CQ[9681]
--      ), coalesce(new.ID_EDIZM, 0)
--      ), K_GETCRC32S(
--         coalesce(new.NORM_GUID, '') ) --[12404]coalesce(new.IDNORMATIV, 0)
--      ), case new.TIPRAB/*[B690580EBEC1]*/ when 3 then 3 else 0 end
--      ), K_GETCRC32S(
--         coalesce(new.ALTTAB, '') )
--      );
  end

end
^

--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_S_RES_AU3 FOR A_S_RES
ACTIVE AFTER UPDATE POSITION 3
as
begin
--[13929]
  if (old.TAB <> coalesce(new.TAB, '') and char_length(old.TAB) = 42) then
    delete from A_S_RES_BLOB where ID=old.ID and FIELD_NAME='TAB';
end
^

--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_S_RES_BI0 FOR A_S_RES
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable CRC_NAME_TITLE INTEGER;
declare variable CRC_TAB_BLOB integer;
declare variable FIELD_VALUE BLOB SUB_TYPE 1 SEGMENT SIZE 80;
begin
  if (new.TAB is null) then new.TAB = '';

  if ( not new.id_source is null ) then
  begin
    if ( new.smetatype is null ) then
      select s.smetatype , s.idhier
        from a_smeta s
        where s.id = new.id_source
        into new.smetatype , new.idhier;

    if ( new.smetatype = 15 ) then
    begin
      if ( new.idhier is null ) then
        select s.idhier
          from a_smeta s
          where s.id = new.id_source
          into new.idhier;

      if ( not new.idhier is null ) then
        execute procedure a_h_get_id_parentatype ( new.idhier , 1 )
          returning_values ( new.smetatype );
    end

    if ( ( new.idhier is null ) or ( new.idhier = 0 ) ) then
      select s.idhier
        from a_smeta s
        where s.id = new.id_source
        into new.idhier;
  end

  /* copyright [83D8FA78914B] */
  begin
    CRC_NAME_TITLE = Null;
    select CRC_NAME_TITLE
      from B_NNAME
      where ID = new.NAME_ID
    into :CRC_NAME_TITLE; -- Voyager CQ[9681]

    -- CQ[TIMUR 13929, 14255]
    CRC_TAB_BLOB = null;
    if (char_length(new.TAB) = 42) then
    begin
      select FIELD_VALUE
        from A_S_RES_BLOB
        where (ID = new.ID) and (FIELD_NAME = 'TAB')
      into :FIELD_VALUE;

      if (char_length(:FIELD_VALUE) > 0) then
        CRC_TAB_BLOB = K_GETCRC32(:FIELD_VALUE);
    end
    -- CQ[TIMUR 13929, 14255]

    --CQ[TIMUR 13444]    CRC
    new.GR_RES_CRC =
      K_GETCRC32S(
        coalesce(new.NORM_GUID, '') ||
        coalesce(:CRC_TAB_BLOB, '') ||
        coalesce(new.TAB, '')       ||
        coalesce(new.ALTTAB, '')    ||
        coalesce(:CRC_NAME_TITLE,0) ||
        coalesce(new.IDEDIZM, 0)    ||
        coalesce(new.RABMAT, 0)     ||
        case when new.RABMAT = 1 then
           coalesce(nullif(new.TYPE_TRUD, 0), case when new.TAB starting '2' then 2 else 1 end)
         else
           coalesce(new.TYPE_TRUD, 0)
        end ||
        0 /*TIPRAB*/ );

--CQ[TIMUR 13444]    CRC.    
--    new.GR_RES_CRC =
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      K_GETCRC32S(
--         coalesce(new.TAB, '')
--      ), coalesce(new.RABMAT, 0)
--      ), case when new.RABMAT = 1 then
--           coalesce(nullif(new.TYPE_TRUD, 0), case when new.TAB starting '2' then 2 else 1 end)
--         else
--           coalesce(new.TYPE_TRUD, 0)
--         end
--      ), coalesce(:CRC_NAME_TITLE,0) --coalesce(new.NAME_ID, 0) Voyager CQ[9681]
--     ), coalesce(new.IDEDIZM, 0)
--      ), K_GETCRC32S(
--         coalesce(new.NORM_GUID, '') ) --[12404]), coalesce(new.NORM_ID, 0)
--      ), 0/*TIPRAB*/
--      ), K_GETCRC32S(
--         coalesce(new.ALTTAB, '') )
--      );
  end

end
^

--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_S_RES_BLOB_AD0 FOR A_S_RES_BLOB
ACTIVE AFTER DELETE POSITION 0
AS
declare IDSMREC integer;
begin
--[13929]   
  if (old.FIELD_NAME='TAB') then
  for select ID from A_SMETA
    where ID_S_RES = old.ID
    into :IDSMREC
  do
  delete from A_SMETA_BLOB
    where ID=:IDSMREC and FIELD_NAME='TAB';
end
^

--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_S_RES_BLOB_AIU0 FOR A_S_RES_BLOB
ACTIVE AFTER INSERT OR UPDATE POSITION 0
AS
declare IDSMREC integer;
declare FIELD_VALUE blob;
begin
--[13929]   
  if (new.FIELD_VALUE is null) then
    exit;
  if (new.FIELD_NAME = 'TAB') then
  for select ID from A_SMETA
    where ID_S_RES = new.ID
    into :IDSMREC
  do
  begin
    select FIELD_VALUE from A_SMETA_BLOB
      where ID=:IDSMREC and FIELD_NAME='TAB'
      into :FIELD_VALUE;
    if (:FIELD_VALUE is null or B_COMPAREBLOB(:FIELD_VALUE, new.FIELD_VALUE) = 0) then
    begin
      update A_SMETA_BLOB
        set FIELD_VALUE=new.FIELD_VALUE
        where ID=:IDSMREC and FIELD_NAME='TAB';
      if (row_count = 0) then
      insert into A_SMETA_BLOB (ID, FIELD_NAME, FIELD_VALUE)
        values (:IDSMREC, 'TAB', new.FIELD_VALUE);
    end
  end
end
^

--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_S_RES_BLOB_BIU0 FOR A_S_RES_BLOB
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
as
declare variable CRC_SM_REC integer;
declare variable CRC_TAB_BLOB integer;
declare variable CRC_NAME_TITLE integer;
declare variable NAME_ID integer;
declare variable NORM_GUID varchar(100);
declare variable TAB varchar(42);
declare variable ALTTAB varchar(250);

declare variable IDEDIZM integer;
declare variable RABMAT integer;
declare variable TYPE_TRUD integer;
begin
  /* copyright [83D8FA78914B] */
  if ( new.FIELD_NAME = 'TAB'
    and ( old.FIELD_VALUE is null
       or new.FIELD_VALUE is null and old.FIELD_VALUE is not null
       or B_COMPAREBLOB(old.FIELD_VALUE, new.FIELD_VALUE) = 0 ))
  then
  begin

    select TAB, ALTTAB, NAME_ID, NORM_GUID, IDEDIZM, RABMAT, TYPE_TRUD
      from A_S_RES
      where ID = new.ID
    into :TAB, :ALTTAB, :NAME_ID, :NORM_GUID, :IDEDIZM, :RABMAT, :TYPE_TRUD;

    CRC_NAME_TITLE = Null;
    select CRC_NAME_TITLE
      from B_NNAME
      where ID = :NAME_ID
    into :CRC_NAME_TITLE; -- Voyager CQ[9681]

    if (char_length(new.FIELD_VALUE) > 0) then
      CRC_TAB_BLOB = K_GETCRC32(new.FIELD_VALUE);

    --CQ[TIMUR 13444]    CRC
    CRC_SM_REC =
      K_GETCRC32S(
        coalesce(:NORM_GUID, '')   ||
        coalesce(CRC_TAB_BLOB, '') ||
        coalesce(:TAB, '')         ||
        coalesce(:ALTTAB, '')      ||
        coalesce(:CRC_NAME_TITLE,0)||
        coalesce(:IDEDIZM, 0)      ||
        coalesce(:RABMAT, 0)       ||
        case when :RABMAT = 1 then
           coalesce(nullif(:TYPE_TRUD, 0), case when :TAB starting '2' then 2 else 1 end)
         else
           coalesce(:TYPE_TRUD, 0)
        end ||
        0 /*TIPRAB*/ );

    update A_S_RES set
      GR_RES_CRC = :CRC_SM_REC
    where ID = new.ID;

  end

end
^

--TFS[338],TFS[242]
CREATE OR ALTER TRIGGER A_S_RES_BU FOR A_S_RES
ACTIVE BEFORE UPDATE POSITION 0
as
declare variable CRC_NAME_TITLE INTEGER;
declare variable CRC_TAB_BLOB integer;
declare variable FIELD_VALUE BLOB SUB_TYPE 1 SEGMENT SIZE 80;
begin
  if (new.TAB is null) then new.TAB = '';
  -- CQ [6884] if (new.ID_PRICE = 0) then new.ID_PRICE = null;

  /* copyright [83D8FA78914B] */
  if (coalesce(old.RABMAT, 0) <> coalesce(new.RABMAT, 0) or
      coalesce(old.TYPE_TRUD, 0) <> coalesce(new.TYPE_TRUD, 0) or
      coalesce(old.TAB, '') <> coalesce(new.TAB, '') or
      coalesce(old.NAME_ID, 0) <> coalesce(new.NAME_ID, 0) or
      coalesce(old.IDEDIZM, 0) <> coalesce(new.IDEDIZM, 0) or
      coalesce(old.NORM_GUID, '') <> coalesce(new.NORM_GUID, '') or --[12404]coalesce(old.NORM_ID, 0) <> coalesce(new.NORM_ID, 0) or
      coalesce(old.ALTTAB, '') <> coalesce(new.ALTTAB, '') ) then
  begin
    CRC_NAME_TITLE = null;
    select CRC_NAME_TITLE
      from B_NNAME
      where ID = new.NAME_ID
    into :CRC_NAME_TITLE; -- Voyager CQ[9681]

    -- CQ[TIMUR 13929, 14255]
    CRC_TAB_BLOB = null;
    if (STRLEN(new.TAB) = 42) then
    begin
      select FIELD_VALUE
        from A_S_RES_BLOB
        where (ID = new.ID) and (FIELD_NAME = 'TAB')
      into :FIELD_VALUE;

      if (char_length(FIELD_VALUE) > 0) then
        CRC_TAB_BLOB = K_GETCRC32(:FIELD_VALUE);
    end
    -- CQ[TIMUR 13929, 14255]

    --CQ[TIMUR 13444]    CRC
    new.GR_RES_CRC =
      K_GETCRC32S(
        coalesce(new.NORM_GUID, '') ||
        coalesce(:CRC_TAB_BLOB, '') ||
        coalesce(new.TAB, '')       ||
        coalesce(new.ALTTAB, '')    ||
        coalesce(:CRC_NAME_TITLE,0) ||
        coalesce(new.IDEDIZM, 0)    ||
        coalesce(new.RABMAT, 0)     ||
        case when new.RABMAT = 1 then
           coalesce(nullif(new.TYPE_TRUD, 0), case when new.TAB starting '2' then 2 else 1 end)
         else
           coalesce(new.TYPE_TRUD, 0)
        end ||
        0 /*TIPRAB*/ );

--CQ[TIMUR 13444]    CRC.    
--    new.GR_RES_CRC =
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      GET_INTEGER_CRC(
--      K_GETCRC32S(
--         coalesce(new.TAB, '')
--      ), coalesce(new.RABMAT, 0)
--      ), case when new.RABMAT = 1 then
--           coalesce(nullif(new.TYPE_TRUD, 0), case when new.TAB starting '2' then 2 else 1 end)
--         else
--           coalesce(new.TYPE_TRUD, 0)
--         end
--      ), coalesce(:CRC_NAME_TITLE,0) --coalesce(new.NAME_ID, 0) Voyager CQ[9681]
--      ), coalesce(new.IDEDIZM, 0)
--      ), K_GETCRC32S(
--         coalesce(new.NORM_GUID, '') ) --[12404]coalesce(new.NORM_ID, 0)
--      ), 0 /*TIPRAB*/
--      ), K_GETCRC32S(
--         coalesce(new.ALTTAB, '') )
--      );
  end


end
^


--------------------------------------------------------------------
--                           10.0.1.1, 10.0.0.14
--------------------------------------------------------------------

-- TFS[375]
create or alter procedure GET_ONE_INDEX_APPLY_INFO (
    IDUSER integer,
    IDSMETASTR integer,
    IDLEVEL integer,
    NEW_LEVEL integer)
returns (
    OUT_INDEX_INFO integer,
    OUT_IDINDEX integer,
    OUT_IND_TYPE varchar(50),
    OUT_IND_YEAR integer,
    OUT_IND_MONTH integer,
    OUT_PUNKTIND varchar(42))
AS
declare variable SMETATYPE integer;
declare variable IDHIER integer;
declare variable ID integer;
declare variable ATYPE integer;
declare variable IDNORMATIV integer;
declare variable RABMAT integer;
declare variable IDPODGROUP integer;
declare variable TIPRAB integer;
declare variable VIDRAB integer;
declare variable ID_LEVEL_INDEX integer;
declare variable LEVEL_IDINDEX integer;
declare variable ID_COMPOSE_VC integer;
declare variable ID_COMPOSE_INDEX integer;
declare variable COMPOSE_IDINDEX integer;
declare variable VN_IDINDEX integer;
declare variable VN_MA double precision;
declare variable VN_MB double precision;
declare variable VN_MC double precision;
declare variable VN_MD double precision;
declare variable VN_ME double precision;
declare variable VN_MF double precision;
declare variable VN_MG double precision;
declare variable VN_MH double precision;
declare variable VN_MI double precision;
declare variable VN_PUNKTIND varchar(42);
declare variable VN_SPOSOB_RASCH integer;
declare variable VN_RES_INDEX integer;
declare variable IDCLASS integer;
declare variable NORM_GUID varchar(100);
declare variable ITOG_DIRTY_MASK integer;
declare variable DIRTY_MASK integer;
declare variable VN_MJ double precision;
declare variable VN_MK double precision;
declare variable VN_ML double precision;
declare variable VN_MM double precision;
declare VN_M_PR double precision; --[15352]
declare variable VN_DA double precision;
declare variable VN_DB double precision;
declare variable VN_DC double precision;
declare variable VN_DD double precision;
declare variable VN_DE double precision;
declare variable VN_DJ double precision;
declare variable VN_DK double precision;
declare variable VN_DL double precision;
declare variable VN_DM double precision;
declare variable NEED_APPLY_INDEX integer;
declare variable FC_IDREESTR integer;
declare variable FC_ATYPE integer;
declare variable FC_RABMAT integer;
declare variable FC_IDNORMATIV integer;
declare variable FC_IDPODGROUP integer;
declare variable FC_PUNKTIND varchar(42);
declare variable FC_TIPRAB integer;
declare variable FC_VIDRAB integer;
declare variable TAB varchar(42);

--<[14593]>
declare INDEX_DX_ONLY integer;
declare USE_MULTIRULES integer; --</>
begin
--[15352]

  --    A_S_PARAMS_TO_SMETA_NL_ONE
  --   !!!

  NEED_APPLY_INDEX = 1;

  --    
  for select S.ID, S.ATYPE,
      S.IDHIER, S.SMETATYPE,
      S.IDNORMATIV, S.RABMAT, S.KODIR_PODGROUP, S.TIPRAB, S.VIDRAB,
      I.ID_LEVEL_INDEX, I.IDINDEX,
      coalesce(nullif(I.PUNKTIND, ''), S.PUNKTIND), S.TAB, S.NORM_GUID,
      I.MJ, I.MK, I.ML, I.MM,
      I.M_PR, --[15352]
      I.DA, I.DB, I.DC, I.DD, I.DE, I.DJ, I.DK, I.DL, I.DM
    from A_SMETA S
    left outer join A_SMETA_INDLVL I on I.ID = S.ID and I.IDCENLVL = :IDLEVEL
    where S.ID = :IDSMETASTR
    into :ID, :ATYPE,
      :IDHIER, :SMETATYPE,
      :IDNORMATIV, :RABMAT, :IDPODGROUP, :TIPRAB, :VIDRAB,
      :ID_LEVEL_INDEX, :LEVEL_IDINDEX,
      :OUT_PUNKTIND, :TAB, :NORM_GUID,
      :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
      :VN_M_PR, --[15352]
      :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM
  do
  begin
    if (:ATYPE = 17) then -- SmRec only
    begin
      if (:SMETATYPE > 999) then
        IDCLASS = :SMETATYPE;
      else
        execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1/*ObgectType*/)
          returning_values :IDCLASS;
    end
    else
      exit;


    execute procedure NL_GET_NORMBASE_LINK(:IDUSER, :RABMAT, :IDNORMATIV,
                                           :IDPODGROUP, :NORM_GUID, :TAB)
    returning_values :FC_IDREESTR, :FC_RABMAT, :FC_IDNORMATIV, :FC_IDPODGROUP;
    FC_ATYPE = :ATYPE;
    FC_PUNKTIND = :OUT_PUNKTIND;
    FC_TIPRAB = :TIPRAB;
    FC_VIDRAB = :VIDRAB;

  --  
    execute procedure NL_FIND_COMPOSE_EX(
        :IDLEVEL, :IDCLASS, :IDUSER,
        :FC_IDREESTR,
        :FC_TIPRAB, :FC_VIDRAB, :FC_ATYPE, :FC_RABMAT,
        :IDHIER,
        :FC_PUNKTIND, :FC_IDNORMATIV, :FC_IDPODGROUP)
      returning_values :ID_COMPOSE_VC, :ID_COMPOSE_INDEX, :INDEX_DX_ONLY; --[14593]


    COMPOSE_IDINDEX = null;
  --    (  :ID_COMPOSE_INDEX)
    select CI.ID_MONTH, CI.DIRTY_MASK
      from LEVEL_INDEX CI
      where CI.ID_COMPOSE = :ID_COMPOSE_INDEX
      into :COMPOSE_IDINDEX, :DIRTY_MASK;

  --      
    select CT.DIRTY_MASK
      from LEVEL_INDEX_ITOG CT
      where CT.ID_COMPOSE = :ID_COMPOSE_INDEX
      into :ITOG_DIRTY_MASK;

  --  ...

  -- ...
  --  :   :COMPOSE_IDINDEX   :ID_COMPOSE_INDEX  _
  -- :COMPOSE_IDINDEX=0  :ID_COMPOSE_INDEX    
  --    
    VN_RES_INDEX = null;
    if ( coalesce(:COMPOSE_IDINDEX, 0) <> coalesce(:LEVEL_IDINDEX, 0)
      or coalesce(:ID_COMPOSE_INDEX, 0) <> coalesce(:ID_LEVEL_INDEX, 0)
      or coalesce(:ITOG_DIRTY_MASK, 0) <> 0
      or coalesce(:DIRTY_MASK, 0) <> 0
      or coalesce(:NEW_LEVEL, 0) <> 0)
    then
    begin
      --  
      execute procedure A_S_GET_INDEX_NL_NEW(
                :IDLEVEL, :IDUSER, :ATYPE,
                :OUT_PUNKTIND, :ID_COMPOSE_INDEX, :ID,
                :NEED_APPLY_INDEX)
            returning_values :VN_IDINDEX, :VN_MA, :VN_MB, :VN_MC, :VN_MD, :VN_ME,
                :VN_MF, :VN_MG, :VN_MH, :VN_MI,
                :VN_MJ, :VN_MK, :VN_ML, :VN_MM,
                :VN_M_PR, --[15352]
                :VN_DA, :VN_DB, :VN_DC, :VN_DD, :VN_DE, :VN_DJ, :VN_DK, :VN_DL, :VN_DM,
                :VN_PUNKTIND, :VN_SPOSOB_RASCH, :VN_RES_INDEX;
        -- :VN_RES_INDEX > 0:        ,
        --     ...      
      --<<[14593]
      if (:INDEX_DX_ONLY <> 0) then
      begin
        VN_MA = 1.0;
        VN_MB = 1.0; VN_MC = 1.0; VN_MD = 1.0; VN_ME = 1.0;
        VN_MF = 0.0; VN_MG = 0.0;
        VN_MH = 1.0; VN_MI = 1.0;
        VN_MJ = 1.0; VN_MK = 1.0; VN_ML = 1.0; VN_MM = 1.0;
        VN_M_PR = 1.0; --[15352]
      end
    end


    --        
    if (:VN_RES_INDEX in (2, 4, 5)) then -- ciFromSbInd, ciFromItog, ciFromSbTCH
    begin
      --   
      if ((VN_MA <> 1) or (VN_MB <> 1) or (VN_MC <> 1) or (VN_MD <> 1) or (VN_ME <> 1) or
          (VN_MF <> 0) or (VN_MG <> 0) or (VN_MH <> 1) or (VN_MI <> 1) or (VN_MJ <> 1) or
          (VN_MK <> 1) or (VN_ML <> 1) or (VN_MM <> 1) or
          (coalesce(nullif(:VN_M_PR, 0), 1) <> 1) or --[15352,15546]
          (VN_DA <> 1) or (VN_DB <> 1) or
          (VN_DC <> 1) or (VN_DD <> 1) or (VN_DE <> 1) or (VN_DJ <> 1) or (VN_DK <> 1) or
          (VN_DL <> 1) or (VN_DM <> 1)) then
      begin
        if ((coalesce(:NEW_LEVEL, 0) <> 0) or
             (exists(select * from A_SMETA_INDLVL where (ID = :ID)
                  and (IDCENLVL = :IDLEVEL)
                  and (coalesce(INDEX_INFO, 0) <> 3)  -- ciDirect

                  -- MK TFS[375] --->
                  -- 1.      (VN_IDINDEX <> 0)
                  -- 2. VN_XX    null
                  -- 3.        A_SMETA_INDLVL
                  -- 4.      
                  --    : "    1"
                  and (
                       ((coalesce(:VN_IDINDEX, 0) <> 0) and (coalesce(IDINDEX, 0) <> coalesce(:VN_IDINDEX, 0)))
                       or ((:VN_MA <> 1) and (coalesce(MA, 1) <> :VN_MA))
                       or ((:VN_MB <> 1) and (coalesce(MB, 1) <> :VN_MB))
                       or ((:VN_MC <> 1) and (coalesce(MC, 1) <> :VN_MC))
                       or ((:VN_MD <> 1) and (coalesce(MD, 1) <> :VN_MD))
                       or ((:VN_ME <> 1) and (coalesce(ME, 1) <> :VN_ME))
                       or ((:VN_MF <> 0) and (coalesce(MF, 0) <> :VN_MF))
                       or ((:VN_MG <> 0) and (coalesce(MG, 0) <> :VN_MG))
                       or ((:VN_MH <> 1) and (coalesce(MH, 1) <> :VN_MH))
                       or ((:VN_MI <> 1) and (coalesce(MI, 1) <> :VN_MI))
                       or coalesce(INDEX_SPOSOBRASCH, 0) <> coalesce(:VN_SPOSOB_RASCH, 0)
                       or ((:VN_MJ <> 1) and (coalesce(MJ, 1) <> :VN_MJ))
                       or ((:VN_MK <> 1) and (coalesce(MK, 1) <> :VN_MK))
                       or ((:VN_ML <> 1) and (coalesce(ML, 1) <> :VN_ML))
                       or ((:VN_MM <> 1) and (coalesce(MM, 1) <> :VN_MM))
                       or ((:VN_M_PR <> 1) and (coalesce(M_PR, 1) <> :VN_M_PR)) --[15352]
                       or ((:VN_DA <> 1) and (coalesce(DA, 1) <> :VN_DA))
                       or ((:VN_DB <> 1) and (coalesce(DB, 1) <> :VN_DB))
                       or ((:VN_DC <> 1) and (coalesce(DC, 1) <> :VN_DC))
                       or ((:VN_DE <> 1) and (coalesce(DE, 1) <> :VN_DE))
                       or ((:VN_DJ <> 1) and (coalesce(DJ, 1) <> :VN_DJ))
                       or ((:VN_DK <> 1) and (coalesce(DK, 1) <> :VN_DK))
                       or ((:VN_DL <> 1) and (coalesce(DL, 1) <> :VN_DL))
                       or ((:VN_DM <> 1) and (coalesce(DM, 1) <> :VN_DM))

                  --and (coalesce(IDINDEX, 0) <> coalesce(:VN_IDINDEX, 0)
                  --     or coalesce(MA, 0) <> coalesce(:VN_MA, 0)
                  --     or coalesce(MB, 0) <> coalesce(:VN_MB, 0)
                  --     or coalesce(MC, 0) <> coalesce(:VN_MC, 0)
                  --     or coalesce(MD, 0) <> coalesce(:VN_MD, 0)
                  --     or coalesce(ME, 0) <> coalesce(:VN_ME, 0)
                  --     or coalesce(MF, 0) <> coalesce(:VN_MF, 0)
                  --     or coalesce(MG, 0) <> coalesce(:VN_MG, 0)
                  --     or coalesce(MH, 0) <> coalesce(:VN_MH, 0)
                  --     or coalesce(MI, 0) <> coalesce(:VN_MI, 0)
                  --     or coalesce(INDEX_SPOSOBRASCH, 0) <> coalesce(:VN_SPOSOB_RASCH, 0)
                  --     or coalesce(MJ, 0) <> coalesce(:VN_MJ, 0)
                  --     or coalesce(MK, 0) <> coalesce(:VN_MK, 0)
                  --     or coalesce(ML, 0) <> coalesce(:VN_ML, 0)
                  --     or coalesce(MM, 0) <> coalesce(:VN_MM, 0)
                  --     or coalesce(M_PR, 0) <> coalesce(:VN_M_PR, 0) --[15352]
                  --     or coalesce(DA, 0) <> coalesce(:VN_DA, 0)
                  --     or coalesce(DB, 0) <> coalesce(:VN_DB, 0)
                  --     or coalesce(DC, 0) <> coalesce(:VN_DC, 0)
                  --     or coalesce(DE, 0) <> coalesce(:VN_DE, 0)
                  --     or coalesce(DJ, 0) <> coalesce(:VN_DJ, 0)
                  --     or coalesce(DK, 0) <> coalesce(:VN_DK, 0)
                  --     or coalesce(DL, 0) <> coalesce(:VN_DL, 0)
                  --     or coalesce(DM, 0) <> coalesce(:VN_DM, 0)
                  -- MK TFS[375] <---
                      )
                  )
             )
           ) then
        begin
          OUT_INDEX_INFO = VN_RES_INDEX;
          OUT_IDINDEX = VN_IDINDEX;
          OUT_PUNKTIND = VN_PUNKTIND;
  
          if ((coalesce(OUT_IDINDEX, 0) > 0) and (VN_RES_INDEX = 2)) then -- 2 -> ciFromSbInd
          begin
            select first 1 r.god, r.orderview, r.indtype
            from b_reestr r
            where (r.id = :OUT_IDINDEX)
            into :OUT_IND_YEAR, :OUT_IND_MONTH, :OUT_IND_TYPE;
          end
          else
          begin
            OUT_IND_YEAR = null;
            OUT_IND_MONTH = null;
            OUT_IND_TYPE = null;
          end

          suspend;
        end
      end
    end
  end
end
^




-- TFS[341]
create or alter procedure MARK_SPEC_EDIT_MODE (
    IDUSER integer,
    NUMBER integer,
    EDIT_MODE_VALUE integer)
AS
begin
  EXIT;
end
^

-- TFS[341]
create or alter procedure ALLOW_EDIT_SPEC_REC (
    ID_REC integer,
    IDUSER integer)
returns (
    RESULT integer)
AS
begin
  SUSPEND;
end
^

-- TFS[341]
create or alter procedure S_RR_SELECT_KKS (
    IDOBJECT integer,
    IDRR integer)
returns (
    ID integer,
    RABMAT integer,
    IDSMREC integer,
    TIP_IZM varchar(5),
    ISKS_NS_ID integer,
    COD_RTM varchar(60),
    FIELD_VALUE blob sub_type 1 segment size 80)
AS
begin
  SUSPEND;
end
^

-- TFS[341]
create or alter procedure S_RRDATA_SELECT_SPEC_TROW_CRC (
    IDSMREC integer)
returns (
    CRC integer)
AS
begin 
  SUSPEND;
end
^

-- TFS[341]
create or alter procedure IS_SPEC_REC (
    FIND_CHILD integer,
    ID_REC integer,
    SMETATYPE integer)
returns (
    SPEC_ISKS_NS_ID integer,
    SPEC_ID_REC integer,
    SPEC_IDHIER integer)
AS
begin
  SUSPEND;
end
^




--TFS[341]
create or alter procedure M__UPGRADE_SPEC_INT64
AS
begin
  if (not exists(
      select * from RDB$FIELDS
      where upper(RDB$FIELD_NAME)='S_BIGINT_D1')) then
  begin
    execute statement 'CREATE DOMAIN S_BIGINT_D1 AS DOUBLE PRECISION';

    execute statement
      'update RDB$RELATION_FIELDS set' ||
      ' RDB$FIELD_SOURCE = ''S_BIGINT_D1''' ||
      ' where (RDB$FIELD_NAME = ''ISKS_NM_ID'') and' ||
      ' (RDB$RELATION_NAME = ''SPEC_TROW_IDS'')';

    execute statement
      'update RDB$RELATION_FIELDS set' ||
      ' RDB$FIELD_SOURCE = ''S_BIGINT_D1''' ||
      ' where (RDB$FIELD_NAME = ''ZS_NOMER_ID'') and' ||
      ' (RDB$RELATION_NAME = ''SPEC_ROOT'')';

    execute statement
      'update RDB$RELATION_FIELDS set' ||
      ' RDB$FIELD_SOURCE = ''S_BIGINT_D1''' ||
      ' where (RDB$FIELD_NAME = ''ZS_NOMER_ID_ANNUL'') and' ||
      ' (RDB$RELATION_NAME = ''SPEC_ROOT'')';

    execute statement
      'update RDB$RELATION_FIELDS set' ||
      ' RDB$FIELD_SOURCE = ''S_BIGINT_D1''' ||
      ' where (RDB$FIELD_NAME = ''PARENT_NS_ID'') and' ||
      ' (RDB$RELATION_NAME = ''SPEC_TROW'')';

    execute statement
      'update RDB$RELATION_FIELDS set' ||
      ' RDB$FIELD_SOURCE = ''S_BIGINT_D1''' ||
      ' where (RDB$FIELD_NAME = ''ISKS_NS_ID'') and' ||
      ' (RDB$RELATION_NAME = ''SPEC_TROW'')';

  end
end
^
execute procedure M__UPGRADE_SPEC_INT64
^
drop procedure M__UPGRADE_SPEC_INT64
^




-- TFS[341]
create or alter procedure IS_SPEC_REC (
    FIND_CHILD integer,
    ID_REC integer,
    SMETATYPE integer)
returns (
    SPEC_ISKS_NS_ID double precision,
    SPEC_ID_REC integer,
    SPEC_IDHIER integer)
AS
declare variable VN_ID integer;
declare variable VN_RABMAT integer;
declare variable VN_ATYPE integer;
declare variable VN_FIND_REC integer;

declare IDOBJECT integer;
declare IDHIER integer;
begin
-- Sem: [54D0B9CA] -  ,    ...
--         (!!!)
-- :SPEC_IDHIER -  SPEC_TROW.IDHIER == SPEC_ROOT.IDHIER,       A_SMETA.IDHIER (!!!)


  if (:SMETATYPE <> 15/*PSType*/ ) then
    exit;

  --  ...
  select first 1 ISKS_NS_ID, IDSMREC, IDHIER --,   ,   [15211]
    from SPEC_TROW
    where IDSMREC = :ID_REC
  into :SPEC_ISKS_NS_ID, :SPEC_ID_REC, :SPEC_IDHIER;

  --   ...      (    )
  if ( (SPEC_ISKS_NS_ID  is null) and
       (SPEC_ID_REC is null) and
       (SPEC_IDHIER is null) and
       (FIND_CHILD = 1) ) then
  begin

    select IDHIER
      from A_SMETA
      where (ID = :ID_REC)
    into :IDHIER;

    --<[08.09.2017]>
    --    ,      ...
    execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, /*:IDTYPE=*/ 1)
      returning_values :IDOBJECT;
    --,     
    select first 1 H.IDHIER
      from S_O_HIER_SELECT_LEVEL_NF(:IDOBJECT) H
      left join SPEC_ROOT R on R.IDHIER=H.IDHIER
      where R.IDHIER is not null
    into :SPEC_IDHIER;
    --</[08.09.2017]>

    if (:SPEC_IDHIER is not null) then
    begin
      --[54D0B9CA]      ...      
      VN_FIND_REC = null;
      for select ID, RABMAT, ATYPE
         from A_SMETA
         where (IDHIER = :IDHIER) and (SMETATYPE = :SMETATYPE)
         order by --IDHIER desc, -- PLAN SORT,         ???
                  --SMETATYPE desc,
                  NUMBER1 desc,
                  NUMBER2 desc,
                  NUMBER3  desc
      into :VN_ID, :VN_RABMAT, :VN_ATYPE
      do
      begin
  
        if (VN_FIND_REC is not null) then
        begin
          if ( (VN_RABMAT <> 3) or (VN_ATYPE <> 17) )  then
            exit;
  
          select first 1 ISKS_NS_ID, IDSMREC, IDHIER --,   ,   [15211]
            from SPEC_TROW
            where IDSMREC = :VN_ID
          into :SPEC_ISKS_NS_ID, :SPEC_ID_REC, :SPEC_IDHIER;
    
          if (SPEC_ISKS_NS_ID is not null) then
            exit;
        end
  
        if ( (VN_ID = ID_REC) and (VN_RABMAT = 3) and (VN_ATYPE = 17) ) then
          VN_FIND_REC = VN_ID;
      end
    end
  end
end
^

-- TFS[341]
create or alter procedure S_RRDATA_SELECT_SPEC_TROW_CRC (
    IDSMREC integer)
returns (
    CRC integer)
AS
declare variable COD_RTM varchar(60);
declare variable VN_SPEC_ISKS_NS_ID double precision;
declare variable VN_SPEC_ID_REC integer;
declare variable VN_SPEC_IDHIER integer;
declare variable FIELD_VALUE blob sub_type text;
begin

  CRC = 0;
  execute procedure IS_SPEC_REC(1/*FIND_CHILD*/, :IDSMREC, 15/*SMETATYPE*/)
  returning_values :VN_SPEC_ISKS_NS_ID, :VN_SPEC_ID_REC, VN_SPEC_IDHIER;

  if (VN_SPEC_ID_REC is not null) then
    for select
        coalesce(nullif(T.COD_RTM, ''), T.COD_MCS),
        coalesce(R.FIELD_VALUE, M.FIELD_VALUE)
      from SPEC_TROW T
      left outer join SPEC_TROW_BLOB R
        on T.IDHIER = R.IDHIER and T.ROW_NUMBER = R.ROW_NUMBER and R.FIELD_NAME = 'COD_RTM'
      left outer join SPEC_TROW_BLOB M
        on T.IDHIER = M.IDHIER and T.ROW_NUMBER = M.ROW_NUMBER and M.FIELD_NAME = 'COD_MCS'
      where /*(T.IDHIER = :VN_SPEC_IDHIER) and -   ???*/ (T.IDSMREC = :VN_SPEC_ID_REC)
      order by T.ISKS_NS_ID
    into :COD_RTM, :FIELD_VALUE
    do
    begin
      if (FIELD_VALUE is not null) then
        CRC = GET_INTEGER_CRC( CRC, K_GETCRC32(FIELD_VALUE) );
      else
        CRC = GET_INTEGER_CRC( CRC, K_GETCRC32S(coalesce(COD_RTM, '')) );
    end
  else
  if (:VN_SPEC_IDHIER is null) then
  --TFS[338],TFS[242]         COD_RTM
  begin
    select FIELD_VALUE
      from A_SMETA_BLOB
      where ID=:IDSMREC and FIELD_NAME='COD_RTM'
      into :FIELD_VALUE;
    if (FIELD_VALUE is not null) then
      CRC = GET_INTEGER_CRC( CRC, K_GETCRC32(:FIELD_VALUE));
  end

  suspend;
end
^

-- TFS[341]
create or alter procedure S_RR_SELECT_KKS (
    IDOBJECT integer,
    IDRR integer)
returns (
    ID integer,
    RABMAT integer,
    IDSMREC integer,
    TIP_IZM varchar(5),
    ISKS_NS_ID double precision,
    COD_RTM varchar(60),
    FIELD_VALUE blob sub_type 1 segment size 80)
AS
declare variable VN_ID_RES_RR integer;
declare variable VN_ID_HIER integer;
declare variable VN_IDSMREC integer;
declare variable NUMBER1 integer;
declare variable SPEC_ID_HIER integer;
declare SMETATYPE integer;
declare COD_RTM_EXISTS integer;
begin
  SMETATYPE = 15;

  --<[08.09.2017]>
  --    ,      ...
  --execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, /*:IDTYPE=*/ 1)
    --returning_values :IDOBJECT;
  --,     
  select first 1 H.IDHIER
    from S_O_HIER_SELECT_LEVEL_NF(:IDOBJECT) H
    left join SPEC_ROOT R on R.IDHIER=H.IDHIER
    where R.IDHIER is not null
  into :SPEC_ID_HIER;
  --</[08.09.2017]>
  if (:SPEC_ID_HIER is null) then
  -- TFS[338],TFS[242]
    select 1
      from S_O_HIER_SELECT_LEVEL_NF(:IDOBJECT) H
        where exists(select * from A_SMETA_BLOB where IDHIER=H.IDHIER and FIELD_NAME='COD_RTM')
      rows 1 --  first 1
      into :COD_RTM_EXISTS;

  if (:SPEC_ID_HIER is null or :COD_RTM_EXISTS <> 0) then -- TFS[338],TFS[242]
  for select IDDATA
    from S_RRDATA R
    where (IDRR = :IDRR)
  into :VN_ID_RES_RR
  do
  begin
    ID = null;
    select first 1 IDRES, NUMBER, IDHIER
      from S_RRSOURCE_RAB
      where IDRES  = :VN_ID_RES_RR
    into :ID, :NUMBER1, :VN_ID_HIER;

    if (ID is not null) then
    begin
      for select S.ID, S.RABMAT
        from A_SMETA S
        where (S.IDHIER = :VN_ID_HIER)
          and (S.SMETATYPE = :SMETATYPE)
          and (S.NUMBER1 = :NUMBER1)
          and (S.NUMBER2 = 0) --    -
          and (S.NUMBER3 = 0)
      into :VN_IDSMREC, :RABMAT
      do
      if (:RABMAT = 3/*rmMater*/) then -- ...

      if (:COD_RTM_EXISTS <> 0) then
      begin --<TFS[338],TFS[242]>    A_SMETA_BLOB
        for select FIELD_VALUE
          from A_SMETA_BLOB
          where ID = :VN_IDSMREC and FIELD_NAME='COD_RTM'
          into :FIELD_VALUE
        do
        begin
          -- COD_RTM   , ..         ...
          --               :
          COD_RTM = substring(:FIELD_VALUE from 1 for 60);
          if (char_length(:COD_RTM) < 60) then
            FIELD_VALUE = null;
          IDSMREC = :VN_IDSMREC;
          suspend;
        end
      end --</TFS[338],TFS[242]>  -   
      else
      begin
        execute procedure IS_SPEC_REC(1/*FIND_CHILD*/, :VN_IDSMREC, :SMETATYPE)
        returning_values :ISKS_NS_ID, :IDSMREC, :SPEC_ID_HIER;

        for select T.TIP_IZM, T.ISKS_NS_ID,
            coalesce(nullif(T.COD_RTM, ''), T.COD_MCS), --TFS[337],TFS[242] +COD_MCS
            coalesce(R.FIELD_VALUE, M.FIELD_VALUE) --TFS[337],TFS[242] +COD_MCS
          from SPEC_TROW T
          left outer join SPEC_TROW_BLOB R
            on T.IDHIER = R.IDHIER and T.ROW_NUMBER = R.ROW_NUMBER and R.FIELD_NAME = 'COD_RTM'
          left outer join SPEC_TROW_BLOB M --TFS[337],TFS[242] +COD_MCS
            on T.IDHIER = M.IDHIER and T.ROW_NUMBER = M.ROW_NUMBER and M.FIELD_NAME = 'COD_MCS'
          where (T.IDSMREC = :IDSMREC)
        into :TIP_IZM, :ISKS_NS_ID, :COD_RTM,  :FIELD_VALUE
        do
          suspend;
      end
    end
  end
end
^

-- TFS[341]
create or alter procedure ALLOW_EDIT_SPEC_REC (
    ID_REC integer,
    IDUSER integer)
returns (
    RESULT integer)
AS
declare variable VN_ID_OBG integer;
declare variable VN_SPEC_INFO integer;
declare variable VN_SPEC_IDHIER integer;
declare variable VN_SPEC_ISKS_NS_ID double precision;
begin
  RESULT = 1;

  --  SPEC_REC_SUPPORT_EDIT_MODE
  if (exists (
        select * from B_USER_ACCESS
          where ID=ABS(:IDUSER)
            and BIN_AND(PROJECT_MODES,4/*pm15213mask*/)<>0 )
      ) then
  begin

    execute procedure IS_SPEC_REC(1/*FIND_CHILD*/, :ID_REC, 15/*SMETATYPE*/)
    returning_values :VN_SPEC_ISKS_NS_ID, :ID_REC, VN_SPEC_IDHIER;
  
    if (VN_SPEC_ISKS_NS_ID is not null) then
    begin

      execute procedure S_O_HIER_PARENT_OFTYPE (:VN_SPEC_IDHIER, 1)
      returning_values :VN_ID_OBG;
  
      --     
      VN_SPEC_INFO = null;
      select SPEC_INFO
        from A_O_OBJECTPARAMS
        where (NUMBER = :VN_ID_OBG)
      into :VN_SPEC_INFO;
  
      if ( (GETBIT(VN_SPEC_INFO, 0/*siSpecReadOnly*/) = 1) and (VN_SPEC_ISKS_NS_ID <> 0) ) then
        RESULT = 0;
    end

  end
end
^

-- TFS[341]
create or alter procedure MARK_SPEC_EDIT_MODE (
    IDUSER integer,
    NUMBER integer,
    EDIT_MODE_VALUE integer)
AS
declare variable VN_OBJ integer;
declare variable VN_ID integer;
declare variable VN_TMP integer;
declare variable VN_ATYPE integer;
declare variable VN_RABMAT integer;
declare variable VN_NEED_UPDATE_OBJ_PARAM integer;
declare variable VN_SPEC_ISKS_NS_ID double precision;
begin

  EDIT_MODE_VALUE = coalesce(EDIT_MODE_VALUE, 0);

  select ATYPE from A_O_HIER
    where NUMBER = :NUMBER
  into :VN_ATYPE;

  -- , , ... 
  if ( (VN_ATYPE = 3) or (VN_ATYPE = 4) or (VN_ATYPE = 5) ) then
  begin
    execute procedure S_O_HIER_PARENT_OFTYPE (:NUMBER, 1)
    returning_values :VN_OBJ;

    VN_ATYPE = 1;
    NUMBER = VN_OBJ;
  end

  -- 
  if (VN_ATYPE = 1) then
  begin
    VN_NEED_UPDATE_OBJ_PARAM = 1;
    VN_OBJ = NUMBER;

    --     ...
    for select NUMBER
      from L_H_SELTREE_HIER(:IDUSER, :NUMBER)
      into :NUMBER
    do
    begin
      --    
      for select ID, ATYPE, RABMAT
         from A_SMETA
         where (IDHIER = :NUMBER) and (SMETATYPE = 15)
         order by IDHIER, SMETATYPE, NUMBER1, NUMBER2, NUMBER3
      into :VN_ID, :VN_ATYPE, :VN_RABMAT
      do
      begin
        if ( (VN_ATYPE = 17) and (VN_RABMAT = 3) ) then
        begin
          execute procedure IS_SPEC_REC(1/*FIND_CHILD*/, :VN_ID, 15/*SMETATYPE*/)
          returning_values :VN_SPEC_ISKS_NS_ID, :VN_TMP, :VN_TMP;
  
          -- ...
          if (VN_SPEC_ISKS_NS_ID is not null) then
          begin
            update A_SMETA
              set UTV = :EDIT_MODE_VALUE
            where (ID = :VN_ID);
  
            if (VN_NEED_UPDATE_OBJ_PARAM = 1) then
            begin
              --      
              update A_O_OBJECTPARAMS
                set SPEC_INFO = SETBIT(SPEC_INFO, 0/*siSpecReadOnly*/, :EDIT_MODE_VALUE)
              where (NUMBER = :VN_OBJ);
     
              VN_NEED_UPDATE_OBJ_PARAM = 0;
            end
          end
        end
      end
    end
  end
  else
  -- 
  if (VN_ATYPE = 0) then
  begin

    --      ...
    for select NUMBER, ATYPE
      from L_H_SELTREE1(:IDUSER, :NUMBER, 0)
      into :NUMBER, :VN_ATYPE
    do
    begin
      if (VN_ATYPE = 1) then
         execute procedure MARK_SPEC_EDIT_MODE(:IDUSER, :NUMBER, :EDIT_MODE_VALUE);
    end
  end
end
^





-- TFS[414]
create or alter procedure M_TEMP_ALTER_TABLE
AS
begin
   -- Alter table SPEC_TROW --------------------------------------------
   if (not exists(
   select *
   from RDB$RELATION_FIELDS f
   where (UPPER(f.rdb$relation_name) = 'SPEC_TROW') and (UPPER(f.rdb$field_name) = 'NOMEN_NAME'))) then
   begin
      execute statement 'ALTER TABLE SPEC_TROW ADD NOMEN_NAME S_VARCHAR510';
   end

   if (not exists(
   select *
   from RDB$RELATION_FIELDS f
   where (UPPER(f.rdb$relation_name) = 'SPEC_TROW') and (UPPER(f.rdb$field_name) = 'NM_CS_MARKA_NAME'))) then
   begin
      execute statement 'ALTER TABLE SPEC_TROW ADD NM_CS_MARKA_NAME S_VARCHAR127';
   end

   if (not exists(
   select *
   from RDB$RELATION_FIELDS f
   where (UPPER(f.rdb$relation_name) = 'SPEC_TROW') and (UPPER(f.rdb$field_name) = 'NM_CS_TEX_CHAR_NAME'))) then
   begin
      execute statement 'ALTER TABLE SPEC_TROW ADD NM_CS_TEX_CHAR_NAME S_VARCHAR510';
   end

   if (not exists(
   select *
   from RDB$RELATION_FIELDS f
   where (UPPER(f.rdb$relation_name) = 'SPEC_TROW') and (UPPER(f.rdb$field_name) = 'NM_CS_SEISM_NAME'))) then
   begin
      execute statement 'ALTER TABLE SPEC_TROW ADD NM_CS_SEISM_NAME S_VARCHAR60';
   end

   if (not exists(
   select *
   from RDB$RELATION_FIELDS f
   where (UPPER(f.rdb$relation_name) = 'SPEC_TROW') and (UPPER(f.rdb$field_name) = 'NM_SAFETY'))) then
   begin
      execute statement 'ALTER TABLE SPEC_TROW ADD NM_SAFETY S_VARCHAR60';
   end
end
^
execute procedure M_TEMP_ALTER_TABLE
^
drop procedure M_TEMP_ALTER_TABLE
^^

--------------------------------------------------------------------
--                           10.0.1.1, 10.0.0.15
--------------------------------------------------------------------

-- Voyager TFS[404]
create or alter procedure B_READ_QUALIFIER_RABMAT_R (
    IDUSER              integer,
    IN_IDQUALIFIER      integer,
    IN_RABMAT           integer,
    IDZONE              integer,
    IS_RECURSIVE        integer,
    SHOW_FULL_QUALIFIER integer)
returns (
    ID            integer,
    IDREESTR      integer,
    RABMAT        integer,
    ORDERVIEW     integer,
    TAB           varchar(42),
    ALTTAB        varchar(250),
    IDEDIZM       integer,
    EDIZMNAME     varchar(100),
    EDIZMFULLNAME varchar(250),
    ID_UNIQUE     integer,
    IDABCOKP      integer,
    comment varchar(42),
    OKP           varchar(42),
    RAZRAD        double precision,
    BA            double precision,
    BB            double precision,
    BC            double precision,
    BD            double precision,
    BE            double precision,
    BF            double precision,
    BG            double precision,
    BH            double precision,
    BI            double precision,
    BJ            double precision,
    PA            double precision,
    PB            double precision,
    PC            double precision,
    PD            double precision,
    PE            double precision,
    MA            double precision,
    MB            double precision,
    MC            double precision,
    MD            double precision,
    ME            double precision,
    MF            double precision,
    MG            double precision,
    MH            double precision,
    MI            double precision,
    MJ            double precision,
    MK            double precision,
    ML            double precision,
    MM            double precision,
    MN            double precision,
    MO            double precision,
    MP            double precision,
    MQ            double precision,
    MR            double precision,
    MS            double precision,
    MT            double precision,
    VRPZ          integer,
    NTR           integer,
    BRUTTO        double precision,
    NETTO         double precision,
    VB            double precision,
    VN            double precision,
    PREISK        varchar(42),
    POSPREISK     varchar(42),
    MBETON        double precision,
    MRKBETON      varchar(15),
    MMASHINE      varchar(25),
    VBETON        double precision,
    TKALK         varchar(50),
    PUNKTIND      varchar(42),
    FRTCH         varchar(250),
    FRESN         varchar(21),
    IDPOSTAV      integer,
    ISESN         smallint,
    IDWITHESN     integer,
    ZONE_BA       double precision,
    ZONE_BB       double precision,
    ZONE_BC       double precision,
    ZONE_BD       double precision,
    ZONE_BE       double precision,
    IDTCH         integer,
    IDOGL         integer,
    IDQUALIFIER   integer,
    IDSOSTAV      integer,
    IDTCARD       integer,
    IDESN         integer,
    IDPICTURE     integer,
    NAME_TITLE    blob sub_type 1 segment size 80,
    NAME_PART     blob sub_type 1 segment size 80,
    NULLBLOB      blob sub_type 1 segment size 80,
    IDNAME        integer,
    REESTRNAME    varchar(250),
    FOLDERNAME    varchar(250),
    NORM_GUID     varchar(100))
AS
BEGIN
  -- Voyager TFS[475]
  --  
  suspend;
END
^

create or alter procedure B_READ_QUALIFIER_RABMAT_EX_R (
    IDUSER              integer,
    IN_IDQUALIFIER      integer,
    IN_RABMAT           integer,
    IDZONE              integer,
    NEEDCALCUSESCOUNT   integer,
    IS_RECURSIVE        integer,
    SHOW_FULL_QUALIFIER integer)
returns (
    ID             integer,
    IDREESTR       integer,
    RABMAT         integer,
    ORDERVIEW      integer,
    TAB            varchar(42),
    ALTTAB         varchar(250),
    IDEDIZM        integer,
    EDIZMNAME      varchar(100),
    EDIZMFULLNAME  varchar(250),
    ID_UNIQUE      integer,
    IDABCOKP       integer,
    comment varchar(42),
    OKP            varchar(42),
    RAZRAD         double precision,
    BA             double precision,
    BB             double precision,
    BC             double precision,
    BD             double precision,
    BE             double precision,
    BF             double precision,
    BG             double precision,
    BH             double precision,
    BI             double precision,
    BJ             double precision,
    PA             double precision,
    PB             double precision,
    PC             double precision,
    PD             double precision,
    PE             double precision,
    MA             double precision,
    MB             double precision,
    MC             double precision,
    MD             double precision,
    ME             double precision,
    MF             double precision,
    MG             double precision,
    MH             double precision,
    MI             double precision,
    MJ             double precision,
    MK             double precision,
    ML             double precision,
    MM             double precision,
    MN             double precision,
    MO             double precision,
    MP             double precision,
    MQ             double precision,
    MR             double precision,
    MS             double precision,
    MT             double precision,
    VRPZ           integer,
    NTR            integer,
    BRUTTO         double precision,
    NETTO          double precision,
    VB             double precision,
    VN             double precision,
    PREISK         varchar(42),
    POSPREISK      varchar(42),
    MBETON         double precision,
    MRKBETON       varchar(15),
    MMASHINE       varchar(25),
    VBETON         double precision,
    TKALK          varchar(50),
    PUNKTIND       varchar(42),
    FRTCH          varchar(250),
    FRESN          varchar(21),
    IDPOSTAV       integer,
    ISESN          smallint,
    IDWITHESN      integer,
    ZONE_BA        double precision,
    ZONE_BB        double precision,
    ZONE_BC        double precision,
    ZONE_BD        double precision,
    ZONE_BE        double precision,
    IDTCH          integer,
    IDOGL          integer,
    IDQUALIFIER    integer,
    IDSOSTAV       integer,
    IDTCARD        integer,
    IDESN          integer,
    IDPICTURE      integer,
    NAME_TITLE     blob sub_type 1 segment size 80,
    NAME_PART      blob sub_type 1 segment size 80,
    NULLBLOB       blob sub_type 1 segment size 80,
    REESTRNAME     varchar(250),
    FOLDERNAME     varchar(250),
    ISMAINMATERIAL integer,
    USESCOUNT      integer)
AS
BEGIN
  -- Voyager TFS[475]
  --  
  suspend;
END
^

create or alter procedure B_READ_QUALIFIER_SBORNIK_INNER1 (
    IDUSER         integer,
    IN_IDQUALIFIER integer,
    IN_RABMAT      integer,
    IN_PODGROUP    integer,
    ISRECURSIVE    integer)
returns (
    ID      integer,
    IDNAME integer)
AS
begin
  -- Voyager TFS[475]
  --  
  suspend;
end
^

create or alter procedure B_READ_QUALIFIER_RABMAT_NAMES_R (
    IDUSER              integer,
    IN_IDQUALIFIER      integer,
    IN_RABMAT           integer,
    IDZONE              integer,
    IS_RECURSIVE        integer,
    SHOW_FULL_QUALIFIER integer)
returns (
    ID        integer,
    IDNAME    integer,
    SUB_ORDER integer,
    SUB_STR   varchar(100))
AS
begin
  -- Voyager TFS[475]
  --  
  suspend;
END
^

-- TFS[438]
create or alter procedure T_TEMP_CREATE_TABLE
as
begin

  if (not exists(select *
          from RDB$RELATIONS F
          where (upper(F.RDB$RELATION_NAME) = 'B_NORM_BASE_LIST')))
  then
  begin
  
    execute statement 'CREATE TABLE B_NORM_BASE_LIST ('  ||
                      '    ID INTEGER NOT NULL, ' ||
                      '    BASE_CODE S_INTEGER NOT NULL, ' ||
                      '    BASE_SUB_TYPE S_INTEGER DEFAULT 0, ' ||
                      '    BASE_FULL_NAME S_VARCHAR250)';

    execute statement 'ALTER TABLE B_NORM_BASE_LIST ADD CONSTRAINT PK_B_NORM_BASE_LIST ' ||
                      'PRIMARY KEY (ID)';

    execute statement 'CREATE UNIQUE INDEX B_NORM_BASE_CODE_IDX ON B_NORM_BASE_LIST ( ' ||
                      'BASE_CODE, BASE_SUB_TYPE)';

  end


  if (not exists(select *
          from RDB$RELATIONS F
          where (upper(F.RDB$RELATION_NAME) = 'B_NORM_BASE_INSTALL')))
  then
  begin
  
    execute statement 'CREATE TABLE B_NORM_BASE_INSTALL ('  ||
                      '    ID A_INTEGERNOTNULL, ' ||
                      '    ID_NORM_BASE  A_INTEGERNOTNULL, ' ||
                      '    INSTALL_GUID  A_VARCHAR100)';

    execute statement 'ALTER TABLE B_NORM_BASE_INSTALL ADD CONSTRAINT PK_B_NORM_BASE_INSTALL ' ||
                      'PRIMARY KEY (ID)';

    execute statement 'ALTER TABLE B_NORM_BASE_INSTALL ADD CONSTRAINT FK_B_NORM_BASE_INSTALL_ID ' ||
                      'FOREIGN KEY (ID_NORM_BASE) REFERENCES B_NORM_BASE_LIST (ID) ON ' ||
                      'DELETE CASCADE ON ' ||
                      'UPDATE CASCADE';

    execute statement 'CREATE UNIQUE INDEX B_NORM_BASE_INSTALL_GUID ON B_NORM_BASE_INSTALL (INSTALL_GUID)';

    execute statement 'CREATE UNIQUE INDEX B_NORM_BASE_INSTALL_ID_GUID ON ' ||
                      'B_NORM_BASE_INSTALL (ID_NORM_BASE, INSTALL_GUID)';

  end

end
^

execute procedure T_TEMP_CREATE_TABLE
^
drop procedure T_TEMP_CREATE_TABLE
^^

-- TFS[438]
create or alter procedure T_FILL_RECORDs_TABLE
as
begin
  if (not exists(
      select * from B_NORM_BASE_LIST
        where ID = -1)) then
  begin

    insert into B_NORM_BASE_LIST (
      ID, BASE_CODE, BASE_SUB_TYPE, BASE_FULL_NAME)
    values (
      -1, -1, 0, '        ');

  end
end
^

execute procedure T_FILL_RECORDs_TABLE
^
drop procedure T_FILL_RECORDs_TABLE
^^

-- TFS[438]
create or alter procedure B_WRITE_N_BASE_TO_INSTALL_LINK (
    IDUSER integer,
    ID_NORM_BASE integer,
    INSTALL_GUID varchar(100))
returns (
    ID integer)
AS
begin

 if (INSTALL_GUID <> '') then
 begin
   select first 1 ID
   from B_NORM_BASE_INSTALL
   where (INSTALL_GUID = :INSTALL_GUID)
   into ID;

   if (ID is null) then
   begin
     ID = gen_id(A_G_SMETA, 1) ;
 
     insert into B_NORM_BASE_INSTALL
        (ID, ID_NORM_BASE, INSTALL_GUID)
     values
        (:ID, :ID_NORM_BASE, :INSTALL_GUID) ;
   end
   else
   begin
     update B_NORM_BASE_INSTALL
       set ID_NORM_BASE = :ID_NORM_BASE
     where (INSTALL_GUID = :INSTALL_GUID);
   end
 end

 suspend;
end^

-- TFS[438]
create or alter procedure B_LINK_NORM_BASE_TO_INSTALL (
    IDUSER integer,
    ID integer,
    PARENTS_LIST varchar(1000),
    SOURCE_LIST blob sub_type 0 segment size 80,
    SOURCE_COUNT integer)
AS
declare variable SOURCE_ID integer;
declare variable INSTALL_GUID varchar(100);
declare variable ID_TMP integer;
begin
 ID_TMP = gen_id(B_GEN_TEMP, 1) ;
 insert into B_TEMP_BLOB (ID, BLOB1) values (:ID_TMP, :SOURCE_LIST);
 select BLOB1 from B_TEMP_BLOB where ID = :ID_TMP into :SOURCE_LIST;
 delete from B_TEMP_BLOB where ID = :ID_TMP ;

 select NORM_GUID
 from B_READ_INSTALL_GUID(:IDUSER, :ID)
 into :INSTALL_GUID ;

 if (INSTALL_GUID is null)
 then exception B_E_GUID_INSTALL_IS_EMPTY;

 execute procedure B_TEST_INSTALL_MOVED(:IDUSER, :ID, :PARENTS_LIST) ;

 for select fvalue
 from S_INTFROMBLOB_SELECT (:SOURCE_LIST, :SOURCE_COUNT)
 into :SOURCE_ID
 do
   SELECT ID
   FROM B_WRITE_N_BASE_TO_INSTALL_LINK(:IDUSER, :SOURCE_ID, :INSTALL_GUID)
   INTO :ID ;

end^

-- TFS[438]
create or alter procedure B_DELETE_INSTALL_NORM_BASE_LINK (
    IDUSER integer,
    IDINSTALL integer,
    ID integer)
as
declare variable INSTALL_GUID varchar(100);
begin
 if (IDINSTALL = 0) then
   IDINSTALL = null;

 if (IDINSTALL is not null) then
 begin
    select NORM_GUID
    from B_READ_INSTALL_GUID(:IDUSER, :IDINSTALL)
    into :INSTALL_GUID ;

    if (INSTALL_GUID is not null)
    then
       delete from B_NORM_BASE_INSTALL
       where (ID_NORM_BASE = :ID) and
             (INSTALL_GUID = :INSTALL_GUID) ;
 end
end^

-- TFS[438]
create or alter procedure B_DEL_INSTALL_NORM_BASE_LINKS (
    IDUSER integer,
    IDINSTALL integer,
    DELBLOB blob sub_type 0 segment size 80,
    DELCOUNT integer)
as
declare variable ID integer;
begin
 ID = gen_id(B_GEN_TEMP, 1) ;
 insert into B_TEMP_BLOB (ID, BLOB1) values (:ID, :DELBLOB);
 select BLOB1 from B_TEMP_BLOB where ID = :ID into :DELBLOB;
 delete from B_TEMP_BLOB where ID = :ID ;

 for select FVALUE
 from S_INTFROMBLOB_SELECT (:DELBLOB, :DELCOUNT)
 into :ID
 do
    execute procedure B_DELETE_INSTALL_NORM_BASE_LINK (:IDUSER, :IDINSTALL, :ID) ;
end^

-- TFS[438]
create or alter procedure B_READ_INSTALL_NORM_BASE_LINKS (
    IDUSER integer,
    ID_INSTALL integer)
returns (
    ID integer,
    BASE_CODE integer,
    BASE_SUB_TYPE integer,
    NAME varchar(250))
AS
declare variable INSTALL_GUID varchar(100);
begin

  select NORM_GUID
    from B_READ_INSTALL_GUID(:IDUSER, :ID_INSTALL)
    into :INSTALL_GUID ;

  if (:INSTALL_GUID is not null) then
    for select ID_NORM_BASE
      from B_NORM_BASE_INSTALL
      where INSTALL_GUID = :INSTALL_GUID
      into :ID
    do
      for select BASE_CODE, BASE_SUB_TYPE, BASE_FULL_NAME
        from B_NORM_BASE_LIST
        where ID = :ID
        order by BASE_CODE, BASE_SUB_TYPE
      into :BASE_CODE, :BASE_SUB_TYPE, :NAME
      do
        suspend;
end^

-- TFS[438]
create or alter procedure B_READ_NORM_BASE_LIST (
    IDUSER integer,
    LINKTOINSTALLREGIM integer)
returns (
    ID integer,
    BASE_CODE integer,
    BASE_SUB_TYPE integer,
    BASE_FULL_NAME varchar(250),
    ISLINKS integer)
AS
begin
 for select ID, BASE_CODE, BASE_SUB_TYPE, BASE_FULL_NAME
   from B_NORM_BASE_LIST
   order by BASE_CODE, BASE_SUB_TYPE
 into :ID, :BASE_CODE, :BASE_SUB_TYPE, :BASE_FULL_NAME
 do
 begin
    ISLINKS = 0;

    if (LINKTOINSTALLREGIM = 1) then
    begin
       if (exists(select * from B_NORM_BASE_INSTALL
                  where ID_NORM_BASE = :ID))
       then ISLINKS = 1;
    end else
    if (LINKTOINSTALLREGIM = 2) then
    begin
       if (not exists(select * from B_NORM_BASE_INSTALL
                      where ID_NORM_BASE = :ID))
       then ISLINKS = 1;
    end

    suspend;
 end
end^

-- TFS[438]
create or alter procedure B_READ_LINKS_TO_INSTALL (
    IDUSER integer,
    ID integer,
    SHOWLINKTYPE integer)
returns (
    ID_INSTALL integer)
as
declare variable INSTALL_GUID varchar(100);
declare variable NORM_GUID varchar(100);
begin
 if (SHOWLINKTYPE between 1 and 3)
 then begin
    for select INSTALL_GUID
    from B_REESTR
    where ID = :ID
    into :INSTALL_GUID
    do
       for select ID
       from B_READ_INSTALL_ID_BY_GUID(:IDUSER, :INSTALL_GUID)
       into :ID_INSTALL
       do
          suspend ;
 end
 else
 if (SHOWLINKTYPE = 4) then begin
    for select NORM_GUID
    from B_REESTR_DOC
    where ID = :ID
    into :NORM_GUID
    do
       for select INSTALL_GUID
       from B_REESTR_DOC_INSTALL
       where NORM_GUID = :NORM_GUID
       into :INSTALL_GUID
       do
          for select ID
          from B_READ_INSTALL_ID_BY_GUID(:IDUSER, :INSTALL_GUID)
          into :ID_INSTALL
          do
             suspend ;
 end
 else
 if (SHOWLINKTYPE = 5) then begin
    for select NORM_GUID
    from B_PODGROUP
    where ID = :ID
    into :NORM_GUID
    do
       for select INSTALL_GUID
       from B_PODGROUP_INSTALL
       where NORM_GUID = :NORM_GUID
       into :INSTALL_GUID
       do
          for select ID
          from B_READ_INSTALL_ID_BY_GUID(:IDUSER, :INSTALL_GUID)
          into :ID_INSTALL
          do
             suspend ;
 end
 else
 if (SHOWLINKTYPE = 6) then begin
    for select NORM_GUID
    from K_GR_CORRECT_TABLE
    where ID = :ID
    into :NORM_GUID
    do
       for select INSTALL_GUID
       from B_CORRECT_INSTALL
       where NORM_GUID = :NORM_GUID
       into :INSTALL_GUID
       do
          for select ID
          from B_READ_INSTALL_ID_BY_GUID(:IDUSER, :INSTALL_GUID)
          into :ID_INSTALL
          do
             suspend ;
 end
 else
 if (SHOWLINKTYPE = 7) then begin
    for select NORM_GUID
    from A_SRF_TR
    where ID = :ID
    into :NORM_GUID
    do
       for select INSTALL_GUID
       from B_SRF_INSTALL
       where NORM_GUID = :NORM_GUID
       into :INSTALL_GUID
       do
          for select ID
          from B_READ_INSTALL_ID_BY_GUID(:IDUSER, :INSTALL_GUID)
          into :ID_INSTALL
          do
             suspend ;
 end
 else
 if (SHOWLINKTYPE = 10) then begin --TFS[440]
    for select INSTALL_GUID
    from B_NORM_BASE_INSTALL
    where ID_NORM_BASE = :ID
    into :INSTALL_GUID
    do
       for select ID
       from B_READ_INSTALL_ID_BY_GUID(:IDUSER, :INSTALL_GUID)
       into :ID_INSTALL
       do
          suspend ;
 end
end^

-- TFS[438]
create or alter procedure B_READ_INSTALL_LEVEL (
    IDUSER integer,
    PARENT_ID integer,
    PARENTS_LIST varchar(1000),
    SHOWLINKTYPE integer)
returns (
    ID integer,
    IDPARENT integer,
    CHILDCOUNT integer,
    NAME varchar(250),
    ORDERVIEW integer,
    NORM_GUID varchar(100),
    BASETYPE varchar(50),
    ISLINKS integer)
as
begin
  /* Parent node not exissts */
  if (PARENT_ID <> 0) then begin
     if (not exists(select * from B_REESTR_INSTALL where ID = :PARENT_ID))
     then exception B_E_NODE_NOTFOUND;

     execute procedure B_TEST_INSTALL_MOVED (:IDUSER, :PARENT_ID, :PARENTS_LIST) ;
  end

  for select ID, IDPARENT, NAME, ORDERVIEW, CHILDCOUNT, NORM_GUID, BASETYPE
  from B_REESTR_INSTALL
  where (IDPARENT = :PARENT_ID)
  order by IDPARENT, ORDERVIEW
  into ID, IDPARENT, NAME, ORDERVIEW, CHILDCOUNT, NORM_GUID, BASETYPE
  do begin
     ISLINKS = 0;

     if (NORM_GUID = '')
     then NORM_GUID = null;

     if (SHOWLINKTYPE = 0)
     then suspend;
     else begin
        if (SHOWLINKTYPE = 1) then begin
           if ((NORM_GUID is not null) and
               (exists(select * from B_REESTR
                where (INSTALL_GUID = :NORM_GUID) and (RABMAT = 0))))
           then ISLINKS = 1;
        end else
        if (SHOWLINKTYPE = 2) then begin
           if ((NORM_GUID is not null) and
               (exists(select * from B_REESTR
                where (INSTALL_GUID = :NORM_GUID) and (RABMAT = 2))))
           then ISLINKS = 1;
        end else
        if (SHOWLINKTYPE = 3) then begin
           if ((NORM_GUID is not null) and
               (exists(select * from B_REESTR
                where (INSTALL_GUID = :NORM_GUID) and (RABMAT = 3))))
           then ISLINKS = 1;
        end else
        if (SHOWLINKTYPE = 4) then begin
           if ((NORM_GUID is not null) and
               (exists(select * from B_REESTR_DOC_INSTALL
                where INSTALL_GUID = :NORM_GUID)))
           then ISLINKS = 1;
        end
        if (SHOWLINKTYPE = 5) then begin
           if ((NORM_GUID is not null) and
              (exists(select * from B_PODGROUP_INSTALL
               where INSTALL_GUID = :NORM_GUID)))
           then ISLINKS = 1;
        end else
        if (SHOWLINKTYPE = 6) then begin
           if ((NORM_GUID is not null) and
               (exists(select * from B_CORRECT_INSTALL
                where INSTALL_GUID = :NORM_GUID)))
           then ISLINKS = 1;
        end else
        if (SHOWLINKTYPE = 7) then begin
           if ((NORM_GUID is not null) and
               (exists(select * from B_SRF_INSTALL
                where INSTALL_GUID = :NORM_GUID)))
           then ISLINKS = 1;
        --DEN[E1FCC731AC4C]
        end else
        if (SHOWLINKTYPE = 9) then begin
           if ((NORM_GUID is not null) and
               (exists(select * from B_PUTI_INSTALL
                where INSTALL_GUID = :NORM_GUID)))
           then ISLINKS = 1;
        --DEN[E1FCC731AC4C]
        end else
        if (SHOWLINKTYPE = 10) then begin --TFS[440]
           if ((NORM_GUID is not null) and
               (exists(select * from B_NORM_BASE_INSTALL
                where INSTALL_GUID = :NORM_GUID)))
           then ISLINKS = 1;
        end

        suspend;
     end
  end
end^

-- TFS[438]
create or alter procedure B_TEST_IS_LINKS_TO_INSTALL (
    IDUSER integer,
    ID integer)
returns (
    RESULT integer)
as
declare variable NORM_GUID varchar(100);
begin
 RESULT = 0;

 select NORM_GUID
 from B_READ_INSTALL_GUID(:IDUSER, :ID)
 into :NORM_GUID ;

 if (NORM_GUID is not null) then begin
    if (exists(select * from B_REESTR
                where INSTALL_GUID = :NORM_GUID))
    then RESULT = 1;

    if ((RESULT = 0) and
        ((exists(select * from B_REESTR_DOC_INSTALL
                 where INSTALL_GUID = :NORM_GUID))))
    then RESULT = 1;

    if ((RESULT = 0) and
        ((exists(select * from B_PODGROUP_INSTALL
                 where INSTALL_GUID = :NORM_GUID))))
    then RESULT = 1;

    if ((RESULT = 0) and
        ((exists(select * from B_CORRECT_INSTALL
                 where INSTALL_GUID = :NORM_GUID))))
    then RESULT = 1;

    if ((RESULT = 0) and
        ((exists(select * from B_SRF_INSTALL
                 where INSTALL_GUID = :NORM_GUID))))
    then RESULT = 1;

    if (:RESULT = 0 and exists ( --DEN[E1FCC731AC4C]
        select * from B_PUTI_INSTALL
          where INSTALL_GUID = :NORM_GUID )) then
      RESULT = 1;

    if (:RESULT = 0 and exists ( --TFS[440]
        select * from B_NORM_BASE_INSTALL
          where INSTALL_GUID = :NORM_GUID )) then
      RESULT = 1;
 end

 suspend ;
end^

--TFS[344],TFS[242]
create or alter procedure A_SMETA_SELECT_CLIPBOARD (
    ID_SM_REC integer,
    ID_USER integer)
returns (
    ID integer,
    SMETATYPE integer,
    ATYPE smallint,
    NAME blob sub_type 0 segment size 80,
    TAB varchar(42),
    KOLL double precision,
    NORMARASH double precision,
    SKOLL varchar(255),
    EDIZM_NAME varchar(100),
    EDIZM_FULLNAME varchar(250),
    EDIZM_RELATION double precision,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    RABMAT integer,
    VRPZ integer,
    ALTTAB varchar(250),
    NACH date,
    OKONCH date,
    TIPRAB integer,
    IDNORMATIV integer,
    KODIR_GROUP_NAME varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ISGROUPOKP integer,
    NOMERROD integer,
    PR_ADDED_REC integer,
    PR_VSEGO double precision,
    VIDRAB integer,
    UTV integer,
    CLCMODE integer,
    TYPE_TRUD integer,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    CORRECTNODE blob sub_type 1 segment size 80,
    CORRECTNODE_1 blob sub_type 1 segment size 80,
    ID_S_RES integer,
    NORM_GUID varchar(100),
    IDFORMULS integer,
    PR_NUMBER1 integer,
    PR_NUMBER2 integer,
    PR_NUMBER3 integer,
    IDHIER integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    S_BA double precision,
    S_BB double precision,
    S_BC double precision,
    S_BD double precision,
    S_BE double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    SLAVEPARENT integer,
    IDNORMATIVUNIQ integer,
    PUNKTIND varchar(42),
    PRICE_GUID varchar(100),
    PRICE_NORMOTAB varchar(42),
    PRICE_NORMOGUID varchar(100),
    ROW integer,
    COST double precision,
    KOEF double precision,
    SM_CLCMODE integer,
    RES_CLCMODE integer,
    BN double precision,
    BO double precision,
    B_ITOGO double precision,
    K_ITOGO varchar(50),
    B_PR double precision,
    K_PR varchar(50),
    COD_RTM blob sub_type 1 segment size 80)
AS
declare variable VN_NAME_ID integer;
declare variable PR_VIPOLNENO double precision;
declare variable PR_EXISTS_CHILDS integer;
declare variable ID_OBJ integer;
declare variable PRICE_NORMOID integer;
begin
--[15352]+

  --    
  select S.ID, S.SMETATYPE, S.ATYPE, S.NAME_ID, S.TAB, S.KOLL, S.NORMARASH, S.SKOLL, E.NAME,
         E.FULLNAME, E.RELATION, S.NUMBER1, S.NUMBER2, S.NUMBER3, S.RABMAT, S.VRPZ, S.ALTTAB,
         S.NACH, S.OKONCH, S.TIPRAB, S.IDNORMATIV, GR.NAME, PGR.NAME, S.ISGROUPOKP, S.NOMERROD,
         S.PR_ADDED_REC, S.VIDRAB, S.UTV, S.CLCMODE, S.TYPE_TRUD, S.KA, S.KB, S.KC, S.KD, S.KE,
         S.KF, S.KG, S.KH, S.KI, S.KJ, S.KK, S.KL, S.KM, S.CORRECTNODE, S.CORRECTNODE_1, S.ID_S_RES,
         S.NORM_GUID, S.IDFORMULS, S.IDHIER, S.BA, S.BB, S.BC, S.BD, S.BE, S.BF, S.BG, S.BH, S.BI,
         S.PA, S.PB, S.PC, S.PD, S.MA, S.MB, S.MC, S.MD, S.ME, S.MF, S.MG, S.MH, S.MI,
         S.SLAVEPARENT, S.IDNORMATIVUNIQ, S.PUNKTIND,
         S.BN, S.BO, S.B_ITOGO, /*CQ[13179]*/ S.K_ITOGO /*14460*/, S.K_PR /*15421*/,
         S.B_PR --[15352]
  from A_SMETA S  left join B_EDIZM E on E.ID = S.ID_EDIZM
  left join B_GROUP GR on GR.ID = S.KODIR_GROUP
  left join B_PODGROUP PGR on PGR.ID = S.KODIR_PODGROUP
  where (S.ID = :ID_SM_REC)
  into :ID, :SMETATYPE, :ATYPE, :VN_NAME_ID, :TAB, :KOLL, :NORMARASH, :SKOLL, :EDIZM_NAME,
       :EDIZM_FULLNAME, :EDIZM_RELATION, :NUMBER1, :NUMBER2, :NUMBER3, :RABMAT, :VRPZ, :ALTTAB,
       :NACH, :OKONCH, :TIPRAB, :IDNORMATIV, :KODIR_GROUP_NAME, :KODIR_PODGROUP_NAME, :ISGROUPOKP,
       :NOMERROD, :PR_ADDED_REC, :VIDRAB, :UTV, :CLCMODE, :TYPE_TRUD, :KA, :KB, :KC, :KD, :KE, :KF,
       :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :CORRECTNODE, :CORRECTNODE_1, :ID_S_RES, :NORM_GUID,
       :IDFORMULS, :IDHIER, :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :PA, :PB, :PC, :PD, :MA,
       :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI, :SLAVEPARENT, :IDNORMATIVUNIQ, :PUNKTIND,
       :BN, :BO, :B_ITOGO,/* CQ[13179]*/ :K_ITOGO /*14460*/, :K_PR /*15421*/,
       :B_PR; --[15352]

  --TFS[344],TFS[242]
  select FIELD_VALUE from A_SMETA_BLOB
    where ID=:ID_SM_REC and FIELD_NAME='COD_RTM'
    into :COD_RTM;

  S_BA = :BA;
  S_BB = :BB;
  S_BC = :BC;
  S_BD = :BD;
  S_BE = :BE;

  SM_CLCMODE = :CLCMODE;
  RES_CLCMODE = 0; -- CQ[12379]

  if (:ATYPE <> 17) then
  begin
    select CLCMODE, BA, BB, BC, BD, BE
    from A_SMETA
    where ID = :SLAVEPARENT
    into :SM_CLCMODE, :S_BA, :S_BB, :S_BC, :S_BD, :S_BE;
  end
  -- CQ[12534] else
  begin
    -- CQ[12379] -->
    if (:ID_S_RES is not null) then
      select CLCMODE from A_S_RES
      where ID = :ID_S_RES
      into :RES_CLCMODE;
    -- CQ[12379] <--
  end

  SM_CLCMODE = coalesce(:SM_CLCMODE, 0);

  -- 
  PRICE_GUID = null;
  PRICE_NORMOTAB = null;
  PRICE_NORMOGUID = null;
  ROW = null;
  PRICE_NORMOID = null;
  select P.PRICE_GUID,
         case
           when B.ID is not null then B.ID
           else I.IDNORMO
         end,
         B.TAB, I.ROW, I.KOEF, I.COST
  from SMETA_PRICEPOS_INFO I
  left outer join PM_PRICE_GUID P on P.PRICE_ID = I.IDPRICE
  left outer join B_RABMAT B on B.ID = I.IDNORMO
  where (I.ID = :ID) and (I.IDCENLVL = 0)
  into :PRICE_GUID, :PRICE_NORMOID, :PRICE_NORMOTAB, :ROW, :KOEF, :COST;
  if (PRICE_NORMOID is not null) then
  begin
    execute procedure D_GET_RABMAT_SBORNIK_GUID(:PRICE_NORMOID)
    returning_values (:PRICE_NORMOGUID);--CQ[7662]
  end
  else
  begin
    PRICE_NORMOGUID = null;
  end
  if (PRICE_NORMOID = -1) then
    PRICE_NORMOGUID = '-1';

  -- 
  select NAME
  from B_GETNAME(:ID_USER, :VN_NAME_ID)
  into :NAME;

  --    
  if (:SMETATYPE <> 15) then
  begin
    execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1)
    returning_values :ID_OBJ;

    execute procedure L_PR_SELECT_REC(:ID_SM_REC, :ID_USER, :ID_OBJ, 0, 0, 1, 1)
    returning_values (:PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, PR_VSEGO, PR_VIPOLNENO,
      :PR_EXISTS_CHILDS);
  end

  suspend;
end
^

--TFS[344],TFS[242]
create or alter procedure M_EXP_SM_REC (
    ID_SM_REC integer,
    ID_USER integer)
returns (
    ID integer,
    SMETATYPE integer,
    ATYPE smallint,
    NAME blob sub_type 0 segment size 80,
    TAB varchar(42),
    KOLL double precision,
    NORMARASH double precision,
    SKOLL varchar(255),
    EDIZM_NAME varchar(100),
    EDIZM_FULLNAME varchar(250),
    EDIZM_RELATION double precision,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    RABMAT integer,
    VRPZ integer,
    ALTTAB varchar(250),
    NACH date,
    OKONCH date,
    TIPRAB integer,
    IDNORMATIV integer,
    KODIR_GROUP_NAME varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ISGROUPOKP integer,
    NOMERROD integer,
    PR_ADDED_REC integer,
    PR_VSEGO double precision,
    VIDRAB integer,
    UTV integer,
    CLCMODE integer,
    TYPE_TRUD integer,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    CORRECTNODE blob sub_type 0 segment size 80,
    CORRECTNODE_1 blob sub_type 0 segment size 80,
    SOSTAV_RABOT blob sub_type 1 segment size 80,
    ID_S_RES integer,
    NORM_GUID varchar(100),
    IDFORMULS integer,
    PR_NUMBER1 integer,
    PR_NUMBER2 integer,
    PR_NUMBER3 integer,
    IDHIER integer,
    SLAVEPARENT integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    BN double precision,
    BO double precision,
    B_ITOGO double precision,
    B_PR double precision,
    VIEW_NUMBER1 integer,
    VIEW_NUMBER2 integer,
    VIEW_NUMBER3 integer,
    K_ITOGO varchar(50),
    K_PR varchar(50),
    KOD_KKS blob sub_type 1 segment size 80)
AS
declare variable VN_NAME_ID integer;
declare variable PR_VIPOLNENO double precision;
declare variable PR_EXISTS_CHILDS integer;
declare variable ID_OBJ integer;
begin
--[15352]+

  --    
  select S.ID, S.SMETATYPE, S.ATYPE, S.NAME_ID, S.TAB, S.KOLL, S.NORMARASH,
         S.SKOLL, E.NAME, E.FULLNAME, E.RELATION,
         S.NUMBER1, S.NUMBER2, S.NUMBER3, S.RABMAT,
         S.VRPZ, S.ALTTAB, S.NACH, S.OKONCH, S.TIPRAB, S.IDNORMATIV,
         GR.NAME, PGR.NAME, S.ISGROUPOKP, S.NOMERROD,
         S.PR_ADDED_REC,  S.VIDRAB, S.UTV, S.CLCMODE, S.TYPE_TRUD,
         S.KA, S.KB, S.KC, S.KD, S.KE, S.KF, S.KG, S.KH, S.KI, S.KJ, S.KK, 
         S.KL, S.KM, S.CORRECTNODE, S.CORRECTNODE_1, S.ID_S_RES, S.NORM_GUID,
         S.IDFORMULS, S.IDHIER,
         S.SLAVEPARENT, --CQ[6814]
         S.BA, S.BB, S.BC, S.BD, S.BE, S.BF, S.BG, S.BH, S.BI, S.BJ, S.BN, S.BO, S.B_ITOGO, -- <-- Voyager CQ[13244]
         S.B_PR, --[15352]
         s.K_ITOGO/*14460*/, s.K_PR/*15421*/
  from A_SMETA S
  left join B_EDIZM E on E.ID = S.ID_EDIZM
  left join B_GROUP GR on GR.ID = S.KODIR_GROUP
  left join B_PODGROUP PGR on PGR.ID = S.KODIR_PODGROUP
  where (S.id = :ID_SM_REC)
  into :ID, :SMETATYPE, :ATYPE, :VN_NAME_ID, :TAB, :KOLL, :NORMARASH,
       :SKOLL, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION,
       :NUMBER1, :NUMBER2, :NUMBER3, :RABMAT,
       :VRPZ, :ALTTAB, :NACH, :OKONCH, :TIPRAB, :IDNORMATIV,
       :KODIR_GROUP_NAME, :KODIR_PODGROUP_NAME, :ISGROUPOKP, :NOMERROD,
       :PR_ADDED_REC,  :VIDRAB, :UTV, :CLCMODE, :TYPE_TRUD,
       :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, 
       :KL, :KM, :CORRECTNODE, :CORRECTNODE_1, :ID_S_RES, :NORM_GUID,
       :IDFORMULS, :IDHIER,
       :SLAVEPARENT, --CQ[6814]
       :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI, :BJ, :BN, :BO, :B_ITOGO, -- <-- Voyager CQ[13244]
       :B_PR, --[15352]
       :K_ITOGO/*14460*/, :K_PR/*15421*/
       ;

  --TFS[344],TFS[242]
  select FIELD_VALUE from A_SMETA_BLOB
    where ID = :ID_SM_REC and FIELD_NAME = 'COD_RTM'
    into :KOD_KKS;
       
  -- MK CQ[12020, 14357] --->
  --  
  select coalesce(v.number1, -1), coalesce(v.number2, -1), coalesce(v.number3, -1)
  from a_smeta_view_num v
  where (v.id = :ID_SM_REC)
  into :VIEW_NUMBER1, :VIEW_NUMBER2, :VIEW_NUMBER3;
  -- MK CQ[12020, 14357] <---

  -- 
  select NAME from B_GETNAME(:ID_USER, :VN_NAME_ID) into :NAME;     

  --  
  if ((:IDNORMATIV <> 0) and (:RABMAT = 0)) then
  begin
    select st.contents
    from b_rabmat r
    left join b_sost st
    on r.IDSostav = st.ID
    where (r.ID = :IDNORMATIV)
    into :SOSTAV_RABOT;
  end

  --    
  if (:SMETATYPE <> 15) then
  begin
    execute procedure S_O_HIER_PARENT_OFTYPE (:IDHIER, 1)
    returning_values :ID_OBJ;

    execute procedure l_pr_select_rec (:ID_SM_REC, :ID_USER, :ID_OBJ, 0, 0, 1 , 1)
    returning_values (:PR_NUMBER1, :PR_NUMBER2, :PR_NUMBER3, PR_VSEGO, PR_VIPOLNENO, :PR_EXISTS_CHILDS );

    --select first 1 PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_VSEGO
    --from l_s_pr_addinfo where ID = :ID_SM_REC
    --into PR_NUMBER1, PR_NUMBER2, PR_NUMBER3, PR_VSEGO;
  end


  suspend;
end
^

--TFS[344],TFS[242]
create or alter procedure PASTE_SMETA_RECORD (
    IDUSER integer,
    IDHIER integer,
    SMETATYPE integer,
    INSERT_TO_ID integer,
    INSERT_TO_ATYPE integer,
    NUMBER1 integer,
    NUMBER2 integer,
    NUMBER3 integer,
    ATYPE integer,
    TAB varchar(42),
    ALTTAB varchar(250),
    RABMAT integer,
    NAME blob sub_type 0 segment size 80,
    EDIZM_NAME varchar(100),
    EDIZM_FULLNAME varchar(250),
    EDIZM_RELATION double precision,
    TYPE_TRUD integer,
    TIPRAB integer,
    VIDRAB integer,
    IDNORMATIVUNIQ integer,
    NORM_GUID varchar(100),
    KODIR_GROUP_NAME varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ISGROUPOKP integer,
    KOLL double precision,
    SKOLL varchar(255),
    NORMARASH double precision,
    PUNKTIND varchar(42),
    SLAVEPARENT integer,
    ID_S_RES integer,
    IDFORMULS integer,
    VRPZ integer,
    BA double precision,
    BB double precision,
    BC double precision,
    BD double precision,
    BE double precision,
    BF double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BN double precision,
    BO double precision,
    B_ITOGO double precision,
    S_BA double precision,
    S_BB double precision,
    S_BC double precision,
    S_BD double precision,
    S_BE double precision,
    PA double precision,
    PB double precision,
    PC double precision,
    PD double precision,
    KA varchar(50),
    KB varchar(50),
    KC varchar(50),
    KD varchar(50),
    KE varchar(50),
    KF varchar(50),
    KG varchar(50),
    KH varchar(50),
    KI varchar(50),
    KJ varchar(50),
    KK varchar(50),
    KL varchar(50),
    KM varchar(50),
    MA double precision,
    MB double precision,
    MC double precision,
    MD double precision,
    ME double precision,
    MF double precision,
    MG double precision,
    MH double precision,
    MI double precision,
    CORRECTNODE blob sub_type 0 segment size 80,
    CORRECTNODE_1 blob sub_type 0 segment size 80,
    CLCMODE integer,
    SM_CLCMODE integer,
    PRICE_GUID varchar(100),
    PRICE_NORMOTAB varchar(42),
    PRICE_NORMOGUID varchar(100),
    ROW integer,
    COST double precision,
    KOEF double precision,
    SOURCE_IDHIER integer,
    VSEGO double precision,
    COPY_RES_UCH_STATUS integer,
    APPLAY_FORMULS_AS_IS integer,
    IDNORMATIV integer,
    K_ITOGO varchar(50),
    B_PR double precision,
    K_PR varchar(50),
    COD_RTM blob sub_type 1 segment size 80)
returns (
    ID integer,
    OUT_SMETATYPE integer,
    OUT_IDFORMULS integer)
AS
declare variable NEW_ID integer;
declare variable DEST_PARAM_KODIR_GROUP integer;
declare variable DEST_PARAM_KODIR_PODGROUP integer;
declare variable COPY_RES_ID integer;
--[13898]declare variable TARGET_LS_IDHIER integer;
declare variable ISCLC integer;
declare variable DOB_UCH integer;
declare variable DOB_NEUCH integer;
declare variable RES_RECALL integer;
declare variable P_PUT_ID_RAB integer;
declare variable P_PUT_ID_MASH integer;
declare variable P_PUT_ID_MAT integer;
declare variable H_NUMBER integer;
declare variable H_ATYPE integer;
declare variable MODE_KOMPNS_ST integer;
declare variable S_CLCMODE integer;
declare variable RES_DOB_V_CENU integer;
declare variable DEST_RES_ID integer;
declare variable APPLY_INDEX_AS_IS integer;
declare variable IDTIPR integer;
declare variable KODZAK integer;
declare variable KODGP integer;
declare variable KODSP integer;
declare variable KODISP integer;
declare variable ASUBTYPE integer;
declare variable SSTCH integer;

declare variable NAME_ID integer;
declare variable ID_EDIZM integer;
declare variable KODIR_GROUP integer;
declare variable KODIR_PODGROUP integer;
declare variable IDOBJECT integer;

declare variable ID_PRICE integer;
declare variable PRICE_NORMOID integer;
declare variable EDIZM_TYPE integer;

--[13898]declare variable SOURCE_LS_IDHIER integer;
begin
--[15352]+

  COPY_RES_ID = null;

  KODZAK = 0;--  (=0)
  KODGP = 0;--  (=0)
  KODSP = 0;--  (=0)
  KODISP = 0;--  (=0)
  ASUBTYPE = null;--  (=null)
  SSTCH = 0;--  (=0)
  IDTIPR = null;--     
  EDIZM_TYPE = 1;--   

  -- CQ[13026] IDNORMATIV = 0;

  if (not(ATYPE in (17, 18, 19))) then
    exit;

  -- MK CQ[13964]          
  if (ATYPE <> 17) then
    SKOLL = null;

  execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1)
  returning_values :IDOBJECT;

  DEST_PARAM_KODIR_GROUP = 1;
  DEST_PARAM_KODIR_PODGROUP = 1;

  --      ------------------------
  select first 1 IDNAME
  from B_WRITE_NAIMENOVANIE(:IDUSER, -1, 0, :NAME)
  into :NAME_ID;

  -- 
  execute procedure V_FIND_KODIRS_ID_FOR_IMP(:IDOBJECT, :SMETATYPE, :KODIR_GROUP_NAME,
    :KODIR_PODGROUP_NAME)
  returning_values (:KODIR_GROUP, :KODIR_PODGROUP);

  if (ATYPE <> 19 ) then
  begin
    --  ID_EDIZM ----------------------------------------------------------
    execute procedure IMP_EDIZM(:IDUSER, :EDIZM_NAME, :EDIZM_FULLNAME, :EDIZM_RELATION)
    returning_values (:ID_EDIZM);
  
      -- <-- Voyager CQ[12939]
      IDNORMATIV = coalesce(IDNORMATIV,0);
      execute procedure L_GET_NORMATIV_FROM_GUID ( :NORM_GUID, :TAB, :IDNORMATIV,
        :KODIR_PODGROUP, :RABMAT, :IDUSER )
      returning_values ( :IDNORMATIV, :KODIR_PODGROUP, :RABMAT );
    
      --   IDNORMATIV ------------------------------------------------
      --      /    
      /*
      execute procedure m_find_normativ(:IDHIER, :SMETATYPE, :KODIR_PODGROUP,
                                        :RABMAT, :IDUSER, :TAB)
      returning_values (:IDNORMATIV);
      */
      -- <-- Voyager CQ[12939]
  end

  --    () 
  execute procedure A_GET_ID_OBJ_AKT(:IDHIER, :SMETATYPE)
  returning_values :H_NUMBER, :H_ATYPE;

  if (:H_ATYPE = 1) then
    select F.KODIR_GROUP, F.KODIR_PODGROUP, F.ISCLC, F.MODE_KOMPNS_ST, F.PUT_ID_RAB, F.PUT_ID_MASH,
           F.PUT_ID_MAT
    from A_O_OBJECTPARAMS F
    where F.NUMBER = :H_NUMBER
    into :DEST_PARAM_KODIR_GROUP, :DEST_PARAM_KODIR_PODGROUP, :ISCLC, :MODE_KOMPNS_ST,
         :P_PUT_ID_RAB, :P_PUT_ID_MASH, :P_PUT_ID_MAT;
  else
  if (:H_ATYPE = 8) then
    select P.KODIR_GROUP, P.KODIR_PODGROUP, P.ISCLC, P.MODE_KOMPNS_ST, P.PUT_ID_RAB, P.PUT_ID_MASH,
           P.PUT_ID_MAT
    from A_O_FACTPARAMS P
    where P.NUMBER = :H_NUMBER
    into :DEST_PARAM_KODIR_GROUP, :DEST_PARAM_KODIR_PODGROUP, :ISCLC, :MODE_KOMPNS_ST,
         :P_PUT_ID_RAB, :P_PUT_ID_MASH, :P_PUT_ID_MAT;

  APPLY_INDEX_AS_IS = 1;

  --[13898]
  --execute procedure S_O_HIER_PARENT_OFTYPE(:SOURCE_IDHIER, 3)
  --returning_values :SOURCE_LS_IDHIER;
  --
  --execute procedure S_O_HIER_PARENT_OFTYPE(IDHIER, 3)
  --returning_values :TARGET_LS_IDHIER;
  --
  --if ((SOURCE_LS_IDHIER <> TARGET_LS_IDHIER) and (ATYPE <> 19)) then
  --begin
  --  /*   ,          . */
  --  if (:SKOLL like '%{%') then
  --    SKOLL = null;
  --end

  ID = null;

  NEW_ID = gen_id(A_G_SMETA, 1);

  if (ATYPE = 17) then
  begin
    --     
    if ((PRICE_GUID is not null) and
        (PRICE_GUID <> '')) then
    begin
      ID_PRICE = null;
      select first 1 PRICE_ID
      from PM_PRICE_GUID
      where PRICE_GUID = :PRICE_GUID
      into :ID_PRICE;

      if (PRICE_NORMOGUID is not null) then
      begin
        if (PRICE_NORMOGUID = '-1') then
        begin
          PRICE_NORMOID = -1;
        end
        else
        begin
          execute procedure L_GET_NORMATIV_FROM_GUID(:PRICE_NORMOGUID, :PRICE_NORMOTAB, :IDNORMATIV,
            :KODIR_PODGROUP, :RABMAT, :IDUSER)
          returning_values (:PRICE_NORMOID, :KODIR_PODGROUP, :RABMAT);
        end
      end
      if (PRICE_NORMOID = 0) then
        PRICE_NORMOID = null;
      if ((ID_PRICE is not null) or (PRICE_NORMOID is not null) or (ROW is not null)) then
        execute procedure SET_SMETA_PRICEPOSINFO_NL(:NEW_ID, 0, :ID_PRICE, :PRICE_NORMOID, :ROW, :COST,
          :KOEF);
    end
  end

  COPY_RES_ID = :ID_S_RES;

  --   
  /*
    begin
      --<rvs:00004103>
      if (bin_and(:SM_CLCMODE, 3) <> 2) then
      begin
        --      -   
        --   
        --   CLCMODE
        SM_CLCMODE = bin_and(:SM_CLCMODE, bin_xor(3, -1));

        if (:INSERT_TO_ATYPE = 17) then
          CLCMODE = :SM_CLCMODE;
      end

      --  STATUS_DOB_V_CENU  
      execute procedure A_S_RES_GET_DEF_ST_DOB_V_CENU3(:ISCLC, :SM_CLCMODE, :S_BA, :S_BB, :S_BC,
        :S_BD, :S_BE)
      returning_values :DOB_UCH, :DOB_NEUCH, :RES_RECALL;

      if (:COPY_RES_ID <> 0) then
      begin
        select
               case
                 when R.UCH <> 0 then :DOB_UCH
                 else :DOB_NEUCH
               end
        from A_S_RES R
        where R.ID = :COPY_RES_ID
        into :RES_DOB_V_CENU;

      end
    end*/
  --  Number.       
  execute procedure M_GET_NEW_NUMBER1(:IDHIER, :SMETATYPE, :ATYPE, :NUMBER1, :IDUSER)
  returning_values (:NUMBER1);

  if (COPY_RES_UCH_STATUS is null) then
    COPY_RES_UCH_STATUS = 1;

  for select OUT_ID, OUT_SMETATYPE, OUT_IDFORMULS
    from A_S_APPENDREC_NL(:IDUSER, :NEW_ID, :IDHIER, :SMETATYPE, :NUMBER1, :NUMBER2, :NUMBER3,
    :SLAVEPARENT, :ATYPE, :RABMAT, :TYPE_TRUD, :TAB, :ALTTAB, :NAME_ID, :ID_EDIZM, :EDIZM_TYPE,
    :KOLL, :SKOLL, :NORMARASH, :BA, :BB, :BC, :BD, :BE, :BF, :BG, :BH, :BI,
    0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
    --EA  EB   EC   ED   EE   EF   EG   EH   EI   EJ   EK
    0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
    --RA  RB   RC   RD   RE   RF   RG   RH   RI   RJ   RK   RL   RM
    :IDTIPR, :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :SSTCH, :KODZAK,
    :KODGP, :KODSP, :KODISP, null, null, :IDNORMATIV, :IDNORMATIVUNIQ, :KODIR_GROUP,
    :KODIR_PODGROUP, :ISGROUPOKP, :INSERT_TO_ATYPE, :INSERT_TO_ID, :ID_S_RES, :VRPZ,
    :PA, :PB, :PC, :PD, :TIPRAB, :PUNKTIND, :NORM_GUID, :VIDRAB, :APPLY_INDEX_AS_IS,
    :APPLAY_FORMULS_AS_IS , 1 /*APPLAY_POPR_AS_IS*/ , :MA, :MB, :MC, :MD, :ME, :MF, :MG, :MH, :MI,

    case
      when (:COPY_RES_UCH_STATUS = 1) then :COPY_RES_ID
      else null
    end,

    0, :CORRECTNODE, :CORRECTNODE_1, :ASUBTYPE, :CLCMODE, :RES_DOB_V_CENU, 0, :IDFORMULS, --CQ[9359]
    :BN, :BO, :B_ITOGO/*CQ[13179]*/, :K_ITOGO/*14460*/,
    :B_PR /*[15352]*/, :K_PR /*15421*/
    )
    into :ID, :OUT_SMETATYPE, :OUT_IDFORMULS
  do
  begin
    if ((ATYPE = 17) and
        (RABMAT = 0)) then
    begin
      --execute procedure UPDATE_SMETA_UNION_INFO(:IDNORMATIV, :IDRECORD, :ID);
      execute procedure UPDATE_SMETA_UNION_INFO(:IDNORMATIV, null, :ID);--    
    end
    suspend;
  end

  if ((ATYPE <> 19) and (not VSEGO is null)) then
  begin
    update L_S_PR_ADDINFO set
      PR_VSEGO = :VSEGO
    where ID = :NEW_ID;
    if (SMETATYPE = 15) then
      update A_SMETA set
        KOLL = :VSEGO
      where ID = :NEW_ID;
  end

  --TFS[344],TFS[242]
  if (char_length(:COD_RTM) > 0) then
    insert into A_SMETA_BLOB (ID, FIELD_NAME, FIELD_VALUE)
    values(:NEW_ID, 'COD_RTM', :COD_RTM);

  --     
  /*
    if (:RES_RECALL <> 0 and
        :COPY_RES_ID <> 0) then
    begin
      select ID_S_RES
      from A_SMETA
      where ID = :NEW_ID
      into :DEST_RES_ID;

      execute procedure A_S_RES_RECALL_ONE_RES(:IDUSER, :H_NUMBER, :DEST_RES_ID, :SMETATYPE, :VRPZ,
        :DEST_PARAM_KODIR_PODGROUP, :P_PUT_ID_RAB, :P_PUT_ID_MASH, :P_PUT_ID_MAT, 0, 1);
    end */
end
^

--TFS[441]
create or alter procedure B_WRITE_ONE_NORM_BASE (
    IDUSER integer,
    BASE_CODE integer,
    BASE_SUB_TYPE integer,
    BASE_FULL_NAME varchar(250))
returns (
    ID integer)
AS
begin
  if (not exists(
        select * from B_NORM_BASE_LIST
          where BASE_CODE = :BASE_CODE and
                BASE_SUB_TYPE = :BASE_SUB_TYPE))
  then
  begin
    ID = next value for A_G_SMETA;  --TFS[434],TFS[443] gen_id(B_GEN_TEMP, 1) ;
 
    insert into B_NORM_BASE_LIST (ID, BASE_CODE, BASE_SUB_TYPE, BASE_FULL_NAME)
    values (:ID, :BASE_CODE, :BASE_SUB_TYPE, :BASE_FULL_NAME);
  end
  else
  begin
    update B_NORM_BASE_LIST
      set BASE_FULL_NAME = :BASE_FULL_NAME
    where (BASE_CODE = :BASE_CODE) and
          (BASE_SUB_TYPE = :BASE_SUB_TYPE);
  end
end
^



--------------------------------------------------------------------
--                           10.0.1.1, 10.0.0.16
--------------------------------------------------------------------



--TFS[440]
create or alter procedure T_GET_PUTI (
    ID_REESTR_RAB integer,
    BASE_CODE integer,
    BASE_SUB_TYPE integer )
returns (
    ID_PUT_U integer,
    ID_PUT_0 integer,
    ID_PUT_2 integer,
    ID_PUT_3 integer)
AS
declare variable ID_NORM_BASE integer;
declare variable INSTALL_GUID varchar(100);

declare variable ISSBORNIK integer;
declare variable IDFOLDER integer;
begin

  --    ,   ,    ID_REESTR_RAB

  --ID_REESTR_RAB -   
  ID_PUT_U = null; --
  ID_PUT_0 = null; --
  ID_PUT_2 = null; --
  ID_PUT_3 = null; --

  if ( (BASE_CODE is not null) and (BASE_SUB_TYPE is not null) ) then
  begin
    select ID
      from B_NORM_BASE_LIST
      where (BASE_CODE = :BASE_CODE) and (BASE_SUB_TYPE = :BASE_SUB_TYPE)
    into :ID_NORM_BASE;
  
    if (ID_NORM_BASE is not null) then
    begin
      for select INSTALL_GUID
        from B_NORM_BASE_INSTALL
        where (ID_NORM_BASE = :ID_NORM_BASE)
      into :INSTALL_GUID
      do
      begin
        for select IDPUT
          from B_PUTI_INSTALL
          where INSTALL_GUID = :INSTALL_GUID
        into :ID_PUT_0
        do
        begin
          --      ...
          if (ID_PUT_0 is not null) then
          begin
            ID_PUT_U = null; ID_PUT_2 = null; ID_PUT_3 = null;
            select first 1 ID, IDPUT2, IDPUT3
              from B_PUTNAME
            where IDPUT0 = :ID_PUT_0
            into :ID_PUT_U, :ID_PUT_2, :ID_PUT_3;
        
            --   ,  
            if (ID_PUT_U is not null) then
              exit;
          end
        end
      end
    end
  end

  --   (  )
  if ( (ID_PUT_U is null) and (ID_REESTR_RAB is not null) ) then
  begin
    select SBORNIK, IDPARENT
      from B_REESTR where ID = :ID_REESTR_RAB
    into :ISSBORNIK, :IDFOLDER;
  
    if (ISSBORNIK = 1) then ID_REESTR_RAB = :IDFOLDER;
  
    select first 1 n.ID
      from B_PUTVIEW v
      left join B_PUTNAME n on n.ID = v.IDPUTNAME
    where v.IDREESTR = :ID_REESTR_RAB
    into :ID_PUT_0;
  
    --      ...
    if (ID_PUT_0 is not null) then
    begin
      select first 1 ID, IDPUT2, IDPUT3
        from B_PUTNAME
      where IDPUT0 = :ID_PUT_0
      into :ID_PUT_U, :ID_PUT_2, :ID_PUT_3;
    end
  end

end^


-- TFS[472]
create or alter procedure IMP_NORM_BASE_INSTALL (
    BASE_CODE integer,
    BASE_SUB_TYPE integer,
    INSTALL_GUID varchar(100),
    BASE_FULL_NAME varchar(250))
AS
declare variable VN_ID_NORM_BASE integer;
declare variable VN_ID integer;
begin
  --    ( )
  VN_ID_NORM_BASE = null;
  select first 1 bl.id
  from B_NORM_BASE_LIST bl
  where (bl.base_code = :BASE_CODE) and (bl.base_sub_type = :BASE_SUB_TYPE)
  into :VN_ID_NORM_BASE;

  --   ,   
  if (VN_ID_NORM_BASE is null) then
  begin
    VN_ID_NORM_BASE = gen_id(a_g_smeta, 1);
    insert into B_NORM_BASE_LIST (ID, BASE_CODE, BASE_SUB_TYPE, BASE_FULL_NAME)
    values (:VN_ID_NORM_BASE, :BASE_CODE, :BASE_SUB_TYPE, :BASE_FULL_NAME);
  end

  --        
  VN_ID = null;
  select first 1 bi.id
  from B_NORM_BASE_INSTALL bi
  where (bi.install_guid = :INSTALL_GUID)
  into :VN_ID;

  --   - 
  if (VN_ID is null) then
  begin
    VN_ID = gen_id(a_g_smeta, 1);
    insert into B_NORM_BASE_INSTALL (ID, ID_NORM_BASE, INSTALL_GUID)
    values (:VN_ID, :VN_ID_NORM_BASE, :INSTALL_GUID);
  end

  --  - 
  else
  begin
    update B_NORM_BASE_INSTALL
    set ID_NORM_BASE = :VN_ID_NORM_BASE
    where (ID = :VN_ID);
  end
end
^

-- TFS[444]
create or alter procedure M_FIND_LINK_INSTALL_TO_SNB (
    ID_REESTR_INSTALL integer,
    NORM_GUID varchar(100))
returns (
    ID_NORM_BASE integer)
AS
declare variable VN_ID_BASE integer;
declare variable VN_ID_REESTR_FOLDER integer;
declare variable VN_ID_REESTR_SB integer;
declare variable VN_POKAZ varchar(8);
declare variable VN_INDTYPE varchar(50);
begin
  VN_ID_BASE = null;
  ID_NORM_BASE = null;

  --    
  if ((ID_REESTR_INSTALL is null) and (NORM_GUID is null)) then
  begin
    suspend;
    exit;
  end
  if (ID_REESTR_INSTALL is null) then
  begin
    select first 1 i.id
    from B_REESTR_INSTALL i
    where (i.norm_guid = :NORM_GUID)
    into :ID_REESTR_INSTALL;
  end
  if (NORM_GUID is null) then
  begin
    select first 1 i.norm_guid
    from B_REESTR_INSTALL i
    where (i.id = :ID_REESTR_INSTALL)
    into :NORM_GUID;
  end


  --        
  for select r.id
  from b_reestr r
  where (r.install_guid = :NORM_GUID)
  into :VN_ID_REESTR_FOLDER do
  begin
    if (VN_ID_BASE is null) then
    begin
      --     
      for select r1.id, coalesce(r1.pokaz, ''), coalesce(r1.indtype, '')
      from b_reestr r1
      where (r1.idparent = :VN_ID_REESTR_FOLDER) and (r1.sbornik = 1)
      into :VN_ID_REESTR_SB, :VN_POKAZ, :VN_INDTYPE do
      begin
        if ((VN_ID_BASE is null) and (VN_POKAZ <> '') and (VN_INDTYPE <> '')) then
        begin
          VN_ID_BASE = DM_GETBASEID(VN_ID_REESTR_SB, VN_POKAZ, VN_INDTYPE);
          if (VN_ID_BASE < 0) then
            VN_ID_BASE = null;
        end
      end
    end
  end

  --   
  if (VN_ID_BASE is not null) then
  begin
    --       .
    --         
    select first 1 b.id
    from B_NORM_BASE_LIST b
    where (b.base_code = :VN_ID_BASE) and (b.base_sub_type = 0)
    into :ID_NORM_BASE;

    --     -    
    if (ID_NORM_BASE is null) then
    begin
      ID_NORM_BASE = gen_id(a_g_smeta, 1);

      insert into B_NORM_BASE_LIST (ID, BASE_CODE, BASE_SUB_TYPE, BASE_FULL_NAME)
      values (:ID_NORM_BASE, :VN_ID_BASE, 0, null);
    end
  end


  suspend;
end
^

-- TFS[444]
create or alter procedure M_SET_LINKS_INSTALL_TO_SNB
as
declare variable VN_REESTR_INSTALL_ID integer;
declare variable VN_NORM_GUID varchar(100);
declare variable VN_ID_NORM_BASE integer;
begin
  --     
  for select i.id, i.norm_guid
  from B_REESTR_INSTALL i
  into :VN_REESTR_INSTALL_ID, :VN_NORM_GUID do
  begin
    --        
    if (not exists(select *
                   from B_NORM_BASE_INSTALL
                   where (INSTALL_GUID = :VN_NORM_GUID))) then
    begin
      --    
      execute procedure M_FIND_LINK_INSTALL_TO_SNB(:VN_REESTR_INSTALL_ID, :VN_NORM_GUID)
      returning_values :VN_ID_NORM_BASE;

      --      -   
      -- ,   
      if (VN_ID_NORM_BASE is null) then
      begin
        insert into B_NORM_BASE_INSTALL (ID, ID_NORM_BASE, INSTALL_GUID)
        values (gen_id(a_g_smeta, 1), -1, :VN_NORM_GUID);
      end

      --    -  
      else
      begin
        insert into B_NORM_BASE_INSTALL (ID, ID_NORM_BASE, INSTALL_GUID)
        values (gen_id(a_g_smeta, 1), :VN_ID_NORM_BASE, :VN_NORM_GUID);
      end
    end
  end
end
^


--------------------------------------------------------------------
--                           10.1.0.0, 10.0.1.2, 10.0.0.17
--------------------------------------------------------------------

/* 
create or alter procedure B_IMP_I_PODGROUP(
*/

create or alter procedure B_READ_OGL_NODE_CHILDS (
    IDUSER integer,
    ID_NODE integer,
    IDREESTR integer)
returns (
    ID integer)
AS
BEGIN

 FOR SELECT ID
 FROM B_OGL
 WHERE (IDREESTR = :IDREESTR) AND (IDPARENT = :ID_NODE)
 order by IDREESTR, IDPARENT, ORDERVIEW --<<2017/10/23
 --order by orderview --<<rvs:2007/09/11
 INTO :ID
 DO BEGIN
     SUSPEND ;

     FOR SELECT ID
     FROM B_READ_OGL_NODE_CHILDS(:IDUSER, :ID, :IDREESTR)
     INTO :ID
     DO
        SUSPEND ;
 END
END
^

-- TFS[499]
create or alter procedure M_GET_NORM_BASE_LIST
returns (
    ID integer,
    BASE_CODE integer,
    BASE_SUB_TYPE integer,
    BASE_FULL_NAME varchar(250),
    INSTALLED integer)
AS
declare variable VN_INSTALL_GUID varchar(100);
begin
  for select ID, BASE_CODE, BASE_SUB_TYPE, BASE_FULL_NAME
  from B_NORM_BASE_LIST b
  where (ID > 0)
  order by BASE_CODE, BASE_SUB_TYPE
  into :ID, :BASE_CODE, :BASE_SUB_TYPE, :BASE_FULL_NAME do
  begin
    --    
    INSTALLED = 0;
    for select i.install_guid
    from B_NORM_BASE_INSTALL i
    where (i.ID_NORM_BASE = :ID)
    into :VN_INSTALL_GUID do
    begin
      if (INSTALLED = 0) then
      begin
        if ((VN_INSTALL_GUID is not null) and (VN_INSTALL_GUID <> '')) then
        begin
          if (exists(select * from b_reestr_install r where (r.norm_guid = :VN_INSTALL_GUID))) then
            INSTALLED = 1;
        end
      end
    end

    suspend;
  end
end
^


create or alter procedure M_TEMP_FILL_LINKS
as
declare variable VN_ID integer;
begin
  if (not exists(select ID_SELF
                 from M_GLOBAL_PARAMS
                 where PARAM_NAME = 'FILL_NORM_LINK_TFS444')) then
  begin

    --  
    execute procedure B_WRITE_ONE_NORM_BASE(null, -1, 0, '        ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 0, 0, '1984 (1991)') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 1, 0, ' 81-98') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 3, 0, '        2001 ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 3, 1, ' 2001') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 3, 2, ' 2001') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 4, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 5, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 6, 0, '-,  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 7, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 8, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 9, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 10, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 11, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 12, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 13, 0, '-2001.      (   "", 2006)') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 14, 0, ' ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 15, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 16, 0, '   ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 17, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 18, 0, ' ()  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 19, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 20, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 21, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 22, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 23, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 24, 0, '-  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 25, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 26, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 27, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 28, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 29, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 30, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 31, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 32, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 33, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 34, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 35, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 36, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 38, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 39, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 40, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 42, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 43, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 44, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 45, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 46, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 47, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 49, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 50, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 51, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 52, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 53, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 55, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 56, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 57, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 58, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 59, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 61, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 62, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 63, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 64, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 65, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 67, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 68, 0, '   ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 69, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 70, 0, '-   ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 71, 0, '-   ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 72, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 73, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 74, 0, ' ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 75, 0, '   ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 76, 0, '  ()  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 77, 0, ' . . - ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 78, 0, ' . .  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 79, 0, ' . , . -  -2001') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 82, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 83, 0, '.      ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 84, 0, ' . (-27,71, -27,71)') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 86, 0, ' .   ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 88, 0, ' .   ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 89, 0, '') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 91, 0, ' .  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 93, 0, '-,  1.1') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 94, 0, ' .    3') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 98, 0, '  ( 2001 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 99, 0, '-2001') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 101, 0, '   ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 103, 0, ' .    2') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 108, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 110, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 111, 0, '   ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 112, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 113, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 114, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 115, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 116, 0, '-  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 117, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 118, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 119, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 120, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 121, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 122, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 123, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 124, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 125, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 126, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 127, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 128, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 129, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 130, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 131, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 132, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 133, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 134, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 135, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 136, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 137, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 139, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 140, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 141, 0, '  ( 2009)') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 142, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 143, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 144, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 145, 0, '-   ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 146, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 147, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 149, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 151, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 152, 0, ' .    1') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 153, 0, ' .    2') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 154, 0, ' .    3') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 155, 0, ' .    4') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 157, 0, ' .    4') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 158, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 159, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 160, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 161, 0, '.  2012 ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 162, 0, '-2001. ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 163, 0, '-2001  13, ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 164, 0, '-2001  14  20, ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 165, 0, '-2001  14  21, ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 166, 0, '-   ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 167, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 168, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 169, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 170, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 171, 0, '   ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 172, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 173, 0, ' (-2001, -2001 ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 173, 1, '-2001 ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 173, 2, '-2001 ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 174, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 175, 0, '  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 176, 0, '   (-2001)') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 177, 0, '  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 178, 0, '-2001  13,   2') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 179, 0, '  ( 2009 ),   2') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 180, 0, '-2001.13-2') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 181, 0, '-2000.    ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 182, 0, '-2001 ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 182, 1, '-2001 ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 182, 2, '-2001 ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 183, 0, '  -2001 (-2001, -2001)') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 184, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 185, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 186, 0, '  ( 2009 ) ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 187, 0, ' .    3') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 188, 0, '  ( 2011 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 189, 0, ' ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 190, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 191, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 192, 0, '-2001.13-2  1') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 193, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 194, 0, ' ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 195, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 196, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 197, 0, '   ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 198, 0, ' (   )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 199, 0, '-2001.13-2  2') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 200, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 201, 0, '  ( 2010)') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 202, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 203, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 204, 0, '-2012.   ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 205, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 206, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 207, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 208, 0, '-2001.  29 -  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 209, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 210, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 211, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 212, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 213, 0, '.   ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 214, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 215, 0, ' .   ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 216, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 217, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 218, 0, '.   :  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 219, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 220, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 221, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 222, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 223, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 224, 0, '-2001.13-2  3') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 225, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 226, 0, ' - ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 227, 0, '  ( 2010 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 228, 0, ' .    5') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 229, 0, '-2001.13-2  4') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 230, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 231, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 232, 0, '   ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 233, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 234, 0, '-2001.13-2  5') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 235, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 236, 0, ' .  ( )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 237, 0, ' . -2001  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 238, 0, '.  2012 ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 239, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 240, 0, '-  ( 2011 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 241, 0, ' .  -2015  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 242, 0, '-2001.13-2  6') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 243, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 244, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 245, 0, '-2012 - 2016    ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 246, 0, '  ( 2009 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 247, 0, ' . ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 248, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 249, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 250, 0, '   ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 251, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 252, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 253, 0, '-2001.13-2  7') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 254, 0, ' .   2016 ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 255, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 256, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 257, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 258, 0, ' .  .  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 259, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 260, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 261, 0, '-2001.13-2  8') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 262, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 263, 0, '-2001 ()') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 264, 0, '-2001.13-2  9') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 265, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 266, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 267, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 268, 0, '-2012 - 2017    ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 269, 0, '-2001.13-2  10') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 270, 0, ' (, ) 2017') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 270, 1, ' 2017') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 270, 2, ' 2017') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 271, 0, ' .    6') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 272, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 273, 0, '-2001.  13-2 ()') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 274, 0, ' . .  ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 275, 0, '  ( 2014 ).   3') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 276, 0, '  ( 2014 )') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 277, 0, '-2012 - 2018    ') returning_values :VN_ID;
    execute procedure B_WRITE_ONE_NORM_BASE(null, 278, 0, '      ') returning_values :VN_ID;
  end
end
^
execute procedure M_TEMP_FILL_LINKS
^
drop procedure M_TEMP_FILL_LINKS
^^


create or alter procedure M_TEMP_FILL_LINKS
as
declare variable VN_ID integer;
begin
  if (not exists(select ID_SELF
                 from M_GLOBAL_PARAMS
                 where PARAM_NAME = 'FILL_NORM_LINK_TFS444')) then
  begin

    --    
    execute procedure IMP_NORM_BASE_INSTALL(-1, 0, '000"B {6A122ADB-A9BD-424D-AE92-D80B625A97ED} {~}', '');
    execute procedure IMP_NORM_BASE_INSTALL(-1, 0, '000"B {D158D45A-A85C-4FA0-B714-6224F2033419} {y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(-1, 0, '000"B {FB5607F3-9459-4477-B78E-324234C957AC} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(-1, 0, '000"B {829B894C-3A49-4430-9EBE-1111356456B1} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(-1, 0, '000"B {E5B19BED-D457-4EDA-8626-126DFD1CCD05} {)}', '');
    execute procedure IMP_NORM_BASE_INSTALL(-1, 0, '000"B {FCC4AE2E-5464-4E30-AD31-199CA33B5B84} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(-1, 0, '000"B {FECC1762-5772-4501-AC67-54C3CF6992BE} {Q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(-1, 0, '000"B {91FA866F-555D-4C65-ABA0-D4A5615F4422} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(-1, 0, '000"B {24F00677-955B-406E-A3EC-97C9AEF5D9B4} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {60096F1F-F666-4ECF-9EFA-80FF4A8F655A} {2}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B003BB7A-F722-43EE-94A6-E075EE5C0384} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F00433F0-E8B6-4362-A90D-676648315D05} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {210A876B-B9C8-4500-834B-CF10BC798FA9} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9102BC23-A494-4DE7-B6BC-ED7D4BB990D2} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {32018BCE-BB58-4A2D-B3D7-374D18539DFF} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {420CC70F-37F4-4081-AF12-DA820E7AB925} {9}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {620CF588-8D98-41CA-B8BB-49583C89D72D} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {73010F10-9FBA-4F1E-8268-FC76A60539EE} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {930BE660-3CE4-4FA5-BC69-0231BD5BA00F} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9702F398-C80B-4767-BEE3-BB84E0EBE202} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D807DB20-04FB-4056-8540-B2B624A98544} {m}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {090EF86D-8B5B-4DF7-96AA-32F2DC67B89A} {+}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1903B2CE-47CF-4589-B167-35A110144241} {W}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {290531AF-466C-4ABE-B4CE-D332611330CD} {@}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {49097AED-1017-47C9-98D0-27A028FCD0CF} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {89065B9A-F7F6-4FB6-B4D7-AA2D04A50280} {W}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B90825C1-4E34-45C2-81BC-0FBDE0056E76} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FA01EAF4-BAA1-4EBB-8301-065855254E80} {B}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1B0D67DB-584F-4D3A-88B2-55A210D56312} {+}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9B0EBB99-B0B3-4DC3-8197-DA2C11EDBD5C} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CB0109C5-BD13-4C81-A40E-34D9277227B3} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FB01A2AB-72B9-4F64-A432-5AA4667CE486} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DC0A9D19-9BAF-40C6-9654-A0FB509975E0} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BD0AC530-6C8B-4C65-98CF-D36F6491A6A2} {i}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CD0C1B01-44A2-41B3-B82C-AAA213957CA6} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DD0C5C22-7F64-4DFC-8344-7072D0ADF30C} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8E0769B7-61FF-4169-A0DB-B6D3D0293DA4} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EF09E1EC-5DD9-4BEB-AAC6-D1514DC72FFC} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {61196D58-3CB7-40A5-B7AB-84FB0ADAE9B5} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {611B1ACD-363F-4F86-98CC-3EBD95E2624B} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {721D4F9C-21EE-4550-BA45-8E6F8546C471} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C2152E63-E605-4439-9562-AA2BC7B4E5DF} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C21FD8EB-1BB0-4E69-8246-7043DC2B3F80} {Q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {541DD25E-F821-408D-86D7-25B81BCAE9CD} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E41ED977-5863-4688-B375-C4F5AF161443} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {851E493B-0709-4A72-A899-D7756402ADC6} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5612F11E-3F6D-41A6-864F-D0F9FAABE8B0} {u}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D61BD91C-F007-40C2-9F6E-AE8FB7FD6845} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B814391D-25CD-4AF0-8192-837E8E511E7F} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D917F98C-646E-4497-B696-FE7150F88FB2} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2A122120-6945-4697-8A89-C4422DD859A6} {`}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FA1CF439-4BCF-47FB-AA46-08CC66BAD8DC} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3C114E5F-25E7-4217-9693-DD4B1D9E0A33} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4C1F2AFB-5651-4C5A-90FF-5F71A17C9600} {Q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1E12773D-AFEC-407C-8D93-48074EBF489C} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1E1D9656-B36F-4FC1-8140-060B3278182C} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5E1C9CB6-DAC2-4C78-94B5-22BB68A9ADFA} {;}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8E1D72B6-9835-4149-90BA-4E77768636C2} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5F18D024-B1F5-461B-B306-9C5316CFAA20} {3}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CF117D92-52A5-42B7-AA42-F1B095B82E1B} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {702FA18E-2DD3-4497-8F0F-60B58EC49954} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {712F8728-F1B6-477F-97EA-9A246C530C5E} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B127ECCE-D2AC-4F83-B576-13F72F712C22} {`}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0224A07C-755A-4EDC-97FF-B3CBF2AA141C} {u}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {222AA59A-7AEF-4E46-97DE-3A2FB5C564C9} {~}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {322F9F59-960F-4656-BC67-DBF9CC2A9892} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {422707B0-FE8C-4E23-8858-1828E83B9DEF} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E22F5CD8-C6D6-499F-9214-DD365B736108} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {032DB399-6A64-4BA3-A06D-B610C9D6793B} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {132B31E5-DB0A-4F0C-8FEE-AD8AEC5AED82} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E32C2DD0-5590-41F5-830A-94EEEF30A1E7} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1423DDA3-1FEA-4C92-B98A-74A065B968A1} {R}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {242D8505-3A6D-4B24-8415-84FA585022BF} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {242F155E-18B4-4126-97FD-4F1669DF4B1D} {@}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D420D690-A567-43A9-890C-0F77D4815B6D} {2}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E42DEBA2-5D1E-4B7A-A0F0-62C4EA2BC4DB} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {652C4C16-1F6A-480D-8155-21F1F2F8AEDD} {T}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {66248B67-AD0F-48ED-B414-9F38867A5938} {D}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {862750F9-7485-48D2-84DD-4D8AF690A356} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0721B0B2-DB15-4B4B-87EC-F9E9C6A925E8} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0921FAFC-9DA0-4DB0-A02F-3EDD10797728} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {492BFB7B-DC15-473A-BF73-E03A03FADA50} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8923B3CC-1063-46CB-97A5-624D34FCE71E} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BA2AC3AA-543A-492C-AB20-0DDCE8D31775} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1B2F3FC2-747B-4DC9-8A3B-FE11574F80A6} {h}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4C2C4973-D077-44D2-8306-7CF4A6DE75D0} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5C2F33AA-433F-4EC3-BC71-A09018D28119} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9D2B1FC3-15F0-4363-9DD5-AA96069AC8B1} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9E2AE480-B260-4690-8674-936BDF377175} {y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FE2ECDD4-946D-40C1-B332-98997599D9E0} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7F21CB3E-CA8A-4ED7-8461-1FB7E9C59240} {m}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9F201875-4995-4334-BEEE-CB8FA697A513} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {703B71D6-40FD-4B51-BBCD-CE6D24BAA07A} {~}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A036C117-FD34-4B7C-8624-87F845E44886} {+}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A03D3B68-A5A1-4B23-BA88-CCDC206185EE} {e}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D03BA2EF-C0C1-42E0-BC18-5DCDA748F42E} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3131F93B-EA28-458F-8FC0-C7752FD8D0D4} {a}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7134DF27-DD2F-4730-AF2C-9ECDC314C46D} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E236CE42-6FC7-4DA4-807C-1499921A8AB7} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {533DC03C-9CEF-47A6-A991-EA44DE1A6DA0} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C3300C24-361B-4394-967E-F89FFF435EFD} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {043027D1-74B8-48FF-9277-5C0A49905DBF} {2}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {543834A9-82CD-4DEF-A806-F120B7E66791} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0534638F-2B72-49F2-AC53-1BDAC0702520} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C530D742-70F4-47C8-9069-357740FA0593} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D5373D96-D140-419B-824D-7D14941BDAD5} {9}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E5379629-6EC5-4AC1-AA33-81204EEF54E0} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {473D7FAF-1E51-4509-9EFC-5BCDF6D4F98C} {@}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3A38F0DA-7423-4129-A410-DC4C307B8CD1} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8A3B80F8-C61E-47B4-93FC-B86C2FFE7BB4} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9A3D0416-DB7F-4B50-81AE-1EA3902203B1} {-}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CA3D93C8-1E82-4E78-9545-89D2739EE995} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0B3EE0CB-5D34-4ED6-8AE7-078C8BD0E0D2} {~}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5D32F493-EF95-4A70-B4B6-4FF0B1973E48} {U}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7D37E27B-3747-49AA-91EC-FDEB54424AAC} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8D32CD88-114D-4C10-9DEB-C2D487E79019} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4E32E85A-19B6-431C-AFF5-89832DC6BA18} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9E33ED2E-D18F-4207-ACC5-F3A74FC18C2A} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DE3D1FB4-D559-4F1D-A872-FBDD49716F71} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2F35B18C-D0EB-43AA-A91D-1A9B7FEFADFB} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BF32023E-2103-4987-8895-00AB33C1F87A} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EF3AAADB-6DBA-4D0C-9CBB-8C27EEBA782D} {~}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3048A548-4C90-41C5-BFDA-A59F70095AD3} {D}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {11475DA0-2DCA-403B-8429-CA0641FFE974} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5143028F-0020-43C9-9385-119C073E7454} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B1430D2B-70C5-4486-AF2E-A3D4C2D6C863} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E24EF698-97C6-4E2E-9B4D-9128B5109B21} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0444F1EE-C106-409D-BB2B-AC8858A4811C} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4449E7DB-CB37-4011-B041-94C24A3E5BCB} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {544BFB33-C30B-42E2-9CB7-40E1F1F67B67} {Q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6440200C-1D2D-4D86-B5C3-792AE041741E} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A44F703F-734F-4D17-93A4-6345DFF532D9} {D}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E44EF86D-3D0D-4392-B1CA-8B7C3C8EB023} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0545DB9F-DEB1-466C-8203-EDC648B4F8FC} {#}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {65462EA2-A280-4727-AEC6-39FF8EFF4B3C} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {95458973-4629-4575-9C50-63AB09F676AB} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {064B668F-5A5C-4370-A5FB-D07CE7005C73} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D64D6E0E-AA08-4A3B-B7F8-97696700EF02} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D641251E-BB8F-46E8-847F-E1399913F00F} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F6436164-6603-43D0-B885-147376786925} {;}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {174DD259-6D8E-4649-B94D-F2F85BEA8913} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1743F2E4-93CB-4FC4-A318-7B2CD0AE4A96} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {27409BB9-B457-4E38-976A-DE2FC3892D74} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {47456CA8-8AA1-42E4-BA89-91D274C4EF51} {N}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9744B712-5EF6-4C54-9CC8-CC71A10E7074} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {68455F40-A23D-4CFA-BE9F-17D29E2B0453} {W}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {78439F33-A486-4F50-A755-22929AEF31E9} {,}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {784C3794-1C50-4F94-824F-EC0FD449167E} {>}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C84F443E-D860-44C8-9645-ECDD6ED06B7A} {x}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {894569BE-C6D2-4048-8D1E-DD9962C6F9AE} {x}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D9427842-C3AE-4ACC-83E9-57C7359DA8D8} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4B4C67FA-6894-4E46-A0F1-14A223E53545} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6B43926C-16AE-43E4-B8A1-27027AA2C4AE} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CB469A9C-1B12-49D4-B01D-94FC2F6EA32B} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BC47EA19-76DA-4BCE-BF8C-5634FD66088C} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BC448034-4486-4F92-8E33-C47B32EF3DB9} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EC4C3CE4-2DD7-4CD2-A12A-E3C6C0A85A6F} {9}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4D4F25E6-6B5F-4F39-899A-DAF008DAF013} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2E48C78C-F582-4567-9276-89BC176C1B95} {:}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8E484C04-490B-447B-8127-59DDF6A9A3EF} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EE40B437-D22D-44DD-B575-F6E5C1D8BD01} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7F49BFF8-B579-4AFB-BEAC-7C3311DAB587} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8F4FD5C1-4F0F-4851-A085-B8C21EB8FD86} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9F482BCF-8DC1-4C8E-BB00-1E0085327421} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CF4FF497-84AC-4F98-AAC3-67B3A8223C8F} {,}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {105874B1-6859-48AB-BBB9-6E85F6D8D2E7} {_}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6059B561-BEFF-47AA-944F-7DDB218F4421} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A150B505-B9DC-4303-93B6-3B877A807F2B} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B15AD9DB-9EB6-4A7E-9D6F-5BC44E508262} {#}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4252BA63-B00D-4B5E-A892-E94FE88DD65A} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {825B0A7E-0DBA-45C5-8C3F-5974B073E206} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D25CAED9-A586-44EA-B356-C48B4353F141} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0358B0D3-F6C1-472D-9CB8-0783FB98724A} {@}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B352B36C-4D95-4EF4-9FCF-A42C77CD5A91} {#}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C355173B-09BB-4D87-8974-ADDAF504625D} {N}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F3586CA8-1A4B-4F61-BCA4-E52E66670F4B} {h}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {44544C8C-07E7-4908-9F99-BC95E1585060} {$}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D45B7B73-4782-419C-98DE-A8BCD4DCC14D} {$}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A65081C2-AB11-4594-9628-8698E530C866} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {58553BE7-B552-4FF5-AEBE-BA17DA33253E} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D85F30E1-D7B7-4867-926F-BFD9B72544F9} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B9559235-2126-4D58-82AE-143D31B7475F} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6B596A3D-39E2-48FF-8D46-A891EFF20DB2} {z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BB59E175-E2E0-4CDE-ACDC-BDEDEEC1F6E0} {$}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CC5149B6-0C7A-4A71-ACDC-D01D9B0FFCA9} {:}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6D505BAA-795F-4A64-A80A-A23523EB4674} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7D5F07AE-8891-4E41-9C77-9A30C563B45D} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5E58E2D6-BE28-44FD-9A7A-3ED9FB0E68E6} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7E51153F-0861-4F64-AD2E-210F8A9E266E} {:}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DE56E678-85FD-4529-9599-D5C570CFFBD8} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E0606277-066E-4CD0-BC6B-17D162070640} {e}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1167151B-E74A-401C-A2F6-C1F5C472488D} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A16C504F-417A-486A-91BA-07D235160DC5} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B1650958-00C4-4190-8018-699FD56B7950} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F16FDF15-7000-4808-91AE-AEA6F1C57A20} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {826E3F9D-AE72-440E-B867-3F21995F2B6A} {Y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8265E0AD-6422-46D7-949E-41B3785AFB05} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {136FBA08-95D6-42A2-A977-5FFD00F599F0} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2362B1EC-5DE0-474A-A95C-03D6C757391B} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {33657157-49B9-41EC-8593-3238A4006313} {:}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7464F12F-931D-4AC0-8168-2502846BE758} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {84641226-CD45-4618-8D41-5E37025FE2D0} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E4699207-0BC8-427F-98EE-E9890607C84C} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {056D515B-481A-4868-B6CE-866160060EF1} {v}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4563D04F-10F6-4CFE-912C-D7697586F5A0} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {266748FD-BFAC-42A4-9916-03ECCD468988} {_}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C6627509-B4A2-4141-8160-5514C0F4842B} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {176C25E4-9080-46EE-ABBB-D767C343E47C} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {676859EF-982E-4414-9BFD-A4762B2196A1} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8863A441-B65A-491C-9AF2-9C0470A4318C} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C8691626-5C08-4633-AADA-F04C041FEDC4} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C86CCFDE-755F-48EF-9612-39A998340757} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E86F3EA8-5114-42E6-A416-A6CDB957E9F6} {h}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F864C110-F670-4C26-AECE-659F200E01FC} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1967CF66-4FC3-458F-BDE2-7A1476782AB8} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B96320B3-CF7A-4072-BAC8-A13C3B2BD56E} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1A64559B-6898-460C-A518-FB0C25F9F54E} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6A670D51-9E60-44A5-B20C-B715159A78E5} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {AA6CDDC9-837B-45C7-8A00-058E1F8F6CBE} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6B6C8AAD-0207-4AA5-93EA-DEDBF4D54117} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4D67F60E-C2DB-4D57-97C8-9A7449D663D4} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9D69EA3F-293A-4323-873E-47EBC79ED523} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DE63D995-3DED-4A93-A652-D45992F3E901} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DE657E92-5D7E-4B57-81C8-91582355F72E} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8F657C3A-0AF5-454A-B70A-E72917960DBF} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {30703CA0-2CDE-40B7-BC7F-EC4361FA278E} {h}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {317AF4F1-8373-4298-9C4C-CAB090CC8CB2} {W}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A1757E0F-9FB9-469E-91FB-2C8DBA48452C} {y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0271042A-6904-434C-B558-29B9A44F4D54} {a}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {237A25F2-BAF5-4617-B06C-691BD18AFB76} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D67B81FD-4FDA-43BA-BB3C-3700AF7E8F3E} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {39711454-E067-4C65-91DC-4CE9C7EDD525} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DD73F212-9687-4EB7-8CAE-5A63D0590675} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DE7B3E27-2522-413E-9101-5EF64833D32D} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {50812CAB-7C01-4622-A8A4-0DE705409573} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D08C04CB-32DA-436D-8242-371D490FA7FC} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A18B989E-3C3E-440A-A468-C287122AD8EB} {Y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E282FD6F-B876-4A5E-B788-D635D37340E6} {_}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E38B4D7F-C584-409F-BB1C-714125C95739} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9587A80A-8BA8-48B4-9404-6044974F432A} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {16838CC4-F225-41B0-803E-A4AF7861C514} {~}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1682C5FA-3214-42F4-9E2B-2353E81DE966} {,}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2C8E3EB1-B04F-4B03-8ACD-42A2AAD0D04A} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {ED893857-5C58-4C39-B8EF-92FF1B36944D} {m}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5E802F36-D366-4C71-B687-4CB65E0D9843} {8}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9E8EEEA2-7DFD-4F5B-8F78-9AD71640D54F} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {009C4613-0D0D-4B15-8C7F-EDB82204A5DE} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F09BB0DC-E300-454C-A2CE-F3F2BE00EC51} {z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7290B49C-C7CB-4982-B2E5-8F62514AB36F} {Q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {54901068-FA64-4BD0-AA23-94AC5C47F93C} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {059FF5DD-5C1B-4B3D-A3EC-CF3110F66AAF} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E99A4C25-0387-4B34-AA18-528CAF3C71FA} {U}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5A94C2C5-6B29-4CBF-BAEC-439FA97A2D9B} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7E9D64A7-B657-41F9-A298-A3B9EE9A86D9} {|}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {31AC6289-12B4-4693-844B-CA99FBE597DF} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {41ADD764-6C6D-47ED-A4D6-BDD2DABE193D} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A2A608FD-467E-4D5F-8FBC-255EF7585E29} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {96A376BC-5AB8-419B-851B-1CDF82EF95F4} {w}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {68A9B012-2661-4B7C-8545-791FB799E734} {|}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E8A0F34C-5516-4A39-8E59-0E5351AC6EF6} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9AA2124B-0310-4688-B7A7-6A4E1A8F5FEF} {R}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2BA083CE-1F63-46E6-A806-D15246838AC4} {4}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4DAD4E12-7E51-4A20-94C6-09E5224B0315} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5DACDC1D-050A-4C04-A3EB-BF63E84BE70D} {2}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DEABF5D6-A63A-40D2-8FBA-8BA7D9CCC433} {R}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FEAA1CB1-E68D-4C2F-8EE3-311ECC069901} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E1B304FB-D744-400D-8ACB-2BBA5161DB4E} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E2B37BF1-C96C-48FD-9377-893D2D7C5DB0} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {03B557AD-21B9-4B25-A20B-808F969495C7} {,}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {73BFAC66-1D06-4974-84BB-71D8EA7E2C78} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C6B0681C-B06D-4A32-B0F3-A0044A1A22C1} {)}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F7BC624B-CBC3-48BB-81B7-3841E470A81F} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {48B24244-608F-492B-AB01-04C91E5B37BA} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {78B32C82-5629-4A0F-B9AE-0D1CDEBB8BAD} {2}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D8B4C415-6D74-410C-82B4-FF2A22A5F7CC} {_}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6AB8DA9A-EA73-4B72-8B23-EF2577DF24EC} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3BB937CF-1590-43EB-9C1C-FBEF23A6CB51} {#}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EFBF5E67-E1C6-44B5-ABB9-7B9ADB16CE11} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A0CE973E-7EB5-452F-BFF6-7678A272ECED} {;}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {14C2F573-513F-4A19-AF75-750DDC779727} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A6C18FF6-D493-428F-856B-FF5D8BD80837} {v}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {19C1D48E-F4B1-4C89-BBBC-68A6D346F071} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BACFECBD-9B72-406B-9F57-984E53AFCF17} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EBCBC1CE-FC1A-4ABD-88AF-B2A4B09EEBD3} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2CC3B447-3B23-41CB-A484-67A5A3D1243D} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CCC3B140-A45C-4D52-8304-61D35A0F0D66} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BEC7464D-9AD6-4952-9082-4DE640BE5DF5} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F0D72C90-16EF-4987-8AF0-CE9C32B5A7B5} {r}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D1D4ECC5-50DC-4A04-B230-4ECCB05216E9} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {33D97796-BA9E-46F8-8AFC-F9BC0FFEDBB2} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D3D1E62B-DCC1-4449-A165-863FFD627877} {U}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {54DEE493-56F2-4EE9-8C28-BA35E538028C} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {95D90C7A-CA35-4A12-860C-1C0A5986FC79} {L}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {09D3F31A-9005-4955-BCF5-F6FDAE3A3E34} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {79DB2854-5A87-4368-A532-1B2A93BF73C5} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A9D1E53C-BB39-4F83-AF3B-519C8578501E} {`}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DAD8E7C3-37B9-4A72-9A56-18D9A423CC3A} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FBD8C490-D604-46E6-BD3A-4977F0C8F8C1} {v}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FBD38BB6-9844-4387-B986-8FB4996203BC} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {73EAC910-9F84-4E1E-B58D-B5ACB421D649} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {04E89B0B-E303-4E2D-B856-80930460C1EE} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {75E7FEA2-AD64-4918-A252-B940B28D0094} {8}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A5EA345D-1CA8-4109-B950-10E7A73A90EB} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D7EBFF5C-B33B-46E3-B80C-227FD9EF893E} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B8E561DA-4E26-46C0-8330-69049DC36B6C} {:}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1AE4EF99-4C3B-40B6-B8BA-443398871C2B} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3AEA3A42-0234-4A43-9D5B-5F342CB9D81A} {D}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FAE71E5D-DD47-4AC5-BCD8-21C3753711C9} {w}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BBE8E619-96D4-42C9-B889-A6EEFFBE3941} {8}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {ACEE5C44-C51D-458A-894D-D19B41D96AF6} {$}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6DEE551B-E007-48E9-829D-CCC2F742464A} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CDE59F16-4107-4B63-B053-BDFB0D34E660} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7EEC2A7E-0E81-4ECC-B566-74AFBA7ABC77} {L}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9EEA6703-A97F-4FA9-AFB3-AD29DC54F30E} {B}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FFE74815-952B-4FB8-AE48-9EA581BE2F2C} {,}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E0F0E32E-8430-4CE9-879C-EB8C6274501E} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B1F8D6BE-6473-498A-BEE5-BE39F208BB47} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A3FB56F5-59A9-4E4C-A101-5442484D8703} {)}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {05769337-D6D4-496C-8959-BD90D3044E69} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {257CA831-8BF0-44B1-88B9-8DE7B9027FA8} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {77749CE3-6C50-4885-8AF8-2F7830766F38} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E87186A7-B624-49FB-86C0-3A2287A6780C} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0A7D8E87-75DF-40D8-A346-12797E25C46C} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {AB729BE7-A7BD-4D85-A8C6-5FBF54411D9C} {3}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FC7431D9-A434-4479-96AB-2BC85F7A2520} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2E74EE64-94DA-4E37-8B7B-6965AC06CB8F} {|}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EE709383-BA51-4ECF-BCED-CD1E4A9B9651} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8F7D1777-0E11-42FF-95E4-92D880AA4D8E} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9F742822-5C47-4EDB-B9BE-C2FA15D226AA} {u}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A084C950-8E97-4C06-BB8D-B6936A9011A9} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E1877170-22CD-4CA0-A93D-B5CFFEB304A6} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E18BC670-856B-42C6-9F31-547A18DA47BD} {N}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C284705B-E748-4F6A-AC54-03642E59F5C1} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C48A383E-E8A5-415D-A099-D089A2DC09A1} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C485884D-3E9A-46A3-A708-BD06AE2C58E8} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8580B75C-95F6-4871-9D69-C942C3306D81} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {288A0D61-8317-4486-B311-7C322E7EE42A} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1D87CD73-1399-4DDC-A3CA-8F00D5488672} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CE8D297C-378E-4757-A0B0-3D96765F7E49} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5F82A3ED-94ED-4781-8D24-8024E1D6AB23} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5F8F60F9-B7E4-4AFF-A5C6-2BA199EE7753} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8F81BEE2-8AB1-4917-A1C6-E27908E302FE} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EF810E7C-BB1B-49D7-9942-90437CEFF6CC} {*}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EF8957CA-A4CB-4660-8E8A-6CD91BE0B2D6} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F2976A6F-00DD-4C68-BF29-C5DA183E9824} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {44912241-3755-48E8-8F71-80FC4399E5EF} {$}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9492C8F9-FD58-4B99-BBC7-ABE592864DFA} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A49C7A71-9262-49AF-88C3-D55D6083DE36} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C49C0F58-28DB-4F2C-A2A3-0742314EEBCF} {m}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8695C027-EFE7-447D-BECC-8E31C9B47746} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8697FA86-E92A-48BA-8F0A-469A4FA9E1C7} {#}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F697C450-FA16-43FB-8935-9904B7BC22B9} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {AA994D50-9DCD-4E84-B05C-C7719D792853} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {AA99DAD7-F7A8-44A2-A3C4-1CC8D6633A92} {x}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1B9C2313-141E-4D27-8681-F56F2DE6F62D} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FD9B4FE5-DD57-42A2-86BB-DD98E2A8F99A} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4E9B83C2-6CA2-43F0-B71E-A7DEA5D6D9C5} {+}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9F99F74D-ED0A-4650-9B79-29C5045CA608} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {00A7A924-823C-414C-B77A-F41881674F1A} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E1ABB69B-CF3F-4038-9957-D0CEEAFE8336} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F2ACCA44-A647-4C22-8F33-310111250C75} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {44A8D68B-0E2A-4E77-A595-A30F53FC65B6} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {35A7C93A-0B7D-42CD-AF10-384AF486F086} {U}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B8AFE49E-52FB-4145-B4AA-6F012AAC4F65} {}}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2AAB379C-4AA2-45B2-AA4E-F955C8C81384} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3CADB28D-5C4A-426A-8B3C-4C5DB4249472} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0EA37DAE-A17B-4B74-96B8-43B2114A1B53} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {2EA3DA50-2E5B-489F-8BA6-B9867A737DE1} {r}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CEADA5DE-4A1E-492C-B4DF-C7029C33F78B} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C0B52D20-61CE-476A-81EC-CE3FC7EB6C28} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B1B1D422-8009-4BD3-992B-9A3883A10404} {e}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {92B4FEE9-E74E-4095-ABF2-0EF64193E295} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F2B07F4E-127B-4FC5-90D8-88413B2CC5EE} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {44BCE9D4-353B-4DA8-8631-2A9A2C18B131} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {74BB5B8C-4DD2-461C-A915-B0BE45FB1AF8} {~}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F4BE686E-A4E3-480E-94AF-F2349DBE44DE} {9}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {25BA5A24-561F-46D6-AD87-D5F0A81EE451} {T}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {45B21024-2CAD-40FE-8897-8D7FA967EA8A} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F5BCCFDD-EDD8-4D4F-B8E8-94817E3733E3} {R}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {16BFACB4-A719-4CA7-A2A7-E0A55937E06A} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {96BBC197-02B8-4D64-8684-CF1B6721CF47} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {27BF2BC5-0AC2-4052-BFB9-A37BB36E425D} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {77B601AC-8FFC-41CF-9EF1-5782644DF6D2} {v}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A7BCBA59-893F-46FC-88A6-A31E8AB27349} {w}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E7BB7CE4-3C99-410D-8240-5E3DD927467E} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {48B04A44-06AA-4C57-90A2-CE1FE2D407CC} {T}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {29B2D9F8-8EEF-4BD6-A5C9-F580C7D4DE54} {D}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {39B7F3A8-462F-490F-AE71-3DBED4B3F1B3} {x}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {69B8BAC4-1B39-4D0F-A36F-65A611DA3DDE} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {99B29E3E-3D5E-47C3-B8CD-70D9A7940E48} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {6AB39CB1-BA04-4D01-B21B-1181C4C1D972} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7ABBA2E7-C8E5-4DEF-9BAE-AEF86A70492E} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9AB3B342-C915-4EC9-A0AC-FBE8319E55E9} {|}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9EB9C1C8-31AF-4FF8-9CA7-3F1AD2C92C9E} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1FB55480-A3DB-4817-B6D0-201F14BC85DF} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4FB22394-55EF-4C1D-8F2D-20D6918FC414} {L}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5FB7EAF9-01BA-4F3C-B975-1D9FC3F73A6F} {D}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {60C0FB0B-9705-44E9-9A5D-EFCBE43C3131} {_}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {70C97144-E892-48F2-BB08-32287223ED8A} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {80C064C2-1EBF-4D69-B9C2-AF5E9A3FB45B} {)}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A0C36461-C541-4132-BD3A-A2939812348D} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E0C2F43A-0205-43BD-8FD9-46D1A3722383} {*}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C1C6177E-4047-4080-AC01-D44518335033} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {12CF22CB-A121-46D9-93FF-30FCCEDB26AA} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {03C67E02-507C-4345-AC9F-79AD80414DA3} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B3C2A86C-146C-43FA-80F5-332EBAA5F373} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D3CA0072-5F3A-4E9D-95FB-FCC6F5D399EC} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {F3C4B8FC-CC22-45A9-912E-05900DB1F888} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {64C114E9-030B-4F10-8BC0-E521F2CFD3E2} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B4C01718-B87B-4082-81AA-98CC7F770D72} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B4C1257B-AF4F-4E71-8A7F-8C693634DD03} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {85C74C46-23A9-4743-A2B2-DC0AE1ACA234} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {96C0C586-9C83-4C81-99E2-F877ED40E08A} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C6CF1BDF-E253-4809-AB38-8F541A543CA8} {i}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {17C8142A-7736-4065-B852-0FFF67C7B320} {w}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {37C052A5-A4E1-4074-9120-8E32CC56D062} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7ACF767C-EAF1-47C9-A56B-6503EB56D291} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7ACD31F5-665C-4DC9-AA63-6DDDFC83E254} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {DBC1552D-575D-4F19-9353-3E000AC649D8} {9}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3CCB3ABF-AC5E-425B-987E-BAA643AF7AC5} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {5DCC663D-BA21-46E8-B37F-0E56B9E4FA79} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EDC002C8-9EB8-4244-A85E-D7C18520765B} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7FC9227F-4E7D-428A-85CC-A759147A5270} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7FCBB0C3-426A-4211-9E11-EF7B022E6DC6} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8FC1D019-23CC-40BB-A9BB-54CBE8E43AF7} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {40D492EF-3EDA-4349-B97F-9D3416658412} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {70DAEB0A-A00C-4908-B5BD-54D9C8EA8994} {v}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {61DBB050-C2CB-4FC7-A79B-BC7A018CB438} {v}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {72DCCF9D-948B-451A-8F31-CEFDBFB728B3} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {53DC305D-AFAE-46C7-B072-1D259AB4651F} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {93DD76ED-9712-45A4-AAFB-93D6625DE130} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A3D3728E-E83F-44E9-9C0F-729F4D3C75C6} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E3DD4896-42F2-489F-B7A6-978DA8EF06D6} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {94D05475-9CAC-41AA-8FF0-2434D5DCE840} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {75D98584-E606-4B45-BA28-08CB9297610C} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {BADC1384-DA9C-449F-98F9-B37DD0C117EB} {2}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {ABD50212-0B13-4E81-A14D-0B3B67305759} {i}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {ABD7EE3D-FD76-455D-9F65-AD347D5DAA20} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1CDEC316-F58D-49C4-B931-224C2125B76A} {@}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {8CD40513-51BB-4FB8-AFD4-B4B2EC87C7D1} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FCD0528C-3A92-4A7A-BC10-02A7D5A29605} {B}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3DDE6BBE-E208-40A5-B620-32EDB57B8FE7} {#}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {3FD2285F-CAB7-4A8A-BD8E-CD879AC8CA75} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {50E107CA-1DF5-4927-B896-28E51BD5E18C} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {01E37241-ED5D-478E-8C03-1CCA75A01145} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {51E36072-D3F4-4AF7-BFF5-8FD8C90F8535} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {33EA9DE6-BB5A-4FCA-9741-552554FE641C} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {05E90F6A-87AF-49D5-9C97-EA482A10F32B} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {96E7E29E-DAED-4B4B-BB7C-68EE126D9D23} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {18E6116A-8B1C-4910-8841-D9E9D9A4E303} {-}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EAEE7305-F33F-46D1-B6AE-3CA0E0E1F4C2} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CCE34FAD-7D39-44C4-AC3A-D7E7A83B5900} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0DE14B03-3022-40C4-A38F-79346BE6F1B7} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4FE0F548-059F-406B-9AB1-A90BF038F75A} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C0FFE642-39F3-4A12-9815-9265C5028BA8} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {91F9C9DA-8F18-4198-8EBE-8233E95EB241} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B1FAA913-0F2C-4A61-95DD-F04EFA0DCB1F} {4}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D1FF92F1-67DD-4076-9995-38B7F8B36387} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {02F2961B-100D-4B74-BBE6-25C9A3AAD3D5} {Q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {12F969A2-9022-4AFF-9173-50690A0BC681} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {63FAFE49-D000-4DF3-8D78-3FD8D21657E0} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {A3F33B20-9BF9-466D-9D5B-843B11B18163} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B3FCC2C4-3B0D-499E-9FF1-7F2648746C96} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {E3F912E6-E96F-429F-AD97-C0EE0605A50C} {q}', '');
  end
end
^
execute procedure M_TEMP_FILL_LINKS
^
drop procedure M_TEMP_FILL_LINKS
^^


create or alter procedure M_TEMP_FILL_LINKS
as
declare variable VN_ID integer;
begin
  if (not exists(select ID_SELF
                 from M_GLOBAL_PARAMS
                 where PARAM_NAME = 'FILL_NORM_LINK_TFS444')) then
  begin

    --    
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {04F5CEDC-81BB-4D62-862E-7D921D9ABAD0} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {34F34447-5E46-4569-9E85-56A2F0547593} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {05F2D620-5C1E-4CA0-86DC-D71CFF3B46A6} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {56F7F2BA-4DAC-40CC-99B0-7DDE3DBF4657} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {87F0BD85-8531-44C3-948C-3A95CD0B1A03} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B7F599D6-ED70-42CF-995F-6836354D16B9} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {18F5497A-2BB5-4C6B-8EA5-DB05CE797352} {a}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {88F902F7-F5B8-4EB2-968B-625B6AE2B9AD} {}}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B8F78706-EFAC-4093-B644-DB94E19D3420} {Q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {B8F67B29-9AF3-44B5-9BF2-5B2612995044} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {C9F3C17A-56D1-41AA-8095-B4B1C2E1D050} {B}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {D9F4DDC8-FE78-4463-A230-D8BF5B9F4CCC} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {4AF18110-2057-42BF-A8BF-31752A748D10} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {CAFA750C-523D-4B52-BCF4-F25F67AECBFD} {R}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {1BFE558E-3720-42F7-A8E5-12A304CD6D31} {>}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {9BF91865-41ED-4D2C-9E21-D8528AED1414} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {EBFAA8AE-1886-4AFE-9214-EC11A95E3E22} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {ACF4C606-954A-43ED-A081-A305D3FF33CF} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {0DFDABD7-9A43-4E54-A36E-2C6DF44BBA92} {4}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {7DFE2F34-43F4-4366-AC75-89EA00E7AD25} {_}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {ADF44C56-35C0-472C-98E8-33C1DA2A8622} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(0, 0, '000"B {FEF3FEB2-BB3E-4195-9C15-9445DAB70367} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(1, 0, '000"B {E423155A-AD9F-42ED-BC14-DB2D400B0CAB} {v}', '');
    execute procedure IMP_NORM_BASE_INSTALL(1, 0, '000"B {0E5EED7B-D2E9-4F30-9735-AB162CBEF20B} {#}', '');
    execute procedure IMP_NORM_BASE_INSTALL(3, 1, '000"B {BB63DBC2-4D06-4540-9E36-DD5E734B898A} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(3, 1, '000"B {B2A0B117-437F-40CC-A6E8-A1338009323C} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(3, 2, '000"B {0FA8A08E-7B0B-4626-A206-95B4A3046BC6} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(3, 2, '000"B {53BF91FE-1CCF-4171-8A70-69C12E4E174C} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(3, 2, '000"B {06B2C8D7-FAF1-45C7-BE3F-188A8D0B0FCD} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(3, 2, '000"B {20E194F8-562A-4E37-9CA7-7D8901BBB809} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(4, 0, '000"B {930B87E8-D447-4368-90E0-A0D586A71C1A} {-}', '');
    execute procedure IMP_NORM_BASE_INSTALL(4, 0, '000"B {AD5DFE31-8080-4B0C-857A-1BE906C7A73F} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(4, 0, '000"B {B4E43DAE-B9C4-4B18-A59F-4E0EC5C78316} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(5, 0, '000"B {C995D515-5FF0-41A2-9879-70CECA5BB65B} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(6, 0, '000"B {9572BAD3-C838-4AF0-AA1C-AC9D3C15C083} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(7, 0, '000"B {8F78DB74-4F0F-454E-B364-F653707F3756} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(8, 0, '000"B {134A14D5-95B3-4E95-85EB-3A3CC3551E57} {8}', '');
    execute procedure IMP_NORM_BASE_INSTALL(9, 0, '000"B {FCC25E38-30A0-4884-A4D9-29651AC363C1} {3}', '');
    execute procedure IMP_NORM_BASE_INSTALL(10, 0, '000"B {B75E32D9-85FC-465C-997E-FE940C3B06E4} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(10, 0, '000"B {40BDA8F9-CFFD-4189-AA07-EFE9A24DE05C} {N}', '');
    execute procedure IMP_NORM_BASE_INSTALL(11, 0, '000"B {00494942-7252-4AAA-B7D9-F91EA82C49F2} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(12, 0, '000"B {F78D88DC-29D0-49F2-9251-424CBFC1C469} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {810DDA72-A8F2-4125-93FF-488561A7718A} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {A3038C48-169E-43B1-A970-52C6DCBD9980} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {E30FDCA5-9BA0-4C88-BE7D-D5E3EC101222} {x}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {5507AF93-C845-40C8-A90A-99A4E1BB07B7} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {770D5D25-653F-4103-BD69-50C5D2565C37} {x}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {9C0C8C65-4169-4345-B832-BF3AB6D72F27} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {1D0A6AB8-7C8C-4E2B-8B4F-88EB892F3FEE} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {8B181610-B581-4692-BC08-481745197301} {4}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {2F14BBD6-730E-4761-B355-F68124E94E31} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {FF166E46-3FA4-470D-A208-BE046B7681FC} {Y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {7127237C-C591-4B4B-AA86-F6416953BEDE} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {9223E1BB-B23E-4CC0-A6EA-FD91EB20B1B8} {~}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {9628783B-CEAA-4BDA-882D-D674D30C2B0A} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {8132D672-7C2B-4C45-9993-E17671602AC7} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {9740D7DA-7AD3-4B66-9CF5-C306E2E199BC} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {5A4EC9D4-03B1-4B92-BA4B-E0C3318F5870} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {EC4E667E-1C15-4CD7-991A-0B218C9BE227} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {CA56FA67-512D-4F21-A188-84D0D4B10984} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {2367615B-8AA1-4386-B019-9AB65D66FFC7} {@}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {8467C0D6-0EEE-47E3-B5C7-397D1ED55CAF} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {D4782DEB-274B-4E9E-A107-6B8A0C4B8165} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {EE755AD3-1204-4453-8221-AEDC347091AA} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {E18443FC-6213-4E2F-9C7F-0E786D58A128} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {148AA50C-3B16-4A0E-A6C8-EBC5544AD59A} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {05887A0E-D957-4743-A4D5-7F5B9465D6D4} {@}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {3B99B565-1AC2-44E3-BC88-6C499FDFD04D} {w}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {1D946696-69B5-4340-94FB-887BB98B2C1B} {@}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {1E9C7DE7-6E1F-4A3B-9EBA-EDE8484558CD} {N}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {DF98D8C8-0666-484A-94CA-70916BF95DCC} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {31ADDE3C-7EBF-4A2D-93D9-FC2CA1E243D2} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {B5B3853F-9E3F-4AF0-870D-CA0720F2DD60} {a}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {F6B9A87F-76EE-41EF-9C11-47B52E197134} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {BAB81DB4-9A43-4C5F-8967-4522A4299222} {,}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {1DBECE96-CC87-481B-9F7C-74CB2A9B8BD8} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {7DB3750F-B39E-454B-8C60-2F8C470C7179} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {61C18253-BC0C-4611-A314-7BCB8471DA59} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {4CCA01FA-4D2A-4795-A546-5126454B2E49} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {6CCAC55D-B3D4-4030-B706-0C3AB8F43C40} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {A5D7E7D3-7F1A-4076-9E40-7E03D27E0B8D} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {06D5910F-840E-43AC-BDA6-466FB46CF37D} {h}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {96D8D864-BD66-4481-94F3-EA07431B0C06} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {0EE60014-5E62-460C-BC00-AE0F912651F9} {#}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {72FDFBFA-E362-49DE-93D1-137E4B5AC7C6} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {15F84134-1C56-4EF5-8F32-CD32B58EC3B3} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {16F9B7A6-7642-40D2-BB93-BB35812F6555} {,}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {68F55082-5FAA-405B-877B-9C20D402A306} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(13, 0, '000"B {6FF2DF34-F4E1-4FE7-BCD1-55174326C7A6} {n}', '');
    execute procedure IMP_NORM_BASE_INSTALL(14, 0, '000"B {6F1A7915-1918-4BBF-A86B-74339709AAF2} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(15, 0, '000"B {EABBB766-072F-435E-92AD-9E7944D73F33} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(16, 0, '000"B {EB515FFD-CF15-11D7-BFE5-0050BF44CBE2} {*}', '');
    execute procedure IMP_NORM_BASE_INSTALL(17, 0, '000"B {948F3BE2-03B9-4813-8141-AA78F33F3B3B} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(18, 0, '000"B {D5FDA435-B61C-447E-86DD-640D9177F6F1} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(20, 0, '000"B {94853FEC-1CF8-4FCB-BF68-F497DCA24553} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(21, 0, '000"B {D9074170-6AE3-4287-8B68-D4BFEED052FB} {`}', '');
    execute procedure IMP_NORM_BASE_INSTALL(23, 0, '000"B {9A2905E6-11A6-4088-A2F2-5B71702C6A9B} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(24, 0, '000"B {E65FBA88-0028-4AB8-831D-78EE678C0A96} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(25, 0, '000"B {80959184-702C-4FF1-994A-D3755D8980C0} {}}', '');
    execute procedure IMP_NORM_BASE_INSTALL(26, 0, '000"B {946B63E7-C51A-4757-98C6-2D2D47978AEC} {T}', '');
    execute procedure IMP_NORM_BASE_INSTALL(27, 0, '000"B {036E238D-5CE0-44A4-A4C3-EF645DC446B3} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(28, 0, '000"B {31317906-3A8B-4B5E-A34F-7AC6B6C4D527} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(29, 0, '000"B {B553F67D-A95B-4F41-944E-EDF77AA77CDB} {;}', '');
    execute procedure IMP_NORM_BASE_INSTALL(30, 0, '000"B {38CD0D88-0827-4365-9A53-255A9C3209E8} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(31, 0, '000"B {16B96554-450E-49D9-8042-B0F7D28A07F9} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(32, 0, '000"B {A17F8C81-ADA5-4356-AA69-49C962DA2339} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(33, 0, '000"B {47A61DA7-7A03-4FB5-9242-508CF833E092} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(34, 0, '000"B {E282F59D-3276-4EAB-B88E-928344A74E6A} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(35, 0, '000"B {ED49F935-9AD2-412D-A03D-A02A94272534} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(36, 0, '000"B {9B4290B4-FF93-4F94-BBC0-B9AF036A8958} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(38, 0, '000"B {E6E1AF1D-7531-4C87-B80D-D6D54F7552AC} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(39, 0, '000"B {A8EEFAFD-B257-4734-9D92-D8931BE45F3F} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(40, 0, '000"B {973BD539-E468-47DB-BAFE-E11305DAE672} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(42, 0, '000"B {7CF60396-EB4B-45AB-B7BE-CDDBCD6E92D2} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(43, 0, '000"B {82564834-8D6D-403C-B49C-487A5333F09C} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(44, 0, '000"B {83EFE30E-7C26-4C88-B7B6-94ED3E55B183} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(45, 0, '000"B {2B69CFB0-24F4-421B-868D-9A39B2D04FEB} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(46, 0, '000"B {3E2A9EE5-1745-4CC9-9504-D6F8E80C9020} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(47, 0, '000"B {DF352FE6-316B-4896-9562-9C077B1347D8} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(49, 0, '000"B {3F164DAB-A5CB-11D8-A8F9-884E08875473} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(50, 0, '000"B {0B11F935-B594-4B2E-B4A1-32F3671D2AE8} {;}', '');
    execute procedure IMP_NORM_BASE_INSTALL(51, 0, '000"B {F3D8C6C8-80CF-49A5-97DF-AFAAF24C3059} {9}', '');
    execute procedure IMP_NORM_BASE_INSTALL(52, 0, '000"B {03E2856C-F838-4544-AA65-F0AE365D4A1D} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(53, 0, '000"B {04EAC8CB-9B39-4C2D-BD2B-4669321E9AA8} {v}', '');
    execute procedure IMP_NORM_BASE_INSTALL(55, 0, '000"B {3BCE8927-BE2B-4A41-AD43-4607B0C72117} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(56, 0, '000"B {78CF0324-FCEA-4A8D-94DB-37ACBAC13D24} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(57, 0, '000"B {CD0C6270-D877-4CDE-9083-1B2C68628F10} {;}', '');
    execute procedure IMP_NORM_BASE_INSTALL(58, 0, '000"B {E4A0EE1E-F456-48E1-9620-DFE6ED2D78AD} {3}', '');
    execute procedure IMP_NORM_BASE_INSTALL(59, 0, '000"B {2F89296E-99CA-48FF-BDBF-FEDD9196350A} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(61, 0, '000"B {3AF6B1E9-DE86-436C-BC81-20A2FFD78163} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(62, 0, '000"B {28825058-DCDA-4582-904E-2452A52B9392} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(63, 0, '000"B {8E8480F1-BA42-4A76-BE62-1F1F831885AF} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(64, 0, '000"B {E9A8C5B8-5D55-4125-95FA-CEEC0F50CFC3} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(65, 0, '000"B {BAE67008-4906-48A9-9BB4-72643C5298C2} {$}', '');
    execute procedure IMP_NORM_BASE_INSTALL(69, 0, '000"B {10B72132-0E76-4FC6-A059-B20D62B9E2A9} {)}', '');
    execute procedure IMP_NORM_BASE_INSTALL(70, 0, '000"B {B1949511-309D-4DA7-97C5-B0C80B71269C} {*}', '');
    execute procedure IMP_NORM_BASE_INSTALL(71, 0, '000"B {8F9CF3E5-A5DC-4CC3-A9F2-1591A87A335A} {}}', '');
    execute procedure IMP_NORM_BASE_INSTALL(72, 0, '000"B {AA4D033F-65FE-41BB-B9B7-82ED9AE4A69E} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(74, 0, '000"B {3207F354-CD24-4782-BA67-7BE2E9A3F5F3} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(74, 0, '000"B {952230E8-02F2-4E9A-B646-C7CEF4B80EC4} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(74, 0, '000"B {392B2B78-C5DC-4A58-A5E0-1F49620AA77A} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(74, 0, '000"B {CD3A2F6F-5573-4D8A-B43C-F1DF931FA952} {|}', '');
    execute procedure IMP_NORM_BASE_INSTALL(74, 0, '000"B {728A50E1-A64D-4B8C-AE0E-EF5386E45629} {_}', '');
    execute procedure IMP_NORM_BASE_INSTALL(74, 0, '000"B {2387B782-9C62-4057-A804-32C40C9E860B} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(74, 0, '000"B {8AAC5EDD-F5F9-4150-AAEF-D6A537CD717A} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(75, 0, '000"B {660AE59B-58D5-4245-9A0B-146880228A08} {h}', '');
    execute procedure IMP_NORM_BASE_INSTALL(77, 0, '000"B {5EE3F964-AA3B-4C41-B81E-D6B834391D10} {R}', '');
    execute procedure IMP_NORM_BASE_INSTALL(78, 0, '000"B {57BC1516-1450-48B2-AED7-50387752425E} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(79, 0, '000"B {B7B8DAA9-05D6-453F-9D6E-432E7A9D4360} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(82, 0, '000"B {1CDCB6A5-BDB5-4D92-8D81-ACAE52DE9010} {+}', '');
    execute procedure IMP_NORM_BASE_INSTALL(83, 0, '000"B {AA767473-B5D5-4B08-A655-BFB2EF45BEA8} {z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(83, 0, '000"B {A6BC3500-D92D-409E-8AFD-2CBB7EFC0DC3} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(84, 0, '000"B {CF987660-8239-4E84-8576-1771E5072DDC} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(86, 0, '000"B {B2BB2311-34EF-49E3-B48B-2A6740FC555A} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(88, 0, '000"B {90EDD20E-CE94-414C-B532-FF27CE12E3B5} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(91, 0, '000"B {BEF78BF8-3D62-437C-A6B3-A2C0F7845105} {Y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(93, 0, '000"B {B41052BF-2F73-4F0B-AF30-3105218B4E7D} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(94, 0, '000"B {733FA921-842B-427F-896C-0F550122271C} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(98, 0, '000"B {5A05994C-4F56-4A1F-A239-53CA4AC735F3} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(99, 0, '000"B {11EF2031-5D6F-4D52-AA18-5009D5B63B7A} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(101, 0, '000"B {975576F2-F52A-4EFB-9885-31812240C486} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(103, 0, '000"B {7BE20DA3-C952-4B0B-A223-38F61657AA44} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(108, 0, '000"B {3AD7E72D-2C8F-446B-98D5-CF890EC727BF} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(110, 0, '000"B {004573DD-41F6-4A54-8D0E-41880F446D4A} {$}', '');
    execute procedure IMP_NORM_BASE_INSTALL(110, 0, '000"B {809D8951-2C1A-43E9-9173-B9D0F1F27DFA} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(110, 0, '000"B {09A886F5-D411-42D0-9C7F-1D0380D71711} {r}', '');
    execute procedure IMP_NORM_BASE_INSTALL(111, 0, '000"B {C7BEB260-51D9-41A3-A6A6-03FF01BB0C32} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(111, 0, '000"B {6FC0A1D3-6A14-44B0-B8DA-F29CFDEBD201} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(112, 0, '000"B {CDEE9E31-E6ED-414F-BEF6-BCE62438E951} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(112, 0, '000"B {8EE0C98F-88BE-4FF1-832C-9F64F7796D77} {+}', '');
    execute procedure IMP_NORM_BASE_INSTALL(113, 0, '000"B {D614FBFA-302C-4981-B554-29AE78E6CDD0} {i}', '');
    execute procedure IMP_NORM_BASE_INSTALL(113, 0, '000"B {BFA7F645-D323-41C6-98D2-52F7075BD5AF} {_}', '');
    execute procedure IMP_NORM_BASE_INSTALL(114, 0, '000"B {4197715D-98B8-42A8-AB46-9FED2A5146FE} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(115, 0, '000"B {A420844C-8724-47E6-A72E-1271D6F55458} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(116, 0, '000"B {4F1323D6-2ED8-4427-A80F-981CB3AE6513} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(117, 0, '000"B {414231CB-6B42-462F-864A-7C037EC2A231} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(117, 0, '000"B {4BA57B0B-F40D-4B67-AEEA-4725E03D47BE} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(118, 0, '000"B {E6EF557B-5275-4716-BF5B-1CE11B6CCC76} {m}', '');
    execute procedure IMP_NORM_BASE_INSTALL(119, 0, '000"B {86EF8892-1119-4943-885C-91900A734830} {N}', '');
    execute procedure IMP_NORM_BASE_INSTALL(119, 0, '000"B {73FDFB94-DC13-4F39-A80F-9A683740E809} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(120, 0, '000"B {DE599C36-FD22-45D6-8685-CB1DBC75BE3B} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(120, 0, '000"B {29F5B3B4-ADA3-42C6-8156-5706C8694723} {~}', '');
    execute procedure IMP_NORM_BASE_INSTALL(121, 0, '000"B {70D57773-73EE-4B89-A75C-E9EFC21BFE5B} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(121, 0, '000"B {F0D6D118-3DF9-4CCB-8234-7FC79FBC11B3} {z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(123, 0, '000"B {9D263BDA-39CE-4BD3-8AAD-6A18663658F5} {r}', '');
    execute procedure IMP_NORM_BASE_INSTALL(123, 0, '000"B {0AB0F74E-CED6-4244-BA33-476072133E3B} {4}', '');
    execute procedure IMP_NORM_BASE_INSTALL(123, 0, '000"B {E5C523C9-86FA-47B7-9AF7-4FC49915857C} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(124, 0, '000"B {3F1D6F0E-3FA8-43C7-876D-D8C41E2C0A96} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(124, 0, '000"B {0FD2EF84-1C86-4BF6-AE57-8126F27094B5} {T}', '');
    execute procedure IMP_NORM_BASE_INSTALL(125, 0, '000"B {3E349532-5E37-4825-9441-9AD44CB217A3} {i}', '');
    execute procedure IMP_NORM_BASE_INSTALL(126, 0, '000"B {1C06EC6A-7A37-4B21-BA6D-98C100DFD3AE} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(126, 0, '000"B {6D3CDCFC-70C2-4BB3-9035-B1E23705F3B8} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(127, 0, '000"B {2C462EFE-C24D-4D66-87CB-2C2A5D86CF41} {z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(127, 0, '000"B {17A4AAF8-FF77-48D5-BDCA-FDCCA7B88209} {T}', '');
    execute procedure IMP_NORM_BASE_INSTALL(127, 0, '000"B {ADB29051-1064-4572-8F63-11B47BC9FD67} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(127, 0, '000"B {AEDB92E0-CFBE-4421-A6A8-8526BCC1E4B6} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(127, 0, '000"B {6CFE5CB7-EC3F-48B9-8D51-6E4F9EEF2AE3} {a}', '');
    execute procedure IMP_NORM_BASE_INSTALL(128, 0, '000"B {8E81741A-9BF7-47A1-B21D-92AEFB5A642B} {e}', '');
    execute procedure IMP_NORM_BASE_INSTALL(129, 0, '000"B {3F0F1D34-CE52-4606-A8D9-CD1FA70D2F1B} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(129, 0, '000"B {20D4EC9D-5893-4E36-8BCC-D6F573D1A0AC} {z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(130, 0, '000"B {7A2FC5CB-05C1-4356-B4F2-9E8137AF866E} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(131, 0, '000"B {AD543BB3-A9CA-47C3-9478-0B797CCAA199} {n}', '');
    execute procedure IMP_NORM_BASE_INSTALL(132, 0, '000"B {5A3770C3-C215-46B0-A800-65E782F179F7} {w}', '');
    execute procedure IMP_NORM_BASE_INSTALL(132, 0, '000"B {10DCC96A-CF9F-48B1-90DB-AA7647CC7293} {}}', '');
    execute procedure IMP_NORM_BASE_INSTALL(133, 0, '000"B {572BC883-E4E1-45E4-8CA2-1095F6D9E6C1} {S}', '');
    execute procedure IMP_NORM_BASE_INSTALL(134, 0, '000"B {9CBAA027-8718-4258-ADB5-4B2E75854D6D} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(134, 0, '000"B {4AC85E3C-0579-49F9-A41C-6A1855E3A7B5} {R}', '');
    execute procedure IMP_NORM_BASE_INSTALL(134, 0, '000"B {50FA9F2C-CCC5-4464-AF8F-9775CA58B626} {y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(135, 0, '000"B {E2017938-9C59-42B5-A8A9-7F8B4B171B2B} {@}', '');
    execute procedure IMP_NORM_BASE_INSTALL(135, 0, '000"B {0E4A9F24-ED4C-4BD9-9E75-9296E5A0A5CC} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(135, 0, '000"B {0DF5D8B7-1195-4350-98AF-74348BF0F00C} {:}', '');
    execute procedure IMP_NORM_BASE_INSTALL(136, 0, '000"B {E21F23C2-47DD-4881-9C4B-C9C2AB2AF862} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(136, 0, '000"B {CCBC22B7-FB43-4481-A535-BF6A674AC7F6} {t}', '');
    execute procedure IMP_NORM_BASE_INSTALL(136, 0, '000"B {D8E181AC-ECDE-4D2E-BC5E-573051CF7E20} {3}', '');
    execute procedure IMP_NORM_BASE_INSTALL(137, 0, '000"B {018DB690-A1C8-468F-A885-2E386304E9AC} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(137, 0, '000"B {53C1C0B0-8BCE-419C-B780-CE22F7175E0D} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(139, 0, '000"B {FFC02320-EA9D-4583-B587-8F00F04110A6} {+}', '');
    execute procedure IMP_NORM_BASE_INSTALL(142, 0, '000"B {A15E4F16-4D2A-4918-8BBD-09163C5B555D} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(142, 0, '000"B {146163FA-6384-416B-A843-B15AB295ABAB} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(144, 0, '000"B {29067D19-8C93-4971-BD3A-D0EAF4B24B90} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(145, 0, '000"B {85184426-5C32-4C96-986A-EB23D7ACAF8D} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(145, 0, '000"B {4D2DE12B-4AE4-41D7-9943-481190A99002} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(145, 0, '000"B {29963561-22E0-464A-B79D-2DE28578F38A} {)}', '');
    execute procedure IMP_NORM_BASE_INSTALL(146, 0, '000"B {E7A0FB7C-D9C4-438E-91D8-2C0BED8BFCAF} {`}', '');
    execute procedure IMP_NORM_BASE_INSTALL(146, 0, '000"B {A0F11861-BBA7-4C97-9D32-65F35817A903} {*}', '');
    execute procedure IMP_NORM_BASE_INSTALL(147, 0, '000"B {03C43879-5167-4D32-AA9B-4473C5DBA33E} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(147, 0, '000"B {A6CE4FA6-FC0F-4901-AB76-FEF02E495626} {|}', '');
    execute procedure IMP_NORM_BASE_INSTALL(149, 0, '000"B {43BB2167-6435-419D-B04F-12C7128FC465} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(149, 0, '000"B {37B1302D-4189-4C78-97F5-1AD42CCFA7A5} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(149, 0, '000"B {9CE0E3A3-F902-4EAA-986B-2537DD634FAE} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(157, 0, '000"B {F2DBB10E-0E6C-495A-BDC7-085DF2B17B7A} {-}', '');
    execute procedure IMP_NORM_BASE_INSTALL(158, 0, '000"B {3419ABA1-E2E8-41BD-9502-F96F923ED31C} {U}', '');
    execute procedure IMP_NORM_BASE_INSTALL(158, 0, '000"B {B092FADB-2BD8-452D-9585-CE2330828266} {;}', '');
    execute procedure IMP_NORM_BASE_INSTALL(158, 0, '000"B {EEA5962E-4F12-4BE5-BE62-A158FE7449EF} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(158, 0, '000"B {6FA5339B-5F1C-433D-8723-4D16147C5D5D} {;}', '');
    execute procedure IMP_NORM_BASE_INSTALL(158, 0, '000"B {25FC9474-D0A9-4340-897B-F971D7CA4908} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(159, 0, '000"B {0F4F79D0-C849-458B-B2E6-80F77B34744F} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(160, 0, '000"B {DE03E77D-AA71-4A35-AE82-1418B225A9EA} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(160, 0, '000"B {6FFDB000-41D9-4F9D-A966-3450E635E042} {8}', '');
    execute procedure IMP_NORM_BASE_INSTALL(161, 0, '000"B {B64B26C3-3BF2-4385-8CC0-A0F100376635} {v}', '');
    execute procedure IMP_NORM_BASE_INSTALL(161, 0, '000"B {D39348EB-ABBB-4204-9030-8EE7C3C34D6F} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(161, 0, '000"B {53D3C660-12E5-4A58-BDFE-286A8F8A3DD8} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(162, 0, '000"B {F5EFE9EA-5153-47CC-AFAD-81A5149C4522} {y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(163, 0, '000"B {40BA4A98-FF2E-48FA-BD75-CA846B392AA6} {,}', '');
    execute procedure IMP_NORM_BASE_INSTALL(166, 0, '000"B {83457A00-1CF1-4105-8453-7F3ECA2E4445} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(166, 0, '000"B {D940A082-554F-49AA-9D53-8D940BB7D987} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(167, 0, '000"B {306E0AB2-AC91-4965-A456-3890CB1B4714} {z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(169, 0, '000"B {946E35E7-CF5A-4257-B7FB-B0793BF83470} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(169, 0, '000"B {3C61B8C9-D47A-4866-97F2-0D4C03B92B4C} {N}', '');
    execute procedure IMP_NORM_BASE_INSTALL(169, 0, '000"B {3487D604-7EE2-484F-9CF4-A065919C0797} {3}', '');
    execute procedure IMP_NORM_BASE_INSTALL(170, 0, '000"B {69D75D27-A37B-4711-A492-650EF31BAAA7} {C}', '');
    execute procedure IMP_NORM_BASE_INSTALL(172, 0, '000"B {ED042F68-02AB-4398-A856-0A45FB92D806} {:}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 0, '000"B {955522D8-659C-4A47-8866-B4E5C3841B1A} {)}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 1, '000"B {9225838E-3AA0-4C52-98BC-B12CADB3B8B1} {Y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 1, '000"B {364EC89E-5795-4BF9-9B8D-B6AEE0732760} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 1, '000"B {4956CC01-2CF3-41B8-B004-5A81767E0271} {i}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 1, '000"B {F9631880-E278-4D4D-955F-15E34089A665} {$}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 1, '000"B {92C1E03D-F2C4-4402-AC52-58789D2C3518} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {CE073F7D-C682-447C-9E77-329DD55FD759} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {CE117DE0-9BED-479A-B61D-766978D4B051} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {2E2CE0D4-2EF3-4E00-843C-1F0EE3512413} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {8E23BDBA-A325-49A8-86C4-1EC3ABEA316A} {x}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {D33C5317-C54E-4A29-873D-C9D047DDF88A} {e}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {A2753C72-6AAE-40EF-870F-B0EDCA5DC4A8} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {53A44F40-4DCA-4C5D-B243-E6758BB3E7B0} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {10BDEA56-C757-4128-A78A-ADD1AB351459} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {A5DE2F8D-0601-4366-B446-D2BE171AA180} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {4DD684D6-F985-4363-AE78-B2AAC76303F6} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {8FEF45F5-EEC2-4FFE-85F6-E55636712ED8} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {E6FE9ECD-14B2-4D38-BE19-B25B9420473B} {i}', '');
    execute procedure IMP_NORM_BASE_INSTALL(173, 2, '000"B {3AF3F9EB-A201-4A77-9DFF-F497AF2AACB1} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(174, 0, '000"B {1D36E651-4104-4F5E-B715-7B80A437FA51} {}}', '');
    execute procedure IMP_NORM_BASE_INSTALL(174, 0, '000"B {A0A9447B-DAE3-454E-9101-252F2BA7B7D7} {L}', '');
    execute procedure IMP_NORM_BASE_INSTALL(174, 0, '000"B {2FE36A00-252E-493F-8217-183170F82F4C} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(175, 0, '000"B {16F225F6-20A7-4C68-ABBF-1368E5B47FB9} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(176, 0, '000"B {E8550F32-EFCA-4ED7-B1BD-82172C75254C} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(176, 0, '000"B {9FB811F7-0C1B-4FAC-959E-42B80D564EA2} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(176, 0, '000"B {9BF89BF7-C158-49D2-A230-EEE854C4489A} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(177, 0, '000"B {BD44FBAB-28CA-41D6-8561-63C2738535A3} {B}', '');
    execute procedure IMP_NORM_BASE_INSTALL(177, 0, '000"B {48AA902D-1CBB-4290-9C77-222B58457548} {y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(179, 0, '000"B {862E82DF-ADA9-4FEE-A1C3-946FA17BF204} {-}', '');
    execute procedure IMP_NORM_BASE_INSTALL(179, 0, '000"B {CFD4C847-2B98-4CEE-A7BB-699B4A6C6886} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(180, 0, '000"B {BF0EE152-62E2-4D28-8619-9D2C8EBC78C6} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(181, 0, '000"B {650FBC7B-2B11-42C7-8639-0E6255A74B8D} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(181, 0, '000"B {83F3246F-6D5F-499C-AC1B-4480FA7DABC3} {}}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 0, '000"B {D53CEAE7-7AF6-4E09-B624-0356994686AF} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 1, '000"B {070785FA-0BD5-484B-A0F9-94C08B34A876} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 1, '000"B {E13F94D2-0DF2-479D-8359-EC9E6D33ECBF} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 1, '000"B {7E6454AE-C4E0-4625-8DC4-1C55EE8C3A51} {Y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 1, '000"B {CC8DB8FE-36E5-4131-89F1-60EAA4EBEC86} {2}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 1, '000"B {ACFAC6AB-4557-4376-A8F5-387802565136} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {8A0035B1-CD13-477A-AFB2-5A7EE24227C7} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {921A5D58-6F88-4D6D-849F-42AD336BEA7C} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {D7115636-DA0D-449E-9EA2-B512D446159A} {4}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {282CDB0F-8670-4182-B191-06D492CC1C87} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {04311693-B85B-4535-9482-2FB9E4F2B206} {g}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {1C327DCE-5C27-44E6-A4D8-347D0A3C2F4A} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {6C4FF780-6C87-4373-8344-33D5185ECE53} {-}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {C154A0BA-A679-49E2-A75B-06521DF62588} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {2962FC2A-A034-4054-AB02-2269AAE7A6B4} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {EB604431-0F36-480F-9E1D-1589B6E88EDE} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {5780D113-2BE3-4A80-BDDB-89C08EB2B7D7} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {60BADC3A-C3E5-4504-BACB-A0E2BFA36B7A} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {7DB2C27B-211F-4368-B040-18E955044639} {b}', '');
    execute procedure IMP_NORM_BASE_INSTALL(182, 2, '000"B {8DFA1D07-F5D2-4BDC-9E36-74EFA68554F1} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(184, 0, '000"B {43542116-141B-4702-8DD2-A2F7CC20FF98} {{}', '');
    execute procedure IMP_NORM_BASE_INSTALL(184, 0, '000"B {A47BD5FD-B12F-45CB-8E14-9949E17DB87F} {,}', '');
    execute procedure IMP_NORM_BASE_INSTALL(184, 0, '000"B {3C829ECF-295F-4422-8813-C6D5971C2954} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(185, 0, '000"B {8742D523-4436-45C0-8148-528AB65C4D7C} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(185, 0, '000"B {D0CCCE32-564C-44E5-83B9-746282E2B136} {8}', '');
    execute procedure IMP_NORM_BASE_INSTALL(185, 0, '000"B {1DDC8228-F6D2-4C9F-A332-AE55202F3D92} {T}', '');
    execute procedure IMP_NORM_BASE_INSTALL(185, 0, '000"B {C5F1B57C-378E-488F-A6F9-EC240CD95904} {n}', '');
    execute procedure IMP_NORM_BASE_INSTALL(186, 0, '000"B {D20CD605-6F3B-4F03-B8DD-E3BD1BD73D3F} {-}', '');
    execute procedure IMP_NORM_BASE_INSTALL(188, 0, '000"B {AE22EE6B-3E64-44E6-814A-D516D742D87D} {' || _win1251 x'5E' ||'}', ''); -- 94(0x5E)  
    execute procedure IMP_NORM_BASE_INSTALL(188, 0, '000"B {4F6F1E1A-4645-4F48-BB0C-060F35EAD6F4} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {6307541C-EAF4-48C8-8C55-B9BA177B7777} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {E4006D4E-8EAA-41D9-A44A-3E257DF6DE0B} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {D70F18AB-621D-4EFE-8D1D-71F8C64093C9} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {0349D9B8-7271-49E7-91E7-D39EE817CC75} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {958C22A9-F2E3-4FF3-A141-B7FE0480D82D} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {059EE6FC-C615-4765-B732-2A0E4FFBECD1} {x}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {69B13D01-D955-4C33-9E41-F44216F1F0D6} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {C0C7F194-2525-4153-A0EB-5394A96C7340} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {E7C375DF-545F-4144-8537-C7D54BC79AB4} {Z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(189, 0, '000"B {C6E74BE0-D290-4B17-A547-4E1F2CAF5CC0} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(190, 0, '000"B {A7006C47-46F0-4B0E-8912-FD49B7D83C85} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(190, 0, '000"B {901501B5-B1A8-465D-992A-E9B8E421A7A7} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(190, 0, '000"B {8A689C45-4304-46F1-9164-6DBDDEEB001F} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(190, 0, '000"B {9B73033C-62BB-4F04-9A06-E732537335F0} {n}', '');
    execute procedure IMP_NORM_BASE_INSTALL(191, 0, '000"B {374BD08A-C02E-4FC2-BCBC-D55CE22868BE} {0}', '');
    execute procedure IMP_NORM_BASE_INSTALL(191, 0, '000"B {F768C0D2-9A16-4C7D-9374-970214D27E54} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(192, 0, '000"B {4A6BC0E2-1088-45DC-A57A-C7C0F820D63B} {Y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(193, 0, '000"B {F3121213-90F6-497F-AC41-9A87BC0B8C43} {4}', '');
    execute procedure IMP_NORM_BASE_INSTALL(193, 0, '000"B {B87260BA-ED04-45AE-8685-8F7621576156} {&}', '');
    execute procedure IMP_NORM_BASE_INSTALL(193, 0, '000"B {6194B102-C453-4D2D-8BBA-BB96098FC58A} {U}', '');
    execute procedure IMP_NORM_BASE_INSTALL(194, 0, '000"B {E543C677-00A4-4927-A60D-D8A5BA1A3068} {-}', '');
    execute procedure IMP_NORM_BASE_INSTALL(194, 0, '000"B {C55FDAFB-CB88-4BDC-8D48-90562579C26E} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(194, 0, '000"B {FFCD96FD-2FA3-485A-8C40-6A77FAA03B70} {+}', '');
    execute procedure IMP_NORM_BASE_INSTALL(195, 0, '000"B {DE00AB96-64FD-434E-9C71-F49016A9E699} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(195, 0, '000"B {F9B421AF-BA08-43AF-B646-9811AE737733} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(196, 0, '000"B {FF32CC61-962C-4FBC-A0AE-6D456D47A699} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(196, 0, '000"B {D79A5D40-DD77-4664-B041-E1F008110411} {d}', '');
    execute procedure IMP_NORM_BASE_INSTALL(197, 0, '000"B {673C59BA-5065-4FAA-831A-E4BA7E9CD2C8} {y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(198, 0, '000"B {06714F89-CAE4-4D73-9D4E-92706C28A13E} {D}', '');
    execute procedure IMP_NORM_BASE_INSTALL(199, 0, '000"B {E7075646-CD04-4334-B36A-90A87E6B7583} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(200, 0, '000"B {1B3A9D21-0D0A-42BB-A560-0762DD2AD0B4} {=}', '');
    execute procedure IMP_NORM_BASE_INSTALL(200, 0, '000"B {83615944-CF33-4B68-9477-A8BFEECD4F0B} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(201, 0, '000"B {54CA371E-0FF3-46B1-89DD-6F2DCE3BD55B} {*}', '');
    execute procedure IMP_NORM_BASE_INSTALL(202, 0, '000"B {EE329EA4-9C9F-4795-A260-E322A26DDBC8} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(202, 0, '000"B {F1988C20-F663-400A-B153-84EF4FD16F9D} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(203, 0, '000"B {39059F7A-C9DE-4B9A-B782-182800138747} {(}', '');
    execute procedure IMP_NORM_BASE_INSTALL(203, 0, '000"B {082199B7-3315-407D-84DE-45534DC51470} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(204, 0, '000"B {292FC14E-32A9-4F47-B84D-4941690A5B9E} {D}', '');
    execute procedure IMP_NORM_BASE_INSTALL(205, 0, '000"B {FF0234A7-AB3C-4C8D-8653-0595BBDFC860} {h}', '');
    execute procedure IMP_NORM_BASE_INSTALL(206, 0, '000"B {4EFC339C-0F83-4D5B-A1E4-283E7B6599A1} {`}', '');
    execute procedure IMP_NORM_BASE_INSTALL(207, 0, '000"B {8FB5DBF9-6035-40D4-8BCD-868EF34B6F68} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(208, 0, '000"B {4B70D56B-D1A1-48AA-9942-19A2CE6066F5} {D}', '');
    execute procedure IMP_NORM_BASE_INSTALL(208, 0, '000"B {44B2B6C3-5476-4FE0-BA32-6117AAFB48E0} {H}', '');
    execute procedure IMP_NORM_BASE_INSTALL(209, 0, '000"B {780FE47D-673D-419C-A585-964D4142CC0F} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(209, 0, '000"B {3082F6BA-CE44-4D54-B668-8BD65FD43740} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(210, 0, '000"B {B38B5EF9-A0A6-4930-9790-D1018BDC275B} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(210, 0, '000"B {F6E4206A-BC8D-4DC1-8A32-95CEC17FA7F7} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(211, 0, '000"B {202FC861-1583-456B-BBFD-9A60C7ADC532} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(211, 0, '000"B {EC397ACA-653C-47D9-AD1D-51F90C45783B} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(211, 0, '000"B {80E5042B-7CA5-482B-A54D-DF9AFA21879A} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(213, 0, '000"B {C0264924-E016-44A4-B3D5-23161214526D} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(214, 0, '000"B {CB58AFDE-E4D5-4588-A7A0-4C0C6C51D5E8} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(214, 0, '000"B {B2657BA9-902B-42B9-AA38-BD251E2F6AD7} {a}', '');
    execute procedure IMP_NORM_BASE_INSTALL(214, 0, '000"B {A283EBB1-D7F3-429E-955F-BA07BF560152} {U}', '');
    execute procedure IMP_NORM_BASE_INSTALL(215, 0, '000"B {A40F79A5-AB92-4116-8A8B-084C87A8F667} {E}', '');
    execute procedure IMP_NORM_BASE_INSTALL(216, 0, '000"B {F3845EAD-0B83-4C7E-BCFE-27FA9054A26F} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(217, 0, '000"B {D476FEA6-45A3-4884-A4B1-EAD4A47C117D} {e}', '');
    execute procedure IMP_NORM_BASE_INSTALL(217, 0, '000"B {09F500B3-1789-4393-A9CC-5E913FD9D0C5} {B}', '');
    execute procedure IMP_NORM_BASE_INSTALL(218, 0, '000"B {2B1EB5D3-CD93-4709-BF99-6909C3D198EA} {j}', '');
    execute procedure IMP_NORM_BASE_INSTALL(219, 0, '000"B {625E7B6A-885E-4BDA-969C-4790F9EC0F7B} {%}', '');
    execute procedure IMP_NORM_BASE_INSTALL(219, 0, '000"B {389F541C-B050-419A-82EE-2F4EE480C8DB} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(220, 0, '000"B {A1F16314-36C3-4BE8-BDC3-548E5CA002CE} {U}', '');
    execute procedure IMP_NORM_BASE_INSTALL(221, 0, '000"B {F02EE20C-B1EE-4588-8941-D5297739F268} {>}', '');
    execute procedure IMP_NORM_BASE_INSTALL(221, 0, '000"B {49874FBC-DFB5-408E-9813-44B42925132F} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(222, 0, '000"B {B41BB387-3A55-4C52-BC22-7C8DD1CE0F41} {W}', '');
    execute procedure IMP_NORM_BASE_INSTALL(223, 0, '000"B {4DD060FE-0FA9-45D0-96D2-EF7D4D89FDF0} {7}', '');
    execute procedure IMP_NORM_BASE_INSTALL(224, 0, '000"B {72722088-08F8-4F07-9672-14DAF6BF7F5B} {<}', '');
    execute procedure IMP_NORM_BASE_INSTALL(225, 0, '000"B {AE53BF1D-7648-49E6-9D38-8B6679CFAF57} {}}', '');
    execute procedure IMP_NORM_BASE_INSTALL(226, 0, '000"B {1BDDA8E0-75A0-42CB-87EA-1B033FD32370} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(226, 0, '000"B {19EBCB68-EDCF-4091-B901-550CBCD72739} {i}', '');
    execute procedure IMP_NORM_BASE_INSTALL(227, 0, '000"B {AE914340-6C37-4AD5-B3BE-158315D570BB} {:}', '');
    execute procedure IMP_NORM_BASE_INSTALL(228, 0, '000"B {17878653-48EF-4CB2-9D8F-EEA79570254C} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(229, 0, '000"B {87084931-1607-4CF9-8C44-DCAE54FE6D35} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(230, 0, '000"B {D85ADE27-BD6C-4A02-ADC7-C27161DAFE45} {/}', '');
    execute procedure IMP_NORM_BASE_INSTALL(231, 0, '000"B {1BE5576D-4913-44B8-9BDC-5C24CCC23E5C} {h}', '');
    execute procedure IMP_NORM_BASE_INSTALL(232, 0, '000"B {F31CA190-0932-4F8A-84C6-B0B838C3C78F} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(232, 0, '000"B {77E8374E-AE21-4FD5-95D7-757CF94047D3} {U}', '');
    execute procedure IMP_NORM_BASE_INSTALL(233, 0, '000"B {E300B6C0-879C-4D6F-9628-E6E934EA3AF4} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(233, 0, '000"B {06924B36-CC8B-49DD-BE04-740D4C362B14} {?}', '');
    execute procedure IMP_NORM_BASE_INSTALL(233, 0, '000"B {50B80AC9-02FE-4686-B12F-64255492D780} {y}', '');
    execute procedure IMP_NORM_BASE_INSTALL(234, 0, '000"B {9D8978F3-FE35-4FBE-8595-4BF61913D2C1} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(235, 0, '000"B {104EFD86-C4A2-44EE-9086-F4E802F5EFF2} {s}', '');
    execute procedure IMP_NORM_BASE_INSTALL(235, 0, '000"B {47AAF3AD-73DC-4E53-A0EC-AA347213A2EE} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(236, 0, '000"B {ED9FBF4F-1001-48AD-B747-EABE0A896757} {"}', '');
    execute procedure IMP_NORM_BASE_INSTALL(237, 0, '000"B {D338B2CF-4015-4520-BF4F-21504BB57A7B} {3}', '');
    execute procedure IMP_NORM_BASE_INSTALL(238, 0, '000"B {E25C904C-A573-4180-9F53-8FECE427FC7D} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(238, 0, '000"B {779D788E-D879-4480-B22D-B7A48CED00C7} {`}', '');
    execute procedure IMP_NORM_BASE_INSTALL(238, 0, '000"B {CBAF95D0-F982-4163-B0AC-9C179661A5F3} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(239, 0, '000"B {19AE7142-D85B-4AA8-AC01-9F9401DE8D36} {V}', '');
    execute procedure IMP_NORM_BASE_INSTALL(240, 0, '000"B {BBDB6505-2756-421F-A095-D76E7B45BFA0} {R}', '');
    execute procedure IMP_NORM_BASE_INSTALL(242, 0, '000"B {18FEB33D-9BCB-46B1-AF3A-ED9EBA9DB55B} {f}', '');
    execute procedure IMP_NORM_BASE_INSTALL(244, 0, '000"B {1E19C76B-3731-476D-B223-DEBC549862EC} {M}', '');
    execute procedure IMP_NORM_BASE_INSTALL(245, 0, '000"B {93152972-0592-43F2-9265-961F6A0CAF9B} {r}', '');
    execute procedure IMP_NORM_BASE_INSTALL(245, 0, '000"B {1910C400-13D9-46AE-89D3-2895C2F3F624} {x}', '');
    execute procedure IMP_NORM_BASE_INSTALL(245, 0, '000"B {8AABABBD-83BD-4708-9C27-30887C146456} {L}', '');
    execute procedure IMP_NORM_BASE_INSTALL(246, 0, '000"B {D3233150-D5A6-4EEA-A8F0-93FE8474B86E} {]}', '');
    execute procedure IMP_NORM_BASE_INSTALL(247, 0, '000"B {ED52DA47-25E5-4312-9C3A-78FAA709E543} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(248, 0, '000"B {027F9FF1-FC0A-407D-B7EF-B8DBA7DEF1ED} {l}', '');
    execute procedure IMP_NORM_BASE_INSTALL(249, 0, '000"B {292C67D6-955E-4502-8655-CC5781B23BFE} {8}', '');
    execute procedure IMP_NORM_BASE_INSTALL(250, 0, '000"B {7712150C-A6B5-4576-9143-921043373F26} {2}', '');
    execute procedure IMP_NORM_BASE_INSTALL(251, 0, '000"B {CB6979E1-7012-4663-856B-744B9B68216A} {u}', '');
    execute procedure IMP_NORM_BASE_INSTALL(252, 0, '000"B {4B2F9D49-2187-460E-AAE9-D3E2987ECC3A} {u}', '');
    execute procedure IMP_NORM_BASE_INSTALL(252, 0, '000"B {40C03039-7BE6-46EE-8EFF-408CF15B6824} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(253, 0, '000"B {FAA60838-7B69-4264-906D-AF145273E2D6} {1}', '');
    execute procedure IMP_NORM_BASE_INSTALL(254, 0, '000"B {8502345F-720A-466A-B9C5-B5CA63AD08F4} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(255, 0, '000"B {8B6AEC82-1E7E-434B-A76C-3C578CE901B8} {p}', '');
    execute procedure IMP_NORM_BASE_INSTALL(255, 0, '000"B {FFF64342-40A1-4705-80B3-7814FAC58C5D} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(257, 0, '000"B {8E20DAF2-B2CA-4F1C-8DCE-35FC2C786E15} {5}', '');
    execute procedure IMP_NORM_BASE_INSTALL(257, 0, '000"B {29563F56-8E47-486F-AFBD-A5C725A3A85F} {m}', '');
    execute procedure IMP_NORM_BASE_INSTALL(258, 0, '000"B {190B3CD7-691B-4502-AA2F-106B9DEE26FB} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(259, 0, '000"B {CB01C4DA-0A5B-4371-BC7C-894D01CCC114} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(260, 0, '000"B {15893671-B010-479E-9B23-E759917B0B65} {c}', '');
    execute procedure IMP_NORM_BASE_INSTALL(261, 0, '000"B {E21DB218-4D0C-457B-812D-028BE7ACC672} {J}', '');
    execute procedure IMP_NORM_BASE_INSTALL(262, 0, '000"B {AA4EA310-240B-4677-90BB-3E599CD16D4B} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(263, 0, '000"B {190C4F83-0BCE-484C-BFBD-86A99DE12238} {n}', '');
    execute procedure IMP_NORM_BASE_INSTALL(263, 0, '000"B {D930EE8F-E1DA-4BE7-A3F1-65061865D0F5} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(263, 0, '000"B {6561BAA7-6550-4339-B67E-4190BD228972} {k}', '');
    execute procedure IMP_NORM_BASE_INSTALL(263, 0, '000"B {3B80434C-02B2-4678-96D3-FBD20ED01E5E} {>}', '');
    execute procedure IMP_NORM_BASE_INSTALL(263, 0, '000"B {64BC10F8-EA5C-4092-BDB1-199F1696BD66} {\}', '');
    execute procedure IMP_NORM_BASE_INSTALL(264, 0, '000"B {28FAC9B1-1A1B-4749-8ADF-61231B3E4B03} {G}', '');
    execute procedure IMP_NORM_BASE_INSTALL(265, 0, '000"B {D9E30822-E3CE-4697-996A-3F84D170F974} {F}', '');
    execute procedure IMP_NORM_BASE_INSTALL(267, 0, '000"B {69E5DE98-D4C7-4539-B8B4-8297081D623F} {I}', '');
    execute procedure IMP_NORM_BASE_INSTALL(268, 0, '000"B {BC30193D-82A2-49B8-9949-23DF4DC06853} {3}', '');
    execute procedure IMP_NORM_BASE_INSTALL(268, 0, '000"B {118A57DB-5E4C-44E6-B85A-47E88AA2C93F} {q}', '');
    execute procedure IMP_NORM_BASE_INSTALL(268, 0, '000"B {7789A342-D12F-4FC0-B757-F743B4A49693} {9}', '');
    execute procedure IMP_NORM_BASE_INSTALL(268, 0, '000"B {96F8323E-76DF-466A-9DE3-64D30854E9AB} {a}', '');
    execute procedure IMP_NORM_BASE_INSTALL(268, 0, '000"B {4CF9D289-FA4A-4FDA-B34F-507E9980EA81} {*}', '');
    execute procedure IMP_NORM_BASE_INSTALL(269, 0, '000"B {CECC5270-4212-4FA9-8156-767B5165C29E} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(270, 0, '{1426BBC2-12A4-4ECD-8F26-9B8954063402}', '');
    execute procedure IMP_NORM_BASE_INSTALL(270, 1, '000"B {DF3835C1-EA22-4D87-8DD4-291F25C7037F} {P}', '');
    execute procedure IMP_NORM_BASE_INSTALL(270, 1, '000"B {B4E217EA-DAD8-439C-9205-498D7E58CBF7} {z}', '');
    execute procedure IMP_NORM_BASE_INSTALL(270, 2, '000"B {C912A719-5001-4D5D-BBD2-759CA0A5A221} {.}', '');
    execute procedure IMP_NORM_BASE_INSTALL(270, 2, '000"B {A32A30DE-EAB8-4621-AE00-6FAAEE25C97F} {''}', '');
    execute procedure IMP_NORM_BASE_INSTALL(270, 2, '000"B {FAB8C11B-A394-4075-A503-01FDB5E4A7CF} {e}', '');
    execute procedure IMP_NORM_BASE_INSTALL(270, 2, '000"B {0ECD785A-F475-431F-879E-164FD5336F82} {O}', '');
    execute procedure IMP_NORM_BASE_INSTALL(271, 0, '000"B {80DA1FD3-D42C-4CFE-A7F2-1EA6730BEEC8} {A}', '');
    execute procedure IMP_NORM_BASE_INSTALL(272, 0, '000"B {9B440E00-A2A1-4DB1-999F-6D64D6F55EFF} {o}', '');
    execute procedure IMP_NORM_BASE_INSTALL(272, 0, '000"B {FEAF1696-7256-4EDF-A2F6-EA7AAF8685FA} {N}', '');
    execute procedure IMP_NORM_BASE_INSTALL(273, 0, '000"B {C6AB78D4-44E3-4CE4-A1FA-0BDFE294ED26} {6}', '');
    execute procedure IMP_NORM_BASE_INSTALL(273, 0, '000"B {B8A976D0-0643-4001-96EF-23D4418A3FCE} {4}', '');
    execute procedure IMP_NORM_BASE_INSTALL(274, 0, '000"B {9A2EB10B-F1AA-43A5-8876-30D4A2705E7F} {L}', '');
    execute procedure IMP_NORM_BASE_INSTALL(274, 0, '000"B {A2F1D27D-CFDC-46DF-A15F-1D96ADE860F4} {K}', '');
    execute procedure IMP_NORM_BASE_INSTALL(275, 0, '000"B {C7F5401A-ADC9-48D2-9F94-0CBC4416A393} {X}', '');
    execute procedure IMP_NORM_BASE_INSTALL(276, 0, '000"B {8B50B57F-F7D3-4BF3-BE63-61BBB468DF27} {!}', '');
    execute procedure IMP_NORM_BASE_INSTALL(276, 0, '000"B {0A7E7DD6-71CF-458E-A42C-F85F0D133015} {T}', '');
    execute procedure IMP_NORM_BASE_INSTALL(277, 0, '000"B {5503C275-13FA-4A1A-86C6-2929D2169012} {[}', '');
    execute procedure IMP_NORM_BASE_INSTALL(278, 0, '000"B {827719F4-286A-4271-A0F4-8B5F9DA013B4} {*}', '');

    --  
    execute procedure M_SET_LINKS_INSTALL_TO_SNB;


    execute procedure M_PUT_GLOBAL_PARAM('FILL_NORM_LINK_TFS444', 1, null, null);
  end
end
^
execute procedure M_TEMP_FILL_LINKS
^
drop procedure M_TEMP_FILL_LINKS
^^

-- Voyager TFS[475]
create or alter procedure B_READ_QUALIFIER_SBORNIK_INNER2 (
    IDUSER         integer,
    IN_IDQUALIFIER integer,
    IN_RABMAT      integer,
    IN_PODGROUP    integer,
    ISRECURSIVE    integer,
    ID_PUT_RAB     integer,
    ID_PUT_MAT     integer,
    ID_PUT_MASH    integer)
returns (
    ID integer)
AS
begin
  suspend;
end
^

create or alter procedure B_READ_QUALIFIER_SBORNIK_INNER2 (
    IDUSER         integer,
    IN_IDQUALIFIER integer,
    IN_RABMAT      integer,
    IN_PODGROUP    integer,
    ISRECURSIVE    integer,
    ID_PUT_RAB     integer,
    ID_PUT_MAT     integer,
    ID_PUT_MASH    integer)
returns (
    ID integer)
AS
declare variable IDQUALIFIER integer;
declare variable CURR_ID_PUT integer;
declare variable CURR_ID_REESTR integer;
begin
 -- Voyager TFS[405]
 --    B_READ_QUALIFIER_SBORNIK_INNER
 --  ,     B_RABMAT
 --      
 if ((IN_PODGROUP = 1) and (IN_RABMAT = 1))
 then
    for select ID
    from B_TRUD T
    where T.IDQUALIFIER = :IN_IDQUALIFIER and
          T.ORDERVIEW is not null
    into ID
    do
       suspend;
 else
 if (IN_PODGROUP > 1)
 then
    for select ID
    from B_ABC_OKP A
    where A.IDQUALIFIER = :IN_IDQUALIFIER and
          A.RABMAT = :IN_RABMAT and
          A.IDPODGROUP = :IN_PODGROUP
    into ID
    do
       suspend ;
 else
    for select R.ID, R.IDREESTR
    from B_RABMAT R
    where R.IDQUALIFIER = :IN_IDQUALIFIER and
          R.RABMAT = :IN_RABMAT and
          R.IDREESTR is not null
    into ID, :CURR_ID_REESTR
    do
    begin
       -- Voyager TFS[475]
       if (IN_RABMAT = 0) then
            CURR_ID_PUT = ID_PUT_RAB;
       else
       if (IN_RABMAT = 2) then
            CURR_ID_PUT = ID_PUT_MASH;
       else
       if (IN_RABMAT = 3) then
            CURR_ID_PUT = ID_PUT_MAT;

       if (CURR_ID_PUT > 0) then
       begin
           if (exists(
               select P.IDREESTR
               from S_SELECT_SBORNIK_FROM_PUTI(:IDUSER,:CURR_ID_PUT) P
               where P.IDREESTR = :CURR_ID_REESTR) ) then
                    Suspend;
       end
       else
           suspend ;
    end

 /* ,  ,    
    ,  ,     
     .   ,   
        */

 if (ISRECURSIVE = 1) then
 begin
   --rvs:2007/07/27 -   :     ...
   --select CHILDCOUNT
   --from B_QUALIFIER
   --where ID = :IN_IDQUALIFIER
   --into :CHILDCOUNT ;
   --if (CHILDCOUNT > 0)
   --then
      for select ID
      from B_QUALIFIER
      where IDPARENT = :IN_IDQUALIFIER
      into :IDQUALIFIER
      do
         for select ID
         from B_READ_QUALIFIER_SBORNIK_INNER2 (:IDUSER, :IDQUALIFIER,
                                                 :IN_RABMAT, :IN_PODGROUP, :ISRECURSIVE,
                                                 :ID_PUT_RAB, :ID_PUT_MAT, :ID_PUT_MASH)
         into ID
         do suspend ;
 end
end
^

create or alter procedure B_READ_QUALIFIER_RABMAT_R (
    IDUSER              integer,
    IN_IDQUALIFIER      integer,
    IN_RABMAT           integer,
    IDZONE              integer,
    IS_RECURSIVE        integer,
    SHOW_FULL_QUALIFIER integer,
    ID_PUT_RAB          integer,
    ID_PUT_MAT          integer,
    ID_PUT_MASH         integer)
returns (
    ID            integer,
    IDREESTR      integer,
    RABMAT        integer,
    ORDERVIEW     integer,
    TAB           varchar(42),
    ALTTAB        varchar(250),
    IDEDIZM       integer,
    EDIZMNAME     varchar(100),
    EDIZMFULLNAME varchar(250),
    ID_UNIQUE     integer,
    IDABCOKP      integer,
    comment varchar(42),
    OKP           varchar(42),
    RAZRAD        double precision,
    BA            double precision,
    BB            double precision,
    BC            double precision,
    BD            double precision,
    BE            double precision,
    BF            double precision,
    BG            double precision,
    BH            double precision,
    BI            double precision,
    BJ            double precision,
    PA            double precision,
    PB            double precision,
    PC            double precision,
    PD            double precision,
    PE            double precision,
    MA            double precision,
    MB            double precision,
    MC            double precision,
    MD            double precision,
    ME            double precision,
    MF            double precision,
    MG            double precision,
    MH            double precision,
    MI            double precision,
    MJ            double precision,
    MK            double precision,
    ML            double precision,
    MM            double precision,
    MN            double precision,
    MO            double precision,
    MP            double precision,
    MQ            double precision,
    MR            double precision,
    MS            double precision,
    MT            double precision,
    VRPZ          integer,
    NTR           integer,
    BRUTTO        double precision,
    NETTO         double precision,
    VB            double precision,
    VN            double precision,
    PREISK        varchar(42),
    POSPREISK     varchar(42),
    MBETON        double precision,
    MRKBETON      varchar(15),
    MMASHINE      varchar(25),
    VBETON        double precision,
    TKALK         varchar(50),
    PUNKTIND      varchar(42),
    FRTCH         varchar(250),
    FRESN         varchar(21),
    IDPOSTAV      integer,
    ISESN         smallint,
    IDWITHESN     integer,
    ZONE_BA       double precision,
    ZONE_BB       double precision,
    ZONE_BC       double precision,
    ZONE_BD       double precision,
    ZONE_BE       double precision,
    IDTCH         integer,
    IDOGL         integer,
    IDQUALIFIER   integer,
    IDSOSTAV      integer,
    IDTCARD       integer,
    IDESN         integer,
    IDPICTURE     integer,
    NAME_TITLE    blob sub_type 1 segment size 80,
    NAME_PART     blob sub_type 1 segment size 80,
    NULLBLOB      blob sub_type 1 segment size 80,
    IDNAME        integer,
    REESTRNAME    varchar(250),
    FOLDERNAME    varchar(250),
    NORM_GUID     varchar(100))
AS
declare variable L_IDQUALIFIER integer;
declare variable L_IDPARENT integer;
declare variable IDPARENT_PARENT integer;
BEGIN
  --   B_READ_QUALIFIER_RABMAT.    (  )
  --  SHOW_FULL_QUALIFIER:
  -- 0 -   ,      
  -- 1 -      , ..     "" 
  L_IDQUALIFIER = IN_IDQUALIFIER;
  if (SHOW_FULL_QUALIFIER = 1) then --  ""  
  begin
      select coalesce(Q.IDPARENT,0) from B_QUALIFIER Q where Q.ID = :L_IDQUALIFIER into :L_IDPARENT;
      select coalesce(Q.IDPARENT,0) from B_QUALIFIER Q where Q.ID = :L_IDPARENT into :IDPARENT_PARENT;
      while (IDPARENT_PARENT > 0) do
      begin
          L_IDQUALIFIER = L_IDPARENT;
          L_IDPARENT = :IDPARENT_PARENT;
          IDPARENT_PARENT = 0;
          select coalesce(Q.IDPARENT,0) from B_QUALIFIER Q where Q.ID = :L_IDPARENT into :IDPARENT_PARENT;
      end
  end

  -- Voyager TFS[475]
  -- B_READ_QUALIFIER_SBORNIK_INNER -> B_READ_QUALIFIER_SBORNIK_INNER2
  FOR SELECT ID
  FROM B_READ_QUALIFIER_SBORNIK_INNER2 (:IDUSER, :L_IDQUALIFIER, :IN_RABMAT, 1, :IS_RECURSIVE,
    :ID_PUT_RAB, :ID_PUT_MAT, :ID_PUT_MASH) -- <-- Voyager TFS[475]
  INTO ID
  DO
    FOR SELECT
        IDREESTR, RABMAT, ORDERVIEW, TAB, ALTTAB, IDOGL, IDQUALIFIER,
        IDTCH, FRTCH, IDSOSTAV, ID_UNIQUE, IDEDIZM, IDABCOKP,
        COMMENT, OKP, IDTCARD, IDESN, FRESN, RAZRAD,
        BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC,
        PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK,
        ML, MM, MN, MO, MP, MQ, MR, MS, MT, VRPZ, NTR,
        BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
        MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, PUNKTIND,
        IDPOSTAV, ISESN, IDWITHESN, EDIZMNAME, EDIZMFULLNAME,
        ZONE_BA/*[10651]*/, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE, NAME_TITLE, NAME_PART,
        IDNAME
    FROM B_READ_RECORD_RABMAT (:IDUSER, :ID, :IDZONE, 1)
    INTO IDREESTR, RABMAT, ORDERVIEW, TAB, ALTTAB, IDOGL, IDQUALIFIER,
         IDTCH, FRTCH, IDSOSTAV, ID_UNIQUE, IDEDIZM, IDABCOKP,
         COMMENT, OKP, IDTCARD, IDESN, FRESN, RAZRAD,
         BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC,
         PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK,
         ML, MM, MN, MO, MP, MQ, MR, MS, MT, VRPZ, NTR,
         BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
         MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, PUNKTIND,
         IDPOSTAV, ISESN, IDWITHESN, EDIZMNAME, EDIZMFULLNAME,
         ZONE_BA/*[10651]*/, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE, NAME_TITLE, NAME_PART,
         IDNAME
    DO BEGIN
         SELECT REESTRNAME, FOLDERNAME
         FROM B_READ_REESTR_NAME (:IDUSER, :IDREESTR)
         INTO REESTRNAME, FOLDERNAME ;

         SELECT NORM_GUID
         FROM B_REESTR
         WHERE ID = :IDREESTR
         INTO NORM_GUID ;

         SUSPEND ;
    END
END
^

create or alter procedure B_READ_QUALIFIER_RABMAT_EX_R (
    IDUSER              integer,
    IN_IDQUALIFIER      integer,
    IN_RABMAT           integer,
    IDZONE              integer,
    NEEDCALCUSESCOUNT   integer,
    IS_RECURSIVE        integer,
    SHOW_FULL_QUALIFIER integer)
returns (
    ID             integer,
    IDREESTR       integer,
    RABMAT         integer,
    ORDERVIEW      integer,
    TAB            varchar(42),
    ALTTAB         varchar(250),
    IDEDIZM        integer,
    EDIZMNAME      varchar(100),
    EDIZMFULLNAME  varchar(250),
    ID_UNIQUE      integer,
    IDABCOKP       integer,
    comment varchar(42),
    OKP            varchar(42),
    RAZRAD         double precision,
    BA             double precision,
    BB             double precision,
    BC             double precision,
    BD             double precision,
    BE             double precision,
    BF             double precision,
    BG             double precision,
    BH             double precision,
    BI             double precision,
    BJ             double precision,
    PA             double precision,
    PB             double precision,
    PC             double precision,
    PD             double precision,
    PE             double precision,
    MA             double precision,
    MB             double precision,
    MC             double precision,
    MD             double precision,
    ME             double precision,
    MF             double precision,
    MG             double precision,
    MH             double precision,
    MI             double precision,
    MJ             double precision,
    MK             double precision,
    ML             double precision,
    MM             double precision,
    MN             double precision,
    MO             double precision,
    MP             double precision,
    MQ             double precision,
    MR             double precision,
    MS             double precision,
    MT             double precision,
    VRPZ           integer,
    NTR            integer,
    BRUTTO         double precision,
    NETTO          double precision,
    VB             double precision,
    VN             double precision,
    PREISK         varchar(42),
    POSPREISK      varchar(42),
    MBETON         double precision,
    MRKBETON       varchar(15),
    MMASHINE       varchar(25),
    VBETON         double precision,
    TKALK          varchar(50),
    PUNKTIND       varchar(42),
    FRTCH          varchar(250),
    FRESN          varchar(21),
    IDPOSTAV       integer,
    ISESN          smallint,
    IDWITHESN      integer,
    ZONE_BA        double precision,
    ZONE_BB        double precision,
    ZONE_BC        double precision,
    ZONE_BD        double precision,
    ZONE_BE        double precision,
    IDTCH          integer,
    IDOGL          integer,
    IDQUALIFIER    integer,
    IDSOSTAV       integer,
    IDTCARD        integer,
    IDESN          integer,
    IDPICTURE      integer,
    NAME_TITLE     blob sub_type 1 segment size 80,
    NAME_PART      blob sub_type 1 segment size 80,
    NULLBLOB       blob sub_type 1 segment size 80,
    REESTRNAME     varchar(250),
    FOLDERNAME     varchar(250),
    ISMAINMATERIAL integer,
    USESCOUNT      integer)
AS
DECLARE VARIABLE IDMAIN INTEGER;
BEGIN
  --   B_READ_QUALIFIER_RABMAT_EX.    (  )
  --  SHOW_FULL_QUALIFIER:
  -- 0 -   ,      
  -- 1 -      , ..     "" 

  SELECT ID
  FROM B_READ_QUALIFIER_IDMAIN(:IDUSER, :IN_IDQUALIFIER, :IN_RABMAT)
  INTO IDMAIN;

  FOR SELECT
     ID, IDREESTR, RABMAT, ORDERVIEW, TAB, ALTTAB, IDOGL, IDQUALIFIER,
     IDTCH, FRTCH, IDSOSTAV, ID_UNIQUE, IDEDIZM, IDABCOKP,
     COMMENT, OKP, IDTCARD, IDESN, FRESN, RAZRAD,
     BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC,
     PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK,
     ML, MM, MN, MO, MP, MQ, MR, MS, MT, VRPZ, NTR,
     BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
     MBETON, MRKBETON, VBETON, MMASHINE, IDPICTURE, TKALK, PUNKTIND,
     IDPOSTAV, ISESN, IDWITHESN, EDIZMNAME, EDIZMFULLNAME,
     ZONE_BA/*[10651]*/, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE, NAME_TITLE, NAME_PART,
     REESTRNAME, FOLDERNAME
  FROM B_READ_QUALIFIER_RABMAT_R (:IDUSER, :IN_IDQUALIFIER, :IN_RABMAT, :IDZONE, :IS_RECURSIVE,:SHOW_FULL_QUALIFIER
        , -1/*ID_PUT_RAB*/, -1/*ID_PUT_MAT*/, -1/*ID_PUT_MASH*/) -- Voyager CQ[475]
  INTO ID, IDREESTR, RABMAT, ORDERVIEW, TAB, ALTTAB, IDOGL, IDQUALIFIER,
      IDTCH, FRTCH, IDSOSTAV, ID_UNIQUE, IDEDIZM, IDABCOKP,
      COMMENT, OKP, IDTCARD, IDESN, FRESN, RAZRAD,
      BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, PA, PB, PC,
      PD, PE, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK,
      ML, MM, MN, MO, MP, MQ, MR, MS, MT, VRPZ, NTR,
      BRUTTO, NETTO, VB, VN, PREISK, POSPREISK,
      MBETON, MRKBETON, VBETON, MMASHINE,IDPICTURE, TKALK, PUNKTIND,
      IDPOSTAV, ISESN, IDWITHESN, EDIZMNAME, EDIZMFULLNAME,
      ZONE_BA/*10651*/, ZONE_BB, ZONE_BC, ZONE_BD, ZONE_BE, NAME_TITLE, NAME_PART,
      REESTRNAME, FOLDERNAME
  DO BEGIN
    IF (ID = IDMAIN)
    THEN ISMAINMATERIAL = 1;
    ELSE ISMAINMATERIAL = 0;

    IF (NEEDCALCUSESCOUNT = 1)
    THEN
       SELECT COUNT(*)
       FROM B_RESURS
       WHERE IDRES_RABMAT = :ID
       INTO USESCOUNT;

    SUSPEND ;
  END
END
^

create or alter procedure B_READ_QUALIFIER_SBORNIK_INNER1 (
    IDUSER         integer,
    IN_IDQUALIFIER integer,
    IN_RABMAT      integer,
    IN_PODGROUP    integer,
    ISRECURSIVE    integer,
    ID_PUT_RAB     integer,
    ID_PUT_MAT     integer,
    ID_PUT_MASH    integer)
returns (
    ID     integer,
    IDNAME integer)
AS
begin
end
^

create or alter procedure B_READ_QUALIFIER_SBORNIK_INNER1 (
    IDUSER         integer,
    IN_IDQUALIFIER integer,
    IN_RABMAT      integer,
    IN_PODGROUP    integer,
    ISRECURSIVE    integer,
    ID_PUT_RAB     integer,
    ID_PUT_MAT     integer,
    ID_PUT_MASH    integer)
returns (
    ID     integer,
    IDNAME integer)
AS
declare variable IDQUALIFIER integer;
declare variable CURR_ID_PUT integer;
declare variable CURR_ID_REESTR integer;
begin
 -- Voyager TFS[404]
 --   ,   B_READ_QUALIFIER_SBORNIK_INNER,  
 --  IDNAME
 if ((IN_PODGROUP = 1) and (IN_RABMAT = 1))
 then
    for select ID, IDNAME
    from B_TRUD T
    where T.IDQUALIFIER = :IN_IDQUALIFIER and
          T.ORDERVIEW is not null
    into :ID, :IDNAME
    do
       suspend;
 else
 if (IN_PODGROUP > 1)
 then
    for select ID, IDNAME
    from B_ABC_OKP A
    where A.IDQUALIFIER = :IN_IDQUALIFIER and
          A.RABMAT = :IN_RABMAT and
          A.IDPODGROUP = :IN_PODGROUP
    into :ID, :IDNAME
    do
       suspend ;
 else
    for select R.ID, R.IDNAME, R.IDREESTR
    from B_RABMAT R
    where R.IDQUALIFIER = :IN_IDQUALIFIER and
          R.RABMAT = :IN_RABMAT and
          R.IDREESTR is not null
    into ID, :IDNAME, :CURR_ID_REESTR
    do
    begin
       -- Voyager TFS[475]
       if (IN_RABMAT = 0) then
            CURR_ID_PUT = ID_PUT_RAB;
       else
       if (IN_RABMAT = 2) then
            CURR_ID_PUT = ID_PUT_MASH;
       else
       if (IN_RABMAT = 3) then
            CURR_ID_PUT = ID_PUT_MAT;

       if (CURR_ID_PUT > 0) then
       begin
           if (exists(
               select P.IDREESTR
               from S_SELECT_SBORNIK_FROM_PUTI(:IDUSER,:CURR_ID_PUT) P
               where P.IDREESTR = :CURR_ID_REESTR) ) then
                    Suspend;
       end
       else
           suspend ;
    end

 /* ,  ,    
    ,  ,     
     .   ,   
        */

 if (ISRECURSIVE = 1) then
 begin
   --rvs:2007/07/27 -   :     ...
   --select CHILDCOUNT
   --from B_QUALIFIER
   --where ID = :IN_IDQUALIFIER
   --into :CHILDCOUNT ;
   --if (CHILDCOUNT > 0)
   --then
      for select ID
      from B_QUALIFIER
      where IDPARENT = :IN_IDQUALIFIER
      into :IDQUALIFIER
      do
         for select ID, IDNAME
         from B_READ_QUALIFIER_SBORNIK_INNER1 (:IDUSER, :IDQUALIFIER,
                                                 :IN_RABMAT, :IN_PODGROUP, :ISRECURSIVE,
                                                 :ID_PUT_RAB, :ID_PUT_MAT, :ID_PUT_MASH)
         into :ID, :IDNAME
         do suspend ;
 end
end
^

create or alter procedure B_READ_QUALIFIER_RABMAT_NAMES_R (
    IDUSER              integer,
    IN_IDQUALIFIER      integer,
    IN_RABMAT           integer,
    IDZONE              integer,
    IS_RECURSIVE        integer,
    SHOW_FULL_QUALIFIER integer,
    ID_PUT_RAB          integer,
    ID_PUT_MAT          integer,
    ID_PUT_MASH         integer)
returns (
    ID        integer,
    IDNAME    integer,
    SUB_ORDER integer,
    SUB_STR   varchar(100))
AS
declare variable L_IDQUALIFIER integer;
declare variable L_IDPARENT integer;
declare variable IDPARENT_PARENT integer;
begin
  -- Voyager TFS[404]
  --   B_READ_QUALIFIER_RABMAT_R  B_READ_QUALIFIER_RABMAT_NAMES
  --            
  -- Voyager TFS[475]
  -- :       
  L_IDQUALIFIER = IN_IDQUALIFIER;
  if (SHOW_FULL_QUALIFIER = 1) then --  ""  
  begin
      select coalesce(Q.IDPARENT,0) from B_QUALIFIER Q where Q.ID = :L_IDQUALIFIER into :L_IDPARENT;
      select coalesce(Q.IDPARENT,0) from B_QUALIFIER Q where Q.ID = :L_IDPARENT into :IDPARENT_PARENT;
      while (IDPARENT_PARENT > 0) do
      begin
          L_IDQUALIFIER = L_IDPARENT;
          L_IDPARENT = :IDPARENT_PARENT;
          IDPARENT_PARENT = 0;
          select coalesce(Q.IDPARENT,0) from B_QUALIFIER Q where Q.ID = :L_IDPARENT into :IDPARENT_PARENT;
      end
  end

  FOR SELECT ID, IDNAME
  FROM B_READ_QUALIFIER_SBORNIK_INNER1 (:IDUSER, :L_IDQUALIFIER, :IN_RABMAT, 1, :IS_RECURSIVE,
    :ID_PUT_RAB, :ID_PUT_MAT, :ID_PUT_MASH)
  INTO :ID, :IDNAME
  DO
  begin
      for select SUB_ORDER, SUB_STR
      from S_SELECT_FROM_NAME(:IDNAME)
      into :SUB_ORDER, :SUB_STR do
         suspend;
  end
END
^

-- TFS[588]
create or alter procedure M_TEMP_ALTER_TABLE
AS
begin
   -- Alter table S_LZTEMPLATES --------------------------------------------
   if (not exists(
   select *
   from RDB$RELATION_FIELDS f
   where (UPPER(f.rdb$relation_name) = 'S_LZTEMPLATES') and (UPPER(f.rdb$field_name) = 'IDUSER'))) then
   begin
     execute statement 'ALTER TABLE S_LZTEMPLATES ADD IDUSER A_INTEGER';
   end
   if (not exists(
   select * from rdb$indices i
   where (UPPER(i.rdb$relation_name) = 'S_LZTEMPLATES' and upper(i.RDB$INDEX_NAME) = 'S_LZTEMPLATES_IDUSER_PARENTID'))) then
   begin
     execute statement 'CREATE INDEX S_LZTEMPLATES_IDUSER_PARENTID ON S_LZTEMPLATES (IDUSER, PARENTID)';
   end
end
^
execute procedure M_TEMP_ALTER_TABLE
^
drop procedure M_TEMP_ALTER_TABLE
^^

create or alter procedure V_LZTEMPLATESELECT (
    IDUSER integer,
    IN_PARENTID integer)
returns (
    ID integer,
    PARENTID integer,
    ATYPE integer,
    FNAME varchar(250))
as
begin
    -- Voyager CQ[12370]
    -- IN_PARENTID: ID 
    for select T.ID, T.FNAME, T.ATYPE, T.PARENTID  from S_LZTEMPLATES T
    where T.PARENTID = :IN_PARENTID
    order by T.ATYPE, T.FNAME
    into :ID, :FNAME, :ATYPE, :PARENTID do
    begin
        suspend;
        if (ATYPE = 0/*FolderType*/) then
            for select ID, PARENTID, ATYPE, FNAME
            from V_LZTEMPLATESELECT(:IDUSER, :ID)
            into :ID, :PARENTID, :ATYPE, :FNAME do
                suspend;
    end
end^

create or alter procedure V_LZTEMPLATE_FILTER_BY_USER (
    IDBASE integer,
    FILTER_USER integer,
    IDUSER integer)
returns (
    ID integer)
as
begin
    FILTER_USER = coalesce(:FILTER_USER, 0);
    if (FILTER_USER = 0) then
        for select T.ID from S_LZTEMPLATES T
        where T.PARENTID = :IDBASE
        order by T.ATYPE, T.FNAME
        into :ID do suspend;
    else
        for select T.ID from S_LZTEMPLATES T
        where T.PARENTID = :IDBASE and T.IDUSER = :IDUSER
        order by T.ATYPE, T.FNAME
        into :ID do suspend;
end
^

create or alter procedure V_LZTEMPLATESELECT_ALL (
    IDUSER integer,
    SHOW_HIER integer,
    FILTER_USER integer)
returns (
    ID integer,
    PARENTID integer,
    ATYPE integer,
    IDBASE integer,
    FNAME varchar(250),
    DEF integer)
as
declare variable DEF0 integer;
declare variable DEF1 integer;
declare variable DEF2 integer;
declare variable DEF3 integer;
begin
    -- Voyager CQ[12370]
    --      
    --      

    /* SHOW_HIER = 1    */
    /* SHOW_HIER = 0    */
    SHOW_HIER = coalesce(:SHOW_HIER, 0);

    for select N.ID, N.NAME from B_NORMTYPE N into :IDBASE, :FNAME do
    begin
        ATYPE = 48; -- VNBType
        ID = :IDBASE;
        DEF = 0;
        PARENTID = 0;
        suspend;

        execute procedure S_LZTEMPLDEFSELECT (:IDUSER, :IDBASE)
            returning_values :DEF0, :DEF1, :DEF2, :DEF3;

        -- TFS[588]
        FILTER_USER = coalesce(:FILTER_USER, 0);

        for select T.ID, T.FNAME, T.ATYPE, T.PARENTID from v_lztemplate_filter_by_user(:IDBASE, :FILTER_USER, :IDUSER) F
        join S_LZTEMPLATES T on T.ID = F.ID
        into :ID, :FNAME, :ATYPE, :PARENTID do
        begin

            DEF = 0;

            if (:ATYPE = 0/*FolderType*/) then
            begin
                if (SHOW_HIER = 0) then
                    PARENTID = :IDBASE;
                if ((SHOW_HIER = 1) or (ATYPE <> 0/*FolderType */)) then
                    suspend;

                for select ID, PARENTID, ATYPE, FNAME
                from V_LZTEMPLATESELECT(:IDUSER, :ID)
                into :ID, :PARENTID, :ATYPE, :FNAME do
                begin
                    DEF = 0;
                    if (DEF3 = ID) then DEF = DEF + 1; /*  */
                    DEF = DEF * 2;
                    if (DEF2 = ID) then DEF = DEF + 1; /*  */
                    DEF = DEF * 2;
                    if (DEF1 = ID) then DEF = DEF + 1; /*   */
                    DEF = DEF * 2;
                    if (DEF0 = ID) then DEF = DEF + 1; /*  */

                    if (SHOW_HIER = 0) then
                        PARENTID = :IDBASE;

                    if ((SHOW_HIER = 1) or (ATYPE <> 0/*FolderType */)) then
                        suspend;
                end
             end
             else
             begin
                 if (DEF3 = ID) then DEF = DEF + 1; /*  */
                 DEF = DEF * 2;
                 if (DEF2 = ID) then DEF = DEF + 1; /*  */
                 DEF = DEF * 2;
                 if (DEF1 = ID) then DEF = DEF + 1; /*   */
                 DEF = DEF * 2;
                 if (DEF0 = ID) then DEF = DEF + 1; /*  */
                 suspend;
             end
        end
    end
end
^

--TFS[434],TFS[443]
create or alter procedure B_EXP_INSTALL_NORM_BASE_LINKS (
    IDUSER integer,
    IN_ID integer)
returns (
    ID integer,
    INSTALL_ID integer,
    INSTALL_GUID varchar(100),
    BASE_FULL_NAME varchar(250))
AS
begin
--TFS[434],TFS[443]
 SELECT ID, BASE_FULL_NAME
 FROM B_NORM_BASE_LIST
 WHERE ID = :IN_ID
 INTO :ID, :BASE_FULL_NAME;

 IF (ID IS NOT NULL) THEN BEGIN
    FOR SELECT INSTALL_GUID
    FROM B_NORM_BASE_INSTALL
    WHERE ID_NORM_BASE = :ID
    INTO :INSTALL_GUID
    DO
       FOR SELECT ID
       FROM B_REESTR_INSTALL
       WHERE NORM_GUID = :INSTALL_GUID
       INTO :INSTALL_ID
       DO
          IF (INSTALL_ID IS NOT NULL)
          THEN SUSPEND ;
 END
end
^

--TFS[434],TFS[443]
create or alter procedure B_EXP_NORM_BASE (
    IDUSER integer,
    SOURCE_LIST blob sub_type 0 segment size 80,
    SOURCE_COUNT integer)
returns (
    ID integer,
    BASE_CODE integer,
    BASE_SUB_TYPE integer,
    BASE_FULL_NAME varchar(250))
AS
DECLARE VARIABLE INSTALL_ID INTEGER;
DECLARE VARIABLE ID_TMP INTEGER;
BEGIN
--TFS[434],TFS[443]
 ID_TMP = GEN_ID(B_GEN_TEMP, 1) ;
 INSERT INTO B_TEMP_BLOB (ID, BLOB1) VALUES (:ID_TMP, :SOURCE_LIST);
 SELECT BLOB1 FROM B_TEMP_BLOB WHERE ID = :ID_TMP INTO :SOURCE_LIST;
 DELETE FROM B_TEMP_BLOB WHERE ID = :ID_TMP ;

 FOR SELECT FVALUE
 FROM S_INTFROMBLOB_SELECT (:SOURCE_LIST, :SOURCE_COUNT)
 INTO :INSTALL_ID
 DO
    FOR SELECT ID, BASE_CODE, BASE_SUB_TYPE, NAME
    FROM B_READ_INSTALL_NORM_BASE_LINKS (:IDUSER, :INSTALL_ID)
    INTO :ID, :BASE_CODE, :BASE_SUB_TYPE, :BASE_FULL_NAME
    DO
          SUSPEND ;
END
^

--TFS[434],TFS[443]
create or alter procedure B_IMP_I_NORM_BASE (
    IDUSER integer,
    IMPMODE integer,
    IDPARENT integer,
    BASE_CODE integer,
    BASE_SUB_TYPE integer,
    BASE_FULL_NAME varchar(250))
returns (
    ID integer)
AS
begin
--TFS[434],TFS[443]
  if (:IDPARENT <> 0) then
  if (not exists(select * from B_NORM_BASE_LIST where ID=:IDPARENT)) then
    exception B_E_RESURS_NOT_FOUND
      '     .   [' || :BASE_CODE || ']';

  update or insert into B_NORM_BASE_LIST (BASE_CODE, BASE_SUB_TYPE, BASE_FULL_NAME)
    values (:BASE_CODE, :BASE_SUB_TYPE, :BASE_FULL_NAME)
    matching (BASE_CODE, BASE_SUB_TYPE)
    returning ID
  into :ID;

  suspend;
end
^

--TFS[434],TFS[443]
create or alter procedure B_WRITE_INSTALL_NORM_BASE_LINK (
    IDUSER integer,
    ID_NORM_BASE integer,
    INSTALL_GUID varchar(100))
returns (
    ID integer)
AS
BEGIN
--TFS[434],TFS[443]
 IF ((ID_NORM_BASE <> 0) AND (INSTALL_GUID <> ''))
 THEN BEGIN
    SELECT FIRST 1 ID
    FROM B_NORM_BASE_INSTALL
    WHERE (ID_NORM_BASE = :ID_NORM_BASE) AND
          (INSTALL_GUID = :INSTALL_GUID)
    INTO ID;

    IF (ID IS NULL)
    THEN BEGIN
       ID = GEN_ID(A_G_SMETA, 1) ;

       INSERT INTO B_NORM_BASE_INSTALL
          (ID, ID_NORM_BASE, INSTALL_GUID)
       VALUES
          (:ID, :ID_NORM_BASE, :INSTALL_GUID) ;
    END
 END

 SUSPEND ;
END
^

--TFS[434],TFS[443]
CREATE OR ALTER TRIGGER B_NORM_BASE_LIST_BI0 FOR B_NORM_BASE_LIST
ACTIVE BEFORE INSERT POSITION 0
AS
begin
--TFS[434],TFS[443]
  if (new.ID is null) then
    new.ID = next value for A_G_SMETA;
end
^

--TFS[502]
create or alter procedure D_GET_HIER (
    ID_USER integer,
    ROOT_ID integer,
    RETURN_ROOT integer,
    AMODE integer,
    DATA_INT integer,
    ONE_LEVEL_ONLY integer)
returns (
    ID integer,
    ID_PARENT integer,
    ATYPE integer,
    SUBTYPE integer,
    FULLNAME varchar(1024),
    SHIFR varchar(1024),
    NUMLSR_LS varchar(1024),
    UTV integer,
    CHILDCOUNT integer,
    SORTING integer,
    REVISION varchar(255))
as
--CQ[TIMUR 13931] -    SHIFR, FULLNAME, NUMLSR_LS
declare variable FPARAM_ID integer;
declare variable FIDPARENT integer;
declare variable FIDPARENT1 integer;
declare variable FBASKETTYPE integer;
declare variable FINBASKETCOUNT integer;
declare variable LYEAR integer;
declare variable LPERIOD integer;
declare variable LMONTH integer;
declare variable IDAKTCENLVL integer;
declare variable OBJCHILDCOUNT integer; /* CQ[9793] */
declare variable VN_IDCLASS integer;
declare variable VN_VIEW_DOSTUP_EXISTS integer;
declare variable VN_IS_DOSTUP_VIRTUAL integer;
begin
--AMODE = 17/*MODE_FOLDERS*/ [01.09.2017]

  REVISION = ''; --CQ[10103]    
  NUMLSR_LS = '';  --CQ[12881]
  if (ONE_LEVEL_ONLY is null) then ONE_LEVEL_ONLY = 0;

  if (AMODE is null) then
    AMODE = 0;

  if (AMODE = -1)  then
  begin
    ID = ROOT_ID;
    suspend;
    exit;
  end

  FIDPARENT = :ROOT_ID;
  if (RETURN_ROOT is null) then
    RETURN_ROOT = 0;

  if (RETURN_ROOT <> 0) then
  begin
    if ((AMODE in (0,6,8,14,15,16,17/*MODE_FOLDERS*/)) and (ROOT_ID = 0))  then  -- MK CQ[9301]  16
    begin
--      if (ROOT_ID = 0) then
      begin
        ID         = 0;
        ATYPE      = -1;
        SUBTYPE    = 0;
        if (AMODE = 8) then
        begin
          FULLNAME   = '';
          SHIFR      = '';
          ID_PARENT  = -1;
          ROOT_ID = 0;
        end
        else
        begin
          FULLNAME   = '';
          SHIFR      = '';
          ID_PARENT  = -1;
        end
        UTV        = 0;
        CHILDCOUNT = 0;
        SORTING    = 0;
        suspend;
      end
    end
    else
    if (AMODE <> 7) then
    begin
      select first 1 h.NUMBER, h.ATYPE, h.COUNTCHILDREN, SORTING
      from A_O_HIER h
      where h.NUMBER = :FIDPARENT
      into :ID, :ATYPE, :CHILDCOUNT, :SORTING;

      select p.PARAM_ID, p.FULLNAME, p.SHIFR, p.NUMLSR_LS, p.UTV, p.REVISION
      from D_GET_HIER_PARAMS(:ID, :ATYPE) p
      into :FPARAM_ID, :FULLNAME, :SHIFR, :NUMLSR_LS, :UTV, :REVISION;
      if (ID_PARENT is null) then
      suspend;
      --chinger cq[9301] ->
      -- MK 17.01.2012   CQ[9958]    
      if (:AMODE = 16) then
      begin
        for select c.ID, c.ID_PARENT, c.ATYPE, c.SUBTYPE, c.FULLNAME,
                     c.SHIFR, c.UTV, c.CHILDCOUNT, c.SORTING
        from MD_GET_OBJ_CENLVL(:ID) c
          into ID, ID_PARENT, ATYPE, SUBTYPE, FULLNAME,
               SHIFR, UTV, CHILDCOUNT, SORTING do
        begin
          SUBTYPE = 0;
          VN_IDCLASS = :ID_PARENT;
          select count(*)
          from GET_CENLVL_COMPOSE(:ID, :VN_IDCLASS ) c
          into :CHILDCOUNT;
          suspend;

          ID_PARENT = :ID;
          UTV = 0;
          SUBTYPE = 0;
          SHIFR = '';
          for select c.id, c.lorder, c.HIER_TYPE, c.name
              from GET_CENLVL_COMPOSE(:ID, :VN_IDCLASS) c
          into :ID, :SORTING, :ATYPE, :FULLNAME
          do begin
            CHILDCOUNT = 0;
            suspend;
          end
        end
      end
    end
  end
  ID_PARENT = 0;

  if ((AMODE in (6,7)) and (ROOT_ID = 0)) then -- 
  begin
    FINBASKETCOUNT = 0;
    FBASKETTYPE = 12;
    /*FIDPARENT1 = 1;*/

    --CQ[TIMUR 9332]
    EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, 1/*:FIDPARENT1*/, :FBASKETTYPE)
    RETURNING_VALUES :FIDPARENT1;

    for select ID, ID_PARENT, ATYPE, SUBTYPE, FULLNAME, SHIFR, UTV, CHILDCOUNT, SORTING
    from D_GET_HIER(:ID_USER, :FIDPARENT1, 0, 0, :DATA_INT, :ONE_LEVEL_ONLY)
    into :ID, :ID_PARENT, :ATYPE, :SUBTYPE, :FULLNAME, :SHIFR, :UTV, :CHILDCOUNT, :SORTING
    do
    begin
      FINBASKETCOUNT = :FINBASKETCOUNT + 1;
      if ((AMODE = 7) and (ID_PARENT = 1)) then
        ID_PARENT = 0;
      else
      if (FIDPARENT1 = ID_PARENT) then
        ID_PARENT = 1; --CQ[TIMUR 9332]

      FBASKETTYPE = 13;
      suspend;
    end
    if (AMODE = 7) then
    begin
      ID         = 0;
      ID_PARENT  = -1;
    end
    else
    begin
      ID         = 1;
      ID_PARENT  = 0;
    end
    ATYPE      = :FBASKETTYPE;
    SUBTYPE    = 0;
    FULLNAME   = '';
    SHIFR      = '';
    UTV        = 0;
    CHILDCOUNT = :FINBASKETCOUNT;
    SORTING    = 0;
    suspend;

    if (AMODE = 7) then
      exit;
    AMODE = 0;
  end

  --CQ[TIMUR 9332]
  IF ((ID_PARENT = 0) AND (ID_USER < 0)) then

    EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, :FIDPARENT,
        --iif(:AMODE = 17/*MODE_FOLDERS*/, 0/*MODE_OBJECTS*/, :AMODE) --  case when :AMODE=17 then 0 else :AMODE end
        decode(:AMODE, 17/*MODE_FOLDERS*/, 0/*MODE_OBJECTS*/, :AMODE) --  case :AMODE when 17 then 0 else :AMODE end
        )
    RETURNING_VALUES :FIDPARENT;

  if ((FIDPARENT = 0) and (AMODE = 8) and (ROOT_ID = 0)) then
    FIDPARENT = 2;

  for select h.NUMBER, h.ATYPE, h.SUBTYPE, h.COUNTCHILDREN, h.SORTING
    from A_O_HIER h
    where h.PARENT = :FIDPARENT
    order by h.SORTING
    into :ID, :ATYPE, :SUBTYPE, :CHILDCOUNT, :SORTING
  do
  begin
    ID_PARENT = ROOT_ID;
    if (
    --   ( ,      
    -- MK 12.11.2011 CQ[9446] +     (AMODE = 14)
       ((AMODE in (0,6,14,16)) and (((:ATYPE = 0)and((:SUBTYPE is null)or(:SUBTYPE = 0))) or (:ATYPE = 1)))
    -- 
    or ((AMODE = 17/*MODE_FOLDERS*/) and ((:ATYPE = 0)and((:SUBTYPE is null)or(:SUBTYPE = 0))))
    --    
--    or ((AMODE = 6) and (((:ATYPE = 0)and((:SUBTYPE is null)or(:SUBTYPE = 0))) or (:ATYPE = 1)))
    -- 
    or ((AMODE = 1) and ((:ATYPE = 0) or (:ATYPE = 3) or (:ATYPE = 4) or (:ATYPE = 5)))

    or ( (AMODE = 2)  and ((:ATYPE = 18) or (:ATYPE = 19) or (:ATYPE = 8)))
    --    (AMODE = 15) CQ[9793]
    or ((AMODE = 15) and ((:ATYPE = 18) or (:ATYPE = 19) or (:ATYPE = 8) or (:ATYPE = 1) or ((:ATYPE = 0) and ((:SUBTYPE is null)or(:SUBTYPE = 0)))))
    --M29  
    or ((AMODE = 3) and (((:ATYPE = 0)and(:SUBTYPE = 9)) or (:ATYPE = 9)))
    --  
    or ((AMODE = 4) and (((:ATYPE = 0)and(:SUBTYPE = 10)) or (:ATYPE = 10)))
    --3  
    or ((AMODE = 5) and (((:ATYPE = 0)and(:SUBTYPE = 11)) or (:ATYPE = 11)))
    --
    or ((AMODE = 8)
      and
      ((((:ATYPE = 0)and(:SUBTYPE = 33)) or (:ATYPE = 33)
      or (:ATYPE = 18) or (:ATYPE = 19) or (:ATYPE = 8)
      or ((:ATYPE = 0)and((:SUBTYPE is null) or (:SUBTYPE = 0))) or (:ATYPE = 1))))

      )
    then
    begin
      -- MK CQ[14654] --->
      VN_VIEW_DOSTUP_EXISTS = 1;
         --      
      if ((DATA_INT = 1) and
         --       
          ((:ATYPE = 1) or ((:ATYPE = 0) and (coalesce(:SUBTYPE, 0) = 0)))
         ) then
      begin
        -- 37 = DD_VIEW_OBJORFOLDER (. D_Dostup.pas)
        -- TFS[502] + ABS
        execute procedure D_GET_DOSTUP2(ABS(:ID_USER), 37, :ID)
        returning_values :VN_VIEW_DOSTUP_EXISTS, :VN_IS_DOSTUP_VIRTUAL;
      end

      if (VN_VIEW_DOSTUP_EXISTS = 1) then
      begin
      -- MK CQ[14654] <---
        select p.PARAM_ID, p.FULLNAME, p.SHIFR, p.NUMLSR_LS, p.UTV, p.REVISION
        from D_GET_HIER_PARAMS(:ID, :ATYPE) p
        into :FPARAM_ID, :FULLNAME, :SHIFR, :NUMLSR_LS, :UTV, :REVISION;
  
        /* MK CQ[3328] 27.04.2006 ---> */
        /*  ,       - - */
        if ((AMODE = 1) and (DATA_INT is not null) and (DATA_INT > 16)) then
        begin
           execute procedure M_H_GET_UTV(:ID, :ATYPE, :DATA_INT)
           returning_values :UTV;
        end
        /* MK <--- */
  
        if ((AMODE = 15) and (:ATYPE = 8)) then
          CHILDCOUNT = 2;
        suspend;
  
  
        FIDPARENT1 = :ID;
  
        -- MK 12.11.2011 CQ[9446] --->
        if (
              ((AMODE = 14) and (:ATYPE = 1))
           or ((AMODE = 15) and (:ATYPE in (1,8)))
           or (AMODE = 16)
           )   --CQ[9793]
        then
        begin
          --CQ[9793]-->
          ObjChildCount = 0;
          if ((AMODE = 15) and (ATYPE = 1)) then
            ObjChildCount = CHILDCOUNT;
          --CQ[9793]<--
          --chinger cq[9301] ->
          -- MK 17.01.2012   CQ[9958]    
          for select c.ID, c.ID_PARENT, c.ATYPE, c.SUBTYPE, c.FULLNAME,
                     c.SHIFR, c.UTV, c.CHILDCOUNT, c.SORTING
          from MD_GET_OBJ_CENLVL(:FIDPARENT1) c
          into ID, ID_PARENT, ATYPE, SUBTYPE, FULLNAME,
               SHIFR, UTV, CHILDCOUNT, SORTING do
          begin
            if (AMODE = 15) then
              SUBTYPE = 0;
            if (AMODE = 16) then
            begin
              SUBTYPE = 0;
              select count(*)
              from GET_CENLVL_COMPOSE(:ID, :ID_PARENT) c
              into :CHILDCOUNT;
            end
            suspend;
            if (AMODE = 16) then
            begin
              UTV = 0;
              SUBTYPE = 0;
              SHIFR = '';
              ID_PARENT = :ID;
              for select c.id, c.lorder, c.HIER_TYPE, c.name
                  from GET_CENLVL_COMPOSE(:ID, :FIDPARENT1) c
              into :ID, :SORTING, :ATYPE, :FULLNAME
              do begin
                CHILDCOUNT = 0;
                suspend;
              end
            end
          end
          --CQ[9793]-->
          if ((AMODE = 15) and (ObjChildCount > 0)) then
            CHILDCOUNT = ObjChildCount;
          --CQ[9793]<--
  
  /*
          --       
          execute procedure M_GET_AKT_CENLVL(:ID) returning_values :IdAktCenLvl;
          if (IdAktCenLvl is null) then IdAktCenLvl = 0;
  
          CHILDCOUNT = 0;
          ATYPE = 44;
          ID_PARENT = :ID;
          --    
          for select l.id, l.lorder, l.lyear, l.lperiod, l.lmonth, l.name
          from level_cost l
          where (l.idobject = :ID_PARENT)
          order by l.lorder
          into :ID, :SORTING, :lYear, :lPeriod, :lMonth, :FULLNAME do
          begin
            --   (__)    
            if ((lYear is null) or (lYear < 0) or (lYear > 9999)) then
              lYear = 0;
            if ((lPeriod is null) or (lPeriod < 1) or (lPeriod > 4)) then
              lPeriod = 0;
            if ((lMonth is null) or (lMonth < 1) or (lMonth > 12)) then
              lMonth = 0;
  
            SHIFR = cast(:lYear as varchar(4)) || '_';
            SHIFR = SHIFR || cast(:lPeriod as varchar(1)) || '_';
            SHIFR = SHIFR || cast(:lMonth as varchar(2));
  
            --      
            if (:ID = :IdAktCenLvl) then
              SUBTYPE = 1;
            else
              SUBTYPE = 0;
  
            suspend;
          end
  */
        end
        -- MK 12.11.2011 CQ[9446] <---
  
  
        if ((ONE_LEVEL_ONLY = 0) and ((CHILDCOUNT > 0) or ((AMODE = 8)and(ATYPE = 33))))  then
          for select ID, ID_PARENT, ATYPE, SUBTYPE, FULLNAME, SHIFR, NUMLSR_LS, UTV, CHILDCOUNT, SORTING, REVISION
          from D_GET_HIER(:ID_USER, :FIDPARENT1, 0, :AMODE, :DATA_INT, :ONE_LEVEL_ONLY)
          into :ID, :ID_PARENT, :ATYPE, :SUBTYPE, :FULLNAME, :SHIFR, :NUMLSR_LS, :UTV, :CHILDCOUNT, :SORTING, :REVISION
          do
            suspend;

      end -- MK CQ[14654]
    end
  end
end
^

create or alter procedure B_WRITE_ONE_NORM_BASE (
    IDUSER integer,
    BASE_CODE integer,
    BASE_SUB_TYPE integer,
    BASE_FULL_NAME varchar(250))
returns (
    ID integer)
AS
begin
  ID = null;
  select ID from B_NORM_BASE_LIST
    where BASE_CODE = :BASE_CODE and
          BASE_SUB_TYPE = :BASE_SUB_TYPE
  into :ID;

  if (ID is null) then
  begin
    ID = next value for A_G_SMETA;  --TFS[434],TFS[443] gen_id(B_GEN_TEMP, 1) ;
 
    insert into B_NORM_BASE_LIST (ID, BASE_CODE, BASE_SUB_TYPE, BASE_FULL_NAME)
    values (:ID, :BASE_CODE, :BASE_SUB_TYPE, :BASE_FULL_NAME);
  end
  else
  begin
    update B_NORM_BASE_LIST
      set BASE_FULL_NAME = :BASE_FULL_NAME
    where (ID = :ID);
  end
end
^

--TFS[385]
create or alter procedure B_READ_DOCUMENT (
    IDUSER integer,
    ID integer,
    IDNORMY integer,
    RABMAT integer,
    PODGROUP integer,
    DOCTYPE integer)
returns (
    DOCEXISTS integer,
    NAME varchar(250),
    CONTENTS blob sub_type 1 segment size 80,
    PATHTOFILE blob sub_type 1 segment size 80,
    FINDFRAGMENT varchar(250),
    POKAZ varchar(8),
    GOD integer,
    NOMER integer,
    ISSYSTEM_MASK smallint)
AS
DECLARE VARIABLE IDREESTR INTEGER;
DECLARE VARIABLE IDCONTENTS INTEGER;
BEGIN
 IF (ID = 0)
 THEN ID = NULL ;

 IF (IDNORMY  = 0)
 THEN IDNORMY  = NULL ;

 IF (ID IS NULL)  THEN
    IF ((IDNORMY IS NOT NULL) AND (RABMAT <> 1)) THEN BEGIN
       IF (:PODGROUP > 1)
       THEN
          SELECT IDNORMA
          FROM B_ABC_OKP
          WHERE ID = :IDNORMY
          INTO :IDNORMY ;

       IF (IDNORMY IS NOT NULL) THEN BEGIN
          IF (DOCTYPE = 100) THEN BEGIN
             SELECT IDTCH, TAB, /*TFS[385] FRTCH*/ IDREESTR
             FROM B_RABMAT
             WHERE ID = :IDNORMY
             INTO :ID, :FINDFRAGMENT, :IDREESTR ;

             IF (ID IS NULL) THEN
                SELECT IDTCH
                FROM B_REESTR
                WHERE ID = :IDREESTR
                INTO :ID ;
          END
          ELSE
          IF (DOCTYPE = 101) THEN BEGIN
             SELECT IDESN, FRESN
             FROM B_RABMAT
             WHERE ID = :IDNORMY
             INTO :ID, :FINDFRAGMENT ;
          END ELSE
          IF (DOCTYPE = 103) THEN BEGIN
             SELECT IDTCARD
             FROM B_RABMAT
             WHERE ID = :IDNORMY
             INTO :ID ;
          END
       END
    END

 DOCEXISTS = 0;
 IF (ID IS NOT NULL)
 THEN
    FOR SELECT ID, NAME, IDCONTENTS, PATHTOFILE, POKAZ, GOD, NOMER,
               ISSYSTEM -- MK CQ[15721]
    FROM B_REESTR_DOC
    WHERE ID = :ID
    INTO :ID, :NAME, :IDCONTENTS, :PATHTOFILE, :POKAZ, :GOD, :NOMER,
         :ISSYSTEM_MASK -- MK CQ[15721]
    DO BEGIN
       DOCEXISTS = 1;

       IF (IDCONTENTS IS NOT NULL)
       THEN
          SELECT CONTENTS
          FROM B_READ_DOC_CONTENTS(:IDUSER, :IDCONTENTS)
          INTO :CONTENTS ;

       SUSPEND;
    END
END^

-- Voyager TFS[535]
create or alter procedure V_GET_NORM_BASE_ID_BY_IDREESTR (
    IDREESTR integer)
returns (
    NORM_BASE_ID integer)
AS
declare variable INSTALL_GUID varchar(100);
begin
  -- Voyager TFS[535]
  --  ID  (B_NORM_BASE_LIST.ID)    ID 
  -- ,   ,    (.   FIND_FOLDER_BASE_ID)
  NORM_BASE_ID = -1/*nbiUndefined*/;

  select R.INSTALL_GUID from B_REESTR R
  where R.ID = :IDREESTR
  into :INSTALL_GUID;

  if (coalesce(INSTALL_GUID,'') <> '') then
    select I.ID_NORM_BASE from B_NORM_BASE_INSTALL I
    where I.INSTALL_GUID = :INSTALL_GUID
    into :NORM_BASE_ID;

  suspend;
end
^

create or alter procedure GET_BASE_FROM_PUTI (
    PUT_ID_GROUP integer,
    PUT_ID_RAB   integer,
    PUT_ID_MASH  integer,
    PUT_ID_MAT   integer)
returns (
    NORM_BASE_ID integer)
AS
declare variable IDREESTR integer;
begin
  -- Voyager TFS[535]
  --  BASEID  NORM_BASE_ID.
  --  find_folder_base_id  V_GET_NORM_BASE_ID_BY_IDREESTR
  PUT_ID_GROUP = NULL; --   

  NORM_BASE_ID = -1/*nbiUndefined*/;
  IDREESTR = null;

  --    CQ[13915]

  if (PUT_ID_RAB is not null) then --  
  begin
    for select IDREESTR
      from B_PUTVIEW
      where IDPUTNAME = :PUT_ID_RAB
      order by id
      into :IDREESTR
    do
    begin
      execute procedure V_GET_NORM_BASE_ID_BY_IDREESTR(:IDREESTR)
      returning_values (:NORM_BASE_ID);
      if (:NORM_BASE_ID <> -1) then
        leave;
    end
  end
  if ((NORM_BASE_ID = -1) and (PUT_ID_MAT is not null)) then --  
  begin
    for select IDREESTR
      from B_PUTVIEW
      where IDPUTNAME = :PUT_ID_MAT
      order by id
      into :IDREESTR
    do
    begin
      execute procedure V_GET_NORM_BASE_ID_BY_IDREESTR(:IDREESTR)
      returning_values (:NORM_BASE_ID);
      if (:NORM_BASE_ID <> -1) then
        leave;
    end
  end
  if ((NORM_BASE_ID = -1) and (PUT_ID_MASH is not null)) then --  
  begin
    for select IDREESTR
      from B_PUTVIEW
      where IDPUTNAME = :PUT_ID_MASH
      order by id
      into :IDREESTR
    do
    begin
      execute procedure V_GET_NORM_BASE_ID_BY_IDREESTR(:IDREESTR)
      returning_values (:NORM_BASE_ID);
      if (:NORM_BASE_ID <> -1) then
        leave;
    end
  end

  -- Voyager TFS[535]
  --   -     ,      
  /*
  if ((NORM_BASE_ID = -1) and (PUT_ID_GROUP is not null)) then --   
  begin
    for select IDPUT0, IDPUT2, IDPUT3
      from B_PUTNAME
      where ID = :PUT_ID_GROUP
      into :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT
    do
    begin
      execute procedure GET_BASE_FROM_PUTI(null, :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT)
      returning_values (:NORM_BASE_ID);
      if (:NORM_BASE_ID <> -1) then
        leave;
    end
  end
  */
end
^

create or alter procedure GET_BASE_FROM_PARAMS (
    NUMBER integer)
returns (
    NORM_BASE_ID integer)
AS
declare variable ATYPE integer;
declare variable PUT_ID_GROUP integer;
declare variable PUT_ID_RAB integer;
declare variable PUT_ID_MASH integer;
declare variable PUT_ID_MAT integer;
begin
  -- Voyager TFS[535]
  --  BASEID  NORM_BASE_ID.
  NORM_BASE_ID = -1/*nbiUndefined*/;
  ATYPE = null;

  select H.ATYPE
  from A_O_HIER H
  where H.NUMBER = :NUMBER
  into :ATYPE;

  PUT_ID_GROUP = null;
  PUT_ID_RAB = null;
  PUT_ID_MASH = null;
  PUT_ID_MAT = null;

  if (ATYPE = 1) then --  ,     
  begin
    select PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT
    from A_O_OBJECTPARAMS
    where NUMBER = :NUMBER
    into :PUT_ID_GROUP, :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT;
  end
  else
  if (ATYPE = 8) then --  ,     
  begin
    select PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT
    from A_O_FACTPARAMS
    where NUMBER = :NUMBER
    into :PUT_ID_GROUP, :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT;
  end

  execute procedure GET_BASE_FROM_PUTI(:PUT_ID_GROUP, :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT)
  returning_values (:NORM_BASE_ID);
  suspend;
end
^

--  
execute block
as
begin
  if (not exists(select * from RDB$INDICES T
      where upper(T.RDB$INDEX_NAME)='M_HR_MAIN_IDX_IDOBJECT')) then
    execute statement
    'CREATE INDEX M_HR_MAIN_IDX_IDOBJECT ON M_HR_MAIN (ID_OBJECT)';

  if (not exists(select * from RDB$INDICES T
      where upper(T.RDB$INDEX_NAME)='M_HR_MAIN_IDX_SMETATYPE')) then
    execute statement
    'CREATE INDEX M_HR_MAIN_IDX_SMETATYPE ON M_HR_MAIN (SMETATYPE)';

end
^

--      
CREATE OR ALTER trigger A_SMETA_AU1 for A_SMETA
active after update position 1
as
declare variable SMETATYPE integer;
declare variable LOCKED integer;
declare variable LIDPRICE integer;
declare variable LIDNORMO integer;
declare variable LROW integer;
declare variable LCOST double precision;
declare variable LKOEF double precision; --CQ[7790]
declare variable LOUT_ID integer;
begin
  if (new.NOMERROD = 0)
  then /*     */
  if (  (old.RABMAT    is null and new.RABMAT    is null or old.RABMAT    = new.RABMAT    )
    and (old.TYPE_TRUD is null and new.TYPE_TRUD is null or old.TYPE_TRUD = new.TYPE_TRUD )
    and (old.TAB       is null and new.TAB       is null or old.TAB       = new.TAB       )
    and (old.NAME_ID   is null and new.NAME_ID   is null or old.NAME_ID   = new.NAME_ID   )
    and (old.ID_EDIZM  is null and new.ID_EDIZM  is null or old.ID_EDIZM  = new.ID_EDIZM  )
      and (old.BA is null and new.BA is null or old.BA = new.BA)
      and (old.BB is null and new.BB is null or old.BB = new.BB)
      and (old.BC is null and new.BC is null or old.BC = new.BC)
      and (old.BD is null and new.BD is null or old.BD = new.BD)
      and (old.BE is null and new.BE is null or old.BE = new.BE)
      and (old.BF is null and new.BF is null or old.BF = new.BF)
      and (old.BG is null and new.BG is null or old.BG = new.BG)
      and (old.BH is null and new.BH is null or old.BH = new.BH)
      and (old.BI is null and new.BI is null or old.BI = new.BI)
      and (old.BJ is null and new.BJ is null or old.BJ = new.BJ)

      -- MK CQ[13261]
      and (old.idnormativ is null and new.idnormativ is null or old.idnormativ = new.idnormativ)

      --CQ[TIMUR 13178]
      and (old.BN is null and new.BN is null or old.BN = new.BN)
      and (old.BO is null and new.BO is null or old.BO = new.BO)
      and (old.B_ITOGO is null and new.B_ITOGO is null or old.B_ITOGO = new.B_ITOGO)

      --[15536,15352]
      and (old.B_PR is null and new.B_PR is null or old.B_PR = new.B_PR) ) then
    SMETATYPE = :SMETATYPE; /*    */
  else
  begin
    if ( coalesce(old.RABMAT,10) <> coalesce(new.RABMAT,10) ) then --CQ[7755]
    begin
      delete from smeta_pricepos_info where id = new.ID ;
    end
  /*    -   */
    for select SMETATYPE, ID
      from A_SMETA
      where NOMERROD = new.ID
      into :SMETATYPE, :LOUT_ID
    do
    begin
      execute procedure S_SET_DORECALC(null, SMETATYPE, 0, 1)
        returning_values :LOCKED;
      --CQ[6945]  -          
      LIDNORMO = null;
      LIDPRICE = null;
      LROW = null;
      LCOST = null;
      LKOEF = null;
      select IDNORMO, IDPRICE, ROW, COST, KOEF from smeta_pricepos_info i where i.ID = new.ID
      into :LIDNORMO, :LIDPRICE, :LROW, :LCOST, :LKOEF;
      if ((LIDPRICE is not null) and (LIDPRICE <> 0)) then
      begin
        execute procedure set_smeta_priceposinfo(:LOUT_ID, :LIDPRICE,  :LIDNORMO, :LROW, :LCOST, :LKOEF);
      end
      else
      begin
        delete from smeta_pricepos_info where id = :LOUT_ID ;
      end
    end
  /*    */
    update A_SMETA
    set RABMAT = new.RABMAT,
        TYPE_TRUD = new.TYPE_TRUD,
        TAB = new.TAB,
        ALTTAB = new.ALTTAB,
        NAME_ID = new.NAME_ID,
        ID_EDIZM = new.ID_EDIZM,
        BA = new.BA,
        BB = new.BB,
        BC = new.BC,
        BD = new.BD,
        BE = new.BE,
        BF = new.BF,
        BG = new.BG,
        BH = new.BH,
        BI = new.BI,
        BJ = new.BJ,
        --CQ[TIMUR 13178]
        BN = new.BN,
        BO = new.BO,
        B_ITOGO = new.B_ITOGO,
        --CQ[TIMUR 13178]

        B_PR = new.B_PR, --[15536,15352]

        -- MK CQ[13261]
        idnormativ = new.idnormativ,
        KODIR_PODGROUP = new.KODIR_PODGROUP, --[28.11.2017] - IDNORMATIV     RABMAT  IDPODGROUP
        NORM_GUID = new.NORM_GUID --[29.11.2017] -      IDNORMATIV

    where NOMERROD = new.ID;
  end
end
^

-- 
create or alter procedure A_S_RES_RECALL_ONE_RES (
    IDUSER integer,
    ID_OBJECT integer,
    RES_ID integer,
    SMETATYPE integer,
    VRPZ integer,
    KODIR_PODGROUP integer,
    PUT_ID_RAB integer,
    PUT_ID_MASH integer,
    PUT_ID_MAT integer,
    CLEAR_ID_PRICE integer,
    UPDATE_ALL_ACT integer)
AS
declare variable DOB_UCH integer;
declare variable DOB_NEUCH integer;

declare variable RES_RABMAT integer;
declare variable RES_TAB varchar(42);
declare variable RES_NORM_ID integer;
declare variable RES_NORM_PODGROUP integer;
declare variable RES_ALTTAB varchar(250);
declare variable RES_NAME_ID integer;
declare variable RES_IDEDIZM integer;
declare variable RES_NORM_GUID varchar(100);
declare variable RES_STATUS_REC_CEN integer;

declare variable RES_BB double precision;
declare variable RES_BC double precision;
declare variable RES_BD double precision;
declare variable RES_BE double precision;

declare variable NORM_BB double precision;
declare variable NORM_BC double precision;
declare variable NORM_BD double precision;
declare variable NORM_BE double precision;

declare variable NEW_NORM_ID integer;
declare variable NEW_NORM_PODGROUP integer;
declare variable NEW_RABMAT integer;
declare variable NEW_ALTTAB varchar(250);
declare variable NEW_NAME_ID integer;
declare variable NEW_IDEDIZM integer;

declare variable NEW_NORM_GUID varchar(100);
declare variable NEW_STATUS_REC_CEN integer;

declare variable RES_SYNHRON integer;
declare variable BASE_INFO integer;

declare variable ID_SM_REC integer;
declare variable ID_SOURCE integer;
declare variable SM_PUNKTIND varchar(42);
declare variable IDTR integer;

declare variable RES_COPY_FORMULS integer;
declare variable NEED_APPLY_INDEX integer;
declare variable NEED_APPLY_FORMUL integer;
begin

  /*   ,      CQ[TIMUR 9760]*/

  DOB_UCH   = 1;
  DOB_NEUCH = 1;

  NEED_APPLY_INDEX  = 0;  --    
  NEED_APPLY_FORMUL = 0;  --    
  RES_COPY_FORMULS  = 0;  --       

  --  
  for select ID_SOURCE, RABMAT, TAB, NORM_ID, NORM_PODGROUP, ALTTAB,
             NAME_ID, IDEDIZM, NORM_GUID, STATUS_REC_CEN,
             BB, BC, BD, BE
      from A_S_RES
      where ID = :RES_ID
      into :ID_SOURCE, :RES_RABMAT, :RES_TAB, :RES_NORM_ID, :RES_NORM_PODGROUP, :RES_ALTTAB,
           :RES_NAME_ID, :RES_IDEDIZM, :RES_NORM_GUID, :RES_STATUS_REC_CEN,
           :RES_BB, :RES_BC, :RES_BD, :RES_BE
  do
  begin

    /*      ( ) */
    /* [6921] TYPE_TRUD  , ..      */
    execute procedure A_CLC_SEARCH_RES ( :IDUSER,
                                         :KODIR_PODGROUP,
                                         :PUT_ID_RAB,
                                         :PUT_ID_MASH,
                                         :PUT_ID_MAT,
                                         0,
                                         :RES_NORM_ID,
                                         :RES_NORM_PODGROUP,
                                         :RES_RABMAT,
                                         :RES_ALTTAB,
                                         :RES_NAME_ID,
                                         :RES_IDEDIZM,
                                         :RES_BB,
                                         :RES_BC,
                                         :RES_BD,
                                         :RES_BE,
                                         :RES_NORM_GUID,
                                         :RES_STATUS_REC_CEN,
                                         :RES_TAB )

    returning_values( :NEW_NORM_ID, :NEW_NORM_PODGROUP, :NEW_RABMAT, :NEW_ALTTAB, :NEW_NAME_ID, :NEW_IDEDIZM,
                      :NORM_BB, :NORM_BC, :NORM_BD, :NORM_BE, :NEW_NORM_GUID, :NEW_STATUS_REC_CEN );

    /*      */
    if (CLEAR_ID_PRICE = 1) then
      delete from SMETA_PRICEPOS_INFO where ID = :RES_ID; -- CQ[6884] ID_PRICE = null;

    update A_S_RES
      set NORM_ID        = :NEW_NORM_ID,
          NORM_PODGROUP  = :NEW_NORM_PODGROUP,
          RABMAT         = :NEW_RABMAT,
          ALTTAB         = :NEW_ALTTAB,
          NAME_ID        = :NEW_NAME_ID,
          IDEDIZM        = :NEW_IDEDIZM,
          NORM_GUID      = :NEW_NORM_GUID,
          STATUS_REC_CEN = :NEW_STATUS_REC_CEN,
          --ID_PRICE  = :ID_PRICE, /*CQ[6884] */
          STATUS_DOB_V_ZENU = case when coalesce(UCH, 0) <> 0 then :DOB_UCH else :DOB_NEUCH end
    where ID = :RES_ID;

    ID_SM_REC = null;
    select ID, IDTIPR, PUNKTIND
      from A_SMETA S where (S.SLAVEPARENT+0 = :ID_SOURCE) and -- +0     
                           (S.ID_S_RES    = :RES_ID)
    into :ID_SM_REC, :IDTR, :SM_PUNKTIND;

    --      
    if (ID_SM_REC is not null) then
    begin

      update A_SMETA
      set BB = :RES_BB,
          BC = :RES_BC,
          BD = :RES_BD,
          BE = :RES_BE
      where (ID = :ID_SM_REC);

      for select RES_VC
        from NL_CTRL_ENTER_SMREC(:ID_OBJECT, :SMETATYPE, :IDUSER, :NEED_APPLY_INDEX, :NEED_APPLY_FORMUL,
                                 :SM_PUNKTIND, :ID_SM_REC, :IDTR, :VRPZ, :RES_COPY_FORMULS, :UPDATE_ALL_ACT)
        into :BASE_INFO
        do
        begin
          BASE_INFO = :BASE_INFO;
        end

        --     
        execute procedure A_S_SYNHRON_SLAVE_RES(:IDUSER, 0, 1, :ID_SM_REC, :RES_ID)
        returning_values :RES_SYNHRON;

    end
    --     
    else
    begin
      for select RES_VC
        from NL_CTRL_ENTER_RESURCY(:ID_OBJECT, :RES_ID, :SMETATYPE, :IDUSER, :VRPZ,
                                   :NORM_BB, :NORM_BC, :NORM_BD, :NORM_BE, :UPDATE_ALL_ACT)
        into :BASE_INFO
        do
          BASE_INFO = :BASE_INFO;
    end

  end

end
^

--
create or alter procedure B_IMP_I_INSTALL_NORM_BASE_LINKS (
    IDUSER integer,
    IMPMODE integer,
    ID integer,
    INSTALL_ID integer,
    INSTALL_GUID varchar(100))
returns (
    ID_NEW integer)
AS
BEGIN
  IF (:ID <> 0) THEN
  BEGIN
    SELECT ID
      FROM B_READ_INSTALL_ID_BY_GUID (:IDUSER, :INSTALL_GUID)
      INTO :ID_NEW;
  END
/*
  ELSE
  IF (:INSTALL_ID <> 0) THEN
  BEGIN
    IF (EXISTS(SELECT * FROM B_PODGROUP T WHERE T.NORM_GUID = :NORM_GUID)) THEN
      ID_NEW = 0;
  END
*/
  IF (:ID_NEW IS NOT NULL) THEN
    SELECT ID
      FROM B_WRITE_INSTALL_NORM_BASE_LINK (:IDUSER, :ID, :INSTALL_GUID)
      INTO :ID_NEW;

  SUSPEND;
END
^

-- 
create or alter procedure B_IMP_I_PODGROUP (
    IDUSER integer,
    IMPMODE integer,
    ID integer,
    NAME varchar(250),
    ISSYSTEM integer,
    NORM_GUID varchar(100),
    HIDDEN integer)
returns (
    ID_NEW integer)
AS
BEGIN
  ID_NEW = null;

  IF (NORM_GUID = '')
  THEN BEGIN
    SUSPEND;
    EXIT;
  END
   
  SELECT ID_NEW
  FROM B_IMP_F_PODGROUP(:IDUSER, :IMPMODE, :ID, :NORM_GUID)
  INTO ID_NEW ;
   
  /*       */
  IF (IMPMODE = 2) THEN BEGIN
    SUSPEND;
    EXIT;
  END

  IF (HIDDEN IS NULL)
  THEN HIDDEN = 0;

  IF (:ID_NEW IS NOT NULL
      AND (:ID_NEW > 3 OR
           :ID_NEW BETWEEN 1 AND 3 AND EXISTS(SELECT * FROM B_PODGROUP WHERE ID = :ID_NEW)) )
  THEN
  BEGIN
    IF (:ISSYSTEM = 1) THEN
      UPDATE B_PODGROUP P
        SET P.ISSYSTEM  = :ISSYSTEM,
            /*P.NORM_GUID = :NORM_GUID,*/
            P.NAME      = :NAME,
            P.HIDDEN    = :HIDDEN
        WHERE P.ID = :ID_NEW;
    ELSE
      UPDATE B_PODGROUP P
        SET /*P.ISSYSTEM  = :ISSYSTEM,*/
            /*P.NORM_GUID = :NORM_GUID,*/
            P.NAME      = :NAME,
            P.HIDDEN    = :HIDDEN
        WHERE P.ID = :ID_NEW;
  END
  ELSE
  BEGIN
    --[15559.P]  -  ID
    ID_NEW = case NORM_GUID
      when '    81-98' then 3 -- 
      when '    81-98 (P)' then 4 --  
      when '000%B {92F6EED9-300E-4DF6-8985-D413B6CE29B3} {n}' then 5 -- 
      when '000%B {673F5D91-27F4-4BB3-9705-EF3E6DD4BC92} {k}' then 6 --  
      when '000%B {2C0C5631-2AAB-43A3-BEDD-5B3030903644} {(}' then 7 -- 
      when '000%B {29501E29-3074-4A8D-8B51-6C1FF0B76796} {%}' then 8 --  
      when '   -2012' then 9     --  2012       --CQ[TIMUR 13178]
      when '   -2012 ' then 10 --  2012     --CQ[TIMUR 13178]
      when '   -2012 - 2016 .' then 11    --  2012-2016
      when '   -2012 - 2016 . ' then 12 --  2012-2016 

      when 'btMTSN    -2001 ' then 13                    -- -2001 
      when 'btMTSN    -2001  ( )' then 14 -- -2001  

      when '000%B {C55E4BDA-F0BF-421E-B5FB-7922261FAA41} {z}' then 15 --  2012-2017
      when '000%B {1A0F0618-8B41-4E7F-94DA-8B63EC0841BE} {W}' then 16 --  2012-2017  (2017/07/07)

      when '{48A2FBEB-9B24-4E2E-8D0E-207706A0B3A5}' then 17 -- -2017
      when '{C25A9F0D-23E7-4D07-8414-F19C2E13E5AB}' then 18 -- -2017  (2017/07/07)

      when '000%B {F141C2EF-6C70-41D4-B7FD-64B66CB11367} {U}' then 19 -- -2012 - 2018 . (2017/10/23)
      when '000%B {E749A3C3-85D6-4FBF-BD4E-7F656E700CEB} {;}' then 20 -- -2012 - 2018 .  

      when '000%B {AC42248E-9BDD-40F7-8D90-E7B1CC5810F8} {q}' then 21 -- -2017  (2017/11/16)
      when '000%B {004B8D73-8485-4346-913E-2DA896B14FD5} {&}' then 22 -- -2017   

      else coalesce(:ID_NEW, nullif(:ID, 0)) -- ...   ID
      end;


    while (:ID_NEW is null
        --[15559.P]    
        or exists(select * from B_PODGROUP where ID = :ID_NEW)) do
      ID_NEW = GEN_ID(A_G_SMETA, 1);

    INSERT INTO B_PODGROUP (ID, NAME, ISSYSTEM, NORM_GUID, HIDDEN)
      VALUES (:ID_NEW, :NAME, :ISSYSTEM, :NORM_GUID, :HIDDEN);
  END

  SUSPEND;
END
^

--TFS[578],TFS[580]
create or alter procedure GET_BASECODE_FROM_SMETA (
    IDCLASS integer)
returns (
    BASE_CODE integer)
AS
declare IDOBJECT integer;
declare SMETATYPE integer;
begin
--    ,  " "  " /  "

  execute procedure S_O_HIER_PARENT_OFTYPE(:IDCLASS, 1/*ObgectType*/)
      returning_values :IDOBJECT;
  SMETATYPE = case when :IDOBJECT = :IDCLASS then 15/*PSType*/ else :IDCLASS end;

  for
  -- ,   ,    
  select B.BASE_CODE
    from B_NORM_BASE_LIST B
    join (
      --      
      select distinct BI.ID_NORM_BASE
        from B_NORM_BASE_INSTALL BI
        join (
          --      
          select distinct RF.INSTALL_GUID
            from B_REESTR RF
            join B_REESTR RS on RS.IDPARENT=RF.ID
              and RF.INSTALL_GUID is not null
            join (
              --     
              select distinct A.NORM_GUID
                from A_SMETA A
                join S_O_HIER_SELECT2(:IDOBJECT) H on A.IDHIER=H.IDHIER and A.SMETATYPE=:SMETATYPE
                  and A.NORM_GUID is not null
            ) S on S.NORM_GUID = RS.NORM_GUID
              and RS.SBORNIK <> 0
        ) I on I.INSTALL_GUID = BI.INSTALL_GUID
    ) BI1 on BI1.ID_NORM_BASE = B.ID
    group by 1
    order by 1 desc
  into :BASE_CODE
  do suspend;
end
^

--
create or alter procedure L_M29_CAN_DELETE_HIER (
    ID_OBJ integer,
    ID_HIER integer,
    ID_USER integer)
returns (
    RESULT integer)
AS
declare variable ID_M29 integer;
--declare variable ID_OBJ_M29 integer;
declare variable id_rec integer;
declare variable id_spis integer;
--declare variable cur_id_hier integer;
begin
   RESULT = 1;

  --  .  
  for
  with recursive
  fo as --    , ,   29
  (
    select NUMBER from A_O_HIER where NUMBER=:ID_OBJ
    union all --     ,      "S NATURAL"
    select t.NUMBER from A_O_HIER t
      join fo on t.PARENT=fo.NUMBER and t.ATYPE=0 --   */
  ),
  fh as --     , 
  (
    select NUMBER, ATYPE from A_O_HIER where NUMBER=:ID_HIER
    union all
    select th.NUMBER, th.ATYPE from A_O_HIER th
      join fh on th.PARENT=fh.NUMBER and th.ATYPE in (0,3,4,5) --
  ),
  h as --     ,  
  (
    select fh.NUMBER from fh where ATYPE <> 0
  ),
  m as --  29  
  (
    select tm.NUMBER from A_O_HIER tm
      join fo on tm.PARENT=fo.NUMBER and tm.ATYPE = 9 -- 29
  ),
  mr as --    29 ,   , 
  (
    select m1.ID_SELF, m1.ID_M29 from L_M29 m1
      join m on m1.ID_M29 = m.NUMBER
      join h on m1.IDHIER = h.NUMBER
  )
  select s.ID_M29, s.ID_SPIS, s.ID_REC from L_M29_SPIS s
    join mr on mr.ID_M29=s.ID_M29 and mr.ID_SELF=s.ID_REC
    where s.ID_SPIS <> 0
    rows 1 --     first 1
    into :ID_M29, :ID_SPIS, :ID_REC
  do
    result = 0;
/*
--  :
PLAN JOIN ( JOIN ( (MR H FH A_O_HIER INDEX (RDB$PRIMARY20))
                   PLAN (MR H FH TH INDEX (I_PARENT, I_PARENT, I_PARENT, I_PARENT))
                        (MR M FO A_O_HIER INDEX (RDB$PRIMARY20))
                        PLAN (MR M FO T INDEX (I_PARENT)), 
                        MR M TM INDEX (I_PARENT), 
                        JOIN ( S INDEX (RDB$PRIMARY86), 
                               MR M1 INDEX (RDB$PRIMARY84)
                             )
                 )
          )
--  ,      :
PLAN MERGE ( SORT ( JOIN ( S NATURAL, 
                           MR M TM INDEX (RDB$PRIMARY20), 
                           MR M FO A_O_HIER INDEX (RDB$PRIMARY20), 
                           MR M1 INDEX (RDB$PRIMARY84)
                         )
                  ), 
             SORT ( (MR H FH A_O_HIER INDEX (RDB$PRIMARY20))
                    PLAN (MR H FH TH INDEX (I_PARENT, I_PARENT, I_PARENT, I_PARENT))
                  )
           )
*/

/* 2017/11/10
  -     
(          ,
     29        )
       29

   for select NUMBER from a_o_hier where atype = 9 into :ID_M29
   do
   begin
      execute procedure a_h_get_id_parentatype ( ID_M29 , 1 ) returning_values ( :ID_OBJ_M29 );
      if ( ID_OBJ_M29 = ID_OBJ ) then
         for select id_self
             from l_m29
             where ( id_m29 = :id_m29 ) and ( idhier = :id_hier )
             into id_rec
         do
             for select ID_SPIS from l_m29_reestr where ( ID_M29 = :ID_M29 ) and ( ID_SPIS <> 0 )
                 into   :id_spis
             do
                 if ( id_spis <>  0 ) then
                    for select first 1 id_rec
                        from l_m29_spis
                        where id_m29 = :id_m29 and id_spis = :id_spis and id_rec = :id_rec
                        into id_rec
                    do
                    begin
                       result = 0;
                       exit;
                    end

   end

   for select number
       from a_o_hier
       where parent = :ID_HIER
       into  cur_id_hier
   do
   begin
      execute procedure L_M29_CAN_DELETE_HIER ( :ID_OBJ , :cur_id_hier , :ID_USER )
         returning_values ( :result );
      if ( result = 0 ) then
         exit;
   end
*/
end
^

--TFS[578],TFS[580]
create or alter procedure M_CONVERT_OBJ_VNB (
    IDOBJECT integer,
    IDUSER integer,
    IN_PODGROUP integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer,
    ID_TR integer,
    INDEX_ID_ORG integer,
    INDEX_ID_GOD integer,
    INDEX_ID_MES integer,
    RETURN_ALL integer,
    MIN_STEP_SUSPEND integer,
    CLEARPRICE_IFNOTFOUND integer,
    REPLACE_CHANGE_NAME integer,
    REPLACE_ALL_RES integer,
    LEAVE_MATER_PRICE integer)
returns (
    ID integer,
    REC_NO integer,
    CONVERT_RESULT integer,
    RABMAT integer,
    TAB varchar(42),
    ATYPE integer,
    HIER_CAPTION varchar(255),
    REC_NUMBER varchar(10),
    VRPZ integer,
    OUT_IDFORMULS integer)
AS
declare variable NOSUSPENDCOUNT integer;
declare variable SM_IDEDIZM integer;
declare variable EDIZMSUCCESS integer;
declare variable SM_NUMBER1 integer;
declare variable SM_NUMBER2 integer;
declare variable SM_SLAVEPARENT integer;
declare variable SM_KOLL double precision;
declare variable SM_NORMARASH double precision;
declare variable SM_IDHIER integer;
declare variable RES_ID integer;
declare variable RES_RASHOD double precision;
declare variable RES_RASHOD_BASE double precision;
declare variable RES_RASHOD_CALC double precision;
declare variable REC_CORRECT varchar(50);
declare variable IFLAG integer;
declare variable V_STAB varchar(42);
declare variable V_ID_SELF integer;
declare variable V_ALTTAB varchar(250);
declare variable V_IDEDIZM integer;
declare variable V_BA double precision;
declare variable V_BB double precision;
declare variable V_BC double precision;
declare variable V_BD double precision;
declare variable V_BE double precision;
declare variable V_BF double precision;
declare variable V_BG double precision;
declare variable V_BH double precision;
declare variable V_BI double precision;
declare variable V_NORM_GUID varchar(100);
declare variable V_PUNKTIND varchar(42);
declare variable V_IDMAME integer;
declare variable V_PODGROUP integer;
declare variable V_RABMAT integer;
--declare variable V_ABC_OKP_ISGROUPOKP integer;
--[12447]
declare V_TAB varchar(42);

declare variable PM_RES_COPY_FORMULS integer;
--declare variable PM_INDEX_RASCHNRISP integer;
--declare variable PM_INDEX_BRAT_ZU_IS integer;
--declare variable PM_INDEX_NASNACHAUTO integer;
--declare variable PM_INDEX_ZAMENNASNACH integer;
--declare variable PM_INDEX_UCHITNDS integer;
--declare variable PM_RES_COPY_INDEX integer;
declare variable PM_RES_APPLY_TAB integer;
declare variable PM_KODIR_GROUP integer;
declare variable S_MA double precision;
declare variable S_MB double precision;
declare variable S_MC double precision;
declare variable S_MD double precision;
declare variable S_ME double precision;
declare variable S_MF double precision;
declare variable S_MG double precision;
declare variable S_MH double precision;
declare variable S_MI double precision;
--declare variable S_PA double precision;
--declare variable S_PB double precision;
--declare variable S_PC double precision;
--declare variable S_PD double precision;
--declare variable S_TIPRAB integer;
--declare variable S_VIDRAB integer;
declare variable OLD_EDIZMIDGROUP integer;
declare variable NEW_EDIZMIDGROUP integer;
declare variable OLD_EDIZMRELATION double precision;
declare variable NEW_EDIZMRELATION double precision;
declare variable USER_EDIZMRELATION double precision;
declare variable RESULT_EDIZM_KOEFF double precision;
declare variable ADDEDID integer;
declare variable S_NAME_CRC integer;
declare variable S_EDIZM_NAME varchar(100);
declare variable ISCHANGEDNAME integer;
declare variable ID_CUR_PODGROUP_NORM integer;
declare variable ID_CUR_NORMATIV integer;
declare variable ID_CUR_NAME integer;
declare variable VN_TIPRAB integer;
declare variable VN_ID_LEVEL integer;

declare variable V_BN double precision;
declare variable V_BO double precision;
declare variable V_B_ITOGO double precision;

declare variable V_ABC_OKP_IDPODGROUP integer;
declare variable V_ABC_OKP_TAB varchar(42);
declare variable V_ID_ABC_OKP integer;
declare variable V_ABC_OKP_COMMENT varchar(42);
declare variable V_NORMATIV_IS_TSN integer;
declare variable S_SKOLL varchar(255);

declare variable V_B_PR double precision;

declare variable ZAMEN integer;
declare variable RES_TOLKO_NEUCHT_RES integer;
declare variable RES_ZANOSIT_S_RES integer;
declare variable DESCR varchar(255);

declare IDPODGROUP2017 integer;
begin
  NOSUSPENDCOUNT = 0;
  REC_NO = 0;

  --    ()
  select first 1
    RES_COPY_FORMULS, RES_APPLY_TAB, KODIR_GROUP,
    RES_TOLKO_NEUCHT_RES, RES_ZANOSIT_S_RES
    /*INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS, INDEX_NASNACHAUTO,
      INDEX_ZAMENNASNACH, INDEX_UCHITNDS, RES_COPY_INDEX, */
    from A_H_GETOBJECTPARAM (:IDUSER, :IDOBJECT)
  into :PM_RES_COPY_FORMULS, :PM_RES_APPLY_TAB, :PM_KODIR_GROUP,
       :RES_TOLKO_NEUCHT_RES, :RES_ZANOSIT_S_RES;
 /*:PM_INDEX_RASCHNRISP, :PM_INDEX_BRAT_ZU_IS, :PM_INDEX_NASNACHAUTO,
   :PM_INDEX_ZAMENNASNACH, :PM_INDEX_UCHITNDS, :PM_RES_COPY_INDEX, */

  --TFS[578],TFS[580]
  if (:IN_PODGROUP = 1) then
    select rr.IDPODGROUPNORM
      from B_RESURS rr
      right join B_REESTR rs on rr.IDREESTR=rs.ID
      right join B_REESTR rf on rs.IDPARENT=rf.ID
      right join B_PUTVIEW pv on rf.ID=pv.IDREESTR
      where pv.IDPUTNAME=:ID_PUT_RAB
        and rr.IDPODGROUP=1
        and rr.IDPODGROUPNORM <> 1
      rows 1
    into :IDPODGROUP2017;

  --     
  for select ID, RABMAT, TAB, ATYPE, ID_EDIZM, STRUCT_NAME, VIEW_NUMBER1, VIEW_NUMBER2, SLAVEPARENT,
             MA, MB, MC, MD, ME, MF, MG, MH, MI, KOLL, NORMARASH, IDHIER,
             case when NAME is null then 0 else K_GETCRC32(upper(NAME)) end, -- MK 24.12.2007 CQ[5749], []
             KODIR_PODGROUP, IDNORMATIV, NAME_ID, TIPRAB, SKOLL
  from A_P_SMETA (:IDOBJECT, :IDOBJECT, :IDUSER, 15, 0, 0, 0, null, null, 0, /*SENDER*/0)
  where (ATYPE = 17) or (ATYPE = 18)
  into :ID, :RABMAT, :TAB, :ATYPE, :SM_IDEDIZM, :HIER_CAPTION, :SM_NUMBER1,
       :SM_NUMBER2, :SM_SLAVEPARENT, :S_MA, :S_MB, :S_MC, :S_MD, :S_ME,
       :S_MF, :S_MG, :S_MH, :S_MI, :SM_KOLL, :SM_NORMARASH, :SM_IDHIER,
       :S_NAME_CRC, :ID_CUR_PODGROUP_NORM, :ID_CUR_NORMATIV, :ID_CUR_NAME, :VN_TIPRAB, :S_SKOLL
  do
  begin

    --   ,       ...
    if ( (ATYPE = 18) and (REPLACE_ALL_RES = 1) ) then --TFS[250]
      ATYPE = ATYPE;
    else
    begin
      REC_NO = REC_NO + 1;
      NOSUSPENDCOUNT = NOSUSPENDCOUNT + 1;
      CONVERT_RESULT = 0;
      if (ATYPE = 17) then
        REC_NUMBER = cast(:SM_NUMBER1 as varchar(100));
      if (ATYPE = 18) then
        REC_NUMBER = cast(:SM_NUMBER1 as varchar(100)) || '.' || cast(:SM_NUMBER2 as varchar(100));
  
      -- MK 24.12.2007 CQ[5749] --->
      select first 1 EDIZMNAME
        from B_GET_EDIZM(:SM_IDEDIZM)
      into :S_EDIZM_NAME;
      -- MK 24.12.2007 CQ[5749] <---
  
      --      
      -- MK 24.12.2007 CQ[5749] --->
  
      V_STAB = upper(:TAB);
      select first 1 ID_SELF, ALTTAB, IDEDIZM, BA, BB, BC, BD,
         BE, BF, BG, BH, BI, BJ, PA, PB,
         NORM_GUID, coalesce(VRPZ, 0), PUNKTIND, IDNAME, PODGROUP,
         RABMAT, /*ABC_OKP_ISGROUPOKP,*/ TAB, --<<[12447]
         ID_ABC_OKP, ABC_OKP_IDPODGROUP, ABC_OKP_TAB, ABC_OKP_COMMENT,
         BB_PR -- Voyager CQ[15500]
      from M_FB_SEARCH_NORMATIV_EX(:IN_PODGROUP, :RABMAT/*-1*/, :IDUSER, :V_STAB,
            :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0,
            :S_NAME_CRC, :ID_CUR_NAME/*[15371, 15408]*/, :S_EDIZM_NAME)
      into :V_ID_SELF, :V_ALTTAB, :V_IDEDIZM, :V_BA, :V_BB, :V_BC, :V_BD, :V_BE,
           :V_BF, :V_BG, :V_BH, :V_BI, :V_B_ITOGO, :V_BN, :V_BO, -- CQ[13221] V_BJ -> V_B_ITOGO, V_PA -> V_BN, V_PB -> V_BO
           :V_NORM_GUID, :VRPZ, :V_PUNKTIND, :V_IDMAME, :V_PODGROUP, :V_RABMAT,
           /*:V_ABC_OKP_ISGROUPOKP,*/ :V_TAB, --<<[12447]
           :V_ID_ABC_OKP, :V_ABC_OKP_IDPODGROUP, :V_ABC_OKP_TAB, :V_ABC_OKP_COMMENT,
           :V_B_PR; -- Voyager CQ[15500]
  
      --          ,
      --     ABC_OKP --[15371] -->
      if ((V_ID_SELF = 0) and (ID_CUR_PODGROUP_NORM > 1)) then
      begin
  
        V_TAB = null;
        select upper(TAB) from B_ABC_OKP
          where (ID = :ID_CUR_NORMATIV)
        into :V_TAB;
  
        if (V_TAB is not null) then
          V_STAB = V_TAB;
        else
          --       0.0-0-0-->9999990001
          execute procedure M_CONVERT_RES_TAB(:IDUSER, :V_STAB, :ID_CUR_NAME)
            returning_values (:V_STAB);
  
        if (V_STAB is not null) then
          select first 1 ID_SELF, ALTTAB, IDEDIZM, BA, BB, BC, BD,
             BE, BF, BG, BH, BI, BJ, PA, PB,
             NORM_GUID, coalesce(VRPZ, 0), PUNKTIND, IDNAME, PODGROUP,
             RABMAT, /*ABC_OKP_ISGROUPOKP,*/ TAB, --<<[12447]
             ID_ABC_OKP, ABC_OKP_IDPODGROUP, ABC_OKP_TAB, ABC_OKP_COMMENT,
             BB_PR -- Voyager CQ[15500]
          from M_FB_SEARCH_NORMATIV_EX(
                case when (:IN_PODGROUP = 1 and :IDPODGROUP2017 > 1) then :IDPODGROUP2017 else :IN_PODGROUP end, --TFS[578],TFS[580] :IN_PODGROUP
                :RABMAT/*-1*/, :IDUSER, :V_STAB,
                :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0,
                :S_NAME_CRC, :ID_CUR_NAME/*[15371, 15408]*/, :S_EDIZM_NAME)
          into :V_ID_SELF, :V_ALTTAB, :V_IDEDIZM, :V_BA, :V_BB, :V_BC, :V_BD, :V_BE,
               :V_BF, :V_BG, :V_BH, :V_BI, :V_B_ITOGO, :V_BN, :V_BO, -- CQ[13221] V_BJ -> V_B_ITOGO, V_PA -> V_BN, V_PB -> V_BO
               :V_NORM_GUID, :VRPZ, :V_PUNKTIND, :V_IDMAME, :V_PODGROUP, :V_RABMAT,
               /*:V_ABC_OKP_ISGROUPOKP,*/ :V_TAB, --<<[12447]
               :V_ID_ABC_OKP, :V_ABC_OKP_IDPODGROUP, :V_ABC_OKP_TAB, :V_ABC_OKP_COMMENT,
               :V_B_PR; -- Voyager CQ[15500]
      end -- <--[15371]
  
      --  
      if (V_ID_SELF > 0) then
      begin
  
        --[15371] --> 9999990001-->0.0-0-0
        --    :  - 0
        if (:V_PODGROUP > 1) then
          if ((:PM_RES_APPLY_TAB = 0) and (:V_ABC_OKP_COMMENT <> '')) then
             V_TAB = :V_ABC_OKP_COMMENT;
  
        --       ABC,     ABC
        if (:V_PODGROUP = 1) then --    
          if ((ID_CUR_PODGROUP_NORM > 1) and (:V_ID_ABC_OKP > 0)) then
          begin
            V_ID_SELF = V_ID_ABC_OKP;
            V_PODGROUP = V_ABC_OKP_IDPODGROUP;
            if (:PM_RES_APPLY_TAB <> 0) then
              V_TAB = V_ABC_OKP_TAB;
          end
        -- <--[15371]
  
        --   
        --if (v_ABC_OKP_ISGROUPOKP = 0) then -- MK 24.12.2007 CQ[5749] 
        begin
          --      ----------------------------
          if (SM_IDEDIZM <> V_IDEDIZM) then
          begin
            EDIZMSUCCESS = 0;
            --     .    
            --     
            select first 1 IDGROUP, RELATION
              from B_FIND_EDIZM_EX(:IDUSER, :SM_IDEDIZM, '')
            into :OLD_EDIZMIDGROUP, :OLD_EDIZMRELATION;
  
            select first 1 IDGROUP, RELATION
              from B_FIND_EDIZM_EX(:IDUSER, :V_IDEDIZM, '')
            into :NEW_EDIZMIDGROUP, :NEW_EDIZMRELATION;
  
            --TFS[250]
            USER_EDIZMRELATION = null;
            select first 1 EDIZMRELATION
            from GTT_CONVERT_OBJ_VNB_BAD_EDIZM
            where (SM_ID_EDIZM = :SM_IDEDIZM) and
                  (NORM_ID_EDIZM = :V_IDEDIZM)
            into :USER_EDIZMRELATION;
            --TFS[250]
  
            --          
            --   . 
            if ( ((OLD_EDIZMIDGROUP is not null) and (NEW_EDIZMIDGROUP is not null) and
                 (OLD_EDIZMIDGROUP = NEW_EDIZMIDGROUP)) or
                (USER_EDIZMRELATION is not null) ) --TFS[250]
            then
            begin
              if (USER_EDIZMRELATION is null) then
                RESULT_EDIZM_KOEFF = OLD_EDIZMRELATION / NEW_EDIZMRELATION;
              else
                RESULT_EDIZM_KOEFF = USER_EDIZMRELATION; --TFS[250]
  
              --         
              if (ATYPE = 17) then
              begin
                SM_KOLL = SM_KOLL * RESULT_EDIZM_KOEFF;
                if (S_SKOLL <> '') then
                  S_SKOLL = '(' || S_SKOLL || ')*' || A_FLOATTOSTR(RESULT_EDIZM_KOEFF, 0/*IsMany*/);
  
                for select ID, RASHOD_BASE, CORRECT
                  from A_S_RES
                  where (ID_SOURCE = :ID)
                into :RES_ID, :RES_RASHOD_BASE, :REC_CORRECT
                do
                begin
                  RES_RASHOD_BASE = RES_RASHOD_BASE / RESULT_EDIZM_KOEFF;
                  --      
                  RES_RASHOD = RES_RASHOD_BASE;
                  if (REC_CORRECT <> '') then
                  begin
                    select first 1 IFLAG, DITOGNORMRASH
                      from K_CALCULATENORMRASH(:REC_CORRECT, :RES_RASHOD_BASE, :IDUSER)
                    into :IFLAG, :RES_RASHOD_CALC;
                    if (IFLAG = 1) then
                      RES_RASHOD = RES_RASHOD_CALC;
                  end
                  update A_S_RES
                  set RASHOD = :RES_RASHOD,
                      RASHOD_BASE = :RES_RASHOD_BASE
                  where (ID = :RES_ID);
                end
              end
              --      
              else if (ATYPE = 18) then
                SM_NORMARASH = SM_NORMARASH * RESULT_EDIZM_KOEFF;
              EDIZMSUCCESS = 1;
            end
          end
          --    
          else
            EDIZMSUCCESS = 1;
  
          /* [15371]       ,  . .  
               ...*/
          if (EDIZMSUCCESS = 0) then
          begin
            execute procedure NORMATIV_IS_TSN(:V_ID_SELF)
               returning_values (:V_NORMATIV_IS_TSN);
  
            if (:V_NORMATIV_IS_TSN > 0) then /*tsn_mccs, tsn_mge*/
              EDIZMSUCCESS = 1;
          end
          --[15371]
  
          --     -------------------------------
          if (EDIZMSUCCESS = 1) then
          begin
            --  =============================================================
            --     
            if ((:INDEX_ID_ORG > 0) and (:INDEX_ID_GOD > 0) and (:INDEX_ID_MES > 0)) then
            begin
              --    CQ[9301]
              /* CQ[9291]
              select first 1 I.RES_MA, I.RES_MB, I.RES_MC, I.RES_MD, I.RES_ME, I.RES_MF,
                             I.RES_MG, I.RES_MH, I.RES_MI, I.RES_PA, I.RES_PB, I.RES_PC,
                             I.RES_PD, I.RES_PUNKTIND
              from A_S_GET_INDEX ( :IDUSER,
                                   :ID,
                                   :SM_SLAVEPARENT,
                                   :ATYPE,
                                   :INDEX_ID_ORG,
                                   :INDEX_ID_GOD,
                                   :INDEX_ID_MES,
                                   :PM_INDEX_NASNACHAUTO,
                                   :PM_INDEX_ZAMENNASNACH,
                                   :PM_INDEX_RASCHNRISP,
                                   :PM_INDEX_BRAT_ZU_IS,
                                   :PM_INDEX_UCHITNDS,
                                   :PM_RES_COPY_INDEX,
                                   :S_MA,
                                   :S_MB,
                                   :S_MC,
                                   :S_MD,
                                   :S_ME,
                                   :S_MF,
                                   :S_MG,
                                   :S_MH,
                                   :S_MI,
                                   :S_PA,
                                   :S_PB,
                                   :S_PC,
                                   :S_PD,
                                   :V_PUNKTIND,
                                   0,
                                   1 ) I
              into :S_MA, :S_MB, :S_MC, :S_MD, :S_ME, :S_MF, :S_MG, :S_MH, :S_MI,
                  :S_PA, :S_PB, :S_PC, :S_PD, :V_PUNKTIND;   */
              S_MA = S_MA;
            end
            --      -  
            -- TODO , , ,       .   
            else
            begin
              S_MA = 1;
              S_MB = 1;
              S_MC = 1;
              S_MD = 1;
              S_ME = 1;
            end
  
            --  =============================================================
            --      
            --CQ[9359], MK 28.05.2013 CQ[9301] -->
            select first 1 RES_VRPZ, /*RES_TIPRAB, RES_VIDRAB,*/ RES_IDFORMULS
              from A_S_GET_FORMULS_DM (:IDUSER, :ATYPE, :SM_SLAVEPARENT, :ID_TR, :VRPZ,
                                       :PM_RES_COPY_FORMULS, :VN_TIPRAB)
            into :VRPZ, /*:S_TIPRAB, :S_VIDRAB,*/ :OUT_IDFORMULS;
  
            --select first 1 RES_VRPZ, RES_TIPRAB, RES_VIDRAB, RES_IDFORMULS --CQ[9359]
            --  from A_DM_GET_FORMULS (:IDUSER, :ATYPE, :SM_SLAVEPARENT, :ID_TR, :VRPZ, :PM_RES_COPY_FORMULS)
            --  into :VRPZ, :S_TIPRAB, :S_VIDRAB, :IDFORMULS;
            --CQ[9359], MK 28.05.2013 CQ[9301] <--
  
            --     
            -- (   a_s_get_formuls    )
            if (not (exists(select * from a_srf_f where (ID_TR = :ID_TR) and (NUMBER = :VRPZ)))) then
              CONVERT_RESULT = 3;
  
            -- cq[Timur 6747]
            if (Replace_Change_Name = 0) then
            begin
              execute procedure T_IS_CHANGED_CRC_NAME( :IDUser,
                                                       :ID_CUR_NORMATIV,
                                                       :ID_CUR_NAME,
                                                       :RABMAT,
                                                       :ID_CUR_PODGROUP_NORM )
              returning_values ( :ISCHANGEDNAME );
            end
            else
              ISCHANGEDNAME = 0;
            -- cq[Timur 6747]
  
            --      ---------------------------------
            update a_smeta
            set TAB = :V_TAB, --<<[12447]
                ALTTAB = :V_ALTTAB,
                ID_EDIZM = :V_IDEDIZM,
                --    ,      
                NAME_ID = case when :ISCHANGEDNAME = 1 then NAME_ID else :V_IDMAME end,
                -- CQ[TIMUR 6747]
                KOLL = :SM_KOLL,
                SKOLL = :S_SKOLL,
                NORMARASH = :SM_NORMARASH,
                -- 
                BA = coalesce(:V_BA, 0),
                BB = coalesce(:V_BB, 0),
                BC = coalesce(:V_BC, 0),
                BD = coalesce(:V_BD, 0),
                BE = coalesce(:V_BE, 0),
                BF = coalesce(:V_BF, 0),
                BG = coalesce(:V_BG, 0),
                BH = coalesce(:V_BH, 0),
                BI = coalesce(:V_BI, 0),
                -- CQ[13221] .  BJ = COALESCE(:V_BJ, 0),
                MF = coalesce(:S_MF, 0),
                MG = coalesce(:S_MG, 0),
                MH = coalesce(:S_MH, 0),
                MI = coalesce(:S_MI, 0),
                -- 
                PUNKTIND = :V_PUNKTIND,
                MA = :S_MA,
                MB = :S_MB,
                MC = :S_MC,
                MD = :S_MD,
                ME = :S_ME,
                -- 
                IDTIPR = :ID_TR,
                VRPZ = :VRPZ,
                IDFORMULS = :OUT_IDFORMULS, --CQ{9359]
                -- MK:  !
                --TIPRAB = :S_TIPRAB,
                --VIDRAB = :S_VIDRAB,
                --   
                IDNORMATIV = :V_ID_SELF,
                KODIR_PODGROUP = :V_PODGROUP,
                RABMAT = :V_RABMAT,
                NORM_GUID = :V_NORM_GUID,
                --IDNORMATIVUNIQ = 0
                -- CQ[13221] -->
                B_ITOGO = :V_B_ITOGO,
                BN = :V_BN,
                BO = :V_BO,
                -- CQ[13221] <--
                B_PR = coalesce(:V_B_PR, 0) -- Voyager CQ[15500]
            where (ID = :ID);
  
            -- MK 28.05.2013 CQ[9301] --->
            for select ID_LEVEL
                from NL_CTRL_ENTER_SMREC(:IDOBJECT, 15, :IDUSER, 1/*:NEED_APPLY_INDEX*/, 1/*:NEED_APPLY_FORMUL*/,
                :v_PUNKTIND, :ID, :ID_TR, :VRPZ, :pm_RES_COPY_FORMULS, 0/*:UPDATE_ALL_ACT*/)
            into :VN_ID_LEVEL
            do
            begin
              --nothing
              VN_ID_LEVEL = :VN_ID_LEVEL;
            end
            -- MK 28.05.2013 CQ[9301] <---
  
            delete from SMETA_PRICEPOS_INFO where ID = :ID;--CQ [6884] 
  
            --           
            if (ATYPE = 17) then
            begin

              --TFS[250]
              ZAMEN = 0;
              ZAMEN = SETBIT(:ZAMEN, 2/*9AF9923D*/, LEAVE_MATER_PRICE);

              for select ADDEDID
              from A_S_ADD_RES_NL_2 (
                                :IDUSER, :ID, :PM_KODIR_GROUP, :IN_PODGROUP,
                                0,           -- ID_ZONE
                                :ZAMEN, --TFS[250]
                                decode( :REPLACE_ALL_RES, --TFS[250]
                                  1, decode(:RES_TOLKO_NEUCHT_RES, 1, 0, 1),  --abs(coalesce(:RES_TOLKO_NEUCHT_RES, 0) - 1) -   ,   
                                     0 ),                                -- INSERT_ALL

                                decode( :REPLACE_ALL_RES, --TFS[250]
                                  1, :RES_ZANOSIT_S_RES,
                                     0 ),                                -- INSERT_SLAVE

                                :PM_RES_APPLY_TAB,
                                :V_ID_SELF,  -- SM_REC_IDNORMATIV
                                :V_PODGROUP, -- SM_REC_KODIR_PODGROUP
                                :V_RABMAT,   -- SM_REC_RABMAT
                                :SM_IDHIER,  -- SM_REC_IDHIER
                                15,          -- SM_REC_SMETATYPE
                                NULL,        -- IDLIST
                                0,           -- IDLIST_COUNT
                                decode( :REPLACE_ALL_RES, --TFS[250]
                                  1, 0/*+*/,
                                     2/*( )*/ ), -- MODE

                                0,           -- APPLY_POPR_MODE
                                0             -- APPLY_POPR_MODE
                                )
              into ADDEDID
              do
                ADDEDID = ADDEDID;
              --CQ[9301] <--
            end
          end
          --     
          else
            CONVERT_RESULT = 2;
  
        end
      end
      --   
      else
      begin
        CONVERT_RESULT = 1;
        if (CLEARPRICE_IFNOTFOUND = 1) then
        begin
          --    
          update A_SMETA
          set BA = 0,
              BB = 0,
              BC = 0,
              BD = 0,
              BE = 0,
              BF = 0,
              BG = 0,
              BH = 0,
              BI = 0,
              BJ = 0,
  
              -- MK 24.12.2007 CQ[5749] --->
              IDNORMATIV = 0,
              KODIR_PODGROUP = :IN_PODGROUP,
              -- MK 24.12.2007 <---
  
             -- idnormativuniq = 0
              B_PR = 0 -- Voyager CQ[15500]
          where (ID = :ID);
  
          -- MK 28.05.2013 CQ[9301] --->
          for select ID
            from LEVEL_COST
            where (IDOBJECT = :IDOBJECT)
          into :VN_ID_LEVEL do
          begin
            update A_SMETA_CENLVL CL
            set CL.BA = 0,
                CL.BB = 0,
                CL.BC = 0,
                CL.BD = 0,
                CL.BE = 0,
                CL.BF = 0,
                CL.BG = 0,
                CL.BH = 0,
                CL.BI = 0,
                CL.BJ = 0,
                CL.B_PR = 0 -- Voyager CQ[15500]
            where (CL.ID = :ID) and (CL.IDCENLVL = :VN_ID_LEVEL);
          end
          -- MK 28.05.2013 CQ[9301] <---
  
          delete from SMETA_PRICEPOS_INFO where ID = :ID;--CQ [6884] 
        end
  
        -- MK 24.12.2007 CQ[5749] --->
        else
        begin
          update A_SMETA
          set IDNORMATIV = 0,
              KODIR_PODGROUP = :IN_PODGROUP
          where (ID = :ID);
        end
        -- MK 24.12.2007 <---
  
        --  KODIR_PODGROUP      
        if (ATYPE = 17) then
        begin
          update M_ETALON_S_RES
            set KODIR_PODGROUP = :IN_PODGROUP
          where (ID_SOURCE = :ID);
        end
      end
  
      if ((ATYPE = 17) and (v_RABMAT = 0)) then
        execute procedure UPDATE_SMETA_UNION_INFO(:V_ID_SELF, null, :ID);  --CQ[TIMUR 9063]


      if (CONVERT_RESULT <> 0) then --TFS[250]
      begin
        DESCR = null;
        if ((CONVERT_RESULT = 1) and (coalesce(ID_CUR_NORMATIV, 0)<>0) or (RABMAT <> 3)) then DESCR = '  '; --    
        else if (CONVERT_RESULT = 2) then DESCR = '    ';
        else if (CONVERT_RESULT = 3) then DESCR = '     ';

        if (DESCR is not null) then
          if (not(exists(select *
                         from D_BOOKMARK
                         where REC_ID = :ID and
                               ENTITY_ID = :IDOBJECT)))
          then
            insert into D_BOOKMARK (USER_ID, REC_ID, ENTITY_ID, DESCR)
            values (:IDUSER, :ID, :IDOBJECT, :DESCR);
      end

      --  
      if ((RETURN_ALL = 1) or (NOSUSPENDCOUNT > MIN_STEP_SUSPEND) or (CONVERT_RESULT <> 0)) then
      begin
        NOSUSPENDCOUNT = 0;
        suspend;
      end
    end
  end
end
^

--TFS[578],TFS[580]
create or alter procedure M_CONVERT_OBJ_VNB_RES (
    ID_SOURCE integer,
    IDUSER integer,
    IN_PODGROUP integer,
    ID_PUT_RAB integer,
    ID_PUT_MASH integer,
    ID_PUT_MAT integer,
    RETURN_ALL integer,
    CLEARPRICE_IFNOTFOUND integer,
    REPLACE_CHANGE_NAME integer)
returns (
    ID integer,
    CONVERT_RESULT integer,
    RABMAT integer,
    TAB varchar(42))
AS
declare variable RES_NAME_ID integer;
declare variable RES_IDEDIZM integer;
declare variable RES_RASHOD_BASE double precision;
declare variable RES_RASHOD double precision;
declare variable RES_RASHOD_CALC double precision;
declare variable REC_CORRECT varchar(50);
declare variable IFLAG integer;
declare variable V_ID_SELF integer;
declare variable V_ALTTAB varchar(250);
declare variable V_IDEDIZM integer;
declare variable V_NORM_GUID varchar(100);
declare variable V_BB double precision;
declare variable V_BC double precision;
declare variable V_BD double precision;
declare variable V_BE double precision;
declare variable V_STAB varchar(42);
declare variable V_IDMAME integer;
declare variable V_PODGROUP integer;
--declare variable V_ABC_OKP_ISGROUPOKP integer;
--<<[12447]
declare V_TAB varchar(42);
declare variable EDIZMSUCCESS integer;
declare variable OLD_EDIZMIDGROUP integer;
declare variable NEW_EDIZMIDGROUP integer;
declare variable OLD_EDIZMRELATION double precision;
declare variable NEW_EDIZMRELATION double precision;
declare variable RESULT_EDIZM_KOEFF double precision;
declare variable USER_EDIZMRELATION double precision;
--[12447]declare variable RES_NAME blob sub_type 0 segment size 80;
declare variable RES_NAME_CRC integer;
declare variable RES_EDIZM_NAME varchar(100);
declare variable ISCHANGEDNAME integer;
declare variable ID_CUR_PODGROUP integer;
declare variable ID_CUR_NAME integer;
declare variable VN_ID_LEVEL integer;
declare variable IDOBJECT integer;
declare variable VN_VRPZ integer;
declare variable VN_IDHIER integer;
declare variable VN_NORM_ID integer;
declare variable V_ABC_OKP_IDPODGROUP integer;
declare variable V_ABC_OKP_TAB varchar(42);
declare variable V_ID_ABC_OKP integer;
declare variable V_ABC_OKP_COMMENT varchar(42);
declare variable V_RES_APPLY_TAB integer;

declare IDSLAVEREC integer;
declare RES integer;
declare IDPODGROUP2017 integer;
declare SM_IDNORMATIV integer;
begin
  --cq[9301] chinger ->
  select first 1 s.idhier
  from a_smeta s
  where s.id = :ID_SOURCE
  into :VN_IDHIER;

  execute procedure S_O_HIER_PARENT_OFTYPE (:VN_IDHIER, 1)
  returning_values  :IDOBJECT;

  --[15371]
  select RES_APPLY_TAB
    from A_O_OBJECTPARAMS
    where (NUMBER = :IDOBJECT)
  into :V_RES_APPLY_TAB;

  for select r.ID, r.RABMAT, r.TAB, r.NAME_ID, r.IDEDIZM, r.RASHOD_BASE,
             r.CORRECT, r.NORM_PODGROUP, r.NAME_ID, r.NORM_ID,
             s.ID
  from A_S_RES r
  left join A_SMETA s on s.ID_S_RES = r.ID
  where (r.ID_SOURCE = :ID_SOURCE)
  into :ID, :RABMAT, :TAB, :RES_NAME_ID, :RES_IDEDIZM, :RES_RASHOD_BASE,
       :REC_CORRECT, :ID_CUR_PODGROUP, :ID_CUR_NAME, :VN_NORM_ID,
       :IDSLAVEREC
  do
  --<TFS[578],TFS[580]>
  if (:IDSLAVEREC is not null) then
  begin
    CONVERT_RESULT = 0;
    execute procedure A_S_SYNHRON_SLAVE_RES(:IDUSER, 1/*SOURCE_SLAVE*/, 0/*SOURCE_RES*/, :IDSLAVEREC, :ID)
        returning_values :RES;
    --  
    if ((RETURN_ALL = 1) or (CONVERT_RESULT <> 0)) then
      suspend;
  end
  else
  --</>
  begin
    CONVERT_RESULT = 0;

    -- MK 24.12.2007 CQ[5749] --->
    -- ,  
    /*[12447]
    select first 1 NAME
    from B_GETNAME_EX(:IDUSER, :res_name_id)
    into :RES_NAME;*/
    RES_NAME_CRC = 0;
    /*[12447]
    if (:RES_NAME is not null) then
      RES_NAME_CRC = K_GETCRC32(:RES_NAME);*/
    select CRC_NAME_TITLE from B_NNAME where ID=:RES_NAME_ID into :RES_NAME_CRC;

    --  
    select first 1 EDIZMNAME
      from B_GET_EDIZM(:RES_IDEDIZM)
    into :RES_EDIZM_NAME;
    -- MK 24.12.2007 <---

    --           -- MK 24.12.2007 CQ[5749] --->
    V_STAB = upper(:TAB);
    select first 1 ID_SELF, ALTTAB, IDEDIZM, BB, BC, BD, BE,
       NORM_GUID, IDNAME, PODGROUP, /*ABC_OKP_ISGROUPOKP,*/ VRPZ, TAB, --<<[12447]
       ID_ABC_OKP, ABC_OKP_IDPODGROUP, ABC_OKP_TAB, ABC_OKP_COMMENT
    from M_FB_SEARCH_NORMATIV_EX(:IN_PODGROUP, :RABMAT/*-1*/, :IDUSER, :V_STAB,
            :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0,
            :RES_NAME_CRC, :RES_NAME_ID/*[15371, 15408]*/, :RES_EDIZM_NAME)
    into :V_ID_SELF, :V_ALTTAB, :V_IDEDIZM, :V_BB, :V_BC, :V_BD, :V_BE,
         :V_NORM_GUID, :V_IDMAME, :V_PODGROUP, /*:V_ABC_OKP_ISGROUPOKP,*/ :VN_VRPZ, :V_TAB, --<<[12447]
         :V_ID_ABC_OKP, :V_ABC_OKP_IDPODGROUP, :V_ABC_OKP_TAB, :V_ABC_OKP_COMMENT;

    -- ...   B_ABC_OKP  --[15371] -->
    if ((V_ID_SELF = 0) and (ID_CUR_PODGROUP > 1)) then
    begin

      V_TAB = null;
      select upper(TAB) from B_ABC_OKP
        where (ID = :VN_NORM_ID)
      into :V_TAB;

      if (V_TAB is not null) then
        V_STAB = V_TAB;
      else
        --       0.0-0-0-->9999990001
        execute procedure M_CONVERT_RES_TAB(:IDUSER, :V_STAB, :ID_CUR_NAME)
          returning_values (:V_STAB);

      if (V_STAB is not null) then
      begin
        --<TFS[578],TFS[580]>
        if (:IN_PODGROUP = 1 and :IDPODGROUP2017 is null) then
        begin
          select rr.IDPODGROUPNORM from B_RESURS rr
            right join A_SMETA sm on sm.IDNORMATIV=rr.IDRAB
            where sm.ID=:ID_SOURCE
              and rr.IDPODGROUP=1
              and rr.IDPODGROUPNORM <> 1
            rows 1
          into :IDPODGROUP2017;
          if (:IDPODGROUP2017 is null) then
            IDPODGROUP2017 = 0;
        end
        --</>

        select first 1 ID_SELF, ALTTAB, IDEDIZM, BB, BC, BD, BE,
           NORM_GUID, IDNAME, PODGROUP, /*ABC_OKP_ISGROUPOKP,*/ VRPZ, TAB, --<<[12447]
           ID_ABC_OKP, ABC_OKP_IDPODGROUP, ABC_OKP_TAB, ABC_OKP_COMMENT
        from M_FB_SEARCH_NORMATIV_EX(
                case when :IN_PODGROUP = 1 and :IDPODGROUP2017 > 1 then :IDPODGROUP2017 else :IN_PODGROUP end, --TFS[578],TFS[580] :IN_PODGROUP
                :RABMAT/*-1*/, :IDUSER, :V_STAB,
                :ID_PUT_RAB, :ID_PUT_MASH, :ID_PUT_MAT, 0,
                :RES_NAME_CRC, :RES_NAME_ID/*[15371, 15408]*/, :RES_EDIZM_NAME)
        into :V_ID_SELF, :V_ALTTAB, :V_IDEDIZM, :V_BB, :V_BC, :V_BD, :V_BE,
             :V_NORM_GUID, :V_IDMAME, :V_PODGROUP, /*:V_ABC_OKP_ISGROUPOKP,*/ :VN_VRPZ, :V_TAB, --<<[12447]
             :V_ID_ABC_OKP, :V_ABC_OKP_IDPODGROUP, :V_ABC_OKP_TAB, :V_ABC_OKP_COMMENT;
      end
    end -- <--[15371]

    --  
    if (V_ID_SELF > 0) then
    begin

      --[15371] --> 9999990001-->0.0-0-0
      --    :  - 0
      if (:V_PODGROUP > 1) then
        if ((:V_RES_APPLY_TAB = 0) and (:V_ABC_OKP_COMMENT <> '')) then
           V_TAB = :V_ABC_OKP_COMMENT;

      --       ABC,     ABC
      if (:V_PODGROUP = 1) then --    
        if ((ID_CUR_PODGROUP > 1) and (:V_ID_ABC_OKP > 0)) then
        begin
          V_ID_SELF = V_ID_ABC_OKP;
          V_PODGROUP = V_ABC_OKP_IDPODGROUP;
          if (:V_RES_APPLY_TAB <> 0) then
            V_TAB = V_ABC_OKP_TAB;
        end
      -- <--[15371]

      --   
      --if (v_ABC_OKP_ISGROUPOKP = 0) then -- MK 24.12.2007 CQ[5749] 
      begin
        --     
        if (RES_IDEDIZM <> V_IDEDIZM) then
        begin
          EdizmSuccess = 0;
          --     .    
          --     
          select first 1 IDGROUP, RELATION
            from B_FIND_EDIZM_EX(:IDUSER, :RES_IDEDIZM, '')
          into :OLD_EDIZMIDGROUP, :OLD_EDIZMRELATION;

          select first 1 IDGROUP, RELATION
            from B_FIND_EDIZM_EX(:IDUSER, :V_IDEDIZM, '')
          into :NEW_EDIZMIDGROUP, :NEW_EDIZMRELATION;

          --TFS[250]
          USER_EDIZMRELATION = null;
          select first 1 EDIZMRELATION
          from GTT_CONVERT_OBJ_VNB_BAD_EDIZM
          where (SM_ID_EDIZM = :RES_IDEDIZM) and
                (NORM_ID_EDIZM = :V_IDEDIZM)
          into :USER_EDIZMRELATION;
          --TFS[250]

          --          
          --   . 
          if ( ((OLD_EDIZMIDGROUP is not null) and (NEW_EDIZMIDGROUP is not null) and
               (OLD_EDIZMIDGROUP = NEW_EDIZMIDGROUP)) or
               (USER_EDIZMRELATION is not null) )
          then
          begin
            if (USER_EDIZMRELATION is null) then
              RESULT_EDIZM_KOEFF = OLD_EDIZMRELATION / NEW_EDIZMRELATION;
            else
              RESULT_EDIZM_KOEFF = USER_EDIZMRELATION; --TFS[250]

            RES_RASHOD_BASE = RES_RASHOD_BASE * RESULT_EDIZM_KOEFF;
            EDIZMSUCCESS = 1;
          end
        end
        --    
        else
          EDIZMSUCCESS = 1;

        --    
        if (EDIZMSUCCESS = 1) then
        begin

          --      
          RES_RASHOD = RES_RASHOD_BASE;
          if (REC_CORRECT <> '') then
          begin
            select first 1 IFLAG, DITOGNORMRASH
              from K_CALCULATENORMRASH(:REC_CORRECT, :RES_RASHOD_BASE, :IDUSER)
            into :IFLAG, :RES_RASHOD_CALC;
            if (IFLAG = 1) then
              RES_RASHOD = RES_RASHOD_CALC;
          end

          -- cq[Timur 6747]
          if (REPLACE_CHANGE_NAME = 0) then
          begin
            execute procedure T_IS_CHANGED_CRC_NAME (:IDUser,
                                                     :VN_NORM_ID, --:ID [15371,15408] -  ID ,   ID  
                                                     :ID_CUR_NAME,
                                                     :RABMAT,
                                                     :ID_CUR_PODGROUP )
            returning_values ( :ISCHANGEDNAME );
          end
          else
            ISCHANGEDNAME = 0;
          -- cq[Timur 6747]

          --      
          update A_S_RES set
              TAB = :V_TAB, --<<[12447]
              ALTTAB = :V_ALTTAB,
              IDEDIZM = :V_IDEDIZM,
          -- cq[Timur 6747]
              -- NAME_ID = :V_IDMAME,
              --    ,      
              NAME_ID = case when :ISCHANGEDNAME = 1 then NAME_ID else :V_IDMAME end,
          -- cq[Timur 6747]
              RASHOD = :RES_RASHOD,
              RASHOD_BASE = :RES_RASHOD_BASE,
              -- 
              BB = :V_BB,
              BC = :V_BC,
              BD = :V_BD,
              BE = :V_BE,
              --   
              NORM_ID = :V_ID_SELF,
              NORM_GUID = :V_NORM_GUID,
              NORM_PODGROUP = :V_PODGROUP -- [15371, 15408] --> :IN_PODGROUP
              --ID_PRICE = 0  CQ[6884] 
          where (ID = :ID);

          -- chinger CQ[9301] ->
          for select ID_LEVEL
            from NL_CTRL_ENTER_RESURCY(:IDOBJECT, :ID, 15, :IDUSER, :VN_VRPZ,
              :V_BB, :V_BC, :V_BD, :V_BE, 0/*:UPDATE_ALL_ACT*/)
          into :VN_ID_LEVEL
          do
          begin
            --nothing
            VN_ID_LEVEL = :VN_ID_LEVEL;
          end
          -- chinger CQ[9301] <-

          delete from SMETA_PRICEPOS_INFO where ID = :ID;
        end
        --     
        else
          CONVERT_RESULT = 2;

      end
    end
    --   
    else
    begin
      CONVERT_RESULT = 1;
      if (CLEARPRICE_IFNOTFOUND = 1) then
      begin
        --   
        update A_S_RES
        set BB = 0,
            BC = 0,
            BD = 0,
            BE = 0,

            NORM_ID = 0 -- MK 24.12.2007 CQ[5749]

           -- ID_PRICE = 0 CQ[6884] 
        where (ID = :ID);

        --cq[9301] chinger ->
        for select ID
          from LEVEL_COST
          where (IDOBJECT = :IDOBJECT)
        into :VN_ID_LEVEL do
        begin
          update A_S_RES_CENLVL CL
          set CL.BB = 0,
              CL.BC = 0,
              CL.BD = 0,
              CL.BE = 0
          where (CL.ID = :ID) and (CL.IDCENLVL = :VN_ID_LEVEL);
        end
        --cq[9301] chinger ->

        delete from SMETA_PRICEPOS_INFO where ID = :ID;
      end
      else
      begin
        -- MK 24.12.2007 CQ[5749] --->
        update A_S_RES
          set NORM_ID = 0
        where (ID = :ID);
        -- MK 24.12.2007 <---
      end
    end

    --  
    if ((RETURN_ALL = 1) or (CONVERT_RESULT <> 0)) then
      suspend;
  end
end
^

create or alter procedure V_TEMP_DROP_PROCEDURE
AS
BEGIN
  if (exists(select RDB$PROCEDURE_NAME
          from RDB$PROCEDURES P
          where (upper(P.RDB$PROCEDURE_NAME) = 'FIND_FOLDER_BASE_ID')))
  then
  begin
    execute statement 'drop procedure FIND_FOLDER_BASE_ID';
  end
END
^
execute procedure V_TEMP_DROP_PROCEDURE
^
drop procedure V_TEMP_DROP_PROCEDURE
^^

create or alter procedure T_TMP_PROC_TFS_355
as
begin
  if (not exists(
    select * from RDB$RELATION_FIELDS
      where (upper(RDB$RELATION_NAME) = 'L_STROYKI') and
            (upper(RDB$FIELD_NAME) = 'NAME') and
            (upper(RDB$FIELD_SOURCE) = 'A_VARCHAR1024')))
  then
  begin
    update RDB$RELATION_FIELDS set
          RDB$FIELD_SOURCE = 'A_VARCHAR1024'
    where (upper(RDB$RELATION_NAME) = 'L_STROYKI') and
          (upper(RDB$FIELD_NAME) = 'NAME');
  end

  if (not exists(
    select * from RDB$RELATION_FIELDS
      where (upper(RDB$RELATION_NAME) = 'L_STROYKI') and
            (upper(RDB$FIELD_NAME) = 'SHIFR') and
            (upper(RDB$FIELD_SOURCE) = 'A_VARCHAR1024')))
  then
  begin
    update RDB$RELATION_FIELDS set
          RDB$FIELD_SOURCE = 'A_VARCHAR1024'
    where (upper(RDB$RELATION_NAME) = 'L_STROYKI') and
          (upper(RDB$FIELD_NAME) = 'SHIFR');
  end

end^

execute procedure T_TMP_PROC_TFS_355
^

drop procedure T_TMP_PROC_TFS_355
^^

--TFS[355]
create or alter procedure L_IMP_SEARCH_STROYKA (
    SHIFR varchar(1024),
    NAME varchar(1024))
returns (
    ID_SELF integer)
as
declare variable S_ID_SELF integer;
declare variable S_SHIFR varchar(1024);
declare variable S_NAME  varchar(1024);
declare variable U_SHIFR varchar(1024);
declare variable U_NAME  varchar(1024);
declare variable US_SHIFR varchar(1024);
declare variable US_NAME  varchar(1024);
begin
--TFS[355]-  

   ID_SELF = 0;
   if ( SHIFR is null ) then
      U_SHIFR = '';
   else
      U_SHIFR = trim(upper(SHIFR)); --TFS[355] LCKUPPERVARCHAR
   if ( NAME is null ) then
      U_NAME = '';
   else
      U_NAME = trim(upper(NAME)); --TFS[355] LCKUPPERVARCHAR
   if ( ( U_SHIFR = '' ) and ( U_NAME = '' ) ) then
      exit;

   for select ID_SELF, SHIFR, NAME from L_STROYKI S
       where ( S.ID_SELF > 0 ) and ( S.ID_TYPE = 1 )
       into S_ID_SELF, S_SHIFR, S_NAME
   do
   begin
      if ( S_SHIFR is null ) then
         US_SHIFR = '';
      else
         US_SHIFR = trim(upper(S_SHIFR)); --TFS[355] LCKUPPERVARCHAR
      if ( S_NAME is null ) then
         US_NAME = '';
      else
         US_NAME = trim(upper(S_NAME)); --TFS[355] LCKUPPERVARCHAR

      if ( ( U_SHIFR = US_SHIFR ) and ( U_NAME = US_NAME ) ) then
      begin
         ID_SELF = S_ID_SELF;
         suspend;
         exit;
      end
   end
end^

--TFS[355]
create or alter procedure L_STR_GETNODEHIERARCHY (
    ID_NODE integer)
returns (
    ID_SELF integer,
    ID_PARENT integer,
    ID_TYPE integer,
    SHIFR varchar(1024),
    NAME varchar(1024))
AS
begin
--TFS[355]-  

  ID_PARENT = ID_NODE;
  while (not ID_PARENT is null) do
  begin
     ID_SELF = null;
     select ID_SELF, ID_PARENT, ID_TYPE, SHIFR, NAME
       from L_STROYKI
       where ID_SELF = :ID_PARENT
     into :ID_SELF, :ID_PARENT, :ID_TYPE, :SHIFR, :NAME;

     ID_NODE = ID_PARENT;
     if (not ID_SELF is null) then
        suspend;
     else
        exit;
  end
end^

--TFS[355]
create or alter procedure A_H_GETOBJECTPARAM (
    IDUSER integer,
    ID integer)
returns (
    IDTN integer,
    ISCLC integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ID_TR integer,
    ID_ZONE integer,
    SAVECENZONETONORMBASE integer,
    INDEX_ID_ORG integer,
    INDEX_ID_GOD integer,
    INDEX_ID_MES integer,
    INDEX_NASNACHAUTO integer,
    INDEX_ZAMENNASNACH integer,
    INDEX_UCHITNDS integer,
    INDEX_SPOSOBRASCH integer,
    INDEX_RASCHNRISP integer,
    INDEX_BRAT_ZU_IS integer,
    INDEX_FOT integer,
    RES_ZANOSIT_S_RES integer,
    RES_TOLKO_NEUCHT_RES integer,
    RES_COPY_INDEX integer,
    RES_COPY_POPR integer,
    RES_COPY_FORMULS integer,
    RES_APPLY_TAB integer,
    NE_OBNUL_KOLL integer,
    NE_OBNUL_NR integer,
    NE_OBNUL_RES integer,
    NE_OBNUL_IND integer,
    NE_OBNUL_POPR integer,
    NE_OBNUL_FORMULS integer,
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision,
    PRECED integer,
    PRECIT integer,
    PUT_ID_GROUP integer,
    PUT_ID_RAB integer,
    PUT_ID_MASH integer,
    PUT_ID_MAT integer,
    NAME_STROYKI varchar(1024),
    OCHERED_STROIT varchar(1024),
    PUSK_KOMPLEX varchar(1024),
    NUMGLSSR integer,
    DOGOVOR varchar(1024),
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VELICHSTROBJ double precision,
    EDIZM varchar(40),
    STAD_PROEKT integer,
    NACH_STROY date,
    OKONCH_STROIT date,
    V_KAKIH_CENAH_MES integer,
    V_KAKIH_CENAH_GOD integer,
    SPISOKSHERT blob sub_type 0 segment size 80,
    OPISANIE blob sub_type 0 segment size 80,
    ADRESS_OBJECTA blob sub_type 0 segment size 80,
    ISPOLNIL_FIO varchar(250),
    ISPOLNIL_DOLGN varchar(100),
    PROVERIL_FIO varchar(250),
    PROVERIL_DOLGN varchar(100),
    UTVERDIL_FIO varchar(250),
    UTVERDIL_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    SUBPODR_ID_ORG integer,
    SUBPODR_NAME_ORG varchar(255),
    SUBPODR_ID integer,
    SUBPODR_FIO varchar(250),
    SUBPODR_DOLGN varchar(100),
    GLAVN_ING_FIO varchar(250),
    BOSS_FIO varchar(250),
    BOSS_DOLGN varchar(100),
    BOSS_OTDEL varchar(100),
    UTV integer,
    DORECALK integer,
    POPR_CURRENTGROUP integer,
    TRUD_SYNH_STR integer,
    TRUD_SYNH_MASH integer,
    MODE_KOMPNS_ST integer,
    CODE varchar(512),
    REPLACECORRECTION integer,
    CORRECTIONRULE integer,
    REVISION varchar(255),
    KODSTROYKI integer,
    APPLY_TO_ALL_IDLEVEL integer,
    APPLY_TO_ALL_IDLEVEL_SNB integer,
    AUTO_RENUM_MODE integer,
    AUTO_RENUM_START integer,
    AUTO_RENUM_STEP integer,
    SPEC_INFO integer)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
--TFS[355]-   NAME_STROYKI, OCHERED_STROIT, PUSK_KOMPLEX
--DECLARE VARIABLE CUR_KODSTROYKI INTEGER;
DECLARE VARIABLE CUR_KODDOG INTEGER;
DECLARE VARIABLE CUR_KODSTROYKI_TYPE INTEGER;
DECLARE VARIABLE CUR_KODSTROYKI_NAME VARCHAR(1024);
DECLARE VARIABLE tmpCount INTEGER;
begin

/* if ( not exists ( select h.number
                   from a_o_hier h
                   where h.number = :id and h.atype = 1 ) )
 then
 begin

  exception A_ELSTRUCTNOTFOUND;
  exit;

 end*/

 if ( not exists ( select p.number
                   from A_O_OBJECTPARAMS p
                   where p.number = :id ) )
 then
 begin

  exception AE_PARAM_NOT_FOUND;
  exit;

 end

 cur_koddog = null;
 kodstroyki = null;

 for select p.idtn, p.ISCLC, p.KODIR_GROUP, p.KODIR_PODGROUP, p.ID_TR, p.ID_ZONE,
            p.SAVECENZONETONORMBASE, p.INDEX_ID_ORG, p.INDEX_ID_GOD, p.INDEX_ID_MES,
            p.INDEX_NASNACHAUTO, p.INDEX_ZAMENNASNACH, p.INDEX_UCHITNDS, p.INDEX_SPOSOBRASCH,
            p.INDEX_RASCHNRISP, p.INDEX_BRAT_ZU_IS, p.INDEX_FOT, p.RES_ZANOSIT_S_RES,
            p.RES_TOLKO_NEUCHT_RES, p.RES_COPY_INDEX, p.RES_COPY_POPR, p.RES_COPY_FORMULS,
            p.RES_APPLY_TAB, p.NE_OBNUL_KOLL, p.NE_OBNUL_NR, p.NE_OBNUL_RES, p.NE_OBNUL_IND,
            p.NE_OBNUL_POPR, p.NE_OBNUL_FORMULS, p.NR_OT_ZPM, p.SP_OT_ZPM, p.PRECED, p.PRECIT,
            p.PUT_ID_GROUP, p.PUT_ID_RAB, p.PUT_ID_MASH, p.PUT_ID_MAT,
            p.KODSTROYKI, p.KODDOG, p.NUMGLSSR,
            p.SHIFR, p.FULLNAME,
            p.VELICHSTROBJ, p.EDIZM, p.STAD_PROEKT, p.NACH_STROY, p.OKONCH_STROIT,
            p.V_KAKIH_CENAH_MES, p.V_KAKIH_CENAH_GOD, p.SPISOKSHERT, p.OPISANIE,
            p.ADRESS_OBJECTA, p.ISPOLNIL_FIO, p.ISPOLNIL_DOLGN, p.PROVERIL_FIO,
            p.PROVERIL_DOLGN, p.UTVERDIL_FIO, p.UTVERDIL_DOLGN, p.ZAKAZCHIK_ID_ORG,
            p.ZAKAZCHIK_NAME_ORG, p.ZAKAZCHIK_ID, p.ZAKAZCHIK_FIO, p.ZAKAZCHIK_DOLGN,
            p.GENPODR_ID_ORG, p.GENPODR_NAME_ORG, p.GENPODR_ID, p.GENPODR_FIO, p.GENPODR_DOLGN,
            p.SUBPODR_ID_ORG, p.SUBPODR_NAME_ORG, p.SUBPODR_ID, p.SUBPODR_FIO, p.SUBPODR_DOLGN,
            p.GLAVN_ING_FIO, p.BOSS_FIO, p.BOSS_DOLGN, p.BOSS_OTDEL, p.utv, p.dorecalk,
            p.POPR_CURRENTGROUP, p.MODE_KOMPNS_ST, p.CODE,
            --CQ[9077]
            p.REPLACECORRECTION,
            p.CORRECTIONRULE,
            --CQ[9077]
            --CQ[9544]>>
            p.REVISION,
            p.APPLY_TO_ALL_IDLEVEL, --<<[12113]
            p.APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
            p.AUTO_RENUM_MODE, p.AUTO_RENUM_START, p.AUTO_RENUM_STEP, -- MK CQ[12020]
            p.SPEC_INFO /*15213*/
     from A_O_OBJECTPARAMS p
     where p.number = :id
     into :idtn, :ISCLC, :KODIR_GROUP, :KODIR_PODGROUP, :ID_TR, :ID_ZONE,
          :SAVECENZONETONORMBASE, :INDEX_ID_ORG, :INDEX_ID_GOD, :INDEX_ID_MES,
          :INDEX_NASNACHAUTO, :INDEX_ZAMENNASNACH, :INDEX_UCHITNDS, :INDEX_SPOSOBRASCH,
          :INDEX_RASCHNRISP, :INDEX_BRAT_ZU_IS, :INDEX_FOT, :RES_ZANOSIT_S_RES,
          :RES_TOLKO_NEUCHT_RES, :RES_COPY_INDEX, :RES_COPY_POPR, :RES_COPY_FORMULS,
          :RES_APPLY_TAB, :NE_OBNUL_KOLL, :NE_OBNUL_NR, :NE_OBNUL_RES, :NE_OBNUL_IND,
          :NE_OBNUL_POPR, :NE_OBNUL_FORMULS, :NR_OT_ZPM, :SP_OT_ZPM, :PRECED, :PRECIT,
          :PUT_ID_GROUP, :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT,
          :KODSTROYKI, :CUR_KODDOG, :NUMGLSSR,
          :SHIFR, :FULLNAME,
          :VELICHSTROBJ, :EDIZM, :STAD_PROEKT, :NACH_STROY, :OKONCH_STROIT,
          :V_KAKIH_CENAH_MES, :V_KAKIH_CENAH_GOD, :SPISOKSHERT, :OPISANIE,
          :ADRESS_OBJECTA, :ISPOLNIL_FIO, :ISPOLNIL_DOLGN, :PROVERIL_FIO,
          :PROVERIL_DOLGN, :UTVERDIL_FIO, :UTVERDIL_DOLGN, :ZAKAZCHIK_ID_ORG,
          :ZAKAZCHIK_NAME_ORG, :ZAKAZCHIK_ID, :ZAKAZCHIK_FIO, :ZAKAZCHIK_DOLGN,
          :GENPODR_ID_ORG, :GENPODR_NAME_ORG, :GENPODR_ID, :GENPODR_FIO, :GENPODR_DOLGN,
          :SUBPODR_ID_ORG, :SUBPODR_NAME_ORG, :SUBPODR_ID, :SUBPODR_FIO, :SUBPODR_DOLGN,
          :GLAVN_ING_FIO, :BOSS_FIO, :BOSS_DOLGN, :BOSS_OTDEL, :utv, :dorecalk,
          :POPR_CURRENTGROUP, :MODE_KOMPNS_ST, :CODE,
          --CQ[9077]
          :REPLACECORRECTION,
          :CORRECTIONRULE,
          --CQ[9077]
          --CQ[9544]>>
          :REVISION,
          :APPLY_TO_ALL_IDLEVEL, --<<[12113]
          :APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
          :AUTO_RENUM_MODE, :AUTO_RENUM_START, :AUTO_RENUM_STEP, -- MK CQ[12020]
          :SPEC_INFO /*15213*/
 do
 begin

  if ( not kodstroyki is null )
  then for select s.id_type, s.name
           from l_str_getnodehierarchy( :kodstroyki ) s
           into :CUR_kodstroyki_type, :CUR_kodstroyki_name
       do if ( CUR_kodstroyki_type = 1 )
          then name_stroyki = cur_kodstroyki_name;
          else if ( CUR_kodstroyki_type = 2 )
               then ochered_stroit = cur_kodstroyki_name;
               else if ( CUR_kodstroyki_type = 3 )
                    then pusk_komplex = cur_kodstroyki_name;

  if ( not cur_koddog is null )
  then for select s.id_type, s.name
           from l_str_getnodehierarchy( :cur_koddog ) s
           into :CUR_kodstroyki_type, :CUR_kodstroyki_name
       do if ( CUR_kodstroyki_type = 4 )
          then dogovor = cur_kodstroyki_name;

  trud_synh_str  = 1;
  trud_synh_mash = 1;


  /* MK 15.11.2004 */
  if ((:ID_TR is not null) and (:ID_TR <> 0)) then
  begin
     select count(*)
     from A_SRF_TR
     where (ID = :ID_TR)
     into :tmpCount;

     if (tmpCount = 0) then
        ID_TR = 0;
  end



  suspend;
  exit;

 end
end^

--TFS[355]
create or alter procedure A_S_GET_PARAMS_OBJ (
    AIDUSER integer,
    AIDHIER integer)
returns (
    ISCLC integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ID_TR integer,
    ID_ZONE integer,
    SAVECENZONETONORMBASE integer,
    INDEX_ID_ORG integer,
    INDEX_ID_GOD integer,
    INDEX_ID_MES integer,
    INDEX_NASNACHAUTO integer,
    INDEX_ZAMENNASNACH integer,
    INDEX_UCHITNDS integer,
    INDEX_SPOSOBRASCH integer,
    INDEX_RASCHNRISP integer,
    INDEX_BRAT_ZU_IS integer,
    INDEX_FOT integer,
    RES_ZANOSIT_S_RES integer,
    RES_TOLKO_NEUCHT_RES integer,
    RES_COPY_INDEX integer,
    RES_COPY_POPR integer,
    RES_COPY_FORMULS integer,
    RES_APPLY_TAB integer,
    NE_OBNUL_KOLL integer,
    NE_OBNUL_NR integer,
    NE_OBNUL_RES integer,
    NE_OBNUL_IND integer,
    NE_OBNUL_POPR integer,
    NE_OBNUL_FORMULS integer,
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision,
    PRECED integer,
    PRECIT integer,
    PUT_ID_GROUP integer,
    PUT_ID_RAB integer,
    PUT_ID_MASH integer,
    PUT_ID_MAT integer,
    NAME_STROYKI varchar(1024),
    OCHERED_STROIT varchar(1024),
    PUSK_KOMPLEX varchar(1024),
    NUMGLSSR integer,
    DOGOVOR varchar(1024),
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VELICHSTROBJ double precision,
    EDIZM varchar(40),
    STAD_PROEKT integer,
    NACH_STROY date,
    OKONCH_STROIT date,
    V_KAKIH_CENAH_MES integer,
    V_KAKIH_CENAH_GOD integer,
    SPISOKSHERT blob sub_type 0 segment size 80,
    OPISANIE blob sub_type 0 segment size 80,
    ADRESS_OBJECTA blob sub_type 0 segment size 80,
    ISPOLNIL_FIO varchar(250),
    ISPOLNIL_DOLGN varchar(100),
    PROVERIL_FIO varchar(250),
    PROVERIL_DOLGN varchar(100),
    UTVERDIL_FIO varchar(250),
    UTVERDIL_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    SUBPODR_ID_ORG integer,
    SUBPODR_NAME_ORG varchar(255),
    SUBPODR_ID integer,
    SUBPODR_FIO varchar(250),
    SUBPODR_DOLGN varchar(100),
    GLAVN_ING_FIO varchar(250),
    BOSS_FIO varchar(250),
    BOSS_DOLGN varchar(100),
    BOSS_OTDEL varchar(100),
    UTV integer,
    DORECALK integer,
    POPR_CURRENTGROUP integer,
    TRUD_SYNH_STR integer,
    TRUD_SYNH_MASH integer,
    MODE_KOMPNS_ST integer,
    IDTN integer,
    CODE varchar(512),
    REPLACECORRECTION integer,
    CORRECTIONRULE integer,
    AUTO_RENUM_MODE integer,
    AUTO_RENUM_START integer,
    AUTO_RENUM_STEP integer)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
--TFS[355]-   NAME_STROYKI, OCHERED_STROIT, PUSK_KOMPLEX
DECLARE VARIABLE CUR_ID_OBJ INTEGER;
begin

  execute procedure a_h_get_id_parentatype( :aidhier, 1 ) returning_values ( :cur_id_obj );

  if ( ( cur_id_obj <> -1 ) and
       ( not cur_id_obj is null ) )
  then select idtn,
              isclc,
              kodir_group,
              kodir_podgroup,
              id_tr,
              id_zone,
              savecenzonetonormbase,
              index_id_org,
              index_id_god,
              index_id_mes,
              index_nasnachauto,
              index_zamennasnach,
              index_uchitnds,
              index_sposobrasch,
              index_raschnrisp,
              index_brat_zu_is,
              index_fot,
              res_zanosit_s_res,
              res_tolko_neucht_res,
              res_copy_index,
              res_copy_popr,
              res_copy_formuls,
              res_apply_tab,
              ne_obnul_koll,
              ne_obnul_nr,
              ne_obnul_res,
              ne_obnul_ind,
              ne_obnul_popr,
              ne_obnul_formuls,
              nr_ot_zpm,
              sp_ot_zpm,
              preced,
              precit,
              put_id_group,
              put_id_rab,
              put_id_mash,
              put_id_mat,
              name_stroyki,
              ochered_stroit,
              pusk_komplex,
              numglssr,
              dogovor,
              shifr,
              fullname,
              velichstrobj,
              edizm,
              stad_proekt,
              nach_stroy,
              okonch_stroit,
              v_kakih_cenah_mes,
              v_kakih_cenah_god,
              spisokshert,
              opisanie,
              adress_objecta,
              ispolnil_fio,
              ispolnil_dolgn,
              proveril_fio,
              proveril_dolgn,
              utverdil_fio,
              utverdil_dolgn,
              zakazchik_id_org,
              zakazchik_name_org,
              zakazchik_id,
              zakazchik_fio,
              zakazchik_dolgn,
              genpodr_id_org,
              genpodr_name_org,
              genpodr_id,
              genpodr_fio,
              genpodr_dolgn,
              subpodr_id_org,
              subpodr_name_org,
              subpodr_id,
              subpodr_fio,
              subpodr_dolgn,
              glavn_ing_fio,
              boss_fio,
              boss_dolgn,
              boss_otdel,
              utv,
              dorecalk,
              POPR_CURRENTGROUP,
              TRUD_SYNH_STR,
              TRUD_SYNH_MASH,
              MODE_KOMPNS_ST,
              CODE,
              --CQ[9077]
              REPLACECORRECTION,
              CORRECTIONRULE,
              --CQ[9077]
              -- MK CQ[12020] --->
              AUTO_RENUM_MODE,
              AUTO_RENUM_START,
              AUTO_RENUM_STEP
              -- MK CQ[12020] <---
       from A_H_GETOBJECTPARAM( :aiduser, :cur_id_obj ) p
       into :idtn,
            :isclc,
            :kodir_group,
            :kodir_podgroup,
            :id_tr,
            :id_zone,
            :savecenzonetonormbase,
            :index_id_org,
            :index_id_god,
            :index_id_mes,
            :index_nasnachauto,
            :index_zamennasnach,
            :index_uchitnds,
            :index_sposobrasch,
            :index_raschnrisp,
            :index_brat_zu_is,
            :index_fot,
            :res_zanosit_s_res,
            :res_tolko_neucht_res,
            :res_copy_index,
            :res_copy_popr,
            :res_copy_formuls,
            :res_apply_tab,
            :ne_obnul_koll,
            :ne_obnul_nr,
            :ne_obnul_res,
            :ne_obnul_ind,
            :ne_obnul_popr,
            :ne_obnul_formuls,
            :nr_ot_zpm,
            :sp_ot_zpm,
            :preced,
            :precit,
            :put_id_group,
            :put_id_rab,
            :put_id_mash,
            :put_id_mat,
            :name_stroyki,
            :ochered_stroit,
            :pusk_komplex,
            :numglssr,
            :dogovor,
            :shifr,
            :fullname,
            :velichstrobj,
            :edizm,
            :stad_proekt,
            :nach_stroy,
            :okonch_stroit,
            :v_kakih_cenah_mes,
            :v_kakih_cenah_god,
            :spisokshert,
            :opisanie,
            :adress_objecta,
            :ispolnil_fio,
            :ispolnil_dolgn,
            :proveril_fio,
            :proveril_dolgn,
            :utverdil_fio,
            :utverdil_dolgn,
            :zakazchik_id_org,
            :zakazchik_name_org,
            :zakazchik_id,
            :zakazchik_fio,
            :zakazchik_dolgn,
            :genpodr_id_org,
            :genpodr_name_org,
            :genpodr_id,
            :genpodr_fio,
            :genpodr_dolgn,
            :subpodr_id_org,
            :subpodr_name_org,
            :subpodr_id,
            :subpodr_fio,
            :subpodr_dolgn,
            :glavn_ing_fio,
            :boss_fio,
            :boss_dolgn,
            :boss_otdel,
            :utv,
            :dorecalk,
            :popr_currentgroup,
            :trud_synh_str,
            :trud_synh_mash,
            :MODE_KOMPNS_ST,
            :CODE,
            --CQ[9077]
            :REPLACECORRECTION,
            :CORRECTIONRULE,
            --CQ[9077]
            -- MK CQ[12020] --->
            :AUTO_RENUM_MODE,
            :AUTO_RENUM_START,
            :AUTO_RENUM_STEP
            -- MK CQ[12020] <---
            ;

 suspend;
end^

--TFS[355]
create or alter procedure L_H_GETOBJECT_PROCENT_PARAM (
    IDUSER integer,
    ID integer)
returns (
    IDTN integer,
    ISCLC integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ID_TR integer,
    ID_ZONE integer,
    SAVECENZONETONORMBASE integer,
    INDEX_ID_ORG integer,
    INDEX_ID_GOD integer,
    INDEX_ID_MES integer,
    INDEX_NASNACHAUTO integer,
    INDEX_ZAMENNASNACH integer,
    INDEX_UCHITNDS integer,
    INDEX_SPOSOBRASCH integer,
    INDEX_RASCHNRISP integer,
    INDEX_BRAT_ZU_IS integer,
    INDEX_FOT integer,
    RES_ZANOSIT_S_RES integer,
    RES_TOLKO_NEUCHT_RES integer,
    RES_COPY_INDEX integer,
    RES_COPY_POPR integer,
    RES_COPY_FORMULS integer,
    RES_APPLY_TAB integer,
    NE_OBNUL_KOLL integer,
    NE_OBNUL_NR integer,
    NE_OBNUL_RES integer,
    NE_OBNUL_IND integer,
    NE_OBNUL_POPR integer,
    NE_OBNUL_FORMULS integer,
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision,
    PRECED integer,
    PRECIT integer,
    PUT_ID_GROUP integer,
    PUT_ID_RAB integer,
    PUT_ID_MASH integer,
    PUT_ID_MAT integer,
    NAME_STROYKI varchar(1024),
    OCHERED_STROIT varchar(1024),
    PUSK_KOMPLEX varchar(1024),
    NUMGLSSR integer,
    DOGOVOR varchar(1024),
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VELICHSTROBJ double precision,
    EDIZM varchar(40),
    STAD_PROEKT integer,
    NACH_STROY date,
    OKONCH_STROIT date,
    V_KAKIH_CENAH_MES integer,
    V_KAKIH_CENAH_GOD integer,
    SPISOKSHERT blob sub_type 0 segment size 80,
    OPISANIE blob sub_type 0 segment size 80,
    ADRESS_OBJECTA blob sub_type 0 segment size 80,
    ISPOLNIL_FIO varchar(250),
    ISPOLNIL_DOLGN varchar(100),
    PROVERIL_FIO varchar(250),
    PROVERIL_DOLGN varchar(100),
    UTVERDIL_FIO varchar(250),
    UTVERDIL_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    SUBPODR_ID_ORG integer,
    SUBPODR_NAME_ORG varchar(255),
    SUBPODR_ID integer,
    SUBPODR_FIO varchar(250),
    SUBPODR_DOLGN varchar(100),
    GLAVN_ING_FIO varchar(250),
    BOSS_FIO varchar(250),
    BOSS_DOLGN varchar(100),
    BOSS_OTDEL varchar(100),
    UTV_DATE date,
    OPLACHEN integer,
    OPL_SUM double precision,
    OPL_DATE date,
    NOMERDOC varchar(40),
    INVESTOR_KODOKPO varchar(40),
    INVESTOR_NAME varchar(255),
    INVESTOR_ID_ORG integer,
    INVESTOR_ID integer,
    INVESTOR_FIO varchar(250),
    INVESTOR_DOLGN varchar(100),
    ZAK_KODOKPO varchar(40),
    SUBPODR_KODOKPO varchar(40),
    STROYKA_KODOKPO varchar(40),
    OBJECT_KODOKPO varchar(40),
    VIDDEYATOKPD varchar(40),
    DOGPODR_NOMER varchar(40),
    DOGPODR_DATE date,
    VIDOPER varchar(40),
    OBJECT_NAME varchar(1024),
    LYEAR integer,
    LMONTH integer,
    USE_ONLY_UTV_PROCENT integer,
    UTV integer,
    DORECALK integer,
    POPR_CURRENTGROUP integer,
    TRUD_SYNH_STR integer,
    TRUD_SYNH_MASH integer,
    MODE_KOMPNS_ST integer,
    CODE varchar(512),
    GENPODR_KODOKPO varchar(40),
    REPLACECORRECTION integer,
    CORRECTIONRULE integer,
    NRSPOTZPM_USED integer,
    REVISION varchar(255),
    APPLY_TO_ALL_IDLEVEL integer,
    APPLY_TO_ALL_IDLEVEL_SNB integer,
    AUTO_RENUM_MODE integer,
    AUTO_RENUM_START integer,
    AUTO_RENUM_STEP integer,
    SPEC_INFO integer)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME, OBJECT_NAME
--TFS[355]-   NAME_STROYKI, OCHERED_STROIT, PUSK_KOMPLEX
DECLARE VARIABLE ID_OBJ INTEGER;
DECLARE VARIABLE ATYPE INTEGER;
DECLARE VARIABLE Y_MONTH INTEGER;
DECLARE VARIABLE Y_YEAR INTEGER;
DECLARE VARIABLE INBASKET INTEGER;
DECLARE VARIABLE CUR_KODSTROYKI INTEGER;
declare variable tmp_parent integer;
declare variable tmp_atype integer;
--[10111]    GOD_VID_NB integer,
begin
   ATYPE = null;
   for select h.atype from a_o_hier h where h.number = :id into :ATYPE
   do
     ATYPE = ATYPE;
     --cq[11569]
    -- isinexchange = 0;
     if ( ATYPE is null ) then
     begin
       ATYPE = 1;
       ID_OBJ = ID;
     end
     else if ( ATYPE = 1 ) then -- exception A_ELSTRUCTNOTFOUND;
     begin
--      ID_OBJ = ID;
       execute procedure a_h_get_id_parentatype( :id, 1 ) returning_values ( :id_obj );
     end
   else if ( ATYPE = 8 ) then
   begin
      id_obj = null;
      execute procedure a_h_get_id_parentatype( :id, 1 ) returning_values ( :id_obj );
      if ( ( id_obj is null ) or ( id_obj <= 0 ) ) then
      begin
         id_obj = null;
         execute procedure a_h_inbasket ( :id ) returning_values ( :inbasket );
         if ( inbasket = 0 ) then
            exception A_ELSTRUCTNOTFOUND;
      end
   end

  /* chinger: please do not delete
  for select p.parent
       from a_h_parentslist(:iduser, :id) p
   into :tmp_parent
   do begin
     isinexchange = iif((:tmp_parent = 517) or (isinexchange = 1) , 1, 0);
   end    */

   if ( not id_obj is null ) then
      if ( not exists ( select p.number
                        from A_O_OBJECTPARAMS p
                        where p.number = :id_obj ) ) then
         exception AE_PARAM_NOT_FOUND;

   if ( ATYPE = 8 ) then
      if ( not exists ( select p.number
                        from a_o_factparams p
                        where p.number = :id ) ) then
         exception AE_PARAM_NOT_FOUND;


   -- MK 4.07.2011 CQ[9295]
   --[10111]execute procedure T_GETGODVIDNB(:IDUSER, :id_obj) returning_values(:GOD_VID_NB);
   execute procedure T_GET_USENRSPOTZPM(:id_obj) returning_values :NRSPOTZPM_USED;

 /* read params for object */
   if ( not id_obj is null ) then
     for select
         IDTN, ISCLC, KODIR_GROUP, KODIR_PODGROUP, ID_TR, ID_ZONE,
         SAVECENZONETONORMBASE, INDEX_ID_ORG, INDEX_ID_GOD, INDEX_ID_MES,
         INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS, INDEX_SPOSOBRASCH,
         INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS, INDEX_FOT, RES_ZANOSIT_S_RES,
         RES_TOLKO_NEUCHT_RES, RES_COPY_INDEX, RES_COPY_POPR, RES_COPY_FORMULS,
         RES_APPLY_TAB, NE_OBNUL_KOLL, NE_OBNUL_NR, NE_OBNUL_RES, NE_OBNUL_IND,
         NE_OBNUL_POPR, NE_OBNUL_FORMULS, NR_OT_ZPM, SP_OT_ZPM, PRECED, PRECIT,
         PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT, NAME_STROYKI,
         OCHERED_STROIT, PUSK_KOMPLEX, NUMGLSSR, DOGOVOR, SHIFR, FULLNAME,
         VELICHSTROBJ, EDIZM, STAD_PROEKT, NACH_STROY, OKONCH_STROIT,
         V_KAKIH_CENAH_MES, V_KAKIH_CENAH_GOD, SPISOKSHERT, OPISANIE,
         ADRESS_OBJECTA, ISPOLNIL_FIO, ISPOLNIL_DOLGN, PROVERIL_FIO,
         PROVERIL_DOLGN, UTVERDIL_FIO, UTVERDIL_DOLGN, ZAKAZCHIK_ID_ORG,
         ZAKAZCHIK_NAME_ORG, ZAKAZCHIK_ID, ZAKAZCHIK_FIO, ZAKAZCHIK_DOLGN,
         GENPODR_ID_ORG, GENPODR_NAME_ORG, GENPODR_ID, GENPODR_FIO, GENPODR_DOLGN,
         SUBPODR_ID_ORG, SUBPODR_NAME_ORG, SUBPODR_ID, SUBPODR_FIO, SUBPODR_DOLGN,
         GLAVN_ING_FIO, BOSS_FIO, BOSS_DOLGN, BOSS_OTDEL, UTV, DORECALK,
         POPR_CURRENTGROUP, TRUD_SYNH_STR, TRUD_SYNH_MASH, MODE_KOMPNS_ST, CODE,
         REPLACECORRECTION, CORRECTIONRULE,
         REVISION,
         KODSTROYKI,
         APPLY_TO_ALL_IDLEVEL, --<<[12113]
         APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
         AUTO_RENUM_MODE, AUTO_RENUM_START, AUTO_RENUM_STEP, -- MK CQ[12020]
         SPEC_INFO
     from A_H_GETOBJECTPARAM ( :IDUSER , :ID_OBJ )
       into
         IDTN, ISCLC, KODIR_GROUP, KODIR_PODGROUP, ID_TR, ID_ZONE,
         SAVECENZONETONORMBASE, INDEX_ID_ORG, INDEX_ID_GOD, INDEX_ID_MES,
         INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS, INDEX_SPOSOBRASCH,
         INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS, INDEX_FOT, RES_ZANOSIT_S_RES,
         RES_TOLKO_NEUCHT_RES, RES_COPY_INDEX, RES_COPY_POPR, RES_COPY_FORMULS,
         RES_APPLY_TAB, NE_OBNUL_KOLL, NE_OBNUL_NR, NE_OBNUL_RES, NE_OBNUL_IND,
         NE_OBNUL_POPR, NE_OBNUL_FORMULS, NR_OT_ZPM, SP_OT_ZPM, PRECED, PRECIT,
         PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT, NAME_STROYKI,
         OCHERED_STROIT, PUSK_KOMPLEX, NUMGLSSR, DOGOVOR, SHIFR, FULLNAME,
         VELICHSTROBJ, EDIZM, STAD_PROEKT, NACH_STROY, OKONCH_STROIT,
         V_KAKIH_CENAH_MES, V_KAKIH_CENAH_GOD, SPISOKSHERT, OPISANIE,
         ADRESS_OBJECTA, ISPOLNIL_FIO, ISPOLNIL_DOLGN, PROVERIL_FIO,
         PROVERIL_DOLGN, UTVERDIL_FIO, UTVERDIL_DOLGN, ZAKAZCHIK_ID_ORG,
         ZAKAZCHIK_NAME_ORG, ZAKAZCHIK_ID, ZAKAZCHIK_FIO, ZAKAZCHIK_DOLGN,
         GENPODR_ID_ORG, GENPODR_NAME_ORG, GENPODR_ID, GENPODR_FIO, GENPODR_DOLGN,
         SUBPODR_ID_ORG, SUBPODR_NAME_ORG, SUBPODR_ID, SUBPODR_FIO, SUBPODR_DOLGN,
         GLAVN_ING_FIO, BOSS_FIO, BOSS_DOLGN, BOSS_OTDEL, utv, dorecalk,
         POPR_CURRENTGROUP, TRUD_SYNH_STR, TRUD_SYNH_MASH, MODE_KOMPNS_ST, CODE,
         --CQ[9077]
         :REPLACECORRECTION, :CORRECTIONRULE,
         --CQ[9077]
         --CQ[9544]>>
         :REVISION,
         :CUR_KODSTROYKI,
         :APPLY_TO_ALL_IDLEVEL, --<<[12113]
         :APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
         :AUTO_RENUM_MODE, :AUTO_RENUM_START, :AUTO_RENUM_STEP, -- MK CQ[12020],
         :SPEC_INFO /*15213*/
   do
   begin
      OBJECT_NAME = FULLNAME;
   end

      /* read params for procentov. */
      if ( ATYPE = 8 ) then
       for select
         IDTN, ISCLC, KODIR_GROUP, KODIR_PODGROUP, ID_TR, ID_ZONE,
         SAVECENZONETONORMBASE, INDEX_ID_ORG, INDEX_ID_GOD, INDEX_ID_MES,
         INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS, INDEX_SPOSOBRASCH,
         INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS, INDEX_FOT, RES_ZANOSIT_S_RES,
         RES_TOLKO_NEUCHT_RES, RES_COPY_INDEX, RES_COPY_POPR, RES_COPY_FORMULS,
         RES_APPLY_TAB, NE_OBNUL_KOLL, NE_OBNUL_NR, NE_OBNUL_RES, NE_OBNUL_IND,
         NE_OBNUL_POPR, NE_OBNUL_FORMULS, NR_OT_ZPM, SP_OT_ZPM, PRECED, PRECIT,
         PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT,
         SHIFR, FULLNAME,
         OPISANIE,
         ISPOLNIL_FIO, ISPOLNIL_DOLGN, PROVERIL_FIO,
         PROVERIL_DOLGN, UTVERDIL_FIO, UTVERDIL_DOLGN, ZAKAZCHIK_ID_ORG,
         ZAKAZCHIK_NAME_ORG, ZAKAZCHIK_ID, ZAKAZCHIK_FIO, ZAKAZCHIK_DOLGN,
         GENPODR_ID_ORG, GENPODR_NAME_ORG, GENPODR_ID, GENPODR_FIO, GENPODR_DOLGN,
         SUBPODR_ID_ORG, SUBPODR_NAME_ORG, SUBPODR_ID, SUBPODR_FIO, SUBPODR_DOLGN,
         UTV_DATE, OPLACHEN, OPL_SUM, OPL_DATE, NOMERDOC, INVESTOR_KODOKPO,
         INVESTOR_NAME, INVESTOR_ID_ORG, INVESTOR_ID, INVESTOR_FIO, INVESTOR_DOLGN,
         ZAK_KODOKPO, SUBPODR_KODOKPO, STROYKA_KODOKPO, OBJECT_KODOKPO,
         VIDDEYATOKPD, DOGPODR_NOMER, DOGPODR_DATE, VIDOPER, USE_ONLY_UTV_PROCENT,
         utv, dorecalk,
         POPR_CURRENTGROUP,
         MODE_KOMPNS_ST, CODE,
         GENPODR_KODOKPO, -- CQ[TIMUR 6902]
         --CQ[9077]
         0, --REPLACECORRECTION,
         0, --CORRECTIONRULE
         --CQ[9077]
         --CQ[9544]>>
         '',
         APPLY_TO_ALL_IDLEVEL, --<<[12113]
         APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
         AUTO_RENUM_MODE, AUTO_RENUM_START, AUTO_RENUM_STEP -- MK CQ[12020]
       from a_o_factparams
       where number = :id
       into
         IDTN, ISCLC, KODIR_GROUP, KODIR_PODGROUP, ID_TR, ID_ZONE,
         SAVECENZONETONORMBASE, INDEX_ID_ORG, INDEX_ID_GOD, INDEX_ID_MES,
         INDEX_NASNACHAUTO, INDEX_ZAMENNASNACH, INDEX_UCHITNDS, INDEX_SPOSOBRASCH,
         INDEX_RASCHNRISP, INDEX_BRAT_ZU_IS, INDEX_FOT, RES_ZANOSIT_S_RES,
         RES_TOLKO_NEUCHT_RES, RES_COPY_INDEX, RES_COPY_POPR, RES_COPY_FORMULS,
         RES_APPLY_TAB, NE_OBNUL_KOLL, NE_OBNUL_NR, NE_OBNUL_RES, NE_OBNUL_IND,
         NE_OBNUL_POPR, NE_OBNUL_FORMULS, NR_OT_ZPM, SP_OT_ZPM, PRECED, PRECIT,
         PUT_ID_GROUP, PUT_ID_RAB, PUT_ID_MASH, PUT_ID_MAT,
         SHIFR, FULLNAME,
         OPISANIE,
         ISPOLNIL_FIO, ISPOLNIL_DOLGN, PROVERIL_FIO,
         PROVERIL_DOLGN, UTVERDIL_FIO, UTVERDIL_DOLGN, ZAKAZCHIK_ID_ORG,
         ZAKAZCHIK_NAME_ORG, ZAKAZCHIK_ID, ZAKAZCHIK_FIO, ZAKAZCHIK_DOLGN,
         GENPODR_ID_ORG, GENPODR_NAME_ORG, GENPODR_ID, GENPODR_FIO, GENPODR_DOLGN,
         SUBPODR_ID_ORG, SUBPODR_NAME_ORG, SUBPODR_ID, SUBPODR_FIO, SUBPODR_DOLGN,
         UTV_DATE, OPLACHEN, OPL_SUM, OPL_DATE, NOMERDOC, INVESTOR_KODOKPO,
         INVESTOR_NAME, INVESTOR_ID_ORG, INVESTOR_ID, INVESTOR_FIO, INVESTOR_DOLGN,
         ZAK_KODOKPO, SUBPODR_KODOKPO, STROYKA_KODOKPO, OBJECT_KODOKPO,
         VIDDEYATOKPD, DOGPODR_NOMER, DOGPODR_DATE, VIDOPER, USE_ONLY_UTV_PROCENT,
         utv, dorecalk,
         POPR_CURRENTGROUP,
         MODE_KOMPNS_ST, CODE,
         GENPODR_KODOKPO, -- CQ[TIMUR 6902]
         --CQ[9077]
         :REPLACECORRECTION,
         :CORRECTIONRULE,
         --CQ[9077]
         --CQ[9544]>>
         :REVISION,
         :APPLY_TO_ALL_IDLEVEL, --<<[12113]
         :APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
         :AUTO_RENUM_MODE, :AUTO_RENUM_START, :AUTO_RENUM_STEP -- MK CQ[12020]
         do                       
         begin
            /* MK CQ[3493] 14.06.2006 */
            --FULLNAME = SHIFR;

            for select parent from a_o_hier where number = :id
                into y_month
            do
                y_month = y_month;

            for select sorting , parent from a_o_hier where number = :y_month
                into  lmonth , y_year
            do
               for select sorting from a_o_hier where number = :y_year
                   into  lyear
               do
                  lyear = lyear;


            /* MK 15.11.2004, semenov - 2004/12/06 */
            if (:ID_TR <> 0) then
            if (not exists (select * from A_SRF_TR where ID = :ID_TR)) then
             ID_TR = 0;

            suspend;
            exit;
         end

      suspend;
      exit;
end^

--TFS[355]
create or alter procedure A_GET_PARAMS_OBJ_AKT (
    IDUSER integer,
    ID_HIER integer,
    SMETATYPE integer)
returns (
    IDTN integer,
    ISCLC integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ID_TR integer,
    ID_ZONE integer,
    SAVECENZONETONORMBASE integer,
    INDEX_ID_ORG integer,
    INDEX_ID_GOD integer,
    INDEX_ID_MES integer,
    INDEX_NASNACHAUTO integer,
    INDEX_ZAMENNASNACH integer,
    INDEX_UCHITNDS integer,
    INDEX_SPOSOBRASCH integer,
    INDEX_RASCHNRISP integer,
    INDEX_BRAT_ZU_IS integer,
    INDEX_FOT integer,
    RES_ZANOSIT_S_RES integer,
    RES_TOLKO_NEUCHT_RES integer,
    RES_COPY_INDEX integer,
    RES_COPY_POPR integer,
    RES_COPY_FORMULS integer,
    RES_APPLY_TAB integer,
    NE_OBNUL_KOLL integer,
    NE_OBNUL_NR integer,
    NE_OBNUL_RES integer,
    NE_OBNUL_IND integer,
    NE_OBNUL_POPR integer,
    NE_OBNUL_FORMULS integer,
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision,
    PRECED integer,
    PRECIT integer,
    PUT_ID_GROUP integer,
    PUT_ID_RAB integer,
    PUT_ID_MASH integer,
    PUT_ID_MAT integer,
    NAME_STROYKI varchar(1024),
    OCHERED_STROIT varchar(1024),
    PUSK_KOMPLEX varchar(1024),
    NUMGLSSR integer,
    DOGOVOR varchar(1024),
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VELICHSTROBJ double precision,
    EDIZM varchar(40),
    STAD_PROEKT integer,
    NACH_STROY date,
    OKONCH_STROIT date,
    V_KAKIH_CENAH_MES integer,
    V_KAKIH_CENAH_GOD integer,
    SPISOKSHERT blob sub_type 0 segment size 80,
    OPISANIE blob sub_type 0 segment size 80,
    ADRESS_OBJECTA blob sub_type 0 segment size 80,
    ISPOLNIL_FIO varchar(250),
    ISPOLNIL_DOLGN varchar(100),
    PROVERIL_FIO varchar(250),
    PROVERIL_DOLGN varchar(100),
    UTVERDIL_FIO varchar(250),
    UTVERDIL_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    SUBPODR_ID_ORG integer,
    SUBPODR_NAME_ORG varchar(255),
    SUBPODR_ID integer,
    SUBPODR_FIO varchar(250),
    SUBPODR_DOLGN varchar(100),
    GLAVN_ING_FIO varchar(250),
    BOSS_FIO varchar(250),
    BOSS_DOLGN varchar(100),
    BOSS_OTDEL varchar(100),
    UTV_DATE date,
    OPLACHEN integer,
    OPL_SUM double precision,
    OPL_DATE date,
    NOMERDOC varchar(40),
    INVESTOR_KODOKPO varchar(40),
    INVESTOR_NAME varchar(255),
    INVESTOR_ID_ORG integer,
    INVESTOR_ID integer,
    INVESTOR_FIO varchar(250),
    INVESTOR_DOLGN varchar(100),
    ZAK_KODOKPO varchar(40),
    SUBPODR_KODOKPO varchar(40),
    STROYKA_KODOKPO varchar(40),
    OBJECT_KODOKPO varchar(40),
    VIDDEYATOKPD varchar(40),
    DOGPODR_NOMER varchar(40),
    DOGPODR_DATE date,
    VIDOPER varchar(40),
    OBJECT_NAME varchar(1024),
    LYEAR integer,
    LMONTH integer,
    USE_ONLY_UTV_PROCENT integer,
    UTV integer,
    DORECALK integer,
    POPR_CURRENTGROUP integer,
    TRUD_SYNH_STR integer,
    TRUD_SYNH_MASH integer,
    MODE_KOMPNS_ST integer,
    CODE varchar(512),
    GENPODR_KODOKPO varchar(40),
    APPLY_TO_ALL_IDLEVEL integer,
    APPLY_TO_ALL_IDLEVEL_SNB integer,
    AUTO_RENUM_MODE integer,
    AUTO_RENUM_START integer,
    AUTO_RENUM_STEP integer)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME, OBJECT_NAME
--TFS[355]-   NAME_STROYKI, OCHERED_STROIT, PUSK_KOMPLEX
declare variable id integer;
begin
 if ( smetatype in ( 15, 16 ) )
 then execute procedure a_h_get_id_parentatype( :id_hier, 1 ) returning_values ( :id );
 else id = smetatype;

 select first 1
        idtn, isclc, kodir_group, kodir_podgroup, id_tr, id_zone,
        savecenzonetonormbase, index_id_org, index_id_god, index_id_mes,
        index_nasnachauto, index_zamennasnach, index_uchitnds, index_sposobrasch,
        index_raschnrisp, index_brat_zu_is, index_fot, res_zanosit_s_res,
        res_tolko_neucht_res, res_copy_index, res_copy_popr, res_copy_formuls,
        res_apply_tab, ne_obnul_koll, ne_obnul_nr, ne_obnul_res, ne_obnul_ind,
        ne_obnul_popr, ne_obnul_formuls, nr_ot_zpm, sp_ot_zpm, preced,
        precit, put_id_group, put_id_rab, put_id_mash, put_id_mat,
        name_stroyki, ochered_stroit, pusk_komplex, numglssr, dogovor,
        shifr, fullname, velichstrobj, edizm, stad_proekt, nach_stroy,
        okonch_stroit, v_kakih_cenah_mes, v_kakih_cenah_god, spisokshert,
        opisanie, adress_objecta, ispolnil_fio, ispolnil_dolgn, proveril_fio,
        proveril_dolgn, utverdil_fio, utverdil_dolgn, zakazchik_id_org,
        zakazchik_name_org, zakazchik_id, zakazchik_fio, zakazchik_dolgn,
        genpodr_id_org, genpodr_name_org, genpodr_id, genpodr_fio,
        genpodr_dolgn, subpodr_id_org, subpodr_name_org, subpodr_id,
        subpodr_fio, subpodr_dolgn, glavn_ing_fio, boss_fio, boss_dolgn,
        boss_otdel, utv_date, oplachen, opl_sum, opl_date, nomerdoc,
        investor_kodokpo, investor_name, investor_id_org, investor_id,
        investor_fio, investor_dolgn, zak_kodokpo, subpodr_kodokpo,
        stroyka_kodokpo, object_kodokpo, viddeyatokpd, dogpodr_nomer,
        dogpodr_date, vidoper, object_name, lyear, lmonth, use_only_utv_procent,
        utv, dorecalk, popr_currentgroup, trud_synh_str, trud_synh_mash,
        mode_kompns_st, CODE, GENPODR_KODOKPO,
        APPLY_TO_ALL_IDLEVEL, --<<[12113]
        APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
        AUTO_RENUM_MODE, AUTO_RENUM_START, AUTO_RENUM_STEP -- MK CQ[12020]
 from l_h_getobject_procent_param( :iduser, :id )
 into :idtn, :isclc, :kodir_group, :kodir_podgroup, :id_tr, :id_zone,
      :savecenzonetonormbase, :index_id_org, :index_id_god, :index_id_mes,
      :index_nasnachauto, :index_zamennasnach, :index_uchitnds, :index_sposobrasch,
      :index_raschnrisp, :index_brat_zu_is, :index_fot, :res_zanosit_s_res,
      :res_tolko_neucht_res, :res_copy_index, :res_copy_popr, :res_copy_formuls,
      :res_apply_tab, :ne_obnul_koll, :ne_obnul_nr, :ne_obnul_res, :ne_obnul_ind,
      :ne_obnul_popr, :ne_obnul_formuls, :nr_ot_zpm, :sp_ot_zpm, :preced,
      :precit, :put_id_group, :put_id_rab, :put_id_mash, :put_id_mat,
      :name_stroyki, :ochered_stroit, :pusk_komplex, :numglssr, :dogovor,
      :shifr, :fullname, :velichstrobj, :edizm, :stad_proekt, :nach_stroy,
      :okonch_stroit, :v_kakih_cenah_mes, :v_kakih_cenah_god, :spisokshert,
      :opisanie, :adress_objecta, :ispolnil_fio, :ispolnil_dolgn, :proveril_fio,
      :proveril_dolgn, :utverdil_fio, :utverdil_dolgn, :zakazchik_id_org,
      :zakazchik_name_org, :zakazchik_id, :zakazchik_fio, :zakazchik_dolgn,
      :genpodr_id_org, :genpodr_name_org, :genpodr_id, :genpodr_fio,
      :genpodr_dolgn, :subpodr_id_org, :subpodr_name_org, :subpodr_id,
      :subpodr_fio, :subpodr_dolgn, :glavn_ing_fio, :boss_fio, :boss_dolgn,
      :boss_otdel, :utv_date, :oplachen, :opl_sum, :opl_date, :nomerdoc,
      :investor_kodokpo, :investor_name, :investor_id_org, :investor_id,
      :investor_fio, :investor_dolgn, :zak_kodokpo, :subpodr_kodokpo,
      :stroyka_kodokpo, :object_kodokpo, :viddeyatokpd, :dogpodr_nomer,
      :dogpodr_date, :vidoper, :object_name, :lyear, :lmonth, :use_only_utv_procent,
      :utv, :dorecalk, :popr_currentgroup, :trud_synh_str, :trud_synh_mash,
      :mode_kompns_st, :CODE, GENPODR_KODOKPO,
      :APPLY_TO_ALL_IDLEVEL, --<<[12113]
      :APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
      :AUTO_RENUM_MODE, :AUTO_RENUM_START, :AUTO_RENUM_STEP; -- MK CQ[12020]
  --<rvs:00003021>
  if (:ID_ZONE = -1) then
    ID_ZONE = 0;
  --</rvs:00003021>
      
 suspend;
end^

--TFS[355]
create or alter procedure M_GET_FULL_OBJ_PROC_PARAM (
    IDUSER integer,
    ID integer)
returns (
    IDTN integer,
    ISCLC integer,
    KODIR_GROUP integer,
    KODIR_PODGROUP integer,
    ID_TR integer,
    ID_ZONE integer,
    SAVECENZONETONORMBASE integer,
    INDEX_ID_ORG integer,
    INDEX_ID_GOD integer,
    INDEX_ID_MES integer,
    INDEX_NASNACHAUTO integer,
    INDEX_ZAMENNASNACH integer,
    INDEX_UCHITNDS integer,
    INDEX_SPOSOBRASCH integer,
    INDEX_RASCHNRISP integer,
    INDEX_BRAT_ZU_IS integer,
    INDEX_FOT integer,
    RES_ZANOSIT_S_RES integer,
    RES_TOLKO_NEUCHT_RES integer,
    RES_COPY_INDEX integer,
    RES_COPY_POPR integer,
    RES_COPY_FORMULS integer,
    RES_APPLY_TAB integer,
    NE_OBNUL_KOLL integer,
    NE_OBNUL_NR integer,
    NE_OBNUL_RES integer,
    NE_OBNUL_IND integer,
    NE_OBNUL_POPR integer,
    NE_OBNUL_FORMULS integer,
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision,
    PRECED integer,
    PRECIT integer,
    PUT_ID_GROUP integer,
    PUT_ID_RAB integer,
    PUT_ID_MASH integer,
    PUT_ID_MAT integer,
    NAME_STROYKI varchar(1024),
    OCHERED_STROIT varchar(1024),
    PUSK_KOMPLEX varchar(1024),
    NUMGLSSR integer,
    DOGOVOR varchar(1024),
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VELICHSTROBJ double precision,
    EDIZM varchar(40),
    STAD_PROEKT integer,
    NACH_STROY date,
    OKONCH_STROIT date,
    V_KAKIH_CENAH_MES integer,
    V_KAKIH_CENAH_GOD integer,
    SPISOKSHERT blob sub_type 0 segment size 80,
    OPISANIE blob sub_type 0 segment size 80,
    ADRESS_OBJECTA blob sub_type 0 segment size 80,
    ISPOLNIL_FIO varchar(250),
    ISPOLNIL_DOLGN varchar(100),
    PROVERIL_FIO varchar(250),
    PROVERIL_DOLGN varchar(100),
    UTVERDIL_FIO varchar(250),
    UTVERDIL_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    SUBPODR_ID_ORG integer,
    SUBPODR_NAME_ORG varchar(255),
    SUBPODR_ID integer,
    SUBPODR_FIO varchar(250),
    SUBPODR_DOLGN varchar(100),
    GLAVN_ING_FIO varchar(250),
    BOSS_FIO varchar(250),
    BOSS_DOLGN varchar(100),
    BOSS_OTDEL varchar(100),
    UTV_DATE date,
    OPLACHEN integer,
    OPL_SUM double precision,
    OPL_DATE date,
    NOMERDOC varchar(40),
    INVESTOR_KODOKPO varchar(40),
    INVESTOR_NAME varchar(255),
    INVESTOR_ID_ORG integer,
    INVESTOR_ID integer,
    INVESTOR_FIO varchar(250),
    INVESTOR_DOLGN varchar(100),
    ZAK_KODOKPO varchar(40),
    SUBPODR_KODOKPO varchar(40),
    STROYKA_KODOKPO varchar(40),
    OBJECT_KODOKPO varchar(40),
    VIDDEYATOKPD varchar(40),
    DOGPODR_NOMER varchar(40),
    DOGPODR_DATE date,
    VIDOPER varchar(40),
    OBJECT_NAME varchar(1024),
    LYEAR integer,
    LMONTH integer,
    USE_ONLY_UTV_PROCENT integer,
    UTV integer,
    DORECALK integer,
    POPR_CURRENTGROUP integer,
    TRUD_SYNH_STR integer,
    TRUD_SYNH_MASH integer,
    MODE_KOMPNS_ST integer,
    USER_CREATOR varchar(50),
    DATE_CREATE date,
    WORK_TIME integer,
    DATE_UTV date,
    EXT_TN_NAME varchar(100),
    EXT_KODIR_GROUP_NAME varchar(250),
    EXT_KODIR_PODGROUP_NAME varchar(250),
    EXT_TR_NAME varchar(250),
    EXT_ZONE_NAME varchar(250),
    EXT_INDEX_ORG_NAME varchar(250),
    EXT_INDEX_GOD_NAME varchar(250),
    EXT_INDEX_MES_NAME varchar(250),
    EXT_PUT_ID_GROUP_NAME varchar(250),
    EXT_PUT_ID_RAB_NAME varchar(250),
    EXT_PUT_ID_MASH_NAME varchar(250),
    EXT_PUT_ID_MAT_NAME varchar(250),
    EXT_POPR_NAME varchar(250),
    CODE varchar(512),
    LAST_CHANGE date,
    GENPODR_KODOKPO varchar(40),
    REPLACECORRECTION integer,
    CORRECTIONRULE integer,
    REVISION varchar(255))
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME, OBJECT_NAME
--TFS[355]-   NAME_STROYKI, OCHERED_STROIT, PUSK_KOMPLEX
begin
  for select idtn, isclc, kodir_group, kodir_podgroup, id_tr, id_zone,
             savecenzonetonormbase, index_id_org, index_id_god, index_id_mes,
             index_nasnachauto, index_zamennasnach, index_uchitnds,
             index_sposobrasch, index_raschnrisp, index_brat_zu_is, index_fot,
             res_zanosit_s_res, res_tolko_neucht_res, res_copy_index, res_copy_popr,
             res_copy_formuls, res_apply_tab, ne_obnul_koll, ne_obnul_nr,
             ne_obnul_res, ne_obnul_ind, ne_obnul_popr, ne_obnul_formuls, nr_ot_zpm,
             sp_ot_zpm, preced, precit, put_id_group, put_id_rab, put_id_mash,
             put_id_mat, name_stroyki, ochered_stroit, pusk_komplex, numglssr,
             dogovor, shifr, fullname, velichstrobj, edizm, stad_proekt, nach_stroy,
             okonch_stroit, v_kakih_cenah_mes, v_kakih_cenah_god, spisokshert,
             opisanie, adress_objecta, ispolnil_fio, ispolnil_dolgn, proveril_fio,
             proveril_dolgn, utverdil_fio, utverdil_dolgn, zakazchik_id_org,
             zakazchik_name_org, zakazchik_id, zakazchik_fio, zakazchik_dolgn,
             genpodr_id_org, genpodr_name_org, genpodr_id, genpodr_fio, genpodr_dolgn,
             subpodr_id_org, subpodr_name_org, subpodr_id, subpodr_fio, subpodr_dolgn,
             glavn_ing_fio, boss_fio, boss_dolgn, boss_otdel, utv_date, oplachen,
             opl_sum, opl_date, nomerdoc, investor_kodokpo, investor_name,
             investor_id_org, investor_id, investor_fio, investor_dolgn, zak_kodokpo,
             subpodr_kodokpo, stroyka_kodokpo, object_kodokpo, viddeyatokpd,
             dogpodr_nomer, dogpodr_date, vidoper, object_name, lyear, lmonth,
             use_only_utv_procent, utv, dorecalk, popr_currentgroup, trud_synh_str,
             trud_synh_mash, mode_kompns_st, CODE, GENPODR_KODOKPO,
             REPLACECORRECTION, CORRECTIONRULE, --CQ[9077]
             REVISION --CQ[9544]
  from l_h_getobject_procent_param(:iduser, :id)
  into :idtn, :isclc, :kodir_group, :kodir_podgroup, :id_tr, :id_zone,
       :savecenzonetonormbase, :index_id_org, :index_id_god, :index_id_mes,
       :index_nasnachauto, :index_zamennasnach, :index_uchitnds, :index_sposobrasch,
       :index_raschnrisp, :index_brat_zu_is, :index_fot, :res_zanosit_s_res,
       :res_tolko_neucht_res, :res_copy_index, :res_copy_popr, :res_copy_formuls,
       :res_apply_tab, :ne_obnul_koll, :ne_obnul_nr, :ne_obnul_res, :ne_obnul_ind,
       :ne_obnul_popr, :ne_obnul_formuls, :nr_ot_zpm, :sp_ot_zpm, :preced, :precit,
       :put_id_group, :put_id_rab, :put_id_mash, :put_id_mat, :name_stroyki,
       :ochered_stroit, :pusk_komplex, :numglssr, :dogovor, :shifr, :fullname,
       :velichstrobj, :edizm, :stad_proekt, :nach_stroy, :okonch_stroit,
       :v_kakih_cenah_mes, :v_kakih_cenah_god, :spisokshert, :opisanie,
       :adress_objecta, :ispolnil_fio, :ispolnil_dolgn, :proveril_fio,
       :proveril_dolgn, :utverdil_fio, :utverdil_dolgn, :zakazchik_id_org,
       :zakazchik_name_org, :zakazchik_id, :zakazchik_fio, :zakazchik_dolgn,
       :genpodr_id_org, :genpodr_name_org, :genpodr_id, :genpodr_fio,
       :genpodr_dolgn, :subpodr_id_org, :subpodr_name_org, :subpodr_id,
       :subpodr_fio, :subpodr_dolgn, :glavn_ing_fio, :boss_fio, :boss_dolgn,
       :boss_otdel, :utv_date, :oplachen, :opl_sum, :opl_date, :nomerdoc,
       :investor_kodokpo, :investor_name, :investor_id_org, :investor_id,
       :investor_fio, :investor_dolgn, :zak_kodokpo, :subpodr_kodokpo,
       :stroyka_kodokpo, :object_kodokpo, :viddeyatokpd, :dogpodr_nomer,
       :dogpodr_date, :vidoper, :object_name, :lyear, :lmonth, :use_only_utv_procent,
       :utv, :dorecalk, :popr_currentgroup, :trud_synh_str, :trud_synh_mash,
       :mode_kompns_st, :CODE, :GENPODR_KODOKPO,
       :REPLACECORRECTION, :CORRECTIONRULE, --CQ[9077]
       :REVISION --CQ[9544]
         do
  begin
    --   
    user_creator = null;
    date_create = null;
    work_time = null;
    date_utv = null;
    LAST_CHANGE = null;
    select first 1 e.user_creator, e.date_create, e.work_time, e.date_utv, e.last_change
    from m_struct_param_ext e
    where (e.id_struct = :id)
    into :user_creator, :date_create, :work_time, :date_utv, :LAST_CHANGE;

    --  
    ext_tn_name = null;
    if (:idtn > 0) then
      execute procedure k_spr_tn_select(:idtn, :iduser)
      returning_values :ext_tn_name;

    --  (, )
    ext_kodir_group_name = null;
    ext_kodir_podgroup_name = null;
    if (kodir_group > 0) then
      select first 1 b.name
      from b_group b
      where (b.id = :kodir_group)
      into :ext_kodir_group_name;
    if (kodir_podgroup > 0) then
      select first 1 pg.name
      from b_podgroup pg
      where (pg.id = :kodir_podgroup)
      into :ext_kodir_podgroup_name;

    --  
    ext_tr_name = null;
    if (id_tr > 0) then
      select first 1 t.name
      from a_srf_tr t
      where (t.id = :id_tr)
      into :ext_tr_name;

    --  
    ext_zone_name = null;
    if (id_zone > 0) then
      select first 1 z.name
      from b_zone z
      where (z.id = :id_zone)
      into :ext_zone_name;
    else if (id_zone = -3) then
      ext_zone_name = ' ';

    -- 
    ext_index_org_name = null;
    ext_index_god_name = null;
    ext_index_mes_name = null;
    if (index_id_org > 0) then
      select first 1 r.name
      from b_reestr r
      where (r.id = :index_id_org)
      into :ext_index_org_name;
    if (index_id_god > 0) then
      select first 1 r.name
      from b_reestr r
      where (r.id = :index_id_god)
      into :ext_index_god_name;
    if (index_id_mes > 0) then
      select first 1 r.name
      from b_reestr r
      where (r.id = :index_id_mes)
      into :ext_index_mes_name;

    --  
    ext_put_id_group_name = null;
    ext_put_id_rab_name = null;
    ext_put_id_mash_name = null;
    ext_put_id_mat_name = null;
    if (put_id_group > 0) then
      select first 1 p.name
      from b_putname p
      where (p.id = :put_id_group)
      into :ext_put_id_group_name;
    if (put_id_rab > 0) then
      select first 1 p.name
      from b_putname p
      where (p.id = :put_id_rab)
      into :ext_put_id_rab_name;
    if (put_id_mash > 0) then
      select first 1 p.name
      from b_putname p
      where (p.id = :put_id_mash)
      into :ext_put_id_mash_name;
    if (put_id_mat > 0) then
      select first 1 p.name
      from b_putname p
      where (p.id = :put_id_mat)
      into :ext_put_id_mat_name;

    -- 
    ext_popr_name = null;
    if (popr_currentgroup > 0) then
      select first 1 c.name
      from k_gr_correct_table c
      where (c.id = :popr_currentgroup)
      into :ext_popr_name;

    suspend;
  end
end^

--TFS[355]
create or alter procedure OBJECT_PROCENT_PARAMS_EXP_XML (
    IDUSER integer,
    ID integer)
returns (
    NUMBER integer,
    IDTN integer,
    TNNAME varchar(100),
    ISCLC integer,
    KODIR_GROUP_NAME varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ID_TR integer,
    GUID varchar(100),
    RES_ZANOSIT_S_RES integer,
    RES_TOLKO_NEUCHT_RES integer,
    RES_COPY_POPR integer,
    RES_COPY_FORMULS integer,
    RES_APPLY_TAB integer,
    NE_OBNUL_KOLL integer,
    NE_OBNUL_NR integer,
    NE_OBNUL_RES integer,
    NE_OBNUL_IND integer,
    NE_OBNUL_POPR integer,
    NE_OBNUL_FORMULS integer,
    PRECED integer,
    PRECIT integer,
    PUT_ID_GROUP integer,
    UNION_PATH varchar(250),
    PUT_ID_RAB integer,
    RAB_PATH varchar(250),
    PUT_ID_MASH integer,
    MASH_PATH varchar(250),
    PUT_ID_MAT integer,
    MAT_PATH varchar(250),
    NAME_STROYKI varchar(1024),
    OCHERED_STROIT varchar(1024),
    PUSK_KOMPLEX varchar(1024),
    NUMGLSSR integer,
    DOGOVOR varchar(1024),
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VELICHSTROBJ double precision,
    EDIZM varchar(40),
    STAD_PROEKT integer,
    NACH_STROY date,
    OKONCH_STROIT date,
    V_KAKIH_CENAH_MES integer,
    V_KAKIH_CENAH_GOD integer,
    SPISOKSHERT blob sub_type 0 segment size 80,
    OPISANIE blob sub_type 0 segment size 80,
    ADRESS_OBJECTA blob sub_type 0 segment size 80,
    ISPOLNIL_FIO varchar(250),
    ISPOLNIL_DOLGN varchar(100),
    PROVERIL_FIO varchar(250),
    PROVERIL_DOLGN varchar(100),
    UTVERDIL_FIO varchar(250),
    UTVERDIL_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    SUBPODR_ID_ORG integer,
    SUBPODR_NAME_ORG varchar(255),
    SUBPODR_ID integer,
    SUBPODR_FIO varchar(250),
    SUBPODR_DOLGN varchar(100),
    GLAVN_ING_FIO varchar(250),
    BOSS_FIO varchar(250),
    BOSS_DOLGN varchar(100),
    BOSS_OTDEL varchar(100),
    UTV_DATE date,
    OPLACHEN integer,
    OPL_SUM double precision,
    OPL_DATE date,
    NOMERDOC varchar(40),
    INVESTOR_KODOKPO varchar(40),
    INVESTOR_NAME varchar(255),
    INVESTOR_ID_ORG integer,
    INVESTOR_ID integer,
    INVESTOR_FIO varchar(250),
    INVESTOR_DOLGN varchar(100),
    ZAK_KODOKPO varchar(40),
    SUBPODR_KODOKPO varchar(40),
    STROYKA_KODOKPO varchar(40),
    OBJECT_KODOKPO varchar(40),
    VIDDEYATOKPD varchar(40),
    DOGPODR_NOMER varchar(40),
    DOGPODR_DATE date,
    VIDOPER varchar(40),
    OBJECT_NAME varchar(1024),
    LYEAR integer,
    LMONTH integer,
    USE_ONLY_UTV_PROCENT integer,
    UTV integer,
    DORECALK integer,
    POPR_CURRENTGROUP integer,
    POPR_CURRENTGROUP_NAME varchar(250),
    POPR_CURRENTGROUP_GUID varchar(100),
    MODE_KOMPNS_ST integer,
    CODE varchar(512),
    GENPODR_KODOKPO varchar(40),
    REPLACECORRECTION integer,
    CORRECTIONRULE integer,
    NRSPOTZPM_USED integer,
    CREATOR varchar(50),
    DATETIME_CREATOR date,
    REVISION varchar(255),
    VRIDDOC integer,
    VRDOCCAPTION varchar(20),
    VRNPPTEXT varchar(20),
    VRPRVALUE double precision,
    ZUIDDOC integer,
    ZUDOCCAPTION varchar(20),
    ZUNPPTEXT varchar(20),
    ZUPRVALUE double precision,
    CLIDDOC integer,
    CLDOCCAPTION varchar(20),
    CLNPPTEXT varchar(20),
    CLZONE integer,
    CLKOEF double precision,
    USER_CREATOR varchar(50),
    DATE_CREATE date,
    WORK_TIME integer,
    DATE_UTV date,
    LAST_CHANGE date,
    APPLY_TO_ALL_IDLEVEL integer,
    APPLY_TO_ALL_IDLEVEL_SNB integer,
    AUTO_RENUM_MODE integer,
    AUTO_RENUM_START integer,
    AUTO_RENUM_STEP integer)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME, OBJECT_NAME
--TFS[355]-   NAME_STROYKI, OCHERED_STROIT, PUSK_KOMPLEX
begin
  NUMBER = :ID;
  select P.IDTN, P.ISCLC, GR.NAME, PGR.NAME, P.ID_TR, P.RES_ZANOSIT_S_RES, P.RES_TOLKO_NEUCHT_RES,
         P.RES_COPY_POPR, P.RES_COPY_FORMULS, P.RES_APPLY_TAB, P.NE_OBNUL_KOLL, P.NE_OBNUL_NR,
         P.NE_OBNUL_RES, P.NE_OBNUL_IND, P.NE_OBNUL_POPR, P.NE_OBNUL_FORMULS, P.PRECED, P.PRECIT,
         P.PUT_ID_GROUP, P.PUT_ID_RAB, P.PUT_ID_MASH, P.PUT_ID_MAT, P.NAME_STROYKI,
         P.OCHERED_STROIT, P.PUSK_KOMPLEX, P.NUMGLSSR, P.DOGOVOR, P.SHIFR, P.FULLNAME,
         P.VELICHSTROBJ, P.EDIZM, P.STAD_PROEKT, P.NACH_STROY, P.OKONCH_STROIT, P.V_KAKIH_CENAH_MES,
         P.V_KAKIH_CENAH_GOD, P.SPISOKSHERT, P.OPISANIE, P.ADRESS_OBJECTA, P.ISPOLNIL_FIO,
         P.ISPOLNIL_DOLGN, P.PROVERIL_FIO, P.PROVERIL_DOLGN, P.UTVERDIL_FIO, P.UTVERDIL_DOLGN,
         P.ZAKAZCHIK_ID_ORG, P.ZAKAZCHIK_NAME_ORG, P.ZAKAZCHIK_ID, P.ZAKAZCHIK_FIO,
         P.ZAKAZCHIK_DOLGN, P.GENPODR_ID_ORG, P.GENPODR_NAME_ORG, P.GENPODR_ID, P.GENPODR_FIO,
         P.GENPODR_DOLGN, P.SUBPODR_ID_ORG, P.SUBPODR_NAME_ORG, P.SUBPODR_ID, P.SUBPODR_FIO,
         P.SUBPODR_DOLGN, P.GLAVN_ING_FIO, P.BOSS_FIO, P.BOSS_DOLGN, P.BOSS_OTDEL, P.UTV_DATE,
         P.OPLACHEN, P.OPL_SUM, P.OPL_DATE, P.NOMERDOC, P.INVESTOR_KODOKPO, P.INVESTOR_NAME,
         P.INVESTOR_ID_ORG, P.INVESTOR_ID, P.INVESTOR_FIO, P.INVESTOR_DOLGN, P.ZAK_KODOKPO,
         P.SUBPODR_KODOKPO, P.STROYKA_KODOKPO, P.OBJECT_KODOKPO, P.VIDDEYATOKPD, P.DOGPODR_NOMER,
         P.DOGPODR_DATE, P.VIDOPER, P.OBJECT_NAME, P.LYEAR, P.LMONTH, P.USE_ONLY_UTV_PROCENT, P.UTV,
         P.DORECALK, P.POPR_CURRENTGROUP, C.NAME, C.NORM_GUID, P.MODE_KOMPNS_ST, P.CODE, P.GENPODR_KODOKPO,
         P.REPLACECORRECTION, P.CORRECTIONRULE, P.NRSPOTZPM_USED, P.REVISION,
         P.APPLY_TO_ALL_IDLEVEL, --<<[12400,12113]
         P.APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
         p.AUTO_RENUM_MODE, p.AUTO_RENUM_START, p.AUTO_RENUM_STEP -- MK CQ[12020, 14357]
  from L_H_GETOBJECT_PROCENT_PARAM(:IDUSER, :ID) P
  left join K_GR_CORRECT_TABLE C on P.POPR_CURRENTGROUP = C.ID
  left join B_GROUP GR on GR.ID = P.KODIR_GROUP
  left join B_PODGROUP PGR on PGR.ID = P.KODIR_PODGROUP
  into :IDTN, :ISCLC, :KODIR_GROUP_NAME, :KODIR_PODGROUP_NAME, :ID_TR, :RES_ZANOSIT_S_RES,
       :RES_TOLKO_NEUCHT_RES, :RES_COPY_POPR, :RES_COPY_FORMULS, :RES_APPLY_TAB, :NE_OBNUL_KOLL,
       :NE_OBNUL_NR, :NE_OBNUL_RES, :NE_OBNUL_IND, :NE_OBNUL_POPR, :NE_OBNUL_FORMULS, :PRECED,
       :PRECIT, :PUT_ID_GROUP, :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT, :NAME_STROYKI,
       :OCHERED_STROIT, :PUSK_KOMPLEX, :NUMGLSSR, :DOGOVOR, :SHIFR, :FULLNAME, :VELICHSTROBJ,
       :EDIZM, :STAD_PROEKT, :NACH_STROY, :OKONCH_STROIT, :V_KAKIH_CENAH_MES, :V_KAKIH_CENAH_GOD,
       :SPISOKSHERT, :OPISANIE, :ADRESS_OBJECTA, :ISPOLNIL_FIO, :ISPOLNIL_DOLGN, :PROVERIL_FIO,
       :PROVERIL_DOLGN, :UTVERDIL_FIO, :UTVERDIL_DOLGN, :ZAKAZCHIK_ID_ORG, :ZAKAZCHIK_NAME_ORG,
       :ZAKAZCHIK_ID, :ZAKAZCHIK_FIO, :ZAKAZCHIK_DOLGN, :GENPODR_ID_ORG, :GENPODR_NAME_ORG,
       :GENPODR_ID, :GENPODR_FIO, :GENPODR_DOLGN, :SUBPODR_ID_ORG, :SUBPODR_NAME_ORG, :SUBPODR_ID,
       :SUBPODR_FIO, :SUBPODR_DOLGN, :GLAVN_ING_FIO, :BOSS_FIO, :BOSS_DOLGN, :BOSS_OTDEL, :UTV_DATE,
       :OPLACHEN, :OPL_SUM, :OPL_DATE, :NOMERDOC, :INVESTOR_KODOKPO, :INVESTOR_NAME,
       :INVESTOR_ID_ORG, :INVESTOR_ID, :INVESTOR_FIO, :INVESTOR_DOLGN, :ZAK_KODOKPO,
       :SUBPODR_KODOKPO, :STROYKA_KODOKPO, :OBJECT_KODOKPO, :VIDDEYATOKPD, :DOGPODR_NOMER,
       :DOGPODR_DATE, :VIDOPER, :OBJECT_NAME, :LYEAR, :LMONTH, :USE_ONLY_UTV_PROCENT, :UTV,
       :DORECALK, :POPR_CURRENTGROUP, :POPR_CURRENTGROUP_NAME, :POPR_CURRENTGROUP_GUID, :MODE_KOMPNS_ST, :CODE,
       :GENPODR_KODOKPO, :REPLACECORRECTION, :CORRECTIONRULE, :NRSPOTZPM_USED, :REVISION,
       :APPLY_TO_ALL_IDLEVEL, --<<[12400,12113]
       :APPLY_TO_ALL_IDLEVEL_SNB, --<<[12578]
       :AUTO_RENUM_MODE, :AUTO_RENUM_START, :AUTO_RENUM_STEP; -- MK CQ[12020, 14357]

  if (CORRECTIONRULE = -1) then
    CORRECTIONRULE = 0;/*    -      ,     CORRECTIONRULE = 0*/

  select NAME
  from B_PUTNAME
  where ID = :PUT_ID_GROUP
  into :UNION_PATH;

  select NAME
  from B_PUTNAME
  where ID = :PUT_ID_RAB
  into :RAB_PATH;

  select NAME
  from B_PUTNAME
  where ID = :PUT_ID_MASH
  into :MASH_PATH;

  select NAME
  from B_PUTNAME
  where ID = :PUT_ID_MAT
  into :MAT_PATH;

  select GUID
  from ENTITY_GUID
  where ID = :ID
  into :GUID;

  if (coalesce(:GUID, '') = '') then
  begin --[10786.1]
    insert into ENTITY_GUID (ID) values(:ID);
    select GUID from ENTITY_GUID where ID = :ID into :GUID;
  end

  select NAME
  from K_SPR_VNB
  where ID = :IDTN
  into :TNNAME;

  select USER_CREATOR, DATE_CREATE
  from M_STRUCT_PARAM_EXT
  where ID_STRUCT = :ID
  into :CREATOR, :DATETIME_CREATOR;

  -- <-- Voyager CQ[9758]
  select VRIDDOC, VRDOCCAPTION, VRNPPTEXT, VRPRVALUE, ZUIDDOC, ZUDOCCAPTION, ZUNPPTEXT, ZUPRVALUE, CLIDDOC, CLDOCCAPTION,
         CLNPPTEXT, CLZONE, CLKOEF
  from V_SELECT_VRZUCL_EXP_OBJ_XML(:ID)
  into :VRIDDOC, :VRDOCCAPTION, :VRNPPTEXT, :VRPRVALUE, :ZUIDDOC, :ZUDOCCAPTION, :ZUNPPTEXT, :ZUPRVALUE, :CLIDDOC,
       :CLDOCCAPTION, :CLNPPTEXT, :CLZONE, :CLKOEF;

  select USER_CREATOR, DATE_CREATE, WORK_TIME, DATE_UTV, LAST_CHANGE
  from M_STRUCT_PARAM_EXT
  where ID_STRUCT = :ID
  into :USER_CREATOR, :DATE_CREATE, :WORK_TIME, :DATE_UTV, :LAST_CHANGE;
  -- <-- CQ[9758]

  suspend;
end^

--TFS[355]
create or alter procedure V_SELECT_OBJPROC_PARAMS_EXP_XML (
    IDUSER integer,
    ID integer)
returns (
    NUMBER integer,
    IDTN integer,
    TNNAME varchar(100),
    ISCLC integer,
    KODIR_GROUP_NAME varchar(250),
    KODIR_PODGROUP_NAME varchar(250),
    ID_TR integer,
    GUID varchar(100),
    RES_ZANOSIT_S_RES integer,
    RES_TOLKO_NEUCHT_RES integer,
    RES_COPY_POPR integer,
    RES_COPY_FORMULS integer,
    RES_APPLY_TAB integer,
    NE_OBNUL_KOLL integer,
    NE_OBNUL_NR integer,
    NE_OBNUL_RES integer,
    NE_OBNUL_IND integer,
    NE_OBNUL_POPR integer,
    NE_OBNUL_FORMULS integer,
    NE_OBNUL_NAME integer,
    NR_OT_ZPM double precision,
    SP_OT_ZPM double precision,
    PRECED integer,
    PRECIT integer,
    UNION_PATH varchar(250),
    RAB_PATH varchar(250),
    MASH_PATH varchar(250),
    MAT_PATH varchar(250),
    NAME_STROYKI varchar(1024),
    OCHERED_STROIT varchar(1024),
    PUSK_KOMPLEX varchar(1024),
    NUMGLSSR integer,
    DOGOVOR varchar(1024),
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    VELICHSTROBJ double precision,
    EDIZM varchar(40),
    STAD_PROEKT integer,
    NACH_STROY date,
    OKONCH_STROIT date,
    V_KAKIH_CENAH_MES integer,
    V_KAKIH_CENAH_GOD integer,
    SPISOKSHERT blob sub_type 0 segment size 80,
    OPISANIE blob sub_type 0 segment size 80,
    ADRESS_OBJECTA blob sub_type 0 segment size 80,
    ISPOLNIL_FIO varchar(250),
    ISPOLNIL_DOLGN varchar(100),
    PROVERIL_FIO varchar(250),
    PROVERIL_DOLGN varchar(100),
    UTVERDIL_FIO varchar(250),
    UTVERDIL_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    SUBPODR_ID_ORG integer,
    SUBPODR_NAME_ORG varchar(255),
    SUBPODR_ID integer,
    SUBPODR_FIO varchar(250),
    SUBPODR_DOLGN varchar(100),
    GLAVN_ING_FIO varchar(250),
    BOSS_FIO varchar(250),
    BOSS_DOLGN varchar(100),
    BOSS_OTDEL varchar(100),
    UTV_DATE date,
    OPLACHEN integer,
    OPL_SUM double precision,
    OPL_DATE date,
    NOMERDOC varchar(40),
    INVESTOR_KODOKPO varchar(40),
    INVESTOR_NAME varchar(255),
    INVESTOR_ID_ORG integer,
    INVESTOR_ID integer,
    INVESTOR_FIO varchar(250),
    INVESTOR_DOLGN varchar(100),
    ZAK_KODOKPO varchar(40),
    SUBPODR_KODOKPO varchar(40),
    STROYKA_KODOKPO varchar(40),
    OBJECT_KODOKPO varchar(40),
    VIDDEYATOKPD varchar(40),
    DOGPODR_NOMER varchar(40),
    DOGPODR_DATE date,
    VIDOPER varchar(40),
    OBJECT_NAME varchar(1024),
    LYEAR integer,
    LMONTH integer,
    USE_ONLY_UTV_PROCENT integer,
    UTV integer,
    DORECALK integer,
    POPR_CURRENTGROUP varchar(250),
    MODE_KOMPNS_ST integer,
    CODE varchar(512),
    GENPODR_KODOKPO varchar(40),
    REPLACECORRECTION integer,
    CORRECTIONRULE integer,
    NRSPOTZPM_USED integer,
    REVISION varchar(255),
    USER_CREATOR varchar(50),
    DATE_CREATE date)
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME, OBJECT_NAME
--TFS[355]-   NAME_STROYKI, OCHERED_STROIT, PUSK_KOMPLEX
declare variable PUT_ID_GROUP integer;
declare variable PUT_ID_RAB integer;
declare variable PUT_ID_MASH integer;
declare variable PUT_ID_MAT integer;
begin
  NUMBER = :ID;
  select P.IDTN, P.ISCLC, GR.NAME, PGR.NAME, P.ID_TR, P.RES_ZANOSIT_S_RES, P.RES_TOLKO_NEUCHT_RES,
         P.RES_COPY_POPR, P.RES_COPY_FORMULS, P.RES_APPLY_TAB, P.NE_OBNUL_KOLL, P.NE_OBNUL_NR,
         P.NE_OBNUL_RES, P.NE_OBNUL_IND, P.NE_OBNUL_POPR, P.NE_OBNUL_FORMULS, P.NR_OT_ZPM,
         P.SP_OT_ZPM, P.PRECED, P.PRECIT, P.PUT_ID_GROUP, P.PUT_ID_RAB, P.PUT_ID_MASH, P.PUT_ID_MAT,
         P.NAME_STROYKI, P.OCHERED_STROIT, P.PUSK_KOMPLEX, P.NUMGLSSR, P.DOGOVOR, P.SHIFR,
         P.FULLNAME, P.VELICHSTROBJ, P.EDIZM, P.STAD_PROEKT, P.NACH_STROY, P.OKONCH_STROIT,
         P.V_KAKIH_CENAH_MES, P.V_KAKIH_CENAH_GOD, P.SPISOKSHERT, P.OPISANIE, P.ADRESS_OBJECTA,
         P.ISPOLNIL_FIO, P.ISPOLNIL_DOLGN, P.PROVERIL_FIO, P.PROVERIL_DOLGN, P.UTVERDIL_FIO,
         P.UTVERDIL_DOLGN, P.ZAKAZCHIK_ID_ORG, P.ZAKAZCHIK_NAME_ORG, P.ZAKAZCHIK_ID,
         P.ZAKAZCHIK_FIO, P.ZAKAZCHIK_DOLGN, P.GENPODR_ID_ORG, P.GENPODR_NAME_ORG, P.GENPODR_ID,
         P.GENPODR_FIO, P.GENPODR_DOLGN, P.SUBPODR_ID_ORG, P.SUBPODR_NAME_ORG, P.SUBPODR_ID,
         P.SUBPODR_FIO, P.SUBPODR_DOLGN, P.GLAVN_ING_FIO, P.BOSS_FIO, P.BOSS_DOLGN, P.BOSS_OTDEL,
         P.UTV_DATE, P.OPLACHEN, P.OPL_SUM, P.OPL_DATE, P.NOMERDOC, P.INVESTOR_KODOKPO,
         P.INVESTOR_NAME, P.INVESTOR_ID_ORG, P.INVESTOR_ID, P.INVESTOR_FIO, P.INVESTOR_DOLGN,
         P.ZAK_KODOKPO, P.SUBPODR_KODOKPO, P.STROYKA_KODOKPO, P.OBJECT_KODOKPO, P.VIDDEYATOKPD,
         P.DOGPODR_NOMER, P.DOGPODR_DATE, P.VIDOPER, P.OBJECT_NAME, P.LYEAR, P.LMONTH,
         P.USE_ONLY_UTV_PROCENT, P.UTV, P.DORECALK, C.NAME, P.MODE_KOMPNS_ST, P.CODE,
         P.GENPODR_KODOKPO, P.REPLACECORRECTION, P.CORRECTIONRULE, P.NRSPOTZPM_USED, P.REVISION,
         MS.USER_CREATOR, MS.DATE_CREATE
  from L_H_GETOBJECT_PROCENT_PARAM(:IDUSER, :ID) P
  left join K_GR_CORRECT_TABLE C on P.POPR_CURRENTGROUP = C.ID
  left join B_GROUP GR on GR.ID = P.KODIR_GROUP
  left join B_PODGROUP PGR on PGR.ID = P.KODIR_PODGROUP
  left join M_STRUCT_PARAM_EXT MS on MS.ID_STRUCT = :ID
  left join ENTITY_GUID EG on EG.ID = :ID
  into :IDTN, :ISCLC, :KODIR_GROUP_NAME, :KODIR_PODGROUP_NAME, :ID_TR, :RES_ZANOSIT_S_RES,
       :RES_TOLKO_NEUCHT_RES, :RES_COPY_POPR, :RES_COPY_FORMULS, :RES_APPLY_TAB, :NE_OBNUL_KOLL,
       :NE_OBNUL_NR, :NE_OBNUL_RES, :NE_OBNUL_IND, :NE_OBNUL_POPR, :NE_OBNUL_FORMULS, :NR_OT_ZPM,
       :SP_OT_ZPM, :PRECED, :PRECIT, :PUT_ID_GROUP, :PUT_ID_RAB, :PUT_ID_MASH, :PUT_ID_MAT,
       :NAME_STROYKI, :OCHERED_STROIT, :PUSK_KOMPLEX, :NUMGLSSR, :DOGOVOR, :SHIFR, :FULLNAME,
       :VELICHSTROBJ, :EDIZM, :STAD_PROEKT, :NACH_STROY, :OKONCH_STROIT, :V_KAKIH_CENAH_MES,
       :V_KAKIH_CENAH_GOD, :SPISOKSHERT, :OPISANIE, :ADRESS_OBJECTA, :ISPOLNIL_FIO, :ISPOLNIL_DOLGN,
       :PROVERIL_FIO, :PROVERIL_DOLGN, :UTVERDIL_FIO, :UTVERDIL_DOLGN, :ZAKAZCHIK_ID_ORG,
       :ZAKAZCHIK_NAME_ORG, :ZAKAZCHIK_ID, :ZAKAZCHIK_FIO, :ZAKAZCHIK_DOLGN, :GENPODR_ID_ORG,
       :GENPODR_NAME_ORG, :GENPODR_ID, :GENPODR_FIO, :GENPODR_DOLGN, :SUBPODR_ID_ORG,
       :SUBPODR_NAME_ORG, :SUBPODR_ID, :SUBPODR_FIO, :SUBPODR_DOLGN, :GLAVN_ING_FIO, :BOSS_FIO,
       :BOSS_DOLGN, :BOSS_OTDEL, :UTV_DATE, :OPLACHEN, :OPL_SUM, :OPL_DATE, :NOMERDOC,
       :INVESTOR_KODOKPO, :INVESTOR_NAME, :INVESTOR_ID_ORG, :INVESTOR_ID, :INVESTOR_FIO,
       :INVESTOR_DOLGN, :ZAK_KODOKPO, :SUBPODR_KODOKPO, :STROYKA_KODOKPO, :OBJECT_KODOKPO,
       :VIDDEYATOKPD, :DOGPODR_NOMER, :DOGPODR_DATE, :VIDOPER, :OBJECT_NAME, :LYEAR, :LMONTH,
       :USE_ONLY_UTV_PROCENT, :UTV, :DORECALK, :POPR_CURRENTGROUP, :MODE_KOMPNS_ST, :CODE,
       :GENPODR_KODOKPO, :REPLACECORRECTION, :CORRECTIONRULE, :NRSPOTZPM_USED, :REVISION,
       :USER_CREATOR, :DATE_CREATE;

  if (CORRECTIONRULE = -1) then
    CORRECTIONRULE = 0;/*    -      ,     CORRECTIONRULE = 0*/

  NE_OBNUL_NAME = GETBIT(coalesce(:MODE_KOMPNS_ST, 0), 1);

  select NAME
  from B_PUTNAME
  where ID = :PUT_ID_GROUP
  into :UNION_PATH;

  select NAME
  from B_PUTNAME
  where ID = :PUT_ID_RAB
  into :RAB_PATH;

  select NAME
  from B_PUTNAME
  where ID = :PUT_ID_MASH
  into :MASH_PATH;

  select NAME
  from B_PUTNAME
  where ID = :PUT_ID_MAT
  into :MAT_PATH;

  select GUID
  from ENTITY_GUID
  where ID = :ID
  into :GUID;

  select NAME
  from K_SPR_VNB
  where ID = :IDTN
  into :TNNAME;

  suspend;
end^

--TFS[355]
create or alter procedure A_O_F3PARAMS_EXP_XML (
    ANUMBER integer,
    IDUSER integer)
returns (
    NUMBER integer,
    ID_OBJECT integer,
    SHIFR varchar(60),
    FULLNAME varchar(255),
    DATECREATE date,
    INVESTOR_ID_ORG integer,
    INVESTOR_NAME_ORG varchar(255),
    INVESTOR_KODOKPO varchar(40),
    INVESTOR_ID integer,
    INVESTOR_FIO varchar(250),
    INVESTOR_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_KODOKPO varchar(40),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_KODOKPO varchar(40),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    STROYKA_NAME varchar(1024),
    STROYKA_KODOKPO varchar(40),
    OBJECT_KODOKPO varchar(40),
    VIDDEYATOKPD varchar(40),
    DOGPODR_NOMER varchar(40),
    DOGPODR_DATE date,
    VIDOPER varchar(40),
    PERIOD_START date,
    PERIOD_FINISH date,
    IS_BASIS_CEN_LVL integer,
    CREATE_PARAMS blob sub_type 0 segment size 80,
    CREATE_FROM blob sub_type 1 segment size 80,
    CREATE_MAIN_AKT_ID integer,
    CREATE_MAIN_KS3_ID integer,
    CREATE_ACT_HISTORY blob sub_type 0 segment size 80,
    CREATE_MAIN_KS3_NAME varchar(255))
AS
--TFS[355]-   NAME_STROYKI
declare variable CUR_KODSTROYKI integer;
declare variable CUR_KODSTROYKI_TYPE integer;
declare variable CUR_KODSTROYKI_NAME varchar(1024);
begin
  for select NUMBER, SHIFR, FULLNAME, DATECREATE, INVESTOR_ID_ORG, INVESTOR_NAME_ORG,
             INVESTOR_KODOKPO, INVESTOR_ID, INVESTOR_FIO, INVESTOR_DOLGN, ZAKAZCHIK_ID_ORG,
             ZAKAZCHIK_NAME_ORG, ZAKAZCHIK_KODOKPO, ZAKAZCHIK_ID, ZAKAZCHIK_FIO, ZAKAZCHIK_DOLGN,
             GENPODR_ID_ORG, GENPODR_NAME_ORG, GENPODR_KODOKPO, GENPODR_ID, GENPODR_FIO,
             GENPODR_DOLGN, STROYKA_KODOKPO, OBJECT_KODOKPO, VIDDEYATOKPD, DOGPODR_NOMER,
             DOGPODR_DATE, VIDOPER, CREATE_FROM, CREATE_MAIN_AKT_ID, CREATE_MAIN_KS3_ID,
             CREATE_ACT_HISTORY, CREATE_PARAMS, CREATE_MAIN_KS3_NAME, PERIOD_START, PERIOD_FINISH,
             IS_BASIS_CEN_LVL from A_O_F3PARAMS
    where NUMBER = :ANUMBER
    into :NUMBER, :SHIFR, :FULLNAME, :DATECREATE, :INVESTOR_ID_ORG, :INVESTOR_NAME_ORG,
         :INVESTOR_KODOKPO, :INVESTOR_ID, :INVESTOR_FIO, :INVESTOR_DOLGN, :ZAKAZCHIK_ID_ORG,
         :ZAKAZCHIK_NAME_ORG, :ZAKAZCHIK_KODOKPO, :ZAKAZCHIK_ID, :ZAKAZCHIK_FIO, :ZAKAZCHIK_DOLGN,
         :GENPODR_ID_ORG, :GENPODR_NAME_ORG, :GENPODR_KODOKPO, :GENPODR_ID, :GENPODR_FIO,
         :GENPODR_DOLGN, :STROYKA_KODOKPO, :OBJECT_KODOKPO, :VIDDEYATOKPD, :DOGPODR_NOMER,
         :DOGPODR_DATE, :VIDOPER, :CREATE_FROM, :CREATE_MAIN_AKT_ID, :CREATE_MAIN_KS3_ID,
         :CREATE_ACT_HISTORY, :CREATE_PARAMS, :CREATE_MAIN_KS3_NAME, :PERIOD_START, :PERIOD_FINISH,
         :IS_BASIS_CEN_LVL
  do
  begin
    execute procedure A_H_GET_ID_PARENTATYPE(:ANUMBER, 1)
    returning_values :ID_OBJECT;

    STROYKA_NAME = '';

    --Copy paste  M_GET_F3_PARAMS >>
    select KODSTROYKI from A_O_OBJECTPARAMS
    where (NUMBER = :ID_OBJECT)
    into :CUR_KODSTROYKI;

    if (not CUR_KODSTROYKI is null) then
    begin
      for select S.ID_TYPE, S.NAME from L_STR_GETNODEHIERARCHY(:CUR_KODSTROYKI) S
        into :CUR_KODSTROYKI_TYPE, :CUR_KODSTROYKI_NAME
      do
      begin
        if (CUR_KODSTROYKI_TYPE = 1) then
          STROYKA_NAME = CUR_KODSTROYKI_NAME;
      end
    end
    suspend;
  end
end^

--TFS[355]
create or alter procedure L_STR_INSERT (
    ID_PARENT integer,
    ID_TYPE integer,
    SHIFR varchar(1024),
    NAME varchar(1024),
    IN_PAR_TYPE integer,
    ID_USER integer)
returns (
    ID_SELF integer)
AS
--TFS[355]-  
DECLARE VARIABLE par_type INTEGER;
DECLARE VARIABLE dt INTEGER;
DECLARE VARIABLE id_parent_dest INTEGER;
BEGIN
   IF ( ID_PARENT < 0 ) THEN
      EXCEPTION LE_STR_ADDTORBIN;

   /* .    */
   IF ( ID_PARENT <> 0 ) THEN
   BEGIN
      /*     */
      IF ( NOT EXISTS ( SELECT ID_SELF FROM l_stroyki
             WHERE ID_SELF = :id_parent )
         )
      THEN
         /*      */
         IF ( EXISTS ( SELECT ID_SELF FROM l_stroyki
              WHERE ID_SELF = -:id_parent )
            )
      THEN
         EXCEPTION LE_STR_PARMOVETORBIN;  /*    */
      ELSE
         EXCEPTION LE_STR_PARNOTFOUND;    /*    */

      /*      */
      par_type = 0;
      SELECT ID_TYPE FROM l_stroyki
      WHERE ID_SELF = :id_parent
      INTO :par_type;

      IF ( par_type <> in_par_type ) THEN
         EXCEPTION LE_STR_PARTYPECHG;  /*    */

      dt = par_type;
      id_parent_dest = id_parent;
      /*       ,       
             */
      IF ( NOT ( ID_TYPE in (6,7) ) AND ( par_type in (6,7) ) ) THEN
      BEGIN
         WHILE ( ( id_parent_dest <> 0 ) AND ( NOT id_parent_dest IS NULL ) AND ( dt in (6,7) ) ) DO
            SELECT id_parent, ID_type FROM l_stroyki
            WHERE ID_SELF = :id_parent_dest
            INTO :id_parent_dest,:dt;
      END
      /* ,      TYPE      dt */
      IF ( ( NOT dt in (6,7) ) AND ( NOT ( id_parent_dest IS NULL ) ) AND ( NOT ( dt IS NULL ) ) ) THEN
      BEGIN
         IF ( NOT (
              ( dt = 0 ) OR
              ( ( dt = 8 ) AND ( ID_type in ( 1,2,3,5,7 ) ) ) OR --<<[9534]
              ( ( dt = 1 ) AND ( ID_type in ( 2,3,5,7 ) ) ) OR
              ( ( dt = 2 ) AND ( ID_type in ( 3,5,7 ) ) ) OR
              ( ( dt = 3 ) AND ( ID_type = 5 ) ) OR
              ( ( dt = 4 ) AND ( ID_type = 5 ) ) OR
              ( ( dt = 6 ) AND ( ID_type in ( 4,6 ) ) ) OR
              ( ( dt = 7 ) AND ( ID_type in ( 5,7 ) ) )
            ) ) THEN
            EXCEPTION LE_STR_PARTYPECHG;
      END
   END

   --CQ[TIMUR 9332]
   if (IN_PAR_TYPE = 0) then -- 
     EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, :id_parent, 100)
     RETURNING_VALUES :id_parent;
   else if (IN_PAR_TYPE = 101) then -- 
     EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, :id_parent, 101)
     RETURNING_VALUES :id_parent;

   EXECUTE PROCEDURE a_set_g_number_obg 1 RETURNING_VALUES :id_self;

   INSERT INTO l_stroyki (id_self, id_parent, ID_type, shifr, name)
              VALUES (:id_self, :id_parent, :ID_type, :shifr, :name);
   SUSPEND;

END^

--TFS[355]
create or alter procedure L_STR_READ_REC (
    IN_ID_SELF integer)
returns (
    ID_SELF integer,
    ID_PARENT integer,
    ID_TYPE integer,
    SHIFR varchar(1024),
    NAME varchar(1024),
    COUNTCHILDREN integer,
    OPISAN blob sub_type 0 segment size 80,
    KODZAK integer,
    NAMEZAK varchar(250),
    KODFIOZAK integer,
    FIOZAK varchar(250),
    KODGP integer,
    NAMEGP varchar(250),
    KODPRORG integer,
    NAMEPRORG varchar(250),
    KODRUKPROEKT integer,
    RUKPROEKT varchar(250),
    KODGIP integer,
    GIP varchar(250),
    KODNACHOTD integer,
    NACHOTD varchar(250),
    OTDEL varchar(50),
    GODNORM integer,
    UTVDOCSSR varchar(50),
    DATESSR date,
    SSRSUM double precision,
    SSRVZVRSUM double precision,
    SSRKOMPSUM double precision,
    SSRITMODE smallint,
    SSRKITMODE double precision,
    SSRVRMODE integer,
    SSRPRECISION smallint,
    SSRSUMROW integer,
    SSRSUMCOL smallint,
    SSRVZVRSUMROW integer,
    SSRVZVRSUMCOL smallint,
    SSRKOMPSUMROW integer,
    SSRKOMPSUMCOL smallint)
AS
--TFS[355]-  
BEGIN

         FOR SELECT id_self, id_parent, ID_type, shifr, name, countchildren,
                  Opisan, KodZak, NameZak, KodFIOZak, FIOZak, KodGp, NameGp,
                  KodPrOrg, NamePrOrg, KodRukProekt, RukProekt, KodGIP,
                  GIP, KodNachOtd, NachOtd, Otdel, GodNorm
             FROM l_stroyki
             WHERE (id_self = :in_id_self )
             INTO :id_self, :id_parent, :ID_type, :shifr, :name, :countchildren,
                  :Opisan, :KodZak, :NameZak, :KodFioZak, :FIOZak, :KodGp, :NameGp,
                  :KodPrOrg, :NamePrOrg, :KodRukProekt, :RukProekt, 
                  :KodGIP, :GIP, :KodNachOtd, :NachOtd, :Otdel, :GodNorm
         DO
         begin
                UTVDOCSSR = null; DATESSR = null;
                SSRSUM = null; SSRVZVRSUM = null;
                SSRITMODE = null; SSRKITMODE = null; SSRPRECISION = null; SSRVRMODE = null;
                SSRSUMROW = null; SSRSUMCOL = null; SSRVZVRSUMROW = null; SSRVZVRSUMCOL = null;
                SSRKOMPSUM = null; SSRKOMPSUMROW = null; SSRKOMPSUMCOL = null;
                if ( :ID_type = 5 ) then /*  ssr */
                begin
                   select
                       id_self, UTVDOCSSR, DATESSR,
                       SSRSUM, SSRVZVRSUM,
                       SSRITMODE, SSRKITMODE, SSRPRECISION, SSRVRMODE,
                       SSRSUMROW, SSRSUMCOL, SSRVZVRSUMROW, SSRVZVRSUMCOL
                   from l_ssr_params
                   where id_self = :id_self
                   into :id_self, :UTVDOCSSR, :DATESSR,
                        :SSRSUM, :SSRVZVRSUM,
                        :SSRITMODE , :SSRKITMODE , :SSRPRECISION, :SSRVRMODE,
                        :SSRSUMROW, :SSRSUMCOL, :SSRVZVRSUMROW, :SSRVZVRSUMCOL;

                   select
                       SSRKOMPSUM,
                       SSRKOMPSUMROW, SSRKOMPSUMCOL
                   from L_SSR_PARAMS2
                   where id_self = :id_self
                   into :SSRKOMPSUM,
                        :SSRKOMPSUMROW, :SSRKOMPSUMCOL;
                end
                SUSPEND;
         end
END^

--TFS[355]
create or alter procedure L_STR_READ_SECTOR (
    IN_PARENT integer,
    IN_TYPE integer,
    ID_USER integer)
returns (
    ID_SELF integer,
    ID_PARENT integer,
    ID_TYPE integer,
    SHIFR varchar(1024),
    NAME varchar(1024),
    COUNTCHILDREN integer,
    OPISAN blob sub_type 0 segment size 80,
    KODZAK integer,
    NAMEZAK varchar(250),
    KODFIOZAK integer,
    FIOZAK varchar(250),
    KODGP integer,
    NAMEGP varchar(250),
    KODPRORG integer,
    NAMEPRORG varchar(250),
    KODRUKPROEKT integer,
    RUKPROEKT varchar(250),
    KODGIP integer,
    GIP varchar(250),
    KODNACHOTD integer,
    NACHOTD varchar(250),
    OTDEL varchar(50),
    GODNORM integer,
    UTVDOCSSR varchar(50),
    DATESSR date,
    SSRSUM double precision,
    SSRVZVRSUM double precision,
    SSRKOMPSUM double precision,
    SSRITMODE smallint,
    SSRKITMODE double precision,
    SSRVRMODE integer,
    SSRPRECISION smallint,
    SSRSUMROW integer,
    SSRSUMCOL smallint,
    SSRVZVRSUMROW integer,
    SSRVZVRSUMCOL smallint,
    SSRKOMPSUMROW integer,
    SSRKOMPSUMCOL smallint)
AS
--TFS[355]-  
declare variable PAR_TYPE integer;
begin

  /*   */
  if ((IN_PARENT = 0) and
      (IN_TYPE = 102/*nts_V_RBin*/)) then
    for select ID_SELF, ID_PARENT, ID_TYPE, SHIFR, NAME, COUNTCHILDREN
    from L_STROYKI A
    where (A.ID_SELF < 0) and
          not exists(select ID_SELF
                     from L_STROYKI
                     where L_STROYKI.ID_SELF = A.ID_PARENT)
    into :ID_SELF, :ID_PARENT, :ID_TYPE, :SHIFR, :NAME, :COUNTCHILDREN do
      suspend;
  else
  begin

    /*    */
    if (IN_PARENT <> 0) then
    begin
      /*     */
      if (not exists(select ID_SELF
                     from L_STROYKI
                     where ID_SELF = :IN_PARENT)) then
        exception LE_STR_PARNOTFOUND;/*    */

      /*      */
      PAR_TYPE = 0;
      select ID_TYPE
      from L_STROYKI
      where ID_SELF = :IN_PARENT
      into :PAR_TYPE;

      if (PAR_TYPE <> IN_TYPE) then
        exception LE_STR_PARTYPECHG;/*    */
    end

    --CQ[TIMUR 9332]
    if (IN_TYPE = 0) then  -- 
      execute procedure CLOUD_GET_PARENT_HIER(:ID_USER, :IN_PARENT, 100)
      returning_values :IN_PARENT;
    else if (IN_TYPE = 101/*nts_V_Dogs*/) then -- 
      execute procedure CLOUD_GET_PARENT_HIER(:ID_USER, :IN_PARENT, 101/*???*/)
      returning_values :IN_PARENT;

    /*    */
    if (IN_PARENT < 0) then
    begin
      for select ID_SELF, ID_PARENT, ID_TYPE, SHIFR, NAME, COUNTCHILDREN
      from L_STROYKI
      where (ID_PARENT = :IN_PARENT) and
            (ID_SELF < 0)
      into :ID_SELF, :ID_PARENT, :ID_TYPE, :SHIFR, :NAME, :COUNTCHILDREN do
        suspend;
    end

    /*    */
    else
    if (IN_TYPE in (101/*nts_V_Dogs*/, 4/*ntsDog*/, 6/*ntsFolderDog*/)) then
    begin
      if (IN_TYPE = 4/*ntsDog*/) then --CQ[8391]       
      begin
        /*  */
        for select ID_SELF, ID_PARENT, ID_TYPE, SHIFR, NAME, COUNTCHILDREN
        from L_STROYKI
        where (ID_PARENT = :IN_PARENT) and
              (ID_TYPE in (4/*ntsDog*/, 6/*ntsFolderDog*/, 5/*ntsSSR*/)) and
              (ID_SELF > 0)
        into :ID_SELF, :ID_PARENT, :ID_TYPE, :SHIFR, :NAME, :COUNTCHILDREN do
          suspend;
      end
      else
      --CQ[8391]       
      begin
        for select ID_SELF
          from L_STROYKI
          where (ID_PARENT = :IN_PARENT) and
                (ID_SELF > 0) and
                (ID_TYPE in (4/*ntsDog*/, 6/*ntsFolderDog*/))
          into :ID_SELF do
          begin
            for select ID_SELF, ID_PARENT, ID_TYPE, SHIFR, NAME, COUNTCHILDREN, OPISAN,
                       KODZAK, NAMEZAK, KODFIOZAK, FIOZAK, KODGP, NAMEGP, KODPRORG, NAMEPRORG,
                       KODRUKPROEKT, RUKPROEKT, KODGIP, GIP, KODNACHOTD, NACHOTD, OTDEL,
                       GODNORM, UTVDOCSSR, DATESSR,
                       SSRSUM, SSRVZVRSUM, SSRKOMPSUM,
                       SSRITMODE, SSRKITMODE, SSRPRECISION, SSRVRMODE,
                       SSRSUMROW, SSRSUMCOL, SSRVZVRSUMROW, SSRVZVRSUMCOL, SSRKOMPSUMROW, SSRKOMPSUMCOL
            from L_STR_READ_REC(:ID_SELF)
            into :ID_SELF, :ID_PARENT, :ID_TYPE, :SHIFR, :NAME, :COUNTCHILDREN, :OPISAN,
                 :KODZAK, :NAMEZAK, :KODFIOZAK, :FIOZAK, :KODGP, :NAMEGP, :KODPRORG, :NAMEPRORG,
                 :KODRUKPROEKT, :RUKPROEKT, :KODGIP, :GIP, :KODNACHOTD, :NACHOTD, :OTDEL,
                 :GODNORM, :UTVDOCSSR, :DATESSR,
                 :SSRSUM, :SSRVZVRSUM, :SSRKOMPSUM,
                 :SSRITMODE, :SSRKITMODE, :SSRPRECISION, :SSRVRMODE,
                 :SSRSUMROW, :SSRSUMCOL, :SSRVZVRSUMROW, :SSRVZVRSUMCOL, :SSRKOMPSUMROW, :SSRKOMPSUMCOL
            do
              suspend;
          end
      end
      --CQ[8391]
    end
    else
    if (IN_TYPE = 100/*nts_V_NzOb*/) then
    begin
      /* . . */
      exception LE_STR_INTERNAL_VIEW100;
    end
    else
      /*        */
      for select ID_SELF
      from L_STROYKI
      where (ID_PARENT = :IN_PARENT) and
            (ID_SELF > 0) and
            not(ID_TYPE in (4/*ntsDog*/, 6/*ntsFolderDog*/))
      into :ID_SELF do
      begin
        for select ID_SELF, ID_PARENT, ID_TYPE, SHIFR, NAME, COUNTCHILDREN, OPISAN,
                   KODZAK, NAMEZAK, KODFIOZAK, FIOZAK, KODGP, NAMEGP, KODPRORG, NAMEPRORG,
                   KODRUKPROEKT, RUKPROEKT, KODGIP, GIP, KODNACHOTD, NACHOTD, OTDEL,
                   GODNORM, UTVDOCSSR, DATESSR,
                   SSRSUM, SSRVZVRSUM, SSRKOMPSUM,
                   SSRITMODE, SSRKITMODE, SSRPRECISION, SSRVRMODE,
                   SSRSUMROW, SSRSUMCOL, SSRVZVRSUMROW, SSRVZVRSUMCOL, SSRKOMPSUMROW, SSRKOMPSUMCOL
        from L_STR_READ_REC(:ID_SELF)
        into :ID_SELF, :ID_PARENT, :ID_TYPE, :SHIFR, :NAME, :COUNTCHILDREN, :OPISAN,
             :KODZAK, :NAMEZAK, :KODFIOZAK, :FIOZAK, :KODGP, :NAMEGP, :KODPRORG, :NAMEPRORG,
             :KODRUKPROEKT, :RUKPROEKT, :KODGIP, :GIP, :KODNACHOTD, :NACHOTD, :OTDEL,
             :GODNORM, :UTVDOCSSR, :DATESSR,
             :SSRSUM, :SSRVZVRSUM, :SSRKOMPSUM,
             :SSRITMODE, :SSRKITMODE, :SSRPRECISION,
             :SSRVRMODE, :SSRSUMROW, :SSRSUMCOL, :SSRVZVRSUMROW, :SSRVZVRSUMCOL, :SSRKOMPSUMROW, :SSRKOMPSUMCOL
        do
          suspend;
      end
  end
end^

--TFS[355]
create or alter procedure L_STR_SELECT_WITH_PARENTS (
    IN_ID_SELF integer,
    ID_USER integer)
returns (
    ID_SELF integer,
    ID_PARENT integer,
    ID_TYPE smallint,
    SHIFR varchar(1024),
    NAME varchar(1024),
    COUNTCHILDREN integer,
    OPISAN blob sub_type 0 segment size 80,
    KODZAK integer,
    NAMEZAK varchar(250),
    KODFIOZAK integer,
    FIOZAK varchar(250),
    KODGP integer,
    NAMEGP varchar(250),
    KODPRORG integer,
    NAMEPRORG varchar(250),
    KODRUKPROEKT integer,
    RUKPROEKT varchar(250),
    KODGIP integer,
    GIP varchar(250),
    KODNACHOTD integer,
    NACHOTD varchar(250),
    OTDEL varchar(50),
    GODNORM integer)
AS
--TFS[355]-   NAME, SHIFR
begin
   for select ID_SELF, ID_PARENT, ID_TYPE, SHIFR, NAME, COUNTCHILDREN, OPISAN,
              KODZAK, NAMEZAK, KODFIOZAK, FIOZAK, KODGP, NAMEGP, KODPRORG,
              NAMEPRORG, KODRUKPROEKT, RUKPROEKT, KODGIP, GIP, KODNACHOTD,
              NACHOTD, OTDEL, GODNORM
       from l_stroyki where ID_SELF = :IN_ID_SELF
       into :ID_SELF, :ID_PARENT, :ID_TYPE, :SHIFR, :NAME, :COUNTCHILDREN, :OPISAN,
            :KODZAK, :NAMEZAK, :KODFIOZAK, :FIOZAK, :KODGP, :NAMEGP, :KODPRORG,
            :NAMEPRORG, :KODRUKPROEKT, :RUKPROEKT, :KODGIP, :GIP, :KODNACHOTD,
            :NACHOTD, :OTDEL, :GODNORM
   do
   begin
      suspend;
      if ( ( not ID_PARENT is null ) and ( ID_PARENT <> 0 ) ) then
         for select * from L_STR_SELECT_WITH_PARENTS ( :ID_PARENT , :ID_USER )
            into :ID_SELF, :ID_PARENT, :ID_TYPE, :SHIFR, :NAME, :COUNTCHILDREN, :OPISAN,
                 :KODZAK, :NAMEZAK, :KODFIOZAK, :FIOZAK, :KODGP, :NAMEGP, :KODPRORG,
                 :NAMEPRORG, :KODRUKPROEKT, :RUKPROEKT, :KODGIP, :GIP, :KODNACHOTD,
                 :NACHOTD, :OTDEL, :GODNORM
         do
            suspend;
   end
end^

--TFS[355]
create or alter procedure L_STR_SSR_READOBJS_1 (
    ID_USER integer,
    ID_SELF integer,
    KOD integer,
    MODE integer,
    ONLY_OBJ integer,
    IN_LEVEL integer)
returns (
    NUMBER integer,
    PARENT integer,
    ID_TYPE smallint,
    SUBTYPE smallint,
    SORTING integer,
    COUNTCHILDREN integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    NUMGLSSR integer,
    OUT_LEVEL integer,
    DEF_KOD_SSR integer,
    ID_TYPE_STROYKI integer,
    NUMLSR_LS varchar(1024))
AS
--CQ[TIMUR 13931] -    SHIFR, FULLNAME
DECLARE VARIABLE KODSTROYKI INTEGER;
DECLARE VARIABLE KODDOG INTEGER;
DECLARE VARIABLE DO_SKIP INTEGER;
DECLARE VARIABLE IGNORE INTEGER;
DECLARE VARIABLE DUMMY INTEGER;
DECLARE VARIABLE ATYPE INTEGER;

declare OBJECT_ROOT integer;
declare OBJECT_PARENT integer;
declare TMP_NUMBER integer;
declare TMP_PARENT integer;

declare variable vn_id integer;
begin

/*
   mode 0 -    
   mode 1 -    id_str_dog
   mode 2 -    
   mode 3 -    id_str_dog
   mode 4 -  

   mode 5 - .   // MK CQ[3427] 22.05.2006

   mode 83 -      
   mode 84 - ,    
   mode 85 -  ,        KOD  ( )
*/

  -- MK CQ[15112] --->
  if (MODE = 85) then
  begin
    EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, 0/**/, 1/**/) --   ,   -   0  1
    RETURNING_VALUES :OBJECT_ROOT;

    --  
    for select ID_SELF
    from L_STR_GETNODEHIERARCHY_1(:KOD)
    order by INV_LEVEL desc
    into :vn_id do
    begin
      NUMLSR_LS = null; -- TFS[29]
      --   
      if (vn_id = KOD) then
      begin
        --      
        for select NUMBER, PARENT, ID_TYPE, SUBTYPE, SORTING, COUNTCHILDREN,
                   SHIFR, FULLNAME, NUMGLSSR, OUT_LEVEL, DEF_KOD_SSR, ID_TYPE_STROYKI,
                   NUMLSR_LS -- TFS[29]
        from L_STR_SSR_READOBJS_2(:ID_USER, :vn_id, :KOD, 84, :ONLY_OBJ, :IN_LEVEL, :OBJECT_ROOT)
        into :NUMBER, :PARENT, :ID_TYPE, :SUBTYPE, :SORTING, :COUNTCHILDREN,
             :SHIFR, :FULLNAME, :NUMGLSSR, :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI,
             :NUMLSR_LS -- TFS[29]
        do
          suspend;
      end

      --    
      else
      begin
        NUMLSR_LS = null; -- TFS[29]
        --        
        select ID_SELF, ID_PARENT, 0, 0, 0, COUNTCHILDREN,
               SHIFR, NAME, 0, :IN_LEVEL, null, ID_TYPE
        from L_STROYKI
        where ID_SELF = :vn_id
          and ID_TYPE in (8/*ntsPrj*/,1/*ntsStr*/,2/*ntsOcher*/,3/*ntsPK*/,7/*ntsFolderStr*/)
        into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren,
             :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI;

        suspend;
        IN_LEVEL = IN_LEVEL + 1;
      end
    end


    exit;
  end
  -- MK CQ[15112] <---

  if (MODE = 84) then
  begin
    EXECUTE PROCEDURE CLOUD_GET_PARENT_HIER(:ID_USER, 0/**/, 1/**/) --   ,   -   0  1
    RETURNING_VALUES :OBJECT_ROOT;

     --    ( )
    for select ID_SELF, ID_PARENT, 0/*ID_TYPE*/, 0/**/, 0/**/, COUNTCHILDREN, SHIFR, NAME, 0/**/, :IN_LEVEL, null/**/, ID_TYPE
        from L_STROYKI
        where ID_PARENT = :ID_SELF
          and ID_TYPE in (8/*ntsPrj*/,1/*ntsStr*/,2/*ntsOcher*/,3/*ntsPK*/,7/*ntsFolderStr*/)
        into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI
    do
    begin
        NUMLSR_LS = null; -- TFS[29]
        if (:NUMBER = :KOD or :PARENT = :KOD) then -- ,    (PARENT)  (NUMBER)  
        begin
          CountChildren = :COUNTCHILDREN + 1; --  
          suspend; --  

          TMP_NUMBER = :NUMBER; --           
          TMP_PARENT = :PARENT;

          --   ,   
          for select NUMBER
            from A_O_OBJECTPARAMS
            where KODSTROYKI = :TMP_NUMBER
            into :NUMBER
          do
          begin
            -- ,      "",
            -- .. PARENT   = :OBJECT_ROOT

            OBJECT_PARENT = NUMBER; --        
            while (OBJECT_PARENT is not null) do
            begin
              select min(PARENT)
                from A_O_HIER
                where NUMBER = :OBJECT_PARENT
                into :OBJECT_PARENT;

              if (:OBJECT_PARENT = :OBJECT_ROOT) then
              begin
                --   - 
                OUT_LEVEL = IN_LEVEL;

                NUMGLSSR = 0;

                DO_SKIP = 0;
                IGNORE  = 0;
                DEF_KOD_SSR = null; --CQ[TIMUR 9078]
                DUMMY = NULL; --CQ[TIMUR 9556]

                ID_TYPE_STROYKI = null;

                for SELECT first 1 shifr, fullname, KodStroyki, KodDog, NUMGLSSR, :IN_LEVEL + 1
                  FROM a_o_objectparams
                  WHERE number = :number
                  INTO :shifr, :fullname, :KodStroyki, :KodDog, :NUMGLSSR, :OUT_LEVEL
                do
                begin
                  ID_TYPE = 1; -- 
                  PARENT = TMP_NUMBER; --   
                  NUMLSR_LS = null; -- TFS[29]
                  suspend; -- 

                  for select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR,
                    NUMLSR_LS -- TFS[29]
                    from L_STR_SSR_READOBJS (:ID_USER, :number, :Kod, 1/*:Mode*/, :Only_Obj, :IN_LEVEL + 2 )
                    into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR,
                    :NUMLSR_LS -- TFS[29]
                  do
                  suspend; --  

                end
              end
            end

          end

          NUMBER = :TMP_NUMBER; --     
          PARENT = :TMP_PARENT;
        end
        else
          suspend; --   ,  


        --   
        for select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR, ID_TYPE_STROYKI,
          NUMLSR_LS -- TFS[29]
          from L_STR_SSR_READOBJS_1 (:ID_USER, :number, case when :NUMBER = :KOD or :PARENT = :KOD then :number else :Kod end, :Mode, :Only_Obj, :IN_LEVEL + 1 )
          into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI,
          :NUMLSR_LS --TFS[29]
        do
        suspend; --  

    end

    exit;
  end


  --     
  --  , ..            
  For Select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR
      from L_STR_SSR_READOBJS (:ID_USER, :ID_SELF, :Kod, :Mode, :Only_Obj, :IN_LEVEL )
      into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR
  do suspend;


end^

--TFS[355]
create or alter procedure L_STR_SSR_READOBJS_2 (
    ID_USER integer,
    ID_SELF integer,
    KOD integer,
    MODE integer,
    ONLY_OBJ integer,
    IN_LEVEL integer,
    OBJECT_ROOT integer)
returns (
    NUMBER integer,
    PARENT integer,
    ID_TYPE smallint,
    SUBTYPE smallint,
    SORTING integer,
    COUNTCHILDREN integer,
    SHIFR varchar(1024),
    FULLNAME varchar(1024),
    NUMGLSSR integer,
    OUT_LEVEL integer,
    DEF_KOD_SSR integer,
    ID_TYPE_STROYKI integer,
    NUMLSR_LS varchar(1024))
AS
DECLARE VARIABLE KODSTROYKI INTEGER;
DECLARE VARIABLE KODDOG INTEGER;
DECLARE VARIABLE DO_SKIP INTEGER;
DECLARE VARIABLE IGNORE INTEGER;
DECLARE VARIABLE DUMMY INTEGER;
DECLARE VARIABLE ATYPE INTEGER;

--declare OBJECT_ROOT integer;
declare OBJECT_PARENT integer;
declare TMP_NUMBER integer;
declare TMP_PARENT integer;
begin

  --      (,  , )
  for select ID_SELF, ID_PARENT, 0, 0, 0, COUNTCHILDREN,
             SHIFR, NAME, 0, :IN_LEVEL, null, ID_TYPE
  from L_STROYKI
  where ID_SELF = :ID_SELF
        and ID_TYPE in (8/*ntsPrj*/,1/*ntsStr*/,2/*ntsOcher*/,3/*ntsPK*/,7/*ntsFolderStr*/)
  into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren ,
       :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI
  do
  begin
      NUMLSR_LS = null; -- TFS[29]
      if (:NUMBER = :KOD or :PARENT = :KOD) then -- ,    (PARENT)  (NUMBER)  
      begin
        CountChildren = :COUNTCHILDREN + 1; --  
        suspend; --  

        TMP_NUMBER = :NUMBER; --           
        TMP_PARENT = :PARENT;

        --   ,   
        for select NUMBER
          from A_O_OBJECTPARAMS
          where KODSTROYKI = :TMP_NUMBER
          into :NUMBER
        do
        begin
          -- ,      "",
          -- .. PARENT   = :OBJECT_ROOT

          OBJECT_PARENT = NUMBER; --        
          while (OBJECT_PARENT is not null) do
          begin
            select min(PARENT)
              from A_O_HIER
              where NUMBER = :OBJECT_PARENT
              into :OBJECT_PARENT;

            if (:OBJECT_PARENT = :OBJECT_ROOT) then
            begin
              --   - 
              OUT_LEVEL = IN_LEVEL;

              NUMGLSSR = 0;

              DO_SKIP = 0;
              IGNORE  = 0;
              DEF_KOD_SSR = null; --CQ[TIMUR 9078]
              DUMMY = NULL; --CQ[TIMUR 9556]

              ID_TYPE_STROYKI = null;

              for SELECT first 1 shifr, fullname, KodStroyki, KodDog, NUMGLSSR, :IN_LEVEL + 1
                FROM a_o_objectparams
                WHERE number = :number
                INTO :shifr, :fullname, :KodStroyki, :KodDog, :NUMGLSSR, :OUT_LEVEL
              do
              begin
                ID_TYPE = 1; -- 
                PARENT = TMP_NUMBER; --   
                NUMLSR_LS = null; -- TFS[29]
                suspend; -- 

                for select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR,
                  NUMLSR_LS -- TFS[29]
                  from L_STR_SSR_READOBJS (:ID_USER, :number, :Kod, 1/*:Mode*/, :Only_Obj, :IN_LEVEL + 2 )
                  into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR,
                  :NUMLSR_LS -- TFS[29]
                do
                suspend; --  

              end
            end
          end

        end

        NUMBER = :TMP_NUMBER; --     
        PARENT = :TMP_PARENT;
      end
      else
        suspend; --   ,  


      --   
      for select Number , Parent , id_Type , SubType , Sorting , CountChildren , SHIFR , FULLNAME , NUMGLSSR , OUT_LEVEL, DEF_KOD_SSR, ID_TYPE_STROYKI,
        NUMLSR_LS -- TFS[29]
        from L_STR_SSR_READOBJS_1 (:ID_USER, :number, case when :NUMBER = :KOD or :PARENT = :KOD then :number else :Kod end, :Mode, :Only_Obj, :IN_LEVEL + 1)
        into :NUMBER , :PARENT , :id_TYPE , :SUBTYPE , :SORTING , :CountChildren , :SHIFR , :FULLNAME , :NUMGLSSR , :OUT_LEVEL, :DEF_KOD_SSR, :ID_TYPE_STROYKI,
        :NUMLSR_LS -- TFS[29]
      do
      suspend; --  

  end

end^

--TFS[355]
create or alter procedure T_SSR_IMP_XML_ONE_STROYKA (
    ID_PARENT integer,
    ID_TYPE smallint,
    SHIFR varchar(1024),
    NAME varchar(1024),
    OPISAN blob sub_type 0 segment size 80,
    NAMEZAK varchar(250),
    FIOZAK varchar(250),
    NAMEGP varchar(250),
    NAMEPRORG varchar(250),
    RUKPROEKT varchar(250),
    GIP varchar(250),
    NACHOTD varchar(250),
    OTDEL varchar(50),
    GODNORM integer)
returns (
    ID_SELF integer)
AS
--TFS[355]-  
declare variable KODZAK integer;
declare variable KODFIOZAK integer;
declare variable KODGP integer;
declare variable KODPRORG integer;
declare variable KODRUKPROEKT integer;
declare variable KODGIP integer;
declare variable KODNACHOTD integer;
begin

  -- 
  execute procedure T_SSR_IMP_SEARCH_ORGANIZ (:NAMEZAK)
  returning_values :KODZAK;

  -- 
  execute procedure T_SSR_IMP_SEARCH_PERSONS(:KODZAK, :FIOZAK)
  returning_values :KODPRORG;

  -- 
  execute procedure T_SSR_IMP_SEARCH_ORGANIZ (:NAMEGP)
  returning_values :KODGP;

  -- 
  execute procedure T_SSR_IMP_SEARCH_ORGANIZ (:NAMEPRORG)
  returning_values :KODPRORG;

  --   
  execute procedure T_SSR_IMP_SEARCH_PERSONS(:KODPRORG, :RUKPROEKT)
  returning_values :KODRUKPROEKT;

  --  
  execute procedure T_SSR_IMP_SEARCH_PERSONS(:KODPRORG, :GIP)
  returning_values :KODGIP;

  --  
  execute procedure T_SSR_IMP_SEARCH_PERSONS(:KODPRORG, :NACHOTD)
  returning_values :KODNACHOTD;

  execute procedure A_SET_G_NUMBER_OBG 1 returning_values :ID_SELF;

  insert into L_STROYKI (
    ID_SELF, ID_PARENT, ID_TYPE, SHIFR, NAME, OPISAN,
    KODZAK, NAMEZAK, KODFIOZAK, FIOZAK,
    KODGP, NAMEGP, KODPRORG, NAMEPRORG,
    KODRUKPROEKT, RUKPROEKT, KODGIP, GIP,
    KODNACHOTD, NACHOTD, OTDEL, GODNORM)
  values (
    :ID_SELF, :ID_PARENT, :ID_TYPE, :SHIFR, :NAME, :OPISAN,
    :KODZAK, :NAMEZAK, :KODFIOZAK, :FIOZAK,
    :KODGP, :NAMEGP, :KODPRORG, :NAMEPRORG,
    :KODRUKPROEKT, :RUKPROEKT, :KODGIP, :GIP,
    :KODNACHOTD, :NACHOTD, :OTDEL, :GODNORM);

end
^

--TFS[355]
create or alter procedure M_GET_F3_PARAMS (
    IN_NUMBER integer)
returns (
    SHIFR varchar(60),
    FULLNAME varchar(255),
    DATECREATE date,
    INVESTOR_ID_ORG integer,
    INVESTOR_NAME_ORG varchar(255),
    INVESTOR_KODOKPO varchar(40),
    INVESTOR_ID integer,
    INVESTOR_FIO varchar(250),
    INVESTOR_DOLGN varchar(100),
    ZAKAZCHIK_ID_ORG integer,
    ZAKAZCHIK_NAME_ORG varchar(255),
    ZAKAZCHIK_KODOKPO varchar(40),
    ZAKAZCHIK_ID integer,
    ZAKAZCHIK_FIO varchar(250),
    ZAKAZCHIK_DOLGN varchar(100),
    GENPODR_ID_ORG integer,
    GENPODR_NAME_ORG varchar(255),
    GENPODR_KODOKPO varchar(40),
    GENPODR_ID integer,
    GENPODR_FIO varchar(250),
    GENPODR_DOLGN varchar(100),
    STROYKA_NAME varchar(1024),
    STROYKA_KODOKPO varchar(40),
    OBJECT_NAME varchar(1024),
    OBJECT_KODOKPO varchar(40),
    ID_OBJECT integer,
    VIDDEYATOKPD varchar(40),
    DOGPODR_NOMER varchar(40),
    DOGPODR_DATE date,
    VIDOPER varchar(40),
    CREATE_FROM blob sub_type 1 segment size 80,
    CREATE_MAIN_AKT_ID integer,
    PERIOD_START date,
    PERIOD_FINISH date,
    IS_BASIS_CEN_LVL integer)
AS
--CQ[TIMUR 13931] -    OBJECT_NAME
--TFS[355]-   NAME_STROYKI
declare variable cur_kodstroyki integer;
declare variable CUR_kodstroyki_type integer;
declare variable CUR_kodstroyki_name varchar(1024);
begin
   if (exists (select * from A_O_F3PARAMS where (NUMBER = :IN_NUMBER))) then
   begin
      OBJECT_NAME = '';
      STROYKA_NAME = '';

      select first 1
           f.SHIFR, f.FULLNAME, f.DATECREATE, f.INVESTOR_ID_ORG, f.INVESTOR_NAME_ORG,
           f.INVESTOR_KODOKPO, f.INVESTOR_ID, f.INVESTOR_FIO, f.INVESTOR_DOLGN,
           f.ZAKAZCHIK_ID_ORG, f.ZAKAZCHIK_NAME_ORG, f.ZAKAZCHIK_KODOKPO,
           f.ZAKAZCHIK_ID, f.ZAKAZCHIK_FIO, f.ZAKAZCHIK_DOLGN, f.GENPODR_ID_ORG,
           f.GENPODR_NAME_ORG, f.GENPODR_KODOKPO, f.GENPODR_ID, f.GENPODR_FIO,
           f.GENPODR_DOLGN, f.STROYKA_KODOKPO, f.OBJECT_KODOKPO, f.VIDDEYATOKPD,
           f.DOGPODR_NOMER, f.DOGPODR_DATE, f.VIDOPER, f.CREATE_FROM, f.CREATE_MAIN_AKT_ID,
           f.PERIOD_START, f.PERIOD_FINISH, f.IS_BASIS_CEN_LVL
      from A_O_F3PARAMS f
      where (f.number = :IN_NUMBER)
      into :SHIFR, :FULLNAME, :DATECREATE, :INVESTOR_ID_ORG, :INVESTOR_NAME_ORG,
           :INVESTOR_KODOKPO, :INVESTOR_ID, :INVESTOR_FIO, :INVESTOR_DOLGN,
           :ZAKAZCHIK_ID_ORG, :ZAKAZCHIK_NAME_ORG, :ZAKAZCHIK_KODOKPO,
           :ZAKAZCHIK_ID, :ZAKAZCHIK_FIO, :ZAKAZCHIK_DOLGN, :GENPODR_ID_ORG,
           :GENPODR_NAME_ORG, :GENPODR_KODOKPO, :GENPODR_ID, :GENPODR_FIO,
           :GENPODR_DOLGN, :STROYKA_KODOKPO, :OBJECT_KODOKPO, :VIDDEYATOKPD,
           :DOGPODR_NOMER, :DOGPODR_DATE, :VIDOPER, :CREATE_FROM, :CREATE_MAIN_AKT_ID,
           :PERIOD_START, :PERIOD_FINISH, :IS_BASIS_CEN_LVL;


      execute procedure A_H_GET_ID_PARENTATYPE(:IN_NUMBER, 1)
      returning_values :ID_OBJECT;

      select first 1 o.fullname, o.kodstroyki
      from A_O_OBJECTPARAMS o
      where (o.number = :ID_OBJECT)
      into :OBJECT_NAME, :cur_kodstroyki;

      if ( not cur_kodstroyki is null ) then
         for select s.id_type, s.name
         from l_str_getnodehierarchy( :cur_kodstroyki ) s
         into :CUR_kodstroyki_type, :CUR_kodstroyki_name do
            if ( CUR_kodstroyki_type = 1 ) then
               STROYKA_NAME = cur_kodstroyki_name;

      suspend;
   end
end
^

-- TFS[695]
create or alter procedure DM_GET_NORMBASE_INDEX (
    BASEID integer)
returns (
    ID integer,
    NAME varchar(1024),
    TAB varchar(42),
    TAB_OKP varchar(42),
    ALTTAB varchar(250),
    BA double precision,
    BE double precision,
    BC double precision,
    BD double precision,
    BB double precision,
    BG double precision,
    BH double precision,
    BI double precision,
    BJ double precision,
    PA double precision,
    PB double precision,
    CONTENTS varchar(5120),
    IDREESTR integer,
    RABMAT integer,
    EDIZM varchar(100),
    BASEINDEX integer)
AS
declare variable IDNAME integer;
declare variable IDINDEX integer;
declare variable NAME_TITLE blob sub_type 1 segment size 80;
declare variable NAME_PART blob sub_type 1 segment size 80;
declare variable CHECKGUID varchar(70);
declare BLOBNAME blob sub_type 1 segment size 80;
declare BLOBCONTENTS blob sub_type 1 segment size 80;

declare variable ID_RES integer;
declare variable FROM_ABC integer;
declare variable ALLOW_SUSPEND integer;

begin
  ID = null;
  BASEINDEX = BASEID;
  NAME = 'Stroysoft Index Control Info';
  TAB = null;
  ALTTAB = null;
  BA = null;
  BE = null;
  BC = null;
  BD = null;
  BB = null;
  BG = null;
  BH = null;
  CONTENTS = null;
  IDREESTR = 2;
  RABMAT = null;
  EDIZM = null;
  TAB_OKP = null;
  --   CQ[8696]  -->
  select INDEXID, ID
  from DM_INDEX_INFO
  where INDEXTYPE = 0 and
        INDEXNAME = cast(:BASEID as varchar(80))
  into :ID, :IDINDEX;
  if (ID is null) then
  begin
    CHECKGUID = COCREATEGUID();
    ID = K_GETCRC32S(:CHECKGUID);
    if (ID > 0) then
      ID = -ID;
    execute procedure DM_SET_INDEX_INFO(0, cast(:BASEID as varchar(80)), :ID, 1)
    returning_values (:IDINDEX);
  end
  suspend;
  --CQ[8696] <--
  for select ID
    from B_REESTR
    where DM_GETBASEID(ID, POKAZ, INDTYPE) = :BASEID
    into :IDREESTR
  do
  begin
    BLOBNAME = null;
    BLOBCONTENTS = null;
    execute procedure DM_SET_INDEX_RELATION(:IDREESTR, :IDINDEX, cast(:BASEID as varchar(80)));

    for select BR.ID, BR.IDNAME, BR.TAB, BR.ALTTAB, BR.BA, BR.BE, BR.BC, BR.BD, BR.BB, BR.BG, BR.BH,
               BR.BI, BR.BJ, BR.PA, BR.PB, -- CQ[13238]
               BS.CONTENTS, BR.RABMAT, BE.NAME, BO.TAB
      from B_RABMAT BR
      left join B_SOST BS on (BR.IDSOSTAV = BS.ID)
      left join B_EDIZM BE on BE.ID = BR.IDEDIZM
      left join B_ABC_OKP BO on BO.ID = BR.IDABCOKP
      where BR.IDREESTR = :IDREESTR
      into :ID, :IDNAME, :TAB, :ALTTAB, :BA, :BE, :BC, :BD, :BB, :BG, :BH,
           :BI, :BJ, :PA, :PB, -- CQ[13238]
           :BLOBCONTENTS, :RABMAT, :EDIZM, :TAB_OKP
    do
    begin
      execute procedure B_GETNAME_EX(10, :IDNAME)
      returning_values :BLOBNAME, :NAME_TITLE, :NAME_PART;
      NAME = '';
      --CQ[8890]-->
      if (BLOBNAME is not null) then
      begin
        NAME = S_SUBSTRING8192(BLOBNAME, 1, 1024);
        NAME = S_TRANSLITERATE_LONG(:NAME);
      end
      CONTENTS = '';
      if (BLOBCONTENTS is not null) then
      begin
        CONTENTS = S_SUBSTRING8192(BLOBCONTENTS, 1, 5120);
        CONTENTS = S_TRANSLITERATE_LONG(:CONTENTS);
      end
      --CQ[8890]<--
      suspend;
    end
  end

  IDREESTR = null; -- ++TFS[695]

  --CQ[11265]-->
  for select distinct ID, FROM_ABC
    from DM_GET_TRUDLIST(:BASEID)
    into :ID_RES, :FROM_ABC
  do
  begin
    ALTTAB = null;
    BA = null;
    BE = null;
    BC = null;
    BD = null;
    BB = null;
    BG = null;
    BH = null;
    CONTENTS = null;
    ALLOW_SUSPEND = 0;
    if (FROM_ABC = 1) then
    begin
      TAB = '';
      select A.ID, A.IDNAME, A.TAB, A.CENA, A.RABMAT, E.NAME,
          /*TFS[695]*/ A.IDPODGROUP
      from B_ABC_OKP A
      left join B_EDIZM E on E.ID = A.IDEDIZM
      where A.ID = :ID_RES
      into :ID, :IDNAME, :TAB_OKP, :BA, :RABMAT, :EDIZM,
          /*TFS[695]*/ :IDREESTR;
      --     ABC,    B_RABMAT,
      --..     
      if (not exists(select ID
                     from B_RABMAT
                     where IDABCOKP = :ID)) then
      begin
        ALLOW_SUSPEND = 1;
        if (RABMAT = 1) then
          BE = :BA;
        else
        if (RABMAT = 2) then
          BC = :BA;
        else
        if (RABMAT = 3) then
          BB = :BA;
        else
          ALLOW_SUSPEND = 0;
      end

    end
    else
    begin
      select T.ID, T.IDNAME, T.TAB, T.CENA, BE.NAME, BO.TAB
      from B_TRUD T
      left join B_EDIZM BE on BE.ID = T.IDEDIZM
      left join B_ABC_OKP BO on BO.ID = T.IDABCOKP
      where T.ID = :ID_RES
      into :ID, :IDNAME, :TAB, :BE, :EDIZM, :TAB_OKP;
      RABMAT = 1;
      IDREESTR = 1; -- TFS[695]
      ALLOW_SUSPEND = 1;
    end
    execute procedure B_GETNAME_EX(10, :IDNAME)
    returning_values :BLOBNAME, :NAME_TITLE, :NAME_PART;
    NAME = '';
    if (BLOBNAME is not null) then
    begin
      NAME = S_SUBSTRING8192(BLOBNAME, 1, 8192);
      NAME = S_TRANSLITERATE_LONG(:NAME);
    end
    if (ALLOW_SUSPEND = 1) then
      suspend;
  end

  --CQ[11265]<--
end
^

-- TFS[695]
execute block
as
begin
  if (not exists(
      select * from M_GLOBAL_PARAMS
        where PARAM_NAME='NORMBASE_INDEX_695'
          and INT_VALUE<>0 )) then
  begin
    update DM_INDEX_INFO set STATE=3;
    update or insert into M_GLOBAL_PARAMS(ID_SELF, PARAM_NAME, INT_VALUE)
      values(next value for A_G_SMETA, 'NORMBASE_INDEX_695', 1)
      matching(PARAM_NAME);
  end
end
^

--------------------------------------------------------------------
--                           10.0.1.3
--------------------------------------------------------------------

--TFS[466]
create or alter procedure S_SEARCH_INSMETA_DM (
    IDUSER integer,
    LIKETABU varchar(88),
    NNAMES blob sub_type 0 segment size 80,
    SOSTAVRABOT blob sub_type 0 segment size 80,
    PRICES blob sub_type 0 segment size 80,
    IDOBJECT integer,
    SMETATYPE integer,
    CORRECT_SET integer,
    CORRECT_TEXT blob sub_type 1 segment size 80)
returns (
    ID integer,
    IDHIER integer)
AS
declare variable tab varchar(42);
declare variable idname integer;
declare variable idsost integer;
declare variable ba double precision;
declare variable bb double precision;
declare variable bc double precision;
declare variable bd double precision;
declare variable be double precision;
declare variable utvhier integer;
declare variable koll double precision;
declare variable name_title blob sub_type 0 segment size 80;
declare variable name_part blob sub_type 0 segment size 80;
declare variable sostav blob sub_type 0 segment size 80;
declare variable idnormativ integer;
declare variable res integer;
declare variable ATYPE integer;
declare variable TAB_FULL varchar(8192);
declare variable FIELD_VALUE blob sub_type 1 segment size 80;

declare variable KA varchar(50);
declare variable KB varchar(50);
declare variable KC varchar(50);
declare variable KD varchar(50);
declare variable KE varchar(50);
declare variable KF varchar(50);
declare variable KG varchar(50);
declare variable KH varchar(50);
declare variable KI varchar(50);
declare variable KJ varchar(50);
declare variable KK varchar(50);
declare variable KL varchar(50);
declare variable KM varchar(50);
declare variable CORRECTNODE blob sub_type 1 segment size 80;
declare variable CORRECTNODE_1 blob sub_type 1 segment size 80;

declare variable POPR_SEARCH_TEXT varchar(50);
declare variable POPR_RES integer;
begin
  if (:LIKETABU = '') then LIKETABU = null;

  UTVHIER = 0;

  for select IDHIER
    from S_O_HIER_SELECT2(:IDOBJECT)
    into :IDHIER
  do
  begin
    if (:SMETATYPE > 999) then
    begin
      if (exists( /* */
          select * from M_UTV_STRUCT_ELEM_IN_AKT
            where ID_STRUCT = :IDHIER and ID_AKT = :SMETATYPE)) then
        UTVHIER = 1;
      else
        UTVHIER = 0;
    end

    for select ID, TAB, NAME_ID, BA, BB, BC, BD, BE, KOLL, IDNORMATIV, ATYPE, /* Voyager CQ[13924] */
      KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM, CORRECTNODE, CORRECTNODE_1 /*TFS[466]*/
      from A_SMETA
      where IDHIER = :IDHIER
        and SMETATYPE = :SMETATYPE
        and ATYPE in (17, 18, 19) -- Voyager CQ[13924] ( 19 - -)
      plan (A_SMETA index (A_SMETA_IDHIER_SMETATYPE))
      into :ID, :TAB, :IDNAME, :BA, :BB, :BC, :BD, :BE, :KOLL, :IDNORMATIV, :ATYPE, /*Voyager CQ[13924]*/
           :KA, :KB, :KC, :KD, :KE, :KF, :KG, :KH, :KI, :KJ, :KK, :KL, :KM, :CORRECTNODE, :CORRECTNODE_1 /*TFS[466]*/
    do
    if (:UTVHIER = 0 or
        :KOLL is not null and  LROUNDN(:KOLL, 3) <> 0.0
        ) then
    begin

      if (:LIKETABU is not null and :TAB is not null) then
      begin
        TAB = S_TRANSLITERATE/*[14343]_TAB*/(:TAB); --[12447]

        --CQ[TIMUR 13929, 14262]
        FIELD_VALUE = null;
        select FIELD_VALUE from A_SMETA_BLOB
          where ID = :ID and FIELD_NAME='TAB'
        into :FIELD_VALUE;

        TAB_FULL = null;
        if (:FIELD_VALUE is not null) then
        begin
          TAB_FULL = S_SUBSTRING8192(:FIELD_VALUE, 1, 8192);
          TAB_FULL = S_TRANSLITERATE_LONG(:TAB_FULL);
        end
        --CQ[TIMUR 13929, 14262]
      end

      --CQ[TIMUR 13929, 14262]
      if (TAB_FULL is null) then
        TAB_FULL = TAB;

      if (:PRICES is not null) then
      begin
        if (:BA is null) then BA = 0.0;
        if (:BB is null) then BB = 0.0;
        if (:BC is null) then BC = 0.0;
        if (:BD is null) then BD = 0.0;
        if (:BE is null) then BE = 0.0;
      end

      if (
            (:LIKETABU is null or
                :TAB_FULL is not null and :TAB_FULL like :LIKETABU) and
            (:PRICES is null or
                S_SEARCHBLOBPRICES(:PRICES, :BA, :BB, :BC, :BD, :BE, 0.0, 0.0) <> 0)
            or ((:ATYPE = 19) and (:NNAMES is not null)) -- Voyager CQ[13924]
        ) then
        begin
           if (:NNAMES is not null) then
              execute procedure S_SEARCH_INNAME_F(:IDNAME, :NNAMES) -- Voyager CQ[13924] S_SEARCH_INNAME -> S_SEARCH_INNAME_F
                returning_values :NAME_TITLE, :NAME_PART, :RES;
           else
             RES = 1;

           if ((:SOSTAVRABOT  is not null) and (:RES <> 0)
             and (:ATYPE <> 19)) /*Voyager CQ[13924]*/
           then
           begin
             IDSOST = null;
             select IDSOSTAV from B_RABMAT where ID = :IDNORMATIV into :IDSOST;
             if (:IDSOST is not null) then
               execute procedure S_SEARCH_INSOST(:IDSOST, :SOSTAVRABOT) returning_values :SOSTAV, :RES;
             else RES = 0;
           end

           /*TFS[466]-->*/
           if ( (:CORRECT_TEXT is not null) and
                (coalesce(:CORRECT_SET, 0) <> 0) and
                (coalesce(:RES, 0) <> 0)  ) then
           begin

             POPR_RES = null;
             if (:ATYPE <> 19) then
             begin
               POPR_SEARCH_TEXT = lower(substring(:CORRECT_TEXT from 1 for 50));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 0/*ceKA*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KA));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 1/*ceKB*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KB));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 2/*ceKC*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KC));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 3/*ceKD*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KD));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 4/*ceKE*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KE));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 5/*ceKF*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KF));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 6/*ceKG*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KG));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 7/*ceKH*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KH));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 8/*ceKI*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KI));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 9/*ceKJ*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KJ));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 10/*ceKK*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KK));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 11/*ceKL*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KL));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 12/*ceKM*/) <> 0)) then
                 POPR_RES = POSITION(POPR_SEARCH_TEXT, lower(KM));
  
               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 13/*ceShifr*/) <> 0)) then
                 POPR_RES = POSITION(lower(CORRECT_TEXT),
                                     lower(CORRECTNODE_1)); --S_SEARCHBLOBNAMES (:CORRECTNODE_1, :CORRECT_TEXT);

               if ((coalesce(:POPR_RES, 0) = 0) and (GETBIT(:CORRECT_SET, 14/*ceDescr*/) <> 0)) then
                 POPR_RES = POSITION(lower(CORRECT_TEXT),
                                     lower(CORRECTNODE)); --S_SEARCHBLOBNAMES (:CORRECTNODE, :CORRECT_TEXT);
  

             end

             RES = coalesce(POPR_RES, 0);
           end
           /*<--TFS[466]*/

           if (:RES <> 0) then
             suspend;
        end
    end
  end
end^

--TFS[708]
execute block
as
begin
  if (not exists(select * from RDB$FUNCTIONS
      where upper(RDB$FUNCTION_NAME) = 'DM_TEXTTOCURRENCY'))
  then
    execute statement
      "DECLARE EXTERNAL FUNCTION DM_TEXTTOCURRENCY "||
      "  VARCHAR(255) "||
      "RETURNS DOUBLE PRECISION BY VALUE "||
      "ENTRY_POINT 'dm_TextToCurrency_2' MODULE_NAME 'B_UDF.dll'";
  else
    execute statement
      "ALTER EXTERNAL FUNCTION DM_TEXTTOCURRENCY "||
      "ENTRY_POINT 'dm_TextToCurrency_2'";
end
^

--TFS[708]
create or alter procedure DM_GET_COPYPARAMPOSITION (
    IDUSER integer,
    IDPOS integer,
    IDPRICE integer,
    ROW integer)
returns (
    TAB varchar(42),
    ALTTAB varchar(250),
    IDNAME integer,
    IDEDIZM integer,
    BB double precision,
    BB_ORIGINAL double precision)
AS
declare variable POSITIONNAME varchar(510);
declare variable POSITIONCOST VARCHAR(255);
declare variable NAMEBLOB BLOB;
declare variable NAMEBLOB1 BLOB;
declare variable POSITIONEDIZM VARCHAR(100);
declare variable SUPPLIERNAME varchar(252);
declare variable IDEDIZMGROUP integer;
declare variable ID_BLOB_GEN integer;
declare variable NDSVALUE double precision;
declare variable BWITHNDS integer;
begin
  --  IDNAME = '   ';
  execute procedure dm_getpriceposname(ABS(:IDPOS)) returning_values :POSITIONNAME;
  NAMEBLOB1 = copyvarchartoblob (substring (:POSITIONNAME from 1 for 500));

  ID_BLOB_GEN = gen_id(B_GEN_TEMP, 1);
  insert into B_TEMP_BLOB(ID, BLOB1) values (:ID_BLOB_GEN, :NAMEBLOB1);
  select BLOB1 from B_TEMP_BLOB where ID = :ID_BLOB_GEN into :NAMEBLOB1;
  delete from B_TEMP_BLOB where ID = :ID_BLOB_GEN;

  execute procedure B_WRITE_NAIMENOVANIE(IDUSER, -1, null, NAMEBLOB1) returning_values :IDNAME, :NAMEBLOB;
  --
  TAB = ' '; -- CQ[12585] TAB = '    '||:ROW;
  -- 
  NDSVALUE = 0;
  SUPPLIERNAME = '';
  BWITHNDS = 0;
  select PS.FNAME, PP.ndsvalue, PP.bwithnds from PM_PRICES PP
  join PM_SUPPLIERS PS on PS.ID = PP.IDSUPPLIER
  where PP.ID = :IDPRICE
  into :SUPPLIERNAME, :NDSVALUE, :BWITHNDS;

  -- CQ[12585] -->
  -- if (STRLEN(:SUPPLIERNAME) > 200) then --          200 
  -- begin
  --   SUPPLIERNAME = substring (:SUPPLIERNAME from 1 for 200)||'...';
  -- end
  -- CQ[12585] ALTTAB = ': '''||:SUPPLIERNAME||'''.     '||:ROW;
  -- ALTTAB = '  ('||:SUPPLIERNAME||')'; -- CQ[12585]
  ALTTAB = ' '; -- csMonitoringAltTab
  -- CQ[12585] <--

  --
  for select LCKTRIMVARCHAR(substring (p.DATAIDENT from  1 for 255))  from pm_priceposareas p
  join pm_areas a on a.id = p.idarea
  where p.IDPOS = ABS(:IDPOS) and a.areatype = 3 into :POSITIONCOST do -- BB  =  '    ';
  begin
    if (POSITIONCOST is not null)  then
    begin
      BB = dm_texttocurrency (POSITIONCOST);
      BB_ORIGINAL = BB; -- MK CQ[11629]
      if (BWITHNDS = 1) then  BB = BB/(1 + NDSVALUE / 100);  --CQ[7773]
      BB = LROUNDN(:BB, 2);
      BB_ORIGINAL = LROUNDN(:BB_ORIGINAL, 2); -- MK CQ[11629]
    end
  end
  -- 
  IDEDIZM = null;
  POSITIONEDIZM = null;
  --            
  select UserEdIzm from PM_PRICES PP where (PP.ID = :IDPRICE) and (PP.USEREDIZMUSED <> 0)
  into :POSITIONEDIZM;
  if (POSITIONEDIZM is null) then
  begin
    select LCKTRIMVARCHAR(substring (P.DATAIDENT from  1 for 100))  from pm_priceposareas p
    join pm_areas a on a.id = p.idarea
    where p.IDPOS = ABS(:IDPOS) and a.areatype = 6 into :POSITIONEDIZM;
  end
  --  B_EDIZM
  execute procedure B_FIND_EDIZM(:IDUSER, :POSITIONEDIZM,'') returning_values :IDEDIZM ;
  if (IDEDIZM is null) then --   - 
  begin
    --  "   "    - 
    execute procedure DM_ADD_EDIZMGROUP ('   ') returning_values :IDEDIZMGROUP;
    execute procedure B_ADD_EDIZM (:IDUSER, :IDEDIZMGROUP,:POSITIONEDIZM, :POSITIONEDIZM, 1) returning_values :IDEDIZM;
  end
  suspend;
end
^

--TFS[722]
create or alter procedure MOVE_SMRECS_AND_HIERS_TO_ELEM (
    IDUSER integer,
    IDHIER integer,
    ATYPE integer,
    SM_RECS_BLOB blob sub_type 0 segment size 80,
    SM_RECS_COUNT integer,
    FIRST_STEAL_HIER_ID integer)
AS
declare variable IdBlobGen integer;
declare variable idrec integer;
declare variable i integer;
declare variable ParentHierId integer;
declare variable Number integer;
declare variable Flag integer;

declare variable AUTORENUM_ENABLED integer;
declare variable AUTORENUM_MODE integer;
declare variable AUTORENUM_START integer;
declare variable AUTORENUM_STEP integer;
declare variable NEED_SKIP_EMPTY integer;
declare variable RENUM_SLAVE_AS_MAIN integer;
declare variable VN_IDOBJECT integer;

begin

  FIRST_STEAL_HIER_ID = coalesce(FIRST_STEAL_HIER_ID, 0);
  IdBlobGen = gen_id(B_GEN_TEMP, 1);
  insert into B_TEMP_BLOB (ID, BLOB1)
  values (:IdBlobGen, :SM_RECS_BLOB);
  select BLOB1
  from B_TEMP_BLOB
  where ID = :IdBlobGen
  into :SM_RECS_BLOB;
  delete from B_TEMP_BLOB
  where ID = :IdBlobGen;
  i = 0;
  --  
  while (i < :SM_RECS_COUNT) do
  begin
    idrec = readintfromblob(:SM_RECS_BLOB, :i);

    update A_SMETA set
      IDHIER = :IDHIER
    where (ID = :idrec);

    update A_S_RES R set --TFS[722]
      IDHIER = :IDHIER
    where (ID_SOURCE = :IDREC);

    i = i + 1;
  end
  --   
  if (FIRST_STEAL_HIER_ID > 0) then
  begin
    ParentHierId = 0;
    Flag = 0;
    select PARENT
    from A_O_HIER
    where NUMBER = :FIRST_STEAL_HIER_ID
    into :ParentHierId;
    for select NUMBER
      from A_O_HIER
      where parent = :ParentHierId
      order by SORTING
      into :Number
    do
    begin
      if ((Flag = 1) or
          (:Number = :FIRST_STEAL_HIER_ID)) then
      begin
        update A_O_HIER set
          parent = :IDHIER
        where number = :Number;
        Flag = 1;
      end
    end
  end

  execute procedure S_O_HIER_PARENT_OFTYPE(:IDHIER, 1) -- ObgectType
  returning_values (:VN_IDOBJECT);

  execute procedure M_GET_AUTORENUM_PARAM(:VN_IDOBJECT, 15) --     PsType
  returning_values :AUTORENUM_ENABLED, :AUTORENUM_MODE, :AUTORENUM_START, :AUTORENUM_STEP,
    :NEED_SKIP_EMPTY, :RENUM_SLAVE_AS_MAIN;

  if (:AUTORENUM_ENABLED = 1) then
  begin
    if (:AUTORENUM_MODE in (0, 1)) then
    begin
      execute procedure MS_SMETA_RENUMBER(:IDHIER, 15, :AUTORENUM_MODE,
        case :ATYPE
          when 3 then 0 -- LSType
          else 1
        end,
        null, :NEED_SKIP_EMPTY,
        :AUTORENUM_START, :AUTORENUM_STEP, :RENUM_SLAVE_AS_MAIN);
    end
  end

end^

--TFS[722]
execute block
as
declare variable RES_ID_SOURCE integer;
declare variable RES_IDHIER integer;
declare variable RES_ID integer;
declare variable IDHIER integer;
declare variable OLD_RES_ID_SOURCE integer;
begin
  if (not exists (
      select * from M_GLOBAL_PARAMS
        where upper(PARAM_NAME)='FIX_ID_HIER_IN_A_S_RES_TFS_722'
          and INT_VALUE <> 0)) then
  begin

    OLD_RES_ID_SOURCE = 0;

    for select R.IDHIER, R.ID_SOURCE, R.ID
      from A_S_RES R
    into :RES_IDHIER, :RES_ID_SOURCE, :RES_ID
    do
    begin
      if (OLD_RES_ID_SOURCE <> RES_ID_SOURCE) then
      begin
        select IDHIER
          from A_SMETA S
        where S.ID = :RES_ID_SOURCE
        into :IDHIER;

        OLD_RES_ID_SOURCE = RES_ID_SOURCE;
      end
  
      if (IDHIER <> RES_IDHIER) then
      begin
        update A_S_RES R set
          IDHIER = :IDHIER
        where (ID = :RES_ID);
      end
    end

    update or insert into M_GLOBAL_PARAMS(ID_SELF, PARAM_NAME, INT_VALUE)
      values(next value for A_G_SMETA, 'FIX_ID_HIER_IN_A_S_RES_TFS_722', 1)
      matching(PARAM_NAME);
  end
end
^